* ************************************************************************
*  2-loop decoupling coefficient for mb in MSSM (from Luminita Mihaila)
*
       function mssmzeta2lmb(MU,mglu, mt, mst1, mst2, Xt, msq1, msq2, Xb)
       
       implicit real*8 (a-h,k-z)
       implicit  integer(i)

       data pi/3.14159265358979323846264338328d0/

       double precision NC, CF, CV, TF
       parameter (NC = 3)
       parameter (CF = 4/3D0)
       parameter (CV = 3D0)
       parameter (TF = 1/2D0)
       
       double precision mssmzetavec(12)
       
       double precision TfinTMP, TfinZTMP, B0finTMP

        mssmzetavec(1) = CF*(1.4704861111111112 + (15*mglu**2)/(64.*msq1**2) - 
     -    (45*msq1**2)/(128.*mglu**2) + (45*msq1**4)/(1024.*mglu**4) + 
     -    (219*mglu**4*msq1**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (219*msq1**6)/(128.*(-mglu**2 + msq1**2)**3) + 
     -    (123*mglu**4)/(512.*(-mglu**2 + msq1**2)**2) + 
     -    (1189*mglu**2*msq1**2)/(1024.*(-mglu**2 + msq1**2)**2) + 
     -    (2539*msq1**4)/(1024.*(-mglu**2 + msq1**2)**2) - 
     -    (25*msq1**6)/(1024.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (165*msq1**8)/(1024.*mglu**4*(-mglu**2 + msq1**2)**2) + 
     -    (149*mglu**2)/(128.*(-mglu**2 + msq1**2)) + 
     -    (15*mglu**4)/(64.*msq1**2*(-mglu**2 + msq1**2)) + 
     -    (755*msq1**2)/(1024.*(-mglu**2 + msq1**2)) + 
     -    (595*msq1**4)/(1024.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (15*msq1**6)/(128.*mglu**4*(-mglu**2 + msq1**2)) + 
     -    (15*mglu**2)/(64.*msq2**2) - 
     -    (15*mglu**2*msq1**2)/(128.*(-mglu**2 + msq1**2)*msq2**2) - 
     -    (45*msq2**2)/(128.*mglu**2) - (45*msq1**2*msq2**2)/(512.*mglu**4) + 
     -    (135*mglu**4*msq2**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (135*msq1**4*msq2**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (135*mglu**2*msq2**2)/(1024.*(-mglu**2 + msq1**2)**2) + 
     -    (1355*msq1**2*msq2**2)/(1024.*(-mglu**2 + msq1**2)**2) - 
     -    (185*msq1**4*msq2**2)/(1024.*mglu**2*(-mglu**2 + msq1**2)**2) + 
     -    (165*msq1**6*msq2**2)/(1024.*mglu**4*(-mglu**2 + msq1**2)**2) - 
     -    (635*msq2**2)/(1024.*(-mglu**2 + msq1**2)) + 
     -    (175*msq1**2*msq2**2)/(512.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (75*msq1**4*msq2**2)/(1024.*mglu**4*(-mglu**2 + msq1**2)) + 
     -    (45*msq2**4)/(1024.*mglu**4) + 
     -    (105*msq2**4)/(256.*(-mglu**2 + msq1**2)**2) + 
     -    (105*msq1**2*msq2**4)/(256.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (585*msq2**4)/(1024.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (45*msq1**2*msq2**4)/(1024.*mglu**4*(-mglu**2 + msq1**2)) - 
     -    (175*mglu**2*msq1**4)/(256.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (35*mglu**2*msq1**2*msq2**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (175*msq1**4*msq2**2)/(256.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (105*mglu**2*msq2**4)/(256.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (35*msq1**2*msq2**4)/(128.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (105*msq2**6)/(256.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (135*mglu**4*msq1**2)/(128.*(-mglu**2 + msq2**2)**3) + 
     -    (219*mglu**4*msq2**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (135*msq1**2*msq2**4)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (219*msq2**6)/(128.*(-mglu**2 + msq2**2)**3) + 
     -    (123*mglu**4)/(512.*(-mglu**2 + msq2**2)**2) - 
     -    (135*mglu**2*msq1**2)/(1024.*(-mglu**2 + msq2**2)**2) + 
     -    (105*msq1**4)/(256.*(-mglu**2 + msq2**2)**2) + 
     -    (115*mglu**4*msq1**2)/
     -     (1024.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (235*mglu**2*msq1**4)/
     -     (1024.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (1189*mglu**2*msq2**2)/(1024.*(-mglu**2 + msq2**2)**2) + 
     -    (1355*msq1**2*msq2**2)/(1024.*(-mglu**2 + msq2**2)**2) + 
     -    (105*msq1**4*msq2**2)/(256.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (115*mglu**4*msq2**2)/
     -     (1024.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (445*mglu**2*msq1**2*msq2**2)/
     -     (512.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (955*msq1**4*msq2**2)/
     -     (1024.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (105*msq1**6*msq2**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (2539*msq2**4)/(1024.*(-mglu**2 + msq2**2)**2) - 
     -    (185*msq1**2*msq2**4)/(1024.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (655*mglu**2*msq2**4)/
     -     (1024.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (105*msq1**2*msq2**4)/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (185*msq1**4*msq2**4)/
     -     (1024.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (25*msq2**6)/(1024.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (165*msq1**2*msq2**6)/(1024.*mglu**4*(-mglu**2 + msq2**2)**2) + 
     -    (115*msq2**6)/(1024.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (95*msq1**2*msq2**6)/
     -     (512.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (165*msq1**4*msq2**6)/
     -     (1024.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (165*msq2**8)/(1024.*mglu**4*(-mglu**2 + msq2**2)**2) + 
     -    (45*msq2**8)/
     -     (1024.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (165*msq1**2*msq2**8)/
     -     (1024.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (105*mglu**2*msq1**4)/(256.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (105*msq1**6)/(256.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (35*mglu**2*msq1**2*msq2**2)/
     -     (128.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (35*msq1**4*msq2**2)/(128.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (175*mglu**2*msq2**4)/(256.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (175*msq1**2*msq2**4)/(256.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (149*mglu**2)/(128.*(-mglu**2 + msq2**2)) - 
     -    (635*msq1**2)/(1024.*(-mglu**2 + msq2**2)) - 
     -    (585*msq1**4)/(1024.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (115*mglu**4*msq1**2)/
     -     (1024.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (655*mglu**2*msq1**4)/
     -     (1024.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (115*msq1**6)/(1024.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (45*msq1**8)/
     -     (1024.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (115*mglu**4)/(256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (455*mglu**2*msq1**2)/(512.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (525*msq1**4)/(512.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (135*msq1**6)/(256.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (15*mglu**4)/(64.*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (15*mglu**4*msq1**2)/
     -     (128.*(-mglu**2 + msq1**2)*msq2**2*(-mglu**2 + msq2**2)) + 
     -    (755*msq2**2)/(1024.*(-mglu**2 + msq2**2)) - 
     -    (15*mglu**2*msq2**2)/(128.*msq1**2*(-mglu**2 + msq2**2)) + 
     -    (175*msq1**2*msq2**2)/(512.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (45*msq1**4*msq2**2)/(1024.*mglu**4*(-mglu**2 + msq2**2)) + 
     -    (115*mglu**4*msq2**2)/
     -     (1024.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (445*mglu**2*msq1**2*msq2**2)/
     -     (512.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (105*msq1**4*msq2**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (95*msq1**6*msq2**2)/
     -     (512.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (165*msq1**8*msq2**2)/
     -     (1024.*mglu**4*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (455*mglu**2*msq2**2)/(512.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (15*mglu**4*msq2**2)/
     -     (128.*msq1**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (455*msq1**2*msq2**2)/(128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (375*msq1**4*msq2**2)/
     -     (512.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (15*msq1**6*msq2**2)/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (595*msq2**4)/(1024.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (75*msq1**2*msq2**4)/(1024.*mglu**4*(-mglu**2 + msq2**2)) + 
     -    (235*mglu**2*msq2**4)/
     -     (1024.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (955*msq1**2*msq2**4)/
     -     (1024.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (185*msq1**4*msq2**4)/
     -     (1024.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (165*msq1**6*msq2**4)/
     -     (1024.*mglu**4*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (525*msq2**4)/(512.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (375*msq1**2*msq2**4)/
     -     (512.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (15*msq1**4*msq2**4)/
     -     (64.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (15*msq2**6)/(128.*mglu**4*(-mglu**2 + msq2**2)) - 
     -    (105*msq1**2*msq2**6)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (135*msq2**6)/(256.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (15*msq1**2*msq2**6)/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mst1**2)/(32.*mglu**2) + 
     -    (27*mglu**4*mst1**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (27*msq1**4*mst1**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mst1**2)/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (45*msq1**2*mst1**2)/(128.*(-mglu**2 + msq1**2)**2) - 
     -    (3*mst1**2)/(64.*(-mglu**2 + msq1**2)) - 
     -    (3*msq1**2*mst1**2)/(64.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (27*mglu**4*mst1**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (27*msq2**4*mst1**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mst1**2)/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (45*msq2**2*mst1**2)/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (3*mst1**2)/(64.*(-mglu**2 + msq2**2)) - 
     -    (3*msq2**2*mst1**2)/(64.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (3*mst2**2)/(32.*mglu**2) + 
     -    (27*mglu**4*mst2**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (27*msq1**4*mst2**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mst2**2)/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (45*msq1**2*mst2**2)/(128.*(-mglu**2 + msq1**2)**2) - 
     -    (3*mst2**2)/(64.*(-mglu**2 + msq1**2)) - 
     -    (3*msq1**2*mst2**2)/(64.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (27*mglu**4*mst2**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (27*msq2**4*mst2**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mst2**2)/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (45*msq2**2*mst2**2)/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (3*mst2**2)/(64.*(-mglu**2 + msq2**2)) - 
     -    (3*msq2**2*mst2**2)/(64.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (3*mt**2)/(16.*mglu**2) - 
     -    (27*mglu**4*mt**2)/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (27*msq1**4*mt**2)/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mt**2)/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (45*msq1**2*mt**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mt**2)/(32.*(-mglu**2 + msq1**2)) + 
     -    (3*msq1**2*mt**2)/(32.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (27*mglu**4*mt**2)/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (27*msq2**4*mt**2)/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mt**2)/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (45*msq2**2*mt**2)/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (3*mt**2)/(32.*(-mglu**2 + msq2**2)) + 
     -    (3*msq2**2*mt**2)/(32.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (25*mglu**8)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**6*msq1**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (19*mglu**8*msq1**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*msq1**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**6*msq2**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (19*mglu**8*msq2**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*msq2**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (41*mglu**6*mst1**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**2)/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (19*mglu**8*mst1**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (25*mglu**6*msq1**2*mst1**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst1**2)/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**2)/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (19*mglu**8*mst1**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (25*mglu**6*msq2**2*mst1**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst1**2)/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (55*mglu**4*mst1**4)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (23*mglu**2*msq1**2*mst1**4)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu**6*mst1**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**4)/
     -     (2.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (23*mglu**2*msq1**4*mst1**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (23*mglu**2*msq2**2*mst1**4)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu**6*mst1**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**4)/
     -     (2.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (23*mglu**2*msq2**4*mst1**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (37*mglu**2*mst1**6)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq1**2*mst1**6)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6)/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (27*mglu**2*msq1**2*mst1**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*msq1**4*mst1**6)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq2**2*mst1**6)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6)/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (27*mglu**2*msq2**2*mst1**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*msq2**4*mst1**6)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (21*mst1**8)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*msq1**2*mst1**8)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*msq2**2*mst1**8)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    mst1**10/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    mst1**10/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**6*mt**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**4*msq1**2*mt**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**8*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**6*msq1**2*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**4*msq1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**4*msq2**2*mt**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**8*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**6*msq2**2*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**4*msq2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**4*mst1**2*mt**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst1**2*mt**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*mst1**2*mt**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**2*mst1**2*mt**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**4*mst1**2*mt**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst1**2*mt**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*mst1**2*mt**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**2*mst1**2*mt**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**4*mst1**2*mt**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*mst1**4*mt**2)/
     -     (2.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*msq1**2*mst1**4*mt**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (21*mglu**4*mst1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (59*mglu**2*msq1**2*mst1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*msq1**4*mst1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*msq2**2*mst1**4*mt**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (21*mglu**4*mst1**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (59*mglu**2*msq2**2*mst1**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*msq2**4*mst1**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**2)/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**2*mst1**6*mt**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**6*mt**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**2*mst1**6*mt**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**6*mt**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mst1**8*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mst1**8*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (23*mglu**4*mt**4)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**2*msq1**2*mt**4)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**6*mt**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**4*msq1**2*mt**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**2*msq1**4*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**2*msq2**2*mt**4)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**6*mt**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**4*msq2**2*mt**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**2*msq2**4*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*mglu**2*mst1**2*mt**4)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**4)/
     -     (2.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (31*mglu**4*mst1**2*mt**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu**2*msq1**2*mst1**2*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**2*mt**4)/
     -     (2.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**4)/
     -     (2.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (31*mglu**4*mst1**2*mt**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu**2*msq2**2*mst1**2*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**2*mt**4)/
     -     (2.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (41*mst1**4*mt**4)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mglu**2*mst1**4*mt**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (41*msq1**2*mst1**4*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mglu**2*mst1**4*mt**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (41*msq2**2*mst1**4*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**6)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**2*mt**6)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**4*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*msq1**2*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq1**4*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**2*mt**6)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**4*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*msq2**2*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq2**4*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mst1**2*mt**6)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mst1**2*mt**6)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*msq1**2*mst1**2*mt**6)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mst1**2*mt**6)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*msq2**2*mst1**2*mt**6)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (41*mst1**4*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (41*mst1**4*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (47*mt**8)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (47*msq1**2*mt**8)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (47*msq2**2*mt**8)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (109*mst1**2*mt**8)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (109*mst1**2*mt**8)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (41*mt**10)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (41*mt**10)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (59*mglu**4)/
     -     (128.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**6*msq1**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mglu**4*msq1**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**6)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (101*mglu**4*msq1**2)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**6*msq2**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mglu**4*msq2**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**6)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (101*mglu**4*msq2**2)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**2*mst1**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**6*mst1**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu**4*msq1**2*mst1**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*msq1**4*mst1**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (33*mglu**4*mst1**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (15*mglu**2*msq1**2*mst1**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**6*mst1**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu**4*msq2**2*mst1**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*msq2**4*mst1**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (33*mglu**4*mst1**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (15*mglu**2*msq2**2*mst1**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (29*mst1**4)/
     -     (128.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**4)/
     -     (64.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**4*mst1**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (63*mglu**2*msq1**2*mst1**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*msq1**4*mst1**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (51*mglu**2*mst1**4)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (87*msq1**2*mst1**4)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**4*mst1**4)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**4)/
     -     (64.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**4*mst1**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (63*mglu**2*msq2**2*mst1**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*msq2**4*mst1**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (51*mglu**2*mst1**4)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (87*msq2**2*mst1**4)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**4*mst1**4)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**6)/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu**2*mst1**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (91*msq1**2*mst1**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (17*mst1**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**6)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu**2*mst1**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (91*msq2**2*mst1**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (17*mst1**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**6)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mst1**8)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mst1**8)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*mt**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mt**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (77*mglu**6*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**4*msq1**2*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*msq1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**4*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (15*mglu**2*msq1**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mt**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (77*mglu**6*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**4*msq2**2*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*msq2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**4*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (15*mglu**2*msq2**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mst1**2*mt**2)/
     -     (64.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**2*mt**2)/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**4*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*mglu**2*msq1**2*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*msq1**4*mst1**2*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (89*msq1**2*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**4*mst1**2*mt**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**2*mt**2)/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**4*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*mglu**2*msq2**2*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*msq2**4*mst1**2*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (89*msq2**2*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**4*mst1**2*mt**2)/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mst1**4*mt**2)/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (49*mglu**2*mst1**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (49*msq1**2*mst1**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (11*mst1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*msq1**2*mst1**4*mt**2)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (49*mglu**2*mst1**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (49*msq2**2*mst1**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (11*mst1**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*msq2**2*mst1**4*mt**2)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mst1**6*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mst1**6*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (61*mt**4)/
     -     (128.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mt**4)/
     -     (64.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (105*mglu**4*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (119*mglu**2*msq1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*msq1**4*mt**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (19*mglu**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (119*msq1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**4*mt**4)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mt**4)/
     -     (64.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (105*mglu**4*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (119*mglu**2*msq2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*msq2**4*mt**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (19*mglu**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (119*msq2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**4*mt**4)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mst1**2*mt**4)/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (91*mglu**2*mst1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*msq1**2*mst1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (17*mst1**2*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq1**2*mst1**2*mt**4)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (91*mglu**2*mst1**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*msq2**2*mst1**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (17*mst1**2*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq2**2*mst1**2*mt**4)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mst1**4*mt**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mst1**4*mt**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mt**6)/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*mt**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (105*msq1**2*mt**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (11*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mt**6)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*mt**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (105*msq2**2*mt**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (11*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mt**6)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mst1**2*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mst1**2*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mt**8)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mt**8)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu**2*msq1**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*mglu**2*msq1**4*mst1**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*msq1**6*mst1**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**2*msq1**2*mst1**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*msq1**4*mst1**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mglu**2*mst1**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*msq1**2*mst1**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mst1**8)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*msq1**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*msq1**6*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**2*msq1**2*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (49*msq1**4*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu**2*mst1**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (105*msq1**2*mst1**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mst1**6*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**2*msq1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*msq1**4*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**2*mst1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (119*msq1**2*mst1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mst1**4*mt**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu**2*mt**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*msq1**2*mt**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mst1**2*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mt**8)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu**2*msq2**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*mglu**2*msq2**4*mst1**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*msq2**6*mst1**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**2*msq2**2*mst1**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*msq2**4*mst1**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mglu**2*mst1**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*msq2**2*mst1**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mst1**8)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*msq2**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*msq2**6*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**2*msq2**2*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (49*msq2**4*mst1**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu**2*mst1**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (105*msq2**2*mst1**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mst1**6*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**2*msq2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*msq2**4*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**2*mst1**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (119*msq2**2*mst1**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mst1**4*mt**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu**2*mt**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*msq2**2*mt**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mst1**2*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mt**8)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (25*mglu**8)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**6*msq1**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (19*mglu**8*msq1**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*msq1**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**6*msq2**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (19*mglu**8*msq2**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*msq2**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (41*mglu**6*mst2**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**2)/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (19*mglu**8*mst2**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (25*mglu**6*msq1**2*mst2**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst2**2)/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**2)/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (19*mglu**8*mst2**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (25*mglu**6*msq2**2*mst2**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst2**2)/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (55*mglu**4*mst2**4)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (23*mglu**2*msq1**2*mst2**4)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**6*mst2**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**4)/
     -     (2.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (23*mglu**2*msq1**4*mst2**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (23*mglu**2*msq2**2*mst2**4)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**6*mst2**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**4)/
     -     (2.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (23*mglu**2*msq2**4*mst2**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (37*mglu**2*mst2**6)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq1**2*mst2**6)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6)/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (27*mglu**2*msq1**2*mst2**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*msq1**4*mst2**6)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq2**2*mst2**6)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6)/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (27*mglu**2*msq2**2*mst2**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*msq2**4*mst2**6)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (21*mst2**8)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*msq1**2*mst2**8)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*msq2**2*mst2**8)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    mst2**10/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    mst2**10/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**6*mt**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**4*msq1**2*mt**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**8*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**6*msq1**2*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**4*msq1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**4*msq2**2*mt**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**8*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**6*msq2**2*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**4*msq2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**4*mst2**2*mt**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst2**2*mt**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*mst2**2*mt**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**2*mst2**2*mt**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**4*mst2**2*mt**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst2**2*mt**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*mst2**2*mt**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**2*mst2**2*mt**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**4*mst2**2*mt**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*mst2**4*mt**2)/
     -     (2.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*msq1**2*mst2**4*mt**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (21*mglu**4*mst2**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (59*mglu**2*msq1**2*mst2**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*msq1**4*mst2**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*msq2**2*mst2**4*mt**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (21*mglu**4*mst2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (59*mglu**2*msq2**2*mst2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*msq2**4*mst2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**2)/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mglu**2*mst2**6*mt**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**6*mt**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mglu**2*mst2**6*mt**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**6*mt**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mst2**8*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mst2**8*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (23*mglu**4*mt**4)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**2*msq1**2*mt**4)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**6*mt**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**4*msq1**2*mt**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**2*msq1**4*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**2*msq2**2*mt**4)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**6*mt**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**4*msq2**2*mt**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**2*msq2**4*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*mglu**2*mst2**2*mt**4)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**4)/
     -     (2.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (31*mglu**4*mst2**2*mt**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**2*msq1**2*mst2**2*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**2*mt**4)/
     -     (2.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**4)/
     -     (2.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (31*mglu**4*mst2**2*mt**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**2*msq2**2*mst2**2*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**2*mt**4)/
     -     (2.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (41*mst2**4*mt**4)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (15*mglu**2*mst2**4*mt**4)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (41*msq1**2*mst2**4*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (15*mglu**2*mst2**4*mt**4)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (41*msq2**2*mst2**4*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**6)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**2*mt**6)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**4*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*msq1**2*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq1**4*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**2*mt**6)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**4*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*msq2**2*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq2**4*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mst2**2*mt**6)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mst2**2*mt**6)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*msq1**2*mst2**2*mt**6)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mst2**2*mt**6)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*msq2**2*mst2**2*mt**6)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (41*mst2**4*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (41*mst2**4*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (47*mt**8)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (47*msq1**2*mt**8)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (47*msq2**2*mt**8)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (109*mst2**2*mt**8)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (109*mst2**2*mt**8)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (41*mt**10)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (41*mt**10)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (59*mglu**4)/
     -     (128.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**6*msq1**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu**4*msq1**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**6)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (101*mglu**4*msq1**2)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**6*msq2**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu**4*msq2**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**6)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (101*mglu**4*msq2**2)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**2*mst2**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**6*mst2**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu**4*msq1**2*mst2**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*msq1**4*mst2**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (33*mglu**4*mst2**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (15*mglu**2*msq1**2*mst2**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**6*mst2**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu**4*msq2**2*mst2**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*msq2**4*mst2**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (33*mglu**4*mst2**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (15*mglu**2*msq2**2*mst2**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (29*mst2**4)/
     -     (128.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**4)/
     -     (64.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**4*mst2**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (63*mglu**2*msq1**2*mst2**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*msq1**4*mst2**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (51*mglu**2*mst2**4)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (87*msq1**2*mst2**4)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**4*mst2**4)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**4)/
     -     (64.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**4*mst2**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (63*mglu**2*msq2**2*mst2**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*msq2**4*mst2**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (51*mglu**2*mst2**4)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (87*msq2**2*mst2**4)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**4*mst2**4)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**6)/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**2*mst2**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (91*msq1**2*mst2**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (17*mst2**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**6)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**2*mst2**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (91*msq2**2*mst2**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (17*mst2**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**6)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mst2**8)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mst2**8)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*mt**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mt**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (77*mglu**6*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**4*msq1**2*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*msq1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**4*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (15*mglu**2*msq1**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mt**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (77*mglu**6*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**4*msq2**2*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*msq2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**4*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (15*mglu**2*msq2**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mst2**2*mt**2)/
     -     (64.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**2*mt**2)/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**4*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (49*mglu**2*msq1**2*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*msq1**4*mst2**2*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (89*msq1**2*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**4*mst2**2*mt**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**2*mt**2)/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**4*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (49*mglu**2*msq2**2*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*msq2**4*mst2**2*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (89*msq2**2*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**4*mst2**2*mt**2)/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mst2**4*mt**2)/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*mglu**2*mst2**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*msq1**2*mst2**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (11*mst2**4*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*msq1**2*mst2**4*mt**2)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*mglu**2*mst2**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*msq2**2*mst2**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (11*mst2**4*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*msq2**2*mst2**4*mt**2)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mst2**6*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mst2**6*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (61*mt**4)/
     -     (128.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mt**4)/
     -     (64.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (105*mglu**4*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (119*mglu**2*msq1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*msq1**4*mt**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (19*mglu**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (119*msq1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**4*mt**4)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mt**4)/
     -     (64.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (105*mglu**4*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (119*mglu**2*msq2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*msq2**4*mt**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (19*mglu**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (119*msq2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**4*mt**4)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mst2**2*mt**4)/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (91*mglu**2*mst2**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*msq1**2*mst2**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (17*mst2**2*mt**4)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq1**2*mst2**2*mt**4)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (91*mglu**2*mst2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*msq2**2*mst2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (17*mst2**2*mt**4)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq2**2*mst2**2*mt**4)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mst2**4*mt**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mst2**4*mt**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mt**6)/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*mt**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (105*msq1**2*mt**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (11*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mt**6)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*mt**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (105*msq2**2*mt**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (11*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mt**6)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mst2**2*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mst2**2*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mt**8)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mt**8)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**2*msq1**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (49*mglu**2*msq1**4*mst2**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*msq1**6*mst2**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**2*msq1**2*mst2**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (49*msq1**4*mst2**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu**2*mst2**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*msq1**2*mst2**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mst2**8)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*msq1**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*msq1**6*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**2*msq1**2*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*msq1**4*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**2*mst2**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (105*msq1**2*mst2**4*mt**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mst2**6*mt**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**2*msq1**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*msq1**4*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**2*mst2**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (119*msq1**2*mst2**2*mt**4)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mst2**4*mt**4)/
     -     (128.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu**2*mt**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*msq1**2*mt**6)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mst2**2*mt**6)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mt**8)/
     -     (256.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**2*msq2**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (49*mglu**2*msq2**4*mst2**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*msq2**6*mst2**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**2*msq2**2*mst2**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (49*msq2**4*mst2**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu**2*mst2**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*msq2**2*mst2**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mst2**8)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*msq2**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*msq2**6*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**2*msq2**2*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*msq2**4*mst2**2*mt**2)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**2*mst2**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (105*msq2**2*mst2**4*mt**2)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mst2**6*mt**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**2*msq2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*msq2**4*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu**2*mst2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (119*msq2**2*mst2**2*mt**4)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mst2**4*mt**4)/
     -     (128.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu**2*mt**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*msq2**2*mt**6)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mst2**2*mt**6)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mt**8)/
     -     (256.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - Pi**2/16. + 
     -    (5*mglu**4*msq1**2*Pi**2)/(96.*(-mglu**2 + msq1**2)**3) - 
     -    (5*msq1**6*Pi**2)/(96.*(-mglu**2 + msq1**2)**3) - 
     -    (13*mglu**4*Pi**2)/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (73*mglu**2*msq1**2*Pi**2)/(768.*(-mglu**2 + msq1**2)**2) + 
     -    (65*msq1**4*Pi**2)/(384.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**6*Pi**2)/(768.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (11*mglu**2*Pi**2)/(96.*(-mglu**2 + msq1**2)) - 
     -    (15*msq1**2*Pi**2)/(256.*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**4*Pi**2)/(768.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**4*msq2**2*Pi**2)/(96.*(-mglu**2 + msq1**2)**3) - 
     -    (5*msq1**4*msq2**2*Pi**2)/(96.*(-mglu**2 + msq1**2)**3) - 
     -    (25*mglu**2*msq2**2*Pi**2)/(768.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**2*msq2**2*Pi**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**4*msq2**2*Pi**2)/(768.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (35*msq2**2*Pi**2)/(768.*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**2*msq2**2*Pi**2)/(768.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (5*mglu**2*msq1**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu**2*msq1**2*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*msq1**4*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*msq1**2*msq2**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu**4*msq1**2*Pi**2)/(96.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**4*msq2**2*Pi**2)/(96.*(-mglu**2 + msq2**2)**3) - 
     -    (5*msq1**2*msq2**4*Pi**2)/(96.*(-mglu**2 + msq2**2)**3) - 
     -    (5*msq2**6*Pi**2)/(96.*(-mglu**2 + msq2**2)**3) - 
     -    (13*mglu**4*Pi**2)/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (25*mglu**2*msq1**2*Pi**2)/(768.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**4*msq1**2*Pi**2)/
     -     (768.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq1**4*Pi**2)/
     -     (768.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (73*mglu**2*msq2**2*Pi**2)/(768.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**2*Pi**2)/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**4*msq2**2*Pi**2)/
     -     (768.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (25*mglu**2*msq1**2*msq2**2*Pi**2)/
     -     (768.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (65*msq2**4*Pi**2)/(384.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*Pi**2)/(768.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*Pi**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**4*Pi**2)/
     -     (768.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**6*Pi**2)/(768.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**6*Pi**2)/(768.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**6*Pi**2)/
     -     (768.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*msq2**2*Pi**2)/
     -     (192.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**2*Pi**2)/
     -     (192.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**4*Pi**2)/
     -     (192.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*Pi**2)/
     -     (192.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (11*mglu**2*Pi**2)/(96.*(-mglu**2 + msq2**2)) - 
     -    (35*msq1**2*Pi**2)/(768.*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*msq1**2*Pi**2)/
     -     (768.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**6*Pi**2)/(768.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*Pi**2)/(192.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*Pi**2)/(128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (15*msq2**2*Pi**2)/(256.*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*Pi**2)/(768.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*msq2**2*Pi**2)/
     -     (768.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (25*mglu**2*msq1**2*msq2**2*Pi**2)/
     -     (768.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**2*Pi**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**6*msq2**2*Pi**2)/
     -     (768.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*Pi**2)/(768.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq2**4*Pi**2)/
     -     (768.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**4*Pi**2)/
     -     (768.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*Pi**2)/(128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*mst1**2*Pi**2)/(96.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*mst1**2*Pi**2)/(96.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**2*mst1**2*Pi**2)/(48.*(-mglu**2 + msq1**2)**2) - 
     -    (mst1**2*Pi**2)/(96.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*mst1**2*Pi**2)/(96.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*mst1**2*Pi**2)/(96.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**2*mst1**2*Pi**2)/(48.*(-mglu**2 + msq2**2)**2) - 
     -    (mst1**2*Pi**2)/(96.*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*mst2**2*Pi**2)/(96.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*mst2**2*Pi**2)/(96.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**2*mst2**2*Pi**2)/(48.*(-mglu**2 + msq1**2)**2) - 
     -    (mst2**2*Pi**2)/(96.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*mst2**2*Pi**2)/(96.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*mst2**2*Pi**2)/(96.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**2*mst2**2*Pi**2)/(48.*(-mglu**2 + msq2**2)**2) - 
     -    (mst2**2*Pi**2)/(96.*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*mt**2*Pi**2)/(48.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**4*mt**2*Pi**2)/(48.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**2*mt**2*Pi**2)/(24.*(-mglu**2 + msq1**2)**2) + 
     -    (mt**2*Pi**2)/(48.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*mt**2*Pi**2)/(48.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**4*mt**2*Pi**2)/(48.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**2*mt**2*Pi**2)/(24.*(-mglu**2 + msq2**2)**2) + 
     -    (mt**2*Pi**2)/(48.*(-mglu**2 + msq2**2)) + 
     -    (mglu**8*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*msq1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*Pi**2)/
     -     (24.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mst1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mst1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**4*Pi**2)/
     -     (12.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**4*Pi**2)/
     -     (48.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst1**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**4*Pi**2)/
     -     (48.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst1**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**6*Pi**2)/
     -     (12.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**6*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**6*Pi**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**6*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**6*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**6*Pi**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**6*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**8*Pi**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**8*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**8*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**10*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**10*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**2*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mst1**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst1**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mst1**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst1**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**4*mt**2*Pi**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**4*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**4*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**4*mst1**4*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**4*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**4*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**4*mst1**4*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mst1**6*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mst1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*msq1**2*mst1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mst1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*msq2**2*mst1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**8*mt**2*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**8*mt**2*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**4*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mst1**4*mt**4*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*msq1**2*mst1**4*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*msq2**2*mst1**4*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**4*Pi**2)/
     -     (24.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**4*Pi**2)/
     -     (24.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**6*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**2*mt**6*Pi**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mst1**4*mt**6*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mst1**4*mt**6*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**8*Pi**2)/
     -     (48.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mt**8*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mt**8*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mst1**2*mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mst1**2*mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*msq1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mst1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq1**2*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**4*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mst1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq2**2*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**4*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*Pi**2)/
     -     (48.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**6*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**6*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq1**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**4*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**4*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))))*TF

        mssmzetavec(2) = CF*TF*(-(mglu**2*msq2**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**2*Pi**2)/
     -     (48.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**4*Pi**2)/
     -     (48.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**4*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**6*mst1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**4*mst1**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**6*mst1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**8*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*msq1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*Pi**2)/
     -     (24.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mst2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mst2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**4*Pi**2)/
     -     (12.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**4*Pi**2)/
     -     (48.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst2**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**4*Pi**2)/
     -     (48.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst2**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**6*Pi**2)/
     -     (12.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**6*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**6*Pi**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**6*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**6*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**6*Pi**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**6*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**8*Pi**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**8*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**8*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**10*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**10*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**2*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mst2**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst2**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mst2**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst2**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**4*mt**2*Pi**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**4*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**4*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**4*mst2**4*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**4*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**4*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**4*mst2**4*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mst2**6*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mst2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*msq1**2*mst2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mst2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*msq2**2*mst2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**8*mt**2*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**8*mt**2*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**4*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mst2**4*mt**4*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*msq1**2*mst2**4*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*msq2**2*mst2**4*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**4*Pi**2)/
     -     (24.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**4*Pi**2)/
     -     (24.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**6*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**2*mt**6*Pi**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mst2**4*mt**6*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mst2**4*mt**6*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**8*Pi**2)/
     -     (48.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mt**8*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mt**8*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mst2**2*mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mst2**2*mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**6*msq1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq1**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**6*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mst2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq1**2*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**4*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mst2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq2**2*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**4*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*Pi**2)/
     -     (48.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**6*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**6*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**2*Pi**2)/
     -     (96.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq1**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**4*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**4*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**2*Pi**2)/
     -     (48.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**4*Pi**2)/
     -     (48.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**4*Pi**2)/
     -     (48.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**4*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**6*mst2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**4*Pi**2)/
     -     (96.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**4*mst2**2*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**6*mst2**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**4*Pi**2)/
     -     (96.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*mt**2*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*mt**2*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**4*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**4*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**6*Pi**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**8*Pi**2)/
     -     (192.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (15*mglu**3*msq1**2*Xb)/(4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (15*mglu*msq1**4*Xb)/(4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu**3*Xb)/((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*Xb)/(4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (15*mglu**3*msq2**2*Xb)/(4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (15*mglu*msq1**2*msq2**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu*msq2**2*Xb)/(4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (15*msq1**2*msq2**2*Xb)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (15*msq2**4*Xb)/(8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (15*mglu**3*msq1**2*Xb)/(4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**3*msq2**2*Xb)/(4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*mglu*msq1**2*msq2**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*mglu*msq2**4*Xb)/(4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu**3*Xb)/((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (15*mglu*msq1**2*Xb)/(4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (15*msq1**4*Xb)/(8.*mglu*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*msq1**2*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (35*mglu*msq1**4*Xb)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (15*msq1**6*Xb)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**2*Xb)/(4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (15*msq1**2*msq2**2*Xb)/
     -     (8.*mglu*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (15*msq1**4*msq2**2*Xb)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (35*mglu*msq2**4*Xb)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (15*msq1**2*msq2**4*Xb)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (15*msq2**6*Xb)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu**3*mst1**2*Xb)/(4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu*msq1**2*mst1**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst1**2*Xb)/(2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*mst1**2*Xb)/(4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu*msq2**2*mst1**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst1**2*Xb)/(2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu**3*mst2**2*Xb)/(4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu*msq1**2*mst2**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst2**2*Xb)/(2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*mst2**2*Xb)/(4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu*msq2**2*mst2**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst2**2*Xb)/(2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (3*mglu**3*mt**2*Xb)/(2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*msq1**2*mt**2*Xb)/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mt**2*Xb)/((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (3*mglu**3*mt**2*Xb)/(2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*msq2**2*mt**2*Xb)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mt**2*Xb)/((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu**5*msq1**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**5*msq2**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**5*mst1**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mst1**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**5*mst1**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mst1**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**4*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**4*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**4*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*Xb)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**6*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**6*Xb)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**5*mt**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**5*mt**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst1**2*mt**2*Xb)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst1**2*mt**2*Xb)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xb)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xb)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**4*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xb)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Xb)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xb)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xb)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**5*msq1**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*msq2**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*mst2**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq1**2*mst2**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**5*mst2**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mst2**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**4*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**4*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**4*Xb)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**6*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**6*Xb)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**5*mt**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*mt**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst2**2*mt**2*Xb)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst2**2*mt**2*Xb)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xb)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xb)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**4*Xb)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xb)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xb)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Xb)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xb)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xb)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**3*msq1**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*Pi**2*Xb)/(16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu**3*msq2**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**2*msq2**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq2**2*Pi**2*Xb)/(48.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*msq1**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**3*msq2**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu*msq1**2*msq2**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu*msq2**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*msq1**2*Pi**2*Xb)/(48.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*msq1**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq1**4*Pi**2*Xb)/
     -     (48.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**2*Pi**2*Xb)/(16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**3*msq2**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**4*Pi**2*Xb)/
     -     (48.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*mst1**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mst1**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst1**2*Pi**2*Xb)/(24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst1**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mst1**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst1**2*Pi**2*Xb)/(24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*mst2**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mst2**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst2**2*Pi**2*Xb)/(24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst2**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mst2**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst2**2*Pi**2*Xb)/(24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*mt**2*Pi**2*Xb)/
     -     (12.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*mt**2*Pi**2*Xb)/
     -     (12.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mt**2*Pi**2*Xb)/(12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mt**2*Pi**2*Xb)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**2*mt**2*Pi**2*Xb)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mt**2*Pi**2*Xb)/(12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq1**2*mst1**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mst1**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**6*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**6*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mst2**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mst2**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**6*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**6*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (25*mglu**7*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (25*mglu**7*msq1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (25*mglu**7*msq2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (89*mglu**5*mst1**2*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (13*mglu**7*mst1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (89*mglu**5*msq1**2*mst1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (13*mglu**7*mst1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (89*mglu**5*msq2**2*mst1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (103*mglu**3*mst1**4*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (25*mglu**5*mst1**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (103*mglu**3*msq1**2*mst1**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (25*mglu**5*mst1**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (103*mglu**3*msq2**2*mst1**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (39*mglu*mst1**6*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**3*mst1**6*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (39*mglu*msq1**2*mst1**6*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**3*mst1**6*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (39*mglu*msq2**2*mst1**6*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (47*mglu**5*mt**4*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*mglu**7*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (47*mglu**5*msq1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*mglu**7*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (47*mglu**5*msq2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu**3*mst1**2*mt**4*Xt)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**5*mst1**2*mt**4*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**3*msq1**2*mst1**2*mt**4*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**5*mst1**2*mt**4*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**3*msq2**2*mst1**2*mt**4*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (31*mglu*mst1**4*mt**4*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (43*mglu**3*mst1**4*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (31*mglu*msq1**2*mst1**4*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (43*mglu**3*mst1**4*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (31*mglu*msq2**2*mst1**4*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**6*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**6*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (75*mglu**3*mt**6*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**5*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (75*mglu**3*msq1**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**5*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (75*mglu**3*msq2**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (101*mglu*mst1**2*mt**6*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mglu**3*mst1**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (101*mglu*msq1**2*mst1**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mglu**3*mst1**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (101*mglu*msq2**2*mst1**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu*mst1**4*mt**6*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu*mst1**4*mt**6*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (53*mglu*mt**8*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (39*mglu**3*mt**8*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (53*mglu*msq1**2*mt**8*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (39*mglu**3*mt**8*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (53*mglu*msq2**2*mt**8*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (17*mglu*mst1**2*mt**8*Xt)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (17*mglu*mst1**2*mt**8*Xt)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (41*mglu*mt**10*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (41*mglu*mt**10*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*mglu**3*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*mglu**5*msq1**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (75*mglu**5*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (13*mglu**3*msq1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*mglu**5*msq2**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (75*mglu**5*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (13*mglu**3*msq2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (15*mglu*mst1**2*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu**5*mst1**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu**3*msq1**2*mst1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (11*mglu**3*mst1**2*mt**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (15*mglu*msq1**2*mst1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu**5*mst1**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu**3*msq2**2*mst1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (11*mglu**3*mst1**2*mt**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (15*mglu*msq2**2*mst1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**4*mt**2*Xt)/
     -     (4.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**3*mst1**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (119*mglu*msq1**2*mst1**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (91*mglu*mst1**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**4*mt**2*Xt)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**3*mst1**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (119*mglu*msq2**2*mst1**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (91*mglu*mst1**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**4*mt**2*Xt)/
     -     (8.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu*mst1**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu*mst1**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**4*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu**5*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**3*msq1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu**5*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu**3*msq2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**4*Xt)/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**3*mst1**2*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (77*mglu*msq1**2*mst1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (89*mglu*mst1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**2*mt**4*Xt)/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**3*mst1**2*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (77*mglu*msq2**2*mst1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (89*mglu*mst1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**2*mt**4*Xt)/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu*mst1**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu*mst1**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mt**6*Xt)/
     -     (4.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**3*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (175*mglu*msq1**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (67*mglu*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mt**6*Xt)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu**3*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (175*mglu*msq2**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (67*mglu*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mt**6*Xt)/
     -     (8.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (49*mglu*mst1**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (49*mglu*mst1**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu*mt**8*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu*mt**8*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu*msq1**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu*msq1**4*mst1**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu*msq1**2*mst1**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mglu*mst1**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*msq1**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu*msq1**2*mst1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*mst1**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu*msq1**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*mglu*mst1**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu*mt**8*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (35*mglu*msq2**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu*msq2**4*mst1**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu*msq2**2*mst1**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (21*mglu*mst1**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*msq2**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (21*mglu*msq2**2*mst1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*mst1**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu*msq2**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (49*mglu*mst1**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (35*mglu*mt**8*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (25*mglu**7*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (25*mglu**7*msq1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (25*mglu**7*msq2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (89*mglu**5*mst2**2*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*mglu**7*mst2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (89*mglu**5*msq1**2*mst2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*mglu**7*mst2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (89*mglu**5*msq2**2*mst2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (103*mglu**3*mst2**4*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (25*mglu**5*mst2**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (103*mglu**3*msq1**2*mst2**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (25*mglu**5*mst2**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (103*mglu**3*msq2**2*mst2**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (39*mglu*mst2**6*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**3*mst2**6*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (39*mglu*msq1**2*mst2**6*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**3*mst2**6*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (39*mglu*msq2**2*mst2**6*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (47*mglu**5*mt**4*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (13*mglu**7*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (47*mglu**5*msq1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (13*mglu**7*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (47*mglu**5*msq2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mglu**3*mst2**2*mt**4*Xt)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**5*mst2**2*mt**4*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**3*msq1**2*mst2**2*mt**4*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**5*mst2**2*mt**4*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**3*msq2**2*mst2**2*mt**4*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (31*mglu*mst2**4*mt**4*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (43*mglu**3*mst2**4*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (31*mglu*msq1**2*mst2**4*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (43*mglu**3*mst2**4*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (31*mglu*msq2**2*mst2**4*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**6*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**6*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (75*mglu**3*mt**6*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**5*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (75*mglu**3*msq1**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**5*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (75*mglu**3*msq2**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (101*mglu*mst2**2*mt**6*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mglu**3*mst2**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (101*mglu*msq1**2*mst2**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mglu**3*mst2**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (101*mglu*msq2**2*mst2**2*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu*mst2**4*mt**6*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu*mst2**4*mt**6*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (53*mglu*mt**8*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (39*mglu**3*mt**8*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (53*mglu*msq1**2*mt**8*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (39*mglu**3*mt**8*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (53*mglu*msq2**2*mt**8*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (17*mglu*mst2**2*mt**8*Xt)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (17*mglu*mst2**2*mt**8*Xt)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (41*mglu*mt**10*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (41*mglu*mt**10*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (13*mglu**3*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*mglu**5*msq1**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (75*mglu**5*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (13*mglu**3*msq1**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*mglu**5*msq2**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (75*mglu**5*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (13*mglu**3*msq2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (15*mglu*mst2**2*mt**2*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu**5*mst2**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**3*msq1**2*mst2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (11*mglu**3*mst2**2*mt**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (15*mglu*msq1**2*mst2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu**5*mst2**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**3*msq2**2*mst2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (11*mglu**3*mst2**2*mt**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (15*mglu*msq2**2*mst2**2*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**2*Xt)/
     -     (4.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**3*mst2**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (119*mglu*msq1**2*mst2**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (91*mglu*mst2**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**4*mt**2*Xt)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**3*mst2**4*mt**2*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (119*mglu*msq2**2*mst2**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (91*mglu*mst2**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**4*mt**2*Xt)/
     -     (8.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu*mst2**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu*mst2**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**4*Xt)/
     -     (16.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**5*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**3*msq1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu**5*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**3*msq2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**4*Xt)/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**3*mst2**2*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (77*mglu*msq1**2*mst2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (89*mglu*mst2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**2*mt**4*Xt)/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**3*mst2**2*mt**4*Xt)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (77*mglu*msq2**2*mst2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (89*mglu*mst2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**2*mt**4*Xt)/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu*mst2**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu*mst2**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mt**6*Xt)/
     -     (4.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu**3*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (175*mglu*msq1**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (67*mglu*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mt**6*Xt)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu**3*mt**6*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (175*mglu*msq2**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (67*mglu*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mt**6*Xt)/
     -     (8.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (49*mglu*mst2**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (49*mglu*mst2**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu*mt**8*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu*mt**8*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu*msq1**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu*msq1**4*mst2**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu*msq1**2*mst2**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu*mst2**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*msq1**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu*msq1**2*mst2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*mst2**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu*msq1**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*mglu*mst2**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu*mt**8*Xt)/
     -     (64.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (35*mglu*msq2**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu*msq2**4*mst2**2*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu*msq2**2*mst2**4*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (21*mglu*mst2**6*mt**2*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*msq2**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (21*mglu*msq2**2*mst2**2*mt**4*Xt)/
     -     (32.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*mst2**4*mt**4*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu*msq2**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (49*mglu*mst2**2*mt**6*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (35*mglu*mt**8*Xt)/
     -     (64.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**7*mt**2*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*msq1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*msq2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**5*mst1**2*mt**2*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*mst1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq1**2*mst1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*mst1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq2**2*mst1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**3*mst1**4*mt**2*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*msq1**2*mst1**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*msq2**2*mst1**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**6*mt**2*Pi**2*Xt)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**6*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mst1**6*mt**2*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**6*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mst1**6*mt**2*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mt**4*Pi**2*Xt)/
     -     (12.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**7*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*msq1**2*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**7*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*msq2**2*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**2*mt**4*Pi**2*Xt)/
     -     (6.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mst1**2*mt**4*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mst1**2*mt**4*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**4*mt**4*Pi**2*Xt)/
     -     (12.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq1**2*mst1**4*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq2**2*mst1**4*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**6*mt**4*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**6*mt**4*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**6*Pi**2*Xt)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mt**6*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mt**6*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu*mst1**2*mt**6*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**2*mt**6*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu*msq1**2*mst1**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**2*mt**6*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu*msq2**2*mst1**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu*mst1**4*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu*mst1**4*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (12.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**8*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mt**8*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**8*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mt**8*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu*mst1**2*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu*mst1**2*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**2*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*msq1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*msq2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**2*Pi**2*Xt)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mst1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**3*msq1**2*mst1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**2*mt**2*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mst1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**3*msq2**2*mst1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**2*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**4*mt**2*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*mt**2*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**4*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq1**2*mt**4*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**4*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu*msq1**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu*msq2**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**6*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**6*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**7*mt**2*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*msq1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*msq2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**5*mst2**2*mt**2*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*mst2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq1**2*mst2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*mst2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq2**2*mst2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**3*mst2**4*mt**2*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*msq1**2*mst2**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*msq2**2*mst2**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**6*mt**2*Pi**2*Xt)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**6*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mst2**6*mt**2*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**6*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mst2**6*mt**2*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mt**4*Pi**2*Xt)/
     -     (12.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**7*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*msq1**2*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**7*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*msq2**2*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**2*mt**4*Pi**2*Xt)/
     -     (6.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mst2**2*mt**4*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mst2**2*mt**4*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**4*mt**4*Pi**2*Xt)/
     -     (12.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq1**2*mst2**4*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq2**2*mst2**4*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**6*mt**4*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**6*mt**4*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**6*Pi**2*Xt)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mt**6*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mt**6*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu*mst2**2*mt**6*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**2*mt**6*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu*msq1**2*mst2**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**2*mt**6*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu*msq2**2*mst2**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu*mst2**4*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu*mst2**4*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (12.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**8*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mt**8*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**8*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mt**8*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu*mst2**2*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu*mst2**2*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**2*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*msq1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq1**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*msq2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**2*Pi**2*Xt)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mst2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**3*msq1**2*mst2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**2*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mst2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**3*msq2**2*mst2**2*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**2*mt**2*Pi**2*Xt)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*mt**2*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**4*mt**2*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**4*Pi**2*Xt)/
     -     (24.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**4*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**4*Pi**2*Xt)/
     -     (12.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**2*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu*msq1**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu*msq2**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**6*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**6*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**4*mt**2*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**4*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))))

        mssmzetavec(3) = CF*TF*((mglu*msq2**2*mt**6*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**6*Pi**2*Xt)/
     -     (24.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**8*Pi**2*Xt)/
     -     (48.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*mt**2*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*msq1**2*mt**2*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mt**2*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*msq2**2*mt**2*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*mt**2*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*mt**2*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (2*mglu**2*mst1**4*mt**2*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (2*msq1**2*mst1**4*mt**2*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (2*mglu**2*mst1**4*mt**2*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (2*msq2**2*mst1**4*mt**2*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**2*mt**4*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**2*mt**4*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**2*mt**4*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**2*mt**4*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (2*mglu**2*mt**6*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (2*msq1**2*mt**6*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (2*mglu**2*mt**6*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (2*msq2**2*mt**6*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mt**2*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*msq1**2*mt**2*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*mt**2*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*msq2**2*mt**2*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*mt**2*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*mt**2*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (2*mglu**2*mst2**4*mt**2*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (2*msq1**2*mst2**4*mt**2*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (2*mglu**2*mst2**4*mt**2*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (2*msq2**2*mst2**4*mt**2*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*Xb*Xt)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**4*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*Xb*Xt)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**2*mt**4*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**2*mt**4*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**2*mt**4*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**2*mt**4*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (2*mglu**2*mt**6*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (2*msq1**2*mt**6*Xb*Xt)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (2*mglu**2*mt**6*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (2*msq2**2*mt**6*Xb*Xt)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**4*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**6*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst2**2*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**4*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*Pi**2*Xb*Xt)/
     -     (12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**6*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*Pi**2*Xb*Xt)/
     -     (12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq1,mu))/(8.*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**2*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu**2*B0finTMP(mglu**2,0.d0,msq1,mu))/(16.*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu))/(16.*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq1,mu))/(8.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*B0finTMP(mglu**2,0.d0,msq1,mu))/(16.*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu))/(16.*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq2,mu))/(8.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu**2*B0finTMP(mglu**2,0.d0,msq2,mu))/(16.*(-mglu**2 + msq1**2)) - 
     -    (5*mglu**2*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu))/(16.*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq2,mu))/(8.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*B0finTMP(mglu**2,0.d0,msq2,mu))/(16.*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu))/(16.*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst1,mu))/(8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*B0finTMP(mglu**2,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst1,mu))/(8.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*B0finTMP(mglu**2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*mst1**2*B0finTMP(mglu**2,mt,mst1,mu))/(8.*(-mglu**2 + msq1**2)**2) - 
     -    (mst1**2*B0finTMP(mglu**2,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)) - 
     -    (mglu**2*mst1**2*B0finTMP(mglu**2,mt,mst1,mu))/(8.*(-mglu**2 + msq2**2)**2) - 
     -    (mst1**2*B0finTMP(mglu**2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst1,mu))/(8.*(-mglu**2 + msq1**2)**2) + 
     -    (mt**2*B0finTMP(mglu**2,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)) + 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst1,mu))/(8.*(-mglu**2 + msq2**2)**2) + 
     -    (mt**2*B0finTMP(mglu**2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*Xb*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*Xb*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst2,mu))/(8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*B0finTMP(mglu**2,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst2,mu))/(8.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*B0finTMP(mglu**2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*mst2**2*B0finTMP(mglu**2,mt,mst2,mu))/(8.*(-mglu**2 + msq1**2)**2) - 
     -    (mst2**2*B0finTMP(mglu**2,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)) - 
     -    (mglu**2*mst2**2*B0finTMP(mglu**2,mt,mst2,mu))/(8.*(-mglu**2 + msq2**2)**2) - 
     -    (mst2**2*B0finTMP(mglu**2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst2,mu))/(8.*(-mglu**2 + msq1**2)**2) + 
     -    (mt**2*B0finTMP(mglu**2,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)) + 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst2,mu))/(8.*(-mglu**2 + msq2**2)**2) + 
     -    (mt**2*B0finTMP(mglu**2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*Xb*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*Xb*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) + 
     -    (15*dlog(mu**2/mglu**2))/8. + 
     -    (5*mglu**2*dlog(mu**2/mglu**2))/(32.*msq1**2) + 
     -    (5*msq1**2*dlog(mu**2/mglu**2))/(16.*mglu**2) - 
     -    (9*mglu**6*dlog(mu**2/mglu**2))/(4.*(-mglu**2 + msq1**2)**3) + 
     -    (27*mglu**4*msq1**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (37*mglu**2*msq1**4*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (63*mglu**4*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**2) - 
     -    (87*mglu**2*msq1**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (15*msq1**4*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**2) - 
     -    (37*mglu**2*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**4*dlog(mu**2/mglu**2))/(32.*msq1**2*(-mglu**2 + msq1**2)) - 
     -    (95*msq1**2*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**4*dlog(mu**2/mglu**2))/(16.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**2*dlog(mu**2/mglu**2))/(32.*msq2**2) - 
     -    (5*mglu**2*msq1**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*msq2**2) + 
     -    (5*msq2**2*dlog(mu**2/mglu**2))/(16.*mglu**2) - 
     -    (15*mglu**4*msq2**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (15*mglu**2*msq2**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq2**2*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)) - 
     -    (9*mglu**6*dlog(mu**2/mglu**2))/(4.*(-mglu**2 + msq2**2)**3) - 
     -    (15*mglu**4*msq1**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (27*mglu**4*msq2**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (37*mglu**2*msq2**4*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (63*mglu**4*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**2*msq1**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (87*mglu**2*msq2**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (15*msq2**4*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**2) - 
     -    (37*mglu**2*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*dlog(mu**2/mglu**2))/(32.*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (95*msq2**2*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq2**2*dlog(mu**2/mglu**2))/
     -     (64.*msq1**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2))/
     -     (64.*msq1**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**4*dlog(mu**2/mglu**2))/(16.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mst1**2*dlog(mu**2/mglu**2))/(16.*mglu**2) - 
     -    (3*mglu**4*mst1**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*msq1**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (3*msq1**2*mst1**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (3*mst1**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq1**2)) - 
     -    (msq1**2*mst1**2*dlog(mu**2/mglu**2))/(32.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (3*mglu**4*mst1**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*msq2**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (3*msq2**2*mst1**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (3*mst1**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*mst1**2*dlog(mu**2/mglu**2))/(32.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (mst2**2*dlog(mu**2/mglu**2))/(16.*mglu**2) - 
     -    (3*mglu**4*mst2**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*msq1**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (3*msq1**2*mst2**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (3*mst2**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq1**2)) - 
     -    (msq1**2*mst2**2*dlog(mu**2/mglu**2))/(32.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (3*mglu**4*mst2**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*msq2**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (3*msq2**2*mst2**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (3*mst2**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*mst2**2*dlog(mu**2/mglu**2))/(32.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (mt**2*dlog(mu**2/mglu**2))/(8.*mglu**2) + 
     -    (3*mglu**4*mt**2*dlog(mu**2/mglu**2))/(8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/mglu**2))/(8.*(-mglu**2 + msq1**2)**3) - 
     -    (3*msq1**2*mt**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mt**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)) + 
     -    (msq1**2*mt**2*dlog(mu**2/mglu**2))/(16.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (3*mglu**4*mt**2*dlog(mu**2/mglu**2))/(8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/mglu**2))/(8.*(-mglu**2 + msq2**2)**3) - 
     -    (3*msq2**2*mt**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (3*mt**2*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)) + 
     -    (msq2**2*mt**2*dlog(mu**2/mglu**2))/(16.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (11*mglu**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**8*msq1**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*msq1**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**8*msq2**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*msq2**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**6*mst1**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**4*msq1**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**8*mst1**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**6*msq1**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**4*msq1**4*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**4*msq2**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**8*mst1**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**6*msq2**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**4*msq2**4*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (15*mglu**4*mst1**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**6*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**4*msq1**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**4*mst1**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**6*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**4*msq2**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**4*mst1**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq1**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**4*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (17*mglu**2*msq1**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*msq1**4*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq2**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**4*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (17*mglu**2*msq2**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*msq2**4*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (13*mst1**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*mst1**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*msq1**2*mst1**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*mst1**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*msq2**2*mst1**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**10*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**10*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*mglu**6*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**6*msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**6*msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*msq1**4*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*msq2**4*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**4*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**4*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**6*mt**2*dlog(mu**2/mglu**2))/
     -     (-mglu**4 - mst1**4 - mt**4 + 
     -        2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2 + 
     -    (5*mglu**2*mst1**6*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**6*mt**2*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mst1**6*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**6*mt**2*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mst1**8*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mst1**8*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*mt**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**6*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**6*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**4*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**2*msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**4*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**2*msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mst1**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*msq1**2*mst1**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*msq2**2*mst1**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (15*mst1**6*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (15*mst1**6*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**2*msq1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**2*msq2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*mst1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*mst1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mst1**4*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mst1**4*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mt**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mt**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*msq1**2*mt**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mt**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*msq2**2*mt**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (15*mst1**2*mt**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (15*mst1**2*mt**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mt**10*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mt**10*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**6*msq1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*msq1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**6*msq2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*msq2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**4*msq1**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**4*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**4*msq2**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**4*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq1**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**4*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq2**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**4*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**6*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**6*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**6*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**4*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**4*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mt**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mt**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (11*mglu**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**8*msq1**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*msq1**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**8*msq2**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*msq2**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**6*mst2**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**4*msq1**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**8*mst2**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mglu**6*msq1**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**4*msq1**4*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**4*msq2**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**8*mst2**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mglu**6*msq2**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**4*msq2**4*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mglu**4*mst2**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**6*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**4*msq1**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**4*mst2**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**6*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**4*msq2**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**4*mst2**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq1**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**4*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (17*mglu**2*msq1**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*msq1**4*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq2**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**4*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (17*mglu**2*msq2**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*msq2**4*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (13*mst2**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*mst2**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*msq1**2*mst2**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*mst2**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*msq2**2*mst2**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**10*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**10*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*mglu**6*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**6*msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**6*msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*msq1**4*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*msq2**4*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**4*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**4*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**6*mt**2*dlog(mu**2/mglu**2))/
     -     (-mglu**4 - mst2**4 - mt**4 + 
     -        2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2 + 
     -    (5*mglu**2*mst2**6*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**6*mt**2*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mst2**6*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**6*mt**2*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (15*mst2**8*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (15*mst2**8*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*mt**4*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**6*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**6*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**4*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**2*msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**4*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**2*msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mst2**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*msq1**2*mst2**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*msq2**2*mst2**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mst2**6*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mst2**6*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**2*msq1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**2*msq2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*mst2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*mst2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (15*mst2**4*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (15*mst2**4*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mt**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mt**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*msq1**2*mt**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mt**8*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*msq2**2*mt**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mst2**2*mt**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mst2**2*mt**8*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mt**10*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mt**10*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*msq1**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*msq1**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*msq2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*msq2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**4*msq1**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**4*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**4*msq2**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**4*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq1**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**4*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq2**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**4*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**6*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**4*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**4*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mglu**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mt**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mt**6*dlog(mu**2/mglu**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/mglu**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*Xb*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (13*mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*Xb*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (15*mglu*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (3*mglu**5*Xb*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (13*mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**3*Xb*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (15*mglu*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**5*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mst1**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mst1**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mst1**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mst1**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**4*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**4*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**6*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**6*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**4*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**4*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**2*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**2*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mst2**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq1**2*mst2**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mst2**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mst2**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**4*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**4*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**6*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**6*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**4*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**4*mt**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**2*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**2*mt**4*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (11*mglu**7*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (39*mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (39*mglu**5*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (39*mglu**5*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (45*mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (45*mglu**3*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (45*mglu**3*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (17*mglu*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (17*mglu*msq1**2*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (17*mglu*msq2**2*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**8*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**8*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (33*mglu**5*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**7*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (33*mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**7*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (33*mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (17*mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (17*mglu**3*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (17*mglu**3*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (23*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (23*mglu*msq1**2*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (23*mglu*msq2**2*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**6*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**6*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (33*mglu**3*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**5*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (33*mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**5*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (33*mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (15*mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu*msq1**2*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (15*mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu*msq2**2*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**3*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu*msq1**2*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**3*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu*msq2**2*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**2*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**2*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mt**10*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mt**10*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**3*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**5*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**5*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (15*mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (15*mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (11*mglu**7*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (39*mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (39*mglu**5*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (39*mglu**5*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (45*mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (45*mglu**3*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (45*mglu**3*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (17*mglu*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (17*mglu*msq1**2*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (17*mglu*msq2**2*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**8*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**8*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (33*mglu**5*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**7*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (33*mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**7*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (33*mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (17*mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (17*mglu**3*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (17*mglu**3*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (23*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (23*mglu*msq1**2*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (23*mglu*msq2**2*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**6*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**6*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (33*mglu**3*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**5*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (33*mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**5*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (33*mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (15*mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu*msq1**2*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (15*mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu*msq2**2*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**3*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mglu*msq1**2*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**3*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mglu*msq2**2*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**2*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**2*mt**8*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mt**10*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mt**10*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**3*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**5*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**5*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (15*mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (15*mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2))/
     -     (2.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*Xt*dlog(mu**2/mglu**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))))

        mssmzetavec(4) = CF*TF*((msq2**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**6*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**4*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu**2*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**6*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**4*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**5*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu**3*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (15*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (15*mglu*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu**5*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**3*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (15*mglu*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**6*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu**4*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**2*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**6*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**4*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**5*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (15*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu**3*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu**5*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**3*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (15*mglu*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**6*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**6*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*mst1**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mst1**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**4*mst1**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mst1**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**4*mt**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**4*mt**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**5*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**5*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**3*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**5*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**3*(mst1**2 - mst2**2)) - 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu**5*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**3*(mst1**2 - mst2**2)) - 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu**4*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) - 
     -    (3*mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**4*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (3*mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**6*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**6*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*mst2**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mst2**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**4*mst2**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mst2**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**4*mt**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**4*mt**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**5*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**5*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**3*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**5*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**3*(mst1**2 - mst2**2)) + 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu**5*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**3*(mst1**2 - mst2**2)) + 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu**4*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     ((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (3*mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**4*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (3*mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) + 
     -    (5*dlog(mu**2/mglu**2)**2)/8. - 
     -    (3*mglu**6*dlog(mu**2/mglu**2)**2)/(4.*(-mglu**2 + msq1**2)**3) + 
     -    (19*mglu**4*msq1**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**3) + 
     -    (19*mglu**2*msq1**4*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (177*mglu**4*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**2) - 
     -    (133*mglu**2*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2) + 
     -    (45*msq1**4*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**6*dlog(mu**2/mglu**2)**2)/(256.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (11*mglu**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)) - 
     -    (195*msq1**2*dlog(mu**2/mglu**2)**2)/(256.*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**4*dlog(mu**2/mglu**2)**2)/(256.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**3) + 
     -    (25*mglu**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2) + 
     -    (35*msq2**2*dlog(mu**2/mglu**2)**2)/(256.*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (3*mglu**6*dlog(mu**2/mglu**2)**2)/(4.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (19*mglu**4*msq2**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**3) + 
     -    (19*mglu**2*msq2**4*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (177*mglu**4*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (25*mglu**2*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**4*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (133*mglu**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (25*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (45*msq2**4*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*msq1**2*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**4*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**6*dlog(mu**2/mglu**2)**2)/(256.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**6*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**6*dlog(mu**2/mglu**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (11*mglu**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)) + 
     -    (35*msq1**2*dlog(mu**2/mglu**2)**2)/(256.*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**6*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (15*msq1**4*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (195*msq2**2*dlog(mu**2/mglu**2)**2)/(256.*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (25*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (15*msq1**4*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**6*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**4*dlog(mu**2/mglu**2)**2)/(256.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (15*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*mst1**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*msq1**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mst1**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mst1**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mst1**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*mst1**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*msq2**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mst1**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mst1**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (mst1**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*mst2**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*msq1**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mst2**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mst2**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mst2**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*mst2**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*msq2**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mst2**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mst2**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (mst2**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mt**2*dlog(mu**2/mglu**2)**2)/(8.*(-mglu**2 + msq1**2)**2) - 
     -    (msq1**2*mt**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (mt**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mt**2*dlog(mu**2/mglu**2)**2)/(8.*(-mglu**2 + msq2**2)**2) - 
     -    (msq2**2*mt**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (mt**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq2**2)) + 
     -    (mglu**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**2*mst1**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**2*mst1**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**10*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**10*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**4*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**4*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mst1**8*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mst1**8*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*mst1**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**2*mst1**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*mst1**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**2*mst1**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mst1**6*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mst1**6*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*mst1**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*mst1**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mst1**4*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mst1**4*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mst1**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mst1**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**6*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq1**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**6*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**4*msq1**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**4*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq1**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**4*msq2**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**4*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq2**2*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq1**2*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq2**2*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**2*mst1**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**2*mst2**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**2*mst2**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**10*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**10*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**4*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**4*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mst2**8*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mst2**8*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*mst2**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**2*mst2**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*mst2**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**2*mst2**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mst2**6*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mst2**6*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*mst2**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*mst2**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mst2**4*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mst2**4*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mst2**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mst2**2*mt**8*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq1**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**4*msq1**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**4*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq1**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**4*msq2**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**4*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq2**2*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq1**2*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq2**2*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu**2*mst2**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq1**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**6*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**4*mt**2*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**4*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**6*dlog(mu**2/mglu**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*Xb*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (19*mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*Xb*dlog(mu**2/mglu**2)**2)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (25*mglu*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (3*mglu**5*Xb*dlog(mu**2/mglu**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (19*mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**3*Xb*dlog(mu**2/mglu**2)**2)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq1**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (25*mglu*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq2**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**5*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mst1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*msq1**2*mst1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mst1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mst1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*mst1**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*mst1**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*msq1**2*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**4*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**4*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**2*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**2*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mst2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq1**2*mst2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mst2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mst2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*mst2**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*mst2**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq1**2*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**4*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**4*mt**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**2*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**2*mt**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**7*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq1**2*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq2**2*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**3*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**3*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu*msq1**2*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu*msq2**2*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**6*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**6*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**3*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**3*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**5*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**5*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (11*mglu**3*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (11*mglu**3*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (13*mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (13*mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**7*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq1**2*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq2**2*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**3*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**3*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu*msq1**2*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu*msq2**2*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**6*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**6*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**3*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**3*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**8*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**5*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**5*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (11*mglu**3*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (11*mglu**3*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (13*mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (13*mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*dlog(mu**2/msq1**2))/24. + 
     -    (5*mglu**2*dlog(mu**2/msq1**2))/(32.*msq1**2) + 
     -    (175*msq1**2*dlog(mu**2/msq1**2))/(256.*mglu**2) - 
     -    (35*msq1**4*dlog(mu**2/msq1**2))/(256.*mglu**4) + 
     -    (9*mglu**6*dlog(mu**2/msq1**2))/(4.*(-mglu**2 + msq1**2)**3) + 
     -    (45*mglu**4*msq1**2*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (37*mglu**2*msq1**4*dlog(mu**2/msq1**2))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (99*msq1**6*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq1**2)**3) + 
     -    (381*mglu**4*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (885*mglu**2*msq1**2*dlog(mu**2/msq1**2))/(256.*(-mglu**2 + msq1**2)**2) + 
     -    (1151*msq1**4*dlog(mu**2/msq1**2))/(256.*(-mglu**2 + msq1**2)**2) - 
     -    (65*msq1**6*dlog(mu**2/msq1**2))/(256.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**8*dlog(mu**2/msq1**2))/(256.*mglu**4*(-mglu**2 + msq1**2)**2) + 
     -    (89*mglu**2*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**4*dlog(mu**2/msq1**2))/(32.*msq1**2*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**2*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)) - 
     -    (35*msq1**4*dlog(mu**2/msq1**2))/(64.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**6*dlog(mu**2/msq1**2))/(32.*mglu**4*(-mglu**2 + msq1**2)) + 
     -    (25*msq2**2*dlog(mu**2/msq1**2))/(256.*mglu**2) + 
     -    (35*msq1**2*msq2**2*dlog(mu**2/msq1**2))/(256.*mglu**4) + 
     -    (5*mglu**4*msq2**2*dlog(mu**2/msq1**2))/(8.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (125*mglu**2*msq2**2*dlog(mu**2/msq1**2))/(256.*(-mglu**2 + msq1**2)**2) - 
     -    (45*msq1**2*msq2**2*dlog(mu**2/msq1**2))/(256.*(-mglu**2 + msq1**2)**2) + 
     -    (35*msq1**4*msq2**2*dlog(mu**2/msq1**2))/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**6*msq2**2*dlog(mu**2/msq1**2))/
     -     (256.*mglu**4*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq2**2*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2))/
     -     (32.*mglu**4*(-mglu**2 + msq1**2)) + 
     -    (25*mglu**4*msq1**2*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (25*msq1**2*msq2**4*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (15*mglu**4*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (15*mglu**2*msq1**2*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (15*msq1**4*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (15*mglu**2*msq2**2*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (35*msq1**2*msq2**2*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (15*msq1**4*msq2**2*dlog(mu**2/msq1**2))/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*msq1**6*msq2**2*dlog(mu**2/msq1**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*msq2**4*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (15*msq1**2*msq2**4*dlog(mu**2/msq1**2))/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (15*mglu**2*msq2**4*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*msq1**4*msq2**4*dlog(mu**2/msq1**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*mglu**2*msq1**4*dlog(mu**2/msq1**2))/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*msq1**6*dlog(mu**2/msq1**2))/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*msq1**4*msq2**2*dlog(mu**2/msq1**2))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*mglu**2*msq2**4*dlog(mu**2/msq1**2))/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*msq1**2*msq2**4*dlog(mu**2/msq1**2))/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**2*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*dlog(mu**2/msq1**2))/(256.*(-mglu**2 + msq2**2)) + 
     -    (55*msq1**4*dlog(mu**2/msq1**2))/(256.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*msq1**2*dlog(mu**2/msq1**2))/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (35*mglu**2*msq1**4*dlog(mu**2/msq1**2))/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**6*dlog(mu**2/msq1**2))/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (35*msq1**8*dlog(mu**2/msq1**2))/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (15*msq1**4*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**6*dlog(mu**2/msq1**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (95*msq2**2*dlog(mu**2/msq1**2))/(256.*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (64.*msq1**2*(-mglu**2 + msq2**2)) - 
     -    (25*msq1**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (35*msq1**4*msq2**2*dlog(mu**2/msq1**2))/
     -     (256.*mglu**4*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/msq1**2))/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (35*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (35*msq1**6*msq2**2*dlog(mu**2/msq1**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**8*msq2**2*dlog(mu**2/msq1**2))/
     -     (256.*mglu**4*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)))

        mssmzetavec(5) = CF*TF*((-5*mglu**4*msq2**2*dlog(mu**2/msq1**2))/
     -     (64.*msq1**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (15*msq1**4*msq2**2*dlog(mu**2/msq1**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**6*msq2**2*dlog(mu**2/msq1**2))/
     -     (32.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (25*msq2**4*dlog(mu**2/msq1**2))/(256.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (35*msq1**2*msq2**4*dlog(mu**2/msq1**2))/
     -     (256.*mglu**4*(-mglu**2 + msq2**2)) + 
     -    (35*mglu**2*msq2**4*dlog(mu**2/msq1**2))/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2))/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (35*msq1**4*msq2**4*dlog(mu**2/msq1**2))/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**6*msq2**4*dlog(mu**2/msq1**2))/
     -     (256.*mglu**4*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**4*dlog(mu**2/msq1**2))/
     -     (32.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*mst1**2*dlog(mu**2/msq1**2))/(8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**2*mst1**2*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**4*mst1**2*dlog(mu**2/msq1**2))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mst1**2*dlog(mu**2/msq1**2))/(8.*(-mglu**2 + msq1**2)**2) - 
     -    (msq1**2*mst1**2*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**4*mst2**2*dlog(mu**2/msq1**2))/(8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**2*mst2**2*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**4*mst2**2*dlog(mu**2/msq1**2))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mst2**2*dlog(mu**2/msq1**2))/(8.*(-mglu**2 + msq1**2)**2) - 
     -    (msq1**2*mst2**2*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**4*mt**2*dlog(mu**2/msq1**2))/(4.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/msq1**2))/(8.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*mt**2*dlog(mu**2/msq1**2))/(8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mt**2*dlog(mu**2/msq1**2))/(4.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mt**2*dlog(mu**2/msq1**2))/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mglu*Xb*dlog(mu**2/msq1**2))/(msq1**2 - msq2**2) + 
     -    (5*msq1**2*Xb*dlog(mu**2/msq1**2))/(8.*mglu*(msq1**2 - msq2**2)) + 
     -    (3*mglu**5*Xb*dlog(mu**2/msq1**2))/
     -     ((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (41*mglu*msq1**4*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (6*mglu**3*Xb*dlog(mu**2/msq1**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (35*mglu*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*msq2**2*Xb*dlog(mu**2/msq1**2))/(8.*mglu*(msq1**2 - msq2**2)) + 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*Xb*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**6*Xb*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mst1**2*Xb*dlog(mu**2/msq1**2))/(8.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*mst1**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*mst1**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mst2**2*Xb*dlog(mu**2/msq1**2))/(8.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*mst2**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*mst2**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mt**2*Xb*dlog(mu**2/msq1**2))/(4.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mt**2*Xb*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu*mt**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu**6*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**4*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**2*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(msq1**2 - msq2**2)) - 
     -    (5*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) + 
     -    (5*mglu**5*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (15*mglu*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu**6*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**4*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**2*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(msq1**2 - msq2**2)) + 
     -    (5*mglu**5*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (15*mglu*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**6*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**4*mst1**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mst1**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**4*mt**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(msq1**2 - msq2**2)) + 
     -    (mglu**5*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu**3*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**5*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)**3*(mst1**2 - mst2**2)) + 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (2.*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**4*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     ((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (3*mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**6*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**4*mst2**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mst2**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**4*mt**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(msq1**2 - msq2**2)) + 
     -    (mglu**5*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu**3*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**5*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)**3*(mst1**2 - mst2**2)) - 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (2.*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**4*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     ((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) - 
     -    (3*mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (5*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/(128.*mglu**2) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**2*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (25*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2) - 
     -    (95*mglu**2*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2) + 
     -    (25*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (25*mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)) - 
     -    (5*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/(128.*mglu**2) - 
     -    (5*mglu**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) - 
     -    (25*mglu**2*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq2**2)) - 
     -    (25*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (25*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**6*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq1**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    dlog(mu**2/msq1**2)**2/32. + 
     -    (85*msq1**2*dlog(mu**2/msq1**2)**2)/(256.*mglu**2) - 
     -    (5*msq1**4*dlog(mu**2/msq1**2)**2)/(128.*mglu**4) + 
     -    (3*mglu**6*dlog(mu**2/msq1**2)**2)/(4.*(-mglu**2 + msq1**2)**3) + 
     -    (25*mglu**4*msq1**2*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (29*mglu**2*msq1**4*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (17*msq1**6*dlog(mu**2/msq1**2)**2)/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (95*mglu**4*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (409*mglu**2*msq1**2*dlog(mu**2/msq1**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2) + 
     -    (7*msq1**4*dlog(mu**2/msq1**2)**2)/(4.*(-mglu**2 + msq1**2)**2) - 
     -    (25*msq1**6*dlog(mu**2/msq1**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**8*dlog(mu**2/msq1**2)**2)/(128.*mglu**4*(-mglu**2 + msq1**2)**2) - 
     -    (25*mglu**2*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**4*dlog(mu**2/msq1**2)**2)/(16.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (5*msq2**2*dlog(mu**2/msq1**2)**2)/(256.*mglu**2) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/(128.*mglu**4) + 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**3) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq1**2)**2)/(256.*(-mglu**2 + msq1**2)**2) - 
     -    (15*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**6*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq2**2*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**2*msq1**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu**4*msq1**2*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**4*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (25*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**6*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**4*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq1**4*dlog(mu**2/msq1**2)**2)/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**6*dlog(mu**2/msq1**2)**2)/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*msq1**4*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**2*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq2**2)) - 
     -    (45*msq1**2*dlog(mu**2/msq1**2)**2)/(256.*(-mglu**2 + msq2**2)) + 
     -    (25*msq1**4*dlog(mu**2/msq1**2)**2)/(128.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/msq1**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**4*dlog(mu**2/msq1**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**6*dlog(mu**2/msq1**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**8*dlog(mu**2/msq1**2)**2)/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*dlog(mu**2/msq1**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**6*dlog(mu**2/msq1**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (25*msq2**2*dlog(mu**2/msq1**2)**2)/(256.*(-mglu**2 + msq2**2)) - 
     -    (75*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (15*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (15*msq1**6*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**8*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*dlog(mu**2/msq1**2)**2)/(256.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**6*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq1**2*mst1**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**4*mst1**2*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**2*mst1**2*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*msq1**2*mst2**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**4*mst2**2*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**2*mst2**2*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*mt**2*dlog(mu**2/msq1**2)**2)/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**2*mt**2*dlog(mu**2/msq1**2)**2)/(16.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*msq1**6*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**4*mst1**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**6*mst1**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**4*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**6*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**6*mt**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**4*mt**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**2*mt**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**6*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**4*mst2**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**6*mst2**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**4*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**6*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**6*mt**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**4*mt**2*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**2*mt**4*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/msq1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*Xb*dlog(mu**2/msq1**2)**2)/(2.*(msq1**2 - msq2**2)) + 
     -    (5*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/(8.*mglu*(msq1**2 - msq2**2)) + 
     -    (3*mglu**5*Xb*dlog(mu**2/msq1**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (17*mglu*msq1**4*Xb*dlog(mu**2/msq1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu**3*Xb*dlog(mu**2/msq1**2)**2)/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*mglu*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq1**4*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**6*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*mglu*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq1**2*mst1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*mst2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mt**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**6*mt**2*Xt*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/msq1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**6*mt**2*Xt*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/msq1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*dlog(mu**2/msq2**2))/24. + 
     -    (25*msq1**2*dlog(mu**2/msq2**2))/(256.*mglu**2) - 
     -    (15*mglu**4*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (15*mglu**2*msq1**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (15*msq1**4*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (15*mglu**2*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq1**2)) - 
     -    (95*msq1**2*dlog(mu**2/msq2**2))/(256.*(-mglu**2 + msq1**2)) - 
     -    (25*msq1**4*dlog(mu**2/msq2**2))/(256.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**2*dlog(mu**2/msq2**2))/(32.*msq2**2) - 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)*msq2**2) + 
     -    (175*msq2**2*dlog(mu**2/msq2**2))/(256.*mglu**2) + 
     -    (35*msq1**2*msq2**2*dlog(mu**2/msq2**2))/(256.*mglu**4) + 
     -    (25*mglu**4*msq2**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (25*msq1**4*msq2**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq1**2)**3) + 
     -    (15*mglu**2*msq2**2*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (35*msq1**2*msq2**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (15*msq1**4*msq2**2*dlog(mu**2/msq2**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq2**2*dlog(mu**2/msq2**2))/(256.*(-mglu**2 + msq1**2)) - 
     -    (25*msq1**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (35*msq1**4*msq2**2*dlog(mu**2/msq2**2))/
     -     (256.*mglu**4*(-mglu**2 + msq1**2)) - 
     -    (35*msq2**4*dlog(mu**2/msq2**2))/(256.*mglu**4) - 
     -    (15*msq2**4*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (15*msq1**2*msq2**4*dlog(mu**2/msq2**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)**2) + 
     -    (55*msq2**4*dlog(mu**2/msq2**2))/(256.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (35*msq1**2*msq2**4*dlog(mu**2/msq2**2))/
     -     (256.*mglu**4*(-mglu**2 + msq1**2)) - 
     -    (15*mglu**2*msq1**4*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (15*msq1**4*msq2**2*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (15*mglu**2*msq2**4*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*msq1**2*msq2**4*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (15*msq2**6*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (9*mglu**6*dlog(mu**2/msq2**2))/(4.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**4*msq1**2*dlog(mu**2/msq2**2))/(8.*(-mglu**2 + msq2**2)**3) + 
     -    (45*mglu**4*msq2**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (37*mglu**2*msq2**4*dlog(mu**2/msq2**2))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (99*msq2**6*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (381*mglu**4*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (125*mglu**2*msq1**2*dlog(mu**2/msq2**2))/(256.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/msq2**2))/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (35*mglu**2*msq1**4*dlog(mu**2/msq2**2))/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (885*mglu**2*msq2**2*dlog(mu**2/msq2**2))/(256.*(-mglu**2 + msq2**2)**2) - 
     -    (45*msq1**2*msq2**2*dlog(mu**2/msq2**2))/(256.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**4*msq2**2*dlog(mu**2/msq2**2))/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (35*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2))/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (1151*msq2**4*dlog(mu**2/msq2**2))/(256.*(-mglu**2 + msq2**2)**2) + 
     -    (35*msq1**2*msq2**4*dlog(mu**2/msq2**2))/
     -     (256.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (35*mglu**2*msq2**4*dlog(mu**2/msq2**2))/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (35*msq1**4*msq2**4*dlog(mu**2/msq2**2))/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (65*msq2**6*dlog(mu**2/msq2**2))/(256.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**6*dlog(mu**2/msq2**2))/
     -     (256.*mglu**4*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**6*dlog(mu**2/msq2**2))/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (35*msq1**2*msq2**6*dlog(mu**2/msq2**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**6*dlog(mu**2/msq2**2))/
     -     (256.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**8*dlog(mu**2/msq2**2))/(256.*mglu**4*(-mglu**2 + msq2**2)**2) - 
     -    (35*msq2**8*dlog(mu**2/msq2**2))/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**8*dlog(mu**2/msq2**2))/
     -     (256.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (89*mglu**2*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)) + 
     -    (15*mglu**2*msq1**4*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**4*dlog(mu**2/msq2**2))/(32.*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**2*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (128.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (15*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (35*msq2**4*dlog(mu**2/msq2**2))/(64.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2))/
     -     (32.*mglu**4*(-mglu**2 + msq2**2)) - 
     -    (15*msq1**4*msq2**4*dlog(mu**2/msq2**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (15*msq2**4*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (15*msq1**2*msq2**4*dlog(mu**2/msq2**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**4*dlog(mu**2/msq2**2))/
     -     (32.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**6*dlog(mu**2/msq2**2))/(32.*mglu**4*(-mglu**2 + msq2**2)) + 
     -    (15*msq1**2*msq2**6*dlog(mu**2/msq2**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**6*dlog(mu**2/msq2**2))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**6*dlog(mu**2/msq2**2))/
     -     (32.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*mst1**2*dlog(mu**2/msq2**2))/(8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**2*mst1**2*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**4*mst1**2*dlog(mu**2/msq2**2))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mst1**2*dlog(mu**2/msq2**2))/(8.*(-mglu**2 + msq2**2)**2) - 
     -    (msq2**2*mst1**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*mst2**2*dlog(mu**2/msq2**2))/(8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**2*mst2**2*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**4*mst2**2*dlog(mu**2/msq2**2))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mst2**2*dlog(mu**2/msq2**2))/(8.*(-mglu**2 + msq2**2)**2) - 
     -    (msq2**2*mst2**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**4*mt**2*dlog(mu**2/msq2**2))/(4.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/msq2**2))/(8.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*mt**2*dlog(mu**2/msq2**2))/(8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mt**2*dlog(mu**2/msq2**2))/(4.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mt**2*dlog(mu**2/msq2**2))/(16.*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*Xb*dlog(mu**2/msq2**2))/(msq1**2 - msq2**2) - 
     -    (5*msq1**2*Xb*dlog(mu**2/msq2**2))/(8.*mglu*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*msq2**2*Xb*dlog(mu**2/msq2**2))/(8.*mglu*(msq1**2 - msq2**2)) + 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*msq2**4*Xb*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (3*mglu**5*Xb*dlog(mu**2/msq2**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (41*mglu*msq2**4*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (6*mglu**3*Xb*dlog(mu**2/msq2**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (15*mglu*msq1**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (35*mglu*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*Xb*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**6*Xb*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mst1**2*Xb*dlog(mu**2/msq2**2))/(8.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**2*mst1**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*mst1**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mst2**2*Xb*dlog(mu**2/msq2**2))/(8.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**2*mst2**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*mst2**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mt**2*Xb*dlog(mu**2/msq2**2))/(4.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mt**2*Xb*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu*mt**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**6*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**4*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)) + 
     -    (5*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) - 
     -    (5*mglu**5*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**3*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (15*mglu*msq1**2*Xb*B0finTMP(mglu**2,0.d0,msq1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**6*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**4*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**4*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq2**2*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)) + 
     -    (5*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) - 
     -    (5*mglu**5*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**3*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**3*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (15*mglu*msq2**2*Xb*B0finTMP(mglu**2,0.d0,msq2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**6*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**4*mst1**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mst1**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*mt**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)) - 
     -    (mglu**5*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu**3*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu*mst1**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**5*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (2.*(-mglu**2 + msq2**2)**3*(mst1**2 - mst2**2)) + 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**4*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (3*mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst1,mu)*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**6*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**4*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**4*mst2**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mst2**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*mt**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mt**2*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)) - 
     -    (mglu**5*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu**3*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu*mst2**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*mt**2*Xb*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**5*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (2.*(-mglu**2 + msq2**2)**3*(mst1**2 - mst2**2)) - 
     -    (mglu**3*mt**2*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**4*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (3*mglu**2*mt**2*Xb*Xt*B0finTMP(mglu**2,mt,mst2,mu)*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) - 
     -    (5*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/(128.*mglu**2) - 
     -    (5*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu**2*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) - 
     -    (15*mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)) - 
     -    (25*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/(128.*mglu**2) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (25*mglu**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) - 
     -    (25*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**2*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (25*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (95*mglu**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (25*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (25*mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu**4*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**2*msq1**4*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu**4*msq1**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**4*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) + 
     -    (5*msq2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) + 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu*msq2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu*msq1**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    dlog(mu**2/msq2**2)**2/32. - 
     -    (5*msq1**2*dlog(mu**2/msq2**2)**2)/(256.*mglu**2) - 
     -    (5*mglu**4*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**4*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (15*mglu**2*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq1**2)) - 
     -    (25*msq1**2*dlog(mu**2/msq2**2)**2)/(256.*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**4*dlog(mu**2/msq2**2)**2)/(256.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (85*msq2**2*dlog(mu**2/msq2**2)**2)/(256.*mglu**2) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/(128.*mglu**4) + 
     -    (5*mglu**4*msq2**2*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (25*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (45*msq2**2*dlog(mu**2/msq2**2)**2)/(256.*(-mglu**2 + msq1**2)) - 
     -    (75*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)) - 
     -    (5*msq2**4*dlog(mu**2/msq2**2)**2)/(128.*mglu**4) - 
     -    (5*msq2**4*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)**2) + 
     -    (25*msq2**4*dlog(mu**2/msq2**2)**2)/(128.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)) - 
     -    (5*mglu**2*msq1**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (15*msq1**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu**6*dlog(mu**2/msq2**2)**2)/(4.*(-mglu**2 + msq2**2)**3) + 
     -    (25*mglu**4*msq2**2*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**3) - 
     -    (29*mglu**2*msq2**4*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (17*msq2**6*dlog(mu**2/msq2**2)**2)/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (95*mglu**4*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq2**2)**2)/(256.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**4*msq1**2*dlog(mu**2/msq2**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq1**4*dlog(mu**2/msq2**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (409*mglu**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (256.*(-mglu**2 + msq2**2)**2) - 
     -    (15*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (128.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (7*msq2**4*dlog(mu**2/msq2**2)**2)/(4.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (25*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (15*msq1**2*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (256.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**4*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**8*dlog(mu**2/msq2**2)**2)/(128.*mglu**4*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**8*dlog(mu**2/msq2**2)**2)/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**8*dlog(mu**2/msq2**2)**2)/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (25*mglu**2*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*dlog(mu**2/msq2**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*dlog(mu**2/msq2**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**4*dlog(mu**2/msq2**2)**2)/(16.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq2**2*mst1**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**4*mst1**2*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**2*mst1**2*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*msq2**2*mst2**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**4*mst2**2*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**2*mst2**2*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*mt**2*dlog(mu**2/msq2**2)**2)/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**2*mt**2*dlog(mu**2/msq2**2)**2)/(16.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**4*mst1**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**6*mst1**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**4*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**6*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**6*mt**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**4*mt**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**2*mt**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**6*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**4*mst2**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**6*mst2**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**4*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**6*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**6*mt**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**4*mt**2*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**2*mt**4*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/msq2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*Xb*dlog(mu**2/msq2**2)**2)/(2.*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/(8.*mglu*(msq1**2 - msq2**2)) + 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*msq2**4*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (3*mglu**5*Xb*dlog(mu**2/msq2**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (17*mglu*msq2**4*Xb*dlog(mu**2/msq2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu**3*Xb*dlog(mu**2/msq2**2)**2)/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq2**4*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**6*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq2**2*mst1**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**2*mst2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mt**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**6*mt**2*Xt*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/msq2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**6*mt**2*Xt*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/msq2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (11*dlog(mu**2/mst1**2))/96. - 
     -    (3*mglu**4*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mglu**2*msq1**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq1**2)) - 
     -    (3*mglu**4*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**2*msq2**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq2**2)) + 
     -    (mst1**2*dlog(mu**2/mst1**2))/(16.*mglu**2) + 
     -    (5*mglu**4*mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (5*msq1**4*mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq1**2)**3) + 
     -    (3*mglu**2*mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (7*msq1**2*mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq1**2)) - 
     -    (msq1**2*mst1**2*dlog(mu**2/mst1**2))/(32.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**4*mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (5*msq2**4*mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (3*mglu**2*mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (7*msq2**2*mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (mst1**2*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*mst1**2*dlog(mu**2/mst1**2))/(32.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (3*mglu**2*mt**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (3*msq1**2*mt**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (mt**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq1**2)) - 
     -    (3*mglu**2*mt**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (3*msq2**2*mt**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (mt**2*dlog(mu**2/mst1**2))/(64.*(-mglu**2 + msq2**2)) + 
     -    (7*mglu**8*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**8*msq1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**8*msq2**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**6*mst1**2*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*msq1**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**8*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**6*msq1**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**4*mst1**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*msq2**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**8*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**6*msq2**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**4*mst1**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*mst1**4*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**6*mst1**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*msq1**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**4*mst1**4*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**6*mst1**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*msq2**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**4*mst1**4*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*msq1**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq1**4*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*msq2**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq2**4*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mst1**8*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**8*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq1**2*mst1**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**8*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq2**2*mst1**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**10*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**10*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**6*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**8*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**6*msq1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**8*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**6*msq2**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu**6*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**4*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**4*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu**6*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**4*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**4*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (15*mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**4*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**2*msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**4*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**4*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (9*mglu**2*msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**4*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq1**2*mst1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq2**2*mst1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**8*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**8*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**6*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**6*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (19*mglu**4*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*mglu**2*msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq1**4*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (19*mglu**4*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*mglu**2*msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq2**4*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (13*mst1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*msq1**2*mst1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*msq2**2*mst1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mst1**6*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mst1**6*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**2*mt**6*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**2*msq1**2*mt**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**2*msq2**2*mt**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**2*mst1**2*mt**6*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**2*mst1**2*mt**6*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (19*mst1**4*mt**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (19*mst1**4*mt**6*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mt**8*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**2*mt**8*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*msq1**2*mt**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**2*mt**8*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*msq2**2*mt**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (27*mst1**2*mt**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (27*mst1**2*mt**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mt**10*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mt**10*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**6*msq1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**6*msq2**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*msq1**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**4*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*msq2**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**4*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**4*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**4*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*dlog(mu**2/mst1**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*msq1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**6*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*msq2**2*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**4*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**4*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (8.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*msq1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*msq2**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mst1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mst1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**6*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**6*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mt**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mt**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq1**4*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**6*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*msq1**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq1**4*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*msq1**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**4*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*msq1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mst1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*msq1**2*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**2*mt**6*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mt**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq2**4*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**6*mst1**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*msq2**2*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq2**4*mst1**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*msq2**2*mst1**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**2*msq2**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**6*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**4*mst1**2*mt**2*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**6*mt**2*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu**2*msq2**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq2**4*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mst1**4*mt**4*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*msq2**2*mt**6*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**2*mt**6*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mt**8*dlog(mu**2/mst1**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)))

        mssmzetavec(6) = CF*TF*(-(mglu*msq1**2*mst1**2*Xb*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mst1**2*Xb*dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu**3*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (3*mglu*msq1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)) + 
     -    (3*mglu**3*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (3*mglu*msq2**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) - 
     -    (7*mglu**7*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (27*mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (27*mglu**5*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (27*mglu**5*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (33*mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (33*mglu**3*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (15*mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (33*mglu**3*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (13*mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*mglu*msq1**2*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*mglu*msq2**2*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**8*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**8*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (21*mglu**5*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**7*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**7*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (13*mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (13*mglu**3*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (13*mglu**3*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (19*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (19*mglu*msq1**2*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (19*mglu*msq2**2*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**6*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**6*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*mglu**3*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (21*mglu**5*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (21*mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (21*mglu**5*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (21*mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (19*mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq1**2*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (19*mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq2**2*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (9*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*mglu**3*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu*msq1**2*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (21*mglu**3*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu*msq2**2*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu*mst1**2*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu*mst1**2*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu*mt**10*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu*mt**10*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**3*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**5*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**3*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu*msq1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**5*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**3*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu*msq2**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**4*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu*msq1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq2**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**4*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu*msq2**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mt**8*Xt*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2) - 
     -    (mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2) - 
     -    (mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) - 
     -    (mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq1**2)) - 
     -    (mglu**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) - 
     -    (mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/(32.*(-mglu**2 + msq2**2)) + 
     -    (mglu**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**2*mst1**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**2*mst1**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**10*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**10*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**6*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**4*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**4*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*msq1**2*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*msq2**2*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq1**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**4*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq2**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**4*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq1**2*mst1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mst1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**7*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq1**2*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq2**2*mst1**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     ((mst1**2 - mst2**2)*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq1**2*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq2**2*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**6*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**6*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq1**2*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq2**2*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**3*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu**3*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*
     -       dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*
     -       dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst1**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**4*mst1**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*msq1**2*mst1**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*mst1**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mst1**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mst1**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*msq1**6*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**4*mst1**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**6*mst1**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**6*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**6*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mst1**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*mst1**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mt**2*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*msq1**6*mt**2*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**4*mt**4*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*mst1**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*msq2**2*mst1**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*mst1**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mst1**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mst1**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*msq2**6*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**4*mst1**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**6*mst1**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**6*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**6*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mst1**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*mst1**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq2**2*mt**2*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*msq2**6*mt**2*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**4*mt**4*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst1**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    dlog(mu**2/mst1**2)**2/32. - 
     -    (mglu**4*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*msq1**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*msq2**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*mst1**2*dlog(mu**2/mst1**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*mst1**2*dlog(mu**2/mst1**2)**2)/(32.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**2*mst1**2*dlog(mu**2/mst1**2)**2)/(16.*(-mglu**2 + msq1**2)**2) - 
     -    (mst1**2*dlog(mu**2/mst1**2)**2)/(32.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*mst1**2*dlog(mu**2/mst1**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*mst1**2*dlog(mu**2/mst1**2)**2)/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**2*mst1**2*dlog(mu**2/mst1**2)**2)/(16.*(-mglu**2 + msq2**2)**2) - 
     -    (mst1**2*dlog(mu**2/mst1**2)**2)/(32.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*mt**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mt**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (mt**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq1**2)) - 
     -    (mglu**2*mt**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mt**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (mt**2*dlog(mu**2/mst1**2)**2)/(64.*(-mglu**2 + msq2**2)) + 
     -    (mglu**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*msq1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**8*msq2**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**2*mst1**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**2*mst1**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**10*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**10*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**4*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**4*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mst1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*msq1**2*mst1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*msq2**2*mst1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mst1**8*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mst1**8*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mst1**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq1**2*mst1**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq2**2*mst1**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**4*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**4*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mt**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mt**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mst1**2*mt**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mst1**2*mt**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*msq1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*msq2**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq2**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**2*msq1**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**2*msq2**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**4*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mglu**4*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mst1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mst1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mst1**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (9*mst1**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mst1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mst1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**6*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**2*msq1**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*msq1**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**4*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mst1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mst1**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mst1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**4*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**6*mst1**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu**2*msq2**2*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**4*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*msq2**2*mst1**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**8*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq2**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**4*mst1**2*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mst1**6*mt**2*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (9*mst1**4*mt**4*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mst1**2*mt**6*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mst1**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mst1**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst1**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mst1**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst1**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*mst1**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq2**2*mst1**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**4*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**4*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**4*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**4*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**6*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**6*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**2*mt**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**2*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Xb*dlog(mu**2/mst1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*msq1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*msq2**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**7*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**7*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**5*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (7*mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq1**2*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq2**2*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**8*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**5*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (11*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu*msq1**2*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (11*mglu*msq2**2*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**6*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**6*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**5*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**5*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq1**2*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (7*mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq2**2*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**2*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**2*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (7*mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**4*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**4*mst1**2*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**4*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**6*mt**2*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**2*mt**2*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**4*mt**2*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mst1**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (11*dlog(mu**2/mst2**2))/96. - 
     -    (3*mglu**4*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mglu**2*msq1**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq1**2)) - 
     -    (3*mglu**4*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**2*msq2**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq2**2)) + 
     -    (mst2**2*dlog(mu**2/mst2**2))/(16.*mglu**2) + 
     -    (5*mglu**4*mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (5*msq1**4*mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq1**2)**3) + 
     -    (3*mglu**2*mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (7*msq1**2*mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq1**2)) - 
     -    (msq1**2*mst2**2*dlog(mu**2/mst2**2))/(32.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**4*mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (5*msq2**4*mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (3*mglu**2*mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (7*msq2**2*mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (mst2**2*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*mst2**2*dlog(mu**2/mst2**2))/(32.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (3*mglu**2*mt**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (3*msq1**2*mt**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (mt**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq1**2)) - 
     -    (3*mglu**2*mt**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (3*msq2**2*mt**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (mt**2*dlog(mu**2/mst2**2))/(64.*(-mglu**2 + msq2**2)) + 
     -    (7*mglu**8*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**8*msq1**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**8*msq2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**6*mst2**2*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*msq1**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**8*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**6*msq1**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**4*mst2**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*msq2**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**8*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**6*msq2**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**4*mst2**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*mst2**4*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**6*mst2**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*msq1**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**4*mst2**4*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**6*mst2**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*msq2**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**4*mst2**4*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*msq1**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq1**4*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*msq2**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq2**4*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mst2**8*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**8*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq1**2*mst2**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**8*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq2**2*mst2**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**10*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**10*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**6*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**8*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**6*msq1**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**8*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**6*msq2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2))

        mssmzetavec(7) = CF*TF*(-(mglu**4*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**6*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**4*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**4*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu**6*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**4*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**4*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**4*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**2*msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**4*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**4*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**2*msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**4*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq1**2*mst2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq2**2*mst2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**8*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**8*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**6*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**6*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (9*mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (19*mglu**4*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*mglu**2*msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq1**4*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (19*mglu**4*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*mglu**2*msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq2**4*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (13*mst2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*msq1**2*mst2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*msq2**2*mst2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mst2**6*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mst2**6*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**2*mt**6*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**2*msq1**2*mt**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**2*msq2**2*mt**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**2*mst2**2*mt**6*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**2*mst2**2*mt**6*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (19*mst2**4*mt**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (19*mst2**4*mt**6*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mt**8*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**2*mt**8*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*msq1**2*mt**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**2*mt**8*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*msq2**2*mt**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (27*mst2**2*mt**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (27*mst2**2*mt**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mt**10*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mt**10*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*msq1**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**4*msq1**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**6*msq2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**4*msq2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*msq1**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**4*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*msq2**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**4*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**4*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**4*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*dlog(mu**2/mst2**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*msq1**2*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**6*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*msq2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**4*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**4*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (8.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*msq1**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*msq2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mst2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mst2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**6*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**6*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mt**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mt**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq1**4*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**6*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*msq1**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq1**4*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*msq1**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq1**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**6*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**4*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*msq1**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq1**4*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mst2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*msq1**2*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**6*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mt**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq2**4*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**6*mst2**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*msq2**2*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq2**4*mst2**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*msq2**2*mst2**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**2*msq2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**4*mst2**2*mt**2*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**6*mt**2*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu**2*msq2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mst2**4*mt**4*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*msq2**2*mt**6*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**6*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mt**8*dlog(mu**2/mst2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mst2**2*Xb*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mst2**2*Xb*dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (3*mglu**3*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (3*mglu*msq1**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)) - 
     -    (3*mglu**3*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (3*mglu*msq2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) + 
     -    (7*mglu**7*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (27*mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (27*mglu**5*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (27*mglu**5*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (33*mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (33*mglu**3*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (15*mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (33*mglu**3*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (13*mglu*msq1**2*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (13*mglu*msq2**2*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**8*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**8*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*mglu**5*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**7*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (21*mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**7*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (21*mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (13*mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*mglu**3*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (13*mglu**3*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (19*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (19*mglu*msq1**2*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (19*mglu*msq2**2*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**6*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**6*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (21*mglu**3*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*mglu**5*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*mglu**5*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (21*mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (19*mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq1**2*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (19*mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq2**2*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (9*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (21*mglu**3*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu*msq1**2*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (21*mglu**3*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu*msq2**2*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu*mst2**2*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu*mst2**2*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu*mt**10*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu*mt**10*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**3*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**5*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**3*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu*msq1**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**5*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**3*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu*msq2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq1**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**4*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu*msq1**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**4*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu*msq2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mt**8*Xt*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2) - 
     -    (mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2) - 
     -    (mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) - 
     -    (mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq1**2)) - 
     -    (mglu**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) - 
     -    (mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/(32.*(-mglu**2 + msq2**2)) + 
     -    (mglu**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**2*mst2**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**2*mst2**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**10*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**10*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**6*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**4*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**4*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*msq1**2*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*msq2**2*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**6*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**6*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq1**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**4*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq2**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**4*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq1**2*mst2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mst2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**7*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq1**2*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq2**2*mst2**6*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     ((mst1**2 - mst2**2)*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq1**2*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq2**2*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**6*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**6*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq1**2*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq2**2*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**3*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**3*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*
     -       dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*
     -       dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mst2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**4*mst2**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*msq1**2*mst2**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*mst2**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mst2**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mst2**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*msq1**6*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**4*mst2**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**6*mst2**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**6*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**6*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mst2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*mst2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*mt**2*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*msq1**6*mt**2*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**4*mt**4*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*mst2**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*msq2**2*mst2**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*mst2**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mst2**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mst2**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*msq2**6*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**4*mst2**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**6*mst2**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**6*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**6*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (8.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mst2**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*mst2**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*mt**2*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*msq2**6*mt**2*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**4*mt**4*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mst2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    dlog(mu**2/mst2**2)**2/32. - 
     -    (mglu**4*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*msq1**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*msq2**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*mst2**2*dlog(mu**2/mst2**2)**2)/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*mst2**2*dlog(mu**2/mst2**2)**2)/(32.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**2*mst2**2*dlog(mu**2/mst2**2)**2)/(16.*(-mglu**2 + msq1**2)**2) - 
     -    (mst2**2*dlog(mu**2/mst2**2)**2)/(32.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*mst2**2*dlog(mu**2/mst2**2)**2)/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*mst2**2*dlog(mu**2/mst2**2)**2)/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**2*mst2**2*dlog(mu**2/mst2**2)**2)/(16.*(-mglu**2 + msq2**2)**2) - 
     -    (mst2**2*dlog(mu**2/mst2**2)**2)/(32.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*mt**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**2*mt**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (mt**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq1**2)) - 
     -    (mglu**2*mt**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**2*mt**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (mt**2*dlog(mu**2/mst2**2)**2)/(64.*(-mglu**2 + msq2**2)) + 
     -    (mglu**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*msq1**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**8*msq2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**2*mst2**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**2*mst2**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**10*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**10*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**8*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**4*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**4*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mst2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*msq1**2*mst2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*msq2**2*mst2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mst2**8*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mst2**8*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mst2**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq1**2*mst2**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq2**2*mst2**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**4*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**4*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mt**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mt**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mst2**2*mt**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mst2**2*mt**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**6*msq1**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq1**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**6*msq2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**2*msq1**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**2*msq2**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq1**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**4*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mglu**4*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mst2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mst2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mst2**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (9*mst2**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mst2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mst2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**6*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**2*msq1**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*msq1**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq1**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**4*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mst2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mst2**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mst2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**4*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**6*mst2**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu**2*msq2**2*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**4*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*msq2**2*mst2**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**8*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**4*mst2**2*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mst2**6*mt**2*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (9*mst2**4*mt**4*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mst2**2*mt**6*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mst2**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mst2**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mst2**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mst2**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mst2**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*mst2**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq2**2*mst2**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**4*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**4*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**4*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**4*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**6*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**6*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**2*mt**2*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xb*dlog(mu**2/mst2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*msq1**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*msq2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)))

        mssmzetavec(8) = CF*TF*(-(mglu*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**7*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*msq1**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*msq2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**7*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**5*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (7*mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq1**2*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq2**2*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**8*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**5*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**7*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (11*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu*msq1**2*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (11*mglu*msq2**2*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**6*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**6*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**5*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**5*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq1**2*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (7*mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq2**2*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**2*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**2*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*msq1**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq1**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*msq2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (7*mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**4*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**4*mst2**2*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**4*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**6*mt**2*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*mt**2*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mst2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    dlog(mu**2/mt**2)/12. - (mt**2*dlog(mu**2/mt**2))/(8.*mglu**2) - 
     -    (5*mglu**4*mt**2*dlog(mu**2/mt**2))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (5*msq1**4*mt**2*dlog(mu**2/mt**2))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (3*mglu**2*mt**2*dlog(mu**2/mt**2))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (17*msq1**2*mt**2*dlog(mu**2/mt**2))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mt**2*dlog(mu**2/mt**2))/(32.*(-mglu**2 + msq1**2)) + 
     -    (msq1**2*mt**2*dlog(mu**2/mt**2))/(16.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (5*mglu**4*mt**2*dlog(mu**2/mt**2))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (5*msq2**4*mt**2*dlog(mu**2/mt**2))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (3*mglu**2*mt**2*dlog(mu**2/mt**2))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (17*msq2**2*mt**2*dlog(mu**2/mt**2))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (3*mt**2*dlog(mu**2/mt**2))/(32.*(-mglu**2 + msq2**2)) + 
     -    (msq2**2*mt**2*dlog(mu**2/mt**2))/(16.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (msq1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**2*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**2*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**2*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**2*dlog(mu**2/mt**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**4*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**4*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mt**4*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**4*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mt**4*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mt**4*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mt**2))/
     -     (8.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2))/
     -     (16.*mglu**2*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**2*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**2*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**2*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*dlog(mu**2/mt**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**4*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**4*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mt**4*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mt**4*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mt**4*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mt**4*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mt**2))/
     -     (8.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mt**2))/
     -     (16.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2))/
     -     (16.*mglu**2*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/mt**2))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/mt**2))/
     -     ((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*mt**2*Xb*dlog(mu**2/mt**2))/
     -     ((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mt**2*Xb*dlog(mu**2/mt**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/mt**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**2*mt**2*Xb*dlog(mu**2/mt**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mt**2*Xb*dlog(mu**2/mt**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mst1**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*Xt*dlog(mu**2/mt**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**6*Xt*dlog(mu**2/mt**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xt*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*Xt*dlog(mu**2/mt**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst2**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mt**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*Xt*dlog(mu**2/mt**2))/
     -     (2.*mglu*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**6*Xt*dlog(mu**2/mt**2))/
     -     (4.*mglu*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xt*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*Xt*dlog(mu**2/mt**2))/
     -     (4.*mglu*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2) - 
     -    (msq1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/(16.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2) - 
     -    (msq2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (3*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/(16.*(-mglu**2 + msq2**2)) + 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mglu**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**4*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**4*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq1**2*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq2**2*mst1**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (5*mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq1**2*mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*msq2**2*mst1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mglu**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**4*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**4*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq1**2*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq2**2*mst2**6*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**8*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (5*mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq1**2*mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*msq2**2*mst2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**4*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**8*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**2*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*mt**2*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**4*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**6*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq1**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**2*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     ((mst1**2 - mst2**2)*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*msq1**2*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*msq2**2*mst1**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**6*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**6*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mst1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**4*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     ((mst1**2 - mst2**2)*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*msq1**2*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*msq2**2*mst2**4*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**6*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**6*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mst2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**4*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**2*mt**8*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**2*mt**4*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mt**6*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*Xb*Xt*dlog(mu**2/mglu**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2) - 
     -    (3*msq1**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*mglu*(msq1**2 - msq2**2)) - 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*mt**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu*mt**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**4*mt**4*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**4*mt**4*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/msq1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2) - 
     -    (3*msq2**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*mglu*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**2*mt**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu*mt**2*Xb*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq2**4*mt**4*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**4*mt**4*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/msq2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**4*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (5*mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**2*mst1**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**2*mst1**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**8*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**8*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*mst1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**2*mst1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**6*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**6*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*mst1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq1**2*mst1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**2*mst1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq2**2*mst1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*msq1**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*msq2**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*mt**2*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**4*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**2*mt**6*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**2*mt**2*Xb*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**2*mt**2*Xb*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xb*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xb*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Xb*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xb*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     ((mst1**2 - mst2**2)*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**5*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq1**2*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq2**2*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**6*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**6*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     ((mst1**2 - mst2**2)*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**4*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**4*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (7*mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**4*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**4*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**4*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mst1**2)*dlog(mu**2/mt**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq1**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**6*msq2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**4*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**4*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**4*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (5*mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**2*mst2**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**2*mst2**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**8*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**8*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**6*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*mst2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**2*mst2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**6*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**6*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq1**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*msq2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*mst2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq1**2*mst2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**2*mst2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq2**2*mst2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**10*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*msq1**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*msq2**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))))

        mssmzetavec(9) = CF*TF*(-(msq1**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*mt**2*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**4*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**6*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**2*mt**2*Xb*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**2*mt**2*Xb*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xb*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xb*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xb*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Xb*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**5*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*msq1**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*msq2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     ((mst1**2 - mst2**2)*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**5*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq1**2*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq2**2*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**6*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**6*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**5*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     ((mst1**2 - mst2**2)*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**4*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**4*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (7*mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**4*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**4*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**4*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mst2**2)*dlog(mu**2/mt**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    dlog(mu**2/mt**2)**2/8. - 
     -    (mglu**4*mt**2*dlog(mu**2/mt**2)**2)/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**4*mt**2*dlog(mu**2/mt**2)**2)/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*mt**2*dlog(mu**2/mt**2)**2)/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**2*mt**2*dlog(mu**2/mt**2)**2)/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mt**2*dlog(mu**2/mt**2)**2)/(32.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*mt**2*dlog(mu**2/mt**2)**2)/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**4*mt**2*dlog(mu**2/mt**2)**2)/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*mt**2*dlog(mu**2/mt**2)**2)/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**2*mt**2*dlog(mu**2/mt**2)**2)/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (3*mt**2*dlog(mu**2/mt**2)**2)/(32.*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**4*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**4*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq1**2*mst1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*msq2**2*mst1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**6*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**6*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**4*mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**4*mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mt**8*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mt**8*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**2*mt**8*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**2*mt**8*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mt**10*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mt**10*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*msq2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*msq2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**4*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**4*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq1**2*mst2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*msq2**2*mst2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**6*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**6*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**4*mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**4*mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mt**8*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mt**8*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**2*mt**8*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**2*mt**8*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mt**10*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mt**10*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq1**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*msq2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*msq2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**2*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**4*mt**2*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*mt**2*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*dlog(mu**2/mt**2)**2)/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**4*mt**4*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**6*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**8*dlog(mu**2/mt**2)**2)/
     -     (64.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mst1**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mst1**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mt**4*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*mt**4*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq1**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*msq2**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mst2**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mst2**2*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*mt**4*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*mt**4*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xb*dlog(mu**2/mt**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*mst1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*msq1**2*mst1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mst1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*msq2**2*mst1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**4*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**4*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**2*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**2*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mt**10*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst1**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst1**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mst1**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (5*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*mst2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*msq1**2*mst2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mst2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*msq2**2*mst2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**4*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**4*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq1**2*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*msq2**2*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**2*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**2*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mt**10*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu**3*msq1**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst2**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst2**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mst2**2*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu*msq1**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (5*mglu*msq2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**4*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**6*Xt*dlog(mu**2/mt**2)**2)/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**8*Xt*dlog(mu**2/mt**2)**2)/
     -     (16.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mt**6*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mt**6*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**2*mt**4*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mt**6*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**6*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mt**6*Xb*Xt*dlog(mu**2/mt**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*TfinZTMP(msq1,mglu,mu))/(16.*mglu**2) + 
     -    (5*msq1**2*TfinZTMP(msq1,mglu,mu))/(128.*mglu**4) - 
     -    (5*mglu**2*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**2*TfinZTMP(msq1,mglu,mu))/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**4*TfinZTMP(msq1,mglu,mu))/(64.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**6*TfinZTMP(msq1,mglu,mu))/(128.*mglu**4*(-mglu**2 + msq1**2)**2) - 
     -    (5*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**2*TfinZTMP(msq1,mglu,mu))/(16.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (5*msq2**2*TfinZTMP(msq1,mglu,mu))/(128.*mglu**4) - 
     -    (5*msq2**2*TfinZTMP(msq1,mglu,mu))/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**4*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq2**2*TfinZTMP(msq1,mglu,mu))/(64.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**2*msq1**2*TfinZTMP(msq1,mglu,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**2*msq2**2*TfinZTMP(msq1,mglu,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq1,mglu,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (5*msq2**4*TfinZTMP(msq1,mglu,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**2*TfinZTMP(msq1,mglu,mu))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*TfinZTMP(msq1,mglu,mu))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**2*TfinZTMP(msq1,mglu,mu))/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (32.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**4*TfinZTMP(msq1,mglu,mu))/(32.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**4*TfinZTMP(msq1,mglu,mu))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*TfinZTMP(msq1,mglu,mu))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq2**2)) - 
     -    (25*msq1**2*TfinZTMP(msq1,mglu,mu))/(128.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**2*TfinZTMP(msq1,mglu,mu))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**6*TfinZTMP(msq1,mglu,mu))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*TfinZTMP(msq1,mglu,mu))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*TfinZTMP(msq1,mglu,mu))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (35*msq2**2*TfinZTMP(msq1,mglu,mu))/(128.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (128.*mglu**4*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**6*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*TfinZTMP(msq1,mglu,mu))/(128.*mglu**4*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*TfinZTMP(msq1,mglu,mu))/
     -     (128.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**4*msq2**4*TfinZTMP(msq1,mglu,mu))/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*TfinZTMP(msq1,mglu,mu))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq1**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu*msq2**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*mglu*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*mglu*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*TfinZTMP(msq2,mglu,mu))/(16.*mglu**2) - 
     -    (5*msq1**2*TfinZTMP(msq2,mglu,mu))/(128.*mglu**4) - 
     -    (5*mglu**2*msq1**2*TfinZTMP(msq2,mglu,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (5*msq1**4*TfinZTMP(msq2,mglu,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (5*mglu**2*TfinZTMP(msq2,mglu,mu))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**2*TfinZTMP(msq2,mglu,mu))/(16.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**4*TfinZTMP(msq2,mglu,mu))/(32.*mglu**2*(-mglu**2 + msq1**2)**2) + 
     -    (5*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq1**2)) + 
     -    (35*msq1**2*TfinZTMP(msq2,mglu,mu))/(128.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (5*msq1**4*TfinZTMP(msq2,mglu,mu))/(128.*mglu**4*(-mglu**2 + msq1**2)) + 
     -    (5*msq2**2*TfinZTMP(msq2,mglu,mu))/(128.*mglu**4) + 
     -    (5*mglu**2*msq2**2*TfinZTMP(msq2,mglu,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,mglu,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (5*msq2**2*TfinZTMP(msq2,mglu,mu))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,mglu,mu))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (25*msq2**2*TfinZTMP(msq2,mglu,mu))/(128.*mglu**2*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,mglu,mu))/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)) - 
     -    (5*mglu**2*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*TfinZTMP(msq2,mglu,mu))/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq1**2*TfinZTMP(msq2,mglu,mu))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**4*TfinZTMP(msq2,mglu,mu))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**2*TfinZTMP(msq2,mglu,mu))/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq2**2*TfinZTMP(msq2,mglu,mu))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,mglu,mu))/
     -     (128.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**4*TfinZTMP(msq2,mglu,mu))/(64.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**4*TfinZTMP(msq2,mglu,mu))/
     -     (128.*mglu**4*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**2*msq2**4*TfinZTMP(msq2,mglu,mu))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*msq2**4*TfinZTMP(msq2,mglu,mu))/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**6*TfinZTMP(msq2,mglu,mu))/(128.*mglu**4*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**6*TfinZTMP(msq2,mglu,mu))/
     -     (128.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**6*TfinZTMP(msq2,mglu,mu))/
     -     (128.*mglu**4*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*TfinZTMP(msq2,mglu,mu))/(64.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*TfinZTMP(msq2,mglu,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*TfinZTMP(msq2,mglu,mu))/
     -     (64.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*TfinZTMP(msq2,mglu,mu))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*TfinZTMP(msq2,mglu,mu))/
     -     (64.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**2*TfinZTMP(msq2,mglu,mu))/(16.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,mglu,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**4*msq2**2*TfinZTMP(msq2,mglu,mu))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,mglu,mu))/
     -     (16.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq1**2*msq2**4*TfinZTMP(msq2,mglu,mu))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*msq2**4*TfinZTMP(msq2,mglu,mu))/
     -     (32.*mglu**2*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq1**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*msq1**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq2**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*msq2**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*msq1**2*msq2**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**4*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*mglu*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**2*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (5*msq1**4*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**2*TfinZTMP(msq2,msq1,mu))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (15*msq1**2*TfinZTMP(msq2,msq1,mu))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**2*msq2**2*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (5*msq2**2*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**2*msq1**2*TfinZTMP(msq2,msq1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu**2*msq2**2*TfinZTMP(msq2,msq1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,msq1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*msq2**4*TfinZTMP(msq2,msq1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu**2*msq1**2*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**2*msq2**2*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (5*msq2**4*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**2*TfinZTMP(msq2,msq1,mu))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*TfinZTMP(msq2,msq1,mu))/(16.*(-mglu**2 + msq2**2)**2) - 
     -    (15*msq2**2*TfinZTMP(msq2,msq1,mu))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*msq1**2*TfinZTMP(msq2,msq1,mu))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq1**4*TfinZTMP(msq2,msq1,mu))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**2*msq2**2*TfinZTMP(msq2,msq1,mu))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq1**2*msq2**2*TfinZTMP(msq2,msq1,mu))/
     -     (32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu*msq1**2*Xb*TfinZTMP(msq2,msq1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq2**2*Xb*TfinZTMP(msq2,msq1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**2*Xb*TfinZTMP(msq2,msq1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*msq2**2*Xb*TfinZTMP(msq2,msq1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*msq1**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*TfinTMP(mglu,mt,mst1,mu))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (3*msq1**2*TfinTMP(mglu,mt,mst1,mu))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*msq2**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*TfinTMP(mglu,mt,mst1,mu))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (3*msq2**2*TfinTMP(mglu,mt,mst1,mu))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (mst1**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (mst1**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mt**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mt**2*TfinTMP(mglu,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**2*mst1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq1**2*mst1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**4*mst1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (msq2**2*mst1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mst1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**4*mst1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq1**2*mst1**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*msq2**2*mst1**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mst1**6*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**4*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mst1**2*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mst1**2*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mst1**2*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**4*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mst1**4*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**6*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq1**2*mt**6*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (msq2**2*mt**6*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**2*mt**6*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mst1**2*mt**6*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**8*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mt**8*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq1**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*msq2**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**4*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mst1**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mst1**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mst1**6*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*msq2**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**4*mt**2*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq1**2*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*msq2**2*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**2*mt**4*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mt**6*TfinTMP(mglu,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq2**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mst1**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mst1**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mt**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mt**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*msq1**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*msq2**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mst1**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mst1**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mst1**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mt**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq1**2*mt**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq2**2*mt**2*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**4*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**4*Xb*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)**3*(mst1**2 - mst2**2)) - 
     -    (3*mglu*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*msq2**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq2**2)**3*(mst1**2 - mst2**2)) - 
     -    (3*mglu*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu**3*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq1**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*msq2**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (3*mglu*mst1**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq1**2*mst1**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu**3*mst1**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu*msq2**2*mst1**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**4*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mst1**4*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**6*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**6*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq1**2*mt**6*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu**3*mt**6*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*msq2**2*mt**6*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**6*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (mglu*mst1**2*mt**6*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**8*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) + 
     -    (mglu*mt**8*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -          2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))**2) - 
     -    (3*mglu**3*msq1**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu**3*msq2**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu**3*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq1**2*mst1**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**3*mst1**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mglu*msq2**2*mst1**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mst1**2*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**4*mt**2*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu*msq1**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**3*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (5*mglu*msq2**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mglu*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**2*mt**4*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mt**6*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (msq1**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) - 
     -    (mglu**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (msq2**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu**4*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**4*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*msq2**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mst1**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**4*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mt**4*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**4*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mt**4*Xb*Xt*TfinTMP(mglu,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst1**4 - mt**4 + 
     -         2*(mglu**2*mst1**2 + mglu**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**4*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*TfinTMP(mglu,mt,mst2,mu))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (3*msq1**2*TfinTMP(mglu,mt,mst2,mu))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*msq2**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**4*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*TfinTMP(mglu,mt,mst2,mu))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (3*msq2**2*TfinTMP(mglu,mt,mst2,mu))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (mst2**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (mst2**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mt**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mt**2*TfinTMP(mglu,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq1**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**4*msq2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**2*mst2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq1**2*mst2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**4*mst2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (msq2**2*mst2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mst2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**4*mst2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq1**2*mst2**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*msq2**2*mst2**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mst2**6*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**4*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mst2**2*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mst2**2*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mst2**2*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**4*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mst2**4*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**6*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq1**2*mt**6*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (msq2**2*mt**6*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**2*mt**6*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mst2**2*mt**6*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**8*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mt**8*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq1**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq1**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**4*msq2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq2**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**2*msq2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mst2**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mst2**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mst2**6*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq1**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*msq2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**4*mt**2*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq1**2*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*msq2**2*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**2*mt**4*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**6*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mt**6*TfinTMP(mglu,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq2**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mst2**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mst2**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mt**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mt**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*msq1**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*msq2**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mst2**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mst2**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mst2**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mt**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq2**2*mt**2*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**4*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**4*Xb*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq1**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)**3*(mst1**2 - mst2**2)) + 
     -    (3*mglu*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*msq2**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq2**2)**3*(mst1**2 - mst2**2)) + 
     -    (3*mglu*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu**3*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq1**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*msq2**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (3*mglu*mst2**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq1**2*mst2**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu**3*mst2**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu*msq2**2*mst2**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**4*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mst2**4*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**6*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**6*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq1**2*mt**6*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu**3*mt**6*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*msq2**2*mt**6*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**6*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (mglu*mst2**2*mt**6*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**8*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) - 
     -    (mglu*mt**8*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -          2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))**2) + 
     -    (3*mglu**3*msq1**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu**3*msq2**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu**3*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq1**2*mst2**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**3*mst2**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mglu*msq2**2*mst2**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mst2**2*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**4*mt**2*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu*msq1**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**3*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (5*mglu*msq2**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mglu*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**2*mt**4*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mt**6*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) - 
     -    (msq1**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (msq2**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu**4*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**4*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mst2**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**2*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**4*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mt**4*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**4*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mt**4*Xb*Xt*TfinTMP(mglu,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(mst1**2 - mst2**2)*
     -       (-mglu**4 - mst2**4 - mt**4 + 
     -         2*(mglu**2*mst2**2 + mglu**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*msq1**2*TfinTMP(msq1,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**4*TfinTMP(msq1,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*TfinTMP(msq1,mt,mst1,mu))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (3*msq1**2*TfinTMP(msq1,mt,mst1,mu))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*mst1**2*TfinTMP(msq1,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**2*mst1**2*TfinTMP(msq1,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mst1**2*TfinTMP(msq1,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*mt**2*TfinTMP(msq1,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**2*mt**2*TfinTMP(msq1,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (mt**2*TfinTMP(msq1,mt,mst1,mu))/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*msq1**4*TfinTMP(msq1,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst1**2*TfinTMP(msq1,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mst1**2*TfinTMP(msq1,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*TfinTMP(msq1,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq1**2*mst1**4*TfinTMP(msq1,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*TfinTMP(msq1,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**4*mt**2*TfinTMP(msq1,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq1**2*mst1**2*mt**2*TfinTMP(msq1,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**2*TfinTMP(msq1,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**4*TfinTMP(msq1,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**2*mt**4*TfinTMP(msq1,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*TfinTMP(msq1,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*msq1**2*Xb*TfinTMP(msq1,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mst1**2*Xb*TfinTMP(msq1,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mt**2*Xb*TfinTMP(msq1,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*mt**2*Xt*TfinTMP(msq1,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)**3*(mst1**2 - mst2**2)) + 
     -    (3*mglu*mt**2*Xt*TfinTMP(msq1,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*msq1**4*mt**2*Xt*TfinTMP(msq1,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xt*TfinTMP(msq1,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Xt*TfinTMP(msq1,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xt*TfinTMP(msq1,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst1**4 - mt**4 + 
     -         2*(msq1**2*mst1**2 + msq1**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**2*Xb*Xt*TfinTMP(msq1,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) - 
     -    (msq1**2*mt**2*Xb*Xt*TfinTMP(msq1,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**2*msq1**2*TfinTMP(msq1,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**4*TfinTMP(msq1,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*TfinTMP(msq1,mt,mst2,mu))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (3*msq1**2*TfinTMP(msq1,mt,mst2,mu))/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*mst2**2*TfinTMP(msq1,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**2*mst2**2*TfinTMP(msq1,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (mst2**2*TfinTMP(msq1,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*mt**2*TfinTMP(msq1,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**2*mt**2*TfinTMP(msq1,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (mt**2*TfinTMP(msq1,mt,mst2,mu))/(16.*(-mglu**2 + msq1**2)**2))

        mssmzetavec(10) = CF*TF*((mglu**2*msq1**4*TfinTMP(msq1,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq1**2*mst2**2*TfinTMP(msq1,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mst2**2*TfinTMP(msq1,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*TfinTMP(msq1,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq1**2*mst2**4*TfinTMP(msq1,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*TfinTMP(msq1,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**4*mt**2*TfinTMP(msq1,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq1**2*mst2**2*mt**2*TfinTMP(msq1,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**2*TfinTMP(msq1,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**4*TfinTMP(msq1,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**4*TfinTMP(msq1,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*TfinTMP(msq1,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq1**2)**2*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*msq1**2*Xb*TfinTMP(msq1,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*mst2**2*Xb*TfinTMP(msq1,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*mt**2*Xb*TfinTMP(msq1,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*mt**2*Xt*TfinTMP(msq1,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)**3*(mst1**2 - mst2**2)) - 
     -    (3*mglu*mt**2*Xt*TfinTMP(msq1,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*msq1**4*mt**2*Xt*TfinTMP(msq1,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xt*TfinTMP(msq1,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Xt*TfinTMP(msq1,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xt*TfinTMP(msq1,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(mst1**2 - mst2**2)*
     -       (-msq1**4 - mst2**4 - mt**4 + 
     -         2*(msq1**2*mst2**2 + msq1**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mt**2*Xb*Xt*TfinTMP(msq1,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (msq1**2*mt**2*Xb*Xt*TfinTMP(msq1,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(mst1**2 - mst2**2)) + 
     -    (mglu**2*msq2**2*TfinTMP(msq2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**4*TfinTMP(msq2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*TfinTMP(msq2,mt,mst1,mu))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (3*msq2**2*TfinTMP(msq2,mt,mst1,mu))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*mst1**2*TfinTMP(msq2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**2*mst1**2*TfinTMP(msq2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mst1**2*TfinTMP(msq2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*mt**2*TfinTMP(msq2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**2*mt**2*TfinTMP(msq2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (mt**2*TfinTMP(msq2,mt,mst1,mu))/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*msq2**4*TfinTMP(msq2,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst1**2*TfinTMP(msq2,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mst1**2*TfinTMP(msq2,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mst1**4*TfinTMP(msq2,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (msq2**2*mst1**4*TfinTMP(msq2,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mst1**6*TfinTMP(msq2,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**4*mt**2*TfinTMP(msq2,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (msq2**2*mst1**2*mt**2*TfinTMP(msq2,mt,mst1,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (3*mst1**4*mt**2*TfinTMP(msq2,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu**2*mt**4*TfinTMP(msq2,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (3*mst1**2*mt**4*TfinTMP(msq2,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mt**6*TfinTMP(msq2,mt,mst1,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*msq2**2*Xb*TfinTMP(msq2,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mst1**2*Xb*TfinTMP(msq2,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mt**2*Xb*TfinTMP(msq2,mt,mst1,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**2*mt**2*Xt*TfinTMP(msq2,mt,mst1,mu))/
     -     (2.*(-mglu**2 + msq2**2)**3*(mst1**2 - mst2**2)) + 
     -    (3*mglu*mt**2*Xt*TfinTMP(msq2,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (mglu*msq2**4*mt**2*Xt*TfinTMP(msq2,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mst1**4*mt**2*Xt*TfinTMP(msq2,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) - 
     -    (mglu*mst1**2*mt**4*Xt*TfinTMP(msq2,mt,mst1,mu))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu*mt**6*Xt*TfinTMP(msq2,mt,mst1,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst1**4 - mt**4 + 
     -         2*(msq2**2*mst1**2 + msq2**2*mt**2 + mst1**2*mt**2))) + 
     -    (mglu**2*mt**2*Xb*Xt*TfinTMP(msq2,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (msq2**2*mt**2*Xb*Xt*TfinTMP(msq2,mt,mst1,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu**2*msq2**2*TfinTMP(msq2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**4*TfinTMP(msq2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*TfinTMP(msq2,mt,mst2,mu))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (3*msq2**2*TfinTMP(msq2,mt,mst2,mu))/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*mst2**2*TfinTMP(msq2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**2*mst2**2*TfinTMP(msq2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (mst2**2*TfinTMP(msq2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*mt**2*TfinTMP(msq2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**2*mt**2*TfinTMP(msq2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (mt**2*TfinTMP(msq2,mt,mst2,mu))/(16.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*msq2**4*TfinTMP(msq2,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*msq2**2*mst2**2*TfinTMP(msq2,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mst2**2*TfinTMP(msq2,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu**2*mst2**4*TfinTMP(msq2,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (msq2**2*mst2**4*TfinTMP(msq2,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mst2**6*TfinTMP(msq2,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**4*mt**2*TfinTMP(msq2,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (msq2**2*mst2**2*mt**2*TfinTMP(msq2,mt,mst2,mu))/
     -     (16.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (3*mst2**4*mt**2*TfinTMP(msq2,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**4*TfinTMP(msq2,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (3*mst2**2*mt**4*TfinTMP(msq2,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mt**6*TfinTMP(msq2,mt,mst2,mu))/
     -     (32.*(-mglu**2 + msq2**2)**2*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*msq2**2*Xb*TfinTMP(msq2,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*mst2**2*Xb*TfinTMP(msq2,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*mt**2*Xb*TfinTMP(msq2,mt,mst2,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**2*mt**2*Xt*TfinTMP(msq2,mt,mst2,mu))/
     -     (2.*(-mglu**2 + msq2**2)**3*(mst1**2 - mst2**2)) - 
     -    (3*mglu*mt**2*Xt*TfinTMP(msq2,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) + 
     -    (mglu*msq2**4*mt**2*Xt*TfinTMP(msq2,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mst2**4*mt**2*Xt*TfinTMP(msq2,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) + 
     -    (mglu*mst2**2*mt**4*Xt*TfinTMP(msq2,mt,mst2,mu))/
     -     (4.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu*mt**6*Xt*TfinTMP(msq2,mt,mst2,mu))/
     -     (8.*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)*
     -       (-msq2**4 - mst2**4 - mt**4 + 
     -         2*(msq2**2*mst2**2 + msq2**2*mt**2 + mst2**2*mt**2))) - 
     -    (mglu**2*mt**2*Xb*Xt*TfinTMP(msq2,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)) - 
     -    (msq2**2*mt**2*Xb*Xt*TfinTMP(msq2,mt,mst2,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2*(mst1**2 - mst2**2)))

        mssmzetavec(11) = CF**2*(-0.8828125 - mglu**2/(8.*msq1**2) - (21*msq1**2)/(256.*mglu**2) - 
     -    (25*mglu**8)/(512.*(-mglu**2 + msq1**2)**4) - 
     -    (35*mglu**6*msq1**2)/(64.*(-mglu**2 + msq1**2)**4) - 
     -    (115*mglu**4*msq1**4)/(256.*(-mglu**2 + msq1**2)**4) + 
     -    (35*mglu**2*msq1**6)/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (255*msq1**8)/(512.*(-mglu**2 + msq1**2)**4) - 
     -    (133*mglu**6)/(256.*(-mglu**2 + msq1**2)**3) + 
     -    (141*mglu**4*msq1**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (697*mglu**2*msq1**4)/(256.*(-mglu**2 + msq1**2)**3) - 
     -    (195*msq1**6)/(128.*(-mglu**2 + msq1**2)**3) + 
     -    (21*msq1**8)/(128.*mglu**2*(-mglu**2 + msq1**2)**3) - 
     -    (699*mglu**4)/(512.*(-mglu**2 + msq1**2)**2) + 
     -    (157*mglu**6)/(512.*msq1**2*(-mglu**2 + msq1**2)**2) + 
     -    (915*mglu**2*msq1**2)/(512.*(-mglu**2 + msq1**2)**2) + 
     -    (253*msq1**4)/(512.*(-mglu**2 + msq1**2)**2) - 
     -    (105*msq1**6)/(256.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**2)/(512.*(-mglu**2 + msq1**2)) + 
     -    (93*mglu**4)/(512.*msq1**2*(-mglu**2 + msq1**2)) - 
     -    (29*msq1**2)/(32.*(-mglu**2 + msq1**2)) + 
     -    (21*msq1**4)/(64.*mglu**2*(-mglu**2 + msq1**2)) - mglu**2/(8.*msq2**2) - 
     -    (21*msq2**2)/(256.*mglu**2) + 
     -    (7*mglu**4)/(2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (25*mglu**8)/(512.*(-mglu**2 + msq2**2)**4) - 
     -    (35*mglu**6*msq2**2)/(64.*(-mglu**2 + msq2**2)**4) - 
     -    (115*mglu**4*msq2**4)/(256.*(-mglu**2 + msq2**2)**4) + 
     -    (35*mglu**2*msq2**6)/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (255*msq2**8)/(512.*(-mglu**2 + msq2**2)**4) - 
     -    (133*mglu**6)/(256.*(-mglu**2 + msq2**2)**3) + 
     -    (141*mglu**4*msq2**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (697*mglu**2*msq2**4)/(256.*(-mglu**2 + msq2**2)**3) - 
     -    (195*msq2**6)/(128.*(-mglu**2 + msq2**2)**3) + 
     -    (21*msq2**8)/(128.*mglu**2*(-mglu**2 + msq2**2)**3) - 
     -    (699*mglu**4)/(512.*(-mglu**2 + msq2**2)**2) + 
     -    (157*mglu**6)/(512.*msq2**2*(-mglu**2 + msq2**2)**2) + 
     -    (915*mglu**2*msq2**2)/(512.*(-mglu**2 + msq2**2)**2) + 
     -    (253*msq2**4)/(512.*(-mglu**2 + msq2**2)**2) - 
     -    (105*msq2**6)/(256.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2)/(512.*(-mglu**2 + msq2**2)) + 
     -    (13*mglu**4)/(32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq1**2)/(4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (93*mglu**4)/(512.*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (29*msq2**2)/(32.*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**2*msq2**2)/(4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (3*msq1**2*msq2**2)/(8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (21*msq2**4)/(64.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (7*mglu**4)/(2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + Pi**2/192. + 
     -    (mglu**8*Pi**2)/(192.*(-mglu**2 + msq1**2)**4) - 
     -    (5*mglu**6*msq1**2*Pi**2)/(384.*(-mglu**2 + msq1**2)**4) - 
     -    (3*mglu**4*msq1**4*Pi**2)/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (5*mglu**2*msq1**6*Pi**2)/(384.*(-mglu**2 + msq1**2)**4) + 
     -    (7*msq1**8*Pi**2)/(384.*(-mglu**2 + msq1**2)**4) - 
     -    (mglu**6*Pi**2)/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (13*mglu**4*msq1**2*Pi**2)/(384.*(-mglu**2 + msq1**2)**3) - 
     -    (5*mglu**2*msq1**4*Pi**2)/(64.*(-mglu**2 + msq1**2)**3) - 
     -    (3*msq1**6*Pi**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (19*mglu**4*Pi**2)/(384.*(-mglu**2 + msq1**2)**2) + 
     -    (25*mglu**2*msq1**2*Pi**2)/(384.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**4*Pi**2)/(192.*(-mglu**2 + msq1**2)**2) - 
     -    (7*mglu**2*Pi**2)/(384.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*Pi**2)/(12.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**8*Pi**2)/(192.*(-mglu**2 + msq2**2)**4) - 
     -    (5*mglu**6*msq2**2*Pi**2)/(384.*(-mglu**2 + msq2**2)**4) - 
     -    (3*mglu**4*msq2**4*Pi**2)/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (5*mglu**2*msq2**6*Pi**2)/(384.*(-mglu**2 + msq2**2)**4) + 
     -    (7*msq2**8*Pi**2)/(384.*(-mglu**2 + msq2**2)**4) - 
     -    (mglu**6*Pi**2)/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (13*mglu**4*msq2**2*Pi**2)/(384.*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**2*msq2**4*Pi**2)/(64.*(-mglu**2 + msq2**2)**3) - 
     -    (3*msq2**6*Pi**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (19*mglu**4*Pi**2)/(384.*(-mglu**2 + msq2**2)**2) + 
     -    (25*mglu**2*msq2**2*Pi**2)/(384.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**4*Pi**2)/(192.*(-mglu**2 + msq2**2)**2) - 
     -    (7*mglu**2*Pi**2)/(384.*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*Pi**2)/(48.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq1**2*Pi**2)/(24.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq2**2*Pi**2)/(24.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (msq1**2*msq2**2*Pi**2)/(48.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*Pi**2)/(12.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (3*mglu**3*msq1**2*Xb)/(4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (3*mglu*msq1**4*Xb)/(4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (3*mglu**3*msq2**2*Xb)/(4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (3*mglu*msq1**2*msq2**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (17*mglu**5*Xb)/(8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu**7*Xb)/(8.*msq1**2*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*msq1**2*Xb)/(8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (11*mglu*msq1**4*Xb)/(8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (7*mglu**3*Xb)/(8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (3*mglu**5*Xb)/(8.*msq1**2*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (9*mglu*msq1**2*Xb)/(4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (17*mglu**5*Xb)/(8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**7*Xb)/(8.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**3*msq2**2*Xb)/(8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (11*mglu*msq2**4*Xb)/(8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**3*msq1**2*Xb)/(4.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (3*mglu**3*msq2**2*Xb)/(4.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (3*mglu*msq1**2*msq2**2*Xb)/
     -     (4.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) + 
     -    (3*mglu*msq2**4*Xb)/(4.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (7*mglu**3*Xb)/(8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (7*mglu**3*msq1**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu**5*Xb)/(8.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (9*mglu*msq2**2*Xb)/(4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (7*mglu**3*msq2**2*Xb)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (mglu*msq1**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (mglu**3*msq2**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (mglu*msq1**2*msq2**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (mglu**3*msq1**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**4*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*Pi**2*Xb)/(48.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*Pi**2*Xb)/(16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*msq2**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*msq1**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq2**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*msq2**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**4*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*Pi**2*Xb)/(48.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*Pi**2*Xb)/(16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq2**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    B0finTMP(msq1**2,0.d0,mglu,mu)/8. - 
     -    (mglu**2*B0finTMP(msq1**2,0.d0,mglu,mu))/(8.*msq1**2) - 
     -    (mglu**4*B0finTMP(msq1**2,0.d0,mglu,mu))/(8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**6*B0finTMP(msq1**2,0.d0,mglu,mu))/(8.*msq1**2*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*B0finTMP(msq1**2,0.d0,mglu,mu))/(16.*(-mglu**2 + msq1**2)) - 
     -    (msq1**2*B0finTMP(msq1**2,0.d0,mglu,mu))/(16.*(-mglu**2 + msq1**2)) + 
     -    (mglu**3*Xb*B0finTMP(msq1**2,0.d0,mglu,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*Xb*B0finTMP(msq1**2,0.d0,mglu,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    B0finTMP(msq2**2,0.d0,mglu,mu)/8. - 
     -    (mglu**2*B0finTMP(msq2**2,0.d0,mglu,mu))/(8.*msq2**2) - 
     -    (mglu**4*B0finTMP(msq2**2,0.d0,mglu,mu))/(8.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**6*B0finTMP(msq2**2,0.d0,mglu,mu))/(8.*msq2**2*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*B0finTMP(msq2**2,0.d0,mglu,mu))/(16.*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*B0finTMP(msq2**2,0.d0,mglu,mu))/(16.*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*Xb*B0finTMP(msq2**2,0.d0,mglu,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*Xb*B0finTMP(msq2**2,0.d0,mglu,mu))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*dlog(mu**2/mglu**2))/(8.*msq1**2) + 
     -    (41*mglu**8*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (41*mglu**4*msq1**4*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (41*msq1**8*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (15*mglu**6*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**8*dlog(mu**2/mglu**2))/(8.*msq1**2*(-mglu**2 + msq1**2)**3) + 
     -    (191*mglu**4*msq1**2*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (3*mglu**2*msq1**4*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (35*msq1**6*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (237*mglu**4*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**2) - 
     -    (15*mglu**6*dlog(mu**2/mglu**2))/(128.*msq1**2*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**2*msq1**2*dlog(mu**2/mglu**2))/(2.*(-mglu**2 + msq1**2)**2) - 
     -    (17*msq1**4*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (41*mglu**2*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)) - 
     -    (15*mglu**4*dlog(mu**2/mglu**2))/(128.*msq1**2*(-mglu**2 + msq1**2)) + 
     -    (7*msq1**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq1**2)) - 
     -    (mglu**2*dlog(mu**2/mglu**2))/(8.*msq2**2) + 
     -    (mglu**4*dlog(mu**2/mglu**2))/((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (41*mglu**8*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (41*mglu**4*msq2**4*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (41*msq2**8*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (15*mglu**6*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**8*dlog(mu**2/mglu**2))/(8.*msq2**2*(-mglu**2 + msq2**2)**3) + 
     -    (191*mglu**4*msq2**2*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (3*mglu**2*msq2**4*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (35*msq2**6*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (237*mglu**4*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) - 
     -    (15*mglu**6*dlog(mu**2/mglu**2))/(128.*msq2**2*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*msq2**2*dlog(mu**2/mglu**2))/(2.*(-mglu**2 + msq2**2)**2) - 
     -    (17*msq2**4*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (41*mglu**2*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)) - 
     -    (mglu**6*dlog(mu**2/mglu**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq1**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (15*mglu**4*dlog(mu**2/mglu**2))/(128.*msq2**2*(-mglu**2 + msq2**2)) + 
     -    (7*msq2**2*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq2**2*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*dlog(mu**2/mglu**2))/((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (11*mglu**5*Xb*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**4*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (19*mglu**3*Xb*dlog(mu**2/mglu**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**5*Xb*dlog(mu**2/mglu**2))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (11*mglu**5*Xb*dlog(mu**2/mglu**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2))/
     -     (8.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*msq2**4*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (2.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) + 
     -    (19*mglu**3*Xb*dlog(mu**2/mglu**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**5*Xb*dlog(mu**2/mglu**2))/
     -     (8.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**6*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**8*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**4*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**6*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**4*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**4*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**5*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu**7*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*msq1**2*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**5*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*msq1**2*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**6*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**8*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (8.*msq2**2*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**4*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**6*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (8.*msq2**2*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**4*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**4*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**5*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**7*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**3*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**5*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/mglu**2))/
     -     (4.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    dlog(mu**2/mglu**2)**2/32. + 
     -    (7*mglu**8*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (5*mglu**6*msq1**2*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (19*mglu**4*msq1**4*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**4) - 
     -    (5*mglu**2*msq1**6*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (7*msq1**8*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (11*mglu**6*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**8*dlog(mu**2/mglu**2)**2)/(8.*msq1**2*(-mglu**2 + msq1**2)**3) + 
     -    (69*mglu**4*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**4*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq1**2)**3) - 
     -    (9*msq1**6*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (73*mglu**4*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**2) - 
     -    (13*mglu**6*dlog(mu**2/mglu**2)**2)/(64.*msq1**2*(-mglu**2 + msq1**2)**2) + 
     -    (49*mglu**2*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**2) - 
     -    (3*msq1**4*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)) - 
     -    (5*mglu**4*dlog(mu**2/mglu**2)**2)/(64.*msq1**2*(-mglu**2 + msq1**2)) + 
     -    (msq1**2*dlog(mu**2/mglu**2)**2)/(8.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (7*mglu**8*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (5*mglu**6*msq2**2*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (19*mglu**4*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq2**2)**4) - 
     -    (5*mglu**2*msq2**6*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (7*msq2**8*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (11*mglu**6*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**8*dlog(mu**2/mglu**2)**2)/(8.*msq2**2*(-mglu**2 + msq2**2)**3) + 
     -    (69*mglu**4*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**4*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq2**2)**3) - 
     -    (9*msq2**6*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (73*mglu**4*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**8*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)**2) - 
     -    (13*mglu**6*dlog(mu**2/mglu**2)**2)/(64.*msq2**2*(-mglu**2 + msq2**2)**2) + 
     -    (49*mglu**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq2**2)**2) - 
     -    (3*msq2**4*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (5*mglu**4*dlog(mu**2/mglu**2)**2)/(64.*msq2**2*(-mglu**2 + msq2**2)) + 
     -    (msq2**2*dlog(mu**2/mglu**2)**2)/(8.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (3*mglu**5*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**5*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (3*mglu**5*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*msq2**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**3*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**5*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - dlog(mu**2/msq1**2)/32. + 
     -    (3*msq1**2*dlog(mu**2/msq1**2))/(64.*mglu**2) + 
     -    (7*mglu**8*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq1**2)**4) - 
     -    (7*mglu**4*msq1**4*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq1**2)**4) + 
     -    (7*msq1**8*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (47*mglu**6*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**8*dlog(mu**2/msq1**2))/(8.*msq1**2*(-mglu**2 + msq1**2)**3) + 
     -    (61*mglu**4*msq1**2*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (69*mglu**2*msq1**4*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq1**2)**3) - 
     -    (17*msq1**6*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (3*msq1**8*dlog(mu**2/msq1**2))/(32.*mglu**2*(-mglu**2 + msq1**2)**3) + 
     -    (41*mglu**4*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mglu**6*dlog(mu**2/msq1**2))/(32.*msq1**2*(-mglu**2 + msq1**2)**2) + 
     -    (171*mglu**2*msq1**2*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**2) - 
     -    (17*msq1**4*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (15*msq1**6*dlog(mu**2/msq1**2))/(64.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (19*mglu**2*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq1**2)) - 
     -    (mglu**4*dlog(mu**2/msq1**2))/(32.*msq1**2*(-mglu**2 + msq1**2)) - 
     -    (7*msq1**2*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq1**2)) - 
     -    (3*msq1**4*dlog(mu**2/msq1**2))/(16.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (mglu**2*dlog(mu**2/msq1**2))/(2.*(msq1**2 - msq2**2)) + 
     -    (mglu**4*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (3*mglu**2*msq1**2*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**2*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq2**2)) + 
     -    (mglu**6*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq1**2*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (msq1**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (mglu*msq1**4*Xb*dlog(mu**2/msq1**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (13*mglu*Xb*dlog(mu**2/msq1**2))/(16.*(msq1**2 - msq2**2)) - 
     -    (mglu**3*Xb*dlog(mu**2/msq1**2))/(4.*msq1**2*(msq1**2 - msq2**2)) + 
     -    (17*mglu**5*Xb*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**7*Xb*dlog(mu**2/msq1**2))/
     -     (4.*msq1**2*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (5*mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*Xb*dlog(mu**2/msq1**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (2.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (2.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*Xb*dlog(mu**2/msq1**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**5*Xb*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**6*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**8*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**4*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**6*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-msq1**2 + msq2**2)) - 
     -    (mglu**4*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(msq1**2 - msq2**2)) - 
     -    (mglu**3*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*msq1**2*(msq1**2 - msq2**2)) - 
     -    (mglu**5*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**7*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*msq1**2*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*Xb*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**2*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-msq1**2 + msq2**2)) - 
     -    (mglu**4*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-msq1**2 + msq2**2)) + 
     -    (dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/32. - 
     -    (5*mglu**6*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**4) - 
     -    (9*mglu**4*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**4) + 
     -    (5*mglu**2*msq1**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**4) + 
     -    (7*msq1**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**4) - 
     -    (5*mglu**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)**3) - 
     -    (3*mglu**4*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**3) - 
     -    (9*mglu**2*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**3) + 
     -    (3*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2) - 
     -    (3*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)) + 
     -    (msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (mglu**3*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (4.*msq1**2*(msq1**2 - msq2**2)) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (11*mglu**5*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (4.*msq1**2*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (5*mglu*msq1**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu**3*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**5*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (4.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (3*dlog(mu**2/msq1**2)**2)/64. + 
     -    (msq1**2*dlog(mu**2/msq1**2)**2)/(32.*mglu**2) + 
     -    (mglu**8*dlog(mu**2/msq1**2)**2)/(32.*(-mglu**2 + msq1**2)**4) + 
     -    (5*mglu**6*msq1**2*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (mglu**4*msq1**4*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (5*mglu**2*msq1**6*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (3*msq1**8*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (15*mglu**6*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (9*mglu**4*msq1**2*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (13*mglu**2*msq1**4*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (19*msq1**6*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**8*dlog(mu**2/msq1**2)**2)/(16.*mglu**2*(-mglu**2 + msq1**2)**3) + 
     -    (9*mglu**4*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (43*mglu**2*msq1**2*dlog(mu**2/msq1**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**4*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq1**2)**2) + 
     -    (5*msq1**6*dlog(mu**2/msq1**2)**2)/(32.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (11*mglu**2*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)) - 
     -    (5*msq1**2*dlog(mu**2/msq1**2)**2)/(16.*(-mglu**2 + msq1**2)) - 
     -    (msq1**4*dlog(mu**2/msq1**2)**2)/(8.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (mglu**2*dlog(mu**2/msq1**2)**2)/(4.*(msq1**2 - msq2**2)) + 
     -    (mglu**4*dlog(mu**2/msq1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**2*msq1**2*dlog(mu**2/msq1**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**2*msq1**2*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (mglu*msq1**4*Xb*dlog(mu**2/msq1**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (5*mglu*Xb*dlog(mu**2/msq1**2)**2)/(16.*(msq1**2 - msq2**2)) + 
     -    (mglu**7*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) + 
     -    (mglu**5*Xb*dlog(mu**2/msq1**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**4*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (8.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) - 
     -    dlog(mu**2/msq2**2)/32. - 
     -    (mglu**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq1**2)) + 
     -    (3*msq2**2*dlog(mu**2/msq2**2))/(64.*mglu**2) - 
     -    (mglu**2*dlog(mu**2/msq2**2))/(2.*(msq1**2 - msq2**2)) + 
     -    (7*mglu**8*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq2**2)**4) - 
     -    (7*mglu**4*msq2**4*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq2**2)**4) + 
     -    (7*msq2**8*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (47*mglu**6*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**8*dlog(mu**2/msq2**2))/(8.*msq2**2*(-mglu**2 + msq2**2)**3) + 
     -    (61*mglu**4*msq2**2*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (69*mglu**2*msq2**4*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq2**2)**3) - 
     -    (17*msq2**6*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (3*msq2**8*dlog(mu**2/msq2**2))/(32.*mglu**2*(-mglu**2 + msq2**2)**3) + 
     -    (41*mglu**4*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**6*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**6*dlog(mu**2/msq2**2))/(32.*msq2**2*(-mglu**2 + msq2**2)**2) + 
     -    (171*mglu**2*msq2**2*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (17*msq2**4*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (15*msq2**6*dlog(mu**2/msq2**2))/(64.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (19*mglu**2*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*dlog(mu**2/msq2**2))/(32.*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (7*msq2**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (msq1**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (3*msq2**4*dlog(mu**2/msq2**2))/(16.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (13*mglu*Xb*dlog(mu**2/msq2**2))/(16.*(msq1**2 - msq2**2)) - 
     -    (mglu**3*Xb*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*Xb*dlog(mu**2/msq2**2))/(4.*msq2**2*(msq1**2 - msq2**2)) - 
     -    (17*mglu**5*Xb*dlog(mu**2/msq2**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**7*Xb*dlog(mu**2/msq2**2))/
     -     (4.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**4*Xb*dlog(mu**2/msq2**2))/
     -     ((msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*Xb*dlog(mu**2/msq2**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**5*Xb*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**2*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(-msq1**2 + msq2**2)) + 
     -    (mglu**4*B0finTMP(msq1**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**6*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**8*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (8.*msq2**2*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**4*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**6*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (8.*msq2**2*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**2*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(-msq1**2 + msq2**2)) + 
     -    (mglu**4*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)) + 
     -    (mglu**3*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*msq2**2*(msq1**2 - msq2**2)) + 
     -    (mglu**5*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**7*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**3*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*Xb*B0finTMP(msq2**2,0.d0,mglu,mu)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/32. + 
     -    (mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**6*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**4) - 
     -    (9*mglu**4*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**4) + 
     -    (5*mglu**2*msq2**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**4) + 
     -    (7*msq2**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**4) - 
     -    (5*mglu**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*msq2**2*(-mglu**2 + msq2**2)**3) - 
     -    (3*mglu**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**3) - 
     -    (9*mglu**2*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**3) + 
     -    (3*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*msq2**2*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2) - 
     -    (3*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)) + 
     -    (msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (mglu**5*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**3*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (4.*msq2**2*(msq1**2 - msq2**2)) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (11*mglu**5*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (4.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu*msq2**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (3*mglu**3*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/32. - 
     -    (mglu**4*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**4*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**8*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq1**2)**2*(-mglu**2 + msq2**2)**2) + 
     -    (msq1**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (mglu**5*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu**3*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**5*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**7*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**7*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu*msq2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (3*dlog(mu**2/msq2**2)**2)/64. + 
     -    (msq2**2*dlog(mu**2/msq2**2)**2)/(32.*mglu**2) - 
     -    (mglu**2*dlog(mu**2/msq2**2)**2)/(4.*(msq1**2 - msq2**2)) + 
     -    (mglu**8*dlog(mu**2/msq2**2)**2)/(32.*(-mglu**2 + msq2**2)**4) + 
     -    (5*mglu**6*msq2**2*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (mglu**4*msq2**4*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (5*mglu**2*msq2**6*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (3*msq2**8*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (15*mglu**6*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (9*mglu**4*msq2**2*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (13*mglu**2*msq2**4*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (19*msq2**6*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**8*dlog(mu**2/msq2**2)**2)/(16.*mglu**2*(-mglu**2 + msq2**2)**3) + 
     -    (9*mglu**4*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (43*mglu**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (128.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**4*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq2**2)**2) + 
     -    (5*msq2**6*dlog(mu**2/msq2**2)**2)/(32.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (11*mglu**2*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)) - 
     -    (5*msq2**2*dlog(mu**2/msq2**2)**2)/(16.*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (msq2**4*dlog(mu**2/msq2**2)**2)/(8.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*dlog(mu**2/msq2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)**2) + 
     -    (5*mglu*Xb*dlog(mu**2/msq2**2)**2)/(16.*(msq1**2 - msq2**2)) - 
     -    (mglu**7*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**5*Xb*dlog(mu**2/msq2**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*msq2**4*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**4*Xb*dlog(mu**2/msq2**2)**2)/
     -     (2.*(msq1**2 - msq2**2)**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*Xb*dlog(mu**2/msq2**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-msq1**2 + msq2**2)) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)*(-msq1**2 + msq2**2)) - 
     -    TfinZTMP(msq1,mglu,mu)/(32.*mglu**2) - 
     -    (5*mglu**6*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**4) - 
     -    (5*mglu**4*msq1**2*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (5*mglu**2*msq1**4*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (5*msq1**6*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**4) - 
     -    (3*mglu**4*TfinZTMP(msq1,mglu,mu))/(32.*(-mglu**2 + msq1**2)**3) - 
     -    (mglu**2*msq1**2*TfinZTMP(msq1,mglu,mu))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (13*msq1**4*TfinZTMP(msq1,mglu,mu))/(32.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**6*TfinZTMP(msq1,mglu,mu))/(16.*mglu**2*(-mglu**2 + msq1**2)**3) - 
     -    (7*mglu**2*TfinZTMP(msq1,mglu,mu))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (5*mglu**4*TfinZTMP(msq1,mglu,mu))/(64.*msq1**2*(-mglu**2 + msq1**2)**2) + 
     -    (19*msq1**2*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**4*TfinZTMP(msq1,mglu,mu))/(32.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (3*TfinZTMP(msq1,mglu,mu))/(16.*(-mglu**2 + msq1**2)) + 
     -    (5*mglu**2*TfinZTMP(msq1,mglu,mu))/(64.*msq1**2*(-mglu**2 + msq1**2)) + 
     -    (msq1**2*TfinZTMP(msq1,mglu,mu))/(8.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (mglu**2*TfinZTMP(msq1,mglu,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (msq1**2*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu**5*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu*msq1**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**3*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*msq1**2*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    TfinZTMP(msq2,mglu,mu)/(32.*mglu**2) - 
     -    (5*mglu**6*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**4) - 
     -    (5*mglu**4*msq2**2*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (5*mglu**2*msq2**4*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (5*msq2**6*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**4) - 
     -    (3*mglu**4*TfinZTMP(msq2,mglu,mu))/(32.*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**2*msq2**2*TfinZTMP(msq2,mglu,mu))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (13*msq2**4*TfinZTMP(msq2,mglu,mu))/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**6*TfinZTMP(msq2,mglu,mu))/(16.*mglu**2*(-mglu**2 + msq2**2)**3) - 
     -    (7*mglu**2*TfinZTMP(msq2,mglu,mu))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (5*mglu**4*TfinZTMP(msq2,mglu,mu))/(64.*msq2**2*(-mglu**2 + msq2**2)**2) + 
     -    (19*msq2**2*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**4*TfinZTMP(msq2,mglu,mu))/(32.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (3*TfinZTMP(msq2,mglu,mu))/(16.*(-mglu**2 + msq2**2)) - 
     -    (msq1**2*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*TfinZTMP(msq2,mglu,mu))/(64.*msq2**2*(-mglu**2 + msq2**2)) + 
     -    (msq2**2*TfinZTMP(msq2,mglu,mu))/(8.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*TfinZTMP(msq2,mglu,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**5*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu*msq2**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*msq2**2*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (msq1**2*TfinZTMP(msq2,msq1,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (msq2**2*TfinZTMP(msq2,msq1,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq1**2*Xb*TfinZTMP(msq2,msq1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq2**2*Xb*TfinZTMP(msq2,msq1,mu))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)))

        mssmzetavec(12) = CF*CV*(-0.3372395833333333 + (29*msq1**2)/(1152.*mglu**2) - 
     -    (9*mglu**10)/(512.*(-mglu**2 + msq1**2)**5) - 
     -    (47*mglu**8*msq1**2)/(512.*(-mglu**2 + msq1**2)**5) + 
     -    (9*mglu**6*msq1**4)/(256.*(-mglu**2 + msq1**2)**5) + 
     -    (47*mglu**4*msq1**6)/(256.*(-mglu**2 + msq1**2)**5) - 
     -    (9*mglu**2*msq1**8)/(512.*(-mglu**2 + msq1**2)**5) - 
     -    (47*msq1**10)/(512.*(-mglu**2 + msq1**2)**5) - 
     -    (173*mglu**8)/(512.*(-mglu**2 + msq1**2)**4) - 
     -    (9*mglu**6*msq1**2)/(32.*(-mglu**2 + msq1**2)**4) + 
     -    (133*mglu**4*msq1**4)/(256.*(-mglu**2 + msq1**2)**4) + 
     -    (9*mglu**2*msq1**6)/(32.*(-mglu**2 + msq1**2)**4) - 
     -    (93*msq1**8)/(512.*(-mglu**2 + msq1**2)**4) - 
     -    (181*mglu**6)/(512.*(-mglu**2 + msq1**2)**3) - 
     -    (57*mglu**4*msq1**2)/(16.*(-mglu**2 + msq1**2)**3) + 
     -    (603*mglu**2*msq1**4)/(256.*(-mglu**2 + msq1**2)**3) + 
     -    (149*msq1**6)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (21*msq1**8)/(512.*mglu**2*(-mglu**2 + msq1**2)**3) + 
     -    (299*mglu**4)/(512.*(-mglu**2 + msq1**2)**2) + 
     -    (3*mglu**6)/(1024.*msq1**2*(-mglu**2 + msq1**2)**2) - 
     -    (2729*mglu**2*msq1**2)/(1024.*(-mglu**2 + msq1**2)**2) - 
     -    (163*msq1**4)/(256.*(-mglu**2 + msq1**2)**2) + 
     -    (21*msq1**6)/(256.*mglu**2*(-mglu**2 + msq1**2)**2) + 
     -    (2117*mglu**2)/(9216.*(-mglu**2 + msq1**2)) + 
     -    (3*mglu**4)/(1024.*msq1**2*(-mglu**2 + msq1**2)) + 
     -    (2761*msq1**2)/(4608.*(-mglu**2 + msq1**2)) - 
     -    (305*msq1**4)/(4608.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (29*msq2**2)/(1152.*mglu**2) - 
     -    (9*mglu**10)/(512.*(-mglu**2 + msq2**2)**5) - 
     -    (47*mglu**8*msq2**2)/(512.*(-mglu**2 + msq2**2)**5) + 
     -    (9*mglu**6*msq2**4)/(256.*(-mglu**2 + msq2**2)**5) + 
     -    (47*mglu**4*msq2**6)/(256.*(-mglu**2 + msq2**2)**5) - 
     -    (9*mglu**2*msq2**8)/(512.*(-mglu**2 + msq2**2)**5) - 
     -    (47*msq2**10)/(512.*(-mglu**2 + msq2**2)**5) - 
     -    (173*mglu**8)/(512.*(-mglu**2 + msq2**2)**4) - 
     -    (9*mglu**6*msq2**2)/(32.*(-mglu**2 + msq2**2)**4) + 
     -    (133*mglu**4*msq2**4)/(256.*(-mglu**2 + msq2**2)**4) + 
     -    (9*mglu**2*msq2**6)/(32.*(-mglu**2 + msq2**2)**4) - 
     -    (93*msq2**8)/(512.*(-mglu**2 + msq2**2)**4) - 
     -    (181*mglu**6)/(512.*(-mglu**2 + msq2**2)**3) - 
     -    (57*mglu**4*msq2**2)/(16.*(-mglu**2 + msq2**2)**3) + 
     -    (603*mglu**2*msq2**4)/(256.*(-mglu**2 + msq2**2)**3) + 
     -    (149*msq2**6)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (21*msq2**8)/(512.*mglu**2*(-mglu**2 + msq2**2)**3) + 
     -    (299*mglu**4)/(512.*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**6)/(1024.*msq2**2*(-mglu**2 + msq2**2)**2) - 
     -    (2729*mglu**2*msq2**2)/(1024.*(-mglu**2 + msq2**2)**2) - 
     -    (163*msq2**4)/(256.*(-mglu**2 + msq2**2)**2) + 
     -    (21*msq2**6)/(256.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (2117*mglu**2)/(9216.*(-mglu**2 + msq2**2)) - 
     -    (3*mglu**4)/(16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq1**2)/(8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu**4)/(1024.*msq2**2*(-mglu**2 + msq2**2)) + 
     -    (2761*msq2**2)/(4608.*(-mglu**2 + msq2**2)) + 
     -    (5*mglu**2*msq2**2)/(8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (3*msq1**2*msq2**2)/(16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (305*msq2**4)/(4608.*mglu**2*(-mglu**2 + msq2**2)) + (7*Pi**2)/384. - 
     -    (mglu**8*msq1**2*Pi**2)/(384.*(-mglu**2 + msq1**2)**5) + 
     -    (mglu**4*msq1**6*Pi**2)/(192.*(-mglu**2 + msq1**2)**5) - 
     -    (msq1**10*Pi**2)/(384.*(-mglu**2 + msq1**2)**5) - 
     -    (mglu**8*Pi**2)/(384.*(-mglu**2 + msq1**2)**4) - 
     -    (mglu**6*msq1**2*Pi**2)/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (mglu**4*msq1**4*Pi**2)/(96.*(-mglu**2 + msq1**2)**4) + 
     -    (mglu**2*msq1**6*Pi**2)/(64.*(-mglu**2 + msq1**2)**4) - 
     -    (msq1**8*Pi**2)/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (mglu**6*Pi**2)/(192.*(-mglu**2 + msq1**2)**3) - 
     -    (7*mglu**4*msq1**2*Pi**2)/(96.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**4*Pi**2)/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**6*Pi**2)/(24.*(-mglu**2 + msq1**2)**3) + 
     -    (35*mglu**4*Pi**2)/(768.*(-mglu**2 + msq1**2)**2) - 
     -    (41*mglu**2*msq1**2*Pi**2)/(768.*(-mglu**2 + msq1**2)**2) - 
     -    (13*msq1**4*Pi**2)/(384.*(-mglu**2 + msq1**2)**2) + 
     -    (7*mglu**2*Pi**2)/(192.*(-mglu**2 + msq1**2)) + 
     -    (7*msq1**2*Pi**2)/(768.*(-mglu**2 + msq1**2)) - 
     -    (mglu**8*msq2**2*Pi**2)/(384.*(-mglu**2 + msq2**2)**5) + 
     -    (mglu**4*msq2**6*Pi**2)/(192.*(-mglu**2 + msq2**2)**5) - 
     -    (msq2**10*Pi**2)/(384.*(-mglu**2 + msq2**2)**5) - 
     -    (mglu**8*Pi**2)/(384.*(-mglu**2 + msq2**2)**4) - 
     -    (mglu**6*msq2**2*Pi**2)/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (mglu**4*msq2**4*Pi**2)/(96.*(-mglu**2 + msq2**2)**4) + 
     -    (mglu**2*msq2**6*Pi**2)/(64.*(-mglu**2 + msq2**2)**4) - 
     -    (msq2**8*Pi**2)/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (mglu**6*Pi**2)/(192.*(-mglu**2 + msq2**2)**3) - 
     -    (7*mglu**4*msq2**2*Pi**2)/(96.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**4*Pi**2)/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**6*Pi**2)/(24.*(-mglu**2 + msq2**2)**3) + 
     -    (35*mglu**4*Pi**2)/(768.*(-mglu**2 + msq2**2)**2) - 
     -    (41*mglu**2*msq2**2*Pi**2)/(768.*(-mglu**2 + msq2**2)**2) - 
     -    (13*msq2**4*Pi**2)/(384.*(-mglu**2 + msq2**2)**2) + 
     -    (7*mglu**2*Pi**2)/(192.*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*Pi**2)/(96.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq1**2*Pi**2)/(48.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (7*msq2**2*Pi**2)/(768.*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq2**2*Pi**2)/(48.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (msq1**2*msq2**2*Pi**2)/(96.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu**7*Xb)/(8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) + 
     -    (mglu**5*msq1**2*Xb)/(2.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*msq1**4*Xb)/(8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**6*Xb)/(2.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (2*mglu**5*Xb)/((-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu**3*msq1**2*Xb)/(2.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (9*mglu*msq1**4*Xb)/(4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (89*mglu**3*Xb)/(16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (5*mglu*msq1**2*Xb)/(16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (3*mglu**7*Xb)/(8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**5*msq2**2*Xb)/(2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (3*mglu**3*msq2**4*Xb)/(8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (mglu*msq2**6*Xb)/(2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (2*mglu**5*Xb)/((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu**3*msq2**2*Xb)/(2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (9*mglu*msq2**4*Xb)/(4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (89*mglu**3*Xb)/(16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (7*mglu**3*msq1**2*Xb)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (5*mglu*msq2**2*Xb)/(16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (7*mglu**3*msq2**2*Xb)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**5*msq1**2*Pi**2*Xb)/
     -     (48.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**6*Pi**2*Xb)/
     -     (48.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (mglu**5*Pi**2*Xb)/(16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*msq1**2*Pi**2*Xb)/
     -     (24.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**4*Pi**2*Xb)/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (11*mglu**3*Pi**2*Xb)/(96.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*Pi**2*Xb)/(32.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**5*msq2**2*Pi**2*Xb)/
     -     (48.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (mglu*msq2**6*Pi**2*Xb)/
     -     (48.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**5*Pi**2*Xb)/(16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**3*msq2**2*Pi**2*Xb)/
     -     (24.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**4*Pi**2*Xb)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (11*mglu**3*Pi**2*Xb)/(96.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**3*msq1**2*Pi**2*Xb)/
     -     (48.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*Pi**2*Xb)/(32.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**3*msq2**2*Pi**2*Xb)/
     -     (48.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    dlog(mu**2/mglu**2)/64. + (msq1**2*dlog(mu**2/mglu**2))/(96.*mglu**2) + 
     -    (7*mglu**10*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**5) - 
     -    (7*mglu**8*msq1**2*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**5) - 
     -    (7*mglu**6*msq1**4*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)**5) + 
     -    (7*mglu**4*msq1**6*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)**5) + 
     -    (7*mglu**2*msq1**8*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**5) - 
     -    (7*msq1**10*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**5) + 
     -    (9*mglu**8*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)**4) - 
     -    (23*mglu**6*msq1**2*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (13*mglu**4*msq1**4*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (23*mglu**2*msq1**6*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (5*msq1**8*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (21*mglu**6*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq1**2)**3) - 
     -    (101*mglu**4*msq1**2*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (mglu**2*msq1**4*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq1**2)**3) + 
     -    (15*msq1**6*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (61*mglu**4*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (7*mglu**6*dlog(mu**2/mglu**2))/(256.*msq1**2*(-mglu**2 + msq1**2)**2) - 
     -    (385*mglu**2*msq1**2*dlog(mu**2/mglu**2))/(256.*(-mglu**2 + msq1**2)**2) + 
     -    (7*msq1**4*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (721*mglu**2*dlog(mu**2/mglu**2))/(768.*(-mglu**2 + msq1**2)) + 
     -    (7*mglu**4*dlog(mu**2/mglu**2))/(256.*msq1**2*(-mglu**2 + msq1**2)) - 
     -    (19*msq1**2*dlog(mu**2/mglu**2))/(96.*(-mglu**2 + msq1**2)) - 
     -    (msq1**4*dlog(mu**2/mglu**2))/(96.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (msq2**2*dlog(mu**2/mglu**2))/(96.*mglu**2) + 
     -    (7*mglu**10*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**5) - 
     -    (7*mglu**8*msq2**2*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**5) - 
     -    (7*mglu**6*msq2**4*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)**5) + 
     -    (7*mglu**4*msq2**6*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)**5) + 
     -    (7*mglu**2*msq2**8*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**5) - 
     -    (7*msq2**10*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**5) + 
     -    (9*mglu**8*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)**4) - 
     -    (23*mglu**6*msq2**2*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (13*mglu**4*msq2**4*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (23*mglu**2*msq2**6*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (5*msq2**8*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (21*mglu**6*dlog(mu**2/mglu**2))/(16.*(-mglu**2 + msq2**2)**3) - 
     -    (101*mglu**4*msq2**2*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**2*msq2**4*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq2**2)**3) + 
     -    (15*msq2**6*dlog(mu**2/mglu**2))/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (61*mglu**4*dlog(mu**2/mglu**2))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (7*mglu**6*dlog(mu**2/mglu**2))/(256.*msq2**2*(-mglu**2 + msq2**2)**2) - 
     -    (385*mglu**2*msq2**2*dlog(mu**2/mglu**2))/(256.*(-mglu**2 + msq2**2)**2) + 
     -    (7*msq2**4*dlog(mu**2/mglu**2))/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (721*mglu**2*dlog(mu**2/mglu**2))/(768.*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq1**2*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (7*mglu**4*dlog(mu**2/mglu**2))/(256.*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (19*msq2**2*dlog(mu**2/mglu**2))/(96.*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq2**2*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (msq2**4*dlog(mu**2/mglu**2))/(96.*mglu**2*(-mglu**2 + msq2**2)) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) + 
     -    (mglu**5*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) + 
     -    (mglu**3*msq1**4*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**6*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) + 
     -    (mglu**5*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**4*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (3*mglu**3*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**5*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**3*msq2**4*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (mglu*msq2**6*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**5*Xb*dlog(mu**2/mglu**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**4*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (3*mglu**3*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*Xb*dlog(mu**2/mglu**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (3*dlog(mu**2/mglu**2)**2)/32. + 
     -    (mglu**10*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq1**2)**5) - 
     -    (mglu**8*msq1**2*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**5) - 
     -    (mglu**6*msq1**4*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**5) + 
     -    (mglu**4*msq1**6*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq1**2)**5) + 
     -    (mglu**2*msq1**8*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq1**2)**5) - 
     -    (msq1**10*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**5) + 
     -    (13*mglu**8*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (3*mglu**6*msq1**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**4) - 
     -    (5*mglu**4*msq1**4*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (3*mglu**2*msq1**6*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq1**2)**4) - 
     -    (3*msq1**8*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (95*mglu**6*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (65*mglu**4*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**3) - 
     -    (25*mglu**2*msq1**4*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**3) + 
     -    (15*msq1**6*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**3) + 
     -    (247*mglu**4*dlog(mu**2/mglu**2)**2)/(256.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**6*dlog(mu**2/mglu**2)**2)/(128.*msq1**2*(-mglu**2 + msq1**2)**2) - 
     -    (119*mglu**2*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2) - 
     -    (5*msq1**4*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (81*mglu**2*dlog(mu**2/mglu**2)**2)/(256.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*dlog(mu**2/mglu**2)**2)/(128.*msq1**2*(-mglu**2 + msq1**2)) - 
     -    (msq1**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq1**2)) + 
     -    (mglu**10*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq2**2)**5) - 
     -    (mglu**8*msq2**2*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**5) - 
     -    (mglu**6*msq2**4*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**5) + 
     -    (mglu**4*msq2**6*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq2**2)**5) + 
     -    (mglu**2*msq2**8*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq2**2)**5) - 
     -    (msq2**10*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**5) + 
     -    (13*mglu**8*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (3*mglu**6*msq2**2*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**4) - 
     -    (5*mglu**4*msq2**4*dlog(mu**2/mglu**2)**2)/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (3*mglu**2*msq2**6*dlog(mu**2/mglu**2)**2)/(32.*(-mglu**2 + msq2**2)**4) - 
     -    (3*msq2**8*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (95*mglu**6*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (65*mglu**4*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq2**2)**3) - 
     -    (25*mglu**2*msq2**4*dlog(mu**2/mglu**2)**2)/
     -     (128.*(-mglu**2 + msq2**2)**3) + 
     -    (15*msq2**6*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**3) + 
     -    (247*mglu**4*dlog(mu**2/mglu**2)**2)/(256.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**6*dlog(mu**2/mglu**2)**2)/(128.*msq2**2*(-mglu**2 + msq2**2)**2) - 
     -    (119*mglu**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (256.*(-mglu**2 + msq2**2)**2) - 
     -    (5*msq2**4*dlog(mu**2/mglu**2)**2)/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (81*mglu**2*dlog(mu**2/mglu**2)**2)/(256.*(-mglu**2 + msq2**2)) - 
     -    (mglu**4*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq1**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*dlog(mu**2/mglu**2)**2)/(128.*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*dlog(mu**2/mglu**2)**2)/(16.*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq2**2*dlog(mu**2/mglu**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) + 
     -    (mglu**5*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) + 
     -    (mglu**3*msq1**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) + 
     -    (5*mglu**5*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (13*mglu**3*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (3*mglu*msq1**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu**7*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**5*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) - 
     -    (mglu**3*msq2**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (mglu*msq2**6*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) - 
     -    (5*mglu**5*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**4*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (13*mglu**3*Xb*dlog(mu**2/mglu**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu*msq2**2*Xb*dlog(mu**2/mglu**2)**2)/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (3*dlog(mu**2/msq1**2))/64. - 
     -    (7*mglu**8*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (7*mglu**6*msq1**2*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (7*mglu**4*msq1**4*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (7*mglu**2*msq1**6*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (149*mglu**6*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**3) - 
     -    (3*mglu**4*msq1**2*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (89*mglu**2*msq1**4*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq1**2)**3) - 
     -    (13*msq1**6*dlog(mu**2/msq1**2))/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (3*msq1**8*dlog(mu**2/msq1**2))/(128.*mglu**2*(-mglu**2 + msq1**2)**3) - 
     -    (189*mglu**4*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**2) + 
     -    (mglu**6*dlog(mu**2/msq1**2))/(64.*msq1**2*(-mglu**2 + msq1**2)**2) - 
     -    (25*mglu**2*msq1**2*dlog(mu**2/msq1**2))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (67*msq1**4*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)**2) - 
     -    (3*msq1**6*dlog(mu**2/msq1**2))/(64.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (39*mglu**2*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)) + 
     -    (mglu**4*dlog(mu**2/msq1**2))/(64.*msq1**2*(-mglu**2 + msq1**2)) - 
     -    (63*msq1**2*dlog(mu**2/msq1**2))/(128.*(-mglu**2 + msq1**2)) + 
     -    (3*msq1**4*dlog(mu**2/msq1**2))/(128.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (mglu**2*msq1**2*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (msq1**2*msq2**2*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (11*mglu*Xb*dlog(mu**2/msq1**2))/(8.*(msq1**2 - msq2**2)) - 
     -    (15*mglu**5*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (9*mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*msq1**4*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (13*mglu**3*Xb*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (3*mglu*msq1**2*Xb*dlog(mu**2/msq1**2))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) - 
     -    (mglu**8*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**5) + 
     -    (mglu**4*msq1**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)**5) - 
     -    (msq1**10*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**5) - 
     -    (mglu**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**4) - 
     -    (3*mglu**6*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)**4) + 
     -    (mglu**4*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)**4) + 
     -    (3*mglu**2*msq1**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (32.*(-mglu**2 + msq1**2)**4) - 
     -    (3*msq1**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**4) - 
     -    (23*mglu**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**3) - 
     -    (3*mglu**4*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**3) - 
     -    (7*mglu**2*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**3) + 
     -    (13*msq1**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**3) - 
     -    (51*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2) + 
     -    (25*mglu**2*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)**2) - 
     -    (9*msq1**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (64.*(-mglu**2 + msq1**2)**2) - 
     -    (7*mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (128.*(-mglu**2 + msq1**2)) + 
     -    (mglu**2*msq1**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (3*mglu*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(msq1**2 - msq2**2)) + 
     -    (mglu**5*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (5*mglu**5*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu**3*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq1**2))/
     -     ((-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (3*dlog(mu**2/msq1**2)**2)/64. + 
     -    (mglu**8*msq1**2*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**5) - 
     -    (mglu**4*msq1**6*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq1**2)**5) + 
     -    (msq1**10*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**5) - 
     -    (mglu**8*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**4) + 
     -    (mglu**6*msq1**2*dlog(mu**2/msq1**2)**2)/(16.*(-mglu**2 + msq1**2)**4) - 
     -    (mglu**4*msq1**4*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq1**2)**4) - 
     -    (mglu**2*msq1**6*dlog(mu**2/msq1**2)**2)/(16.*(-mglu**2 + msq1**2)**4) + 
     -    (3*msq1**8*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**4) - 
     -    (23*mglu**6*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**3) + 
     -    (15*mglu**4*msq1**2*dlog(mu**2/msq1**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**3) + 
     -    (51*mglu**2*msq1**4*dlog(mu**2/msq1**2)**2)/
     -     (128.*(-mglu**2 + msq1**2)**3) - 
     -    (25*msq1**6*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**3) + 
     -    (msq1**8*dlog(mu**2/msq1**2)**2)/(64.*mglu**2*(-mglu**2 + msq1**2)**3) - 
     -    (61*mglu**4*dlog(mu**2/msq1**2)**2)/(256.*(-mglu**2 + msq1**2)**2) - 
     -    (49*mglu**2*msq1**2*dlog(mu**2/msq1**2)**2)/
     -     (256.*(-mglu**2 + msq1**2)**2) + 
     -    (19*msq1**4*dlog(mu**2/msq1**2)**2)/(128.*(-mglu**2 + msq1**2)**2) - 
     -    (msq1**6*dlog(mu**2/msq1**2)**2)/(32.*mglu**2*(-mglu**2 + msq1**2)**2) - 
     -    (5*mglu**2*dlog(mu**2/msq1**2)**2)/(256.*(-mglu**2 + msq1**2)) - 
     -    (msq1**2*dlog(mu**2/msq1**2)**2)/(64.*(-mglu**2 + msq1**2)) + 
     -    (msq1**4*dlog(mu**2/msq1**2)**2)/(64.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (mglu**2*msq1**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (msq1**2*msq2**2*dlog(mu**2/msq1**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (3*mglu*Xb*dlog(mu**2/msq1**2)**2)/(8.*(msq1**2 - msq2**2)) - 
     -    (mglu**5*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**6*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (5*mglu**5*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (mglu**3*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (4.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*msq1**4*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (11*mglu**3*Xb*dlog(mu**2/msq1**2)**2)/
     -     (16.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*Xb*dlog(mu**2/msq1**2)**2)/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (3*dlog(mu**2/msq2**2))/64. - 
     -    (7*mglu**8*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (7*mglu**6*msq2**2*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (7*mglu**4*msq2**4*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (7*mglu**2*msq2**6*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (149*mglu**6*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**3) - 
     -    (3*mglu**4*msq2**2*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (89*mglu**2*msq2**4*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq2**2)**3) - 
     -    (13*msq2**6*dlog(mu**2/msq2**2))/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (3*msq2**8*dlog(mu**2/msq2**2))/(128.*mglu**2*(-mglu**2 + msq2**2)**3) - 
     -    (189*mglu**4*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**6*dlog(mu**2/msq2**2))/(64.*msq2**2*(-mglu**2 + msq2**2)**2) - 
     -    (25*mglu**2*msq2**2*dlog(mu**2/msq2**2))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (67*msq2**4*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (3*msq2**6*dlog(mu**2/msq2**2))/(64.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (39*mglu**2*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)) + 
     -    (mglu**4*dlog(mu**2/msq2**2))/(64.*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (63*msq2**2*dlog(mu**2/msq2**2))/(128.*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (msq1**2*msq2**2*dlog(mu**2/msq2**2))/
     -     (8.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (3*msq2**4*dlog(mu**2/msq2**2))/(128.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (11*mglu*Xb*dlog(mu**2/msq2**2))/(8.*(msq1**2 - msq2**2)) + 
     -    (15*mglu**5*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (9*mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*msq2**4*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (13*mglu**3*Xb*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (3*mglu*msq2**2*Xb*dlog(mu**2/msq2**2))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**8*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**5) + 
     -    (mglu**4*msq2**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq2**2)**5) - 
     -    (msq2**10*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**5) - 
     -    (mglu**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**4) - 
     -    (3*mglu**6*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq2**2)**4) + 
     -    (mglu**4*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq2**2)**4) + 
     -    (3*mglu**2*msq2**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (32.*(-mglu**2 + msq2**2)**4) - 
     -    (3*msq2**8*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**4) - 
     -    (23*mglu**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**3) - 
     -    (3*mglu**4*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**3) - 
     -    (7*mglu**2*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**3) + 
     -    (13*msq2**6*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**3) - 
     -    (51*mglu**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq2**2)**2) + 
     -    (25*mglu**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq2**2)**2) - 
     -    (9*msq2**4*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (64.*(-mglu**2 + msq2**2)**2) - 
     -    (7*mglu**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (128.*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq2**2*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (3*mglu*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)) - 
     -    (mglu**5*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (mglu*msq2**6*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**5*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu*msq2**4*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu**3*Xb*dlog(mu**2/mglu**2)*dlog(mu**2/msq2**2))/
     -     ((msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (msq1**2*msq2**2*dlog(mu**2/msq1**2)*dlog(mu**2/msq2**2))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (3*dlog(mu**2/msq2**2)**2)/64. + 
     -    (mglu**8*msq2**2*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**5) - 
     -    (mglu**4*msq2**6*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq2**2)**5) + 
     -    (msq2**10*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**5) - 
     -    (mglu**8*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**4) + 
     -    (mglu**6*msq2**2*dlog(mu**2/msq2**2)**2)/(16.*(-mglu**2 + msq2**2)**4) - 
     -    (mglu**4*msq2**4*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq2**2)**4) - 
     -    (mglu**2*msq2**6*dlog(mu**2/msq2**2)**2)/(16.*(-mglu**2 + msq2**2)**4) + 
     -    (3*msq2**8*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**4) - 
     -    (23*mglu**6*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**3) + 
     -    (15*mglu**4*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (128.*(-mglu**2 + msq2**2)**3) + 
     -    (51*mglu**2*msq2**4*dlog(mu**2/msq2**2)**2)/
     -     (128.*(-mglu**2 + msq2**2)**3) - 
     -    (25*msq2**6*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**3) + 
     -    (msq2**8*dlog(mu**2/msq2**2)**2)/(64.*mglu**2*(-mglu**2 + msq2**2)**3) - 
     -    (61*mglu**4*dlog(mu**2/msq2**2)**2)/(256.*(-mglu**2 + msq2**2)**2) - 
     -    (49*mglu**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (256.*(-mglu**2 + msq2**2)**2) + 
     -    (19*msq2**4*dlog(mu**2/msq2**2)**2)/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (msq2**6*dlog(mu**2/msq2**2)**2)/(32.*mglu**2*(-mglu**2 + msq2**2)**2) - 
     -    (5*mglu**2*dlog(mu**2/msq2**2)**2)/(256.*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*dlog(mu**2/msq2**2)**2)/(64.*(-mglu**2 + msq2**2)) + 
     -    (mglu**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (msq1**2*msq2**2*dlog(mu**2/msq2**2)**2)/
     -     (32.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (msq2**4*dlog(mu**2/msq2**2)**2)/(64.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (3*mglu*Xb*dlog(mu**2/msq2**2)**2)/(8.*(msq1**2 - msq2**2)) + 
     -    (mglu**5*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) - 
     -    (mglu*msq2**6*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (5*mglu**5*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**3*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (4.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*msq2**4*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (11*mglu**3*Xb*dlog(mu**2/msq2**2)**2)/
     -     (16.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq2**2*Xb*dlog(mu**2/msq2**2)**2)/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**8*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**5) + 
     -    (mglu**4*msq1**4*TfinZTMP(msq1,mglu,mu))/(32.*(-mglu**2 + msq1**2)**5) - 
     -    (msq1**8*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**5) - 
     -    (7*mglu**6*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (3*mglu**4*msq1**2*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**4) + 
     -    (7*mglu**2*msq1**4*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**4) - 
     -    (3*msq1**6*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**4) - 
     -    (9*mglu**4*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**3) - 
     -    (19*mglu**2*msq1**2*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**3) + 
     -    (25*msq1**4*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)**3) - 
     -    (msq1**6*TfinZTMP(msq1,mglu,mu))/(64.*mglu**2*(-mglu**2 + msq1**2)**3) + 
     -    (29*mglu**2*TfinZTMP(msq1,mglu,mu))/(128.*(-mglu**2 + msq1**2)**2) - 
     -    (mglu**4*TfinZTMP(msq1,mglu,mu))/(128.*msq1**2*(-mglu**2 + msq1**2)**2) - 
     -    (13*msq1**2*TfinZTMP(msq1,mglu,mu))/(32.*(-mglu**2 + msq1**2)**2) + 
     -    (msq1**4*TfinZTMP(msq1,mglu,mu))/(32.*mglu**2*(-mglu**2 + msq1**2)**2) + 
     -    (13*TfinZTMP(msq1,mglu,mu))/(64.*(-mglu**2 + msq1**2)) - 
     -    (mglu**2*TfinZTMP(msq1,mglu,mu))/(128.*msq1**2*(-mglu**2 + msq1**2)) - 
     -    (msq1**2*TfinZTMP(msq1,mglu,mu))/(64.*mglu**2*(-mglu**2 + msq1**2)) + 
     -    (msq1**2*TfinZTMP(msq1,mglu,mu))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (msq2**2*TfinZTMP(msq1,mglu,mu))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu**5*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (mglu*msq1**4*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)**3*(msq1**2 - msq2**2)) - 
     -    (mglu**3*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) + 
     -    (3*mglu*msq1**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)**2*(msq1**2 - msq2**2)) - 
     -    (mglu*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (2.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)) + 
     -    (mglu*msq1**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq2**2*Xb*TfinZTMP(msq1,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**8*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**5) + 
     -    (mglu**4*msq2**4*TfinZTMP(msq2,mglu,mu))/(32.*(-mglu**2 + msq2**2)**5) - 
     -    (msq2**8*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**5) - 
     -    (7*mglu**6*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (3*mglu**4*msq2**2*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**4) + 
     -    (7*mglu**2*msq2**4*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**4) - 
     -    (3*msq2**6*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**4) - 
     -    (9*mglu**4*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**3) - 
     -    (19*mglu**2*msq2**2*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**3) + 
     -    (25*msq2**4*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)**3) - 
     -    (msq2**6*TfinZTMP(msq2,mglu,mu))/(64.*mglu**2*(-mglu**2 + msq2**2)**3) + 
     -    (29*mglu**2*TfinZTMP(msq2,mglu,mu))/(128.*(-mglu**2 + msq2**2)**2) - 
     -    (mglu**4*TfinZTMP(msq2,mglu,mu))/(128.*msq2**2*(-mglu**2 + msq2**2)**2) - 
     -    (13*msq2**2*TfinZTMP(msq2,mglu,mu))/(32.*(-mglu**2 + msq2**2)**2) + 
     -    (msq2**4*TfinZTMP(msq2,mglu,mu))/(32.*mglu**2*(-mglu**2 + msq2**2)**2) + 
     -    (13*TfinZTMP(msq2,mglu,mu))/(64.*(-mglu**2 + msq2**2)) + 
     -    (msq1**2*TfinZTMP(msq2,mglu,mu))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**2*TfinZTMP(msq2,mglu,mu))/(128.*msq2**2*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*TfinZTMP(msq2,mglu,mu))/(64.*mglu**2*(-mglu**2 + msq2**2)) + 
     -    (msq2**2*TfinZTMP(msq2,mglu,mu))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu**5*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (mglu*msq2**4*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**3) + 
     -    (mglu**3*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) - 
     -    (3*mglu*msq2**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)**2) + 
     -    (mglu*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (2.*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq1**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq2**2*Xb*TfinZTMP(msq2,mglu,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) - 
     -    (msq1**2*TfinZTMP(msq2,msq1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (msq2**2*TfinZTMP(msq2,msq1,mu))/
     -     (16.*(-mglu**2 + msq1**2)*(-mglu**2 + msq2**2)) - 
     -    (mglu*msq1**2*Xb*TfinZTMP(msq2,msq1,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)) + 
     -    (mglu*msq2**2*Xb*TfinZTMP(msq2,msq1,mu))/
     -     (8.*(-mglu**2 + msq1**2)*(msq1**2 - msq2**2)*(-mglu**2 + msq2**2)))
     
        mssmzeta2lmb = 0d0
        do i=1,12
          mssmzeta2lmb = mssmzeta2lmb + mssmzetavec(i) 
        enddo
        
       return
       end