* =====================================================================
*  2-loop decoupling coefficient for alpha_s in MSSM (from Luminita Mihaila)
*
       function mssmzeta2l(mu,Mgl,Mt,Mst1,Mst2,Xt,Msb1,Msb2,Msq1,Msq2)
                
       implicit real*8 (a-h,k-z)
       implicit  integer(i)
       
       double precision mssmzeta2l

       data pi/3.14159265358979323846264338328d0/
       data z2/1.6449340668482264d0/
       data z3/1.2020569031595942d0/


c Strong Interaction: color factors
       nc        = 3.d0                          ! Number of Colors N_C
       cr        = (nc**2-1.d0)/(2.d0*nc)        ! Color Factor C_F
       ca        = nc

       Mq = 1d0
       inf=6                  ! Number of active quarks
       Nt=1.d0                ! Number of heavy quarks :e.g. top
       Nb=1.d0                ! Number of light quarks :e.g. bottom
       Nq=dfloat(inf)-Nt-Nb   ! Number of "massless" quarks:u,d,s,c

       mssmzeta2l =(
     &   -2d0*((dlog(mu**2/Mgl**2))/(2.d0) + 
     &   (Nq*dlog(mu**2/Msq1**2))/(24.d0)  +
     &   (Nq*dlog(mu**2/Msq2**2))/(24.d0) +
     &   (Nb*dlog(mu**2/Msb1**2))/(24.d0) +
     &   (Nb*dlog(mu**2/Msb2**2))/(24.d0) + 
     &   (Nt*dlog(mu**2/Mst1**2))/(24.d0) +
     &   (Nt*dlog(mu**2/Mst2**2))/(24.d0) +
     &   (Nt*dlog(mu**2/Mt**2))/(6.d0))**2 +

     &  Nb**2*(ln(mu,Msb1)**2./576.+(ln(mu,Msb1)*ln(mu,Msb2))/288.+

     &  ln(mu,Msb2)**2./576.)+

     &  Nb*((ln(mu,Msb1)*((Nt*ln(mu,Mst1))/288.+

     &  (Nt*ln(mu,Mst2))/288.+(Nt*ln(mu,Mt))/72.)+

     &  ln(mu,Msb2)*((Nt*ln(mu,Mst1))/288.+

     &  (Nt*ln(mu,Mst2))/288.+(Nt*ln(mu,Mt))/72.))+

     &  cR*((1745.*Mgl**8.*Msb1**4.+

     &  8104.*Mgl**6.*Msb1**4.*Msb2**2.+

     &  1745.*Mgl**8.*Msb2**4.+

     &  8104.*Mgl**6.*Msb1**2.*Msb2**4.+

     &  21438.*Mgl**4.*Msb1**4.*Msb2**4.-

     &  27424.*Mgl**2.*Msb1**6.*Msb2**4.+

     &  1752.*Msb1**8.*Msb2**4.-

     &  27424.*Mgl**2.*Msb1**4.*Msb2**6.+

     &  1752.*Msb1**4.*Msb2**8.-

     &  18432.*Mgl**4.*Msb1**4.*Msb2**4.*z2)/

     &  (331776.*Mgl**4.*Msb1**4.*Msb2**4.)+

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*B0fin(Msb1,Mgl,Mq,mu))/

     &  (48.*Msb1**2.)+

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*B0fin(Msb2,Mgl,Mq,mu))/

     &  (48.*Msb2**2.)-

     &  ((19.*Mgl**6.*Msb1**4.+37.*Mgl**4.*Msb1**4.*Msb2**2.+

     &  19.*Mgl**6.*Msb2**4.+

     &  37.*Mgl**4.*Msb1**2.*Msb2**4.+

     &  16.*Mgl**2.*Msb1**4.*Msb2**4.-

     &  24.*Msb1**6.*Msb2**4.-24.*Msb1**4.*Msb2**6.)*

     &  ln(mu,Mgl)**2.)/(4608.*Mgl**2.*Msb1**4.*Msb2**4.)-

     &  ((127.*Mgl**6.-1127.*Mgl**4.*Msb1**2.+

     &  120.*Mgl**2.*Msb1**4.-216.*Msb1**6.)*ln(mu,Msb1))/

     &  (9216.*Mgl**4.*Msb1**2.)-

     &  ((19.*Mgl**6.+101.*Mgl**4.*Msb1**2.-

     &  56.*Mgl**2.*Msb1**4.-24.*Msb1**6.)*ln(mu,Msb1)**2.)

     &  /(4608.*Mgl**4.*Msb1**2.)+

     &  Den(Msb1,Mgl)**2.*

     &  (-(2641.*Mgl**12.+708.*Mgl**10.*Msb1**2.+

     &  53249.*Mgl**8.*Msb1**4.-

     &  37836.*Mgl**6.*Msb1**6.-

     &  64466.*Mgl**4.*Msb1**8.-

     &  4084.*Mgl**2.*Msb1**10.+5388.*Msb1**12.+

     &  5652.*Mgl**10.*Msb1**2.*z2-

     &  5328.*Mgl**8.*Msb1**4.*z2+

     &  8604.*Mgl**6.*Msb1**6.*z2-

     &  20736.*Mgl**4.*Msb1**8.*z2+

     &  4320.*Mgl**2.*Msb1**10.*z2)/

     &  (82944.*Mgl**4.*Msb1**4.)+

     &  ((44.*Mgl**10.-101.*Mgl**8.*Msb1**2.+

     &  632.*Mgl**6.*Msb1**4.-967.*Mgl**4.*Msb1**6.+

     &  352.*Mgl**2.*Msb1**8.-72.*Msb1**10.)*

     &  ln(mu,Mgl)**2.)/(4608.*Mgl**2.*Msb1**4.)-

     &  ((501.*Mgl**10.+1648.*Mgl**8.*Msb1**2.-

     &  4737.*Mgl**6.*Msb1**4.-892.*Mgl**4.*Msb1**6.+

     &  2880.*Mgl**2.*Msb1**8.+72.*Msb1**10.)*

     &  ln(mu,Msb1))/(13824.*Mgl**4.*Msb1**2.)-

     &  ((113.*Mgl**10.-204.*Mgl**8.*Msb1**2.-

     &  245.*Mgl**6.*Msb1**4.+152.*Mgl**4.*Msb1**6.+

     &  344.*Mgl**2.*Msb1**8.-48.*Msb1**10.)*

     &  ln(mu,Msb1)**2.)/(4608.*Mgl**4.*Msb1**2.)+

     &  ln(mu,Mgl)*((138.*Mgl**10.+1349.*Mgl**8.*Msb1**2.-

     &  1494.*Mgl**6.*Msb1**4.-

     &  3041.*Mgl**4.*Msb1**6.+

     &  4128.*Mgl**2.*Msb1**8.-552.*Msb1**10.)/

     &  (13824.*Mgl**2.*Msb1**4.)-

     &  ((157.*Mgl**8.-148.*Mgl**6.*Msb1**2.+

     &  239.*Mgl**4.*Msb1**4.-

     &  576.*Mgl**2.*Msb1**6.+120.*Msb1**8.)*

     &  ln(mu,Msb1))/(2304.*Mgl**2.*Msb1**2.)))+

     &  Den(Msb1,Mgl)**4.*

     &  (((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (15155.*Mgl**14.-97849.*Mgl**12.*Msb1**2.+

     &  250638.*Mgl**10.*Msb1**4.-

     &  326678.*Mgl**8.*Msb1**6.+

     &  56739.*Mgl**6.*Msb1**8.+

     &  478843.*Mgl**4.*Msb1**10.-

     &  31860.*Mgl**2.*Msb1**12.-10332.*Msb1**14.+

     &  15912.*Mgl**12.*Msb1**2.*z2-

     &  38808.*Mgl**10.*Msb1**4.*z2+

     &  24120.*Mgl**8.*Msb1**6.*z2-

     &  35496.*Mgl**6.*Msb1**8.*z2+

     &  91584.*Mgl**4.*Msb1**10.*z2-

     &  9504.*Mgl**2.*Msb1**12.*z2))/

     &  (165888.*Mgl**4.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (74.*Mgl**12.-705.*Mgl**10.*Msb1**2.+

     &  2071.*Mgl**8.*Msb1**4.-3187.*Mgl**6.*Msb1**6.+

     &  3287.*Mgl**4.*Msb1**8.-936.*Mgl**2.*Msb1**10.+

     &  60.*Msb1**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**2.*(Mgl+Msb1)**2.*

     &  (60.*Mgl**10.+4365.*Mgl**8.*Msb1**2.-

     &  13828.*Mgl**6.*Msb1**4.+

     &  8575.*Mgl**4.*Msb1**6.+6936.*Mgl**2.*Msb1**8.-

     &  396.*Msb1**10.)*ln(mu,Msb1))/

     &  (13824.*Mgl**4.*Msb1**2.)+

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (147.*Mgl**12.-55.*Mgl**10.*Msb1**2.-

     &  1197.*Mgl**8.*Msb1**4.+2359.*Mgl**6.*Msb1**6.-

     &  1522.*Mgl**4.*Msb1**8.-468.*Mgl**2.*Msb1**10.+

     &  72.*Msb1**12.)*ln(mu,Msb1)**2.)/

     &  (4608.*Mgl**4.*Msb1**2.)+

     &  ln(mu,Mgl)*(((Mgl-1.*Msb1)**2.*(Mgl+Msb1)**2.*

     &  (249.*Mgl**10.-1046.*Mgl**8.*Msb1**2.+

     &  27.*Mgl**6.*Msb1**4.+

     &  6194.*Mgl**4.*Msb1**6.-

     &  15488.*Mgl**2.*Msb1**8.+504.*Msb1**10.))/

     &  (13824.*Mgl**2.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (221.*Mgl**10.-539.*Mgl**8.*Msb1**2.+

     &  335.*Mgl**6.*Msb1**4.-

     &  493.*Mgl**4.*Msb1**6.+

     &  1272.*Mgl**2.*Msb1**8.-132.*Msb1**10.)*

     &  ln(mu,Msb1))/(2304.*Mgl**2.*Msb1**2.)))+

     &  Den(Msb1,Mgl)**8.*

     &  (((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (3169.*Mgl**14.-120995.*Mgl**12.*Msb1**2.-

     &  7342.*Mgl**10.*Msb1**4.-

     &  474054.*Mgl**8.*Msb1**6.+

     &  182445.*Mgl**6.*Msb1**8.+

     &  227737.*Mgl**4.*Msb1**10.+

     &  21440.*Mgl**2.*Msb1**12.-1744.*Msb1**14.-

     &  13968.*Mgl**12.*Msb1**2.*z2-

     &  13392.*Mgl**10.*Msb1**4.*z2-

     &  59184.*Mgl**8.*Msb1**6.*z2+

     &  30672.*Mgl**6.*Msb1**8.*z2+

     &  25344.*Mgl**4.*Msb1**10.*z2+

     &  6336.*Mgl**2.*Msb1**12.*z2))/

     &  (331776.*Mgl**4.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (37.*Mgl**12.+15.*Mgl**10.*Msb1**2.+

     &  433.*Mgl**8.*Msb1**4.+245.*Mgl**6.*Msb1**6.-

     &  734.*Mgl**4.*Msb1**8.+144.*Mgl**2.*Msb1**10.+

     &  28.*Msb1**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)**6.*(Mgl+Msb1)**6.*

     &  (4059.*Mgl**10.+5105.*Mgl**8.*Msb1**2.+

     &  7753.*Mgl**6.*Msb1**4.-

     &  14205.*Mgl**4.*Msb1**6.-456.*Mgl**2.*Msb1**8.-

     &  432.*Msb1**10.)*ln(mu,Msb1))/

     &  (27648.*Mgl**4.*Msb1**2.)-

     &  ((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (60.*Mgl**12.-19.*Mgl**10.*Msb1**2.-

     &  115.*Mgl**8.*Msb1**4.-869.*Mgl**6.*Msb1**6.+

     &  771.*Mgl**4.*Msb1**8.-12.*Mgl**2.*Msb1**10.+

     &  16.*Msb1**12.)*ln(mu,Msb1)**2.)/

     &  (4608.*Mgl**4.*Msb1**2.)+

     &  ln(mu,Mgl)*(((Mgl-1.*Msb1)**6.*(Mgl+Msb1)**6.*

     &  (915.*Mgl**10.-2171.*Mgl**8.*Msb1**2.+

     &  13441.*Mgl**6.*Msb1**4.+

     &  3287.*Mgl**4.*Msb1**6.-

     &  12424.*Mgl**2.*Msb1**8.-2136.*Msb1**10.))/

     &  (27648.*Mgl**2.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (97.*Mgl**10.+93.*Mgl**8.*Msb1**2.+

     &  411.*Mgl**6.*Msb1**4.-

     &  213.*Mgl**4.*Msb1**6.-

     &  176.*Mgl**2.*Msb1**8.-44.*Msb1**10.)*

     &  ln(mu,Msb1))/(2304.*Mgl**2.*Msb1**2.)))+

     &  Den(Msb1,Mgl)**6.*

     &  (-((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (6165.*Mgl**14.-74795.*Mgl**12.*Msb1**2.+

     &  61509.*Mgl**10.*Msb1**4.-

     &  188357.*Mgl**8.*Msb1**6.+

     &  119422.*Mgl**6.*Msb1**8.+

     &  213572.*Mgl**4.*Msb1**10.-

     &  11872.*Mgl**2.*Msb1**12.-652.*Msb1**14.-

     &  1188.*Mgl**12.*Msb1**2.*z2-

     &  14076.*Mgl**10.*Msb1**4.*z2-

     &  9756.*Mgl**8.*Msb1**6.*z2+

     &  12348.*Mgl**6.*Msb1**8.*z2+

     &  29376.*Mgl**4.*Msb1**10.*z2+

     &  1152.*Mgl**2.*Msb1**12.*z2))/

     &  (82944.*Mgl**4.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (12.*Mgl**12.-595.*Mgl**10.*Msb1**2.+

     &  859.*Mgl**8.*Msb1**4.-1789.*Mgl**6.*Msb1**6.+

     &  2761.*Mgl**4.*Msb1**8.-736.*Mgl**2.*Msb1**10.-

     &  16.*Msb1**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**4.*(Mgl+Msb1)**4.*

     &  (2661.*Mgl**10.-508.*Mgl**8.*Msb1**2.+

     &  13839.*Mgl**6.*Msb1**4.-

     &  17792.*Mgl**4.*Msb1**6.-

     &  3456.*Mgl**2.*Msb1**8.-72.*Msb1**10.)*

     &  ln(mu,Msb1))/(13824.*Mgl**4.*Msb1**2.)+

     &  ((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (45.*Mgl**12.-237.*Mgl**10.*Msb1**2.+

     &  739.*Mgl**8.*Msb1**4.-2403.*Mgl**6.*Msb1**6.+

     &  2288.*Mgl**4.*Msb1**8.+48.*Mgl**2.*Msb1**10.+

     &  16.*Msb1**12.)*ln(mu,Msb1)**2.)/

     &  (4608.*Mgl**4.*Msb1**2.)+

     &  ln(mu,Mgl)*(-((Mgl-1.*Msb1)**4.*(Mgl+Msb1)**4.*

     &  (654.*Mgl**10.-535.*Mgl**8.*Msb1**2.+

     &  6494.*Mgl**6.*Msb1**4.+

     &  2851.*Mgl**4.*Msb1**6.-

     &  16864.*Mgl**2.*Msb1**8.-1176.*Msb1**10.))/

     &  (13824.*Mgl**2.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (33.*Mgl**10.+391.*Mgl**8.*Msb1**2.+

     &  271.*Mgl**6.*Msb1**4.-

     &  343.*Mgl**4.*Msb1**6.-

     &  816.*Mgl**2.*Msb1**8.-32.*Msb1**10.)*

     &  ln(mu,Msb1))/(2304.*Mgl**2.*Msb1**2.)))+

     &  ln(mu,Mgl)*(-(127.*Mgl**6.*Msb1**4.+

     &  281.*Mgl**4.*Msb1**4.*Msb2**2.+

     &  127.*Mgl**6.*Msb2**4.+

     &  281.*Mgl**4.*Msb1**2.*Msb2**4.-

     &  784.*Mgl**2.*Msb1**4.*Msb2**4.+

     &  40.*Msb1**6.*Msb2**4.+40.*Msb1**4.*Msb2**6.)/

     &  (9216.*Mgl**2.*Msb1**4.*Msb2**4.)-ln(mu,Msb1)/36.-

     &  ln(mu,Msb2)/36.)-

     &  ((127.*Mgl**6.-1127.*Mgl**4.*Msb2**2.+

     &  120.*Mgl**2.*Msb2**4.-216.*Msb2**6.)*ln(mu,Msb2))/

     &  (9216.*Mgl**4.*Msb2**2.)-

     &  ((19.*Mgl**6.+101.*Mgl**4.*Msb2**2.-

     &  56.*Mgl**2.*Msb2**4.-24.*Msb2**6.)*ln(mu,Msb2)**2.)

     &  /(4608.*Mgl**4.*Msb2**2.)+

     &  Den(Msb2,Mgl)**2.*

     &  (-(2641.*Mgl**12.+708.*Mgl**10.*Msb2**2.+

     &  53249.*Mgl**8.*Msb2**4.-

     &  37836.*Mgl**6.*Msb2**6.-

     &  64466.*Mgl**4.*Msb2**8.-

     &  4084.*Mgl**2.*Msb2**10.+5388.*Msb2**12.+

     &  5652.*Mgl**10.*Msb2**2.*z2-

     &  5328.*Mgl**8.*Msb2**4.*z2+

     &  8604.*Mgl**6.*Msb2**6.*z2-

     &  20736.*Mgl**4.*Msb2**8.*z2+

     &  4320.*Mgl**2.*Msb2**10.*z2)/

     &  (82944.*Mgl**4.*Msb2**4.)+

     &  ((44.*Mgl**10.-101.*Mgl**8.*Msb2**2.+

     &  632.*Mgl**6.*Msb2**4.-967.*Mgl**4.*Msb2**6.+

     &  352.*Mgl**2.*Msb2**8.-72.*Msb2**10.)*

     &  ln(mu,Mgl)**2.)/(4608.*Mgl**2.*Msb2**4.)-

     &  ((501.*Mgl**10.+1648.*Mgl**8.*Msb2**2.-

     &  4737.*Mgl**6.*Msb2**4.-892.*Mgl**4.*Msb2**6.+

     &  2880.*Mgl**2.*Msb2**8.+72.*Msb2**10.)*

     &  ln(mu,Msb2))/(13824.*Mgl**4.*Msb2**2.)-

     &  ((113.*Mgl**10.-204.*Mgl**8.*Msb2**2.-

     &  245.*Mgl**6.*Msb2**4.+152.*Mgl**4.*Msb2**6.+

     &  344.*Mgl**2.*Msb2**8.-48.*Msb2**10.)*

     &  ln(mu,Msb2)**2.)/(4608.*Mgl**4.*Msb2**2.)+

     &  ln(mu,Mgl)*((138.*Mgl**10.+1349.*Mgl**8.*Msb2**2.-

     &  1494.*Mgl**6.*Msb2**4.-

     &  3041.*Mgl**4.*Msb2**6.+

     &  4128.*Mgl**2.*Msb2**8.-552.*Msb2**10.)/

     &  (13824.*Mgl**2.*Msb2**4.)-

     &  ((157.*Mgl**8.-148.*Mgl**6.*Msb2**2.+

     &  239.*Mgl**4.*Msb2**4.-

     &  576.*Mgl**2.*Msb2**6.+120.*Msb2**8.)*

     &  ln(mu,Msb2))/(2304.*Mgl**2.*Msb2**2.)))+

     &  Den(Msb2,Mgl)**4.*

     &  (((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (15155.*Mgl**14.-97849.*Mgl**12.*Msb2**2.+

     &  250638.*Mgl**10.*Msb2**4.-

     &  326678.*Mgl**8.*Msb2**6.+

     &  56739.*Mgl**6.*Msb2**8.+

     &  478843.*Mgl**4.*Msb2**10.-

     &  31860.*Mgl**2.*Msb2**12.-10332.*Msb2**14.+

     &  15912.*Mgl**12.*Msb2**2.*z2-

     &  38808.*Mgl**10.*Msb2**4.*z2+

     &  24120.*Mgl**8.*Msb2**6.*z2-

     &  35496.*Mgl**6.*Msb2**8.*z2+

     &  91584.*Mgl**4.*Msb2**10.*z2-

     &  9504.*Mgl**2.*Msb2**12.*z2))/

     &  (165888.*Mgl**4.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (74.*Mgl**12.-705.*Mgl**10.*Msb2**2.+

     &  2071.*Mgl**8.*Msb2**4.-3187.*Mgl**6.*Msb2**6.+

     &  3287.*Mgl**4.*Msb2**8.-936.*Mgl**2.*Msb2**10.+

     &  60.*Msb2**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**2.*(Mgl+Msb2)**2.*

     &  (60.*Mgl**10.+4365.*Mgl**8.*Msb2**2.-

     &  13828.*Mgl**6.*Msb2**4.+

     &  8575.*Mgl**4.*Msb2**6.+6936.*Mgl**2.*Msb2**8.-

     &  396.*Msb2**10.)*ln(mu,Msb2))/

     &  (13824.*Mgl**4.*Msb2**2.)+

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (147.*Mgl**12.-55.*Mgl**10.*Msb2**2.-

     &  1197.*Mgl**8.*Msb2**4.+2359.*Mgl**6.*Msb2**6.-

     &  1522.*Mgl**4.*Msb2**8.-468.*Mgl**2.*Msb2**10.+

     &  72.*Msb2**12.)*ln(mu,Msb2)**2.)/

     &  (4608.*Mgl**4.*Msb2**2.)+

     &  ln(mu,Mgl)*(((Mgl-1.*Msb2)**2.*(Mgl+Msb2)**2.*

     &  (249.*Mgl**10.-1046.*Mgl**8.*Msb2**2.+

     &  27.*Mgl**6.*Msb2**4.+

     &  6194.*Mgl**4.*Msb2**6.-

     &  15488.*Mgl**2.*Msb2**8.+504.*Msb2**10.))/

     &  (13824.*Mgl**2.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (221.*Mgl**10.-539.*Mgl**8.*Msb2**2.+

     &  335.*Mgl**6.*Msb2**4.-

     &  493.*Mgl**4.*Msb2**6.+

     &  1272.*Mgl**2.*Msb2**8.-132.*Msb2**10.)*

     &  ln(mu,Msb2))/(2304.*Mgl**2.*Msb2**2.)))+

     &  Den(Msb2,Mgl)**8.*

     &  (((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (3169.*Mgl**14.-120995.*Mgl**12.*Msb2**2.-

     &  7342.*Mgl**10.*Msb2**4.-

     &  474054.*Mgl**8.*Msb2**6.+

     &  182445.*Mgl**6.*Msb2**8.+

     &  227737.*Mgl**4.*Msb2**10.+

     &  21440.*Mgl**2.*Msb2**12.-1744.*Msb2**14.-

     &  13968.*Mgl**12.*Msb2**2.*z2-

     &  13392.*Mgl**10.*Msb2**4.*z2-

     &  59184.*Mgl**8.*Msb2**6.*z2+

     &  30672.*Mgl**6.*Msb2**8.*z2+

     &  25344.*Mgl**4.*Msb2**10.*z2+

     &  6336.*Mgl**2.*Msb2**12.*z2))/

     &  (331776.*Mgl**4.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (37.*Mgl**12.+15.*Mgl**10.*Msb2**2.+

     &  433.*Mgl**8.*Msb2**4.+245.*Mgl**6.*Msb2**6.-

     &  734.*Mgl**4.*Msb2**8.+144.*Mgl**2.*Msb2**10.+

     &  28.*Msb2**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)**6.*(Mgl+Msb2)**6.*

     &  (4059.*Mgl**10.+5105.*Mgl**8.*Msb2**2.+

     &  7753.*Mgl**6.*Msb2**4.-

     &  14205.*Mgl**4.*Msb2**6.-456.*Mgl**2.*Msb2**8.-

     &  432.*Msb2**10.)*ln(mu,Msb2))/

     &  (27648.*Mgl**4.*Msb2**2.)-

     &  ((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (60.*Mgl**12.-19.*Mgl**10.*Msb2**2.-

     &  115.*Mgl**8.*Msb2**4.-869.*Mgl**6.*Msb2**6.+

     &  771.*Mgl**4.*Msb2**8.-12.*Mgl**2.*Msb2**10.+

     &  16.*Msb2**12.)*ln(mu,Msb2)**2.)/

     &  (4608.*Mgl**4.*Msb2**2.)+

     &  ln(mu,Mgl)*(((Mgl-1.*Msb2)**6.*(Mgl+Msb2)**6.*

     &  (915.*Mgl**10.-2171.*Mgl**8.*Msb2**2.+

     &  13441.*Mgl**6.*Msb2**4.+

     &  3287.*Mgl**4.*Msb2**6.-

     &  12424.*Mgl**2.*Msb2**8.-2136.*Msb2**10.))/

     &  (27648.*Mgl**2.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (97.*Mgl**10.+93.*Mgl**8.*Msb2**2.+

     &  411.*Mgl**6.*Msb2**4.-

     &  213.*Mgl**4.*Msb2**6.-

     &  176.*Mgl**2.*Msb2**8.-44.*Msb2**10.)*

     &  ln(mu,Msb2))/(2304.*Mgl**2.*Msb2**2.)))+

     &  Den(Msb2,Mgl)**6.*

     &  (-((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (6165.*Mgl**14.-74795.*Mgl**12.*Msb2**2.+

     &  61509.*Mgl**10.*Msb2**4.-

     &  188357.*Mgl**8.*Msb2**6.+

     &  119422.*Mgl**6.*Msb2**8.+

     &  213572.*Mgl**4.*Msb2**10.-

     &  11872.*Mgl**2.*Msb2**12.-652.*Msb2**14.-

     &  1188.*Mgl**12.*Msb2**2.*z2-

     &  14076.*Mgl**10.*Msb2**4.*z2-

     &  9756.*Mgl**8.*Msb2**6.*z2+

     &  12348.*Mgl**6.*Msb2**8.*z2+

     &  29376.*Mgl**4.*Msb2**10.*z2+

     &  1152.*Mgl**2.*Msb2**12.*z2))/

     &  (82944.*Mgl**4.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (12.*Mgl**12.-595.*Mgl**10.*Msb2**2.+

     &  859.*Mgl**8.*Msb2**4.-1789.*Mgl**6.*Msb2**6.+

     &  2761.*Mgl**4.*Msb2**8.-736.*Mgl**2.*Msb2**10.-

     &  16.*Msb2**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**4.*(Mgl+Msb2)**4.*

     &  (2661.*Mgl**10.-508.*Mgl**8.*Msb2**2.+

     &  13839.*Mgl**6.*Msb2**4.-

     &  17792.*Mgl**4.*Msb2**6.-

     &  3456.*Mgl**2.*Msb2**8.-72.*Msb2**10.)*

     &  ln(mu,Msb2))/(13824.*Mgl**4.*Msb2**2.)+

     &  ((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (45.*Mgl**12.-237.*Mgl**10.*Msb2**2.+

     &  739.*Mgl**8.*Msb2**4.-2403.*Mgl**6.*Msb2**6.+

     &  2288.*Mgl**4.*Msb2**8.+48.*Mgl**2.*Msb2**10.+

     &  16.*Msb2**12.)*ln(mu,Msb2)**2.)/

     &  (4608.*Mgl**4.*Msb2**2.)+

     &  ln(mu,Mgl)*(-((Mgl-1.*Msb2)**4.*(Mgl+Msb2)**4.*

     &  (654.*Mgl**10.-535.*Mgl**8.*Msb2**2.+

     &  6494.*Mgl**6.*Msb2**4.+

     &  2851.*Mgl**4.*Msb2**6.-

     &  16864.*Mgl**2.*Msb2**8.-1176.*Msb2**10.))/

     &  (13824.*Mgl**2.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (33.*Mgl**10.+391.*Mgl**8.*Msb2**2.+

     &  271.*Mgl**6.*Msb2**4.-

     &  343.*Mgl**4.*Msb2**6.-

     &  816.*Mgl**2.*Msb2**8.-32.*Msb2**10.)*

     &  ln(mu,Msb2))/(2304.*Mgl**2.*Msb2**2.)))+

     &  ((19.*Mgl**6.+37.*Mgl**4.*Msb1**2.-

     &  56.*Mgl**2.*Msb1**4.-24.*Msb1**6.)/

     &  (4608.*Mgl**4.*Msb1**4.)-

     &  ((11.*Mgl**10.+14.*Mgl**8.*Msb1**2.+

     &  121.*Mgl**6.*Msb1**4.-182.*Mgl**4.*Msb1**6.-

     &  56.*Mgl**2.*Msb1**8.+12.*Msb1**10.)*

     &  Den(Msb1,Mgl)**2.)/(1152.*Mgl**4.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (37.*Mgl**12.-242.*Mgl**10.*Msb1**2.+

     &  766.*Mgl**8.*Msb1**4.-1426.*Mgl**6.*Msb1**6.+

     &  1397.*Mgl**4.*Msb1**8.+168.*Mgl**2.*Msb1**10.-

     &  36.*Msb1**12.)*Den(Msb1,Mgl)**4.)/

     &  (2304.*Mgl**4.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (3.*Mgl**12.-157.*Mgl**10.*Msb1**2.+

     &  117.*Mgl**8.*Msb1**4.-515.*Mgl**6.*Msb1**6.+

     &  776.*Mgl**4.*Msb1**8.+20.*Mgl**2.*Msb1**10.+

     &  4.*Msb1**12.)*Den(Msb1,Mgl)**6.)/

     &  (1152.*Mgl**4.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (37.*Mgl**12.+112.*Mgl**10.*Msb1**2.+

     &  526.*Mgl**8.*Msb1**4.+656.*Mgl**6.*Msb1**6.-

     &  947.*Mgl**4.*Msb1**8.-32.*Mgl**2.*Msb1**10.-

     &  16.*Msb1**12.)*Den(Msb1,Mgl)**8.)/

     &  (4608.*Mgl**4.*Msb1**4.))*Tfin0(Msb1,Mgl)+

     &  ((19.*Mgl**6.+37.*Mgl**4.*Msb2**2.-

     &  56.*Mgl**2.*Msb2**4.-24.*Msb2**6.)/

     &  (4608.*Mgl**4.*Msb2**4.)-

     &  ((11.*Mgl**10.+14.*Mgl**8.*Msb2**2.+

     &  121.*Mgl**6.*Msb2**4.-182.*Mgl**4.*Msb2**6.-

     &  56.*Mgl**2.*Msb2**8.+12.*Msb2**10.)*

     &  Den(Msb2,Mgl)**2.)/(1152.*Mgl**4.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (37.*Mgl**12.-242.*Mgl**10.*Msb2**2.+

     &  766.*Mgl**8.*Msb2**4.-1426.*Mgl**6.*Msb2**6.+

     &  1397.*Mgl**4.*Msb2**8.+168.*Mgl**2.*Msb2**10.-

     &  36.*Msb2**12.)*Den(Msb2,Mgl)**4.)/

     &  (2304.*Mgl**4.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (3.*Mgl**12.-157.*Mgl**10.*Msb2**2.+

     &  117.*Mgl**8.*Msb2**4.-515.*Mgl**6.*Msb2**6.+

     &  776.*Mgl**4.*Msb2**8.+20.*Mgl**2.*Msb2**10.+

     &  4.*Msb2**12.)*Den(Msb2,Mgl)**6.)/

     &  (1152.*Mgl**4.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (37.*Mgl**12.+112.*Mgl**10.*Msb2**2.+

     &  526.*Mgl**8.*Msb2**4.+656.*Mgl**6.*Msb2**6.-

     &  947.*Mgl**4.*Msb2**8.-32.*Mgl**2.*Msb2**10.-

     &  16.*Msb2**12.)*Den(Msb2,Mgl)**8.)/

     &  (4608.*Mgl**4.*Msb2**4.))*Tfin0(Msb2,Mgl))+

     &  cA*

     &  ((672.*Mgl**6.*Msb1**2.+672.*Mgl**6.*Msb2**2.+

     &  18910.*Mgl**4.*Msb1**2.*Msb2**2.+

     &  13104.*Mgl**2.*Msb1**4.*Msb2**2.+

     &  3937.*Msb1**6.*Msb2**2.+

     &  13104.*Mgl**2.*Msb1**2.*Msb2**4.+

     &  3937.*Msb1**2.*Msb2**6.+

     &  13824.*Mgl**4.*Msb1**2.*Msb2**2.*z2)/

     &  (331776.*Mgl**4.*Msb1**2.*Msb2**2.)-

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*B0fin(Mgl,Mq,Msb1,mu))/

     &  (24.*Mgl**2.)-((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  B0fin(Mgl,Mq,Msb2,mu))/(24.*Mgl**2.)-

     &  ((26.*Mgl**2.+35.*Msb1**2.+35.*Msb2**2.)*

     &  ln(mu,Mgl)**2.)/(4608.*Mgl**2.)+

     &  ((16.*Mgl**6.+272.*Mgl**4.*Msb1**2.-

     &  113.*Mgl**2.*Msb1**4.-223.*Msb1**6.)*ln(mu,Msb1))/

     &  (9216.*Mgl**4.*Msb1**2.)+

     &  ((48.*Mgl**4.-61.*Mgl**2.*Msb1**2.-35.*Msb1**4.)*

     &  ln(mu,Msb1)**2.)/(4608.*Mgl**4.)+

     &  Den(Msb1,Mgl)**2.*

     &  ((-516.*Mgl**10.+3151.*Mgl**8.*Msb1**2.+

     &  25605.*Mgl**6.*Msb1**4.-18828.*Mgl**4.*Msb1**6.-

     &  7493.*Mgl**2.*Msb1**8.+3473.*Msb1**10.+

     &  360.*Mgl**10.*z2-3672.*Mgl**8.*Msb1**2.*z2+

     &  14652.*Mgl**6.*Msb1**4.*z2-

     &  13752.*Mgl**4.*Msb1**6.*z2+

     &  3564.*Mgl**2.*Msb1**8.*z2)/(82944.*Mgl**4.*Msb1**2.)

     &  +((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (42.*Mgl**6.-256.*Mgl**4.*Msb1**2.+

     &  123.*Mgl**2.*Msb1**4.-71.*Msb1**6.)*

     &  ln(mu,Mgl)**2.)/(4608.*Mgl**2.*Msb1**2.)+

     &  ((246.*Mgl**10.-646.*Mgl**8.*Msb1**2.+

     &  1727.*Mgl**6.*Msb1**4.-2112.*Mgl**4.*Msb1**6.+

     &  651.*Mgl**2.*Msb1**8.+310.*Msb1**10.)*

     &  ln(mu,Msb1))/(13824.*Mgl**4.*Msb1**2.)+

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (10.*Mgl**8.-60.*Mgl**6.*Msb1**2.+

     &  151.*Mgl**4.*Msb1**4.-259.*Mgl**2.*Msb1**6.+

     &  28.*Msb1**8.)*ln(mu,Msb1)**2.)/

     &  (4608.*Mgl**4.*Msb1**2.)+

     &  ln(mu,Mgl)*((50.*Mgl**8.-1504.*Mgl**6.*Msb1**2.+

     &  2471.*Mgl**4.*Msb1**4.-

     &  1208.*Mgl**2.*Msb1**6.+367.*Msb1**8.)/

     &  (13824.*Mgl**2.*Msb1**2.)+

     &  ((10.*Mgl**8.-102.*Mgl**6.*Msb1**2.+

     &  407.*Mgl**4.*Msb1**4.-

     &  382.*Mgl**2.*Msb1**6.+99.*Msb1**8.)*

     &  ln(mu,Msb1))/(2304.*Mgl**2.*Msb1**2.)))+

     &  Den(Msb1,Mgl)**4.*

     &  (((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (32.*Mgl**14.+4430.*Mgl**12.*Msb1**2.-

     &  461.*Mgl**10.*Msb1**4.-9785.*Mgl**8.*Msb1**6.+

     &  101326.*Mgl**6.*Msb1**8.-

     &  111544.*Mgl**4.*Msb1**10.-

     &  6225.*Mgl**2.*Msb1**12.+10131.*Msb1**14.-

     &  144.*Mgl**12.*Msb1**2.*z2+

     &  8352.*Mgl**10.*Msb1**4.*z2-

     &  20376.*Mgl**8.*Msb1**6.*z2+

     &  41832.*Mgl**6.*Msb1**8.*z2-

     &  39672.*Mgl**4.*Msb1**10.*z2+

     &  8280.*Mgl**2.*Msb1**12.*z2))/

     &  (165888.*Mgl**4.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (8.*Mgl**12.+30.*Mgl**10.*Msb1**2.-

     &  222.*Mgl**8.*Msb1**4.+707.*Mgl**6.*Msb1**6.-

     &  765.*Mgl**4.*Msb1**8.+267.*Mgl**2.*Msb1**10.-

     &  49.*Msb1**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**2.*(Mgl+Msb1)**2.*

     &  (138.*Mgl**10.+1512.*Mgl**8.*Msb1**2.-

     &  1018.*Mgl**6.*Msb1**4.+805.*Mgl**4.*Msb1**6.-

     &  2908.*Mgl**2.*Msb1**8.+95.*Msb1**10.)*

     &  ln(mu,Msb1))/(13824.*Mgl**4.*Msb1**2.)-

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (10.*Mgl**12.-88.*Mgl**10.*Msb1**2.+

     &  177.*Mgl**8.*Msb1**4.-157.*Mgl**6.*Msb1**6.+

     &  367.*Mgl**4.*Msb1**8.-399.*Mgl**2.*Msb1**10.+

     &  66.*Msb1**12.)*ln(mu,Msb1)**2.)/

     &  (4608.*Mgl**4.*Msb1**2.)+

     &  ln(mu,Mgl)*(-((Mgl-1.*Msb1)**2.*(Mgl+Msb1)**2.*

     &  (96.*Mgl**10.+80.*Mgl**8.*Msb1**2.-

     &  755.*Mgl**6.*Msb1**4.+

     &  4438.*Mgl**4.*Msb1**6.-

     &  3581.*Mgl**2.*Msb1**8.+162.*Msb1**10.))/

     &  (13824.*Mgl**2.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (2.*Mgl**10.-116.*Mgl**8.*Msb1**2.+

     &  283.*Mgl**6.*Msb1**4.-

     &  581.*Mgl**4.*Msb1**6.+

     &  551.*Mgl**2.*Msb1**8.-115.*Msb1**10.)*

     &  ln(mu,Msb1))/(2304.*Mgl**2.*Msb1**2.)))+

     &  Den(Msb1,Mgl)**8.*

     &  (((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (192.*Mgl**14.+35812.*Mgl**12.*Msb1**2.+

     &  95515.*Mgl**10.*Msb1**4.+

     &  128759.*Mgl**8.*Msb1**6.-

     &  142594.*Mgl**6.*Msb1**8.-

     &  109238.*Mgl**4.*Msb1**10.-

     &  33529.*Mgl**2.*Msb1**12.+891.*Msb1**14.+

     &  8064.*Mgl**12.*Msb1**2.*z2+

     &  10944.*Mgl**10.*Msb1**4.*z2+

     &  18864.*Mgl**8.*Msb1**6.*z2-

     &  19152.*Mgl**6.*Msb1**8.*z2-

     &  15984.*Mgl**4.*Msb1**10.*z2-

     &  6192.*Mgl**2.*Msb1**12.*z2))/

     &  (331776.*Mgl**4.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (24.*Mgl**12.-28.*Mgl**10.*Msb1**2.+

     &  409.*Mgl**8.*Msb1**4.-247.*Mgl**6.*Msb1**6.-

     &  249.*Mgl**4.*Msb1**8.+39.*Mgl**2.*Msb1**10.+

     &  28.*Msb1**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**6.*(Mgl+Msb1)**6.*

     &  (2160.*Mgl**10.+5932.*Mgl**8.*Msb1**2.-

     &  197.*Mgl**6.*Msb1**4.-6223.*Mgl**4.*Msb1**6.-

     &  343.*Mgl**2.*Msb1**8.-385.*Msb1**10.)*

     &  ln(mu,Msb1))/(27648.*Mgl**4.*Msb1**2.)+

     &  ((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (32.*Mgl**12.+48.*Mgl**10.*Msb1**2.-

     &  354.*Mgl**8.*Msb1**4.-17.*Mgl**6.*Msb1**6.+

     &  271.*Mgl**4.*Msb1**8.+29.*Mgl**2.*Msb1**10.+

     &  15.*Msb1**12.)*ln(mu,Msb1)**2.)/

     &  (4608.*Mgl**4.*Msb1**2.)+

     &  ln(mu,Mgl)*(-((Mgl-1.*Msb1)**6.*(Mgl+Msb1)**6.*

     &  (576.*Mgl**10.-316.*Mgl**8.*Msb1**2.+

     &  6623.*Mgl**6.*Msb1**4.-

     &  343.*Mgl**4.*Msb1**6.-

     &  5899.*Mgl**2.*Msb1**8.-1921.*Msb1**10.))/

     &  (27648.*Mgl**2.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (56.*Mgl**10.+76.*Mgl**8.*Msb1**2.+

     &  131.*Mgl**6.*Msb1**4.-

     &  133.*Mgl**4.*Msb1**6.-

     &  111.*Mgl**2.*Msb1**8.-43.*Msb1**10.)*

     &  ln(mu,Msb1))/(2304.*Mgl**2.*Msb1**2.)))+

     &  Den(Msb1,Mgl)**6.*

     &  (-((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (64.*Mgl**14.+10820.*Mgl**12.*Msb1**2.+

     &  30615.*Mgl**10.*Msb1**4.+

     &  45576.*Mgl**8.*Msb1**6.-

     &  37387.*Mgl**6.*Msb1**8.-

     &  58307.*Mgl**4.*Msb1**10.-

     &  4308.*Mgl**2.*Msb1**12.+831.*Msb1**14.+

     &  2304.*Mgl**12.*Msb1**2.*z2+

     &  4608.*Mgl**10.*Msb1**4.*z2+

     &  7668.*Mgl**8.*Msb1**6.*z2-

     &  7092.*Mgl**6.*Msb1**8.*z2-

     &  8244.*Mgl**4.*Msb1**10.*z2-

     &  972.*Mgl**2.*Msb1**12.*z2))/

     &  (82944.*Mgl**4.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (32.*Mgl**12.-40.*Mgl**10.*Msb1**2.+

     &  540.*Mgl**8.*Msb1**4.-221.*Mgl**6.*Msb1**6.-

     &  507.*Mgl**4.*Msb1**8.+133.*Mgl**2.*Msb1**10.+

     &  15.*Msb1**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)**4.*(Mgl+Msb1)**4.*

     &  (1488.*Mgl**10.+3904.*Mgl**8.*Msb1**2.+

     &  513.*Mgl**6.*Msb1**4.-5158.*Mgl**4.*Msb1**6.-

     &  1353.*Mgl**2.*Msb1**8.-122.*Msb1**10.)*

     &  ln(mu,Msb1))/(13824.*Mgl**4.*Msb1**2.)-

     &  ((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (32.*Mgl**12.+104.*Mgl**10.*Msb1**2.-

     &  455.*Mgl**8.*Msb1**4.-189.*Mgl**6.*Msb1**6.+

     &  475.*Mgl**4.*Msb1**8.+69.*Mgl**2.*Msb1**10.+

     &  12.*Msb1**12.)*ln(mu,Msb1)**2.)/

     &  (4608.*Mgl**4.*Msb1**2.)+

     &  ln(mu,Mgl)*(((Mgl-1.*Msb1)**4.*(Mgl+Msb1)**4.*

     &  (384.*Mgl**10.-152.*Mgl**8.*Msb1**2.+

     &  4206.*Mgl**6.*Msb1**4.+

     &  1287.*Mgl**4.*Msb1**6.-

     &  4934.*Mgl**2.*Msb1**8.-1167.*Msb1**10.))/

     &  (13824.*Mgl**2.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (64.*Mgl**10.+128.*Mgl**8.*Msb1**2.+

     &  213.*Mgl**6.*Msb1**4.-

     &  197.*Mgl**4.*Msb1**6.-

     &  229.*Mgl**2.*Msb1**8.-27.*Msb1**10.)*

     &  ln(mu,Msb1))/(2304.*Mgl**2.*Msb1**2.)))+

     &  ln(mu,Mgl)*((16.*Mgl**4.*Msb1**2.+

     &  16.*Mgl**4.*Msb2**2.-

     &  514.*Mgl**2.*Msb1**2.*Msb2**2.+

     &  Msb1**4.*Msb2**2.+Msb1**2.*Msb2**4.)/

     &  (9216.*Mgl**2.*Msb1**2.*Msb2**2.)+

     &  (5*ln(mu,Msb1))/144.+(5*ln(mu,Msb2))/144.)+

     &  ((16.*Mgl**6.+272.*Mgl**4.*Msb2**2.-

     &  113.*Mgl**2.*Msb2**4.-223.*Msb2**6.)*ln(mu,Msb2))/

     &  (9216.*Mgl**4.*Msb2**2.)+

     &  ((48.*Mgl**4.-61.*Mgl**2.*Msb2**2.-35.*Msb2**4.)*

     &  ln(mu,Msb2)**2.)/(4608.*Mgl**4.)+

     &  Den(Msb2,Mgl)**2.*

     &  ((-516.*Mgl**10.+3151.*Mgl**8.*Msb2**2.+

     &  25605.*Mgl**6.*Msb2**4.-18828.*Mgl**4.*Msb2**6.-

     &  7493.*Mgl**2.*Msb2**8.+3473.*Msb2**10.+

     &  360.*Mgl**10.*z2-3672.*Mgl**8.*Msb2**2.*z2+

     &  14652.*Mgl**6.*Msb2**4.*z2-

     &  13752.*Mgl**4.*Msb2**6.*z2+

     &  3564.*Mgl**2.*Msb2**8.*z2)/(82944.*Mgl**4.*Msb2**2.)

     &  +((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (42.*Mgl**6.-256.*Mgl**4.*Msb2**2.+

     &  123.*Mgl**2.*Msb2**4.-71.*Msb2**6.)*

     &  ln(mu,Mgl)**2.)/(4608.*Mgl**2.*Msb2**2.)+

     &  ((246.*Mgl**10.-646.*Mgl**8.*Msb2**2.+

     &  1727.*Mgl**6.*Msb2**4.-2112.*Mgl**4.*Msb2**6.+

     &  651.*Mgl**2.*Msb2**8.+310.*Msb2**10.)*

     &  ln(mu,Msb2))/(13824.*Mgl**4.*Msb2**2.)+

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (10.*Mgl**8.-60.*Mgl**6.*Msb2**2.+

     &  151.*Mgl**4.*Msb2**4.-259.*Mgl**2.*Msb2**6.+

     &  28.*Msb2**8.)*ln(mu,Msb2)**2.)/

     &  (4608.*Mgl**4.*Msb2**2.)+

     &  ln(mu,Mgl)*((50.*Mgl**8.-1504.*Mgl**6.*Msb2**2.+

     &  2471.*Mgl**4.*Msb2**4.-

     &  1208.*Mgl**2.*Msb2**6.+367.*Msb2**8.)/

     &  (13824.*Mgl**2.*Msb2**2.)+

     &  ((10.*Mgl**8.-102.*Mgl**6.*Msb2**2.+

     &  407.*Mgl**4.*Msb2**4.-

     &  382.*Mgl**2.*Msb2**6.+99.*Msb2**8.)*

     &  ln(mu,Msb2))/(2304.*Mgl**2.*Msb2**2.)))+

     &  Den(Msb2,Mgl)**4.*

     &  (((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (32.*Mgl**14.+4430.*Mgl**12.*Msb2**2.-

     &  461.*Mgl**10.*Msb2**4.-9785.*Mgl**8.*Msb2**6.+

     &  101326.*Mgl**6.*Msb2**8.-

     &  111544.*Mgl**4.*Msb2**10.-

     &  6225.*Mgl**2.*Msb2**12.+10131.*Msb2**14.-

     &  144.*Mgl**12.*Msb2**2.*z2+

     &  8352.*Mgl**10.*Msb2**4.*z2-

     &  20376.*Mgl**8.*Msb2**6.*z2+

     &  41832.*Mgl**6.*Msb2**8.*z2-

     &  39672.*Mgl**4.*Msb2**10.*z2+

     &  8280.*Mgl**2.*Msb2**12.*z2))/

     &  (165888.*Mgl**4.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (8.*Mgl**12.+30.*Mgl**10.*Msb2**2.-

     &  222.*Mgl**8.*Msb2**4.+707.*Mgl**6.*Msb2**6.-

     &  765.*Mgl**4.*Msb2**8.+267.*Mgl**2.*Msb2**10.-

     &  49.*Msb2**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**2.*(Mgl+Msb2)**2.*

     &  (138.*Mgl**10.+1512.*Mgl**8.*Msb2**2.-

     &  1018.*Mgl**6.*Msb2**4.+805.*Mgl**4.*Msb2**6.-

     &  2908.*Mgl**2.*Msb2**8.+95.*Msb2**10.)*

     &  ln(mu,Msb2))/(13824.*Mgl**4.*Msb2**2.)-

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (10.*Mgl**12.-88.*Mgl**10.*Msb2**2.+

     &  177.*Mgl**8.*Msb2**4.-157.*Mgl**6.*Msb2**6.+

     &  367.*Mgl**4.*Msb2**8.-399.*Mgl**2.*Msb2**10.+

     &  66.*Msb2**12.)*ln(mu,Msb2)**2.)/

     &  (4608.*Mgl**4.*Msb2**2.)+

     &  ln(mu,Mgl)*(-((Mgl-1.*Msb2)**2.*(Mgl+Msb2)**2.*

     &  (96.*Mgl**10.+80.*Mgl**8.*Msb2**2.-

     &  755.*Mgl**6.*Msb2**4.+

     &  4438.*Mgl**4.*Msb2**6.-

     &  3581.*Mgl**2.*Msb2**8.+162.*Msb2**10.))/

     &  (13824.*Mgl**2.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (2.*Mgl**10.-116.*Mgl**8.*Msb2**2.+

     &  283.*Mgl**6.*Msb2**4.-

     &  581.*Mgl**4.*Msb2**6.+

     &  551.*Mgl**2.*Msb2**8.-115.*Msb2**10.)*

     &  ln(mu,Msb2))/(2304.*Mgl**2.*Msb2**2.)))+

     &  Den(Msb2,Mgl)**8.*

     &  (((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (192.*Mgl**14.+35812.*Mgl**12.*Msb2**2.+

     &  95515.*Mgl**10.*Msb2**4.+

     &  128759.*Mgl**8.*Msb2**6.-

     &  142594.*Mgl**6.*Msb2**8.-

     &  109238.*Mgl**4.*Msb2**10.-

     &  33529.*Mgl**2.*Msb2**12.+891.*Msb2**14.+

     &  8064.*Mgl**12.*Msb2**2.*z2+

     &  10944.*Mgl**10.*Msb2**4.*z2+

     &  18864.*Mgl**8.*Msb2**6.*z2-

     &  19152.*Mgl**6.*Msb2**8.*z2-

     &  15984.*Mgl**4.*Msb2**10.*z2-

     &  6192.*Mgl**2.*Msb2**12.*z2))/

     &  (331776.*Mgl**4.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (24.*Mgl**12.-28.*Mgl**10.*Msb2**2.+

     &  409.*Mgl**8.*Msb2**4.-247.*Mgl**6.*Msb2**6.-

     &  249.*Mgl**4.*Msb2**8.+39.*Mgl**2.*Msb2**10.+

     &  28.*Msb2**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**6.*(Mgl+Msb2)**6.*

     &  (2160.*Mgl**10.+5932.*Mgl**8.*Msb2**2.-

     &  197.*Mgl**6.*Msb2**4.-6223.*Mgl**4.*Msb2**6.-

     &  343.*Mgl**2.*Msb2**8.-385.*Msb2**10.)*

     &  ln(mu,Msb2))/(27648.*Mgl**4.*Msb2**2.)+

     &  ((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (32.*Mgl**12.+48.*Mgl**10.*Msb2**2.-

     &  354.*Mgl**8.*Msb2**4.-17.*Mgl**6.*Msb2**6.+

     &  271.*Mgl**4.*Msb2**8.+29.*Mgl**2.*Msb2**10.+

     &  15.*Msb2**12.)*ln(mu,Msb2)**2.)/

     &  (4608.*Mgl**4.*Msb2**2.)+

     &  ln(mu,Mgl)*(-((Mgl-1.*Msb2)**6.*(Mgl+Msb2)**6.*

     &  (576.*Mgl**10.-316.*Mgl**8.*Msb2**2.+

     &  6623.*Mgl**6.*Msb2**4.-

     &  343.*Mgl**4.*Msb2**6.-

     &  5899.*Mgl**2.*Msb2**8.-1921.*Msb2**10.))/

     &  (27648.*Mgl**2.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (56.*Mgl**10.+76.*Mgl**8.*Msb2**2.+

     &  131.*Mgl**6.*Msb2**4.-

     &  133.*Mgl**4.*Msb2**6.-

     &  111.*Mgl**2.*Msb2**8.-43.*Msb2**10.)*

     &  ln(mu,Msb2))/(2304.*Mgl**2.*Msb2**2.)))+

     &  Den(Msb2,Mgl)**6.*

     &  (-((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (64.*Mgl**14.+10820.*Mgl**12.*Msb2**2.+

     &  30615.*Mgl**10.*Msb2**4.+

     &  45576.*Mgl**8.*Msb2**6.-

     &  37387.*Mgl**6.*Msb2**8.-

     &  58307.*Mgl**4.*Msb2**10.-

     &  4308.*Mgl**2.*Msb2**12.+831.*Msb2**14.+

     &  2304.*Mgl**12.*Msb2**2.*z2+

     &  4608.*Mgl**10.*Msb2**4.*z2+

     &  7668.*Mgl**8.*Msb2**6.*z2-

     &  7092.*Mgl**6.*Msb2**8.*z2-

     &  8244.*Mgl**4.*Msb2**10.*z2-

     &  972.*Mgl**2.*Msb2**12.*z2))/

     &  (82944.*Mgl**4.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (32.*Mgl**12.-40.*Mgl**10.*Msb2**2.+

     &  540.*Mgl**8.*Msb2**4.-221.*Mgl**6.*Msb2**6.-

     &  507.*Mgl**4.*Msb2**8.+133.*Mgl**2.*Msb2**10.+

     &  15.*Msb2**12.)*ln(mu,Mgl)**2.)/

     &  (4608.*Mgl**2.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)**4.*(Mgl+Msb2)**4.*

     &  (1488.*Mgl**10.+3904.*Mgl**8.*Msb2**2.+

     &  513.*Mgl**6.*Msb2**4.-5158.*Mgl**4.*Msb2**6.-

     &  1353.*Mgl**2.*Msb2**8.-122.*Msb2**10.)*

     &  ln(mu,Msb2))/(13824.*Mgl**4.*Msb2**2.)-

     &  ((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (32.*Mgl**12.+104.*Mgl**10.*Msb2**2.-

     &  455.*Mgl**8.*Msb2**4.-189.*Mgl**6.*Msb2**6.+

     &  475.*Mgl**4.*Msb2**8.+69.*Mgl**2.*Msb2**10.+

     &  12.*Msb2**12.)*ln(mu,Msb2)**2.)/

     &  (4608.*Mgl**4.*Msb2**2.)+

     &  ln(mu,Mgl)*(((Mgl-1.*Msb2)**4.*(Mgl+Msb2)**4.*

     &  (384.*Mgl**10.-152.*Mgl**8.*Msb2**2.+

     &  4206.*Mgl**6.*Msb2**4.+

     &  1287.*Mgl**4.*Msb2**6.-

     &  4934.*Mgl**2.*Msb2**8.-1167.*Msb2**10.))/

     &  (13824.*Mgl**2.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (64.*Mgl**10.+128.*Mgl**8.*Msb2**2.+

     &  213.*Mgl**6.*Msb2**4.-

     &  197.*Mgl**4.*Msb2**6.-

     &  229.*Mgl**2.*Msb2**8.-27.*Msb2**10.)*

     &  ln(mu,Msb2))/(2304.*Mgl**2.*Msb2**2.)))+

     &  ((61.*Mgl**2.+35.*Msb1**2.)/(4608.*Mgl**4.)-

     &  ((8.*Mgl**8.-49.*Mgl**6.*Msb1**2.-

     &  7.*Mgl**4.*Msb1**4.+47.*Mgl**2.*Msb1**6.-

     &  7.*Msb1**8.)*Den(Msb1,Mgl)**2.)/

     &  (1152.*Mgl**4.*Msb1**2.)+

     &  ((Mgl-1.*Msb1)*(Mgl+Msb1)*

     &  (4.*Mgl**12.+14.*Mgl**10.*Msb1**2.-

     &  53.*Mgl**8.*Msb1**4.+212.*Mgl**6.*Msb1**6.-

     &  92.*Mgl**4.*Msb1**8.-142.*Mgl**2.*Msb1**10.+

     &  33.*Msb1**12.)*Den(Msb1,Mgl)**4.)/

     &  (2304.*Mgl**4.*Msb1**4.)-

     &  ((Mgl-1.*Msb1)**3.*(Mgl+Msb1)**3.*

     &  (8.*Mgl**12.+6.*Mgl**10.*Msb1**2.+

     &  167.*Mgl**8.*Msb1**4.-2.*Mgl**6.*Msb1**6.-

     &  176.*Mgl**4.*Msb1**8.-24.*Mgl**2.*Msb1**10.-

     &  3.*Msb1**12.)*Den(Msb1,Mgl)**6.)/

     &  (1152.*Mgl**4.*Msb1**4.)+

     &  ((Mgl-1.*Msb1)**5.*(Mgl+Msb1)**5.*

     &  (24.*Mgl**12.+28.*Mgl**10.*Msb1**2.+

     &  485.*Mgl**8.*Msb1**4.-116.*Mgl**6.*Msb1**6.-

     &  382.*Mgl**4.*Msb1**8.-72.*Mgl**2.*Msb1**10.-

     &  15.*Msb1**12.)*Den(Msb1,Mgl)**8.)/

     &  (4608.*Mgl**4.*Msb1**4.))*Tfin0(Msb1,Mgl)+

     &  ((61.*Mgl**2.+35.*Msb2**2.)/(4608.*Mgl**4.)-

     &  ((8.*Mgl**8.-49.*Mgl**6.*Msb2**2.-

     &  7.*Mgl**4.*Msb2**4.+47.*Mgl**2.*Msb2**6.-

     &  7.*Msb2**8.)*Den(Msb2,Mgl)**2.)/

     &  (1152.*Mgl**4.*Msb2**2.)+

     &  ((Mgl-1.*Msb2)*(Mgl+Msb2)*

     &  (4.*Mgl**12.+14.*Mgl**10.*Msb2**2.-

     &  53.*Mgl**8.*Msb2**4.+212.*Mgl**6.*Msb2**6.-

     &  92.*Mgl**4.*Msb2**8.-142.*Mgl**2.*Msb2**10.+

     &  33.*Msb2**12.)*Den(Msb2,Mgl)**4.)/

     &  (2304.*Mgl**4.*Msb2**4.)-

     &  ((Mgl-1.*Msb2)**3.*(Mgl+Msb2)**3.*

     &  (8.*Mgl**12.+6.*Mgl**10.*Msb2**2.+

     &  167.*Mgl**8.*Msb2**4.-2.*Mgl**6.*Msb2**6.-

     &  176.*Mgl**4.*Msb2**8.-24.*Mgl**2.*Msb2**10.-

     &  3.*Msb2**12.)*Den(Msb2,Mgl)**6.)/

     &  (1152.*Mgl**4.*Msb2**4.)+

     &  ((Mgl-1.*Msb2)**5.*(Mgl+Msb2)**5.*

     &  (24.*Mgl**12.+28.*Mgl**10.*Msb2**2.+

     &  485.*Mgl**8.*Msb2**4.-116.*Mgl**6.*Msb2**6.-

     &  382.*Mgl**4.*Msb2**8.-72.*Mgl**2.*Msb2**10.-

     &  15.*Msb2**12.)*Den(Msb2,Mgl)**8.)/

     &  (4608.*Mgl**4.*Msb2**4.))*Tfin0(Msb2,Mgl)))+

     &  (cA**2.*(0.2951388888888889+ln(mu,Mgl)/3.+

     &  ln(mu,Mgl)**2./36.)+

     &  Nq**2.*(ln(mu,Msq1)**2./576.+

     &  (ln(mu,Msq1)*ln(mu,Msq2))/288.+ln(mu,Msq2)**2./576.)+

     &  Nq*Nt*((ln(mu,Msq1)*ln(mu,Mst1))/288.+

     &  (ln(mu,Msq2)*ln(mu,Mst1))/288.+

     &  (ln(mu,Msq1)*ln(mu,Mst2))/288.+

     &  (ln(mu,Msq2)*ln(mu,Mst2))/288.+

     &  (ln(mu,Msq1)*ln(mu,Mt))/72.+(ln(mu,Msq2)*ln(mu,Mt))/72.)

     &  +Nt**2.*(ln(mu,Mst1)**2./576.+

     &  (ln(mu,Mst1)*ln(mu,Mst2))/288.+ln(mu,Mst2)**2./576.+

     &  (ln(mu,Mst1)*ln(mu,Mt))/72.+

     &  (ln(mu,Mst2)*ln(mu,Mt))/72.+ln(mu,Mt)**2./36.)+

     &  cR*(Nt*(0.5077431761188271+

     &  (1745*Mgl**4.)/(331776.*Mst1**4.)+

     &  (4699*Mgl**2.)/(165888.*Mst1**2.)-

     &  (91*Mst1**2.)/(1152.*Mgl**2.)-

     &  (47*Mst1**4.)/(1152.*Mgl**4.)+

     &  (1745*Mgl**4.)/(331776.*Mst2**4.)+

     &  (4699*Mgl**2.)/(165888.*Mst2**2.)-

     &  (127*Mst2**2.)/(1152.*Mgl**2.)-

     &  (47*Mst2**4.)/(1152.*Mgl**4.)-

     &  (15689*Mgl**4.)/(331776.*Mt**4.)+

     &  (2333*Mgl**2.*Mst2**2.)/(165888.*Mt**4.)+

     &  (11023*Mst2**4.)/(331776.*Mt**4.)-

     &  (10457*Mgl**2.)/(165888.*Mt**2.)+

     &  (13*Mgl**4.)/(1728.*Mst1**2.*Mt**2.)+

     &  (43*Mst1**2.)/(1728.*Mt**2.)-

     &  Mst1**4./(288.*Mgl**2.*Mt**2.)+

     &  (13*Mgl**4.)/(1728.*Mst2**2.*Mt**2.)+

     &  (2479*Mst2**2.)/(55296.*Mt**2.)+

     &  (7*Mst2**4.)/(576.*Mgl**2.*Mt**2.)+

     &  (121*Mt**2.)/(576.*Mgl**2.)+

     &  (133*Mgl**2.*Mt**2.)/(4608.*Mst1**4.)+

     &  (323*Mt**2.)/(10368.*Mst1**2.)+

     &  (47*Mst1**2.*Mt**2.)/(384.*Mgl**4.)+

     &  (133*Mgl**2.*Mt**2.)/(4608.*Mst2**4.)+

     &  (323*Mt**2.)/(10368.*Mst2**2.)+

     &  (47*Mst2**2.*Mt**2.)/(384.*Mgl**4.)-

     &  (47*Mt**4.)/(192.*Mgl**4.)+

     &  (7831*Mt**4.)/(331776.*Mst1**4.)-

     &  (17*Mt**4.)/(1152.*Mgl**2.*Mst1**2.)+

     &  (7831*Mt**4.)/(331776.*Mst2**4.)-

     &  (17*Mt**4.)/(1152.*Mgl**2.*Mst2**2.)+

     &  (47*Mt**6.)/(1152.*Mgl**4.*Mst1**2.)+

     &  (47*Mt**6.)/(1152.*Mgl**4.*Mst2**2.)-(59*z2)/512.-

     &  (61*Mgl**2.*z2)/(4608.*Mst1**2.)-

     &  (61*Mgl**2.*z2)/(4608.*Mst2**2.)-

     &  (53*Mgl**4.*z2)/(4608.*Mt**4.)+

     &  (53*Mgl**2.*Mst2**2.*z2)/(4608.*Mt**4.)-

     &  (19*Mgl**2.*z2)/(768.*Mt**2.)+

     &  (373*Mst2**2.*z2)/(4608.*Mt**2.)+

     &  (19*Mgl**2.*Mt**2.*z2)/(4608.*Mst1**4.)+

     &  (Mt**2.*z2)/(64.*Mst1**2.)+

     &  (19*Mgl**2.*Mt**2.*z2)/(4608.*Mst2**4.)+

     &  (Mt**2.*z2)/(64.*Mst2**2.)+

     &  (19*Mt**4.*z2)/(4608.*Mst1**4.)+

     &  (19*Mt**4.*z2)/(4608.*Mst2**4.)+

     &  (-0.020833333333333332+Mgl**2./(48.*Mst1**2.)+

     &  Mt**2./(48.*Mst1**2.))*B0fin(Mst1,Mgl,Mt,mu)+

     &  (-0.020833333333333332+Mgl**2./(48.*Mst2**2.)+

     &  Mt**2./(48.*Mst2**2.))*B0fin(Mst2,Mgl,Mt,mu)+

     &  (-0.041666666666666664-Mgl**2./(24.*Mt**2.)+

     &  Mst1**2./(24.*Mt**2.))*B0fin(Mt,Mgl,Mst1,mu)+

     &  (-0.041666666666666664-Mgl**2./(24.*Mt**2.)+

     &  Mst2**2./(24.*Mt**2.))*B0fin(Mt,Mgl,Mst2,mu)+

     &  ((-13183*Mgl**4.)/82944.-

     &  (4529*Mgl**8.)/(82944.*Mst1**4.)-

     &  (3329*Mgl**6.)/(82944.*Mst1**2.)+

     &  (1687*Mgl**2.*Mst1**2.)/3072.+

     &  (1811*Mst1**4.)/20736.+

     &  (257*Mst1**6.)/(1152.*Mgl**2.)+

     &  (3*Mst1**8.)/(64.*Mgl**4.)-

     &  (95*Mgl**6.)/(432.*Mt**2.)+

     &  (71*Mgl**8.)/(864.*Mst1**2.*Mt**2.)+

     &  (47*Mgl**4.*Mst1**2.)/(288.*Mt**2.)+

     &  (7*Mgl**2.*Mst1**4.)/(864.*Mt**2.)-

     &  Mst1**6./(27.*Mt**2.)+

     &  Mst1**8./(288.*Mgl**2.*Mt**2.)+

     &  (19115*Mgl**2.*Mt**2.)/41472.+

     &  (1895*Mgl**6.*Mt**2.)/(41472.*Mst1**4.)-

     &  (2441*Mgl**4.*Mt**2.)/(5184.*Mst1**2.)+

     &  (4727*Mst1**2.*Mt**2.)/20736.-

     &  (467*Mst1**4.*Mt**2.)/(864.*Mgl**2.)-

     &  (15*Mst1**6.*Mt**2.)/(64.*Mgl**4.)+

     &  (45791*Mt**4.)/82944.+

     &  (289*Mgl**4.*Mt**4.)/(6912.*Mst1**4.)-

     &  (21523*Mgl**2.*Mt**4.)/(82944.*Mst1**2.)+

     &  (311*Mst1**2.*Mt**4.)/(1152.*Mgl**2.)+

     &  (15*Mst1**4.*Mt**4.)/(32.*Mgl**4.)+

     &  (173*Mt**6.)/(1152.*Mgl**2.)-

     &  (995*Mgl**2.*Mt**6.)/(41472.*Mst1**4.)-

     &  (347*Mt**6.)/(20736.*Mst1**2.)-

     &  (15*Mst1**2.*Mt**6.)/(32.*Mgl**4.)+

     &  (15*Mt**8.)/(64.*Mgl**4.)+

     &  (1061*Mt**8.)/(82944.*Mst1**4.)-

     &  (73*Mt**8.)/(864.*Mgl**2.*Mst1**2.)-

     &  (25*Mt**10.)/(1152.*Mgl**2.*Mst1**4.)-

     &  (3*Mt**10.)/(64.*Mgl**4.*Mst1**2.)-

     &  (3*Mgl**4.*z2)/64.-(Mgl**8.*z2)/(144.*Mst1**4.)+

     &  (5*Mgl**6.*z2)/(384.*Mst1**2.)-

     &  (73*Mgl**2.*Mst1**2.*z2)/1152.+

     &  (7*Mst1**4.*z2)/48.-(Mgl**2.*Mt**2.*z2)/72.-

     &  (Mgl**6.*Mt**2.*z2)/(1152.*Mst1**4.)-

     &  (365*Mgl**4.*Mt**2.*z2)/(2304.*Mst1**2.)-

     &  (9*Mst1**2.*Mt**2.*z2)/256.-

     &  (31*Mt**4.*z2)/1152.+

     &  (17*Mgl**4.*Mt**4.*z2)/(1152.*Mst1**4.)-

     &  (17*Mgl**2.*Mt**4.*z2)/(128.*Mst1**2.)+

     &  (Mgl**2.*Mt**6.*z2)/(1152.*Mst1**4.)+

     &  (97*Mt**6.*z2)/(2304.*Mst1**2.)-

     &  (Mt**8.*z2)/(128.*Mst1**4.))*d123(Mt,Mgl,Mst1)+

     &  ((36265*Mgl**8.)/18432.+

     &  (5263*Mgl**12.)/(165888.*Mst1**4.)-

     &  (5461*Mgl**10.)/(20736.*Mst1**2.)-

     &  (5423*Mgl**6.*Mst1**2.)/1728.+

     &  (252137*Mgl**4.*Mst1**4.)/165888.+

     &  (10007*Mgl**2.*Mst1**6.)/6912.-

     &  (207145*Mst1**8.)/165888.-

     &  (1073*Mst1**10.)/(3456.*Mgl**2.)-

     &  (7*Mst1**12.)/(1152.*Mgl**4.)+

     &  (149*Mgl**10.)/(216.*Mt**2.)-

     &  (215*Mgl**12.)/(1728.*Mst1**2.*Mt**2.)-

     &  (2735*Mgl**8.*Mst1**2.)/(1728.*Mt**2.)+

     &  (415*Mgl**6.*Mst1**4.)/(216.*Mt**2.)-

     &  (2245*Mgl**4.*Mst1**6.)/(1728.*Mt**2.)+

     &  (25*Mgl**2.*Mst1**8.)/(54.*Mt**2.)-

     &  (13*Mst1**10.)/(192.*Mt**2.)-

     &  (7745*Mgl**6.*Mt**2.)/1728.-

     &  (6311*Mgl**10.*Mt**2.)/(41472.*Mst1**4.)+

     &  (61801*Mgl**8.*Mt**2.)/(41472.*Mst1**2.)+

     &  (42307*Mgl**4.*Mst1**2.*Mt**2.)/6912.-

     &  (5173*Mgl**2.*Mst1**4.*Mt**2.)/41472.-

     &  (42571*Mst1**6.*Mt**2.)/41472.+

     &  (163*Mst1**8.*Mt**2.)/(144.*Mgl**2.)+

     &  (49*Mst1**10.*Mt**2.)/(1152.*Mgl**4.)+

     &  (10259*Mgl**4.*Mt**4.)/82944.+

     &  (18923*Mgl**8.*Mt**4.)/(165888.*Mst1**4.)-

     &  (50135*Mgl**6.*Mt**4.)/(41472.*Mst1**2.)+

     &  (79207*Mgl**2.*Mst1**2.*Mt**4.)/41472.+

     &  (163205*Mst1**4.*Mt**4.)/55296.-

     &  (1219*Mst1**6.*Mt**4.)/(1152.*Mgl**2.)-

     &  (49*Mst1**8.*Mt**4.)/(384.*Mgl**4.)-

     &  (727*Mgl**2.*Mt**6.)/1152.+

     &  (349*Mgl**6.*Mt**6.)/(2592.*Mst1**4.)+

     &  (16391*Mgl**4.*Mt**6.)/(41472.*Mst1**2.)-

     &  (56581*Mst1**2.*Mt**6.)/41472.-

     &  (355*Mst1**4.*Mt**6.)/(432.*Mgl**2.)+

     &  (245*Mst1**6.*Mt**6.)/(1152.*Mgl**4.)+

     &  (55811*Mt**8.)/55296.-

     &  (16267*Mgl**4.*Mt**8.)/(165888.*Mst1**4.)-

     &  (9607*Mgl**2.*Mt**8.)/(41472.*Mst1**2.)+

     &  (805*Mst1**2.*Mt**8.)/(384.*Mgl**2.)-

     &  (245*Mst1**4.*Mt**8.)/(1152.*Mgl**4.)-

     &  (89*Mt**10.)/(72.*Mgl**2.)-

     &  (1577*Mgl**2.*Mt**10.)/(41472.*Mst1**4.)-

     &  (1067*Mt**10.)/(5184.*Mst1**2.)+

     &  (49*Mst1**2.*Mt**10.)/(384.*Mgl**4.)-

     &  (49*Mt**12.)/(1152.*Mgl**4.)-

     &  (7919*Mt**12.)/(165888.*Mst1**4.)+

     &  (493*Mt**12.)/(3456.*Mgl**2.*Mst1**2.)+

     &  Mt**14./(18.*Mgl**2.*Mst1**4.)+

     &  (7*Mt**14.)/(1152.*Mgl**4.*Mst1**2.)+

     &  (235*Mgl**8.*z2)/768.+

     &  (Mgl**12.*z2)/(144.*Mst1**4.)-

     &  (19*Mgl**10.*z2)/(256.*Mst1**2.)-

     &  (83*Mgl**6.*Mst1**2.*z2)/288.-

     &  (11*Mgl**4.*Mst1**4.*z2)/144.+

     &  (329*Mgl**2.*Mst1**6.*z2)/768.-

     &  (697*Mst1**8.*z2)/2304.-

     &  (361*Mgl**6.*Mt**2.*z2)/384.-

     &  (59*Mgl**10.*Mt**2.*z2)/(2304.*Mst1**4.)+

     &  (239*Mgl**8.*Mt**2.*z2)/(768.*Mst1**2.)+

     &  (59*Mgl**4.*Mst1**2.*Mt**2.*z2)/72.+

     &  (5*Mgl**2.*Mst1**4.*Mt**2.*z2)/2304.+

     &  (127*Mst1**6.*Mt**2.*z2)/2304.-

     &  (7*Mgl**4.*Mt**4.*z2)/128.-

     &  (7*Mgl**8.*Mt**4.*z2)/(2304.*Mst1**4.)-

     &  (17*Mgl**6.*Mt**4.*z2)/(192.*Mst1**2.)+

     &  (311*Mgl**2.*Mst1**2.*Mt**4.*z2)/1152.+

     &  (1027*Mst1**4.*Mt**4.*z2)/2304.-

     &  (539*Mgl**2.*Mt**6.*z2)/1152.+

     &  (77*Mgl**6.*Mt**6.*z2)/(1152.*Mst1**4.)-

     &  (217*Mgl**4.*Mt**6.*z2)/(576.*Mst1**2.)-

     &  (109*Mst1**2.*Mt**6.*z2)/384.+

     &  (89*Mt**8.*z2)/2304.-

     &  (35*Mgl**4.*Mt**8.*z2)/(1152.*Mst1**4.)+

     &  (479*Mgl**2.*Mt**8.*z2)/(2304.*Mst1**2.)-

     &  (95*Mgl**2.*Mt**10.*z2)/(2304.*Mst1**4.)+

     &  (47*Mt**10.*z2)/(2304.*Mst1**2.)+

     &  (61*Mt**12.*z2)/(2304.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**2.+

     &  ((-345283*Mgl**12.)/82944.+

     &  (3685*Mgl**16.)/(27648.*Mst1**4.)+

     &  (11317*Mgl**14.)/(27648.*Mst1**2.)+

     &  (825815*Mgl**10.*Mst1**2.)/82944.-

     &  (832357*Mgl**8.*Mst1**4.)/82944.+

     &  (48013*Mgl**6.*Mst1**6.)/82944.+

     &  (741223*Mgl**4.*Mst1**8.)/82944.-

     &  (673067*Mgl**2.*Mst1**10.)/82944.+

     &  (10177*Mst1**12.)/4608.+

     &  (311*Mst1**14.)/(3456.*Mgl**2.)-

     &  (79*Mgl**14.)/(288.*Mt**2.)+

     &  (5*Mgl**16.)/(144.*Mst1**2.*Mt**2.)+

     &  (91*Mgl**12.*Mst1**2.)/(96.*Mt**2.)-

     &  (539*Mgl**10.*Mst1**4.)/(288.*Mt**2.)+

     &  (665*Mgl**8.*Mst1**6.)/(288.*Mt**2.)-

     &  (175*Mgl**6.*Mst1**8.)/(96.*Mt**2.)+

     &  (259*Mgl**4.*Mst1**10.)/(288.*Mt**2.)-

     &  (73*Mgl**2.*Mst1**12.)/(288.*Mt**2.)+

     &  Mst1**14./(32.*Mt**2.)+

     &  (454897*Mgl**10.*Mt**2.)/41472.-

     &  (21185*Mgl**14.*Mt**2.)/(41472.*Mst1**4.)-

     &  (74821*Mgl**12.*Mt**2.)/(41472.*Mst1**2.)-

     &  (104527*Mgl**8.*Mst1**2.*Mt**2.)/4608.+

     &  (980597*Mgl**6.*Mst1**4.*Mt**2.)/41472.-

     &  (627151*Mgl**4.*Mst1**6.*Mt**2.)/41472.+

     &  (299195*Mgl**2.*Mst1**8.*Mt**2.)/41472.-

     &  (52405*Mst1**10.*Mt**2.)/41472.-

     &  (383*Mst1**12.*Mt**2.)/(864.*Mgl**2.)-

     &  (734939*Mgl**8.*Mt**4.)/82944.+

     &  (10367*Mgl**12.*Mt**4.)/(13824.*Mst1**4.)+

     &  (101863*Mgl**10.*Mt**4.)/(82944.*Mst1**2.)+

     &  (404039*Mgl**6.*Mst1**2.*Mt**4.)/41472.-

     &  (19213*Mgl**4.*Mst1**4.*Mt**4.)/20736.-

     &  (4949*Mgl**2.*Mst1**6.*Mt**4.)/9216.-

     &  (908891*Mst1**8.*Mt**4.)/82944.+

     &  (79*Mst1**10.*Mt**4.)/(128.*Mgl**2.)+

     &  (68543*Mgl**6.*Mt**6.)/20736.-

     &  (8987*Mgl**10.*Mt**6.)/(13824.*Mst1**4.)+

     &  (82675*Mgl**8.*Mt**6.)/(41472.*Mst1**2.)+

     &  (45155*Mgl**4.*Mst1**2.*Mt**6.)/20736.+

     &  (84737*Mgl**2.*Mst1**4.*Mt**6.)/13824.+

     &  (826955*Mst1**6.*Mt**6.)/41472.+

     &  (1841*Mst1**8.*Mt**6.)/(3456.*Mgl**2.)+

     &  (90805*Mgl**4.*Mt**8.)/27648.+

     &  (3893*Mgl**8.*Mt**8.)/(10368.*Mst1**4.)-

     &  (28195*Mgl**6.*Mt**8.)/(82944.*Mst1**2.)-

     &  (308341*Mgl**2.*Mst1**2.*Mt**8.)/82944.-

     &  (1212719*Mst1**4.*Mt**8.)/82944.-

     &  (9233*Mst1**6.*Mt**8.)/(3456.*Mgl**2.)-

     &  (56713*Mgl**2.*Mt**10.)/13824.+

     &  (15833*Mgl**6.*Mt**10.)/(41472.*Mst1**4.)-

     &  (54817*Mgl**4.*Mt**10.)/(13824.*Mst1**2.)+

     &  (78007*Mst1**2.*Mt**10.)/13824.+

     &  (3983*Mst1**4.*Mt**10.)/(1152.*Mgl**2.)-

     &  (55057*Mt**12.)/82944.-

     &  (15439*Mgl**4.*Mt**12.)/(13824.*Mst1**4.)+

     &  (213005*Mgl**2.*Mt**12.)/(82944.*Mst1**2.)-

     &  (7273*Mst1**2.*Mt**12.)/(3456.*Mgl**2.)+

     &  (1747*Mt**14.)/(3456.*Mgl**2.)+

     &  (11239*Mgl**2.*Mt**14.)/(13824.*Mst1**4.)-

     &  (7243*Mt**14.)/(41472.*Mst1**2.)-

     &  (11767*Mt**16.)/(82944.*Mst1**4.)+

     &  (29*Mt**16.)/(576.*Mgl**2.*Mst1**2.)-

     &  (13*Mt**18.)/(384.*Mgl**2.*Mst1**4.)-

     &  (157*Mgl**12.*z2)/288.+

     &  (Mgl**16.*z2)/(144.*Mst1**4.)+

     &  (113*Mgl**14.*z2)/(1152.*Mst1**2.)+

     &  (1193*Mgl**10.*Mst1**2.*z2)/1152.-

     &  (27*Mgl**8.*Mst1**4.*z2)/32.-

     &  (47*Mgl**6.*Mst1**6.*z2)/384.+

     &  (287*Mgl**4.*Mst1**8.*z2)/288.-

     &  (1037*Mgl**2.*Mst1**10.*z2)/1152.+

     &  (79*Mst1**12.*z2)/288.+

     &  (1049*Mgl**10.*Mt**2.*z2)/576.-

     &  (Mgl**14.*Mt**2.*z2)/(128.*Mst1**4.)-

     &  (1079*Mgl**12.*Mt**2.*z2)/(2304.*Mst1**2.)-

     &  (7409*Mgl**8.*Mst1**2.*Mt**2.*z2)/2304.+

     &  (1201*Mgl**6.*Mst1**4.*Mt**2.*z2)/384.-

     &  (4289*Mgl**4.*Mst1**6.*Mt**2.*z2)/2304.+

     &  (197*Mgl**2.*Mst1**8.*Mt**2.*z2)/288.-

     &  (61*Mst1**10.*Mt**2.*z2)/768.-

     &  (667*Mgl**8.*Mt**4.*z2)/384.-

     &  (23*Mgl**12.*Mt**4.*z2)/(1152.*Mst1**4.)+

     &  (223*Mgl**10.*Mt**4.*z2)/(384.*Mst1**2.)+

     &  (99*Mgl**6.*Mst1**2.*Mt**4.*z2)/64.+

     &  (5*Mgl**4.*Mst1**4.*Mt**4.*z2)/384.-

     &  (355*Mgl**2.*Mst1**6.*Mt**4.*z2)/1152.-

     &  (1559*Mst1**8.*Mt**4.*z2)/1152.+

     &  (95*Mgl**6.*Mt**6.*z2)/144.-

     &  (25*Mgl**10.*Mt**6.*z2)/(1152.*Mst1**4.)+

     &  (449*Mgl**8.*Mt**6.*z2)/(2304.*Mst1**2.)+

     &  (55*Mgl**4.*Mst1**2.*Mt**6.*z2)/1152.+

     &  (1121*Mgl**2.*Mst1**4.*Mt**6.*z2)/1152.+

     &  (1435*Mst1**6.*Mt**6.*z2)/768.+

     &  (235*Mgl**4.*Mt**8.*z2)/576.+

     &  (59*Mgl**8.*Mt**8.*z2)/(384.*Mst1**4.)-

     &  (481*Mgl**6.*Mt**8.*z2)/(1152.*Mst1**2.)-

     &  (107*Mgl**2.*Mst1**2.*Mt**8.*z2)/1152.-

     &  (743*Mst1**4.*Mt**8.*z2)/1152.-

     &  (505*Mgl**2.*Mt**10.*z2)/576.-

     &  (131*Mgl**6.*Mt**10.*z2)/(1152.*Mst1**4.)-

     &  (263*Mgl**4.*Mt**10.*z2)/(768.*Mst1**2.)-

     &  (613*Mst1**2.*Mt**10.*z2)/2304.+

     &  (311*Mt**12.*z2)/1152.-

     &  (109*Mgl**4.*Mt**12.*z2)/(1152.*Mst1**4.)+

     &  (145*Mgl**2.*Mt**12.*z2)/(384.*Mst1**2.)+

     &  (55*Mgl**2.*Mt**14.*z2)/(384.*Mst1**4.)-

     &  (53*Mt**14.*z2)/(2304.*Mst1**2.)-

     &  (53*Mt**16.*z2)/(1152.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.+

     &  ((584557*Mgl**16.)/331776.-

     &  (38375*Mgl**20.)/(331776.*Mst1**4.)+

     &  (12929*Mgl**18.)/(165888.*Mst1**2.)-

     &  (90971*Mgl**14.*Mst1**2.)/13824.+

     &  (1882513*Mgl**12.*Mst1**4.)/165888.-

     &  (814277*Mgl**10.*Mst1**6.)/82944.+

     &  (5969*Mgl**8.*Mst1**8.)/18432.+

     &  (369271*Mgl**6.*Mst1**10.)/41472.-

     &  (3133691*Mgl**4.*Mst1**12.)/331776.+

     &  (714097*Mgl**2.*Mst1**14.)/165888.-

     &  (252767*Mst1**16.)/331776.-

     &  (5785*Mgl**14.*Mt**2.)/1152.+

     &  (1805*Mgl**18.*Mt**2.)/(2592.*Mst1**4.)-

     &  (2033*Mgl**16.*Mt**2.)/(6912.*Mst1**2.)+

     &  (361019*Mgl**12.*Mst1**2.*Mt**2.)/20736.-

     &  (349459*Mgl**10.*Mst1**4.*Mt**2.)/10368.+

     &  (869473*Mgl**8.*Mst1**6.*Mt**2.)/20736.-

     &  (123737*Mgl**6.*Mst1**8.*Mt**2.)/3456.+

     &  (421985*Mgl**4.*Mst1**10.*Mt**2.)/20736.-

     &  (59189*Mgl**2.*Mst1**12.*Mt**2.)/10368.+

     &  (505*Mst1**14.*Mt**2.)/3456.+

     &  (156695*Mgl**12.*Mt**4.)/82944.-

     &  (566197*Mgl**16.*Mt**4.)/(331776.*Mst1**4.)+

     &  (36581*Mgl**14.*Mt**4.)/(20736.*Mst1**2.)-

     &  (58261*Mgl**10.*Mst1**2.*Mt**4.)/3456.+

     &  (3133717*Mgl**8.*Mst1**4.*Mt**4.)/165888.-

     &  (86623*Mgl**6.*Mst1**6.*Mt**4.)/20736.-

     &  (493733*Mgl**4.*Mst1**8.*Mt**4.)/82944.-

     &  (6307*Mgl**2.*Mst1**10.*Mt**4.)/1296.+

     &  (3655235*Mst1**12.*Mt**4.)/331776.+

     &  (81913*Mgl**10.*Mt**6.)/10368.+

     &  (45515*Mgl**14.*Mt**6.)/(20736.*Mst1**4.)-

     &  (323359*Mgl**12.*Mt**6.)/(41472.*Mst1**2.)+

     &  (23603*Mgl**8.*Mst1**2.*Mt**6.)/13824.-

     &  (12367*Mgl**6.*Mst1**4.*Mt**6.)/6912.-

     &  (38975*Mgl**4.*Mst1**6.*Mt**6.)/13824.+

     &  (10741*Mgl**2.*Mst1**8.*Mt**6.)/2592.-

     &  (1308077*Mst1**10.*Mt**6.)/41472.-

     &  (1537145*Mgl**8.*Mt**8.)/165888.-

     &  (87233*Mgl**12.*Mt**8.)/(55296.*Mst1**4.)+

     &  (412091*Mgl**10.*Mt**8.)/(27648.*Mst1**2.)+

     &  (508783*Mgl**6.*Mst1**2.*Mt**8.)/41472.+

     &  (367753*Mgl**4.*Mst1**4.*Mt**8.)/55296.+

     &  (875633*Mgl**2.*Mst1**6.*Mt**8.)/82944.+

     &  (6630433*Mst1**8.*Mt**8.)/165888.+

     &  (9047*Mgl**6.*Mt**10.)/1152.+

     &  (7115*Mgl**10.*Mt**10.)/(20736.*Mst1**4.)-

     &  (154753*Mgl**8.*Mt**10.)/(13824.*Mst1**2.)-

     &  (7397*Mgl**4.*Mst1**2.*Mt**10.)/2592.-

     &  (60275*Mgl**2.*Mst1**4.*Mt**10.)/6912.-

     &  (1109021*Mst1**6.*Mt**10.)/41472.-

     &  (989561*Mgl**4.*Mt**12.)/82944.+

     &  (187435*Mgl**8.*Mt**12.)/(165888.*Mst1**4.)-

     &  (65*Mgl**6.*Mt**12.)/(432.*Mst1**2.)-

     &  (110009*Mgl**2.*Mst1**2.*Mt**12.)/20736.+

     &  (1407775*Mst1**4.*Mt**12.)/165888.+

     &  (78637*Mgl**2.*Mt**14.)/10368.-

     &  (15701*Mgl**6.*Mt**14.)/(6912.*Mst1**4.)+

     &  (54025*Mgl**4.*Mt**14.)/(13824.*Mst1**2.)+

     &  (8785*Mst1**2.*Mt**14.)/41472.-

     &  (255859*Mt**16.)/331776.+

     &  (694205*Mgl**4.*Mt**16.)/(331776.*Mst1**4.)-

     &  (170251*Mgl**2.*Mt**16.)/(165888.*Mst1**2.)-

     &  (19967*Mgl**2.*Mt**18.)/(20736.*Mst1**4.)-

     &  (7987*Mt**18.)/(41472.*Mst1**2.)+

     &  (58895*Mt**20.)/(331776.*Mst1**4.)+

     &  (1153*Mgl**16.*z2)/4608.-

     &  (Mgl**20.*z2)/(144.*Mst1**4.)-

     &  (109*Mgl**18.*z2)/(4608.*Mst1**2.)-

     &  (413*Mgl**14.*Mst1**2.*z2)/576.+

     &  (13*Mgl**12.*Mst1**4.*z2)/12.-

     &  (1861*Mgl**10.*Mst1**6.*z2)/2304.-

     &  (443*Mgl**8.*Mst1**8.*z2)/2304.+

     &  (13*Mgl**6.*Mst1**10.*z2)/12.-

     &  (607*Mgl**4.*Mst1**12.*z2)/576.+

     &  (2143*Mgl**2.*Mst1**14.*z2)/4608.-

     &  (371*Mst1**16.*z2)/4608.-

     &  (1259*Mgl**14.*Mt**2.*z2)/1152.+

     &  (139*Mgl**18.*Mt**2.*z2)/(4608.*Mst1**4.)+

     &  (443*Mgl**16.*Mt**2.*z2)/(2304.*Mst1**2.)+

     &  (1009*Mgl**12.*Mst1**2.*Mt**2.*z2)/384.-

     &  (9131*Mgl**10.*Mst1**4.*Mt**2.*z2)/2304.+

     &  (1241*Mgl**8.*Mst1**6.*Mt**2.*z2)/288.-

     &  (4463*Mgl**6.*Mst1**8.*Mt**2.*z2)/1152.+

     &  (947*Mgl**4.*Mst1**10.*Mt**2.*z2)/384.-

     &  (1007*Mgl**2.*Mst1**12.*Mt**2.*z2)/1536.-

     &  (91*Mst1**14.*Mt**2.*z2)/2304.+

     &  (1879*Mgl**12.*Mt**4.*z2)/1152.-

     &  (47*Mgl**16.*Mt**4.*z2)/(1536.*Mst1**4.)-

     &  (11*Mgl**14.*Mt**4.*z2)/(24.*Mst1**2.)-

     &  (1199*Mgl**10.*Mst1**2.*Mt**4.*z2)/384.+

     &  (695*Mgl**8.*Mst1**4.*Mt**4.*z2)/256.-

     &  (865*Mgl**6.*Mst1**6.*Mt**4.*z2)/576.-

     &  (209*Mgl**4.*Mst1**8.*Mt**4.*z2)/384.+

     &  (5*Mgl**2.*Mst1**10.*Mt**4.*z2)/384.+

     &  (5983*Mst1**12.*Mt**4.*z2)/4608.-

     &  (449*Mgl**10.*Mt**6.*z2)/1152.-

     &  (11*Mgl**14.*Mt**6.*z2)/(384.*Mst1**4.)+

     &  (19*Mgl**12.*Mt**6.*z2)/(1152.*Mst1**2.)+

     &  (63*Mgl**8.*Mst1**2.*Mt**6.*z2)/64.-

     &  (53*Mgl**6.*Mst1**4.*Mt**6.*z2)/384.-

     &  (263*Mgl**4.*Mst1**6.*Mt**6.*z2)/384.-

     &  (631*Mgl**2.*Mst1**8.*Mt**6.*z2)/1152.-

     &  (925*Mst1**10.*Mt**6.*z2)/288.-

     &  (1817*Mgl**8.*Mt**8.*z2)/2304.+

     &  (3*Mgl**12.*Mt**8.*z2)/(128.*Mst1**4.)+

     &  (2743*Mgl**10.*Mt**8.*z2)/(2304.*Mst1**2.)+

     &  (355*Mgl**6.*Mst1**2.*Mt**8.*z2)/288.+

     &  (551*Mgl**4.*Mst1**4.*Mt**8.*z2)/1152.+

     &  (931*Mgl**2.*Mst1**6.*Mt**8.*z2)/768.+

     &  (2719*Mst1**8.*Mt**8.*z2)/768.+

     &  (1315*Mgl**6.*Mt**10.*z2)/1152.+

     &  (95*Mgl**10.*Mt**10.*z2)/(768.*Mst1**4.)-

     &  (703*Mgl**8.*Mt**10.*z2)/(576.*Mst1**2.)+

     &  (335*Mgl**4.*Mst1**2.*Mt**10.*z2)/1152.-

     &  (7*Mgl**2.*Mst1**4.*Mt**10.*z2)/2304.-

     &  (2399*Mst1**6.*Mt**10.*z2)/1152.-

     &  (1901*Mgl**4.*Mt**12.*z2)/1152.-

     &  (43*Mgl**8.*Mt**12.*z2)/(256.*Mst1**4.)-

     &  (53*Mgl**6.*Mt**12.*z2)/(576.*Mst1**2.)-

     &  (1301*Mgl**2.*Mst1**2.*Mt**12.*z2)/1152.+

     &  (1651*Mst1**4.*Mt**12.*z2)/2304.+

     &  (323*Mgl**2.*Mt**14.*z2)/384.-

     &  (7*Mgl**6.*Mt**14.*z2)/(384.*Mst1**4.)+

     &  (69*Mgl**4.*Mt**14.*z2)/(128.*Mst1**2.)-

     &  (Mst1**2.*Mt**14.*z2)/6.+(265*Mt**16.*z2)/4608.+

     &  (61*Mgl**4.*Mt**16.*z2)/(384.*Mst1**4.)-

     &  (409*Mgl**2.*Mt**16.*z2)/(4608.*Mst1**2.)-

     &  (493*Mgl**2.*Mt**18.*z2)/(4608.*Mst1**4.)-

     &  (127*Mt**18.*z2)/(2304.*Mst1**2.)+

     &  (107*Mt**20.*z2)/(4608.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.+

     &  ((-19*Mgl**4.)/256.-

     &  (4529*Mgl**8.)/(82944.*Mst2**4.)-

     &  (953*Mgl**6.)/(82944.*Mst2**2.)-

     &  (13831*Mgl**2.*Mst2**2.)/82944.-

     &  (21059*Mst2**4.)/82944.-

     &  (167*Mst2**6.)/(1152.*Mgl**2.)+

     &  (3*Mst2**8.)/(64.*Mgl**4.)+

     &  (3391*Mgl**8.)/(41472.*Mt**4.)-

     &  (2981*Mgl**6.*Mst2**2.)/(20736.*Mt**4.)-

     &  (205*Mgl**4.*Mst2**4.)/(3456.*Mt**4.)+

     &  (4621*Mgl**2.*Mst2**6.)/(20736.*Mt**4.)-

     &  (4211*Mst2**8.)/(41472.*Mt**4.)-

     &  (997*Mgl**6.)/(41472.*Mt**2.)+

     &  (5*Mgl**8.)/(72.*Mst2**2.*Mt**2.)-

     &  (44723*Mgl**4.*Mst2**2.)/(82944.*Mt**2.)+

     &  (10811*Mgl**2.*Mst2**4.)/(20736.*Mt**2.)-

     &  (10207*Mst2**6.)/(82944.*Mt**2.)+

     &  (55*Mst2**8.)/(576.*Mgl**2.*Mt**2.)+

     &  (44825*Mgl**2.*Mt**2.)/41472.+

     &  (1895*Mgl**6.*Mt**2.)/(41472.*Mst2**4.)-

     &  (4915*Mgl**4.*Mt**2.)/(10368.*Mst2**2.)+

     &  (22295*Mst2**2.*Mt**2.)/82944.+

     &  (5*Mst2**4.*Mt**2.)/(432.*Mgl**2.)-

     &  (15*Mst2**6.*Mt**2.)/(64.*Mgl**4.)+

     &  (3293*Mt**4.)/5184.+

     &  (289*Mgl**4.*Mt**4.)/(6912.*Mst2**4.)-

     &  (23899*Mgl**2.*Mt**4.)/(82944.*Mst2**2.)-

     &  (113*Mst2**2.*Mt**4.)/(1152.*Mgl**2.)+

     &  (15*Mst2**4.*Mt**4.)/(32.*Mgl**4.)+

     &  (31*Mt**6.)/(128.*Mgl**2.)-

     &  (995*Mgl**2.*Mt**6.)/(41472.*Mst2**4.)-

     &  (17*Mt**6.)/(20736.*Mst2**2.)-

     &  (15*Mst2**2.*Mt**6.)/(32.*Mgl**4.)+

     &  (15*Mt**8.)/(64.*Mgl**4.)+

     &  (1061*Mt**8.)/(82944.*Mst2**4.)-

     &  (73*Mt**8.)/(864.*Mgl**2.*Mst2**2.)-

     &  (25*Mt**10.)/(1152.*Mgl**2.*Mst2**4.)-

     &  (3*Mt**10.)/(64.*Mgl**4.*Mst2**2.)-

     &  (23*Mgl**4.*z2)/288.-

     &  (Mgl**8.*z2)/(144.*Mst2**4.)+

     &  (5*Mgl**6.*z2)/(384.*Mst2**2.)+

     &  (7*Mgl**2.*Mst2**2.*z2)/192.+

     &  (23*Mst2**4.*z2)/128.+

     &  (5*Mgl**8.*z2)/(192.*Mt**4.)-

     &  (43*Mgl**6.*Mst2**2.*z2)/(576.*Mt**4.)+

     &  (13*Mgl**4.*Mst2**4.*z2)/(192.*Mt**4.)-

     &  (Mgl**2.*Mst2**6.*z2)/(64.*Mt**4.)-

     &  (Mst2**8.*z2)/(288.*Mt**4.)+

     &  (7*Mgl**6.*z2)/(768.*Mt**2.)-

     &  (259*Mgl**4.*Mst2**2.*z2)/(1152.*Mt**2.)+

     &  (613*Mgl**2.*Mst2**4.*z2)/(2304.*Mt**2.)-

     &  (29*Mst2**6.*z2)/(576.*Mt**2.)+

     &  (Mgl**2.*Mt**2.*z2)/256.-

     &  (Mgl**6.*Mt**2.*z2)/(1152.*Mst2**4.)-

     &  (365*Mgl**4.*Mt**2.*z2)/(2304.*Mst2**2.)-

     &  (91*Mst2**2.*Mt**2.*z2)/768.+(Mt**4.*z2)/48.+

     &  (17*Mgl**4.*Mt**4.*z2)/(1152.*Mst2**4.)-

     &  (17*Mgl**2.*Mt**4.*z2)/(128.*Mst2**2.)+

     &  (Mgl**2.*Mt**6.*z2)/(1152.*Mst2**4.)+

     &  (97*Mt**6.*z2)/(2304.*Mst2**2.)-

     &  (Mt**8.*z2)/(128.*Mst2**4.))*d123(Mt,Mgl,Mst2)+

     &  ((43319*Mgl**8.)/41472.+

     &  (5263*Mgl**12.)/(165888.*Mst2**4.)-

     &  (7705*Mgl**10.)/(20736.*Mst2**2.)-

     &  (1783*Mgl**6.*Mst2**2.)/864.+

     &  (481951*Mgl**4.*Mst2**4.)/165888.-

     &  (27179*Mgl**2.*Mst2**6.)/10368.+

     &  (17165*Mst2**8.)/27648.+

     &  (1591*Mst2**10.)/(3456.*Mgl**2.)-

     &  (7*Mst2**12.)/(1152.*Mgl**4.)-

     &  (7295*Mgl**12.)/(165888.*Mt**4.)+

     &  (7687*Mgl**10.*Mst2**2.)/(82944.*Mt**4.)+

     &  (16667*Mgl**8.*Mst2**4.)/(165888.*Mt**4.)-

     &  (6209*Mgl**6.*Mst2**6.)/(13824.*Mt**4.)+

     &  (79207*Mgl**4.*Mst2**8.)/(165888.*Mt**4.)-

     &  (17329*Mgl**2.*Mst2**10.)/(82944.*Mt**4.)+

     &  (5213*Mst2**12.)/(165888.*Mt**4.)+

     &  (57997*Mgl**10.)/(82944.*Mt**2.)-

     &  (19*Mgl**12.)/(192.*Mst2**2.*Mt**2.)+

     &  (7385*Mgl**8.*Mst2**2.)/(41472.*Mt**2.)-

     &  (103163*Mgl**6.*Mst2**4.)/(41472.*Mt**2.)+

     &  (38165*Mgl**4.*Mst2**6.)/(20736.*Mt**2.)+

     &  (3185*Mgl**2.*Mst2**8.)/(82944.*Mt**2.)-

     &  (1711*Mst2**10.)/(41472.*Mt**2.)-

     &  (37*Mst2**12.)/(288.*Mgl**2.*Mt**2.)-

     &  (22973*Mgl**6.*Mt**2.)/5184.-

     &  (6311*Mgl**10.*Mt**2.)/(41472.*Mst2**4.)+

     &  (67873*Mgl**8.*Mt**2.)/(41472.*Mst2**2.)+

     &  (53485*Mgl**4.*Mst2**2.*Mt**2.)/20736.+

     &  (41977*Mgl**2.*Mst2**4.*Mt**2.)/41472.-

     &  (58363*Mst2**6.*Mt**2.)/13824.-

     &  (229*Mst2**8.*Mt**2.)/(288.*Mgl**2.)+

     &  (49*Mst2**10.*Mt**2.)/(1152.*Mgl**4.)+

     &  (154315*Mgl**4.*Mt**4.)/55296.+

     &  (18923*Mgl**8.*Mt**4.)/(165888.*Mst2**4.)-

     &  (50663*Mgl**6.*Mt**4.)/(41472.*Mst2**2.)+

     &  (316123*Mgl**2.*Mst2**2.*Mt**4.)/82944.+

     &  (291689*Mst2**4.*Mt**4.)/82944.+

     &  (1741*Mst2**6.*Mt**4.)/(1152.*Mgl**2.)-

     &  (49*Mst2**8.*Mt**4.)/(384.*Mgl**4.)-

     &  (61303*Mgl**2.*Mt**6.)/27648.+

     &  (349*Mgl**6.*Mt**6.)/(2592.*Mst2**4.)+

     &  (10583*Mgl**4.*Mt**6.)/(41472.*Mst2**2.)-

     &  (7667*Mst2**2.*Mt**6.)/10368.-

     &  (2375*Mst2**4.*Mt**6.)/(864.*Mgl**2.)+

     &  (245*Mst2**6.*Mt**6.)/(1152.*Mgl**4.)+

     &  (10313*Mt**8.)/9216.-

     &  (16267*Mgl**4.*Mt**8.)/(165888.*Mst2**4.)-

     &  (4591*Mgl**2.*Mt**8.)/(41472.*Mst2**2.)+

     &  (367*Mst2**2.*Mt**8.)/(128.*Mgl**2.)-

     &  (245*Mst2**4.*Mt**8.)/(1152.*Mgl**4.)-

     &  (131*Mt**10.)/(96.*Mgl**2.)-

     &  (1577*Mgl**2.*Mt**10.)/(41472.*Mst2**4.)-

     &  (77*Mt**10.)/(324.*Mst2**2.)+

     &  (49*Mst2**2.*Mt**10.)/(384.*Mgl**4.)-

     &  (49*Mt**12.)/(1152.*Mgl**4.)-

     &  (7919*Mt**12.)/(165888.*Mst2**4.)+

     &  (493*Mt**12.)/(3456.*Mgl**2.*Mst2**2.)+

     &  Mt**14./(18.*Mgl**2.*Mst2**4.)+

     &  (7*Mt**14.)/(1152.*Mgl**4.*Mst2**2.)+

     &  (53*Mgl**8.*z2)/1152.+

     &  (Mgl**12.*z2)/(144.*Mst2**4.)-

     &  (19*Mgl**10.*z2)/(256.*Mst2**2.)-

     &  (613*Mgl**6.*Mst2**2.*z2)/1152.+

     &  (13*Mgl**4.*Mst2**4.*z2)/16.-

     &  (433*Mgl**2.*Mst2**6.*z2)/768.+

     &  (39*Mst2**8.*z2)/128.-

     &  (47*Mgl**12.*z2)/(2304.*Mt**4.)+

     &  (191*Mgl**10.*Mst2**2.*z2)/(2304.*Mt**4.)-

     &  (143*Mgl**8.*Mst2**4.*z2)/(1152.*Mt**4.)+

     &  (29*Mgl**6.*Mst2**6.*z2)/(384.*Mt**4.)-

     &  (11*Mgl**4.*Mst2**8.*z2)/(2304.*Mt**4.)-

     &  (29*Mgl**2.*Mst2**10.*z2)/(2304.*Mt**4.)+

     &  (Mst2**12.*z2)/(288.*Mt**4.)+

     &  (373*Mgl**10.*z2)/(2304.*Mt**2.)-

     &  (241*Mgl**8.*Mst2**2.*z2)/(2304.*Mt**2.)-

     &  (431*Mgl**6.*Mst2**4.*z2)/(1152.*Mt**2.)+

     &  (331*Mgl**4.*Mst2**6.*z2)/(1152.*Mt**2.)+

     &  (361*Mgl**2.*Mst2**8.*z2)/(2304.*Mt**2.)-

     &  (293*Mst2**10.*z2)/(2304.*Mt**2.)-

     &  (1205*Mgl**6.*Mt**2.*z2)/1152.-

     &  (59*Mgl**10.*Mt**2.*z2)/(2304.*Mst2**4.)+

     &  (239*Mgl**8.*Mt**2.*z2)/(768.*Mst2**2.)+

     &  (131*Mgl**4.*Mst2**2.*Mt**2.*z2)/288.+

     &  (379*Mgl**2.*Mst2**4.*Mt**2.*z2)/768.-

     &  (659*Mst2**6.*Mt**2.*z2)/768.+

     &  (1007*Mgl**4.*Mt**4.*z2)/2304.-

     &  (7*Mgl**8.*Mt**4.*z2)/(2304.*Mst2**4.)-

     &  (17*Mgl**6.*Mt**4.*z2)/(192.*Mst2**2.)+

     &  (1133*Mgl**2.*Mst2**2.*Mt**4.*z2)/2304.+

     &  (2123*Mst2**4.*Mt**4.*z2)/2304.-

     &  (1663*Mgl**2.*Mt**6.*z2)/2304.+

     &  (77*Mgl**6.*Mt**6.*z2)/(1152.*Mst2**4.)-

     &  (217*Mgl**4.*Mt**6.*z2)/(576.*Mst2**2.)-

     &  (713*Mst2**2.*Mt**6.*z2)/2304.+

     &  (7*Mt**8.*z2)/384.-

     &  (35*Mgl**4.*Mt**8.*z2)/(1152.*Mst2**4.)+

     &  (479*Mgl**2.*Mt**8.*z2)/(2304.*Mst2**2.)-

     &  (95*Mgl**2.*Mt**10.*z2)/(2304.*Mst2**4.)+

     &  (47*Mt**10.*z2)/(2304.*Mst2**2.)+

     &  (61*Mt**12.*z2)/(2304.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**2.+

     &  ((-31195*Mgl**12.)/20736.+

     &  (3685*Mgl**16.)/(27648.*Mst2**4.)+

     &  (13517*Mgl**14.)/(27648.*Mst2**2.)+

     &  (561391*Mgl**10.*Mst2**2.)/82944.-

     &  (616079*Mgl**8.*Mst2**4.)/41472.+

     &  (1219597*Mgl**6.*Mst2**6.)/82944.-

     &  (222205*Mgl**4.*Mst2**8.)/20736.+

     &  (610549*Mgl**2.*Mst2**10.)/82944.-

     &  (7075*Mst2**12.)/3072.-

     &  (265*Mst2**14.)/(3456.*Mgl**2.)+

     &  (737*Mgl**16.)/(41472.*Mt**4.)-

     &  (89*Mgl**14.*Mst2**2.)/(10368.*Mt**4.)-

     &  (365*Mgl**12.*Mst2**4.)/(1728.*Mt**4.)+

     &  (4691*Mgl**10.*Mst2**6.)/(10368.*Mt**4.)-

     &  (775*Mgl**8.*Mst2**8.)/(20736.*Mt**4.)-

     &  (2921*Mgl**6.*Mst2**10.)/(3456.*Mt**4.)+

     &  (88*Mgl**4.*Mst2**12.)/(81.*Mt**4.)-

     &  (5855*Mgl**2.*Mst2**14.)/(10368.*Mt**4.)+

     &  (509*Mst2**16.)/(4608.*Mt**4.)-

     &  (24755*Mgl**14.)/(41472.*Mt**2.)+

     &  (19*Mgl**16.)/(864.*Mst2**2.*Mt**2.)+

     &  (9193*Mgl**12.*Mst2**2.)/(27648.*Mt**2.)+

     &  (85153*Mgl**10.*Mst2**4.)/(20736.*Mt**2.)-

     &  (679255*Mgl**8.*Mst2**6.)/(82944.*Mt**2.)+

     &  (195877*Mgl**6.*Mst2**8.)/(41472.*Mt**2.)+

     &  (67373*Mgl**4.*Mst2**10.)/(82944.*Mt**2.)-

     &  (15977*Mgl**2.*Mst2**12.)/(10368.*Mt**2.)+

     &  (25711*Mst2**14.)/(82944.*Mt**2.)+

     &  Mst2**16./(48.*Mgl**2.*Mt**2.)+

     &  (86209*Mgl**10.*Mt**2.)/13824.-

     &  (21185*Mgl**14.*Mt**2.)/(41472.*Mst2**4.)-

     &  (82873*Mgl**12.*Mt**2.)/(41472.*Mst2**2.)-

     &  (354997*Mgl**8.*Mst2**2.*Mt**2.)/27648.+

     &  (20413*Mgl**6.*Mst2**4.*Mt**2.)/1536.+

     &  (29449*Mgl**4.*Mst2**6.*Mt**2.)/6912.-

     &  (724733*Mgl**2.*Mst2**8.*Mt**2.)/41472.+

     &  (738013*Mst2**10.*Mt**2.)/82944.+

     &  (121*Mst2**12.*Mt**2.)/(864.*Mgl**2.)-

     &  (325079*Mgl**8.*Mt**4.)/41472.+

     &  (10367*Mgl**12.*Mt**4.)/(13824.*Mst2**4.)+

     &  (119023*Mgl**10.*Mt**4.)/(82944.*Mst2**2.)+

     &  (16417*Mgl**6.*Mst2**2.*Mt**4.)/13824.-

     &  (225329*Mgl**4.*Mst2**4.*Mt**4.)/41472.+

     &  (1463851*Mgl**2.*Mst2**6.*Mt**4.)/82944.-

     &  (631937*Mst2**8.*Mt**4.)/41472.-

     &  (211*Mst2**10.*Mt**4.)/(384.*Mgl**2.)+

     &  (315187*Mgl**6.*Mt**6.)/41472.-

     &  (8987*Mgl**10.*Mt**6.)/(13824.*Mst2**4.)+

     &  (82015*Mgl**8.*Mt**6.)/(41472.*Mst2**2.)+

     &  (247933*Mgl**4.*Mst2**2.*Mt**6.)/82944.-

     &  (117247*Mgl**2.*Mst2**4.*Mt**6.)/13824.+

     &  (808915*Mst2**6.*Mt**6.)/82944.+

     &  (6881*Mst2**8.*Mt**6.)/(3456.*Mgl**2.)-

     &  (2629*Mgl**4.*Mt**8.)/10368.+

     &  (3893*Mgl**8.*Mt**8.)/(10368.*Mst2**4.)-

     &  (44299*Mgl**6.*Mt**8.)/(82944.*Mst2**2.)+

     &  (324611*Mgl**2.*Mst2**2.*Mt**8.)/82944.-

     &  (6641*Mst2**4.*Mt**8.)/5184.-

     &  (13265*Mst2**6.*Mt**8.)/(3456.*Mgl**2.)-

     &  (57365*Mgl**2.*Mt**10.)/13824.+

     &  (15833*Mgl**6.*Mt**10.)/(41472.*Mst2**4.)-

     &  (5773*Mgl**4.*Mt**10.)/(1536.*Mst2**2.)+

     &  (7375*Mst2**2.*Mt**10.)/82944.+

     &  (4655*Mst2**4.*Mt**10.)/(1152.*Mgl**2.)-

     &  (193*Mt**12.)/5184.-

     &  (15439*Mgl**4.*Mt**12.)/(13824.*Mst2**4.)+

     &  (205349*Mgl**2.*Mt**12.)/(82944.*Mst2**2.)-

     &  (7849*Mst2**2.*Mt**12.)/(3456.*Mgl**2.)+

     &  (1819*Mt**14.)/(3456.*Mgl**2.)+

     &  (11239*Mgl**2.*Mt**14.)/(13824.*Mst2**4.)-

     &  (6583*Mt**14.)/(41472.*Mst2**2.)-

     &  (11767*Mt**16.)/(82944.*Mst2**4.)+

     &  (29*Mt**16.)/(576.*Mgl**2.*Mst2**2.)-

     &  (13*Mt**18.)/(384.*Mgl**2.*Mst2**4.)+

     &  (9*Mgl**12.*z2)/32.+

     &  (Mgl**16.*z2)/(144.*Mst2**4.)+

     &  (113*Mgl**14.*z2)/(1152.*Mst2**2.)-

     &  (5*Mgl**10.*Mst2**2.*z2)/32.-

     &  (1883*Mgl**8.*Mst2**4.*z2)/1152.+

     &  (2881*Mgl**6.*Mst2**6.*z2)/1152.-

     &  (1141*Mgl**4.*Mst2**8.*z2)/576.+

     &  (259*Mgl**2.*Mst2**10.*z2)/192.-

     &  (535*Mst2**12.*z2)/1152.+

     &  (5*Mgl**16.*z2)/(576.*Mt**4.)-

     &  (19*Mgl**14.*Mst2**2.*z2)/(576.*Mt**4.)+

     &  (11*Mgl**12.*Mst2**4.*z2)/(576.*Mt**4.)+

     &  (53*Mgl**10.*Mst2**6.*z2)/(576.*Mt**4.)-

     &  (115*Mgl**8.*Mst2**8.*z2)/(576.*Mt**4.)+

     &  (95*Mgl**6.*Mst2**10.*z2)/(576.*Mt**4.)-

     &  (31*Mgl**4.*Mst2**12.*z2)/(576.*Mt**4.)-

     &  (Mgl**2.*Mst2**14.*z2)/(576.*Mt**4.)+

     &  (Mst2**16.*z2)/(288.*Mt**4.)-

     &  (143*Mgl**14.*z2)/(768.*Mt**2.)+

     &  (65*Mgl**12.*Mst2**2.*z2)/(128.*Mt**2.)-

     &  (379*Mgl**10.*Mst2**4.*z2)/(2304.*Mt**2.)-

     &  (41*Mgl**8.*Mst2**6.*z2)/(72.*Mt**2.)+

     &  (653*Mgl**6.*Mst2**8.*z2)/(2304.*Mt**2.)+

     &  (581*Mgl**4.*Mst2**10.*z2)/(1152.*Mt**2.)-

     &  (1157*Mgl**2.*Mst2**12.*z2)/(2304.*Mt**2.)+

     &  (73*Mst2**14.*z2)/(576.*Mt**2.)+

     &  (1289*Mgl**10.*Mt**2.*z2)/2304.-

     &  (Mgl**14.*Mt**2.*z2)/(128.*Mst2**4.)-

     &  (1079*Mgl**12.*Mt**2.*z2)/(2304.*Mst2**2.)-

     &  (3697*Mgl**8.*Mst2**2.*Mt**2.*z2)/2304.+

     &  (123*Mgl**6.*Mst2**4.*Mt**2.*z2)/64.+

     &  (809*Mgl**4.*Mst2**6.*Mt**2.*z2)/768.-

     &  (2153*Mgl**2.*Mst2**8.*Mt**2.*z2)/768.+

     &  (3109*Mst2**10.*Mt**2.*z2)/2304.-

     &  (113*Mgl**8.*Mt**4.*z2)/72.-

     &  (23*Mgl**12.*Mt**4.*z2)/(1152.*Mst2**4.)+

     &  (223*Mgl**10.*Mt**4.*z2)/(384.*Mst2**2.)-

     &  (71*Mgl**6.*Mst2**2.*Mt**4.*z2)/576.-

     &  (329*Mgl**4.*Mst2**4.*Mt**4.*z2)/384.+

     &  (2825*Mgl**2.*Mst2**6.*Mt**4.*z2)/1152.-

     &  (1315*Mst2**8.*Mt**4.*z2)/576.+

     &  (4493*Mgl**6.*Mt**6.*z2)/2304.-

     &  (25*Mgl**10.*Mt**6.*z2)/(1152.*Mst2**4.)+

     &  (449*Mgl**8.*Mt**6.*z2)/(2304.*Mst2**2.)+

     &  (265*Mgl**4.*Mst2**2.*Mt**6.*z2)/288.-

     &  (929*Mgl**2.*Mst2**4.*Mt**6.*z2)/2304.+

     &  (3325*Mst2**6.*Mt**6.*z2)/2304.-

     &  (187*Mgl**4.*Mt**8.*z2)/288.+

     &  (59*Mgl**8.*Mt**8.*z2)/(384.*Mst2**4.)-

     &  (481*Mgl**6.*Mt**8.*z2)/(1152.*Mst2**2.)+

     &  (31*Mgl**2.*Mst2**2.*Mt**8.*z2)/288.+

     &  (35*Mst2**4.*Mt**8.*z2)/144.-

     &  (1657*Mgl**2.*Mt**10.*z2)/2304.-

     &  (131*Mgl**6.*Mt**10.*z2)/(1152.*Mst2**4.)-

     &  (263*Mgl**4.*Mt**10.*z2)/(768.*Mst2**2.)-

     &  (1553*Mst2**2.*Mt**10.*z2)/2304.+

     &  (187*Mt**12.*z2)/576.-

     &  (109*Mgl**4.*Mt**12.*z2)/(1152.*Mst2**4.)+

     &  (145*Mgl**2.*Mt**12.*z2)/(384.*Mst2**2.)+

     &  (55*Mgl**2.*Mt**14.*z2)/(384.*Mst2**4.)-

     &  (53*Mt**14.*z2)/(2304.*Mst2**2.)-

     &  (53*Mt**16.*z2)/(1152.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.+

     &  ((3827*Mgl**16.)/4608.-

     &  (38375*Mgl**20.)/(331776.*Mst2**4.)+

     &  (12929*Mgl**18.)/(165888.*Mst2**2.)-

     &  (23633*Mgl**14.*Mst2**2.)/4608.+

     &  (813125*Mgl**12.*Mst2**4.)/55296.-

     &  (1751641*Mgl**10.*Mst2**6.)/82944.+

     &  (1467103*Mgl**8.*Mst2**8.)/82944.-

     &  (184391*Mgl**6.*Mst2**10.)/13824.+

     &  (3763921*Mgl**4.*Mst2**12.)/331776.-

     &  (1053655*Mgl**2.*Mst2**14.)/165888.+

     &  (116681*Mst2**16.)/82944.-

     &  (305*Mgl**20.)/(36864.*Mt**4.)+

     &  (2909*Mgl**18.*Mst2**2.)/(165888.*Mt**4.)+

     &  (9289*Mgl**16.*Mst2**4.)/(110592.*Mt**4.)-

     &  (4291*Mgl**14.*Mst2**6.)/(13824.*Mt**4.)+

     &  (175*Mgl**12.*Mst2**8.)/(2048.*Mt**4.)+

     &  (32557*Mgl**10.*Mst2**10.)/(27648.*Mt**4.)-

     &  (146923*Mgl**8.*Mst2**12.)/(55296.*Mt**4.)+

     &  (39037*Mgl**6.*Mst2**14.)/(13824.*Mt**4.)-

     &  (185687*Mgl**4.*Mst2**16.)/(110592.*Mt**4.)+

     &  (29855*Mgl**2.*Mst2**18.)/(55296.*Mt**4.)-

     &  (24409*Mst2**20.)/(331776.*Mt**4.)+

     &  (5221*Mgl**18.)/(55296.*Mt**2.)+

     &  (57887*Mgl**16.*Mst2**2.)/(165888.*Mt**2.)-

     &  (155167*Mgl**14.*Mst2**4.)/(41472.*Mt**2.)+

     &  (406525*Mgl**12.*Mst2**6.)/(41472.*Mt**2.)-

     &  (968891*Mgl**10.*Mst2**8.)/(82944.*Mt**2.)+

     &  (497581*Mgl**8.*Mst2**10.)/(82944.*Mt**2.)+

     &  (10297*Mgl**6.*Mst2**12.)/(41472.*Mt**2.)-

     &  (64723*Mgl**4.*Mst2**14.)/(41472.*Mt**2.)+

     &  (86495*Mgl**2.*Mst2**16.)/(165888.*Mt**2.)-

     &  (5153*Mst2**18.)/(165888.*Mt**2.)-

     &  (18721*Mgl**14.*Mt**2.)/6912.+

     &  (1805*Mgl**18.*Mt**2.)/(2592.*Mst2**4.)-

     &  (2033*Mgl**16.*Mt**2.)/(6912.*Mst2**2.)+

     &  (139931*Mgl**12.*Mst2**2.*Mt**2.)/13824.-

     &  (479569*Mgl**10.*Mst2**4.*Mt**2.)/20736.+

     &  (368699*Mgl**8.*Mst2**6.*Mt**2.)/13824.-

     &  (184753*Mgl**6.*Mst2**8.*Mt**2.)/20736.-

     &  (572869*Mgl**4.*Mst2**10.*Mt**2.)/41472.+

     &  (40597*Mgl**2.*Mst2**12.*Mt**2.)/2304.-

     &  (28831*Mst2**14.*Mt**2.)/4608.+

     &  (104129*Mgl**12.*Mt**4.)/165888.-

     &  (566197*Mgl**16.*Mt**4.)/(331776.*Mst2**4.)+

     &  (36581*Mgl**14.*Mt**4.)/(20736.*Mst2**2.)-

     &  (18923*Mgl**10.*Mst2**2.*Mt**4.)/9216.+

     &  (781495*Mgl**8.*Mst2**4.*Mt**4.)/82944.-

     &  (493711*Mgl**6.*Mst2**6.*Mt**4.)/41472.+

     &  (2895275*Mgl**4.*Mst2**8.*Mt**4.)/165888.-

     &  (771649*Mgl**2.*Mst2**10.*Mt**4.)/27648.+

     &  (4746817*Mst2**12.*Mt**4.)/331776.+

     &  (144013*Mgl**10.*Mt**6.)/27648.+

     &  (45515*Mgl**14.*Mt**6.)/(20736.*Mst2**4.)-

     &  (323359*Mgl**12.*Mt**6.)/(41472.*Mst2**2.)-

     &  (1017737*Mgl**8.*Mst2**2.*Mt**6.)/82944.+

     &  (33707*Mgl**6.*Mst2**4.*Mt**6.)/41472.-

     &  (5749*Mgl**4.*Mst2**6.*Mt**6.)/6912.+

     &  (2460055*Mgl**2.*Mst2**8.*Mt**6.)/82944.-

     &  (437119*Mst2**10.*Mt**6.)/27648.-

     &  (393035*Mgl**8.*Mt**8.)/82944.-

     &  (87233*Mgl**12.*Mt**8.)/(55296.*Mst2**4.)+

     &  (412091*Mgl**10.*Mt**8.)/(27648.*Mst2**2.)+

     &  (471829*Mgl**6.*Mst2**2.*Mt**8.)/41472.-

     &  (2563063*Mgl**4.*Mst2**4.*Mt**8.)/165888.-

     &  (808253*Mgl**2.*Mst2**6.*Mt**8.)/27648.+

     &  (75137*Mst2**8.*Mt**8.)/20736.+

     &  (63725*Mgl**6.*Mt**10.)/10368.+

     &  (7115*Mgl**10.*Mt**10.)/(20736.*Mst2**4.)-

     &  (154753*Mgl**8.*Mt**10.)/(13824.*Mst2**2.)+

     &  (505883*Mgl**4.*Mst2**2.*Mt**10.)/41472.+

     &  (576511*Mgl**2.*Mst2**4.*Mt**10.)/20736.+

     &  (24947*Mst2**6.*Mt**10.)/2592.-

     &  (4532465*Mgl**4.*Mt**12.)/331776.+

     &  (187435*Mgl**8.*Mt**12.)/(165888.*Mst2**4.)-

     &  (65*Mgl**6.*Mt**12.)/(432.*Mst2**2.)-

     &  (1118893*Mgl**2.*Mst2**2.*Mt**12.)/55296.-

     &  (1219981*Mst2**4.*Mt**12.)/110592.+

     &  (19611*Mgl**2.*Mt**14.)/2048.-

     &  (15701*Mgl**6.*Mt**14.)/(6912.*Mst2**4.)+

     &  (54025*Mgl**4.*Mt**14.)/(13824.*Mst2**2.)+

     &  (310913*Mst2**2.*Mt**14.)/55296.-

     &  (113377*Mt**16.)/82944.+

     &  (694205*Mgl**4.*Mt**16.)/(331776.*Mst2**4.)-

     &  (170251*Mgl**2.*Mt**16.)/(165888.*Mst2**2.)-

     &  (19967*Mgl**2.*Mt**18.)/(20736.*Mst2**4.)-

     &  (7987*Mt**18.)/(41472.*Mst2**2.)+

     &  (58895*Mt**20.)/(331776.*Mst2**4.)-

     &  (25*Mgl**16.*z2)/384.-

     &  (Mgl**20.*z2)/(144.*Mst2**4.)-

     &  (109*Mgl**18.*z2)/(4608.*Mst2**2.)+

     &  (353*Mgl**14.*Mst2**2.*z2)/1152.+

     &  (17*Mgl**12.*Mst2**4.*z2)/64.-

     &  (3647*Mgl**10.*Mst2**6.*z2)/2304.+

     &  (275*Mgl**8.*Mst2**8.*z2)/144.-

     &  (1591*Mgl**6.*Mst2**10.*z2)/1152.+

     &  (623*Mgl**4.*Mst2**12.*z2)/576.-

     &  (3133*Mgl**2.*Mst2**14.*z2)/4608.+

     &  (203*Mst2**16.*z2)/1152.-

     &  (13*Mgl**20.*z2)/(4608.*Mt**4.)+

     &  (61*Mgl**18.*Mst2**2.*z2)/(4608.*Mt**4.)-

     &  (Mgl**16.*Mst2**4.*z2)/(128.*Mt**4.)-

     &  (29*Mgl**14.*Mst2**6.*z2)/(384.*Mt**4.)+

     &  (175*Mgl**12.*Mst2**8.*z2)/(768.*Mt**4.)-

     &  (77*Mgl**10.*Mst2**10.*z2)/(256.*Mt**4.)+

     &  (77*Mgl**8.*Mst2**12.*z2)/(384.*Mt**4.)-

     &  (17*Mgl**6.*Mst2**14.*z2)/(384.*Mt**4.)-

     &  (13*Mgl**4.*Mst2**16.*z2)/(512.*Mt**4.)+

     &  (85*Mgl**2.*Mst2**18.*z2)/(4608.*Mt**4.)-

     &  (Mst2**20.*z2)/(288.*Mt**4.)+

     &  (23*Mgl**18.*z2)/(576.*Mt**2.)-

     &  (587*Mgl**16.*Mst2**2.*z2)/(4608.*Mt**2.)-

     &  (35*Mgl**14.*Mst2**4.*z2)/(576.*Mt**2.)+

     &  (99*Mgl**12.*Mst2**6.*z2)/(128.*Mt**2.)-

     &  (727*Mgl**10.*Mst2**8.*z2)/(576.*Mt**2.)+

     &  (1663*Mgl**8.*Mst2**10.*z2)/(2304.*Mt**2.)+

     &  (11*Mgl**6.*Mst2**12.*z2)/(64.*Mt**2.)-

     &  (485*Mgl**4.*Mst2**14.*z2)/(1152.*Mt**2.)+

     &  (7*Mgl**2.*Mst2**16.*z2)/(36.*Mt**2.)-

     &  (139*Mst2**18.*z2)/(4608.*Mt**2.)-

     &  (13*Mgl**14.*Mt**2.*z2)/144.+

     &  (139*Mgl**18.*Mt**2.*z2)/(4608.*Mst2**4.)+

     &  (443*Mgl**16.*Mt**2.*z2)/(2304.*Mst2**2.)-

     &  (149*Mgl**12.*Mst2**2.*Mt**2.*z2)/1152.-

     &  (1091*Mgl**10.*Mst2**4.*Mt**2.*z2)/768.+

     &  (503*Mgl**8.*Mst2**6.*Mt**2.*z2)/192.-

     &  (191*Mgl**6.*Mst2**8.*Mt**2.*z2)/192.-

     &  (1339*Mgl**4.*Mst2**10.*Mt**2.*z2)/1152.+

     &  (7055*Mgl**2.*Mst2**12.*Mt**2.*z2)/4608.-

     &  (1327*Mst2**14.*Mt**2.*z2)/2304.+

     &  (87*Mgl**12.*Mt**4.*z2)/256.-

     &  (47*Mgl**16.*Mt**4.*z2)/(1536.*Mst2**4.)-

     &  (11*Mgl**14.*Mt**4.*z2)/(24.*Mst2**2.)+

     &  (449*Mgl**10.*Mst2**2.*Mt**4.*z2)/2304.+

     &  (2641*Mgl**8.*Mst2**4.*Mt**4.*z2)/2304.-

     &  (2023*Mgl**6.*Mst2**6.*Mt**4.*z2)/1152.+

     &  (4463*Mgl**4.*Mst2**8.*Mt**4.*z2)/2304.-

     &  (1985*Mgl**2.*Mst2**10.*Mt**4.*z2)/768.+

     &  (1861*Mst2**12.*Mt**4.*z2)/1536.-

     &  (149*Mgl**10.*Mt**6.*z2)/576.-

     &  (11*Mgl**14.*Mt**6.*z2)/(384.*Mst2**4.)+

     &  (19*Mgl**12.*Mt**6.*z2)/(1152.*Mst2**2.)-

     &  (1069*Mgl**8.*Mst2**2.*Mt**6.*z2)/768.-

     &  (307*Mgl**6.*Mst2**4.*Mt**6.*z2)/1152.+

     &  (55*Mgl**4.*Mst2**6.*Mt**6.*z2)/576.+

     &  (1801*Mgl**2.*Mst2**8.*Mt**6.*z2)/576.-

     &  (865*Mst2**10.*Mt**6.*z2)/768.+

     &  (313*Mgl**8.*Mt**8.*z2)/576.+

     &  (3*Mgl**12.*Mt**8.*z2)/(128.*Mst2**4.)+

     &  (2743*Mgl**10.*Mt**8.*z2)/(2304.*Mst2**2.)+

     &  (299*Mgl**6.*Mst2**2.*Mt**8.*z2)/128.-

     &  (1921*Mgl**4.*Mst2**4.*Mt**8.*z2)/1152.-

     &  (8309*Mgl**2.*Mst2**6.*Mt**8.*z2)/2304.-

     &  (Mst2**8.*Mt**8.*z2)/4.-

     &  (35*Mgl**6.*Mt**10.*z2)/288.+

     &  (95*Mgl**10.*Mt**10.*z2)/(768.*Mst2**4.)-

     &  (703*Mgl**8.*Mt**10.*z2)/(576.*Mst2**2.)+

     &  (917*Mgl**4.*Mst2**2.*Mt**10.*z2)/1152.+

     &  (8107*Mgl**2.*Mst2**4.*Mt**10.*z2)/2304.+

     &  (503*Mst2**6.*Mt**10.*z2)/384.-

     &  (6137*Mgl**4.*Mt**12.*z2)/4608.-

     &  (43*Mgl**8.*Mt**12.*z2)/(256.*Mst2**4.)-

     &  (53*Mgl**6.*Mt**12.*z2)/(576.*Mst2**2.)-

     &  (3461*Mgl**2.*Mst2**2.*Mt**12.*z2)/1536.-

     &  (731*Mst2**4.*Mt**12.*z2)/768.+

     &  (67*Mgl**2.*Mt**14.*z2)/72.-

     &  (7*Mgl**6.*Mt**14.*z2)/(384.*Mst2**4.)+

     &  (69*Mgl**4.*Mt**14.*z2)/(128.*Mst2**2.)+

     &  (1177*Mst2**2.*Mt**14.*z2)/4608.+

     &  (19*Mt**16.*z2)/1152.+

     &  (61*Mgl**4.*Mt**16.*z2)/(384.*Mst2**4.)-

     &  (409*Mgl**2.*Mt**16.*z2)/(4608.*Mst2**2.)-

     &  (493*Mgl**2.*Mt**18.*z2)/(4608.*Mst2**4.)-

     &  (127*Mt**18.*z2)/(2304.*Mst2**2.)+

     &  (107*Mt**20.*z2)/(4608.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.+

     &  Xt*((-7061*Mgl)/82944.-(5*Mgl**3.)/(864.*Mst1**2.)-

     &  Mst1**2./(72.*Mgl**1.)+

     &  (5*Mgl**3.)/(864.*Mst2**2.)-

     &  Mst2**2./(36.*Mgl**1.)-

     &  (5629*Mgl**3.)/(82944.*Mt**2.)-

     &  (6971*Mgl*Mst2**2.)/(82944.*Mt**2.)+

     &  Mt**2./(24.*Mgl**1.)-

     &  (1745*Mgl**3.*Mt**2.)/(82944.*Mst1**4.)-

     &  (437*Mgl*Mt**2.)/(27648.*Mst1**2.)-

     &  (11*Mst1**2.*Mt**2.)/(96.*Mgl**3.)+

     &  (1745*Mgl**3.*Mt**2.)/(82944.*Mst2**4.)+

     &  (437*Mgl*Mt**2.)/(27648.*Mst2**2.)+

     &  (11*Mst2**2.*Mt**2.)/(96.*Mgl**3.)-

     &  (7831*Mgl*Mt**4.)/(82944.*Mst1**4.)+

     &  Mt**4./(16.*Mgl**1.*Mst1**2.)+

     &  (7831*Mgl*Mt**4.)/(82944.*Mst2**4.)-

     &  Mt**4./(16.*Mgl**1.*Mst2**2.)-

     &  (11*Mt**6.)/(96.*Mgl**3.*Mst1**2.)+

     &  (11*Mt**6.)/(96.*Mgl**3.*Mst2**2.)-

     &  (17*Mgl*z2)/128.-(25*Mgl**3.*z2)/(1152.*Mt**2.)+

     &  (13*Mgl*Mt**2.*z2)/(1152.*Mst1**2.)-

     &  (13*Mgl*Mt**2.*z2)/(1152.*Mst2**2.)-

     &  (19*Mgl*Mt**4.*z2)/(1152.*Mst1**4.)+

     &  (19*Mgl*Mt**4.*z2)/(1152.*Mst2**4.))*Den(Mst1,Mst2)

     &  -(Mgl*Mt**2.*Xt*B0fin(Mst1,Mgl,Mt,mu)*

     &  Den(Mst1,Mst2))/(12.*Mst1**2.)+

     &  (Mgl*Mt**2.*Xt*B0fin(Mst2,Mgl,Mt,mu)*Den(Mst1,Mst2))/

     &  (12.*Mst2**2.)+

     &  (Mgl*Xt*B0fin(Mt,Mgl,Mst1,mu)*Den(Mst1,Mst2))/6.-

     &  (Mgl*Xt*B0fin(Mt,Mgl,Mst2,mu)*Den(Mst1,Mst2))/6.+

     &  Xt*((107*Mgl**5.)/216.-

     &  (19*Mgl**7.)/(108.*Mst1**2.)-

     &  (97*Mgl**3.*Mst1**2.)/216.+

     &  (25*Mgl*Mst1**4.)/216.+Mst1**6./(72.*Mgl**1.)+

     &  (9133*Mgl**3.*Mt**2.)/20736.+

     &  (4529*Mgl**7.*Mt**2.)/(20736.*Mst1**4.)+

     &  (391*Mgl**5.*Mt**2.)/(1152.*Mst1**2.)-

     &  (4625*Mgl*Mst1**2.*Mt**2.)/5184.+

     &  (127*Mst1**4.*Mt**2.)/(288.*Mgl**1.)+

     &  (5*Mst1**6.*Mt**2.)/(36.*Mgl**3.)-

     &  (2719*Mgl*Mt**4.)/1728.-

     &  (2773*Mgl**5.*Mt**4.)/(6912.*Mst1**4.)+

     &  (8381*Mgl**3.*Mt**4.)/(6912.*Mst1**2.)-

     &  (395*Mst1**2.*Mt**4.)/(864.*Mgl**1.)-

     &  (5*Mst1**4.*Mt**4.)/(9.*Mgl**3.)-

     &  (163*Mt**6.)/(432.*Mgl**1.)+

     &  (539*Mgl**3.*Mt**6.)/(2304.*Mst1**4.)-

     &  (2797*Mgl*Mt**6.)/(20736.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**6.)/(6.*Mgl**3.)-

     &  (5*Mt**8.)/(9.*Mgl**3.)-

     &  (2861*Mgl*Mt**8.)/(20736.*Mst1**4.)+

     &  (253*Mt**8.)/(864.*Mgl**1.*Mst1**2.)+

     &  (25*Mt**10.)/(288.*Mgl**1.*Mst1**4.)+

     &  (5*Mt**10.)/(36.*Mgl**3.*Mst1**2.)+

     &  (17*Mgl**3.*Mt**2.*z2)/96.+

     &  (Mgl**7.*Mt**2.*z2)/(36.*Mst1**4.)-

     &  (7*Mgl**5.*Mt**2.*z2)/(288.*Mst1**2.)-

     &  (Mgl*Mst1**2.*Mt**2.*z2)/18.-

     &  (41*Mgl*Mt**4.*z2)/576.-

     &  (7*Mgl**5.*Mt**4.*z2)/(288.*Mst1**4.)+

     &  (365*Mgl**3.*Mt**4.*z2)/(576.*Mst1**2.)-

     &  (5*Mgl**3.*Mt**6.*z2)/(144.*Mst1**4.)-

     &  (79*Mgl*Mt**6.*z2)/(576.*Mst1**2.)+

     &  (Mgl*Mt**8.*z2)/(32.*Mst1**4.))*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)+

     &  Xt*((-1399*Mgl**9.)/864.+

     &  (277*Mgl**11.)/(864.*Mst1**2.)+

     &  (157*Mgl**7.*Mst1**2.)/48.-

     &  (1427*Mgl**5.*Mst1**4.)/432.+

     &  (1441*Mgl**3.*Mst1**6.)/864.-

     &  (97*Mgl*Mst1**8.)/288.-

     &  (7435*Mgl**7.*Mt**2.)/1296.-

     &  (5263*Mgl**11.*Mt**2.)/(41472.*Mst1**4.)+

     &  (13741*Mgl**9.*Mt**2.)/(41472.*Mst1**2.)+

     &  (39173*Mgl**5.*Mst1**2.*Mt**2.)/5184.-

     &  (55513*Mgl**3.*Mst1**4.*Mt**2.)/41472.-

     &  (104509*Mgl*Mst1**6.*Mt**2.)/41472.-

     &  (373*Mst1**8.*Mt**2.)/(432.*Mgl**1.)-

     &  (7*Mst1**10.*Mt**2.)/(288.*Mgl**3.)+

     &  (114049*Mgl**5.*Mt**4.)/6912.+

     &  (10169*Mgl**9.*Mt**4.)/(13824.*Mst1**4.)-

     &  (56741*Mgl**7.*Mt**4.)/(20736.*Mst1**2.)-

     &  (208961*Mgl**3.*Mst1**2.*Mt**4.)/20736.-

     &  (8957*Mgl*Mst1**4.*Mt**4.)/4608.+

     &  (863*Mst1**6.*Mt**4.)/(432.*Mgl**1.)+

     &  (7*Mst1**8.*Mt**4.)/(48.*Mgl**3.)-

     &  (7247*Mgl**3.*Mt**6.)/1152.-

     &  (24715*Mgl**7.*Mt**6.)/(20736.*Mst1**4.)+

     &  (305*Mgl**5.*Mt**6.)/(192.*Mst1**2.)+

     &  (22193*Mgl*Mst1**2.*Mt**6.)/20736.+

     &  (91*Mst1**4.*Mt**6.)/(216.*Mgl**1.)-

     &  (35*Mst1**6.*Mt**6.)/(96.*Mgl**3.)-

     &  (9839*Mgl*Mt**8.)/6912.+

     &  (13547*Mgl**5.*Mt**8.)/(20736.*Mst1**4.)+

     &  (2869*Mgl**3.*Mt**8.)/(20736.*Mst1**2.)-

     &  (949*Mst1**2.*Mt**8.)/(216.*Mgl**1.)+

     &  (35*Mst1**4.*Mt**8.)/(72.*Mgl**3.)+

     &  (1567*Mt**10.)/(432.*Mgl**1.)-

     &  (401*Mgl**3.*Mt**10.)/(1536.*Mst1**4.)+

     &  (39355*Mgl*Mt**10.)/(41472.*Mst1**2.)-

     &  (35*Mst1**2.*Mt**10.)/(96.*Mgl**3.)+

     &  (7*Mt**12.)/(48.*Mgl**3.)+

     &  (17135*Mgl*Mt**12.)/(41472.*Mst1**4.)-

     &  (245*Mt**12.)/(432.*Mgl**1.*Mst1**2.)-

     &  (2*Mt**14.)/(9.*Mgl**1.*Mst1**4.)-

     &  (7*Mt**14.)/(288.*Mgl**3.*Mst1**2.)-

     &  (281*Mgl**7.*Mt**2.*z2)/288.-

     &  (Mgl**11.*Mt**2.*z2)/(36.*Mst1**4.)+

     &  (131*Mgl**9.*Mt**2.*z2)/(576.*Mst1**2.)+

     &  (89*Mgl**5.*Mst1**2.*Mt**2.*z2)/96.-

     &  (17*Mgl**3.*Mst1**4.*Mt**2.*z2)/288.-

     &  (277*Mgl*Mst1**6.*Mt**2.*z2)/576.+

     &  (1999*Mgl**5.*Mt**4.*z2)/576.+

     &  (25*Mgl**9.*Mt**4.*z2)/(192.*Mst1**4.)-

     &  (235*Mgl**7.*Mt**4.*z2)/(192.*Mst1**2.)-

     &  (791*Mgl**3.*Mst1**2.*Mt**4.*z2)/576.-

     &  (65*Mgl*Mst1**4.*Mt**4.*z2)/288.-

     &  (61*Mgl**3.*Mt**6.*z2)/72.-

     &  (17*Mgl**7.*Mt**6.*z2)/(144.*Mst1**4.)+

     &  (809*Mgl**5.*Mt**6.*z2)/(576.*Mst1**2.)-

     &  (47*Mgl*Mst1**2.*Mt**6.*z2)/576.+

     &  (113*Mgl*Mt**8.*z2)/192.-

     &  (43*Mgl**5.*Mt**8.*z2)/(288.*Mst1**4.)-

     &  (11*Mgl**3.*Mt**8.*z2)/(64.*Mst1**2.)+

     &  (13*Mgl**3.*Mt**10.*z2)/(48.*Mst1**4.)-

     &  (17*Mgl*Mt**10.*z2)/(72.*Mst1**2.)-

     &  (61*Mgl*Mt**12.*z2)/(576.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)+

     &  Xt*((23*Mgl**13.)/24.-(5*Mgl**15.)/(36.*Mst1**2.)-

     &  (17*Mgl**11.*Mst1**2.)/6.+

     &  (335*Mgl**9.*Mst1**4.)/72.-

     &  (55*Mgl**7.*Mst1**6.)/12.+

     &  (65*Mgl**5.*Mst1**8.)/24.-

     &  (8*Mgl**3.*Mst1**10.)/9.+(Mgl*Mst1**12.)/8.+

     &  (241405*Mgl**11.*Mt**2.)/20736.-

     &  (3685*Mgl**15.*Mt**2.)/(6912.*Mst1**4.)-

     &  (4325*Mgl**13.*Mt**2.)/(3456.*Mst1**2.)-

     &  (233141*Mgl**9.*Mst1**2.*Mt**2.)/10368.+

     &  (120305*Mgl**7.*Mst1**4.*Mt**2.)/6912.+

     &  (34027*Mgl**5.*Mst1**6.*Mt**2.)/10368.-

     &  (320201*Mgl**3.*Mst1**8.*Mt**2.)/20736.+

     &  (24275*Mgl*Mst1**10.*Mt**2.)/3456.+

     &  (311*Mst1**12.*Mt**2.)/(864.*Mgl**1.)-

     &  (121849*Mgl**9.*Mt**4.)/3456.+

     &  (53425*Mgl**13.*Mt**4.)/(20736.*Mst1**4.)+

     &  (41819*Mgl**11.*Mt**4.)/(6912.*Mst1**2.)+

     &  (651785*Mgl**7.*Mst1**2.*Mt**4.)/10368.-

     &  (102403*Mgl**5.*Mst1**4.*Mt**4.)/2304.+

     &  (82103*Mgl**3.*Mst1**6.*Mt**4.)/6912.+

     &  (1111*Mgl*Mst1**8.*Mt**4.)/1296.-

     &  (407*Mst1**10.*Mt**4.)/(288.*Mgl**1.)+

     &  (126413*Mgl**7.*Mt**6.)/3456.-

     &  (115627*Mgl**11.*Mt**6.)/(20736.*Mst1**4.)-

     &  (61283*Mgl**9.*Mt**6.)/(20736.*Mst1**2.)-

     &  (486889*Mgl**5.*Mst1**2.*Mt**6.)/10368.-

     &  (225571*Mgl**3.*Mst1**4.*Mt**6.)/20736.-

     &  (561739*Mgl*Mst1**6.*Mt**6.)/20736.+

     &  (19*Mst1**8.*Mt**6.)/(18.*Mgl**1.)-

     &  (73565*Mgl**5.*Mt**8.)/2592.+

     &  (169549*Mgl**9.*Mt**8.)/(20736.*Mst1**4.)-

     &  (177799*Mgl**7.*Mt**8.)/(10368.*Mst1**2.)+

     &  (186031*Mgl**3.*Mst1**2.*Mt**8.)/10368.+

     &  (202169*Mgl*Mst1**4.*Mt**8.)/6912.+

     &  (2753*Mst1**6.*Mt**8.)/(864.*Mgl**1.)+

     &  (274733*Mgl**3.*Mt**10.)/20736.-

     &  (200693*Mgl**7.*Mt**10.)/(20736.*Mst1**4.)+

     &  (138955*Mgl**5.*Mt**10.)/(5184.*Mst1**2.)-

     &  (76619*Mgl*Mst1**2.*Mt**10.)/5184.-

     &  (15*Mst1**4.*Mt**10.)/(2.*Mgl**1.)+

     &  (34211*Mgl*Mt**12.)/10368.+

     &  (169027*Mgl**5.*Mt**12.)/(20736.*Mst1**4.)-

     &  (84169*Mgl**3.*Mt**12.)/(6912.*Mst1**2.)+

     &  (1823*Mst1**2.*Mt**12.)/(288.*Mgl**1.)-

     &  (451*Mt**14.)/(216.*Mgl**1.)-

     &  (76393*Mgl**3.*Mt**14.)/(20736.*Mst1**4.)+

     &  (6103*Mgl*Mt**14.)/(6912.*Mst1**2.)+

     &  (8959*Mgl*Mt**16.)/(20736.*Mst1**4.)-

     &  (19*Mt**16.)/(288.*Mgl**1.*Mst1**2.)+

     &  (13*Mt**18.)/(96.*Mgl**1.*Mst1**4.)+

     &  (157*Mgl**11.*Mt**2.*z2)/96.-

     &  (Mgl**15.*Mt**2.*z2)/(36.*Mst1**4.)-

     &  (97*Mgl**13.*Mt**2.*z2)/(288.*Mst1**2.)-

     &  (355*Mgl**9.*Mst1**2.*Mt**2.*z2)/144.+

     &  (227*Mgl**7.*Mst1**4.*Mt**2.*z2)/144.+

     &  (115*Mgl**5.*Mst1**6.*Mt**2.*z2)/288.-

     &  (469*Mgl**3.*Mst1**8.*Mt**2.*z2)/288.+

     &  (61*Mgl*Mst1**10.*Mt**2.*z2)/72.-

     &  (383*Mgl**9.*Mt**4.*z2)/64.+

     &  (17*Mgl**13.*Mt**4.*z2)/(288.*Mst1**4.)+

     &  (995*Mgl**11.*Mt**4.*z2)/(576.*Mst1**2.)+

     &  (781*Mgl**7.*Mst1**2.*Mt**4.*z2)/96.-

     &  (797*Mgl**5.*Mst1**4.*Mt**4.*z2)/144.+

     &  (991*Mgl**3.*Mst1**6.*Mt**4.*z2)/576.+

     &  (185*Mgl*Mst1**8.*Mt**4.*z2)/576.+

     &  (527*Mgl**7.*Mt**6.*z2)/72.+

     &  (Mgl**11.*Mt**6.*z2)/(48.*Mst1**4.)-

     &  (1457*Mgl**9.*Mt**6.*z2)/(576.*Mst1**2.)-

     &  (1465*Mgl**5.*Mst1**2.*Mt**6.*z2)/288.-

     &  (65*Mgl**3.*Mst1**4.*Mt**6.*z2)/48.-

     &  (1589*Mgl*Mst1**6.*Mt**6.*z2)/576.-

     &  (1733*Mgl**5.*Mt**8.*z2)/288.+

     &  (19*Mgl**9.*Mt**8.*z2)/(288.*Mst1**4.)-

     &  (137*Mgl**7.*Mt**8.*z2)/(288.*Mst1**2.)-

     &  (11*Mgl**3.*Mst1**2.*Mt**8.*z2)/288.+

     &  (145*Mgl*Mst1**4.*Mt**8.*z2)/144.+

     &  (1217*Mgl**3.*Mt**10.*z2)/288.-

     &  (49*Mgl**7.*Mt**10.*z2)/(72.*Mst1**4.)+

     &  (511*Mgl**5.*Mt**10.*z2)/(144.*Mst1**2.)+

     &  (43*Mgl*Mst1**2.*Mt**10.*z2)/32.-

     &  (679*Mgl*Mt**12.*z2)/576.+

     &  (109*Mgl**5.*Mt**12.*z2)/(96.*Mst1**4.)-

     &  (1249*Mgl**3.*Mt**12.*z2)/(576.*Mst1**2.)-

     &  (109*Mgl**3.*Mt**14.*z2)/(144.*Mst1**4.)+

     &  (15*Mgl*Mt**14.*z2)/(64.*Mst1**2.)+

     &  (53*Mgl*Mt**16.*z2)/(288.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)+

     &  Xt*((-7945*Mgl**15.*Mt**2.)/1152.+

     &  (38375*Mgl**19.*Mt**2.)/(82944.*Mst1**4.)+

     &  (12517*Mgl**17.*Mt**2.)/(82944.*Mst1**2.)+

     &  (1049*Mgl**13.*Mst1**2.*Mt**2.)/54.-

     &  (1076881*Mgl**11.*Mst1**4.*Mt**2.)/41472.+

     &  (61297*Mgl**9.*Mst1**6.*Mt**2.)/4608.+

     &  (1729*Mgl**7.*Mst1**8.*Mt**2.)/144.-

     &  (244783*Mgl**5.*Mst1**10.*Mt**2.)/10368.+

     &  (130603*Mgl**3.*Mst1**12.*Mt**2.)/9216.-

     &  (252767*Mgl*Mst1**14.*Mt**2.)/82944.+

     &  (513443*Mgl**13.*Mt**4.)/20736.-

     &  (29935*Mgl**17.*Mt**4.)/(9216.*Mst1**4.)-

     &  (46087*Mgl**15.*Mt**4.)/(20736.*Mst1**2.)-

     &  (49387*Mgl**11.*Mst1**2.*Mt**4.)/768.+

     &  (4001327*Mgl**9.*Mst1**4.*Mt**4.)/41472.-

     &  (194785*Mgl**7.*Mst1**6.*Mt**4.)/2304.+

     &  (322549*Mgl**5.*Mst1**8.*Mt**4.)/6912.-

     &  (76909*Mgl**3.*Mst1**10.*Mt**4.)/6912.-

     &  (204287*Mgl*Mst1**12.*Mt**4.)/82944.-

     &  (8773*Mgl**11.*Mt**6.)/324.+

     &  (208903*Mgl**15.*Mt**6.)/(20736.*Mst1**4.)+

     &  (6037*Mgl**13.*Mt**6.)/(1152.*Mst1**2.)+

     &  (2170241*Mgl**9.*Mst1**2.*Mt**6.)/20736.-

     &  (1397281*Mgl**7.*Mst1**4.*Mt**6.)/20736.+

     &  (58523*Mgl**5.*Mst1**6.*Mt**6.)/1728.+

     &  (114181*Mgl**3.*Mst1**8.*Mt**6.)/10368.+

     &  (287579*Mgl*Mst1**10.*Mt**6.)/6912.+

     &  (53257*Mgl**9.*Mt**8.)/20736.-

     &  (130321*Mgl**13.*Mt**8.)/(6912.*Mst1**4.)+

     &  (147089*Mgl**11.*Mt**8.)/(20736.*Mst1**2.)-

     &  (1129301*Mgl**7.*Mst1**2.*Mt**8.)/10368.-

     &  (79213*Mgl**5.*Mst1**4.*Mt**8.)/2304.-

     &  (393781*Mgl**3.*Mst1**6.*Mt**8.)/6912.-

     &  (1753417*Mgl*Mst1**8.*Mt**8.)/20736.-

     &  (73117*Mgl**7.*Mt**10.)/10368.+

     &  (347875*Mgl**11.*Mt**10.)/(13824.*Mst1**4.)-

     &  (1723099*Mgl**9.*Mt**10.)/(41472.*Mst1**2.)+

     &  (182467*Mgl**5.*Mst1**2.*Mt**10.)/3456.+

     &  (279131*Mgl**3.*Mst1**4.*Mt**10.)/4608.+

     &  (3123599*Mgl*Mst1**6.*Mt**10.)/41472.+

     &  (734645*Mgl**5.*Mt**12.)/20736.-

     &  (1100545*Mgl**9.*Mt**12.)/(41472.*Mst1**4.)+

     &  (137755*Mgl**7.*Mt**12.)/(2304.*Mst1**2.)-

     &  (13717*Mgl**3.*Mst1**2.*Mt**12.)/2304.-

     &  (437495*Mgl*Mst1**4.*Mt**12.)/13824.-

     &  (14329*Mgl**3.*Mt**14.)/576.+

     &  (152185*Mgl**7.*Mt**14.)/(6912.*Mst1**4.)-

     &  (10705*Mgl**5.*Mt**14.)/(288.*Mst1**2.)+

     &  (47645*Mgl*Mst1**2.*Mt**14.)/20736.+

     &  (65215*Mgl*Mt**16.)/20736.-

     &  (89381*Mgl**5.*Mt**16.)/(6912.*Mst1**4.)+

     &  (59489*Mgl**3.*Mt**16.)/(6912.*Mst1**2.)+

     &  (378367*Mgl**3.*Mt**18.)/(82944.*Mst1**4.)+

     &  (1667*Mgl*Mt**18.)/(27648.*Mst1**2.)-

     &  (58895*Mgl*Mt**20.)/(82944.*Mst1**4.)-

     &  (253*Mgl**15.*Mt**2.*z2)/288.+

     &  (Mgl**19.*Mt**2.*z2)/(36.*Mst1**4.)+

     &  (47*Mgl**17.*Mt**2.*z2)/(384.*Mst1**2.)+

     &  (191*Mgl**13.*Mst1**2.*Mt**2.*z2)/96.-

     &  (75*Mgl**11.*Mst1**4.*Mt**2.*z2)/32.+

     &  (511*Mgl**9.*Mst1**6.*Mt**2.*z2)/576.+

     &  (53*Mgl**7.*Mst1**8.*Mt**2.*z2)/32.-

     &  (257*Mgl**5.*Mst1**10.*Mt**2.*z2)/96.+

     &  (443*Mgl**3.*Mst1**12.*Mt**2.*z2)/288.-

     &  (371*Mgl*Mst1**14.*Mt**2.*z2)/1152.+

     &  (2425*Mgl**13.*Mt**4.*z2)/576.-

     &  (19*Mgl**17.*Mt**4.*z2)/(128.*Mst1**4.)-

     &  (599*Mgl**15.*Mt**4.*z2)/(576.*Mst1**2.)-

     &  (4775*Mgl**11.*Mst1**2.*Mt**4.*z2)/576.+

     &  (317*Mgl**9.*Mst1**4.*Mt**4.*z2)/32.-

     &  (4733*Mgl**7.*Mst1**6.*Mt**4.*z2)/576.+

     &  (3239*Mgl**5.*Mst1**8.*Mt**4.*z2)/576.-

     &  (901*Mgl**3.*Mst1**10.*Mt**4.*z2)/576.-

     &  (553*Mgl*Mst1**12.*Mt**4.*z2)/1152.-

     &  (1093*Mgl**11.*Mt**6.*z2)/144.+

     &  (13*Mgl**15.*Mt**6.*z2)/(48.*Mst1**4.)+

     &  (1811*Mgl**13.*Mt**6.*z2)/(576.*Mst1**2.)+

     &  (7597*Mgl**9.*Mst1**2.*Mt**6.*z2)/576.-

     &  (1091*Mgl**7.*Mst1**4.*Mt**6.*z2)/144.+

     &  (3829*Mgl**5.*Mst1**6.*Mt**6.*z2)/576.+

     &  (461*Mgl**3.*Mst1**8.*Mt**6.*z2)/144.+

     &  (905*Mgl*Mst1**10.*Mt**6.*z2)/192.+

     &  (3331*Mgl**9.*Mt**8.*z2)/576.-

     &  (5*Mgl**13.*Mt**8.*z2)/(32.*Mst1**4.)-

     &  (1939*Mgl**11.*Mt**8.*z2)/(576.*Mst1**2.)-

     &  (363*Mgl**7.*Mst1**2.*Mt**8.*z2)/32.-

     &  (463*Mgl**5.*Mst1**4.*Mt**8.*z2)/144.-

     &  (4103*Mgl**3.*Mst1**6.*Mt**8.*z2)/576.-

     &  (4685*Mgl*Mst1**8.*Mt**8.*z2)/576.-

     &  (1141*Mgl**7.*Mt**10.*z2)/288.+

     &  (Mgl**11.*Mt**10.*z2)/(16.*Mst1**4.)-

     &  (4*Mgl**9.*Mt**10.*z2)/(3.*Mst1**2.)+

     &  (353*Mgl**5.*Mst1**2.*Mt**10.*z2)/144.+

     &  (1081*Mgl**3.*Mst1**4.*Mt**10.*z2)/288.+

     &  (217*Mgl*Mst1**6.*Mt**10.*z2)/36.+

     &  (2911*Mgl**5.*Mt**12.*z2)/576.-

     &  (107*Mgl**9.*Mt**12.*z2)/(192.*Mst1**4.)+

     &  (3259*Mgl**7.*Mt**12.*z2)/(576.*Mst1**2.)+

     &  (829*Mgl**3.*Mst1**2.*Mt**12.*z2)/576.-

     &  (221*Mgl*Mst1**4.*Mt**12.*z2)/96.-

     &  (181*Mgl**3.*Mt**14.*z2)/72.+

     &  (59*Mgl**7.*Mt**14.*z2)/(48.*Mst1**4.)-

     &  (2339*Mgl**5.*Mt**14.*z2)/(576.*Mst1**2.)+

     &  (325*Mgl*Mst1**2.*Mt**14.*z2)/576.-

     &  (59*Mgl*Mt**16.*z2)/576.-

     &  (37*Mgl**5.*Mt**16.*z2)/(32.*Mst1**4.)+

     &  (431*Mgl**3.*Mt**16.*z2)/(576.*Mst1**2.)+

     &  (25*Mgl**3.*Mt**18.*z2)/(48.*Mst1**4.)+

     &  (49*Mgl*Mt**18.*z2)/(384.*Mst1**2.)-

     &  (107*Mgl*Mt**20.*z2)/(1152.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)+

     &  Xt*((-3505*Mgl**5.)/6912.+Mgl**7./(8.*Mst2**2.)-

     &  (22619*Mgl**3.*Mst2**2.)/20736.+

     &  (5987*Mgl*Mst2**4.)/10368.-

     &  (13*Mst2**6.)/(48.*Mgl**1.)+

     &  (4231*Mgl**7.)/(20736.*Mt**2.)-

     &  (113*Mgl**5.*Mst2**2.)/(2304.*Mt**2.)-

     &  (3553*Mgl**3.*Mst2**4.)/(6912.*Mt**2.)+

     &  (7445*Mgl*Mst2**6.)/(20736.*Mt**2.)+

     &  (25829*Mgl**3.*Mt**2.)/20736.-

     &  (4529*Mgl**7.*Mt**2.)/(20736.*Mst2**4.)-

     &  (601*Mgl**5.*Mt**2.)/(3456.*Mst2**2.)+

     &  (51061*Mgl*Mst2**2.*Mt**2.)/20736.+

     &  (95*Mst2**4.*Mt**2.)/(288.*Mgl**1.)-

     &  (5*Mst2**6.*Mt**2.)/(36.*Mgl**3.)+

     &  (245*Mgl*Mt**4.)/162.+

     &  (2773*Mgl**5.*Mt**4.)/(6912.*Mst2**4.)-

     &  (9613*Mgl**3.*Mt**4.)/(6912.*Mst2**2.)-

     &  (271*Mst2**2.*Mt**4.)/(864.*Mgl**1.)+

     &  (5*Mst2**4.*Mt**4.)/(9.*Mgl**3.)+

     &  (137*Mt**6.)/(216.*Mgl**1.)-

     &  (539*Mgl**3.*Mt**6.)/(2304.*Mst2**4.)+

     &  (4117*Mgl*Mt**6.)/(20736.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**6.)/(6.*Mgl**3.)+

     &  (5*Mt**8.)/(9.*Mgl**3.)+

     &  (2861*Mgl*Mt**8.)/(20736.*Mst2**4.)-

     &  (253*Mt**8.)/(864.*Mgl**1.*Mst2**2.)-

     &  (25*Mt**10.)/(288.*Mgl**1.*Mst2**4.)-

     &  (5*Mt**10.)/(36.*Mgl**3.*Mst2**2.)-

     &  (Mgl**5.*z2)/64.-(221*Mgl**3.*Mst2**2.*z2)/576.+

     &  (47*Mgl*Mst2**4.*z2)/288.+

     &  (23*Mgl**7.*z2)/(288.*Mt**2.)-

     &  (7*Mgl**5.*Mst2**2.*z2)/(48.*Mt**2.)+

     &  (5*Mgl**3.*Mst2**4.*z2)/(96.*Mt**2.)+

     &  (Mgl*Mst2**6.*z2)/(72.*Mt**2.)-

     &  (217*Mgl**3.*Mt**2.*z2)/576.-

     &  (Mgl**7.*Mt**2.*z2)/(36.*Mst2**4.)+

     &  (7*Mgl**5.*Mt**2.*z2)/(288.*Mst2**2.)+

     &  (3*Mgl*Mst2**2.*Mt**2.*z2)/32.+

     &  (101*Mgl*Mt**4.*z2)/576.+

     &  (7*Mgl**5.*Mt**4.*z2)/(288.*Mst2**4.)-

     &  (365*Mgl**3.*Mt**4.*z2)/(576.*Mst2**2.)+

     &  (5*Mgl**3.*Mt**6.*z2)/(144.*Mst2**4.)+

     &  (79*Mgl*Mt**6.*z2)/(576.*Mst2**2.)-

     &  (Mgl*Mt**8.*z2)/(32.*Mst2**4.))*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)+

     &  Xt*((129095*Mgl**9.)/41472.-

     &  (7*Mgl**11.)/(32.*Mst2**2.)+

     &  (32147*Mgl**7.*Mst2**2.)/20736.-

     &  (78793*Mgl**5.*Mst2**4.)/10368.+

     &  (19879*Mgl**3.*Mst2**6.)/6912.-

     &  (4259*Mgl*Mst2**8.)/41472.+

     &  (55*Mst2**10.)/(144.*Mgl**1.)-

     &  (2263*Mgl**11.)/(13824.*Mt**2.)+

     &  (6557*Mgl**9.*Mst2**2.)/(41472.*Mt**2.)+

     &  (12887*Mgl**7.*Mst2**4.)/(20736.*Mt**2.)-

     &  (8129*Mgl**5.*Mst2**6.)/(6912.*Mt**2.)+

     &  (27943*Mgl**3.*Mst2**8.)/(41472.*Mt**2.)-

     &  (4711*Mgl*Mst2**10.)/(41472.*Mt**2.)-

     &  (97777*Mgl**7.*Mt**2.)/20736.+

     &  (5263*Mgl**11.*Mt**2.)/(41472.*Mst2**4.)-

     &  (35917*Mgl**9.*Mt**2.)/(41472.*Mst2**2.)-

     &  (57925*Mgl**5.*Mst2**2.*Mt**2.)/5184.+

     &  (473855*Mgl**3.*Mst2**4.*Mt**2.)/41472.-

     &  (45485*Mgl*Mst2**6.*Mt**2.)/13824.-

     &  (113*Mst2**8.*Mt**2.)/(108.*Mgl**1.)+

     &  (7*Mst2**10.*Mt**2.)/(288.*Mgl**3.)+

     &  (8083*Mgl**5.*Mt**4.)/10368.-

     &  (10169*Mgl**9.*Mt**4.)/(13824.*Mst2**4.)+

     &  (79973*Mgl**7.*Mt**4.)/(20736.*Mst2**2.)+

     &  (130549*Mgl**3.*Mst2**2.*Mt**4.)/10368.+

     &  (39025*Mgl*Mst2**4.*Mt**4.)/4608.+

     &  (787*Mst2**6.*Mt**4.)/(432.*Mgl**1.)-

     &  (7*Mst2**8.*Mt**4.)/(48.*Mgl**3.)-

     &  (98141*Mgl**3.*Mt**6.)/41472.+

     &  (24715*Mgl**7.*Mt**6.)/(20736.*Mst2**4.)-

     &  (4769*Mgl**5.*Mt**6.)/(1728.*Mst2**2.)-

     &  (10583*Mgl*Mst2**2.*Mt**6.)/4608.-

     &  (229*Mst2**4.*Mt**6.)/(54.*Mgl**1.)+

     &  (35*Mst2**6.*Mt**6.)/(96.*Mgl**3.)+

     &  (36155*Mgl*Mt**8.)/13824.-

     &  (13547*Mgl**5.*Mt**8.)/(20736.*Mst2**4.)+

     &  (9803*Mgl**3.*Mt**8.)/(20736.*Mst2**2.)+

     &  (2723*Mst2**2.*Mt**8.)/(432.*Mgl**1.)-

     &  (35*Mst2**4.*Mt**8.)/(72.*Mgl**3.)-

     &  (433*Mt**10.)/(108.*Mgl**1.)+

     &  (401*Mgl**3.*Mt**10.)/(1536.*Mst2**4.)-

     &  (44635*Mgl*Mt**10.)/(41472.*Mst2**2.)+

     &  (35*Mst2**2.*Mt**10.)/(96.*Mgl**3.)-

     &  (7*Mt**12.)/(48.*Mgl**3.)-

     &  (17135*Mgl*Mt**12.)/(41472.*Mst2**4.)+

     &  (245*Mt**12.)/(432.*Mgl**1.*Mst2**2.)+

     &  (2*Mt**14.)/(9.*Mgl**1.*Mst2**4.)+

     &  (7*Mt**14.)/(288.*Mgl**3.*Mst2**2.)+

     &  (241*Mgl**9.*z2)/288.-

     &  (233*Mgl**7.*Mst2**2.*z2)/576.-

     &  (53*Mgl**5.*Mst2**4.*z2)/64.+

     &  (85*Mgl**3.*Mst2**6.*z2)/576.+

     &  (143*Mgl*Mst2**8.*z2)/576.-

     &  (5*Mgl**11.*z2)/(64.*Mt**2.)+

     &  (17*Mgl**9.*Mst2**2.*z2)/(72.*Mt**2.)-

     &  (65*Mgl**7.*Mst2**4.*z2)/(288.*Mt**2.)+

     &  (Mgl**5.*Mst2**6.*z2)/(24.*Mt**2.)+

     &  (23*Mgl**3.*Mst2**8.*z2)/(576.*Mt**2.)-

     &  (Mgl*Mst2**10.*z2)/(72.*Mt**2.)-

     &  (263*Mgl**7.*Mt**2.*z2)/192.+

     &  (Mgl**11.*Mt**2.*z2)/(36.*Mst2**4.)-

     &  (131*Mgl**9.*Mt**2.*z2)/(576.*Mst2**2.)-

     &  (637*Mgl**5.*Mst2**2.*Mt**2.*z2)/288.+

     &  (131*Mgl**3.*Mst2**4.*Mt**2.*z2)/64.-

     &  (385*Mgl*Mst2**6.*Mt**2.*z2)/576.-

     &  (113*Mgl**5.*Mt**4.*z2)/144.-

     &  (25*Mgl**9.*Mt**4.*z2)/(192.*Mst2**4.)+

     &  (235*Mgl**7.*Mt**4.*z2)/(192.*Mst2**2.)+

     &  (57*Mgl**3.*Mst2**2.*Mt**4.*z2)/32.+

     &  (19*Mgl*Mst2**4.*Mt**4.*z2)/12.-

     &  (23*Mgl**3.*Mt**6.*z2)/72.+

     &  (17*Mgl**7.*Mt**6.*z2)/(144.*Mst2**4.)-

     &  (809*Mgl**5.*Mt**6.*z2)/(576.*Mst2**2.)-

     &  (239*Mgl*Mst2**2.*Mt**6.*z2)/576.-

     &  (77*Mgl*Mt**8.*z2)/144.+

     &  (43*Mgl**5.*Mt**8.*z2)/(288.*Mst2**4.)+

     &  (11*Mgl**3.*Mt**8.*z2)/(64.*Mst2**2.)-

     &  (13*Mgl**3.*Mt**10.*z2)/(48.*Mst2**4.)+

     &  (17*Mgl*Mt**10.*z2)/(72.*Mst2**2.)+

     &  (61*Mgl*Mt**12.*z2)/(576.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)+

     &  Xt*((-54289*Mgl**13.)/20736.+

     &  (19*Mgl**15.)/(216.*Mst2**2.)-

     &  (8573*Mgl**11.*Mst2**2.)/20736.+

     &  (43103*Mgl**9.*Mst2**4.)/2592.-

     &  (219653*Mgl**7.*Mst2**6.)/10368.+

     &  (112463*Mgl**5.*Mst2**8.)/20736.+

     &  (67799*Mgl**3.*Mst2**10.)/20736.-

     &  (11507*Mgl*Mst2**12.)/10368.-

     &  Mst2**14./(12.*Mgl**1.)+

     &  (419*Mgl**15.)/(6912.*Mt**2.)+

     &  (1777*Mgl**13.*Mst2**2.)/(20736.*Mt**2.)-

     &  (6097*Mgl**11.*Mst2**4.)/(6912.*Mt**2.)+

     &  (6935*Mgl**9.*Mst2**6.)/(6912.*Mt**2.)+

     &  (20155*Mgl**7.*Mst2**8.)/(20736.*Mt**2.)-

     &  (18479*Mgl**5.*Mst2**10.)/(6912.*Mt**2.)+

     &  (13061*Mgl**3.*Mst2**12.)/(6912.*Mt**2.)-

     &  (9449*Mgl*Mst2**14.)/(20736.*Mt**2.)+

     &  (59797*Mgl**11.*Mt**2.)/20736.+

     &  (3685*Mgl**15.*Mt**2.)/(6912.*Mst2**4.)+

     &  (1867*Mgl**13.*Mt**2.)/(1152.*Mst2**2.)+

     &  (403805*Mgl**9.*Mst2**2.*Mt**2.)/20736.-

     &  (323641*Mgl**7.*Mst2**4.*Mt**2.)/6912.+

     &  (168265*Mgl**5.*Mst2**6.*Mt**2.)/5184.-

     &  (115987*Mgl**3.*Mst2**8.*Mt**2.)/6912.+

     &  (132929*Mgl*Mst2**10.*Mt**2.)/20736.+

     &  (193*Mst2**12.*Mt**2.)/(864.*Mgl**1.)-

     &  (28777*Mgl**9.*Mt**4.)/10368.-

     &  (53425*Mgl**13.*Mt**4.)/(20736.*Mst2**4.)-

     &  (49739*Mgl**11.*Mt**4.)/(6912.*Mst2**2.)-

     &  (27467*Mgl**7.*Mst2**2.*Mt**4.)/648.+

     &  (259159*Mgl**5.*Mst2**4.*Mt**4.)/6912.+

     &  (518785*Mgl**3.*Mst2**6.*Mt**4.)/20736.-

     &  (73247*Mgl*Mst2**8.*Mt**4.)/3456.-

     &  (97*Mst2**10.*Mt**4.)/(288.*Mgl**1.)+

     &  (51845*Mgl**7.*Mt**6.)/6912.+

     &  (115627*Mgl**11.*Mt**6.)/(20736.*Mst2**4.)+

     &  (102203*Mgl**9.*Mt**6.)/(20736.*Mst2**2.)+

     &  (358349*Mgl**5.*Mst2**2.*Mt**6.)/20736.-

     &  (318593*Mgl**3.*Mst2**4.*Mt**6.)/10368.+

     &  (28687*Mgl*Mst2**6.*Mt**6.)/1296.+

     &  (67*Mst2**8.*Mt**6.)/(36.*Mgl**1.)+

     &  (128015*Mgl**5.*Mt**8.)/20736.-

     &  (169549*Mgl**9.*Mt**8.)/(20736.*Mst2**4.)+

     &  (156679*Mgl**7.*Mt**8.)/(10368.*Mst2**2.)+

     &  (95735*Mgl**3.*Mst2**2.*Mt**8.)/6912.-

     &  (50381*Mgl*Mst2**4.*Mt**8.)/20736.-

     &  (5273*Mst2**6.*Mt**8.)/(864.*Mgl**1.)-

     &  (82583*Mgl**3.*Mt**10.)/6912.+

     &  (200693*Mgl**7.*Mt**10.)/(20736.*Mst2**4.)-

     &  (132421*Mgl**5.*Mt**10.)/(5184.*Mst2**2.)-

     &  (4537*Mgl*Mst2**2.*Mt**10.)/6912.+

     &  (37*Mst2**4.*Mt**10.)/(4.*Mgl**1.)-

     &  (2503*Mgl*Mt**12.)/1728.-

     &  (169027*Mgl**5.*Mt**12.)/(20736.*Mst2**4.)+

     &  (27059*Mgl**3.*Mt**12.)/(2304.*Mst2**2.)-

     &  (1991*Mst2**2.*Mt**12.)/(288.*Mgl**1.)+

     &  (469*Mt**14.)/(216.*Mgl**1.)+

     &  (76393*Mgl**3.*Mt**14.)/(20736.*Mst2**4.)-

     &  (5663*Mgl*Mt**14.)/(6912.*Mst2**2.)-

     &  (8959*Mgl*Mt**16.)/(20736.*Mst2**4.)+

     &  (19*Mt**16.)/(288.*Mgl**1.*Mst2**2.)-

     &  (13*Mt**18.)/(96.*Mgl**1.*Mst2**4.)-

     &  (463*Mgl**13.*z2)/576.+

     &  (283*Mgl**11.*Mst2**2.*z2)/192.+

     &  (9*Mgl**9.*Mst2**4.*z2)/16.-

     &  (599*Mgl**7.*Mst2**6.*z2)/288.+

     &  (35*Mgl**5.*Mst2**8.*z2)/192.+

     &  (69*Mgl**3.*Mst2**10.*z2)/64.-

     &  (119*Mgl*Mst2**12.*z2)/288.+

     &  (Mgl**15.*z2)/(32.*Mt**2.)-

     &  (11*Mgl**13.*Mst2**2.*z2)/(144.*Mt**2.)-

     &  (7*Mgl**11.*Mst2**4.*z2)/(96.*Mt**2.)+

     &  (5*Mgl**9.*Mst2**6.*z2)/(12.*Mt**2.)-

     &  (145*Mgl**7.*Mst2**8.*z2)/(288.*Mt**2.)+

     &  (11*Mgl**5.*Mst2**10.*z2)/(48.*Mt**2.)-

     &  (Mgl**3.*Mst2**12.*z2)/(96.*Mt**2.)-

     &  (Mgl*Mst2**14.*z2)/(72.*Mt**2.)+

     &  (1597*Mgl**11.*Mt**2.*z2)/576.+

     &  (Mgl**15.*Mt**2.*z2)/(36.*Mst2**4.)+

     &  (97*Mgl**13.*Mt**2.*z2)/(288.*Mst2**2.)-

     &  (251*Mgl**9.*Mst2**2.*Mt**2.*z2)/288.-

     &  (1741*Mgl**7.*Mst2**4.*Mt**2.*z2)/288.+

     &  (1553*Mgl**5.*Mst2**6.*Mt**2.*z2)/288.-

     &  (1579*Mgl**3.*Mst2**8.*Mt**2.*z2)/576.+

     &  (325*Mgl*Mst2**10.*Mt**2.*z2)/288.-

     &  (2423*Mgl**9.*Mt**4.*z2)/576.-

     &  (17*Mgl**13.*Mt**4.*z2)/(288.*Mst2**4.)-

     &  (995*Mgl**11.*Mt**4.*z2)/(576.*Mst2**2.)-

     &  (401*Mgl**7.*Mst2**2.*Mt**4.*z2)/72.+

     &  (1547*Mgl**5.*Mst2**4.*Mt**4.*z2)/288.+

     &  (267*Mgl**3.*Mst2**6.*Mt**4.*z2)/64.-

     &  (583*Mgl*Mst2**8.*Mt**4.*z2)/192.+

     &  (295*Mgl**7.*Mt**6.*z2)/72.-

     &  (Mgl**11.*Mt**6.*z2)/(48.*Mst2**4.)+

     &  (1457*Mgl**9.*Mt**6.*z2)/(576.*Mst2**2.)+

     &  (1223*Mgl**5.*Mst2**2.*Mt**6.*z2)/288.-

     &  (455*Mgl**3.*Mst2**4.*Mt**6.*z2)/144.+

     &  (1873*Mgl*Mst2**6.*Mt**6.*z2)/576.+

     &  (55*Mgl**5.*Mt**8.*z2)/576.-

     &  (19*Mgl**9.*Mt**8.*z2)/(288.*Mst2**4.)+

     &  (137*Mgl**7.*Mt**8.*z2)/(288.*Mst2**2.)+

     &  (599*Mgl**3.*Mst2**2.*Mt**8.*z2)/576.+

     &  (155*Mgl*Mst2**4.*Mt**8.*z2)/288.-

     &  (1903*Mgl**3.*Mt**10.*z2)/576.+

     &  (49*Mgl**7.*Mt**10.*z2)/(72.*Mst2**4.)-

     &  (511*Mgl**5.*Mt**10.*z2)/(144.*Mst2**2.)-

     &  (113*Mgl*Mst2**2.*Mt**10.*z2)/48.+

     &  (253*Mgl*Mt**12.*z2)/192.-

     &  (109*Mgl**5.*Mt**12.*z2)/(96.*Mst2**4.)+

     &  (1249*Mgl**3.*Mt**12.*z2)/(576.*Mst2**2.)+

     &  (109*Mgl**3.*Mt**14.*z2)/(144.*Mst2**4.)-

     &  (15*Mgl*Mt**14.*z2)/(64.*Mst2**2.)-

     &  (53*Mgl*Mt**16.*z2)/(288.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)+

     &  Xt*((11357*Mgl**17.)/27648.+

     &  (453*Mgl**15.*Mst2**2.)/256.-

     &  (977*Mgl**13.*Mst2**4.)/72.+

     &  (549685*Mgl**11.*Mst2**6.)/20736.-

     &  (816565*Mgl**9.*Mst2**8.)/41472.+

     &  (2551*Mgl**7.*Mst2**10.)/20736.+

     &  (78391*Mgl**5.*Mst2**12.)/10368.-

     &  (73249*Mgl**3.*Mst2**14.)/20736.+

     &  (34715*Mgl*Mst2**16.)/82944.-

     &  (305*Mgl**19.)/(9216.*Mt**2.)+

     &  (3073*Mgl**17.*Mst2**2.)/(82944.*Mt**2.)+

     &  (7735*Mgl**15.*Mst2**4.)/(20736.*Mt**2.)-

     &  (18011*Mgl**13.*Mst2**6.)/(20736.*Mt**2.)-

     &  (21847*Mgl**11.*Mst2**8.)/(41472.*Mt**2.)+

     &  (173495*Mgl**9.*Mst2**10.)/(41472.*Mt**2.)-

     &  (133637*Mgl**7.*Mst2**12.)/(20736.*Mt**2.)+

     &  (100585*Mgl**5.*Mst2**14.)/(20736.*Mt**2.)-

     &  (154721*Mgl**3.*Mst2**16.)/(82944.*Mt**2.)+

     &  (24409*Mgl*Mst2**18.)/(82944.*Mt**2.)+

     &  (57239*Mgl**15.*Mt**2.)/20736.-

     &  (38375*Mgl**19.*Mt**2.)/(82944.*Mst2**4.)-

     &  (12517*Mgl**17.*Mt**2.)/(82944.*Mst2**2.)-

     &  (25303*Mgl**13.*Mst2**2.*Mt**2.)/1296.+

     &  (2192431*Mgl**11.*Mst2**4.*Mt**2.)/41472.-

     &  (803407*Mgl**9.*Mst2**6.*Mt**2.)/13824.+

     &  (8275*Mgl**7.*Mst2**8.*Mt**2.)/256.-

     &  (219311*Mgl**5.*Mst2**10.*Mt**2.)/10368.+

     &  (1382305*Mgl**3.*Mst2**12.*Mt**2.)/82944.-

     &  (48001*Mgl*Mst2**14.*Mt**2.)/9216.-

     &  (58951*Mgl**13.*Mt**4.)/5184.+

     &  (29935*Mgl**17.*Mt**4.)/(9216.*Mst2**4.)+

     &  (46087*Mgl**15.*Mt**4.)/(20736.*Mst2**2.)+

     &  (56035*Mgl**11.*Mst2**2.*Mt**4.)/1152.-

     &  (445747*Mgl**9.*Mst2**4.*Mt**4.)/4608.+

     &  (156827*Mgl**7.*Mst2**6.*Mt**4.)/2304.+

     &  (539*Mgl**5.*Mst2**8.*Mt**4.)/5184.-

     &  (11015*Mgl**3.*Mst2**10.*Mt**4.)/324.+

     &  (182647*Mgl*Mst2**12.*Mt**4.)/9216.+

     &  (358405*Mgl**11.*Mt**6.)/41472.-

     &  (208903*Mgl**15.*Mt**6.)/(20736.*Mst2**4.)-

     &  (6037*Mgl**13.*Mt**6.)/(1152.*Mst2**2.)-

     &  (1999469*Mgl**9.*Mst2**2.*Mt**6.)/41472.+

     &  (297937*Mgl**7.*Mst2**4.*Mt**6.)/3456.-

     &  (611243*Mgl**5.*Mst2**6.*Mt**6.)/20736.+

     &  (556159*Mgl**3.*Mst2**8.*Mt**6.)/13824.-

     &  (1551497*Mgl*Mst2**10.*Mt**6.)/41472.+

     &  (211495*Mgl**9.*Mt**8.)/41472.+

     &  (130321*Mgl**13.*Mt**8.)/(6912.*Mst2**4.)-

     &  (147089*Mgl**11.*Mt**8.)/(20736.*Mst2**2.)+

     &  (87745*Mgl**7.*Mst2**2.*Mt**8.)/20736.-

     &  (1632463*Mgl**5.*Mst2**4.*Mt**8.)/20736.-

     &  (34069*Mgl**3.*Mst2**6.*Mt**8.)/648.+

     &  (1071217*Mgl*Mst2**8.*Mt**8.)/41472.+

     &  (362767*Mgl**7.*Mt**10.)/20736.-

     &  (347875*Mgl**11.*Mt**10.)/(13824.*Mst2**4.)+

     &  (1723099*Mgl**9.*Mt**10.)/(41472.*Mst2**2.)+

     &  (152335*Mgl**5.*Mst2**2.*Mt**10.)/2592.+

     &  (3139223*Mgl**3.*Mst2**4.*Mt**10.)/41472.+

     &  (156707*Mgl*Mst2**6.*Mt**10.)/13824.-

     &  (60709*Mgl**5.*Mt**12.)/1152.+

     &  (1100545*Mgl**9.*Mt**12.)/(41472.*Mst2**4.)-

     &  (137755*Mgl**7.*Mt**12.)/(2304.*Mst2**2.)-

     &  (324919*Mgl**3.*Mst2**2.*Mt**12.)/5184.-

     &  (1126487*Mgl*Mst2**4.*Mt**12.)/41472.+

     &  (2921623*Mgl**3.*Mt**14.)/82944.-

     &  (152185*Mgl**7.*Mt**14.)/(6912.*Mst2**4.)+

     &  (10705*Mgl**5.*Mt**14.)/(288.*Mst2**2.)+

     &  (1406969*Mgl*Mst2**2.*Mt**14.)/82944.-

     &  (458509*Mgl*Mt**16.)/82944.+

     &  (89381*Mgl**5.*Mt**16.)/(6912.*Mst2**4.)-

     &  (59489*Mgl**3.*Mt**16.)/(6912.*Mst2**2.)-

     &  (378367*Mgl**3.*Mt**18.)/(82944.*Mst2**4.)-

     &  (1667*Mgl*Mt**18.)/(27648.*Mst2**2.)+

     &  (58895*Mgl*Mt**20.)/(82944.*Mst2**4.)+

     &  (197*Mgl**17.*z2)/1152.-

     &  (73*Mgl**15.*Mst2**2.*z2)/192.-

     &  (365*Mgl**13.*Mst2**4.*z2)/576.+

     &  (1585*Mgl**11.*Mst2**6.*z2)/576.-

     &  (35*Mgl**9.*Mst2**8.*z2)/12.+

     &  (319*Mgl**7.*Mst2**10.*z2)/576.+

     &  (589*Mgl**5.*Mst2**12.*z2)/576.-

     &  (45*Mgl**3.*Mst2**14.*z2)/64.+

     &  (155*Mgl*Mst2**16.*z2)/1152.-

     &  (13*Mgl**19.*z2)/(1152.*Mt**2.)+

     &  (Mgl**17.*Mst2**2.*z2)/(24.*Mt**2.)+

     &  (Mgl**15.*Mst2**4.*z2)/(96.*Mt**2.)-

     &  (7*Mgl**13.*Mst2**6.*z2)/(24.*Mt**2.)+

     &  (119*Mgl**11.*Mst2**8.*z2)/(192.*Mt**2.)-

     &  (7*Mgl**9.*Mst2**10.*z2)/(12.*Mt**2.)+

     &  (7*Mgl**7.*Mst2**12.*z2)/(32.*Mt**2.)+

     &  (Mgl**5.*Mst2**14.*z2)/(24.*Mt**2.)-

     &  (23*Mgl**3.*Mst2**16.*z2)/(384.*Mt**2.)+

     &  (Mgl*Mst2**18.*z2)/(72.*Mt**2.)-

     &  (319*Mgl**15.*Mt**2.*z2)/576.-

     &  (Mgl**19.*Mt**2.*z2)/(36.*Mst2**4.)-

     &  (47*Mgl**17.*Mt**2.*z2)/(384.*Mst2**2.)+

     &  (101*Mgl**13.*Mst2**2.*Mt**2.*z2)/96.+

     &  (1583*Mgl**11.*Mst2**4.*Mt**2.*z2)/576.-

     &  (3649*Mgl**9.*Mst2**6.*Mt**2.*z2)/576.+

     &  (2431*Mgl**7.*Mst2**8.*Mt**2.*z2)/576.-

     &  (535*Mgl**5.*Mst2**10.*Mt**2.*z2)/288.+

     &  (833*Mgl**3.*Mst2**12.*Mt**2.*z2)/576.-

     &  (73*Mgl*Mst2**14.*Mt**2.*z2)/128.+

     &  (355*Mgl**13.*Mt**4.*z2)/288.+

     &  (19*Mgl**17.*Mt**4.*z2)/(128.*Mst2**4.)+

     &  (599*Mgl**15.*Mt**4.*z2)/(576.*Mst2**2.)-

     &  (97*Mgl**11.*Mst2**2.*Mt**4.*z2)/288.-

     &  (2525*Mgl**9.*Mst2**4.*Mt**4.*z2)/288.+

     &  (515*Mgl**7.*Mst2**6.*Mt**4.*z2)/64.-

     &  (11*Mgl**5.*Mst2**8.*Mt**4.*z2)/72.-

     &  (53*Mgl**3.*Mst2**10.*Mt**4.*z2)/18.+

     &  (1997*Mgl*Mst2**12.*Mt**4.*z2)/1152.-

     &  (869*Mgl**11.*Mt**6.*z2)/288.-

     &  (13*Mgl**15.*Mt**6.*z2)/(48.*Mst2**4.)-

     &  (1811*Mgl**13.*Mt**6.*z2)/(576.*Mst2**2.)-

     &  (365*Mgl**9.*Mst2**2.*Mt**6.*z2)/192.+

     &  (1649*Mgl**7.*Mst2**4.*Mt**6.*z2)/144.-

     &  (695*Mgl**5.*Mst2**6.*Mt**6.*z2)/192.+

     &  (137*Mgl**3.*Mst2**8.*Mt**6.*z2)/32.-

     &  (1793*Mgl*Mst2**10.*Mt**6.*z2)/576.+

     &  (1027*Mgl**9.*Mt**8.*z2)/192.+

     &  (5*Mgl**13.*Mt**8.*z2)/(32.*Mst2**4.)+

     &  (1939*Mgl**11.*Mt**8.*z2)/(576.*Mst2**2.)+

     &  (323*Mgl**7.*Mst2**2.*Mt**8.*z2)/192.-

     &  (6241*Mgl**5.*Mst2**4.*Mt**8.*z2)/576.-

     &  (41*Mgl**3.*Mst2**6.*Mt**8.*z2)/6.+

     &  (401*Mgl*Mst2**8.*Mt**8.*z2)/288.-

     &  (1061*Mgl**7.*Mt**10.*z2)/576.-

     &  (Mgl**11.*Mt**10.*z2)/(16.*Mst2**4.)+

     &  (4*Mgl**9.*Mt**10.*z2)/(3.*Mst2**2.)+

     &  (419*Mgl**5.*Mst2**2.*Mt**10.*z2)/72.+

     &  (639*Mgl**3.*Mst2**4.*Mt**10.*z2)/64.+

     &  (689*Mgl*Mst2**6.*Mt**10.*z2)/288.-

     &  (413*Mgl**5.*Mt**12.*z2)/96.+

     &  (107*Mgl**9.*Mt**12.*z2)/(192.*Mst2**4.)-

     &  (3259*Mgl**7.*Mt**12.*z2)/(576.*Mst2**2.)-

     &  (111*Mgl**3.*Mst2**2.*Mt**12.*z2)/16.-

     &  (205*Mgl*Mst2**4.*Mt**12.*z2)/72.+

     &  (3497*Mgl**3.*Mt**14.*z2)/1152.-

     &  (59*Mgl**7.*Mt**14.*z2)/(48.*Mst2**4.)+

     &  (2339*Mgl**5.*Mt**14.*z2)/(576.*Mst2**2.)+

     &  (553*Mgl*Mst2**2.*Mt**14.*z2)/576.-

     &  (71*Mgl*Mt**16.*z2)/1152.+

     &  (37*Mgl**5.*Mt**16.*z2)/(32.*Mst2**4.)-

     &  (431*Mgl**3.*Mt**16.*z2)/(576.*Mst2**2.)-

     &  (25*Mgl**3.*Mt**18.*z2)/(48.*Mst2**4.)-

     &  (49*Mgl*Mt**18.*z2)/(384.*Mst2**2.)+

     &  (107*Mgl*Mt**20.*z2)/(1152.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)+

     &  (0.03927951388888889-

     &  (127*Mgl**4.)/(9216.*Mst1**4.)-

     &  (35*Mgl**2.)/(4608.*Mst1**2.)-

     &  (47*Mst1**2.)/(576.*Mgl**2.)-

     &  (7*Mst1**4.)/(576.*Mgl**4.)-

     &  (127*Mgl**4.)/(9216.*Mst2**4.)-

     &  (35*Mgl**2.)/(4608.*Mst2**2.)-

     &  (59*Mst2**2.)/(576.*Mgl**2.)-

     &  (7*Mst2**4.)/(576.*Mgl**4.)+

     &  Mgl**2./(72.*Mt**2.)+

     &  Mgl**4./(96.*Mst1**2.*Mt**2.)-

     &  (13*Mst1**2.)/(288.*Mt**2.)+

     &  Mgl**4./(96.*Mst2**2.*Mt**2.)-

     &  Mst2**2./(48.*Mt**2.)+

     &  Mst2**4./(96.*Mgl**2.*Mt**2.)+

     &  (67*Mt**2.)/(288.*Mgl**2.)-

     &  (7*Mt**2.)/(768.*Mst1**2.)+

     &  (7*Mst1**2.*Mt**2.)/(192.*Mgl**4.)-

     &  (7*Mt**2.)/(768.*Mst2**2.)+

     &  (7*Mst2**2.*Mt**2.)/(192.*Mgl**4.)-

     &  (7*Mt**4.)/(96.*Mgl**4.)+

     &  (127*Mt**4.)/(9216.*Mst1**4.)-

     &  (17*Mt**4.)/(576.*Mgl**2.*Mst1**2.)+

     &  (127*Mt**4.)/(9216.*Mst2**4.)-

     &  (17*Mt**4.)/(576.*Mgl**2.*Mst2**2.)+

     &  (7*Mt**6.)/(576.*Mgl**4.*Mst1**2.)+

     &  (7*Mt**6.)/(576.*Mgl**4.*Mst2**2.))*ln(mu,Mgl)+

     &  ((-349*Mgl**4.)/1152.-

     &  (17*Mgl**8.)/(2304.*Mst1**4.)+

     &  (43*Mgl**6.)/(864.*Mst1**2.)+

     &  (101*Mgl**2.*Mst1**2.)/576.-(95*Mst1**4.)/6912.+

     &  (9*Mst1**6.)/(64.*Mgl**2.)+

     &  Mst1**8./(72.*Mgl**4.)-Mgl**6./(32.*Mt**2.)+

     &  Mgl**8./(96.*Mst1**2.*Mt**2.)+

     &  (23*Mgl**4.*Mst1**2.)/(288.*Mt**2.)-

     &  (31*Mgl**2.*Mst1**4.)/(288.*Mt**2.)+

     &  (7*Mst1**6.)/(144.*Mt**2.)-

     &  (625*Mgl**2.*Mt**2.)/3456.+

     &  (5*Mgl**6.*Mt**2.)/(576.*Mst1**4.)-

     &  (1039*Mgl**4.*Mt**2.)/(3456.*Mst1**2.)+

     &  (403*Mst1**2.*Mt**2.)/1728.-

     &  (37*Mst1**4.*Mt**2.)/(96.*Mgl**2.)-

     &  (5*Mst1**6.*Mt**2.)/(72.*Mgl**4.)-

     &  (251*Mt**4.)/864.+

     &  (Mgl**4.*Mt**4.)/(1152.*Mst1**4.)-

     &  (41*Mgl**2.*Mt**4.)/(108.*Mst1**2.)+

     &  (61*Mst1**2.*Mt**4.)/(192.*Mgl**2.)+

     &  (5*Mst1**4.*Mt**4.)/(36.*Mgl**4.)-

     &  (3*Mt**6.)/(64.*Mgl**2.)-

     &  (Mgl**2.*Mt**6.)/(288.*Mst1**4.)+

     &  (55*Mt**6.)/(3456.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**6.)/(36.*Mgl**4.)+

     &  (5*Mt**8.)/(72.*Mgl**4.)+

     &  (5*Mt**8.)/(768.*Mst1**4.)-

     &  Mt**8./(48.*Mgl**2.*Mst1**2.)-

     &  Mt**10./(192.*Mgl**2.*Mst1**4.)-

     &  Mt**10./(72.*Mgl**4.*Mst1**2.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mgl)+((18925*Mgl**8.)/13824.+

     &  (127*Mgl**12.)/(4608.*Mst1**4.)-

     &  (2161*Mgl**10.)/(6912.*Mst1**2.)-

     &  (6233*Mgl**6.*Mst1**2.)/3456.+

     &  (287*Mgl**4.*Mst1**4.)/13824.+

     &  (8215*Mgl**2.*Mst1**6.)/6912.-

     &  (5377*Mst1**8.)/13824.-

     &  (19*Mst1**10.)/(192.*Mgl**2.)-

     &  Mst1**12./(576.*Mgl**4.)+

     &  (55*Mgl**10.)/(288.*Mt**2.)-

     &  (5*Mgl**12.)/(144.*Mst1**2.*Mt**2.)-

     &  (121*Mgl**8.*Mst1**2.)/(288.*Mt**2.)+

     &  (67*Mgl**6.*Mst1**4.)/(144.*Mt**2.)-

     &  (19*Mgl**4.*Mst1**6.)/(72.*Mt**2.)+

     &  (19*Mgl**2.*Mst1**8.)/(288.*Mt**2.)-

     &  Mst1**10./(288.*Mt**2.)-

     &  (2443*Mgl**6.*Mt**2.)/864.-

     &  (67*Mgl**10.*Mt**2.)/(576.*Mst1**4.)+

     &  (4949*Mgl**8.*Mt**2.)/(3456.*Mst1**2.)+

     &  (2515*Mgl**4.*Mst1**2.*Mt**2.)/1728.+

     &  (943*Mgl**2.*Mst1**4.*Mt**2.)/576.-

     &  (35*Mst1**6.*Mt**2.)/128.+

     &  (25*Mst1**8.*Mt**2.)/(72.*Mgl**2.)+

     &  (7*Mst1**10.*Mt**2.)/(576.*Mgl**4.)+

     &  (617*Mgl**4.*Mt**4.)/6912.+

     &  (55*Mgl**8.*Mt**4.)/(512.*Mst1**4.)-

     &  (577*Mgl**6.*Mt**4.)/(1152.*Mst1**2.)-

     &  (131*Mgl**2.*Mst1**2.*Mt**4.)/1152.+

     &  (42209*Mst1**4.*Mt**4.)/13824.-

     &  (17*Mst1**6.*Mt**4.)/(64.*Mgl**2.)-

     &  (7*Mst1**8.*Mt**4.)/(192.*Mgl**4.)-

     &  (5591*Mgl**2.*Mt**6.)/1728.+

     &  (41*Mgl**6.*Mt**6.)/(576.*Mst1**4.)-

     &  (91*Mgl**4.*Mt**6.)/(72.*Mst1**2.)-

     &  (385*Mst1**2.*Mt**6.)/108.-

     &  (5*Mst1**4.*Mt**6.)/(12.*Mgl**2.)+

     &  (35*Mst1**6.*Mt**6.)/(576.*Mgl**4.)+

     &  (1561*Mt**8.)/1536.-

     &  (563*Mgl**4.*Mt**8.)/(4608.*Mst1**4.)+

     &  (2947*Mgl**2.*Mt**8.)/(6912.*Mst1**2.)+

     &  (485*Mst1**2.*Mt**8.)/(576.*Mgl**2.)-

     &  (35*Mst1**4.*Mt**8.)/(576.*Mgl**4.)-

     &  Mt**10./(2.*Mgl**2.)+

     &  (Mgl**2.*Mt**10.)/(32.*Mst1**4.)+

     &  (601*Mt**10.)/(3456.*Mst1**2.)+

     &  (7*Mst1**2.*Mt**10.)/(192.*Mgl**4.)-

     &  (7*Mt**12.)/(576.*Mgl**4.)-

     &  (59*Mt**12.)/(4608.*Mst1**4.)+

     &  (5*Mt**12.)/(64.*Mgl**2.*Mst1**2.)+

     &  Mt**14./(72.*Mgl**2.*Mst1**4.)+

     &  Mt**14./(576.*Mgl**4.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mgl)+

     &  ((-349*Mgl**12.)/144.+

     &  (31*Mgl**16.)/(2304.*Mst1**4.)+

     &  (145*Mgl**14.)/(384.*Mst1**2.)+

     &  (17923*Mgl**10.*Mst1**2.)/3456.-

     &  (13571*Mgl**8.*Mst1**4.)/3456.-

     &  (5639*Mgl**6.*Mst1**6.)/3456.+

     &  (3995*Mgl**4.*Mst1**8.)/864.-

     &  (9559*Mgl**2.*Mst1**10.)/3456.+

     &  (3649*Mst1**12.)/6912.+

     &  (11*Mst1**14.)/(576.*Mgl**2.)-

     &  (13*Mgl**14.)/(144.*Mt**2.)+

     &  Mgl**16./(72.*Mst1**2.*Mt**2.)+

     &  (Mgl**12.*Mst1**2.)/(4.*Mt**2.)-

     &  (55*Mgl**10.*Mst1**4.)/(144.*Mt**2.)+

     &  (25*Mgl**8.*Mst1**6.)/(72.*Mt**2.)-

     &  (3*Mgl**6.*Mst1**8.)/(16.*Mt**2.)+

     &  (Mgl**4.*Mst1**10.)/(18.*Mt**2.)-

     &  (Mgl**2.*Mst1**12.)/(144.*Mt**2.)+

     &  (26711*Mgl**10.*Mt**2.)/3456.-

     &  (Mgl**14.*Mt**2.)/(72.*Mst1**4.)-

     &  (3371*Mgl**12.*Mt**2.)/(1728.*Mst1**2.)-

     &  (41863*Mgl**8.*Mst1**2.*Mt**2.)/3456.+

     &  (17051*Mgl**6.*Mst1**4.*Mt**2.)/1728.-

     &  (2029*Mgl**4.*Mst1**6.*Mt**2.)/432.+

     &  (4591*Mgl**2.*Mst1**8.*Mt**2.)/3456.-

     &  (89*Mst1**10.*Mt**2.)/1152.-

     &  (7*Mst1**12.*Mt**2.)/(96.*Mgl**2.)-

     &  (16195*Mgl**8.*Mt**4.)/3456.+

     &  (Mgl**12.*Mt**4.)/(192.*Mst1**4.)+

     &  (7609*Mgl**10.*Mt**4.)/(3456.*Mst1**2.)+

     &  (2861*Mgl**6.*Mst1**2.*Mt**4.)/864.+

     &  (73*Mgl**4.*Mst1**4.*Mt**4.)/72.+

     &  (17041*Mgl**2.*Mst1**6.*Mt**4.)/3456.-

     &  (7789*Mst1**8.*Mt**4.)/1152.-

     &  (Mst1**10.*Mt**4.)/(64.*Mgl**2.)+

     &  (1679*Mgl**6.*Mt**6.)/864.-

     &  (125*Mgl**10.*Mt**6.)/(576.*Mst1**4.)+

     &  (1873*Mgl**8.*Mt**6.)/(1728.*Mst1**2.)+

     &  (7225*Mgl**4.*Mst1**2.*Mt**6.)/1728.+

     &  (221*Mgl**2.*Mst1**4.*Mt**6.)/96.+

     &  (7165*Mst1**6.*Mt**6.)/432.+

     &  (35*Mst1**8.*Mt**6.)/(64.*Mgl**2.)-

     &  (6743*Mgl**4.*Mt**8.)/1728.+

     &  (565*Mgl**8.*Mt**8.)/(1152.*Mst1**4.)-

     &  (7061*Mgl**6.*Mt**8.)/(3456.*Mst1**2.)-

     &  (29557*Mgl**2.*Mst1**2.*Mt**8.)/3456.-

     &  (18155*Mst1**4.*Mt**8.)/1152.-

     &  (245*Mst1**6.*Mt**8.)/(192.*Mgl**2.)+

     &  (3071*Mgl**2.*Mt**10.)/3456.-

     &  (11*Mgl**6.*Mt**10.)/(64.*Mst1**4.)-

     &  (1493*Mgl**4.*Mt**10.)/(1728.*Mst1**2.)+

     &  (6391*Mst1**2.*Mt**10.)/1152.+

     &  (91*Mst1**4.*Mt**10.)/(64.*Mgl**2.)+

     &  (1097*Mt**12.)/3456.-

     &  (79*Mgl**4.*Mt**12.)/(192.*Mst1**4.)+

     &  (5059*Mgl**2.*Mt**12.)/(3456.*Mst1**2.)-

     &  (161*Mst1**2.*Mt**12.)/(192.*Mgl**2.)+

     &  (43*Mt**14.)/(192.*Mgl**2.)+

     &  (79*Mgl**2.*Mt**14.)/(192.*Mst1**4.)-

     &  (163*Mt**14.)/(576.*Mst1**2.)-

     &  (25*Mt**16.)/(256.*Mst1**4.)-

     &  (5*Mt**18.)/(576.*Mgl**2.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.*ln(mu,Mgl)+

     &  ((1277*Mgl**16.)/1024.-

     &  (61*Mgl**20.)/(3072.*Mst1**4.)-

     &  (1529*Mgl**18.)/(13824.*Mst1**2.)-

     &  (13651*Mgl**14.*Mst1**2.)/3456.+

     &  (82339*Mgl**12.*Mst1**4.)/13824.-

     &  (8489*Mgl**10.*Mst1**6.)/2304.-

     &  (25741*Mgl**8.*Mst1**8.)/13824.+

     &  (18157*Mgl**6.*Mst1**10.)/3456.-

     &  (38539*Mgl**4.*Mst1**12.)/9216.+

     &  (22151*Mgl**2.*Mst1**14.)/13824.-

     &  (2311*Mst1**16.)/9216.-

     &  (265*Mgl**14.*Mt**2.)/64.+

     &  (5*Mgl**18.*Mt**2.)/(48.*Mst1**4.)+

     &  (4163*Mgl**16.*Mt**2.)/(6912.*Mst1**2.)+

     &  (9491*Mgl**12.*Mst1**2.*Mt**2.)/864.-

     &  (32969*Mgl**10.*Mst1**4.*Mt**2.)/1728.+

     &  (78943*Mgl**8.*Mst1**6.*Mt**2.)/3456.-

     &  (10271*Mgl**6.*Mst1**8.*Mt**2.)/576.+

     &  (1267*Mgl**4.*Mst1**10.*Mt**2.)/144.-

     &  (4763*Mgl**2.*Mst1**12.*Mt**2.)/1728.+

     &  (3287*Mst1**14.*Mt**2.)/6912.+

     &  (12319*Mgl**12.*Mt**4.)/6912.-

     &  (2309*Mgl**16.*Mt**4.)/(9216.*Mst1**4.)-

     &  (427*Mgl**14.*Mt**4.)/(1152.*Mst1**2.)-

     &  (9029*Mgl**10.*Mst1**2.*Mt**4.)/1152.+

     &  (39569*Mgl**8.*Mst1**4.*Mt**4.)/4608.+

     &  (5219*Mgl**6.*Mst1**6.*Mt**4.)/1152.-

     &  (12043*Mgl**4.*Mst1**8.*Mt**4.)/2304.-

     &  (5059*Mgl**2.*Mst1**10.*Mt**4.)/1152.+

     &  (87857*Mst1**12.*Mt**4.)/27648.+

     &  (5183*Mgl**10.*Mt**6.)/864.+

     &  (275*Mgl**14.*Mt**6.)/(576.*Mst1**4.)-

     &  (1781*Mgl**12.*Mt**6.)/(576.*Mst1**2.)+

     &  (325*Mgl**8.*Mst1**2.*Mt**6.)/288.+

     &  (4313*Mgl**6.*Mst1**4.*Mt**6.)/1728.-

     &  (4415*Mgl**4.*Mst1**6.*Mt**6.)/1728.+

     &  (365*Mgl**2.*Mst1**8.*Mt**6.)/36.-

     &  (394*Mst1**10.*Mt**6.)/27.-

     &  (85783*Mgl**8.*Mt**8.)/13824.-

     &  (3859*Mgl**12.*Mt**8.)/(4608.*Mst1**4.)+

     &  (48289*Mgl**10.*Mt**8.)/(6912.*Mst1**2.)+

     &  (4613*Mgl**6.*Mst1**2.*Mt**8.)/1152.+

     &  (39251*Mgl**4.*Mst1**4.*Mt**8.)/4608.+

     &  (43*Mgl**2.*Mst1**6.*Mt**8.)/2304.+

     &  (357847*Mst1**8.*Mt**8.)/13824.+

     &  (641*Mgl**6.*Mt**10.)/192.+

     &  (523*Mgl**10.*Mt**10.)/(576.*Mst1**4.)-

     &  (16115*Mgl**8.*Mt**10.)/(3456.*Mst1**2.)-

     &  (931*Mgl**4.*Mst1**2.*Mt**10.)/288.-

     &  (401*Mgl**2.*Mst1**4.*Mt**10.)/54.-

     &  (81389*Mst1**6.*Mt**10.)/3456.-

     &  (35509*Mgl**4.*Mt**12.)/6912.-

     &  (485*Mgl**8.*Mt**12.)/(4608.*Mst1**4.)-

     &  (2885*Mgl**6.*Mt**12.)/(3456.*Mst1**2.)+

     &  (691*Mgl**2.*Mst1**2.*Mt**12.)/3456.+

     &  (145201*Mst1**4.*Mt**12.)/13824.+

     &  (1469*Mgl**2.*Mt**14.)/432.-

     &  (551*Mgl**6.*Mt**14.)/(576.*Mst1**4.)+

     &  (365*Mgl**4.*Mt**14.)/(192.*Mst1**2.)-

     &  (1121*Mst1**2.*Mt**14.)/864.-

     &  (7849*Mt**16.)/27648.+

     &  (10285*Mgl**4.*Mt**16.)/(9216.*Mst1**4.)-

     &  (3505*Mgl**2.*Mt**16.)/(13824.*Mst1**2.)-

     &  (307*Mgl**2.*Mt**18.)/(576.*Mst1**4.)-

     &  (1141*Mt**18.)/(6912.*Mst1**2.)+

     &  (895*Mt**20.)/(9216.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.*ln(mu,Mgl)+

     &  ((-1367*Mgl**4.)/3456.-

     &  (17*Mgl**8.)/(2304.*Mst2**4.)+

     &  (101*Mgl**6.)/(1728.*Mst2**2.)+

     &  (827*Mgl**2.*Mst2**2.)/3456.-

     &  (2705*Mst2**4.)/6912.+

     &  (25*Mst2**6.)/(576.*Mgl**2.)+

     &  Mst2**8./(72.*Mgl**4.)+Mgl**8./(1152.*Mt**4.)+

     &  (Mgl**6.*Mst2**2.)/(128.*Mt**4.)-

     &  (11*Mgl**4.*Mst2**4.)/(384.*Mt**4.)+

     &  (35*Mgl**2.*Mst2**6.)/(1152.*Mt**4.)-

     &  Mst2**8./(96.*Mt**4.)+

     &  (299*Mgl**6.)/(6912.*Mt**2.)+

     &  Mgl**8./(288.*Mst2**2.*Mt**2.)-

     &  (25*Mgl**4.*Mst2**2.)/(576.*Mt**2.)-

     &  (671*Mgl**2.*Mst2**4.)/(2304.*Mt**2.)+

     &  (911*Mst2**6.)/(3456.*Mt**2.)+

     &  (7*Mst2**8.)/(288.*Mgl**2.*Mt**2.)+

     &  (451*Mgl**2.*Mt**2.)/6912.+

     &  (5*Mgl**6.*Mt**2.)/(576.*Mst2**4.)-

     &  (1015*Mgl**4.*Mt**2.)/(3456.*Mst2**2.)+

     &  (1331*Mst2**2.*Mt**2.)/3456.-

     &  (23*Mst2**4.*Mt**2.)/(96.*Mgl**2.)-

     &  (5*Mst2**6.*Mt**2.)/(72.*Mgl**4.)-

     &  (931*Mt**4.)/3456.+

     &  (Mgl**4.*Mt**4.)/(1152.*Mst2**4.)-

     &  (671*Mgl**2.*Mt**4.)/(1728.*Mst2**2.)+

     &  (127*Mst2**2.*Mt**4.)/(576.*Mgl**2.)+

     &  (5*Mst2**4.*Mt**4.)/(36.*Mgl**4.)-

     &  (13*Mt**6.)/(576.*Mgl**2.)-

     &  (Mgl**2.*Mt**6.)/(288.*Mst2**4.)+

     &  (55*Mt**6.)/(3456.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**6.)/(36.*Mgl**4.)+

     &  (5*Mt**8.)/(72.*Mgl**4.)+

     &  (5*Mt**8.)/(768.*Mst2**4.)-

     &  Mt**8./(48.*Mgl**2.*Mst2**2.)-

     &  Mt**10./(192.*Mgl**2.*Mst2**4.)-

     &  Mt**10./(72.*Mgl**4.*Mst2**2.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mgl)+((20249*Mgl**8.)/13824.+

     &  (127*Mgl**12.)/(4608.*Mst2**4.)-

     &  (2473*Mgl**10.)/(6912.*Mst2**2.)-

     &  (2767*Mgl**6.*Mst2**2.)/1152.+

     &  (7469*Mgl**4.*Mst2**4.)/4608.-

     &  (12953*Mgl**2.*Mst2**6.)/6912.+

     &  (18955*Mst2**8.)/13824.+

     &  (29*Mst2**10.)/(192.*Mgl**2.)-

     &  Mst2**12./(576.*Mgl**4.)-

     &  (5*Mgl**12.)/(1152.*Mt**4.)-

     &  (17*Mgl**10.*Mst2**2.)/(1152.*Mt**4.)+

     &  (61*Mgl**8.*Mst2**4.)/(576.*Mt**4.)-

     &  (109*Mgl**6.*Mst2**6.)/(576.*Mt**4.)+

     &  (167*Mgl**4.*Mst2**8.)/(1152.*Mt**4.)-

     &  (53*Mgl**2.*Mst2**10.)/(1152.*Mt**4.)+

     &  Mst2**12./(288.*Mt**4.)-

     &  (137*Mgl**10.)/(6912.*Mt**2.)-

     &  Mgl**12./(48.*Mst2**2.*Mt**2.)+

     &  (85*Mgl**8.*Mst2**2.)/(128.*Mt**2.)-

     &  (2533*Mgl**6.*Mst2**4.)/(3456.*Mt**2.)-

     &  (1633*Mgl**4.*Mst2**6.)/(1728.*Mt**2.)+

     &  (3721*Mgl**2.*Mst2**8.)/(2304.*Mt**2.)-

     &  (1793*Mst2**10.)/(3456.*Mt**2.)-

     &  Mst2**12./(24.*Mgl**2.*Mt**2.)-

     &  (11543*Mgl**6.*Mt**2.)/3456.-

     &  (67*Mgl**10.*Mt**2.)/(576.*Mst2**4.)+

     &  (5069*Mgl**8.*Mt**2.)/(3456.*Mst2**2.)-

     &  (143*Mgl**4.*Mst2**2.*Mt**2.)/864.+

     &  (10565*Mgl**2.*Mst2**4.*Mt**2.)/3456.-

     &  (2569*Mst2**6.*Mt**2.)/1152.-

     &  (5*Mst2**8.*Mt**2.)/(18.*Mgl**2.)+

     &  (7*Mst2**10.*Mt**2.)/(576.*Mgl**4.)+

     &  (3265*Mgl**4.*Mt**4.)/2304.+

     &  (55*Mgl**8.*Mt**4.)/(512.*Mst2**4.)-

     &  (545*Mgl**6.*Mt**4.)/(1152.*Mst2**2.)+

     &  (493*Mgl**2.*Mst2**2.*Mt**4.)/1728.+

     &  (47881*Mst2**4.*Mt**4.)/13824.+

     &  (109*Mst2**6.*Mt**4.)/(192.*Mgl**2.)-

     &  (7*Mst2**8.*Mt**4.)/(192.*Mgl**4.)-

     &  (24277*Mgl**2.*Mt**6.)/6912.+

     &  (41*Mgl**6.*Mt**6.)/(576.*Mst2**4.)-

     &  (21*Mgl**4.*Mt**6.)/(16.*Mst2**2.)-

     &  (10369*Mst2**2.*Mt**6.)/3456.-

     &  (25*Mst2**4.*Mt**6.)/(24.*Mgl**2.)+

     &  (35*Mst2**6.*Mt**6.)/(576.*Mgl**4.)+

     &  (3455*Mt**8.)/4608.-

     &  (563*Mgl**4.*Mt**8.)/(4608.*Mst2**4.)+

     &  (3067*Mgl**2.*Mt**8.)/(6912.*Mst2**2.)+

     &  (629*Mst2**2.*Mt**8.)/(576.*Mgl**2.)-

     &  (35*Mst2**4.*Mt**8.)/(576.*Mgl**4.)-

     &  (13*Mt**10.)/(24.*Mgl**2.)+

     &  (Mgl**2.*Mt**10.)/(32.*Mst2**4.)+

     &  (601*Mt**10.)/(3456.*Mst2**2.)+

     &  (7*Mst2**2.*Mt**10.)/(192.*Mgl**4.)-

     &  (7*Mt**12.)/(576.*Mgl**4.)-

     &  (59*Mt**12.)/(4608.*Mst2**4.)+

     &  (5*Mt**12.)/(64.*Mgl**2.*Mst2**2.)+

     &  Mt**14./(72.*Mgl**2.*Mst2**4.)+

     &  Mt**14./(576.*Mgl**4.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mgl)+

     &  ((-443*Mgl**12.)/216.+

     &  (31*Mgl**16.)/(2304.*Mst2**4.)+

     &  (53*Mgl**14.)/(128.*Mst2**2.)+

     &  (3709*Mgl**10.*Mst2**2.)/576.-

     &  (16133*Mgl**8.*Mst2**4.)/1728.+

     &  (855*Mgl**6.*Mst2**6.)/128.-

     &  (3187*Mgl**4.*Mst2**8.)/576.+

     &  (4699*Mgl**2.*Mst2**10.)/864.-

     &  (14021*Mst2**12.)/6912.-

     &  (7*Mst2**14.)/(192.*Mgl**2.)+

     &  (7*Mgl**16.)/(1152.*Mt**4.)+

     &  (7*Mgl**14.*Mst2**2.)/(1152.*Mt**4.)-

     &  (17*Mgl**12.*Mst2**4.)/(128.*Mt**4.)+

     &  (379*Mgl**10.*Mst2**6.)/(1152.*Mt**4.)-

     &  (335*Mgl**8.*Mst2**8.)/(1152.*Mt**4.)-

     &  (3*Mgl**6.*Mst2**10.)/(128.*Mt**4.)+

     &  (253*Mgl**4.*Mst2**12.)/(1152.*Mt**4.)-

     &  (167*Mgl**2.*Mst2**14.)/(1152.*Mt**4.)+

     &  Mst2**16./(32.*Mt**4.)-

     &  (311*Mgl**14.)/(6912.*Mt**2.)+

     &  Mgl**16./(144.*Mst2**2.*Mt**2.)-

     &  (379*Mgl**12.*Mst2**2.)/(432.*Mt**2.)+

     &  (24887*Mgl**10.*Mst2**4.)/(6912.*Mt**2.)-

     &  (15575*Mgl**8.*Mst2**6.)/(3456.*Mt**2.)+

     &  (5255*Mgl**6.*Mst2**8.)/(6912.*Mt**2.)+

     &  (4591*Mgl**4.*Mst2**10.)/(1728.*Mt**2.)-

     &  (1567*Mgl**2.*Mst2**12.)/(768.*Mt**2.)+

     &  (1513*Mst2**14.)/(3456.*Mt**2.)+

     &  Mst2**16./(144.*Mgl**2.*Mt**2.)+

     &  (47203*Mgl**10.*Mt**2.)/6912.-

     &  (Mgl**14.*Mt**2.)/(72.*Mst2**4.)-

     &  (3491*Mgl**12.*Mt**2.)/(1728.*Mst2**2.)-

     &  (4361*Mgl**8.*Mst2**2.*Mt**2.)/432.+

     &  (4807*Mgl**6.*Mst2**4.*Mt**2.)/1152.+

     &  (937*Mgl**4.*Mst2**6.*Mt**2.)/144.-

     &  (7541*Mgl**2.*Mst2**8.*Mt**2.)/768.+

     &  (829*Mst2**10.*Mt**2.)/192.+

     &  (35*Mst2**12.*Mt**2.)/(288.*Mgl**2.)-

     &  (19351*Mgl**8.*Mt**4.)/3456.+

     &  (Mgl**12.*Mt**4.)/(192.*Mst2**4.)+

     &  (7759*Mgl**10.*Mt**4.)/(3456.*Mst2**2.)-

     &  (2869*Mgl**6.*Mst2**2.*Mt**4.)/3456.-

     &  (1297*Mgl**4.*Mst2**4.*Mt**4.)/384.+

     &  (311*Mgl**2.*Mst2**6.*Mt**4.)/24.-

     &  (13651*Mst2**8.*Mt**4.)/1728.-

     &  (233*Mst2**10.*Mt**4.)/(576.*Mgl**2.)+

     &  (33947*Mgl**6.*Mt**6.)/6912.-

     &  (125*Mgl**10.*Mt**6.)/(576.*Mst2**4.)+

     &  (1933*Mgl**8.*Mt**6.)/(1728.*Mst2**2.)+

     &  (547*Mgl**4.*Mst2**2.*Mt**6.)/96.-

     &  (23413*Mgl**2.*Mst2**4.*Mt**6.)/6912.+

     &  (38867*Mst2**6.*Mt**6.)/3456.+

     &  (595*Mst2**8.*Mt**6.)/(576.*Mgl**2.)-

     &  (8531*Mgl**4.*Mt**8.)/1728.+

     &  (565*Mgl**8.*Mt**8.)/(1152.*Mst2**4.)-

     &  (7307*Mgl**6.*Mt**8.)/(3456.*Mst2**2.)-

     &  (1291*Mgl**2.*Mst2**2.*Mt**8.)/288.-

     &  (4943*Mst2**4.*Mt**8.)/576.-

     &  (959*Mst2**6.*Mt**8.)/(576.*Mgl**2.)-

     &  (299*Mgl**2.*Mt**10.)/768.-

     &  (11*Mgl**6.*Mt**10.)/(64.*Mst2**4.)-

     &  (1421*Mgl**4.*Mt**10.)/(1728.*Mst2**2.)+

     &  (1567*Mst2**2.*Mt**10.)/864.+

     &  (931*Mst2**4.*Mt**10.)/(576.*Mgl**2.)+

     &  (451*Mt**12.)/432.-

     &  (79*Mgl**4.*Mt**12.)/(192.*Mst2**4.)+

     &  (5029*Mgl**2.*Mt**12.)/(3456.*Mst2**2.)-

     &  (515*Mst2**2.*Mt**12.)/(576.*Mgl**2.)+

     &  (133*Mt**14.)/(576.*Mgl**2.)+

     &  (79*Mgl**2.*Mt**14.)/(192.*Mst2**4.)-

     &  (163*Mt**14.)/(576.*Mst2**2.)-

     &  (25*Mt**16.)/(256.*Mst2**4.)-

     &  (5*Mt**18.)/(576.*Mgl**2.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.*ln(mu,Mgl)+

     &  ((5245*Mgl**16.)/9216.-

     &  (61*Mgl**20.)/(3072.*Mst2**4.)-

     &  (1529*Mgl**18.)/(13824.*Mst2**2.)-

     &  (3409*Mgl**14.*Mst2**2.)/1152.+

     &  (130499*Mgl**12.*Mst2**4.)/13824.-

     &  (100747*Mgl**10.*Mst2**6.)/6912.+

     &  (163355*Mgl**8.*Mst2**8.)/13824.-

     &  (23971*Mgl**6.*Mst2**10.)/3456.+

     &  (142303*Mgl**4.*Mst2**12.)/27648.-

     &  (43673*Mgl**2.*Mst2**14.)/13824.+

     &  (21779*Mst2**16.)/27648.-Mgl**20./(384.*Mt**4.)+

     &  (Mgl**18.*Mst2**2.)/(1152.*Mt**4.)+

     &  (Mgl**16.*Mst2**4.)/(16.*Mt**4.)-

     &  (7*Mgl**14.*Mst2**6.)/(32.*Mt**4.)+

     &  (49*Mgl**12.*Mst2**8.)/(192.*Mt**4.)+

     &  (7*Mgl**10.*Mst2**10.)/(64.*Mt**4.)-

     &  (21*Mgl**8.*Mst2**12.)/(32.*Mt**4.)+

     &  (79*Mgl**6.*Mst2**14.)/(96.*Mt**4.)-

     &  (67*Mgl**4.*Mst2**16.)/(128.*Mt**4.)+

     &  (67*Mgl**2.*Mst2**18.)/(384.*Mt**4.)-

     &  (7*Mst2**20.)/(288.*Mt**4.)+

     &  (629*Mgl**18.)/(6912.*Mt**2.)-

     &  (421*Mgl**16.*Mst2**2.)/(3456.*Mt**2.)-

     &  (10*Mgl**14.*Mst2**4.)/(9.*Mt**2.)+

     &  (779*Mgl**12.*Mst2**6.)/(192.*Mt**2.)-

     &  (19543*Mgl**10.*Mst2**8.)/(3456.*Mt**2.)+

     &  (323*Mgl**8.*Mst2**10.)/(96.*Mt**2.)+

     &  (Mgl**6.*Mst2**12.)/(96.*Mt**2.)-

     &  (1835*Mgl**4.*Mst2**14.)/(1728.*Mt**2.)+

     &  (1147*Mgl**2.*Mst2**16.)/(2304.*Mt**2.)-

     &  (247*Mst2**18.)/(3456.*Mt**2.)-

     &  (493*Mgl**14.*Mt**2.)/216.+

     &  (5*Mgl**18.*Mt**2.)/(48.*Mst2**4.)+

     &  (4163*Mgl**16.*Mt**2.)/(6912.*Mst2**2.)+

     &  (1517*Mgl**12.*Mst2**2.*Mt**2.)/192.-

     &  (9511*Mgl**10.*Mst2**4.*Mt**2.)/576.+

     &  (46607*Mgl**8.*Mst2**6.*Mt**2.)/3456.+

     &  (535*Mgl**6.*Mst2**8.*Mt**2.)/864.-

     &  (15293*Mgl**4.*Mst2**10.*Mt**2.)/1728.+

     &  (12571*Mgl**2.*Mst2**12.*Mt**2.)/1728.-

     &  (16193*Mst2**14.*Mt**2.)/6912.+

     &  (275*Mgl**12.*Mt**4.)/6912.-

     &  (2309*Mgl**16.*Mt**4.)/(9216.*Mst2**4.)-

     &  (427*Mgl**14.*Mt**4.)/(1152.*Mst2**2.)-

     &  (8749*Mgl**10.*Mst2**2.*Mt**4.)/3456.+

     &  (51187*Mgl**8.*Mst2**4.*Mt**4.)/13824.-

     &  (3251*Mgl**6.*Mst2**6.*Mt**4.)/3456.+

     &  (66451*Mgl**4.*Mst2**8.*Mt**4.)/6912.-

     &  (16357*Mgl**2.*Mst2**10.*Mt**4.)/1152.+

     &  (136465*Mst2**12.*Mt**4.)/27648.+

     &  (16279*Mgl**10.*Mt**6.)/3456.+

     &  (275*Mgl**14.*Mt**6.)/(576.*Mst2**4.)-

     &  (1781*Mgl**12.*Mt**6.)/(576.*Mst2**2.)-

     &  (39*Mgl**8.*Mst2**2.*Mt**6.)/8.-

     &  (419*Mgl**6.*Mst2**4.*Mt**6.)/1728.-

     &  (2819*Mgl**4.*Mst2**6.*Mt**6.)/432.+

     &  (64037*Mgl**2.*Mst2**8.*Mt**6.)/3456.-

     &  (15521*Mst2**10.*Mt**6.)/1728.-

     &  (3607*Mgl**8.*Mt**8.)/1536.-

     &  (3859*Mgl**12.*Mt**8.)/(4608.*Mst2**4.)+

     &  (48289*Mgl**10.*Mt**8.)/(6912.*Mst2**2.)+

     &  (24943*Mgl**6.*Mst2**2.*Mt**8.)/3456.+

     &  (67705*Mgl**4.*Mst2**4.*Mt**8.)/13824.-

     &  (27589*Mgl**2.*Mst2**6.*Mt**8.)/2304.+

     &  (159215*Mst2**8.*Mt**8.)/13824.+

     &  (67*Mgl**6.*Mt**10.)/54.+

     &  (523*Mgl**10.*Mt**10.)/(576.*Mst2**4.)-

     &  (16115*Mgl**8.*Mt**10.)/(3456.*Mst2**2.)+

     &  (775*Mgl**4.*Mst2**2.*Mt**10.)/1728.+

     &  (1207*Mgl**2.*Mst2**4.*Mt**10.)/216.-

     &  (27433*Mst2**6.*Mt**10.)/3456.-

     &  (42599*Mgl**4.*Mt**12.)/6912.-

     &  (485*Mgl**8.*Mt**12.)/(4608.*Mst2**4.)-

     &  (2885*Mgl**6.*Mt**12.)/(3456.*Mst2**2.)-

     &  (3907*Mgl**2.*Mst2**2.*Mt**12.)/576.+

     &  (16241*Mst2**4.*Mt**12.)/13824.+

     &  (33437*Mgl**2.*Mt**14.)/6912.-

     &  (551*Mgl**6.*Mt**14.)/(576.*Mst2**4.)+

     &  (365*Mgl**4.*Mt**14.)/(192.*Mst2**2.)+

     &  (5885*Mst2**2.*Mt**14.)/3456.-

     &  (6379*Mt**16.)/9216.+

     &  (10285*Mgl**4.*Mt**16.)/(9216.*Mst2**4.)-

     &  (3505*Mgl**2.*Mt**16.)/(13824.*Mst2**2.)-

     &  (307*Mgl**2.*Mt**18.)/(576.*Mst2**4.)-

     &  (1141*Mt**18.)/(6912.*Mst2**2.)+

     &  (895*Mt**20.)/(9216.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.*ln(mu,Mgl)+

     &  (-Mgl**3./(48.*Mst1**2.)+Mgl**3./(48.*Mst2**2.)-

     &  Mst2**2./(36.*Mgl**1.)+Mt**2./(36.*Mgl**1.)+

     &  (127*Mgl**3.*Mt**2.)/(2304.*Mst1**4.)+

     &  (13*Mgl*Mt**2.)/(2304.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**2.)/(144.*Mgl**3.)-

     &  (127*Mgl**3.*Mt**2.)/(2304.*Mst2**4.)-

     &  (13*Mgl*Mt**2.)/(2304.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**2.)/(144.*Mgl**3.)-

     &  (127*Mgl*Mt**4.)/(2304.*Mst1**4.)+

     &  (7*Mt**4.)/(72.*Mgl**1.*Mst1**2.)+

     &  (127*Mgl*Mt**4.)/(2304.*Mst2**4.)-

     &  (7*Mt**4.)/(72.*Mgl**1.*Mst2**2.)-

     &  (5*Mt**6.)/(144.*Mgl**3.*Mst1**2.)+

     &  (5*Mt**6.)/(144.*Mgl**3.*Mst2**2.))*Xt*

     &  Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((7*Mgl**5.)/48.-(11*Mgl**3.*Mst1**2.)/36.+

     &  (23*Mgl*Mst1**4.)/144.+

     &  (1921*Mgl**3.*Mt**2.)/1728.+

     &  (17*Mgl**7.*Mt**2.)/(576.*Mst1**4.)-

     &  (461*Mgl**5.*Mt**2.)/(1728.*Mst1**2.)-

     &  (443*Mgl*Mst1**2.*Mt**2.)/1728.+

     &  (5*Mst1**4.*Mt**2.)/(16.*Mgl**1.)+

     &  (Mst1**6.*Mt**2.)/(24.*Mgl**3.)+

     &  (1109*Mgl*Mt**4.)/1728.-

     &  (37*Mgl**5.*Mt**4.)/(576.*Mst1**4.)+

     &  (83*Mgl**3.*Mt**4.)/(54.*Mst1**2.)-

     &  (73*Mst1**2.*Mt**4.)/(144.*Mgl**1.)-

     &  (Mst1**4.*Mt**4.)/(6.*Mgl**3.)+

     &  (7*Mt**6.)/(72.*Mgl**1.)+

     &  (35*Mgl**3.*Mt**6.)/(576.*Mst1**4.)-

     &  (191*Mgl*Mt**6.)/(1728.*Mst1**2.)+

     &  (Mst1**2.*Mt**6.)/(4.*Mgl**3.)-

     &  Mt**8./(6.*Mgl**3.)-

     &  (3*Mgl*Mt**8.)/(64.*Mst1**4.)+

     &  (11*Mt**8.)/(144.*Mgl**1.*Mst1**2.)+

     &  Mt**10./(48.*Mgl**1.*Mst1**4.)+

     &  Mt**10./(24.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((-4*Mgl**9.)/9.+(11*Mgl**11.)/(144.*Mst1**2.)+

     &  (8*Mgl**7.*Mst1**2.)/9.-

     &  (55*Mgl**5.*Mst1**4.)/72.+

     &  (37*Mgl**3.*Mst1**6.)/144.-(Mgl*Mst1**8.)/72.-

     &  (505*Mgl**7.*Mt**2.)/108.-

     &  (127*Mgl**11.*Mt**2.)/(1152.*Mst1**4.)+

     &  (3785*Mgl**9.*Mt**2.)/(3456.*Mst1**2.)+

     &  (1213*Mgl**5.*Mst1**2.*Mt**2.)/288.+

     &  (1429*Mgl**3.*Mst1**4.*Mt**2.)/3456.-

     &  (2293*Mgl*Mst1**6.*Mt**2.)/3456.-

     &  (19*Mst1**8.*Mt**2.)/(72.*Mgl**1.)-

     &  (Mst1**10.*Mt**2.)/(144.*Mgl**3.)+

     &  (7457*Mgl**5.*Mt**4.)/864.+

     &  (221*Mgl**9.*Mt**4.)/(384.*Mst1**4.)-

     &  (5059*Mgl**7.*Mt**4.)/(864.*Mst1**2.)+

     &  (43*Mgl**3.*Mst1**2.*Mt**4.)/48.-

     &  (6709*Mgl*Mst1**4.*Mt**4.)/3456.+

     &  (13*Mst1**6.*Mt**4.)/(24.*Mgl**1.)+

     &  (Mst1**8.*Mt**4.)/(24.*Mgl**3.)+

     &  (137*Mgl**3.*Mt**6.)/27.-

     &  (193*Mgl**7.*Mt**6.)/(192.*Mst1**4.)+

     &  (10871*Mgl**5.*Mt**6.)/(1728.*Mst1**2.)+

     &  (4717*Mgl*Mst1**2.*Mt**6.)/864.+

     &  (5*Mst1**4.*Mt**6.)/(12.*Mgl**1.)-

     &  (5*Mst1**6.*Mt**6.)/(48.*Mgl**3.)-

     &  (1957*Mgl*Mt**8.)/864.+

     &  (415*Mgl**5.*Mt**8.)/(576.*Mst1**4.)-

     &  (541*Mgl**3.*Mt**8.)/(864.*Mst1**2.)-

     &  (65*Mst1**2.*Mt**8.)/(36.*Mgl**1.)+

     &  (5*Mst1**4.*Mt**8.)/(36.*Mgl**3.)+

     &  (35*Mt**10.)/(24.*Mgl**1.)-

     &  (89*Mgl**3.*Mt**10.)/(384.*Mst1**4.)-

     &  (2359*Mgl*Mt**10.)/(3456.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**10.)/(48.*Mgl**3.)+

     &  Mt**12./(24.*Mgl**3.)+

     &  (41*Mgl*Mt**12.)/(384.*Mst1**4.)-

     &  (7*Mt**12.)/(24.*Mgl**1.*Mst1**2.)-

     &  Mt**14./(18.*Mgl**1.*Mst1**4.)-

     &  Mt**14./(144.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((11*Mgl**13.)/36.-Mgl**15./(18.*Mst1**2.)-

     &  (25*Mgl**11.*Mst1**2.)/36.+

     &  (5*Mgl**9.*Mst1**4.)/6.-(5*Mgl**7.*Mst1**6.)/9.+

     &  (7*Mgl**5.*Mst1**8.)/36.-

     &  (Mgl**3.*Mst1**10.)/36.+

     &  (3911*Mgl**11.*Mt**2.)/576.-

     &  (31*Mgl**15.*Mt**2.)/(576.*Mst1**4.)-

     &  (677*Mgl**13.*Mt**2.)/(576.*Mst1**2.)-

     &  (20897*Mgl**9.*Mst1**2.*Mt**2.)/1728.+

     &  (10889*Mgl**7.*Mst1**4.*Mt**2.)/1728.+

     &  (2557*Mgl**5.*Mst1**6.*Mt**2.)/576.-

     &  (10117*Mgl**3.*Mst1**8.*Mt**2.)/1728.+

     &  (2713*Mgl*Mst1**10.*Mt**2.)/1728.+

     &  (11*Mst1**12.*Mt**2.)/(144.*Mgl**1.)-

     &  (39287*Mgl**9.*Mt**4.)/1728.+

     &  (7*Mgl**13.*Mt**4.)/(64.*Mst1**4.)+

     &  (3029*Mgl**11.*Mt**4.)/(432.*Mst1**2.)+

     &  (12485*Mgl**7.*Mst1**2.*Mt**4.)/432.-

     &  (25937*Mgl**5.*Mst1**4.*Mt**4.)/1728.+

     &  (47*Mgl**3.*Mst1**6.*Mt**4.)/432.+

     &  (3163*Mgl*Mst1**8.*Mt**4.)/1728.-

     &  (31*Mst1**10.*Mt**4.)/(144.*Mgl**1.)+

     &  (367*Mgl**7.*Mt**6.)/32.-

     &  (25*Mgl**11.*Mt**6.)/(192.*Mst1**4.)-

     &  (18127*Mgl**9.*Mt**6.)/(1728.*Mst1**2.)-

     &  (6011*Mgl**5.*Mst1**2.*Mt**6.)/288.-

     &  (11257*Mgl**3.*Mst1**4.*Mt**6.)/1728.-

     &  (34943*Mgl*Mst1**6.*Mt**6.)/1728.-

     &  (5*Mst1**8.*Mt**6.)/(18.*Mgl**1.)+

     &  (6109*Mgl**5.*Mt**8.)/864.+

     &  (575*Mgl**9.*Mt**8.)/(576.*Mst1**4.)-

     &  (95*Mgl**7.*Mt**8.)/(144.*Mst1**2.)+

     &  (643*Mgl**3.*Mst1**2.*Mt**8.)/27.+

     &  (54497*Mgl*Mst1**4.*Mt**8.)/1728.+

     &  (275*Mst1**6.*Mt**8.)/(144.*Mgl**1.)-

     &  (1871*Mgl**3.*Mt**10.)/1728.-

     &  (1705*Mgl**7.*Mt**10.)/(576.*Mst1**4.)+

     &  (21427*Mgl**5.*Mt**10.)/(1728.*Mst1**2.)-

     &  (26773*Mgl*Mst1**2.*Mt**10.)/1728.-

     &  (115*Mst1**4.*Mt**10.)/(36.*Mgl**1.)-

     &  (1651*Mgl*Mt**12.)/1728.+

     &  (2101*Mgl**5.*Mt**12.)/(576.*Mst1**4.)-

     &  (3647*Mgl**3.*Mt**12.)/(432.*Mst1**2.)+

     &  (359*Mst1**2.*Mt**12.)/(144.*Mgl**1.)-

     &  (31*Mt**14.)/(36.*Mgl**1.)-

     &  (1153*Mgl**3.*Mt**14.)/(576.*Mst1**4.)+

     &  (793*Mgl*Mt**14.)/(576.*Mst1**2.)+

     &  (205*Mgl*Mt**16.)/(576.*Mst1**4.)+

     &  (5*Mt**16.)/(144.*Mgl**1.*Mst1**2.)+

     &  (5*Mt**18.)/(144.*Mgl**1.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((-3859*Mgl**15.*Mt**2.)/864.+

     &  (61*Mgl**19.*Mt**2.)/(768.*Mst1**4.)+

     &  (3607*Mgl**17.*Mt**2.)/(6912.*Mst1**2.)+

     &  (34*Mgl**13.*Mst1**2.*Mt**2.)/3.-

     &  (43171*Mgl**11.*Mst1**4.*Mt**2.)/3456.+

     &  (7763*Mgl**9.*Mst1**6.*Mt**2.)/3456.+

     &  (349*Mgl**7.*Mst1**8.*Mt**2.)/36.-

     &  (9781*Mgl**5.*Mst1**10.*Mt**2.)/864.+

     &  (37369*Mgl**3.*Mst1**12.*Mt**2.)/6912.-

     &  (2311*Mgl*Mst1**14.*Mt**2.)/2304.+

     &  (1901*Mgl**13.*Mt**4.)/108.-

     &  (127*Mgl**17.*Mt**4.)/(256.*Mst1**4.)-

     &  (329*Mgl**15.*Mt**4.)/(96.*Mst1**2.)-

     &  (8137*Mgl**11.*Mst1**2.*Mt**4.)/216.+

     &  (176731*Mgl**9.*Mst1**4.*Mt**4.)/3456.-

     &  (36701*Mgl**7.*Mst1**6.*Mt**4.)/864.+

     &  (16549*Mgl**5.*Mst1**8.*Mt**4.)/864.-

     &  (2039*Mgl**3.*Mst1**10.*Mt**4.)/432.+

     &  (6215*Mgl*Mst1**12.*Mt**4.)/6912.-

     &  (1759*Mgl**11.*Mt**6.)/96.+

     &  (863*Mgl**15.*Mt**6.)/(576.*Mst1**4.)+

     &  (3691*Mgl**13.*Mt**6.)/(576.*Mst1**2.)+

     &  (10951*Mgl**9.*Mst1**2.*Mt**6.)/216.-

     &  (6679*Mgl**7.*Mst1**4.*Mt**6.)/192.-

     &  (18023*Mgl**5.*Mst1**6.*Mt**6.)/1728.-

     &  (937*Mgl**3.*Mst1**8.*Mt**6.)/108.+

     &  (11759*Mgl*Mst1**10.*Mt**6.)/864.-

     &  (337*Mgl**9.*Mt**8.)/108.-

     &  (1963*Mgl**13.*Mt**8.)/(576.*Mst1**4.)+

     &  (245*Mgl**11.*Mt**8.)/(96.*Mst1**2.)-

     &  (175*Mgl**7.*Mst1**2.*Mt**8.)/3.-

     &  (57941*Mgl**5.*Mst1**4.*Mt**8.)/1728.-

     &  (11129*Mgl**3.*Mst1**6.*Mt**8.)/864.-

     &  (4297*Mgl*Mst1**8.*Mt**8.)/96.+

     &  (3631*Mgl**7.*Mt**10.)/864.+

     &  (865*Mgl**11.*Mt**10.)/(128.*Mst1**4.)-

     &  (82043*Mgl**9.*Mt**10.)/(3456.*Mst1**2.)+

     &  (1256*Mgl**5.*Mst1**2.*Mt**10.)/27.+

     &  (158897*Mgl**3.*Mst1**4.*Mt**10.)/3456.+

     &  (203155*Mgl*Mst1**6.*Mt**10.)/3456.+

     &  (130*Mgl**5.*Mt**12.)/9.-

     &  (11969*Mgl**9.*Mt**12.)/(1152.*Mst1**4.)+

     &  (27649*Mgl**7.*Mt**12.)/(864.*Mst1**2.)-

     &  (4135*Mgl**3.*Mst1**2.*Mt**12.)/216.-

     &  (122401*Mgl*Mst1**4.*Mt**12.)/3456.-

     &  (3383*Mgl**3.*Mt**14.)/288.+

     &  (6227*Mgl**7.*Mt**14.)/(576.*Mst1**4.)-

     &  (30847*Mgl**5.*Mt**14.)/(1728.*Mst1**2.)+

     &  (475*Mgl*Mst1**2.*Mt**14.)/72.+

     &  (38*Mgl*Mt**16.)/27.-

     &  (447*Mgl**5.*Mt**16.)/(64.*Mst1**4.)+

     &  (2819*Mgl**3.*Mt**16.)/(864.*Mst1**2.)+

     &  (5807*Mgl**3.*Mt**18.)/(2304.*Mst1**4.)+

     &  (1879*Mgl*Mt**18.)/(6912.*Mst1**2.)-

     &  (895*Mgl*Mt**20.)/(2304.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((-451*Mgl**5.)/1728.-Mgl**7./(36.*Mst2**2.)+

     &  (593*Mgl**3.*Mst2**2.)/1728.-

     &  (533*Mgl*Mst2**4.)/864.-

     &  (5*Mst2**6.)/(72.*Mgl**1.)+

     &  Mgl**7./(288.*Mt**2.)+

     &  (5*Mgl**5.*Mst2**2.)/(144.*Mt**2.)-

     &  (23*Mgl**3.*Mst2**4.)/(288.*Mt**2.)+

     &  (Mgl*Mst2**6.)/(24.*Mt**2.)-

     &  (607*Mgl**3.*Mt**2.)/864.-

     &  (17*Mgl**7.*Mt**2.)/(576.*Mst2**4.)+

     &  (569*Mgl**5.*Mt**2.)/(1728.*Mst2**2.)+

     &  (1231*Mgl*Mst2**2.*Mt**2.)/1728.-

     &  (5*Mst2**4.*Mt**2.)/(48.*Mgl**1.)-

     &  (Mst2**6.*Mt**2.)/(24.*Mgl**3.)-

     &  (131*Mgl*Mt**4.)/192.+

     &  (37*Mgl**5.*Mt**4.)/(576.*Mst2**4.)-

     &  (679*Mgl**3.*Mt**4.)/(432.*Mst2**2.)+

     &  (43*Mst2**2.*Mt**4.)/(144.*Mgl**1.)+

     &  (Mst2**4.*Mt**4.)/(6.*Mgl**3.)-

     &  Mt**6./(36.*Mgl**1.)-

     &  (35*Mgl**3.*Mt**6.)/(576.*Mst2**4.)+

     &  (191*Mgl*Mt**6.)/(1728.*Mst2**2.)-

     &  (Mst2**2.*Mt**6.)/(4.*Mgl**3.)+

     &  Mt**8./(6.*Mgl**3.)+

     &  (3*Mgl*Mt**8.)/(64.*Mst2**4.)-

     &  (11*Mt**8.)/(144.*Mgl**1.*Mst2**2.)-

     &  Mt**10./(48.*Mgl**1.*Mst2**4.)-

     &  Mt**10./(24.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((319*Mgl**9.)/576.-Mgl**11./(48.*Mst2**2.)+

     &  (2215*Mgl**7.*Mst2**2.)/1728.-

     &  (2491*Mgl**5.*Mst2**4.)/1728.-

     &  (3103*Mgl**3.*Mst2**6.)/1728.+

     &  (1121*Mgl*Mst2**8.)/864.+Mst2**10./(8.*Mgl**1.)-

     &  (5*Mgl**11.)/(288.*Mt**2.)-

     &  (11*Mgl**9.*Mst2**2.)/(144.*Mt**2.)+

     &  (25*Mgl**7.*Mst2**4.)/(72.*Mt**2.)-

     &  (59*Mgl**5.*Mst2**6.)/(144.*Mt**2.)+

     &  (49*Mgl**3.*Mst2**8.)/(288.*Mt**2.)-

     &  (Mgl*Mst2**10.)/(72.*Mt**2.)+

     &  (2321*Mgl**7.*Mt**2.)/1728.+

     &  (127*Mgl**11.*Mt**2.)/(1152.*Mst2**4.)-

     &  (4601*Mgl**9.*Mt**2.)/(3456.*Mst2**2.)-

     &  (2929*Mgl**5.*Mst2**2.*Mt**2.)/432.+

     &  (12413*Mgl**3.*Mst2**4.*Mt**2.)/3456.-

     &  (8867*Mgl*Mst2**6.*Mt**2.)/3456.-

     &  (13*Mst2**8.*Mt**2.)/(36.*Mgl**1.)+

     &  (Mst2**10.*Mt**2.)/(144.*Mgl**3.)-

     &  (5137*Mgl**5.*Mt**4.)/1728.-

     &  (221*Mgl**9.*Mt**4.)/(384.*Mst2**4.)+

     &  (5383*Mgl**7.*Mt**4.)/(864.*Mst2**2.)-

     &  (3577*Mgl**3.*Mst2**2.*Mt**4.)/1728.+

     &  (14053*Mgl*Mst2**4.*Mt**4.)/3456.+

     &  (17*Mst2**6.*Mt**4.)/(24.*Mgl**1.)-

     &  (Mst2**8.*Mt**4.)/(24.*Mgl**3.)-

     &  (3805*Mgl**3.*Mt**6.)/576.+

     &  (193*Mgl**7.*Mt**6.)/(192.*Mst2**4.)-

     &  (11327*Mgl**5.*Mt**6.)/(1728.*Mst2**2.)-

     &  (1465*Mgl*Mst2**2.*Mt**6.)/288.-

     &  (5*Mst2**4.*Mt**6.)/(3.*Mgl**1.)+

     &  (5*Mst2**6.*Mt**6.)/(48.*Mgl**3.)+

     &  (373*Mgl*Mt**8.)/216.-

     &  (415*Mgl**5.*Mt**8.)/(576.*Mst2**4.)+

     &  (601*Mgl**3.*Mt**8.)/(864.*Mst2**2.)+

     &  (175*Mst2**2.*Mt**8.)/(72.*Mgl**1.)-

     &  (5*Mst2**4.*Mt**8.)/(36.*Mgl**3.)-

     &  (19*Mt**10.)/(12.*Mgl**1.)+

     &  (89*Mgl**3.*Mt**10.)/(384.*Mst2**4.)+

     &  (2359*Mgl*Mt**10.)/(3456.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**10.)/(48.*Mgl**3.)-

     &  Mt**12./(24.*Mgl**3.)-

     &  (41*Mgl*Mt**12.)/(384.*Mst2**4.)+

     &  (7*Mt**12.)/(24.*Mgl**1.*Mst2**2.)+

     &  Mt**14./(18.*Mgl**1.*Mst2**4.)+

     &  Mt**14./(144.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((-1165*Mgl**13.)/1728.+Mgl**15./(36.*Mst2**2.)-

     &  (3809*Mgl**11.*Mst2**2.)/1728.+

     &  (1505*Mgl**9.*Mst2**4.)/144.-

     &  (985*Mgl**7.*Mst2**6.)/96.-

     &  (565*Mgl**5.*Mst2**8.)/1728.+

     &  (859*Mgl**3.*Mst2**10.)/192.-

     &  (1261*Mgl*Mst2**12.)/864.-

     &  Mst2**14./(36.*Mgl**1.)+

     &  (7*Mgl**15.)/(288.*Mt**2.)+

     &  (7*Mgl**13.*Mst2**2.)/(144.*Mt**2.)-

     &  (139*Mgl**11.*Mst2**4.)/(288.*Mt**2.)+

     &  (5*Mgl**9.*Mst2**6.)/(6.*Mt**2.)-

     &  (95*Mgl**7.*Mst2**8.)/(288.*Mt**2.)-

     &  (61*Mgl**5.*Mst2**10.)/(144.*Mt**2.)+

     &  (131*Mgl**3.*Mst2**12.)/(288.*Mt**2.)-

     &  (Mgl*Mst2**14.)/(8.*Mt**2.)-

     &  (85*Mgl**11.*Mt**2.)/48.+

     &  (31*Mgl**15.*Mt**2.)/(576.*Mst2**4.)+

     &  (259*Mgl**13.*Mt**2.)/(192.*Mst2**2.)+

     &  (9299*Mgl**9.*Mst2**2.*Mt**2.)/576.-

     &  (14873*Mgl**7.*Mst2**4.*Mt**2.)/576.+

     &  (7643*Mgl**5.*Mst2**6.*Mt**2.)/576.-

     &  (2459*Mgl**3.*Mst2**8.*Mt**2.)/288.+

     &  (2993*Mgl*Mst2**10.*Mt**2.)/576.+

     &  (17*Mst2**12.*Mt**2.)/(144.*Mgl**1.)+

     &  (12827*Mgl**9.*Mt**4.)/1728.-

     &  (7*Mgl**13.*Mt**4.)/(64.*Mst2**4.)-

     &  (403*Mgl**11.*Mt**4.)/(54.*Mst2**2.)-

     &  (25013*Mgl**7.*Mst2**2.*Mt**4.)/864.+

     &  (457*Mgl**5.*Mst2**4.*Mt**4.)/64.+

     &  (15455*Mgl**3.*Mst2**6.*Mt**4.)/864.-

     &  (5411*Mgl*Mst2**8.*Mt**4.)/576.-

     &  (53*Mst2**10.*Mt**4.)/(144.*Mgl**1.)+

     &  (4673*Mgl**7.*Mt**6.)/864.+

     &  (25*Mgl**11.*Mt**6.)/(192.*Mst2**4.)+

     &  (19207*Mgl**9.*Mt**6.)/(1728.*Mst2**2.)+

     &  (4355*Mgl**5.*Mst2**2.*Mt**6.)/288.-

     &  (19643*Mgl**3.*Mst2**4.*Mt**6.)/1728.+

     &  (28303*Mgl*Mst2**6.*Mt**6.)/1728.+

     &  (5*Mst2**8.*Mt**6.)/(4.*Mgl**1.)-

     &  (18671*Mgl**5.*Mt**8.)/1728.-

     &  (575*Mgl**9.*Mt**8.)/(576.*Mst2**4.)+

     &  (25*Mgl**7.*Mt**8.)/(144.*Mst2**2.)-

     &  (1817*Mgl**3.*Mst2**2.*Mt**8.)/192.-

     &  (10237*Mgl*Mst2**4.*Mt**8.)/576.-

     &  (415*Mst2**6.*Mt**8.)/(144.*Mgl**1.)-

     &  (833*Mgl**3.*Mt**10.)/216.+

     &  (1705*Mgl**7.*Mt**10.)/(576.*Mst2**4.)-

     &  (21079*Mgl**5.*Mt**10.)/(1728.*Mst2**2.)+

     &  (355*Mgl*Mst2**2.*Mt**10.)/64.+

     &  (34*Mst2**4.*Mt**10.)/(9.*Mgl**1.)+

     &  (5809*Mgl*Mt**12.)/1728.-

     &  (2101*Mgl**5.*Mt**12.)/(576.*Mst2**4.)+

     &  (227*Mgl**3.*Mt**12.)/(27.*Mst2**2.)-

     &  (43*Mst2**2.*Mt**12.)/(16.*Mgl**1.)+

     &  (8*Mt**14.)/(9.*Mgl**1.)+

     &  (1153*Mgl**3.*Mt**14.)/(576.*Mst2**4.)-

     &  (793*Mgl*Mt**14.)/(576.*Mst2**2.)-

     &  (205*Mgl*Mt**16.)/(576.*Mst2**4.)-

     &  (5*Mt**16.)/(144.*Mgl**1.*Mst2**2.)-

     &  (5*Mt**18.)/(144.*Mgl**1.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((647*Mgl**17.)/1728.-(61*Mgl**15.*Mst2**2.)/576.-

     &  (2761*Mgl**13.*Mst2**4.)/576.+

     &  (2317*Mgl**11.*Mst2**6.)/192.-

     &  (18905*Mgl**9.*Mst2**8.)/1728.+

     &  (2923*Mgl**7.*Mst2**10.)/1728.+

     &  (6103*Mgl**5.*Mst2**12.)/1728.-

     &  (3817*Mgl**3.*Mst2**14.)/1728.+

     &  (331*Mgl*Mst2**16.)/864.-Mgl**19./(96.*Mt**2.)-

     &  (Mgl**17.*Mst2**2.)/(144.*Mt**2.)+

     &  (35*Mgl**15.*Mst2**4.)/(144.*Mt**2.)-

     &  (91*Mgl**13.*Mst2**6.)/(144.*Mt**2.)+

     &  (7*Mgl**11.*Mst2**8.)/(18.*Mt**2.)+

     &  (119*Mgl**9.*Mst2**10.)/(144.*Mt**2.)-

     &  (259*Mgl**7.*Mst2**12.)/(144.*Mt**2.)+

     &  (215*Mgl**5.*Mst2**14.)/(144.*Mt**2.)-

     &  (173*Mgl**3.*Mst2**16.)/(288.*Mt**2.)+

     &  (7*Mgl*Mst2**18.)/(72.*Mt**2.)+

     &  (265*Mgl**15.*Mt**2.)/192.-

     &  (61*Mgl**19.*Mt**2.)/(768.*Mst2**4.)-

     &  (3607*Mgl**17.*Mt**2.)/(6912.*Mst2**2.)-

     &  (2981*Mgl**13.*Mst2**2.*Mt**2.)/288.+

     &  (111293*Mgl**11.*Mst2**4.*Mt**2.)/3456.-

     &  (43969*Mgl**9.*Mst2**6.*Mt**2.)/1152.+

     &  (11543*Mgl**7.*Mst2**8.*Mt**2.)/576.-

     &  (451*Mgl**5.*Mst2**10.*Mt**2.)/48.+

     &  (1961*Mgl**3.*Mst2**12.*Mt**2.)/256.-

     &  (6377*Mgl*Mst2**14.*Mt**2.)/2304.-

     &  (12239*Mgl**13.*Mt**4.)/1728.+

     &  (127*Mgl**17.*Mt**4.)/(256.*Mst2**4.)+

     &  (329*Mgl**15.*Mt**4.)/(96.*Mst2**2.)+

     &  (60259*Mgl**11.*Mst2**2.*Mt**4.)/1728.-

     &  (73013*Mgl**9.*Mst2**4.*Mt**4.)/1152.+

     &  (3103*Mgl**7.*Mst2**6.*Mt**4.)/108.+

     &  (6433*Mgl**5.*Mst2**8.*Mt**4.)/576.-

     &  (25637*Mgl**3.*Mst2**10.*Mt**4.)/1728.+

     &  (45641*Mgl*Mst2**12.*Mt**4.)/6912.+

     &  (1441*Mgl**11.*Mt**6.)/1728.-

     &  (863*Mgl**15.*Mt**6.)/(576.*Mst2**4.)-

     &  (3691*Mgl**13.*Mt**6.)/(576.*Mst2**2.)-

     &  (19079*Mgl**9.*Mst2**2.*Mt**6.)/432.+

     &  (6533*Mgl**7.*Mst2**4.*Mt**6.)/192.+

     &  (2647*Mgl**5.*Mst2**6.*Mt**6.)/1728.+

     &  (49799*Mgl**3.*Mst2**8.*Mt**6.)/1728.-

     &  (11353*Mgl*Mst2**10.*Mt**6.)/864.+

     &  (26707*Mgl**9.*Mt**8.)/1728.+

     &  (1963*Mgl**13.*Mt**8.)/(576.*Mst2**4.)-

     &  (245*Mgl**11.*Mt**8.)/(96.*Mst2**2.)+

     &  (7703*Mgl**7.*Mst2**2.*Mt**8.)/192.+

     &  (4427*Mgl**5.*Mst2**4.*Mt**8.)/864.-

     &  (38897*Mgl**3.*Mst2**6.*Mt**8.)/1728.+

     &  (6563*Mgl*Mst2**8.*Mt**8.)/288.-

     &  (71*Mgl**7.*Mt**10.)/64.-

     &  (865*Mgl**11.*Mt**10.)/(128.*Mst2**4.)+

     &  (82043*Mgl**9.*Mt**10.)/(3456.*Mst2**2.)-

     &  (10679*Mgl**5.*Mst2**2.*Mt**10.)/864.+

     &  (809*Mgl**3.*Mst2**4.*Mt**10.)/384.-

     &  (80459*Mgl*Mst2**6.*Mt**10.)/3456.-

     &  (14935*Mgl**5.*Mt**12.)/576.+

     &  (11969*Mgl**9.*Mt**12.)/(1152.*Mst2**4.)-

     &  (27649*Mgl**7.*Mt**12.)/(864.*Mst2**2.)-

     &  (20347*Mgl**3.*Mst2**2.*Mt**12.)/1728.+

     &  (29273*Mgl*Mst2**4.*Mt**12.)/3456.+

     &  (33053*Mgl**3.*Mt**14.)/1728.-

     &  (6227*Mgl**7.*Mt**14.)/(576.*Mst2**4.)+

     &  (30847*Mgl**5.*Mt**14.)/(1728.*Mst2**2.)+

     &  (181*Mgl*Mst2**2.*Mt**14.)/48.-

     &  (2627*Mgl*Mt**16.)/864.+

     &  (447*Mgl**5.*Mt**16.)/(64.*Mst2**4.)-

     &  (2819*Mgl**3.*Mt**16.)/(864.*Mst2**2.)-

     &  (5807*Mgl**3.*Mt**18.)/(2304.*Mst2**4.)-

     &  (1879*Mgl*Mt**18.)/(6912.*Mst2**2.)+

     &  (895*Mgl*Mt**20.)/(2304.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  (-0.099609375-(19*Mgl**4.)/(4608.*Mst1**4.)-

     &  (15*Mgl**2.)/(1024.*Mst1**2.)-

     &  (19*Mgl**4.)/(4608.*Mst2**4.)-

     &  (15*Mgl**2.)/(1024.*Mst2**2.)+

     &  (53*Mgl**4.)/(9216.*Mt**4.)-

     &  (53*Mgl**2.*Mst2**2.)/(9216.*Mt**4.)-

     &  (67*Mgl**2.)/(9216.*Mt**2.)+

     &  (5*Mst2**2.)/(144.*Mt**2.)-

     &  (19*Mgl**2.*Mt**2.)/(9216.*Mst1**4.)+

     &  Mt**2./(128.*Mst1**2.)-

     &  (19*Mgl**2.*Mt**2.)/(9216.*Mst2**4.)+

     &  Mt**2./(128.*Mst2**2.)+

     &  (19*Mt**4.)/(9216.*Mst1**4.)+

     &  (19*Mt**4.)/(9216.*Mst2**4.))*ln(mu,Mgl)**2.+

     &  ((-11*Mgl**4.)/384.+(7*Mgl**8.)/(1152.*Mst1**4.)+

     &  (7*Mgl**6.)/(768.*Mst1**2.)-

     &  (65*Mgl**2.*Mst1**2.)/768.+(89*Mst1**4.)/1152.-

     &  (247*Mgl**2.*Mt**2.)/2304.-

     &  (23*Mgl**6.*Mt**2.)/(2304.*Mst1**4.)-

     &  (23*Mgl**4.*Mt**2.)/(256.*Mst1**2.)+

     &  (53*Mst1**2.*Mt**2.)/2304.-(355*Mt**4.)/2304.-

     &  (5*Mgl**4.*Mt**4.)/(2304.*Mst1**4.)-

     &  (73*Mgl**2.*Mt**4.)/(768.*Mst1**2.)+

     &  (23*Mgl**2.*Mt**6.)/(2304.*Mst1**4.)+

     &  (133*Mt**6.)/(2304.*Mst1**2.)-

     &  Mt**8./(256.*Mst1**4.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mgl)**2.+

     &  ((239*Mgl**8.)/1536.-

     &  (17*Mgl**12.)/(2304.*Mst1**4.)-

     &  (65*Mgl**10.)/(4608.*Mst1**2.)-

     &  (77*Mgl**6.*Mst1**2.)/288.-

     &  (65*Mgl**4.*Mst1**4.)/768.+

     &  (1433*Mgl**2.*Mst1**6.)/4608.-

     &  (143*Mst1**8.)/1536.-(247*Mgl**6.*Mt**2.)/384.+

     &  (139*Mgl**10.*Mt**2.)/(4608.*Mst1**4.)+

     &  (59*Mgl**8.*Mt**2.)/(256.*Mst1**2.)+

     &  (11*Mgl**4.*Mst1**2.*Mt**2.)/192.+

     &  (133*Mgl**2.*Mst1**4.*Mt**2.)/512.-

     &  (35*Mst1**6.*Mt**2.)/768.+

     &  (137*Mgl**4.*Mt**4.)/2304.-

     &  (203*Mgl**8.*Mt**4.)/(4608.*Mst1**4.)-

     &  (241*Mgl**6.*Mt**4.)/(2304.*Mst1**2.)-

     &  (Mgl**2.*Mst1**2.*Mt**4.)/1152.+

     &  (359*Mst1**4.*Mt**4.)/512.-

     &  (1063*Mgl**2.*Mt**6.)/1152.+

     &  (3*Mgl**6.*Mt**6.)/(256.*Mst1**4.)-

     &  (59*Mgl**4.*Mt**6.)/(128.*Mst1**2.)-

     &  (1051*Mst1**2.*Mt**6.)/1152.+(587*Mt**8.)/1536.+

     &  (11*Mgl**4.*Mt**8.)/(288.*Mst1**4.)+

     &  (1819*Mgl**2.*Mt**8.)/(4608.*Mst1**2.)-

     &  (193*Mgl**2.*Mt**10.)/(4608.*Mst1**4.)-

     &  (35*Mt**10.)/(768.*Mst1**2.)+

     &  (61*Mt**12.)/(4608.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mgl)**2.+

     &  ((-337*Mgl**12.)/1152.+Mgl**16./(384.*Mst1**4.)+

     &  (65*Mgl**14.)/(2304.*Mst1**2.)+

     &  (1793*Mgl**10.*Mst1**2.)/2304.-

     &  (755*Mgl**8.*Mst1**4.)/1152.-

     &  (85*Mgl**6.*Mst1**6.)/256.+

     &  (1001*Mgl**4.*Mst1**8.)/1152.-

     &  (1093*Mgl**2.*Mst1**10.)/2304.+

     &  (11*Mst1**12.)/144.+(1123*Mgl**10.*Mt**2.)/768.-

     &  (13*Mgl**14.*Mt**2.)/(768.*Mst1**4.)-

     &  (79*Mgl**12.*Mt**2.)/(256.*Mst1**2.)-

     &  (5197*Mgl**8.*Mst1**2.*Mt**2.)/2304.+

     &  (3979*Mgl**6.*Mst1**4.*Mt**2.)/2304.-

     &  (1937*Mgl**4.*Mst1**6.*Mt**2.)/2304.+

     &  (739*Mgl**2.*Mst1**8.*Mt**2.)/2304.-

     &  (203*Mst1**10.*Mt**2.)/2304.-

     &  (2371*Mgl**8.*Mt**4.)/2304.+

     &  (15*Mgl**12.*Mt**4.)/(256.*Mst1**4.)+

     &  (1447*Mgl**10.*Mt**4.)/(2304.*Mst1**2.)+

     &  (767*Mgl**6.*Mst1**2.*Mt**4.)/1152.+

     &  (265*Mgl**4.*Mst1**4.*Mt**4.)/2304.+

     &  (625*Mgl**2.*Mst1**6.*Mt**4.)/768.-

     &  (157*Mst1**8.*Mt**4.)/256.+

     &  (79*Mgl**6.*Mt**6.)/384.-

     &  (263*Mgl**10.*Mt**6.)/(2304.*Mst1**4.)-

     &  (421*Mgl**8.*Mt**6.)/(2304.*Mst1**2.)+

     &  (821*Mgl**4.*Mst1**2.*Mt**6.)/1152.+

     &  (517*Mgl**2.*Mst1**4.*Mt**6.)/2304.+

     &  (4003*Mst1**6.*Mt**6.)/2304.-

     &  (113*Mgl**4.*Mt**8.)/96.+

     &  (73*Mgl**8.*Mt**8.)/(768.*Mst1**4.)-

     &  (1177*Mgl**6.*Mt**8.)/(2304.*Mst1**2.)-

     &  (4015*Mgl**2.*Mst1**2.*Mt**8.)/2304.-

     &  (1345*Mst1**4.*Mt**8.)/768.+

     &  (229*Mgl**2.*Mt**10.)/256.+

     &  (83*Mgl**6.*Mt**10.)/(2304.*Mst1**4.)+

     &  (349*Mgl**4.*Mt**10.)/(768.*Mst1**2.)+

     &  (1619*Mst1**2.*Mt**10.)/2304.-(49*Mt**12.)/768.-

     &  (307*Mgl**4.*Mt**12.)/(2304.*Mst1**4.)-

     &  (101*Mgl**2.*Mt**12.)/(768.*Mst1**2.)+

     &  (73*Mgl**2.*Mt**14.)/(768.*Mst1**4.)+

     &  (53*Mt**14.)/(2304.*Mst1**2.)-

     &  (53*Mt**16.)/(2304.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.*ln(mu,Mgl)**2.+

     &  ((1921*Mgl**16.)/9216.+

     &  (13*Mgl**20.)/(4608.*Mst1**4.)-

     &  (271*Mgl**18.)/(9216.*Mst1**2.)-

     &  (263*Mgl**14.*Mst1**2.)/384.+

     &  (2405*Mgl**12.*Mst1**4.)/2304.-

     &  (2383*Mgl**10.*Mst1**6.)/4608.-

     &  (889*Mgl**8.*Mst1**8.)/1536.+

     &  (599*Mgl**6.*Mst1**10.)/576.-

     &  (3019*Mgl**4.*Mst1**12.)/4608.+

     &  (1765*Mgl**2.*Mst1**14.)/9216.-

     &  (65*Mst1**16.)/3072.-(547*Mgl**14.*Mt**2.)/576.-

     &  (203*Mgl**18.*Mt**2.)/(9216.*Mst1**4.)+

     &  (457*Mgl**16.*Mt**2.)/(2304.*Mst1**2.)+

     &  (2507*Mgl**12.*Mst1**2.*Mt**2.)/1152.-

     &  (1635*Mgl**10.*Mst1**4.*Mt**2.)/512.+

     &  (4217*Mgl**8.*Mst1**6.*Mt**2.)/1152.-

     &  (1121*Mgl**6.*Mst1**8.*Mt**2.)/384.+

     &  (1459*Mgl**4.*Mst1**10.*Mt**2.)/1152.-

     &  (255*Mgl**2.*Mst1**12.*Mt**2.)/1024.+

     &  (73*Mst1**14.*Mt**2.)/2304.+

     &  (2047*Mgl**12.*Mt**4.)/2304.+

     &  (571*Mgl**16.*Mt**4.)/(9216.*Mst1**4.)-

     &  (317*Mgl**14.*Mt**4.)/(768.*Mst1**2.)-

     &  (755*Mgl**10.*Mst1**2.*Mt**4.)/576.+

     &  (8287*Mgl**8.*Mst1**4.*Mt**4.)/4608.+

     &  (329*Mgl**6.*Mst1**6.*Mt**4.)/2304.-

     &  (1163*Mgl**4.*Mst1**8.*Mt**4.)/2304.-

     &  (1147*Mgl**2.*Mst1**10.*Mt**4.)/1152.+

     &  (1021*Mst1**12.*Mt**4.)/3072.+

     &  (409*Mgl**10.*Mt**6.)/576.-

     &  (15*Mgl**14.*Mt**6.)/(256.*Mst1**4.)+

     &  (31*Mgl**12.*Mt**6.)/(192.*Mst1**2.)-

     &  (Mgl**8.*Mst1**2.*Mt**6.)/64.+

     &  (2189*Mgl**6.*Mst1**4.*Mt**6.)/2304.-

     &  (13*Mgl**4.*Mst1**6.*Mt**6.)/24.+

     &  (287*Mgl**2.*Mst1**8.*Mt**6.)/128.-

     &  (139*Mst1**10.*Mt**6.)/96.-

     &  (1543*Mgl**8.*Mt**8.)/1536.-

     &  (23*Mgl**12.*Mt**8.)/(384.*Mst1**4.)+

     &  (685*Mgl**10.*Mt**8.)/(1536.*Mst1**2.)+

     &  (991*Mgl**6.*Mst1**2.*Mt**8.)/1152.+

     &  (415*Mgl**4.*Mst1**4.*Mt**8.)/288.-

     &  (4171*Mgl**2.*Mst1**6.*Mt**8.)/4608.+

     &  (1337*Mst1**8.*Mt**8.)/512.-

     &  (5*Mgl**6.*Mt**10.)/64.+

     &  (851*Mgl**10.*Mt**10.)/(4608.*Mst1**4.)-

     &  (185*Mgl**8.*Mt**10.)/(384.*Mst1**2.)-

     &  (1585*Mgl**4.*Mst1**2.*Mt**10.)/1152.-

     &  (4415*Mgl**2.*Mst1**4.*Mt**10.)/4608.-

     &  (973*Mst1**6.*Mt**10.)/384.+

     &  (503*Mgl**4.*Mt**12.)/2304.-

     &  (197*Mgl**8.*Mt**12.)/(1536.*Mst1**4.)+

     &  (109*Mgl**6.*Mt**12.)/(2304.*Mst1**2.)+

     &  (215*Mgl**2.*Mst1**2.*Mt**12.)/288.+

     &  (2093*Mst1**4.*Mt**12.)/1536.-

     &  (49*Mgl**2.*Mt**14.)/576.-

     &  (11*Mgl**6.*Mt**14.)/(256.*Mst1**4.)+

     &  (23*Mgl**4.*Mt**14.)/(576.*Mst1**2.)-

     &  (19*Mst1**2.*Mt**14.)/48.+(283*Mt**16.)/3072.+

     &  (515*Mgl**4.*Mt**16.)/(4608.*Mst1**4.)+

     &  (227*Mgl**2.*Mt**16.)/(3072.*Mst1**2.)-

     &  (563*Mgl**2.*Mt**18.)/(9216.*Mst1**4.)-

     &  (11*Mt**18.)/(256.*Mst1**2.)+

     &  (107*Mt**20.)/(9216.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.*ln(mu,Mgl)**2.+

     &  (-Mgl**4./18.+(7*Mgl**8.)/(1152.*Mst2**4.)+

     &  (7*Mgl**6.)/(768.*Mst2**2.)+

     &  (17*Mgl**2.*Mst2**2.)/256.+(29*Mst2**4.)/288.-

     &  (13*Mgl**8.)/(1152.*Mt**4.)+

     &  (41*Mgl**6.*Mst2**2.)/(1152.*Mt**4.)-

     &  (5*Mgl**4.*Mst2**4.)/(128.*Mt**4.)+

     &  (19*Mgl**2.*Mst2**6.)/(1152.*Mt**4.)-

     &  Mst2**8./(576.*Mt**4.)+

     &  (7*Mgl**6.)/(1152.*Mt**2.)-

     &  (97*Mgl**4.*Mst2**2.)/(1152.*Mt**2.)+

     &  (91*Mgl**2.*Mst2**4.)/(1152.*Mt**2.)-

     &  Mst2**6./(1152.*Mt**2.)-

     &  (431*Mgl**2.*Mt**2.)/2304.-

     &  (23*Mgl**6.*Mt**2.)/(2304.*Mst2**4.)-

     &  (23*Mgl**4.*Mt**2.)/(256.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**2.)/768.-(317*Mt**4.)/2304.-

     &  (5*Mgl**4.*Mt**4.)/(2304.*Mst2**4.)-

     &  (73*Mgl**2.*Mt**4.)/(768.*Mst2**2.)+

     &  (23*Mgl**2.*Mt**6.)/(2304.*Mst2**4.)+

     &  (133*Mt**6.)/(2304.*Mst2**2.)-

     &  Mt**8./(256.*Mst2**4.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mgl)**2.+

     &  ((713*Mgl**8.)/4608.-

     &  (17*Mgl**12.)/(2304.*Mst2**4.)-

     &  (65*Mgl**10.)/(4608.*Mst2**2.)-

     &  (125*Mgl**6.*Mst2**2.)/192.+

     &  (1153*Mgl**4.*Mst2**4.)/2304.-

     &  (815*Mgl**2.*Mst2**6.)/4608.+

     &  (895*Mst2**8.)/4608.+

     &  (23*Mgl**12.)/(4608.*Mt**4.)-

     &  (15*Mgl**10.*Mst2**2.)/(512.*Mt**4.)+

     &  (53*Mgl**8.*Mst2**4.)/(768.*Mt**4.)-

     &  (191*Mgl**6.*Mst2**6.)/(2304.*Mt**4.)+

     &  (27*Mgl**4.*Mst2**8.)/(512.*Mt**4.)-

     &  (25*Mgl**2.*Mst2**10.)/(1536.*Mt**4.)+

     &  Mst2**12./(576.*Mt**4.)-

     &  (109*Mgl**10.)/(4608.*Mt**2.)+

     &  (59*Mgl**8.*Mst2**2.)/(288.*Mt**2.)-

     &  (839*Mgl**6.*Mst2**4.)/(2304.*Mt**2.)+

     &  (145*Mgl**4.*Mst2**6.)/(1152.*Mt**2.)+

     &  (643*Mgl**2.*Mst2**8.)/(4608.*Mt**2.)-

     &  (95*Mst2**10.)/(1152.*Mt**2.)-

     &  (395*Mgl**6.*Mt**2.)/576.+

     &  (139*Mgl**10.*Mt**2.)/(4608.*Mst2**4.)+

     &  (59*Mgl**8.*Mt**2.)/(256.*Mst2**2.)-

     &  (5*Mgl**4.*Mst2**2.*Mt**2.)/36.+

     &  (433*Mgl**2.*Mst2**4.*Mt**2.)/512.-

     &  (311*Mst2**6.*Mt**2.)/768.+

     &  (859*Mgl**4.*Mt**4.)/4608.-

     &  (203*Mgl**8.*Mt**4.)/(4608.*Mst2**4.)-

     &  (241*Mgl**6.*Mt**4.)/(2304.*Mst2**2.)-

     &  (857*Mgl**2.*Mst2**2.*Mt**4.)/4608.+

     &  (3935*Mst2**4.*Mt**4.)/4608.-

     &  (491*Mgl**2.*Mt**6.)/512.+

     &  (3*Mgl**6.*Mt**6.)/(256.*Mst2**4.)-

     &  (59*Mgl**4.*Mt**6.)/(128.*Mst2**2.)-

     &  (511*Mst2**2.*Mt**6.)/576.+(1645*Mt**8.)/4608.+

     &  (11*Mgl**4.*Mt**8.)/(288.*Mst2**4.)+

     &  (1819*Mgl**2.*Mt**8.)/(4608.*Mst2**2.)-

     &  (193*Mgl**2.*Mt**10.)/(4608.*Mst2**4.)-

     &  (35*Mt**10.)/(768.*Mst2**2.)+

     &  (61*Mt**12.)/(4608.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mgl)**2.+

     &  ((-19*Mgl**12.)/128.+Mgl**16./(384.*Mst2**4.)+

     &  (65*Mgl**14.)/(2304.*Mst2**2.)+

     &  (215*Mgl**10.*Mst2**2.)/256.-

     &  (293*Mgl**8.*Mst2**4.)/192.+

     &  (2063*Mgl**6.*Mst2**6.)/2304.-

     &  (101*Mgl**4.*Mst2**8.)/384.+

     &  (961*Mgl**2.*Mst2**10.)/2304.-

     &  (283*Mst2**12.)/1152.+Mgl**16./(1152.*Mt**4.)-

     &  (Mgl**14.*Mst2**2.)/(384.*Mt**4.)-

     &  (Mgl**12.*Mst2**4.)/(1152.*Mt**4.)+

     &  (13*Mgl**10.*Mst2**6.)/(1152.*Mt**4.)-

     &  (5*Mgl**8.*Mst2**8.)/(384.*Mt**4.)-

     &  (Mgl**6.*Mst2**10.)/(1152.*Mt**4.)+

     &  (13*Mgl**4.*Mst2**12.)/(1152.*Mt**4.)-

     &  (Mgl**2.*Mst2**14.)/(128.*Mt**4.)+

     &  Mst2**16./(576.*Mt**4.)+Mgl**14./(384.*Mt**2.)-

     &  (185*Mgl**12.*Mst2**2.)/(1152.*Mt**2.)+

     &  (755*Mgl**10.*Mst2**4.)/(1152.*Mt**2.)-

     &  (129*Mgl**8.*Mst2**6.)/(128.*Mt**2.)+

     &  (689*Mgl**6.*Mst2**8.)/(1152.*Mt**2.)+

     &  (61*Mgl**4.*Mst2**10.)/(1152.*Mt**2.)-

     &  (77*Mgl**2.*Mst2**12.)/(384.*Mt**2.)+

     &  (23*Mst2**14.)/(384.*Mt**2.)+

     &  (2563*Mgl**10.*Mt**2.)/2304.-

     &  (13*Mgl**14.*Mt**2.)/(768.*Mst2**4.)-

     &  (79*Mgl**12.*Mt**2.)/(256.*Mst2**2.)-

     &  (4379*Mgl**8.*Mst2**2.*Mt**2.)/2304.+

     &  (685*Mgl**6.*Mst2**4.*Mt**2.)/768.+

     &  (1931*Mgl**4.*Mst2**6.*Mt**2.)/2304.-

     &  (283*Mgl**2.*Mst2**8.*Mt**2.)/256.+

     &  (1127*Mst2**10.*Mt**2.)/2304.-

     &  (311*Mgl**8.*Mt**4.)/256.+

     &  (15*Mgl**12.*Mt**4.)/(256.*Mst2**4.)+

     &  (1447*Mgl**10.*Mt**4.)/(2304.*Mst2**2.)-

     &  (53*Mgl**6.*Mst2**2.*Mt**4.)/192.-

     &  (1685*Mgl**4.*Mst2**4.*Mt**4.)/2304.+

     &  (4349*Mgl**2.*Mst2**6.*Mt**4.)/2304.-

     &  (227*Mst2**8.*Mt**4.)/256.+

     &  (667*Mgl**6.*Mt**6.)/576.-

     &  (263*Mgl**10.*Mt**6.)/(2304.*Mst2**4.)-

     &  (421*Mgl**8.*Mt**6.)/(2304.*Mst2**2.)+

     &  (901*Mgl**4.*Mst2**2.*Mt**6.)/576.-

     &  (421*Mgl**2.*Mst2**4.*Mt**6.)/2304.+

     &  (1003*Mst2**6.*Mt**6.)/768.-

     &  (1033*Mgl**4.*Mt**8.)/576.+

     &  (73*Mgl**8.*Mt**8.)/(768.*Mst2**4.)-

     &  (1177*Mgl**6.*Mt**8.)/(2304.*Mst2**2.)-

     &  (421*Mgl**2.*Mst2**2.*Mt**8.)/256.-

     &  (2453*Mst2**4.*Mt**8.)/2304.+

     &  (2011*Mgl**2.*Mt**10.)/2304.+

     &  (83*Mgl**6.*Mt**10.)/(2304.*Mst2**4.)+

     &  (349*Mgl**4.*Mt**10.)/(768.*Mst2**2.)+

     &  (761*Mst2**2.*Mt**10.)/2304.+(23*Mt**12.)/2304.-

     &  (307*Mgl**4.*Mt**12.)/(2304.*Mst2**4.)-

     &  (101*Mgl**2.*Mt**12.)/(768.*Mst2**2.)+

     &  (73*Mgl**2.*Mt**14.)/(768.*Mst2**4.)+

     &  (53*Mt**14.)/(2304.*Mst2**2.)-

     &  (53*Mt**16.)/(2304.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.*ln(mu,Mgl)**2.+

     &  ((-191*Mgl**16.)/9216.+

     &  (13*Mgl**20.)/(4608.*Mst2**4.)-

     &  (271*Mgl**18.)/(9216.*Mst2**2.)+

     &  (17*Mgl**14.*Mst2**2.)/288.+

     &  (155*Mgl**12.*Mst2**4.)/256.-

     &  (2489*Mgl**10.*Mst2**6.)/1536.+

     &  (6769*Mgl**8.*Mst2**8.)/4608.-

     &  (71*Mgl**6.*Mst2**10.)/128.+

     &  (1129*Mgl**4.*Mst2**12.)/4608.-

     &  (2243*Mgl**2.*Mst2**14.)/9216.+

     &  (805*Mst2**16.)/9216.-Mgl**20./(3072.*Mt**4.)+

     &  (19*Mgl**18.*Mst2**2.)/(9216.*Mt**4.)-

     &  (5*Mgl**16.*Mst2**4.)/(768.*Mt**4.)+

     &  (13*Mgl**14.*Mst2**6.)/(768.*Mt**4.)-

     &  (21*Mgl**12.*Mst2**8.)/(512.*Mt**4.)+

     &  (119*Mgl**10.*Mst2**10.)/(1536.*Mt**4.)-

     &  (77*Mgl**8.*Mst2**12.)/(768.*Mt**4.)+

     &  (65*Mgl**6.*Mst2**14.)/(768.*Mt**4.)-

     &  (137*Mgl**4.*Mst2**16.)/(3072.*Mt**4.)+

     &  (41*Mgl**2.*Mst2**18.)/(3072.*Mt**4.)-

     &  Mst2**20./(576.*Mt**4.)+

     &  (205*Mgl**18.)/(9216.*Mt**2.)-

     &  (61*Mgl**16.*Mst2**2.)/(576.*Mt**2.)+

     &  (39*Mgl**14.*Mst2**4.)/(256.*Mt**2.)+

     &  (61*Mgl**12.*Mst2**6.)/(1152.*Mt**2.)-

     &  (1793*Mgl**10.*Mst2**8.)/(4608.*Mt**2.)+

     &  (55*Mgl**8.*Mst2**10.)/(128.*Mt**2.)-

     &  (361*Mgl**6.*Mst2**12.)/(2304.*Mt**2.)-

     &  (53*Mgl**4.*Mst2**14.)/(1152.*Mt**2.)+

     &  (53*Mgl**2.*Mst2**16.)/(1024.*Mt**2.)-

     &  (13*Mst2**18.)/(1152.*Mt**2.)-

     &  (11*Mgl**14.*Mt**2.)/72.-

     &  (203*Mgl**18.*Mt**2.)/(9216.*Mst2**4.)+

     &  (457*Mgl**16.*Mt**2.)/(2304.*Mst2**2.)+

     &  (695*Mgl**12.*Mst2**2.*Mt**2.)/1152.-

     &  (1187*Mgl**10.*Mst2**4.*Mt**2.)/512.+

     &  (2725*Mgl**8.*Mst2**6.*Mt**2.)/1152.-

     &  (293*Mgl**6.*Mst2**8.*Mt**2.)/1152.-

     &  (977*Mgl**4.*Mst2**10.*Mt**2.)/1152.+

     &  (5993*Mgl**2.*Mst2**12.*Mt**2.)/9216.-

     &  (511*Mst2**14.*Mt**2.)/2304.-

     &  (869*Mgl**12.*Mt**4.)/4608.+

     &  (571*Mgl**16.*Mt**4.)/(9216.*Mst2**4.)-

     &  (317*Mgl**14.*Mt**4.)/(768.*Mst2**2.)+

     &  (167*Mgl**10.*Mst2**2.*Mt**4.)/4608.+

     &  (3905*Mgl**8.*Mst2**4.*Mt**4.)/4608.-

     &  (149*Mgl**6.*Mst2**6.*Mt**4.)/288.+

     &  (835*Mgl**4.*Mst2**8.*Mt**4.)/512.-

     &  (8473*Mgl**2.*Mst2**10.*Mt**4.)/4608.+

     &  (3511*Mst2**12.*Mt**4.)/9216.+

     &  (1259*Mgl**10.*Mt**6.)/1536.-

     &  (15*Mgl**14.*Mt**6.)/(256.*Mst2**4.)+

     &  (31*Mgl**12.*Mt**6.)/(192.*Mst2**2.)-

     &  (499*Mgl**8.*Mst2**2.*Mt**6.)/384.-

     &  (71*Mgl**6.*Mst2**4.*Mt**6.)/576.-

     &  (2113*Mgl**4.*Mst2**6.*Mt**6.)/1152.+

     &  (1477*Mgl**2.*Mst2**8.*Mt**6.)/512.-

     &  (365*Mst2**10.*Mt**6.)/576.+

     &  (683*Mgl**8.*Mt**8.)/4608.-

     &  (23*Mgl**12.*Mt**8.)/(384.*Mst2**4.)+

     &  (685*Mgl**10.*Mt**8.)/(1536.*Mst2**2.)+

     &  (339*Mgl**6.*Mst2**2.*Mt**8.)/128.+

     &  (1361*Mgl**4.*Mst2**4.*Mt**8.)/576.-

     &  (2809*Mgl**2.*Mst2**6.*Mt**8.)/1536.+

     &  (4025*Mst2**8.*Mt**8.)/4608.-

     &  (1303*Mgl**6.*Mt**10.)/1152.+

     &  (851*Mgl**10.*Mt**10.)/(4608.*Mst2**4.)-

     &  (185*Mgl**8.*Mt**10.)/(384.*Mst2**2.)-

     &  (781*Mgl**4.*Mst2**2.*Mt**10.)/384.+

     &  (469*Mgl**2.*Mst2**4.*Mt**10.)/4608.-

     &  (859*Mst2**6.*Mt**10.)/1152.+

     &  (1279*Mgl**4.*Mt**12.)/3072.-

     &  (197*Mgl**8.*Mt**12.)/(1536.*Mst2**4.)+

     &  (109*Mgl**6.*Mt**12.)/(2304.*Mst2**2.)+

     &  (1447*Mgl**2.*Mst2**2.*Mt**12.)/9216.+

     &  (1487*Mst2**4.*Mt**12.)/4608.+

     &  (361*Mgl**2.*Mt**14.)/9216.-

     &  (11*Mgl**6.*Mt**14.)/(256.*Mst2**4.)+

     &  (23*Mgl**4.*Mt**14.)/(576.*Mst2**2.)-

     &  (77*Mst2**2.*Mt**14.)/1152.+(49*Mt**16.)/1024.+

     &  (515*Mgl**4.*Mt**16.)/(4608.*Mst2**4.)+

     &  (227*Mgl**2.*Mt**16.)/(3072.*Mst2**2.)-

     &  (563*Mgl**2.*Mt**18.)/(9216.*Mst2**4.)-

     &  (11*Mt**18.)/(256.*Mst2**2.)+

     &  (107*Mt**20.)/(9216.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.*ln(mu,Mgl)**2.+

     &  (-Mgl/18.+(25*Mgl**3.)/(2304.*Mt**2.)+

     &  (19*Mgl**3.*Mt**2.)/(1152.*Mst1**4.)+

     &  (13*Mgl*Mt**2.)/(2304.*Mst1**2.)-

     &  (19*Mgl**3.*Mt**2.)/(1152.*Mst2**4.)-

     &  (13*Mgl*Mt**2.)/(2304.*Mst2**2.)-

     &  (19*Mgl*Mt**4.)/(2304.*Mst1**4.)+

     &  (19*Mgl*Mt**4.)/(2304.*Mst2**4.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mgl)**2.+

     &  ((127*Mgl**3.*Mt**2.)/576.-

     &  (7*Mgl**7.*Mt**2.)/(288.*Mst1**4.)-

     &  (43*Mgl**5.*Mt**2.)/(576.*Mst1**2.)+

     &  (Mgl*Mst1**2.*Mt**2.)/96.+(187*Mgl*Mt**4.)/576.+

     &  (37*Mgl**5.*Mt**4.)/(576.*Mst1**4.)+

     &  (101*Mgl**3.*Mt**4.)/(192.*Mst1**2.)-

     &  (Mgl**3.*Mt**6.)/(18.*Mst1**4.)-

     &  (31*Mgl*Mt**6.)/(144.*Mst1**2.)+

     &  (Mgl*Mt**8.)/(64.*Mst1**4.))*Xt*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((-43*Mgl**7.*Mt**2.)/64.+

     &  (17*Mgl**11.*Mt**2.)/(576.*Mst1**4.)+

     &  (49*Mgl**9.*Mt**2.)/(384.*Mst1**2.)+

     &  (433*Mgl**5.*Mst1**2.*Mt**2.)/576.+

     &  (19*Mgl**3.*Mst1**4.*Mt**2.)/144.-

     &  (67*Mgl*Mst1**6.*Mt**2.)/384.+

     &  (11*Mgl**5.*Mt**4.)/6.-

     &  (173*Mgl**9.*Mt**4.)/(1152.*Mst1**4.)-

     &  (89*Mgl**7.*Mt**4.)/(64.*Mst1**2.)+

     &  (37*Mgl**3.*Mst1**2.*Mt**4.)/192.-

     &  (479*Mgl*Mst1**4.*Mt**4.)/1152.+

     &  (917*Mgl**3.*Mt**6.)/576.+

     &  (47*Mgl**7.*Mt**6.)/(144.*Mst1**4.)+

     &  (715*Mgl**5.*Mt**6.)/(288.*Mst1**2.)+

     &  (65*Mgl*Mst1**2.*Mt**6.)/48.-

     &  (235*Mgl*Mt**8.)/288.-

     &  (215*Mgl**5.*Mt**8.)/(576.*Mst1**4.)-

     &  (763*Mgl**3.*Mt**8.)/(576.*Mst1**2.)+

     &  (127*Mgl**3.*Mt**10.)/(576.*Mst1**4.)+

     &  (121*Mgl*Mt**10.)/(1152.*Mst1**2.)-

     &  (61*Mgl*Mt**12.)/(1152.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((55*Mgl**11.*Mt**2.)/64.-

     &  (Mgl**15.*Mt**2.)/(96.*Mst1**4.)-

     &  (47*Mgl**13.*Mt**2.)/(576.*Mst1**2.)-

     &  (601*Mgl**9.*Mst1**2.*Mt**2.)/288.+

     &  (47*Mgl**7.*Mst1**4.*Mt**2.)/36.+

     &  (533*Mgl**5.*Mst1**6.*Mt**2.)/576.-

     &  (665*Mgl**3.*Mst1**8.*Mt**2.)/576.+

     &  (35*Mgl*Mst1**10.*Mt**2.)/144.-

     &  (2521*Mgl**9.*Mt**4.)/576.+

     &  (5*Mgl**13.*Mt**4.)/(64.*Mst1**4.)+

     &  (647*Mgl**11.*Mt**4.)/(576.*Mst1**2.)+

     &  (1549*Mgl**7.*Mst1**2.*Mt**4.)/288.-

     &  (1441*Mgl**5.*Mst1**4.*Mt**4.)/576.+

     &  (71*Mgl**3.*Mst1**6.*Mt**4.)/576.-

     &  (3*Mgl*Mst1**8.*Mt**4.)/64.+

     &  (751*Mgl**7.*Mt**6.)/288.-

     &  (5*Mgl**11.*Mt**6.)/(16.*Mst1**4.)-

     &  (307*Mgl**9.*Mt**6.)/(96.*Mst1**2.)-

     &  (965*Mgl**5.*Mst1**2.*Mt**6.)/288.-

     &  (77*Mgl**3.*Mst1**4.*Mt**6.)/288.-

     &  (91*Mgl*Mst1**6.*Mt**6.)/48.+

     &  (971*Mgl**5.*Mt**8.)/288.+

     &  (443*Mgl**9.*Mt**8.)/(576.*Mst1**4.)+

     &  (341*Mgl**7.*Mt**8.)/(96.*Mst1**2.)+

     &  (1175*Mgl**3.*Mst1**2.*Mt**8.)/288.+

     &  (1891*Mgl*Mst1**4.*Mt**8.)/576.-

     &  (1469*Mgl**3.*Mt**10.)/576.-

     &  (331*Mgl**7.*Mt**10.)/(288.*Mst1**4.)-

     &  (931*Mgl**5.*Mt**10.)/(576.*Mst1**2.)-

     &  (251*Mgl*Mst1**2.*Mt**10.)/144.+

     &  (17*Mgl*Mt**12.)/192.+

     &  (193*Mgl**5.*Mt**12.)/(192.*Mst1**4.)+

     &  (139*Mgl**3.*Mt**12.)/(576.*Mst1**2.)-

     &  (17*Mgl**3.*Mt**14.)/(36.*Mst1**4.)-

     &  (Mgl*Mt**14.)/(48.*Mst1**2.)+

     &  (53*Mgl*Mt**16.)/(576.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((-419*Mgl**15.*Mt**2.)/576.-

     &  (13*Mgl**19.*Mt**2.)/(1152.*Mst1**4.)+

     &  (245*Mgl**17.*Mt**2.)/(2304.*Mst1**2.)+

     &  (1159*Mgl**13.*Mst1**2.*Mt**2.)/576.-

     &  (623*Mgl**11.*Mst1**4.*Mt**2.)/288.-

     &  (109*Mgl**9.*Mst1**6.*Mt**2.)/1152.+

     &  (1279*Mgl**7.*Mst1**8.*Mt**2.)/576.-

     &  (1117*Mgl**5.*Mst1**10.*Mt**2.)/576.+

     &  (785*Mgl**3.*Mst1**12.*Mt**2.)/1152.-

     &  (65*Mgl*Mst1**14.*Mt**2.)/768.+

     &  (1073*Mgl**13.*Mt**4.)/288.+

     &  (229*Mgl**17.*Mt**4.)/(2304.*Mst1**4.)-

     &  (461*Mgl**15.*Mt**4.)/(576.*Mst1**2.)-

     &  (4027*Mgl**11.*Mst1**2.*Mt**4.)/576.+

     &  (1017*Mgl**9.*Mst1**4.*Mt**4.)/128.-

     &  (3803*Mgl**7.*Mst1**6.*Mt**4.)/576.+

     &  (137*Mgl**5.*Mst1**8.*Mt**4.)/48.-

     &  (157*Mgl**3.*Mst1**10.*Mt**4.)/576.+

     &  (97*Mgl*Mst1**12.*Mt**4.)/2304.-

     &  (2981*Mgl**11.*Mt**6.)/576.-

     &  (25*Mgl**15.*Mt**6.)/(72.*Mst1**4.)+

     &  (101*Mgl**13.*Mt**6.)/(48.*Mst1**2.)+

     &  (2033*Mgl**9.*Mst1**2.*Mt**6.)/288.-

     &  (2327*Mgl**7.*Mst1**4.*Mt**6.)/288.-

     &  (295*Mgl**5.*Mst1**6.*Mt**6.)/144.-

     &  (1661*Mgl**3.*Mst1**8.*Mt**6.)/576.+

     &  (395*Mgl*Mst1**10.*Mt**6.)/288.+

     &  (Mgl**9.*Mt**8.)/6.+

     &  (335*Mgl**13.*Mt**8.)/(576.*Mst1**4.)-

     &  (1249*Mgl**11.*Mt**8.)/(576.*Mst1**2.)-

     &  (1967*Mgl**7.*Mst1**2.*Mt**8.)/288.-

     &  (1469*Mgl**5.*Mst1**4.*Mt**8.)/576.+

     &  (959*Mgl**3.*Mst1**6.*Mt**8.)/576.-

     &  (1273*Mgl*Mst1**8.*Mt**8.)/288.+

     &  (2243*Mgl**7.*Mt**10.)/576.-

     &  (197*Mgl**11.*Mt**10.)/(576.*Mst1**4.)+

     &  (49*Mgl**9.*Mt**10.)/(1152.*Mst1**2.)+

     &  (4195*Mgl**5.*Mst1**2.*Mt**10.)/576.+

     &  (293*Mgl**3.*Mst1**4.*Mt**10.)/72.+

     &  (6941*Mgl*Mst1**6.*Mt**10.)/1152.-

     &  (67*Mgl**5.*Mt**12.)/32.-

     &  (457*Mgl**9.*Mt**12.)/(1152.*Mst1**4.)+

     &  (857*Mgl**7.*Mt**12.)/(576.*Mst1**2.)-

     &  (2231*Mgl**3.*Mst1**2.*Mt**12.)/576.-

     &  (4735*Mgl*Mst1**4.*Mt**12.)/1152.+

     &  (29*Mgl**3.*Mt**14.)/64.+

     &  (131*Mgl**7.*Mt**14.)/(144.*Mst1**4.)-

     &  (221*Mgl**5.*Mt**14.)/(288.*Mst1**2.)+

     &  (193*Mgl*Mst1**2.*Mt**14.)/144.-

     &  (35*Mgl*Mt**16.)/144.-

     &  (425*Mgl**5.*Mt**16.)/(576.*Mst1**4.)-

     &  (25*Mgl**3.*Mt**16.)/(192.*Mst1**2.)+

     &  (335*Mgl**3.*Mt**18.)/(1152.*Mst1**4.)+

     &  (289*Mgl*Mt**18.)/(2304.*Mst1**2.)-

     &  (107*Mgl*Mt**20.)/(2304.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((13*Mgl**5.)/144.-(7*Mgl**3.*Mst2**2.)/32.+

     &  (Mgl*Mst2**4.)/96.-(19*Mgl**7.)/(576.*Mt**2.)+

     &  (7*Mgl**5.*Mst2**2.)/(96.*Mt**2.)-

     &  (3*Mgl**3.*Mst2**4.)/(64.*Mt**2.)+

     &  (Mgl*Mst2**6.)/(144.*Mt**2.)-

     &  (83*Mgl**3.*Mt**2.)/144.+

     &  (7*Mgl**7.*Mt**2.)/(288.*Mst2**4.)+

     &  (43*Mgl**5.*Mt**2.)/(576.*Mst2**2.)-

     &  (5*Mgl*Mst2**2.*Mt**2.)/96.-

     &  (173*Mgl*Mt**4.)/576.-

     &  (37*Mgl**5.*Mt**4.)/(576.*Mst2**4.)-

     &  (101*Mgl**3.*Mt**4.)/(192.*Mst2**2.)+

     &  (Mgl**3.*Mt**6.)/(18.*Mst2**4.)+

     &  (31*Mgl*Mt**6.)/(144.*Mst2**2.)-

     &  (Mgl*Mt**8.)/(64.*Mst2**4.))*Xt*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((-7*Mgl**9.)/144.+(29*Mgl**7.*Mst2**2.)/48.-

     &  (223*Mgl**5.*Mst2**4.)/288.+

     &  (5*Mgl**3.*Mst2**6.)/144.+

     &  (53*Mgl*Mst2**8.)/288.+

     &  (7*Mgl**11.)/(384.*Mt**2.)-

     &  (13*Mgl**9.*Mst2**2.)/(144.*Mt**2.)+

     &  (97*Mgl**7.*Mst2**4.)/(576.*Mt**2.)-

     &  (7*Mgl**5.*Mst2**6.)/(48.*Mt**2.)+

     &  (65*Mgl**3.*Mst2**8.)/(1152.*Mt**2.)-

     &  (Mgl*Mst2**10.)/(144.*Mt**2.)+

     &  (263*Mgl**7.*Mt**2.)/576.-

     &  (17*Mgl**11.*Mt**2.)/(576.*Mst2**4.)-

     &  (49*Mgl**9.*Mt**2.)/(384.*Mst2**2.)-

     &  (385*Mgl**5.*Mst2**2.*Mt**2.)/192.+

     &  (173*Mgl**3.*Mst2**4.*Mt**2.)/288.-

     &  (39*Mgl*Mst2**6.*Mt**2.)/128.-

     &  (11*Mgl**5.*Mt**4.)/8.+

     &  (173*Mgl**9.*Mt**4.)/(1152.*Mst2**4.)+

     &  (89*Mgl**7.*Mt**4.)/(64.*Mst2**2.)-

     &  (485*Mgl**3.*Mst2**2.*Mt**4.)/576.+

     &  (943*Mgl*Mst2**4.*Mt**4.)/1152.-

     &  (2035*Mgl**3.*Mt**6.)/1152.-

     &  (47*Mgl**7.*Mt**6.)/(144.*Mst2**4.)-

     &  (715*Mgl**5.*Mt**6.)/(288.*Mst2**2.)-

     &  (205*Mgl*Mst2**2.*Mt**6.)/144.+

     &  (113*Mgl*Mt**8.)/144.+

     &  (215*Mgl**5.*Mt**8.)/(576.*Mst2**4.)+

     &  (763*Mgl**3.*Mt**8.)/(576.*Mst2**2.)-

     &  (127*Mgl**3.*Mt**10.)/(576.*Mst2**4.)-

     &  (121*Mgl*Mt**10.)/(1152.*Mst2**2.)+

     &  (61*Mgl*Mt**12.)/(1152.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((-5*Mgl**13.)/48.-(61*Mgl**11.*Mst2**2.)/288.+

     &  (433*Mgl**9.*Mst2**4.)/288.-

     &  (289*Mgl**7.*Mst2**6.)/144.+

     &  (49*Mgl**5.*Mst2**8.)/72.+

     &  (95*Mgl**3.*Mst2**10.)/288.-

     &  (55*Mgl*Mst2**12.)/288.+Mgl**15./(192.*Mt**2.)-

     &  (5*Mgl**13.*Mst2**2.)/(288.*Mt**2.)+

     &  (Mgl**11.*Mst2**4.)/(64.*Mt**2.)+

     &  (5*Mgl**7.*Mst2**8.)/(576.*Mt**2.)-

     &  (Mgl**5.*Mst2**10.)/(32.*Mt**2.)+

     &  (5*Mgl**3.*Mst2**12.)/(192.*Mt**2.)-

     &  (Mgl*Mst2**14.)/(144.*Mt**2.)+

     &  (47*Mgl**11.*Mt**2.)/96.+

     &  (Mgl**15.*Mt**2.)/(96.*Mst2**4.)+

     &  (47*Mgl**13.*Mt**2.)/(576.*Mst2**2.)+

     &  (523*Mgl**9.*Mst2**2.*Mt**2.)/288.-

     &  (1229*Mgl**7.*Mst2**4.*Mt**2.)/288.+

     &  (317*Mgl**5.*Mst2**6.*Mt**2.)/192.-

     &  (103*Mgl**3.*Mst2**8.*Mt**2.)/288.+

     &  (83*Mgl*Mst2**10.*Mt**2.)/144.+

     &  (11*Mgl**9.*Mt**4.)/576.-

     &  (5*Mgl**13.*Mt**4.)/(64.*Mst2**4.)-

     &  (647*Mgl**11.*Mt**4.)/(576.*Mst2**2.)-

     &  (1559*Mgl**7.*Mst2**2.*Mt**4.)/288.+

     &  (649*Mgl**5.*Mst2**4.*Mt**4.)/576.+

     &  (1309*Mgl**3.*Mst2**6.*Mt**4.)/576.-

     &  (181*Mgl*Mst2**8.*Mt**4.)/192.+

     &  (1631*Mgl**7.*Mt**6.)/576.+

     &  (5*Mgl**11.*Mt**6.)/(16.*Mst2**4.)+

     &  (307*Mgl**9.*Mt**6.)/(96.*Mst2**2.)+

     &  (143*Mgl**5.*Mst2**2.*Mt**6.)/36.-

     &  (295*Mgl**3.*Mst2**4.*Mt**6.)/192.+

     &  (31*Mgl*Mst2**6.*Mt**6.)/18.-

     &  (187*Mgl**5.*Mt**8.)/32.-

     &  (443*Mgl**9.*Mt**8.)/(576.*Mst2**4.)-

     &  (341*Mgl**7.*Mt**8.)/(96.*Mst2**2.)-

     &  (41*Mgl**3.*Mst2**2.*Mt**8.)/12.-

     &  (1157*Mgl*Mst2**4.*Mt**8.)/576.+

     &  (353*Mgl**3.*Mt**10.)/144.+

     &  (331*Mgl**7.*Mt**10.)/(288.*Mst2**4.)+

     &  (931*Mgl**5.*Mt**10.)/(576.*Mst2**2.)+

     &  (37*Mgl*Mst2**2.*Mt**10.)/48.+

     &  (29*Mgl*Mt**12.)/192.-

     &  (193*Mgl**5.*Mt**12.)/(192.*Mst2**4.)-

     &  (139*Mgl**3.*Mt**12.)/(576.*Mst2**2.)+

     &  (17*Mgl**3.*Mt**14.)/(36.*Mst2**4.)+

     &  (Mgl*Mt**14.)/(48.*Mst2**2.)-

     &  (53*Mgl*Mt**16.)/(576.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((13*Mgl**17.)/144.-(49*Mgl**15.*Mst2**2.)/144.+

     &  (83*Mgl**13.*Mst2**4.)/288.+

     &  (65*Mgl**11.*Mst2**6.)/144.-

     &  (95*Mgl**9.*Mst2**8.)/96.+

     &  (77*Mgl**7.*Mst2**10.)/144.+

     &  (11*Mgl**5.*Mst2**12.)/96.-

     &  (29*Mgl**3.*Mst2**14.)/144.+

     &  (5*Mgl*Mst2**16.)/96.-Mgl**19./(768.*Mt**2.)+

     &  (Mgl**17.*Mst2**2.)/(144.*Mt**2.)-

     &  (11*Mgl**15.*Mst2**4.)/(576.*Mt**2.)+

     &  (7*Mgl**13.*Mst2**6.)/(144.*Mt**2.)-

     &  (133*Mgl**11.*Mst2**8.)/(1152.*Mt**2.)+

     &  (7*Mgl**9.*Mst2**10.)/(36.*Mt**2.)-

     &  (119*Mgl**7.*Mst2**12.)/(576.*Mt**2.)+

     &  (19*Mgl**5.*Mst2**14.)/(144.*Mt**2.)-

     &  (107*Mgl**3.*Mst2**16.)/(2304.*Mt**2.)+

     &  (Mgl*Mst2**18.)/(144.*Mt**2.)-

     &  (161*Mgl**15.*Mt**2.)/576.+

     &  (13*Mgl**19.*Mt**2.)/(1152.*Mst2**4.)-

     &  (245*Mgl**17.*Mt**2.)/(2304.*Mst2**2.)+

     &  (19*Mgl**13.*Mst2**2.*Mt**2.)/64.+

     &  (175*Mgl**11.*Mst2**4.*Mt**2.)/72.-

     &  (1729*Mgl**9.*Mst2**6.*Mt**2.)/384.+

     &  (1361*Mgl**7.*Mst2**8.*Mt**2.)/576.-

     &  (25*Mgl**5.*Mst2**10.*Mt**2.)/64.+

     &  (547*Mgl**3.*Mst2**12.*Mt**2.)/1152.-

     &  (685*Mgl*Mst2**14.*Mt**2.)/2304.+

     &  (15*Mgl**13.*Mt**4.)/32.-

     &  (229*Mgl**17.*Mt**4.)/(2304.*Mst2**4.)+

     &  (461*Mgl**15.*Mt**4.)/(576.*Mst2**2.)+

     &  (1489*Mgl**11.*Mst2**2.*Mt**4.)/576.-

     &  (10505*Mgl**9.*Mst2**4.*Mt**4.)/1152.+

     &  (2791*Mgl**7.*Mst2**6.*Mt**4.)/576.+

     &  (211*Mgl**5.*Mst2**8.*Mt**4.)/144.-

     &  (295*Mgl**3.*Mst2**10.*Mt**4.)/192.+

     &  (151*Mgl*Mst2**12.*Mt**4.)/256.-

     &  (3833*Mgl**11.*Mt**6.)/1152.+

     &  (25*Mgl**15.*Mt**6.)/(72.*Mst2**4.)-

     &  (101*Mgl**13.*Mt**6.)/(48.*Mst2**2.)-

     &  (1661*Mgl**9.*Mst2**2.*Mt**6.)/288.+

     &  (3883*Mgl**7.*Mst2**4.*Mt**6.)/576.-

     &  (25*Mgl**5.*Mst2**6.*Mt**6.)/144.+

     &  (5627*Mgl**3.*Mst2**8.*Mt**6.)/1152.-

     &  (269*Mgl*Mst2**10.*Mt**6.)/288.+

     &  (2527*Mgl**9.*Mt**8.)/288.-

     &  (335*Mgl**13.*Mt**8.)/(576.*Mst2**4.)+

     &  (1249*Mgl**11.*Mt**8.)/(576.*Mst2**2.)+

     &  (299*Mgl**7.*Mst2**2.*Mt**8.)/32.+

     &  (135*Mgl**5.*Mst2**4.*Mt**8.)/64.-

     &  (2911*Mgl**3.*Mst2**6.*Mt**8.)/576.+

     &  (461*Mgl*Mst2**8.*Mt**8.)/288.-

     &  (1579*Mgl**7.*Mt**10.)/192.+

     &  (197*Mgl**11.*Mt**10.)/(576.*Mst2**4.)-

     &  (49*Mgl**9.*Mt**10.)/(1152.*Mst2**2.)-

     &  (1339*Mgl**5.*Mst2**2.*Mt**10.)/192.+

     &  (53*Mgl**3.*Mst2**4.*Mt**10.)/144.-

     &  (727*Mgl*Mst2**6.*Mt**10.)/384.+

     &  (637*Mgl**5.*Mt**12.)/288.+

     &  (457*Mgl**9.*Mt**12.)/(1152.*Mst2**4.)-

     &  (857*Mgl**7.*Mt**12.)/(576.*Mst2**2.)+

     &  (605*Mgl**3.*Mst2**2.*Mt**12.)/576.+

     &  (1255*Mgl*Mst2**4.*Mt**12.)/1152.+

     &  (509*Mgl**3.*Mt**14.)/2304.-

     &  (131*Mgl**7.*Mt**14.)/(144.*Mst2**4.)+

     &  (221*Mgl**5.*Mt**14.)/(288.*Mst2**2.)-

     &  (29*Mgl*Mst2**2.*Mt**14.)/144.+

     &  (19*Mgl*Mt**16.)/288.+

     &  (425*Mgl**5.*Mt**16.)/(576.*Mst2**4.)+

     &  (25*Mgl**3.*Mt**16.)/(192.*Mst2**2.)-

     &  (335*Mgl**3.*Mt**18.)/(1152.*Mst2**4.)-

     &  (289*Mgl*Mt**18.)/(2304.*Mst2**2.)+

     &  (107*Mgl*Mt**20.)/(2304.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  (0.11762152777777778+(17*Mgl**2.)/(2304.*Mst1**2.)-

     &  (13*Mst1**2.)/(192.*Mgl**2.)-

     &  (7*Mst1**4.)/(576.*Mgl**4.)-

     &  Mgl**2./(144.*Mt**2.)+

     &  (5*Mst1**2.)/(144.*Mt**2.)+

     &  (11*Mt**2.)/(144.*Mgl**2.)-

     &  (23*Mt**2.)/(2304.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**2.)/(192.*Mgl**4.)-

     &  Mt**4./(64.*Mgl**4.)-

     &  Mt**4./(64.*Mgl**2.*Mst1**2.)+

     &  Mt**6./(576.*Mgl**4.*Mst1**2.))*ln(mu,Mst1)+

     &  ((27*Mgl**4.)/256.-(9*Mgl**6.)/(256.*Mst1**2.)+

     &  (337*Mgl**2.*Mst1**2.)/2304.+(35*Mst1**4.)/768.+

     &  (65*Mst1**6.)/(576.*Mgl**2.)+

     &  Mst1**8./(72.*Mgl**4.)-Mgl**6./(32.*Mt**2.)+

     &  Mgl**8./(96.*Mst1**2.*Mt**2.)-

     &  (5*Mgl**4.*Mst1**2.)/(288.*Mt**2.)+

     &  (25*Mgl**2.*Mst1**4.)/(288.*Mt**2.)-

     &  (7*Mst1**6.)/(144.*Mt**2.)-

     &  (7*Mgl**2.*Mt**2.)/1152.+

     &  (65*Mgl**4.*Mt**2.)/(2304.*Mst1**2.)-

     &  (403*Mst1**2.*Mt**2.)/2304.-

     &  (49*Mst1**4.*Mt**2.)/(192.*Mgl**2.)-

     &  (11*Mst1**6.*Mt**2.)/(192.*Mgl**4.)+

     &  (431*Mt**4.)/2304.+

     &  (5*Mgl**2.*Mt**4.)/(256.*Mst1**2.)+

     &  (3*Mst1**2.*Mt**4.)/(16.*Mgl**2.)+

     &  (13*Mst1**4.*Mt**4.)/(144.*Mgl**4.)-

     &  (35*Mt**6.)/(576.*Mgl**2.)-

     &  (85*Mt**6.)/(2304.*Mst1**2.)-

     &  (19*Mst1**2.*Mt**6.)/(288.*Mgl**4.)+

     &  Mt**8./(48.*Mgl**4.)+

     &  Mt**8./(64.*Mgl**2.*Mst1**2.)-

     &  Mt**10./(576.*Mgl**4.*Mst1**2.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mst1)+

     &  ((-451*Mgl**8.)/2304.+

     &  (115*Mgl**10.)/(2304.*Mst1**2.)+

     &  (11*Mgl**6.*Mst1**2.)/128.+

     &  (65*Mgl**4.*Mst1**4.)/1152.+

     &  (19*Mgl**2.*Mst1**6.)/256.+(37*Mst1**8.)/2304.-

     &  (49*Mst1**10.)/(576.*Mgl**2.)-

     &  Mst1**12./(576.*Mgl**4.)+

     &  (7*Mgl**10.)/(96.*Mt**2.)-

     &  Mgl**12./(96.*Mst1**2.*Mt**2.)-

     &  (2*Mgl**8.*Mst1**2.)/(9.*Mt**2.)+

     &  (53*Mgl**6.*Mst1**4.)/(144.*Mt**2.)-

     &  (11*Mgl**4.*Mst1**6.)/(32.*Mt**2.)+

     &  (49*Mgl**2.*Mst1**8.)/(288.*Mt**2.)-

     &  (5*Mst1**10.)/(144.*Mt**2.)-

     &  (59*Mgl**6.*Mt**2.)/576.-

     &  (173*Mgl**8.*Mt**2.)/(2304.*Mst1**2.)+

     &  (347*Mgl**4.*Mst1**2.*Mt**2.)/1152.-

     &  (67*Mgl**2.*Mst1**4.*Mt**2.)/192.+

     &  (85*Mst1**6.*Mt**2.)/768.+

     &  (31*Mst1**8.*Mt**2.)/(144.*Mgl**2.)+

     &  (Mst1**10.*Mt**2.)/(96.*Mgl**4.)+

     &  (121*Mgl**4.*Mt**4.)/1152.+

     &  (7*Mgl**6.*Mt**4.)/(384.*Mst1**2.)-

     &  (13*Mgl**2.*Mst1**2.*Mt**4.)/128.-

     &  (137*Mst1**4.*Mt**4.)/1152.-

     &  (Mst1**6.*Mt**4.)/(64.*Mgl**2.)-

     &  (5*Mst1**8.*Mt**4.)/(192.*Mgl**4.)+

     &  (155*Mgl**2.*Mt**6.)/576.+

     &  (67*Mgl**4.*Mt**6.)/(1152.*Mst1**2.)+

     &  (49*Mst1**2.*Mt**6.)/1152.-

     &  (7*Mst1**4.*Mt**6.)/(18.*Mgl**2.)+

     &  (5*Mst1**6.*Mt**6.)/(144.*Mgl**4.)-

     &  (11*Mt**8.)/256.-

     &  (145*Mgl**2.*Mt**8.)/(2304.*Mst1**2.)+

     &  (221*Mst1**2.*Mt**8.)/(576.*Mgl**2.)-

     &  (5*Mst1**4.*Mt**8.)/(192.*Mgl**4.)-

     &  (5*Mt**10.)/(48.*Mgl**2.)+

     &  (7*Mt**10.)/(256.*Mst1**2.)+

     &  (Mst1**2.*Mt**10.)/(96.*Mgl**4.)-

     &  Mt**12./(576.*Mgl**4.)-

     &  Mt**12./(192.*Mgl**2.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mst1)+

     &  ((41*Mgl**12.)/2304.-Mgl**14./(768.*Mst1**2.)+

     &  (33*Mgl**10.*Mst1**2.)/256.-

     &  (365*Mgl**8.*Mst1**4.)/768.+

     &  (739*Mgl**6.*Mst1**6.)/2304.+

     &  (787*Mgl**4.*Mst1**8.)/2304.-

     &  (359*Mgl**2.*Mst1**10.)/768.+

     &  (89*Mst1**12.)/768.+

     &  (11*Mst1**14.)/(576.*Mgl**2.)-

     &  Mgl**14./(72.*Mt**2.)+

     &  (13*Mgl**12.*Mst1**2.)/(144.*Mt**2.)-

     &  (Mgl**10.*Mst1**4.)/(4.*Mt**2.)+

     &  (55*Mgl**8.*Mst1**6.)/(144.*Mt**2.)-

     &  (25*Mgl**6.*Mst1**8.)/(72.*Mt**2.)+

     &  (3*Mgl**4.*Mst1**10.)/(16.*Mt**2.)-

     &  (Mgl**2.*Mst1**12.)/(18.*Mt**2.)+

     &  Mst1**14./(144.*Mt**2.)+

     &  (79*Mgl**10.*Mt**2.)/384.+

     &  (19*Mgl**12.*Mt**2.)/(2304.*Mst1**2.)-

     &  (877*Mgl**8.*Mst1**2.*Mt**2.)/768.+

     &  (10*Mgl**6.*Mst1**4.*Mt**2.)/9.-

     &  (35*Mgl**4.*Mst1**6.*Mt**2.)/256.+

     &  (433*Mgl**2.*Mst1**8.*Mt**2.)/1152.-

     &  (283*Mst1**10.*Mt**2.)/768.-

     &  (31*Mst1**12.*Mt**2.)/(576.*Mgl**2.)-

     &  (989*Mgl**8.*Mt**4.)/2304.-

     &  (7*Mgl**10.*Mt**4.)/(256.*Mst1**2.)+

     &  (121*Mgl**6.*Mst1**2.*Mt**4.)/128.-

     &  (913*Mgl**4.*Mst1**4.*Mt**4.)/1152.+

     &  (653*Mgl**2.*Mst1**6.*Mt**4.)/2304.+

     &  (23*Mst1**8.*Mt**4.)/256.-

     &  (5*Mst1**10.*Mt**4.)/(72.*Mgl**2.)-

     &  (Mgl**6.*Mt**6.)/144.+

     &  (115*Mgl**8.*Mt**6.)/(2304.*Mst1**2.)-

     &  (155*Mgl**4.*Mst1**2.*Mt**6.)/1152.+

     &  (95*Mgl**2.*Mst1**4.*Mt**6.)/576.+

     &  (1675*Mst1**6.*Mt**6.)/2304.+

     &  (275*Mst1**8.*Mt**6.)/(576.*Mgl**2.)+

     &  (1279*Mgl**4.*Mt**8.)/2304.-

     &  (85*Mgl**6.*Mt**8.)/(2304.*Mst1**2.)+

     &  (101*Mgl**2.*Mst1**2.*Mt**8.)/2304.-

     &  (677*Mst1**4.*Mt**8.)/768.-

     &  (115*Mst1**6.*Mt**8.)/(144.*Mgl**2.)-

     &  (463*Mgl**2.*Mt**10.)/1152.-

     &  (47*Mgl**4.*Mt**10.)/(2304.*Mst1**2.)+

     &  (653*Mst1**2.*Mt**10.)/2304.+

     &  (359*Mst1**4.*Mt**10.)/(576.*Mgl**2.)+

     &  (149*Mt**12.)/2304.+

     &  (131*Mgl**2.*Mt**12.)/(2304.*Mst1**2.)-

     &  (31*Mst1**2.*Mt**12.)/(144.*Mgl**2.)+

     &  (5*Mt**14.)/(576.*Mgl**2.)-

     &  (29*Mt**14.)/(768.*Mst1**2.)+

     &  (5*Mt**16.)/(576.*Mgl**2.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**3.*ln(mu,Mst1)+

     &  (-Mgl/72.-(11*Mt**2.)/(72.*Mgl**1.)-

     &  (17*Mgl*Mt**2.)/(576.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**2.)/(144.*Mgl**3.)+

     &  Mt**4./(24.*Mgl**3.)+

     &  (5*Mt**4.)/(72.*Mgl**1.*Mst1**2.)-

     &  Mt**6./(144.*Mgl**3.*Mst1**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mst1)+

     &  (Mgl**5./16.-Mgl**7./(24.*Mst1**2.)+

     &  (Mgl**3.*Mst1**2.)/72.-(5*Mgl*Mst1**4.)/144.-

     &  (41*Mgl**3.*Mt**2.)/288.+

     &  (35*Mgl**5.*Mt**2.)/(192.*Mst1**2.)+

     &  (53*Mgl*Mst1**2.*Mt**2.)/576.+

     &  (11*Mst1**4.*Mt**2.)/(48.*Mgl**1.)+

     &  (Mst1**6.*Mt**2.)/(24.*Mgl**3.)-

     &  (127*Mgl*Mt**4.)/288.-

     &  (85*Mgl**3.*Mt**4.)/(288.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**4.)/(16.*Mgl**1.)-

     &  (19*Mst1**4.*Mt**4.)/(144.*Mgl**3.)+

     &  (11*Mt**6.)/(72.*Mgl**1.)+

     &  (125*Mgl*Mt**6.)/(576.*Mst1**2.)+

     &  (7*Mst1**2.*Mt**6.)/(48.*Mgl**3.)-

     &  Mt**8./(16.*Mgl**3.)-

     &  (5*Mt**8.)/(72.*Mgl**1.*Mst1**2.)+

     &  Mt**10./(144.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mst1)+

     &  ((-3*Mgl**9.)/16.+Mgl**11./(24.*Mst1**2.)+

     &  (11*Mgl**7.*Mst1**2.)/24.-

     &  (2*Mgl**5.*Mst1**4.)/3.+(Mgl**3.*Mst1**6.)/2.-

     &  (7*Mgl*Mst1**8.)/48.+(19*Mgl**7.*Mt**2.)/36.-

     &  (139*Mgl**9.*Mt**2.)/(576.*Mst1**2.)+

     &  (19*Mgl**5.*Mst1**2.*Mt**2.)/96.+

     &  (13*Mgl**3.*Mst1**4.*Mt**2.)/72.-

     &  (259*Mgl*Mst1**6.*Mt**2.)/576.-

     &  (5*Mst1**8.*Mt**2.)/(24.*Mgl**1.)-

     &  (Mst1**10.*Mt**2.)/(144.*Mgl**3.)+

     &  (77*Mgl**5.*Mt**4.)/144.+

     &  (13*Mgl**7.*Mt**4.)/(24.*Mst1**2.)-

     &  (163*Mgl**3.*Mst1**2.*Mt**4.)/144.+

     &  (5*Mgl*Mst1**4.*Mt**4.)/24.+

     &  (29*Mst1**6.*Mt**4.)/(144.*Mgl**1.)+

     &  (5*Mst1**8.*Mt**4.)/(144.*Mgl**3.)-

     &  (5*Mgl**3.*Mt**6.)/4.-

     &  (59*Mgl**5.*Mt**6.)/(96.*Mst1**2.)+

     &  (49*Mgl*Mst1**2.*Mt**6.)/96.+

     &  (5*Mst1**4.*Mt**6.)/(8.*Mgl**1.)-

     &  (5*Mst1**6.*Mt**6.)/(72.*Mgl**3.)+

     &  (Mgl*Mt**8.)/144.+

     &  (55*Mgl**3.*Mt**8.)/(144.*Mst1**2.)-

     &  (1.*Mst1**2.*Mt**8.)/Mgl**1.+

     &  (5*Mst1**4.*Mt**8.)/(72.*Mgl**3.)+

     &  (13*Mt**10.)/(36.*Mgl**1.)-

     &  (25*Mgl*Mt**10.)/(192.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**10.)/(144.*Mgl**3.)+

     &  Mt**12./(144.*Mgl**3.)+

     &  Mt**12./(48.*Mgl**1.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mst1)+

     &  (Mgl**13./18.-(11*Mgl**11.*Mst1**2.)/36.+

     &  (25*Mgl**9.*Mst1**4.)/36.-

     &  (5*Mgl**7.*Mst1**6.)/6.+(5*Mgl**5.*Mst1**8.)/9.-

     &  (7*Mgl**3.*Mst1**10.)/36.+(Mgl*Mst1**12.)/36.-

     &  (35*Mgl**11.*Mt**2.)/288.+

     &  (Mgl**13.*Mt**2.)/(192.*Mst1**2.)-

     &  (191*Mgl**9.*Mst1**2.*Mt**2.)/576.+

     &  (7*Mgl**7.*Mst1**4.*Mt**2.)/8.+

     &  (245*Mgl**5.*Mst1**6.*Mt**2.)/576.-

     &  (431*Mgl**3.*Mst1**8.*Mt**2.)/288.+

     &  (109*Mgl*Mst1**10.*Mt**2.)/192.+

     &  (11*Mst1**12.*Mt**2.)/(144.*Mgl**1.)-

     &  (71*Mgl**9.*Mt**4.)/96.-

     &  (11*Mgl**11.*Mt**4.)/(288.*Mst1**2.)+

     &  (599*Mgl**7.*Mst1**2.*Mt**4.)/144.-

     &  (167*Mgl**5.*Mst1**4.*Mt**4.)/144.-

     &  (299*Mgl**3.*Mst1**6.*Mt**4.)/288.-

     &  (301*Mgl*Mst1**8.*Mt**4.)/288.-

     &  (5*Mst1**10.*Mt**4.)/(36.*Mgl**1.)+

     &  (125*Mgl**7.*Mt**6.)/48.+

     &  (85*Mgl**9.*Mt**6.)/(576.*Mst1**2.)-

     &  (1537*Mgl**5.*Mst1**2.*Mt**6.)/288.-

     &  (145*Mgl**3.*Mst1**4.*Mt**6.)/144.-

     &  (635*Mgl*Mst1**6.*Mt**6.)/576.-

     &  (5*Mst1**8.*Mt**6.)/(12.*Mgl**1.)-

     &  (421*Mgl**5.*Mt**8.)/144.-

     &  (25*Mgl**7.*Mt**8.)/(72.*Mst1**2.)+

     &  (425*Mgl**3.*Mst1**2.*Mt**8.)/144.+

     &  (475*Mgl*Mst1**4.*Mt**8.)/144.+

     &  (215*Mst1**6.*Mt**8.)/(144.*Mgl**1.)+

     &  (115*Mgl**3.*Mt**10.)/96.+

     &  (95*Mgl**5.*Mt**10.)/(192.*Mst1**2.)-

     &  (1111*Mgl*Mst1**2.*Mt**10.)/576.-

     &  (245*Mst1**4.*Mt**10.)/(144.*Mgl**1.)-

     &  (Mgl*Mt**12.)/288.-

     &  (119*Mgl**3.*Mt**12.)/(288.*Mst1**2.)+

     &  (19*Mst1**2.*Mt**12.)/(24.*Mgl**1.)-

     &  (5*Mt**14.)/(72.*Mgl**1.)+

     &  (107*Mgl*Mt**14.)/(576.*Mst1**2.)-

     &  (5*Mt**16.)/(144.*Mgl**1.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mst1)+

     &  (-0.033637152777777776+

     &  (19*Mgl**2.)/(4608.*Mst1**2.)+

     &  (19*Mt**2.)/(4608.*Mst1**2.))*ln(mu,Mgl)*ln(mu,Mst1)

     &  +((23*Mgl**4.)/576.-(7*Mgl**6.)/(384.*Mst1**2.)-

     &  (7*Mgl**2.*Mst1**2.)/384.+(11*Mst1**4.)/288.-

     &  (37*Mgl**2.*Mt**2.)/384.-

     &  (49*Mgl**4.*Mt**2.)/(768.*Mst1**2.)+

     &  (337*Mst1**2.*Mt**2.)/2304.-(143*Mt**4.)/576.+

     &  (7*Mgl**2.*Mt**4.)/(384.*Mst1**2.)+

     &  (49*Mt**6.)/(768.*Mst1**2.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mgl)*ln(mu,Mst1)+

     &  ((-151*Mgl**8.)/2304.+

     &  (61*Mgl**10.)/(2304.*Mst1**2.)+

     &  (19*Mgl**6.*Mst1**2.)/288.+

     &  (3*Mgl**4.*Mst1**4.)/16.-

     &  (317*Mgl**2.*Mst1**6.)/2304.-(59*Mst1**8.)/768.-

     &  (91*Mgl**6.*Mt**2.)/1152.-

     &  (5*Mgl**8.*Mt**2.)/(1152.*Mst1**2.)-

     &  (79*Mgl**4.*Mst1**2.*Mt**2.)/576.+

     &  (81*Mgl**2.*Mst1**4.*Mt**2.)/128.-

     &  (73*Mst1**6.*Mt**2.)/384.-

     &  (11*Mgl**4.*Mt**4.)/128.-

     &  (5*Mgl**6.*Mt**4.)/(36.*Mst1**2.)-

     &  (155*Mgl**2.*Mst1**2.*Mt**4.)/384.+

     &  (91*Mst1**4.*Mt**4.)/96.-

     &  (235*Mgl**2.*Mt**6.)/1152.+

     &  (109*Mgl**4.*Mt**6.)/(1152.*Mst1**2.)-

     &  (1277*Mst1**2.*Mt**6.)/1152.+

     &  (1193*Mt**8.)/2304.+

     &  (259*Mgl**2.*Mt**8.)/(2304.*Mst1**2.)-

     &  (13*Mt**10.)/(144.*Mst1**2.))*d123(Mt,Mgl,Mst1)**2.*

     &  ln(mu,Mgl)*ln(mu,Mst1)+

     &  ((3*Mgl**12.)/32.+Mgl**14./(1152.*Mst1**2.)-

     &  (343*Mgl**10.*Mst1**2.)/1152.+

     &  (37*Mgl**8.*Mst1**4.)/288.+

     &  (43*Mgl**6.*Mst1**6.)/128.-

     &  (65*Mgl**4.*Mst1**8.)/288.-

     &  (173*Mgl**2.*Mst1**10.)/1152.+

     &  (11*Mst1**12.)/96.-(245*Mgl**10.*Mt**2.)/1152.+

     &  (95*Mgl**12.*Mt**2.)/(2304.*Mst1**2.)+

     &  (533*Mgl**8.*Mst1**2.*Mt**2.)/2304.-

     &  (13*Mgl**6.*Mst1**4.*Mt**2.)/64.-

     &  (47*Mgl**4.*Mst1**6.*Mt**2.)/2304.+

     &  (101*Mgl**2.*Mst1**8.*Mt**2.)/384.-

     &  (229*Mst1**10.*Mt**2.)/2304.+

     &  (49*Mgl**8.*Mt**4.)/288.-

     &  (43*Mgl**10.*Mt**4.)/(384.*Mst1**2.)-

     &  (403*Mgl**6.*Mst1**2.*Mt**4.)/576.-

     &  (3*Mgl**4.*Mst1**4.*Mt**4.)/16.+

     &  (311*Mgl**2.*Mst1**6.*Mt**4.)/1152.-

     &  (23*Mst1**8.*Mt**4.)/32.-

     &  (59*Mgl**6.*Mt**6.)/576.+

     &  (19*Mgl**8.*Mt**6.)/(2304.*Mst1**2.)+

     &  (19*Mgl**4.*Mst1**2.*Mt**6.)/384.-

     &  (653*Mgl**2.*Mst1**4.*Mt**6.)/576.+

     &  (3739*Mst1**6.*Mt**6.)/2304.+

     &  (23*Mgl**4.*Mt**8.)/48.+

     &  (203*Mgl**6.*Mt**8.)/(1152.*Mst1**2.)+

     &  (419*Mgl**2.*Mst1**2.*Mt**8.)/384.-

     &  (191*Mst1**4.*Mt**8.)/144.-

     &  (317*Mgl**2.*Mt**10.)/1152.-

     &  (73*Mgl**4.*Mt**10.)/(768.*Mst1**2.)+

     &  (395*Mst1**2.*Mt**10.)/768.-(11*Mt**12.)/72.-

     &  (25*Mgl**2.*Mt**12.)/(384.*Mst1**2.)+

     &  (35*Mt**14.)/(768.*Mst1**2.))*d123(Mt,Mgl,Mst1)**3.*

     &  ln(mu,Mgl)*ln(mu,Mst1)+

     &  ((-5*Mgl**16.)/1536.-

     &  (61*Mgl**18.)/(4608.*Mst1**2.)+

     &  (83*Mgl**14.*Mst1**2.)/576.-

     &  (13*Mgl**12.*Mst1**4.)/72.-

     &  (45*Mgl**10.*Mst1**6.)/256.+

     &  (1013*Mgl**8.*Mst1**8.)/2304.-

     &  (5*Mgl**6.*Mst1**10.)/36.-

     &  (41*Mgl**4.*Mst1**12.)/192.+

     &  (847*Mgl**2.*Mst1**14.)/4608.-

     &  (65*Mst1**16.)/1536.+(67*Mgl**14.*Mt**2.)/1152.+

     &  (83*Mgl**16.*Mt**2.)/(1536.*Mst1**2.)-

     &  (433*Mgl**12.*Mst1**2.*Mt**2.)/1152.+

     &  (781*Mgl**10.*Mst1**4.*Mt**2.)/1152.-

     &  (1505*Mgl**8.*Mst1**6.*Mt**2.)/2304.-

     &  (145*Mgl**6.*Mst1**8.*Mt**2.)/384.+

     &  (1355*Mgl**4.*Mst1**10.*Mt**2.)/1152.-

     &  (223*Mgl**2.*Mst1**12.*Mt**2.)/384.+

     &  (97*Mst1**14.*Mt**2.)/4608.-

     &  (49*Mgl**12.*Mt**4.)/384.-

     &  (31*Mgl**14.*Mt**4.)/(576.*Mst1**2.)+

     &  (317*Mgl**10.*Mst1**2.*Mt**4.)/384.-

     &  (139*Mgl**8.*Mst1**4.*Mt**4.)/72.+

     &  (17*Mgl**6.*Mst1**6.*Mt**4.)/72.-

     &  (43*Mgl**4.*Mst1**8.*Mt**4.)/128.+

     &  (269*Mgl**2.*Mst1**10.*Mt**4.)/384.+

     &  (395*Mst1**12.*Mt**4.)/576.-

     &  (403*Mgl**10.*Mt**6.)/1152.-

     &  (11*Mgl**12.*Mt**6.)/(288.*Mst1**2.)-

     &  (203*Mgl**8.*Mst1**2.*Mt**6.)/576.+

     &  (55*Mgl**6.*Mst1**4.*Mt**6.)/64.-

     &  (497*Mgl**4.*Mst1**6.*Mt**6.)/288.-

     &  (211*Mgl**2.*Mst1**8.*Mt**6.)/1152.-

     &  (1273*Mst1**10.*Mt**6.)/576.+

     &  (2099*Mgl**8.*Mt**8.)/2304.+

     &  (131*Mgl**10.*Mt**8.)/(2304.*Mst1**2.)-

     &  (83*Mgl**6.*Mst1**2.*Mt**8.)/288.+

     &  (61*Mgl**4.*Mst1**4.*Mt**8.)/288.-

     &  (2339*Mgl**2.*Mst1**6.*Mt**8.)/2304.+

     &  (6941*Mst1**8.*Mt**8.)/2304.-

     &  (259*Mgl**6.*Mt**10.)/1152.+

     &  (133*Mgl**8.*Mt**10.)/(2304.*Mst1**2.)+

     &  (1667*Mgl**4.*Mst1**2.*Mt**10.)/1152.+

     &  (245*Mgl**2.*Mst1**4.*Mt**10.)/128.-

     &  (4735*Mst1**6.*Mt**10.)/2304.-

     &  (587*Mgl**4.*Mt**12.)/1152.-

     &  (19*Mgl**6.*Mt**12.)/(288.*Mst1**2.)-

     &  (491*Mgl**2.*Mst1**2.*Mt**12.)/384.+

     &  (193*Mst1**4.*Mt**12.)/288.+

     &  (211*Mgl**2.*Mt**14.)/1152.-

     &  (29*Mgl**4.*Mt**14.)/(576.*Mst1**2.)-

     &  (35*Mst1**2.*Mt**14.)/288.+(289*Mt**16.)/4608.+

     &  (39*Mgl**2.*Mt**16.)/(512.*Mst1**2.)-

     &  (107*Mt**18.)/(4608.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**4.*ln(mu,Mgl)*ln(mu,Mst1)-

     &  (19*Mgl*Mt**2.*Xt*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst1))/(1152.*Mst1**2.)+

     &  (-(Mgl**3.*Mt**2.)/32.+

     &  (7*Mgl**5.*Mt**2.)/(96.*Mst1**2.)-

     &  (Mgl*Mst1**2.*Mt**2.)/9.+(41*Mgl*Mt**4.)/64.+

     &  (35*Mgl**3.*Mt**4.)/(192.*Mst1**2.)-

     &  (49*Mgl*Mt**6.)/(192.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst1)+

     &  ((13*Mgl**7.*Mt**2.)/96.-

     &  (61*Mgl**9.*Mt**2.)/(576.*Mst1**2.)+

     &  (11*Mgl**5.*Mst1**2.*Mt**2.)/288.-

     &  (121*Mgl**3.*Mst1**4.*Mt**2.)/288.-

     &  (7*Mgl*Mst1**6.*Mt**2.)/192.+

     &  (37*Mgl**5.*Mt**4.)/192.+

     &  (71*Mgl**7.*Mt**4.)/(576.*Mst1**2.)+

     &  (613*Mgl**3.*Mst1**2.*Mt**4.)/576.-

     &  (443*Mgl*Mst1**4.*Mt**4.)/576.+

     &  (25*Mgl**3.*Mt**6.)/24.+

     &  (83*Mgl**5.*Mt**6.)/(192.*Mst1**2.)+

     &  (1141*Mgl*Mst1**2.*Mt**6.)/576.-

     &  (295*Mgl*Mt**8.)/192.-

     &  (467*Mgl**3.*Mt**8.)/(576.*Mst1**2.)+

     &  (13*Mgl*Mt**10.)/(36.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst1)+

     &  ((-85*Mgl**11.*Mt**2.)/288.-

     &  (Mgl**13.*Mt**2.)/(288.*Mst1**2.)+

     &  (41*Mgl**9.*Mst1**2.*Mt**2.)/48.-

     &  (5*Mgl**7.*Mst1**4.*Mt**2.)/144.-

     &  (277*Mgl**5.*Mst1**6.*Mt**2.)/288.+

     &  (31*Mgl**3.*Mst1**8.*Mt**2.)/288.+

     &  (Mgl*Mst1**10.*Mt**2.)/3.+

     &  (101*Mgl**9.*Mt**4.)/192.-

     &  (31*Mgl**11.*Mt**4.)/(192.*Mst1**2.)-

     &  (265*Mgl**7.*Mst1**2.*Mt**4.)/288.+

     &  (49*Mgl**5.*Mst1**4.*Mt**4.)/96.+

     &  (319*Mgl**3.*Mst1**6.*Mt**4.)/576.-

     &  (37*Mgl*Mst1**8.*Mt**4.)/576.+

     &  (4*Mgl**7.*Mt**6.)/9.+

     &  (39*Mgl**9.*Mt**6.)/(64.*Mst1**2.)+

     &  (887*Mgl**5.*Mst1**2.*Mt**6.)/288.+

     &  (119*Mgl**3.*Mst1**4.*Mt**6.)/72.-

     &  (997*Mgl*Mst1**6.*Mt**6.)/576.-

     &  (185*Mgl**5.*Mt**8.)/96.-

     &  (185*Mgl**7.*Mt**8.)/(288.*Mst1**2.)-

     &  (1019*Mgl**3.*Mst1**2.*Mt**8.)/288.+

     &  (233*Mgl*Mst1**4.*Mt**8.)/96.+

     &  (25*Mgl**3.*Mt**10.)/32.-

     &  (Mgl**5.*Mt**10.)/(16.*Mst1**2.)-

     &  (361*Mgl*Mst1**2.*Mt**10.)/288.+

     &  (271*Mgl*Mt**12.)/576.+

     &  (85*Mgl**3.*Mt**12.)/(192.*Mst1**2.)-

     &  (35*Mgl*Mt**14.)/(192.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst1)+

     &  ((19*Mgl**15.*Mt**2.)/288.+

     &  (61*Mgl**17.*Mt**2.)/(1152.*Mst1**2.)-

     &  (49*Mgl**13.*Mst1**2.*Mt**2.)/96.+

     &  (61*Mgl**11.*Mst1**4.*Mt**2.)/288.+

     &  (527*Mgl**9.*Mst1**6.*Mt**2.)/576.-

     &  (27*Mgl**7.*Mst1**8.*Mt**2.)/32.-

     &  (83*Mgl**5.*Mst1**10.*Mt**2.)/288.+

     &  (163*Mgl**3.*Mst1**12.*Mt**2.)/288.-

     &  (65*Mgl*Mst1**14.*Mt**2.)/384.-

     &  (109*Mgl**13.*Mt**4.)/192.-

     &  (155*Mgl**15.*Mt**4.)/(576.*Mst1**2.)+

     &  (833*Mgl**11.*Mst1**2.*Mt**4.)/576.-

     &  (851*Mgl**9.*Mst1**4.*Mt**4.)/576.+

     &  (127*Mgl**7.*Mst1**6.*Mt**4.)/576.+

     &  (1483*Mgl**5.*Mst1**8.*Mt**4.)/576.-

     &  (1061*Mgl**3.*Mst1**10.*Mt**4.)/576.-

     &  (49*Mgl*Mst1**12.*Mt**4.)/576.+

     &  (25*Mgl**11.*Mt**6.)/16.+

     &  (31*Mgl**13.*Mt**6.)/(64.*Mst1**2.)-

     &  (1835*Mgl**9.*Mst1**2.*Mt**6.)/576.+

     &  (433*Mgl**7.*Mst1**4.*Mt**6.)/72.+

     &  (931*Mgl**5.*Mst1**6.*Mt**6.)/192.+

     &  (521*Mgl**3.*Mst1**8.*Mt**6.)/144.+

     &  (1531*Mgl*Mst1**10.*Mt**6.)/576.-

     &  (95*Mgl**9.*Mt**8.)/192.-

     &  (191*Mgl**11.*Mt**8.)/(576.*Mst1**2.)+

     &  (1181*Mgl**7.*Mst1**2.*Mt**8.)/288.-

     &  (1541*Mgl**5.*Mst1**4.*Mt**8.)/288.-

     &  (211*Mgl**3.*Mst1**6.*Mt**8.)/64.-

     &  (1187*Mgl*Mst1**8.*Mt**8.)/192.-

     &  (877*Mgl**7.*Mt**10.)/288.+

     &  (5*Mgl**9.*Mt**10.)/(48.*Mst1**2.)-

     &  (863*Mgl**5.*Mst1**2.*Mt**10.)/144.-

     &  (143*Mgl**3.*Mst1**4.*Mt**10.)/96.+

     &  (845*Mgl*Mst1**6.*Mt**10.)/144.+

     &  (231*Mgl**5.*Mt**12.)/64.-

     &  (193*Mgl**7.*Mt**12.)/(576.*Mst1**2.)+

     &  (2197*Mgl**3.*Mst1**2.*Mt**12.)/576.-

     &  (1355*Mgl*Mst1**4.*Mt**12.)/576.-

     &  (35*Mgl**3.*Mt**14.)/36.+

     &  (115*Mgl**5.*Mt**14.)/(192.*Mst1**2.)+

     &  (21*Mgl*Mst1**2.*Mt**14.)/64.-

     &  (91*Mgl*Mt**16.)/576.-

     &  (229*Mgl**3.*Mt**16.)/(576.*Mst1**2.)+

     &  (107*Mgl*Mt**18.)/(1152.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst1)+

     &  (-0.004014756944444444-

     &  (19*Mgl**2.)/(9216.*Mst1**2.)-

     &  (19*Mt**2.)/(9216.*Mst1**2.))*ln(mu,Mst1)**2.+

     &  (Mgl**4./288.+(11*Mgl**6.)/(2304.*Mst1**2.)-

     &  (11*Mgl**2.*Mst1**2.)/768.-(17*Mst1**4.)/1152.+

     &  (5*Mgl**2.*Mt**2.)/384.-

     &  (11*Mgl**4.*Mt**2.)/(2304.*Mst1**2.)-

     &  (25*Mst1**2.*Mt**2.)/768.-(19*Mt**4.)/1152.-

     &  (11*Mgl**2.*Mt**4.)/(2304.*Mst1**2.)+

     &  (11*Mt**6.)/(2304.*Mst1**2.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mst1)**2.+

     &  ((35*Mgl**8.)/4608.-(25*Mgl**10.)/(4608.*Mst1**2.)+

     &  (Mgl**6.*Mst1**2.)/72.-

     &  (49*Mgl**4.*Mst1**4.)/576.-

     &  (127*Mgl**2.*Mst1**6.)/4608.+

     &  (445*Mst1**8.)/4608.+(Mgl**6.*Mt**2.)/36.+

     &  (11*Mgl**8.*Mt**2.)/(512.*Mst1**2.)-

     &  (31*Mgl**4.*Mst1**2.*Mt**2.)/384.-

     &  (13*Mgl**2.*Mst1**4.*Mt**2.)/128.+

     &  (101*Mst1**6.*Mt**2.)/4608.+

     &  (35*Mgl**4.*Mt**4.)/2304.-

     &  (49*Mgl**6.*Mt**4.)/(2304.*Mst1**2.)+

     &  (11*Mgl**2.*Mst1**2.*Mt**4.)/192.+

     &  (5*Mst1**4.*Mt**4.)/1152.-

     &  (89*Mgl**2.*Mt**6.)/576.-

     &  (25*Mgl**4.*Mt**6.)/(2304.*Mst1**2.)-

     &  (83*Mst1**2.*Mt**6.)/384.+(479*Mt**8.)/4608.+

     &  (41*Mgl**2.*Mt**8.)/(1536.*Mst1**2.)-

     &  (49*Mt**10.)/(4608.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mst1)**2.+

     &  (-Mgl**12./96.-Mgl**14./(2304.*Mst1**2.)-

     &  (65*Mgl**10.*Mst1**2.)/2304.+

     &  (7*Mgl**8.*Mst1**4.)/32.-

     &  (595*Mgl**6.*Mst1**6.)/2304.-

     &  (13*Mgl**4.*Mst1**8.)/144.+

     &  (661*Mgl**2.*Mst1**10.)/2304.-

     &  (17*Mst1**12.)/144.-(17*Mgl**10.*Mt**2.)/384.-

     &  (5*Mgl**12.*Mt**2.)/(768.*Mst1**2.)+

     &  (809*Mgl**8.*Mst1**2.*Mt**2.)/2304.-

     &  (107*Mgl**6.*Mst1**4.*Mt**2.)/192.+

     &  (947*Mgl**4.*Mst1**6.*Mt**2.)/2304.-

     &  (179*Mgl**2.*Mst1**8.*Mt**2.)/1152.+

     &  (Mst1**10.*Mt**2.)/768.+

     &  (23*Mgl**8.*Mt**4.)/128.+

     &  (79*Mgl**10.*Mt**4.)/(2304.*Mst1**2.)-

     &  (245*Mgl**6.*Mst1**2.*Mt**4.)/1152.+

     &  (131*Mgl**4.*Mst1**4.*Mt**4.)/576.-

     &  (29*Mgl**2.*Mst1**6.*Mt**4.)/2304.+

     &  (487*Mst1**8.*Mt**4.)/1152.-

     &  (67*Mgl**6.*Mt**6.)/576.-

     &  (119*Mgl**8.*Mt**6.)/(2304.*Mst1**2.)+

     &  (25*Mgl**4.*Mst1**2.*Mt**6.)/1152.+

     &  (185*Mgl**2.*Mst1**4.*Mt**6.)/576.-

     &  (19*Mst1**6.*Mt**6.)/2304.-

     &  (115*Mgl**4.*Mt**8.)/576.+

     &  (7*Mgl**6.*Mt**8.)/(768.*Mst1**2.)-

     &  (1637*Mgl**2.*Mst1**2.*Mt**8.)/2304.-

     &  (49*Mst1**4.*Mt**8.)/64.+

     &  (361*Mgl**2.*Mt**10.)/1152.+

     &  (107*Mgl**4.*Mt**10.)/(2304.*Mst1**2.)+

     &  (1333*Mst1**2.*Mt**10.)/2304.-(47*Mt**12.)/384.-

     &  (11*Mgl**2.*Mt**12.)/(256.*Mst1**2.)+

     &  (3*Mt**14.)/(256.*Mst1**2.))*d123(Mt,Mgl,Mst1)**3.*

     &  ln(mu,Mst1)**2.+

     &  ((-65*Mgl**16.)/9216.+

     &  (29*Mgl**18.)/(9216.*Mst1**2.)+

     &  (53*Mgl**14.*Mst1**2.)/1152.-

     &  (2*Mgl**12.*Mst1**4.)/9.+

     &  (1877*Mgl**10.*Mst1**6.)/4608.-

     &  (997*Mgl**8.*Mst1**8.)/4608.-

     &  (35*Mgl**6.*Mst1**10.)/144.+

     &  (467*Mgl**4.*Mst1**12.)/1152.-

     &  (1967*Mgl**2.*Mst1**14.)/9216.+

     &  (371*Mst1**16.)/9216.+(3*Mgl**14.*Mt**2.)/64.-

     &  (19*Mgl**16.*Mt**2.)/(1024.*Mst1**2.)-

     &  (23*Mgl**12.*Mst1**2.*Mt**2.)/96.+

     &  (743*Mgl**10.*Mst1**4.*Mt**2.)/1152.-

     &  (5059*Mgl**8.*Mst1**6.*Mt**2.)/4608.+

     &  (211*Mgl**6.*Mst1**8.*Mt**2.)/144.-

     &  (1301*Mgl**4.*Mst1**10.*Mt**2.)/1152.+

     &  (331*Mgl**2.*Mst1**12.*Mt**2.)/1152.+

     &  (377*Mst1**14.*Mt**2.)/9216.-

     &  (25*Mgl**12.*Mt**4.)/256.+

     &  (89*Mgl**14.*Mt**4.)/(2304.*Mst1**2.)+

     &  (15*Mgl**10.*Mst1**2.*Mt**4.)/128.-

     &  (161*Mgl**8.*Mst1**4.*Mt**4.)/1152.+

     &  (1781*Mgl**6.*Mst1**6.*Mt**4.)/2304.+

     &  (Mgl**4.*Mst1**8.*Mt**4.)/768.-

     &  (19*Mgl**2.*Mst1**10.*Mt**4.)/576.-

     &  (95*Mst1**12.*Mt**4.)/144.+

     &  (7*Mgl**10.*Mt**6.)/72.-

     &  (17*Mgl**12.*Mt**6.)/(768.*Mst1**2.)+

     &  (283*Mgl**8.*Mst1**2.*Mt**6.)/576.-

     &  (79*Mgl**6.*Mst1**4.*Mt**6.)/192.+

     &  (1153*Mgl**4.*Mst1**6.*Mt**6.)/2304.+

     &  (47*Mgl**2.*Mst1**8.*Mt**6.)/576.+

     &  (485*Mst1**10.*Mt**6.)/384.-

     &  (109*Mgl**8.*Mt**8.)/1536.-

     &  (55*Mgl**10.*Mt**8.)/(1536.*Mst1**2.)-

     &  (191*Mgl**6.*Mst1**2.*Mt**8.)/384.+

     &  (85*Mgl**4.*Mst1**4.*Mt**8.)/192.+

     &  (1505*Mgl**2.*Mst1**6.*Mt**8.)/4608.-

     &  (3065*Mst1**8.*Mt**8.)/4608.+

     &  (11*Mgl**6.*Mt**10.)/576.+

     &  (283*Mgl**8.*Mt**10.)/(4608.*Mst1**2.)-

     &  (5*Mgl**4.*Mst1**2.*Mt**10.)/18.-

     &  (1133*Mgl**2.*Mst1**4.*Mt**10.)/1152.-

     &  (2143*Mst1**6.*Mt**10.)/4608.+

     &  (19*Mgl**4.*Mt**12.)/256.-

     &  (17*Mgl**6.*Mt**12.)/(768.*Mst1**2.)+

     &  (235*Mgl**2.*Mst1**2.*Mt**12.)/384.+

     &  (257*Mst1**4.*Mt**12.)/384.-

     &  (3*Mgl**2.*Mt**14.)/32.-

     &  (13*Mgl**4.*Mt**14.)/(768.*Mst1**2.)-

     &  (145*Mst1**2.*Mt**14.)/576.+(295*Mt**16.)/9216.+

     &  (149*Mgl**2.*Mt**16.)/(9216.*Mst1**2.)-

     &  (35*Mt**18.)/(9216.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**4.*ln(mu,Mst1)**2.+

     &  (19*Mgl*Mt**2.*Xt*Den(Mst1,Mst2)*ln(mu,Mst1)**2.)/

     &  (2304.*Mst1**2.)+

     &  ((-23*Mgl**3.*Mt**2.)/576.-

     &  (11*Mgl**5.*Mt**2.)/(576.*Mst1**2.)+

     &  (3*Mgl*Mst1**2.*Mt**2.)/32.+

     &  (23*Mgl*Mt**4.)/576.+

     &  (11*Mgl**3.*Mt**4.)/(288.*Mst1**2.)-

     &  (11*Mgl*Mt**6.)/(576.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mst1)**2.+

     &  ((13*Mgl**7.*Mt**2.)/576.+

     &  (25*Mgl**9.*Mt**2.)/(1152.*Mst1**2.)-

     &  (79*Mgl**5.*Mst1**2.*Mt**2.)/576.+

     &  (13*Mgl**3.*Mst1**4.*Mt**2.)/64.+

     &  (97*Mgl*Mst1**6.*Mt**2.)/1152.-

     &  (211*Mgl**5.*Mt**4.)/576.-

     &  (31*Mgl**7.*Mt**4.)/(288.*Mst1**2.)+

     &  (53*Mgl**3.*Mst1**2.*Mt**4.)/288.+

     &  (47*Mgl*Mst1**4.*Mt**4.)/576.+

     &  (395*Mgl**3.*Mt**6.)/576.+

     &  (37*Mgl**5.*Mt**6.)/(192.*Mst1**2.)+

     &  (233*Mgl*Mst1**2.*Mt**6.)/576.-

     &  (197*Mgl*Mt**8.)/576.-

     &  (43*Mgl**3.*Mt**8.)/(288.*Mst1**2.)+

     &  (49*Mgl*Mt**10.)/(1152.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mst1)**2.

     &  +((25*Mgl**11.*Mt**2.)/576.+

     &  (Mgl**13.*Mt**2.)/(576.*Mst1**2.)+

     &  (7*Mgl**9.*Mst1**2.*Mt**2.)/96.-

     &  (65*Mgl**7.*Mst1**4.*Mt**2.)/96.+

     &  (349*Mgl**5.*Mst1**6.*Mt**2.)/576.+

     &  (173*Mgl**3.*Mst1**8.*Mt**2.)/576.-

     &  (25*Mgl*Mst1**10.*Mt**2.)/72.+

     &  (91*Mgl**9.*Mt**4.)/576.+

     &  (7*Mgl**11.*Mt**4.)/(288.*Mst1**2.)-

     &  (65*Mgl**7.*Mst1**2.*Mt**4.)/72.+

     &  (385*Mgl**5.*Mst1**4.*Mt**4.)/288.-

     &  (191*Mgl**3.*Mst1**6.*Mt**4.)/288.-

     &  (101*Mgl*Mst1**8.*Mt**4.)/576.-

     &  (299*Mgl**7.*Mt**6.)/288.-

     &  (31*Mgl**9.*Mt**6.)/(192.*Mst1**2.)-

     &  (17*Mgl**5.*Mst1**2.*Mt**6.)/144.-

     &  (107*Mgl**3.*Mst1**4.*Mt**6.)/96.+

     &  (67*Mgl*Mst1**6.*Mt**6.)/192.+

     &  (539*Mgl**5.*Mt**8.)/288.+

     &  (53*Mgl**7.*Mt**8.)/(144.*Mst1**2.)+

     &  (197*Mgl**3.*Mst1**2.*Mt**8.)/72.+

     &  (451*Mgl*Mst1**4.*Mt**8.)/288.-

     &  (851*Mgl**3.*Mt**10.)/576.-

     &  (233*Mgl**5.*Mt**10.)/(576.*Mst1**2.)-

     &  (515*Mgl*Mst1**2.*Mt**10.)/288.+

     &  (85*Mgl*Mt**12.)/192.+

     &  (7*Mgl**3.*Mt**12.)/(32.*Mst1**2.)-

     &  (3*Mgl*Mt**14.)/(64.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mst1)**2.

     &  +((Mgl**15.*Mt**2.)/64.-

     &  (29*Mgl**17.*Mt**2.)/(2304.*Mst1**2.)-

     &  (97*Mgl**13.*Mst1**2.*Mt**2.)/576.+

     &  (415*Mgl**11.*Mst1**4.*Mt**2.)/576.-

     &  (349*Mgl**9.*Mst1**6.*Mt**2.)/384.-

     &  (25*Mgl**7.*Mst1**8.*Mt**2.)/576.+

     &  (535*Mgl**5.*Mst1**10.*Mt**2.)/576.-

     &  (133*Mgl**3.*Mst1**12.*Mt**2.)/192.+

     &  (371*Mgl*Mst1**14.*Mt**2.)/2304.-

     &  (67*Mgl**13.*Mt**4.)/576.+

     &  (25*Mgl**15.*Mt**4.)/(288.*Mst1**2.)+

     &  (97*Mgl**11.*Mst1**2.*Mt**4.)/96.-

     &  (1319*Mgl**9.*Mst1**4.*Mt**4.)/576.+

     &  (289*Mgl**7.*Mst1**6.*Mt**4.)/96.-

     &  (539*Mgl**5.*Mst1**8.*Mt**4.)/192.+

     &  (25*Mgl**3.*Mst1**10.*Mt**4.)/32.+

     &  (187*Mgl*Mst1**12.*Mt**4.)/576.+

     &  (17*Mgl**11.*Mt**6.)/64.-

     &  (139*Mgl**13.*Mt**6.)/(576.*Mst1**2.)-

     &  (233*Mgl**9.*Mst1**2.*Mt**6.)/192.+

     &  (157*Mgl**7.*Mst1**4.*Mt**6.)/96.-

     &  (2573*Mgl**5.*Mst1**6.*Mt**6.)/576.-

     &  (959*Mgl**3.*Mst1**8.*Mt**6.)/576.-

     &  (1333*Mgl*Mst1**10.*Mt**6.)/576.-

     &  (187*Mgl**9.*Mt**8.)/576.+

     &  (95*Mgl**11.*Mt**8.)/(288.*Mst1**2.)-

     &  (155*Mgl**7.*Mst1**2.*Mt**8.)/144.-

     &  (307*Mgl**5.*Mst1**4.*Mt**8.)/288.+

     &  (403*Mgl**3.*Mst1**6.*Mt**8.)/288.+

     &  (1577*Mgl*Mst1**8.*Mt**8.)/576.+

     &  (27*Mgl**7.*Mt**10.)/64.-

     &  (215*Mgl**9.*Mt**10.)/(1152.*Mst1**2.)+

     &  (2009*Mgl**5.*Mst1**2.*Mt**10.)/576.+

     &  (1603*Mgl**3.*Mst1**4.*Mt**10.)/576.+

     &  (89*Mgl*Mst1**6.*Mt**10.)/1152.-

     &  (107*Mgl**5.*Mt**12.)/192.-

     &  (17*Mgl**7.*Mt**12.)/(288.*Mst1**2.)-

     &  (845*Mgl**3.*Mst1**2.*Mt**12.)/288.-

     &  (1027*Mgl*Mst1**4.*Mt**12.)/576.+

     &  (235*Mgl**3.*Mt**14.)/576.+

     &  (85*Mgl**5.*Mt**14.)/(576.*Mst1**2.)+

     &  (515*Mgl*Mst1**2.*Mt**14.)/576.-

     &  (65*Mgl*Mt**16.)/576.-

     &  (23*Mgl**3.*Mt**16.)/(288.*Mst1**2.)+

     &  (35*Mgl*Mt**18.)/(2304.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mst1)**2.

     &  +(0.1066623263888889+

     &  (17*Mgl**2.)/(2304.*Mst2**2.)-

     &  (17*Mst2**2.)/(192.*Mgl**2.)-

     &  (7*Mst2**4.)/(576.*Mgl**4.)-

     &  (91*Mgl**4.)/(3072.*Mt**4.)+

     &  (91*Mgl**2.*Mst2**2.)/(1536.*Mt**4.)-

     &  (91*Mst2**4.)/(3072.*Mt**4.)+

     &  (23*Mgl**2.)/(1536.*Mt**2.)+

     &  (19*Mst2**2.)/(512.*Mt**2.)+

     &  Mst2**4./(96.*Mgl**2.*Mt**2.)+

     &  (25*Mt**2.)/(288.*Mgl**2.)-

     &  (23*Mt**2.)/(2304.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**2.)/(192.*Mgl**4.)-

     &  Mt**4./(64.*Mgl**4.)-

     &  Mt**4./(64.*Mgl**2.*Mst2**2.)+

     &  Mt**6./(576.*Mgl**4.*Mst2**2.))*ln(mu,Mst2)+

     &  ((229*Mgl**4.)/2304.-(5*Mgl**6.)/(256.*Mst2**2.)+

     &  (499*Mgl**2.*Mst2**2.)/6912.+

     &  (1685*Mst2**4.)/6912.+

     &  (13*Mst2**6.)/(192.*Mgl**2.)+

     &  Mst2**8./(72.*Mgl**4.)+

     &  (13*Mgl**8.)/(192.*Mt**4.)-

     &  (299*Mgl**6.*Mst2**2.)/(1152.*Mt**4.)+

     &  (143*Mgl**4.*Mst2**4.)/(384.*Mt**4.)-

     &  (91*Mgl**2.*Mst2**6.)/(384.*Mt**4.)+

     &  (65*Mst2**8.)/(1152.*Mt**4.)-

     &  (601*Mgl**6.)/(3456.*Mt**2.)+

     &  Mgl**8./(288.*Mst2**2.*Mt**2.)-

     &  (59*Mgl**4.*Mst2**2.)/(1152.*Mt**2.)+

     &  (427*Mgl**2.*Mst2**4.)/(1152.*Mt**2.)-

     &  (581*Mst2**6.)/(3456.*Mt**2.)+

     &  (11*Mst2**8.)/(576.*Mgl**2.*Mt**2.)+

     &  (863*Mgl**2.*Mt**2.)/3456.+

     &  (61*Mgl**4.*Mt**2.)/(2304.*Mst2**2.)-

     &  (1243*Mst2**2.*Mt**2.)/6912.-

     &  (15*Mst2**4.*Mt**2.)/(64.*Mgl**2.)-

     &  (11*Mst2**6.*Mt**2.)/(192.*Mgl**4.)+

     &  (37*Mt**4.)/768.+

     &  (Mgl**2.*Mt**4.)/(256.*Mst2**2.)+

     &  (59*Mst2**2.*Mt**4.)/(288.*Mgl**2.)+

     &  (13*Mst2**4.*Mt**4.)/(144.*Mgl**4.)-

     &  (7*Mt**6.)/(96.*Mgl**2.)-

     &  (65*Mt**6.)/(2304.*Mst2**2.)-

     &  (19*Mst2**2.*Mt**6.)/(288.*Mgl**4.)+

     &  Mt**8./(48.*Mgl**4.)+

     &  Mt**8./(64.*Mgl**2.*Mst2**2.)-

     &  Mt**10./(576.*Mgl**4.*Mst2**2.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mst2)+

     &  ((-3445*Mgl**8.)/4608.-

     &  (7*Mgl**10.)/(768.*Mst2**2.)-

     &  (1073*Mgl**6.*Mst2**2.)/3456.+

     &  (2221*Mgl**4.*Mst2**4.)/6912.+

     &  (3553*Mgl**2.*Mst2**6.)/6912.+

     &  (1909*Mst2**8.)/13824.+

     &  (55*Mst2**10.)/(576.*Mgl**2.)-

     &  Mst2**12./(576.*Mgl**4.)-

     &  (331*Mgl**12.)/(4608.*Mt**4.)+

     &  (287*Mgl**10.*Mst2**2.)/(768.*Mt**4.)-

     &  (3797*Mgl**8.*Mst2**4.)/(4608.*Mt**4.)+

     &  (1147*Mgl**6.*Mst2**6.)/(1152.*Mt**4.)-

     &  (1079*Mgl**4.*Mst2**8.)/(1536.*Mt**4.)+

     &  (637*Mgl**2.*Mst2**10.)/(2304.*Mt**4.)-

     &  (73*Mst2**12.)/(1536.*Mt**4.)+

     &  (3287*Mgl**10.)/(6912.*Mt**2.)+

     &  Mgl**12./(288.*Mst2**2.*Mt**2.)-

     &  (4711*Mgl**8.*Mst2**2.)/(6912.*Mt**2.)-

     &  (1759*Mgl**6.*Mst2**4.)/(3456.*Mt**2.)+

     &  (3917*Mgl**4.*Mst2**6.)/(3456.*Mt**2.)-

     &  (3101*Mgl**2.*Mst2**8.)/(6912.*Mt**2.)+

     &  (437*Mst2**10.)/(6912.*Mt**2.)-

     &  (7*Mst2**12.)/(192.*Mgl**2.*Mt**2.)-

     &  (581*Mgl**6.*Mt**2.)/864.+

     &  (11*Mgl**8.*Mt**2.)/(2304.*Mst2**2.)-

     &  (37*Mgl**4.*Mst2**2.*Mt**2.)/432.-

     &  (343*Mgl**2.*Mst2**4.*Mt**2.)/432.-

     &  (671*Mst2**6.*Mt**2.)/2304.-

     &  (9*Mst2**8.*Mt**2.)/(64.*Mgl**2.)+

     &  (Mst2**10.*Mt**2.)/(96.*Mgl**4.)+

     &  (9935*Mgl**4.*Mt**4.)/4608.+

     &  (13*Mgl**6.*Mt**4.)/(1152.*Mst2**2.)+

     &  (441*Mgl**2.*Mst2**2.*Mt**4.)/256.+

     &  (8753*Mst2**4.*Mt**4.)/13824.+

     &  (191*Mst2**6.*Mt**4.)/(576.*Mgl**2.)-

     &  (5*Mst2**8.*Mt**4.)/(192.*Mgl**4.)-

     &  (10339*Mgl**2.*Mt**6.)/6912.-

     &  (7*Mgl**4.*Mt**6.)/(384.*Mst2**2.)-

     &  (6677*Mst2**2.*Mt**6.)/6912.-

     &  (319*Mst2**4.*Mt**6.)/(576.*Mgl**2.)+

     &  (5*Mst2**6.*Mt**6.)/(144.*Mgl**4.)+

     &  (707*Mt**8.)/1536.+

     &  (7*Mgl**2.*Mt**8.)/(2304.*Mst2**2.)+

     &  (79*Mst2**2.*Mt**8.)/(192.*Mgl**2.)-

     &  (5*Mst2**4.*Mt**8.)/(192.*Mgl**4.)-

     &  (59*Mt**10.)/(576.*Mgl**2.)+

     &  (23*Mt**10.)/(2304.*Mst2**2.)+

     &  (Mst2**2.*Mt**10.)/(96.*Mgl**4.)-

     &  Mt**12./(576.*Mgl**4.)-

     &  Mt**12./(192.*Mgl**2.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mst2)+

     &  ((13859*Mgl**12.)/6912.+

     &  (97*Mgl**14.)/(2304.*Mst2**2.)-

     &  (16709*Mgl**10.*Mst2**2.)/6912.-

     &  (16277*Mgl**8.*Mst2**4.)/6912.+

     &  (2717*Mgl**6.*Mst2**6.)/768.-

     &  (14431*Mgl**4.*Mst2**8.)/6912.+

     &  (18761*Mgl**2.*Mst2**10.)/6912.-

     &  (9743*Mst2**12.)/6912.-

     &  (17*Mst2**14.)/(576.*Mgl**2.)+

     &  (25*Mgl**16.)/(576.*Mt**4.)-

     &  (97*Mgl**14.*Mst2**2.)/(384.*Mt**4.)+

     &  (81*Mgl**12.*Mst2**4.)/(128.*Mt**4.)-

     &  (1063*Mgl**10.*Mst2**6.)/(1152.*Mt**4.)+

     &  (355*Mgl**8.*Mst2**8.)/(384.*Mt**4.)-

     &  (275*Mgl**6.*Mst2**10.)/(384.*Mt**4.)+

     &  (491*Mgl**4.*Mst2**12.)/(1152.*Mt**4.)-

     &  (21*Mgl**2.*Mst2**14.)/(128.*Mt**4.)+

     &  (11*Mst2**16.)/(384.*Mt**4.)-

     &  (677*Mgl**14.)/(1152.*Mt**2.)-

     &  Mgl**16./(144.*Mst2**2.*Mt**2.)+

     &  (6173*Mgl**12.*Mst2**2.)/(3456.*Mt**2.)-

     &  (115*Mgl**10.*Mst2**4.)/(128.*Mt**2.)-

     &  (6905*Mgl**8.*Mst2**6.)/(3456.*Mt**2.)+

     &  (7663*Mgl**6.*Mst2**8.)/(3456.*Mt**2.)+

     &  (65*Mgl**4.*Mst2**10.)/(1152.*Mt**2.)-

     &  (2839*Mgl**2.*Mst2**12.)/(3456.*Mt**2.)+

     &  (283*Mst2**14.)/(1152.*Mt**2.)+

     &  Mst2**16./(144.*Mgl**2.*Mt**2.)-

     &  (7867*Mgl**10.*Mt**2.)/3456.-

     &  (25*Mgl**12.*Mt**2.)/(256.*Mst2**2.)+

     &  (1219*Mgl**8.*Mst2**2.*Mt**2.)/2304.+

     &  (199*Mgl**6.*Mst2**4.*Mt**2.)/144.+

     &  (925*Mgl**4.*Mst2**6.*Mt**2.)/2304.-

     &  (8563*Mgl**2.*Mst2**8.*Mt**2.)/3456.+

     &  (16915*Mst2**10.*Mt**2.)/6912.+

     &  (53*Mst2**12.*Mt**2.)/(576.*Mgl**2.)-

     &  (2039*Mgl**8.*Mt**4.)/2304.+

     &  (197*Mgl**10.*Mt**4.)/(2304.*Mst2**2.)-

     &  (4363*Mgl**6.*Mst2**2.*Mt**4.)/1728.-

     &  (2975*Mgl**4.*Mst2**4.*Mt**4.)/1728.-

     &  (187*Mgl**2.*Mst2**6.*Mt**4.)/6912.-

     &  (14711*Mst2**8.*Mt**4.)/6912.-

     &  (5*Mst2**10.*Mt**4.)/(16.*Mgl**2.)+

     &  (15701*Mgl**6.*Mt**6.)/3456.+

     &  (95*Mgl**8.*Mt**6.)/(2304.*Mst2**2.)+

     &  (11161*Mgl**4.*Mst2**2.*Mt**6.)/1728.+

     &  (13139*Mgl**2.*Mst2**4.*Mt**6.)/3456.+

     &  (13835*Mst2**6.*Mt**6.)/6912.+

     &  (415*Mst2**8.*Mt**6.)/(576.*Mgl**2.)-

     &  (31207*Mgl**4.*Mt**8.)/6912.-

     &  (329*Mgl**6.*Mt**8.)/(2304.*Mst2**2.)-

     &  (35245*Mgl**2.*Mst2**2.*Mt**8.)/6912.-

     &  (17245*Mst2**4.*Mt**8.)/6912.-

     &  (17*Mst2**6.*Mt**8.)/(18.*Mgl**2.)+

     &  (2381*Mgl**2.*Mt**10.)/1152.+

     &  (71*Mgl**4.*Mt**10.)/(768.*Mst2**2.)+

     &  (12041*Mst2**2.*Mt**10.)/6912.+

     &  (43*Mst2**4.*Mt**10.)/(64.*Mgl**2.)-

     &  (929*Mt**12.)/2304.+

     &  (5*Mgl**2.*Mt**12.)/(768.*Mst2**2.)-

     &  (2*Mst2**2.*Mt**12.)/(9.*Mgl**2.)+

     &  (5*Mt**14.)/(576.*Mgl**2.)-

     &  (67*Mt**14.)/(2304.*Mst2**2.)+

     &  (5*Mt**16.)/(576.*Mgl**2.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**3.*ln(mu,Mst2)+

     &  ((-1469*Mgl**16.)/1024.+

     &  (3571*Mgl**14.*Mst2**2.)/864.-

     &  (4625*Mgl**12.*Mst2**4.)/2304.-

     &  (7369*Mgl**10.*Mst2**6.)/1728.+

     &  (27157*Mgl**8.*Mst2**8.)/4608.-

     &  (245*Mgl**6.*Mst2**10.)/48.+

     &  (42025*Mgl**4.*Mst2**12.)/6912.-

     &  (7793*Mgl**2.*Mst2**14.)/1728.+

     &  (1243*Mst2**16.)/1024.-

     &  (89*Mgl**20.)/(9216.*Mt**4.)+

     &  (221*Mgl**18.*Mst2**2.)/(4608.*Mt**4.)-

     &  (45*Mgl**16.*Mst2**4.)/(1024.*Mt**4.)-

     &  (83*Mgl**14.*Mst2**6.)/(384.*Mt**4.)+

     &  (1141*Mgl**12.*Mst2**8.)/(1536.*Mt**4.)-

     &  (273*Mgl**10.*Mst2**10.)/(256.*Mt**4.)+

     &  (1253*Mgl**8.*Mst2**12.)/(1536.*Mt**4.)-

     &  (115*Mgl**6.*Mst2**14.)/(384.*Mt**4.)+

     &  (3*Mgl**4.*Mst2**16.)/(1024.*Mt**4.)+

     &  (157*Mgl**2.*Mst2**18.)/(4608.*Mt**4.)-

     &  (73*Mst2**20.)/(9216.*Mt**4.)+

     &  (1201*Mgl**18.)/(4608.*Mt**2.)-

     &  (15875*Mgl**16.*Mst2**2.)/(13824.*Mt**2.)+

     &  (1657*Mgl**14.*Mst2**4.)/(1152.*Mt**2.)+

     &  (2437*Mgl**12.*Mst2**6.)/(3456.*Mt**2.)-

     &  (20515*Mgl**10.*Mst2**8.)/(6912.*Mt**2.)+

     &  (3377*Mgl**8.*Mst2**10.)/(2304.*Mt**2.)+

     &  (6175*Mgl**6.*Mst2**12.)/(3456.*Mt**2.)-

     &  (8591*Mgl**4.*Mst2**14.)/(3456.*Mt**2.)+

     &  (5209*Mgl**2.*Mst2**16.)/(4608.*Mt**2.)-

     &  (2555*Mst2**18.)/(13824.*Mt**2.)+

     &  (169*Mgl**14.*Mt**2.)/48.-

     &  (22205*Mgl**12.*Mst2**2.*Mt**2.)/3456.+

     &  (595*Mgl**10.*Mst2**4.*Mt**2.)/576.+

     &  (2647*Mgl**8.*Mst2**6.*Mt**2.)/1152.+

     &  (97*Mgl**6.*Mst2**8.*Mt**2.)/96.-

     &  (5425*Mgl**4.*Mst2**10.*Mt**2.)/1152.+

     &  (3419*Mgl**2.*Mst2**12.*Mt**2.)/576.-

     &  (9205*Mst2**14.*Mt**2.)/3456.-

     &  (19565*Mgl**12.*Mt**4.)/4608.+

     &  (4823*Mgl**10.*Mst2**2.*Mt**4.)/768.-

     &  (4423*Mgl**8.*Mst2**4.*Mt**4.)/4608.+

     &  (1325*Mgl**6.*Mst2**6.*Mt**4.)/3456.+

     &  (295*Mgl**4.*Mst2**8.*Mt**4.)/1536.-

     &  (8339*Mgl**2.*Mst2**10.*Mt**4.)/2304.+

     &  (27229*Mst2**12.*Mt**4.)/13824.+

     &  (1127*Mgl**10.*Mt**6.)/768.-

     &  (15023*Mgl**8.*Mst2**2.*Mt**6.)/2304.-

     &  (337*Mgl**6.*Mst2**4.*Mt**6.)/384.+

     &  (5563*Mgl**4.*Mst2**6.*Mt**6.)/3456.+

     &  (20035*Mgl**2.*Mst2**8.*Mt**6.)/6912.+

     &  (3277*Mst2**10.*Mt**6.)/2304.+

     &  (4193*Mgl**8.*Mt**8.)/1536.+

     &  (4265*Mgl**6.*Mst2**2.*Mt**8.)/576.+

     &  (5447*Mgl**4.*Mst2**4.*Mt**8.)/2304.-

     &  (39*Mgl**2.*Mst2**6.*Mt**8.)/16.-

     &  (47755*Mst2**8.*Mt**8.)/13824.-

     &  (2479*Mgl**6.*Mt**10.)/576.-

     &  (20329*Mgl**4.*Mst2**2.*Mt**10.)/3456.-

     &  (35*Mgl**2.*Mst2**4.*Mt**10.)/32.+

     &  (6643*Mst2**6.*Mt**10.)/3456.+

     &  (8689*Mgl**4.*Mt**12.)/3072.+

     &  (36035*Mgl**2.*Mst2**2.*Mt**12.)/13824.+

     &  (1355*Mst2**4.*Mt**12.)/9216.-

     &  (4355*Mgl**2.*Mt**14.)/4608.-

     &  (6859*Mst2**2.*Mt**14.)/13824.+(135*Mt**16.)/1024.

     &  )*d123(Mt,Mgl,Mst2)**4.*ln(mu,Mst2)+

     &  ((31*Mgl)/2304.-Mst2**2./(36.*Mgl**1.)-

     &  (101*Mgl**3.)/(2304.*Mt**2.)+

     &  (101*Mgl*Mst2**2.)/(2304.*Mt**2.)+

     &  (13*Mt**2.)/(72.*Mgl**1.)+

     &  (17*Mgl*Mt**2.)/(576.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**2.)/(144.*Mgl**3.)-

     &  Mt**4./(24.*Mgl**3.)-

     &  (5*Mt**4.)/(72.*Mgl**1.*Mst2**2.)+

     &  Mt**6./(144.*Mgl**3.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mst2)+

     &  ((-1223*Mgl**5.)/1728.+Mgl**7./(72.*Mst2**2.)-

     &  (37*Mgl**3.*Mst2**2.)/216.+

     &  (487*Mgl*Mst2**4.)/1728.-

     &  (7*Mst2**6.)/(144.*Mgl**1.)+

     &  (263*Mgl**7.)/(1728.*Mt**2.)-

     &  (79*Mgl**5.*Mst2**2.)/(192.*Mt**2.)+

     &  (211*Mgl**3.*Mst2**4.)/(576.*Mt**2.)-

     &  (185*Mgl*Mst2**6.)/(1728.*Mt**2.)+

     &  (1927*Mgl**3.*Mt**2.)/1728.-

     &  (53*Mgl**5.*Mt**2.)/(576.*Mst2**2.)-

     &  (7*Mgl*Mst2**2.*Mt**2.)/864.-

     &  (Mst2**4.*Mt**2.)/(6.*Mgl**1.)-

     &  (Mst2**6.*Mt**2.)/(24.*Mgl**3.)+

     &  (25*Mgl*Mt**4.)/576.+

     &  (19*Mgl**3.*Mt**4.)/(96.*Mst2**2.)+

     &  (Mst2**2.*Mt**4.)/(3.*Mgl**1.)+

     &  (19*Mst2**4.*Mt**4.)/(144.*Mgl**3.)-

     &  (3*Mt**6.)/(16.*Mgl**1.)-

     &  (35*Mgl*Mt**6.)/(192.*Mst2**2.)-

     &  (7*Mst2**2.*Mt**6.)/(48.*Mgl**3.)+

     &  Mt**8./(16.*Mgl**3.)+

     &  (5*Mt**8.)/(72.*Mgl**1.*Mst2**2.)-

     &  Mt**10./(144.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mst2)+

     &  ((8281*Mgl**9.)/3456.+Mgl**11./(72.*Mst2**2.)-

     &  (1721*Mgl**7.*Mst2**2.)/864.-

     &  (3277*Mgl**5.*Mst2**4.)/1728.+

     &  (395*Mgl**3.*Mst2**6.)/288.+(Mgl*Mst2**8.)/384.+

     &  (5*Mst2**10.)/(48.*Mgl**1.)-

     &  (257*Mgl**11.)/(1152.*Mt**2.)+

     &  (1021*Mgl**9.*Mst2**2.)/(1152.*Mt**2.)-

     &  (833*Mgl**7.*Mst2**4.)/(576.*Mt**2.)+

     &  (721*Mgl**5.*Mst2**6.)/(576.*Mt**2.)-

     &  (685*Mgl**3.*Mst2**8.)/(1152.*Mt**2.)+

     &  (145*Mgl*Mst2**10.)/(1152.*Mt**2.)-

     &  (3233*Mgl**7.*Mt**2.)/432.-

     &  (29*Mgl**9.*Mt**2.)/(576.*Mst2**2.)-

     &  (515*Mgl**5.*Mst2**2.*Mt**2.)/216.+

     &  (37*Mgl**3.*Mst2**4.*Mt**2.)/144.-

     &  (427*Mgl*Mst2**6.*Mt**2.)/576.-

     &  (29*Mst2**8.*Mt**2.)/(144.*Mgl**1.)+

     &  (Mst2**10.*Mt**2.)/(144.*Mgl**3.)+

     &  (4003*Mgl**5.*Mt**4.)/432.+

     &  (5*Mgl**7.*Mt**4.)/(72.*Mst2**2.)+

     &  (2761*Mgl**3.*Mst2**2.*Mt**4.)/432.+

     &  (145*Mgl*Mst2**4.*Mt**4.)/72.+

     &  (19*Mst2**6.*Mt**4.)/(48.*Mgl**1.)-

     &  (5*Mst2**8.*Mt**4.)/(144.*Mgl**3.)-

     &  (17957*Mgl**3.*Mt**6.)/3456.-

     &  (7*Mgl**5.*Mt**6.)/(288.*Mst2**2.)-

     &  (3529*Mgl*Mst2**2.*Mt**6.)/1152.-

     &  (1.*Mst2**4.*Mt**6.)/Mgl**1.+

     &  (5*Mst2**6.*Mt**6.)/(72.*Mgl**3.)+

     &  (205*Mgl*Mt**8.)/128.-

     &  (7*Mgl**3.*Mt**8.)/(144.*Mst2**2.)+

     &  (155*Mst2**2.*Mt**8.)/(144.*Mgl**1.)-

     &  (5*Mst2**4.*Mt**8.)/(72.*Mgl**3.)-

     &  (17*Mt**10.)/(48.*Mgl**1.)+

     &  (35*Mgl*Mt**10.)/(576.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**10.)/(144.*Mgl**3.)-

     &  Mt**12./(144.*Mgl**3.)-

     &  Mt**12./(48.*Mgl**1.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mst2)+

     &  ((-4705*Mgl**13.)/1728.-Mgl**15./(36.*Mst2**2.)+

     &  (613*Mgl**11.*Mst2**2.)/108.+

     &  (1651*Mgl**9.*Mst2**4.)/1728.-

     &  (1763*Mgl**7.*Mst2**6.)/216.+

     &  (5957*Mgl**5.*Mst2**8.)/1728.+

     &  (409*Mgl**3.*Mst2**10.)/216.-

     &  (1783*Mgl*Mst2**12.)/1728.-

     &  Mst2**14./(36.*Mgl**1.)+

     &  (265*Mgl**15.)/(1728.*Mt**2.)-

     &  (1201*Mgl**13.*Mst2**2.)/(1728.*Mt**2.)+

     &  (731*Mgl**11.*Mst2**4.)/(576.*Mt**2.)-

     &  (2225*Mgl**9.*Mst2**6.)/(1728.*Mt**2.)+

     &  (1715*Mgl**7.*Mst2**8.)/(1728.*Mt**2.)-

     &  (425*Mgl**5.*Mst2**10.)/(576.*Mt**2.)+

     &  (691*Mgl**3.*Mst2**12.)/(1728.*Mt**2.)-

     &  (163*Mgl*Mst2**14.)/(1728.*Mt**2.)+

     &  (2429*Mgl**11.*Mt**2.)/192.+

     &  (113*Mgl**13.*Mt**2.)/(576.*Mst2**2.)-

     &  (3121*Mgl**9.*Mst2**2.*Mt**2.)/432.-

     &  (12481*Mgl**7.*Mst2**4.*Mt**2.)/864.+

     &  (13507*Mgl**5.*Mst2**6.*Mt**2.)/1728.-

     &  (5407*Mgl**3.*Mst2**8.*Mt**2.)/1728.+

     &  (1165*Mgl*Mst2**10.*Mt**2.)/288.+

     &  (13*Mst2**12.*Mt**2.)/(144.*Mgl**1.)-

     &  (47467*Mgl**9.*Mt**4.)/1728.-

     &  (169*Mgl**11.*Mt**4.)/(288.*Mst2**2.)-

     &  (3875*Mgl**7.*Mst2**2.*Mt**4.)/432.+

     &  (2275*Mgl**5.*Mst2**4.*Mt**4.)/288.+

     &  (607*Mgl**3.*Mst2**6.*Mt**4.)/288.-

     &  (2869*Mgl*Mst2**8.*Mt**4.)/576.-

     &  (5*Mst2**10.*Mt**4.)/(18.*Mgl**1.)+

     &  (56875*Mgl**7.*Mt**6.)/1728.+

     &  (535*Mgl**9.*Mt**6.)/(576.*Mst2**2.)+

     &  (4531*Mgl**5.*Mst2**2.*Mt**6.)/192.+

     &  (12269*Mgl**3.*Mst2**4.*Mt**6.)/1728.+

     &  (983*Mgl*Mst2**6.*Mt**6.)/216.+

     &  (35*Mst2**8.*Mt**6.)/(36.*Mgl**1.)-

     &  (13181*Mgl**5.*Mt**8.)/576.-

     &  (55*Mgl**7.*Mt**8.)/(72.*Mst2**2.)-

     &  (7573*Mgl**3.*Mst2**2.*Mt**8.)/432.-

     &  (423*Mgl*Mst2**4.*Mt**8.)/64.-

     &  (275*Mst2**6.*Mt**8.)/(144.*Mgl**1.)+

     &  (5173*Mgl**3.*Mt**10.)/576.+

     &  (37*Mgl**5.*Mt**10.)/(192.*Mst2**2.)+

     &  (5153*Mgl*Mst2**2.*Mt**10.)/864.+

     &  (269*Mst2**4.*Mt**10.)/(144.*Mgl**1.)-

     &  (325*Mgl*Mt**12.)/192.+

     &  (17*Mgl**3.*Mt**12.)/(96.*Mst2**2.)-

     &  (59*Mst2**2.*Mt**12.)/(72.*Mgl**1.)+

     &  (5*Mt**14.)/(72.*Mgl**1.)-

     &  (29*Mgl*Mt**14.)/(192.*Mst2**2.)+

     &  (5*Mt**16.)/(144.*Mgl**1.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mst2)+

     &  ((2491*Mgl**17.)/2304.-

     &  (3167*Mgl**15.*Mst2**2.)/864.+

     &  (3647*Mgl**13.*Mst2**4.)/1728.+

     &  (5027*Mgl**11.*Mst2**6.)/864.-

     &  (3125*Mgl**9.*Mst2**8.)/384.-

     &  (3*Mgl**7.*Mst2**10.)/32.+

     &  (10319*Mgl**5.*Mst2**12.)/1728.-

     &  (3331*Mgl**3.*Mst2**14.)/864.+

     &  (5329*Mgl*Mst2**16.)/6912.-

     &  (89*Mgl**19.)/(2304.*Mt**2.)+

     &  (353*Mgl**17.*Mst2**2.)/(2304.*Mt**2.)-

     &  (13*Mgl**15.*Mst2**4.)/(576.*Mt**2.)-

     &  (511*Mgl**13.*Mst2**6.)/(576.*Mt**2.)+

     &  (2401*Mgl**11.*Mst2**8.)/(1152.*Mt**2.)-

     &  (2513*Mgl**9.*Mst2**10.)/(1152.*Mt**2.)+

     &  (623*Mgl**7.*Mst2**12.)/(576.*Mt**2.)-

     &  (67*Mgl**5.*Mst2**14.)/(576.*Mt**2.)-

     &  (241*Mgl**3.*Mst2**16.)/(2304.*Mt**2.)+

     &  (73*Mgl*Mst2**18.)/(2304.*Mt**2.)-

     &  (491*Mgl**15.*Mt**2.)/72.+

     &  (3853*Mgl**13.*Mst2**2.*Mt**2.)/288.+

     &  (1399*Mgl**11.*Mst2**4.*Mt**2.)/432.-

     &  (16967*Mgl**9.*Mst2**6.*Mt**2.)/864.+

     &  (326*Mgl**7.*Mst2**8.*Mt**2.)/27.-

     &  (7127*Mgl**5.*Mst2**10.*Mt**2.)/864.+

     &  (4363*Mgl**3.*Mst2**12.*Mt**2.)/432.-

     &  (3529*Mgl*Mst2**14.*Mt**2.)/864.+

     &  (1505*Mgl**13.*Mt**4.)/72.-

     &  (1963*Mgl**11.*Mst2**2.*Mt**4.)/108.-

     &  (3733*Mgl**9.*Mst2**4.*Mt**4.)/216.+

     &  (1247*Mgl**7.*Mst2**6.*Mt**4.)/108.+

     &  (253*Mgl**5.*Mst2**8.*Mt**4.)/72.-

     &  (191*Mgl**3.*Mst2**10.*Mt**4.)/27.+

     &  (473*Mgl*Mst2**12.*Mt**4.)/72.-

     &  (43645*Mgl**11.*Mt**6.)/1152.+

     &  (18695*Mgl**9.*Mst2**2.*Mt**6.)/3456.+

     &  (10859*Mgl**7.*Mst2**4.*Mt**6.)/576.+

     &  (15275*Mgl**5.*Mst2**6.*Mt**6.)/1728.+

     &  (21061*Mgl**3.*Mst2**8.*Mt**6.)/3456.-

     &  (4525*Mgl*Mst2**10.*Mt**6.)/3456.+

     &  (50407*Mgl**9.*Mt**8.)/1152.+

     &  (10597*Mgl**7.*Mst2**2.*Mt**8.)/864.-

     &  (17449*Mgl**5.*Mst2**4.*Mt**8.)/1728.-

     &  (10799*Mgl**3.*Mst2**6.*Mt**8.)/864.-

     &  (24187*Mgl*Mst2**8.*Mt**8.)/3456.-

     &  (9457*Mgl**7.*Mt**10.)/288.-

     &  (6689*Mgl**5.*Mst2**2.*Mt**10.)/432.+

     &  (3517*Mgl**3.*Mst2**4.*Mt**10.)/864.+

     &  (491*Mgl*Mst2**6.*Mt**10.)/72.+

     &  (4499*Mgl**5.*Mt**12.)/288.+

     &  (1091*Mgl**3.*Mst2**2.*Mt**12.)/144.-

     &  (751*Mgl*Mst2**4.*Mt**12.)/864.-

     &  (9925*Mgl**3.*Mt**14.)/2304.-

     &  (10073*Mgl*Mst2**2.*Mt**14.)/6912.+

     &  (135*Mgl*Mt**16.)/256.)*Xt*d123(Mt,Mgl,Mst2)**4.*

     &  Den(Mst1,Mst2)*ln(mu,Mst2)+

     &  (-0.07530381944444445+

     &  (19*Mgl**2.)/(4608.*Mst2**2.)-

     &  (53*Mgl**4.)/(4608.*Mt**4.)+

     &  (53*Mgl**2.*Mst2**2.)/(4608.*Mt**4.)-

     &  (61*Mgl**2.)/(4608.*Mt**2.)+

     &  (5*Mst2**2.)/(72.*Mt**2.)+

     &  (19*Mt**2.)/(4608.*Mst2**2.))*ln(mu,Mgl)*ln(mu,Mst2)

     &  +((-5*Mgl**4.)/1152.-

     &  (7*Mgl**6.)/(384.*Mst2**2.)-

     &  (Mgl**2.*Mst2**2.)/36.+(37*Mst2**4.)/192.+

     &  (5*Mgl**8.)/(192.*Mt**4.)-

     &  (43*Mgl**6.*Mst2**2.)/(576.*Mt**4.)+

     &  (13*Mgl**4.*Mst2**4.)/(192.*Mt**4.)-

     &  (Mgl**2.*Mst2**6.)/(64.*Mt**4.)-

     &  Mst2**8./(288.*Mt**4.)-

     &  (35*Mgl**6.)/(2304.*Mt**2.)-

     &  (175*Mgl**4.*Mst2**2.)/(1152.*Mt**2.)+

     &  (445*Mgl**2.*Mst2**4.)/(2304.*Mt**2.)-

     &  (5*Mst2**6.)/(192.*Mt**2.)-

     &  (289*Mgl**2.*Mt**2.)/2304.-

     &  (49*Mgl**4.*Mt**2.)/(768.*Mst2**2.)-

     &  (Mst2**2.*Mt**2.)/768.-(65*Mt**4.)/288.+

     &  (7*Mgl**2.*Mt**4.)/(384.*Mst2**2.)+

     &  (49*Mt**6.)/(768.*Mst2**2.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mgl)*ln(mu,Mst2)+

     &  ((-653*Mgl**8.)/2304.+

     &  (61*Mgl**10.)/(2304.*Mst2**2.)-

     &  (29*Mgl**6.*Mst2**2.)/384.+

     &  (535*Mgl**4.*Mst2**4.)/1152.-

     &  (293*Mgl**2.*Mst2**6.)/768.+

     &  (575*Mst2**8.)/2304.-

     &  (47*Mgl**12.)/(2304.*Mt**4.)+

     &  (191*Mgl**10.*Mst2**2.)/(2304.*Mt**4.)-

     &  (143*Mgl**8.*Mst2**4.)/(1152.*Mt**4.)+

     &  (29*Mgl**6.*Mst2**6.)/(384.*Mt**4.)-

     &  (11*Mgl**4.*Mst2**8.)/(2304.*Mt**4.)-

     &  (29*Mgl**2.*Mst2**10.)/(2304.*Mt**4.)+

     &  Mst2**12./(288.*Mt**4.)+

     &  (17*Mgl**10.)/(96.*Mt**2.)-

     &  (101*Mgl**8.*Mst2**2.)/(576.*Mt**2.)-

     &  (35*Mgl**6.*Mst2**4.)/(144.*Mt**2.)+

     &  (Mgl**4.*Mst2**6.)/(6.*Mt**2.)+

     &  (61*Mgl**2.*Mst2**8.)/(288.*Mt**2.)-

     &  (79*Mst2**10.)/(576.*Mt**2.)-

     &  (329*Mgl**6.*Mt**2.)/1152.-

     &  (5*Mgl**8.*Mt**2.)/(1152.*Mst2**2.)-

     &  (37*Mgl**4.*Mst2**2.*Mt**2.)/64.+

     &  (731*Mgl**2.*Mst2**4.*Mt**2.)/1152.-

     &  (503*Mst2**6.*Mt**2.)/1152.+

     &  (895*Mgl**4.*Mt**4.)/2304.-

     &  (5*Mgl**6.*Mt**4.)/(36.*Mst2**2.)-

     &  (227*Mgl**2.*Mst2**2.*Mt**4.)/2304.+

     &  (151*Mst2**4.*Mt**4.)/144.-

     &  (179*Mgl**2.*Mt**6.)/384.+

     &  (109*Mgl**4.*Mt**6.)/(1152.*Mst2**2.)-

     &  (155*Mst2**2.*Mt**6.)/128.+(1321*Mt**8.)/2304.+

     &  (259*Mgl**2.*Mt**8.)/(2304.*Mst2**2.)-

     &  (13*Mt**10.)/(144.*Mst2**2.))*d123(Mt,Mgl,Mst2)**2.*

     &  ln(mu,Mgl)*ln(mu,Mst2)+

     &  ((973*Mgl**12.)/1152.+Mgl**14./(1152.*Mst2**2.)-

     &  (715*Mgl**10.*Mst2**2.)/576.-

     &  (97*Mgl**8.*Mst2**4.)/144.+

     &  (2341*Mgl**6.*Mst2**6.)/1152.-

     &  (1963*Mgl**4.*Mst2**8.)/1152.+

     &  (41*Mgl**2.*Mst2**10.)/36.-(229*Mst2**12.)/576.+

     &  (5*Mgl**16.)/(576.*Mt**4.)-

     &  (19*Mgl**14.*Mst2**2.)/(576.*Mt**4.)+

     &  (11*Mgl**12.*Mst2**4.)/(576.*Mt**4.)+

     &  (53*Mgl**10.*Mst2**6.)/(576.*Mt**4.)-

     &  (115*Mgl**8.*Mst2**8.)/(576.*Mt**4.)+

     &  (95*Mgl**6.*Mst2**10.)/(576.*Mt**4.)-

     &  (31*Mgl**4.*Mst2**12.)/(576.*Mt**4.)-

     &  (Mgl**2.*Mst2**14.)/(576.*Mt**4.)+

     &  Mst2**16./(288.*Mt**4.)-

     &  (437*Mgl**14.)/(2304.*Mt**2.)+

     &  (601*Mgl**12.*Mst2**2.)/(1152.*Mt**2.)-

     &  (403*Mgl**10.*Mst2**4.)/(2304.*Mt**2.)-

     &  (29*Mgl**8.*Mst2**6.)/(48.*Mt**2.)+

     &  (853*Mgl**6.*Mst2**8.)/(2304.*Mt**2.)+

     &  (485*Mgl**4.*Mst2**10.)/(1152.*Mt**2.)-

     &  (1069*Mgl**2.*Mst2**12.)/(2304.*Mt**2.)+

     &  (23*Mst2**14.)/(192.*Mt**2.)-

     &  (2693*Mgl**10.*Mt**2.)/2304.+

     &  (95*Mgl**12.*Mt**2.)/(2304.*Mst2**2.)+

     &  (743*Mgl**8.*Mst2**2.*Mt**2.)/768.-

     &  (29*Mgl**6.*Mst2**4.*Mt**2.)/384.+

     &  (2029*Mgl**4.*Mst2**6.*Mt**2.)/2304.-

     &  (2821*Mgl**2.*Mst2**8.*Mt**2.)/2304.+

     &  (445*Mst2**10.*Mt**2.)/768.+

     &  (61*Mgl**8.*Mt**4.)/576.-

     &  (43*Mgl**10.*Mt**4.)/(384.*Mst2**2.)-

     &  (365*Mgl**6.*Mst2**2.*Mt**4.)/192.-

     &  (13*Mgl**4.*Mst2**4.*Mt**4.)/32.+

     &  (1567*Mgl**2.*Mst2**6.*Mt**4.)/1152.-

     &  (499*Mst2**8.*Mt**4.)/576.+

     &  (2345*Mgl**6.*Mt**6.)/2304.+

     &  (19*Mgl**8.*Mt**6.)/(2304.*Mst2**2.)+

     &  (815*Mgl**4.*Mst2**2.*Mt**6.)/576.-

     &  (3167*Mgl**2.*Mst2**4.*Mt**6.)/2304.+

     &  (2951*Mst2**6.*Mt**6.)/2304.-

     &  (527*Mgl**4.*Mt**8.)/1152.+

     &  (203*Mgl**6.*Mt**8.)/(1152.*Mst2**2.)+

     &  (347*Mgl**2.*Mst2**2.*Mt**8.)/576.-

     &  (653*Mst2**4.*Mt**8.)/576.+

     &  (65*Mgl**2.*Mt**10.)/2304.-

     &  (73*Mgl**4.*Mt**10.)/(768.*Mst2**2.)+

     &  (1285*Mst2**2.*Mt**10.)/2304.-

     &  (109*Mt**12.)/576.-

     &  (25*Mgl**2.*Mt**12.)/(384.*Mst2**2.)+

     &  (35*Mt**14.)/(768.*Mst2**2.))*d123(Mt,Mgl,Mst2)**3.*

     &  ln(mu,Mgl)*ln(mu,Mst2)+

     &  ((-1259*Mgl**16.)/4608.-

     &  (61*Mgl**18.)/(4608.*Mst2**2.)+

     &  (1003*Mgl**14.*Mst2**2.)/1152.-

     &  (271*Mgl**12.*Mst2**4.)/1152.-

     &  (1409*Mgl**10.*Mst2**6.)/768.+

     &  (699*Mgl**8.*Mst2**8.)/256.-

     &  (2225*Mgl**6.*Mst2**10.)/1152.+

     &  (1301*Mgl**4.*Mst2**12.)/1152.-

     &  (2725*Mgl**2.*Mst2**14.)/4608.+

     &  (685*Mst2**16.)/4608.-

     &  (13*Mgl**20.)/(4608.*Mt**4.)+

     &  (61*Mgl**18.*Mst2**2.)/(4608.*Mt**4.)-

     &  (Mgl**16.*Mst2**4.)/(128.*Mt**4.)-

     &  (29*Mgl**14.*Mst2**6.)/(384.*Mt**4.)+

     &  (175*Mgl**12.*Mst2**8.)/(768.*Mt**4.)-

     &  (77*Mgl**10.*Mst2**10.)/(256.*Mt**4.)+

     &  (77*Mgl**8.*Mst2**12.)/(384.*Mt**4.)-

     &  (17*Mgl**6.*Mst2**14.)/(384.*Mt**4.)-

     &  (13*Mgl**4.*Mst2**16.)/(512.*Mt**4.)+

     &  (85*Mgl**2.*Mst2**18.)/(4608.*Mt**4.)-

     &  Mst2**20./(288.*Mt**4.)+

     &  (21*Mgl**18.)/(512.*Mt**2.)-

     &  (19*Mgl**16.*Mst2**2.)/(144.*Mt**2.)-

     &  (73*Mgl**14.*Mst2**4.)/(1152.*Mt**2.)+

     &  (53*Mgl**12.*Mst2**6.)/(64.*Mt**2.)-

     &  (3265*Mgl**10.*Mst2**8.)/(2304.*Mt**2.)+

     &  (547*Mgl**8.*Mst2**10.)/(576.*Mt**2.)-

     &  (11*Mgl**6.*Mst2**12.)/(384.*Mt**2.)-

     &  (181*Mgl**4.*Mst2**14.)/(576.*Mt**2.)+

     &  (749*Mgl**2.*Mst2**16.)/(4608.*Mt**2.)-

     &  (5*Mst2**18.)/(192.*Mt**2.)+

     &  (77*Mgl**14.*Mt**2.)/96.+

     &  (83*Mgl**16.*Mt**2.)/(1536.*Mst2**2.)-

     &  (2207*Mgl**12.*Mst2**2.*Mt**2.)/1152.+

     &  (257*Mgl**10.*Mst2**4.*Mt**2.)/288.+

     &  (149*Mgl**8.*Mst2**6.*Mt**2.)/768.+

     &  (101*Mgl**6.*Mst2**8.*Mt**2.)/288.-

     &  (875*Mgl**4.*Mst2**10.*Mt**2.)/1152.+

     &  (65*Mgl**2.*Mst2**12.*Mt**2.)/96.-

     &  (151*Mst2**14.*Mt**2.)/512.-

     &  (253*Mgl**12.*Mt**4.)/256.-

     &  (31*Mgl**14.*Mt**4.)/(576.*Mst2**2.)+

     &  (5969*Mgl**10.*Mst2**2.*Mt**4.)/2304.-

     &  (781*Mgl**8.*Mst2**4.*Mt**4.)/384.+

     &  (835*Mgl**6.*Mst2**6.*Mt**4.)/1152.+

     &  (431*Mgl**4.*Mst2**8.*Mt**4.)/2304.-

     &  (2059*Mgl**2.*Mst2**10.*Mt**4.)/2304.+

     &  (269*Mst2**12.*Mt**4.)/576.-

     &  (209*Mgl**10.*Mt**6.)/768.-

     &  (11*Mgl**12.*Mt**6.)/(288.*Mst2**2.)-

     &  (193*Mgl**8.*Mst2**2.*Mt**6.)/96.+

     &  (433*Mgl**6.*Mst2**4.*Mt**6.)/384.-

     &  (109*Mgl**4.*Mst2**6.*Mt**6.)/576.+

     &  (5413*Mgl**2.*Mst2**8.*Mt**6.)/2304.-

     &  (461*Mst2**10.*Mt**6.)/576.+

     &  (1319*Mgl**8.*Mt**8.)/768.+

     &  (131*Mgl**10.*Mt**8.)/(2304.*Mst2**2.)+

     &  (1045*Mgl**6.*Mst2**2.*Mt**8.)/1152.-

     &  (1165*Mgl**4.*Mst2**4.*Mt**8.)/1152.-

     &  (8941*Mgl**2.*Mst2**6.*Mt**8.)/2304.+

     &  (727*Mst2**8.*Mt**8.)/768.-

     &  (599*Mgl**6.*Mt**10.)/576.+

     &  (133*Mgl**8.*Mt**10.)/(2304.*Mst2**2.)+

     &  (467*Mgl**4.*Mst2**2.*Mt**10.)/384.+

     &  (221*Mgl**2.*Mst2**4.*Mt**10.)/64.-

     &  (1255*Mst2**6.*Mt**10.)/2304.-

     &  (841*Mgl**4.*Mt**12.)/4608.-

     &  (19*Mgl**6.*Mt**12.)/(288.*Mst2**2.)-

     &  (6943*Mgl**2.*Mst2**2.*Mt**12.)/4608.+

     &  (29*Mst2**4.*Mt**12.)/288.+

     &  (625*Mgl**2.*Mt**14.)/4608.-

     &  (29*Mgl**4.*Mt**14.)/(576.*Mst2**2.)-

     &  (19*Mst2**2.*Mt**14.)/576.+(289*Mt**16.)/4608.+

     &  (39*Mgl**2.*Mt**16.)/(512.*Mst2**2.)-

     &  (107*Mt**18.)/(4608.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**4.*ln(mu,Mgl)*ln(mu,Mst2)+

     &  (-Mgl/9.-(25*Mgl**3.)/(1152.*Mt**2.)+

     &  (19*Mgl*Mt**2.)/(1152.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mgl)*ln(mu,Mst2)+

     &  ((-17*Mgl**5.)/192.-(137*Mgl**3.*Mst2**2.)/576.+

     &  (13*Mgl*Mst2**4.)/144.+

     &  (23*Mgl**7.)/(288.*Mt**2.)-

     &  (7*Mgl**5.*Mst2**2.)/(48.*Mt**2.)+

     &  (5*Mgl**3.*Mst2**4.)/(96.*Mt**2.)+

     &  (Mgl*Mst2**6.)/(72.*Mt**2.)-

     &  (67*Mgl**3.*Mt**2.)/576.-

     &  (7*Mgl**5.*Mt**2.)/(96.*Mst2**2.)-

     &  (Mgl*Mst2**2.*Mt**2.)/8.-(325*Mgl*Mt**4.)/576.-

     &  (35*Mgl**3.*Mt**4.)/(192.*Mst2**2.)+

     &  (49*Mgl*Mt**6.)/(192.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst2)+

     &  ((515*Mgl**9.)/576.-(353*Mgl**7.*Mst2**2.)/576.-

     &  (35*Mgl**5.*Mst2**4.)/64.-

     &  (11*Mgl**3.*Mst2**6.)/576.+

     &  (41*Mgl*Mst2**8.)/144.-

     &  (5*Mgl**11.)/(64.*Mt**2.)+

     &  (17*Mgl**9.*Mst2**2.)/(72.*Mt**2.)-

     &  (65*Mgl**7.*Mst2**4.)/(288.*Mt**2.)+

     &  (Mgl**5.*Mst2**6.)/(24.*Mt**2.)+

     &  (23*Mgl**3.*Mst2**8.)/(576.*Mt**2.)-

     &  (Mgl*Mst2**10.)/(72.*Mt**2.)-

     &  (457*Mgl**7.*Mt**2.)/192.+

     &  (61*Mgl**9.*Mt**2.)/(576.*Mst2**2.)-

     &  (145*Mgl**5.*Mst2**2.*Mt**2.)/144.+

     &  (81*Mgl**3.*Mst2**4.*Mt**2.)/64.-

     &  (223*Mgl*Mst2**6.*Mt**2.)/576.+

     &  (583*Mgl**5.*Mt**4.)/288.-

     &  (71*Mgl**7.*Mt**4.)/(576.*Mst2**2.)-

     &  (13*Mgl**3.*Mst2**2.*Mt**4.)/32.+

     &  (575*Mgl*Mst2**4.*Mt**4.)/576.-

     &  (193*Mgl**3.*Mt**6.)/96.-

     &  (83*Mgl**5.*Mt**6.)/(192.*Mst2**2.)-

     &  (1289*Mgl*Mst2**2.*Mt**6.)/576.+

     &  (989*Mgl*Mt**8.)/576.+

     &  (467*Mgl**3.*Mt**8.)/(576.*Mst2**2.)-

     &  (13*Mgl*Mt**10.)/(36.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst2)+

     &  ((-469*Mgl**13.)/576.+(287*Mgl**11.*Mst2**2.)/192.+

     &  (59*Mgl**9.*Mst2**4.)/96.-

     &  (659*Mgl**7.*Mst2**6.)/288.+

     &  (85*Mgl**5.*Mst2**8.)/192.+

     &  (179*Mgl**3.*Mst2**10.)/192.-

     &  (55*Mgl*Mst2**12.)/144.+Mgl**15./(32.*Mt**2.)-

     &  (11*Mgl**13.*Mst2**2.)/(144.*Mt**2.)-

     &  (7*Mgl**11.*Mst2**4.)/(96.*Mt**2.)+

     &  (5*Mgl**9.*Mst2**6.)/(12.*Mt**2.)-

     &  (145*Mgl**7.*Mst2**8.)/(288.*Mt**2.)+

     &  (11*Mgl**5.*Mst2**10.)/(48.*Mt**2.)-

     &  (Mgl**3.*Mst2**12.)/(96.*Mt**2.)-

     &  (Mgl*Mst2**14.)/(72.*Mt**2.)+

     &  (829*Mgl**11.*Mt**2.)/192.+

     &  (Mgl**13.*Mt**2.)/(288.*Mst2**2.)-

     &  (217*Mgl**9.*Mst2**2.*Mt**2.)/72.-

     &  (1411*Mgl**7.*Mst2**4.*Mt**2.)/288.+

     &  (1423*Mgl**5.*Mst2**6.*Mt**2.)/288.-

     &  (1289*Mgl**3.*Mst2**8.*Mt**2.)/576.+

     &  (8*Mgl*Mst2**10.*Mt**2.)/9.-

     &  (1711*Mgl**9.*Mt**4.)/192.+

     &  (31*Mgl**11.*Mt**4.)/(192.*Mst2**2.)-

     &  (35*Mgl**7.*Mst2**2.*Mt**4.)/72.+

     &  (403*Mgl**5.*Mst2**4.*Mt**4.)/144.+

     &  (433*Mgl**3.*Mst2**6.*Mt**4.)/192.-

     &  (503*Mgl*Mst2**8.*Mt**4.)/576.+

     &  (403*Mgl**7.*Mt**6.)/48.-

     &  (39*Mgl**9.*Mt**6.)/(64.*Mst2**2.)+

     &  (9*Mgl**5.*Mst2**2.*Mt**6.)/32.-

     &  (155*Mgl**3.*Mst2**4.*Mt**6.)/48.+

     &  (797*Mgl*Mst2**6.*Mt**6.)/576.-

     &  (1699*Mgl**5.*Mt**8.)/576.+

     &  (185*Mgl**7.*Mt**8.)/(288.*Mst2**2.)+

     &  (1259*Mgl**3.*Mst2**2.*Mt**8.)/576.-

     &  (565*Mgl*Mst2**4.*Mt**8.)/288.+

     &  (35*Mgl**3.*Mt**10.)/64.+

     &  (Mgl**5.*Mt**10.)/(16.*Mst2**2.)+

     &  (401*Mgl*Mst2**2.*Mt**10.)/288.-

     &  (355*Mgl*Mt**12.)/576.-

     &  (85*Mgl**3.*Mt**12.)/(192.*Mst2**2.)+

     &  (35*Mgl*Mt**14.)/(192.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst2)+

     &  ((101*Mgl**17.)/576.-(227*Mgl**15.*Mst2**2.)/576.-

     &  (379*Mgl**13.*Mst2**4.)/576.+

     &  (1697*Mgl**11.*Mst2**6.)/576.-

     &  (1925*Mgl**9.*Mst2**8.)/576.+

     &  (599*Mgl**7.*Mst2**10.)/576.+

     &  (407*Mgl**5.*Mst2**12.)/576.-

     &  (341*Mgl**3.*Mst2**14.)/576.+

     &  (17*Mgl*Mst2**16.)/144.-

     &  (13*Mgl**19.)/(1152.*Mt**2.)+

     &  (Mgl**17.*Mst2**2.)/(24.*Mt**2.)+

     &  (Mgl**15.*Mst2**4.)/(96.*Mt**2.)-

     &  (7*Mgl**13.*Mst2**6.)/(24.*Mt**2.)+

     &  (119*Mgl**11.*Mst2**8.)/(192.*Mt**2.)-

     &  (7*Mgl**9.*Mst2**10.)/(12.*Mt**2.)+

     &  (7*Mgl**7.*Mst2**12.)/(32.*Mt**2.)+

     &  (Mgl**5.*Mst2**14.)/(24.*Mt**2.)-

     &  (23*Mgl**3.*Mst2**16.)/(384.*Mt**2.)+

     &  (Mgl*Mst2**18.)/(72.*Mt**2.)-

     &  (761*Mgl**15.*Mt**2.)/576.-

     &  (61*Mgl**17.*Mt**2.)/(1152.*Mst2**2.)+

     &  (23*Mgl**13.*Mst2**2.*Mt**2.)/9.+

     &  (1309*Mgl**11.*Mst2**4.*Mt**2.)/576.-

     &  (4615*Mgl**9.*Mst2**6.*Mt**2.)/576.+

     &  (3601*Mgl**7.*Mst2**8.*Mt**2.)/576.-

     &  (181*Mgl**5.*Mst2**10.*Mt**2.)/72.+

     &  (83*Mgl**3.*Mst2**12.*Mt**2.)/64.-

     &  (61*Mgl*Mst2**14.*Mt**2.)/128.+

     &  (691*Mgl**13.*Mt**4.)/144.+

     &  (155*Mgl**15.*Mt**4.)/(576.*Mst2**2.)-

     &  (1561*Mgl**11.*Mst2**2.*Mt**4.)/288.-

     &  (2375*Mgl**9.*Mst2**4.*Mt**4.)/576.+

     &  (2687*Mgl**7.*Mst2**6.*Mt**4.)/576.-

     &  (53*Mgl**5.*Mst2**8.*Mt**4.)/288.-

     &  (17*Mgl**3.*Mst2**10.*Mt**4.)/24.+

     &  (45*Mgl*Mst2**12.*Mt**4.)/64.-

     &  (665*Mgl**11.*Mt**6.)/72.-

     &  (31*Mgl**13.*Mt**6.)/(64.*Mst2**2.)+

     &  (419*Mgl**9.*Mst2**2.*Mt**6.)/64.+

     &  (365*Mgl**7.*Mst2**4.*Mt**6.)/144.+

     &  (443*Mgl**5.*Mst2**6.*Mt**6.)/576.+

     &  (245*Mgl**3.*Mst2**8.*Mt**6.)/144.-

     &  (671*Mgl*Mst2**10.*Mt**6.)/576.+

     &  (407*Mgl**9.*Mt**8.)/48.+

     &  (191*Mgl**11.*Mt**8.)/(576.*Mst2**2.)-

     &  (391*Mgl**7.*Mst2**2.*Mt**8.)/64.-

     &  (2381*Mgl**5.*Mst2**4.*Mt**8.)/576.-

     &  (815*Mgl**3.*Mst2**6.*Mt**8.)/144.+

     &  (391*Mgl*Mst2**8.*Mt**8.)/192.-

     &  (329*Mgl**7.*Mt**10.)/192.-

     &  (5*Mgl**9.*Mt**10.)/(48.*Mst2**2.)+

     &  (2311*Mgl**5.*Mst2**2.*Mt**10.)/288.+

     &  (4673*Mgl**3.*Mst2**4.*Mt**10.)/576.-

     &  (7*Mgl*Mst2**6.*Mt**10.)/4.-

     &  (19*Mgl**5.*Mt**12.)/9.+

     &  (193*Mgl**7.*Mt**12.)/(576.*Mst2**2.)-

     &  (253*Mgl**3.*Mst2**2.*Mt**12.)/48.+

     &  (247*Mgl*Mst2**4.*Mt**12.)/576.+

     &  (901*Mgl**3.*Mt**14.)/1152.-

     &  (115*Mgl**5.*Mt**14.)/(192.*Mst2**2.)+

     &  (5*Mgl*Mst2**2.*Mt**14.)/192.+

     &  (91*Mgl*Mt**16.)/576.+

     &  (229*Mgl**3.*Mt**16.)/(576.*Mst2**2.)-

     &  (107*Mgl*Mt**18.)/(1152.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst2)+

     &  (-0.024522569444444444-

     &  (19*Mgl**2.)/(9216.*Mst2**2.)-

     &  (53*Mgl**4.)/(9216.*Mt**4.)+

     &  (53*Mgl**2.*Mst2**2.)/(3072.*Mt**4.)-

     &  (53*Mst2**4.)/(4608.*Mt**4.)-

     &  (19*Mgl**2.)/(1536.*Mt**2.)+

     &  (367*Mst2**2.)/(9216.*Mt**2.)-

     &  (19*Mt**2.)/(9216.*Mst2**2.))*ln(mu,Mst2)**2.+

     &  ((-31*Mgl**4.)/2304.+(11*Mgl**6.)/(2304.*Mst2**2.)-

     &  (7*Mgl**2.*Mst2**2.)/768.+(397*Mst2**4.)/2304.+

     &  (5*Mgl**8.)/(384.*Mt**4.)-

     &  (71*Mgl**6.*Mst2**2.)/(1152.*Mt**4.)+

     &  (41*Mgl**4.*Mst2**4.)/(384.*Mt**4.)-

     &  (31*Mgl**2.*Mst2**6.)/(384.*Mt**4.)+

     &  (13*Mst2**8.)/(576.*Mt**4.)-

     &  (47*Mgl**6.)/(2304.*Mt**2.)-

     &  (11*Mgl**4.*Mst2**2.)/(128.*Mt**2.)+

     &  (373*Mgl**2.*Mst2**4.)/(2304.*Mt**2.)-

     &  Mst2**6./(18.*Mt**2.)+(47*Mgl**2.*Mt**2.)/2304.-

     &  (11*Mgl**4.*Mt**2.)/(2304.*Mst2**2.)-

     &  (409*Mst2**2.*Mt**2.)/2304.+(5*Mt**4.)/2304.-

     &  (11*Mgl**2.*Mt**4.)/(2304.*Mst2**2.)+

     &  (11*Mt**6.)/(2304.*Mst2**2.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mst2)**2.+

     &  ((-475*Mgl**8.)/2304.-

     &  (25*Mgl**10.)/(4608.*Mst2**2.)+

     &  (Mgl**6.*Mst2**2.)/72.-

     &  (65*Mgl**4.*Mst2**4.)/2304.+

     &  (17*Mgl**2.*Mst2**6.)/512.+(37*Mst2**8.)/192.-

     &  (47*Mgl**12.)/(4608.*Mt**4.)+

     &  (29*Mgl**10.*Mst2**2.)/(512.*Mt**4.)-

     &  (17*Mgl**8.*Mst2**4.)/(128.*Mt**4.)+

     &  (389*Mgl**6.*Mst2**6.)/(2304.*Mt**4.)-

     &  (63*Mgl**4.*Mst2**8.)/(512.*Mt**4.)+

     &  (25*Mgl**2.*Mst2**10.)/(512.*Mt**4.)-

     &  (19*Mst2**12.)/(2304.*Mt**4.)+

     &  (127*Mgl**10.)/(1152.*Mt**2.)-

     &  (1051*Mgl**8.*Mst2**2.)/(4608.*Mt**2.)+

     &  (13*Mgl**6.*Mst2**4.)/(128.*Mt**2.)-

     &  (29*Mgl**4.*Mst2**6.)/(2304.*Mt**2.)+

     &  (47*Mgl**2.*Mst2**8.)/(576.*Mt**2.)-

     &  (27*Mst2**10.)/(512.*Mt**2.)+

     &  (25*Mgl**6.*Mt**2.)/1152.+

     &  (11*Mgl**8.*Mt**2.)/(512.*Mst2**2.)-

     &  (127*Mgl**4.*Mst2**2.*Mt**2.)/1152.-

     &  (47*Mgl**2.*Mst2**4.*Mt**2.)/288.+

     &  (5*Mst2**6.*Mt**2.)/512.+

     &  (1481*Mgl**4.*Mt**4.)/4608.-

     &  (49*Mgl**6.*Mt**4.)/(2304.*Mst2**2.)+

     &  (1619*Mgl**2.*Mst2**2.*Mt**4.)/4608.+

     &  (9*Mst2**4.*Mt**4.)/256.-

     &  (221*Mgl**2.*Mt**6.)/576.-

     &  (25*Mgl**4.*Mt**6.)/(2304.*Mst2**2.)-

     &  (1441*Mst2**2.*Mt**6.)/4608.+(169*Mt**8.)/1152.+

     &  (41*Mgl**2.*Mt**8.)/(1536.*Mst2**2.)-

     &  (49*Mt**10.)/(4608.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mst2)**2.+

     &  ((1013*Mgl**12.)/2304.-Mgl**14./(2304.*Mst2**2.)-

     &  (1963*Mgl**10.*Mst2**2.)/2304.+

     &  (803*Mgl**8.*Mst2**4.)/2304.+

     &  (689*Mgl**6.*Mst2**6.)/2304.-

     &  (2189*Mgl**4.*Mst2**8.)/2304.+

     &  (2843*Mgl**2.*Mst2**10.)/2304.-

     &  (1195*Mst2**12.)/2304.+

     &  (5*Mgl**16.)/(1152.*Mt**4.)-

     &  (23*Mgl**14.*Mst2**2.)/(1152.*Mt**4.)+

     &  (3*Mgl**12.*Mst2**4.)/(128.*Mt**4.)+

     &  (41*Mgl**10.*Mst2**6.)/(1152.*Mt**4.)-

     &  (155*Mgl**8.*Mst2**8.)/(1152.*Mt**4.)+

     &  (65*Mgl**6.*Mst2**10.)/(384.*Mt**4.)-

     &  (127*Mgl**4.*Mst2**12.)/(1152.*Mt**4.)+

     &  (43*Mgl**2.*Mst2**14.)/(1152.*Mt**4.)-

     &  Mst2**16./(192.*Mt**4.)-

     &  (229*Mgl**14.)/(2304.*Mt**2.)+

     &  (139*Mgl**12.*Mst2**2.)/(384.*Mt**2.)-

     &  (1099*Mgl**10.*Mst2**4.)/(2304.*Mt**2.)+

     &  (37*Mgl**8.*Mst2**6.)/(96.*Mt**2.)-

     &  (409*Mgl**6.*Mst2**8.)/(768.*Mt**2.)+

     &  (821*Mgl**4.*Mst2**10.)/(1152.*Mt**2.)-

     &  (1061*Mgl**2.*Mst2**12.)/(2304.*Mt**2.)+

     &  (7*Mst2**14.)/(64.*Mt**2.)-

     &  (201*Mgl**10.*Mt**2.)/256.-

     &  (5*Mgl**12.*Mt**2.)/(768.*Mst2**2.)+

     &  (2153*Mgl**8.*Mst2**2.*Mt**2.)/2304.-

     &  (75*Mgl**6.*Mst2**4.*Mt**2.)/128.+

     &  (1495*Mgl**4.*Mst2**6.*Mt**2.)/2304.-

     &  (233*Mgl**2.*Mst2**8.*Mt**2.)/256.+

     &  (541*Mst2**10.*Mt**2.)/768.+

     &  (953*Mgl**8.*Mt**4.)/2304.+

     &  (79*Mgl**10.*Mt**4.)/(2304.*Mst2**2.)-

     &  (541*Mgl**6.*Mst2**2.*Mt**4.)/576.-

     &  (101*Mgl**4.*Mst2**4.*Mt**4.)/576.-

     &  (571*Mgl**2.*Mst2**6.*Mt**4.)/2304.-

     &  (1045*Mst2**8.*Mt**4.)/2304.+

     &  (1361*Mgl**6.*Mt**6.)/2304.-

     &  (119*Mgl**8.*Mt**6.)/(2304.*Mst2**2.)+

     &  (967*Mgl**4.*Mst2**2.*Mt**6.)/576.+

     &  (4049*Mgl**2.*Mst2**4.*Mt**6.)/2304.+

     &  (241*Mst2**6.*Mt**6.)/256.-

     &  (2537*Mgl**4.*Mt**8.)/2304.+

     &  (7*Mgl**6.*Mt**8.)/(768.*Mst2**2.)-

     &  (4819*Mgl**2.*Mst2**2.*Mt**8.)/2304.-

     &  (1175*Mst2**4.*Mt**8.)/768.+

     &  (1669*Mgl**2.*Mt**10.)/2304.+

     &  (107*Mgl**4.*Mt**10.)/(2304.*Mst2**2.)+

     &  (2137*Mst2**2.*Mt**10.)/2304.-

     &  (431*Mt**12.)/2304.-

     &  (11*Mgl**2.*Mt**12.)/(256.*Mst2**2.)+

     &  (3*Mt**14.)/(256.*Mst2**2.))*d123(Mt,Mgl,Mst2)**3.*

     &  ln(mu,Mst2)**2.+

     &  ((-749*Mgl**16.)/4608.+

     &  (29*Mgl**18.)/(9216.*Mst2**2.)+

     &  (37*Mgl**14.*Mst2**2.)/96.+

     &  (5*Mgl**12.*Mst2**4.)/2304.-

     &  (893*Mgl**10.*Mst2**6.)/1536.+

     &  (61*Mgl**8.*Mst2**8.)/192.-

     &  (175*Mgl**6.*Mst2**10.)/1152.+

     &  (1555*Mgl**4.*Mst2**12.)/2304.-

     &  (2141*Mgl**2.*Mst2**14.)/3072.+

     &  (965*Mst2**16.)/4608.-

     &  (13*Mgl**20.)/(9216.*Mt**4.)+

     &  (71*Mgl**18.*Mst2**2.)/(9216.*Mt**4.)-

     &  (13*Mgl**16.*Mst2**4.)/(1536.*Mt**4.)-

     &  (31*Mgl**14.*Mst2**6.)/(768.*Mt**4.)+

     &  (259*Mgl**12.*Mst2**8.)/(1536.*Mt**4.)-

     &  (469*Mgl**10.*Mst2**10.)/(1536.*Mt**4.)+

     &  (21*Mgl**8.*Mst2**12.)/(64.*Mt**4.)-

     &  (57*Mgl**6.*Mst2**14.)/(256.*Mt**4.)+

     &  (289*Mgl**4.*Mst2**16.)/(3072.*Mt**4.)-

     &  (209*Mgl**2.*Mst2**18.)/(9216.*Mt**4.)+

     &  (11*Mst2**20.)/(4608.*Mt**4.)+

     &  (101*Mgl**18.)/(4608.*Mt**2.)-

     &  (617*Mgl**16.*Mst2**2.)/(9216.*Mt**2.)-

     &  (47*Mgl**14.*Mst2**4.)/(576.*Mt**2.)+

     &  (1445*Mgl**12.*Mst2**6.)/(2304.*Mt**2.)-

     &  (2447*Mgl**10.*Mst2**8.)/(2304.*Mt**2.)+

     &  (3149*Mgl**8.*Mst2**10.)/(4608.*Mt**2.)+

     &  (31*Mgl**6.*Mst2**12.)/(288.*Mt**2.)-

     &  (947*Mgl**4.*Mst2**14.)/(2304.*Mt**2.)+

     &  (1025*Mgl**2.*Mst2**16.)/(4608.*Mt**2.)-

     &  (377*Mst2**18.)/(9216.*Mt**2.)+

     &  (319*Mgl**14.*Mt**2.)/576.-

     &  (19*Mgl**16.*Mt**2.)/(1024.*Mst2**2.)-

     &  (1079*Mgl**12.*Mst2**2.*Mt**2.)/1152.+

     &  (551*Mgl**10.*Mst2**4.*Mt**2.)/1152.-

     &  (3911*Mgl**8.*Mst2**6.*Mt**2.)/4608.+

     &  (25*Mgl**6.*Mst2**8.*Mt**2.)/18.-

     &  (529*Mgl**4.*Mst2**10.*Mt**2.)/576.+

     &  (217*Mgl**2.*Mst2**12.*Mt**2.)/384.-

     &  (2431*Mst2**14.*Mt**2.)/9216.-

     &  (4147*Mgl**12.*Mt**4.)/4608.+

     &  (89*Mgl**14.*Mt**4.)/(2304.*Mst2**2.)+

     &  (3731*Mgl**10.*Mst2**2.*Mt**4.)/4608.-

     &  (23*Mgl**8.*Mst2**4.*Mt**4.)/144.+

     &  (119*Mgl**6.*Mst2**6.*Mt**4.)/192.-

     &  (851*Mgl**4.*Mst2**8.*Mt**4.)/4608.+

     &  (75*Mgl**2.*Mst2**10.*Mt**4.)/512.-

     &  (853*Mst2**12.*Mt**4.)/2304.+

     &  (145*Mgl**10.*Mt**6.)/256.-

     &  (17*Mgl**12.*Mt**6.)/(768.*Mst2**2.)-

     &  (1577*Mgl**8.*Mst2**2.*Mt**6.)/4608.-

     &  (265*Mgl**6.*Mst2**4.*Mt**6.)/288.+

     &  (89*Mgl**4.*Mst2**6.*Mt**6.)/1152.-

     &  (343*Mgl**2.*Mst2**8.*Mt**6.)/768.+

     &  (4627*Mst2**10.*Mt**6.)/4608.+

     &  (169*Mgl**8.*Mt**8.)/576.-

     &  (55*Mgl**10.*Mt**8.)/(1536.*Mst2**2.)+

     &  (413*Mgl**6.*Mst2**2.*Mt**8.)/384.+

     &  (4687*Mgl**4.*Mst2**4.*Mt**8.)/2304.+

     &  (2243*Mgl**2.*Mst2**6.*Mt**8.)/1536.-

     &  (547*Mst2**8.*Mt**8.)/2304.-

     &  (19*Mgl**6.*Mt**10.)/24.+

     &  (283*Mgl**8.*Mt**10.)/(4608.*Mst2**2.)-

     &  (383*Mgl**4.*Mst2**2.*Mt**10.)/192.-

     &  (935*Mgl**2.*Mst2**4.*Mt**10.)/384.-

     &  (4775*Mst2**6.*Mt**10.)/4608.+

     &  (5947*Mgl**4.*Mt**12.)/9216.-

     &  (17*Mgl**6.*Mt**12.)/(768.*Mst2**2.)+

     &  (1507*Mgl**2.*Mst2**2.*Mt**12.)/1024.+

     &  (5023*Mst2**4.*Mt**12.)/4608.-

     &  (1295*Mgl**2.*Mt**14.)/4608.-

     &  (13*Mgl**4.*Mt**14.)/(768.*Mst2**2.)-

     &  (3773*Mst2**2.*Mt**14.)/9216.+

     &  (257*Mt**16.)/4608.+

     &  (149*Mgl**2.*Mt**16.)/(9216.*Mst2**2.)-

     &  (35*Mt**18.)/(9216.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**4.*ln(mu,Mst2)**2.+

     &  ((-17*Mgl)/256.-(25*Mgl**3.)/(2304.*Mt**2.)+

     &  (25*Mgl*Mst2**2.)/(1152.*Mt**2.)-

     &  (19*Mgl*Mt**2.)/(2304.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mst2)**2.+

     &  ((-13*Mgl**5.)/144.-(53*Mgl**3.*Mst2**2.)/576.+

     &  (37*Mgl*Mst2**4.)/576.+

     &  (23*Mgl**7.)/(576.*Mt**2.)-

     &  (7*Mgl**5.*Mst2**2.)/(48.*Mt**2.)+

     &  (11*Mgl**3.*Mst2**4.)/(64.*Mt**2.)-

     &  (19*Mgl*Mst2**6.)/(288.*Mt**2.)+

     &  (Mgl**3.*Mt**2.)/36.+

     &  (11*Mgl**5.*Mt**2.)/(576.*Mst2**2.)-

     &  (199*Mgl*Mst2**2.*Mt**2.)/576.+

     &  (5*Mgl*Mt**4.)/192.-

     &  (11*Mgl**3.*Mt**4.)/(288.*Mst2**2.)+

     &  (11*Mgl*Mt**6.)/(576.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mst2)**2.+

     &  ((593*Mgl**9.)/1152.-(155*Mgl**7.*Mst2**2.)/192.+

     &  (107*Mgl**5.*Mst2**4.)/288.-

     &  (53*Mgl**3.*Mst2**6.)/192.+

     &  (227*Mgl*Mst2**8.)/1152.-

     &  (5*Mgl**11.)/(128.*Mt**2.)+

     &  (101*Mgl**9.*Mst2**2.)/(576.*Mt**2.)-

     &  (185*Mgl**7.*Mst2**4.)/(576.*Mt**2.)+

     &  (29*Mgl**5.*Mst2**6.)/(96.*Mt**2.)-

     &  (169*Mgl**3.*Mst2**8.)/(1152.*Mt**2.)+

     &  (17*Mgl*Mst2**10.)/(576.*Mt**2.)-

     &  (905*Mgl**7.*Mt**2.)/576.-

     &  (25*Mgl**9.*Mt**2.)/(1152.*Mst2**2.)+

     &  (29*Mgl**5.*Mst2**2.*Mt**2.)/288.-

     &  (55*Mgl**3.*Mst2**4.*Mt**2.)/192.-

     &  (535*Mgl*Mst2**6.*Mt**2.)/1152.+

     &  (427*Mgl**5.*Mt**4.)/192.+

     &  (31*Mgl**7.*Mt**4.)/(288.*Mst2**2.)+

     &  (475*Mgl**3.*Mst2**2.*Mt**4.)/576.+

     &  (13*Mgl*Mst2**4.*Mt**4.)/48.-

     &  (1865*Mgl**3.*Mt**6.)/1152.-

     &  (37*Mgl**5.*Mt**6.)/(192.*Mst2**2.)-

     &  (433*Mgl*Mst2**2.*Mt**6.)/576.+

     &  (565*Mgl*Mt**8.)/1152.+

     &  (43*Mgl**3.*Mt**8.)/(288.*Mst2**2.)-

     &  (49*Mgl*Mt**10.)/(1152.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mst2)**2.

     &  +((-61*Mgl**13.)/144.+

     &  (601*Mgl**11.*Mst2**2.)/576.-

     &  (103*Mgl**9.*Mst2**4.)/192.-

     &  (Mgl**7.*Mst2**6.)/96.-

     &  (239*Mgl**5.*Mst2**8.)/288.+

     &  (223*Mgl**3.*Mst2**10.)/192.-

     &  (233*Mgl*Mst2**12.)/576.+Mgl**15./(64.*Mt**2.)-

     &  (7*Mgl**13.*Mst2**2.)/(144.*Mt**2.)-

     &  (Mgl**11.*Mst2**4.)/(64.*Mt**2.)+

     &  (25*Mgl**9.*Mst2**6.)/(96.*Mt**2.)-

     &  (265*Mgl**7.*Mst2**8.)/(576.*Mt**2.)+

     &  (3*Mgl**5.*Mst2**10.)/(8.*Mt**2.)-

     &  (29*Mgl**3.*Mst2**12.)/(192.*Mt**2.)+

     &  (7*Mgl*Mst2**14.)/(288.*Mt**2.)+

     &  (661*Mgl**11.*Mt**2.)/288.-

     &  (Mgl**13.*Mt**2.)/(576.*Mst2**2.)-

     &  (1213*Mgl**9.*Mst2**2.*Mt**2.)/576.-

     &  (43*Mgl**7.*Mst2**4.*Mt**2.)/48.+

     &  (167*Mgl**5.*Mst2**6.*Mt**2.)/192.-

     &  (161*Mgl**3.*Mst2**8.*Mt**2.)/96.+

     &  (97*Mgl*Mst2**10.*Mt**2.)/64.-

     &  (3359*Mgl**9.*Mt**4.)/576.-

     &  (7*Mgl**11.*Mt**4.)/(288.*Mst2**2.)-

     &  (103*Mgl**7.*Mst2**2.*Mt**4.)/288.-

     &  (19*Mgl**5.*Mst2**4.*Mt**4.)/36.+

     &  (37*Mgl**3.*Mst2**6.*Mt**4.)/48.-

     &  (865*Mgl*Mst2**8.*Mt**4.)/576.+

     &  (4765*Mgl**7.*Mt**6.)/576.+

     &  (31*Mgl**9.*Mt**6.)/(192.*Mst2**2.)+

     &  (1697*Mgl**5.*Mst2**2.*Mt**6.)/288.+

     &  (799*Mgl**3.*Mst2**4.*Mt**6.)/192.+

     &  (919*Mgl*Mst2**6.*Mt**6.)/576.-

     &  (1985*Mgl**5.*Mt**8.)/288.-

     &  (53*Mgl**7.*Mt**8.)/(144.*Mst2**2.)-

     &  (467*Mgl**3.*Mst2**2.*Mt**8.)/64.-

     &  (665*Mgl*Mst2**4.*Mt**8.)/192.+

     &  (13*Mgl**3.*Mt**10.)/4.+

     &  (233*Mgl**5.*Mt**10.)/(576.*Mst2**2.)+

     &  (1655*Mgl*Mst2**2.*Mt**10.)/576.-

     &  (395*Mgl*Mt**12.)/576.-

     &  (7*Mgl**3.*Mt**12.)/(32.*Mst2**2.)+

     &  (3*Mgl*Mt**14.)/(64.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mst2)**2.

     &  +((215*Mgl**17.)/2304.-

     &  (115*Mgl**15.*Mst2**2.)/576.-

     &  (149*Mgl**13.*Mst2**4.)/288.+

     &  (415*Mgl**11.*Mst2**6.)/192.-

     &  (995*Mgl**9.*Mst2**8.)/384.+

     &  (55*Mgl**7.*Mst2**10.)/64.+

     &  (25*Mgl**5.*Mst2**12.)/36.-

     &  (377*Mgl**3.*Mst2**14.)/576.+

     &  (355*Mgl*Mst2**16.)/2304.-

     &  (13*Mgl**19.)/(2304.*Mt**2.)+

     &  (29*Mgl**17.*Mst2**2.)/(1152.*Mt**2.)-

     &  (5*Mgl**15.*Mst2**4.)/(576.*Mt**2.)-

     &  (49*Mgl**13.*Mst2**6.)/(288.*Mt**2.)+

     &  (581*Mgl**11.*Mst2**8.)/(1152.*Mt**2.)-

     &  (413*Mgl**9.*Mst2**10.)/(576.*Mt**2.)+

     &  (343*Mgl**7.*Mst2**12.)/(576.*Mt**2.)-

     &  (85*Mgl**5.*Mst2**14.)/(288.*Mt**2.)+

     &  (187*Mgl**3.*Mst2**16.)/(2304.*Mt**2.)-

     &  (11*Mgl*Mst2**18.)/(1152.*Mt**2.)-

     &  (421*Mgl**15.*Mt**2.)/576.+

     &  (29*Mgl**17.*Mt**2.)/(2304.*Mst2**2.)+

     &  (97*Mgl**13.*Mst2**2.*Mt**2.)/96.+

     &  (295*Mgl**11.*Mst2**4.*Mt**2.)/192.-

     &  (1133*Mgl**9.*Mst2**6.*Mt**2.)/384.+

     &  (175*Mgl**7.*Mst2**8.*Mt**2.)/192.-

     &  (5*Mgl**5.*Mst2**10.*Mt**2.)/9.+

     &  (835*Mgl**3.*Mst2**12.*Mt**2.)/576.-

     &  (175*Mgl*Mst2**14.*Mt**2.)/256.+

     &  (183*Mgl**13.*Mt**4.)/64.-

     &  (25*Mgl**15.*Mt**4.)/(288.*Mst2**2.)-

     &  (1093*Mgl**11.*Mst2**2.*Mt**4.)/576.-

     &  (73*Mgl**9.*Mst2**4.*Mt**4.)/48.-

     &  (283*Mgl**7.*Mst2**6.*Mt**4.)/144.+

     &  (1543*Mgl**5.*Mst2**8.*Mt**4.)/576.-

     &  (253*Mgl**3.*Mst2**10.*Mt**4.)/576.+

     &  (107*Mgl*Mst2**12.*Mt**4.)/288.-

     &  (7163*Mgl**11.*Mt**6.)/1152.+

     &  (139*Mgl**13.*Mt**6.)/(576.*Mst2**2.)-

     &  (623*Mgl**9.*Mst2**2.*Mt**6.)/576.-

     &  (115*Mgl**7.*Mst2**4.*Mt**6.)/576.+

     &  (815*Mgl**5.*Mst2**6.*Mt**6.)/192.+

     &  (953*Mgl**3.*Mst2**8.*Mt**6.)/1152.+

     &  (1067*Mgl*Mst2**10.*Mt**6.)/576.+

     &  (3131*Mgl**9.*Mt**8.)/384.-

     &  (95*Mgl**11.*Mt**8.)/(288.*Mst2**2.)+

     &  (4531*Mgl**7.*Mst2**2.*Mt**8.)/576.+

     &  (421*Mgl**5.*Mst2**4.*Mt**8.)/96.+

     &  (259*Mgl**3.*Mst2**6.*Mt**8.)/576.-

     &  (277*Mgl*Mst2**8.*Mt**8.)/128.-

     &  (3913*Mgl**7.*Mt**10.)/576.+

     &  (215*Mgl**9.*Mt**10.)/(1152.*Mst2**2.)-

     &  (2983*Mgl**5.*Mst2**2.*Mt**10.)/288.-

     &  (3805*Mgl**3.*Mst2**4.*Mt**10.)/576.-

     &  (1399*Mgl*Mst2**6.*Mt**10.)/1152.+

     &  (2123*Mgl**5.*Mt**12.)/576.+

     &  (17*Mgl**7.*Mt**12.)/(288.*Mst2**2.)+

     &  (3493*Mgl**3.*Mst2**2.*Mt**12.)/576.+

     &  (211*Mgl*Mst2**4.*Mt**12.)/72.-

     &  (2885*Mgl**3.*Mt**14.)/2304.-

     &  (85*Mgl**5.*Mt**14.)/(576.*Mst2**2.)-

     &  (183*Mgl*Mst2**2.*Mt**14.)/128.+

     &  (479*Mgl*Mt**16.)/2304.+

     &  (23*Mgl**3.*Mt**16.)/(288.*Mst2**2.)-

     &  (35*Mgl*Mt**18.)/(2304.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mst2)**2.

     &  +(0.07855902777777778+

     &  (5*Mgl**2.)/(576.*Mst1**2.)-

     &  Mst1**2./(72.*Mgl**2.)+

     &  (5*Mgl**2.)/(576.*Mst2**2.)-

     &  Mst2**2./(72.*Mgl**2.)-

     &  (91*Mgl**2.)/(2304.*Mt**2.)+

     &  Mgl**4./(96.*Mst1**2.*Mt**2.)+

     &  Mst1**2./(32.*Mt**2.)+

     &  Mgl**4./(96.*Mst2**2.*Mt**2.)-

     &  (29*Mst2**2.)/(2304.*Mt**2.)+

     &  (5*Mt**2.)/(72.*Mgl**2.)+Mt**2./(192.*Mst1**2.)+

     &  (Mst1**2.*Mt**2.)/(96.*Mgl**4.)+

     &  Mt**2./(192.*Mst2**2.)+

     &  (Mst2**2.*Mt**2.)/(96.*Mgl**4.)-

     &  Mt**4./(24.*Mgl**4.)-

     &  Mt**4./(72.*Mgl**2.*Mst1**2.)-

     &  Mt**4./(72.*Mgl**2.*Mst2**2.)+

     &  Mt**6./(96.*Mgl**4.*Mst1**2.)+

     &  Mt**6./(96.*Mgl**4.*Mst2**2.))*ln(mu,Mt)+

     &  ((-7*Mgl**4.)/32.-(5*Mgl**8.)/(288.*Mst1**4.)+

     &  (13*Mgl**6.)/(432.*Mst1**2.)+

     &  (7*Mgl**2.*Mst1**2.)/48.+(7*Mst1**4.)/216.+

     &  Mst1**6./(36.*Mgl**2.)-Mgl**6./(16.*Mt**2.)+

     &  Mgl**8./(48.*Mst1**2.*Mt**2.)+

     &  (Mgl**4.*Mst1**2.)/(16.*Mt**2.)-

     &  (Mgl**2.*Mst1**4.)/(48.*Mt**2.)+

     &  (1255*Mgl**2.*Mt**2.)/3456.+

     &  (11*Mgl**6.*Mt**2.)/(384.*Mst1**4.)-

     &  (769*Mgl**4.*Mt**2.)/(6912.*Mst1**2.)-

     &  (1675*Mst1**2.*Mt**2.)/6912.-

     &  (25*Mst1**4.*Mt**2.)/(192.*Mgl**2.)-

     &  (7*Mst1**6.*Mt**2.)/(576.*Mgl**4.)+

     &  (77*Mt**4.)/216.+

     &  (Mgl**4.*Mt**4.)/(1152.*Mst1**4.)-

     &  (341*Mgl**2.*Mt**4.)/(864.*Mst1**2.)+

     &  (25*Mst1**2.*Mt**4.)/(192.*Mgl**2.)+

     &  (7*Mst1**4.*Mt**4.)/(144.*Mgl**4.)+

     &  Mt**6./(72.*Mgl**2.)-

     &  (3*Mgl**2.*Mt**6.)/(128.*Mst1**4.)-

     &  (935*Mt**6.)/(6912.*Mst1**2.)-

     &  (7*Mst1**2.*Mt**6.)/(96.*Mgl**4.)+

     &  (7*Mt**8.)/(144.*Mgl**4.)+

     &  (19*Mt**8.)/(1152.*Mst1**4.)-

     &  (7*Mt**8.)/(192.*Mgl**2.*Mst1**2.)-

     &  Mt**10./(192.*Mgl**2.*Mst1**4.)-

     &  (7*Mt**10.)/(576.*Mgl**4.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)*ln(mu,Mt)+

     &  ((65*Mgl**8.)/54.+Mgl**12./(288.*Mst1**4.)-

     &  (85*Mgl**10.)/(432.*Mst1**2.)-

     &  (89*Mgl**6.*Mst1**2.)/48.+

     &  (233*Mgl**4.*Mst1**4.)/864.+

     &  (125*Mgl**2.*Mst1**6.)/108.-(41*Mst1**8.)/72.-

     &  Mst1**10./(72.*Mgl**2.)+

     &  (19*Mgl**10.)/(72.*Mt**2.)-

     &  (13*Mgl**12.)/(288.*Mst1**2.*Mt**2.)-

     &  (185*Mgl**8.*Mst1**2.)/(288.*Mt**2.)+

     &  (5*Mgl**6.*Mst1**4.)/(6.*Mt**2.)-

     &  (175*Mgl**4.*Mst1**6.)/(288.*Mt**2.)+

     &  (17*Mgl**2.*Mst1**8.)/(72.*Mt**2.)-

     &  (11*Mst1**10.)/(288.*Mt**2.)-

     &  (5207*Mgl**6.*Mt**2.)/1728.-

     &  (55*Mgl**10.*Mt**2.)/(1152.*Mst1**4.)+

     &  (863*Mgl**8.*Mt**2.)/(768.*Mst1**2.)+

     &  (9023*Mgl**4.*Mst1**2.*Mt**2.)/3456.-

     &  (5749*Mgl**2.*Mst1**4.*Mt**2.)/3456.+

     &  (1973*Mst1**6.*Mt**2.)/2304.+

     &  (19*Mst1**8.*Mt**2.)/(144.*Mgl**2.)+

     &  (Mst1**10.*Mt**2.)/(576.*Mgl**4.)-

     &  (583*Mgl**4.*Mt**4.)/3456.+

     &  (9*Mgl**8.*Mt**4.)/(128.*Mst1**4.)-

     &  (185*Mgl**6.*Mt**4.)/(3456.*Mst1**2.)+

     &  (4201*Mgl**2.*Mst1**2.*Mt**4.)/3456.-

     &  (155*Mst1**4.*Mt**4.)/432.-

     &  (Mst1**6.*Mt**4.)/(4.*Mgl**2.)-

     &  (Mst1**8.*Mt**4.)/(96.*Mgl**4.)-

     &  (647*Mgl**2.*Mt**6.)/864.+

     &  (Mgl**6.*Mt**6.)/(64.*Mst1**4.)-

     &  (361*Mgl**4.*Mt**6.)/(288.*Mst1**2.)+

     &  (1969*Mst1**2.*Mt**6.)/1728.-

     &  (Mst1**4.*Mt**6.)/(36.*Mgl**2.)+

     &  (5*Mst1**6.*Mt**6.)/(192.*Mgl**4.)-

     &  (5419*Mt**8.)/3456.-

     &  (11*Mgl**4.*Mt**8.)/(192.*Mst1**4.)-

     &  (743*Mgl**2.*Mt**8.)/(3456.*Mst1**2.)+

     &  (11*Mst1**2.*Mt**8.)/(24.*Mgl**2.)-

     &  (5*Mst1**4.*Mt**8.)/(144.*Mgl**4.)-

     &  (19*Mt**10.)/(48.*Mgl**2.)+

     &  (7*Mgl**2.*Mt**10.)/(384.*Mst1**4.)+

     &  (1279*Mt**10.)/(2304.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**10.)/(192.*Mgl**4.)-

     &  Mt**12./(96.*Mgl**4.)-

     &  (19*Mt**12.)/(1152.*Mst1**4.)+

     &  Mt**12./(12.*Mgl**2.*Mst1**2.)+

     &  Mt**14./(72.*Mgl**2.*Mst1**4.)+

     &  Mt**14./(576.*Mgl**4.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mt)+

     &  ((-147*Mgl**12.)/64.+(17*Mgl**16.)/(288.*Mst1**4.)+

     &  (359*Mgl**14.)/(1728.*Mst1**2.)+

     &  (3173*Mgl**10.*Mst1**2.)/576.-

     &  (7765*Mgl**8.*Mst1**4.)/1728.-

     &  (1009*Mgl**6.*Mst1**6.)/576.+

     &  (1069*Mgl**4.*Mst1**8.)/192.-

     &  (6211*Mgl**2.*Mst1**10.)/1728.+

     &  (457*Mst1**12.)/576.-(5*Mgl**14.)/(48.*Mt**2.)+

     &  Mgl**16./(72.*Mst1**2.*Mt**2.)+

     &  (49*Mgl**12.*Mst1**2.)/(144.*Mt**2.)-

     &  (91*Mgl**10.*Mst1**4.)/(144.*Mt**2.)+

     &  (35*Mgl**8.*Mst1**6.)/(48.*Mt**2.)-

     &  (77*Mgl**6.*Mst1**8.)/(144.*Mt**2.)+

     &  (35*Mgl**4.*Mst1**10.)/(144.*Mt**2.)-

     &  (Mgl**2.*Mst1**12.)/(16.*Mt**2.)+

     &  Mst1**14./(144.*Mt**2.)+

     &  (2885*Mgl**10.*Mt**2.)/384.-

     &  (253*Mgl**14.*Mt**2.)/(1152.*Mst1**4.)-

     &  (11407*Mgl**12.*Mt**2.)/(6912.*Mst1**2.)-

     &  (76931*Mgl**8.*Mst1**2.*Mt**2.)/6912.+

     &  (34157*Mgl**6.*Mst1**4.*Mt**2.)/3456.-

     &  (19847*Mgl**4.*Mst1**6.*Mt**2.)/2304.+

     &  (20575*Mgl**2.*Mst1**8.*Mt**2.)/3456.-

     &  (3955*Mst1**10.*Mt**2.)/2304.-

     &  (11*Mst1**12.*Mt**2.)/(576.*Mgl**2.)-

     &  (7367*Mgl**8.*Mt**4.)/1728.+

     &  (331*Mgl**12.*Mt**4.)/(1152.*Mst1**4.)+

     &  (1967*Mgl**10.*Mt**4.)/(864.*Mst1**2.)+

     &  (5747*Mgl**6.*Mst1**2.*Mt**4.)/1728.+

     &  (10441*Mgl**4.*Mst1**4.*Mt**4.)/3456.-

     &  (2993*Mgl**2.*Mst1**6.*Mt**4.)/864.-

     &  (1069*Mst1**8.*Mt**4.)/864.+

     &  (31*Mst1**10.*Mt**4.)/(576.*Mgl**2.)+

     &  (331*Mgl**6.*Mt**6.)/1728.-

     &  (203*Mgl**10.*Mt**6.)/(1152.*Mst1**4.)+

     &  (8209*Mgl**8.*Mt**6.)/(6912.*Mst1**2.)+

     &  (5333*Mgl**4.*Mst1**2.*Mt**6.)/3456.+

     &  (5885*Mgl**2.*Mst1**4.*Mt**6.)/1152.+

     &  (1271*Mst1**6.*Mt**6.)/256.+

     &  (5*Mst1**8.*Mt**6.)/(72.*Mgl**2.)-

     &  (425*Mgl**4.*Mt**8.)/1728.+

     &  (25*Mgl**8.*Mt**8.)/(384.*Mst1**4.)-

     &  (781*Mgl**6.*Mt**8.)/(288.*Mst1**2.)-

     &  (1201*Mgl**2.*Mst1**2.*Mt**8.)/576.-

     &  (4739*Mst1**4.*Mt**8.)/3456.-

     &  (275*Mst1**6.*Mt**8.)/(576.*Mgl**2.)-

     &  (5513*Mgl**2.*Mt**10.)/1152.+

     &  (49*Mgl**6.*Mt**10.)/(384.*Mst1**4.)-

     &  (8029*Mgl**4.*Mt**10.)/(6912.*Mst1**2.)-

     &  (30079*Mst1**2.*Mt**10.)/6912.+

     &  (115*Mst1**4.*Mt**10.)/(144.*Mgl**2.)+

     &  (725*Mt**12.)/192.-

     &  (407*Mgl**4.*Mt**12.)/(1152.*Mst1**4.)+

     &  (191*Mgl**2.*Mt**12.)/(72.*Mst1**2.)-

     &  (359*Mst1**2.*Mt**12.)/(576.*Mgl**2.)+

     &  (31*Mt**14.)/(144.*Mgl**2.)+

     &  (319*Mgl**2.*Mt**14.)/(1152.*Mst1**4.)-

     &  (5573*Mt**14.)/(6912.*Mst1**2.)-

     &  (67*Mt**16.)/(1152.*Mst1**4.)-

     &  (5*Mt**16.)/(576.*Mgl**2.*Mst1**2.)-

     &  (5*Mt**18.)/(576.*Mgl**2.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.*ln(mu,Mt)+

     &  ((811*Mgl**16.)/864.-(13*Mgl**20.)/(288.*Mst1**4.)+

     &  (29*Mgl**18.)/(864.*Mst1**2.)-

     &  (1549*Mgl**14.*Mst1**2.)/432.+

     &  (1183*Mgl**12.*Mst1**4.)/216.-

     &  (161*Mgl**10.*Mst1**6.)/54.-

     &  (119*Mgl**8.*Mst1**8.)/54.+

     &  (1997*Mgl**6.*Mst1**10.)/432.-

     &  (2717*Mgl**4.*Mst1**12.)/864.+

     &  (883*Mgl**2.*Mst1**14.)/864.-

     &  (115*Mst1**16.)/864.-

     &  (6557*Mgl**14.*Mt**2.)/1728.+

     &  (307*Mgl**18.*Mt**2.)/(1152.*Mst1**4.)+

     &  (989*Mgl**16.*Mt**2.)/(6912.*Mst1**2.)+

     &  (16693*Mgl**12.*Mst1**2.*Mt**2.)/1728.-

     &  (12833*Mgl**10.*Mst1**4.*Mt**2.)/864.+

     &  (64199*Mgl**8.*Mst1**6.*Mt**2.)/3456.-

     &  (28631*Mgl**6.*Mst1**8.*Mt**2.)/1728.+

     &  (13757*Mgl**4.*Mst1**10.*Mt**2.)/1728.-

     &  (4141*Mgl**2.*Mst1**12.*Mt**2.)/3456.-

     &  (1331*Mst1**14.*Mt**2.)/6912.+

     &  (12383*Mgl**12.*Mt**4.)/3456.-

     &  (733*Mgl**16.*Mt**4.)/(1152.*Mst1**4.)-

     &  (51*Mgl**14.*Mt**4.)/(128.*Mst1**2.)-

     &  (30689*Mgl**10.*Mst1**2.*Mt**4.)/3456.+

     &  (3457*Mgl**8.*Mst1**4.*Mt**4.)/384.+

     &  (19525*Mgl**6.*Mst1**6.*Mt**4.)/3456.-

     &  (33619*Mgl**4.*Mst1**8.*Mt**4.)/3456.-

     &  (3137*Mgl**2.*Mst1**10.*Mt**4.)/1152.+

     &  (793*Mst1**12.*Mt**4.)/192.+

     &  (1957*Mgl**10.*Mt**6.)/864.+

     &  (227*Mgl**14.*Mt**6.)/(288.*Mst1**4.)-

     &  (5995*Mgl**12.*Mt**6.)/(3456.*Mst1**2.)+

     &  (12151*Mgl**8.*Mst1**2.*Mt**6.)/3456.+

     &  (2467*Mgl**6.*Mst1**4.*Mt**6.)/864.+

     &  (4745*Mgl**4.*Mst1**6.*Mt**6.)/1152.+

     &  (265*Mgl**2.*Mst1**8.*Mt**6.)/288.-

     &  (43991*Mst1**10.*Mt**6.)/3456.-

     &  (9271*Mgl**8.*Mt**8.)/3456.-

     &  (155*Mgl**12.*Mt**8.)/(288.*Mst1**4.)+

     &  (21659*Mgl**10.*Mt**8.)/(3456.*Mst1**2.)+

     &  (551*Mgl**6.*Mst1**2.*Mt**8.)/192.+

     &  (10343*Mgl**4.*Mst1**4.*Mt**8.)/1728.+

     &  (31319*Mgl**2.*Mst1**6.*Mt**8.)/3456.+

     &  (59645*Mst1**8.*Mt**8.)/3456.+

     &  (587*Mgl**6.*Mt**10.)/1728.+

     &  (61*Mgl**10.*Mt**10.)/(576.*Mst1**4.)-

     &  (11191*Mgl**8.*Mt**10.)/(1728.*Mst1**2.)-

     &  (125*Mgl**4.*Mst1**2.*Mt**10.)/48.-

     &  (1433*Mgl**2.*Mst1**4.*Mt**10.)/216.-

     &  (5605*Mst1**6.*Mt**10.)/576.-

     &  (19295*Mgl**4.*Mt**12.)/3456.+

     &  (229*Mgl**8.*Mt**12.)/(576.*Mst1**4.)+

     &  (1199*Mgl**6.*Mt**12.)/(1152.*Mst1**2.)-

     &  (20485*Mgl**2.*Mst1**2.*Mt**12.)/3456.-

     &  (5567*Mst1**4.*Mt**12.)/3456.+

     &  (1535*Mgl**2.*Mt**14.)/216.-

     &  (233*Mgl**6.*Mt**14.)/(288.*Mst1**4.)+

     &  (859*Mgl**4.*Mt**14.)/(384.*Mst1**2.)+

     &  (17111*Mst1**2.*Mt**14.)/3456.-

     &  (2503*Mt**16.)/1152.+

     &  (109*Mgl**4.*Mt**16.)/(144.*Mst1**4.)-

     &  (4411*Mgl**2.*Mt**16.)/(3456.*Mst1**2.)-

     &  (45*Mgl**2.*Mt**18.)/(128.*Mst1**4.)+

     &  (1135*Mt**18.)/(6912.*Mst1**2.)+

     &  (25*Mt**20.)/(384.*Mst1**4.))*d123(Mt,Mgl,Mst1)**4.*

     &  ln(mu,Mt)+((-223*Mgl**4.)/2304.-

     &  (5*Mgl**8.)/(288.*Mst2**4.)+

     &  Mgl**6./(27.*Mst2**2.)+

     &  (211*Mgl**2.*Mst2**2.)/1152.-

     &  (565*Mst2**4.)/6912.-

     &  (7*Mst2**6.)/(288.*Mgl**2.)-

     &  (113*Mgl**6.)/(2304.*Mt**2.)+

     &  Mgl**8./(48.*Mst2**2.*Mt**2.)+

     &  (13*Mgl**4.*Mst2**2.)/(768.*Mt**2.)+

     &  (9*Mgl**2.*Mst2**4.)/(256.*Mt**2.)-

     &  (67*Mst2**6.)/(2304.*Mt**2.)+

     &  Mst2**8./(192.*Mgl**2.*Mt**2.)+

     &  (2777*Mgl**2.*Mt**2.)/6912.+

     &  (11*Mgl**6.*Mt**2.)/(384.*Mst2**4.)-

     &  (829*Mgl**4.*Mt**2.)/(6912.*Mst2**2.)-

     &  (101*Mst2**2.*Mt**2.)/3456.-

     &  (Mst2**4.*Mt**2.)/(192.*Mgl**2.)-

     &  (7*Mst2**6.*Mt**2.)/(576.*Mgl**4.)+

     &  (1921*Mt**4.)/6912.+

     &  (Mgl**4.*Mt**4.)/(1152.*Mst2**4.)-

     &  (347*Mgl**2.*Mt**4.)/(864.*Mst2**2.)+

     &  (Mst2**2.*Mt**4.)/(64.*Mgl**2.)+

     &  (7*Mst2**4.*Mt**4.)/(144.*Mgl**4.)+

     &  (29*Mt**6.)/(576.*Mgl**2.)-

     &  (3*Mgl**2.*Mt**6.)/(128.*Mst2**4.)-

     &  (875*Mt**6.)/(6912.*Mst2**2.)-

     &  (7*Mst2**2.*Mt**6.)/(96.*Mgl**4.)+

     &  (7*Mt**8.)/(144.*Mgl**4.)+

     &  (19*Mt**8.)/(1152.*Mst2**4.)-

     &  (7*Mt**8.)/(192.*Mgl**2.*Mst2**2.)-

     &  Mt**10./(192.*Mgl**2.*Mst2**4.)-

     &  (7*Mt**10.)/(576.*Mgl**4.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)*ln(mu,Mt)+

     &  ((4105*Mgl**8.)/6912.+Mgl**12./(288.*Mst2**4.)-

     &  (91*Mgl**10.)/(432.*Mst2**2.)-

     &  (457*Mgl**6.*Mst2**2.)/576.+

     &  (2819*Mgl**4.*Mst2**4.)/3456.-

     &  (931*Mgl**2.*Mst2**6.)/1728.+(19*Mst2**8.)/256.+

     &  Mst2**10./(18.*Mgl**2.)+

     &  (431*Mgl**10.)/(2304.*Mt**2.)-

     &  (13*Mgl**12.)/(288.*Mst2**2.*Mt**2.)-

     &  (583*Mgl**8.*Mst2**2.)/(2304.*Mt**2.)+

     &  (5*Mgl**6.*Mst2**4.)/(128.*Mt**2.)+

     &  (245*Mgl**4.*Mst2**6.)/(1152.*Mt**2.)-

     &  (461*Mgl**2.*Mst2**8.)/(2304.*Mt**2.)+

     &  (149*Mst2**10.)/(2304.*Mt**2.)-

     &  Mst2**12./(192.*Mgl**2.*Mt**2.)-

     &  (7969*Mgl**6.*Mt**2.)/3456.-

     &  (55*Mgl**10.*Mt**2.)/(1152.*Mst2**4.)+

     &  (2693*Mgl**8.*Mt**2.)/(2304.*Mst2**2.)+

     &  (3157*Mgl**4.*Mst2**2.*Mt**2.)/1728.+

     &  (371*Mgl**2.*Mst2**4.*Mt**2.)/864.-

     &  (719*Mst2**6.*Mt**2.)/768.-

     &  (79*Mst2**8.*Mt**2.)/(576.*Mgl**2.)+

     &  (Mst2**10.*Mt**2.)/(576.*Mgl**4.)+

     &  (293*Mgl**4.*Mt**4.)/864.+

     &  (9*Mgl**8.*Mt**4.)/(128.*Mst2**4.)-

     &  (305*Mgl**6.*Mt**4.)/(3456.*Mst2**2.)+

     &  (4087*Mgl**2.*Mst2**2.*Mt**4.)/3456.+

     &  (2327*Mst2**4.*Mt**4.)/3456.+

     &  (17*Mst2**6.*Mt**4.)/(72.*Mgl**2.)-

     &  (Mst2**8.*Mt**4.)/(96.*Mgl**4.)-

     &  (6547*Mgl**2.*Mt**6.)/6912.+

     &  (Mgl**6.*Mt**6.)/(64.*Mst2**4.)-

     &  (41*Mgl**4.*Mt**6.)/(32.*Mst2**2.)+

     &  (9307*Mst2**2.*Mt**6.)/6912.-

     &  (281*Mst2**4.*Mt**6.)/(576.*Mgl**2.)+

     &  (5*Mst2**6.*Mt**6.)/(192.*Mgl**4.)-

     &  (12053*Mt**8.)/6912.-

     &  (11*Mgl**4.*Mt**8.)/(192.*Mst2**4.)-

     &  (575*Mgl**2.*Mt**8.)/(3456.*Mst2**2.)+

     &  (49*Mst2**2.*Mt**8.)/(72.*Mgl**2.)-

     &  (5*Mst2**4.*Mt**8.)/(144.*Mgl**4.)-

     &  (253*Mt**10.)/(576.*Mgl**2.)+

     &  (7*Mgl**2.*Mt**10.)/(384.*Mst2**4.)+

     &  (413*Mt**10.)/(768.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**10.)/(192.*Mgl**4.)-

     &  Mt**12./(96.*Mgl**4.)-

     &  (19*Mt**12.)/(1152.*Mst2**4.)+

     &  Mt**12./(12.*Mgl**2.*Mst2**2.)+

     &  Mt**14./(72.*Mgl**2.*Mst2**4.)+

     &  Mt**14./(576.*Mgl**4.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mt)+

     &  ((-3277*Mgl**12.)/2304.+

     &  (17*Mgl**16.)/(288.*Mst2**4.)+

     &  (371*Mgl**14.)/(1728.*Mst2**2.)+

     &  (2345*Mgl**10.*Mst2**2.)/1152.-

     &  (3337*Mgl**8.*Mst2**4.)/6912.-

     &  (29*Mgl**6.*Mst2**6.)/36.+

     &  (317*Mgl**4.*Mst2**8.)/2304.+

     &  (1543*Mgl**2.*Mst2**10.)/3456.-

     &  (45*Mst2**12.)/256.-Mst2**14./(144.*Mgl**2.)-

     &  (65*Mgl**14.)/(768.*Mt**2.)+

     &  Mgl**16./(72.*Mst2**2.*Mt**2.)+

     &  (469*Mgl**12.*Mst2**2.)/(2304.*Mt**2.)-

     &  (511*Mgl**10.*Mst2**4.)/(2304.*Mt**2.)+

     &  (35*Mgl**8.*Mst2**6.)/(768.*Mt**2.)+

     &  (343*Mgl**6.*Mst2**8.)/(2304.*Mt**2.)-

     &  (385*Mgl**4.*Mst2**10.)/(2304.*Mt**2.)+

     &  (19*Mgl**2.*Mst2**12.)/(256.*Mt**2.)-

     &  (29*Mst2**14.)/(2304.*Mt**2.)+

     &  (3929*Mgl**10.*Mt**2.)/768.-

     &  (253*Mgl**14.*Mt**2.)/(1152.*Mst2**4.)-

     &  (11659*Mgl**12.*Mt**2.)/(6912.*Mst2**2.)-

     &  (18409*Mgl**8.*Mst2**2.*Mt**2.)/3456.+

     &  (1525*Mgl**6.*Mst2**4.*Mt**2.)/432.+

     &  (73*Mgl**4.*Mst2**6.*Mt**2.)/768.-

     &  (23263*Mgl**2.*Mst2**8.*Mt**2.)/6912.+

     &  (117*Mst2**10.*Mt**2.)/64.+

     &  (17*Mst2**12.*Mt**2.)/(576.*Mgl**2.)-

     &  (20663*Mgl**8.*Mt**4.)/6912.+

     &  (331*Mgl**12.*Mt**4.)/(1152.*Mst2**4.)+

     &  (2027*Mgl**10.*Mt**4.)/(864.*Mst2**2.)+

     &  (667*Mgl**6.*Mst2**2.*Mt**4.)/864.+

     &  (Mgl**4.*Mst2**4.*Mt**4.)/216.+

     &  (7037*Mgl**2.*Mst2**6.*Mt**4.)/1728.-

     &  (30419*Mst2**8.*Mt**4.)/6912.-

     &  (53*Mst2**10.*Mt**4.)/(576.*Mgl**2.)+

     &  (6265*Mgl**6.*Mt**6.)/6912.-

     &  (203*Mgl**10.*Mt**6.)/(1152.*Mst2**4.)+

     &  (7909*Mgl**8.*Mt**6.)/(6912.*Mst2**2.)-

     &  (197*Mgl**4.*Mst2**2.*Mt**6.)/6912.-

     &  (835*Mgl**2.*Mst2**4.*Mt**6.)/768.+

     &  (1295*Mst2**6.*Mt**6.)/576.+

     &  (5*Mst2**8.*Mt**6.)/(16.*Mgl**2.)+

     &  (3547*Mgl**4.*Mt**8.)/6912.+

     &  (25*Mgl**8.*Mt**8.)/(384.*Mst2**4.)-

     &  (791*Mgl**6.*Mt**8.)/(288.*Mst2**2.)+

     &  (4501*Mgl**2.*Mst2**2.*Mt**8.)/1152.+

     &  (36305*Mst2**4.*Mt**8.)/6912.-

     &  (415*Mst2**6.*Mt**8.)/(576.*Mgl**2.)-

     &  (15979*Mgl**2.*Mt**10.)/2304.+

     &  (49*Mgl**6.*Mt**10.)/(384.*Mst2**4.)-

     &  (7537*Mgl**4.*Mt**10.)/(6912.*Mst2**2.)-

     &  (3697*Mst2**2.*Mt**10.)/432.+

     &  (17*Mst2**4.*Mt**10.)/(18.*Mgl**2.)+

     &  (10769*Mt**12.)/2304.-

     &  (407*Mgl**4.*Mt**12.)/(1152.*Mst2**4.)+

     &  (47*Mgl**2.*Mt**12.)/(18.*Mst2**2.)-

     &  (43*Mst2**2.*Mt**12.)/(64.*Mgl**2.)+

     &  (2*Mt**14.)/(9.*Mgl**2.)+

     &  (319*Mgl**2.*Mt**14.)/(1152.*Mst2**4.)-

     &  (5513*Mt**14.)/(6912.*Mst2**2.)-

     &  (67*Mt**16.)/(1152.*Mst2**4.)-

     &  (5*Mt**16.)/(576.*Mgl**2.*Mst2**2.)-

     &  (5*Mt**18.)/(576.*Mgl**2.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.*ln(mu,Mt)+

     &  ((637*Mgl**16.)/864.-(13*Mgl**20.)/(288.*Mst2**4.)+

     &  (29*Mgl**18.)/(864.*Mst2**2.)-

     &  (1021*Mgl**14.*Mst2**2.)/432.+

     &  (553*Mgl**12.*Mst2**4.)/216.+

     &  (7*Mgl**10.*Mst2**6.)/54.-

     &  (581*Mgl**8.*Mst2**8.)/216.+

     &  (989*Mgl**6.*Mst2**10.)/432.-

     &  (533*Mgl**4.*Mst2**12.)/864.-

     &  (77*Mgl**2.*Mst2**14.)/864.+(47*Mst2**16.)/864.-

     &  (5645*Mgl**14.*Mt**2.)/1728.+

     &  (307*Mgl**18.*Mt**2.)/(1152.*Mst2**4.)+

     &  (989*Mgl**16.*Mt**2.)/(6912.*Mst2**2.)+

     &  (11173*Mgl**12.*Mst2**2.*Mt**2.)/1728.-

     &  (5333*Mgl**10.*Mst2**4.*Mt**2.)/864.+

     &  (15959*Mgl**8.*Mst2**6.*Mt**2.)/3456.-

     &  (3671*Mgl**6.*Mst2**8.*Mt**2.)/1728.-

     &  (2755*Mgl**4.*Mst2**10.*Mt**2.)/1728.+

     &  (8579*Mgl**2.*Mst2**12.*Mt**2.)/3456.-

     &  (5651*Mst2**14.*Mt**2.)/6912.+

     &  (14303*Mgl**12.*Mt**4.)/3456.-

     &  (733*Mgl**16.*Mt**4.)/(1152.*Mst2**4.)-

     &  (51*Mgl**14.*Mt**4.)/(128.*Mst2**2.)-

     &  (18689*Mgl**10.*Mst2**2.*Mt**4.)/3456.+

     &  (3155*Mgl**8.*Mst2**4.*Mt**4.)/1152.-

     &  (4139*Mgl**6.*Mst2**6.*Mt**4.)/3456.+

     &  (18461*Mgl**4.*Mst2**8.*Mt**4.)/3456.-

     &  (9169*Mgl**2.*Mst2**10.*Mt**4.)/1152.+

     &  (649*Mst2**12.*Mt**4.)/192.-

     &  (899*Mgl**10.*Mt**6.)/864.+

     &  (227*Mgl**14.*Mt**6.)/(288.*Mst2**4.)-

     &  (5995*Mgl**12.*Mt**6.)/(3456.*Mst2**2.)+

     &  (4279*Mgl**8.*Mst2**2.*Mt**6.)/3456.-

     &  (29*Mgl**6.*Mst2**4.*Mt**6.)/864.-

     &  (3815*Mgl**4.*Mst2**6.*Mt**6.)/1152.+

     &  (931*Mgl**2.*Mst2**8.*Mt**6.)/96.-

     &  (19367*Mst2**10.*Mt**6.)/3456.+

     &  (3161*Mgl**8.*Mt**8.)/3456.-

     &  (155*Mgl**12.*Mt**8.)/(288.*Mst2**4.)+

     &  (21659*Mgl**10.*Mt**8.)/(3456.*Mst2**2.)+

     &  (77*Mgl**6.*Mst2**2.*Mt**8.)/576.-

     &  (3745*Mgl**4.*Mst2**4.*Mt**8.)/1728.-

     &  (29065*Mgl**2.*Mst2**6.*Mt**8.)/3456.+

     &  (5645*Mst2**8.*Mt**8.)/3456.+

     &  (1211*Mgl**6.*Mt**10.)/1728.+

     &  (61*Mgl**10.*Mt**10.)/(576.*Mst2**4.)-

     &  (11191*Mgl**8.*Mt**10.)/(1728.*Mst2**2.)+

     &  (1199*Mgl**4.*Mst2**2.*Mt**10.)/144.+

     &  (1469*Mgl**2.*Mst2**4.*Mt**10.)/108.+

     &  (4547*Mst2**6.*Mt**10.)/576.-

     &  (31007*Mgl**4.*Mt**12.)/3456.+

     &  (229*Mgl**8.*Mt**12.)/(576.*Mst2**4.)+

     &  (1199*Mgl**6.*Mt**12.)/(1152.*Mst2**2.)-

     &  (59509*Mgl**2.*Mst2**2.*Mt**12.)/3456.-

     &  (44447*Mst2**4.*Mt**12.)/3456.+

     &  (2057*Mgl**2.*Mt**14.)/216.-

     &  (233*Mgl**6.*Mt**14.)/(288.*Mst2**4.)+

     &  (859*Mgl**4.*Mt**14.)/(384.*Mst2**2.)+

     &  (30503*Mst2**2.*Mt**14.)/3456.-

     &  (3151*Mt**16.)/1152.+

     &  (109*Mgl**4.*Mt**16.)/(144.*Mst2**4.)-

     &  (4411*Mgl**2.*Mt**16.)/(3456.*Mst2**2.)-

     &  (45*Mgl**2.*Mt**18.)/(128.*Mst2**4.)+

     &  (1135*Mt**18.)/(6912.*Mst2**2.)+

     &  (25*Mt**20.)/(384.*Mst2**4.))*d123(Mt,Mgl,Mst2)**4.*

     &  ln(mu,Mt)+((25*Mgl)/576.-Mgl**3./(48.*Mst1**2.)+

     &  Mgl**3./(48.*Mst2**2.)-

     &  (Mgl*Mt**2.)/(48.*Mst1**2.)+

     &  (Mgl*Mt**2.)/(48.*Mst2**2.)+

     &  Mt**4./(36.*Mgl**1.*Mst1**2.)-

     &  Mt**4./(36.*Mgl**1.*Mst2**2.)-

     &  Mt**6./(36.*Mgl**3.*Mst1**2.)+

     &  Mt**6./(36.*Mgl**3.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mt)+((5*Mgl**5.)/24.-

     &  Mgl**7./(24.*Mst1**2.)-(7*Mgl**3.*Mst1**2.)/24.+

     &  (Mgl*Mst1**4.)/8.+(239*Mgl**3.*Mt**2.)/432.+

     &  (5*Mgl**7.*Mt**2.)/(72.*Mst1**4.)-

     &  (85*Mgl**5.*Mt**2.)/(432.*Mst1**2.)-

     &  (29*Mgl*Mst1**2.*Mt**2.)/216.+

     &  (Mst1**4.*Mt**2.)/(12.*Mgl**1.)-

     &  (2315*Mgl*Mt**4.)/1728.-

     &  (53*Mgl**5.*Mt**4.)/(288.*Mst1**4.)+

     &  (1487*Mgl**3.*Mt**4.)/(1728.*Mst1**2.)-

     &  (7*Mst1**2.*Mt**4.)/(36.*Mgl**1.)-

     &  (5*Mst1**4.*Mt**4.)/(144.*Mgl**3.)-

     &  Mt**6./(18.*Mgl**1.)+

     &  (13*Mgl**3.*Mt**6.)/(72.*Mst1**4.)+

     &  (821*Mgl*Mt**6.)/(1728.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**6.)/(48.*Mgl**3.)-

     &  (5*Mt**8.)/(48.*Mgl**3.)-

     &  (25*Mgl*Mt**8.)/(288.*Mst1**4.)+

     &  (7*Mt**8.)/(48.*Mgl**1.*Mst1**2.)+

     &  Mt**10./(48.*Mgl**1.*Mst1**4.)+

     &  (5*Mt**10.)/(144.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((-91*Mgl**9.)/144.+(17*Mgl**11.)/(144.*Mst1**2.)+

     &  (97*Mgl**7.*Mst1**2.)/72.-

     &  (103*Mgl**5.*Mst1**4.)/72.+

     &  (109*Mgl**3.*Mst1**6.)/144.-

     &  (23*Mgl*Mst1**8.)/144.-(269*Mgl**7.*Mt**2.)/72.-

     &  (Mgl**11.*Mt**2.)/(72.*Mst1**4.)+

     &  (271*Mgl**9.*Mt**2.)/(432.*Mst1**2.)+

     &  (17*Mgl**5.*Mst1**2.*Mt**2.)/4.+

     &  (23*Mgl**3.*Mst1**4.*Mt**2.)/108.-

     &  (185*Mgl*Mst1**6.*Mt**2.)/144.-

     &  (Mst1**8.*Mt**2.)/(18.*Mgl**1.)+

     &  (17311*Mgl**5.*Mt**4.)/1728.+

     &  (59*Mgl**9.*Mt**4.)/(288.*Mst1**4.)-

     &  (7309*Mgl**7.*Mt**4.)/(1728.*Mst1**2.)-

     &  (2629*Mgl**3.*Mst1**2.*Mt**4.)/576.+

     &  (1025*Mgl*Mst1**4.*Mt**4.)/576.+

     &  (49*Mst1**6.*Mt**4.)/(144.*Mgl**1.)+

     &  (Mst1**8.*Mt**4.)/(144.*Mgl**3.)-

     &  (775*Mgl**3.*Mt**6.)/288.-

     &  (35*Mgl**7.*Mt**6.)/(72.*Mst1**4.)+

     &  (4847*Mgl**5.*Mt**6.)/(1728.*Mst1**2.)-

     &  (5405*Mgl*Mst1**2.*Mt**6.)/1728.-

     &  (5*Mst1**4.*Mt**6.)/(24.*Mgl**1.)-

     &  (5*Mst1**6.*Mt**6.)/(144.*Mgl**3.)+

     &  (8267*Mgl*Mt**8.)/1728.+

     &  (61*Mgl**5.*Mt**8.)/(144.*Mst1**4.)+

     &  (5377*Mgl**3.*Mt**8.)/(1728.*Mst1**2.)-

     &  (29*Mst1**2.*Mt**8.)/(36.*Mgl**1.)+

     &  (5*Mst1**4.*Mt**8.)/(72.*Mgl**3.)+

     &  (79*Mt**10.)/(72.*Mgl**1.)-

     &  (7*Mgl**3.*Mt**10.)/(36.*Mst1**4.)-

     &  (1217*Mgl*Mt**10.)/(576.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**10.)/(72.*Mgl**3.)+

     &  (5*Mt**12.)/(144.*Mgl**3.)+

     &  (35*Mgl*Mt**12.)/(288.*Mst1**4.)-

     &  (5*Mt**12.)/(16.*Mgl**1.*Mst1**2.)-

     &  Mt**14./(18.*Mgl**1.*Mst1**4.)-

     &  Mt**14./(144.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((13*Mgl**13.)/36.-Mgl**15./(18.*Mst1**2.)-

     &  1.*Mgl**11.*Mst1**2.+(55*Mgl**9.*Mst1**4.)/36.-

     &  (25*Mgl**7.*Mst1**6.)/18.+

     &  (3*Mgl**5.*Mst1**8.)/4.-

     &  (2*Mgl**3.*Mst1**10.)/9.+(Mgl*Mst1**12.)/36.+

     &  (2965*Mgl**11.*Mt**2.)/432.-

     &  (17*Mgl**15.*Mt**2.)/(72.*Mst1**4.)-

     &  (269*Mgl**13.*Mt**2.)/(432.*Mst1**2.)-

     &  (3025*Mgl**9.*Mst1**2.*Mt**2.)/216.+

     &  (875*Mgl**7.*Mst1**4.*Mt**2.)/108.+

     &  (2327*Mgl**5.*Mst1**6.*Mt**2.)/432.-

     &  (3451*Mgl**3.*Mst1**8.*Mt**2.)/432.+

     &  (5*Mgl*Mst1**10.*Mt**2.)/2.-

     &  (43033*Mgl**9.*Mt**4.)/1728.+

     &  (107*Mgl**13.*Mt**4.)/(96.*Mst1**4.)+

     &  (3383*Mgl**11.*Mt**4.)/(576.*Mst1**2.)+

     &  (2851*Mgl**7.*Mst1**2.*Mt**4.)/96.-

     &  (2495*Mgl**5.*Mst1**4.*Mt**4.)/144.+

     &  (15625*Mgl**3.*Mst1**6.*Mt**4.)/1728.-

     &  (219*Mgl*Mst1**8.*Mt**4.)/64.-

     &  (11*Mst1**10.*Mt**4.)/(144.*Mgl**1.)+

     &  (8495*Mgl**7.*Mt**6.)/432.-

     &  (163*Mgl**11.*Mt**6.)/(72.*Mst1**4.)-

     &  (18349*Mgl**9.*Mt**6.)/(1728.*Mst1**2.)-

     &  (561*Mgl**5.*Mst1**2.*Mt**6.)/32.-

     &  (5195*Mgl**3.*Mst1**4.*Mt**6.)/432.-

     &  (7349*Mgl*Mst1**6.*Mt**6.)/1728.+

     &  (5*Mst1**8.*Mt**6.)/(36.*Mgl**1.)-

     &  (887*Mgl**5.*Mt**8.)/96.+

     &  (95*Mgl**9.*Mt**8.)/(32.*Mst1**4.)-

     &  (265*Mgl**7.*Mt**8.)/(288.*Mst1**2.)+

     &  (5875*Mgl**3.*Mst1**2.*Mt**8.)/864.+

     &  (1753*Mgl*Mst1**4.*Mt**8.)/432.+

     &  (5*Mst1**6.*Mt**8.)/(12.*Mgl**1.)+

     &  (2123*Mgl**3.*Mt**10.)/108.-

     &  (155*Mgl**7.*Mt**10.)/(48.*Mst1**4.)+

     &  (1633*Mgl**5.*Mt**10.)/(96.*Mst1**2.)+

     &  (297*Mgl*Mst1**2.*Mt**10.)/32.-

     &  (215*Mst1**4.*Mt**10.)/(144.*Mgl**1.)-

     &  (20065*Mgl*Mt**12.)/1728.+

     &  (87*Mgl**5.*Mt**12.)/(32.*Mst1**4.)-

     &  (24119*Mgl**3.*Mt**12.)/(1728.*Mst1**2.)+

     &  (245*Mst1**2.*Mt**12.)/(144.*Mgl**1.)-

     &  (19*Mt**14.)/(24.*Mgl**1.)-

     &  (47*Mgl**3.*Mt**14.)/(36.*Mst1**4.)+

     &  (5567*Mgl*Mt**14.)/(1728.*Mst1**2.)+

     &  (19*Mgl*Mt**16.)/(96.*Mst1**4.)+

     &  (5*Mt**16.)/(72.*Mgl**1.*Mst1**2.)+

     &  (5*Mt**18.)/(144.*Mgl**1.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((-89*Mgl**15.*Mt**2.)/24.+

     &  (13*Mgl**19.*Mt**2.)/(72.*Mst1**4.)+

     &  (5*Mgl**17.*Mt**2.)/(108.*Mst1**2.)+

     &  (2297*Mgl**13.*Mst1**2.*Mt**2.)/216.-

     &  (2435*Mgl**11.*Mst1**4.*Mt**2.)/216.+

     &  (47*Mgl**9.*Mst1**6.*Mt**2.)/72.+

     &  (2045*Mgl**7.*Mst1**8.*Mt**2.)/216.-

     &  (1949*Mgl**5.*Mst1**10.*Mt**2.)/216.+

     &  (32*Mgl**3.*Mst1**12.*Mt**2.)/9.-

     &  (115*Mgl*Mst1**14.*Mt**2.)/216.+

     &  (29413*Mgl**13.*Mt**4.)/1728.-

     &  (359*Mgl**17.*Mt**4.)/(288.*Mst1**4.)-

     &  (3223*Mgl**15.*Mt**4.)/(1728.*Mst1**2.)-

     &  (55735*Mgl**11.*Mst1**2.*Mt**4.)/1728.+

     &  (66409*Mgl**9.*Mst1**4.*Mt**4.)/1728.-

     &  (7013*Mgl**7.*Mst1**6.*Mt**4.)/192.+

     &  (35047*Mgl**5.*Mst1**8.*Mt**4.)/1728.-

     &  (1463*Mgl**3.*Mst1**10.*Mt**4.)/576.-

     &  (2251*Mgl*Mst1**12.*Mt**4.)/1728.-

     &  (20825*Mgl**11.*Mt**6.)/864.+

     &  (91*Mgl**15.*Mt**6.)/(24.*Mst1**4.)+

     &  (12529*Mgl**13.*Mt**6.)/(1728.*Mst1**2.)+

     &  (75463*Mgl**9.*Mst1**2.*Mt**6.)/1728.-

     &  (1477*Mgl**7.*Mst1**4.*Mt**6.)/48.-

     &  (29105*Mgl**5.*Mst1**6.*Mt**6.)/1728.+

     &  (1543*Mgl**3.*Mst1**8.*Mt**6.)/864.+

     &  (26297*Mgl*Mst1**10.*Mt**6.)/1728.+

     &  (1495*Mgl**9.*Mt**8.)/192.-

     &  (125*Mgl**13.*Mt**8.)/(18.*Mst1**4.)-

     &  (12539*Mgl**11.*Mt**8.)/(1728.*Mst1**2.)-

     &  (4795*Mgl**7.*Mst1**2.*Mt**8.)/96.-

     &  (26437*Mgl**5.*Mst1**4.*Mt**8.)/864.-

     &  (17413*Mgl**3.*Mst1**6.*Mt**8.)/576.-

     &  (61685*Mgl*Mst1**8.*Mt**8.)/1728.-

     &  (277*Mgl**7.*Mt**10.)/48.+

     &  (655*Mgl**11.*Mt**10.)/(72.*Mst1**4.)-

     &  (15059*Mgl**9.*Mt**10.)/(1728.*Mst1**2.)+

     &  (3139*Mgl**5.*Mst1**2.*Mt**10.)/96.+

     &  (1889*Mgl**3.*Mst1**4.*Mt**10.)/48.+

     &  (57605*Mgl*Mst1**6.*Mt**10.)/1728.+

     &  (50995*Mgl**5.*Mt**12.)/1728.-

     &  (457*Mgl**9.*Mt**12.)/(48.*Mst1**4.)+

     &  (4819*Mgl**7.*Mt**12.)/(192.*Mst1**2.)+

     &  (12493*Mgl**3.*Mst1**2.*Mt**12.)/1728.-

     &  (9655*Mgl*Mst1**4.*Mt**12.)/1728.-

     &  (2737*Mgl**3.*Mt**14.)/96.+

     &  (571*Mgl**7.*Mt**14.)/(72.*Mst1**4.)-

     &  (12287*Mgl**5.*Mt**14.)/(576.*Mst1**2.)-

     &  (20789*Mgl*Mst1**2.*Mt**14.)/1728.+

     &  (13433*Mgl*Mt**16.)/1728.-

     &  (169*Mgl**5.*Mt**16.)/(36.*Mst1**4.)+

     &  (4429*Mgl**3.*Mt**16.)/(576.*Mst1**2.)+

     &  (5*Mgl**3.*Mt**18.)/(3.*Mst1**4.)-

     &  (1585*Mgl*Mt**18.)/(1728.*Mst1**2.)-

     &  (25*Mgl*Mt**20.)/(96.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((-49*Mgl**5.)/576.+Mgl**7./(24.*Mst2**2.)+

     &  (7*Mgl**3.*Mst2**2.)/288.+

     &  (23*Mgl*Mst2**4.)/576.-Mst2**6./(48.*Mgl**1.)-

     &  (271*Mgl**3.*Mt**2.)/864.-

     &  (5*Mgl**7.*Mt**2.)/(72.*Mst2**4.)+

     &  (97*Mgl**5.*Mt**2.)/(432.*Mst2**2.)+

     &  (431*Mgl*Mst2**2.*Mt**2.)/864.+

     &  (Mst2**4.*Mt**2.)/(16.*Mgl**1.)+

     &  (395*Mgl*Mt**4.)/432.+

     &  (53*Mgl**5.*Mt**4.)/(288.*Mst2**4.)-

     &  (1595*Mgl**3.*Mt**4.)/(1728.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**4.)/(144.*Mgl**1.)+

     &  (5*Mst2**4.*Mt**4.)/(144.*Mgl**3.)+

     &  (23*Mt**6.)/(144.*Mgl**1.)-

     &  (13*Mgl**3.*Mt**6.)/(72.*Mst2**4.)-

     &  (761*Mgl*Mt**6.)/(1728.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**6.)/(48.*Mgl**3.)+

     &  (5*Mt**8.)/(48.*Mgl**3.)+

     &  (25*Mgl*Mt**8.)/(288.*Mst2**4.)-

     &  (7*Mt**8.)/(48.*Mgl**1.*Mst2**2.)-

     &  Mt**10./(48.*Mgl**1.*Mst2**4.)-

     &  (5*Mt**10.)/(144.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((223*Mgl**9.)/576.-(17*Mgl**11.)/(144.*Mst2**2.)-

     &  (25*Mgl**7.*Mst2**2.)/72.-

     &  (35*Mgl**5.*Mst2**4.)/288.+

     &  (25*Mgl**3.*Mst2**6.)/72.-

     &  (97*Mgl*Mst2**8.)/576.+Mst2**10./(48.*Mgl**1.)+

     &  (161*Mgl**7.*Mt**2.)/144.+

     &  (Mgl**11.*Mt**2.)/(72.*Mst2**4.)-

     &  (295*Mgl**9.*Mt**2.)/(432.*Mst2**2.)-

     &  (17*Mgl**5.*Mst2**2.*Mt**2.)/12.+

     &  (107*Mgl**3.*Mst2**4.*Mt**2.)/54.-

     &  (41*Mgl*Mst2**6.*Mt**2.)/48.-

     &  (23*Mst2**8.*Mt**2.)/(144.*Mgl**1.)-

     &  (7777*Mgl**5.*Mt**4.)/1728.-

     &  (59*Mgl**9.*Mt**4.)/(288.*Mst2**4.)+

     &  (7717*Mgl**7.*Mt**4.)/(1728.*Mst2**2.)+

     &  (1273*Mgl**3.*Mst2**2.*Mt**4.)/576.+

     &  (929*Mgl*Mst2**4.*Mt**4.)/576.+

     &  (5*Mst2**6.*Mt**4.)/(16.*Mgl**1.)-

     &  (Mst2**8.*Mt**4.)/(144.*Mgl**3.)+

     &  (163*Mgl**3.*Mt**6.)/288.+

     &  (35*Mgl**7.*Mt**6.)/(72.*Mst2**4.)-

     &  (5495*Mgl**5.*Mt**6.)/(1728.*Mst2**2.)+

     &  (4229*Mgl*Mst2**2.*Mt**6.)/1728.-

     &  (2*Mst2**4.*Mt**6.)/(3.*Mgl**1.)+

     &  (5*Mst2**6.*Mt**6.)/(144.*Mgl**3.)-

     &  (4285*Mgl*Mt**8.)/864.-

     &  (61*Mgl**5.*Mt**8.)/(144.*Mst2**4.)-

     &  (4921*Mgl**3.*Mt**8.)/(1728.*Mst2**2.)+

     &  (65*Mst2**2.*Mt**8.)/(48.*Mgl**1.)-

     &  (5*Mst2**4.*Mt**8.)/(72.*Mgl**3.)-

     &  (59*Mt**10.)/(48.*Mgl**1.)+

     &  (7*Mgl**3.*Mt**10.)/(36.*Mst2**4.)+

     &  (1177*Mgl*Mt**10.)/(576.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**10.)/(72.*Mgl**3.)-

     &  (5*Mt**12.)/(144.*Mgl**3.)-

     &  (35*Mgl*Mt**12.)/(288.*Mst2**4.)+

     &  (5*Mt**12.)/(16.*Mgl**1.*Mst2**2.)+

     &  Mt**14./(18.*Mgl**1.*Mst2**4.)+

     &  Mt**14./(144.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((-163*Mgl**13.)/576.+Mgl**15./(18.*Mst2**2.)+

     &  (17*Mgl**11.*Mst2**2.)/32.-

     &  (205*Mgl**9.*Mst2**4.)/576.-

     &  (25*Mgl**7.*Mst2**6.)/144.+

     &  (27*Mgl**5.*Mst2**8.)/64.-

     &  (71*Mgl**3.*Mst2**10.)/288.+

     &  (29*Mgl*Mst2**12.)/576.-

     &  (2951*Mgl**11.*Mt**2.)/864.+

     &  (17*Mgl**15.*Mt**2.)/(72.*Mst2**4.)+

     &  (281*Mgl**13.*Mt**2.)/(432.*Mst2**2.)+

     &  (2689*Mgl**9.*Mst2**2.*Mt**2.)/864.+

     &  (199*Mgl**7.*Mst2**4.*Mt**2.)/432.-

     &  (139*Mgl**5.*Mst2**6.*Mt**2.)/216.-

     &  (859*Mgl**3.*Mst2**8.*Mt**2.)/864.+

     &  (163*Mgl*Mst2**10.*Mt**2.)/288.+

     &  (Mst2**12.*Mt**2.)/(36.*Mgl**1.)+

     &  (11303*Mgl**9.*Mt**4.)/864.-

     &  (107*Mgl**13.*Mt**4.)/(96.*Mst2**4.)-

     &  (387*Mgl**11.*Mt**4.)/(64.*Mst2**2.)-

     &  (2359*Mgl**7.*Mst2**2.*Mt**4.)/288.+

     &  (647*Mgl**5.*Mst2**4.*Mt**4.)/288.+

     &  (7919*Mgl**3.*Mst2**6.*Mt**4.)/1728.-

     &  (143*Mgl*Mst2**8.*Mt**4.)/32.-

     &  (13*Mst2**10.*Mt**4.)/(144.*Mgl**1.)-

     &  (917*Mgl**7.*Mt**6.)/108.+

     &  (163*Mgl**11.*Mt**6.)/(72.*Mst2**4.)+

     &  (19129*Mgl**9.*Mt**6.)/(1728.*Mst2**2.)-

     &  (293*Mgl**5.*Mst2**2.*Mt**6.)/288.-

     &  (343*Mgl**3.*Mst2**4.*Mt**6.)/108.+

     &  (9821*Mgl*Mst2**6.*Mt**6.)/1728.+

     &  (5*Mst2**8.*Mt**6.)/(18.*Mgl**1.)+

     &  (6445*Mgl**5.*Mt**8.)/576.-

     &  (95*Mgl**9.*Mt**8.)/(32.*Mst2**4.)+

     &  (85*Mgl**7.*Mt**8.)/(288.*Mst2**2.)+

     &  (2645*Mgl**3.*Mst2**2.*Mt**8.)/216.+

     &  (12317*Mgl*Mst2**4.*Mt**8.)/1728.-

     &  (35*Mst2**6.*Mt**8.)/(36.*Mgl**1.)-

     &  (23737*Mgl**3.*Mt**10.)/864.+

     &  (155*Mgl**7.*Mt**10.)/(48.*Mst2**4.)-

     &  (4759*Mgl**5.*Mt**10.)/(288.*Mst2**2.)-

     &  (967*Mgl*Mst2**2.*Mt**10.)/48.+

     &  (275*Mst2**4.*Mt**10.)/(144.*Mgl**1.)+

     &  (6295*Mgl*Mt**12.)/432.-

     &  (87*Mgl**5.*Mt**12.)/(32.*Mst2**4.)+

     &  (23771*Mgl**3.*Mt**12.)/(1728.*Mst2**2.)-

     &  (269*Mst2**2.*Mt**12.)/(144.*Mgl**1.)+

     &  (59*Mt**14.)/(72.*Mgl**1.)+

     &  (47*Mgl**3.*Mt**14.)/(36.*Mst2**4.)-

     &  (5507*Mgl*Mt**14.)/(1728.*Mst2**2.)-

     &  (19*Mgl*Mt**16.)/(96.*Mst2**4.)-

     &  (5*Mt**16.)/(72.*Mgl**1.*Mst2**2.)-

     &  (5*Mt**18.)/(144.*Mgl**1.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((209*Mgl**15.*Mt**2.)/72.-

     &  (13*Mgl**19.*Mt**2.)/(72.*Mst2**4.)-

     &  (5*Mgl**17.*Mt**2.)/(108.*Mst2**2.)-

     &  (1415*Mgl**13.*Mst2**2.*Mt**2.)/216.+

     &  (797*Mgl**11.*Mst2**4.*Mt**2.)/216.+

     &  (101*Mgl**9.*Mst2**6.*Mt**2.)/24.-

     &  (1415*Mgl**7.*Mst2**8.*Mt**2.)/216.+

     &  (563*Mgl**5.*Mst2**10.*Mt**2.)/216.+

     &  (5*Mgl**3.*Mst2**12.*Mt**2.)/36.-

     &  (47*Mgl*Mst2**14.*Mt**2.)/216.-

     &  (24373*Mgl**13.*Mt**4.)/1728.+

     &  (359*Mgl**17.*Mt**4.)/(288.*Mst2**4.)+

     &  (3223*Mgl**15.*Mt**4.)/(1728.*Mst2**2.)+

     &  (31639*Mgl**11.*Mst2**2.*Mt**4.)/1728.-

     &  (17401*Mgl**9.*Mst2**4.*Mt**4.)/1728.+

     &  (805*Mgl**7.*Mst2**6.*Mt**4.)/192.+

     &  (3881*Mgl**5.*Mst2**8.*Mt**4.)/1728.-

     &  (3881*Mgl**3.*Mst2**10.*Mt**4.)/576.+

     &  (5275*Mgl*Mst2**12.*Mt**4.)/1728.+

     &  (20225*Mgl**11.*Mt**6.)/864.-

     &  (91*Mgl**15.*Mt**6.)/(24.*Mst2**4.)-

     &  (12529*Mgl**13.*Mt**6.)/(1728.*Mst2**2.)-

     &  (28567*Mgl**9.*Mst2**2.*Mt**6.)/1728.+

     &  (647*Mgl**7.*Mst2**4.*Mt**6.)/144.-

     &  (7759*Mgl**5.*Mst2**6.*Mt**6.)/1728.+

     &  (12641*Mgl**3.*Mst2**8.*Mt**6.)/864.-

     &  (18089*Mgl*Mst2**10.*Mt**6.)/1728.-

     &  (11701*Mgl**9.*Mt**8.)/576.+

     &  (125*Mgl**13.*Mt**8.)/(18.*Mst2**4.)+

     &  (12539*Mgl**11.*Mt**8.)/(1728.*Mst2**2.)+

     &  (337*Mgl**7.*Mst2**2.*Mt**8.)/288.-

     &  (2987*Mgl**5.*Mst2**4.*Mt**8.)/864.-

     &  (2345*Mgl**3.*Mst2**6.*Mt**8.)/192.+

     &  (20645*Mgl*Mst2**8.*Mt**8.)/1728.+

     &  (523*Mgl**7.*Mt**10.)/16.-

     &  (655*Mgl**11.*Mt**10.)/(72.*Mst2**4.)+

     &  (15059*Mgl**9.*Mt**10.)/(1728.*Mst2**2.)+

     &  (3077*Mgl**5.*Mst2**2.*Mt**10.)/96.+

     &  (3865*Mgl**3.*Mst2**4.*Mt**10.)/144.+

     &  (9355*Mgl*Mst2**6.*Mt**10.)/1728.-

     &  (95011*Mgl**5.*Mt**12.)/1728.+

     &  (457*Mgl**9.*Mt**12.)/(48.*Mst2**4.)-

     &  (4819*Mgl**7.*Mt**12.)/(192.*Mst2**2.)-

     &  (92845*Mgl**3.*Mst2**2.*Mt**12.)/1728.-

     &  (45209*Mgl*Mst2**4.*Mt**12.)/1728.+

     &  (3881*Mgl**3.*Mt**14.)/96.-

     &  (571*Mgl**7.*Mt**14.)/(72.*Mst2**4.)+

     &  (12287*Mgl**5.*Mt**14.)/(576.*Mst2**2.)+

     &  (43685*Mgl*Mst2**2.*Mt**14.)/1728.-

     &  (17321*Mgl*Mt**16.)/1728.+

     &  (169*Mgl**5.*Mt**16.)/(36.*Mst2**4.)-

     &  (4429*Mgl**3.*Mt**16.)/(576.*Mst2**2.)-

     &  (5*Mgl**3.*Mt**18.)/(3.*Mst2**4.)+

     &  (1585*Mgl*Mt**18.)/(1728.*Mst2**2.)+

     &  (25*Mgl*Mt**20.)/(96.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  (-0.09027777777777778-(5*Mgl**2.)/(288.*Mst1**2.)-

     &  (5*Mgl**2.)/(288.*Mst2**2.)+

     &  (19*Mgl**2.*Mt**2.)/(4608.*Mst1**4.)+

     &  (53*Mt**2.)/(4608.*Mst1**2.)+

     &  (19*Mgl**2.*Mt**2.)/(4608.*Mst2**4.)+

     &  (53*Mt**2.)/(4608.*Mst2**2.)+

     &  (19*Mt**4.)/(4608.*Mst1**4.)+

     &  (19*Mt**4.)/(4608.*Mst2**4.))*ln(mu,Mgl)*ln(mu,Mt)

     &  +((-23*Mgl**4.)/576.-Mgl**8./(144.*Mst1**4.)+

     &  (13*Mgl**6.)/(576.*Mst1**2.)-

     &  (53*Mgl**2.*Mst1**2.)/576.+(67*Mst1**4.)/576.+

     &  (7*Mgl**2.*Mt**2.)/576.-

     &  (Mgl**6.*Mt**2.)/(1152.*Mst1**4.)-

     &  (43*Mgl**4.*Mt**2.)/(256.*Mst1**2.)-

     &  (77*Mst1**2.*Mt**2.)/768.-(23*Mt**4.)/384.+

     &  (17*Mgl**4.*Mt**4.)/(1152.*Mst1**4.)-

     &  (41*Mgl**2.*Mt**4.)/(288.*Mst1**2.)+

     &  (Mgl**2.*Mt**6.)/(1152.*Mst1**4.)+

     &  (119*Mt**6.)/(2304.*Mst1**2.)-

     &  Mt**8./(128.*Mst1**4.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  ((185*Mgl**8.)/576.+Mgl**12./(144.*Mst1**4.)-

     &  (49*Mgl**10.)/(576.*Mst1**2.)-

     &  (25*Mgl**6.*Mst1**2.)/96.-

     &  (71*Mgl**4.*Mst1**4.)/288.+

     &  (215*Mgl**2.*Mst1**6.)/576.-(7*Mst1**8.)/64.-

     &  (1019*Mgl**6.*Mt**2.)/1152.-

     &  (59*Mgl**10.*Mt**2.)/(2304.*Mst1**4.)+

     &  (17*Mgl**8.*Mt**2.)/(48.*Mst1**2.)+

     &  (379*Mgl**4.*Mst1**2.*Mt**2.)/576.-

     &  (463*Mgl**2.*Mst1**4.*Mt**2.)/2304.+

     &  (19*Mst1**6.*Mt**2.)/192.-

     &  (7*Mgl**4.*Mt**4.)/288.-

     &  (7*Mgl**8.*Mt**4.)/(2304.*Mst1**4.)-

     &  (151*Mgl**6.*Mt**4.)/(1152.*Mst1**2.)+

     &  (443*Mgl**2.*Mst1**2.*Mt**4.)/1152.+

     &  (349*Mst1**4.*Mt**4.)/768.-

     &  (895*Mgl**2.*Mt**6.)/1152.+

     &  (77*Mgl**6.*Mt**6.)/(1152.*Mst1**4.)-

     &  (51*Mgl**4.*Mt**6.)/(128.*Mst1**2.)-

     &  (275*Mst1**2.*Mt**6.)/384.+(71*Mt**8.)/288.-

     &  (35*Mgl**4.*Mt**8.)/(1152.*Mst1**4.)+

     &  (301*Mgl**2.*Mt**8.)/(1152.*Mst1**2.)-

     &  (95*Mgl**2.*Mt**10.)/(2304.*Mst1**4.)-

     &  Mt**10./(1152.*Mst1**2.)+

     &  (61*Mt**12.)/(2304.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-163*Mgl**12.)/288.+Mgl**16./(144.*Mst1**4.)+

     &  (7*Mgl**14.)/(72.*Mst1**2.)+

     &  (47*Mgl**10.*Mst1**2.)/48.-

     &  (13*Mgl**8.*Mst1**4.)/32.-

     &  (23*Mgl**6.*Mst1**6.)/36.+

     &  (235*Mgl**4.*Mst1**8.)/288.-

     &  (47*Mgl**2.*Mst1**10.)/144.+(11*Mst1**12.)/288.+

     &  (499*Mgl**10.*Mt**2.)/288.-

     &  (Mgl**14.*Mt**2.)/(128.*Mst1**4.)-

     &  (1109*Mgl**12.*Mt**2.)/(2304.*Mst1**2.)-

     &  (5791*Mgl**8.*Mst1**2.*Mt**2.)/2304.+

     &  (773*Mgl**6.*Mst1**4.*Mt**2.)/384.-

     &  (2395*Mgl**4.*Mst1**6.*Mt**2.)/2304.+

     &  (215*Mgl**2.*Mst1**8.*Mt**2.)/576.-

     &  (59*Mst1**10.*Mt**2.)/768.-

     &  (529*Mgl**8.*Mt**4.)/384.-

     &  (23*Mgl**12.*Mt**4.)/(1152.*Mst1**4.)+

     &  (187*Mgl**10.*Mt**4.)/(288.*Mst1**2.)+

     &  (323*Mgl**6.*Mst1**2.*Mt**4.)/288.+

     &  (539*Mgl**4.*Mst1**4.*Mt**4.)/1152.-

     &  (Mgl**2.*Mst1**6.*Mt**4.)/3.-

     &  (65*Mst1**8.*Mt**4.)/128.+

     &  (41*Mgl**6.*Mt**6.)/96.-

     &  (25*Mgl**10.*Mt**6.)/(1152.*Mst1**4.)+

     &  (211*Mgl**8.*Mt**6.)/(2304.*Mst1**2.)+

     &  (35*Mgl**4.*Mst1**2.*Mt**6.)/384.+

     &  (1861*Mgl**2.*Mst1**4.*Mt**6.)/1152.+

     &  (4267*Mst1**6.*Mt**6.)/2304.+

     &  (5*Mgl**4.*Mt**8.)/576.+

     &  (59*Mgl**8.*Mt**8.)/(384.*Mst1**4.)-

     &  (115*Mgl**6.*Mt**8.)/(288.*Mst1**2.)-

     &  (109*Mgl**2.*Mst1**2.*Mt**8.)/72.-

     &  (2507*Mst1**4.*Mt**8.)/1152.-

     &  (Mgl**2.*Mt**10.)/4.-

     &  (131*Mgl**6.*Mt**10.)/(1152.*Mst1**4.)-

     &  (575*Mgl**4.*Mt**10.)/(2304.*Mst1**2.)+

     &  (2053*Mst1**2.*Mt**10.)/2304.+

     &  (29*Mt**12.)/1152.-

     &  (109*Mgl**4.*Mt**12.)/(1152.*Mst1**4.)+

     &  (7*Mgl**2.*Mt**12.)/(24.*Mst1**2.)+

     &  (55*Mgl**2.*Mt**14.)/(384.*Mst1**4.)+

     &  Mt**14./(2304.*Mst1**2.)-

     &  (53*Mt**16.)/(1152.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((17*Mgl**16.)/72.-Mgl**20./(144.*Mst1**4.)-

     &  (5*Mgl**18.)/(288.*Mst1**2.)-

     &  (5*Mgl**14.*Mst1**2.)/8.+

     &  (23*Mgl**12.*Mst1**4.)/36.+

     &  (Mgl**10.*Mst1**6.)/144.-

     &  (5*Mgl**8.*Mst1**8.)/8.+

     &  (43*Mgl**6.*Mst1**10.)/72.-

     &  (35*Mgl**4.*Mst1**12.)/144.+

     &  (11*Mgl**2.*Mst1**14.)/288.-

     &  (1151*Mgl**14.*Mt**2.)/1152.+

     &  (139*Mgl**18.*Mt**2.)/(4608.*Mst1**4.)+

     &  (715*Mgl**16.*Mt**2.)/(4608.*Mst1**2.)+

     &  (275*Mgl**12.*Mst1**2.*Mt**2.)/128.-

     &  (2053*Mgl**10.*Mst1**4.*Mt**2.)/768.+

     &  (541*Mgl**8.*Mst1**6.*Mt**2.)/256.-

     &  (1087*Mgl**6.*Mst1**8.*Mt**2.)/1152.+

     &  (239*Mgl**4.*Mst1**10.*Mt**2.)/1152.-

     &  (373*Mgl**2.*Mst1**12.*Mt**2.)/4608.+

     &  (65*Mst1**14.*Mt**2.)/1536.+

     &  (827*Mgl**12.*Mt**4.)/576.-

     &  (47*Mgl**16.*Mt**4.)/(1536.*Mst1**4.)-

     &  (439*Mgl**14.*Mt**4.)/(1152.*Mst1**2.)-

     &  (1109*Mgl**10.*Mst1**2.*Mt**4.)/384.+

     &  (5611*Mgl**8.*Mst1**4.*Mt**4.)/2304.+

     &  (17*Mgl**6.*Mst1**6.*Mt**4.)/384.-

     &  (13*Mgl**4.*Mst1**8.*Mt**4.)/24.-

     &  (61*Mgl**2.*Mst1**10.*Mt**4.)/1152.-

     &  (97*Mst1**12.*Mt**4.)/4608.-

     &  (25*Mgl**10.*Mt**6.)/128.-

     &  (11*Mgl**14.*Mt**6.)/(384.*Mst1**4.)-

     &  (Mgl**12.*Mt**6.)/(36.*Mst1**2.)+

     &  (1133*Mgl**8.*Mst1**2.*Mt**6.)/576.-

     &  (123*Mgl**6.*Mst1**4.*Mt**6.)/128.+

     &  (91*Mgl**4.*Mst1**6.*Mt**6.)/288.-

     &  (443*Mgl**2.*Mst1**8.*Mt**6.)/1152.-

     &  (395*Mst1**10.*Mt**6.)/576.-

     &  (67*Mgl**8.*Mt**8.)/72.+

     &  (3*Mgl**12.*Mt**8.)/(128.*Mst1**4.)+

     &  (1289*Mgl**10.*Mt**8.)/(1152.*Mst1**2.)+

     &  (137*Mgl**6.*Mst1**2.*Mt**8.)/576.+

     &  (1571*Mgl**4.*Mst1**4.*Mt**8.)/1152.+

     &  (2149*Mgl**2.*Mst1**6.*Mt**8.)/1152.+

     &  (1273*Mst1**8.*Mt**8.)/576.+

     &  (151*Mgl**6.*Mt**10.)/128.+

     &  (95*Mgl**10.*Mt**10.)/(768.*Mst1**4.)-

     &  (281*Mgl**8.*Mt**10.)/(256.*Mst1**2.)-

     &  (305*Mgl**4.*Mst1**2.*Mt**10.)/1152.-

     &  (1513*Mgl**2.*Mst1**4.*Mt**10.)/768.-

     &  (6941*Mst1**6.*Mt**10.)/2304.-

     &  (865*Mgl**4.*Mt**12.)/576.-

     &  (43*Mgl**8.*Mt**12.)/(256.*Mst1**4.)-

     &  (157*Mgl**6.*Mt**12.)/(1152.*Mst1**2.)+

     &  (109*Mgl**2.*Mst1**2.*Mt**12.)/1152.+

     &  (4735*Mst1**4.*Mt**12.)/2304.+

     &  (251*Mgl**2.*Mt**14.)/384.-

     &  (7*Mgl**6.*Mt**14.)/(384.*Mst1**4.)+

     &  (97*Mgl**4.*Mt**14.)/(192.*Mst1**2.)-

     &  (193*Mst1**2.*Mt**14.)/288.+(35*Mt**16.)/288.+

     &  (61*Mgl**4.*Mt**16.)/(384.*Mst1**4.)-

     &  (65*Mgl**2.*Mt**16.)/(1152.*Mst1**2.)-

     &  (493*Mgl**2.*Mt**18.)/(4608.*Mst1**4.)-

     &  (289*Mt**18.)/(4608.*Mst1**2.)+

     &  (107*Mt**20.)/(4608.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-5*Mgl**4.)/128.-Mgl**8./(144.*Mst2**4.)+

     &  (13*Mgl**6.)/(576.*Mst2**2.)-

     &  (5*Mgl**2.*Mst2**2.)/384.+(5*Mst2**4.)/576.+

     &  (115*Mgl**6.)/(2304.*Mt**2.)-

     &  (29*Mgl**4.*Mst2**2.)/(384.*Mt**2.)+

     &  (Mgl**2.*Mst2**4.)/(768.*Mt**2.)+

     &  (7*Mst2**6.)/(288.*Mt**2.)+

     &  (35*Mgl**2.*Mt**2.)/2304.-

     &  (Mgl**6.*Mt**2.)/(1152.*Mst2**4.)-

     &  (43*Mgl**4.*Mt**2.)/(256.*Mst2**2.)-

     &  (7*Mst2**2.*Mt**2.)/256.-(19*Mt**4.)/384.+

     &  (17*Mgl**4.*Mt**4.)/(1152.*Mst2**4.)-

     &  (41*Mgl**2.*Mt**4.)/(288.*Mst2**2.)+

     &  (Mgl**2.*Mt**6.)/(1152.*Mst2**4.)+

     &  (119*Mt**6.)/(2304.*Mst2**2.)-

     &  Mt**8./(128.*Mst2**4.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  ((563*Mgl**8.)/1152.+Mgl**12./(144.*Mst2**4.)-

     &  (49*Mgl**10.)/(576.*Mst2**2.)-

     &  (175*Mgl**6.*Mst2**2.)/384.+

     &  (113*Mgl**4.*Mst2**4.)/1152.-

     &  (221*Mgl**2.*Mst2**6.)/1152.+(5*Mst2**8.)/36.-

     &  (15*Mgl**10.)/(256.*Mt**2.)+

     &  (107*Mgl**8.*Mst2**2.)/(576.*Mt**2.)-

     &  (205*Mgl**6.*Mst2**4.)/(1152.*Mt**2.)+

     &  (Mgl**4.*Mst2**6.)/(192.*Mt**2.)+

     &  (169*Mgl**2.*Mst2**8.)/(2304.*Mt**2.)-

     &  Mst2**10./(36.*Mt**2.)-

     &  (1127*Mgl**6.*Mt**2.)/1152.-

     &  (59*Mgl**10.*Mt**2.)/(2304.*Mst2**4.)+

     &  (17*Mgl**8.*Mt**2.)/(48.*Mst2**2.)+

     &  (109*Mgl**4.*Mst2**2.*Mt**2.)/192.+

     &  (1273*Mgl**2.*Mst2**4.*Mt**2.)/2304.-

     &  (215*Mst2**6.*Mt**2.)/576.-

     &  (167*Mgl**4.*Mt**4.)/1152.-

     &  (7*Mgl**8.*Mt**4.)/(2304.*Mst2**4.)-

     &  (151*Mgl**6.*Mt**4.)/(1152.*Mst2**2.)-

     &  (47*Mgl**2.*Mst2**2.*Mt**4.)/576.+

     &  (1519*Mst2**4.*Mt**4.)/2304.-

     &  (1319*Mgl**2.*Mt**6.)/2304.+

     &  (77*Mgl**6.*Mt**6.)/(1152.*Mst2**4.)-

     &  (51*Mgl**4.*Mt**6.)/(128.*Mst2**2.)-

     &  (649*Mst2**2.*Mt**6.)/1152.+(9*Mt**8.)/64.-

     &  (35*Mgl**4.*Mt**8.)/(1152.*Mst2**4.)+

     &  (301*Mgl**2.*Mt**8.)/(1152.*Mst2**2.)-

     &  (95*Mgl**2.*Mt**10.)/(2304.*Mst2**4.)-

     &  Mt**10./(1152.*Mst2**2.)+

     &  (61*Mt**12.)/(2304.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-737*Mgl**12.)/1152.+Mgl**16./(144.*Mst2**4.)+

     &  (7*Mgl**14.)/(72.*Mst2**2.)+

     &  (1205*Mgl**10.*Mst2**2.)/1152.-

     &  (263*Mgl**8.*Mst2**4.)/576.-

     &  (11*Mgl**6.*Mst2**6.)/576.-

     &  (349*Mgl**4.*Mst2**8.)/1152.+

     &  (139*Mgl**2.*Mst2**10.)/384.-(3*Mst2**12.)/32.+

     &  (29*Mgl**14.)/(2304.*Mt**2.)-

     &  (13*Mgl**12.*Mst2**2.)/(384.*Mt**2.)-

     &  (5*Mgl**10.*Mst2**4.)/(256.*Mt**2.)+

     &  (95*Mgl**8.*Mst2**6.)/(576.*Mt**2.)-

     &  (175*Mgl**6.*Mst2**8.)/(768.*Mt**2.)+

     &  (17*Mgl**4.*Mst2**10.)/(128.*Mt**2.)-

     &  (67*Mgl**2.*Mst2**12.)/(2304.*Mt**2.)+

     &  (4499*Mgl**10.*Mt**2.)/2304.-

     &  (Mgl**14.*Mt**2.)/(128.*Mst2**4.)-

     &  (1109*Mgl**12.*Mt**2.)/(2304.*Mst2**2.)-

     &  (1561*Mgl**8.*Mst2**2.*Mt**2.)/768.+

     &  (103*Mgl**6.*Mst2**4.*Mt**2.)/288.+

     &  (2897*Mgl**4.*Mst2**6.*Mt**2.)/2304.-

     &  (3329*Mgl**2.*Mst2**8.*Mt**2.)/2304.+

     &  (919*Mst2**10.*Mt**2.)/2304.-

     &  (1933*Mgl**8.*Mt**4.)/1152.-

     &  (23*Mgl**12.*Mt**4.)/(1152.*Mst2**4.)+

     &  (187*Mgl**10.*Mt**4.)/(288.*Mst2**2.)+

     &  (517*Mgl**6.*Mst2**2.*Mt**4.)/576.-

     &  (7*Mgl**4.*Mst2**4.*Mt**4.)/128.+

     &  (1121*Mgl**2.*Mst2**6.*Mt**4.)/576.-

     &  (1045*Mst2**8.*Mt**4.)/1152.+

     &  (233*Mgl**6.*Mt**6.)/768.-

     &  (25*Mgl**10.*Mt**6.)/(1152.*Mst2**4.)+

     &  (211*Mgl**8.*Mt**6.)/(2304.*Mst2**2.)-

     &  (277*Mgl**4.*Mst2**2.*Mt**6.)/192.-

     &  (195*Mgl**2.*Mst2**4.*Mt**6.)/256.+

     &  (3067*Mst2**6.*Mt**6.)/2304.+

     &  (869*Mgl**4.*Mt**8.)/1152.+

     &  (59*Mgl**8.*Mt**8.)/(384.*Mst2**4.)-

     &  (115*Mgl**6.*Mt**8.)/(288.*Mst2**2.)+

     &  (469*Mgl**2.*Mst2**2.*Mt**8.)/1152.-

     &  (1147*Mst2**4.*Mt**8.)/1152.-

     &  (2107*Mgl**2.*Mt**10.)/2304.-

     &  (131*Mgl**6.*Mt**10.)/(1152.*Mst2**4.)-

     &  (575*Mgl**4.*Mt**10.)/(2304.*Mst2**2.)+

     &  (79*Mst2**2.*Mt**10.)/768.+(241*Mt**12.)/1152.-

     &  (109*Mgl**4.*Mt**12.)/(1152.*Mst2**4.)+

     &  (7*Mgl**2.*Mt**12.)/(24.*Mst2**2.)+

     &  (55*Mgl**2.*Mt**14.)/(384.*Mst2**4.)+

     &  Mt**14./(2304.*Mst2**2.)-

     &  (53*Mt**16.)/(1152.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((89*Mgl**16.)/384.-Mgl**20./(144.*Mst2**4.)-

     &  (5*Mgl**18.)/(288.*Mst2**2.)-

     &  (535*Mgl**14.*Mst2**2.)/1152.-

     &  (31*Mgl**12.*Mst2**4.)/1152.+

     &  (1213*Mgl**10.*Mst2**6.)/1152.-

     &  (455*Mgl**8.*Mst2**8.)/384.+

     &  (121*Mgl**6.*Mst2**10.)/384.+

     &  (275*Mgl**4.*Mst2**12.)/1152.-

     &  (21*Mgl**2.*Mst2**14.)/128.+(5*Mst2**16.)/192.-

     &  Mgl**18./(256.*Mt**2.)+

     &  (Mgl**16.*Mst2**2.)/(72.*Mt**2.)+

     &  (5*Mgl**14.*Mst2**4.)/(576.*Mt**2.)-

     &  (35*Mgl**12.*Mst2**6.)/(288.*Mt**2.)+

     &  (301*Mgl**10.*Mst2**8.)/(1152.*Mt**2.)-

     &  (77*Mgl**8.*Mst2**10.)/(288.*Mt**2.)+

     &  (77*Mgl**6.*Mst2**12.)/(576.*Mt**2.)-

     &  (5*Mgl**4.*Mst2**14.)/(288.*Mt**2.)-

     &  (25*Mgl**2.*Mst2**16.)/(2304.*Mt**2.)+

     &  Mst2**18./(288.*Mt**2.)-

     &  (97*Mgl**14.*Mt**2.)/96.+

     &  (139*Mgl**18.*Mt**2.)/(4608.*Mst2**4.)+

     &  (715*Mgl**16.*Mt**2.)/(4608.*Mst2**2.)+

     &  (1897*Mgl**12.*Mst2**2.*Mt**2.)/1152.-

     &  (2077*Mgl**10.*Mst2**4.*Mt**2.)/2304.-

     &  (715*Mgl**8.*Mst2**6.*Mt**2.)/2304.+

     &  (619*Mgl**6.*Mst2**8.*Mt**2.)/576.-

     &  (1451*Mgl**4.*Mst2**10.*Mt**2.)/1152.+

     &  (3335*Mgl**2.*Mst2**12.*Mt**2.)/4608.-

     &  (685*Mst2**14.*Mt**2.)/4608.+

     &  (2015*Mgl**12.*Mt**4.)/1152.-

     &  (47*Mgl**16.*Mt**4.)/(1536.*Mst2**4.)-

     &  (439*Mgl**14.*Mt**4.)/(1152.*Mst2**2.)-

     &  (41*Mgl**10.*Mst2**2.*Mt**4.)/16.+

     &  (3479*Mgl**8.*Mst2**4.*Mt**4.)/2304.-

     &  (895*Mgl**6.*Mst2**6.*Mt**4.)/1152.+

     &  (1525*Mgl**4.*Mst2**8.*Mt**4.)/1152.-

     &  (649*Mgl**2.*Mst2**10.*Mt**4.)/576.+

     &  (151*Mst2**12.*Mt**4.)/512.-

     &  (385*Mgl**10.*Mt**6.)/384.-

     &  (11*Mgl**14.*Mt**6.)/(384.*Mst2**4.)-

     &  (Mgl**12.*Mt**6.)/(36.*Mst2**2.)+

     &  (1271*Mgl**8.*Mst2**2.*Mt**6.)/576.-

     &  (469*Mgl**6.*Mst2**4.*Mt**6.)/384.-

     &  (61*Mgl**4.*Mst2**6.*Mt**6.)/288.+

     &  (289*Mgl**2.*Mst2**8.*Mt**6.)/384.-

     &  (269*Mst2**10.*Mt**6.)/576.-

     &  (377*Mgl**8.*Mt**8.)/1152.+

     &  (3*Mgl**12.*Mt**8.)/(128.*Mst2**4.)+

     &  (1289*Mgl**10.*Mt**8.)/(1152.*Mst2**2.)-

     &  (349*Mgl**6.*Mst2**2.*Mt**8.)/384.-

     &  (7*Mgl**4.*Mst2**4.*Mt**8.)/16.-

     &  (203*Mgl**2.*Mst2**6.*Mt**8.)/576.+

     &  (461*Mst2**8.*Mt**8.)/576.+

     &  (443*Mgl**6.*Mt**10.)/288.+

     &  (95*Mgl**10.*Mt**10.)/(768.*Mst2**4.)-

     &  (281*Mgl**8.*Mt**10.)/(256.*Mst2**2.)+

     &  (2333*Mgl**4.*Mst2**2.*Mt**10.)/1152.+

     &  (829*Mgl**2.*Mst2**4.*Mt**10.)/768.-

     &  (727*Mst2**6.*Mt**10.)/768.-

     &  (893*Mgl**4.*Mt**12.)/384.-

     &  (43*Mgl**8.*Mt**12.)/(256.*Mst2**4.)-

     &  (157*Mgl**6.*Mt**12.)/(1152.*Mst2**2.)-

     &  (1069*Mgl**2.*Mst2**2.*Mt**12.)/576.+

     &  (1255*Mst2**4.*Mt**12.)/2304.+

     &  (2575*Mgl**2.*Mt**14.)/2304.-

     &  (7*Mgl**6.*Mt**14.)/(384.*Mst2**4.)+

     &  (97*Mgl**4.*Mt**14.)/(192.*Mst2**2.)-

     &  (29*Mst2**2.*Mt**14.)/288.+(19*Mt**16.)/576.+

     &  (61*Mgl**4.*Mt**16.)/(384.*Mst2**4.)-

     &  (65*Mgl**2.*Mt**16.)/(1152.*Mst2**2.)-

     &  (493*Mgl**2.*Mt**18.)/(4608.*Mst2**4.)-

     &  (289*Mt**18.)/(4608.*Mst2**2.)+

     &  (107*Mt**20.)/(4608.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((Mgl*Mt**2.)/(36.*Mst1**2.)-

     &  (Mgl*Mt**2.)/(36.*Mst2**2.)-

     &  (19*Mgl*Mt**4.)/(1152.*Mst1**4.)+

     &  (19*Mgl*Mt**4.)/(1152.*Mst2**4.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  ((7*Mgl**3.*Mt**2.)/72.+

     &  (Mgl**7.*Mt**2.)/(36.*Mst1**4.)-

     &  (Mgl**5.*Mt**2.)/(16.*Mst1**2.)+

     &  (19*Mgl*Mst1**2.*Mt**2.)/144.+

     &  (5*Mgl*Mt**4.)/576.-

     &  (7*Mgl**5.*Mt**4.)/(288.*Mst1**4.)+

     &  (409*Mgl**3.*Mt**4.)/(576.*Mst1**2.)-

     &  (5*Mgl**3.*Mt**6.)/(144.*Mst1**4.)-

     &  (101*Mgl*Mt**6.)/(576.*Mst1**2.)+

     &  (Mgl*Mt**8.)/(32.*Mst1**4.))*Xt*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-67*Mgl**7.*Mt**2.)/72.-

     &  (Mgl**11.*Mt**2.)/(36.*Mst1**4.)+

     &  (13*Mgl**9.*Mt**2.)/(48.*Mst1**2.)+

     &  (47*Mgl**5.*Mst1**2.*Mt**2.)/72.+

     &  (25*Mgl**3.*Mst1**4.*Mt**2.)/72.-

     &  (5*Mgl*Mst1**6.*Mt**2.)/16.+

     &  (1577*Mgl**5.*Mt**4.)/576.+

     &  (25*Mgl**9.*Mt**4.)/(192.*Mst1**4.)-

     &  (829*Mgl**7.*Mt**4.)/(576.*Mst1**2.)-

     &  (193*Mgl**3.*Mst1**2.*Mt**4.)/192.-

     &  (Mgl*Mst1**4.*Mt**4.)/16.+

     &  (151*Mgl**3.*Mt**6.)/288.-

     &  (17*Mgl**7.*Mt**6.)/(144.*Mst1**4.)+

     &  (1031*Mgl**5.*Mt**6.)/(576.*Mst1**2.)+

     &  (419*Mgl*Mst1**2.*Mt**6.)/576.-

     &  (55*Mgl*Mt**8.)/576.-

     &  (43*Mgl**5.*Mt**8.)/(288.*Mst1**4.)-

     &  (271*Mgl**3.*Mt**8.)/(576.*Mst1**2.)+

     &  (13*Mgl**3.*Mt**10.)/(48.*Mst1**4.)-

     &  (29*Mgl*Mt**10.)/(192.*Mst1**2.)-

     &  (61*Mgl*Mt**12.)/(576.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+((31*Mgl**11.*Mt**2.)/18.-

     &  (Mgl**15.*Mt**2.)/(36.*Mst1**4.)-

     &  (Mgl**13.*Mt**2.)/(3.*Mst1**2.)-

     &  (167*Mgl**9.*Mst1**2.*Mt**2.)/72.+

     &  (2*Mgl**7.*Mst1**4.*Mt**2.)/9.+

     &  (29*Mgl**5.*Mst1**6.*Mt**2.)/18.-

     &  (37*Mgl**3.*Mst1**8.*Mt**2.)/36.+

     &  (11*Mgl*Mst1**10.*Mt**2.)/72.-

     &  (3265*Mgl**9.*Mt**4.)/576.+

     &  (17*Mgl**13.*Mt**4.)/(288.*Mst1**4.)+

     &  (341*Mgl**11.*Mt**4.)/(192.*Mst1**2.)+

     &  (1823*Mgl**7.*Mst1**2.*Mt**4.)/288.-

     &  (103*Mgl**5.*Mst1**4.*Mt**4.)/36.+

     &  (227*Mgl**3.*Mst1**6.*Mt**4.)/576.-

     &  (17*Mgl*Mst1**8.*Mt**4.)/576.+

     &  (755*Mgl**7.*Mt**6.)/144.+

     &  (Mgl**11.*Mt**6.)/(48.*Mst1**4.)-

     &  (1643*Mgl**9.*Mt**6.)/(576.*Mst1**2.)-

     &  (511*Mgl**5.*Mst1**2.*Mt**6.)/96.-

     &  (43*Mgl**3.*Mst1**4.*Mt**6.)/12.-

     &  (1187*Mgl*Mst1**6.*Mt**6.)/576.-

     &  (655*Mgl**5.*Mt**8.)/288.+

     &  (19*Mgl**9.*Mt**8.)/(288.*Mst1**4.)+

     &  (25*Mgl**7.*Mt**8.)/(96.*Mst1**2.)+

     &  (1565*Mgl**3.*Mst1**2.*Mt**8.)/288.+

     &  (149*Mgl*Mst1**4.*Mt**8.)/36.+

     &  (61*Mgl**3.*Mt**10.)/48.-

     &  (49*Mgl**7.*Mt**10.)/(72.*Mst1**4.)+

     &  (263*Mgl**5.*Mt**10.)/(96.*Mst1**2.)-

     &  (643*Mgl*Mst1**2.*Mt**10.)/288.-

     &  (169*Mgl*Mt**12.)/576.+

     &  (109*Mgl**5.*Mt**12.)/(96.*Mst1**4.)-

     &  (997*Mgl**3.*Mt**12.)/(576.*Mst1**2.)-

     &  (109*Mgl**3.*Mt**14.)/(144.*Mst1**4.)+

     &  (9*Mgl*Mt**14.)/(64.*Mst1**2.)+

     &  (53*Mgl*Mt**16.)/(288.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+((-61*Mgl**15.*Mt**2.)/72.+

     &  (Mgl**19.*Mt**2.)/(36.*Mst1**4.)+

     &  (7*Mgl**17.*Mt**2.)/(72.*Mst1**2.)+

     &  (119*Mgl**13.*Mst1**2.*Mt**2.)/72.-

     &  (65*Mgl**11.*Mst1**4.*Mt**2.)/72.-

     &  (67*Mgl**9.*Mst1**6.*Mt**2.)/72.+

     &  (113*Mgl**7.*Mst1**8.*Mt**2.)/72.-

     &  (59*Mgl**5.*Mst1**10.*Mt**2.)/72.+

     &  (11*Mgl**3.*Mst1**12.*Mt**2.)/72.+

     &  (2291*Mgl**13.*Mt**4.)/576.-

     &  (19*Mgl**17.*Mt**4.)/(128.*Mst1**4.)-

     &  (499*Mgl**15.*Mt**4.)/(576.*Mst1**2.)-

     &  (3611*Mgl**11.*Mst1**2.*Mt**4.)/576.+

     &  (767*Mgl**9.*Mst1**4.*Mt**4.)/144.-

     &  (1265*Mgl**7.*Mst1**6.*Mt**4.)/576.+

     &  (5*Mgl**5.*Mst1**8.*Mt**4.)/576.-

     &  (Mgl**3.*Mst1**10.*Mt**4.)/576.+

     &  (65*Mgl*Mst1**12.*Mt**4.)/384.-

     &  (2033*Mgl**11.*Mt**6.)/288.+

     &  (13*Mgl**15.*Mt**6.)/(48.*Mst1**4.)+

     &  (511*Mgl**13.*Mt**6.)/(192.*Mst1**2.)+

     &  (6199*Mgl**9.*Mst1**2.*Mt**6.)/576.-

     &  (155*Mgl**7.*Mst1**4.*Mt**6.)/36.-

     &  (439*Mgl**5.*Mst1**6.*Mt**6.)/192.-

     &  (37*Mgl**3.*Mst1**8.*Mt**6.)/288.+

     &  (49*Mgl*Mst1**10.*Mt**6.)/576.+

     &  (2957*Mgl**9.*Mt**8.)/576.-

     &  (5*Mgl**13.*Mt**8.)/(32.*Mst1**4.)-

     &  (1559*Mgl**11.*Mt**8.)/(576.*Mst1**2.)-

     &  (3887*Mgl**7.*Mst1**2.*Mt**8.)/288.-

     &  (385*Mgl**5.*Mst1**4.*Mt**8.)/72.-

     &  (2491*Mgl**3.*Mst1**6.*Mt**8.)/576.-

     &  (1531*Mgl*Mst1**8.*Mt**8.)/576.-

     &  (449*Mgl**7.*Mt**10.)/144.+

     &  (Mgl**11.*Mt**10.)/(16.*Mst1**4.)-

     &  (983*Mgl**9.*Mt**10.)/(576.*Mst1**2.)+

     &  (905*Mgl**5.*Mst1**2.*Mt**10.)/96.+

     &  (671*Mgl**3.*Mst1**4.*Mt**10.)/72.+

     &  (1187*Mgl*Mst1**6.*Mt**10.)/192.+

     &  (2269*Mgl**5.*Mt**12.)/576.-

     &  (107*Mgl**9.*Mt**12.)/(192.*Mst1**4.)+

     &  (3191*Mgl**7.*Mt**12.)/(576.*Mst1**2.)-

     &  (2551*Mgl**3.*Mst1**2.*Mt**12.)/576.-

     &  (845*Mgl*Mst1**4.*Mt**12.)/144.-

     &  (163*Mgl**3.*Mt**14.)/96.+

     &  (59*Mgl**7.*Mt**14.)/(48.*Mst1**4.)-

     &  (241*Mgl**5.*Mt**14.)/(64.*Mst1**2.)+

     &  (1355*Mgl*Mst1**2.*Mt**14.)/576.-

     &  (21*Mgl*Mt**16.)/64.-

     &  (37*Mgl**5.*Mt**16.)/(32.*Mst1**4.)+

     &  (113*Mgl**3.*Mt**16.)/(192.*Mst1**2.)+

     &  (25*Mgl**3.*Mt**18.)/(48.*Mst1**4.)+

     &  (91*Mgl*Mt**18.)/(576.*Mst1**2.)-

     &  (107*Mgl*Mt**20.)/(1152.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+((95*Mgl**5.)/576.-

     &  (55*Mgl**3.*Mst2**2.)/576.-(5*Mgl*Mst2**4.)/72.-

     &  (157*Mgl**3.*Mt**2.)/576.-

     &  (Mgl**7.*Mt**2.)/(36.*Mst2**4.)+

     &  (Mgl**5.*Mt**2.)/(16.*Mst2**2.)+

     &  (Mgl*Mst2**2.*Mt**2.)/48.-(7*Mgl*Mt**4.)/192.+

     &  (7*Mgl**5.*Mt**4.)/(288.*Mst2**4.)-

     &  (409*Mgl**3.*Mt**4.)/(576.*Mst2**2.)+

     &  (5*Mgl**3.*Mt**6.)/(144.*Mst2**4.)+

     &  (101*Mgl*Mt**6.)/(576.*Mst2**2.)-

     &  (Mgl*Mt**8.)/(32.*Mst2**4.))*Xt*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-37*Mgl**9.)/192.+(79*Mgl**7.*Mst2**2.)/192.-

     &  (31*Mgl**5.*Mst2**4.)/192.-

     &  (9*Mgl**3.*Mst2**6.)/64.+(Mgl*Mst2**8.)/12.+

     &  (323*Mgl**7.*Mt**2.)/192.+

     &  (Mgl**11.*Mt**2.)/(36.*Mst2**4.)-

     &  (13*Mgl**9.*Mt**2.)/(48.*Mst2**2.)-

     &  (77*Mgl**5.*Mst2**2.*Mt**2.)/96.+

     &  (241*Mgl**3.*Mst2**4.*Mt**2.)/576.-

     &  (2*Mgl*Mst2**6.*Mt**2.)/9.-

     &  (1085*Mgl**5.*Mt**4.)/288.-

     &  (25*Mgl**9.*Mt**4.)/(192.*Mst2**4.)+

     &  (829*Mgl**7.*Mt**4.)/(576.*Mst2**2.)-

     &  (7*Mgl**3.*Mst2**2.*Mt**4.)/8.+

     &  (23*Mgl*Mst2**4.*Mt**4.)/36.+

     &  (101*Mgl**3.*Mt**6.)/576.+

     &  (17*Mgl**7.*Mt**6.)/(144.*Mst2**4.)-

     &  (1031*Mgl**5.*Mt**6.)/(576.*Mst2**2.)-

     &  (39*Mgl*Mst2**2.*Mt**6.)/64.-

     &  (85*Mgl*Mt**8.)/576.+

     &  (43*Mgl**5.*Mt**8.)/(288.*Mst2**4.)+

     &  (271*Mgl**3.*Mt**8.)/(576.*Mst2**2.)-

     &  (13*Mgl**3.*Mt**10.)/(48.*Mst2**4.)+

     &  (29*Mgl*Mt**10.)/(192.*Mst2**2.)+

     &  (61*Mgl*Mt**12.)/(576.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+((25*Mgl**13.)/576.-

     &  (29*Mgl**11.*Mst2**2.)/576.-

     &  (67*Mgl**9.*Mst2**4.)/288.+

     &  (163*Mgl**7.*Mst2**6.)/288.-

     &  (259*Mgl**5.*Mst2**8.)/576.+

     &  (71*Mgl**3.*Mst2**10.)/576.-

     &  (1147*Mgl**11.*Mt**2.)/576.+

     &  (Mgl**15.*Mt**2.)/(36.*Mst2**4.)+

     &  (Mgl**13.*Mt**2.)/(3.*Mst2**2.)+

     &  (287*Mgl**9.*Mst2**2.*Mt**2.)/144.+

     &  (115*Mgl**7.*Mst2**4.*Mt**2.)/288.-

     &  (55*Mgl**5.*Mst2**6.*Mt**2.)/144.-

     &  (371*Mgl**3.*Mst2**8.*Mt**2.)/576.+

     &  (19*Mgl*Mst2**10.*Mt**2.)/72.+

     &  (3931*Mgl**9.*Mt**4.)/576.-

     &  (17*Mgl**13.*Mt**4.)/(288.*Mst2**4.)-

     &  (341*Mgl**11.*Mt**4.)/(192.*Mst2**2.)-

     &  (131*Mgl**7.*Mst2**2.*Mt**4.)/48.-

     &  (341*Mgl**5.*Mst2**4.*Mt**4.)/288.+

     &  (1883*Mgl**3.*Mst2**6.*Mt**4.)/576.-

     &  (583*Mgl*Mst2**8.*Mt**4.)/576.-

     &  (2389*Mgl**7.*Mt**6.)/288.-

     &  (Mgl**11.*Mt**6.)/(48.*Mst2**4.)+

     &  (1643*Mgl**9.*Mt**6.)/(576.*Mst2**2.)-

     &  (569*Mgl**5.*Mst2**2.*Mt**6.)/288.-

     &  (59*Mgl**3.*Mst2**4.*Mt**6.)/32.+

     &  (1187*Mgl*Mst2**6.*Mt**6.)/576.+

     &  (3683*Mgl**5.*Mt**8.)/576.-

     &  (19*Mgl**9.*Mt**8.)/(288.*Mst2**4.)-

     &  (25*Mgl**7.*Mt**8.)/(96.*Mst2**2.)+

     &  (289*Mgl**3.*Mst2**2.*Mt**8.)/576.-

     &  (37*Mgl*Mst2**4.*Mt**8.)/18.-

     &  (2243*Mgl**3.*Mt**10.)/576.+

     &  (49*Mgl**7.*Mt**10.)/(72.*Mst2**4.)-

     &  (263*Mgl**5.*Mt**10.)/(96.*Mst2**2.)+

     &  (43*Mgl*Mst2**2.*Mt**10.)/288.+

     &  (529*Mgl*Mt**12.)/576.-

     &  (109*Mgl**5.*Mt**12.)/(96.*Mst2**4.)+

     &  (997*Mgl**3.*Mt**12.)/(576.*Mst2**2.)+

     &  (109*Mgl**3.*Mt**14.)/(144.*Mst2**4.)-

     &  (9*Mgl*Mt**14.)/(64.*Mst2**2.)-

     &  (53*Mgl*Mt**16.)/(288.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+(-Mgl**17./64.+

     &  (23*Mgl**15.*Mst2**2.)/576.+

     &  (43*Mgl**13.*Mst2**4.)/576.-

     &  (79*Mgl**11.*Mst2**6.)/192.+

     &  (365*Mgl**9.*Mst2**8.)/576.-

     &  (251*Mgl**7.*Mst2**10.)/576.+

     &  (19*Mgl**5.*Mst2**12.)/192.+

     &  (17*Mgl**3.*Mst2**14.)/576.-(Mgl*Mst2**16.)/72.+

     &  (487*Mgl**15.*Mt**2.)/576.-

     &  (Mgl**19.*Mt**2.)/(36.*Mst2**4.)-

     &  (7*Mgl**17.*Mt**2.)/(72.*Mst2**2.)-

     &  (101*Mgl**13.*Mst2**2.*Mt**2.)/96.-

     &  (79*Mgl**11.*Mst2**4.*Mt**2.)/64.+

     &  (61*Mgl**9.*Mst2**6.*Mt**2.)/18.-

     &  (127*Mgl**7.*Mst2**8.*Mt**2.)/64.-

     &  (83*Mgl**5.*Mst2**10.*Mt**2.)/288.+

     &  (109*Mgl**3.*Mst2**12.*Mt**2.)/192.-

     &  (17*Mgl*Mst2**14.*Mt**2.)/144.-

     &  (193*Mgl**13.*Mt**4.)/48.+

     &  (19*Mgl**17.*Mt**4.)/(128.*Mst2**4.)+

     &  (499*Mgl**15.*Mt**4.)/(576.*Mst2**2.)+

     &  (521*Mgl**11.*Mst2**2.*Mt**4.)/144.+

     &  (359*Mgl**9.*Mst2**4.*Mt**4.)/288.-

     &  (1949*Mgl**7.*Mst2**6.*Mt**4.)/576.+

     &  (835*Mgl**5.*Mst2**8.*Mt**4.)/288.-

     &  (533*Mgl**3.*Mst2**10.*Mt**4.)/288.+

     &  (61*Mgl*Mst2**12.*Mt**4.)/128.+

     &  (4813*Mgl**11.*Mt**6.)/576.-

     &  (13*Mgl**15.*Mt**6.)/(48.*Mst2**4.)-

     &  (511*Mgl**13.*Mt**6.)/(192.*Mst2**2.)-

     &  (3175*Mgl**9.*Mst2**2.*Mt**6.)/576.-

     &  (23*Mgl**7.*Mst2**4.*Mt**6.)/32.-

     &  (85*Mgl**5.*Mst2**6.*Mt**6.)/192.+

     &  (125*Mgl**3.*Mst2**8.*Mt**6.)/64.-

     &  (45*Mgl*Mst2**10.*Mt**6.)/64.-

     &  (1391*Mgl**9.*Mt**8.)/144.+

     &  (5*Mgl**13.*Mt**8.)/(32.*Mst2**4.)+

     &  (1559*Mgl**11.*Mt**8.)/(576.*Mst2**2.)+

     &  (2695*Mgl**7.*Mst2**2.*Mt**8.)/576.+

     &  (295*Mgl**5.*Mst2**4.*Mt**8.)/576.+

     &  (31*Mgl**3.*Mst2**6.*Mt**8.)/288.+

     &  (671*Mgl*Mst2**8.*Mt**8.)/576.+

     &  (1931*Mgl**7.*Mt**10.)/192.-

     &  (Mgl**11.*Mt**10.)/(16.*Mst2**4.)+

     &  (983*Mgl**9.*Mt**10.)/(576.*Mst2**2.)+

     &  (251*Mgl**5.*Mst2**2.*Mt**10.)/144.-

     &  (299*Mgl**3.*Mst2**4.*Mt**10.)/576.-

     &  (391*Mgl*Mst2**6.*Mt**10.)/192.-

     &  (85*Mgl**5.*Mt**12.)/9.+

     &  (107*Mgl**9.*Mt**12.)/(192.*Mst2**4.)-

     &  (3191*Mgl**7.*Mt**12.)/(576.*Mst2**2.)-

     &  (889*Mgl**3.*Mst2**2.*Mt**12.)/288.+

     &  (7*Mgl*Mst2**4.*Mt**12.)/4.+

     &  (2251*Mgl**3.*Mt**14.)/576.-

     &  (59*Mgl**7.*Mt**14.)/(48.*Mst2**4.)+

     &  (241*Mgl**5.*Mt**14.)/(64.*Mst2**2.)-

     &  (247*Mgl*Mst2**2.*Mt**14.)/576.-

     &  (5*Mgl*Mt**16.)/192.+

     &  (37*Mgl**5.*Mt**16.)/(32.*Mst2**4.)-

     &  (113*Mgl**3.*Mt**16.)/(192.*Mst2**2.)-

     &  (25*Mgl**3.*Mt**18.)/(48.*Mst2**4.)-

     &  (91*Mgl*Mt**18.)/(576.*Mst2**2.)+

     &  (107*Mgl*Mt**20.)/(1152.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+(ln(mu,Mst1)*ln(mu,Mt))/24.+

     &  ((-3*Mgl**4.)/64.+(5*Mgl**6.)/(576.*Mst1**2.)+

     &  (3*Mgl**2.*Mst1**2.)/64.-(5*Mst1**4.)/576.+

     &  (9*Mgl**2.*Mt**2.)/128.+

     &  (169*Mgl**4.*Mt**2.)/(2304.*Mst1**2.)-

     &  (187*Mst1**2.*Mt**2.)/2304.+(9*Mt**4.)/32.-

     &  (5*Mgl**2.*Mt**4.)/(576.*Mst1**2.)-

     &  (169*Mt**6.)/(2304.*Mst1**2.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mst1)*ln(mu,Mt)+

     &  ((29*Mgl**8.)/576.-Mgl**10./(64.*Mst1**2.)-

     &  (3*Mgl**6.*Mst1**2.)/32.-

     &  (5*Mgl**4.*Mst1**4.)/288.+

     &  (37*Mgl**2.*Mst1**6.)/192.-(67*Mst1**8.)/576.+

     &  (3*Mgl**6.*Mt**2.)/128.-

     &  (89*Mgl**8.*Mt**2.)/(2304.*Mst1**2.)+

     &  (43*Mgl**4.*Mst1**2.*Mt**2.)/144.-

     &  (55*Mgl**2.*Mst1**4.*Mt**2.)/128.+

     &  (337*Mst1**6.*Mt**2.)/2304.+

     &  (Mgl**4.*Mt**4.)/18.+

     &  (209*Mgl**6.*Mt**4.)/(1152.*Mst1**2.)+

     &  (37*Mgl**2.*Mst1**2.*Mt**4.)/128.-

     &  (551*Mst1**4.*Mt**4.)/576.+

     &  (197*Mgl**2.*Mt**6.)/384.-

     &  (7*Mgl**4.*Mt**6.)/(96.*Mst1**2.)+

     &  (1775*Mst1**2.*Mt**6.)/1152.-(209*Mt**8.)/288.-

     &  (191*Mgl**2.*Mt**8.)/(1152.*Mst1**2.)+

     &  (257*Mt**10.)/(2304.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mst1)*ln(mu,Mt)+

     &  ((-7*Mgl**12.)/96.+(17*Mgl**10.*Mst1**2.)/48.-

     &  (163*Mgl**8.*Mst1**4.)/288.+

     &  (13*Mgl**6.*Mst1**6.)/72.+

     &  (13*Mgl**4.*Mst1**8.)/32.-

     &  (61*Mgl**2.*Mst1**10.)/144.+(35*Mst1**12.)/288.+

     &  (347*Mgl**10.*Mt**2.)/1152.-

     &  (65*Mgl**12.*Mt**2.)/(2304.*Mst1**2.)-

     &  (239*Mgl**8.*Mst1**2.*Mt**2.)/256.+

     &  (253*Mgl**6.*Mst1**4.*Mt**2.)/192.-

     &  (1847*Mgl**4.*Mst1**6.*Mt**2.)/2304.+

     &  (55*Mgl**2.*Mst1**8.*Mt**2.)/1152.+

     &  (223*Mst1**10.*Mt**2.)/2304.-

     &  (305*Mgl**8.*Mt**4.)/576.+

     &  (25*Mgl**10.*Mt**4.)/(576.*Mst1**2.)+

     &  (9*Mgl**6.*Mst1**2.*Mt**4.)/8.-

     &  (77*Mgl**4.*Mst1**4.*Mt**4.)/288.-

     &  (47*Mgl**2.*Mst1**6.*Mt**4.)/192.-

     &  (73*Mst1**8.*Mt**4.)/576.+

     &  (193*Mgl**6.*Mt**6.)/576.+

     &  (73*Mgl**8.*Mt**6.)/(768.*Mst1**2.)-

     &  (107*Mgl**4.*Mst1**2.*Mt**6.)/1152.+

     &  (283*Mgl**2.*Mst1**4.*Mt**6.)/576.-

     &  (3701*Mst1**6.*Mt**6.)/2304.-

     &  (23*Mgl**4.*Mt**8.)/288.-

     &  (7*Mgl**6.*Mt**8.)/(36.*Mst1**2.)+

     &  (95*Mgl**2.*Mst1**2.*Mt**8.)/288.+

     &  (823*Mst1**4.*Mt**8.)/288.-

     &  (45*Mgl**2.*Mt**10.)/128.+

     &  (5*Mgl**4.*Mt**10.)/(2304.*Mst1**2.)-

     &  (3851*Mst1**2.*Mt**10.)/2304.+

     &  (229*Mt**12.)/576.+

     &  (29*Mgl**2.*Mt**12.)/(192.*Mst1**2.)-

     &  (53*Mt**14.)/(768.*Mst1**2.))*d123(Mt,Mgl,Mst1)**3.*

     &  ln(mu,Mst1)*ln(mu,Mt)+

     &  ((5*Mgl**16.)/288.+Mgl**18./(144.*Mst1**2.)-

     &  (17*Mgl**14.*Mst1**2.)/72.+

     &  (5*Mgl**12.*Mst1**4.)/8.-

     &  (23*Mgl**10.*Mst1**6.)/36.-

     &  (Mgl**8.*Mst1**8.)/144.+

     &  (5*Mgl**6.*Mst1**10.)/8.-

     &  (43*Mgl**4.*Mst1**12.)/72.+

     &  (35*Mgl**2.*Mst1**14.)/144.-(11*Mst1**16.)/288.-

     &  (175*Mgl**14.*Mt**2.)/1152.-

     &  (13*Mgl**16.*Mt**2.)/(768.*Mst1**2.)+

     &  (985*Mgl**12.*Mst1**2.*Mt**2.)/1152.-

     &  (2267*Mgl**10.*Mst1**4.*Mt**2.)/1152.+

     &  (547*Mgl**8.*Mst1**6.*Mt**2.)/192.-

     &  (2941*Mgl**6.*Mst1**8.*Mt**2.)/1152.+

     &  (1247*Mgl**4.*Mst1**10.*Mt**2.)/1152.+

     &  (7*Mgl**2.*Mst1**12.*Mt**2.)/1152.-

     &  (79*Mst1**14.*Mt**2.)/768.+

     &  (31*Mgl**12.*Mt**4.)/96.-

     &  (3*Mgl**14.*Mt**4.)/(128.*Mst1**2.)-

     &  (407*Mgl**10.*Mst1**2.*Mt**4.)/384.+

     &  (1273*Mgl**8.*Mst1**4.*Mt**4.)/576.-

     &  (2053*Mgl**6.*Mst1**6.*Mt**4.)/1152.+

     &  (Mgl**4.*Mst1**8.*Mt**4.)/3.-

     &  (731*Mgl**2.*Mst1**10.*Mt**4.)/1152.+

     &  (365*Mst1**12.*Mt**4.)/576.+

     &  (179*Mgl**10.*Mt**6.)/1152.+

     &  (95*Mgl**12.*Mt**6.)/(1152.*Mst1**2.)-

     &  (121*Mgl**8.*Mst1**2.*Mt**6.)/192.-

     &  (7*Mgl**6.*Mst1**4.*Mt**6.)/192.+

     &  (835*Mgl**4.*Mst1**6.*Mt**6.)/1152.+

     &  (23*Mgl**2.*Mst1**8.*Mt**6.)/1152.-

     &  (91*Mst1**10.*Mt**6.)/288.-

     &  (443*Mgl**8.*Mt**8.)/576.+

     &  (17*Mgl**10.*Mt**8.)/(1152.*Mst1**2.)+

     &  (739*Mgl**6.*Mst1**2.*Mt**8.)/576.-

     &  (79*Mgl**4.*Mst1**4.*Mt**8.)/72.+

     &  (139*Mgl**2.*Mst1**6.*Mt**8.)/384.-

     &  (323*Mst1**8.*Mt**8.)/192.+

     &  (215*Mgl**6.*Mt**10.)/1152.-

     &  (13*Mgl**8.*Mt**10.)/(72.*Mst1**2.)-

     &  (1027*Mgl**4.*Mst1**2.*Mt**10.)/1152.+

     &  (61*Mgl**2.*Mst1**4.*Mt**10.)/1152.+

     &  (3439*Mst1**6.*Mt**10.)/1152.+

     &  (13*Mgl**4.*Mt**12.)/36.+

     &  (127*Mgl**6.*Mt**12.)/(1152.*Mst1**2.)+

     &  (7*Mgl**2.*Mst1**2.*Mt**12.)/128.-

     &  (1157*Mst1**4.*Mt**12.)/576.+

     &  (5*Mgl**2.*Mt**14.)/1152.+

     &  (97*Mgl**4.*Mt**14.)/(1152.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**14.)/8.-(73*Mt**16.)/576.-

     &  (125*Mgl**2.*Mt**16.)/(1152.*Mst1**2.)+

     &  (71*Mt**18.)/(2304.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**4.*ln(mu,Mst1)*ln(mu,Mt)+

     &  ((Mgl**3.*Mt**2.)/9.-

     &  (5*Mgl**5.*Mt**2.)/(144.*Mst1**2.)-

     &  (11*Mgl*Mst1**2.*Mt**2.)/144.-

     &  (415*Mgl*Mt**4.)/576.-

     &  (149*Mgl**3.*Mt**4.)/(576.*Mst1**2.)+

     &  (169*Mgl*Mt**6.)/(576.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mst1)*ln(mu,Mt)

     &  +((-13*Mgl**7.*Mt**2.)/72.+

     &  (Mgl**9.*Mt**2.)/(16.*Mst1**2.)+

     &  (17*Mgl**5.*Mst1**2.*Mt**2.)/72.+

     &  (Mgl**3.*Mst1**4.*Mt**2.)/72.-

     &  (19*Mgl*Mst1**6.*Mt**2.)/144.+

     &  (311*Mgl**5.*Mt**4.)/576.+

     &  (53*Mgl**7.*Mt**4.)/(576.*Mst1**2.)-

     &  (275*Mgl**3.*Mst1**2.*Mt**4.)/192.+

     &  (349*Mgl*Mst1**4.*Mt**4.)/576.-

     &  (695*Mgl**3.*Mt**6.)/288.-

     &  (157*Mgl**5.*Mt**6.)/(192.*Mst1**2.)-

     &  (1607*Mgl*Mst1**2.*Mt**6.)/576.+

     &  (1279*Mgl*Mt**8.)/576.+

     &  (71*Mgl**3.*Mt**8.)/(64.*Mst1**2.)-

     &  (257*Mgl*Mt**10.)/(576.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mst1)*

     &  ln(mu,Mt)+((5*Mgl**11.*Mt**2.)/24.-

     &  1.*Mgl**9.*Mst1**2.*Mt**2.+

     &  (25*Mgl**7.*Mst1**4.*Mt**2.)/18.-

     &  (Mgl**5.*Mst1**6.*Mt**2.)/4.-

     &  (17*Mgl**3.*Mst1**8.*Mt**2.)/24.+

     &  (13*Mgl*Mst1**10.*Mt**2.)/36.-

     &  (485*Mgl**9.*Mt**4.)/576.+

     &  (65*Mgl**11.*Mt**4.)/(576.*Mst1**2.)+

     &  (785*Mgl**7.*Mst1**2.*Mt**4.)/288.-

     &  (917*Mgl**5.*Mst1**4.*Mt**4.)/288.+

     &  (445*Mgl**3.*Mst1**6.*Mt**4.)/576.+

     &  (239*Mgl*Mst1**8.*Mt**4.)/576.+

     &  (235*Mgl**7.*Mt**6.)/144.-

     &  (55*Mgl**9.*Mt**6.)/(192.*Mst1**2.)-

     &  (91*Mgl**5.*Mst1**2.*Mt**6.)/32.+

     &  (83*Mgl**3.*Mst1**4.*Mt**6.)/144.+

     &  (595*Mgl*Mst1**6.*Mt**6.)/576.-

     &  (523*Mgl**5.*Mt**8.)/288.-

     &  (3*Mgl**7.*Mt**8.)/(32.*Mst1**2.)-

     &  (557*Mgl**3.*Mst1**2.*Mt**8.)/288.-

     &  (1601*Mgl*Mst1**4.*Mt**8.)/288.+

     &  (313*Mgl**3.*Mt**10.)/144.+

     &  (251*Mgl**5.*Mt**10.)/(288.*Mst1**2.)+

     &  (1391*Mgl*Mst1**2.*Mt**10.)/288.-

     &  (781*Mgl*Mt**12.)/576.-

     &  (169*Mgl**3.*Mt**12.)/(192.*Mst1**2.)+

     &  (53*Mgl*Mt**14.)/(192.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mst1)*

     &  ln(mu,Mt)+((-7*Mgl**15.*Mt**2.)/72.-

     &  (Mgl**17.*Mt**2.)/(36.*Mst1**2.)+

     &  (61*Mgl**13.*Mst1**2.*Mt**2.)/72.-

     &  (119*Mgl**11.*Mst1**4.*Mt**2.)/72.+

     &  (65*Mgl**9.*Mst1**6.*Mt**2.)/72.+

     &  (67*Mgl**7.*Mst1**8.*Mt**2.)/72.-

     &  (113*Mgl**5.*Mst1**10.*Mt**2.)/72.+

     &  (59*Mgl**3.*Mst1**12.*Mt**2.)/72.-

     &  (11*Mgl*Mst1**14.*Mt**2.)/72.+

     &  (461*Mgl**13.*Mt**4.)/576.+

     &  (55*Mgl**15.*Mt**4.)/(576.*Mst1**2.)-

     &  (1997*Mgl**11.*Mst1**2.*Mt**4.)/576.+

     &  (1163*Mgl**9.*Mst1**4.*Mt**4.)/192.-

     &  (3595*Mgl**7.*Mst1**6.*Mt**4.)/576.+

     &  (1751*Mgl**5.*Mst1**8.*Mt**4.)/576.+

     &  (161*Mgl**3.*Mst1**10.*Mt**4.)/576.-

     &  (325*Mgl*Mst1**12.*Mt**4.)/576.-

     &  (67*Mgl**11.*Mt**6.)/32.-

     &  (Mgl**13.*Mt**6.)/(576.*Mst1**2.)+

     &  (3233*Mgl**9.*Mst1**2.*Mt**6.)/576.-

     &  (1337*Mgl**7.*Mst1**4.*Mt**6.)/144.+

     &  (2353*Mgl**5.*Mst1**6.*Mt**6.)/576.-

     &  (83*Mgl**3.*Mst1**8.*Mt**6.)/288.+

     &  (1135*Mgl*Mst1**10.*Mt**6.)/576.+

     &  (659*Mgl**9.*Mt**8.)/576.-

     &  (21*Mgl**11.*Mt**8.)/(64.*Mst1**2.)-

     &  (187*Mgl**7.*Mst1**2.*Mt**8.)/96.+

     &  (2155*Mgl**5.*Mst1**4.*Mt**8.)/288.+

     &  (287*Mgl**3.*Mst1**6.*Mt**8.)/576.+

     &  (407*Mgl*Mst1**8.*Mt**8.)/576.+

     &  (317*Mgl**7.*Mt**10.)/144.+

     &  (155*Mgl**9.*Mt**10.)/(576.*Mst1**2.)-

     &  (283*Mgl**5.*Mst1**2.*Mt**10.)/288.-

     &  (587*Mgl**3.*Mst1**4.*Mt**10.)/144.-

     &  (3469*Mgl*Mst1**6.*Mt**10.)/576.-

     &  (479*Mgl**5.*Mt**12.)/192.+

     &  (29*Mgl**7.*Mt**12.)/(64.*Mst1**2.)+

     &  (1183*Mgl**3.*Mst1**2.*Mt**12.)/576.+

     &  (3409*Mgl*Mst1**4.*Mt**12.)/576.+

     &  (5*Mgl**3.*Mt**14.)/32.-

     &  (515*Mgl**5.*Mt**14.)/(576.*Mst1**2.)-

     &  (1219*Mgl*Mst1**2.*Mt**14.)/576.+

     &  (221*Mgl*Mt**16.)/576.+

     &  (107*Mgl**3.*Mt**16.)/(192.*Mst1**2.)-

     &  (71*Mgl*Mt**18.)/(576.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mst1)*

     &  ln(mu,Mt)+(0.042317708333333336-

     &  (53*Mgl**2.)/(4608.*Mt**2.)+

     &  (53*Mst2**2.)/(4608.*Mt**2.))*ln(mu,Mst2)*ln(mu,Mt)

     &  +((-7*Mgl**4.)/192.+(5*Mgl**6.)/(576.*Mst2**2.)+

     &  (89*Mgl**2.*Mst2**2.)/1152.-(25*Mst2**4.)/1152.-

     &  (59*Mgl**6.)/(2304.*Mt**2.)+

     &  (Mgl**4.*Mst2**2.)/(384.*Mt**2.)+

     &  (55*Mgl**2.*Mst2**4.)/(768.*Mt**2.)-

     &  (7*Mst2**6.)/(144.*Mt**2.)+

     &  (263*Mgl**2.*Mt**2.)/2304.+

     &  (169*Mgl**4.*Mt**2.)/(2304.*Mst2**2.)-

     &  (23*Mst2**2.*Mt**2.)/256.+(341*Mt**4.)/1152.-

     &  (5*Mgl**2.*Mt**4.)/(576.*Mst2**2.)-

     &  (169*Mt**6.)/(2304.*Mst2**2.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mst2)*ln(mu,Mt)+

     &  ((-367*Mgl**8.)/2304.-Mgl**10./(64.*Mst2**2.)-

     &  (Mgl**6.*Mst2**2.)/1152.+(Mgl**4.*Mst2**4.)/4.+

     &  (11*Mgl**2.*Mst2**6.)/1152.-

     &  (193*Mst2**8.)/2304.+

     &  (25*Mgl**10.)/(576.*Mt**2.)-

     &  (265*Mgl**8.*Mst2**2.)/(2304.*Mt**2.)+

     &  (3*Mgl**6.*Mst2**4.)/(64.*Mt**2.)+

     &  (133*Mgl**4.*Mst2**6.)/(1152.*Mt**2.)-

     &  (37*Mgl**2.*Mst2**8.)/(288.*Mt**2.)+

     &  (29*Mst2**10.)/(768.*Mt**2.)+

     &  (251*Mgl**6.*Mt**2.)/1152.-

     &  (89*Mgl**8.*Mt**2.)/(2304.*Mst2**2.)+

     &  (67*Mgl**4.*Mst2**2.*Mt**2.)/144.-

     &  (799*Mgl**2.*Mst2**4.*Mt**2.)/1152.-

     &  (37*Mst2**6.*Mt**2.)/768.+

     &  (223*Mgl**4.*Mt**4.)/1152.+

     &  (209*Mgl**6.*Mt**4.)/(1152.*Mst2**2.)+

     &  (43*Mgl**2.*Mst2**2.*Mt**4.)/64.-

     &  (151*Mst2**4.*Mt**4.)/192.+

     &  (365*Mgl**2.*Mt**6.)/1152.-

     &  (7*Mgl**4.*Mt**6.)/(96.*Mst2**2.)+

     &  (375*Mst2**2.*Mt**6.)/256.-(1603*Mt**8.)/2304.-

     &  (191*Mgl**2.*Mt**8.)/(1152.*Mst2**2.)+

     &  (257*Mt**10.)/(2304.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mst2)*ln(mu,Mt)+

     &  ((11*Mgl**12.)/144.+(5*Mgl**10.*Mst2**2.)/128.-

     &  (581*Mgl**8.*Mst2**4.)/1152.+

     &  (281*Mgl**6.*Mst2**6.)/576.+

     &  (5*Mgl**4.*Mst2**8.)/192.-

     &  (175*Mgl**2.*Mst2**10.)/1152.+

     &  (31*Mst2**12.)/1152.-(7*Mgl**14.)/(768.*Mt**2.)+

     &  (23*Mgl**12.*Mst2**2.)/(1152.*Mt**2.)+

     &  (23*Mgl**10.*Mst2**4.)/(768.*Mt**2.)-

     &  (25*Mgl**8.*Mst2**6.)/(192.*Mt**2.)+

     &  (325*Mgl**6.*Mst2**8.)/(2304.*Mt**2.)-

     &  (19*Mgl**4.*Mst2**10.)/(384.*Mt**2.)-

     &  (7*Mgl**2.*Mst2**12.)/(768.*Mt**2.)+

     &  Mst2**14./(144.*Mt**2.)-

     &  (517*Mgl**10.*Mt**2.)/2304.-

     &  (65*Mgl**12.*Mt**2.)/(2304.*Mst2**2.)-

     &  (1243*Mgl**8.*Mst2**2.*Mt**2.)/2304.+

     &  (1889*Mgl**6.*Mst2**4.*Mt**2.)/1152.-

     &  (833*Mgl**4.*Mst2**6.*Mt**2.)/768.-

     &  (103*Mgl**2.*Mst2**8.*Mt**2.)/768.+

     &  (95*Mst2**10.*Mt**2.)/256.+

     &  (Mgl**8.*Mt**4.)/384.+

     &  (25*Mgl**10.*Mt**4.)/(576.*Mst2**2.)+

     &  (169*Mgl**6.*Mst2**2.*Mt**4.)/192.-

     &  (19*Mgl**4.*Mst2**4.*Mt**4.)/48.-

     &  (41*Mgl**2.*Mst2**6.*Mt**4.)/48.-

     &  (587*Mst2**8.*Mt**4.)/1152.+

     &  (161*Mgl**6.*Mt**6.)/256.+

     &  (73*Mgl**8.*Mt**6.)/(768.*Mst2**2.)+

     &  (91*Mgl**4.*Mst2**2.*Mt**6.)/96.+

     &  (1331*Mgl**2.*Mst2**4.*Mt**6.)/768.-

     &  (2693*Mst2**6.*Mt**6.)/2304.-

     &  (545*Mgl**4.*Mt**8.)/576.-

     &  (7*Mgl**6.*Mt**8.)/(36.*Mst2**2.)-

     &  (1039*Mgl**2.*Mst2**2.*Mt**8.)/1152.+

     &  (911*Mst2**4.*Mt**8.)/384.+

     &  (385*Mgl**2.*Mt**10.)/2304.+

     &  (5*Mgl**4.*Mt**10.)/(2304.*Mst2**2.)-

     &  (1025*Mst2**2.*Mt**10.)/768.+(39*Mt**12.)/128.+

     &  (29*Mgl**2.*Mt**12.)/(192.*Mst2**2.)-

     &  (53*Mt**14.)/(768.*Mst2**2.))*d123(Mt,Mgl,Mst2)**3.*

     &  ln(mu,Mst2)*ln(mu,Mt)+

     &  ((-109*Mgl**16.)/4608.+Mgl**18./(144.*Mst2**2.)-

     &  (115*Mgl**14.*Mst2**2.)/1152.+

     &  (19*Mgl**12.*Mst2**4.)/36.-

     &  (923*Mgl**10.*Mst2**6.)/1152.+

     &  (839*Mgl**8.*Mst2**8.)/2304.+

     &  (271*Mgl**6.*Mst2**10.)/1152.-

     &  (55*Mgl**4.*Mst2**12.)/192.+

     &  (29*Mgl**2.*Mst2**14.)/384.+(7*Mst2**16.)/4608.+

     &  (13*Mgl**18.)/(4608.*Mt**2.)-

     &  (43*Mgl**16.*Mst2**2.)/(4608.*Mt**2.)-

     &  (7*Mgl**14.*Mst2**4.)/(1152.*Mt**2.)+

     &  (77*Mgl**12.*Mst2**6.)/(1152.*Mt**2.)-

     &  (245*Mgl**10.*Mst2**8.)/(2304.*Mt**2.)+

     &  (91*Mgl**8.*Mst2**10.)/(2304.*Mt**2.)+

     &  (77*Mgl**6.*Mst2**12.)/(1152.*Mt**2.)-

     &  (103*Mgl**4.*Mst2**14.)/(1152.*Mt**2.)+

     &  (197*Mgl**2.*Mst2**16.)/(4608.*Mt**2.)-

     &  (35*Mst2**18.)/(4608.*Mt**2.)+

     &  (17*Mgl**14.*Mt**2.)/144.-

     &  (13*Mgl**16.*Mt**2.)/(768.*Mst2**2.)+

     &  (161*Mgl**12.*Mst2**2.*Mt**2.)/1152.-

     &  (271*Mgl**10.*Mst2**4.*Mt**2.)/192.+

     &  (197*Mgl**8.*Mst2**6.*Mt**2.)/72.-

     &  (697*Mgl**6.*Mst2**8.*Mt**2.)/288.+

     &  (329*Mgl**4.*Mst2**10.*Mt**2.)/384.+

     &  (25*Mgl**2.*Mst2**12.*Mt**2.)/192.-

     &  (305*Mst2**14.*Mt**2.)/2304.-

     &  (485*Mgl**12.*Mt**4.)/1152.-

     &  (3*Mgl**14.*Mt**4.)/(128.*Mst2**2.)+

     &  (Mgl**10.*Mst2**2.*Mt**4.)/6.+

     &  (481*Mgl**8.*Mst2**4.*Mt**4.)/288.-

     &  (1963*Mgl**6.*Mst2**6.*Mt**4.)/1152.+

     &  (491*Mgl**4.*Mst2**8.*Mt**4.)/1152.-

     &  (325*Mgl**2.*Mst2**10.*Mt**4.)/576.+

     &  (259*Mst2**12.*Mt**4.)/576.+

     &  (2341*Mgl**10.*Mt**6.)/2304.+

     &  (95*Mgl**12.*Mt**6.)/(1152.*Mst2**2.)-

     &  (3659*Mgl**8.*Mst2**2.*Mt**6.)/2304.-

     &  (199*Mgl**6.*Mst2**4.*Mt**6.)/1152.+

     &  (143*Mgl**4.*Mst2**6.*Mt**6.)/288.+

     &  (19*Mgl**2.*Mst2**8.*Mt**6.)/768.+

     &  (325*Mst2**10.*Mt**6.)/2304.-

     &  (1951*Mgl**8.*Mt**8.)/2304.+

     &  (17*Mgl**10.*Mt**8.)/(1152.*Mst2**2.)+

     &  (2693*Mgl**6.*Mst2**2.*Mt**8.)/1152.-

     &  (7*Mgl**4.*Mst2**4.*Mt**8.)/32.+

     &  (361*Mgl**2.*Mst2**6.*Mt**8.)/576.-

     &  (4601*Mst2**8.*Mt**8.)/2304.-

     &  (119*Mgl**6.*Mt**10.)/192.-

     &  (13*Mgl**8.*Mt**10.)/(72.*Mst2**2.)-

     &  (313*Mgl**4.*Mst2**2.*Mt**10.)/128.-

     &  (73*Mgl**2.*Mst2**4.*Mt**10.)/72.+

     &  (3227*Mst2**6.*Mt**10.)/1152.+

     &  (1355*Mgl**4.*Mt**12.)/1152.+

     &  (127*Mgl**6.*Mt**12.)/(1152.*Mst2**2.)+

     &  (71*Mgl**2.*Mst2**2.*Mt**12.)/64.-

     &  (115*Mst2**4.*Mt**12.)/72.-

     &  (1487*Mgl**2.*Mt**14.)/4608.+

     &  (97*Mgl**4.*Mt**14.)/(1152.*Mst2**2.)+

     &  (1793*Mst2**2.*Mt**14.)/4608.-

     &  (365*Mt**16.)/4608.-

     &  (125*Mgl**2.*Mt**16.)/(1152.*Mst2**2.)+

     &  (71*Mt**18.)/(2304.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**4.*ln(mu,Mst2)*ln(mu,Mt)-

     &  (25*Mgl*Xt*Den(Mst1,Mst2)*ln(mu,Mst2)*ln(mu,Mt))/

     &  1152.+((-53*Mgl**5.)/576.-

     &  (29*Mgl**3.*Mst2**2.)/576.+

     &  (41*Mgl*Mst2**4.)/288.+(7*Mgl**3.*Mt**2.)/576.+

     &  (5*Mgl**5.*Mt**2.)/(144.*Mst2**2.)+

     &  (19*Mgl*Mst2**2.*Mt**2.)/96.+

     &  (149*Mgl*Mt**4.)/192.+

     &  (149*Mgl**3.*Mt**4.)/(576.*Mst2**2.)-

     &  (169*Mgl*Mt**6.)/(576.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mst2)*ln(mu,Mt)

     &  +((13*Mgl**9.)/96.-(13*Mgl**7.*Mst2**2.)/64.-

     &  (23*Mgl**5.*Mst2**4.)/192.+

     &  (59*Mgl**3.*Mst2**6.)/192.-

     &  (23*Mgl*Mst2**8.)/192.-(43*Mgl**7.*Mt**2.)/64.-

     &  (Mgl**9.*Mt**2.)/(16.*Mst2**2.)-

     &  (29*Mgl**5.*Mst2**2.*Mt**2.)/72.+

     &  (209*Mgl**3.*Mst2**4.*Mt**2.)/576.-

     &  (17*Mgl*Mst2**6.*Mt**2.)/288.+

     &  (23*Mgl**5.*Mt**4.)/24.-

     &  (53*Mgl**7.*Mt**4.)/(576.*Mst2**2.)+

     &  (49*Mgl**3.*Mst2**2.*Mt**4.)/16.-

     &  (31*Mgl*Mst2**4.*Mt**4.)/576.+

     &  (97*Mgl**3.*Mt**6.)/64.+

     &  (157*Mgl**5.*Mt**6.)/(192.*Mst2**2.)+

     &  (467*Mgl*Mst2**2.*Mt**6.)/192.-

     &  (101*Mgl*Mt**8.)/48.-

     &  (71*Mgl**3.*Mt**8.)/(64.*Mst2**2.)+

     &  (257*Mgl*Mt**10.)/(576.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mst2)*

     &  ln(mu,Mt)+((-19*Mgl**13.)/576.+

     &  (17*Mgl**11.*Mst2**2.)/576.+

     &  (13*Mgl**9.*Mst2**4.)/72.-

     &  (103*Mgl**7.*Mst2**6.)/288.+

     &  (109*Mgl**5.*Mst2**8.)/576.+

     &  (13*Mgl**3.*Mst2**10.)/576.-(Mgl*Mst2**12.)/32.+

     &  (257*Mgl**11.*Mt**2.)/576.+

     &  (43*Mgl**9.*Mst2**2.*Mt**2.)/288.-

     &  (445*Mgl**7.*Mst2**4.*Mt**2.)/288.+

     &  (5*Mgl**5.*Mst2**6.*Mt**2.)/6.+

     &  (9*Mgl**3.*Mst2**8.*Mt**2.)/64.-

     &  (7*Mgl*Mst2**10.*Mt**2.)/288.-

     &  (407*Mgl**9.*Mt**4.)/192.-

     &  (65*Mgl**11.*Mt**4.)/(576.*Mst2**2.)-

     &  (113*Mgl**7.*Mst2**2.*Mt**4.)/48.+

     &  (541*Mgl**5.*Mst2**4.*Mt**4.)/144.-

     &  (779*Mgl**3.*Mst2**6.*Mt**4.)/576.-

     &  (221*Mgl*Mst2**8.*Mt**4.)/192.+

     &  (1151*Mgl**7.*Mt**6.)/288.+

     &  (55*Mgl**9.*Mt**6.)/(192.*Mst2**2.)+

     &  (1711*Mgl**5.*Mst2**2.*Mt**6.)/288.+

     &  (551*Mgl**3.*Mst2**4.*Mt**6.)/288.-

     &  (37*Mgl*Mst2**6.*Mt**6.)/192.-

     &  (643*Mgl**5.*Mt**8.)/192.+

     &  (3*Mgl**7.*Mt**8.)/(32.*Mst2**2.)-

     &  (949*Mgl**3.*Mst2**2.*Mt**8.)/576.+

     &  (41*Mgl*Mst2**4.*Mt**8.)/9.+

     &  (25*Mgl**3.*Mt**10.)/576.-

     &  (251*Mgl**5.*Mt**10.)/(288.*Mst2**2.)-

     &  (187*Mgl*Mst2**2.*Mt**10.)/48.+

     &  (65*Mgl*Mt**12.)/64.+

     &  (169*Mgl**3.*Mt**12.)/(192.*Mst2**2.)-

     &  (53*Mgl*Mt**14.)/(192.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mst2)*

     &  ln(mu,Mt)+((13*Mgl**17.)/1152.-

     &  (5*Mgl**15.*Mst2**2.)/192.-

     &  (29*Mgl**13.*Mst2**4.)/576.+

     &  (125*Mgl**11.*Mst2**6.)/576.-

     &  (5*Mgl**9.*Mst2**8.)/24.-

     &  (29*Mgl**7.*Mst2**10.)/576.+

     &  (125*Mgl**5.*Mst2**12.)/576.-

     &  (9*Mgl**3.*Mst2**14.)/64.+

     &  (35*Mgl*Mst2**16.)/1152.-

     &  (5*Mgl**15.*Mt**2.)/64.+

     &  (Mgl**17.*Mt**2.)/(36.*Mst2**2.)-

     &  (65*Mgl**13.*Mst2**2.*Mt**2.)/144.+

     &  (985*Mgl**11.*Mst2**4.*Mt**2.)/576.-

     &  (493*Mgl**9.*Mst2**6.*Mt**2.)/288.-

     &  (3*Mgl**7.*Mst2**8.*Mt**2.)/64.+

     &  (17*Mgl**5.*Mst2**10.*Mt**2.)/18.-

     &  (241*Mgl**3.*Mst2**12.*Mt**2.)/576.+

     &  (7*Mgl*Mst2**14.*Mt**2.)/288.+

     &  (131*Mgl**13.*Mt**4.)/288.-

     &  (55*Mgl**15.*Mt**4.)/(576.*Mst2**2.)+

     &  (211*Mgl**11.*Mst2**2.*Mt**4.)/144.-

     &  (377*Mgl**9.*Mst2**4.*Mt**4.)/64.+

     &  (433*Mgl**7.*Mst2**6.*Mt**4.)/64.-

     &  (413*Mgl**5.*Mst2**8.*Mt**4.)/144.-

     &  (37*Mgl**3.*Mst2**10.*Mt**4.)/96.+

     &  (319*Mgl*Mst2**12.*Mt**4.)/576.-

     &  (1231*Mgl**11.*Mt**6.)/576.+

     &  (Mgl**13.*Mt**6.)/(576.*Mst2**2.)-

     &  (1691*Mgl**9.*Mst2**2.*Mt**6.)/576.+

     &  (925*Mgl**7.*Mst2**4.*Mt**6.)/96.-

     &  (2273*Mgl**5.*Mst2**6.*Mt**6.)/576.+

     &  (361*Mgl**3.*Mst2**8.*Mt**6.)/576.-

     &  (239*Mgl*Mst2**10.*Mt**6.)/192.+

     &  (3761*Mgl**9.*Mt**8.)/576.+

     &  (21*Mgl**11.*Mt**8.)/(64.*Mst2**2.)+

     &  (1793*Mgl**7.*Mst2**2.*Mt**8.)/576.-

     &  (1385*Mgl**5.*Mst2**4.*Mt**8.)/192.-

     &  (41*Mgl**3.*Mst2**6.*Mt**8.)/32.-

     &  (521*Mgl*Mst2**8.*Mt**8.)/288.-

     &  (5867*Mgl**7.*Mt**10.)/576.-

     &  (155*Mgl**9.*Mt**10.)/(576.*Mst2**2.)-

     &  (379*Mgl**5.*Mst2**2.*Mt**10.)/96.+

     &  (153*Mgl**3.*Mst2**4.*Mt**10.)/64.+

     &  (3559*Mgl*Mst2**6.*Mt**10.)/576.+

     &  (2089*Mgl**5.*Mt**12.)/288.-

     &  (29*Mgl**7.*Mt**12.)/(64.*Mst2**2.)+

     &  (409*Mgl**3.*Mst2**2.*Mt**12.)/288.-

     &  (965*Mgl*Mst2**4.*Mt**12.)/192.-

     &  (953*Mgl**3.*Mt**14.)/576.+

     &  (515*Mgl**5.*Mt**14.)/(576.*Mst2**2.)+

     &  (785*Mgl*Mst2**2.*Mt**14.)/576.-

     &  (223*Mgl*Mt**16.)/1152.-

     &  (107*Mgl**3.*Mt**16.)/(192.*Mst2**2.)+

     &  (71*Mgl*Mt**18.)/(576.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mst2)*

     &  ln(mu,Mt)+(-0.0037977430555555555-

     &  (5*Mgl**2.)/(576.*Mst1**2.)-

     &  (5*Mgl**2.)/(576.*Mst2**2.)+

     &  (53*Mgl**2.)/(9216.*Mt**2.)-

     &  (53*Mst2**2.)/(9216.*Mt**2.)-

     &  (19*Mgl**2.*Mt**2.)/(9216.*Mst1**4.)-

     &  (7*Mt**2.)/(3072.*Mst1**2.)-

     &  (19*Mgl**2.*Mt**2.)/(9216.*Mst2**4.)-

     &  (7*Mt**2.)/(3072.*Mst2**2.)-

     &  (19*Mt**4.)/(9216.*Mst1**4.)-

     &  (19*Mt**4.)/(9216.*Mst2**4.))*ln(mu,Mt)**2.+

     &  ((-25*Mgl**4.)/576.-Mgl**8./(288.*Mst1**4.)+

     &  Mgl**6./(64.*Mst1**2.)-

     &  (13*Mgl**2.*Mst1**2.)/576.+(31*Mst1**4.)/576.+

     &  (29*Mgl**2.*Mt**2.)/2304.+

     &  (7*Mgl**6.*Mt**2.)/(768.*Mst1**4.)-

     &  (31*Mgl**4.*Mt**2.)/(768.*Mst1**2.)-

     &  (277*Mst1**2.*Mt**2.)/2304.+(35*Mt**4.)/768.-

     &  (5*Mgl**4.*Mt**4.)/(2304.*Mst1**4.)-

     &  (19*Mgl**2.*Mt**4.)/(384.*Mst1**2.)-

     &  (7*Mgl**2.*Mt**6.)/(768.*Mst1**4.)-

     &  (101*Mt**6.)/(2304.*Mst1**2.)+

     &  (13*Mt**8.)/(2304.*Mst1**4.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mt)**2.+

     &  ((107*Mgl**8.)/576.+Mgl**12./(288.*Mst1**4.)-

     &  (29*Mgl**10.)/(576.*Mst1**2.)-

     &  (17*Mgl**6.*Mst1**2.)/96.-

     &  (19*Mgl**4.*Mst1**4.)/144.+

     &  (163*Mgl**2.*Mst1**6.)/576.-(65*Mst1**8.)/576.-

     &  (29*Mgl**6.*Mt**2.)/72.-

     &  (109*Mgl**10.*Mt**2.)/(4608.*Mst1**4.)+

     &  (797*Mgl**8.*Mt**2.)/(4608.*Mst1**2.)+

     &  (355*Mgl**4.*Mst1**2.*Mt**2.)/1152.-

     &  (569*Mgl**2.*Mst1**4.*Mt**2.)/1536.+

     &  (485*Mst1**6.*Mt**2.)/1536.-

     &  (7*Mgl**4.*Mt**4.)/48.+

     &  (191*Mgl**8.*Mt**4.)/(4608.*Mst1**4.)+

     &  (31*Mgl**6.*Mt**4.)/(384.*Mst1**2.)+

     &  (77*Mgl**2.*Mst1**2.*Mt**4.)/576.-

     &  (955*Mst1**4.*Mt**4.)/4608.-

     &  (5*Mgl**2.*Mt**6.)/288.-

     &  (7*Mgl**6.*Mt**6.)/(768.*Mst1**4.)-

     &  (473*Mgl**4.*Mt**6.)/(2304.*Mst1**2.)+

     &  (485*Mst1**2.*Mt**6.)/1152.-(43*Mt**8.)/64.-

     &  (85*Mgl**4.*Mt**8.)/(2304.*Mst1**4.)-

     &  (301*Mgl**2.*Mt**8.)/(1152.*Mst1**2.)+

     &  (151*Mgl**2.*Mt**10.)/(4608.*Mst1**4.)+

     &  (1213*Mt**10.)/(4608.*Mst1**2.)-

     &  (37*Mt**12.)/(4608.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mt)**2.+

     &  ((-23*Mgl**12.)/72.+Mgl**16./(288.*Mst1**4.)+

     &  (7*Mgl**14.)/(144.*Mst1**2.)+

     &  (2*Mgl**10.*Mst1**2.)/3.-

     &  (35*Mgl**8.*Mst1**4.)/72.-

     &  (11*Mgl**6.*Mst1**6.)/48.+

     &  (11*Mgl**4.*Mst1**8.)/18.-

     &  (3*Mgl**2.*Mst1**10.)/8.+(23*Mst1**12.)/288.+

     &  (2213*Mgl**10.*Mt**2.)/2304.-

     &  (11*Mgl**14.*Mt**2.)/(2304.*Mst1**4.)-

     &  (635*Mgl**12.*Mt**2.)/(2304.*Mst1**2.)-

     &  (2963*Mgl**8.*Mst1**2.*Mt**2.)/2304.+

     &  (2647*Mgl**6.*Mst1**4.*Mt**2.)/2304.-

     &  (2537*Mgl**4.*Mst1**6.*Mt**2.)/2304.+

     &  (1807*Mgl**2.*Mst1**8.*Mt**2.)/2304.-

     &  (521*Mst1**10.*Mt**2.)/2304.-

     &  (193*Mgl**8.*Mt**4.)/768.-

     &  (53*Mgl**12.*Mt**4.)/(2304.*Mst1**4.)+

     &  (33*Mgl**10.*Mt**4.)/(128.*Mst1**2.)+

     &  (5*Mgl**6.*Mst1**2.*Mt**4.)/576.+

     &  (2125*Mgl**4.*Mst1**4.*Mt**4.)/2304.-

     &  (691*Mgl**2.*Mst1**6.*Mt**4.)/1152.-

     &  (725*Mst1**8.*Mt**4.)/2304.-

     &  (17*Mgl**6.*Mt**6.)/384.+

     &  (133*Mgl**10.*Mt**6.)/(2304.*Mst1**4.)+

     &  (1043*Mgl**8.*Mt**6.)/(2304.*Mst1**2.)+

     &  (523*Mgl**4.*Mst1**2.*Mt**6.)/1152.+

     &  (2369*Mgl**2.*Mst1**4.*Mt**6.)/2304.+

     &  (2231*Mst1**6.*Mt**6.)/2304.+

     &  (Mgl**4.*Mt**8.)/128.-

     &  (61*Mgl**8.*Mt**8.)/(2304.*Mst1**4.)-

     &  (305*Mgl**6.*Mt**8.)/(576.*Mst1**2.)+

     &  (29*Mgl**2.*Mst1**2.*Mt**8.)/576.+

     &  (83*Mst1**4.*Mt**8.)/256.-

     &  (3967*Mgl**2.*Mt**10.)/2304.-

     &  (89*Mgl**6.*Mt**10.)/(2304.*Mst1**4.)-

     &  (1205*Mgl**4.*Mt**10.)/(2304.*Mst1**2.)-

     &  (4427*Mst1**2.*Mt**10.)/2304.+

     &  (1051*Mt**12.)/768.+

     &  (35*Mgl**4.*Mt**12.)/(768.*Mst1**4.)+

     &  (977*Mgl**2.*Mt**12.)/(1152.*Mst1**2.)-

     &  (11*Mgl**2.*Mt**14.)/(768.*Mst1**4.)-

     &  (643*Mt**14.)/(2304.*Mst1**2.)+

     &  Mt**16./(2304.*Mst1**4.))*d123(Mt,Mgl,Mst1)**3.*

     &  ln(mu,Mt)**2.+

     &  ((73*Mgl**16.)/576.-Mgl**20./(288.*Mst1**4.)-

     &  Mgl**18./(192.*Mst1**2.)-

     &  (31*Mgl**14.*Mst1**2.)/72.+

     &  (91*Mgl**12.*Mst1**4.)/144.-

     &  (91*Mgl**10.*Mst1**6.)/288.-

     &  (91*Mgl**8.*Mst1**8.)/288.+

     &  (11*Mgl**6.*Mst1**10.)/18.-

     &  (121*Mgl**4.*Mst1**12.)/288.+

     &  (9*Mgl**2.*Mst1**14.)/64.-(11*Mst1**16.)/576.-

     &  (557*Mgl**14.*Mt**2.)/1152.+

     &  (197*Mgl**18.*Mt**2.)/(9216.*Mst1**4.)+

     &  (169*Mgl**16.*Mt**2.)/(3072.*Mst1**2.)+

     &  (203*Mgl**12.*Mst1**2.*Mt**2.)/192.-

     &  (771*Mgl**10.*Mst1**4.*Mt**2.)/512.+

     &  (9439*Mgl**8.*Mst1**6.*Mt**2.)/4608.-

     &  (143*Mgl**6.*Mst1**8.*Mt**2.)/64.+

     &  (559*Mgl**4.*Mst1**10.*Mt**2.)/384.-

     &  (4279*Mgl**2.*Mst1**12.*Mt**2.)/9216.+

     &  (463*Mst1**14.*Mt**2.)/9216.+

     &  (461*Mgl**12.*Mt**4.)/1152.-

     &  (161*Mgl**16.*Mt**4.)/(3072.*Mst1**4.)-

     &  (125*Mgl**14.*Mt**4.)/(1152.*Mst1**2.)-

     &  (197*Mgl**10.*Mst1**2.*Mt**4.)/288.+

     &  (65*Mgl**8.*Mst1**4.*Mt**4.)/512.+

     &  (2375*Mgl**6.*Mst1**6.*Mt**4.)/1152.-

     &  (1361*Mgl**4.*Mst1**8.*Mt**4.)/576.+

     &  (133*Mgl**2.*Mst1**10.*Mt**4.)/576.+

     &  (3577*Mst1**12.*Mt**4.)/9216.+

     &  (247*Mgl**10.*Mt**6.)/1152.+

     &  (145*Mgl**14.*Mt**6.)/(2304.*Mst1**4.)-

     &  (43*Mgl**12.*Mt**6.)/(256.*Mst1**2.)+

     &  (7*Mgl**8.*Mst1**2.*Mt**6.)/18.+

     &  (2413*Mgl**6.*Mst1**4.*Mt**6.)/2304.+

     &  (1205*Mgl**4.*Mst1**6.*Mt**6.)/2304.-

     &  (143*Mgl**2.*Mst1**8.*Mt**6.)/576.-

     &  (233*Mst1**10.*Mt**6.)/128.+

     &  (17*Mgl**8.*Mt**8.)/128.-

     &  (25*Mgl**12.*Mt**8.)/(768.*Mst1**4.)+

     &  (877*Mgl**10.*Mt**8.)/(1152.*Mst1**2.)-

     &  (Mgl**6.*Mst1**2.*Mt**8.)/16.+

     &  (871*Mgl**4.*Mst1**4.*Mt**8.)/768.+

     &  (1471*Mgl**2.*Mst1**6.*Mt**8.)/1152.+

     &  (1607*Mst1**8.*Mt**8.)/576.-

     &  (359*Mgl**6.*Mt**10.)/1152.-

     &  (5*Mgl**10.*Mt**10.)/(512.*Mst1**4.)-

     &  (3599*Mgl**8.*Mt**10.)/(4608.*Mst1**2.)+

     &  (59*Mgl**4.*Mst1**2.*Mt**10.)/192.-

     &  (469*Mgl**2.*Mst1**4.*Mt**10.)/1536.-

     &  (6193*Mst1**6.*Mt**10.)/4608.-

     &  (1297*Mgl**4.*Mt**12.)/1152.+

     &  (179*Mgl**8.*Mt**12.)/(4608.*Mst1**4.)+

     &  (29*Mgl**6.*Mt**12.)/(1152.*Mst1**2.)-

     &  (545*Mgl**2.*Mst1**2.*Mt**12.)/288.-

     &  (1393*Mst1**4.*Mt**12.)/1536.+

     &  (1789*Mgl**2.*Mt**14.)/1152.-

     &  (41*Mgl**6.*Mt**14.)/(768.*Mst1**4.)+

     &  (1021*Mgl**4.*Mt**14.)/(2304.*Mst1**2.)+

     &  (379*Mst1**2.*Mt**14.)/288.-(583*Mt**16.)/1152.+

     &  (35*Mgl**4.*Mt**16.)/(768.*Mst1**4.)-

     &  (311*Mgl**2.*Mt**16.)/(1152.*Mst1**2.)-

     &  (65*Mgl**2.*Mt**18.)/(3072.*Mst1**4.)+

     &  (443*Mt**18.)/(9216.*Mst1**2.)+

     &  (37*Mt**20.)/(9216.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.*ln(mu,Mt)**2.+

     &  ((-113*Mgl**4.)/2304.-Mgl**8./(288.*Mst2**4.)+

     &  Mgl**6./(64.*Mst2**2.)+

     &  (71*Mgl**2.*Mst2**2.)/1152.-(19*Mst2**4.)/768.-

     &  (7*Mgl**6.)/(576.*Mt**2.)+

     &  (7*Mgl**4.*Mst2**2.)/(192.*Mt**2.)-

     &  (7*Mgl**2.*Mst2**4.)/(192.*Mt**2.)+

     &  (7*Mst2**6.)/(576.*Mt**2.)+

     &  (71*Mgl**2.*Mt**2.)/2304.+

     &  (7*Mgl**6.*Mt**2.)/(768.*Mst2**4.)-

     &  (31*Mgl**4.*Mt**2.)/(768.*Mst2**2.)+

     &  (65*Mst2**2.*Mt**2.)/2304.-(5*Mt**4.)/576.-

     &  (5*Mgl**4.*Mt**4.)/(2304.*Mst2**4.)-

     &  (19*Mgl**2.*Mt**4.)/(384.*Mst2**2.)-

     &  (7*Mgl**2.*Mt**6.)/(768.*Mst2**4.)-

     &  (101*Mt**6.)/(2304.*Mst2**2.)+

     &  (13*Mt**8.)/(2304.*Mst2**4.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mt)**2.+

     &  ((377*Mgl**8.)/4608.+Mgl**12./(288.*Mst2**4.)-

     &  (29*Mgl**10.)/(576.*Mst2**2.)-

     &  (11*Mgl**6.*Mst2**2.)/384.+

     &  (47*Mgl**4.*Mst2**4.)/2304.-

     &  (59*Mgl**2.*Mst2**6.)/1152.+

     &  (113*Mst2**8.)/4608.+

     &  (35*Mgl**10.)/(4608.*Mt**2.)-

     &  (163*Mgl**8.*Mst2**2.)/(4608.*Mt**2.)+

     &  (151*Mgl**6.*Mst2**4.)/(2304.*Mt**2.)-

     &  (139*Mgl**4.*Mst2**6.)/(2304.*Mt**2.)+

     &  (127*Mgl**2.*Mst2**8.)/(4608.*Mt**2.)-

     &  (23*Mst2**10.)/(4608.*Mt**2.)-

     &  (21*Mgl**6.*Mt**2.)/64.-

     &  (109*Mgl**10.*Mt**2.)/(4608.*Mst2**4.)+

     &  (797*Mgl**8.*Mt**2.)/(4608.*Mst2**2.)+

     &  (151*Mgl**4.*Mst2**2.*Mt**2.)/1152.+

     &  (685*Mgl**2.*Mst2**4.*Mt**2.)/4608.-

     &  (155*Mst2**6.*Mt**2.)/1536.-

     &  (17*Mgl**4.*Mt**4.)/576.+

     &  (191*Mgl**8.*Mt**4.)/(4608.*Mst2**4.)+

     &  (31*Mgl**6.*Mt**4.)/(384.*Mst2**2.)+

     &  (31*Mgl**2.*Mst2**2.*Mt**4.)/192.+

     &  (869*Mst2**4.*Mt**4.)/4608.-

     &  (97*Mgl**2.*Mt**6.)/1536.-

     &  (7*Mgl**6.*Mt**6.)/(768.*Mst2**4.)-

     &  (473*Mgl**4.*Mt**6.)/(2304.*Mst2**2.)+

     &  (545*Mst2**2.*Mt**6.)/1536.-(3305*Mt**8.)/4608.-

     &  (85*Mgl**4.*Mt**8.)/(2304.*Mst2**4.)-

     &  (301*Mgl**2.*Mt**8.)/(1152.*Mst2**2.)+

     &  (151*Mgl**2.*Mt**10.)/(4608.*Mst2**4.)+

     &  (1213*Mt**10.)/(4608.*Mst2**2.)-

     &  (37*Mt**12.)/(4608.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mt)**2.+

     &  ((-439*Mgl**12.)/2304.+Mgl**16./(288.*Mst2**4.)+

     &  (7*Mgl**14.)/(144.*Mst2**2.)+

     &  (53*Mgl**10.*Mst2**2.)/384.+

     &  (209*Mgl**8.*Mst2**4.)/768.-

     &  (319*Mgl**6.*Mst2**6.)/576.+

     &  (895*Mgl**4.*Mst2**8.)/2304.-

     &  (137*Mgl**2.*Mst2**10.)/1152.+

     &  (29*Mst2**12.)/2304.-Mgl**14./(576.*Mt**2.)+

     &  (Mgl**12.*Mst2**2.)/(144.*Mt**2.)-

     &  (Mgl**10.*Mst2**4.)/(192.*Mt**2.)-

     &  (5*Mgl**8.*Mst2**6.)/(288.*Mt**2.)+

     &  (25*Mgl**6.*Mst2**8.)/(576.*Mt**2.)-

     &  (Mgl**4.*Mst2**10.)/(24.*Mt**2.)+

     &  (11*Mgl**2.*Mst2**12.)/(576.*Mt**2.)-

     &  Mst2**14./(288.*Mt**2.)+

     &  (157*Mgl**10.*Mt**2.)/256.-

     &  (11*Mgl**14.*Mt**2.)/(2304.*Mst2**4.)-

     &  (635*Mgl**12.*Mt**2.)/(2304.*Mst2**2.)-

     &  (803*Mgl**8.*Mst2**2.*Mt**2.)/2304.+

     &  (29*Mgl**6.*Mst2**4.*Mt**2.)/768.-

     &  (19*Mgl**4.*Mst2**6.*Mt**2.)/768.-

     &  (113*Mgl**2.*Mst2**8.*Mt**2.)/2304.+

     &  (119*Mst2**10.*Mt**2.)/2304.-

     &  (15*Mgl**8.*Mt**4.)/128.-

     &  (53*Mgl**12.*Mt**4.)/(2304.*Mst2**4.)+

     &  (33*Mgl**10.*Mt**4.)/(128.*Mst2**2.)-

     &  (23*Mgl**6.*Mst2**2.*Mt**4.)/48.+

     &  (1211*Mgl**4.*Mst2**4.*Mt**4.)/2304.+

     &  (121*Mgl**2.*Mst2**6.*Mt**4.)/384.-

     &  (23*Mst2**8.*Mt**4.)/48.+

     &  (43*Mgl**6.*Mt**6.)/1152.+

     &  (133*Mgl**10.*Mt**6.)/(2304.*Mst2**4.)+

     &  (1043*Mgl**8.*Mt**6.)/(2304.*Mst2**2.)-

     &  (25*Mgl**4.*Mst2**2.*Mt**6.)/1152.-

     &  (35*Mgl**2.*Mst2**4.*Mt**6.)/2304.+

     &  (727*Mst2**6.*Mt**6.)/2304.+

     &  (925*Mgl**4.*Mt**8.)/2304.-

     &  (61*Mgl**8.*Mt**8.)/(2304.*Mst2**4.)-

     &  (305*Mgl**6.*Mt**8.)/(576.*Mst2**2.)+

     &  (511*Mgl**2.*Mst2**2.*Mt**8.)/384.+

     &  (1813*Mst2**4.*Mt**8.)/1152.-

     &  (5335*Mgl**2.*Mt**10.)/2304.-

     &  (89*Mgl**6.*Mt**10.)/(2304.*Mst2**4.)-

     &  (1205*Mgl**4.*Mt**10.)/(2304.*Mst2**2.)-

     &  (6371*Mst2**2.*Mt**10.)/2304.+(151*Mt**12.)/96.+

     &  (35*Mgl**4.*Mt**12.)/(768.*Mst2**4.)+

     &  (977*Mgl**2.*Mt**12.)/(1152.*Mst2**2.)-

     &  (11*Mgl**2.*Mt**14.)/(768.*Mst2**4.)-

     &  (643*Mt**14.)/(2304.*Mst2**2.)+

     &  Mt**16./(2304.*Mst2**4.))*d123(Mt,Mgl,Mst2)**3.*

     &  ln(mu,Mt)**2.+

     &  ((331*Mgl**16.)/3072.-Mgl**20./(288.*Mst2**4.)-

     &  Mgl**18./(192.*Mst2**2.)-

     &  (379*Mgl**14.*Mst2**2.)/1152.+

     &  (991*Mgl**12.*Mst2**4.)/2304.-

     &  (67*Mgl**10.*Mst2**6.)/384.-

     &  (1021*Mgl**8.*Mst2**8.)/4608.+

     &  (419*Mgl**6.*Mst2**10.)/1152.-

     &  (179*Mgl**4.*Mst2**12.)/768.+

     &  (29*Mgl**2.*Mst2**14.)/384.-

     &  (95*Mst2**16.)/9216.+

     &  (5*Mgl**18.)/(9216.*Mt**2.)-

     &  (7*Mgl**16.*Mst2**2.)/(3072.*Mt**2.)-

     &  (Mgl**14.*Mst2**4.)/(768.*Mt**2.)+

     &  (7*Mgl**12.*Mst2**6.)/(256.*Mt**2.)-

     &  (119*Mgl**10.*Mst2**8.)/(1536.*Mt**2.)+

     &  (175*Mgl**8.*Mst2**10.)/(1536.*Mt**2.)-

     &  (77*Mgl**6.*Mst2**12.)/(768.*Mt**2.)+

     &  (41*Mgl**4.*Mst2**14.)/(768.*Mt**2.)-

     &  (49*Mgl**2.*Mst2**16.)/(3072.*Mt**2.)+

     &  (19*Mst2**18.)/(9216.*Mt**2.)-

     &  (257*Mgl**14.*Mt**2.)/576.+

     &  (197*Mgl**18.*Mt**2.)/(9216.*Mst2**4.)+

     &  (169*Mgl**16.*Mt**2.)/(3072.*Mst2**2.)+

     &  (863*Mgl**12.*Mst2**2.*Mt**2.)/1152.-

     &  (215*Mgl**10.*Mst2**4.*Mt**2.)/512.-

     &  (77*Mgl**8.*Mst2**6.*Mt**2.)/4608.+

     &  (3*Mgl**6.*Mst2**8.*Mt**2.)/128.+

     &  (5*Mgl**4.*Mst2**10.*Mt**2.)/96.-

     &  (37*Mgl**2.*Mst2**12.*Mt**2.)/3072.-

     &  (19*Mst2**14.*Mt**2.)/3072.+

     &  (709*Mgl**12.*Mt**4.)/1152.-

     &  (161*Mgl**16.*Mt**4.)/(3072.*Mst2**4.)-

     &  (125*Mgl**14.*Mt**4.)/(1152.*Mst2**2.)-

     &  (265*Mgl**10.*Mst2**2.*Mt**4.)/576.-

     &  (3335*Mgl**8.*Mst2**4.*Mt**4.)/4608.+

     &  (1363*Mgl**6.*Mst2**6.*Mt**4.)/1152.-

     &  (53*Mgl**4.*Mst2**8.*Mt**4.)/576.-

     &  (197*Mgl**2.*Mst2**10.*Mt**4.)/288.+

     &  (2969*Mst2**12.*Mt**4.)/9216.-

     &  (2591*Mgl**10.*Mt**6.)/4608.+

     &  (145*Mgl**14.*Mt**6.)/(2304.*Mst2**4.)-

     &  (43*Mgl**12.*Mt**6.)/(256.*Mst2**2.)+

     &  (509*Mgl**8.*Mst2**2.*Mt**6.)/1536.+

     &  (475*Mgl**6.*Mst2**4.*Mt**6.)/1152.-

     &  (67*Mgl**4.*Mst2**6.*Mt**6.)/192.+

     &  (5825*Mgl**2.*Mst2**8.*Mt**6.)/4608.-

     &  (1523*Mst2**10.*Mt**6.)/1536.+

     &  (4009*Mgl**8.*Mt**8.)/4608.-

     &  (25*Mgl**12.*Mt**8.)/(768.*Mst2**4.)+

     &  (877*Mgl**10.*Mt**8.)/(1152.*Mst2**2.)-

     &  (787*Mgl**6.*Mst2**2.*Mt**8.)/1152.-

     &  (233*Mgl**4.*Mst2**4.*Mt**8.)/576.-

     &  (431*Mgl**2.*Mst2**6.*Mt**8.)/288.+

     &  (3389*Mst2**8.*Mt**8.)/4608.-

     &  (101*Mgl**6.*Mt**10.)/1152.-

     &  (5*Mgl**10.*Mt**10.)/(512.*Mst2**4.)-

     &  (3599*Mgl**8.*Mt**10.)/(4608.*Mst2**2.)+

     &  (1405*Mgl**4.*Mst2**2.*Mt**10.)/576.+

     &  (14377*Mgl**2.*Mst2**4.*Mt**10.)/4608.+

     &  (5599*Mst2**6.*Mt**10.)/4608.-

     &  (563*Mgl**4.*Mt**12.)/288.+

     &  (179*Mgl**8.*Mt**12.)/(4608.*Mst2**4.)+

     &  (29*Mgl**6.*Mt**12.)/(1152.*Mst2**2.)-

     &  (145*Mgl**2.*Mst2**2.*Mt**12.)/36.-

     &  (4133*Mst2**4.*Mt**12.)/1536.+

     &  (19057*Mgl**2.*Mt**14.)/9216.-

     &  (41*Mgl**6.*Mt**14.)/(768.*Mst2**4.)+

     &  (1021*Mgl**4.*Mt**14.)/(2304.*Mst2**2.)+

     &  (18271*Mst2**2.*Mt**14.)/9216.-

     &  (5627*Mt**16.)/9216.+

     &  (35*Mgl**4.*Mt**16.)/(768.*Mst2**4.)-

     &  (311*Mgl**2.*Mt**16.)/(1152.*Mst2**2.)-

     &  (65*Mgl**2.*Mt**18.)/(3072.*Mst2**4.)+

     &  (443*Mt**18.)/(9216.*Mst2**2.)+

     &  (37*Mt**20.)/(9216.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.*ln(mu,Mt)**2.+

     &  ((25*Mgl)/2304.+(Mgl*Mt**2.)/(72.*Mst1**2.)-

     &  (Mgl*Mt**2.)/(72.*Mst2**2.)+

     &  (19*Mgl*Mt**4.)/(2304.*Mst1**4.)-

     &  (19*Mgl*Mt**4.)/(2304.*Mst2**4.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mt)**2.+

     &  ((5*Mgl**3.*Mt**2.)/48.+

     &  (Mgl**7.*Mt**2.)/(72.*Mst1**4.)-

     &  (7*Mgl**5.*Mt**2.)/(144.*Mst1**2.)+

     &  (Mgl*Mst1**2.*Mt**2.)/36.-(97*Mgl*Mt**4.)/576.-

     &  (29*Mgl**5.*Mt**4.)/(576.*Mst1**4.)+

     &  (7*Mgl**3.*Mt**4.)/(48.*Mst1**2.)+

     &  (17*Mgl**3.*Mt**6.)/(288.*Mst1**4.)+

     &  (5*Mgl*Mt**6.)/(36.*Mst1**2.)-

     &  (13*Mgl*Mt**8.)/(576.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((-5*Mgl**7.*Mt**2.)/9.-

     &  (Mgl**11.*Mt**2.)/(72.*Mst1**4.)+

     &  (Mgl**9.*Mt**2.)/(6.*Mst1**2.)+

     &  (4*Mgl**5.*Mst1**2.*Mt**2.)/9.+

     &  (13*Mgl**3.*Mst1**4.*Mt**2.)/72.-

     &  (2*Mgl*Mst1**6.*Mt**2.)/9.+

     &  (131*Mgl**5.*Mt**4.)/96.+

     &  (125*Mgl**9.*Mt**4.)/(1152.*Mst1**4.)-

     &  (181*Mgl**7.*Mt**4.)/(288.*Mst1**2.)-

     &  (13*Mgl**3.*Mst1**2.*Mt**4.)/16.+

     &  (169*Mgl*Mst1**4.*Mt**4.)/384.-

     &  (83*Mgl**3.*Mt**6.)/144.-

     &  (79*Mgl**7.*Mt**6.)/(288.*Mst1**4.)-

     &  (71*Mgl**5.*Mt**6.)/(288.*Mst1**2.)-

     &  (125*Mgl*Mst1**2.*Mt**6.)/144.+

     &  (539*Mgl*Mt**8.)/288.+

     &  (179*Mgl**5.*Mt**8.)/(576.*Mst1**4.)+

     &  (487*Mgl**3.*Mt**8.)/(288.*Mst1**2.)-

     &  (47*Mgl**3.*Mt**10.)/(288.*Mst1**4.)-

     &  (283*Mgl*Mt**10.)/(288.*Mst1**2.)+

     &  (37*Mgl*Mt**12.)/(1152.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((139*Mgl**11.*Mt**2.)/144.-

     &  (Mgl**15.*Mt**2.)/(72.*Mst1**4.)-

     &  (Mgl**13.*Mt**2.)/(6.*Mst1**2.)-

     &  (239*Mgl**9.*Mst1**2.*Mt**2.)/144.+

     &  (29*Mgl**7.*Mst1**4.*Mt**2.)/36.+

     &  (49*Mgl**5.*Mst1**6.*Mt**2.)/72.-

     &  (125*Mgl**3.*Mst1**8.*Mt**2.)/144.+

     &  (37*Mgl*Mst1**10.*Mt**2.)/144.-

     &  (199*Mgl**9.*Mt**4.)/64.+

     &  (19*Mgl**13.*Mt**4.)/(576.*Mst1**4.)+

     &  (33*Mgl**11.*Mt**4.)/(32.*Mst1**2.)+

     &  (457*Mgl**7.*Mst1**2.*Mt**4.)/144.-

     &  (1043*Mgl**5.*Mst1**4.*Mt**4.)/576.+

     &  (341*Mgl**3.*Mst1**6.*Mt**4.)/288.-

     &  (289*Mgl*Mst1**8.*Mt**4.)/576.+

     &  (235*Mgl**7.*Mt**6.)/144.+

     &  (17*Mgl**11.*Mt**6.)/(288.*Mst1**4.)-

     &  (361*Mgl**9.*Mt**6.)/(288.*Mst1**2.)-

     &  (203*Mgl**5.*Mst1**2.*Mt**6.)/144.-

     &  (815*Mgl**3.*Mst1**4.*Mt**6.)/288.-

     &  (83*Mgl*Mst1**6.*Mt**6.)/96.-

     &  (73*Mgl**5.*Mt**8.)/32.-

     &  (167*Mgl**9.*Mt**8.)/(576.*Mst1**4.)-

     &  (287*Mgl**7.*Mt**8.)/(144.*Mst1**2.)-

     &  (23*Mgl**3.*Mst1**2.*Mt**8.)/48.-

     &  (7*Mgl*Mst1**4.*Mt**8.)/576.+

     &  (259*Mgl**3.*Mt**10.)/36.+

     &  (19*Mgl**7.*Mt**10.)/(48.*Mst1**4.)+

     &  (799*Mgl**5.*Mt**10.)/(144.*Mst1**2.)+

     &  (319*Mgl*Mst1**2.*Mt**10.)/72.-

     &  (845*Mgl*Mt**12.)/192.-

     &  (139*Mgl**5.*Mt**12.)/(576.*Mst1**4.)-

     &  (409*Mgl**3.*Mt**12.)/(96.*Mst1**2.)+

     &  (17*Mgl**3.*Mt**14.)/(288.*Mst1**4.)+

     &  (35*Mgl*Mt**14.)/(32.*Mst1**2.)-

     &  (Mgl*Mt**16.)/(576.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((-17*Mgl**15.*Mt**2.)/36.+

     &  (Mgl**19.*Mt**2.)/(72.*Mst1**4.)+

     &  (5*Mgl**17.*Mt**2.)/(144.*Mst1**2.)+

     &  (5*Mgl**13.*Mst1**2.*Mt**2.)/4.-

     &  (23*Mgl**11.*Mst1**4.*Mt**2.)/18.-

     &  (Mgl**9.*Mst1**6.*Mt**2.)/72.+

     &  (5*Mgl**7.*Mst1**8.*Mt**2.)/4.-

     &  (43*Mgl**5.*Mst1**10.*Mt**2.)/36.+

     &  (35*Mgl**3.*Mst1**12.*Mt**2.)/72.-

     &  (11*Mgl*Mst1**14.*Mt**2.)/144.+

     &  (197*Mgl**13.*Mt**4.)/96.-

     &  (229*Mgl**17.*Mt**4.)/(2304.*Mst1**4.)-

     &  (17*Mgl**15.*Mt**4.)/(48.*Mst1**2.)-

     &  (329*Mgl**11.*Mst1**2.*Mt**4.)/96.+

     &  (4463*Mgl**9.*Mst1**4.*Mt**4.)/1152.-

     &  (155*Mgl**7.*Mst1**6.*Mt**4.)/36.+

     &  (487*Mgl**5.*Mst1**8.*Mt**4.)/144.-

     &  (359*Mgl**3.*Mst1**10.*Mt**4.)/288.+

     &  (287*Mgl*Mst1**12.*Mt**4.)/2304.-

     &  (23*Mgl**11.*Mt**6.)/9.+

     &  (89*Mgl**15.*Mt**6.)/(288.*Mst1**4.)+

     &  (79*Mgl**13.*Mt**6.)/(72.*Mst1**2.)+

     &  (1039*Mgl**9.*Mst1**2.*Mt**6.)/288.-

     &  (223*Mgl**7.*Mst1**4.*Mt**6.)/288.-

     &  (679*Mgl**5.*Mst1**6.*Mt**6.)/144.+

     &  (65*Mgl**3.*Mst1**8.*Mt**6.)/48.+

     &  (161*Mgl*Mst1**10.*Mt**6.)/96.+

     &  (205*Mgl**9.*Mt**8.)/288.-

     &  (323*Mgl**13.*Mt**8.)/(576.*Mst1**4.)-

     &  (71*Mgl**11.*Mt**8.)/(72.*Mst1**2.)-

     &  (641*Mgl**7.*Mst1**2.*Mt**8.)/144.-

     &  (4531*Mgl**5.*Mst1**4.*Mt**8.)/576.-

     &  (755*Mgl**3.*Mst1**6.*Mt**8.)/144.-

     &  (269*Mgl*Mst1**8.*Mt**8.)/48.-

     &  (47*Mgl**7.*Mt**10.)/18.+

     &  (199*Mgl**11.*Mt**10.)/(288.*Mst1**4.)-

     &  (197*Mgl**9.*Mt**10.)/(144.*Mst1**2.)+

     &  (301*Mgl**5.*Mst1**2.*Mt**10.)/144.+

     &  (1561*Mgl**3.*Mst1**4.*Mt**10.)/288.+

     &  (50*Mgl*Mst1**6.*Mt**10.)/9.+

     &  (739*Mgl**5.*Mt**12.)/96.-

     &  (751*Mgl**9.*Mt**12.)/(1152.*Mst1**4.)+

     &  (553*Mgl**7.*Mt**12.)/(144.*Mst1**2.)+

     &  (1261*Mgl**3.*Mst1**2.*Mt**12.)/288.+

     &  (23*Mgl*Mst1**4.*Mt**12.)/128.-

     &  (239*Mgl**3.*Mt**14.)/36.+

     &  (143*Mgl**7.*Mt**14.)/(288.*Mst1**4.)-

     &  (31*Mgl**5.*Mt**14.)/(9.*Mst1**2.)-

     &  (331*Mgl*Mst1**2.*Mt**14.)/96.+

     &  (523*Mgl*Mt**16.)/288.-

     &  (163*Mgl**5.*Mt**16.)/(576.*Mst1**4.)+

     &  (25*Mgl**3.*Mt**16.)/(18.*Mst1**2.)+

     &  (29*Mgl**3.*Mt**18.)/(288.*Mst1**4.)-

     &  (5*Mgl*Mt**18.)/(24.*Mst1**2.)-

     &  (37*Mgl*Mt**20.)/(2304.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((-7*Mgl**5.)/192.+(7*Mgl**3.*Mst2**2.)/96.-

     &  (7*Mgl*Mst2**4.)/192.-(5*Mgl**3.*Mt**2.)/64.-

     &  (Mgl**7.*Mt**2.)/(72.*Mst2**4.)+

     &  (7*Mgl**5.*Mt**2.)/(144.*Mst2**2.)+

     &  (11*Mgl*Mst2**2.*Mt**2.)/192.-

     &  (7*Mgl*Mt**4.)/576.+

     &  (29*Mgl**5.*Mt**4.)/(576.*Mst2**4.)-

     &  (7*Mgl**3.*Mt**4.)/(48.*Mst2**2.)-

     &  (17*Mgl**3.*Mt**6.)/(288.*Mst2**4.)-

     &  (5*Mgl*Mt**6.)/(36.*Mst2**2.)+

     &  (13*Mgl*Mt**8.)/(576.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((11*Mgl**9.)/384.-(5*Mgl**7.*Mst2**2.)/48.+

     &  (9*Mgl**5.*Mst2**4.)/64.-(Mgl**3.*Mst2**6.)/12.+

     &  (7*Mgl*Mst2**8.)/384.+(61*Mgl**7.*Mt**2.)/576.+

     &  (Mgl**11.*Mt**2.)/(72.*Mst2**4.)-

     &  (Mgl**9.*Mt**2.)/(6.*Mst2**2.)+

     &  (59*Mgl**5.*Mst2**2.*Mt**2.)/576.-

     &  (17*Mgl**3.*Mst2**4.*Mt**2.)/576.-

     &  (5*Mgl*Mst2**6.*Mt**2.)/192.-

     &  (115*Mgl**5.*Mt**4.)/192.-

     &  (125*Mgl**9.*Mt**4.)/(1152.*Mst2**4.)+

     &  (181*Mgl**7.*Mt**4.)/(288.*Mst2**2.)-

     &  (Mgl**3.*Mst2**2.*Mt**4.)/144.+

     &  (59*Mgl*Mst2**4.*Mt**4.)/1152.+

     &  (197*Mgl**3.*Mt**6.)/576.+

     &  (79*Mgl**7.*Mt**6.)/(288.*Mst2**4.)+

     &  (71*Mgl**5.*Mt**6.)/(288.*Mst2**2.)+

     &  (409*Mgl*Mst2**2.*Mt**6.)/576.-

     &  (2275*Mgl*Mt**8.)/1152.-

     &  (179*Mgl**5.*Mt**8.)/(576.*Mst2**4.)-

     &  (487*Mgl**3.*Mt**8.)/(288.*Mst2**2.)+

     &  (47*Mgl**3.*Mt**10.)/(288.*Mst2**4.)+

     &  (283*Mgl*Mt**10.)/(288.*Mst2**2.)-

     &  (37*Mgl*Mt**12.)/(1152.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  (-Mgl**13./192.+(Mgl**11.*Mst2**2.)/96.+

     &  (5*Mgl**9.*Mst2**4.)/192.-

     &  (5*Mgl**7.*Mst2**6.)/48.+

     &  (25*Mgl**5.*Mst2**8.)/192.-

     &  (7*Mgl**3.*Mst2**10.)/96.+(Mgl*Mst2**12.)/64.-

     &  (283*Mgl**11.*Mt**2.)/576.+

     &  (Mgl**15.*Mt**2.)/(72.*Mst2**4.)+

     &  (Mgl**13.*Mt**2.)/(6.*Mst2**2.)+

     &  (79*Mgl**9.*Mst2**2.*Mt**2.)/576.+

     &  (71*Mgl**7.*Mst2**4.*Mt**2.)/96.-

     &  (265*Mgl**5.*Mst2**6.*Mt**2.)/288.+

     &  (83*Mgl**3.*Mst2**8.*Mt**2.)/192.-

     &  (5*Mgl*Mst2**10.*Mt**2.)/64.+

     &  (967*Mgl**9.*Mt**4.)/576.-

     &  (19*Mgl**13.*Mt**4.)/(576.*Mst2**4.)-

     &  (33*Mgl**11.*Mt**4.)/(32.*Mst2**2.)-

     &  (31*Mgl**7.*Mst2**2.*Mt**4.)/144.-

     &  (421*Mgl**5.*Mst2**4.*Mt**4.)/576.+

     &  (95*Mgl**3.*Mst2**6.*Mt**4.)/288.+

     &  (Mgl*Mst2**8.*Mt**4.)/576.-

     &  (313*Mgl**7.*Mt**6.)/288.-

     &  (17*Mgl**11.*Mt**6.)/(288.*Mst2**4.)+

     &  (361*Mgl**9.*Mt**6.)/(288.*Mst2**2.)-

     &  (175*Mgl**5.*Mst2**2.*Mt**6.)/96.+

     &  (17*Mgl**3.*Mst2**4.*Mt**6.)/48.+

     &  (4*Mgl*Mst2**6.*Mt**6.)/9.+

     &  (2479*Mgl**5.*Mt**8.)/576.+

     &  (167*Mgl**9.*Mt**8.)/(576.*Mst2**4.)+

     &  (287*Mgl**7.*Mt**8.)/(144.*Mst2**2.)+

     &  (1223*Mgl**3.*Mst2**2.*Mt**8.)/288.+

     &  (9*Mgl*Mst2**4.*Mt**8.)/4.-

     &  (5467*Mgl**3.*Mt**10.)/576.-

     &  (19*Mgl**7.*Mt**10.)/(48.*Mst2**4.)-

     &  (799*Mgl**5.*Mt**10.)/(144.*Mst2**2.)-

     &  (3821*Mgl*Mst2**2.*Mt**10.)/576.+

     &  (2933*Mgl*Mt**12.)/576.+

     &  (139*Mgl**5.*Mt**12.)/(576.*Mst2**4.)+

     &  (409*Mgl**3.*Mt**12.)/(96.*Mst2**2.)-

     &  (17*Mgl**3.*Mt**14.)/(288.*Mst2**4.)-

     &  (35*Mgl*Mt**14.)/(32.*Mst2**2.)+

     &  (Mgl*Mt**16.)/(576.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((5*Mgl**17.)/2304.-(Mgl**15.*Mst2**2.)/144.-

     &  (7*Mgl**13.*Mst2**4.)/576.+

     &  (7*Mgl**11.*Mst2**6.)/72.-

     &  (245*Mgl**9.*Mst2**8.)/1152.+

     &  (35*Mgl**7.*Mst2**10.)/144.-

     &  (91*Mgl**5.*Mst2**12.)/576.+

     &  (Mgl**3.*Mst2**14.)/18.-

     &  (19*Mgl*Mst2**16.)/2304.+

     &  (227*Mgl**15.*Mt**2.)/576.-

     &  (Mgl**19.*Mt**2.)/(72.*Mst2**4.)-

     &  (5*Mgl**17.*Mt**2.)/(144.*Mst2**2.)-

     &  (527*Mgl**13.*Mst2**2.*Mt**2.)/576.+

     &  (157*Mgl**11.*Mst2**4.*Mt**2.)/192.+

     &  (13*Mgl**9.*Mst2**6.*Mt**2.)/576.-

     &  (125*Mgl**7.*Mst2**8.*Mt**2.)/192.+

     &  (323*Mgl**5.*Mst2**10.*Mt**2.)/576.-

     &  (41*Mgl**3.*Mst2**12.*Mt**2.)/192.+

     &  (19*Mgl*Mst2**14.*Mt**2.)/576.-

     &  (1051*Mgl**13.*Mt**4.)/576.+

     &  (229*Mgl**17.*Mt**4.)/(2304.*Mst2**4.)+

     &  (17*Mgl**15.*Mt**4.)/(48.*Mst2**2.)+

     &  (601*Mgl**11.*Mst2**2.*Mt**4.)/288.-

     &  (473*Mgl**9.*Mst2**4.*Mt**4.)/1152.-

     &  (Mgl**7.*Mst2**6.*Mt**4.)/2.+

     &  (47*Mgl**5.*Mst2**8.*Mt**4.)/192.-

     &  (31*Mgl**3.*Mst2**10.*Mt**4.)/288.+

     &  (133*Mgl*Mst2**12.*Mt**4.)/2304.+

     &  (1837*Mgl**11.*Mt**6.)/576.-

     &  (89*Mgl**15.*Mt**6.)/(288.*Mst2**4.)-

     &  (79*Mgl**13.*Mt**6.)/(72.*Mst2**2.)-

     &  (425*Mgl**9.*Mst2**2.*Mt**6.)/576.-

     &  (29*Mgl**7.*Mst2**4.*Mt**6.)/9.+

     &  (193*Mgl**5.*Mst2**6.*Mt**6.)/96.+

     &  (805*Mgl**3.*Mst2**8.*Mt**6.)/576.-

     &  (709*Mgl*Mst2**10.*Mt**6.)/576.-

     &  (5129*Mgl**9.*Mt**8.)/1152.+

     &  (323*Mgl**13.*Mt**8.)/(576.*Mst2**4.)+

     &  (71*Mgl**11.*Mt**8.)/(72.*Mst2**2.)-

     &  (43*Mgl**7.*Mst2**2.*Mt**8.)/18.+

     &  (715*Mgl**5.*Mst2**4.*Mt**8.)/288.-

     &  (133*Mgl**3.*Mst2**6.*Mt**8.)/144.+

     &  (3151*Mgl*Mst2**8.*Mt**8.)/1152.+

     &  (5357*Mgl**7.*Mt**10.)/576.-

     &  (199*Mgl**11.*Mt**10.)/(288.*Mst2**4.)+

     &  (197*Mgl**9.*Mt**10.)/(144.*Mst2**2.)+

     &  (5159*Mgl**5.*Mst2**2.*Mt**10.)/576.+

     &  (2797*Mgl**3.*Mst2**4.*Mt**10.)/576.-

     &  (119*Mgl*Mst2**6.*Mt**10.)/576.-

     &  (7771*Mgl**5.*Mt**12.)/576.+

     &  (751*Mgl**9.*Mt**12.)/(1152.*Mst2**4.)-

     &  (553*Mgl**7.*Mt**12.)/(144.*Mst2**2.)-

     &  (3655*Mgl**3.*Mst2**2.*Mt**12.)/288.-

     &  (5837*Mgl*Mst2**4.*Mt**12.)/1152.+

     &  (5251*Mgl**3.*Mt**14.)/576.-

     &  (143*Mgl**7.*Mt**14.)/(288.*Mst2**4.)+

     &  (31*Mgl**5.*Mt**14.)/(9.*Mst2**2.)+

     &  (3281*Mgl*Mst2**2.*Mt**14.)/576.-

     &  (5147*Mgl*Mt**16.)/2304.+

     &  (163*Mgl**5.*Mt**16.)/(576.*Mst2**4.)-

     &  (25*Mgl**3.*Mt**16.)/(18.*Mst2**2.)-

     &  (29*Mgl**3.*Mt**18.)/(288.*Mst2**4.)+

     &  (5*Mgl*Mt**18.)/(24.*Mst2**2.)+

     &  (37*Mgl*Mt**20.)/(2304.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((19*Mgl**2.)/(4608.*Mst1**4.)+37/(4608.*Mst1**2.)+

     &  (19*Mt**2.)/(4608.*Mst1**4.))*Tfin(Mt,Mgl,Mst1)+

     &  ((11*Mgl**2.)/384.-(11*Mgl**6.)/(1152.*Mst1**4.)-

     &  Mgl**4./(144.*Mst1**2.)+(17*Mst1**2.)/576.+

     &  (25*Mt**2.)/384.+

     &  (11*Mgl**4.*Mt**2.)/(1152.*Mst1**4.)-

     &  (5*Mgl**2.*Mt**2.)/(192.*Mst1**2.)+

     &  (11*Mgl**2.*Mt**4.)/(1152.*Mst1**4.)+

     &  (19*Mt**4.)/(576.*Mst1**2.)-

     &  (11*Mt**6.)/(1152.*Mst1**4.))*d123(Mt,Mgl,Mst1)*

     &  Tfin(Mt,Mgl,Mst1)+

     &  (-Mgl**6./36.+(25*Mgl**10.)/(2304.*Mst1**4.)-

     &  (35*Mgl**8.)/(2304.*Mst1**2.)+

     &  (49*Mgl**4.*Mst1**2.)/288.+

     &  (127*Mgl**2.*Mst1**4.)/2304.-

     &  (445*Mst1**6.)/2304.+(31*Mgl**4.*Mt**2.)/192.-

     &  (11*Mgl**8.*Mt**2.)/(256.*Mst1**4.)-

     &  (Mgl**6.*Mt**2.)/(18.*Mst1**2.)+

     &  (13*Mgl**2.*Mst1**2.*Mt**2.)/64.-

     &  (101*Mst1**4.*Mt**2.)/2304.-

     &  (11*Mgl**2.*Mt**4.)/96.+

     &  (49*Mgl**6.*Mt**4.)/(1152.*Mst1**4.)-

     &  (35*Mgl**4.*Mt**4.)/(1152.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**4.)/576.+(83*Mt**6.)/192.+

     &  (25*Mgl**4.*Mt**6.)/(1152.*Mst1**4.)+

     &  (89*Mgl**2.*Mt**6.)/(288.*Mst1**2.)-

     &  (41*Mgl**2.*Mt**8.)/(768.*Mst1**4.)-

     &  (479*Mt**8.)/(2304.*Mst1**2.)+

     &  (49*Mt**10.)/(2304.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**2.*Tfin(Mt,Mgl,Mst1)+

     &  ((65*Mgl**10.)/1152.+Mgl**14./(1152.*Mst1**4.)+

     &  Mgl**12./(48.*Mst1**2.)-

     &  (7*Mgl**8.*Mst1**2.)/16.+

     &  (595*Mgl**6.*Mst1**4.)/1152.+

     &  (13*Mgl**4.*Mst1**6.)/72.-

     &  (661*Mgl**2.*Mst1**8.)/1152.+(17*Mst1**10.)/72.-

     &  (809*Mgl**8.*Mt**2.)/1152.+

     &  (5*Mgl**12.*Mt**2.)/(384.*Mst1**4.)+

     &  (17*Mgl**10.*Mt**2.)/(192.*Mst1**2.)+

     &  (107*Mgl**6.*Mst1**2.*Mt**2.)/96.-

     &  (947*Mgl**4.*Mst1**4.*Mt**2.)/1152.+

     &  (179*Mgl**2.*Mst1**6.*Mt**2.)/576.-

     &  (Mst1**8.*Mt**2.)/384.+

     &  (245*Mgl**6.*Mt**4.)/576.-

     &  (79*Mgl**10.*Mt**4.)/(1152.*Mst1**4.)-

     &  (23*Mgl**8.*Mt**4.)/(64.*Mst1**2.)-

     &  (131*Mgl**4.*Mst1**2.*Mt**4.)/288.+

     &  (29*Mgl**2.*Mst1**4.*Mt**4.)/1152.-

     &  (487*Mst1**6.*Mt**4.)/576.-

     &  (25*Mgl**4.*Mt**6.)/576.+

     &  (119*Mgl**8.*Mt**6.)/(1152.*Mst1**4.)+

     &  (67*Mgl**6.*Mt**6.)/(288.*Mst1**2.)-

     &  (185*Mgl**2.*Mst1**2.*Mt**6.)/288.+

     &  (19*Mst1**4.*Mt**6.)/1152.+

     &  (1637*Mgl**2.*Mt**8.)/1152.-

     &  (7*Mgl**6.*Mt**8.)/(384.*Mst1**4.)+

     &  (115*Mgl**4.*Mt**8.)/(288.*Mst1**2.)+

     &  (49*Mst1**2.*Mt**8.)/32.-(1333*Mt**10.)/1152.-

     &  (107*Mgl**4.*Mt**10.)/(1152.*Mst1**4.)-

     &  (361*Mgl**2.*Mt**10.)/(576.*Mst1**2.)+

     &  (11*Mgl**2.*Mt**12.)/(128.*Mst1**4.)+

     &  (47*Mt**12.)/(192.*Mst1**2.)-

     &  (3*Mt**14.)/(128.*Mst1**4.))*d123(Mt,Mgl,Mst1)**3.*

     &  Tfin(Mt,Mgl,Mst1)+

     &  ((-53*Mgl**14.)/576.-

     &  (29*Mgl**18.)/(4608.*Mst1**4.)+

     &  (65*Mgl**16.)/(4608.*Mst1**2.)+

     &  (4*Mgl**12.*Mst1**2.)/9.-

     &  (1877*Mgl**10.*Mst1**4.)/2304.+

     &  (997*Mgl**8.*Mst1**6.)/2304.+

     &  (35*Mgl**6.*Mst1**8.)/72.-

     &  (467*Mgl**4.*Mst1**10.)/576.+

     &  (1967*Mgl**2.*Mst1**12.)/4608.-

     &  (371*Mst1**14.)/4608.+(23*Mgl**12.*Mt**2.)/48.+

     &  (19*Mgl**16.*Mt**2.)/(512.*Mst1**4.)-

     &  (3*Mgl**14.*Mt**2.)/(32.*Mst1**2.)-

     &  (743*Mgl**10.*Mst1**2.*Mt**2.)/576.+

     &  (5059*Mgl**8.*Mst1**4.*Mt**2.)/2304.-

     &  (211*Mgl**6.*Mst1**6.*Mt**2.)/72.+

     &  (1301*Mgl**4.*Mst1**8.*Mt**2.)/576.-

     &  (331*Mgl**2.*Mst1**10.*Mt**2.)/576.-

     &  (377*Mst1**12.*Mt**2.)/4608.-

     &  (15*Mgl**10.*Mt**4.)/64.-

     &  (89*Mgl**14.*Mt**4.)/(1152.*Mst1**4.)+

     &  (25*Mgl**12.*Mt**4.)/(128.*Mst1**2.)+

     &  (161*Mgl**8.*Mst1**2.*Mt**4.)/576.-

     &  (1781*Mgl**6.*Mst1**4.*Mt**4.)/1152.-

     &  (Mgl**4.*Mst1**6.*Mt**4.)/384.+

     &  (19*Mgl**2.*Mst1**8.*Mt**4.)/288.+

     &  (95*Mst1**10.*Mt**4.)/72.-

     &  (283*Mgl**8.*Mt**6.)/288.+

     &  (17*Mgl**12.*Mt**6.)/(384.*Mst1**4.)-

     &  (7*Mgl**10.*Mt**6.)/(36.*Mst1**2.)+

     &  (79*Mgl**6.*Mst1**2.*Mt**6.)/96.-

     &  (1153*Mgl**4.*Mst1**4.*Mt**6.)/1152.-

     &  (47*Mgl**2.*Mst1**6.*Mt**6.)/288.-

     &  (485*Mst1**8.*Mt**6.)/192.+

     &  (191*Mgl**6.*Mt**8.)/192.+

     &  (55*Mgl**10.*Mt**8.)/(768.*Mst1**4.)+

     &  (109*Mgl**8.*Mt**8.)/(768.*Mst1**2.)-

     &  (85*Mgl**4.*Mst1**2.*Mt**8.)/96.-

     &  (1505*Mgl**2.*Mst1**4.*Mt**8.)/2304.+

     &  (3065*Mst1**6.*Mt**8.)/2304.+

     &  (5*Mgl**4.*Mt**10.)/9.-

     &  (283*Mgl**8.*Mt**10.)/(2304.*Mst1**4.)-

     &  (11*Mgl**6.*Mt**10.)/(288.*Mst1**2.)+

     &  (1133*Mgl**2.*Mst1**2.*Mt**10.)/576.+

     &  (2143*Mst1**4.*Mt**10.)/2304.-

     &  (235*Mgl**2.*Mt**12.)/192.+

     &  (17*Mgl**6.*Mt**12.)/(384.*Mst1**4.)-

     &  (19*Mgl**4.*Mt**12.)/(128.*Mst1**2.)-

     &  (257*Mst1**2.*Mt**12.)/192.+(145*Mt**14.)/288.+

     &  (13*Mgl**4.*Mt**14.)/(384.*Mst1**4.)+

     &  (3*Mgl**2.*Mt**14.)/(16.*Mst1**2.)-

     &  (149*Mgl**2.*Mt**16.)/(4608.*Mst1**4.)-

     &  (295*Mt**16.)/(4608.*Mst1**2.)+

     &  (35*Mt**18.)/(4608.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.*Tfin(Mt,Mgl,Mst1)-

     &  (19*Mgl*Mt**2.*Xt*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1))/

     &  (1152.*Mst1**4.)+

     &  ((-3*Mgl*Mt**2.)/16.+

     &  (11*Mgl**5.*Mt**2.)/(288.*Mst1**4.)+

     &  (23*Mgl**3.*Mt**2.)/(288.*Mst1**2.)-

     &  (11*Mgl**3.*Mt**4.)/(144.*Mst1**4.)-

     &  (23*Mgl*Mt**4.)/(288.*Mst1**2.)+

     &  (11*Mgl*Mt**6.)/(288.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1)+

     &  ((79*Mgl**5.*Mt**2.)/288.-

     &  (25*Mgl**9.*Mt**2.)/(576.*Mst1**4.)-

     &  (13*Mgl**7.*Mt**2.)/(288.*Mst1**2.)-

     &  (13*Mgl**3.*Mst1**2.*Mt**2.)/32.-

     &  (97*Mgl*Mst1**4.*Mt**2.)/576.-

     &  (53*Mgl**3.*Mt**4.)/144.+

     &  (31*Mgl**7.*Mt**4.)/(144.*Mst1**4.)+

     &  (211*Mgl**5.*Mt**4.)/(288.*Mst1**2.)-

     &  (47*Mgl*Mst1**2.*Mt**4.)/288.-

     &  (233*Mgl*Mt**6.)/288.-

     &  (37*Mgl**5.*Mt**6.)/(96.*Mst1**4.)-

     &  (395*Mgl**3.*Mt**6.)/(288.*Mst1**2.)+

     &  (43*Mgl**3.*Mt**8.)/(144.*Mst1**4.)+

     &  (197*Mgl*Mt**8.)/(288.*Mst1**2.)-

     &  (49*Mgl*Mt**10.)/(576.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1)

     &  +((-7*Mgl**9.*Mt**2.)/48.-

     &  (Mgl**13.*Mt**2.)/(288.*Mst1**4.)-

     &  (25*Mgl**11.*Mt**2.)/(288.*Mst1**2.)+

     &  (65*Mgl**7.*Mst1**2.*Mt**2.)/48.-

     &  (349*Mgl**5.*Mst1**4.*Mt**2.)/288.-

     &  (173*Mgl**3.*Mst1**6.*Mt**2.)/288.+

     &  (25*Mgl*Mst1**8.*Mt**2.)/36.+

     &  (65*Mgl**7.*Mt**4.)/36.-

     &  (7*Mgl**11.*Mt**4.)/(144.*Mst1**4.)-

     &  (91*Mgl**9.*Mt**4.)/(288.*Mst1**2.)-

     &  (385*Mgl**5.*Mst1**2.*Mt**4.)/144.+

     &  (191*Mgl**3.*Mst1**4.*Mt**4.)/144.+

     &  (101*Mgl*Mst1**6.*Mt**4.)/288.+

     &  (17*Mgl**5.*Mt**6.)/72.+

     &  (31*Mgl**9.*Mt**6.)/(96.*Mst1**4.)+

     &  (299*Mgl**7.*Mt**6.)/(144.*Mst1**2.)+

     &  (107*Mgl**3.*Mst1**2.*Mt**6.)/48.-

     &  (67*Mgl*Mst1**4.*Mt**6.)/96.-

     &  (197*Mgl**3.*Mt**8.)/36.-

     &  (53*Mgl**7.*Mt**8.)/(72.*Mst1**4.)-

     &  (539*Mgl**5.*Mt**8.)/(144.*Mst1**2.)-

     &  (451*Mgl*Mst1**2.*Mt**8.)/144.+

     &  (515*Mgl*Mt**10.)/144.+

     &  (233*Mgl**5.*Mt**10.)/(288.*Mst1**4.)+

     &  (851*Mgl**3.*Mt**10.)/(288.*Mst1**2.)-

     &  (7*Mgl**3.*Mt**12.)/(16.*Mst1**4.)-

     &  (85*Mgl*Mt**12.)/(96.*Mst1**2.)+

     &  (3*Mgl*Mt**14.)/(32.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1)

     &  +((97*Mgl**13.*Mt**2.)/288.+

     &  (29*Mgl**17.*Mt**2.)/(1152.*Mst1**4.)-

     &  (Mgl**15.*Mt**2.)/(32.*Mst1**2.)-

     &  (415*Mgl**11.*Mst1**2.*Mt**2.)/288.+

     &  (349*Mgl**9.*Mst1**4.*Mt**2.)/192.+

     &  (25*Mgl**7.*Mst1**6.*Mt**2.)/288.-

     &  (535*Mgl**5.*Mst1**8.*Mt**2.)/288.+

     &  (133*Mgl**3.*Mst1**10.*Mt**2.)/96.-

     &  (371*Mgl*Mst1**12.*Mt**2.)/1152.-

     &  (97*Mgl**11.*Mt**4.)/48.-

     &  (25*Mgl**15.*Mt**4.)/(144.*Mst1**4.)+

     &  (67*Mgl**13.*Mt**4.)/(288.*Mst1**2.)+

     &  (1319*Mgl**9.*Mst1**2.*Mt**4.)/288.-

     &  (289*Mgl**7.*Mst1**4.*Mt**4.)/48.+

     &  (539*Mgl**5.*Mst1**6.*Mt**4.)/96.-

     &  (25*Mgl**3.*Mst1**8.*Mt**4.)/16.-

     &  (187*Mgl*Mst1**10.*Mt**4.)/288.+

     &  (233*Mgl**9.*Mt**6.)/96.+

     &  (139*Mgl**13.*Mt**6.)/(288.*Mst1**4.)-

     &  (17*Mgl**11.*Mt**6.)/(32.*Mst1**2.)-

     &  (157*Mgl**7.*Mst1**2.*Mt**6.)/48.+

     &  (2573*Mgl**5.*Mst1**4.*Mt**6.)/288.+

     &  (959*Mgl**3.*Mst1**6.*Mt**6.)/288.+

     &  (1333*Mgl*Mst1**8.*Mt**6.)/288.+

     &  (155*Mgl**7.*Mt**8.)/72.-

     &  (95*Mgl**11.*Mt**8.)/(144.*Mst1**4.)+

     &  (187*Mgl**9.*Mt**8.)/(288.*Mst1**2.)+

     &  (307*Mgl**5.*Mst1**2.*Mt**8.)/144.-

     &  (403*Mgl**3.*Mst1**4.*Mt**8.)/144.-

     &  (1577*Mgl*Mst1**6.*Mt**8.)/288.-

     &  (2009*Mgl**5.*Mt**10.)/288.+

     &  (215*Mgl**9.*Mt**10.)/(576.*Mst1**4.)-

     &  (27*Mgl**7.*Mt**10.)/(32.*Mst1**2.)-

     &  (1603*Mgl**3.*Mst1**2.*Mt**10.)/288.-

     &  (89*Mgl*Mst1**4.*Mt**10.)/576.+

     &  (845*Mgl**3.*Mt**12.)/144.+

     &  (17*Mgl**7.*Mt**12.)/(144.*Mst1**4.)+

     &  (107*Mgl**5.*Mt**12.)/(96.*Mst1**2.)+

     &  (1027*Mgl*Mst1**2.*Mt**12.)/288.-

     &  (515*Mgl*Mt**14.)/288.-

     &  (85*Mgl**5.*Mt**14.)/(288.*Mst1**4.)-

     &  (235*Mgl**3.*Mt**14.)/(288.*Mst1**2.)+

     &  (23*Mgl**3.*Mt**16.)/(144.*Mst1**4.)+

     &  (65*Mgl*Mt**16.)/(288.*Mst1**2.)-

     &  (35*Mgl*Mt**18.)/(1152.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1)

     &  +((19*Mgl**2.)/(4608.*Mst2**4.)+

     &  37/(4608.*Mst2**2.)-(53*Mgl**2.)/(4608.*Mt**4.)+

     &  (53*Mst2**2.)/(4608.*Mt**4.)+1/(1536.*Mt**2.)+

     &  (19*Mt**2.)/(4608.*Mst2**4.))*Tfin(Mt,Mgl,Mst2)+

     &  ((13*Mgl**2.)/384.-(11*Mgl**6.)/(1152.*Mst2**4.)-

     &  Mgl**4./(144.*Mst2**2.)-(25*Mst2**2.)/288.+

     &  (7*Mgl**6.)/(288.*Mt**4.)-

     &  (7*Mgl**4.*Mst2**2.)/(96.*Mt**4.)+

     &  (7*Mgl**2.*Mst2**4.)/(96.*Mt**4.)-

     &  (7*Mst2**6.)/(288.*Mt**4.)+

     &  (13*Mgl**4.)/(1152.*Mt**2.)-

     &  (17*Mgl**2.*Mst2**2.)/(576.*Mt**2.)+

     &  (7*Mst2**4.)/(384.*Mt**2.)+(19*Mt**2.)/144.+

     &  (11*Mgl**4.*Mt**2.)/(1152.*Mst2**4.)-

     &  (5*Mgl**2.*Mt**2.)/(192.*Mst2**2.)+

     &  (11*Mgl**2.*Mt**4.)/(1152.*Mst2**4.)+

     &  (19*Mt**4.)/(576.*Mst2**2.)-

     &  (11*Mt**6.)/(1152.*Mst2**4.))*d123(Mt,Mgl,Mst2)*

     &  Tfin(Mt,Mgl,Mst2)+

     &  ((-5*Mgl**6.)/96.+(25*Mgl**10.)/(2304.*Mst2**4.)-

     &  (35*Mgl**8.)/(2304.*Mst2**2.)+

     &  (37*Mgl**4.*Mst2**2.)/96.-

     &  (505*Mgl**2.*Mst2**4.)/2304.-

     &  (253*Mst2**6.)/2304.-

     &  (35*Mgl**10.)/(2304.*Mt**4.)+

     &  (163*Mgl**8.*Mst2**2.)/(2304.*Mt**4.)-

     &  (151*Mgl**6.*Mst2**4.)/(1152.*Mt**4.)+

     &  (139*Mgl**4.*Mst2**6.)/(1152.*Mt**4.)-

     &  (127*Mgl**2.*Mst2**8.)/(2304.*Mt**4.)+

     &  (23*Mst2**10.)/(2304.*Mt**4.)+

     &  (191*Mgl**8.)/(2304.*Mt**2.)-

     &  (115*Mgl**6.*Mst2**2.)/(576.*Mt**2.)+

     &  (59*Mgl**4.*Mst2**4.)/(384.*Mt**2.)-

     &  (23*Mgl**2.*Mst2**6.)/(576.*Mt**2.)+

     &  (7*Mst2**8.)/(2304.*Mt**2.)+

     &  (31*Mgl**4.*Mt**2.)/576.-

     &  (11*Mgl**8.*Mt**2.)/(256.*Mst2**4.)-

     &  (Mgl**6.*Mt**2.)/(18.*Mst2**2.)+

     &  (77*Mgl**2.*Mst2**2.*Mt**2.)/576.-

     &  (581*Mst2**4.*Mt**2.)/2304.-

     &  (149*Mgl**2.*Mt**4.)/2304.+

     &  (49*Mgl**6.*Mt**4.)/(1152.*Mst2**4.)-

     &  (35*Mgl**4.*Mt**4.)/(1152.*Mst2**2.)+

     &  (221*Mst2**2.*Mt**4.)/2304.+(1013*Mt**6.)/2304.+

     &  (25*Mgl**4.*Mt**6.)/(1152.*Mst2**4.)+

     &  (89*Mgl**2.*Mt**6.)/(288.*Mst2**2.)-

     &  (41*Mgl**2.*Mt**8.)/(768.*Mst2**4.)-

     &  (479*Mt**8.)/(2304.*Mst2**2.)+

     &  (49*Mt**10.)/(2304.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**2.*Tfin(Mt,Mgl,Mst2)+

     &  ((289*Mgl**10.)/1152.+Mgl**14./(1152.*Mst2**4.)+

     &  Mgl**12./(48.*Mst2**2.)-

     &  (15*Mgl**8.*Mst2**2.)/16.+

     &  (123*Mgl**6.*Mst2**4.)/128.+

     &  (Mgl**4.*Mst2**6.)/9.-

     &  (853*Mgl**2.*Mst2**8.)/1152.+Mst2**10./3.+

     &  Mgl**14./(288.*Mt**4.)-

     &  (Mgl**12.*Mst2**2.)/(72.*Mt**4.)+

     &  (Mgl**10.*Mst2**4.)/(96.*Mt**4.)+

     &  (5*Mgl**8.*Mst2**6.)/(144.*Mt**4.)-

     &  (25*Mgl**6.*Mst2**8.)/(288.*Mt**4.)+

     &  (Mgl**4.*Mst2**10.)/(12.*Mt**4.)-

     &  (11*Mgl**2.*Mst2**12.)/(288.*Mt**4.)+

     &  Mst2**14./(144.*Mt**4.)-

     &  (35*Mgl**12.)/(384.*Mt**2.)+

     &  (233*Mgl**10.*Mst2**2.)/(576.*Mt**2.)-

     &  (289*Mgl**8.*Mst2**4.)/(384.*Mt**2.)+

     &  (227*Mgl**6.*Mst2**6.)/(288.*Mt**2.)-

     &  (607*Mgl**4.*Mst2**8.)/(1152.*Mt**2.)+

     &  (43*Mgl**2.*Mst2**10.)/(192.*Mt**2.)-

     &  (53*Mst2**12.)/(1152.*Mt**2.)-

     &  (415*Mgl**8.*Mt**2.)/576.+

     &  (5*Mgl**12.*Mt**2.)/(384.*Mst2**4.)+

     &  (17*Mgl**10.*Mt**2.)/(192.*Mst2**2.)+

     &  (197*Mgl**6.*Mst2**2.*Mt**2.)/144.-

     &  (865*Mgl**4.*Mst2**4.*Mt**2.)/1152.+

     &  (133*Mgl**2.*Mst2**6.*Mt**2.)/576.-

     &  (11*Mst2**8.*Mt**2.)/48.+

     &  (247*Mgl**6.*Mt**4.)/576.-

     &  (79*Mgl**10.*Mt**4.)/(1152.*Mst2**4.)-

     &  (23*Mgl**8.*Mt**4.)/(64.*Mst2**2.)-

     &  (65*Mgl**4.*Mst2**2.*Mt**4.)/288.+

     &  (577*Mgl**2.*Mst2**4.*Mt**4.)/1152.-

     &  (15*Mst2**6.*Mt**4.)/64.-

     &  (191*Mgl**4.*Mt**6.)/384.+

     &  (119*Mgl**8.*Mt**6.)/(1152.*Mst2**4.)+

     &  (67*Mgl**6.*Mt**6.)/(288.*Mst2**2.)-

     &  (101*Mgl**2.*Mst2**2.*Mt**6.)/64.-

     &  (85*Mst2**4.*Mt**6.)/96.+

     &  (2237*Mgl**2.*Mt**8.)/1152.-

     &  (7*Mgl**6.*Mt**8.)/(384.*Mst2**4.)+

     &  (115*Mgl**4.*Mt**8.)/(288.*Mst2**2.)+

     &  (619*Mst2**2.*Mt**8.)/288.-(379*Mt**10.)/288.-

     &  (107*Mgl**4.*Mt**10.)/(1152.*Mst2**4.)-

     &  (361*Mgl**2.*Mt**10.)/(576.*Mst2**2.)+

     &  (11*Mgl**2.*Mt**12.)/(128.*Mst2**4.)+

     &  (47*Mt**12.)/(192.*Mst2**2.)-

     &  (3*Mt**14.)/(128.*Mst2**4.))*d123(Mt,Mgl,Mst2)**3.*

     &  Tfin(Mt,Mgl,Mst2)+

     &  ((-29*Mgl**18.)/(4608.*Mst2**4.)+

     &  (65*Mgl**16.)/(4608.*Mst2**2.)+

     &  (83*Mgl**12.*Mst2**2.)/576.-

     &  (1697*Mgl**10.*Mst2**4.)/2304.+

     &  (2833*Mgl**8.*Mst2**6.)/2304.-

     &  (401*Mgl**6.*Mst2**8.)/576.-

     &  (73*Mgl**4.*Mst2**10.)/288.+

     &  (2023*Mgl**2.*Mst2**12.)/4608.-

     &  (619*Mst2**14.)/4608.-

     &  (5*Mgl**18.)/(4608.*Mt**4.)+

     &  (7*Mgl**16.*Mst2**2.)/(1536.*Mt**4.)+

     &  (Mgl**14.*Mst2**4.)/(384.*Mt**4.)-

     &  (7*Mgl**12.*Mst2**6.)/(128.*Mt**4.)+

     &  (119*Mgl**10.*Mst2**8.)/(768.*Mt**4.)-

     &  (175*Mgl**8.*Mst2**10.)/(768.*Mt**4.)+

     &  (77*Mgl**6.*Mst2**12.)/(384.*Mt**4.)-

     &  (41*Mgl**4.*Mst2**14.)/(384.*Mt**4.)+

     &  (49*Mgl**2.*Mst2**16.)/(1536.*Mt**4.)-

     &  (19*Mst2**18.)/(4608.*Mt**4.)-

     &  (17*Mgl**16.)/(4608.*Mt**2.)+

     &  (3*Mgl**14.*Mst2**2.)/(64.*Mt**2.)-

     &  (23*Mgl**12.*Mst2**4.)/(128.*Mt**2.)+

     &  (173*Mgl**10.*Mst2**6.)/(576.*Mt**2.)-

     &  (145*Mgl**8.*Mst2**8.)/(768.*Mt**2.)-

     &  (17*Mgl**6.*Mst2**10.)/(192.*Mt**2.)+

     &  (241*Mgl**4.*Mst2**12.)/(1152.*Mt**2.)-

     &  (23*Mgl**2.*Mst2**14.)/(192.*Mt**2.)+

     &  (37*Mst2**16.)/(1536.*Mt**2.)+

     &  (7*Mgl**12.*Mt**2.)/144.+

     &  (19*Mgl**16.*Mt**2.)/(512.*Mst2**4.)-

     &  (3*Mgl**14.*Mt**2.)/(32.*Mst2**2.)-

     &  (425*Mgl**10.*Mst2**2.*Mt**2.)/576.+

     &  (1777*Mgl**8.*Mst2**4.*Mt**2.)/768.-

     &  (349*Mgl**6.*Mst2**6.*Mt**2.)/144.+

     &  (557*Mgl**4.*Mst2**8.*Mt**2.)/576.-

     &  (31*Mgl**2.*Mst2**10.*Mt**2.)/192.+

     &  (77*Mst2**12.*Mt**2.)/1536.+

     &  (437*Mgl**10.*Mt**4.)/768.-

     &  (89*Mgl**14.*Mt**4.)/(1152.*Mst2**4.)+

     &  (25*Mgl**12.*Mt**4.)/(128.*Mst2**2.)-

     &  (17*Mgl**8.*Mst2**2.*Mt**4.)/768.-

     &  (71*Mgl**6.*Mst2**4.*Mt**4.)/64.+

     &  (283*Mgl**4.*Mst2**6.*Mt**4.)/576.-

     &  (2017*Mgl**2.*Mst2**8.*Mt**4.)/2304.+

     &  (1909*Mst2**10.*Mt**4.)/2304.-

     &  (373*Mgl**8.*Mt**6.)/256.+

     &  (17*Mgl**12.*Mt**6.)/(384.*Mst2**4.)-

     &  (7*Mgl**10.*Mt**6.)/(36.*Mst2**2.)+

     &  (805*Mgl**6.*Mst2**2.*Mt**6.)/576.+

     &  (11*Mgl**4.*Mst2**4.*Mt**6.)/144.+

     &  (941*Mgl**2.*Mst2**6.*Mt**6.)/576.-

     &  (3073*Mst2**8.*Mt**6.)/2304.+

     &  (35*Mgl**6.*Mt**8.)/64.+

     &  (55*Mgl**10.*Mt**8.)/(768.*Mst2**4.)+

     &  (109*Mgl**8.*Mt**8.)/(768.*Mst2**2.)-

     &  (763*Mgl**4.*Mst2**2.*Mt**8.)/288.-

     &  (2371*Mgl**2.*Mst2**4.*Mt**8.)/768.-

     &  (221*Mst2**6.*Mt**8.)/768.+

     &  (265*Mgl**4.*Mt**10.)/192.-

     &  (283*Mgl**8.*Mt**10.)/(2304.*Mst2**4.)-

     &  (11*Mgl**6.*Mt**10.)/(288.*Mst2**2.)+

     &  (2105*Mgl**2.*Mst2**2.*Mt**10.)/576.+

     &  (4987*Mst2**4.*Mt**10.)/2304.-

     &  (7697*Mgl**2.*Mt**12.)/4608.+

     &  (17*Mgl**6.*Mt**12.)/(384.*Mst2**4.)-

     &  (19*Mgl**4.*Mt**12.)/(128.*Mst2**2.)-

     &  (8471*Mst2**2.*Mt**12.)/4608.+

     &  (2707*Mt**14.)/4608.+

     &  (13*Mgl**4.*Mt**14.)/(384.*Mst2**4.)+

     &  (3*Mgl**2.*Mt**14.)/(16.*Mst2**2.)-

     &  (149*Mgl**2.*Mt**16.)/(4608.*Mst2**4.)-

     &  (295*Mt**16.)/(4608.*Mst2**2.)+

     &  (35*Mt**18.)/(4608.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.*Tfin(Mt,Mgl,Mst2)+

     &  ((-25*Mgl)/(1152.*Mt**2.)+

     &  (19*Mgl*Mt**2.)/(1152.*Mst2**4.))*Xt*Den(Mst1,Mst2)*

     &  Tfin(Mt,Mgl,Mst2)+

     &  ((-5*Mgl**3.)/96.+(5*Mgl*Mst2**2.)/96.+

     &  (7*Mgl**5.)/(96.*Mt**2.)-

     &  (7*Mgl**3.*Mst2**2.)/(48.*Mt**2.)+

     &  (7*Mgl*Mst2**4.)/(96.*Mt**2.)+

     &  (55*Mgl*Mt**2.)/144.-

     &  (11*Mgl**5.*Mt**2.)/(288.*Mst2**4.)-

     &  (23*Mgl**3.*Mt**2.)/(288.*Mst2**2.)+

     &  (11*Mgl**3.*Mt**4.)/(144.*Mst2**4.)+

     &  (23*Mgl*Mt**4.)/(288.*Mst2**2.)-

     &  (11*Mgl*Mt**6.)/(288.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst2)+

     &  ((115*Mgl**7.)/288.-(203*Mgl**5.*Mst2**2.)/288.+

     &  (121*Mgl**3.*Mst2**4.)/288.-

     &  (11*Mgl*Mst2**6.)/96.-

     &  (11*Mgl**9.)/(192.*Mt**2.)+

     &  (5*Mgl**7.*Mst2**2.)/(24.*Mt**2.)-

     &  (9*Mgl**5.*Mst2**4.)/(32.*Mt**2.)+

     &  (Mgl**3.*Mst2**6.)/(6.*Mt**2.)-

     &  (7*Mgl*Mst2**8.)/(192.*Mt**2.)-

     &  (29*Mgl**5.*Mt**2.)/36.+

     &  (25*Mgl**9.*Mt**2.)/(576.*Mst2**4.)+

     &  (13*Mgl**7.*Mt**2.)/(288.*Mst2**2.)+

     &  (317*Mgl**3.*Mst2**2.*Mt**2.)/288.+

     &  (139*Mgl*Mst2**4.*Mt**2.)/576.+

     &  (145*Mgl**3.*Mt**4.)/288.-

     &  (31*Mgl**7.*Mt**4.)/(144.*Mst2**4.)-

     &  (211*Mgl**5.*Mt**4.)/(288.*Mst2**2.)+

     &  (29*Mgl*Mst2**2.*Mt**4.)/144.+

     &  (163*Mgl*Mt**6.)/192.+

     &  (37*Mgl**5.*Mt**6.)/(96.*Mst2**4.)+

     &  (395*Mgl**3.*Mt**6.)/(288.*Mst2**2.)-

     &  (43*Mgl**3.*Mt**8.)/(144.*Mst2**4.)-

     &  (197*Mgl*Mt**8.)/(288.*Mst2**2.)+

     &  (49*Mgl*Mt**10.)/(576.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst2)

     &  +((-9*Mgl**11.)/32.+(269*Mgl**9.*Mst2**2.)/288.-

     &  (21*Mgl**7.*Mst2**4.)/16.+

     &  (55*Mgl**5.*Mst2**6.)/48.-

     &  (197*Mgl**3.*Mst2**8.)/288.+

     &  (19*Mgl*Mst2**10.)/96.+Mgl**13./(96.*Mt**2.)-

     &  (Mgl**11.*Mst2**2.)/(48.*Mt**2.)-

     &  (5*Mgl**9.*Mst2**4.)/(96.*Mt**2.)+

     &  (5*Mgl**7.*Mst2**6.)/(24.*Mt**2.)-

     &  (25*Mgl**5.*Mst2**8.)/(96.*Mt**2.)+

     &  (7*Mgl**3.*Mst2**10.)/(48.*Mt**2.)-

     &  (Mgl*Mst2**12.)/(32.*Mt**2.)+

     &  (97*Mgl**9.*Mt**2.)/144.+

     &  (Mgl**13.*Mt**2.)/(288.*Mst2**4.)+

     &  (25*Mgl**11.*Mt**2.)/(288.*Mst2**2.)-

     &  (335*Mgl**7.*Mst2**2.*Mt**2.)/144.+

     &  (581*Mgl**5.*Mst2**4.*Mt**2.)/288.+

     &  (181*Mgl**3.*Mst2**6.*Mt**2.)/288.-

     &  (13*Mgl*Mst2**8.*Mt**2.)/12.-

     &  (17*Mgl**7.*Mt**4.)/16.+

     &  (7*Mgl**11.*Mt**4.)/(144.*Mst2**4.)+

     &  (91*Mgl**9.*Mt**4.)/(288.*Mst2**2.)+

     &  (137*Mgl**5.*Mst2**2.*Mt**4.)/36.-

     &  (23*Mgl**3.*Mst2**4.*Mt**4.)/72.+

     &  (47*Mgl*Mst2**6.*Mt**4.)/96.-

     &  (89*Mgl**5.*Mt**6.)/32.-

     &  (31*Mgl**9.*Mt**6.)/(96.*Mst2**4.)-

     &  (299*Mgl**7.*Mt**6.)/(144.*Mst2**2.)-

     &  (347*Mgl**3.*Mst2**2.*Mt**6.)/72.-

     &  1.*Mgl*Mst2**4.*Mt**6.+

     &  (2179*Mgl**3.*Mt**8.)/288.+

     &  (53*Mgl**7.*Mt**8.)/(72.*Mst2**4.)+

     &  (539*Mgl**5.*Mt**8.)/(144.*Mst2**2.)+

     &  (457*Mgl*Mst2**2.*Mt**8.)/96.-

     &  (33*Mgl*Mt**10.)/8.-

     &  (233*Mgl**5.*Mt**10.)/(288.*Mst2**4.)-

     &  (851*Mgl**3.*Mt**10.)/(288.*Mst2**2.)+

     &  (7*Mgl**3.*Mt**12.)/(16.*Mst2**4.)+

     &  (85*Mgl*Mt**12.)/(96.*Mst2**2.)-

     &  (3*Mgl*Mt**14.)/(32.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst2)

     &  +(-Mgl**15./96.+(47*Mgl**13.*Mst2**2.)/288.-

     &  (167*Mgl**11.*Mst2**4.)/288.+

     &  (235*Mgl**9.*Mst2**6.)/288.-

     &  (35*Mgl**7.*Mst2**8.)/96.-

     &  (67*Mgl**5.*Mst2**10.)/288.+

     &  (83*Mgl**3.*Mst2**12.)/288.-

     &  (23*Mgl*Mst2**14.)/288.-

     &  (5*Mgl**17.)/(1152.*Mt**2.)+

     &  (Mgl**15.*Mst2**2.)/(72.*Mt**2.)+

     &  (7*Mgl**13.*Mst2**4.)/(288.*Mt**2.)-

     &  (7*Mgl**11.*Mst2**6.)/(36.*Mt**2.)+

     &  (245*Mgl**9.*Mst2**8.)/(576.*Mt**2.)-

     &  (35*Mgl**7.*Mst2**10.)/(72.*Mt**2.)+

     &  (91*Mgl**5.*Mst2**12.)/(288.*Mt**2.)-

     &  (Mgl**3.*Mst2**14.)/(9.*Mt**2.)+

     &  (19*Mgl*Mst2**16.)/(1152.*Mt**2.)+

     &  (Mgl**13.*Mt**2.)/24.-

     &  (29*Mgl**17.*Mt**2.)/(1152.*Mst2**4.)+

     &  (Mgl**15.*Mt**2.)/(32.*Mst2**2.)+

     &  (131*Mgl**11.*Mst2**2.*Mt**2.)/288.-

     &  (367*Mgl**9.*Mst2**4.*Mt**2.)/192.+

     &  (631*Mgl**7.*Mst2**6.*Mt**2.)/288.-

     &  (11*Mgl**5.*Mst2**8.*Mt**2.)/48.-

     &  (97*Mgl**3.*Mst2**10.*Mt**2.)/96.+

     &  (527*Mgl*Mst2**12.*Mt**2.)/1152.-

     &  (23*Mgl**11.*Mt**4.)/288.+

     &  (25*Mgl**15.*Mt**4.)/(144.*Mst2**4.)-

     &  (67*Mgl**13.*Mt**4.)/(288.*Mst2**2.)-

     &  (251*Mgl**9.*Mst2**2.*Mt**4.)/72.+

     &  (553*Mgl**7.*Mst2**4.*Mt**4.)/72.-

     &  (1211*Mgl**5.*Mst2**6.*Mt**4.)/288.-

     &  (31*Mgl**3.*Mst2**8.*Mt**4.)/288.+

     &  (37*Mgl*Mst2**10.*Mt**4.)/144.+

     &  (1663*Mgl**9.*Mt**6.)/576.-

     &  (139*Mgl**13.*Mt**6.)/(288.*Mst2**4.)+

     &  (17*Mgl**11.*Mt**6.)/(32.*Mst2**2.)+

     &  (905*Mgl**7.*Mst2**2.*Mt**6.)/144.-

     &  (35*Mgl**5.*Mst2**4.*Mt**6.)/6.+

     &  (97*Mgl**3.*Mst2**6.*Mt**6.)/288.-

     &  (587*Mgl*Mst2**8.*Mt**6.)/192.-

     &  (899*Mgl**7.*Mt**8.)/96.+

     &  (95*Mgl**11.*Mt**8.)/(144.*Mst2**4.)-

     &  (187*Mgl**9.*Mt**8.)/(288.*Mst2**2.)-

     &  (2897*Mgl**5.*Mst2**2.*Mt**8.)/288.-

     &  (1129*Mgl**3.*Mst2**4.*Mt**8.)/288.+

     &  (41*Mgl*Mst2**6.*Mt**8.)/18.+

     &  (595*Mgl**5.*Mt**10.)/48.-

     &  (215*Mgl**9.*Mt**10.)/(576.*Mst2**4.)+

     &  (27*Mgl**7.*Mt**10.)/(32.*Mst2**2.)+

     &  (3415*Mgl**3.*Mst2**2.*Mt**10.)/288.+

     &  (1975*Mgl*Mst2**4.*Mt**10.)/576.-

     &  (767*Mgl**3.*Mt**12.)/96.-

     &  (17*Mgl**7.*Mt**12.)/(144.*Mst2**4.)-

     &  (107*Mgl**5.*Mt**12.)/(96.*Mst2**2.)-

     &  (251*Mgl*Mst2**2.*Mt**12.)/48.+

     &  (2447*Mgl*Mt**14.)/1152.+

     &  (85*Mgl**5.*Mt**14.)/(288.*Mst2**4.)+

     &  (235*Mgl**3.*Mt**14.)/(288.*Mst2**2.)-

     &  (23*Mgl**3.*Mt**16.)/(144.*Mst2**4.)-

     &  (65*Mgl*Mt**16.)/(288.*Mst2**2.)+

     &  (35*Mgl*Mt**18.)/(1152.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst2)

     &  )+Nq*(0.06461588541666667+

     &  (1745*Mgl**4.)/(331776.*Msq1**4.)+

     &  (1013*Mgl**2.)/(41472.*Msq1**2.)-

     &  (857*Msq1**2.)/(10368.*Mgl**2.)+

     &  (73*Msq1**4.)/(13824.*Mgl**4.)+

     &  (1745*Mgl**4.)/(331776.*Msq2**4.)+

     &  (1013*Mgl**2.)/(41472.*Msq2**2.)-

     &  (857*Msq2**2.)/(10368.*Mgl**2.)+

     &  (73*Msq2**4.)/(13824.*Mgl**4.)-z2/18.+

     &  (-0.020833333333333332+Mgl**2./(48.*Msq1**2.))*

     &  B0fin(Msq1,Mgl,Mq,mu)+

     &  (-0.020833333333333332+Mgl**2./(48.*Msq2**2.))*

     &  B0fin(Msq2,Mgl,Mq,mu)+

     &  ((-53249*Mgl**4.)/82944.-

     &  (2641*Mgl**8.)/(82944.*Msq1**4.)-

     &  (59*Mgl**6.)/(6912.*Msq1**2.)+

     &  (1051*Mgl**2.*Msq1**2.)/2304.+

     &  (32233*Msq1**4.)/41472.+

     &  (1021*Msq1**6.)/(20736.*Mgl**2.)-

     &  (449*Msq1**8.)/(6912.*Mgl**4.)+

     &  (37*Mgl**4.*z2)/576.-

     &  (157*Mgl**6.*z2)/(2304.*Msq1**2.)-

     &  (239*Mgl**2.*Msq1**2.*z2)/2304.+

     &  (Msq1**4.*z2)/4.-(5*Msq1**6.*z2)/(96.*Mgl**2.))*

     &  Den(Msq1,Mgl)**2.+

     &  ((348487*Mgl**8.)/165888.+

     &  (15155*Mgl**12.)/(165888.*Msq1**4.)-

     &  (3139*Mgl**10.)/(4608.*Msq1**2.)-

     &  (144329*Mgl**6.*Msq1**2.)/41472.+

     &  (383417*Mgl**4.*Msq1**4.)/165888.+

     &  (52763*Mgl**2.*Msq1**6.)/20736.-

     &  (510703*Msq1**8.)/165888.+

     &  (299*Msq1**10.)/(2304.*Mgl**2.)+

     &  (287*Msq1**12.)/(4608.*Mgl**4.)-

     &  (95*Mgl**8.*z2)/288.+

     &  (221*Mgl**10.*z2)/(2304.*Msq1**2.)+

     &  (437*Mgl**6.*Msq1**2.*z2)/1152.-

     &  (23*Mgl**4.*Msq1**4.*z2)/64.+

     &  (1765*Mgl**2.*Msq1**6.*z2)/2304.-

     &  (39*Msq1**8.*z2)/64.+

     &  (11*Msq1**10.*z2)/(192.*Mgl**2.))*Den(Msq1,Mgl)**4.

     &  +((-33821*Mgl**12.)/9216.-

     &  (685*Mgl**16.)/(9216.*Msq1**4.)+

     &  (46645*Mgl**14.)/(41472.*Msq1**2.)+

     &  (301717*Mgl**10.*Msq1**2.)/41472.-

     &  (314605*Mgl**8.*Msq1**4.)/27648.+

     &  (385637*Mgl**6.*Msq1**6.)/41472.+

     &  (105965*Mgl**4.*Msq1**8.)/82944.-

     &  (278129*Mgl**2.*Msq1**10.)/41472.+

     &  (3863*Msq1**12.)/1296.-

     &  (2479*Msq1**14.)/(20736.*Mgl**2.)-

     &  (163*Msq1**16.)/(20736.*Mgl**4.)+

     &  (73*Mgl**12.*z2)/576.+

     &  (11*Mgl**14.*z2)/(768.*Msq1**2.)-

     &  (803*Mgl**10.*Msq1**2.*z2)/2304.-

     &  (Mgl**8.*Msq1**4.*z2)/144.+

     &  (635*Mgl**6.*Msq1**6.*z2)/2304.+

     &  (31*Mgl**4.*Msq1**8.*z2)/64.-

     &  (2009*Mgl**2.*Msq1**10.*z2)/2304.+

     &  (5*Msq1**12.*z2)/16.+(Msq1**14.*z2)/(72.*Mgl**2.))

     &  *Den(Msq1,Mgl)**6.+

     &  ((629323*Mgl**16.)/331776.+

     &  (3169*Mgl**20.)/(331776.*Msq1**4.)-

     &  (17105*Mgl**18.)/(41472.*Msq1**2.)-

     &  (209873*Mgl**14.*Msq1**2.)/41472.+

     &  (617515*Mgl**12.*Msq1**4.)/55296.-

     &  (248323*Mgl**10.*Msq1**6.)/13824.+

     &  (102445*Mgl**8.*Msq1**8.)/6144.-

     &  (9347*Mgl**6.*Msq1**10.)/1536.-

     &  (74219*Mgl**4.*Msq1**12.)/36864.+

     &  (45275*Mgl**2.*Msq1**14.)/20736.-

     &  (103097*Msq1**16.)/331776.-

     &  (1885*Msq1**18.)/(20736.*Mgl**2.)+

     &  (109*Msq1**20.)/(20736.*Mgl**4.)+

     &  (49*Mgl**16.*z2)/288.-

     &  (97*Mgl**18.*z2)/(2304.*Msq1**2.)-

     &  (229*Mgl**14.*Msq1**2.*z2)/576.+

     &  (577*Mgl**12.*Msq1**4.*z2)/576.-

     &  (253*Mgl**10.*Msq1**6.*z2)/128.+

     &  (1259*Mgl**8.*Msq1**8.*z2)/576.-

     &  (319*Mgl**6.*Msq1**10.*z2)/288.+

     &  (13*Mgl**4.*Msq1**12.*z2)/192.+

     &  (227*Mgl**2.*Msq1**14.*z2)/2304.+

     &  (11*Msq1**16.*z2)/576.-

     &  (11*Msq1**18.*z2)/(576.*Mgl**2.))*Den(Msq1,Mgl)**8.

     &  +((-53249*Mgl**4.)/82944.-

     &  (2641*Mgl**8.)/(82944.*Msq2**4.)-

     &  (59*Mgl**6.)/(6912.*Msq2**2.)+

     &  (1051*Mgl**2.*Msq2**2.)/2304.+

     &  (32233*Msq2**4.)/41472.+

     &  (1021*Msq2**6.)/(20736.*Mgl**2.)-

     &  (449*Msq2**8.)/(6912.*Mgl**4.)+

     &  (37*Mgl**4.*z2)/576.-

     &  (157*Mgl**6.*z2)/(2304.*Msq2**2.)-

     &  (239*Mgl**2.*Msq2**2.*z2)/2304.+

     &  (Msq2**4.*z2)/4.-(5*Msq2**6.*z2)/(96.*Mgl**2.))*

     &  Den(Msq2,Mgl)**2.+

     &  ((348487*Mgl**8.)/165888.+

     &  (15155*Mgl**12.)/(165888.*Msq2**4.)-

     &  (3139*Mgl**10.)/(4608.*Msq2**2.)-

     &  (144329*Mgl**6.*Msq2**2.)/41472.+

     &  (383417*Mgl**4.*Msq2**4.)/165888.+

     &  (52763*Mgl**2.*Msq2**6.)/20736.-

     &  (510703*Msq2**8.)/165888.+

     &  (299*Msq2**10.)/(2304.*Mgl**2.)+

     &  (287*Msq2**12.)/(4608.*Mgl**4.)-

     &  (95*Mgl**8.*z2)/288.+

     &  (221*Mgl**10.*z2)/(2304.*Msq2**2.)+

     &  (437*Mgl**6.*Msq2**2.*z2)/1152.-

     &  (23*Mgl**4.*Msq2**4.*z2)/64.+

     &  (1765*Mgl**2.*Msq2**6.*z2)/2304.-

     &  (39*Msq2**8.*z2)/64.+

     &  (11*Msq2**10.*z2)/(192.*Mgl**2.))*Den(Msq2,Mgl)**4.

     &  +((-33821*Mgl**12.)/9216.-

     &  (685*Mgl**16.)/(9216.*Msq2**4.)+

     &  (46645*Mgl**14.)/(41472.*Msq2**2.)+

     &  (301717*Mgl**10.*Msq2**2.)/41472.-

     &  (314605*Mgl**8.*Msq2**4.)/27648.+

     &  (385637*Mgl**6.*Msq2**6.)/41472.+

     &  (105965*Mgl**4.*Msq2**8.)/82944.-

     &  (278129*Mgl**2.*Msq2**10.)/41472.+

     &  (3863*Msq2**12.)/1296.-

     &  (2479*Msq2**14.)/(20736.*Mgl**2.)-

     &  (163*Msq2**16.)/(20736.*Mgl**4.)+

     &  (73*Mgl**12.*z2)/576.+

     &  (11*Mgl**14.*z2)/(768.*Msq2**2.)-

     &  (803*Mgl**10.*Msq2**2.*z2)/2304.-

     &  (Mgl**8.*Msq2**4.*z2)/144.+

     &  (635*Mgl**6.*Msq2**6.*z2)/2304.+

     &  (31*Mgl**4.*Msq2**8.*z2)/64.-

     &  (2009*Mgl**2.*Msq2**10.*z2)/2304.+

     &  (5*Msq2**12.*z2)/16.+(Msq2**14.*z2)/(72.*Mgl**2.))

     &  *Den(Msq2,Mgl)**6.+

     &  ((629323*Mgl**16.)/331776.+

     &  (3169*Mgl**20.)/(331776.*Msq2**4.)-

     &  (17105*Mgl**18.)/(41472.*Msq2**2.)-

     &  (209873*Mgl**14.*Msq2**2.)/41472.+

     &  (617515*Mgl**12.*Msq2**4.)/55296.-

     &  (248323*Mgl**10.*Msq2**6.)/13824.+

     &  (102445*Mgl**8.*Msq2**8.)/6144.-

     &  (9347*Mgl**6.*Msq2**10.)/1536.-

     &  (74219*Mgl**4.*Msq2**12.)/36864.+

     &  (45275*Mgl**2.*Msq2**14.)/20736.-

     &  (103097*Msq2**16.)/331776.-

     &  (1885*Msq2**18.)/(20736.*Mgl**2.)+

     &  (109*Msq2**20.)/(20736.*Mgl**4.)+

     &  (49*Mgl**16.*z2)/288.-

     &  (97*Mgl**18.*z2)/(2304.*Msq2**2.)-

     &  (229*Mgl**14.*Msq2**2.*z2)/576.+

     &  (577*Mgl**12.*Msq2**4.*z2)/576.-

     &  (253*Mgl**10.*Msq2**6.*z2)/128.+

     &  (1259*Mgl**8.*Msq2**8.*z2)/576.-

     &  (319*Mgl**6.*Msq2**10.*z2)/288.+

     &  (13*Mgl**4.*Msq2**12.*z2)/192.+

     &  (227*Mgl**2.*Msq2**14.*z2)/2304.+

     &  (11*Msq2**16.*z2)/576.-

     &  (11*Msq2**18.*z2)/(576.*Mgl**2.))*Den(Msq2,Mgl)**8.

     &  +(0.08506944444444445-

     &  (127*Mgl**4.)/(9216.*Msq1**4.)-

     &  (281*Mgl**2.)/(9216.*Msq1**2.)-

     &  (5*Msq1**2.)/(1152.*Mgl**2.)-

     &  (127*Mgl**4.)/(9216.*Msq2**4.)-

     &  (281*Mgl**2.)/(9216.*Msq2**2.)-

     &  (5*Msq2**2.)/(1152.*Mgl**2.))*ln(mu,Mgl)+

     &  ((-83*Mgl**4.)/768.+(23*Mgl**8.)/(2304.*Msq1**4.)+

     &  (1349*Mgl**6.)/(13824.*Msq1**2.)-

     &  (3041*Mgl**2.*Msq1**2.)/13824.+

     &  (43*Msq1**4.)/144.-(23*Msq1**6.)/(576.*Mgl**2.))*

     &  Den(Msq1,Mgl)**2.*ln(mu,Mgl)+

     &  ((37*Mgl**8.)/216.+(83*Mgl**12.)/(4608.*Msq1**4.)-

     &  (193*Mgl**10.)/(1728.*Msq1**2.)+

     &  (283*Mgl**6.*Msq1**2.)/768.-

     &  (9283*Mgl**4.*Msq1**4.)/4608.+

     &  (2093*Mgl**2.*Msq1**6.)/768.-

     &  (1031*Msq1**8.)/864.+(7*Msq1**10.)/(192.*Mgl**2.))

     &  *Den(Msq1,Mgl)**4.*ln(mu,Mgl)+

     &  ((-2093*Mgl**12.)/2304.-

     &  (109*Mgl**16.)/(2304.*Msq1**4.)+

     &  (3151*Mgl**14.)/(13824.*Msq1**2.)+

     &  (28951*Mgl**10.*Msq1**2.)/13824.-

     &  (6745*Mgl**8.*Msq1**4.)/6912.-

     &  (56875*Mgl**6.*Msq1**6.)/13824.+

     &  (50695*Mgl**4.*Msq1**8.)/6912.-

     &  (63251*Mgl**2.*Msq1**10.)/13824.+

     &  (95*Msq1**12.)/108.+(49*Msq1**14.)/(576.*Mgl**2.))

     &  *Den(Msq1,Mgl)**6.*ln(mu,Mgl)+

     &  ((157*Mgl**16.)/108.+

     &  (305*Mgl**20.)/(9216.*Msq1**4.)-

     &  (7661*Mgl**18.)/(27648.*Msq1**2.)-

     &  (4007*Mgl**14.*Msq1**2.)/864.+

     &  (37769*Mgl**12.*Msq1**4.)/4608.-

     &  (92581*Mgl**10.*Msq1**6.)/13824.-

     &  (1483*Mgl**8.*Msq1**8.)/1728.+

     &  (3811*Mgl**6.*Msq1**10.)/576.-

     &  (149921*Mgl**4.*Msq1**12.)/27648.+

     &  (45791*Mgl**2.*Msq1**14.)/27648.+

     &  (49*Msq1**16.)/3456.-

     &  (89*Msq1**18.)/(1152.*Mgl**2.))*Den(Msq1,Mgl)**8.*

     &  ln(mu,Mgl)+((-83*Mgl**4.)/768.+

     &  (23*Mgl**8.)/(2304.*Msq2**4.)+

     &  (1349*Mgl**6.)/(13824.*Msq2**2.)-

     &  (3041*Mgl**2.*Msq2**2.)/13824.+

     &  (43*Msq2**4.)/144.-(23*Msq2**6.)/(576.*Mgl**2.))*

     &  Den(Msq2,Mgl)**2.*ln(mu,Mgl)+

     &  ((37*Mgl**8.)/216.+(83*Mgl**12.)/(4608.*Msq2**4.)-

     &  (193*Mgl**10.)/(1728.*Msq2**2.)+

     &  (283*Mgl**6.*Msq2**2.)/768.-

     &  (9283*Mgl**4.*Msq2**4.)/4608.+

     &  (2093*Mgl**2.*Msq2**6.)/768.-

     &  (1031*Msq2**8.)/864.+(7*Msq2**10.)/(192.*Mgl**2.))

     &  *Den(Msq2,Mgl)**4.*ln(mu,Mgl)+

     &  ((-2093*Mgl**12.)/2304.-

     &  (109*Mgl**16.)/(2304.*Msq2**4.)+

     &  (3151*Mgl**14.)/(13824.*Msq2**2.)+

     &  (28951*Mgl**10.*Msq2**2.)/13824.-

     &  (6745*Mgl**8.*Msq2**4.)/6912.-

     &  (56875*Mgl**6.*Msq2**6.)/13824.+

     &  (50695*Mgl**4.*Msq2**8.)/6912.-

     &  (63251*Mgl**2.*Msq2**10.)/13824.+

     &  (95*Msq2**12.)/108.+(49*Msq2**14.)/(576.*Mgl**2.))

     &  *Den(Msq2,Mgl)**6.*ln(mu,Mgl)+

     &  ((157*Mgl**16.)/108.+

     &  (305*Mgl**20.)/(9216.*Msq2**4.)-

     &  (7661*Mgl**18.)/(27648.*Msq2**2.)-

     &  (4007*Mgl**14.*Msq2**2.)/864.+

     &  (37769*Mgl**12.*Msq2**4.)/4608.-

     &  (92581*Mgl**10.*Msq2**6.)/13824.-

     &  (1483*Mgl**8.*Msq2**8.)/1728.+

     &  (3811*Mgl**6.*Msq2**10.)/576.-

     &  (149921*Mgl**4.*Msq2**12.)/27648.+

     &  (45791*Mgl**2.*Msq2**14.)/27648.+

     &  (49*Msq2**16.)/3456.-

     &  (89*Msq2**18.)/(1152.*Mgl**2.))*Den(Msq2,Mgl)**8.*

     &  ln(mu,Mgl)+(-0.003472222222222222-

     &  (19*Mgl**4.)/(4608.*Msq1**4.)-

     &  (37*Mgl**2.)/(4608.*Msq1**2.)+

     &  Msq1**2./(192.*Mgl**2.)-

     &  (19*Mgl**4.)/(4608.*Msq2**4.)-

     &  (37*Mgl**2.)/(4608.*Msq2**2.)+

     &  Msq2**2./(192.*Mgl**2.))*ln(mu,Mgl)**2.+

     &  ((79*Mgl**4.)/576.+(11*Mgl**8.)/(1152.*Msq1**4.)-

     &  (101*Mgl**6.)/(4608.*Msq1**2.)-

     &  (967*Mgl**2.*Msq1**2.)/4608.+(11*Msq1**4.)/144.-

     &  Msq1**6./(64.*Mgl**2.))*Den(Msq1,Mgl)**2.*

     &  ln(mu,Mgl)**2.+

     &  ((-347*Mgl**8.)/576.-

     &  (37*Mgl**12.)/(2304.*Msq1**4.)+

     &  (779*Mgl**10.)/(4608.*Msq1**2.)+

     &  (2629*Mgl**6.*Msq1**2.)/2304.-

     &  (1079*Mgl**4.*Msq1**4.)/768.+

     &  (4223*Mgl**2.*Msq1**6.)/4608.-

     &  (83*Msq1**8.)/384.+(5*Msq1**10.)/(384.*Mgl**2.))*

     &  Den(Msq1,Mgl)**4.*ln(mu,Mgl)**2.+

     &  ((335*Mgl**12.)/576.+Mgl**16./(384.*Msq1**4.)-

     &  (631*Mgl**14.)/(4608.*Msq1**2.)-

     &  (6163*Mgl**10.*Msq1**2.)/4608.+

     &  (2825*Mgl**8.*Msq1**4.)/1152.-

     &  (15245*Mgl**6.*Msq1**6.)/4608.+

     &  (511*Mgl**4.*Msq1**8.)/192.-

     &  (4921*Mgl**2.*Msq1**10.)/4608.+

     &  (43*Msq1**12.)/288.+Msq1**14./(288.*Mgl**2.))*

     &  Den(Msq1,Mgl)**6.*ln(mu,Mgl)**2.+

     &  ((91*Mgl**16.)/576.+(37*Mgl**20.)/(4608.*Msq1**4.)-

     &  (85*Mgl**18.)/(2304.*Msq1**2.)-

     &  (535*Mgl**14.*Msq1**2.)/1152.+

     &  (401*Mgl**12.*Msq1**4.)/768.+

     &  (493*Mgl**10.*Msq1**6.)/1152.-

     &  (2083*Mgl**8.*Msq1**8.)/1152.+

     &  (131*Mgl**6.*Msq1**10.)/64.-

     &  (5075*Mgl**4.*Msq1**12.)/4608.+

     &  (587*Mgl**2.*Msq1**14.)/2304.-Msq1**16./1152.-

     &  (7*Msq1**18.)/(1152.*Mgl**2.))*Den(Msq1,Mgl)**8.*

     &  ln(mu,Mgl)**2.+

     &  ((79*Mgl**4.)/576.+(11*Mgl**8.)/(1152.*Msq2**4.)-

     &  (101*Mgl**6.)/(4608.*Msq2**2.)-

     &  (967*Mgl**2.*Msq2**2.)/4608.+(11*Msq2**4.)/144.-

     &  Msq2**6./(64.*Mgl**2.))*Den(Msq2,Mgl)**2.*

     &  ln(mu,Mgl)**2.+

     &  ((-347*Mgl**8.)/576.-

     &  (37*Mgl**12.)/(2304.*Msq2**4.)+

     &  (779*Mgl**10.)/(4608.*Msq2**2.)+

     &  (2629*Mgl**6.*Msq2**2.)/2304.-

     &  (1079*Mgl**4.*Msq2**4.)/768.+

     &  (4223*Mgl**2.*Msq2**6.)/4608.-

     &  (83*Msq2**8.)/384.+(5*Msq2**10.)/(384.*Mgl**2.))*

     &  Den(Msq2,Mgl)**4.*ln(mu,Mgl)**2.+

     &  ((335*Mgl**12.)/576.+Mgl**16./(384.*Msq2**4.)-

     &  (631*Mgl**14.)/(4608.*Msq2**2.)-

     &  (6163*Mgl**10.*Msq2**2.)/4608.+

     &  (2825*Mgl**8.*Msq2**4.)/1152.-

     &  (15245*Mgl**6.*Msq2**6.)/4608.+

     &  (511*Mgl**4.*Msq2**8.)/192.-

     &  (4921*Mgl**2.*Msq2**10.)/4608.+

     &  (43*Msq2**12.)/288.+Msq2**14./(288.*Mgl**2.))*

     &  Den(Msq2,Mgl)**6.*ln(mu,Mgl)**2.+

     &  ((91*Mgl**16.)/576.+(37*Mgl**20.)/(4608.*Msq2**4.)-

     &  (85*Mgl**18.)/(2304.*Msq2**2.)-

     &  (535*Mgl**14.*Msq2**2.)/1152.+

     &  (401*Mgl**12.*Msq2**4.)/768.+

     &  (493*Mgl**10.*Msq2**6.)/1152.-

     &  (2083*Mgl**8.*Msq2**8.)/1152.+

     &  (131*Mgl**6.*Msq2**10.)/64.-

     &  (5075*Mgl**4.*Msq2**12.)/4608.+

     &  (587*Mgl**2.*Msq2**14.)/2304.-Msq2**16./1152.-

     &  (7*Msq2**18.)/(1152.*Mgl**2.))*Den(Msq2,Mgl)**8.*

     &  ln(mu,Mgl)**2.+

     &  (0.1222873263888889-(127*Mgl**2.)/(9216.*Msq1**2.)-

     &  (5*Msq1**2.)/(384.*Mgl**2.)+

     &  (3*Msq1**4.)/(128.*Mgl**4.))*ln(mu,Msq1)+

     &  ((-103*Mgl**4.)/864.-

     &  (167*Mgl**6.)/(4608.*Msq1**2.)+

     &  (1579*Mgl**2.*Msq1**2.)/4608.+

     &  (223*Msq1**4.)/3456.-(5*Msq1**6.)/(24.*Mgl**2.)-

     &  Msq1**8./(192.*Mgl**4.))*Den(Msq1,Mgl)**2.*

     &  ln(mu,Msq1)+

     &  ((1415*Mgl**8.)/4608.+

     &  (5*Mgl**10.)/(1152.*Msq1**2.)-

     &  (11249*Mgl**6.*Msq1**2.)/6912.+

     &  (3383*Mgl**4.*Msq1**4.)/1152.-

     &  (4007*Mgl**2.*Msq1**6.)/2304.-

     &  (5693*Msq1**8.)/13824.+

     &  (161*Msq1**10.)/(288.*Mgl**2.)-

     &  (11*Msq1**12.)/(384.*Mgl**4.))*Den(Msq1,Mgl)**4.*

     &  ln(mu,Msq1)+

     &  ((-697*Mgl**12.)/864.+

     &  (887*Mgl**14.)/(4608.*Msq1**2.)+

     &  (31837*Mgl**10.*Msq1**2.)/13824.-

     &  (10855*Mgl**8.*Msq1**4.)/1728.+

     &  (5757*Mgl**6.*Msq1**6.)/512.-

     &  (1163*Mgl**4.*Msq1**8.)/108.+

     &  (64559*Mgl**2.*Msq1**10.)/13824.-

     &  (275*Msq1**12.)/864.-

     &  (11*Msq1**14.)/(48.*Mgl**2.)-

     &  Msq1**16./(192.*Mgl**4.))*Den(Msq1,Mgl)**6.*

     &  ln(mu,Msq1)+

     &  ((19249*Mgl**16.)/27648.-

     &  (451*Mgl**18.)/(3072.*Msq1**2.)-

     &  (4751*Mgl**14.*Msq1**2.)/3456.+

     &  (1361*Mgl**12.*Msq1**4.)/576.-

     &  (79927*Mgl**10.*Msq1**6.)/13824.+

     &  (156805*Mgl**8.*Msq1**8.)/13824.-

     &  (1711*Mgl**6.*Msq1**10.)/128.+

     &  (31481*Mgl**4.*Msq1**12.)/3456.-

     &  (94783*Mgl**2.*Msq1**14.)/27648.+

     &  (5983*Msq1**16.)/9216.-

     &  (89*Msq1**18.)/(1152.*Mgl**2.)+

     &  Msq1**20./(64.*Mgl**4.))*Den(Msq1,Mgl)**8.*

     &  ln(mu,Msq1)-(ln(mu,Mgl)*ln(mu,Msq1))/36.+

     &  ((37*Mgl**4.)/576.-(157*Mgl**6.)/(2304.*Msq1**2.)-

     &  (239*Mgl**2.*Msq1**2.)/2304.+Msq1**4./4.-

     &  (5*Msq1**6.)/(96.*Mgl**2.))*Den(Msq1,Mgl)**2.*

     &  ln(mu,Mgl)*ln(mu,Msq1)+

     &  ((-95*Mgl**8.)/288.+

     &  (221*Mgl**10.)/(2304.*Msq1**2.)+

     &  (437*Mgl**6.*Msq1**2.)/1152.-

     &  (23*Mgl**4.*Msq1**4.)/64.+

     &  (1765*Mgl**2.*Msq1**6.)/2304.-(39*Msq1**8.)/64.+

     &  (11*Msq1**10.)/(192.*Mgl**2.))*Den(Msq1,Mgl)**4.*

     &  ln(mu,Mgl)*ln(mu,Msq1)+

     &  ((73*Mgl**12.)/576.+(11*Mgl**14.)/(768.*Msq1**2.)-

     &  (803*Mgl**10.*Msq1**2.)/2304.-

     &  (Mgl**8.*Msq1**4.)/144.+

     &  (635*Mgl**6.*Msq1**6.)/2304.+

     &  (31*Mgl**4.*Msq1**8.)/64.-

     &  (2009*Mgl**2.*Msq1**10.)/2304.+

     &  (5*Msq1**12.)/16.+Msq1**14./(72.*Mgl**2.))*

     &  Den(Msq1,Mgl)**6.*ln(mu,Mgl)*ln(mu,Msq1)+

     &  ((49*Mgl**16.)/288.-(97*Mgl**18.)/(2304.*Msq1**2.)-

     &  (229*Mgl**14.*Msq1**2.)/576.+

     &  (577*Mgl**12.*Msq1**4.)/576.-

     &  (253*Mgl**10.*Msq1**6.)/128.+

     &  (1259*Mgl**8.*Msq1**8.)/576.-

     &  (319*Mgl**6.*Msq1**10.)/288.+

     &  (13*Mgl**4.*Msq1**12.)/192.+

     &  (227*Mgl**2.*Msq1**14.)/2304.+

     &  (11*Msq1**16.)/576.-(11*Msq1**18.)/(576.*Mgl**2.))

     &  *Den(Msq1,Mgl)**8.*ln(mu,Mgl)*ln(mu,Msq1)+

     &  (-0.021918402777777776-

     &  (19*Mgl**2.)/(4608.*Msq1**2.)+

     &  (7*Msq1**2.)/(576.*Mgl**2.)+

     &  Msq1**4./(192.*Mgl**4.))*ln(mu,Msq1)**2.+

     &  ((17*Mgl**4.)/384.-(113*Mgl**6.)/(4608.*Msq1**2.)+

     &  (245*Mgl**2.*Msq1**2.)/4608.-(19*Msq1**4.)/576.-

     &  (43*Msq1**6.)/(576.*Mgl**2.)+

     &  Msq1**8./(96.*Mgl**4.))*Den(Msq1,Mgl)**2.*

     &  ln(mu,Msq1)**2.+

     &  ((-101*Mgl**8.)/2304.+

     &  (49*Mgl**10.)/(1536.*Msq1**2.)-

     &  (571*Mgl**6.*Msq1**2.)/2304.+

     &  (889*Mgl**4.*Msq1**4.)/1152.-

     &  (3881*Mgl**2.*Msq1**6.)/4608.+

     &  (527*Msq1**8.)/2304.+

     &  (15*Msq1**10.)/(128.*Mgl**2.)-

     &  Msq1**12./(64.*Mgl**4.))*Den(Msq1,Mgl)**4.*

     &  ln(mu,Msq1)**2.+

     &  ((-31*Mgl**12.)/384.+(5*Mgl**14.)/(512.*Msq1**2.)+

     &  (1585*Mgl**10.*Msq1**2.)/4608.-

     &  (7*Mgl**8.*Msq1**4.)/6.+

     &  (11951*Mgl**6.*Msq1**6.)/4608.-

     &  (3691*Mgl**4.*Msq1**8.)/1152.+

     &  (9139*Mgl**2.*Msq1**10.)/4608.-

     &  (137*Msq1**12.)/288.-Msq1**16./(288.*Mgl**4.))*

     &  Den(Msq1,Mgl)**6.*ln(mu,Msq1)**2.+

     &  ((319*Mgl**16.)/4608.-(5*Mgl**18.)/(384.*Msq1**2.)-

     &  (145*Mgl**14.*Msq1**2.)/1152.+

     &  (271*Mgl**12.*Msq1**4.)/1152.-

     &  (557*Mgl**10.*Msq1**6.)/576.+

     &  (1927*Mgl**8.*Msq1**8.)/768.-

     &  (995*Mgl**6.*Msq1**10.)/288.+

     &  (3035*Mgl**4.*Msq1**12.)/1152.-

     &  (139*Mgl**2.*Msq1**14.)/128.+

     &  (991*Msq1**16.)/4608.-

     &  (23*Msq1**18.)/(1152.*Mgl**2.)+

     &  Msq1**20./(288.*Mgl**4.))*Den(Msq1,Mgl)**8.*

     &  ln(mu,Msq1)**2.+

     &  (0.1222873263888889-(127*Mgl**2.)/(9216.*Msq2**2.)-

     &  (5*Msq2**2.)/(384.*Mgl**2.)+

     &  (3*Msq2**4.)/(128.*Mgl**4.))*ln(mu,Msq2)+

     &  ((-103*Mgl**4.)/864.-

     &  (167*Mgl**6.)/(4608.*Msq2**2.)+

     &  (1579*Mgl**2.*Msq2**2.)/4608.+

     &  (223*Msq2**4.)/3456.-(5*Msq2**6.)/(24.*Mgl**2.)-

     &  Msq2**8./(192.*Mgl**4.))*Den(Msq2,Mgl)**2.*

     &  ln(mu,Msq2)+

     &  ((1415*Mgl**8.)/4608.+

     &  (5*Mgl**10.)/(1152.*Msq2**2.)-

     &  (11249*Mgl**6.*Msq2**2.)/6912.+

     &  (3383*Mgl**4.*Msq2**4.)/1152.-

     &  (4007*Mgl**2.*Msq2**6.)/2304.-

     &  (5693*Msq2**8.)/13824.+

     &  (161*Msq2**10.)/(288.*Mgl**2.)-

     &  (11*Msq2**12.)/(384.*Mgl**4.))*Den(Msq2,Mgl)**4.*

     &  ln(mu,Msq2)+

     &  ((-697*Mgl**12.)/864.+

     &  (887*Mgl**14.)/(4608.*Msq2**2.)+

     &  (31837*Mgl**10.*Msq2**2.)/13824.-

     &  (10855*Mgl**8.*Msq2**4.)/1728.+

     &  (5757*Mgl**6.*Msq2**6.)/512.-

     &  (1163*Mgl**4.*Msq2**8.)/108.+

     &  (64559*Mgl**2.*Msq2**10.)/13824.-

     &  (275*Msq2**12.)/864.-

     &  (11*Msq2**14.)/(48.*Mgl**2.)-

     &  Msq2**16./(192.*Mgl**4.))*Den(Msq2,Mgl)**6.*

     &  ln(mu,Msq2)+

     &  ((19249*Mgl**16.)/27648.-

     &  (451*Mgl**18.)/(3072.*Msq2**2.)-

     &  (4751*Mgl**14.*Msq2**2.)/3456.+

     &  (1361*Mgl**12.*Msq2**4.)/576.-

     &  (79927*Mgl**10.*Msq2**6.)/13824.+

     &  (156805*Mgl**8.*Msq2**8.)/13824.-

     &  (1711*Mgl**6.*Msq2**10.)/128.+

     &  (31481*Mgl**4.*Msq2**12.)/3456.-

     &  (94783*Mgl**2.*Msq2**14.)/27648.+

     &  (5983*Msq2**16.)/9216.-

     &  (89*Msq2**18.)/(1152.*Mgl**2.)+

     &  Msq2**20./(64.*Mgl**4.))*Den(Msq2,Mgl)**8.*

     &  ln(mu,Msq2)-(ln(mu,Mgl)*ln(mu,Msq2))/36.+

     &  ((37*Mgl**4.)/576.-(157*Mgl**6.)/(2304.*Msq2**2.)-

     &  (239*Mgl**2.*Msq2**2.)/2304.+Msq2**4./4.-

     &  (5*Msq2**6.)/(96.*Mgl**2.))*Den(Msq2,Mgl)**2.*

     &  ln(mu,Mgl)*ln(mu,Msq2)+

     &  ((-95*Mgl**8.)/288.+

     &  (221*Mgl**10.)/(2304.*Msq2**2.)+

     &  (437*Mgl**6.*Msq2**2.)/1152.-

     &  (23*Mgl**4.*Msq2**4.)/64.+

     &  (1765*Mgl**2.*Msq2**6.)/2304.-(39*Msq2**8.)/64.+

     &  (11*Msq2**10.)/(192.*Mgl**2.))*Den(Msq2,Mgl)**4.*

     &  ln(mu,Mgl)*ln(mu,Msq2)+

     &  ((73*Mgl**12.)/576.+(11*Mgl**14.)/(768.*Msq2**2.)-

     &  (803*Mgl**10.*Msq2**2.)/2304.-

     &  (Mgl**8.*Msq2**4.)/144.+

     &  (635*Mgl**6.*Msq2**6.)/2304.+

     &  (31*Mgl**4.*Msq2**8.)/64.-

     &  (2009*Mgl**2.*Msq2**10.)/2304.+

     &  (5*Msq2**12.)/16.+Msq2**14./(72.*Mgl**2.))*

     &  Den(Msq2,Mgl)**6.*ln(mu,Mgl)*ln(mu,Msq2)+

     &  ((49*Mgl**16.)/288.-(97*Mgl**18.)/(2304.*Msq2**2.)-

     &  (229*Mgl**14.*Msq2**2.)/576.+

     &  (577*Mgl**12.*Msq2**4.)/576.-

     &  (253*Mgl**10.*Msq2**6.)/128.+

     &  (1259*Mgl**8.*Msq2**8.)/576.-

     &  (319*Mgl**6.*Msq2**10.)/288.+

     &  (13*Mgl**4.*Msq2**12.)/192.+

     &  (227*Mgl**2.*Msq2**14.)/2304.+

     &  (11*Msq2**16.)/576.-(11*Msq2**18.)/(576.*Mgl**2.))

     &  *Den(Msq2,Mgl)**8.*ln(mu,Mgl)*ln(mu,Msq2)+

     &  (-0.021918402777777776-

     &  (19*Mgl**2.)/(4608.*Msq2**2.)+

     &  (7*Msq2**2.)/(576.*Mgl**2.)+

     &  Msq2**4./(192.*Mgl**4.))*ln(mu,Msq2)**2.+

     &  ((17*Mgl**4.)/384.-(113*Mgl**6.)/(4608.*Msq2**2.)+

     &  (245*Mgl**2.*Msq2**2.)/4608.-(19*Msq2**4.)/576.-

     &  (43*Msq2**6.)/(576.*Mgl**2.)+

     &  Msq2**8./(96.*Mgl**4.))*Den(Msq2,Mgl)**2.*

     &  ln(mu,Msq2)**2.+

     &  ((-101*Mgl**8.)/2304.+

     &  (49*Mgl**10.)/(1536.*Msq2**2.)-

     &  (571*Mgl**6.*Msq2**2.)/2304.+

     &  (889*Mgl**4.*Msq2**4.)/1152.-

     &  (3881*Mgl**2.*Msq2**6.)/4608.+

     &  (527*Msq2**8.)/2304.+

     &  (15*Msq2**10.)/(128.*Mgl**2.)-

     &  Msq2**12./(64.*Mgl**4.))*Den(Msq2,Mgl)**4.*

     &  ln(mu,Msq2)**2.+

     &  ((-31*Mgl**12.)/384.+(5*Mgl**14.)/(512.*Msq2**2.)+

     &  (1585*Mgl**10.*Msq2**2.)/4608.-

     &  (7*Mgl**8.*Msq2**4.)/6.+

     &  (11951*Mgl**6.*Msq2**6.)/4608.-

     &  (3691*Mgl**4.*Msq2**8.)/1152.+

     &  (9139*Mgl**2.*Msq2**10.)/4608.-

     &  (137*Msq2**12.)/288.-Msq2**16./(288.*Mgl**4.))*

     &  Den(Msq2,Mgl)**6.*ln(mu,Msq2)**2.+

     &  ((319*Mgl**16.)/4608.-(5*Mgl**18.)/(384.*Msq2**2.)-

     &  (145*Mgl**14.*Msq2**2.)/1152.+

     &  (271*Mgl**12.*Msq2**4.)/1152.-

     &  (557*Mgl**10.*Msq2**6.)/576.+

     &  (1927*Mgl**8.*Msq2**8.)/768.-

     &  (995*Mgl**6.*Msq2**10.)/288.+

     &  (3035*Mgl**4.*Msq2**12.)/1152.-

     &  (139*Mgl**2.*Msq2**14.)/128.+

     &  (991*Msq2**16.)/4608.-

     &  (23*Msq2**18.)/(1152.*Mgl**2.)+

     &  Msq2**20./(288.*Mgl**4.))*Den(Msq2,Mgl)**8.*

     &  ln(mu,Msq2)**2.+

     &  (-7/(576.*Mgl**2.)+(19*Mgl**2.)/(4608.*Msq1**4.)+

     &  37/(4608.*Msq1**2.)-Msq1**2./(192.*Mgl**4.))*

     &  Tfin0(Msq1,Mgl)+

     &  ((-121*Mgl**2.)/1152.-

     &  (11*Mgl**6.)/(1152.*Msq1**4.)-

     &  (7*Mgl**4.)/(576.*Msq1**2.)+(91*Msq1**2.)/576.+

     &  (7*Msq1**4.)/(144.*Mgl**2.)-Msq1**6./(96.*Mgl**4.)

     &  )*Den(Msq1,Mgl)**2.*Tfin0(Msq1,Mgl)+

     &  ((7*Mgl**6.)/16.+(37*Mgl**10.)/(2304.*Msq1**4.)-

     &  (31*Mgl**8.)/(256.*Msq1**2.)-

     &  (137*Mgl**4.*Msq1**2.)/144.+

     &  (941*Mgl**2.*Msq1**4.)/768.-

     &  (1229*Msq1**6.)/2304.-

     &  (17*Msq1**8.)/(192.*Mgl**2.)+

     &  Msq1**10./(64.*Mgl**4.))*Den(Msq1,Mgl)**4.*

     &  Tfin0(Msq1,Mgl)+

     &  ((-199*Mgl**10.)/384.-Mgl**14./(384.*Msq1**4.)+

     &  (83*Mgl**12.)/(576.*Msq1**2.)+

     &  (335*Mgl**8.*Msq1**2.)/288.-

     &  (943*Mgl**6.*Msq1**4.)/384.+

     &  (1985*Mgl**4.*Msq1**6.)/576.-

     &  (929*Mgl**2.*Msq1**8.)/384.+(91*Msq1**10.)/144.+

     &  Msq1**12./(144.*Mgl**2.)+Msq1**14./(288.*Mgl**4.))

     &  *Den(Msq1,Mgl)**6.*Tfin0(Msq1,Mgl)+

     &  ((-7*Mgl**14.)/96.-(37*Mgl**18.)/(4608.*Msq1**4.)+

     &  (73*Mgl**16.)/(4608.*Msq1**2.)+

     &  (17*Mgl**12.*Msq1**2.)/64.-

     &  (49*Mgl**10.*Msq1**4.)/2304.-

     &  (3263*Mgl**8.*Msq1**6.)/2304.+

     &  (557*Mgl**6.*Msq1**8.)/192.-

     &  (749*Mgl**4.*Msq1**10.)/288.+

     &  (5231*Mgl**2.*Msq1**12.)/4608.-

     &  (947*Msq1**14.)/4608.+Msq1**16./(96.*Mgl**2.)-

     &  Msq1**18./(288.*Mgl**4.))*Den(Msq1,Mgl)**8.*

     &  Tfin0(Msq1,Mgl)+

     &  (-7/(576.*Mgl**2.)+(19*Mgl**2.)/(4608.*Msq2**4.)+

     &  37/(4608.*Msq2**2.)-Msq2**2./(192.*Mgl**4.))*

     &  Tfin0(Msq2,Mgl)+

     &  ((-121*Mgl**2.)/1152.-

     &  (11*Mgl**6.)/(1152.*Msq2**4.)-

     &  (7*Mgl**4.)/(576.*Msq2**2.)+(91*Msq2**2.)/576.+

     &  (7*Msq2**4.)/(144.*Mgl**2.)-Msq2**6./(96.*Mgl**4.)

     &  )*Den(Msq2,Mgl)**2.*Tfin0(Msq2,Mgl)+

     &  ((7*Mgl**6.)/16.+(37*Mgl**10.)/(2304.*Msq2**4.)-

     &  (31*Mgl**8.)/(256.*Msq2**2.)-

     &  (137*Mgl**4.*Msq2**2.)/144.+

     &  (941*Mgl**2.*Msq2**4.)/768.-

     &  (1229*Msq2**6.)/2304.-

     &  (17*Msq2**8.)/(192.*Mgl**2.)+

     &  Msq2**10./(64.*Mgl**4.))*Den(Msq2,Mgl)**4.*

     &  Tfin0(Msq2,Mgl)+

     &  ((-199*Mgl**10.)/384.-Mgl**14./(384.*Msq2**4.)+

     &  (83*Mgl**12.)/(576.*Msq2**2.)+

     &  (335*Mgl**8.*Msq2**2.)/288.-

     &  (943*Mgl**6.*Msq2**4.)/384.+

     &  (1985*Mgl**4.*Msq2**6.)/576.-

     &  (929*Mgl**2.*Msq2**8.)/384.+(91*Msq2**10.)/144.+

     &  Msq2**12./(144.*Mgl**2.)+Msq2**14./(288.*Mgl**4.))

     &  *Den(Msq2,Mgl)**6.*Tfin0(Msq2,Mgl)+

     &  ((-7*Mgl**14.)/96.-(37*Mgl**18.)/(4608.*Msq2**4.)+

     &  (73*Mgl**16.)/(4608.*Msq2**2.)+

     &  (17*Mgl**12.*Msq2**2.)/64.-

     &  (49*Mgl**10.*Msq2**4.)/2304.-

     &  (3263*Mgl**8.*Msq2**6.)/2304.+

     &  (557*Mgl**6.*Msq2**8.)/192.-

     &  (749*Mgl**4.*Msq2**10.)/288.+

     &  (5231*Mgl**2.*Msq2**12.)/4608.-

     &  (947*Msq2**14.)/4608.+Msq2**16./(96.*Mgl**2.)-

     &  Msq2**18./(288.*Mgl**4.))*Den(Msq2,Mgl)**8.*

     &  Tfin0(Msq2,Mgl)))+

     &  cA*(Nt*(-0.1577690972222222+

     &  (7*Mgl**2.)/(10368.*Mst1**2.)-

     &  (451*Mst1**2.)/(6912.*Mgl**2.)+

     &  (955*Mst1**4.)/(82944.*Mgl**4.)+

     &  (7*Mgl**2.)/(10368.*Mst2**2.)-

     &  (451*Mst2**2.)/(6912.*Mgl**2.)+

     &  (955*Mst2**4.)/(82944.*Mgl**4.)+

     &  (13*Mgl**2.)/(1728.*Mt**2.)-

     &  (13*Mgl**4.)/(3456.*Mst1**2.*Mt**2.)+

     &  (13*Mst1**2.)/(3456.*Mt**2.)-

     &  (13*Mst1**4.)/(3456.*Mgl**2.*Mt**2.)-

     &  (13*Mgl**4.)/(3456.*Mst2**2.*Mt**2.)+

     &  (13*Mst2**2.)/(3456.*Mt**2.)-

     &  (13*Mst2**4.)/(3456.*Mgl**2.*Mt**2.)+

     &  (43*Mt**2.)/(1728.*Mgl**2.)-

     &  Mt**2./(20736.*Mst1**2.)-

     &  (1879*Mst1**2.*Mt**2.)/(41472.*Mgl**4.)-

     &  Mt**2./(20736.*Mst2**2.)-

     &  (1879*Mst2**2.*Mt**2.)/(41472.*Mgl**4.)+

     &  (4147*Mt**4.)/(41472.*Mgl**4.)+

     &  (29*Mt**4.)/(2304.*Mgl**2.*Mst1**2.)+

     &  (29*Mt**4.)/(2304.*Mgl**2.*Mst2**2.)-

     &  (7*Mt**6.)/(432.*Mgl**4.*Mst1**2.)-

     &  (7*Mt**6.)/(432.*Mgl**4.*Mst2**2.)+(53*z2)/576.+

     &  (5*Mgl**2.*z2)/(576.*Mst1**2.)-

     &  (7*Mst1**2.*z2)/(384.*Mgl**2.)+

     &  (5*Mgl**2.*z2)/(576.*Mst2**2.)-

     &  (7*Mst2**2.*z2)/(384.*Mgl**2.)+

     &  (7*Mt**2.*z2)/(144.*Mgl**2.)-

     &  (Mt**2.*z2)/(576.*Mst1**2.)-

     &  (Mst1**2.*Mt**2.*z2)/(1152.*Mgl**4.)-

     &  (Mt**2.*z2)/(576.*Mst2**2.)-

     &  (Mst2**2.*Mt**2.*z2)/(1152.*Mgl**4.)+

     &  (Mt**4.*z2)/(576.*Mgl**4.)+

     &  (-0.041666666666666664+Mst1**2./(24.*Mgl**2.)-

     &  Mt**2./(24.*Mgl**2.))*B0fin(Mgl,Mt,Mst1,mu)+

     &  (-0.041666666666666664+Mst2**2./(24.*Mgl**2.)-

     &  Mt**2./(24.*Mgl**2.))*B0fin(Mgl,Mt,Mst2,mu)+

     &  ((-3409*Mgl**4.)/27648.+

     &  (59*Mgl**8.)/(5184.*Mst1**4.)-

     &  (55*Mgl**6.)/(3456.*Mst1**2.)+

     &  (25*Mgl**2.*Mst1**2.)/41472.-

     &  (8563*Mst1**4.)/41472.+

     &  (389*Mst1**6.)/(41472.*Mgl**2.)+

     &  (199*Mst1**8.)/(27648.*Mgl**4.)+

     &  (71*Mgl**6.)/(576.*Mt**2.)-

     &  (71*Mgl**8.)/(1728.*Mst1**2.*Mt**2.)-

     &  (71*Mgl**4.*Mst1**2.)/(864.*Mt**2.)-

     &  (71*Mgl**2.*Mst1**4.)/(864.*Mt**2.)+

     &  (71*Mst1**6.)/(576.*Mt**2.)-

     &  (71*Mst1**8.)/(1728.*Mgl**2.*Mt**2.)-

     &  (13795*Mgl**2.*Mt**2.)/41472.-

     &  (145*Mgl**6.*Mt**2.)/(5184.*Mst1**4.)-

     &  (1739*Mgl**4.*Mt**2.)/(20736.*Mst1**2.)-

     &  (8491*Mst1**2.*Mt**2.)/20736.-

     &  (1649*Mst1**4.*Mt**2.)/(13824.*Mgl**2.)+

     &  (211*Mst1**6.*Mt**2.)/(6912.*Mgl**4.)-

     &  (11363*Mt**4.)/41472.+

     &  (7*Mgl**4.*Mt**4.)/(288.*Mst1**4.)+

     &  (581*Mgl**2.*Mt**4.)/(10368.*Mst1**2.)+

     &  (10213*Mst1**2.*Mt**4.)/(41472.*Mgl**2.)-

     &  (2159*Mst1**4.*Mt**4.)/(13824.*Mgl**4.)-

     &  (793*Mt**6.)/(13824.*Mgl**2.)+

     &  (23*Mgl**2.*Mt**6.)/(2592.*Mst1**4.)+

     &  (1813*Mt**6.)/(20736.*Mst1**2.)+

     &  (1475*Mst1**2.*Mt**6.)/(6912.*Mgl**4.)-

     &  (3217*Mt**8.)/(27648.*Mgl**4.)-

     &  (185*Mt**8.)/(5184.*Mst1**4.)-

     &  (197*Mt**8.)/(3456.*Mgl**2.*Mst1**2.)+

     &  (11*Mt**10.)/(576.*Mgl**2.*Mst1**4.)+

     &  (37*Mt**10.)/(1728.*Mgl**4.*Mst1**2.)-

     &  (5*Mgl**4.*z2)/96.+(Mgl**8.*z2)/(288.*Mst1**4.)-

     &  (13*Mgl**6.*z2)/(1152.*Mst1**2.)+

     &  (Mgl**2.*Mst1**2.*z2)/8.-(61*Mst1**4.*z2)/576.-

     &  (5*Mst1**6.*z2)/(1152.*Mgl**2.)+

     &  (Mst1**8.*z2)/(288.*Mgl**4.)+

     &  (53*Mgl**2.*Mt**2.*z2)/576.-

     &  (Mgl**6.*Mt**2.*z2)/(144.*Mst1**4.)-

     &  (17*Mgl**4.*Mt**2.*z2)/(1152.*Mst1**2.)+

     &  (31*Mst1**2.*Mt**2.*z2)/288.-

     &  (35*Mst1**4.*Mt**2.*z2)/(576.*Mgl**2.)-

     &  (5*Mst1**6.*Mt**2.*z2)/(1152.*Mgl**4.)-

     &  (53*Mt**4.*z2)/1152.-

     &  (Mgl**2.*Mt**4.*z2)/(384.*Mst1**2.)+

     &  (55*Mst1**2.*Mt**4.*z2)/(384.*Mgl**2.)-

     &  (Mst1**4.*Mt**4.*z2)/(128.*Mgl**4.)-

     &  (5*Mt**6.*z2)/(64.*Mgl**2.)+

     &  (Mgl**2.*Mt**6.*z2)/(144.*Mst1**4.)+

     &  (11*Mt**6.*z2)/(384.*Mst1**2.)+

     &  (17*Mst1**2.*Mt**6.*z2)/(1152.*Mgl**4.)-

     &  (7*Mt**8.*z2)/(1152.*Mgl**4.)-

     &  (Mt**8.*z2)/(288.*Mst1**4.))*d123(Mt,Mgl,Mst1)+

     &  ((-8927*Mgl**8.)/82944.+

     &  (25*Mgl**12.)/(864.*Mst1**4.)+

     &  (1159*Mgl**10.)/(27648.*Mst1**2.)-

     &  (26539*Mgl**6.*Mst1**2.)/82944.+

     &  (37013*Mgl**4.*Mst1**4.)/82944.-

     &  (7541*Mgl**2.*Mst1**6.)/82944.-

     &  (7097*Mst1**8.)/82944.+

     &  (6715*Mst1**10.)/(82944.*Mgl**2.)+

     &  (499*Mst1**12.)/(82944.*Mgl**4.)-

     &  (1075*Mgl**10.)/(3456.*Mt**2.)+

     &  (215*Mgl**12.)/(3456.*Mst1**2.*Mt**2.)+

     &  (215*Mgl**8.*Mst1**2.)/(384.*Mt**2.)-

     &  (1075*Mgl**6.*Mst1**4.)/(3456.*Mt**2.)-

     &  (1075*Mgl**4.*Mst1**6.)/(3456.*Mt**2.)+

     &  (215*Mgl**2.*Mst1**8.)/(384.*Mt**2.)-

     &  (1075*Mst1**10.)/(3456.*Mt**2.)+

     &  (215*Mst1**12.)/(3456.*Mgl**2.*Mt**2.)+

     &  (4573*Mgl**6.*Mt**2.)/27648.-

     &  (335*Mgl**10.*Mt**2.)/(5184.*Mst1**4.)-

     &  (17315*Mgl**8.*Mt**2.)/(82944.*Mst1**2.)+

     &  (2863*Mgl**4.*Mst1**2.*Mt**2.)/20736.-

     &  (23821*Mgl**2.*Mst1**4.*Mt**2.)/41472.+

     &  (68393*Mst1**6.*Mt**2.)/82944.-

     &  (32197*Mst1**8.*Mt**2.)/(82944.*Mgl**2.)+

     &  (923*Mst1**10.*Mt**2.)/(41472.*Mgl**4.)-

     &  (56255*Mgl**4.*Mt**4.)/82944.+

     &  (31*Mgl**8.*Mt**4.)/(864.*Mst1**4.)-

     &  (713*Mgl**6.*Mt**4.)/(6912.*Mst1**2.)-

     &  (33883*Mgl**2.*Mst1**2.*Mt**4.)/20736.-

     &  (48901*Mst1**4.*Mt**4.)/41472.-

     &  (2447*Mst1**6.*Mt**4.)/(6912.*Mgl**2.)-

     &  (9707*Mst1**8.*Mt**4.)/(82944.*Mgl**4.)+

     &  (887*Mgl**2.*Mt**6.)/10368.+

     &  (5*Mgl**6.*Mt**6.)/(81.*Mst1**4.)-

     &  (55*Mgl**4.*Mt**6.)/(6912.*Mst1**2.)+

     &  (12109*Mst1**2.*Mt**6.)/20736.+

     &  (16147*Mst1**4.*Mt**6.)/(10368.*Mgl**2.)+

     &  (2489*Mst1**6.*Mt**6.)/(20736.*Mgl**4.)+

     &  (13669*Mt**8.)/27648.-

     &  (181*Mgl**4.*Mt**8.)/(1296.*Mst1**4.)+

     &  (39971*Mgl**2.*Mt**8.)/(82944.*Mst1**2.)-

     &  (102371*Mst1**2.*Mt**8.)/(82944.*Mgl**2.)+

     &  (2861*Mst1**4.*Mt**8.)/(82944.*Mgl**4.)+

     &  (5071*Mt**10.)/(27648.*Mgl**2.)+

     &  (89*Mgl**2.*Mt**10.)/(1728.*Mst1**4.)-

     &  (1235*Mt**10.)/(3072.*Mst1**2.)-

     &  (4709*Mst1**2.*Mt**10.)/(41472.*Mgl**4.)+

     &  (1465*Mt**12.)/(27648.*Mgl**4.)+

     &  (97*Mt**12.)/(1296.*Mst1**4.)+

     &  (325*Mt**12.)/(2304.*Mgl**2.*Mst1**2.)-

     &  (7*Mt**14.)/(144.*Mgl**2.*Mst1**4.)-

     &  Mt**14./(192.*Mgl**4.*Mst1**2.)-

     &  (13*Mgl**8.*z2)/192.-

     &  (Mgl**12.*z2)/(288.*Mst1**4.)+

     &  (53*Mgl**10.*z2)/(1152.*Mst1**2.)-

     &  (179*Mgl**6.*Mst1**2.*z2)/1152.+

     &  (13*Mgl**4.*Mst1**4.*z2)/48.-

     &  (41*Mgl**2.*Mst1**6.*z2)/1152.-

     &  (23*Mst1**8.*z2)/192.+

     &  (79*Mst1**10.*z2)/(1152.*Mgl**2.)-

     &  (Mst1**12.*z2)/(288.*Mgl**4.)-

     &  (53*Mgl**6.*Mt**2.*z2)/384.+

     &  (7*Mgl**10.*Mt**2.*z2)/(288.*Mst1**4.)-

     &  (Mgl**8.*Mt**2.*z2)/(96.*Mst1**2.)+

     &  (215*Mgl**4.*Mst1**2.*Mt**2.*z2)/1152.+

     &  (11*Mgl**2.*Mst1**4.*Mt**2.*z2)/288.+

     &  (5*Mst1**6.*Mt**2.*z2)/192.-

     &  (17*Mst1**8.*Mt**2.*z2)/(128.*Mgl**2.)+

     &  (23*Mst1**10.*Mt**2.*z2)/(1152.*Mgl**4.)+

     &  (9*Mgl**4.*Mt**4.*z2)/128.-

     &  (19*Mgl**8.*Mt**4.*z2)/(576.*Mst1**4.)-

     &  (17*Mgl**6.*Mt**4.*z2)/(144.*Mst1**2.)-

     &  (121*Mgl**2.*Mst1**2.*Mt**4.*z2)/576.+

     &  (85*Mst1**4.*Mt**4.*z2)/576.-

     &  (17*Mst1**6.*Mt**4.*z2)/(192.*Mgl**2.)-

     &  (37*Mst1**8.*Mt**4.*z2)/(1152.*Mgl**4.)-

     &  (53*Mgl**2.*Mt**6.*z2)/576.-

     &  (Mgl**6.*Mt**6.*z2)/(96.*Mst1**4.)-

     &  (7*Mgl**4.*Mt**6.*z2)/(144.*Mst1**2.)-

     &  (7*Mst1**2.*Mt**6.*z2)/64.+

     &  (13*Mst1**4.*Mt**6.*z2)/(36.*Mgl**2.)-

     &  (Mst1**6.*Mt**6.*z2)/(576.*Mgl**4.)+

     &  (91*Mt**8.*z2)/576.+

     &  (11*Mgl**4.*Mt**8.*z2)/(288.*Mst1**4.)+

     &  (89*Mgl**2.*Mt**8.*z2)/(384.*Mst1**2.)-

     &  (103*Mst1**2.*Mt**8.*z2)/(384.*Mgl**2.)+

     &  (29*Mst1**4.*Mt**8.*z2)/(576.*Mgl**4.)+

     &  (23*Mt**10.*z2)/(384.*Mgl**2.)-

     &  (Mgl**2.*Mt**10.*z2)/(72.*Mst1**4.)-

     &  (29*Mt**10.*z2)/(288.*Mst1**2.)-

     &  (53*Mst1**2.*Mt**10.*z2)/(1152.*Mgl**4.)+

     &  (5*Mt**12.*z2)/(384.*Mgl**4.)-

     &  (Mt**12.*z2)/(576.*Mst1**4.))*d123(Mt,Mgl,Mst1)**2.

     &  +((77545*Mgl**12.)/82944.-

     &  (59*Mgl**16.)/(576.*Mst1**4.)-

     &  (167*Mgl**14.)/(6912.*Mst1**2.)-

     &  (10957*Mgl**10.*Mst1**2.)/20736.-

     &  (93095*Mgl**8.*Mst1**4.)/41472.+

     &  (2423*Mgl**6.*Mst1**6.)/768.-

     &  (15197*Mgl**4.*Mst1**8.)/20736.-

     &  (25643*Mgl**2.*Mst1**10.)/20736.+

     &  (38695*Mst1**12.)/41472.-

     &  (5*Mst1**14.)/(72.*Mgl**2.)-

     &  (2327*Mst1**16.)/(27648.*Mgl**4.)+

     &  (35*Mgl**14.)/(288.*Mt**2.)-

     &  (5*Mgl**16.)/(288.*Mst1**2.*Mt**2.)-

     &  (25*Mgl**12.*Mst1**2.)/(72.*Mt**2.)+

     &  (35*Mgl**10.*Mst1**4.)/(72.*Mt**2.)-

     &  (35*Mgl**8.*Mst1**6.)/(144.*Mt**2.)-

     &  (35*Mgl**6.*Mst1**8.)/(144.*Mt**2.)+

     &  (35*Mgl**4.*Mst1**10.)/(72.*Mt**2.)-

     &  (25*Mgl**2.*Mst1**12.)/(72.*Mt**2.)+

     &  (35*Mst1**14.)/(288.*Mt**2.)-

     &  (5*Mst1**16.)/(288.*Mgl**2.*Mt**2.)-

     &  (51673*Mgl**10.*Mt**2.)/20736.+

     &  (835*Mgl**14.*Mt**2.)/(1728.*Mst1**4.)+

     &  (1093*Mgl**12.*Mt**2.)/(6912.*Mst1**2.)+

     &  (25183*Mgl**8.*Mst1**2.*Mt**2.)/20736.+

     &  (19159*Mgl**6.*Mst1**4.*Mt**2.)/10368.-

     &  (60695*Mgl**4.*Mst1**6.*Mt**2.)/20736.+

     &  (100327*Mgl**2.*Mst1**8.*Mt**2.)/20736.-

     &  (90239*Mst1**10.*Mt**2.)/20736.+

     &  (703*Mst1**12.*Mt**2.)/(864.*Mgl**2.)+

     &  (269*Mst1**14.*Mt**2.)/(648.*Mgl**4.)+

     &  (20999*Mgl**8.*Mt**4.)/13824.-

     &  (1189*Mgl**12.*Mt**4.)/(1296.*Mst1**4.)+

     &  (8611*Mgl**10.*Mt**4.)/(20736.*Mst1**2.)+

     &  (3425*Mgl**6.*Mst1**2.*Mt**4.)/10368.+

     &  (24187*Mgl**4.*Mst1**4.*Mt**4.)/10368.-

     &  (6247*Mgl**2.*Mst1**6.*Mt**4.)/2304.+

     &  (3425*Mst1**8.*Mt**4.)/512.-

     &  (17509*Mst1**10.*Mt**4.)/(10368.*Mgl**2.)-

     &  (15253*Mst1**12.*Mt**4.)/(20736.*Mgl**4.)-

     &  (77*Mgl**6.*Mt**6.)/162.+

     &  (47*Mgl**10.*Mt**6.)/(54.*Mst1**4.)-

     &  (24691*Mgl**8.*Mt**6.)/(20736.*Mst1**2.)-

     &  (121*Mgl**4.*Mst1**2.*Mt**6.)/144.-

     &  (2567*Mgl**2.*Mst1**4.*Mt**6.)/10368.-

     &  (114881*Mst1**6.*Mt**6.)/20736.+

     &  (1469*Mst1**8.*Mt**6.)/(3456.*Mgl**2.)+

     &  (707*Mst1**10.*Mt**6.)/(1728.*Mgl**4.)-

     &  (25199*Mgl**4.*Mt**8.)/20736.-

     &  (487*Mgl**8.*Mt**8.)/(2592.*Mst1**4.)+

     &  (4081*Mgl**6.*Mt**8.)/(20736.*Mst1**2.)-

     &  (12245*Mgl**2.*Mst1**2.*Mt**8.)/6912.+

     &  (107453*Mst1**4.*Mt**8.)/41472.+

     &  (2975*Mst1**6.*Mt**8.)/(1296.*Mgl**2.)+

     &  (14525*Mst1**8.*Mt**8.)/(41472.*Mgl**4.)+

     &  (691*Mgl**2.*Mt**10.)/256.-

     &  (1945*Mgl**6.*Mt**10.)/(2592.*Mst1**4.)+

     &  (19765*Mgl**4.*Mt**10.)/(20736.*Mst1**2.)+

     &  (2699*Mst1**2.*Mt**10.)/6912.-

     &  (7151*Mst1**4.*Mt**10.)/(2592.*Mgl**2.)-

     &  (1547*Mst1**6.*Mt**10.)/(2592.*Mgl**4.)-

     &  (15935*Mt**12.)/13824.+

     &  (487*Mgl**4.*Mt**12.)/(432.*Mst1**4.)-

     &  (4081*Mgl**2.*Mt**12.)/(6912.*Mst1**2.)+

     &  (1195*Mst1**2.*Mt**12.)/(1152.*Mgl**2.)+

     &  (623*Mst1**4.*Mt**12.)/(2304.*Mgl**4.)+

     &  (755*Mt**14.)/(10368.*Mgl**2.)-

     &  (205*Mgl**2.*Mt**14.)/(324.*Mst1**4.)+

     &  (4951*Mt**14.)/(20736.*Mst1**2.)-

     &  (83*Mst1**2.*Mt**14.)/(5184.*Mgl**4.)-

     &  (1021*Mt**16.)/(82944.*Mgl**4.)+

     &  (139*Mt**16.)/(1728.*Mst1**4.)-

     &  (241*Mt**16.)/(1728.*Mgl**2.*Mst1**2.)+

     &  (17*Mt**18.)/(576.*Mgl**2.*Mst1**4.)+

     &  (269*Mgl**12.*z2)/1152.-

     &  (Mgl**16.*z2)/(288.*Mst1**4.)-

     &  (Mgl**14.*z2)/(18.*Mst1**2.)-

     &  (103*Mgl**10.*Mst1**2.*z2)/1152.-

     &  (685*Mgl**8.*Mst1**4.*z2)/1152.+

     &  (107*Mgl**6.*Mst1**6.*z2)/128.-

     &  (83*Mgl**4.*Mst1**8.*z2)/384.-

     &  (115*Mgl**2.*Mst1**10.*z2)/384.+

     &  (289*Mst1**12.*z2)/1152.-

     &  (67*Mst1**14.*z2)/(1152.*Mgl**2.)-

     &  (Mst1**16.*z2)/(288.*Mgl**4.)-

     &  (91*Mgl**10.*Mt**2.*z2)/288.+

     &  (49*Mgl**12.*Mt**2.*z2)/(288.*Mst1**2.)-

     &  (331*Mgl**8.*Mst1**2.*Mt**2.*z2)/1152.+

     &  (15*Mgl**6.*Mst1**4.*Mt**2.*z2)/32.+

     &  (Mgl**4.*Mst1**6.*Mt**2.*z2)/384.+

     &  (Mgl**2.*Mst1**8.*Mt**2.*z2)/3.-

     &  (251*Mst1**10.*Mt**2.*z2)/384.+

     &  (5*Mst1**12.*Mt**2.*z2)/(18.*Mgl**2.)+

     &  (5*Mst1**14.*Mt**2.*z2)/(1152.*Mgl**4.)+

     &  (13*Mgl**8.*Mt**4.*z2)/576.+

     &  (5*Mgl**12.*Mt**4.*z2)/(144.*Mst1**4.)+

     &  (Mgl**10.*Mt**4.*z2)/(144.*Mst1**2.)+

     &  (397*Mgl**6.*Mst1**2.*Mt**4.*z2)/1152.-

     &  (41*Mgl**4.*Mst1**4.*Mt**4.*z2)/384.+

     &  (193*Mgl**2.*Mst1**6.*Mt**4.*z2)/576.+

     &  (77*Mst1**8.*Mt**4.*z2)/144.-

     &  (463*Mst1**10.*Mt**4.*z2)/(1152.*Mgl**2.)+

     &  (41*Mst1**12.*Mt**4.*z2)/(1152.*Mgl**4.)+

     &  (7*Mgl**6.*Mt**6.*z2)/96.-

     &  (5*Mgl**10.*Mt**6.*z2)/(144.*Mst1**4.)-

     &  (25*Mgl**8.*Mt**6.*z2)/(96.*Mst1**2.)-

     &  (47*Mgl**4.*Mst1**2.*Mt**6.*z2)/1152.-

     &  (Mgl**2.*Mst1**4.*Mt**6.*z2)/3.-

     &  (97*Mst1**6.*Mt**6.*z2)/576.-

     &  (Mst1**8.*Mt**6.*z2)/(144.*Mgl**2.)-

     &  (127*Mst1**10.*Mt**6.*z2)/(1152.*Mgl**4.)-

     &  (21*Mgl**4.*Mt**8.*z2)/32.-

     &  (Mgl**8.*Mt**8.*z2)/(16.*Mst1**4.)-

     &  (29*Mgl**6.*Mt**8.*z2)/(144.*Mst1**2.)-

     &  (227*Mgl**2.*Mst1**2.*Mt**8.*z2)/384.-

     &  (37*Mst1**4.*Mt**8.*z2)/384.+

     &  (607*Mst1**6.*Mt**8.*z2)/(1152.*Mgl**2.)+

     &  (125*Mst1**8.*Mt**8.*z2)/(1152.*Mgl**4.)+

     &  (47*Mgl**2.*Mt**10.*z2)/48.+

     &  (7*Mgl**6.*Mt**10.*z2)/(72.*Mst1**4.)+

     &  (193*Mgl**4.*Mt**10.*z2)/(288.*Mst1**2.)+

     &  (463*Mst1**2.*Mt**10.*z2)/1152.-

     &  (67*Mst1**4.*Mt**10.*z2)/(144.*Mgl**2.)-

     &  (Mst1**6.*Mt**10.*z2)/(1152.*Mgl**4.)-

     &  (187*Mt**12.*z2)/576.+

     &  (Mgl**4.*Mt**12.*z2)/(144.*Mst1**4.)-

     &  (13*Mgl**2.*Mt**12.*z2)/(36.*Mst1**2.)+

     &  (49*Mst1**2.*Mt**12.*z2)/(384.*Mgl**2.)-

     &  (85*Mst1**4.*Mt**12.*z2)/(1152.*Mgl**4.)-

     &  (Mgl**2.*Mt**14.*z2)/(16.*Mst1**4.)+

     &  (Mt**14.*z2)/(32.*Mst1**2.)+

     &  (59*Mst1**2.*Mt**14.*z2)/(1152.*Mgl**4.)-

     &  (13*Mt**16.*z2)/(1152.*Mgl**4.)+

     &  (7*Mt**16.*z2)/(288.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.+

     &  ((-11107*Mgl**16.)/20736.+

     &  (161*Mgl**20.)/(2592.*Mst1**4.)-

     &  (7121*Mgl**18.)/(82944.*Mst1**2.)+

     &  (86795*Mgl**14.*Mst1**2.)/82944.+

     &  (19171*Mgl**12.*Mst1**4.)/13824.-

     &  (82435*Mgl**10.*Mst1**6.)/13824.+

     &  (4103*Mgl**8.*Mst1**8.)/576.-

     &  (45611*Mgl**6.*Mst1**10.)/13824.-

     &  (1849*Mgl**4.*Mst1**12.)/2304.+

     &  (138275*Mgl**2.*Mst1**14.)/82944.-

     &  (12229*Mst1**16.)/20736.-

     &  (5705*Mst1**18.)/(82944.*Mgl**2.)+

     &  (2465*Mst1**20.)/(41472.*Mgl**4.)+

     &  (39877*Mgl**14.*Mt**2.)/27648.-

     &  (79*Mgl**18.*Mt**2.)/(192.*Mst1**4.)+

     &  (45139*Mgl**16.*Mt**2.)/(82944.*Mst1**2.)-

     &  (4669*Mgl**12.*Mst1**2.*Mt**2.)/2304.-

     &  (6971*Mgl**10.*Mst1**4.*Mt**2.)/5184.+

     &  (141647*Mgl**8.*Mst1**6.*Mt**2.)/41472.-

     &  (142693*Mgl**6.*Mst1**8.*Mt**2.)/41472.+

     &  (13939*Mgl**4.*Mst1**10.*Mt**2.)/2592.-

     &  (69713*Mgl**2.*Mst1**12.*Mt**2.)/10368.+

     &  (290327*Mst1**14.*Mt**2.)/82944.+

     &  (8195*Mst1**16.*Mt**2.)/(82944.*Mgl**2.)-

     &  (2983*Mst1**18.*Mt**2.)/(6912.*Mgl**4.)-

     &  (18619*Mgl**12.*Mt**4.)/41472.+

     &  (2995*Mgl**16.*Mt**4.)/(2592.*Mst1**4.)-

     &  (82549*Mgl**14.*Mt**4.)/(41472.*Mst1**2.)+

     &  (1039*Mgl**10.*Mst1**2.*Mt**4.)/1152.+

     &  (9035*Mgl**8.*Mst1**4.*Mt**4.)/5184.+

     &  (45619*Mgl**6.*Mst1**6.*Mt**4.)/20736.-

     &  (143605*Mgl**4.*Mst1**8.*Mt**4.)/20736.+

     &  (33403*Mgl**2.*Mst1**10.*Mt**4.)/3456.-

     &  (42845*Mst1**12.*Mt**4.)/5184.+

     &  (26863*Mst1**14.*Mt**4.)/(41472.*Mgl**2.)+

     &  (18199*Mst1**16.*Mt**4.)/(13824.*Mgl**4.)-

     &  (64817*Mgl**10.*Mt**6.)/41472.-

     &  (4715*Mgl**14.*Mt**6.)/(2592.*Mst1**4.)+

     &  (66919*Mgl**12.*Mt**6.)/(13824.*Mst1**2.)-

     &  (12911*Mgl**8.*Mst1**2.*Mt**6.)/13824.-

     &  (3257*Mgl**6.*Mst1**4.*Mt**6.)/1536.+

     &  (177355*Mgl**4.*Mst1**6.*Mt**6.)/41472.-

     &  (266863*Mgl**2.*Mst1**8.*Mt**6.)/41472.+

     &  (413797*Mst1**10.*Mt**6.)/41472.-

     &  (28847*Mst1**12.*Mt**6.)/(13824.*Mgl**2.)-

     &  (3677*Mst1**14.*Mt**6.)/(1728.*Mgl**4.)+

     &  (1339*Mgl**8.*Mt**8.)/768.+

     &  (4469*Mgl**12.*Mt**8.)/(2592.*Mst1**4.)-

     &  (143437*Mgl**10.*Mt**8.)/(20736.*Mst1**2.)+

     &  (25331*Mgl**6.*Mst1**2.*Mt**8.)/6912.+

     &  (36851*Mgl**4.*Mst1**4.*Mt**8.)/20736.+

     &  (90329*Mgl**2.*Mst1**6.*Mt**8.)/20736.-

     &  (131437*Mst1**8.*Mt**8.)/20736.+

     &  (42539*Mst1**10.*Mt**8.)/(20736.*Mgl**2.)+

     &  (12467*Mst1**12.*Mt**8.)/(6912.*Mgl**4.)-

     &  (27073*Mgl**6.*Mt**10.)/10368.-

     &  (107*Mgl**10.*Mt**10.)/(162.*Mst1**4.)+

     &  (54647*Mgl**8.*Mt**10.)/(10368.*Mst1**2.)-

     &  (48473*Mgl**4.*Mst1**2.*Mt**10.)/6912.-

     &  (130801*Mgl**2.*Mst1**4.*Mt**10.)/20736.+

     &  (26291*Mst1**6.*Mt**10.)/20736.+

     &  (2555*Mst1**8.*Mt**10.)/(20736.*Mgl**2.)-

     &  (1589*Mst1**10.*Mt**10.)/(3456.*Mgl**4.)+

     &  (74135*Mgl**4.*Mt**12.)/20736.-

     &  (2531*Mgl**8.*Mt**12.)/(2592.*Mst1**4.)-

     &  (96347*Mgl**6.*Mt**12.)/(41472.*Mst1**2.)+

     &  (122027*Mgl**2.*Mst1**2.*Mt**12.)/20736.+

     &  (14641*Mst1**4.*Mt**12.)/10368.-

     &  (23485*Mst1**6.*Mt**12.)/(13824.*Mgl**2.)-

     &  (413*Mst1**8.*Mt**12.)/(768.*Mgl**4.)-

     &  (64835*Mgl**2.*Mt**14.)/41472.+

     &  (5435*Mgl**6.*Mt**14.)/(2592.*Mst1**4.)+

     &  (21553*Mgl**4.*Mt**14.)/(13824.*Mst1**2.)-

     &  (49705*Mst1**2.*Mt**14.)/41472.+

     &  (51877*Mst1**4.*Mt**14.)/(41472.*Mgl**2.)+

     &  (947*Mst1**6.*Mt**14.)/(1728.*Mgl**4.)-

     &  (113*Mt**16.)/1728.-

     &  (2365*Mgl**4.*Mt**16.)/(1296.*Mst1**4.)-

     &  (110939*Mgl**2.*Mt**16.)/(82944.*Mst1**2.)-

     &  (28243*Mst1**2.*Mt**16.)/(82944.*Mgl**2.)-

     &  (2609*Mst1**4.*Mt**16.)/(13824.*Mgl**4.)+

     &  (1889*Mt**18.)/(82944.*Mgl**2.)+

     &  (4117*Mgl**2.*Mt**18.)/(5184.*Mst1**4.)+

     &  (12151*Mt**18.)/(27648.*Mst1**2.)+

     &  (299*Mst1**2.*Mt**18.)/(20736.*Mgl**4.)+

     &  (17*Mt**20.)/(4608.*Mgl**4.)-

     &  (91*Mt**20.)/(648.*Mst1**4.)-

     &  (65*Mgl**16.*z2)/576.+

     &  (Mgl**20.*z2)/(288.*Mst1**4.)+

     &  (7*Mgl**18.*z2)/(576.*Mst1**2.)+

     &  (29*Mgl**14.*Mst1**2.*z2)/192.+

     &  (85*Mgl**12.*Mst1**4.*z2)/288.-

     &  (311*Mgl**10.*Mst1**6.*z2)/288.+

     &  (373*Mgl**8.*Mst1**8.*z2)/288.-

     &  (191*Mgl**6.*Mst1**10.*z2)/288.-

     &  (11*Mgl**4.*Mst1**12.*z2)/288.+

     &  (15*Mgl**2.*Mst1**14.*z2)/64.-

     &  (65*Mst1**16.*z2)/576.+

     &  (7*Mst1**18.*z2)/(576.*Mgl**2.)+

     &  (Mst1**20.*z2)/(288.*Mgl**4.)+

     &  (415*Mgl**14.*Mt**2.*z2)/1152.-

     &  (5*Mgl**18.*Mt**2.*z2)/(288.*Mst1**4.)-

     &  (79*Mgl**16.*Mt**2.*z2)/(1152.*Mst1**2.)-

     &  (65*Mgl**12.*Mst1**2.*Mt**2.*z2)/288.-

     &  (145*Mgl**10.*Mst1**4.*Mt**2.*z2)/288.+

     &  (83*Mgl**8.*Mst1**6.*Mt**2.*z2)/144.-

     &  (Mgl**6.*Mst1**8.*Mt**2.*z2)/64.+

     &  (97*Mgl**4.*Mst1**10.*Mt**2.*z2)/576.-

     &  (101*Mgl**2.*Mst1**12.*Mt**2.*z2)/144.+

     &  (655*Mst1**14.*Mt**2.*z2)/1152.-

     &  (47*Mst1**16.*Mt**2.*z2)/(384.*Mgl**2.)-

     &  (11*Mst1**18.*Mt**2.*z2)/(576.*Mgl**4.)-

     &  (71*Mgl**12.*Mt**4.*z2)/288.+

     &  (5*Mgl**16.*Mt**4.*z2)/(192.*Mst1**4.)+

     &  (7*Mgl**14.*Mt**4.*z2)/(192.*Mst1**2.)+

     &  (23*Mgl**10.*Mst1**2.*Mt**4.*z2)/192.+

     &  (77*Mgl**8.*Mst1**4.*Mt**4.*z2)/288.-

     &  (53*Mgl**6.*Mst1**6.*Mt**4.*z2)/576.-

     &  (Mgl**4.*Mst1**8.*Mt**4.*z2)/16.+

     &  (109*Mgl**2.*Mst1**10.*Mt**4.*z2)/192.-

     &  (617*Mst1**12.*Mt**4.*z2)/576.+

     &  (61*Mst1**14.*Mt**4.*z2)/(144.*Mgl**2.)+

     &  (Mst1**16.*Mt**4.*z2)/(32.*Mgl**4.)-

     &  (17*Mgl**10.*Mt**6.*z2)/192.-

     &  (Mgl**14.*Mt**6.*z2)/(96.*Mst1**4.)+

     &  (113*Mgl**12.*Mt**6.*z2)/(288.*Mst1**2.)-

     &  (91*Mgl**8.*Mst1**2.*Mt**6.*z2)/576.-

     &  (151*Mgl**6.*Mst1**4.*Mt**6.*z2)/576.+

     &  (3*Mgl**4.*Mst1**6.*Mt**6.*z2)/16.+

     &  (Mgl**2.*Mst1**8.*Mt**6.*z2)/192.+

     &  (521*Mst1**10.*Mt**6.*z2)/576.-

     &  (379*Mst1**12.*Mt**6.*z2)/(576.*Mgl**2.)+

     &  (Mst1**14.*Mt**6.*z2)/(48.*Mgl**4.)+

     &  (31*Mgl**8.*Mt**8.*z2)/144.+

     &  (Mgl**12.*Mt**8.*z2)/(32.*Mst1**4.)-

     &  (469*Mgl**10.*Mt**8.*z2)/(576.*Mst1**2.)+

     &  (67*Mgl**6.*Mst1**2.*Mt**8.*z2)/96.+

     &  (151*Mgl**4.*Mst1**4.*Mt**8.*z2)/288.+

     &  (163*Mgl**2.*Mst1**6.*Mt**8.*z2)/576.-

     &  (5*Mst1**8.*Mt**8.*z2)/18.+

     &  (3*Mst1**10.*Mt**8.*z2)/(8.*Mgl**2.)-

     &  (7*Mst1**12.*Mt**8.*z2)/(48.*Mgl**4.)-

     &  (121*Mgl**6.*Mt**10.*z2)/144.-

     &  (11*Mgl**10.*Mt**10.*z2)/(96.*Mst1**4.)+

     &  (223*Mgl**8.*Mt**10.*z2)/(576.*Mst1**2.)-

     &  (317*Mgl**4.*Mst1**2.*Mt**10.*z2)/192.-

     &  (331*Mgl**2.*Mst1**4.*Mt**10.*z2)/288.-

     &  (5*Mst1**6.*Mt**10.*z2)/48.+

     &  (59*Mst1**8.*Mt**10.*z2)/(288.*Mgl**2.)+

     &  (7*Mst1**10.*Mt**10.*z2)/(32.*Mgl**4.)+

     &  (89*Mgl**4.*Mt**12.*z2)/72.+

     &  (5*Mgl**8.*Mt**12.*z2)/(48.*Mst1**4.)+

     &  (167*Mgl**6.*Mt**12.*z2)/(576.*Mst1**2.)+

     &  (725*Mgl**2.*Mst1**2.*Mt**12.*z2)/576.+

     &  (31*Mst1**4.*Mt**12.*z2)/144.-

     &  (29*Mst1**6.*Mt**12.*z2)/(72.*Mgl**2.)-

     &  (7*Mst1**8.*Mt**12.*z2)/(48.*Mgl**4.)-

     &  (293*Mgl**2.*Mt**14.*z2)/576.+

     &  (5*Mgl**6.*Mt**14.*z2)/(96.*Mst1**4.)-

     &  (7*Mgl**4.*Mt**14.*z2)/(32.*Mst1**2.)-

     &  (89*Mst1**2.*Mt**14.*z2)/576.+

     &  (37*Mst1**4.*Mt**14.*z2)/(192.*Mgl**2.)+

     &  (Mst1**6.*Mt**14.*z2)/(48.*Mgl**4.)-

     &  (7*Mt**16.*z2)/576.-

     &  (7*Mgl**4.*Mt**16.*z2)/(48.*Mst1**4.)-

     &  (23*Mgl**2.*Mt**16.*z2)/(288.*Mst1**2.)-

     &  (11*Mst1**2.*Mt**16.*z2)/(576.*Mgl**2.)+

     &  (Mst1**4.*Mt**16.*z2)/(32.*Mgl**4.)-

     &  (7*Mt**18.*z2)/(1152.*Mgl**2.)+

     &  (13*Mgl**2.*Mt**18.*z2)/(144.*Mst1**4.)+

     &  (73*Mt**18.*z2)/(1152.*Mst1**2.)-

     &  (11*Mst1**2.*Mt**18.*z2)/(576.*Mgl**4.)+

     &  (Mt**20.*z2)/(288.*Mgl**4.)-

     &  (11*Mt**20.*z2)/(576.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.+

     &  ((-3409*Mgl**4.)/27648.+

     &  (59*Mgl**8.)/(5184.*Mst2**4.)-

     &  (55*Mgl**6.)/(3456.*Mst2**2.)+

     &  (25*Mgl**2.*Mst2**2.)/41472.-

     &  (8563*Mst2**4.)/41472.+

     &  (389*Mst2**6.)/(41472.*Mgl**2.)+

     &  (199*Mst2**8.)/(27648.*Mgl**4.)+

     &  (71*Mgl**6.)/(576.*Mt**2.)-

     &  (71*Mgl**8.)/(1728.*Mst2**2.*Mt**2.)-

     &  (71*Mgl**4.*Mst2**2.)/(864.*Mt**2.)-

     &  (71*Mgl**2.*Mst2**4.)/(864.*Mt**2.)+

     &  (71*Mst2**6.)/(576.*Mt**2.)-

     &  (71*Mst2**8.)/(1728.*Mgl**2.*Mt**2.)-

     &  (13795*Mgl**2.*Mt**2.)/41472.-

     &  (145*Mgl**6.*Mt**2.)/(5184.*Mst2**4.)-

     &  (1739*Mgl**4.*Mt**2.)/(20736.*Mst2**2.)-

     &  (8491*Mst2**2.*Mt**2.)/20736.-

     &  (1649*Mst2**4.*Mt**2.)/(13824.*Mgl**2.)+

     &  (211*Mst2**6.*Mt**2.)/(6912.*Mgl**4.)-

     &  (11363*Mt**4.)/41472.+

     &  (7*Mgl**4.*Mt**4.)/(288.*Mst2**4.)+

     &  (581*Mgl**2.*Mt**4.)/(10368.*Mst2**2.)+

     &  (10213*Mst2**2.*Mt**4.)/(41472.*Mgl**2.)-

     &  (2159*Mst2**4.*Mt**4.)/(13824.*Mgl**4.)-

     &  (793*Mt**6.)/(13824.*Mgl**2.)+

     &  (23*Mgl**2.*Mt**6.)/(2592.*Mst2**4.)+

     &  (1813*Mt**6.)/(20736.*Mst2**2.)+

     &  (1475*Mst2**2.*Mt**6.)/(6912.*Mgl**4.)-

     &  (3217*Mt**8.)/(27648.*Mgl**4.)-

     &  (185*Mt**8.)/(5184.*Mst2**4.)-

     &  (197*Mt**8.)/(3456.*Mgl**2.*Mst2**2.)+

     &  (11*Mt**10.)/(576.*Mgl**2.*Mst2**4.)+

     &  (37*Mt**10.)/(1728.*Mgl**4.*Mst2**2.)-

     &  (5*Mgl**4.*z2)/96.+(Mgl**8.*z2)/(288.*Mst2**4.)-

     &  (13*Mgl**6.*z2)/(1152.*Mst2**2.)+

     &  (Mgl**2.*Mst2**2.*z2)/8.-(61*Mst2**4.*z2)/576.-

     &  (5*Mst2**6.*z2)/(1152.*Mgl**2.)+

     &  (Mst2**8.*z2)/(288.*Mgl**4.)+

     &  (53*Mgl**2.*Mt**2.*z2)/576.-

     &  (Mgl**6.*Mt**2.*z2)/(144.*Mst2**4.)-

     &  (17*Mgl**4.*Mt**2.*z2)/(1152.*Mst2**2.)+

     &  (31*Mst2**2.*Mt**2.*z2)/288.-

     &  (35*Mst2**4.*Mt**2.*z2)/(576.*Mgl**2.)-

     &  (5*Mst2**6.*Mt**2.*z2)/(1152.*Mgl**4.)-

     &  (53*Mt**4.*z2)/1152.-

     &  (Mgl**2.*Mt**4.*z2)/(384.*Mst2**2.)+

     &  (55*Mst2**2.*Mt**4.*z2)/(384.*Mgl**2.)-

     &  (Mst2**4.*Mt**4.*z2)/(128.*Mgl**4.)-

     &  (5*Mt**6.*z2)/(64.*Mgl**2.)+

     &  (Mgl**2.*Mt**6.*z2)/(144.*Mst2**4.)+

     &  (11*Mt**6.*z2)/(384.*Mst2**2.)+

     &  (17*Mst2**2.*Mt**6.*z2)/(1152.*Mgl**4.)-

     &  (7*Mt**8.*z2)/(1152.*Mgl**4.)-

     &  (Mt**8.*z2)/(288.*Mst2**4.))*d123(Mt,Mgl,Mst2)+

     &  ((-8927*Mgl**8.)/82944.+

     &  (25*Mgl**12.)/(864.*Mst2**4.)+

     &  (1159*Mgl**10.)/(27648.*Mst2**2.)-

     &  (26539*Mgl**6.*Mst2**2.)/82944.+

     &  (37013*Mgl**4.*Mst2**4.)/82944.-

     &  (7541*Mgl**2.*Mst2**6.)/82944.-

     &  (7097*Mst2**8.)/82944.+

     &  (6715*Mst2**10.)/(82944.*Mgl**2.)+

     &  (499*Mst2**12.)/(82944.*Mgl**4.)-

     &  (1075*Mgl**10.)/(3456.*Mt**2.)+

     &  (215*Mgl**12.)/(3456.*Mst2**2.*Mt**2.)+

     &  (215*Mgl**8.*Mst2**2.)/(384.*Mt**2.)-

     &  (1075*Mgl**6.*Mst2**4.)/(3456.*Mt**2.)-

     &  (1075*Mgl**4.*Mst2**6.)/(3456.*Mt**2.)+

     &  (215*Mgl**2.*Mst2**8.)/(384.*Mt**2.)-

     &  (1075*Mst2**10.)/(3456.*Mt**2.)+

     &  (215*Mst2**12.)/(3456.*Mgl**2.*Mt**2.)+

     &  (4573*Mgl**6.*Mt**2.)/27648.-

     &  (335*Mgl**10.*Mt**2.)/(5184.*Mst2**4.)-

     &  (17315*Mgl**8.*Mt**2.)/(82944.*Mst2**2.)+

     &  (2863*Mgl**4.*Mst2**2.*Mt**2.)/20736.-

     &  (23821*Mgl**2.*Mst2**4.*Mt**2.)/41472.+

     &  (68393*Mst2**6.*Mt**2.)/82944.-

     &  (32197*Mst2**8.*Mt**2.)/(82944.*Mgl**2.)+

     &  (923*Mst2**10.*Mt**2.)/(41472.*Mgl**4.)-

     &  (56255*Mgl**4.*Mt**4.)/82944.+

     &  (31*Mgl**8.*Mt**4.)/(864.*Mst2**4.)-

     &  (713*Mgl**6.*Mt**4.)/(6912.*Mst2**2.)-

     &  (33883*Mgl**2.*Mst2**2.*Mt**4.)/20736.-

     &  (48901*Mst2**4.*Mt**4.)/41472.-

     &  (2447*Mst2**6.*Mt**4.)/(6912.*Mgl**2.)-

     &  (9707*Mst2**8.*Mt**4.)/(82944.*Mgl**4.)+

     &  (887*Mgl**2.*Mt**6.)/10368.+

     &  (5*Mgl**6.*Mt**6.)/(81.*Mst2**4.)-

     &  (55*Mgl**4.*Mt**6.)/(6912.*Mst2**2.)+

     &  (12109*Mst2**2.*Mt**6.)/20736.+

     &  (16147*Mst2**4.*Mt**6.)/(10368.*Mgl**2.)+

     &  (2489*Mst2**6.*Mt**6.)/(20736.*Mgl**4.)+

     &  (13669*Mt**8.)/27648.-

     &  (181*Mgl**4.*Mt**8.)/(1296.*Mst2**4.)+

     &  (39971*Mgl**2.*Mt**8.)/(82944.*Mst2**2.)-

     &  (102371*Mst2**2.*Mt**8.)/(82944.*Mgl**2.)+

     &  (2861*Mst2**4.*Mt**8.)/(82944.*Mgl**4.)+

     &  (5071*Mt**10.)/(27648.*Mgl**2.)+

     &  (89*Mgl**2.*Mt**10.)/(1728.*Mst2**4.)-

     &  (1235*Mt**10.)/(3072.*Mst2**2.)-

     &  (4709*Mst2**2.*Mt**10.)/(41472.*Mgl**4.)+

     &  (1465*Mt**12.)/(27648.*Mgl**4.)+

     &  (97*Mt**12.)/(1296.*Mst2**4.)+

     &  (325*Mt**12.)/(2304.*Mgl**2.*Mst2**2.)-

     &  (7*Mt**14.)/(144.*Mgl**2.*Mst2**4.)-

     &  Mt**14./(192.*Mgl**4.*Mst2**2.)-

     &  (13*Mgl**8.*z2)/192.-

     &  (Mgl**12.*z2)/(288.*Mst2**4.)+

     &  (53*Mgl**10.*z2)/(1152.*Mst2**2.)-

     &  (179*Mgl**6.*Mst2**2.*z2)/1152.+

     &  (13*Mgl**4.*Mst2**4.*z2)/48.-

     &  (41*Mgl**2.*Mst2**6.*z2)/1152.-

     &  (23*Mst2**8.*z2)/192.+

     &  (79*Mst2**10.*z2)/(1152.*Mgl**2.)-

     &  (Mst2**12.*z2)/(288.*Mgl**4.)-

     &  (53*Mgl**6.*Mt**2.*z2)/384.+

     &  (7*Mgl**10.*Mt**2.*z2)/(288.*Mst2**4.)-

     &  (Mgl**8.*Mt**2.*z2)/(96.*Mst2**2.)+

     &  (215*Mgl**4.*Mst2**2.*Mt**2.*z2)/1152.+

     &  (11*Mgl**2.*Mst2**4.*Mt**2.*z2)/288.+

     &  (5*Mst2**6.*Mt**2.*z2)/192.-

     &  (17*Mst2**8.*Mt**2.*z2)/(128.*Mgl**2.)+

     &  (23*Mst2**10.*Mt**2.*z2)/(1152.*Mgl**4.)+

     &  (9*Mgl**4.*Mt**4.*z2)/128.-

     &  (19*Mgl**8.*Mt**4.*z2)/(576.*Mst2**4.)-

     &  (17*Mgl**6.*Mt**4.*z2)/(144.*Mst2**2.)-

     &  (121*Mgl**2.*Mst2**2.*Mt**4.*z2)/576.+

     &  (85*Mst2**4.*Mt**4.*z2)/576.-

     &  (17*Mst2**6.*Mt**4.*z2)/(192.*Mgl**2.)-

     &  (37*Mst2**8.*Mt**4.*z2)/(1152.*Mgl**4.)-

     &  (53*Mgl**2.*Mt**6.*z2)/576.-

     &  (Mgl**6.*Mt**6.*z2)/(96.*Mst2**4.)-

     &  (7*Mgl**4.*Mt**6.*z2)/(144.*Mst2**2.)-

     &  (7*Mst2**2.*Mt**6.*z2)/64.+

     &  (13*Mst2**4.*Mt**6.*z2)/(36.*Mgl**2.)-

     &  (Mst2**6.*Mt**6.*z2)/(576.*Mgl**4.)+

     &  (91*Mt**8.*z2)/576.+

     &  (11*Mgl**4.*Mt**8.*z2)/(288.*Mst2**4.)+

     &  (89*Mgl**2.*Mt**8.*z2)/(384.*Mst2**2.)-

     &  (103*Mst2**2.*Mt**8.*z2)/(384.*Mgl**2.)+

     &  (29*Mst2**4.*Mt**8.*z2)/(576.*Mgl**4.)+

     &  (23*Mt**10.*z2)/(384.*Mgl**2.)-

     &  (Mgl**2.*Mt**10.*z2)/(72.*Mst2**4.)-

     &  (29*Mt**10.*z2)/(288.*Mst2**2.)-

     &  (53*Mst2**2.*Mt**10.*z2)/(1152.*Mgl**4.)+

     &  (5*Mt**12.*z2)/(384.*Mgl**4.)-

     &  (Mt**12.*z2)/(576.*Mst2**4.))*d123(Mt,Mgl,Mst2)**2.

     &  +((77545*Mgl**12.)/82944.-

     &  (59*Mgl**16.)/(576.*Mst2**4.)-

     &  (167*Mgl**14.)/(6912.*Mst2**2.)-

     &  (10957*Mgl**10.*Mst2**2.)/20736.-

     &  (93095*Mgl**8.*Mst2**4.)/41472.+

     &  (2423*Mgl**6.*Mst2**6.)/768.-

     &  (15197*Mgl**4.*Mst2**8.)/20736.-

     &  (25643*Mgl**2.*Mst2**10.)/20736.+

     &  (38695*Mst2**12.)/41472.-

     &  (5*Mst2**14.)/(72.*Mgl**2.)-

     &  (2327*Mst2**16.)/(27648.*Mgl**4.)+

     &  (35*Mgl**14.)/(288.*Mt**2.)-

     &  (5*Mgl**16.)/(288.*Mst2**2.*Mt**2.)-

     &  (25*Mgl**12.*Mst2**2.)/(72.*Mt**2.)+

     &  (35*Mgl**10.*Mst2**4.)/(72.*Mt**2.)-

     &  (35*Mgl**8.*Mst2**6.)/(144.*Mt**2.)-

     &  (35*Mgl**6.*Mst2**8.)/(144.*Mt**2.)+

     &  (35*Mgl**4.*Mst2**10.)/(72.*Mt**2.)-

     &  (25*Mgl**2.*Mst2**12.)/(72.*Mt**2.)+

     &  (35*Mst2**14.)/(288.*Mt**2.)-

     &  (5*Mst2**16.)/(288.*Mgl**2.*Mt**2.)-

     &  (51673*Mgl**10.*Mt**2.)/20736.+

     &  (835*Mgl**14.*Mt**2.)/(1728.*Mst2**4.)+

     &  (1093*Mgl**12.*Mt**2.)/(6912.*Mst2**2.)+

     &  (25183*Mgl**8.*Mst2**2.*Mt**2.)/20736.+

     &  (19159*Mgl**6.*Mst2**4.*Mt**2.)/10368.-

     &  (60695*Mgl**4.*Mst2**6.*Mt**2.)/20736.+

     &  (100327*Mgl**2.*Mst2**8.*Mt**2.)/20736.-

     &  (90239*Mst2**10.*Mt**2.)/20736.+

     &  (703*Mst2**12.*Mt**2.)/(864.*Mgl**2.)+

     &  (269*Mst2**14.*Mt**2.)/(648.*Mgl**4.)+

     &  (20999*Mgl**8.*Mt**4.)/13824.-

     &  (1189*Mgl**12.*Mt**4.)/(1296.*Mst2**4.)+

     &  (8611*Mgl**10.*Mt**4.)/(20736.*Mst2**2.)+

     &  (3425*Mgl**6.*Mst2**2.*Mt**4.)/10368.+

     &  (24187*Mgl**4.*Mst2**4.*Mt**4.)/10368.-

     &  (6247*Mgl**2.*Mst2**6.*Mt**4.)/2304.+

     &  (3425*Mst2**8.*Mt**4.)/512.-

     &  (17509*Mst2**10.*Mt**4.)/(10368.*Mgl**2.)-

     &  (15253*Mst2**12.*Mt**4.)/(20736.*Mgl**4.)-

     &  (77*Mgl**6.*Mt**6.)/162.+

     &  (47*Mgl**10.*Mt**6.)/(54.*Mst2**4.)-

     &  (24691*Mgl**8.*Mt**6.)/(20736.*Mst2**2.)-

     &  (121*Mgl**4.*Mst2**2.*Mt**6.)/144.-

     &  (2567*Mgl**2.*Mst2**4.*Mt**6.)/10368.-

     &  (114881*Mst2**6.*Mt**6.)/20736.+

     &  (1469*Mst2**8.*Mt**6.)/(3456.*Mgl**2.)+

     &  (707*Mst2**10.*Mt**6.)/(1728.*Mgl**4.)-

     &  (25199*Mgl**4.*Mt**8.)/20736.-

     &  (487*Mgl**8.*Mt**8.)/(2592.*Mst2**4.)+

     &  (4081*Mgl**6.*Mt**8.)/(20736.*Mst2**2.)-

     &  (12245*Mgl**2.*Mst2**2.*Mt**8.)/6912.+

     &  (107453*Mst2**4.*Mt**8.)/41472.+

     &  (2975*Mst2**6.*Mt**8.)/(1296.*Mgl**2.)+

     &  (14525*Mst2**8.*Mt**8.)/(41472.*Mgl**4.)+

     &  (691*Mgl**2.*Mt**10.)/256.-

     &  (1945*Mgl**6.*Mt**10.)/(2592.*Mst2**4.)+

     &  (19765*Mgl**4.*Mt**10.)/(20736.*Mst2**2.)+

     &  (2699*Mst2**2.*Mt**10.)/6912.-

     &  (7151*Mst2**4.*Mt**10.)/(2592.*Mgl**2.)-

     &  (1547*Mst2**6.*Mt**10.)/(2592.*Mgl**4.)-

     &  (15935*Mt**12.)/13824.+

     &  (487*Mgl**4.*Mt**12.)/(432.*Mst2**4.)-

     &  (4081*Mgl**2.*Mt**12.)/(6912.*Mst2**2.)+

     &  (1195*Mst2**2.*Mt**12.)/(1152.*Mgl**2.)+

     &  (623*Mst2**4.*Mt**12.)/(2304.*Mgl**4.)+

     &  (755*Mt**14.)/(10368.*Mgl**2.)-

     &  (205*Mgl**2.*Mt**14.)/(324.*Mst2**4.)+

     &  (4951*Mt**14.)/(20736.*Mst2**2.)-

     &  (83*Mst2**2.*Mt**14.)/(5184.*Mgl**4.)-

     &  (1021*Mt**16.)/(82944.*Mgl**4.)+

     &  (139*Mt**16.)/(1728.*Mst2**4.)-

     &  (241*Mt**16.)/(1728.*Mgl**2.*Mst2**2.)+

     &  (17*Mt**18.)/(576.*Mgl**2.*Mst2**4.)+

     &  (269*Mgl**12.*z2)/1152.-

     &  (Mgl**16.*z2)/(288.*Mst2**4.)-

     &  (Mgl**14.*z2)/(18.*Mst2**2.)-

     &  (103*Mgl**10.*Mst2**2.*z2)/1152.-

     &  (685*Mgl**8.*Mst2**4.*z2)/1152.+

     &  (107*Mgl**6.*Mst2**6.*z2)/128.-

     &  (83*Mgl**4.*Mst2**8.*z2)/384.-

     &  (115*Mgl**2.*Mst2**10.*z2)/384.+

     &  (289*Mst2**12.*z2)/1152.-

     &  (67*Mst2**14.*z2)/(1152.*Mgl**2.)-

     &  (Mst2**16.*z2)/(288.*Mgl**4.)-

     &  (91*Mgl**10.*Mt**2.*z2)/288.+

     &  (49*Mgl**12.*Mt**2.*z2)/(288.*Mst2**2.)-

     &  (331*Mgl**8.*Mst2**2.*Mt**2.*z2)/1152.+

     &  (15*Mgl**6.*Mst2**4.*Mt**2.*z2)/32.+

     &  (Mgl**4.*Mst2**6.*Mt**2.*z2)/384.+

     &  (Mgl**2.*Mst2**8.*Mt**2.*z2)/3.-

     &  (251*Mst2**10.*Mt**2.*z2)/384.+

     &  (5*Mst2**12.*Mt**2.*z2)/(18.*Mgl**2.)+

     &  (5*Mst2**14.*Mt**2.*z2)/(1152.*Mgl**4.)+

     &  (13*Mgl**8.*Mt**4.*z2)/576.+

     &  (5*Mgl**12.*Mt**4.*z2)/(144.*Mst2**4.)+

     &  (Mgl**10.*Mt**4.*z2)/(144.*Mst2**2.)+

     &  (397*Mgl**6.*Mst2**2.*Mt**4.*z2)/1152.-

     &  (41*Mgl**4.*Mst2**4.*Mt**4.*z2)/384.+

     &  (193*Mgl**2.*Mst2**6.*Mt**4.*z2)/576.+

     &  (77*Mst2**8.*Mt**4.*z2)/144.-

     &  (463*Mst2**10.*Mt**4.*z2)/(1152.*Mgl**2.)+

     &  (41*Mst2**12.*Mt**4.*z2)/(1152.*Mgl**4.)+

     &  (7*Mgl**6.*Mt**6.*z2)/96.-

     &  (5*Mgl**10.*Mt**6.*z2)/(144.*Mst2**4.)-

     &  (25*Mgl**8.*Mt**6.*z2)/(96.*Mst2**2.)-

     &  (47*Mgl**4.*Mst2**2.*Mt**6.*z2)/1152.-

     &  (Mgl**2.*Mst2**4.*Mt**6.*z2)/3.-

     &  (97*Mst2**6.*Mt**6.*z2)/576.-

     &  (Mst2**8.*Mt**6.*z2)/(144.*Mgl**2.)-

     &  (127*Mst2**10.*Mt**6.*z2)/(1152.*Mgl**4.)-

     &  (21*Mgl**4.*Mt**8.*z2)/32.-

     &  (Mgl**8.*Mt**8.*z2)/(16.*Mst2**4.)-

     &  (29*Mgl**6.*Mt**8.*z2)/(144.*Mst2**2.)-

     &  (227*Mgl**2.*Mst2**2.*Mt**8.*z2)/384.-

     &  (37*Mst2**4.*Mt**8.*z2)/384.+

     &  (607*Mst2**6.*Mt**8.*z2)/(1152.*Mgl**2.)+

     &  (125*Mst2**8.*Mt**8.*z2)/(1152.*Mgl**4.)+

     &  (47*Mgl**2.*Mt**10.*z2)/48.+

     &  (7*Mgl**6.*Mt**10.*z2)/(72.*Mst2**4.)+

     &  (193*Mgl**4.*Mt**10.*z2)/(288.*Mst2**2.)+

     &  (463*Mst2**2.*Mt**10.*z2)/1152.-

     &  (67*Mst2**4.*Mt**10.*z2)/(144.*Mgl**2.)-

     &  (Mst2**6.*Mt**10.*z2)/(1152.*Mgl**4.)-

     &  (187*Mt**12.*z2)/576.+

     &  (Mgl**4.*Mt**12.*z2)/(144.*Mst2**4.)-

     &  (13*Mgl**2.*Mt**12.*z2)/(36.*Mst2**2.)+

     &  (49*Mst2**2.*Mt**12.*z2)/(384.*Mgl**2.)-

     &  (85*Mst2**4.*Mt**12.*z2)/(1152.*Mgl**4.)-

     &  (Mgl**2.*Mt**14.*z2)/(16.*Mst2**4.)+

     &  (Mt**14.*z2)/(32.*Mst2**2.)+

     &  (59*Mst2**2.*Mt**14.*z2)/(1152.*Mgl**4.)-

     &  (13*Mt**16.*z2)/(1152.*Mgl**4.)+

     &  (7*Mt**16.*z2)/(288.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.+

     &  ((-11107*Mgl**16.)/20736.+

     &  (161*Mgl**20.)/(2592.*Mst2**4.)-

     &  (7121*Mgl**18.)/(82944.*Mst2**2.)+

     &  (86795*Mgl**14.*Mst2**2.)/82944.+

     &  (19171*Mgl**12.*Mst2**4.)/13824.-

     &  (82435*Mgl**10.*Mst2**6.)/13824.+

     &  (4103*Mgl**8.*Mst2**8.)/576.-

     &  (45611*Mgl**6.*Mst2**10.)/13824.-

     &  (1849*Mgl**4.*Mst2**12.)/2304.+

     &  (138275*Mgl**2.*Mst2**14.)/82944.-

     &  (12229*Mst2**16.)/20736.-

     &  (5705*Mst2**18.)/(82944.*Mgl**2.)+

     &  (2465*Mst2**20.)/(41472.*Mgl**4.)+

     &  (39877*Mgl**14.*Mt**2.)/27648.-

     &  (79*Mgl**18.*Mt**2.)/(192.*Mst2**4.)+

     &  (45139*Mgl**16.*Mt**2.)/(82944.*Mst2**2.)-

     &  (4669*Mgl**12.*Mst2**2.*Mt**2.)/2304.-

     &  (6971*Mgl**10.*Mst2**4.*Mt**2.)/5184.+

     &  (141647*Mgl**8.*Mst2**6.*Mt**2.)/41472.-

     &  (142693*Mgl**6.*Mst2**8.*Mt**2.)/41472.+

     &  (13939*Mgl**4.*Mst2**10.*Mt**2.)/2592.-

     &  (69713*Mgl**2.*Mst2**12.*Mt**2.)/10368.+

     &  (290327*Mst2**14.*Mt**2.)/82944.+

     &  (8195*Mst2**16.*Mt**2.)/(82944.*Mgl**2.)-

     &  (2983*Mst2**18.*Mt**2.)/(6912.*Mgl**4.)-

     &  (18619*Mgl**12.*Mt**4.)/41472.+

     &  (2995*Mgl**16.*Mt**4.)/(2592.*Mst2**4.)-

     &  (82549*Mgl**14.*Mt**4.)/(41472.*Mst2**2.)+

     &  (1039*Mgl**10.*Mst2**2.*Mt**4.)/1152.+

     &  (9035*Mgl**8.*Mst2**4.*Mt**4.)/5184.+

     &  (45619*Mgl**6.*Mst2**6.*Mt**4.)/20736.-

     &  (143605*Mgl**4.*Mst2**8.*Mt**4.)/20736.+

     &  (33403*Mgl**2.*Mst2**10.*Mt**4.)/3456.-

     &  (42845*Mst2**12.*Mt**4.)/5184.+

     &  (26863*Mst2**14.*Mt**4.)/(41472.*Mgl**2.)+

     &  (18199*Mst2**16.*Mt**4.)/(13824.*Mgl**4.)-

     &  (64817*Mgl**10.*Mt**6.)/41472.-

     &  (4715*Mgl**14.*Mt**6.)/(2592.*Mst2**4.)+

     &  (66919*Mgl**12.*Mt**6.)/(13824.*Mst2**2.)-

     &  (12911*Mgl**8.*Mst2**2.*Mt**6.)/13824.-

     &  (3257*Mgl**6.*Mst2**4.*Mt**6.)/1536.+

     &  (177355*Mgl**4.*Mst2**6.*Mt**6.)/41472.-

     &  (266863*Mgl**2.*Mst2**8.*Mt**6.)/41472.+

     &  (413797*Mst2**10.*Mt**6.)/41472.-

     &  (28847*Mst2**12.*Mt**6.)/(13824.*Mgl**2.)-

     &  (3677*Mst2**14.*Mt**6.)/(1728.*Mgl**4.)+

     &  (1339*Mgl**8.*Mt**8.)/768.+

     &  (4469*Mgl**12.*Mt**8.)/(2592.*Mst2**4.)-

     &  (143437*Mgl**10.*Mt**8.)/(20736.*Mst2**2.)+

     &  (25331*Mgl**6.*Mst2**2.*Mt**8.)/6912.+

     &  (36851*Mgl**4.*Mst2**4.*Mt**8.)/20736.+

     &  (90329*Mgl**2.*Mst2**6.*Mt**8.)/20736.-

     &  (131437*Mst2**8.*Mt**8.)/20736.+

     &  (42539*Mst2**10.*Mt**8.)/(20736.*Mgl**2.)+

     &  (12467*Mst2**12.*Mt**8.)/(6912.*Mgl**4.)-

     &  (27073*Mgl**6.*Mt**10.)/10368.-

     &  (107*Mgl**10.*Mt**10.)/(162.*Mst2**4.)+

     &  (54647*Mgl**8.*Mt**10.)/(10368.*Mst2**2.)-

     &  (48473*Mgl**4.*Mst2**2.*Mt**10.)/6912.-

     &  (130801*Mgl**2.*Mst2**4.*Mt**10.)/20736.+

     &  (26291*Mst2**6.*Mt**10.)/20736.+

     &  (2555*Mst2**8.*Mt**10.)/(20736.*Mgl**2.)-

     &  (1589*Mst2**10.*Mt**10.)/(3456.*Mgl**4.)+

     &  (74135*Mgl**4.*Mt**12.)/20736.-

     &  (2531*Mgl**8.*Mt**12.)/(2592.*Mst2**4.)-

     &  (96347*Mgl**6.*Mt**12.)/(41472.*Mst2**2.)+

     &  (122027*Mgl**2.*Mst2**2.*Mt**12.)/20736.+

     &  (14641*Mst2**4.*Mt**12.)/10368.-

     &  (23485*Mst2**6.*Mt**12.)/(13824.*Mgl**2.)-

     &  (413*Mst2**8.*Mt**12.)/(768.*Mgl**4.)-

     &  (64835*Mgl**2.*Mt**14.)/41472.+

     &  (5435*Mgl**6.*Mt**14.)/(2592.*Mst2**4.)+

     &  (21553*Mgl**4.*Mt**14.)/(13824.*Mst2**2.)-

     &  (49705*Mst2**2.*Mt**14.)/41472.+

     &  (51877*Mst2**4.*Mt**14.)/(41472.*Mgl**2.)+

     &  (947*Mst2**6.*Mt**14.)/(1728.*Mgl**4.)-

     &  (113*Mt**16.)/1728.-

     &  (2365*Mgl**4.*Mt**16.)/(1296.*Mst2**4.)-

     &  (110939*Mgl**2.*Mt**16.)/(82944.*Mst2**2.)-

     &  (28243*Mst2**2.*Mt**16.)/(82944.*Mgl**2.)-

     &  (2609*Mst2**4.*Mt**16.)/(13824.*Mgl**4.)+

     &  (1889*Mt**18.)/(82944.*Mgl**2.)+

     &  (4117*Mgl**2.*Mt**18.)/(5184.*Mst2**4.)+

     &  (12151*Mt**18.)/(27648.*Mst2**2.)+

     &  (299*Mst2**2.*Mt**18.)/(20736.*Mgl**4.)+

     &  (17*Mt**20.)/(4608.*Mgl**4.)-

     &  (91*Mt**20.)/(648.*Mst2**4.)-

     &  (65*Mgl**16.*z2)/576.+

     &  (Mgl**20.*z2)/(288.*Mst2**4.)+

     &  (7*Mgl**18.*z2)/(576.*Mst2**2.)+

     &  (29*Mgl**14.*Mst2**2.*z2)/192.+

     &  (85*Mgl**12.*Mst2**4.*z2)/288.-

     &  (311*Mgl**10.*Mst2**6.*z2)/288.+

     &  (373*Mgl**8.*Mst2**8.*z2)/288.-

     &  (191*Mgl**6.*Mst2**10.*z2)/288.-

     &  (11*Mgl**4.*Mst2**12.*z2)/288.+

     &  (15*Mgl**2.*Mst2**14.*z2)/64.-

     &  (65*Mst2**16.*z2)/576.+

     &  (7*Mst2**18.*z2)/(576.*Mgl**2.)+

     &  (Mst2**20.*z2)/(288.*Mgl**4.)+

     &  (415*Mgl**14.*Mt**2.*z2)/1152.-

     &  (5*Mgl**18.*Mt**2.*z2)/(288.*Mst2**4.)-

     &  (79*Mgl**16.*Mt**2.*z2)/(1152.*Mst2**2.)-

     &  (65*Mgl**12.*Mst2**2.*Mt**2.*z2)/288.-

     &  (145*Mgl**10.*Mst2**4.*Mt**2.*z2)/288.+

     &  (83*Mgl**8.*Mst2**6.*Mt**2.*z2)/144.-

     &  (Mgl**6.*Mst2**8.*Mt**2.*z2)/64.+

     &  (97*Mgl**4.*Mst2**10.*Mt**2.*z2)/576.-

     &  (101*Mgl**2.*Mst2**12.*Mt**2.*z2)/144.+

     &  (655*Mst2**14.*Mt**2.*z2)/1152.-

     &  (47*Mst2**16.*Mt**2.*z2)/(384.*Mgl**2.)-

     &  (11*Mst2**18.*Mt**2.*z2)/(576.*Mgl**4.)-

     &  (71*Mgl**12.*Mt**4.*z2)/288.+

     &  (5*Mgl**16.*Mt**4.*z2)/(192.*Mst2**4.)+

     &  (7*Mgl**14.*Mt**4.*z2)/(192.*Mst2**2.)+

     &  (23*Mgl**10.*Mst2**2.*Mt**4.*z2)/192.+

     &  (77*Mgl**8.*Mst2**4.*Mt**4.*z2)/288.-

     &  (53*Mgl**6.*Mst2**6.*Mt**4.*z2)/576.-

     &  (Mgl**4.*Mst2**8.*Mt**4.*z2)/16.+

     &  (109*Mgl**2.*Mst2**10.*Mt**4.*z2)/192.-

     &  (617*Mst2**12.*Mt**4.*z2)/576.+

     &  (61*Mst2**14.*Mt**4.*z2)/(144.*Mgl**2.)+

     &  (Mst2**16.*Mt**4.*z2)/(32.*Mgl**4.)-

     &  (17*Mgl**10.*Mt**6.*z2)/192.-

     &  (Mgl**14.*Mt**6.*z2)/(96.*Mst2**4.)+

     &  (113*Mgl**12.*Mt**6.*z2)/(288.*Mst2**2.)-

     &  (91*Mgl**8.*Mst2**2.*Mt**6.*z2)/576.-

     &  (151*Mgl**6.*Mst2**4.*Mt**6.*z2)/576.+

     &  (3*Mgl**4.*Mst2**6.*Mt**6.*z2)/16.+

     &  (Mgl**2.*Mst2**8.*Mt**6.*z2)/192.+

     &  (521*Mst2**10.*Mt**6.*z2)/576.-

     &  (379*Mst2**12.*Mt**6.*z2)/(576.*Mgl**2.)+

     &  (Mst2**14.*Mt**6.*z2)/(48.*Mgl**4.)+

     &  (31*Mgl**8.*Mt**8.*z2)/144.+

     &  (Mgl**12.*Mt**8.*z2)/(32.*Mst2**4.)-

     &  (469*Mgl**10.*Mt**8.*z2)/(576.*Mst2**2.)+

     &  (67*Mgl**6.*Mst2**2.*Mt**8.*z2)/96.+

     &  (151*Mgl**4.*Mst2**4.*Mt**8.*z2)/288.+

     &  (163*Mgl**2.*Mst2**6.*Mt**8.*z2)/576.-

     &  (5*Mst2**8.*Mt**8.*z2)/18.+

     &  (3*Mst2**10.*Mt**8.*z2)/(8.*Mgl**2.)-

     &  (7*Mst2**12.*Mt**8.*z2)/(48.*Mgl**4.)-

     &  (121*Mgl**6.*Mt**10.*z2)/144.-

     &  (11*Mgl**10.*Mt**10.*z2)/(96.*Mst2**4.)+

     &  (223*Mgl**8.*Mt**10.*z2)/(576.*Mst2**2.)-

     &  (317*Mgl**4.*Mst2**2.*Mt**10.*z2)/192.-

     &  (331*Mgl**2.*Mst2**4.*Mt**10.*z2)/288.-

     &  (5*Mst2**6.*Mt**10.*z2)/48.+

     &  (59*Mst2**8.*Mt**10.*z2)/(288.*Mgl**2.)+

     &  (7*Mst2**10.*Mt**10.*z2)/(32.*Mgl**4.)+

     &  (89*Mgl**4.*Mt**12.*z2)/72.+

     &  (5*Mgl**8.*Mt**12.*z2)/(48.*Mst2**4.)+

     &  (167*Mgl**6.*Mt**12.*z2)/(576.*Mst2**2.)+

     &  (725*Mgl**2.*Mst2**2.*Mt**12.*z2)/576.+

     &  (31*Mst2**4.*Mt**12.*z2)/144.-

     &  (29*Mst2**6.*Mt**12.*z2)/(72.*Mgl**2.)-

     &  (7*Mst2**8.*Mt**12.*z2)/(48.*Mgl**4.)-

     &  (293*Mgl**2.*Mt**14.*z2)/576.+

     &  (5*Mgl**6.*Mt**14.*z2)/(96.*Mst2**4.)-

     &  (7*Mgl**4.*Mt**14.*z2)/(32.*Mst2**2.)-

     &  (89*Mst2**2.*Mt**14.*z2)/576.+

     &  (37*Mst2**4.*Mt**14.*z2)/(192.*Mgl**2.)+

     &  (Mst2**6.*Mt**14.*z2)/(48.*Mgl**4.)-

     &  (7*Mt**16.*z2)/576.-

     &  (7*Mgl**4.*Mt**16.*z2)/(48.*Mst2**4.)-

     &  (23*Mgl**2.*Mt**16.*z2)/(288.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**16.*z2)/(576.*Mgl**2.)+

     &  (Mst2**4.*Mt**16.*z2)/(32.*Mgl**4.)-

     &  (7*Mt**18.*z2)/(1152.*Mgl**2.)+

     &  (13*Mgl**2.*Mt**18.*z2)/(144.*Mst2**4.)+

     &  (73*Mt**18.*z2)/(1152.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**18.*z2)/(576.*Mgl**4.)+

     &  (Mt**20.*z2)/(288.*Mgl**4.)-

     &  (11*Mt**20.*z2)/(576.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.+

     &  Xt*((5*Mgl**3.)/(1728.*Mst1**2.)-

     &  (5*Mst1**2.)/(1728.*Mgl**1.)-

     &  (5*Mgl**3.)/(1728.*Mst2**2.)+

     &  (5*Mst2**2.)/(1728.*Mgl**1.)-

     &  (11*Mgl*Mt**2.)/(1296.*Mst1**2.)+

     &  (251*Mst1**2.*Mt**2.)/(10368.*Mgl**3.)+

     &  (11*Mgl*Mt**2.)/(1296.*Mst2**2.)-

     &  (251*Mst2**2.*Mt**2.)/(10368.*Mgl**3.)-

     &  (11*Mt**4.)/(864.*Mgl**1.*Mst1**2.)+

     &  (11*Mt**4.)/(864.*Mgl**1.*Mst2**2.)+

     &  (55*Mt**6.)/(1728.*Mgl**3.*Mst1**2.)-

     &  (55*Mt**6.)/(1728.*Mgl**3.*Mst2**2.)-

     &  (Mgl*Mt**2.*z2)/(72.*Mst1**2.)+

     &  (Mgl*Mt**2.*z2)/(72.*Mst2**2.))*Den(Mst1,Mst2)-

     &  (Mt**2.*Xt*B0fin(Mgl,Mt,Mst1,mu)*Den(Mst1,Mst2))/

     &  (6.*Mgl**1.)+

     &  (Mt**2.*Xt*B0fin(Mgl,Mt,Mst2,mu)*Den(Mst1,Mst2))/

     &  (6.*Mgl**1.)+

     &  Xt*((-19*Mgl**5.)/108.+

     &  (19*Mgl**7.)/(216.*Mst1**2.)+

     &  (19*Mgl*Mst1**4.)/108.-

     &  (19*Mst1**6.)/(216.*Mgl**1.)+

     &  (44135*Mgl**3.*Mt**2.)/41472.-

     &  (59*Mgl**7.*Mt**2.)/(1296.*Mst1**4.)+

     &  (583*Mgl**5.*Mt**2.)/(5184.*Mst1**2.)+

     &  (25361*Mgl*Mst1**2.*Mt**2.)/41472.-

     &  (14239*Mst1**4.*Mt**2.)/(41472.*Mgl**1.)+

     &  (719*Mst1**6.*Mt**2.)/(41472.*Mgl**3.)+

     &  (10309*Mgl*Mt**4.)/13824.+

     &  (17*Mgl**5.*Mt**4.)/(108.*Mst1**4.)+

     &  (1009*Mgl**3.*Mt**4.)/(5184.*Mst1**2.)+

     &  (4831*Mst1**2.*Mt**4.)/(20736.*Mgl**1.)+

     &  (1265*Mst1**4.*Mt**4.)/(13824.*Mgl**3.)+

     &  (275*Mt**6.)/(13824.*Mgl**1.)-

     &  (55*Mgl**3.*Mt**6.)/(216.*Mst1**4.)-

     &  (2483*Mgl*Mt**6.)/(5184.*Mst1**2.)-

     &  (3977*Mst1**2.*Mt**6.)/(13824.*Mgl**3.)+

     &  (9601*Mt**8.)/(41472.*Mgl**3.)+

     &  (71*Mgl*Mt**8.)/(324.*Mst1**4.)+

     &  (175*Mt**8.)/(864.*Mgl**1.*Mst1**2.)-

     &  (11*Mt**10.)/(144.*Mgl**1.*Mst1**4.)-

     &  (91*Mt**10.)/(1728.*Mgl**3.*Mst1**2.)+

     &  (55*Mgl**3.*Mt**2.*z2)/192.-

     &  (Mgl**7.*Mt**2.*z2)/(72.*Mst1**4.)+

     &  (Mgl**5.*Mt**2.*z2)/(32.*Mst1**2.)-

     &  (109*Mgl*Mst1**2.*Mt**2.*z2)/288.-

     &  (13*Mst1**4.*Mt**2.*z2)/(576.*Mgl**1.)+

     &  (Mst1**6.*Mt**2.*z2)/(72.*Mgl**3.)-

     &  (221*Mgl*Mt**4.*z2)/576.+

     &  (Mgl**5.*Mt**4.*z2)/(24.*Mst1**4.)+

     &  (5*Mgl**3.*Mt**4.*z2)/(72.*Mst1**2.)-

     &  (83*Mst1**2.*Mt**4.*z2)/(288.*Mgl**1.)-

     &  (7*Mst1**4.*Mt**4.*z2)/(576.*Mgl**3.)+

     &  (175*Mt**6.*z2)/(576.*Mgl**1.)-

     &  (Mgl**3.*Mt**6.*z2)/(24.*Mst1**4.)-

     &  (29*Mgl*Mt**6.*z2)/(288.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**6.*z2)/(288.*Mgl**3.)+

     &  (Mt**8.*z2)/(64.*Mgl**3.)+

     &  (Mgl*Mt**8.*z2)/(72.*Mst1**4.))*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)+

     &  Xt*((277*Mgl**9.)/432.-

     &  (277*Mgl**11.)/(1728.*Mst1**2.)-

     &  (1385*Mgl**7.*Mst1**2.)/1728.+

     &  (1385*Mgl**3.*Mst1**6.)/1728.-

     &  (277*Mgl*Mst1**8.)/432.+

     &  (277*Mst1**10.)/(1728.*Mgl**1.)-

     &  (5851*Mgl**7.*Mt**2.)/20736.-

     &  (25*Mgl**11.*Mt**2.)/(216.*Mst1**4.)-

     &  (715*Mgl**9.*Mt**2.)/(6912.*Mst1**2.)+

     &  (10403*Mgl**5.*Mst1**2.*Mt**2.)/20736.-

     &  (281*Mgl**3.*Mst1**4.*Mt**2.)/648.+

     &  (1003*Mgl*Mst1**6.*Mt**2.)/20736.+

     &  (6667*Mst1**8.*Mt**2.)/(20736.*Mgl**1.)+

     &  (1315*Mst1**10.*Mt**2.)/(20736.*Mgl**3.)+

     &  (1055*Mgl**5.*Mt**4.)/768.+

     &  (485*Mgl**9.*Mt**4.)/(1296.*Mst1**4.)+

     &  (1039*Mgl**7.*Mt**4.)/(5184.*Mst1**2.)+

     &  (269*Mgl**3.*Mst1**2.*Mt**4.)/128.+

     &  (12557*Mgl*Mst1**4.*Mt**4.)/3456.-

     &  (8941*Mst1**6.*Mt**4.)/(10368.*Mgl**1.)-

     &  (223*Mst1**8.*Mt**4.)/(20736.*Mgl**3.)+

     &  (95*Mgl**3.*Mt**6.)/96.-

     &  (671*Mgl**7.*Mt**6.)/(1296.*Mst1**4.)+

     &  (3529*Mgl**5.*Mt**6.)/(1728.*Mst1**2.)+

     &  (167*Mgl*Mst1**2.*Mt**6.)/162.-

     &  (4043*Mst1**4.*Mt**6.)/(3456.*Mgl**1.)-

     &  (875*Mst1**6.*Mt**6.)/(3456.*Mgl**3.)-

     &  (19637*Mgl*Mt**8.)/10368.+

     &  (13*Mgl**5.*Mt**8.)/(48.*Mst1**4.)-

     &  (6049*Mgl**3.*Mt**8.)/(1728.*Mst1**2.)+

     &  (24061*Mst1**2.*Mt**8.)/(10368.*Mgl**1.)+

     &  (1753*Mst1**4.*Mt**8.)/(10368.*Mgl**3.)-

     &  (9133*Mt**10.)/(20736.*Mgl**1.)+

     &  (373*Mgl**3.*Mt**10.)/(1296.*Mst1**4.)+

     &  (41993*Mgl*Mt**10.)/(20736.*Mst1**2.)+

     &  (3487*Mst1**2.*Mt**10.)/(20736.*Mgl**3.)-

     &  (121*Mt**12.)/(768.*Mgl**3.)-

     &  (40*Mgl*Mt**12.)/(81.*Mst1**4.)-

     &  (151*Mt**12.)/(288.*Mgl**1.*Mst1**2.)+

     &  (7*Mt**14.)/(36.*Mgl**1.*Mst1**4.)+

     &  Mt**14./(48.*Mgl**3.*Mst1**2.)+

     &  (7*Mgl**7.*Mt**2.*z2)/144.+

     &  (Mgl**11.*Mt**2.*z2)/(72.*Mst1**4.)-

     &  (43*Mgl**9.*Mt**2.*z2)/(288.*Mst1**2.)+

     &  (19*Mgl**5.*Mst1**2.*Mt**2.*z2)/32.-

     &  (197*Mgl**3.*Mst1**4.*Mt**2.*z2)/288.-

     &  (5*Mgl*Mst1**6.*Mt**2.*z2)/72.+

     &  (25*Mst1**8.*Mt**2.*z2)/(96.*Mgl**1.)-

     &  (Mst1**10.*Mt**2.*z2)/(72.*Mgl**3.)+

     &  (205*Mgl**5.*Mt**4.*z2)/288.-

     &  (Mgl**9.*Mt**4.*z2)/(9.*Mst1**4.)-

     &  (7*Mgl**7.*Mt**4.*z2)/(288.*Mst1**2.)-

     &  (4*Mgl**3.*Mst1**2.*Mt**4.*z2)/9.-

     &  (13*Mgl*Mst1**4.*Mt**4.*z2)/96.-

     &  (89*Mst1**6.*Mt**4.*z2)/(288.*Mgl**1.)+

     &  (11*Mst1**8.*Mt**4.*z2)/(144.*Mgl**3.)-

     &  (7*Mgl**3.*Mt**6.*z2)/18.+

     &  (35*Mgl**7.*Mt**6.*z2)/(144.*Mst1**4.)+

     &  (91*Mgl**5.*Mt**6.*z2)/(96.*Mst1**2.)+

     &  (61*Mgl*Mst1**2.*Mt**6.*z2)/144.-

     &  (127*Mst1**4.*Mt**6.*z2)/(288.*Mgl**1.)-

     &  (5*Mst1**6.*Mt**6.*z2)/(48.*Mgl**3.)-

     &  (35*Mgl*Mt**8.*z2)/288.-

     &  (29*Mgl**5.*Mt**8.*z2)/(144.*Mst1**4.)-

     &  (335*Mgl**3.*Mt**8.*z2)/(288.*Mst1**2.)+

     &  (203*Mst1**2.*Mt**8.*z2)/(288.*Mgl**1.)-

     &  (Mst1**4.*Mt**8.*z2)/(144.*Mgl**3.)-

     &  (31*Mt**10.*z2)/(144.*Mgl**1.)+

     &  (7*Mgl**3.*Mt**10.*z2)/(144.*Mst1**4.)+

     &  (7*Mgl*Mt**10.*z2)/(18.*Mst1**2.)+

     &  (13*Mst1**2.*Mt**10.*z2)/(144.*Mgl**3.)-

     &  (Mt**12.*z2)/(24.*Mgl**3.)+

     &  (Mgl*Mt**12.*z2)/(144.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)+

     &  Xt*((-5*Mgl**13.)/12.+(5*Mgl**15.)/(72.*Mst1**2.)+

     &  (35*Mgl**11.*Mst1**2.)/36.-

     &  (35*Mgl**9.*Mst1**4.)/36.+

     &  (35*Mgl**5.*Mst1**8.)/36.-

     &  (35*Mgl**3.*Mst1**10.)/36.+

     &  (5*Mgl*Mst1**12.)/12.-

     &  (5*Mst1**14.)/(72.*Mgl**1.)-

     &  (87383*Mgl**11.*Mt**2.)/41472.+

     &  (59*Mgl**15.*Mt**2.)/(144.*Mst1**4.)+

     &  (7*Mgl**13.*Mt**2.)/(192.*Mst1**2.)-

     &  (43079*Mgl**9.*Mst1**2.*Mt**2.)/41472.+

     &  (28993*Mgl**7.*Mst1**4.*Mt**2.)/4608.-

     &  (160655*Mgl**5.*Mst1**6.*Mt**2.)/41472.-

     &  (71213*Mgl**3.*Mst1**8.*Mt**2.)/41472.+

     &  (36305*Mgl*Mst1**10.*Mt**2.)/13824.-

     &  (11813*Mst1**12.*Mt**2.)/(41472.*Mgl**1.)-

     &  (14213*Mst1**14.*Mt**2.)/(41472.*Mgl**3.)+

     &  (10373*Mgl**9.*Mt**4.)/1536.-

     &  (253*Mgl**13.*Mt**4.)/(108.*Mst1**4.)-

     &  (7*Mgl**11.*Mt**4.)/(18.*Mst1**2.)+

     &  (40715*Mgl**7.*Mst1**2.*Mt**4.)/20736.-

     &  (402067*Mgl**5.*Mst1**4.*Mt**4.)/41472.+

     &  (58141*Mgl**3.*Mst1**6.*Mt**4.)/10368.-

     &  (325199*Mgl*Mst1**8.*Mt**4.)/41472.+

     &  (17833*Mst1**10.*Mt**4.)/(6912.*Mgl**1.)+

     &  (56155*Mst1**12.*Mt**4.)/(41472.*Mgl**3.)-

     &  (293767*Mgl**7.*Mt**6.)/41472.+

     &  (487*Mgl**11.*Mt**6.)/(81.*Mst1**4.)-

     &  (4469*Mgl**9.*Mt**6.)/(1728.*Mst1**2.)-

     &  (216253*Mgl**5.*Mst1**2.*Mt**6.)/41472.-

     &  (3529*Mgl**3.*Mst1**4.*Mt**6.)/6912.+

     &  (51493*Mgl*Mst1**6.*Mt**6.)/6912.-

     &  (132211*Mst1**8.*Mt**6.)/(41472.*Mgl**1.)-

     &  (23123*Mst1**10.*Mt**6.)/(13824.*Mgl**3.)+

     &  (145837*Mgl**5.*Mt**8.)/13824.-

     &  (769*Mgl**9.*Mt**8.)/(81.*Mst1**4.)+

     &  (2639*Mgl**7.*Mt**8.)/(288.*Mst1**2.)+

     &  (25615*Mgl**3.*Mst1**2.*Mt**8.)/3456.-

     &  (111259*Mgl*Mst1**4.*Mt**8.)/20736.-

     &  (3179*Mst1**6.*Mt**8.)/(1152.*Mgl**1.)+

     &  (1975*Mst1**8.*Mt**8.)/(41472.*Mgl**3.)-

     &  (471125*Mgl**3.*Mt**10.)/41472.+

     &  (2213*Mgl**7.*Mt**10.)/(216.*Mst1**4.)-

     &  (52411*Mgl**5.*Mt**10.)/(5184.*Mst1**2.)+

     &  (33079*Mgl*Mst1**2.*Mt**10.)/41472.+

     &  (100247*Mst1**4.*Mt**10.)/(13824.*Mgl**1.)+

     &  (60145*Mst1**6.*Mt**10.)/(41472.*Mgl**3.)+

     &  (145109*Mgl*Mt**12.)/41472.-

     &  (2347*Mgl**5.*Mt**12.)/(324.*Mst1**4.)+

     &  (12325*Mgl**3.*Mt**12.)/(2592.*Mst1**2.)-

     &  (82405*Mst1**2.*Mt**12.)/(20736.*Mgl**1.)-

     &  (14149*Mst1**4.*Mt**12.)/(13824.*Mgl**3.)+

     &  (5075*Mt**14.)/(41472.*Mgl**1.)+

     &  (443*Mgl**3.*Mt**14.)/(162.*Mst1**4.)-

     &  (7147*Mgl*Mt**14.)/(5184.*Mst1**2.)+

     &  (5965*Mst1**2.*Mt**14.)/(41472.*Mgl**3.)+

     &  (1789*Mt**16.)/(41472.*Mgl**3.)-

     &  (11*Mgl*Mt**16.)/(54.*Mst1**4.)+

     &  (95*Mt**16.)/(216.*Mgl**1.*Mst1**2.)-

     &  (17*Mt**18.)/(144.*Mgl**1.*Mst1**4.)-

     &  (121*Mgl**11.*Mt**2.*z2)/192.+

     &  (Mgl**15.*Mt**2.*z2)/(72.*Mst1**4.)+

     &  (7*Mgl**13.*Mt**2.*z2)/(36.*Mst1**2.)-

     &  (11*Mgl**9.*Mst1**2.*Mt**2.*z2)/96.+

     &  (107*Mgl**7.*Mst1**4.*Mt**2.*z2)/64.-

     &  (193*Mgl**5.*Mst1**6.*Mt**2.*z2)/144.-

     &  (13*Mgl**3.*Mst1**8.*Mt**2.*z2)/64.+

     &  (175*Mgl*Mst1**10.*Mt**2.*z2)/288.-

     &  (107*Mst1**12.*Mt**2.*z2)/(576.*Mgl**1.)-

     &  (Mst1**14.*Mt**2.*z2)/(72.*Mgl**3.)+

     &  (437*Mgl**9.*Mt**4.*z2)/576.-

     &  (Mgl**13.*Mt**4.*z2)/(72.*Mst1**4.)-

     &  (43*Mgl**11.*Mt**4.*z2)/(72.*Mst1**2.)+

     &  (391*Mgl**7.*Mst1**2.*Mt**4.*z2)/288.-

     &  (809*Mgl**5.*Mst1**4.*Mt**4.*z2)/576.-

     &  (49*Mgl**3.*Mst1**6.*Mt**4.*z2)/144.-

     &  (151*Mgl*Mst1**8.*Mt**4.*z2)/192.+

     &  (199*Mst1**10.*Mt**4.*z2)/(288.*Mgl**1.)+

     &  (Mst1**12.*Mt**4.*z2)/(576.*Mgl**3.)-

     &  (145*Mgl**7.*Mt**6.*z2)/576.-

     &  (Mgl**11.*Mt**6.*z2)/(8.*Mst1**4.)-

     &  (31*Mgl**9.*Mt**6.*z2)/(72.*Mst1**2.)-

     &  (45*Mgl**5.*Mst1**2.*Mt**6.*z2)/32.+

     &  (257*Mgl**3.*Mst1**4.*Mt**6.*z2)/288.+

     &  (Mgl*Mst1**6.*Mt**6.*z2)/18.-

     &  (91*Mst1**8.*Mt**6.*z2)/(192.*Mgl**1.)+

     &  (5*Mst1**10.*Mt**6.*z2)/(32.*Mgl**3.)+

     &  (1295*Mgl**5.*Mt**8.*z2)/576.+

     &  (19*Mgl**9.*Mt**8.*z2)/(72.*Mst1**4.)+

     &  (115*Mgl**7.*Mt**8.*z2)/(36.*Mst1**2.)+

     &  (73*Mgl**3.*Mst1**2.*Mt**8.*z2)/48.-

     &  (7*Mgl*Mst1**4.*Mt**8.*z2)/288.-

     &  (121*Mst1**6.*Mt**8.*z2)/(144.*Mgl**1.)-

     &  (185*Mst1**8.*Mt**8.*z2)/(576.*Mgl**3.)-

     &  (205*Mgl**3.*Mt**10.*z2)/64.-

     &  (Mgl**7.*Mt**10.*z2)/(72.*Mst1**4.)-

     &  (139*Mgl**5.*Mt**10.*z2)/(36.*Mst1**2.)-

     &  (61*Mgl*Mst1**2.*Mt**10.*z2)/96.+

     &  (715*Mst1**4.*Mt**10.*z2)/(576.*Mgl**1.)+

     &  (25*Mst1**6.*Mt**10.*z2)/(144.*Mgl**3.)+

     &  (611*Mgl*Mt**12.*z2)/576.-

     &  (3*Mgl**5.*Mt**12.*z2)/(8.*Mst1**4.)+

     &  (121*Mgl**3.*Mt**12.*z2)/(72.*Mst1**2.)-

     &  (13*Mst1**2.*Mt**12.*z2)/(32.*Mgl**1.)+

     &  (7*Mst1**4.*Mt**12.*z2)/(64.*Mgl**3.)-

     &  (5*Mt**14.*z2)/(192.*Mgl**1.)+

     &  (25*Mgl**3.*Mt**14.*z2)/(72.*Mst1**4.)-

     &  (13*Mgl*Mt**14.*z2)/(72.*Mst1**2.)-

     &  (43*Mst1**2.*Mt**14.*z2)/(288.*Mgl**3.)+

     &  (25*Mt**16.*z2)/(576.*Mgl**3.)-

     &  (7*Mgl*Mt**16.*z2)/(72.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)+

     &  Xt*((46397*Mgl**15.*Mt**2.)/20736.-

     &  (161*Mgl**19.*Mt**2.)/(648.*Mst1**4.)+

     &  (1969*Mgl**17.*Mt**2.)/(20736.*Mst1**2.)-

     &  (6733*Mgl**13.*Mst1**2.*Mt**2.)/3456.-

     &  (1619*Mgl**11.*Mst1**4.*Mt**2.)/216.+

     &  (56531*Mgl**9.*Mst1**6.*Mt**2.)/3456.-

     &  (41941*Mgl**7.*Mst1**8.*Mt**2.)/3456.+

     &  (1835*Mgl**5.*Mst1**10.*Mt**2.)/1728.+

     &  (3691*Mgl**3.*Mst1**12.*Mt**2.)/864.-

     &  (49691*Mgl*Mst1**14.*Mt**2.)/20736.-

     &  (775*Mst1**16.*Mt**2.)/(20736.*Mgl**1.)+

     &  (2465*Mst1**18.*Mt**2.)/(10368.*Mgl**3.)-

     &  (1811*Mgl**13.*Mt**4.)/216.+

     &  (2455*Mgl**17.*Mt**4.)/(1296.*Mst1**4.)-

     &  (1957*Mgl**15.*Mt**4.)/(5184.*Mst1**2.)+

     &  (5771*Mgl**11.*Mst1**2.*Mt**4.)/3456.+

     &  (150793*Mgl**9.*Mst1**4.*Mt**4.)/10368.-

     &  (160447*Mgl**7.*Mst1**6.*Mt**4.)/10368.+

     &  (36023*Mgl**5.*Mst1**8.*Mt**4.)/3456.-

     &  (125965*Mgl**3.*Mst1**10.*Mt**4.)/10368.+

     &  (108595*Mgl*Mst1**12.*Mt**4.)/10368.-

     &  (11723*Mst1**14.*Mt**4.)/(10368.*Mgl**1.)-

     &  (15433*Mst1**16.*Mt**4.)/(10368.*Mgl**3.)+

     &  (62225*Mgl**11.*Mt**6.)/5184.-

     &  (2815*Mgl**15.*Mt**6.)/(432.*Mst1**4.)+

     &  (6301*Mgl**13.*Mt**6.)/(3456.*Mst1**2.)+

     &  (69733*Mgl**9.*Mst1**2.*Mt**6.)/10368.-

     &  (38335*Mgl**7.*Mst1**4.*Mt**6.)/2592.-

     &  (84131*Mgl**5.*Mst1**6.*Mt**6.)/10368.+

     &  (15835*Mgl**3.*Mst1**8.*Mt**6.)/1728.-

     &  (179861*Mgl*Mst1**10.*Mt**6.)/10368.+

     &  (1697*Mst1**12.*Mt**6.)/(324.*Mgl**1.)+

     &  (9791*Mst1**14.*Mt**6.)/(2592.*Mgl**3.)-

     &  (45431*Mgl**9.*Mt**8.)/3456.+

     &  (17875*Mgl**13.*Mt**8.)/(1296.*Mst1**4.)-

     &  (19165*Mgl**11.*Mt**8.)/(2592.*Mst1**2.)-

     &  (167293*Mgl**7.*Mst1**2.*Mt**8.)/10368.+

     &  (12331*Mgl**5.*Mst1**4.*Mt**8.)/1728.-

     &  (9619*Mgl**3.*Mst1**6.*Mt**8.)/5184.+

     &  (152615*Mgl*Mst1**8.*Mt**8.)/10368.-

     &  (27107*Mst1**10.*Mt**8.)/(3456.*Mgl**1.)-

     &  (12271*Mst1**12.*Mt**8.)/(2592.*Mgl**3.)+

     &  (213017*Mgl**7.*Mt**10.)/10368.-

     &  (26813*Mgl**11.*Mt**10.)/(1296.*Mst1**4.)+

     &  (74515*Mgl**9.*Mt**10.)/(5184.*Mst1**2.)+

     &  (19027*Mgl**5.*Mst1**2.*Mt**10.)/864.+

     &  (20159*Mgl**3.*Mst1**4.*Mt**10.)/2592.-

     &  (187*Mgl*Mst1**6.*Mt**10.)/24.+

     &  (3275*Mst1**8.*Mt**10.)/(1152.*Mgl**1.)+

     &  (12859*Mst1**10.*Mt**10.)/(5184.*Mgl**3.)-

     &  (230447*Mgl**5.*Mt**12.)/10368.+

     &  (10079*Mgl**9.*Mt**12.)/(432.*Mst1**4.)-

     &  (62861*Mgl**7.*Mt**12.)/(5184.*Mst1**2.)-

     &  (167933*Mgl**3.*Mst1**2.*Mt**12.)/10368.+

     &  (13033*Mgl*Mst1**4.*Mt**12.)/10368.+

     &  (13745*Mst1**6.*Mt**12.)/(3456.*Mgl**1.)+

     &  (3325*Mst1**8.*Mt**12.)/(5184.*Mgl**3.)+

     &  (17141*Mgl**3.*Mt**14.)/1728.-

     &  (25175*Mgl**7.*Mt**14.)/(1296.*Mst1**4.)+

     &  (20669*Mgl**5.*Mt**14.)/(10368.*Mst1**2.)+

     &  (26725*Mgl*Mst1**2.*Mt**14.)/10368.-

     &  (5609*Mst1**4.*Mt**14.)/(1296.*Mgl**1.)-

     &  (3913*Mst1**6.*Mt**14.)/(2592.*Mgl**3.)-

     &  (8899*Mgl*Mt**16.)/10368.+

     &  (14305*Mgl**5.*Mt**16.)/(1296.*Mst1**4.)+

     &  (1213*Mgl**3.*Mt**16.)/(432.*Mst1**2.)+

     &  (14081*Mst1**2.*Mt**16.)/(10368.*Mgl**1.)+

     &  (1769*Mst1**4.*Mt**16.)/(2592.*Mgl**3.)-

     &  (1583*Mt**18.)/(20736.*Mgl**1.)-

     &  (1615*Mgl**3.*Mt**18.)/(432.*Mst1**4.)-

     &  (24805*Mgl*Mt**18.)/(20736.*Mst1**2.)-

     &  (751*Mst1**2.*Mt**18.)/(10368.*Mgl**3.)-

     &  (17*Mt**20.)/(1152.*Mgl**3.)+

     &  (91*Mgl*Mt**20.)/(162.*Mst1**4.)+

     &  (7*Mgl**15.*Mt**2.*z2)/18.-

     &  (Mgl**19.*Mt**2.*z2)/(72.*Mst1**4.)-

     &  (Mgl**17.*Mt**2.*z2)/(16.*Mst1**2.)-

     &  (31*Mgl**13.*Mst1**2.*Mt**2.*z2)/144.-

     &  (67*Mgl**11.*Mst1**4.*Mt**2.*z2)/48.+

     &  (421*Mgl**9.*Mst1**6.*Mt**2.*z2)/144.-

     &  (325*Mgl**7.*Mst1**8.*Mt**2.*z2)/144.+

     &  (19*Mgl**5.*Mst1**10.*Mt**2.*z2)/48.+

     &  (79*Mgl**3.*Mst1**12.*Mt**2.*z2)/144.-

     &  (7*Mgl*Mst1**14.*Mt**2.*z2)/18.+

     &  (Mst1**16.*Mt**2.*z2)/(16.*Mgl**1.)+

     &  (Mst1**18.*Mt**2.*z2)/(72.*Mgl**3.)-

     &  (203*Mgl**13.*Mt**4.*z2)/144.+

     &  (Mgl**17.*Mt**4.*z2)/(12.*Mst1**4.)+

     &  (121*Mgl**15.*Mt**4.*z2)/(288.*Mst1**2.)-

     &  (7*Mgl**11.*Mst1**2.*Mt**4.*z2)/24.+

     &  (449*Mgl**9.*Mst1**4.*Mt**4.*z2)/144.-

     &  (19*Mgl**7.*Mst1**6.*Mt**4.*z2)/9.+

     &  (5*Mgl**5.*Mst1**8.*Mt**4.*z2)/24.-

     &  (31*Mgl**3.*Mst1**10.*Mt**4.*z2)/36.+

     &  (67*Mgl*Mst1**12.*Mt**4.*z2)/48.-

     &  (47*Mst1**14.*Mt**4.*z2)/(96.*Mgl**1.)-

     &  (Mst1**16.*Mt**4.*z2)/(16.*Mgl**3.)+

     &  (473*Mgl**11.*Mt**6.*z2)/288.-

     &  (3*Mgl**15.*Mt**6.*z2)/(16.*Mst1**4.)-

     &  (217*Mgl**13.*Mt**6.*z2)/(288.*Mst1**2.)+

     &  (419*Mgl**9.*Mst1**2.*Mt**6.*z2)/288.-

     &  (787*Mgl**7.*Mst1**4.*Mt**6.*z2)/288.-

     &  (73*Mgl**5.*Mst1**6.*Mt**6.*z2)/288.-

     &  (61*Mgl**3.*Mst1**8.*Mt**6.*z2)/288.-

     &  (467*Mgl*Mst1**10.*Mt**6.*z2)/288.+

     &  (365*Mst1**12.*Mt**6.*z2)/(288.*Mgl**1.)+

     &  (Mst1**14.*Mt**6.*z2)/(16.*Mgl**3.)-

     &  (15*Mgl**9.*Mt**8.*z2)/8.+

     &  (11*Mgl**13.*Mt**8.*z2)/(48.*Mst1**4.)-

     &  (169*Mgl**11.*Mt**8.*z2)/(288.*Mst1**2.)-

     &  (259*Mgl**7.*Mst1**2.*Mt**8.*z2)/96.+

     &  (13*Mgl**5.*Mst1**4.*Mt**8.*z2)/12.+

     &  (169*Mgl**3.*Mst1**6.*Mt**8.*z2)/288.+

     &  (7*Mgl*Mst1**8.*Mt**8.*z2)/9.-

     &  (39*Mst1**10.*Mt**8.*z2)/(32.*Mgl**1.)+

     &  (7*Mst1**12.*Mt**8.*z2)/(48.*Mgl**3.)+

     &  (1297*Mgl**7.*Mt**10.*z2)/288.-

     &  (17*Mgl**11.*Mt**10.*z2)/(48.*Mst1**4.)+

     &  (335*Mgl**9.*Mt**10.*z2)/(96.*Mst1**2.)+

     &  (635*Mgl**5.*Mst1**2.*Mt**10.*z2)/144.+

     &  (59*Mgl**3.*Mst1**4.*Mt**10.*z2)/48.-

     &  (47*Mgl*Mst1**6.*Mt**10.*z2)/96.-

     &  (5*Mst1**8.*Mt**10.*z2)/(32.*Mgl**1.)-

     &  (7*Mst1**10.*Mt**10.*z2)/(16.*Mgl**3.)-

     &  (773*Mgl**5.*Mt**12.*z2)/144.+

     &  (13*Mgl**9.*Mt**12.*z2)/(16.*Mst1**4.)-

     &  (1217*Mgl**7.*Mt**12.*z2)/(288.*Mst1**2.)-

     &  (457*Mgl**3.*Mst1**2.*Mt**12.*z2)/144.+

     &  (7*Mgl*Mst1**4.*Mt**12.*z2)/36.+

     &  (317*Mst1**6.*Mt**12.*z2)/(288.*Mgl**1.)+

     &  (7*Mst1**8.*Mt**12.*z2)/(16.*Mgl**3.)+

     &  (217*Mgl**3.*Mt**14.*z2)/96.-

     &  (59*Mgl**7.*Mt**14.*z2)/(48.*Mst1**4.)+

     &  (529*Mgl**5.*Mt**14.*z2)/(288.*Mst1**2.)+

     &  (115*Mgl*Mst1**2.*Mt**14.*z2)/288.-

     &  (21*Mst1**4.*Mt**14.*z2)/(32.*Mgl**1.)-

     &  (7*Mst1**6.*Mt**14.*z2)/(48.*Mgl**3.)-

     &  (Mgl*Mt**16.*z2)/6.+

     &  (49*Mgl**5.*Mt**16.*z2)/(48.*Mst1**4.)+

     &  (17*Mgl**3.*Mt**16.*z2)/(288.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**16.*z2)/(96.*Mgl**1.)-

     &  (Mst1**4.*Mt**16.*z2)/(16.*Mgl**3.)+

     &  (11*Mt**18.*z2)/(288.*Mgl**1.)-

     &  (7*Mgl**3.*Mt**18.*z2)/(16.*Mst1**4.)-

     &  (17*Mgl*Mt**18.*z2)/(96.*Mst1**2.)+

     &  (Mst1**2.*Mt**18.*z2)/(16.*Mgl**3.)-

     &  (Mt**20.*z2)/(72.*Mgl**3.)+

     &  (11*Mgl*Mt**20.*z2)/(144.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)+

     &  Xt*((19*Mgl**5.)/108.-(19*Mgl**7.)/(216.*Mst2**2.)-

     &  (19*Mgl*Mst2**4.)/108.+

     &  (19*Mst2**6.)/(216.*Mgl**1.)-

     &  (44135*Mgl**3.*Mt**2.)/41472.+

     &  (59*Mgl**7.*Mt**2.)/(1296.*Mst2**4.)-

     &  (583*Mgl**5.*Mt**2.)/(5184.*Mst2**2.)-

     &  (25361*Mgl*Mst2**2.*Mt**2.)/41472.+

     &  (14239*Mst2**4.*Mt**2.)/(41472.*Mgl**1.)-

     &  (719*Mst2**6.*Mt**2.)/(41472.*Mgl**3.)-

     &  (10309*Mgl*Mt**4.)/13824.-

     &  (17*Mgl**5.*Mt**4.)/(108.*Mst2**4.)-

     &  (1009*Mgl**3.*Mt**4.)/(5184.*Mst2**2.)-

     &  (4831*Mst2**2.*Mt**4.)/(20736.*Mgl**1.)-

     &  (1265*Mst2**4.*Mt**4.)/(13824.*Mgl**3.)-

     &  (275*Mt**6.)/(13824.*Mgl**1.)+

     &  (55*Mgl**3.*Mt**6.)/(216.*Mst2**4.)+

     &  (2483*Mgl*Mt**6.)/(5184.*Mst2**2.)+

     &  (3977*Mst2**2.*Mt**6.)/(13824.*Mgl**3.)-

     &  (9601*Mt**8.)/(41472.*Mgl**3.)-

     &  (71*Mgl*Mt**8.)/(324.*Mst2**4.)-

     &  (175*Mt**8.)/(864.*Mgl**1.*Mst2**2.)+

     &  (11*Mt**10.)/(144.*Mgl**1.*Mst2**4.)+

     &  (91*Mt**10.)/(1728.*Mgl**3.*Mst2**2.)-

     &  (55*Mgl**3.*Mt**2.*z2)/192.+

     &  (Mgl**7.*Mt**2.*z2)/(72.*Mst2**4.)-

     &  (Mgl**5.*Mt**2.*z2)/(32.*Mst2**2.)+

     &  (109*Mgl*Mst2**2.*Mt**2.*z2)/288.+

     &  (13*Mst2**4.*Mt**2.*z2)/(576.*Mgl**1.)-

     &  (Mst2**6.*Mt**2.*z2)/(72.*Mgl**3.)+

     &  (221*Mgl*Mt**4.*z2)/576.-

     &  (Mgl**5.*Mt**4.*z2)/(24.*Mst2**4.)-

     &  (5*Mgl**3.*Mt**4.*z2)/(72.*Mst2**2.)+

     &  (83*Mst2**2.*Mt**4.*z2)/(288.*Mgl**1.)+

     &  (7*Mst2**4.*Mt**4.*z2)/(576.*Mgl**3.)-

     &  (175*Mt**6.*z2)/(576.*Mgl**1.)+

     &  (Mgl**3.*Mt**6.*z2)/(24.*Mst2**4.)+

     &  (29*Mgl*Mt**6.*z2)/(288.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**6.*z2)/(288.*Mgl**3.)-

     &  (Mt**8.*z2)/(64.*Mgl**3.)-

     &  (Mgl*Mt**8.*z2)/(72.*Mst2**4.))*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)+

     &  Xt*((-277*Mgl**9.)/432.+

     &  (277*Mgl**11.)/(1728.*Mst2**2.)+

     &  (1385*Mgl**7.*Mst2**2.)/1728.-

     &  (1385*Mgl**3.*Mst2**6.)/1728.+

     &  (277*Mgl*Mst2**8.)/432.-

     &  (277*Mst2**10.)/(1728.*Mgl**1.)+

     &  (5851*Mgl**7.*Mt**2.)/20736.+

     &  (25*Mgl**11.*Mt**2.)/(216.*Mst2**4.)+

     &  (715*Mgl**9.*Mt**2.)/(6912.*Mst2**2.)-

     &  (10403*Mgl**5.*Mst2**2.*Mt**2.)/20736.+

     &  (281*Mgl**3.*Mst2**4.*Mt**2.)/648.-

     &  (1003*Mgl*Mst2**6.*Mt**2.)/20736.-

     &  (6667*Mst2**8.*Mt**2.)/(20736.*Mgl**1.)-

     &  (1315*Mst2**10.*Mt**2.)/(20736.*Mgl**3.)-

     &  (1055*Mgl**5.*Mt**4.)/768.-

     &  (485*Mgl**9.*Mt**4.)/(1296.*Mst2**4.)-

     &  (1039*Mgl**7.*Mt**4.)/(5184.*Mst2**2.)-

     &  (269*Mgl**3.*Mst2**2.*Mt**4.)/128.-

     &  (12557*Mgl*Mst2**4.*Mt**4.)/3456.+

     &  (8941*Mst2**6.*Mt**4.)/(10368.*Mgl**1.)+

     &  (223*Mst2**8.*Mt**4.)/(20736.*Mgl**3.)-

     &  (95*Mgl**3.*Mt**6.)/96.+

     &  (671*Mgl**7.*Mt**6.)/(1296.*Mst2**4.)-

     &  (3529*Mgl**5.*Mt**6.)/(1728.*Mst2**2.)-

     &  (167*Mgl*Mst2**2.*Mt**6.)/162.+

     &  (4043*Mst2**4.*Mt**6.)/(3456.*Mgl**1.)+

     &  (875*Mst2**6.*Mt**6.)/(3456.*Mgl**3.)+

     &  (19637*Mgl*Mt**8.)/10368.-

     &  (13*Mgl**5.*Mt**8.)/(48.*Mst2**4.)+

     &  (6049*Mgl**3.*Mt**8.)/(1728.*Mst2**2.)-

     &  (24061*Mst2**2.*Mt**8.)/(10368.*Mgl**1.)-

     &  (1753*Mst2**4.*Mt**8.)/(10368.*Mgl**3.)+

     &  (9133*Mt**10.)/(20736.*Mgl**1.)-

     &  (373*Mgl**3.*Mt**10.)/(1296.*Mst2**4.)-

     &  (41993*Mgl*Mt**10.)/(20736.*Mst2**2.)-

     &  (3487*Mst2**2.*Mt**10.)/(20736.*Mgl**3.)+

     &  (121*Mt**12.)/(768.*Mgl**3.)+

     &  (40*Mgl*Mt**12.)/(81.*Mst2**4.)+

     &  (151*Mt**12.)/(288.*Mgl**1.*Mst2**2.)-

     &  (7*Mt**14.)/(36.*Mgl**1.*Mst2**4.)-

     &  Mt**14./(48.*Mgl**3.*Mst2**2.)-

     &  (7*Mgl**7.*Mt**2.*z2)/144.-

     &  (Mgl**11.*Mt**2.*z2)/(72.*Mst2**4.)+

     &  (43*Mgl**9.*Mt**2.*z2)/(288.*Mst2**2.)-

     &  (19*Mgl**5.*Mst2**2.*Mt**2.*z2)/32.+

     &  (197*Mgl**3.*Mst2**4.*Mt**2.*z2)/288.+

     &  (5*Mgl*Mst2**6.*Mt**2.*z2)/72.-

     &  (25*Mst2**8.*Mt**2.*z2)/(96.*Mgl**1.)+

     &  (Mst2**10.*Mt**2.*z2)/(72.*Mgl**3.)-

     &  (205*Mgl**5.*Mt**4.*z2)/288.+

     &  (Mgl**9.*Mt**4.*z2)/(9.*Mst2**4.)+

     &  (7*Mgl**7.*Mt**4.*z2)/(288.*Mst2**2.)+

     &  (4*Mgl**3.*Mst2**2.*Mt**4.*z2)/9.+

     &  (13*Mgl*Mst2**4.*Mt**4.*z2)/96.+

     &  (89*Mst2**6.*Mt**4.*z2)/(288.*Mgl**1.)-

     &  (11*Mst2**8.*Mt**4.*z2)/(144.*Mgl**3.)+

     &  (7*Mgl**3.*Mt**6.*z2)/18.-

     &  (35*Mgl**7.*Mt**6.*z2)/(144.*Mst2**4.)-

     &  (91*Mgl**5.*Mt**6.*z2)/(96.*Mst2**2.)-

     &  (61*Mgl*Mst2**2.*Mt**6.*z2)/144.+

     &  (127*Mst2**4.*Mt**6.*z2)/(288.*Mgl**1.)+

     &  (5*Mst2**6.*Mt**6.*z2)/(48.*Mgl**3.)+

     &  (35*Mgl*Mt**8.*z2)/288.+

     &  (29*Mgl**5.*Mt**8.*z2)/(144.*Mst2**4.)+

     &  (335*Mgl**3.*Mt**8.*z2)/(288.*Mst2**2.)-

     &  (203*Mst2**2.*Mt**8.*z2)/(288.*Mgl**1.)+

     &  (Mst2**4.*Mt**8.*z2)/(144.*Mgl**3.)+

     &  (31*Mt**10.*z2)/(144.*Mgl**1.)-

     &  (7*Mgl**3.*Mt**10.*z2)/(144.*Mst2**4.)-

     &  (7*Mgl*Mt**10.*z2)/(18.*Mst2**2.)-

     &  (13*Mst2**2.*Mt**10.*z2)/(144.*Mgl**3.)+

     &  (Mt**12.*z2)/(24.*Mgl**3.)-

     &  (Mgl*Mt**12.*z2)/(144.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)+

     &  Xt*((5*Mgl**13.)/12.-(5*Mgl**15.)/(72.*Mst2**2.)-

     &  (35*Mgl**11.*Mst2**2.)/36.+

     &  (35*Mgl**9.*Mst2**4.)/36.-

     &  (35*Mgl**5.*Mst2**8.)/36.+

     &  (35*Mgl**3.*Mst2**10.)/36.-

     &  (5*Mgl*Mst2**12.)/12.+

     &  (5*Mst2**14.)/(72.*Mgl**1.)+

     &  (87383*Mgl**11.*Mt**2.)/41472.-

     &  (59*Mgl**15.*Mt**2.)/(144.*Mst2**4.)-

     &  (7*Mgl**13.*Mt**2.)/(192.*Mst2**2.)+

     &  (43079*Mgl**9.*Mst2**2.*Mt**2.)/41472.-

     &  (28993*Mgl**7.*Mst2**4.*Mt**2.)/4608.+

     &  (160655*Mgl**5.*Mst2**6.*Mt**2.)/41472.+

     &  (71213*Mgl**3.*Mst2**8.*Mt**2.)/41472.-

     &  (36305*Mgl*Mst2**10.*Mt**2.)/13824.+

     &  (11813*Mst2**12.*Mt**2.)/(41472.*Mgl**1.)+

     &  (14213*Mst2**14.*Mt**2.)/(41472.*Mgl**3.)-

     &  (10373*Mgl**9.*Mt**4.)/1536.+

     &  (253*Mgl**13.*Mt**4.)/(108.*Mst2**4.)+

     &  (7*Mgl**11.*Mt**4.)/(18.*Mst2**2.)-

     &  (40715*Mgl**7.*Mst2**2.*Mt**4.)/20736.+

     &  (402067*Mgl**5.*Mst2**4.*Mt**4.)/41472.-

     &  (58141*Mgl**3.*Mst2**6.*Mt**4.)/10368.+

     &  (325199*Mgl*Mst2**8.*Mt**4.)/41472.-

     &  (17833*Mst2**10.*Mt**4.)/(6912.*Mgl**1.)-

     &  (56155*Mst2**12.*Mt**4.)/(41472.*Mgl**3.)+

     &  (293767*Mgl**7.*Mt**6.)/41472.-

     &  (487*Mgl**11.*Mt**6.)/(81.*Mst2**4.)+

     &  (4469*Mgl**9.*Mt**6.)/(1728.*Mst2**2.)+

     &  (216253*Mgl**5.*Mst2**2.*Mt**6.)/41472.+

     &  (3529*Mgl**3.*Mst2**4.*Mt**6.)/6912.-

     &  (51493*Mgl*Mst2**6.*Mt**6.)/6912.+

     &  (132211*Mst2**8.*Mt**6.)/(41472.*Mgl**1.)+

     &  (23123*Mst2**10.*Mt**6.)/(13824.*Mgl**3.)-

     &  (145837*Mgl**5.*Mt**8.)/13824.+

     &  (769*Mgl**9.*Mt**8.)/(81.*Mst2**4.)-

     &  (2639*Mgl**7.*Mt**8.)/(288.*Mst2**2.)-

     &  (25615*Mgl**3.*Mst2**2.*Mt**8.)/3456.+

     &  (111259*Mgl*Mst2**4.*Mt**8.)/20736.+

     &  (3179*Mst2**6.*Mt**8.)/(1152.*Mgl**1.)-

     &  (1975*Mst2**8.*Mt**8.)/(41472.*Mgl**3.)+

     &  (471125*Mgl**3.*Mt**10.)/41472.-

     &  (2213*Mgl**7.*Mt**10.)/(216.*Mst2**4.)+

     &  (52411*Mgl**5.*Mt**10.)/(5184.*Mst2**2.)-

     &  (33079*Mgl*Mst2**2.*Mt**10.)/41472.-

     &  (100247*Mst2**4.*Mt**10.)/(13824.*Mgl**1.)-

     &  (60145*Mst2**6.*Mt**10.)/(41472.*Mgl**3.)-

     &  (145109*Mgl*Mt**12.)/41472.+

     &  (2347*Mgl**5.*Mt**12.)/(324.*Mst2**4.)-

     &  (12325*Mgl**3.*Mt**12.)/(2592.*Mst2**2.)+

     &  (82405*Mst2**2.*Mt**12.)/(20736.*Mgl**1.)+

     &  (14149*Mst2**4.*Mt**12.)/(13824.*Mgl**3.)-

     &  (5075*Mt**14.)/(41472.*Mgl**1.)-

     &  (443*Mgl**3.*Mt**14.)/(162.*Mst2**4.)+

     &  (7147*Mgl*Mt**14.)/(5184.*Mst2**2.)-

     &  (5965*Mst2**2.*Mt**14.)/(41472.*Mgl**3.)-

     &  (1789*Mt**16.)/(41472.*Mgl**3.)+

     &  (11*Mgl*Mt**16.)/(54.*Mst2**4.)-

     &  (95*Mt**16.)/(216.*Mgl**1.*Mst2**2.)+

     &  (17*Mt**18.)/(144.*Mgl**1.*Mst2**4.)+

     &  (121*Mgl**11.*Mt**2.*z2)/192.-

     &  (Mgl**15.*Mt**2.*z2)/(72.*Mst2**4.)-

     &  (7*Mgl**13.*Mt**2.*z2)/(36.*Mst2**2.)+

     &  (11*Mgl**9.*Mst2**2.*Mt**2.*z2)/96.-

     &  (107*Mgl**7.*Mst2**4.*Mt**2.*z2)/64.+

     &  (193*Mgl**5.*Mst2**6.*Mt**2.*z2)/144.+

     &  (13*Mgl**3.*Mst2**8.*Mt**2.*z2)/64.-

     &  (175*Mgl*Mst2**10.*Mt**2.*z2)/288.+

     &  (107*Mst2**12.*Mt**2.*z2)/(576.*Mgl**1.)+

     &  (Mst2**14.*Mt**2.*z2)/(72.*Mgl**3.)-

     &  (437*Mgl**9.*Mt**4.*z2)/576.+

     &  (Mgl**13.*Mt**4.*z2)/(72.*Mst2**4.)+

     &  (43*Mgl**11.*Mt**4.*z2)/(72.*Mst2**2.)-

     &  (391*Mgl**7.*Mst2**2.*Mt**4.*z2)/288.+

     &  (809*Mgl**5.*Mst2**4.*Mt**4.*z2)/576.+

     &  (49*Mgl**3.*Mst2**6.*Mt**4.*z2)/144.+

     &  (151*Mgl*Mst2**8.*Mt**4.*z2)/192.-

     &  (199*Mst2**10.*Mt**4.*z2)/(288.*Mgl**1.)-

     &  (Mst2**12.*Mt**4.*z2)/(576.*Mgl**3.)+

     &  (145*Mgl**7.*Mt**6.*z2)/576.+

     &  (Mgl**11.*Mt**6.*z2)/(8.*Mst2**4.)+

     &  (31*Mgl**9.*Mt**6.*z2)/(72.*Mst2**2.)+

     &  (45*Mgl**5.*Mst2**2.*Mt**6.*z2)/32.-

     &  (257*Mgl**3.*Mst2**4.*Mt**6.*z2)/288.-

     &  (Mgl*Mst2**6.*Mt**6.*z2)/18.+

     &  (91*Mst2**8.*Mt**6.*z2)/(192.*Mgl**1.)-

     &  (5*Mst2**10.*Mt**6.*z2)/(32.*Mgl**3.)-

     &  (1295*Mgl**5.*Mt**8.*z2)/576.-

     &  (19*Mgl**9.*Mt**8.*z2)/(72.*Mst2**4.)-

     &  (115*Mgl**7.*Mt**8.*z2)/(36.*Mst2**2.)-

     &  (73*Mgl**3.*Mst2**2.*Mt**8.*z2)/48.+

     &  (7*Mgl*Mst2**4.*Mt**8.*z2)/288.+

     &  (121*Mst2**6.*Mt**8.*z2)/(144.*Mgl**1.)+

     &  (185*Mst2**8.*Mt**8.*z2)/(576.*Mgl**3.)+

     &  (205*Mgl**3.*Mt**10.*z2)/64.+

     &  (Mgl**7.*Mt**10.*z2)/(72.*Mst2**4.)+

     &  (139*Mgl**5.*Mt**10.*z2)/(36.*Mst2**2.)+

     &  (61*Mgl*Mst2**2.*Mt**10.*z2)/96.-

     &  (715*Mst2**4.*Mt**10.*z2)/(576.*Mgl**1.)-

     &  (25*Mst2**6.*Mt**10.*z2)/(144.*Mgl**3.)-

     &  (611*Mgl*Mt**12.*z2)/576.+

     &  (3*Mgl**5.*Mt**12.*z2)/(8.*Mst2**4.)-

     &  (121*Mgl**3.*Mt**12.*z2)/(72.*Mst2**2.)+

     &  (13*Mst2**2.*Mt**12.*z2)/(32.*Mgl**1.)-

     &  (7*Mst2**4.*Mt**12.*z2)/(64.*Mgl**3.)+

     &  (5*Mt**14.*z2)/(192.*Mgl**1.)-

     &  (25*Mgl**3.*Mt**14.*z2)/(72.*Mst2**4.)+

     &  (13*Mgl*Mt**14.*z2)/(72.*Mst2**2.)+

     &  (43*Mst2**2.*Mt**14.*z2)/(288.*Mgl**3.)-

     &  (25*Mt**16.*z2)/(576.*Mgl**3.)+

     &  (7*Mgl*Mt**16.*z2)/(72.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)+

     &  Xt*((-46397*Mgl**15.*Mt**2.)/20736.+

     &  (161*Mgl**19.*Mt**2.)/(648.*Mst2**4.)-

     &  (1969*Mgl**17.*Mt**2.)/(20736.*Mst2**2.)+

     &  (6733*Mgl**13.*Mst2**2.*Mt**2.)/3456.+

     &  (1619*Mgl**11.*Mst2**4.*Mt**2.)/216.-

     &  (56531*Mgl**9.*Mst2**6.*Mt**2.)/3456.+

     &  (41941*Mgl**7.*Mst2**8.*Mt**2.)/3456.-

     &  (1835*Mgl**5.*Mst2**10.*Mt**2.)/1728.-

     &  (3691*Mgl**3.*Mst2**12.*Mt**2.)/864.+

     &  (49691*Mgl*Mst2**14.*Mt**2.)/20736.+

     &  (775*Mst2**16.*Mt**2.)/(20736.*Mgl**1.)-

     &  (2465*Mst2**18.*Mt**2.)/(10368.*Mgl**3.)+

     &  (1811*Mgl**13.*Mt**4.)/216.-

     &  (2455*Mgl**17.*Mt**4.)/(1296.*Mst2**4.)+

     &  (1957*Mgl**15.*Mt**4.)/(5184.*Mst2**2.)-

     &  (5771*Mgl**11.*Mst2**2.*Mt**4.)/3456.-

     &  (150793*Mgl**9.*Mst2**4.*Mt**4.)/10368.+

     &  (160447*Mgl**7.*Mst2**6.*Mt**4.)/10368.-

     &  (36023*Mgl**5.*Mst2**8.*Mt**4.)/3456.+

     &  (125965*Mgl**3.*Mst2**10.*Mt**4.)/10368.-

     &  (108595*Mgl*Mst2**12.*Mt**4.)/10368.+

     &  (11723*Mst2**14.*Mt**4.)/(10368.*Mgl**1.)+

     &  (15433*Mst2**16.*Mt**4.)/(10368.*Mgl**3.)-

     &  (62225*Mgl**11.*Mt**6.)/5184.+

     &  (2815*Mgl**15.*Mt**6.)/(432.*Mst2**4.)-

     &  (6301*Mgl**13.*Mt**6.)/(3456.*Mst2**2.)-

     &  (69733*Mgl**9.*Mst2**2.*Mt**6.)/10368.+

     &  (38335*Mgl**7.*Mst2**4.*Mt**6.)/2592.+

     &  (84131*Mgl**5.*Mst2**6.*Mt**6.)/10368.-

     &  (15835*Mgl**3.*Mst2**8.*Mt**6.)/1728.+

     &  (179861*Mgl*Mst2**10.*Mt**6.)/10368.-

     &  (1697*Mst2**12.*Mt**6.)/(324.*Mgl**1.)-

     &  (9791*Mst2**14.*Mt**6.)/(2592.*Mgl**3.)+

     &  (45431*Mgl**9.*Mt**8.)/3456.-

     &  (17875*Mgl**13.*Mt**8.)/(1296.*Mst2**4.)+

     &  (19165*Mgl**11.*Mt**8.)/(2592.*Mst2**2.)+

     &  (167293*Mgl**7.*Mst2**2.*Mt**8.)/10368.-

     &  (12331*Mgl**5.*Mst2**4.*Mt**8.)/1728.+

     &  (9619*Mgl**3.*Mst2**6.*Mt**8.)/5184.-

     &  (152615*Mgl*Mst2**8.*Mt**8.)/10368.+

     &  (27107*Mst2**10.*Mt**8.)/(3456.*Mgl**1.)+

     &  (12271*Mst2**12.*Mt**8.)/(2592.*Mgl**3.)-

     &  (213017*Mgl**7.*Mt**10.)/10368.+

     &  (26813*Mgl**11.*Mt**10.)/(1296.*Mst2**4.)-

     &  (74515*Mgl**9.*Mt**10.)/(5184.*Mst2**2.)-

     &  (19027*Mgl**5.*Mst2**2.*Mt**10.)/864.-

     &  (20159*Mgl**3.*Mst2**4.*Mt**10.)/2592.+

     &  (187*Mgl*Mst2**6.*Mt**10.)/24.-

     &  (3275*Mst2**8.*Mt**10.)/(1152.*Mgl**1.)-

     &  (12859*Mst2**10.*Mt**10.)/(5184.*Mgl**3.)+

     &  (230447*Mgl**5.*Mt**12.)/10368.-

     &  (10079*Mgl**9.*Mt**12.)/(432.*Mst2**4.)+

     &  (62861*Mgl**7.*Mt**12.)/(5184.*Mst2**2.)+

     &  (167933*Mgl**3.*Mst2**2.*Mt**12.)/10368.-

     &  (13033*Mgl*Mst2**4.*Mt**12.)/10368.-

     &  (13745*Mst2**6.*Mt**12.)/(3456.*Mgl**1.)-

     &  (3325*Mst2**8.*Mt**12.)/(5184.*Mgl**3.)-

     &  (17141*Mgl**3.*Mt**14.)/1728.+

     &  (25175*Mgl**7.*Mt**14.)/(1296.*Mst2**4.)-

     &  (20669*Mgl**5.*Mt**14.)/(10368.*Mst2**2.)-

     &  (26725*Mgl*Mst2**2.*Mt**14.)/10368.+

     &  (5609*Mst2**4.*Mt**14.)/(1296.*Mgl**1.)+

     &  (3913*Mst2**6.*Mt**14.)/(2592.*Mgl**3.)+

     &  (8899*Mgl*Mt**16.)/10368.-

     &  (14305*Mgl**5.*Mt**16.)/(1296.*Mst2**4.)-

     &  (1213*Mgl**3.*Mt**16.)/(432.*Mst2**2.)-

     &  (14081*Mst2**2.*Mt**16.)/(10368.*Mgl**1.)-

     &  (1769*Mst2**4.*Mt**16.)/(2592.*Mgl**3.)+

     &  (1583*Mt**18.)/(20736.*Mgl**1.)+

     &  (1615*Mgl**3.*Mt**18.)/(432.*Mst2**4.)+

     &  (24805*Mgl*Mt**18.)/(20736.*Mst2**2.)+

     &  (751*Mst2**2.*Mt**18.)/(10368.*Mgl**3.)+

     &  (17*Mt**20.)/(1152.*Mgl**3.)-

     &  (91*Mgl*Mt**20.)/(162.*Mst2**4.)-

     &  (7*Mgl**15.*Mt**2.*z2)/18.+

     &  (Mgl**19.*Mt**2.*z2)/(72.*Mst2**4.)+

     &  (Mgl**17.*Mt**2.*z2)/(16.*Mst2**2.)+

     &  (31*Mgl**13.*Mst2**2.*Mt**2.*z2)/144.+

     &  (67*Mgl**11.*Mst2**4.*Mt**2.*z2)/48.-

     &  (421*Mgl**9.*Mst2**6.*Mt**2.*z2)/144.+

     &  (325*Mgl**7.*Mst2**8.*Mt**2.*z2)/144.-

     &  (19*Mgl**5.*Mst2**10.*Mt**2.*z2)/48.-

     &  (79*Mgl**3.*Mst2**12.*Mt**2.*z2)/144.+

     &  (7*Mgl*Mst2**14.*Mt**2.*z2)/18.-

     &  (Mst2**16.*Mt**2.*z2)/(16.*Mgl**1.)-

     &  (Mst2**18.*Mt**2.*z2)/(72.*Mgl**3.)+

     &  (203*Mgl**13.*Mt**4.*z2)/144.-

     &  (Mgl**17.*Mt**4.*z2)/(12.*Mst2**4.)-

     &  (121*Mgl**15.*Mt**4.*z2)/(288.*Mst2**2.)+

     &  (7*Mgl**11.*Mst2**2.*Mt**4.*z2)/24.-

     &  (449*Mgl**9.*Mst2**4.*Mt**4.*z2)/144.+

     &  (19*Mgl**7.*Mst2**6.*Mt**4.*z2)/9.-

     &  (5*Mgl**5.*Mst2**8.*Mt**4.*z2)/24.+

     &  (31*Mgl**3.*Mst2**10.*Mt**4.*z2)/36.-

     &  (67*Mgl*Mst2**12.*Mt**4.*z2)/48.+

     &  (47*Mst2**14.*Mt**4.*z2)/(96.*Mgl**1.)+

     &  (Mst2**16.*Mt**4.*z2)/(16.*Mgl**3.)-

     &  (473*Mgl**11.*Mt**6.*z2)/288.+

     &  (3*Mgl**15.*Mt**6.*z2)/(16.*Mst2**4.)+

     &  (217*Mgl**13.*Mt**6.*z2)/(288.*Mst2**2.)-

     &  (419*Mgl**9.*Mst2**2.*Mt**6.*z2)/288.+

     &  (787*Mgl**7.*Mst2**4.*Mt**6.*z2)/288.+

     &  (73*Mgl**5.*Mst2**6.*Mt**6.*z2)/288.+

     &  (61*Mgl**3.*Mst2**8.*Mt**6.*z2)/288.+

     &  (467*Mgl*Mst2**10.*Mt**6.*z2)/288.-

     &  (365*Mst2**12.*Mt**6.*z2)/(288.*Mgl**1.)-

     &  (Mst2**14.*Mt**6.*z2)/(16.*Mgl**3.)+

     &  (15*Mgl**9.*Mt**8.*z2)/8.-

     &  (11*Mgl**13.*Mt**8.*z2)/(48.*Mst2**4.)+

     &  (169*Mgl**11.*Mt**8.*z2)/(288.*Mst2**2.)+

     &  (259*Mgl**7.*Mst2**2.*Mt**8.*z2)/96.-

     &  (13*Mgl**5.*Mst2**4.*Mt**8.*z2)/12.-

     &  (169*Mgl**3.*Mst2**6.*Mt**8.*z2)/288.-

     &  (7*Mgl*Mst2**8.*Mt**8.*z2)/9.+

     &  (39*Mst2**10.*Mt**8.*z2)/(32.*Mgl**1.)-

     &  (7*Mst2**12.*Mt**8.*z2)/(48.*Mgl**3.)-

     &  (1297*Mgl**7.*Mt**10.*z2)/288.+

     &  (17*Mgl**11.*Mt**10.*z2)/(48.*Mst2**4.)-

     &  (335*Mgl**9.*Mt**10.*z2)/(96.*Mst2**2.)-

     &  (635*Mgl**5.*Mst2**2.*Mt**10.*z2)/144.-

     &  (59*Mgl**3.*Mst2**4.*Mt**10.*z2)/48.+

     &  (47*Mgl*Mst2**6.*Mt**10.*z2)/96.+

     &  (5*Mst2**8.*Mt**10.*z2)/(32.*Mgl**1.)+

     &  (7*Mst2**10.*Mt**10.*z2)/(16.*Mgl**3.)+

     &  (773*Mgl**5.*Mt**12.*z2)/144.-

     &  (13*Mgl**9.*Mt**12.*z2)/(16.*Mst2**4.)+

     &  (1217*Mgl**7.*Mt**12.*z2)/(288.*Mst2**2.)+

     &  (457*Mgl**3.*Mst2**2.*Mt**12.*z2)/144.-

     &  (7*Mgl*Mst2**4.*Mt**12.*z2)/36.-

     &  (317*Mst2**6.*Mt**12.*z2)/(288.*Mgl**1.)-

     &  (7*Mst2**8.*Mt**12.*z2)/(16.*Mgl**3.)-

     &  (217*Mgl**3.*Mt**14.*z2)/96.+

     &  (59*Mgl**7.*Mt**14.*z2)/(48.*Mst2**4.)-

     &  (529*Mgl**5.*Mt**14.*z2)/(288.*Mst2**2.)-

     &  (115*Mgl*Mst2**2.*Mt**14.*z2)/288.+

     &  (21*Mst2**4.*Mt**14.*z2)/(32.*Mgl**1.)+

     &  (7*Mst2**6.*Mt**14.*z2)/(48.*Mgl**3.)+

     &  (Mgl*Mt**16.*z2)/6.-

     &  (49*Mgl**5.*Mt**16.*z2)/(48.*Mst2**4.)-

     &  (17*Mgl**3.*Mt**16.*z2)/(288.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**16.*z2)/(96.*Mgl**1.)+

     &  (Mst2**4.*Mt**16.*z2)/(16.*Mgl**3.)-

     &  (11*Mt**18.*z2)/(288.*Mgl**1.)+

     &  (7*Mgl**3.*Mt**18.*z2)/(16.*Mst2**4.)+

     &  (17*Mgl*Mt**18.*z2)/(96.*Mst2**2.)-

     &  (Mst2**2.*Mt**18.*z2)/(16.*Mgl**3.)+

     &  (Mt**20.*z2)/(72.*Mgl**3.)-

     &  (11*Mgl*Mt**20.*z2)/(144.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)+

     &  (-0.06076388888888889+Mgl**2./(576.*Mst1**2.)+

     &  (7*Mst1**2.)/(384.*Mgl**2.)+

     &  Mst1**4./(192.*Mgl**4.)+Mgl**2./(576.*Mst2**2.)+

     &  (7*Mst2**2.)/(384.*Mgl**2.)+

     &  Mst2**4./(192.*Mgl**4.)+Mgl**2./(72.*Mt**2.)-

     &  Mgl**4./(192.*Mst1**2.*Mt**2.)-

     &  Mst1**2./(576.*Mt**2.)-

     &  Mgl**4./(192.*Mst2**2.*Mt**2.)-

     &  Mst2**2./(576.*Mt**2.)-Mt**2./(16.*Mgl**2.)+

     &  Mt**2./(384.*Mst1**2.)-

     &  (Mst1**2.*Mt**2.)/(64.*Mgl**4.)+

     &  Mt**2./(384.*Mst2**2.)-

     &  (Mst2**2.*Mt**2.)/(64.*Mgl**4.)+

     &  Mt**4./(32.*Mgl**4.)+

     &  (5*Mt**4.)/(384.*Mgl**2.*Mst1**2.)+

     &  (5*Mt**4.)/(384.*Mgl**2.*Mst2**2.)-

     &  Mt**6./(192.*Mgl**4.*Mst1**2.)-

     &  Mt**6./(192.*Mgl**4.*Mst2**2.))*ln(mu,Mgl)+

     &  (-Mgl**4./64.+(5*Mgl**8.)/(576.*Mst1**4.)-

     &  (23*Mgl**6.)/(3456.*Mst1**2.)+

     &  (11*Mgl**2.*Mst1**2.)/384.-(53*Mst1**4.)/1728.+

     &  (5*Mst1**6.)/(576.*Mgl**2.)-

     &  Mst1**8./(144.*Mgl**4.)+

     &  (5*Mgl**6.)/(576.*Mt**2.)-

     &  Mgl**8./(192.*Mst1**2.*Mt**2.)+

     &  (Mgl**4.*Mst1**2.)/(96.*Mt**2.)-

     &  (Mgl**2.*Mst1**4.)/(32.*Mt**2.)+

     &  (13*Mst1**6.)/(576.*Mt**2.)-

     &  Mst1**8./(192.*Mgl**2.*Mt**2.)+

     &  (11*Mgl**2.*Mt**2.)/216.-

     &  (5*Mgl**6.*Mt**2.)/(288.*Mst1**4.)-

     &  (149*Mgl**4.*Mt**2.)/(1728.*Mst1**2.)-

     &  (Mst1**2.*Mt**2.)/864.+

     &  (Mst1**4.*Mt**2.)/(192.*Mgl**2.)+

     &  (5*Mst1**6.*Mt**2.)/(144.*Mgl**4.)-

     &  (67*Mt**4.)/1728.+

     &  (Mgl**4.*Mt**4.)/(192.*Mst1**4.)+

     &  (119*Mgl**2.*Mt**4.)/(3456.*Mst1**2.)-

     &  (Mst1**2.*Mt**4.)/(48.*Mgl**2.)-

     &  (5*Mst1**4.*Mt**4.)/(72.*Mgl**4.)+

     &  (13*Mt**6.)/(576.*Mgl**2.)+

     &  (7*Mgl**2.*Mt**6.)/(576.*Mst1**4.)+

     &  (107*Mt**6.)/(1728.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**6.)/(72.*Mgl**4.)-

     &  (5*Mt**8.)/(144.*Mgl**4.)-Mt**8./(72.*Mst1**4.)-

     &  Mt**8./(64.*Mgl**2.*Mst1**2.)+

     &  Mt**10./(192.*Mgl**2.*Mst1**4.)+

     &  Mt**10./(144.*Mgl**4.*Mst1**2.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mgl)+((5*Mgl**8.)/6912.-

     &  (5*Mgl**12.)/(576.*Mst1**4.)+

     &  (491*Mgl**10.)/(6912.*Mst1**2.)-

     &  (829*Mgl**6.*Mst1**2.)/1728.+

     &  (1883*Mgl**4.*Mst1**4.)/3456.-

     &  (1313*Mgl**2.*Mst1**6.)/6912.+

     &  (613*Mst1**8.)/6912.-

     &  (11*Mst1**10.)/(384.*Mgl**2.)+

     &  Mst1**12./(576.*Mgl**4.)-

     &  (43*Mgl**10.)/(576.*Mt**2.)+

     &  (5*Mgl**12.)/(288.*Mst1**2.*Mt**2.)+

     &  (31*Mgl**8.*Mst1**2.)/(288.*Mt**2.)-

     &  (5*Mgl**6.*Mst1**4.)/(192.*Mt**2.)-

     &  (25*Mgl**4.*Mst1**6.)/(288.*Mt**2.)+

     &  (55*Mgl**2.*Mst1**8.)/(576.*Mt**2.)-

     &  (11*Mst1**10.)/(288.*Mt**2.)+

     &  Mst1**12./(192.*Mgl**2.*Mt**2.)-

     &  (1015*Mgl**6.*Mt**2.)/3456.+

     &  (Mgl**10.*Mt**2.)/(36.*Mst1**4.)-

     &  (173*Mgl**8.*Mt**2.)/(6912.*Mst1**2.)+

     &  (781*Mgl**4.*Mst1**2.*Mt**2.)/1728.-

     &  (13*Mgl**2.*Mst1**4.*Mt**2.)/1152.+

     &  (13*Mst1**6.*Mt**2.)/768.+

     &  (7*Mst1**8.*Mt**2.)/(64.*Mgl**2.)-

     &  (7*Mst1**10.*Mt**2.)/(576.*Mgl**4.)-

     &  (527*Mgl**4.*Mt**4.)/3456.-

     &  (Mgl**8.*Mt**4.)/(576.*Mst1**4.)-

     &  (257*Mgl**6.*Mt**4.)/(1152.*Mst1**2.)-

     &  (3*Mgl**2.*Mst1**2.*Mt**4.)/64.-

     &  (193*Mst1**4.*Mt**4.)/3456.-

     &  (329*Mst1**6.*Mt**4.)/(1152.*Mgl**2.)+

     &  (7*Mst1**8.*Mt**4.)/(192.*Mgl**4.)-

     &  (823*Mgl**2.*Mt**6.)/3456.-

     &  (Mgl**6.*Mt**6.)/(24.*Mst1**4.)-

     &  (Mgl**4.*Mt**6.)/(18.*Mst1**2.)-

     &  (887*Mst1**2.*Mt**6.)/3456.+

     &  (245*Mst1**4.*Mt**6.)/(576.*Mgl**2.)-

     &  (35*Mst1**6.*Mt**6.)/(576.*Mgl**4.)+

     &  (313*Mt**8.)/768.+

     &  (Mgl**4.*Mt**8.)/(576.*Mst1**4.)+

     &  (2509*Mgl**2.*Mt**8.)/(6912.*Mst1**2.)-

     &  (371*Mst1**2.*Mt**8.)/(1152.*Mgl**2.)+

     &  (35*Mst1**4.*Mt**8.)/(576.*Mgl**4.)+

     &  (49*Mt**10.)/(576.*Mgl**2.)+

     &  (Mgl**2.*Mt**10.)/(36.*Mst1**4.)-

     &  (1183*Mt**10.)/(6912.*Mst1**2.)-

     &  (7*Mst1**2.*Mt**10.)/(192.*Mgl**4.)+

     &  (7*Mt**12.)/(576.*Mgl**4.)+

     &  (5*Mt**12.)/(576.*Mst1**4.)+

     &  (29*Mt**12.)/(1152.*Mgl**2.*Mst1**2.)-

     &  Mt**14./(72.*Mgl**2.*Mst1**4.)-

     &  Mt**14./(576.*Mgl**4.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mgl)+

     &  ((595*Mgl**12.)/1152.-(5*Mgl**16.)/(576.*Mst1**4.)-

     &  (155*Mgl**14.)/(1152.*Mst1**2.)+

     &  (301*Mgl**10.*Mst1**2.)/3456.-

     &  (6155*Mgl**8.*Mst1**4.)/3456.+

     &  (6787*Mgl**6.*Mst1**6.)/3456.-

     &  (2029*Mgl**4.*Mst1**8.)/3456.-

     &  (409*Mgl**2.*Mst1**10.)/3456.+

     &  (221*Mst1**12.)/3456.-Mst1**14./(576.*Mgl**2.)+

     &  Mgl**14./(24.*Mt**2.)-

     &  Mgl**16./(144.*Mst1**2.*Mt**2.)-

     &  (7*Mgl**12.*Mst1**2.)/(72.*Mt**2.)+

     &  (7*Mgl**10.*Mst1**4.)/(72.*Mt**2.)-

     &  (7*Mgl**6.*Mst1**8.)/(72.*Mt**2.)+

     &  (7*Mgl**4.*Mst1**10.)/(72.*Mt**2.)-

     &  (Mgl**2.*Mst1**12.)/(24.*Mt**2.)+

     &  Mst1**14./(144.*Mt**2.)-

     &  (385*Mgl**10.*Mt**2.)/864.+

     &  (13*Mgl**14.*Mt**2.)/(288.*Mst1**4.)+

     &  (445*Mgl**12.*Mt**2.)/(1728.*Mst1**2.)-

     &  (1361*Mgl**8.*Mst1**2.*Mt**2.)/1728.+

     &  (2513*Mgl**6.*Mst1**4.*Mt**2.)/1728.-

     &  (1957*Mgl**4.*Mst1**6.*Mt**2.)/1728.+

     &  (265*Mgl**2.*Mst1**8.*Mt**2.)/216.-

     &  (349*Mst1**10.*Mt**2.)/576.-

     &  (7*Mst1**12.*Mt**2.)/(576.*Mgl**2.)-

     &  (1237*Mgl**8.*Mt**4.)/3456.-

     &  (97*Mgl**12.*Mt**4.)/(576.*Mst1**4.)+

     &  (1087*Mgl**10.*Mt**4.)/(3456.*Mst1**2.)+

     &  (265*Mgl**6.*Mst1**2.*Mt**4.)/1728.+

     &  (487*Mgl**4.*Mst1**4.*Mt**4.)/288.-

     &  (5153*Mgl**2.*Mst1**6.*Mt**4.)/3456.+

     &  (575*Mst1**8.*Mt**4.)/384.+

     &  (Mst1**10.*Mt**4.)/(8.*Mgl**2.)-

     &  (259*Mgl**6.*Mt**6.)/864.+

     &  (233*Mgl**10.*Mt**6.)/(576.*Mst1**4.)-

     &  (14*Mgl**8.*Mt**6.)/(27.*Mst1**2.)-

     &  (425*Mgl**4.*Mst1**2.*Mt**6.)/432.+

     &  (55*Mgl**2.*Mst1**4.*Mt**6.)/192.-

     &  (259*Mst1**6.*Mt**6.)/216.-

     &  (7*Mst1**8.*Mt**6.)/(18.*Mgl**2.)-

     &  (2245*Mgl**4.*Mt**8.)/3456.-

     &  (27*Mgl**8.*Mt**8.)/(64.*Mst1**4.)-

     &  (2249*Mgl**6.*Mt**8.)/(3456.*Mst1**2.)-

     &  (3967*Mgl**2.*Mst1**2.*Mt**8.)/3456.-

     &  (703*Mst1**4.*Mt**8.)/1152.+

     &  (175*Mst1**6.*Mt**8.)/(288.*Mgl**2.)+

     &  (407*Mgl**2.*Mt**10.)/216.-

     &  (43*Mgl**6.*Mt**10.)/(576.*Mst1**4.)+

     &  (1801*Mgl**4.*Mt**10.)/(1728.*Mst1**2.)+

     &  (293*Mst1**2.*Mt**10.)/192.-

     &  (49*Mst1**4.*Mt**10.)/(96.*Mgl**2.)-

     &  (2431*Mt**12.)/3456.+

     &  (301*Mgl**4.*Mt**12.)/(576.*Mst1**4.)-

     &  (743*Mgl**2.*Mt**12.)/(3456.*Mst1**2.)+

     &  (7*Mst1**2.*Mt**12.)/(36.*Mgl**2.)+

     &  Mt**14./(72.*Mgl**2.)-

     &  (221*Mgl**2.*Mt**14.)/(576.*Mst1**4.)-

     &  (5*Mt**14.)/(96.*Mst1**2.)+

     &  (11*Mt**16.)/(144.*Mst1**4.)-

     &  (7*Mt**16.)/(192.*Mgl**2.*Mst1**2.)+

     &  (5*Mt**18.)/(576.*Mgl**2.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.*ln(mu,Mgl)+

     &  ((-1063*Mgl**16.)/2304.+

     &  (5*Mgl**20.)/(576.*Mst1**4.)+

     &  (353*Mgl**18.)/(6912.*Mst1**2.)+

     &  (22*Mgl**14.*Mst1**2.)/27.+

     &  (79*Mgl**12.*Mst1**4.)/216.-

     &  (3145*Mgl**10.*Mst1**6.)/1152.+

     &  (12155*Mgl**8.*Mst1**8.)/3456.-

     &  (1811*Mgl**6.*Mst1**10.)/864.+

     &  (37*Mgl**4.*Mst1**12.)/64.-

     &  (275*Mgl**2.*Mst1**14.)/6912.-

     &  (19*Mst1**16.)/2304.+(269*Mgl**14.*Mt**2.)/384.-

     &  (Mgl**18.*Mt**2.)/(18.*Mst1**4.)-

     &  (517*Mgl**16.*Mt**2.)/(6912.*Mst1**2.)-

     &  (613*Mgl**12.*Mst1**2.*Mt**2.)/3456.-

     &  (5599*Mgl**10.*Mst1**4.*Mt**2.)/3456.+

     &  (2987*Mgl**8.*Mst1**6.*Mt**2.)/1728.-

     &  (683*Mgl**6.*Mst1**8.*Mt**2.)/1152.+

     &  (367*Mgl**4.*Mst1**10.*Mt**2.)/1152.-

     &  (1429*Mgl**2.*Mst1**12.*Mt**2.)/3456.+

     &  (1289*Mst1**14.*Mt**2.)/6912.+

     &  (1963*Mgl**12.*Mt**4.)/1728.+

     &  (37*Mgl**16.*Mt**4.)/(192.*Mst1**4.)-

     &  (257*Mgl**14.*Mt**4.)/(384.*Mst1**2.)-

     &  (1531*Mgl**10.*Mst1**2.*Mt**4.)/1152.+

     &  (233*Mgl**8.*Mst1**4.*Mt**4.)/192.+

     &  (2023*Mgl**6.*Mst1**6.*Mt**4.)/1152.-

     &  (595*Mgl**4.*Mst1**8.*Mt**4.)/192.+

     &  (637*Mgl**2.*Mst1**10.*Mt**4.)/384.-

     &  (743*Mst1**12.*Mt**4.)/864.-

     &  (8089*Mgl**10.*Mt**6.)/3456.-

     &  (Mgl**14.*Mt**6.)/(2.*Mst1**4.)+

     &  (919*Mgl**12.*Mt**6.)/(384.*Mst1**2.)-

     &  (115*Mgl**8.*Mst1**2.*Mt**6.)/288.-

     &  (73*Mgl**6.*Mst1**4.*Mt**6.)/1728.+

     &  (10727*Mgl**4.*Mst1**6.*Mt**6.)/3456.-

     &  (2119*Mgl**2.*Mst1**8.*Mt**6.)/1152.+

     &  (2711*Mst1**10.*Mt**6.)/1728.+

     &  (3095*Mgl**8.*Mt**8.)/3456.+

     &  (257*Mgl**12.*Mt**8.)/(288.*Mst1**4.)-

     &  (2527*Mgl**10.*Mt**8.)/(864.*Mst1**2.)+

     &  (649*Mgl**6.*Mst1**2.*Mt**8.)/576.-

     &  (89*Mgl**4.*Mst1**4.*Mt**8.)/144.+

     &  (649*Mgl**2.*Mst1**6.*Mt**8.)/576.-

     &  (2891*Mst1**8.*Mt**8.)/3456.-

     &  (959*Mgl**6.*Mt**10.)/1152.-

     &  (5*Mgl**10.*Mt**10.)/(6.*Mst1**4.)+

     &  (2147*Mgl**8.*Mt**10.)/(1728.*Mst1**2.)-

     &  (1975*Mgl**4.*Mst1**2.*Mt**10.)/1152.-

     &  (7415*Mgl**2.*Mst1**4.*Mt**10.)/3456.-

     &  (4109*Mst1**6.*Mt**10.)/3456.+

     &  (2453*Mgl**4.*Mt**12.)/1728.-

     &  (Mgl**8.*Mt**12.)/(32.*Mst1**4.)-

     &  (911*Mgl**6.*Mt**12.)/(3456.*Mst1**2.)+

     &  (8779*Mgl**2.*Mst1**2.*Mt**12.)/3456.+

     &  (3479*Mst1**4.*Mt**12.)/1728.-

     &  (863*Mgl**2.*Mt**14.)/3456.+

     &  (17*Mgl**6.*Mt**14.)/(18.*Mst1**4.)+

     &  (1147*Mgl**4.*Mt**14.)/(1152.*Mst1**2.)-

     &  (1489*Mst1**2.*Mt**14.)/1728.-

     &  (1849*Mt**16.)/6912.-

     &  (63*Mgl**4.*Mt**16.)/(64.*Mst1**4.)-

     &  (7481*Mgl**2.*Mt**16.)/(6912.*Mst1**2.)+

     &  (4*Mgl**2.*Mt**18.)/(9.*Mst1**4.)+

     &  (2297*Mt**18.)/(6912.*Mst1**2.)-

     &  (5*Mt**20.)/(64.*Mst1**4.))*d123(Mt,Mgl,Mst1)**4.*

     &  ln(mu,Mgl)+(-Mgl**4./64.+

     &  (5*Mgl**8.)/(576.*Mst2**4.)-

     &  (23*Mgl**6.)/(3456.*Mst2**2.)+

     &  (11*Mgl**2.*Mst2**2.)/384.-(53*Mst2**4.)/1728.+

     &  (5*Mst2**6.)/(576.*Mgl**2.)-

     &  Mst2**8./(144.*Mgl**4.)+

     &  (5*Mgl**6.)/(576.*Mt**2.)-

     &  Mgl**8./(192.*Mst2**2.*Mt**2.)+

     &  (Mgl**4.*Mst2**2.)/(96.*Mt**2.)-

     &  (Mgl**2.*Mst2**4.)/(32.*Mt**2.)+

     &  (13*Mst2**6.)/(576.*Mt**2.)-

     &  Mst2**8./(192.*Mgl**2.*Mt**2.)+

     &  (11*Mgl**2.*Mt**2.)/216.-

     &  (5*Mgl**6.*Mt**2.)/(288.*Mst2**4.)-

     &  (149*Mgl**4.*Mt**2.)/(1728.*Mst2**2.)-

     &  (Mst2**2.*Mt**2.)/864.+

     &  (Mst2**4.*Mt**2.)/(192.*Mgl**2.)+

     &  (5*Mst2**6.*Mt**2.)/(144.*Mgl**4.)-

     &  (67*Mt**4.)/1728.+

     &  (Mgl**4.*Mt**4.)/(192.*Mst2**4.)+

     &  (119*Mgl**2.*Mt**4.)/(3456.*Mst2**2.)-

     &  (Mst2**2.*Mt**4.)/(48.*Mgl**2.)-

     &  (5*Mst2**4.*Mt**4.)/(72.*Mgl**4.)+

     &  (13*Mt**6.)/(576.*Mgl**2.)+

     &  (7*Mgl**2.*Mt**6.)/(576.*Mst2**4.)+

     &  (107*Mt**6.)/(1728.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**6.)/(72.*Mgl**4.)-

     &  (5*Mt**8.)/(144.*Mgl**4.)-Mt**8./(72.*Mst2**4.)-

     &  Mt**8./(64.*Mgl**2.*Mst2**2.)+

     &  Mt**10./(192.*Mgl**2.*Mst2**4.)+

     &  Mt**10./(144.*Mgl**4.*Mst2**2.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mgl)+((5*Mgl**8.)/6912.-

     &  (5*Mgl**12.)/(576.*Mst2**4.)+

     &  (491*Mgl**10.)/(6912.*Mst2**2.)-

     &  (829*Mgl**6.*Mst2**2.)/1728.+

     &  (1883*Mgl**4.*Mst2**4.)/3456.-

     &  (1313*Mgl**2.*Mst2**6.)/6912.+

     &  (613*Mst2**8.)/6912.-

     &  (11*Mst2**10.)/(384.*Mgl**2.)+

     &  Mst2**12./(576.*Mgl**4.)-

     &  (43*Mgl**10.)/(576.*Mt**2.)+

     &  (5*Mgl**12.)/(288.*Mst2**2.*Mt**2.)+

     &  (31*Mgl**8.*Mst2**2.)/(288.*Mt**2.)-

     &  (5*Mgl**6.*Mst2**4.)/(192.*Mt**2.)-

     &  (25*Mgl**4.*Mst2**6.)/(288.*Mt**2.)+

     &  (55*Mgl**2.*Mst2**8.)/(576.*Mt**2.)-

     &  (11*Mst2**10.)/(288.*Mt**2.)+

     &  Mst2**12./(192.*Mgl**2.*Mt**2.)-

     &  (1015*Mgl**6.*Mt**2.)/3456.+

     &  (Mgl**10.*Mt**2.)/(36.*Mst2**4.)-

     &  (173*Mgl**8.*Mt**2.)/(6912.*Mst2**2.)+

     &  (781*Mgl**4.*Mst2**2.*Mt**2.)/1728.-

     &  (13*Mgl**2.*Mst2**4.*Mt**2.)/1152.+

     &  (13*Mst2**6.*Mt**2.)/768.+

     &  (7*Mst2**8.*Mt**2.)/(64.*Mgl**2.)-

     &  (7*Mst2**10.*Mt**2.)/(576.*Mgl**4.)-

     &  (527*Mgl**4.*Mt**4.)/3456.-

     &  (Mgl**8.*Mt**4.)/(576.*Mst2**4.)-

     &  (257*Mgl**6.*Mt**4.)/(1152.*Mst2**2.)-

     &  (3*Mgl**2.*Mst2**2.*Mt**4.)/64.-

     &  (193*Mst2**4.*Mt**4.)/3456.-

     &  (329*Mst2**6.*Mt**4.)/(1152.*Mgl**2.)+

     &  (7*Mst2**8.*Mt**4.)/(192.*Mgl**4.)-

     &  (823*Mgl**2.*Mt**6.)/3456.-

     &  (Mgl**6.*Mt**6.)/(24.*Mst2**4.)-

     &  (Mgl**4.*Mt**6.)/(18.*Mst2**2.)-

     &  (887*Mst2**2.*Mt**6.)/3456.+

     &  (245*Mst2**4.*Mt**6.)/(576.*Mgl**2.)-

     &  (35*Mst2**6.*Mt**6.)/(576.*Mgl**4.)+

     &  (313*Mt**8.)/768.+

     &  (Mgl**4.*Mt**8.)/(576.*Mst2**4.)+

     &  (2509*Mgl**2.*Mt**8.)/(6912.*Mst2**2.)-

     &  (371*Mst2**2.*Mt**8.)/(1152.*Mgl**2.)+

     &  (35*Mst2**4.*Mt**8.)/(576.*Mgl**4.)+

     &  (49*Mt**10.)/(576.*Mgl**2.)+

     &  (Mgl**2.*Mt**10.)/(36.*Mst2**4.)-

     &  (1183*Mt**10.)/(6912.*Mst2**2.)-

     &  (7*Mst2**2.*Mt**10.)/(192.*Mgl**4.)+

     &  (7*Mt**12.)/(576.*Mgl**4.)+

     &  (5*Mt**12.)/(576.*Mst2**4.)+

     &  (29*Mt**12.)/(1152.*Mgl**2.*Mst2**2.)-

     &  Mt**14./(72.*Mgl**2.*Mst2**4.)-

     &  Mt**14./(576.*Mgl**4.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mgl)+

     &  ((595*Mgl**12.)/1152.-(5*Mgl**16.)/(576.*Mst2**4.)-

     &  (155*Mgl**14.)/(1152.*Mst2**2.)+

     &  (301*Mgl**10.*Mst2**2.)/3456.-

     &  (6155*Mgl**8.*Mst2**4.)/3456.+

     &  (6787*Mgl**6.*Mst2**6.)/3456.-

     &  (2029*Mgl**4.*Mst2**8.)/3456.-

     &  (409*Mgl**2.*Mst2**10.)/3456.+

     &  (221*Mst2**12.)/3456.-Mst2**14./(576.*Mgl**2.)+

     &  Mgl**14./(24.*Mt**2.)-

     &  Mgl**16./(144.*Mst2**2.*Mt**2.)-

     &  (7*Mgl**12.*Mst2**2.)/(72.*Mt**2.)+

     &  (7*Mgl**10.*Mst2**4.)/(72.*Mt**2.)-

     &  (7*Mgl**6.*Mst2**8.)/(72.*Mt**2.)+

     &  (7*Mgl**4.*Mst2**10.)/(72.*Mt**2.)-

     &  (Mgl**2.*Mst2**12.)/(24.*Mt**2.)+

     &  Mst2**14./(144.*Mt**2.)-

     &  (385*Mgl**10.*Mt**2.)/864.+

     &  (13*Mgl**14.*Mt**2.)/(288.*Mst2**4.)+

     &  (445*Mgl**12.*Mt**2.)/(1728.*Mst2**2.)-

     &  (1361*Mgl**8.*Mst2**2.*Mt**2.)/1728.+

     &  (2513*Mgl**6.*Mst2**4.*Mt**2.)/1728.-

     &  (1957*Mgl**4.*Mst2**6.*Mt**2.)/1728.+

     &  (265*Mgl**2.*Mst2**8.*Mt**2.)/216.-

     &  (349*Mst2**10.*Mt**2.)/576.-

     &  (7*Mst2**12.*Mt**2.)/(576.*Mgl**2.)-

     &  (1237*Mgl**8.*Mt**4.)/3456.-

     &  (97*Mgl**12.*Mt**4.)/(576.*Mst2**4.)+

     &  (1087*Mgl**10.*Mt**4.)/(3456.*Mst2**2.)+

     &  (265*Mgl**6.*Mst2**2.*Mt**4.)/1728.+

     &  (487*Mgl**4.*Mst2**4.*Mt**4.)/288.-

     &  (5153*Mgl**2.*Mst2**6.*Mt**4.)/3456.+

     &  (575*Mst2**8.*Mt**4.)/384.+

     &  (Mst2**10.*Mt**4.)/(8.*Mgl**2.)-

     &  (259*Mgl**6.*Mt**6.)/864.+

     &  (233*Mgl**10.*Mt**6.)/(576.*Mst2**4.)-

     &  (14*Mgl**8.*Mt**6.)/(27.*Mst2**2.)-

     &  (425*Mgl**4.*Mst2**2.*Mt**6.)/432.+

     &  (55*Mgl**2.*Mst2**4.*Mt**6.)/192.-

     &  (259*Mst2**6.*Mt**6.)/216.-

     &  (7*Mst2**8.*Mt**6.)/(18.*Mgl**2.)-

     &  (2245*Mgl**4.*Mt**8.)/3456.-

     &  (27*Mgl**8.*Mt**8.)/(64.*Mst2**4.)-

     &  (2249*Mgl**6.*Mt**8.)/(3456.*Mst2**2.)-

     &  (3967*Mgl**2.*Mst2**2.*Mt**8.)/3456.-

     &  (703*Mst2**4.*Mt**8.)/1152.+

     &  (175*Mst2**6.*Mt**8.)/(288.*Mgl**2.)+

     &  (407*Mgl**2.*Mt**10.)/216.-

     &  (43*Mgl**6.*Mt**10.)/(576.*Mst2**4.)+

     &  (1801*Mgl**4.*Mt**10.)/(1728.*Mst2**2.)+

     &  (293*Mst2**2.*Mt**10.)/192.-

     &  (49*Mst2**4.*Mt**10.)/(96.*Mgl**2.)-

     &  (2431*Mt**12.)/3456.+

     &  (301*Mgl**4.*Mt**12.)/(576.*Mst2**4.)-

     &  (743*Mgl**2.*Mt**12.)/(3456.*Mst2**2.)+

     &  (7*Mst2**2.*Mt**12.)/(36.*Mgl**2.)+

     &  Mt**14./(72.*Mgl**2.)-

     &  (221*Mgl**2.*Mt**14.)/(576.*Mst2**4.)-

     &  (5*Mt**14.)/(96.*Mst2**2.)+

     &  (11*Mt**16.)/(144.*Mst2**4.)-

     &  (7*Mt**16.)/(192.*Mgl**2.*Mst2**2.)+

     &  (5*Mt**18.)/(576.*Mgl**2.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.*ln(mu,Mgl)+

     &  ((-1063*Mgl**16.)/2304.+

     &  (5*Mgl**20.)/(576.*Mst2**4.)+

     &  (353*Mgl**18.)/(6912.*Mst2**2.)+

     &  (22*Mgl**14.*Mst2**2.)/27.+

     &  (79*Mgl**12.*Mst2**4.)/216.-

     &  (3145*Mgl**10.*Mst2**6.)/1152.+

     &  (12155*Mgl**8.*Mst2**8.)/3456.-

     &  (1811*Mgl**6.*Mst2**10.)/864.+

     &  (37*Mgl**4.*Mst2**12.)/64.-

     &  (275*Mgl**2.*Mst2**14.)/6912.-

     &  (19*Mst2**16.)/2304.+(269*Mgl**14.*Mt**2.)/384.-

     &  (Mgl**18.*Mt**2.)/(18.*Mst2**4.)-

     &  (517*Mgl**16.*Mt**2.)/(6912.*Mst2**2.)-

     &  (613*Mgl**12.*Mst2**2.*Mt**2.)/3456.-

     &  (5599*Mgl**10.*Mst2**4.*Mt**2.)/3456.+

     &  (2987*Mgl**8.*Mst2**6.*Mt**2.)/1728.-

     &  (683*Mgl**6.*Mst2**8.*Mt**2.)/1152.+

     &  (367*Mgl**4.*Mst2**10.*Mt**2.)/1152.-

     &  (1429*Mgl**2.*Mst2**12.*Mt**2.)/3456.+

     &  (1289*Mst2**14.*Mt**2.)/6912.+

     &  (1963*Mgl**12.*Mt**4.)/1728.+

     &  (37*Mgl**16.*Mt**4.)/(192.*Mst2**4.)-

     &  (257*Mgl**14.*Mt**4.)/(384.*Mst2**2.)-

     &  (1531*Mgl**10.*Mst2**2.*Mt**4.)/1152.+

     &  (233*Mgl**8.*Mst2**4.*Mt**4.)/192.+

     &  (2023*Mgl**6.*Mst2**6.*Mt**4.)/1152.-

     &  (595*Mgl**4.*Mst2**8.*Mt**4.)/192.+

     &  (637*Mgl**2.*Mst2**10.*Mt**4.)/384.-

     &  (743*Mst2**12.*Mt**4.)/864.-

     &  (8089*Mgl**10.*Mt**6.)/3456.-

     &  (Mgl**14.*Mt**6.)/(2.*Mst2**4.)+

     &  (919*Mgl**12.*Mt**6.)/(384.*Mst2**2.)-

     &  (115*Mgl**8.*Mst2**2.*Mt**6.)/288.-

     &  (73*Mgl**6.*Mst2**4.*Mt**6.)/1728.+

     &  (10727*Mgl**4.*Mst2**6.*Mt**6.)/3456.-

     &  (2119*Mgl**2.*Mst2**8.*Mt**6.)/1152.+

     &  (2711*Mst2**10.*Mt**6.)/1728.+

     &  (3095*Mgl**8.*Mt**8.)/3456.+

     &  (257*Mgl**12.*Mt**8.)/(288.*Mst2**4.)-

     &  (2527*Mgl**10.*Mt**8.)/(864.*Mst2**2.)+

     &  (649*Mgl**6.*Mst2**2.*Mt**8.)/576.-

     &  (89*Mgl**4.*Mst2**4.*Mt**8.)/144.+

     &  (649*Mgl**2.*Mst2**6.*Mt**8.)/576.-

     &  (2891*Mst2**8.*Mt**8.)/3456.-

     &  (959*Mgl**6.*Mt**10.)/1152.-

     &  (5*Mgl**10.*Mt**10.)/(6.*Mst2**4.)+

     &  (2147*Mgl**8.*Mt**10.)/(1728.*Mst2**2.)-

     &  (1975*Mgl**4.*Mst2**2.*Mt**10.)/1152.-

     &  (7415*Mgl**2.*Mst2**4.*Mt**10.)/3456.-

     &  (4109*Mst2**6.*Mt**10.)/3456.+

     &  (2453*Mgl**4.*Mt**12.)/1728.-

     &  (Mgl**8.*Mt**12.)/(32.*Mst2**4.)-

     &  (911*Mgl**6.*Mt**12.)/(3456.*Mst2**2.)+

     &  (8779*Mgl**2.*Mst2**2.*Mt**12.)/3456.+

     &  (3479*Mst2**4.*Mt**12.)/1728.-

     &  (863*Mgl**2.*Mt**14.)/3456.+

     &  (17*Mgl**6.*Mt**14.)/(18.*Mst2**4.)+

     &  (1147*Mgl**4.*Mt**14.)/(1152.*Mst2**2.)-

     &  (1489*Mst2**2.*Mt**14.)/1728.-

     &  (1849*Mt**16.)/6912.-

     &  (63*Mgl**4.*Mt**16.)/(64.*Mst2**4.)-

     &  (7481*Mgl**2.*Mt**16.)/(6912.*Mst2**2.)+

     &  (4*Mgl**2.*Mt**18.)/(9.*Mst2**4.)+

     &  (2297*Mt**18.)/(6912.*Mst2**2.)-

     &  (5*Mt**20.)/(64.*Mst2**4.))*d123(Mt,Mgl,Mst2)**4.*

     &  ln(mu,Mgl)+(Mgl**3./(96.*Mst1**2.)-

     &  Mgl**3./(96.*Mst2**2.)-

     &  (Mgl*Mt**2.)/(72.*Mst1**2.)+

     &  (Mst1**2.*Mt**2.)/(96.*Mgl**3.)+

     &  (Mgl*Mt**2.)/(72.*Mst2**2.)-

     &  (Mst2**2.*Mt**2.)/(96.*Mgl**3.)-

     &  Mt**4./(48.*Mgl**1.*Mst1**2.)+

     &  Mt**4./(48.*Mgl**1.*Mst2**2.)+

     &  Mt**6./(96.*Mgl**3.*Mst1**2.)-

     &  Mt**6./(96.*Mgl**3.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mgl)+(Mgl**5./144.-

     &  (5*Mgl**3.*Mst1**2.)/144.+(7*Mgl*Mst1**4.)/144.-

     &  Mst1**6./(48.*Mgl**1.)+(65*Mgl**3.*Mt**2.)/864.-

     &  (5*Mgl**7.*Mt**2.)/(144.*Mst1**4.)+

     &  (37*Mgl**5.*Mt**2.)/(432.*Mst1**2.)+

     &  (41*Mgl*Mst1**2.*Mt**2.)/864.-

     &  (31*Mst1**4.*Mt**2.)/(288.*Mgl**1.)-

     &  (5*Mst1**6.*Mt**2.)/(288.*Mgl**3.)+

     &  (49*Mgl*Mt**4.)/864.+

     &  (5*Mgl**5.*Mt**4.)/(48.*Mst1**4.)+

     &  (161*Mgl**3.*Mt**4.)/(864.*Mst1**2.)+

     &  (41*Mst1**2.*Mt**4.)/(144.*Mgl**1.)+

     &  (5*Mst1**4.*Mt**4.)/(72.*Mgl**3.)-

     &  (53*Mt**6.)/(288.*Mgl**1.)-

     &  (Mgl**3.*Mt**6.)/(8.*Mst1**4.)-

     &  (61*Mgl*Mt**6.)/(216.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**6.)/(48.*Mgl**3.)+

     &  (5*Mt**8.)/(72.*Mgl**3.)+

     &  (11*Mgl*Mt**8.)/(144.*Mst1**4.)+

     &  (7*Mt**8.)/(144.*Mgl**1.*Mst1**2.)-

     &  Mt**10./(48.*Mgl**1.*Mst1**4.)-

     &  (5*Mt**10.)/(288.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((13*Mgl**9.)/96.-(11*Mgl**11.)/(288.*Mst1**2.)-

     &  (5*Mgl**7.*Mst1**2.)/36.-

     &  (5*Mgl**5.*Mst1**4.)/144.+

     &  (5*Mgl**3.*Mst1**6.)/32.-(29*Mgl*Mst1**8.)/288.+

     &  Mst1**10./(48.*Mgl**1.)-

     &  (71*Mgl**7.*Mt**2.)/216.+

     &  (5*Mgl**11.*Mt**2.)/(144.*Mst1**4.)-

     &  (341*Mgl**9.*Mt**2.)/(1728.*Mst1**2.)+

     &  (65*Mgl**5.*Mst1**2.*Mt**2.)/36.-

     &  (1637*Mgl**3.*Mst1**4.*Mt**2.)/864.+

     &  (1153*Mgl*Mst1**6.*Mt**2.)/1728.-

     &  (3*Mst1**8.*Mt**2.)/(32.*Mgl**1.)+

     &  (Mst1**10.*Mt**2.)/(144.*Mgl**3.)+

     &  (1397*Mgl**5.*Mt**4.)/864.-

     &  (7*Mgl**9.*Mt**4.)/(48.*Mst1**4.)-

     &  (217*Mgl**7.*Mt**4.)/(864.*Mst1**2.)-

     &  (515*Mgl**3.*Mst1**2.*Mt**4.)/288.-

     &  (775*Mgl*Mst1**4.*Mt**4.)/864.+

     &  (41*Mst1**6.*Mt**4.)/(144.*Mgl**1.)-

     &  (Mst1**8.*Mt**4.)/(24.*Mgl**3.)+

     &  (529*Mgl**3.*Mt**6.)/864.+

     &  (11*Mgl**7.*Mt**6.)/(72.*Mst1**4.)+

     &  (1807*Mgl**5.*Mt**6.)/(864.*Mst1**2.)+

     &  (383*Mgl*Mst1**2.*Mt**6.)/432.-

     &  (9*Mst1**4.*Mt**6.)/(16.*Mgl**1.)+

     &  (5*Mst1**6.*Mt**6.)/(48.*Mgl**3.)-

     &  (289*Mgl*Mt**8.)/216.+

     &  (Mgl**5.*Mt**8.)/(72.*Mst1**4.)-

     &  (257*Mgl**3.*Mt**8.)/(108.*Mst1**2.)+

     &  (79*Mst1**2.*Mt**8.)/(144.*Mgl**1.)-

     &  (5*Mst1**4.*Mt**8.)/(36.*Mgl**3.)-

     &  (43*Mt**10.)/(288.*Mgl**1.)-

     &  (Mgl**3.*Mt**10.)/(48.*Mst1**4.)+

     &  (1507*Mgl*Mt**10.)/(1728.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**10.)/(48.*Mgl**3.)-

     &  Mt**12./(24.*Mgl**3.)-

     &  (13*Mgl*Mt**12.)/(144.*Mst1**4.)-

     &  (5*Mt**12.)/(48.*Mgl**1.*Mst1**2.)+

     &  Mt**14./(18.*Mgl**1.*Mst1**4.)+

     &  Mt**14./(144.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((-5*Mgl**13.)/36.+Mgl**15./(36.*Mst1**2.)+

     &  (Mgl**11.*Mst1**2.)/4.-(5*Mgl**9.*Mst1**4.)/36.-

     &  (5*Mgl**7.*Mst1**6.)/36.+(Mgl**5.*Mst1**8.)/4.-

     &  (5*Mgl**3.*Mst1**10.)/36.+(Mgl*Mst1**12.)/36.-

     &  (257*Mgl**11.*Mt**2.)/288.+

     &  (5*Mgl**15.*Mt**2.)/(144.*Mst1**4.)+

     &  (101*Mgl**13.*Mt**2.)/(288.*Mst1**2.)-

     &  (367*Mgl**9.*Mst1**2.*Mt**2.)/216.+

     &  (1877*Mgl**7.*Mst1**4.*Mt**2.)/432.-

     &  (707*Mgl**5.*Mst1**6.*Mt**2.)/288.+

     &  (97*Mgl**3.*Mst1**8.*Mt**2.)/864.+

     &  (91*Mgl*Mst1**10.*Mt**2.)/432.-

     &  (Mst1**12.*Mt**2.)/(144.*Mgl**1.)-

     &  (173*Mgl**9.*Mt**4.)/432.-

     &  (31*Mgl**13.*Mt**4.)/(144.*Mst1**4.)-

     &  (275*Mgl**11.*Mt**4.)/(864.*Mst1**2.)+

     &  (955*Mgl**7.*Mst1**2.*Mt**4.)/216.-

     &  (1165*Mgl**5.*Mst1**4.*Mt**4.)/216.+

     &  (1207*Mgl**3.*Mst1**6.*Mt**4.)/864.-

     &  (149*Mgl*Mst1**8.*Mt**4.)/108.-

     &  (Mst1**10.*Mt**4.)/(18.*Mgl**1.)+

     &  (43*Mgl**7.*Mt**6.)/18.+

     &  (8*Mgl**11.*Mt**6.)/(9.*Mst1**4.)-

     &  (785*Mgl**9.*Mt**6.)/(216.*Mst1**2.)-

     &  (43*Mgl**5.*Mst1**2.*Mt**6.)/48.-

     &  (395*Mgl**3.*Mst1**4.*Mt**6.)/216.+

     &  (739*Mgl*Mst1**6.*Mt**6.)/432.+

     &  (4*Mst1**8.*Mt**6.)/(9.*Mgl**1.)+

     &  (2027*Mgl**5.*Mt**8.)/432.-

     &  (361*Mgl**9.*Mt**8.)/(144.*Mst1**4.)+

     &  (1261*Mgl**7.*Mt**8.)/(144.*Mst1**2.)+

     &  (1121*Mgl**3.*Mst1**2.*Mt**8.)/216.+

     &  (647*Mgl*Mst1**4.*Mt**8.)/432.-

     &  (10*Mst1**6.*Mt**8.)/(9.*Mgl**1.)-

     &  (7261*Mgl**3.*Mt**10.)/864.+

     &  (151*Mgl**7.*Mt**10.)/(36.*Mst1**4.)-

     &  (6133*Mgl**5.*Mt**10.)/(864.*Mst1**2.)-

     &  (1915*Mgl*Mst1**2.*Mt**10.)/432.+

     &  (95*Mst1**4.*Mt**10.)/(72.*Mgl**1.)+

     &  (583*Mgl*Mt**12.)/216.-

     &  (187*Mgl**5.*Mt**12.)/(48.*Mst1**4.)+

     &  (1613*Mgl**3.*Mt**12.)/(864.*Mst1**2.)-

     &  (13*Mst1**2.*Mt**12.)/(18.*Mgl**1.)+

     &  Mt**14./(18.*Mgl**1.)+

     &  (65*Mgl**3.*Mt**14.)/(36.*Mst1**4.)-

     &  (Mgl*Mt**14.)/(16.*Mst1**2.)-

     &  (13*Mgl*Mt**16.)/(48.*Mst1**4.)+

     &  Mt**16./(9.*Mgl**1.*Mst1**2.)-

     &  (5*Mt**18.)/(144.*Mgl**1.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((347*Mgl**15.*Mt**2.)/216.-

     &  (5*Mgl**19.*Mt**2.)/(144.*Mst1**4.)-

     &  (413*Mgl**17.*Mt**2.)/(1728.*Mst1**2.)-

     &  (119*Mgl**13.*Mst1**2.*Mt**2.)/72.-

     &  (673*Mgl**11.*Mst1**4.*Mt**2.)/216.+

     &  (6743*Mgl**9.*Mst1**6.*Mt**2.)/864.-

     &  (451*Mgl**7.*Mst1**8.*Mt**2.)/72.+

     &  (229*Mgl**5.*Mst1**10.*Mt**2.)/108.-

     &  (83*Mgl**3.*Mst1**12.*Mt**2.)/432.-

     &  (19*Mgl*Mst1**14.*Mt**2.)/576.-

     &  (1561*Mgl**13.*Mt**4.)/432.+

     &  (37*Mgl**17.*Mt**4.)/(144.*Mst1**4.)+

     &  (229*Mgl**15.*Mt**4.)/(288.*Mst1**2.)-

     &  (1081*Mgl**11.*Mst1**2.*Mt**4.)/864.+

     &  (3605*Mgl**9.*Mst1**4.*Mt**4.)/432.-

     &  (5507*Mgl**7.*Mst1**6.*Mt**4.)/864.+

     &  (977*Mgl**5.*Mst1**8.*Mt**4.)/432.-

     &  (979*Mgl**3.*Mst1**10.*Mt**4.)/864.+

     &  (77*Mgl*Mst1**12.*Mt**4.)/108.-

     &  (11*Mgl**11.*Mt**6.)/144.-

     &  (37*Mgl**15.*Mt**6.)/(36.*Mst1**4.)+

     &  (41*Mgl**13.*Mt**6.)/(48.*Mst1**2.)+

     &  (701*Mgl**9.*Mst1**2.*Mt**6.)/108.-

     &  (161*Mgl**7.*Mst1**4.*Mt**6.)/24.-

     &  (3179*Mgl**5.*Mst1**6.*Mt**6.)/432.+

     &  (1199*Mgl**3.*Mst1**8.*Mt**6.)/432.-

     &  (589*Mgl*Mst1**10.*Mt**6.)/216.+

     &  (881*Mgl**9.*Mt**8.)/432.+

     &  (109*Mgl**13.*Mt**8.)/(36.*Mst1**4.)-

     &  (2131*Mgl**11.*Mt**8.)/(288.*Mst1**2.)-

     &  (137*Mgl**7.*Mst1**2.*Mt**8.)/48.+

     &  (869*Mgl**5.*Mst1**4.*Mt**8.)/216.-

     &  (893*Mgl**3.*Mst1**6.*Mt**8.)/864.+

     &  (511*Mgl*Mst1**8.*Mt**8.)/144.+

     &  (743*Mgl**7.*Mt**10.)/108.-

     &  (475*Mgl**11.*Mt**10.)/(72.*Mst1**4.)+

     &  (10801*Mgl**9.*Mt**10.)/(864.*Mst1**2.)+

     &  (1129*Mgl**5.*Mst1**2.*Mt**10.)/216.+

     &  (397*Mgl**3.*Mst1**4.*Mt**10.)/108.+

     &  (175*Mgl*Mst1**6.*Mt**10.)/864.-

     &  (1597*Mgl**5.*Mt**12.)/144.+

     &  (715*Mgl**9.*Mt**12.)/(72.*Mst1**4.)-

     &  (6515*Mgl**7.*Mt**12.)/(864.*Mst1**2.)-

     &  (8173*Mgl**3.*Mst1**2.*Mt**12.)/864.-

     &  (1967*Mgl*Mst1**4.*Mt**12.)/432.+

     &  (605*Mgl**3.*Mt**14.)/144.-

     &  (353*Mgl**7.*Mt**14.)/(36.*Mst1**4.)-

     &  (523*Mgl**5.*Mt**14.)/(432.*Mst1**2.)+

     &  (7*Mgl*Mst1**2.*Mt**14.)/2.+

     &  (23*Mgl*Mt**16.)/432.+

     &  (217*Mgl**5.*Mt**16.)/(36.*Mst1**4.)+

     &  (2813*Mgl**3.*Mt**16.)/(864.*Mst1**2.)-

     &  (301*Mgl**3.*Mt**18.)/(144.*Mst1**4.)-

     &  (1757*Mgl*Mt**18.)/(1728.*Mst1**2.)+

     &  (5*Mgl*Mt**20.)/(16.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  (-Mgl**5./144.+(5*Mgl**3.*Mst2**2.)/144.-

     &  (7*Mgl*Mst2**4.)/144.+Mst2**6./(48.*Mgl**1.)-

     &  (65*Mgl**3.*Mt**2.)/864.+

     &  (5*Mgl**7.*Mt**2.)/(144.*Mst2**4.)-

     &  (37*Mgl**5.*Mt**2.)/(432.*Mst2**2.)-

     &  (41*Mgl*Mst2**2.*Mt**2.)/864.+

     &  (31*Mst2**4.*Mt**2.)/(288.*Mgl**1.)+

     &  (5*Mst2**6.*Mt**2.)/(288.*Mgl**3.)-

     &  (49*Mgl*Mt**4.)/864.-

     &  (5*Mgl**5.*Mt**4.)/(48.*Mst2**4.)-

     &  (161*Mgl**3.*Mt**4.)/(864.*Mst2**2.)-

     &  (41*Mst2**2.*Mt**4.)/(144.*Mgl**1.)-

     &  (5*Mst2**4.*Mt**4.)/(72.*Mgl**3.)+

     &  (53*Mt**6.)/(288.*Mgl**1.)+

     &  (Mgl**3.*Mt**6.)/(8.*Mst2**4.)+

     &  (61*Mgl*Mt**6.)/(216.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**6.)/(48.*Mgl**3.)-

     &  (5*Mt**8.)/(72.*Mgl**3.)-

     &  (11*Mgl*Mt**8.)/(144.*Mst2**4.)-

     &  (7*Mt**8.)/(144.*Mgl**1.*Mst2**2.)+

     &  Mt**10./(48.*Mgl**1.*Mst2**4.)+

     &  (5*Mt**10.)/(288.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((-13*Mgl**9.)/96.+(11*Mgl**11.)/(288.*Mst2**2.)+

     &  (5*Mgl**7.*Mst2**2.)/36.+

     &  (5*Mgl**5.*Mst2**4.)/144.-

     &  (5*Mgl**3.*Mst2**6.)/32.+(29*Mgl*Mst2**8.)/288.-

     &  Mst2**10./(48.*Mgl**1.)+

     &  (71*Mgl**7.*Mt**2.)/216.-

     &  (5*Mgl**11.*Mt**2.)/(144.*Mst2**4.)+

     &  (341*Mgl**9.*Mt**2.)/(1728.*Mst2**2.)-

     &  (65*Mgl**5.*Mst2**2.*Mt**2.)/36.+

     &  (1637*Mgl**3.*Mst2**4.*Mt**2.)/864.-

     &  (1153*Mgl*Mst2**6.*Mt**2.)/1728.+

     &  (3*Mst2**8.*Mt**2.)/(32.*Mgl**1.)-

     &  (Mst2**10.*Mt**2.)/(144.*Mgl**3.)-

     &  (1397*Mgl**5.*Mt**4.)/864.+

     &  (7*Mgl**9.*Mt**4.)/(48.*Mst2**4.)+

     &  (217*Mgl**7.*Mt**4.)/(864.*Mst2**2.)+

     &  (515*Mgl**3.*Mst2**2.*Mt**4.)/288.+

     &  (775*Mgl*Mst2**4.*Mt**4.)/864.-

     &  (41*Mst2**6.*Mt**4.)/(144.*Mgl**1.)+

     &  (Mst2**8.*Mt**4.)/(24.*Mgl**3.)-

     &  (529*Mgl**3.*Mt**6.)/864.-

     &  (11*Mgl**7.*Mt**6.)/(72.*Mst2**4.)-

     &  (1807*Mgl**5.*Mt**6.)/(864.*Mst2**2.)-

     &  (383*Mgl*Mst2**2.*Mt**6.)/432.+

     &  (9*Mst2**4.*Mt**6.)/(16.*Mgl**1.)-

     &  (5*Mst2**6.*Mt**6.)/(48.*Mgl**3.)+

     &  (289*Mgl*Mt**8.)/216.-

     &  (Mgl**5.*Mt**8.)/(72.*Mst2**4.)+

     &  (257*Mgl**3.*Mt**8.)/(108.*Mst2**2.)-

     &  (79*Mst2**2.*Mt**8.)/(144.*Mgl**1.)+

     &  (5*Mst2**4.*Mt**8.)/(36.*Mgl**3.)+

     &  (43*Mt**10.)/(288.*Mgl**1.)+

     &  (Mgl**3.*Mt**10.)/(48.*Mst2**4.)-

     &  (1507*Mgl*Mt**10.)/(1728.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**10.)/(48.*Mgl**3.)+

     &  Mt**12./(24.*Mgl**3.)+

     &  (13*Mgl*Mt**12.)/(144.*Mst2**4.)+

     &  (5*Mt**12.)/(48.*Mgl**1.*Mst2**2.)-

     &  Mt**14./(18.*Mgl**1.*Mst2**4.)-

     &  Mt**14./(144.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((5*Mgl**13.)/36.-Mgl**15./(36.*Mst2**2.)-

     &  (Mgl**11.*Mst2**2.)/4.+(5*Mgl**9.*Mst2**4.)/36.+

     &  (5*Mgl**7.*Mst2**6.)/36.-(Mgl**5.*Mst2**8.)/4.+

     &  (5*Mgl**3.*Mst2**10.)/36.-(Mgl*Mst2**12.)/36.+

     &  (257*Mgl**11.*Mt**2.)/288.-

     &  (5*Mgl**15.*Mt**2.)/(144.*Mst2**4.)-

     &  (101*Mgl**13.*Mt**2.)/(288.*Mst2**2.)+

     &  (367*Mgl**9.*Mst2**2.*Mt**2.)/216.-

     &  (1877*Mgl**7.*Mst2**4.*Mt**2.)/432.+

     &  (707*Mgl**5.*Mst2**6.*Mt**2.)/288.-

     &  (97*Mgl**3.*Mst2**8.*Mt**2.)/864.-

     &  (91*Mgl*Mst2**10.*Mt**2.)/432.+

     &  (Mst2**12.*Mt**2.)/(144.*Mgl**1.)+

     &  (173*Mgl**9.*Mt**4.)/432.+

     &  (31*Mgl**13.*Mt**4.)/(144.*Mst2**4.)+

     &  (275*Mgl**11.*Mt**4.)/(864.*Mst2**2.)-

     &  (955*Mgl**7.*Mst2**2.*Mt**4.)/216.+

     &  (1165*Mgl**5.*Mst2**4.*Mt**4.)/216.-

     &  (1207*Mgl**3.*Mst2**6.*Mt**4.)/864.+

     &  (149*Mgl*Mst2**8.*Mt**4.)/108.+

     &  (Mst2**10.*Mt**4.)/(18.*Mgl**1.)-

     &  (43*Mgl**7.*Mt**6.)/18.-

     &  (8*Mgl**11.*Mt**6.)/(9.*Mst2**4.)+

     &  (785*Mgl**9.*Mt**6.)/(216.*Mst2**2.)+

     &  (43*Mgl**5.*Mst2**2.*Mt**6.)/48.+

     &  (395*Mgl**3.*Mst2**4.*Mt**6.)/216.-

     &  (739*Mgl*Mst2**6.*Mt**6.)/432.-

     &  (4*Mst2**8.*Mt**6.)/(9.*Mgl**1.)-

     &  (2027*Mgl**5.*Mt**8.)/432.+

     &  (361*Mgl**9.*Mt**8.)/(144.*Mst2**4.)-

     &  (1261*Mgl**7.*Mt**8.)/(144.*Mst2**2.)-

     &  (1121*Mgl**3.*Mst2**2.*Mt**8.)/216.-

     &  (647*Mgl*Mst2**4.*Mt**8.)/432.+

     &  (10*Mst2**6.*Mt**8.)/(9.*Mgl**1.)+

     &  (7261*Mgl**3.*Mt**10.)/864.-

     &  (151*Mgl**7.*Mt**10.)/(36.*Mst2**4.)+

     &  (6133*Mgl**5.*Mt**10.)/(864.*Mst2**2.)+

     &  (1915*Mgl*Mst2**2.*Mt**10.)/432.-

     &  (95*Mst2**4.*Mt**10.)/(72.*Mgl**1.)-

     &  (583*Mgl*Mt**12.)/216.+

     &  (187*Mgl**5.*Mt**12.)/(48.*Mst2**4.)-

     &  (1613*Mgl**3.*Mt**12.)/(864.*Mst2**2.)+

     &  (13*Mst2**2.*Mt**12.)/(18.*Mgl**1.)-

     &  Mt**14./(18.*Mgl**1.)-

     &  (65*Mgl**3.*Mt**14.)/(36.*Mst2**4.)+

     &  (Mgl*Mt**14.)/(16.*Mst2**2.)+

     &  (13*Mgl*Mt**16.)/(48.*Mst2**4.)-

     &  Mt**16./(9.*Mgl**1.*Mst2**2.)+

     &  (5*Mt**18.)/(144.*Mgl**1.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  ((-347*Mgl**15.*Mt**2.)/216.+

     &  (5*Mgl**19.*Mt**2.)/(144.*Mst2**4.)+

     &  (413*Mgl**17.*Mt**2.)/(1728.*Mst2**2.)+

     &  (119*Mgl**13.*Mst2**2.*Mt**2.)/72.+

     &  (673*Mgl**11.*Mst2**4.*Mt**2.)/216.-

     &  (6743*Mgl**9.*Mst2**6.*Mt**2.)/864.+

     &  (451*Mgl**7.*Mst2**8.*Mt**2.)/72.-

     &  (229*Mgl**5.*Mst2**10.*Mt**2.)/108.+

     &  (83*Mgl**3.*Mst2**12.*Mt**2.)/432.+

     &  (19*Mgl*Mst2**14.*Mt**2.)/576.+

     &  (1561*Mgl**13.*Mt**4.)/432.-

     &  (37*Mgl**17.*Mt**4.)/(144.*Mst2**4.)-

     &  (229*Mgl**15.*Mt**4.)/(288.*Mst2**2.)+

     &  (1081*Mgl**11.*Mst2**2.*Mt**4.)/864.-

     &  (3605*Mgl**9.*Mst2**4.*Mt**4.)/432.+

     &  (5507*Mgl**7.*Mst2**6.*Mt**4.)/864.-

     &  (977*Mgl**5.*Mst2**8.*Mt**4.)/432.+

     &  (979*Mgl**3.*Mst2**10.*Mt**4.)/864.-

     &  (77*Mgl*Mst2**12.*Mt**4.)/108.+

     &  (11*Mgl**11.*Mt**6.)/144.+

     &  (37*Mgl**15.*Mt**6.)/(36.*Mst2**4.)-

     &  (41*Mgl**13.*Mt**6.)/(48.*Mst2**2.)-

     &  (701*Mgl**9.*Mst2**2.*Mt**6.)/108.+

     &  (161*Mgl**7.*Mst2**4.*Mt**6.)/24.+

     &  (3179*Mgl**5.*Mst2**6.*Mt**6.)/432.-

     &  (1199*Mgl**3.*Mst2**8.*Mt**6.)/432.+

     &  (589*Mgl*Mst2**10.*Mt**6.)/216.-

     &  (881*Mgl**9.*Mt**8.)/432.-

     &  (109*Mgl**13.*Mt**8.)/(36.*Mst2**4.)+

     &  (2131*Mgl**11.*Mt**8.)/(288.*Mst2**2.)+

     &  (137*Mgl**7.*Mst2**2.*Mt**8.)/48.-

     &  (869*Mgl**5.*Mst2**4.*Mt**8.)/216.+

     &  (893*Mgl**3.*Mst2**6.*Mt**8.)/864.-

     &  (511*Mgl*Mst2**8.*Mt**8.)/144.-

     &  (743*Mgl**7.*Mt**10.)/108.+

     &  (475*Mgl**11.*Mt**10.)/(72.*Mst2**4.)-

     &  (10801*Mgl**9.*Mt**10.)/(864.*Mst2**2.)-

     &  (1129*Mgl**5.*Mst2**2.*Mt**10.)/216.-

     &  (397*Mgl**3.*Mst2**4.*Mt**10.)/108.-

     &  (175*Mgl*Mst2**6.*Mt**10.)/864.+

     &  (1597*Mgl**5.*Mt**12.)/144.-

     &  (715*Mgl**9.*Mt**12.)/(72.*Mst2**4.)+

     &  (6515*Mgl**7.*Mt**12.)/(864.*Mst2**2.)+

     &  (8173*Mgl**3.*Mst2**2.*Mt**12.)/864.+

     &  (1967*Mgl*Mst2**4.*Mt**12.)/432.-

     &  (605*Mgl**3.*Mt**14.)/144.+

     &  (353*Mgl**7.*Mt**14.)/(36.*Mst2**4.)+

     &  (523*Mgl**5.*Mt**14.)/(432.*Mst2**2.)-

     &  (7*Mgl*Mst2**2.*Mt**14.)/2.-

     &  (23*Mgl*Mt**16.)/432.-

     &  (217*Mgl**5.*Mt**16.)/(36.*Mst2**4.)-

     &  (2813*Mgl**3.*Mt**16.)/(864.*Mst2**2.)+

     &  (301*Mgl**3.*Mt**18.)/(144.*Mst2**4.)+

     &  (1757*Mgl*Mt**18.)/(1728.*Mst2**2.)-

     &  (5*Mgl*Mt**20.)/(16.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)+

     &  (0.04774305555555555+(5*Mgl**2.)/(1152.*Mst1**2.)+

     &  Mst1**2./(2304.*Mgl**2.)+

     &  (5*Mgl**2.)/(1152.*Mst2**2.)+

     &  Mst2**2./(2304.*Mgl**2.)-Mt**2./(1152.*Mgl**2.)-

     &  Mt**2./(1152.*Mst1**2.)-Mt**2./(1152.*Mst2**2.))*

     &  ln(mu,Mgl)**2.+

     &  ((-41*Mgl**4.)/2304.+Mgl**8./(576.*Mst1**4.)+

     &  Mgl**6./(288.*Mst1**2.)+

     &  (167*Mgl**2.*Mst1**2.)/2304.-

     &  (85*Mst1**4.)/2304.-

     &  (5*Mst1**6.)/(2304.*Mgl**2.)+

     &  (25*Mgl**2.*Mt**2.)/256.-

     &  (Mgl**6.*Mt**2.)/(288.*Mst1**4.)-

     &  (11*Mgl**4.*Mt**2.)/(1152.*Mst1**2.)+

     &  (43*Mst1**2.*Mt**2.)/576.+

     &  (5*Mst1**4.*Mt**2.)/(768.*Mgl**2.)-

     &  (121*Mt**4.)/2304.-

     &  (Mgl**2.*Mt**4.)/(96.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**4.)/(768.*Mgl**2.)+

     &  (5*Mt**6.)/(2304.*Mgl**2.)+

     &  (Mgl**2.*Mt**6.)/(288.*Mst1**4.)+

     &  (19*Mt**6.)/(1152.*Mst1**2.)-

     &  Mt**8./(576.*Mst1**4.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mgl)**2.+

     &  (-Mgl**8./768.-Mgl**12./(192.*Mst1**4.)+

     &  (19*Mgl**10.)/(1152.*Mst1**2.)-

     &  (241*Mgl**6.*Mst1**2.)/2304.+

     &  (155*Mgl**4.*Mst1**4.)/1152.-

     &  (Mgl**2.*Mst1**6.)/24.+Mst1**8./2304.+

     &  Mst1**10./(768.*Mgl**2.)-

     &  (53*Mgl**6.*Mt**2.)/768.+

     &  (5*Mgl**10.*Mt**2.)/(288.*Mst1**4.)+

     &  (17*Mgl**8.*Mt**2.)/(768.*Mst1**2.)+

     &  (11*Mgl**4.*Mst1**2.*Mt**2.)/96.+

     &  (Mgl**2.*Mst1**4.*Mt**2.)/96.-

     &  (23*Mst1**6.*Mt**2.)/2304.-

     &  (7*Mst1**8.*Mt**2.)/(768.*Mgl**2.)+

     &  (47*Mgl**4.*Mt**4.)/1152.-

     &  (5*Mgl**8.*Mt**4.)/(384.*Mst1**4.)-

     &  (25*Mgl**6.*Mt**4.)/(384.*Mst1**2.)+

     &  (23*Mgl**2.*Mst1**2.*Mt**4.)/288.+

     &  (Mst1**4.*Mt**4.)/12.+

     &  (3*Mst1**6.*Mt**4.)/(128.*Mgl**2.)-

     &  (103*Mgl**2.*Mt**6.)/576.-

     &  (7*Mgl**6.*Mt**6.)/(576.*Mst1**4.)-

     &  (67*Mgl**4.*Mt**6.)/(1152.*Mst1**2.)-

     &  (55*Mst1**2.*Mt**6.)/288.-

     &  (11*Mst1**4.*Mt**6.)/(384.*Mgl**2.)+

     &  (389*Mt**8.)/2304.+

     &  (11*Mgl**4.*Mt**8.)/(576.*Mst1**4.)+

     &  (13*Mgl**2.*Mt**8.)/(96.*Mst1**2.)+

     &  (13*Mst1**2.*Mt**8.)/(768.*Mgl**2.)-

     &  Mt**10./(256.*Mgl**2.)-

     &  (Mgl**2.*Mt**10.)/(192.*Mst1**4.)-

     &  (13*Mt**10.)/(256.*Mst1**2.)-

     &  Mt**12./(1152.*Mst1**4.))*d123(Mt,Mgl,Mst1)**2.*

     &  ln(mu,Mgl)**2.+

     &  ((35*Mgl**12.)/256.+Mgl**16./(192.*Mst1**4.)-

     &  (25*Mgl**14.)/(576.*Mst1**2.)-

     &  (191*Mgl**10.*Mst1**2.)/2304.-

     &  (575*Mgl**8.*Mst1**4.)/2304.+

     &  (935*Mgl**6.*Mst1**6.)/2304.-

     &  (137*Mgl**4.*Mst1**8.)/768.-

     &  (Mgl**2.*Mst1**10.)/256.+(19*Mst1**12.)/2304.+

     &  (5*Mst1**14.)/(2304.*Mgl**2.)-

     &  (101*Mgl**10.*Mt**2.)/2304.-

     &  (Mgl**14.*Mt**2.)/(36.*Mst1**4.)+

     &  (53*Mgl**12.*Mt**2.)/(576.*Mst1**2.)-

     &  (85*Mgl**8.*Mst1**2.*Mt**2.)/384.+

     &  (299*Mgl**6.*Mst1**4.*Mt**2.)/2304.+

     &  (7*Mgl**4.*Mst1**6.*Mt**2.)/96.+

     &  (59*Mgl**2.*Mst1**8.*Mt**2.)/768.-

     &  (79*Mst1**10.*Mt**2.)/1152.-

     &  (23*Mst1**12.*Mt**2.)/(2304.*Mgl**2.)-

     &  (367*Mgl**8.*Mt**4.)/2304.+

     &  (13*Mgl**12.*Mt**4.)/(288.*Mst1**4.)+

     &  (25*Mgl**10.*Mt**4.)/(576.*Mst1**2.)+

     &  (23*Mgl**6.*Mst1**2.*Mt**4.)/768.-

     &  (17*Mgl**4.*Mst1**4.*Mt**4.)/384.-

     &  (61*Mgl**2.*Mst1**6.*Mt**4.)/1152.+

     &  (317*Mst1**8.*Mt**4.)/2304.+

     &  (11*Mst1**10.*Mt**4.)/(768.*Mgl**2.)+

     &  (7*Mgl**6.*Mt**6.)/768.+

     &  (Mgl**10.*Mt**6.)/(288.*Mst1**4.)-

     &  (7*Mgl**8.*Mt**6.)/(64.*Mst1**2.)+

     &  (11*Mgl**4.*Mst1**2.*Mt**6.)/192.+

     &  (5*Mgl**2.*Mst1**4.*Mt**6.)/384.+

     &  (Mst1**6.*Mt**6.)/48.+

     &  (5*Mst1**8.*Mt**6.)/(2304.*Mgl**2.)-

     &  (695*Mgl**4.*Mt**8.)/2304.-

     &  (23*Mgl**8.*Mt**8.)/(288.*Mst1**4.)-

     &  (121*Mgl**6.*Mt**8.)/(576.*Mst1**2.)-

     &  (881*Mgl**2.*Mst1**2.*Mt**8.)/2304.-

     &  (839*Mst1**4.*Mt**8.)/2304.-

     &  (65*Mst1**6.*Mt**8.)/(2304.*Mgl**2.)+

     &  (1241*Mgl**2.*Mt**10.)/2304.+

     &  (Mgl**6.*Mt**10.)/(16.*Mst1**4.)+

     &  (217*Mgl**4.*Mt**10.)/(576.*Mst1**2.)+

     &  (167*Mst1**2.*Mt**10.)/384.+

     &  (25*Mst1**4.*Mt**10.)/(768.*Mgl**2.)-

     &  (421*Mt**12.)/2304.+

     &  (5*Mgl**4.*Mt**12.)/(288.*Mst1**4.)-

     &  (29*Mgl**2.*Mt**12.)/(192.*Mst1**2.)-

     &  (37*Mst1**2.*Mt**12.)/(2304.*Mgl**2.)+

     &  (7*Mt**14.)/(2304.*Mgl**2.)-

     &  (11*Mgl**2.*Mt**14.)/(288.*Mst1**4.)+

     &  Mt**14./(576.*Mst1**2.)+

     &  (7*Mt**16.)/(576.*Mst1**4.))*d123(Mt,Mgl,Mst1)**3.*

     &  ln(mu,Mgl)**2.+

     &  ((-41*Mgl**16.)/384.-Mgl**20./(576.*Mst1**4.)+

     &  (11*Mgl**18.)/(576.*Mst1**2.)+

     &  (145*Mgl**14.*Mst1**2.)/576.-

     &  (Mgl**12.*Mst1**4.)/6.-

     &  (23*Mgl**10.*Mst1**6.)/72.+

     &  (415*Mgl**8.*Mst1**8.)/576.-

     &  (7*Mgl**6.*Mst1**10.)/12.+

     &  (125*Mgl**4.*Mst1**12.)/576.-

     &  (19*Mgl**2.*Mst1**14.)/576.+(5*Mst1**16.)/1152.-

     &  Mst1**18./(576.*Mgl**2.)+

     &  (59*Mgl**14.*Mt**2.)/288.+

     &  (Mgl**18.*Mt**2.)/(72.*Mst1**4.)-

     &  (175*Mgl**16.*Mt**2.)/(2304.*Mst1**2.)-

     &  (167*Mgl**12.*Mst1**2.*Mt**2.)/1152.-

     &  (17*Mgl**10.*Mst1**4.*Mt**2.)/128.-

     &  (19*Mgl**8.*Mst1**6.*Mt**2.)/288.+

     &  (629*Mgl**6.*Mst1**8.*Mt**2.)/1152.-

     &  (493*Mgl**4.*Mst1**10.*Mt**2.)/1152.+

     &  (89*Mgl**2.*Mst1**12.*Mt**2.)/1152.-

     &  (17*Mst1**14.*Mt**2.)/2304.+

     &  (5*Mst1**16.*Mt**2.)/(384.*Mgl**2.)+

     &  (17*Mgl**12.*Mt**4.)/96.-

     &  (5*Mgl**16.*Mt**4.)/(128.*Mst1**4.)+

     &  (11*Mgl**14.*Mt**4.)/(384.*Mst1**2.)-

     &  (335*Mgl**10.*Mst1**2.*Mt**4.)/1152.+

     &  (53*Mgl**8.*Mst1**4.*Mt**4.)/288.-

     &  (197*Mgl**6.*Mst1**6.*Mt**4.)/1152.+

     &  (2*Mgl**4.*Mst1**8.*Mt**4.)/9.-

     &  (5*Mgl**2.*Mst1**10.*Mt**4.)/128.-

     &  (35*Mst1**12.*Mt**4.)/1152.-

     &  (Mst1**14.*Mt**4.)/(24.*Mgl**2.)-

     &  (583*Mgl**10.*Mt**6.)/1152.+

     &  (19*Mgl**14.*Mt**6.)/(576.*Mst1**4.)+

     &  (71*Mgl**12.*Mt**6.)/(288.*Mst1**2.)+

     &  (101*Mgl**8.*Mst1**2.*Mt**6.)/1152.+

     &  (19*Mgl**6.*Mst1**4.*Mt**6.)/144.+

     &  (Mgl**4.*Mst1**6.*Mt**6.)/576.+

     &  (7*Mgl**2.*Mst1**8.*Mt**6.)/384.+

     &  (31*Mst1**10.*Mt**6.)/384.+

     &  (7*Mst1**12.*Mt**6.)/(96.*Mgl**2.)+

     &  (23*Mgl**8.*Mt**8.)/96.+

     &  (31*Mgl**12.*Mt**8.)/(576.*Mst1**4.)-

     &  (403*Mgl**10.*Mt**8.)/(1152.*Mst1**2.)+

     &  (11*Mgl**6.*Mst1**2.*Mt**8.)/192.+

     &  (5*Mgl**4.*Mst1**4.*Mt**8.)/576.+

     &  (29*Mgl**2.*Mst1**6.*Mt**8.)/1152.+

     &  (Mst1**8.*Mt**8.)/96.-

     &  (7*Mst1**10.*Mt**8.)/(96.*Mgl**2.)-

     &  (101*Mgl**6.*Mt**10.)/384.-

     &  (9*Mgl**10.*Mt**10.)/(64.*Mst1**4.)-

     &  (7*Mgl**8.*Mt**10.)/(1152.*Mst1**2.)-

     &  (349*Mgl**4.*Mst1**2.*Mt**10.)/1152.-

     &  (355*Mgl**2.*Mst1**4.*Mt**10.)/1152.-

     &  (127*Mst1**6.*Mt**10.)/576.+

     &  (7*Mst1**8.*Mt**10.)/(192.*Mgl**2.)+

     &  (5*Mgl**4.*Mt**12.)/12.+

     &  (13*Mgl**8.*Mt**12.)/(144.*Mst1**4.)+

     &  (275*Mgl**6.*Mt**12.)/(1152.*Mst1**2.)+

     &  (493*Mgl**2.*Mst1**2.*Mt**12.)/1152.+

     &  (17*Mst1**4.*Mt**12.)/64.-

     &  (133*Mgl**2.*Mt**14.)/1152.+

     &  (25*Mgl**6.*Mt**14.)/(576.*Mst1**4.)-

     &  (Mgl**4.*Mt**14.)/(24.*Mst1**2.)-

     &  (35*Mst1**2.*Mt**14.)/384.-

     &  (Mst1**4.*Mt**14.)/(96.*Mgl**2.)-

     &  (53*Mt**16.)/1152.-

     &  (3*Mgl**4.*Mt**16.)/(32.*Mst1**4.)-

     &  (119*Mgl**2.*Mt**16.)/(1152.*Mst1**2.)+

     &  (Mst1**2.*Mt**16.)/(192.*Mgl**2.)-

     &  Mt**18./(1152.*Mgl**2.)+

     &  (29*Mgl**2.*Mt**18.)/(576.*Mst1**4.)+

     &  (101*Mt**18.)/(2304.*Mst1**2.)-

     &  (11*Mt**20.)/(1152.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.*ln(mu,Mgl)**2.+

     &  ((-41*Mgl**4.)/2304.+Mgl**8./(576.*Mst2**4.)+

     &  Mgl**6./(288.*Mst2**2.)+

     &  (167*Mgl**2.*Mst2**2.)/2304.-

     &  (85*Mst2**4.)/2304.-

     &  (5*Mst2**6.)/(2304.*Mgl**2.)+

     &  (25*Mgl**2.*Mt**2.)/256.-

     &  (Mgl**6.*Mt**2.)/(288.*Mst2**4.)-

     &  (11*Mgl**4.*Mt**2.)/(1152.*Mst2**2.)+

     &  (43*Mst2**2.*Mt**2.)/576.+

     &  (5*Mst2**4.*Mt**2.)/(768.*Mgl**2.)-

     &  (121*Mt**4.)/2304.-

     &  (Mgl**2.*Mt**4.)/(96.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**4.)/(768.*Mgl**2.)+

     &  (5*Mt**6.)/(2304.*Mgl**2.)+

     &  (Mgl**2.*Mt**6.)/(288.*Mst2**4.)+

     &  (19*Mt**6.)/(1152.*Mst2**2.)-

     &  Mt**8./(576.*Mst2**4.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mgl)**2.+

     &  (-Mgl**8./768.-Mgl**12./(192.*Mst2**4.)+

     &  (19*Mgl**10.)/(1152.*Mst2**2.)-

     &  (241*Mgl**6.*Mst2**2.)/2304.+

     &  (155*Mgl**4.*Mst2**4.)/1152.-

     &  (Mgl**2.*Mst2**6.)/24.+Mst2**8./2304.+

     &  Mst2**10./(768.*Mgl**2.)-

     &  (53*Mgl**6.*Mt**2.)/768.+

     &  (5*Mgl**10.*Mt**2.)/(288.*Mst2**4.)+

     &  (17*Mgl**8.*Mt**2.)/(768.*Mst2**2.)+

     &  (11*Mgl**4.*Mst2**2.*Mt**2.)/96.+

     &  (Mgl**2.*Mst2**4.*Mt**2.)/96.-

     &  (23*Mst2**6.*Mt**2.)/2304.-

     &  (7*Mst2**8.*Mt**2.)/(768.*Mgl**2.)+

     &  (47*Mgl**4.*Mt**4.)/1152.-

     &  (5*Mgl**8.*Mt**4.)/(384.*Mst2**4.)-

     &  (25*Mgl**6.*Mt**4.)/(384.*Mst2**2.)+

     &  (23*Mgl**2.*Mst2**2.*Mt**4.)/288.+

     &  (Mst2**4.*Mt**4.)/12.+

     &  (3*Mst2**6.*Mt**4.)/(128.*Mgl**2.)-

     &  (103*Mgl**2.*Mt**6.)/576.-

     &  (7*Mgl**6.*Mt**6.)/(576.*Mst2**4.)-

     &  (67*Mgl**4.*Mt**6.)/(1152.*Mst2**2.)-

     &  (55*Mst2**2.*Mt**6.)/288.-

     &  (11*Mst2**4.*Mt**6.)/(384.*Mgl**2.)+

     &  (389*Mt**8.)/2304.+

     &  (11*Mgl**4.*Mt**8.)/(576.*Mst2**4.)+

     &  (13*Mgl**2.*Mt**8.)/(96.*Mst2**2.)+

     &  (13*Mst2**2.*Mt**8.)/(768.*Mgl**2.)-

     &  Mt**10./(256.*Mgl**2.)-

     &  (Mgl**2.*Mt**10.)/(192.*Mst2**4.)-

     &  (13*Mt**10.)/(256.*Mst2**2.)-

     &  Mt**12./(1152.*Mst2**4.))*d123(Mt,Mgl,Mst2)**2.*

     &  ln(mu,Mgl)**2.+

     &  ((35*Mgl**12.)/256.+Mgl**16./(192.*Mst2**4.)-

     &  (25*Mgl**14.)/(576.*Mst2**2.)-

     &  (191*Mgl**10.*Mst2**2.)/2304.-

     &  (575*Mgl**8.*Mst2**4.)/2304.+

     &  (935*Mgl**6.*Mst2**6.)/2304.-

     &  (137*Mgl**4.*Mst2**8.)/768.-

     &  (Mgl**2.*Mst2**10.)/256.+(19*Mst2**12.)/2304.+

     &  (5*Mst2**14.)/(2304.*Mgl**2.)-

     &  (101*Mgl**10.*Mt**2.)/2304.-

     &  (Mgl**14.*Mt**2.)/(36.*Mst2**4.)+

     &  (53*Mgl**12.*Mt**2.)/(576.*Mst2**2.)-

     &  (85*Mgl**8.*Mst2**2.*Mt**2.)/384.+

     &  (299*Mgl**6.*Mst2**4.*Mt**2.)/2304.+

     &  (7*Mgl**4.*Mst2**6.*Mt**2.)/96.+

     &  (59*Mgl**2.*Mst2**8.*Mt**2.)/768.-

     &  (79*Mst2**10.*Mt**2.)/1152.-

     &  (23*Mst2**12.*Mt**2.)/(2304.*Mgl**2.)-

     &  (367*Mgl**8.*Mt**4.)/2304.+

     &  (13*Mgl**12.*Mt**4.)/(288.*Mst2**4.)+

     &  (25*Mgl**10.*Mt**4.)/(576.*Mst2**2.)+

     &  (23*Mgl**6.*Mst2**2.*Mt**4.)/768.-

     &  (17*Mgl**4.*Mst2**4.*Mt**4.)/384.-

     &  (61*Mgl**2.*Mst2**6.*Mt**4.)/1152.+

     &  (317*Mst2**8.*Mt**4.)/2304.+

     &  (11*Mst2**10.*Mt**4.)/(768.*Mgl**2.)+

     &  (7*Mgl**6.*Mt**6.)/768.+

     &  (Mgl**10.*Mt**6.)/(288.*Mst2**4.)-

     &  (7*Mgl**8.*Mt**6.)/(64.*Mst2**2.)+

     &  (11*Mgl**4.*Mst2**2.*Mt**6.)/192.+

     &  (5*Mgl**2.*Mst2**4.*Mt**6.)/384.+

     &  (Mst2**6.*Mt**6.)/48.+

     &  (5*Mst2**8.*Mt**6.)/(2304.*Mgl**2.)-

     &  (695*Mgl**4.*Mt**8.)/2304.-

     &  (23*Mgl**8.*Mt**8.)/(288.*Mst2**4.)-

     &  (121*Mgl**6.*Mt**8.)/(576.*Mst2**2.)-

     &  (881*Mgl**2.*Mst2**2.*Mt**8.)/2304.-

     &  (839*Mst2**4.*Mt**8.)/2304.-

     &  (65*Mst2**6.*Mt**8.)/(2304.*Mgl**2.)+

     &  (1241*Mgl**2.*Mt**10.)/2304.+

     &  (Mgl**6.*Mt**10.)/(16.*Mst2**4.)+

     &  (217*Mgl**4.*Mt**10.)/(576.*Mst2**2.)+

     &  (167*Mst2**2.*Mt**10.)/384.+

     &  (25*Mst2**4.*Mt**10.)/(768.*Mgl**2.)-

     &  (421*Mt**12.)/2304.+

     &  (5*Mgl**4.*Mt**12.)/(288.*Mst2**4.)-

     &  (29*Mgl**2.*Mt**12.)/(192.*Mst2**2.)-

     &  (37*Mst2**2.*Mt**12.)/(2304.*Mgl**2.)+

     &  (7*Mt**14.)/(2304.*Mgl**2.)-

     &  (11*Mgl**2.*Mt**14.)/(288.*Mst2**4.)+

     &  Mt**14./(576.*Mst2**2.)+

     &  (7*Mt**16.)/(576.*Mst2**4.))*d123(Mt,Mgl,Mst2)**3.*

     &  ln(mu,Mgl)**2.+

     &  ((-41*Mgl**16.)/384.-Mgl**20./(576.*Mst2**4.)+

     &  (11*Mgl**18.)/(576.*Mst2**2.)+

     &  (145*Mgl**14.*Mst2**2.)/576.-

     &  (Mgl**12.*Mst2**4.)/6.-

     &  (23*Mgl**10.*Mst2**6.)/72.+

     &  (415*Mgl**8.*Mst2**8.)/576.-

     &  (7*Mgl**6.*Mst2**10.)/12.+

     &  (125*Mgl**4.*Mst2**12.)/576.-

     &  (19*Mgl**2.*Mst2**14.)/576.+(5*Mst2**16.)/1152.-

     &  Mst2**18./(576.*Mgl**2.)+

     &  (59*Mgl**14.*Mt**2.)/288.+

     &  (Mgl**18.*Mt**2.)/(72.*Mst2**4.)-

     &  (175*Mgl**16.*Mt**2.)/(2304.*Mst2**2.)-

     &  (167*Mgl**12.*Mst2**2.*Mt**2.)/1152.-

     &  (17*Mgl**10.*Mst2**4.*Mt**2.)/128.-

     &  (19*Mgl**8.*Mst2**6.*Mt**2.)/288.+

     &  (629*Mgl**6.*Mst2**8.*Mt**2.)/1152.-

     &  (493*Mgl**4.*Mst2**10.*Mt**2.)/1152.+

     &  (89*Mgl**2.*Mst2**12.*Mt**2.)/1152.-

     &  (17*Mst2**14.*Mt**2.)/2304.+

     &  (5*Mst2**16.*Mt**2.)/(384.*Mgl**2.)+

     &  (17*Mgl**12.*Mt**4.)/96.-

     &  (5*Mgl**16.*Mt**4.)/(128.*Mst2**4.)+

     &  (11*Mgl**14.*Mt**4.)/(384.*Mst2**2.)-

     &  (335*Mgl**10.*Mst2**2.*Mt**4.)/1152.+

     &  (53*Mgl**8.*Mst2**4.*Mt**4.)/288.-

     &  (197*Mgl**6.*Mst2**6.*Mt**4.)/1152.+

     &  (2*Mgl**4.*Mst2**8.*Mt**4.)/9.-

     &  (5*Mgl**2.*Mst2**10.*Mt**4.)/128.-

     &  (35*Mst2**12.*Mt**4.)/1152.-

     &  (Mst2**14.*Mt**4.)/(24.*Mgl**2.)-

     &  (583*Mgl**10.*Mt**6.)/1152.+

     &  (19*Mgl**14.*Mt**6.)/(576.*Mst2**4.)+

     &  (71*Mgl**12.*Mt**6.)/(288.*Mst2**2.)+

     &  (101*Mgl**8.*Mst2**2.*Mt**6.)/1152.+

     &  (19*Mgl**6.*Mst2**4.*Mt**6.)/144.+

     &  (Mgl**4.*Mst2**6.*Mt**6.)/576.+

     &  (7*Mgl**2.*Mst2**8.*Mt**6.)/384.+

     &  (31*Mst2**10.*Mt**6.)/384.+

     &  (7*Mst2**12.*Mt**6.)/(96.*Mgl**2.)+

     &  (23*Mgl**8.*Mt**8.)/96.+

     &  (31*Mgl**12.*Mt**8.)/(576.*Mst2**4.)-

     &  (403*Mgl**10.*Mt**8.)/(1152.*Mst2**2.)+

     &  (11*Mgl**6.*Mst2**2.*Mt**8.)/192.+

     &  (5*Mgl**4.*Mst2**4.*Mt**8.)/576.+

     &  (29*Mgl**2.*Mst2**6.*Mt**8.)/1152.+

     &  (Mst2**8.*Mt**8.)/96.-

     &  (7*Mst2**10.*Mt**8.)/(96.*Mgl**2.)-

     &  (101*Mgl**6.*Mt**10.)/384.-

     &  (9*Mgl**10.*Mt**10.)/(64.*Mst2**4.)-

     &  (7*Mgl**8.*Mt**10.)/(1152.*Mst2**2.)-

     &  (349*Mgl**4.*Mst2**2.*Mt**10.)/1152.-

     &  (355*Mgl**2.*Mst2**4.*Mt**10.)/1152.-

     &  (127*Mst2**6.*Mt**10.)/576.+

     &  (7*Mst2**8.*Mt**10.)/(192.*Mgl**2.)+

     &  (5*Mgl**4.*Mt**12.)/12.+

     &  (13*Mgl**8.*Mt**12.)/(144.*Mst2**4.)+

     &  (275*Mgl**6.*Mt**12.)/(1152.*Mst2**2.)+

     &  (493*Mgl**2.*Mst2**2.*Mt**12.)/1152.+

     &  (17*Mst2**4.*Mt**12.)/64.-

     &  (133*Mgl**2.*Mt**14.)/1152.+

     &  (25*Mgl**6.*Mt**14.)/(576.*Mst2**4.)-

     &  (Mgl**4.*Mt**14.)/(24.*Mst2**2.)-

     &  (35*Mst2**2.*Mt**14.)/384.-

     &  (Mst2**4.*Mt**14.)/(96.*Mgl**2.)-

     &  (53*Mt**16.)/1152.-

     &  (3*Mgl**4.*Mt**16.)/(32.*Mst2**4.)-

     &  (119*Mgl**2.*Mt**16.)/(1152.*Mst2**2.)+

     &  (Mst2**2.*Mt**16.)/(192.*Mgl**2.)-

     &  Mt**18./(1152.*Mgl**2.)+

     &  (29*Mgl**2.*Mt**18.)/(576.*Mst2**4.)+

     &  (101*Mt**18.)/(2304.*Mst2**2.)-

     &  (11*Mt**20.)/(1152.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.*ln(mu,Mgl)**2.+

     &  (-(Mgl*Mt**2.)/(144.*Mst1**2.)+

     &  (Mgl*Mt**2.)/(144.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mgl)**2.+

     &  ((-119*Mgl**3.*Mt**2.)/1152.-

     &  (Mgl**7.*Mt**2.)/(144.*Mst1**4.)-

     &  (Mgl**5.*Mt**2.)/(48.*Mst1**2.)-

     &  (43*Mgl*Mst1**2.*Mt**2.)/288.-

     &  (5*Mst1**4.*Mt**2.)/(1152.*Mgl**1.)+

     &  (Mgl*Mt**4.)/36.+

     &  (Mgl**5.*Mt**4.)/(48.*Mst1**4.)+

     &  (23*Mgl**3.*Mt**4.)/(288.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**4.)/(576.*Mgl**1.)-

     &  (5*Mt**6.)/(1152.*Mgl**1.)-

     &  (Mgl**3.*Mt**6.)/(48.*Mst1**4.)-

     &  (17*Mgl*Mt**6.)/(288.*Mst1**2.)+

     &  (Mgl*Mt**8.)/(144.*Mst1**4.))*Xt*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((-5*Mgl**7.*Mt**2.)/576.+

     &  (Mgl**11.*Mt**2.)/(48.*Mst1**4.)-

     &  (5*Mgl**9.*Mt**2.)/(144.*Mst1**2.)+

     &  (25*Mgl**5.*Mst1**2.*Mt**2.)/64.-

     &  (287*Mgl**3.*Mst1**4.*Mt**2.)/576.+

     &  (25*Mgl*Mst1**6.*Mt**2.)/192.+

     &  (Mgl**5.*Mt**4.)/18.-

     &  (13*Mgl**9.*Mt**4.)/(144.*Mst1**4.)-

     &  (113*Mgl**7.*Mt**4.)/(576.*Mst1**2.)-

     &  (395*Mgl**3.*Mst1**2.*Mt**4.)/576.-

     &  (91*Mgl*Mst1**4.*Mt**4.)/288.-

     &  (Mst1**6.*Mt**4.)/(96.*Mgl**1.)+

     &  (287*Mgl**3.*Mt**6.)/576.+

     &  (41*Mgl**7.*Mt**6.)/(288.*Mst1**4.)+

     &  (45*Mgl**5.*Mt**6.)/(64.*Mst1**2.)+

     &  (131*Mgl*Mst1**2.*Mt**6.)/288.+

     &  (Mst1**4.*Mt**6.)/(32.*Mgl**1.)-

     &  (15*Mgl*Mt**8.)/32.-

     &  (3*Mgl**5.*Mt**8.)/(32.*Mst1**4.)-

     &  (385*Mgl**3.*Mt**8.)/(576.*Mst1**2.)-

     &  (Mst1**2.*Mt**8.)/(32.*Mgl**1.)+

     &  Mt**10./(96.*Mgl**1.)+

     &  (5*Mgl**3.*Mt**10.)/(288.*Mst1**4.)+

     &  (113*Mgl*Mt**10.)/(576.*Mst1**2.)+

     &  (Mgl*Mt**12.)/(288.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((-349*Mgl**11.*Mt**2.)/1152.-

     &  (Mgl**15.*Mt**2.)/(48.*Mst1**4.)+

     &  (19*Mgl**13.*Mt**2.)/(144.*Mst1**2.)-

     &  (35*Mgl**9.*Mst1**2.*Mt**2.)/576.+

     &  (893*Mgl**7.*Mst1**4.*Mt**2.)/1152.-

     &  (187*Mgl**5.*Mst1**6.*Mt**2.)/288.+

     &  (109*Mgl**3.*Mst1**8.*Mt**2.)/1152.+

     &  (13*Mgl*Mst1**10.*Mt**2.)/576.+

     &  (11*Mst1**12.*Mt**2.)/(1152.*Mgl**1.)-

     &  (131*Mgl**9.*Mt**4.)/576.+

     &  (19*Mgl**13.*Mt**4.)/(144.*Mst1**4.)-

     &  (2*Mgl**11.*Mt**4.)/(9.*Mst1**2.)+

     &  (523*Mgl**7.*Mst1**2.*Mt**4.)/576.-

     &  (115*Mgl**5.*Mst1**4.*Mt**4.)/288.-

     &  (47*Mgl**3.*Mst1**6.*Mt**4.)/288.-

     &  (91*Mgl*Mst1**8.*Mt**4.)/576.-

     &  (7*Mst1**10.*Mt**4.)/(192.*Mgl**1.)+

     &  (1045*Mgl**7.*Mt**6.)/1152.-

     &  (5*Mgl**11.*Mt**6.)/(16.*Mst1**4.)-

     &  (101*Mgl**9.*Mt**6.)/(144.*Mst1**2.)-

     &  (19*Mgl**5.*Mst1**2.*Mt**6.)/96.+

     &  (15*Mgl**3.*Mst1**4.*Mt**6.)/64.+

     &  (29*Mgl*Mst1**6.*Mt**6.)/288.+

     &  (5*Mst1**8.*Mt**6.)/(128.*Mgl**1.)+

     &  (27*Mgl**5.*Mt**8.)/32.+

     &  (43*Mgl**9.*Mt**8.)/(144.*Mst1**4.)+

     &  (13*Mgl**7.*Mt**8.)/(6.*Mst1**2.)+

     &  (25*Mgl**3.*Mst1**2.*Mt**8.)/32.+

     &  (173*Mgl*Mst1**4.*Mt**8.)/288.+

     &  (5*Mst1**6.*Mt**8.)/(288.*Mgl**1.)-

     &  (2123*Mgl**3.*Mt**10.)/1152.+

     &  (Mgl**7.*Mt**10.)/(48.*Mst1**4.)-

     &  (293*Mgl**5.*Mt**10.)/(144.*Mst1**2.)-

     &  (643*Mgl*Mst1**2.*Mt**10.)/576.-

     &  (25*Mst1**4.*Mt**10.)/(384.*Mgl**1.)+

     &  (365*Mgl*Mt**12.)/576.-

     &  (13*Mgl**5.*Mt**12.)/(48.*Mst1**4.)+

     &  (25*Mgl**3.*Mt**12.)/(36.*Mst1**2.)+

     &  (3*Mst1**2.*Mt**12.)/(64.*Mgl**1.)-

     &  (13*Mt**14.)/(1152.*Mgl**1.)+

     &  (29*Mgl**3.*Mt**14.)/(144.*Mst1**4.)-

     &  (5*Mgl*Mt**14.)/(144.*Mst1**2.)-

     &  (7*Mgl*Mt**16.)/(144.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((103*Mgl**15.*Mt**2.)/288.+

     &  (Mgl**19.*Mt**2.)/(144.*Mst1**4.)-

     &  (5*Mgl**17.*Mt**2.)/(72.*Mst1**2.)-

     &  (187*Mgl**13.*Mst1**2.*Mt**2.)/288.+

     &  (5*Mgl**11.*Mst1**4.*Mt**2.)/288.+

     &  (373*Mgl**9.*Mst1**6.*Mt**2.)/288.-

     &  (457*Mgl**7.*Mst1**8.*Mt**2.)/288.+

     &  (215*Mgl**5.*Mst1**10.*Mt**2.)/288.-

     &  (35*Mgl**3.*Mst1**12.*Mt**2.)/288.+

     &  (Mgl*Mst1**14.*Mt**2.)/96.-

     &  (Mst1**16.*Mt**2.)/(144.*Mgl**1.)-

     &  (499*Mgl**13.*Mt**4.)/576.-

     &  (Mgl**17.*Mt**4.)/(16.*Mst1**4.)+

     &  (179*Mgl**15.*Mt**4.)/(576.*Mst1**2.)+

     &  (209*Mgl**11.*Mst1**2.*Mt**4.)/576.+

     &  (505*Mgl**9.*Mst1**4.*Mt**4.)/576.-

     &  (89*Mgl**7.*Mst1**6.*Mt**4.)/576.-

     &  (433*Mgl**5.*Mst1**8.*Mt**4.)/576.+

     &  (41*Mgl**3.*Mst1**10.*Mt**4.)/192.+

     &  (5*Mgl*Mst1**12.*Mt**4.)/192.+

     &  (13*Mst1**14.*Mt**4.)/(288.*Mgl**1.)-

     &  (7*Mgl**11.*Mt**6.)/144.+

     &  (7*Mgl**15.*Mt**6.)/(32.*Mst1**4.)-

     &  (119*Mgl**13.*Mt**6.)/(576.*Mst1**2.)+

     &  (433*Mgl**9.*Mst1**2.*Mt**6.)/576.-

     &  (31*Mgl**7.*Mst1**4.*Mt**6.)/36.-

     &  (13*Mgl**5.*Mst1**6.*Mt**6.)/576.-

     &  (23*Mgl**3.*Mst1**8.*Mt**6.)/144.-

     &  (125*Mgl*Mst1**10.*Mt**6.)/576.-

     &  (35*Mst1**12.*Mt**6.)/(288.*Mgl**1.)+

     &  (181*Mgl**9.*Mt**8.)/192.-

     &  (101*Mgl**13.*Mt**8.)/(288.*Mst1**4.)-

     &  (217*Mgl**11.*Mt**8.)/(192.*Mst1**2.)-

     &  (23*Mgl**7.*Mst1**2.*Mt**8.)/144.+

     &  (25*Mgl**5.*Mst1**4.*Mt**8.)/144.+

     &  (109*Mgl**3.*Mst1**6.*Mt**8.)/576.+

     &  (53*Mgl*Mst1**8.*Mt**8.)/192.+

     &  (49*Mst1**10.*Mt**8.)/(288.*Mgl**1.)+

     &  (55*Mgl**7.*Mt**10.)/72.+

     &  (13*Mgl**11.*Mt**10.)/(96.*Mst1**4.)+

     &  (1535*Mgl**9.*Mt**10.)/(576.*Mst1**2.)+

     &  (25*Mgl**5.*Mst1**2.*Mt**10.)/36.+

     &  (35*Mgl**3.*Mst1**4.*Mt**10.)/72.+

     &  (113*Mgl*Mst1**6.*Mt**10.)/576.-

     &  (35*Mst1**8.*Mt**10.)/(288.*Mgl**1.)-

     &  (1109*Mgl**5.*Mt**12.)/576.+

     &  (41*Mgl**9.*Mt**12.)/(96.*Mst1**4.)-

     &  (425*Mgl**7.*Mt**12.)/(192.*Mst1**2.)-

     &  (811*Mgl**3.*Mst1**2.*Mt**12.)/576.-

     &  (127*Mgl*Mst1**4.*Mt**12.)/192.+

     &  (7*Mst1**6.*Mt**12.)/(288.*Mgl**1.)+

     &  (35*Mgl**3.*Mt**14.)/48.-

     &  (227*Mgl**7.*Mt**14.)/(288.*Mst1**4.)+

     &  (271*Mgl**5.*Mt**14.)/(576.*Mst1**2.)+

     &  (245*Mgl*Mst1**2.*Mt**14.)/576.+

     &  (7*Mst1**4.*Mt**14.)/(288.*Mgl**1.)+

     &  (25*Mgl*Mt**16.)/576.+

     &  (59*Mgl**5.*Mt**16.)/(96.*Mst1**4.)+

     &  (179*Mgl**3.*Mt**16.)/(576.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**16.)/(288.*Mgl**1.)+

     &  Mt**18./(288.*Mgl**1.)-

     &  (23*Mgl**3.*Mt**18.)/(96.*Mst1**4.)-

     &  (79*Mgl*Mt**18.)/(576.*Mst1**2.)+

     &  (11*Mgl*Mt**20.)/(288.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((119*Mgl**3.*Mt**2.)/1152.+

     &  (Mgl**7.*Mt**2.)/(144.*Mst2**4.)+

     &  (Mgl**5.*Mt**2.)/(48.*Mst2**2.)+

     &  (43*Mgl*Mst2**2.*Mt**2.)/288.+

     &  (5*Mst2**4.*Mt**2.)/(1152.*Mgl**1.)-

     &  (Mgl*Mt**4.)/36.-

     &  (Mgl**5.*Mt**4.)/(48.*Mst2**4.)-

     &  (23*Mgl**3.*Mt**4.)/(288.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**4.)/(576.*Mgl**1.)+

     &  (5*Mt**6.)/(1152.*Mgl**1.)+

     &  (Mgl**3.*Mt**6.)/(48.*Mst2**4.)+

     &  (17*Mgl*Mt**6.)/(288.*Mst2**2.)-

     &  (Mgl*Mt**8.)/(144.*Mst2**4.))*Xt*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((5*Mgl**7.*Mt**2.)/576.-

     &  (Mgl**11.*Mt**2.)/(48.*Mst2**4.)+

     &  (5*Mgl**9.*Mt**2.)/(144.*Mst2**2.)-

     &  (25*Mgl**5.*Mst2**2.*Mt**2.)/64.+

     &  (287*Mgl**3.*Mst2**4.*Mt**2.)/576.-

     &  (25*Mgl*Mst2**6.*Mt**2.)/192.-

     &  (Mgl**5.*Mt**4.)/18.+

     &  (13*Mgl**9.*Mt**4.)/(144.*Mst2**4.)+

     &  (113*Mgl**7.*Mt**4.)/(576.*Mst2**2.)+

     &  (395*Mgl**3.*Mst2**2.*Mt**4.)/576.+

     &  (91*Mgl*Mst2**4.*Mt**4.)/288.+

     &  (Mst2**6.*Mt**4.)/(96.*Mgl**1.)-

     &  (287*Mgl**3.*Mt**6.)/576.-

     &  (41*Mgl**7.*Mt**6.)/(288.*Mst2**4.)-

     &  (45*Mgl**5.*Mt**6.)/(64.*Mst2**2.)-

     &  (131*Mgl*Mst2**2.*Mt**6.)/288.-

     &  (Mst2**4.*Mt**6.)/(32.*Mgl**1.)+

     &  (15*Mgl*Mt**8.)/32.+

     &  (3*Mgl**5.*Mt**8.)/(32.*Mst2**4.)+

     &  (385*Mgl**3.*Mt**8.)/(576.*Mst2**2.)+

     &  (Mst2**2.*Mt**8.)/(32.*Mgl**1.)-

     &  Mt**10./(96.*Mgl**1.)-

     &  (5*Mgl**3.*Mt**10.)/(288.*Mst2**4.)-

     &  (113*Mgl*Mt**10.)/(576.*Mst2**2.)-

     &  (Mgl*Mt**12.)/(288.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((349*Mgl**11.*Mt**2.)/1152.+

     &  (Mgl**15.*Mt**2.)/(48.*Mst2**4.)-

     &  (19*Mgl**13.*Mt**2.)/(144.*Mst2**2.)+

     &  (35*Mgl**9.*Mst2**2.*Mt**2.)/576.-

     &  (893*Mgl**7.*Mst2**4.*Mt**2.)/1152.+

     &  (187*Mgl**5.*Mst2**6.*Mt**2.)/288.-

     &  (109*Mgl**3.*Mst2**8.*Mt**2.)/1152.-

     &  (13*Mgl*Mst2**10.*Mt**2.)/576.-

     &  (11*Mst2**12.*Mt**2.)/(1152.*Mgl**1.)+

     &  (131*Mgl**9.*Mt**4.)/576.-

     &  (19*Mgl**13.*Mt**4.)/(144.*Mst2**4.)+

     &  (2*Mgl**11.*Mt**4.)/(9.*Mst2**2.)-

     &  (523*Mgl**7.*Mst2**2.*Mt**4.)/576.+

     &  (115*Mgl**5.*Mst2**4.*Mt**4.)/288.+

     &  (47*Mgl**3.*Mst2**6.*Mt**4.)/288.+

     &  (91*Mgl*Mst2**8.*Mt**4.)/576.+

     &  (7*Mst2**10.*Mt**4.)/(192.*Mgl**1.)-

     &  (1045*Mgl**7.*Mt**6.)/1152.+

     &  (5*Mgl**11.*Mt**6.)/(16.*Mst2**4.)+

     &  (101*Mgl**9.*Mt**6.)/(144.*Mst2**2.)+

     &  (19*Mgl**5.*Mst2**2.*Mt**6.)/96.-

     &  (15*Mgl**3.*Mst2**4.*Mt**6.)/64.-

     &  (29*Mgl*Mst2**6.*Mt**6.)/288.-

     &  (5*Mst2**8.*Mt**6.)/(128.*Mgl**1.)-

     &  (27*Mgl**5.*Mt**8.)/32.-

     &  (43*Mgl**9.*Mt**8.)/(144.*Mst2**4.)-

     &  (13*Mgl**7.*Mt**8.)/(6.*Mst2**2.)-

     &  (25*Mgl**3.*Mst2**2.*Mt**8.)/32.-

     &  (173*Mgl*Mst2**4.*Mt**8.)/288.-

     &  (5*Mst2**6.*Mt**8.)/(288.*Mgl**1.)+

     &  (2123*Mgl**3.*Mt**10.)/1152.-

     &  (Mgl**7.*Mt**10.)/(48.*Mst2**4.)+

     &  (293*Mgl**5.*Mt**10.)/(144.*Mst2**2.)+

     &  (643*Mgl*Mst2**2.*Mt**10.)/576.+

     &  (25*Mst2**4.*Mt**10.)/(384.*Mgl**1.)-

     &  (365*Mgl*Mt**12.)/576.+

     &  (13*Mgl**5.*Mt**12.)/(48.*Mst2**4.)-

     &  (25*Mgl**3.*Mt**12.)/(36.*Mst2**2.)-

     &  (3*Mst2**2.*Mt**12.)/(64.*Mgl**1.)+

     &  (13*Mt**14.)/(1152.*Mgl**1.)-

     &  (29*Mgl**3.*Mt**14.)/(144.*Mst2**4.)+

     &  (5*Mgl*Mt**14.)/(144.*Mst2**2.)+

     &  (7*Mgl*Mt**16.)/(144.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  ((-103*Mgl**15.*Mt**2.)/288.-

     &  (Mgl**19.*Mt**2.)/(144.*Mst2**4.)+

     &  (5*Mgl**17.*Mt**2.)/(72.*Mst2**2.)+

     &  (187*Mgl**13.*Mst2**2.*Mt**2.)/288.-

     &  (5*Mgl**11.*Mst2**4.*Mt**2.)/288.-

     &  (373*Mgl**9.*Mst2**6.*Mt**2.)/288.+

     &  (457*Mgl**7.*Mst2**8.*Mt**2.)/288.-

     &  (215*Mgl**5.*Mst2**10.*Mt**2.)/288.+

     &  (35*Mgl**3.*Mst2**12.*Mt**2.)/288.-

     &  (Mgl*Mst2**14.*Mt**2.)/96.+

     &  (Mst2**16.*Mt**2.)/(144.*Mgl**1.)+

     &  (499*Mgl**13.*Mt**4.)/576.+

     &  (Mgl**17.*Mt**4.)/(16.*Mst2**4.)-

     &  (179*Mgl**15.*Mt**4.)/(576.*Mst2**2.)-

     &  (209*Mgl**11.*Mst2**2.*Mt**4.)/576.-

     &  (505*Mgl**9.*Mst2**4.*Mt**4.)/576.+

     &  (89*Mgl**7.*Mst2**6.*Mt**4.)/576.+

     &  (433*Mgl**5.*Mst2**8.*Mt**4.)/576.-

     &  (41*Mgl**3.*Mst2**10.*Mt**4.)/192.-

     &  (5*Mgl*Mst2**12.*Mt**4.)/192.-

     &  (13*Mst2**14.*Mt**4.)/(288.*Mgl**1.)+

     &  (7*Mgl**11.*Mt**6.)/144.-

     &  (7*Mgl**15.*Mt**6.)/(32.*Mst2**4.)+

     &  (119*Mgl**13.*Mt**6.)/(576.*Mst2**2.)-

     &  (433*Mgl**9.*Mst2**2.*Mt**6.)/576.+

     &  (31*Mgl**7.*Mst2**4.*Mt**6.)/36.+

     &  (13*Mgl**5.*Mst2**6.*Mt**6.)/576.+

     &  (23*Mgl**3.*Mst2**8.*Mt**6.)/144.+

     &  (125*Mgl*Mst2**10.*Mt**6.)/576.+

     &  (35*Mst2**12.*Mt**6.)/(288.*Mgl**1.)-

     &  (181*Mgl**9.*Mt**8.)/192.+

     &  (101*Mgl**13.*Mt**8.)/(288.*Mst2**4.)+

     &  (217*Mgl**11.*Mt**8.)/(192.*Mst2**2.)+

     &  (23*Mgl**7.*Mst2**2.*Mt**8.)/144.-

     &  (25*Mgl**5.*Mst2**4.*Mt**8.)/144.-

     &  (109*Mgl**3.*Mst2**6.*Mt**8.)/576.-

     &  (53*Mgl*Mst2**8.*Mt**8.)/192.-

     &  (49*Mst2**10.*Mt**8.)/(288.*Mgl**1.)-

     &  (55*Mgl**7.*Mt**10.)/72.-

     &  (13*Mgl**11.*Mt**10.)/(96.*Mst2**4.)-

     &  (1535*Mgl**9.*Mt**10.)/(576.*Mst2**2.)-

     &  (25*Mgl**5.*Mst2**2.*Mt**10.)/36.-

     &  (35*Mgl**3.*Mst2**4.*Mt**10.)/72.-

     &  (113*Mgl*Mst2**6.*Mt**10.)/576.+

     &  (35*Mst2**8.*Mt**10.)/(288.*Mgl**1.)+

     &  (1109*Mgl**5.*Mt**12.)/576.-

     &  (41*Mgl**9.*Mt**12.)/(96.*Mst2**4.)+

     &  (425*Mgl**7.*Mt**12.)/(192.*Mst2**2.)+

     &  (811*Mgl**3.*Mst2**2.*Mt**12.)/576.+

     &  (127*Mgl*Mst2**4.*Mt**12.)/192.-

     &  (7*Mst2**6.*Mt**12.)/(288.*Mgl**1.)-

     &  (35*Mgl**3.*Mt**14.)/48.+

     &  (227*Mgl**7.*Mt**14.)/(288.*Mst2**4.)-

     &  (271*Mgl**5.*Mt**14.)/(576.*Mst2**2.)-

     &  (245*Mgl*Mst2**2.*Mt**14.)/576.-

     &  (7*Mst2**4.*Mt**14.)/(288.*Mgl**1.)-

     &  (25*Mgl*Mt**16.)/576.-

     &  (59*Mgl**5.*Mt**16.)/(96.*Mst2**4.)-

     &  (179*Mgl**3.*Mt**16.)/(576.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**16.)/(288.*Mgl**1.)-

     &  Mt**18./(288.*Mgl**1.)+

     &  (23*Mgl**3.*Mt**18.)/(96.*Mst2**4.)+

     &  (79*Mgl*Mt**18.)/(576.*Mst2**2.)-

     &  (11*Mgl*Mt**20.)/(288.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)**2.+

     &  (0.031684027777777776+Mgl**2./(384.*Mst1**2.)-

     &  (29*Mst1**2.)/(1152.*Mgl**2.)+

     &  (5*Mst1**4.)/(768.*Mgl**4.)-

     &  Mgl**2./(576.*Mt**2.)+Mst1**2./(144.*Mt**2.)-

     &  Mst1**4./(192.*Mgl**2.*Mt**2.)-

     &  (5*Mt**2.)/(288.*Mgl**2.)+

     &  Mt**2./(576.*Mst1**2.)-

     &  (17*Mst1**2.*Mt**2.)/(1152.*Mgl**4.)+

     &  (23*Mt**4.)/(2304.*Mgl**4.)-

     &  Mt**4./(384.*Mgl**2.*Mst1**2.)-

     &  Mt**6./(576.*Mgl**4.*Mst1**2.))*ln(mu,Mst1)+

     &  ((-83*Mgl**4.)/2304.-Mgl**6./(384.*Mst1**2.)+

     &  (197*Mgl**2.*Mst1**2.)/1728.-

     &  (245*Mst1**4.)/3456.-

     &  (41*Mst1**6.)/(3456.*Mgl**2.)-

     &  (5*Mst1**8.)/(768.*Mgl**4.)+

     &  (13*Mgl**6.)/(576.*Mt**2.)-

     &  Mgl**8./(192.*Mst1**2.*Mt**2.)-

     &  (Mgl**4.*Mst1**2.)/(32.*Mt**2.)+

     &  (Mgl**2.*Mst1**4.)/(96.*Mt**2.)+

     &  (5*Mst1**6.)/(576.*Mt**2.)-

     &  Mst1**8./(192.*Mgl**2.*Mt**2.)+

     &  (197*Mgl**2.*Mt**2.)/3456.+

     &  (Mgl**4.*Mt**2.)/(64.*Mst1**2.)+

     &  (155*Mst1**2.*Mt**2.)/3456.+

     &  (7*Mst1**6.*Mt**2.)/(192.*Mgl**4.)+

     &  (5*Mt**4.)/1152.+

     &  (Mgl**2.*Mt**4.)/(576.*Mst1**2.)+

     &  (67*Mst1**2.*Mt**4.)/(1152.*Mgl**2.)-

     &  (83*Mst1**4.*Mt**4.)/(1152.*Mgl**4.)-

     &  (145*Mt**6.)/(3456.*Mgl**2.)-

     &  (7*Mt**6.)/(576.*Mst1**2.)+

     &  (Mst1**2.*Mt**6.)/(16.*Mgl**4.)-

     &  (17*Mt**8.)/(768.*Mgl**4.)+

     &  Mt**8./(1152.*Mgl**2.*Mst1**2.)+

     &  Mt**10./(576.*Mgl**4.*Mst1**2.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mst1)+

     &  (Mgl**8./384.-(5*Mgl**10.)/(576.*Mst1**2.)-

     &  (1745*Mgl**6.*Mst1**2.)/6912.+

     &  (3169*Mgl**4.*Mst1**4.)/6912.-

     &  (115*Mgl**2.*Mst1**6.)/384.+

     &  (113*Mst1**8.)/1728.+

     &  (227*Mst1**10.)/(6912.*Mgl**2.)+

     &  Mst1**12./(768.*Mgl**4.)-

     &  (11*Mgl**10.)/(288.*Mt**2.)+

     &  Mgl**12./(192.*Mst1**2.*Mt**2.)+

     &  (55*Mgl**8.*Mst1**2.)/(576.*Mt**2.)-

     &  (25*Mgl**6.*Mst1**4.)/(288.*Mt**2.)-

     &  (5*Mgl**4.*Mst1**6.)/(192.*Mt**2.)+

     &  (31*Mgl**2.*Mst1**8.)/(288.*Mt**2.)-

     &  (43*Mst1**10.)/(576.*Mt**2.)+

     &  (5*Mst1**12.)/(288.*Mgl**2.*Mt**2.)+

     &  (611*Mgl**6.*Mt**2.)/6912.-

     &  (5*Mgl**8.*Mt**2.)/(576.*Mst1**2.)+

     &  (491*Mgl**4.*Mst1**2.*Mt**2.)/1152.+

     &  (553*Mgl**2.*Mst1**4.*Mt**2.)/3456.-

     &  (253*Mst1**6.*Mt**2.)/864.-

     &  (773*Mst1**8.*Mt**2.)/(6912.*Mgl**2.)+

     &  (Mst1**10.*Mt**2.)/(384.*Mgl**4.)+

     &  (17*Mgl**4.*Mt**4.)/768.+

     &  (7*Mgl**6.*Mt**4.)/(576.*Mst1**2.)-

     &  (1073*Mgl**2.*Mst1**2.*Mt**4.)/3456.+

     &  (Mst1**4.*Mt**4.)/432.-

     &  (613*Mst1**6.*Mt**4.)/(3456.*Mgl**2.)-

     &  (11*Mst1**8.*Mt**4.)/(2304.*Mgl**4.)+

     &  (19*Mgl**2.*Mt**6.)/3456.+

     &  (Mgl**4.*Mt**6.)/(64.*Mst1**2.)+

     &  (427*Mst1**2.*Mt**6.)/864.+

     &  (1979*Mst1**4.*Mt**6.)/(3456.*Mgl**2.)-

     &  (19*Mst1**6.*Mt**6.)/(576.*Mgl**4.)-

     &  (35*Mt**8.)/192.-

     &  (7*Mgl**2.*Mt**8.)/(576.*Mst1**2.)-

     &  (2941*Mst1**2.*Mt**8.)/(6912.*Mgl**2.)+

     &  (21*Mst1**4.*Mt**8.)/(256.*Mgl**4.)+

     &  (575*Mt**10.)/(6912.*Mgl**2.)-

     &  (7*Mt**10.)/(576.*Mst1**2.)-

     &  (77*Mst1**2.*Mt**10.)/(1152.*Mgl**4.)+

     &  (43*Mt**12.)/(2304.*Mgl**4.)+

     &  (5*Mt**12.)/(576.*Mgl**2.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mst1)+

     &  ((125*Mgl**12.)/2304.-Mgl**14./(576.*Mst1**2.)+

     &  (173*Mgl**10.*Mst1**2.)/432.-

     &  (5225*Mgl**8.*Mst1**4.)/3456.+

     &  (1483*Mgl**6.*Mst1**6.)/864.-

     &  (959*Mgl**4.*Mst1**8.)/1728.-

     &  (47*Mgl**2.*Mst1**10.)/108.+

     &  (1553*Mst1**12.)/3456.-

     &  (61*Mst1**14.)/(576.*Mgl**2.)-

     &  (25*Mst1**16.)/(2304.*Mgl**4.)+

     &  Mgl**14./(144.*Mt**2.)-

     &  (Mgl**12.*Mst1**2.)/(24.*Mt**2.)+

     &  (7*Mgl**10.*Mst1**4.)/(72.*Mt**2.)-

     &  (7*Mgl**8.*Mst1**6.)/(72.*Mt**2.)+

     &  (7*Mgl**4.*Mst1**10.)/(72.*Mt**2.)-

     &  (7*Mgl**2.*Mst1**12.)/(72.*Mt**2.)+

     &  Mst1**14./(24.*Mt**2.)-

     &  Mst1**16./(144.*Mgl**2.*Mt**2.)-

     &  (377*Mgl**10.*Mt**2.)/1152.+

     &  (Mgl**12.*Mt**2.)/(192.*Mst1**2.)-

     &  (1805*Mgl**8.*Mst1**2.*Mt**2.)/3456.+

     &  (2371*Mgl**6.*Mst1**4.*Mt**2.)/1728.-

     &  (439*Mgl**4.*Mst1**6.*Mt**2.)/1728.+

     &  (761*Mgl**2.*Mst1**8.*Mt**2.)/3456.-

     &  (3857*Mst1**10.*Mt**2.)/3456.+

     &  (515*Mst1**12.*Mt**2.)/(864.*Mgl**2.)+

     &  (5*Mst1**14.*Mt**2.)/(192.*Mgl**4.)+

     &  (1543*Mgl**8.*Mt**4.)/3456.+

     &  (5*Mgl**10.*Mt**4.)/(576.*Mst1**2.)+

     &  (53*Mgl**6.*Mst1**2.*Mt**4.)/3456.+

     &  (1507*Mgl**4.*Mst1**4.*Mt**4.)/1728.+

     &  (23*Mgl**2.*Mst1**6.*Mt**4.)/96.+

     &  (2575*Mst1**8.*Mt**4.)/3456.-

     &  (1093*Mst1**10.*Mt**4.)/(1152.*Mgl**2.)+

     &  (5*Mst1**12.*Mt**4.)/(96.*Mgl**4.)+

     &  (131*Mgl**6.*Mt**6.)/3456.-

     &  (29*Mgl**8.*Mt**6.)/(576.*Mst1**2.)+

     &  (61*Mgl**4.*Mst1**2.*Mt**6.)/864.-

     &  (205*Mgl**2.*Mst1**4.*Mt**6.)/288.-

     &  (43*Mst1**6.*Mt**6.)/48.+

     &  (625*Mst1**8.*Mt**6.)/(3456.*Mgl**2.)-

     &  (145*Mst1**10.*Mt**6.)/(576.*Mgl**4.)-

     &  (43*Mgl**4.*Mt**8.)/96.+

     &  (35*Mgl**6.*Mt**8.)/(576.*Mst1**2.)+

     &  (343*Mgl**2.*Mst1**2.*Mt**8.)/576.+

     &  (5483*Mst1**4.*Mt**8.)/3456.+

     &  (401*Mst1**6.*Mt**8.)/(432.*Mgl**2.)+

     &  (125*Mst1**8.*Mt**8.)/(384.*Mgl**4.)+

     &  (851*Mgl**2.*Mt**10.)/3456.+

     &  (Mgl**4.*Mt**10.)/(576.*Mst1**2.)-

     &  (2869*Mst1**2.*Mt**10.)/3456.-

     &  (515*Mst1**4.*Mt**10.)/(576.*Mgl**2.)-

     &  (25*Mst1**6.*Mt**10.)/(192.*Mgl**4.)-

     &  (83*Mt**12.)/3456.-

     &  (11*Mgl**2.*Mt**12.)/(192.*Mst1**2.)+

     &  (809*Mst1**2.*Mt**12.)/(3456.*Mgl**2.)-

     &  (5*Mst1**4.*Mt**12.)/(72.*Mgl**4.)+

     &  (31*Mt**14.)/(1152.*Mgl**2.)+

     &  (25*Mt**14.)/(576.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**14.)/(64.*Mgl**4.)-

     &  (5*Mt**16.)/(256.*Mgl**4.)-

     &  Mt**16./(96.*Mgl**2.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**3.*ln(mu,Mst1)+

     &  ((-7*Mgl**16.)/768.-(2315*Mgl**14.*Mst1**2.)/6912.+

     &  (2015*Mgl**12.*Mst1**4.)/1152.-

     &  (3011*Mgl**10.*Mst1**6.)/864.+

     &  (11357*Mgl**8.*Mst1**8.)/3456.-

     &  (1105*Mgl**6.*Mst1**10.)/1152.-

     &  (1753*Mgl**4.*Mst1**12.)/1728.+

     &  (127*Mgl**2.*Mst1**14.)/108.-

     &  (1073*Mst1**16.)/2304.+

     &  (329*Mst1**18.)/(6912.*Mgl**2.)+

     &  (11*Mst1**20.)/(1152.*Mgl**4.)+

     &  (73*Mgl**14.*Mt**2.)/768.+

     &  (25*Mgl**12.*Mst1**2.*Mt**2.)/27.-

     &  (637*Mgl**10.*Mst1**4.*Mt**2.)/192.+

     &  (2245*Mgl**8.*Mst1**6.*Mt**2.)/576.-

     &  (7849*Mgl**6.*Mst1**8.*Mt**2.)/3456.+

     &  (1103*Mgl**4.*Mst1**10.*Mt**2.)/576.-

     &  (521*Mgl**2.*Mst1**12.*Mt**2.)/192.+

     &  (3265*Mst1**14.*Mt**2.)/1728.-

     &  (845*Mst1**16.*Mt**2.)/(2304.*Mgl**2.)-

     &  (31*Mst1**18.*Mt**2.)/(576.*Mgl**4.)-

     &  (361*Mgl**12.*Mt**4.)/1152.-

     &  (181*Mgl**10.*Mst1**2.*Mt**4.)/864.+

     &  (575*Mgl**8.*Mst1**4.*Mt**4.)/576.+

     &  (1415*Mgl**6.*Mst1**6.*Mt**4.)/1728.-

     &  (781*Mgl**4.*Mst1**8.*Mt**4.)/576.+

     &  (83*Mgl**2.*Mst1**10.*Mt**4.)/48.-

     &  (4895*Mst1**12.*Mt**4.)/1728.+

     &  (1847*Mst1**14.*Mt**4.)/(1728.*Mgl**2.)+

     &  (37*Mst1**16.*Mt**4.)/(384.*Mgl**4.)+

     &  (121*Mgl**10.*Mt**6.)/288.-

     &  (1043*Mgl**8.*Mst1**2.*Mt**6.)/576.+

     &  (101*Mgl**6.*Mst1**4.*Mt**6.)/288.+

     &  (695*Mgl**4.*Mst1**6.*Mt**6.)/864.+

     &  (13*Mgl**2.*Mst1**8.*Mt**6.)/288.+

     &  (1261*Mst1**10.*Mt**6.)/576.-

     &  (1217*Mst1**12.*Mt**6.)/(864.*Mgl**2.)+

     &  (Mst1**14.*Mt**6.)/(48.*Mgl**4.)-

     &  (121*Mgl**8.*Mt**8.)/1152.+

     &  (2747*Mgl**6.*Mst1**2.*Mt**8.)/1152.+

     &  (15*Mgl**4.*Mst1**4.*Mt**8.)/64.-

     &  (41*Mgl**2.*Mst1**6.*Mt**8.)/48.-

     &  (2147*Mst1**8.*Mt**8.)/1152.+

     &  (629*Mst1**10.*Mt**8.)/(1152.*Mgl**2.)-

     &  (21*Mst1**12.*Mt**8.)/(64.*Mgl**4.)-

     &  (373*Mgl**6.*Mt**10.)/1152.-

     &  (545*Mgl**4.*Mst1**2.*Mt**10.)/576.+

     &  (581*Mgl**2.*Mst1**4.*Mt**10.)/576.+

     &  (3743*Mst1**6.*Mt**10.)/1728.+

     &  (2293*Mst1**8.*Mt**10.)/(3456.*Mgl**2.)+

     &  (49*Mst1**10.*Mt**10.)/(96.*Mgl**4.)+

     &  (209*Mgl**4.*Mt**12.)/576.-

     &  (25*Mgl**2.*Mst1**2.*Mt**12.)/108.-

     &  (781*Mst1**4.*Mt**12.)/576.-

     &  (1405*Mst1**6.*Mt**12.)/(1728.*Mgl**2.)-

     &  (21*Mst1**8.*Mt**12.)/(64.*Mgl**4.)-

     &  (23*Mgl**2.*Mt**14.)/144.+

     &  (377*Mst1**2.*Mt**14.)/1728.+

     &  (17*Mst1**4.*Mt**14.)/(72.*Mgl**2.)+

     &  (Mst1**6.*Mt**14.)/(48.*Mgl**4.)+

     &  (127*Mt**16.)/2304.+

     &  (401*Mst1**2.*Mt**16.)/(6912.*Mgl**2.)+

     &  (37*Mst1**4.*Mt**16.)/(384.*Mgl**4.)-

     &  (73*Mt**18.)/(2304.*Mgl**2.)-

     &  (31*Mst1**2.*Mt**18.)/(576.*Mgl**4.)+

     &  (11*Mt**20.)/(1152.*Mgl**4.))*d123(Mt,Mgl,Mst1)**4.*

     &  ln(mu,Mst1)+

     &  ((5*Mgl)/288.-Mst1**2./(96.*Mgl**1.)-

     &  (Mgl*Mt**2.)/(96.*Mst1**2.)+

     &  (Mst1**2.*Mt**2.)/(48.*Mgl**3.)-

     &  Mt**4./(36.*Mgl**3.)+

     &  Mt**4./(288.*Mgl**1.*Mst1**2.)+

     &  Mt**6./(144.*Mgl**3.*Mst1**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mst1)+

     &  ((-7*Mgl**5.)/144.+Mgl**7./(48.*Mst1**2.)+

     &  (5*Mgl**3.*Mst1**2.)/144.-(Mgl*Mst1**4.)/144.+

     &  (167*Mgl**3.*Mt**2.)/1152.-

     &  (Mgl**5.*Mt**2.)/(96.*Mst1**2.)-

     &  (1997*Mgl*Mst1**2.*Mt**2.)/3456.-

     &  (917*Mst1**4.*Mt**2.)/(3456.*Mgl**1.)-

     &  (23*Mst1**6.*Mt**2.)/(3456.*Mgl**3.)-

     &  (1187*Mgl*Mt**4.)/3456.-

     &  (5*Mgl**3.*Mt**4.)/(96.*Mst1**2.)+

     &  (59*Mst1**2.*Mt**4.)/(1728.*Mgl**1.)+

     &  (71*Mst1**4.*Mt**4.)/(1152.*Mgl**3.)+

     &  (751*Mt**6.)/(3456.*Mgl**1.)+

     &  (13*Mgl*Mt**6.)/(288.*Mst1**2.)-

     &  (127*Mst1**2.*Mt**6.)/(1152.*Mgl**3.)+

     &  (215*Mt**8.)/(3456.*Mgl**3.)+

     &  Mt**8./(288.*Mgl**1.*Mst1**2.)-

     &  Mt**10./(144.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mst1)+

     &  ((29*Mgl**9.)/288.-Mgl**11./(48.*Mst1**2.)-

     &  (5*Mgl**7.*Mst1**2.)/32.+

     &  (5*Mgl**5.*Mst1**4.)/144.+

     &  (5*Mgl**3.*Mst1**6.)/36.-(13*Mgl*Mst1**8.)/96.+

     &  (11*Mst1**10.)/(288.*Mgl**1.)-

     &  (Mgl**7.*Mt**2.)/64.+

     &  (Mgl**9.*Mt**2.)/(18.*Mst1**2.)+

     &  (39*Mgl**5.*Mst1**2.*Mt**2.)/64.-

     &  (277*Mgl**3.*Mst1**4.*Mt**2.)/288.+

     &  (17*Mgl*Mst1**6.*Mt**2.)/288.+

     &  (155*Mst1**8.*Mt**2.)/(576.*Mgl**1.)-

     &  (Mst1**10.*Mt**2.)/(64.*Mgl**3.)-

     &  (269*Mgl**5.*Mt**4.)/1728.-

     &  (Mgl**7.*Mt**4.)/(48.*Mst1**2.)-

     &  (361*Mgl**3.*Mst1**2.*Mt**4.)/432.-

     &  (317*Mgl*Mst1**4.*Mt**4.)/288.-

     &  (49*Mst1**6.*Mt**4.)/(144.*Mgl**1.)+

     &  (23*Mst1**8.*Mt**4.)/(192.*Mgl**3.)-

     &  (455*Mgl**3.*Mt**6.)/864.-

     &  (Mgl**5.*Mt**6.)/(36.*Mst1**2.)-

     &  (751*Mgl*Mst1**2.*Mt**6.)/864.-

     &  (715*Mst1**4.*Mt**6.)/(864.*Mgl**1.)-

     &  (61*Mst1**6.*Mt**6.)/(288.*Mgl**3.)+

     &  (431*Mgl*Mt**8.)/432.-

     &  (5*Mgl**3.*Mt**8.)/(144.*Mst1**2.)+

     &  (1073*Mst1**2.*Mt**8.)/(864.*Mgl**1.)+

     &  (7*Mst1**4.*Mt**8.)/(96.*Mgl**3.)-

     &  (599*Mt**10.)/(1728.*Mgl**1.)+

     &  (Mgl*Mt**10.)/(12.*Mst1**2.)+

     &  (17*Mst1**2.*Mt**10.)/(192.*Mgl**3.)-

     &  (31*Mt**12.)/(576.*Mgl**3.)-

     &  (5*Mt**12.)/(144.*Mgl**1.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mst1)+

     &  (-Mgl**13./36.+(5*Mgl**11.*Mst1**2.)/36.-

     &  (Mgl**9.*Mst1**4.)/4.+(5*Mgl**7.*Mst1**6.)/36.+

     &  (5*Mgl**5.*Mst1**8.)/36.-(Mgl**3.*Mst1**10.)/4.+

     &  (5*Mgl*Mst1**12.)/36.-Mst1**14./(36.*Mgl**1.)-

     &  (199*Mgl**11.*Mt**2.)/1152.+

     &  (Mgl**13.*Mt**2.)/(144.*Mst1**2.)-

     &  (4985*Mgl**9.*Mst1**2.*Mt**2.)/3456.+

     &  (4237*Mgl**7.*Mst1**4.*Mt**2.)/1152.-

     &  (9701*Mgl**5.*Mst1**6.*Mt**2.)/3456.+

     &  (43*Mgl**3.*Mst1**8.*Mt**2.)/1152.+

     &  (1303*Mgl*Mst1**10.*Mt**2.)/1152.-

     &  (1363*Mst1**12.*Mt**2.)/(3456.*Mgl**1.)-

     &  (127*Mst1**14.*Mt**2.)/(3456.*Mgl**3.)+

     &  (529*Mgl**9.*Mt**4.)/384.-

     &  (Mgl**11.*Mt**4.)/(36.*Mst1**2.)+

     &  (4315*Mgl**7.*Mst1**2.*Mt**4.)/1728.-

     &  (14857*Mgl**5.*Mst1**4.*Mt**4.)/3456.-

     &  (61*Mgl**3.*Mst1**6.*Mt**4.)/96.-

     &  (3937*Mgl*Mst1**8.*Mt**4.)/3456.+

     &  (2767*Mst1**10.*Mt**4.)/(1728.*Mgl**1.)+

     &  (49*Mst1**12.*Mt**4.)/(3456.*Mgl**3.)-

     &  (1121*Mgl**7.*Mt**6.)/384.-

     &  (Mgl**9.*Mt**6.)/(144.*Mst1**2.)-

     &  (421*Mgl**5.*Mst1**2.*Mt**6.)/1152.+

     &  (107*Mgl**3.*Mst1**4.*Mt**6.)/192.+

     &  (929*Mgl*Mst1**6.*Mt**6.)/1728.-

     &  (3997*Mst1**8.*Mt**6.)/(3456.*Mgl**1.)+

     &  (157*Mst1**10.*Mt**6.)/(384.*Mgl**3.)+

     &  (8773*Mgl**5.*Mt**8.)/3456.+

     &  (5*Mgl**7.*Mt**8.)/(24.*Mst1**2.)-

     &  (2657*Mgl**3.*Mst1**2.*Mt**8.)/864.-

     &  (6589*Mgl*Mst1**4.*Mt**8.)/1728.-

     &  (1543*Mst1**6.*Mt**8.)/(864.*Mgl**1.)-

     &  (3355*Mst1**8.*Mt**8.)/(3456.*Mgl**3.)-

     &  (2671*Mgl**3.*Mt**10.)/3456.-

     &  (65*Mgl**5.*Mt**10.)/(144.*Mst1**2.)+

     &  (11537*Mgl*Mst1**2.*Mt**10.)/3456.+

     &  (9475*Mst1**4.*Mt**10.)/(3456.*Mgl**1.)+

     &  (2755*Mst1**6.*Mt**10.)/(3456.*Mgl**3.)+

     &  (25*Mgl*Mt**12.)/1152.+

     &  (4*Mgl**3.*Mt**12.)/(9.*Mst1**2.)-

     &  (1561*Mst1**2.*Mt**12.)/(1728.*Mgl**1.)-

     &  (37*Mst1**4.*Mt**12.)/(384.*Mgl**3.)-

     &  (403*Mt**14.)/(3456.*Mgl**1.)-

     &  (31*Mgl*Mt**14.)/(144.*Mst1**2.)-

     &  (649*Mst1**2.*Mt**14.)/(3456.*Mgl**3.)+

     &  (247*Mt**16.)/(3456.*Mgl**3.)+

     &  Mt**16./(24.*Mgl**1.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mst1)+

     &  ((7*Mgl**15.*Mt**2.)/192.+

     &  (1189*Mgl**13.*Mst1**2.*Mt**2.)/864.-

     &  (607*Mgl**11.*Mst1**4.*Mt**2.)/108.+

     &  (599*Mgl**9.*Mst1**6.*Mt**2.)/72.-

     &  (4169*Mgl**7.*Mst1**8.*Mt**2.)/864.-

     &  (427*Mgl**5.*Mst1**10.*Mt**2.)/432.+

     &  (221*Mgl**3.*Mst1**12.*Mt**2.)/72.-

     &  (353*Mgl*Mst1**14.*Mt**2.)/216.+

     &  (395*Mst1**16.*Mt**2.)/(1728.*Mgl**1.)+

     &  (11*Mst1**18.*Mt**2.)/(288.*Mgl**3.)-

     &  (5*Mgl**13.*Mt**4.)/12.-

     &  (1583*Mgl**11.*Mst1**2.*Mt**4.)/288.+

     &  (11573*Mgl**9.*Mst1**4.*Mt**4.)/864.-

     &  (9085*Mgl**7.*Mst1**6.*Mt**4.)/864.+

     &  (2933*Mgl**5.*Mst1**8.*Mt**4.)/864.-

     &  (2831*Mgl**3.*Mst1**10.*Mt**4.)/864.+

     &  (3895*Mgl*Mst1**12.*Mt**4.)/864.-

     &  (1223*Mst1**14.*Mt**4.)/(864.*Mgl**1.)-

     &  (17*Mst1**16.*Mt**4.)/(96.*Mgl**3.)+

     &  (481*Mgl**11.*Mt**6.)/288.+

     &  (1729*Mgl**9.*Mst1**2.*Mt**6.)/216.-

     &  (8107*Mgl**7.*Mst1**4.*Mt**6.)/864.-

     &  (463*Mgl**5.*Mst1**6.*Mt**6.)/216.-

     &  (11*Mgl**3.*Mst1**8.*Mt**6.)/96.-

     &  (811*Mgl*Mst1**10.*Mt**6.)/216.+

     &  (2651*Mst1**12.*Mt**6.)/(864.*Mgl**1.)+

     &  (5*Mst1**14.*Mt**6.)/(24.*Mgl**3.)-

     &  (965*Mgl**9.*Mt**8.)/288.-

     &  (3553*Mgl**7.*Mst1**2.*Mt**8.)/864.+

     &  (557*Mgl**5.*Mst1**4.*Mt**8.)/144.+

     &  (1207*Mgl**3.*Mst1**6.*Mt**8.)/432.+

     &  (2357*Mgl*Mst1**8.*Mt**8.)/864.-

     &  (655*Mst1**10.*Mt**8.)/(288.*Mgl**1.)+

     &  (7*Mst1**12.*Mt**8.)/(24.*Mgl**3.)+

     &  (181*Mgl**7.*Mt**10.)/48.-

     &  (715*Mgl**5.*Mst1**2.*Mt**10.)/432.-

     &  (2791*Mgl**3.*Mst1**4.*Mt**10.)/432.-

     &  (1261*Mgl*Mst1**6.*Mt**10.)/216.-

     &  (10*Mst1**8.*Mt**10.)/(9.*Mgl**1.)-

     &  (49*Mst1**10.*Mt**10.)/(48.*Mgl**3.)-

     &  (713*Mgl**5.*Mt**12.)/288.+

     &  (2561*Mgl**3.*Mst1**2.*Mt**12.)/864.+

     &  (4657*Mgl*Mst1**4.*Mt**12.)/864.+

     &  (2215*Mst1**6.*Mt**12.)/(864.*Mgl**1.)+

     &  (49*Mst1**8.*Mt**12.)/(48.*Mgl**3.)+

     &  (295*Mgl**3.*Mt**14.)/288.-

     &  (73*Mgl*Mst1**2.*Mt**14.)/72.-

     &  (847*Mst1**4.*Mt**14.)/(864.*Mgl**1.)-

     &  (7*Mst1**6.*Mt**14.)/(24.*Mgl**3.)-

     &  (37*Mgl*Mt**16.)/96.-

     &  (211*Mst1**2.*Mt**16.)/(864.*Mgl**1.)-

     &  (5*Mst1**4.*Mt**16.)/(24.*Mgl**3.)+

     &  (95*Mt**18.)/(576.*Mgl**1.)+

     &  (17*Mst1**2.*Mt**18.)/(96.*Mgl**3.)-

     &  (11*Mt**20.)/(288.*Mgl**3.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mst1)+

     &  (0.030381944444444444-Mst1**2./(1152.*Mgl**2.)+

     &  Mt**2./(1152.*Mgl**2.))*ln(mu,Mgl)*ln(mu,Mst1)+

     &  ((-17*Mgl**4.)/288.+(5*Mgl**6.)/(1152.*Mst1**2.)+

     &  (11*Mgl**2.*Mst1**2.)/96.-(65*Mst1**4.)/576.+

     &  (13*Mst1**6.)/(1152.*Mgl**2.)-

     &  (13*Mgl**2.*Mt**2.)/384.-

     &  (5*Mgl**4.*Mt**2.)/(1152.*Mst1**2.)+

     &  (79*Mst1**2.*Mt**2.)/1152.-

     &  (Mst1**4.*Mt**2.)/(128.*Mgl**2.)-Mt**4./576.-

     &  (5*Mgl**2.*Mt**4.)/(1152.*Mst1**2.)-

     &  (7*Mst1**2.*Mt**4.)/(384.*Mgl**2.)+

     &  (17*Mt**6.)/(1152.*Mgl**2.)+

     &  (5*Mt**6.)/(1152.*Mst1**2.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mgl)*ln(mu,Mst1)+

     &  ((29*Mgl**8.)/576.-(5*Mgl**10.)/(1152.*Mst1**2.)-

     &  (301*Mgl**6.*Mst1**2.)/1152.+

     &  (29*Mgl**4.*Mst1**4.)/72.-

     &  (343*Mgl**2.*Mst1**6.)/1152.+(71*Mst1**8.)/576.-

     &  (5*Mst1**10.)/(384.*Mgl**2.)-

     &  (53*Mgl**6.*Mt**2.)/1152.+

     &  (37*Mgl**8.*Mt**2.)/(1152.*Mst1**2.)-

     &  (Mgl**4.*Mst1**2.*Mt**2.)/36.+

     &  (115*Mgl**2.*Mst1**4.*Mt**2.)/576.-

     &  (221*Mst1**6.*Mt**2.)/1152.+

     &  (55*Mst1**8.*Mt**2.)/(1152.*Mgl**2.)-

     &  (19*Mgl**4.*Mt**4.)/576.-

     &  (5*Mgl**6.*Mt**4.)/(192.*Mst1**2.)-

     &  (13*Mgl**2.*Mst1**2.*Mt**4.)/288.+

     &  (19*Mst1**4.*Mt**4.)/576.-

     &  (23*Mst1**6.*Mt**4.)/(576.*Mgl**2.)-

     &  (19*Mgl**2.*Mt**6.)/576.-

     &  (17*Mgl**4.*Mt**6.)/(576.*Mst1**2.)-

     &  (Mst1**2.*Mt**6.)/144.-

     &  (7*Mst1**4.*Mt**6.)/(192.*Mgl**2.)+

     &  (13*Mt**8.)/288.+

     &  (35*Mgl**2.*Mt**8.)/(1152.*Mst1**2.)+

     &  (77*Mst1**2.*Mt**8.)/(1152.*Mgl**2.)-

     &  (29*Mt**10.)/(1152.*Mgl**2.)-

     &  Mt**10./(384.*Mst1**2.))*d123(Mt,Mgl,Mst1)**2.*

     &  ln(mu,Mgl)*ln(mu,Mst1)+

     &  (-Mgl**12./128.-Mgl**14./(144.*Mst1**2.)+

     &  (251*Mgl**10.*Mst1**2.)/1152.-

     &  (607*Mgl**8.*Mst1**4.)/1152.+

     &  (565*Mgl**6.*Mst1**6.)/1152.-

     &  (85*Mgl**4.*Mst1**8.)/384.+

     &  (31*Mgl**2.*Mst1**10.)/384.-

     &  (25*Mst1**12.)/1152.-

     &  (5*Mst1**14.)/(1152.*Mgl**2.)+

     &  (67*Mgl**10.*Mt**2.)/1152.-

     &  (71*Mgl**8.*Mst1**2.*Mt**2.)/192.+

     &  (379*Mgl**6.*Mst1**4.*Mt**2.)/1152.+

     &  (Mgl**4.*Mst1**6.*Mt**2.)/48.-

     &  (107*Mgl**2.*Mst1**8.*Mt**2.)/1152.+

     &  (11*Mst1**10.*Mt**2.)/192.-

     &  (Mst1**12.*Mt**2.)/(384.*Mgl**2.)+

     &  (5*Mgl**8.*Mt**4.)/1152.+

     &  (Mgl**10.*Mt**4.)/(18.*Mst1**2.)+

     &  (151*Mgl**6.*Mst1**2.*Mt**4.)/1152.+

     &  (259*Mgl**4.*Mst1**4.*Mt**4.)/576.+

     &  (3*Mgl**2.*Mst1**6.*Mt**4.)/64.+

     &  (61*Mst1**8.*Mt**4.)/1152.+

     &  (25*Mst1**10.*Mt**4.)/(384.*Mgl**2.)+

     &  (97*Mgl**6.*Mt**6.)/1152.-

     &  (7*Mgl**8.*Mt**6.)/(144.*Mst1**2.)+

     &  (25*Mgl**4.*Mst1**2.*Mt**6.)/144.+

     &  (13*Mgl**2.*Mst1**4.*Mt**6.)/192.-

     &  (7*Mst1**6.*Mt**6.)/32.-

     &  (155*Mst1**8.*Mt**6.)/(1152.*Mgl**2.)-

     &  (157*Mgl**4.*Mt**8.)/384.-

     &  (Mgl**6.*Mt**8.)/(16.*Mst1**2.)-

     &  (145*Mgl**2.*Mst1**2.*Mt**8.)/384.+

     &  (43*Mst1**4.*Mt**8.)/384.+

     &  (35*Mst1**6.*Mt**8.)/(384.*Mgl**2.)+

     &  (301*Mgl**2.*Mt**10.)/1152.+

     &  (5*Mgl**4.*Mt**10.)/(72.*Mst1**2.)+

     &  (25*Mst1**2.*Mt**10.)/576.+

     &  (5*Mst1**4.*Mt**10.)/(384.*Mgl**2.)-

     &  (5*Mt**12.)/1152.+

     &  (Mgl**2.*Mt**12.)/(72.*Mst1**2.)-

     &  (47*Mst1**2.*Mt**12.)/(1152.*Mgl**2.)+

     &  (5*Mt**14.)/(384.*Mgl**2.)-Mt**14./(48.*Mst1**2.))

     &  *d123(Mt,Mgl,Mst1)**3.*ln(mu,Mgl)*ln(mu,Mst1)+

     &  (-Mgl**16./192.+Mgl**18./(144.*Mst1**2.)-

     &  (5*Mgl**14.*Mst1**2.)/36.+

     &  (73*Mgl**12.*Mst1**4.)/144.-

     &  (113*Mgl**10.*Mst1**6.)/144.+

     &  (191*Mgl**8.*Mst1**8.)/288.-

     &  (53*Mgl**6.*Mst1**10.)/144.+

     &  (25*Mgl**4.*Mst1**12.)/144.-

     &  (Mgl**2.*Mst1**14.)/18.-Mst1**16./192.+

     &  Mst1**18./(144.*Mgl**2.)+

     &  (7*Mgl**14.*Mt**2.)/576.-

     &  (19*Mgl**16.*Mt**2.)/(576.*Mst1**2.)+

     &  (7*Mgl**12.*Mst1**2.*Mt**2.)/18.-

     &  (545*Mgl**10.*Mst1**4.*Mt**2.)/576.+

     &  (43*Mgl**8.*Mst1**6.*Mt**2.)/48.-

     &  (17*Mgl**6.*Mst1**8.*Mt**2.)/64.-

     &  (35*Mgl**4.*Mst1**10.*Mt**2.)/144.+

     &  (137*Mgl**2.*Mst1**12.*Mt**2.)/576.-

     &  (5*Mst1**14.*Mt**2.)/576.-

     &  (11*Mst1**16.*Mt**2.)/(288.*Mgl**2.)-

     &  (5*Mgl**12.*Mt**4.)/48.+

     &  (13*Mgl**14.*Mt**4.)/(288.*Mst1**2.)-

     &  (49*Mgl**10.*Mst1**2.*Mt**4.)/288.+

     &  (4*Mgl**8.*Mst1**4.*Mt**4.)/9.+

     &  (53*Mgl**6.*Mst1**6.*Mt**4.)/288.-

     &  (29*Mgl**4.*Mst1**8.*Mt**4.)/144.-

     &  (103*Mgl**2.*Mst1**10.*Mt**4.)/288.+

     &  (Mst1**12.*Mt**4.)/12.+

     &  (11*Mst1**14.*Mt**4.)/(144.*Mgl**2.)+

     &  (233*Mgl**10.*Mt**6.)/576.-

     &  (Mgl**12.*Mt**6.)/(288.*Mst1**2.)-

     &  (2*Mgl**8.*Mst1**2.*Mt**6.)/9.+

     &  (Mgl**6.*Mst1**4.*Mt**6.)/288.+

     &  (23*Mgl**4.*Mst1**6.*Mt**6.)/96.+

     &  (19*Mgl**2.*Mst1**8.*Mt**6.)/192.-

     &  (5*Mst1**10.*Mt**6.)/36.-

     &  (7*Mst1**12.*Mt**6.)/(144.*Mgl**2.)-

     &  (125*Mgl**8.*Mt**8.)/288.-

     &  (Mgl**10.*Mt**8.)/(96.*Mst1**2.)+

     &  (73*Mgl**6.*Mst1**2.*Mt**8.)/144.+

     &  (89*Mgl**4.*Mst1**4.*Mt**8.)/144.+

     &  (143*Mgl**2.*Mst1**6.*Mt**8.)/288.+

     &  (3*Mst1**8.*Mt**8.)/32.-

     &  (7*Mst1**10.*Mt**8.)/(144.*Mgl**2.)-

     &  (49*Mgl**6.*Mt**10.)/576.-

     &  (Mgl**8.*Mt**10.)/(24.*Mst1**2.)-

     &  (11*Mgl**4.*Mst1**2.*Mt**10.)/12.-

     &  (485*Mgl**2.*Mst1**4.*Mt**10.)/576.-

     &  (11*Mst1**6.*Mt**10.)/288.+

     &  (7*Mst1**8.*Mt**10.)/(72.*Mgl**2.)+

     &  (13*Mgl**4.*Mt**12.)/48.+

     &  (7*Mgl**6.*Mt**12.)/(288.*Mst1**2.)+

     &  (139*Mgl**2.*Mst1**2.*Mt**12.)/288.-

     &  (7*Mst1**6.*Mt**12.)/(144.*Mgl**2.)+

     &  (Mgl**2.*Mt**14.)/192.+

     &  (17*Mgl**4.*Mt**14.)/(288.*Mst1**2.)+

     &  (Mst1**2.*Mt**14.)/18.-

     &  (Mst1**4.*Mt**14.)/(144.*Mgl**2.)-

     &  (35*Mt**16.)/576.-

     &  (19*Mgl**2.*Mt**16.)/(288.*Mst1**2.)+

     &  (Mst1**2.*Mt**16.)/(72.*Mgl**2.)-

     &  Mt**18./(288.*Mgl**2.)+

     &  (11*Mt**18.)/(576.*Mst1**2.))*d123(Mt,Mgl,Mst1)**4.*

     &  ln(mu,Mgl)*ln(mu,Mst1)-

     &  (Mt**2.*Xt*Den(Mst1,Mst2)*ln(mu,Mgl)*ln(mu,Mst1))/

     &  (288.*Mgl**1.)+

     &  ((43*Mgl**3.*Mt**2.)/192.-

     &  (5*Mgl**5.*Mt**2.)/(288.*Mst1**2.)-

     &  (91*Mgl*Mst1**2.*Mt**2.)/288.+

     &  (5*Mst1**4.*Mt**2.)/(192.*Mgl**1.)-

     &  (Mgl*Mt**4.)/36.+

     &  (5*Mgl**3.*Mt**4.)/(144.*Mst1**2.)+

     &  (Mst1**2.*Mt**4.)/(96.*Mgl**1.)-

     &  (7*Mt**6.)/(192.*Mgl**1.)-

     &  (5*Mgl*Mt**6.)/(288.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst1)+

     &  ((-31*Mgl**7.*Mt**2.)/144.+

     &  (5*Mgl**9.*Mt**2.)/(288.*Mst1**2.)+

     &  (223*Mgl**5.*Mst1**2.*Mt**2.)/288.-

     &  (107*Mgl**3.*Mst1**4.*Mt**2.)/96.+

     &  (41*Mgl*Mst1**6.*Mt**2.)/72.-

     &  (Mst1**8.*Mt**2.)/(32.*Mgl**1.)+

     &  (47*Mgl**5.*Mt**4.)/144.-

     &  (7*Mgl**7.*Mt**4.)/(48.*Mst1**2.)-

     &  (11*Mgl**3.*Mst1**2.*Mt**4.)/288.-

     &  (23*Mgl*Mst1**4.*Mt**4.)/48.+

     &  (29*Mst1**6.*Mt**4.)/(288.*Mgl**1.)+

     &  (7*Mgl**3.*Mt**6.)/144.+

     &  (Mgl**5.*Mt**6.)/(4.*Mst1**2.)-

     &  (Mgl*Mst1**2.*Mt**6.)/32.-

     &  (Mst1**4.*Mt**6.)/(32.*Mgl**1.)-

     &  (11*Mgl*Mt**8.)/72.-

     &  (19*Mgl**3.*Mt**8.)/(144.*Mst1**2.)-

     &  (11*Mst1**2.*Mt**8.)/(96.*Mgl**1.)+

     &  (11*Mt**10.)/(144.*Mgl**1.)+

     &  (Mgl*Mt**10.)/(96.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst1)+

     &  ((13*Mgl**11.*Mt**2.)/576.+

     &  (Mgl**13.*Mt**2.)/(36.*Mst1**2.)-

     &  (181*Mgl**9.*Mst1**2.*Mt**2.)/288.+

     &  (715*Mgl**7.*Mst1**4.*Mt**2.)/576.-

     &  (131*Mgl**5.*Mst1**6.*Mt**2.)/144.+

     &  (179*Mgl**3.*Mst1**8.*Mt**2.)/576.-

     &  (13*Mgl*Mst1**10.*Mt**2.)/288.-

     &  (11*Mst1**12.*Mt**2.)/(576.*Mgl**1.)-

     &  (7*Mgl**9.*Mt**4.)/144.-

     &  (Mgl**11.*Mt**4.)/(36.*Mst1**2.)+

     &  (161*Mgl**7.*Mst1**2.*Mt**4.)/144.-

     &  (49*Mgl**5.*Mst1**4.*Mt**4.)/36.-

     &  (Mgl**3.*Mst1**6.*Mt**4.)/8.+

     &  (19*Mgl*Mst1**8.*Mt**4.)/144.-

     &  (Mst1**10.*Mt**4.)/(48.*Mgl**1.)-

     &  (455*Mgl**7.*Mt**6.)/576.-

     &  (7*Mgl**9.*Mt**6.)/(36.*Mst1**2.)-

     &  (15*Mgl**5.*Mst1**2.*Mt**6.)/16.-

     &  (35*Mgl**3.*Mst1**4.*Mt**6.)/96.+

     &  (7*Mgl*Mst1**6.*Mt**6.)/48.+

     &  (43*Mst1**8.*Mt**6.)/(192.*Mgl**1.)+

     &  (125*Mgl**5.*Mt**8.)/72.+

     &  (7*Mgl**7.*Mt**8.)/(18.*Mst1**2.)+

     &  (17*Mgl**3.*Mst1**2.*Mt**8.)/18.-

     &  (Mgl*Mst1**4.*Mt**8.)/4.-

     &  (11*Mst1**6.*Mt**8.)/(36.*Mgl**1.)-

     &  (553*Mgl**3.*Mt**10.)/576.-

     &  (5*Mgl**5.*Mt**10.)/(36.*Mst1**2.)-

     &  (5*Mgl*Mst1**2.*Mt**10.)/32.+

     &  (13*Mst1**4.*Mt**10.)/(192.*Mgl**1.)+

     &  (13*Mgl*Mt**12.)/144.-

     &  (5*Mgl**3.*Mt**12.)/(36.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**12.)/(48.*Mgl**1.)-

     &  (29*Mt**14.)/(576.*Mgl**1.)+

     &  (Mgl*Mt**14.)/(12.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst1)+

     &  (-(Mgl**15.*Mt**2.)/144.-

     &  (Mgl**17.*Mt**2.)/(36.*Mst1**2.)+

     &  (79*Mgl**13.*Mst1**2.*Mt**2.)/144.-

     &  (71*Mgl**11.*Mst1**4.*Mt**2.)/48.+

     &  (239*Mgl**9.*Mst1**6.*Mt**2.)/144.-

     &  (143*Mgl**7.*Mst1**8.*Mt**2.)/144.+

     &  (23*Mgl**5.*Mst1**10.*Mt**2.)/48.-

     &  (31*Mgl**3.*Mst1**12.*Mt**2.)/144.+

     &  (Mgl*Mst1**14.*Mt**2.)/144.+

     &  (Mst1**16.*Mt**2.)/(36.*Mgl**1.)+

     &  (17*Mgl**13.*Mt**4.)/144.+

     &  (23*Mgl**15.*Mt**4.)/(144.*Mst1**2.)-

     &  (143*Mgl**11.*Mst1**2.*Mt**4.)/72.+

     &  (59*Mgl**9.*Mst1**4.*Mt**4.)/18.-

     &  (283*Mgl**7.*Mst1**6.*Mt**4.)/144.+

     &  (13*Mgl**5.*Mst1**8.*Mt**4.)/144.+

     &  (7*Mgl**3.*Mst1**10.*Mt**4.)/12.-

     &  (11*Mgl*Mst1**12.*Mt**4.)/72.-

     &  (Mst1**14.*Mt**4.)/(8.*Mgl**1.)-

     &  (Mgl**11.*Mt**6.)/24.-

     &  (49*Mgl**13.*Mt**6.)/(144.*Mst1**2.)+

     &  (21*Mgl**9.*Mst1**2.*Mt**6.)/8.-

     &  (175*Mgl**7.*Mst1**4.*Mt**6.)/72.-

     &  (173*Mgl**5.*Mst1**6.*Mt**6.)/144.-

     &  (35*Mgl**3.*Mst1**8.*Mt**6.)/72.+

     &  (13*Mgl*Mst1**10.*Mt**6.)/36.+

     &  (13*Mst1**12.*Mt**6.)/(72.*Mgl**1.)-

     &  (11*Mgl**9.*Mt**8.)/9.+

     &  (17*Mgl**11.*Mt**8.)/(48.*Mst1**2.)-

     &  (71*Mgl**7.*Mst1**2.*Mt**8.)/24.-

     &  (13*Mgl**5.*Mst1**4.*Mt**8.)/24.-

     &  (43*Mgl**3.*Mst1**6.*Mt**8.)/144.-

     &  (5*Mgl*Mst1**8.*Mt**8.)/24.-

     &  (Mst1**10.*Mt**8.)/(72.*Mgl**1.)+

     &  (127*Mgl**7.*Mt**10.)/48.-

     &  (5*Mgl**9.*Mt**10.)/(16.*Mst1**2.)+

     &  (515*Mgl**5.*Mst1**2.*Mt**10.)/144.+

     &  (79*Mgl**3.*Mst1**4.*Mt**10.)/48.-

     &  (Mgl*Mst1**6.*Mt**10.)/24.-

     &  (5*Mst1**8.*Mt**10.)/(24.*Mgl**1.)-

     &  (263*Mgl**5.*Mt**12.)/144.+

     &  (23*Mgl**7.*Mt**12.)/(48.*Mst1**2.)-

     &  (125*Mgl**3.*Mst1**2.*Mt**12.)/72.-

     &  (Mgl*Mst1**4.*Mt**12.)/72.+

     &  (13*Mst1**6.*Mt**12.)/(72.*Mgl**1.)+

     &  (Mgl**3.*Mt**14.)/6.-

     &  (83*Mgl**5.*Mt**14.)/(144.*Mst1**2.)-

     &  (Mgl*Mst1**2.*Mt**14.)/36.-

     &  (Mst1**4.*Mt**14.)/(72.*Mgl**1.)+

     &  (11*Mgl*Mt**16.)/72.+

     &  (49*Mgl**3.*Mt**16.)/(144.*Mst1**2.)-

     &  (Mst1**2.*Mt**16.)/(24.*Mgl**1.)+

     &  Mt**18./(72.*Mgl**1.)-

     &  (11*Mgl*Mt**18.)/(144.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst1)+

     &  (0.01171875-(11*Mst1**2.)/(2304.*Mgl**2.)+

     &  Mst1**4./(1152.*Mgl**4.)+

     &  (7*Mt**2.)/(576.*Mgl**2.)-

     &  (Mst1**2.*Mt**2.)/(768.*Mgl**4.)+

     &  Mt**4./(2304.*Mgl**4.))*ln(mu,Mst1)**2.+

     &  ((-5*Mgl**4.)/256.+(173*Mgl**2.*Mst1**2.)/2304.-

     &  (103*Mst1**4.)/2304.+

     &  (29*Mst1**6.)/(2304.*Mgl**2.)-

     &  Mst1**8./(384.*Mgl**4.)+(5*Mgl**2.*Mt**2.)/192.+

     &  (221*Mst1**2.*Mt**2.)/2304.-

     &  (23*Mst1**4.*Mt**2.)/(576.*Mgl**2.)+

     &  (25*Mst1**6.*Mt**2.)/(2304.*Mgl**4.)+

     &  (13*Mt**4.)/576.+

     &  (131*Mst1**2.*Mt**4.)/(2304.*Mgl**2.)-

     &  (13*Mst1**4.*Mt**4.)/(768.*Mgl**4.)-

     &  (17*Mt**6.)/(576.*Mgl**2.)+

     &  (3*Mst1**2.*Mt**6.)/(256.*Mgl**4.)-

     &  (7*Mt**8.)/(2304.*Mgl**4.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mst1)**2.+

     &  (Mgl**8./256.-Mgl**10./(576.*Mst1**2.)-

     &  (221*Mgl**6.*Mst1**2.)/2304.+

     &  (101*Mgl**4.*Mst1**4.)/576.-

     &  (121*Mgl**2.*Mst1**6.)/1152.+

     &  (41*Mst1**8.)/2304.+

     &  (11*Mst1**10.)/(2304.*Mgl**2.)+

     &  Mst1**12./(1152.*Mgl**4.)-

     &  (43*Mgl**6.*Mt**2.)/2304.+

     &  (Mgl**8.*Mt**2.)/(384.*Mst1**2.)+

     &  (293*Mgl**4.*Mst1**2.*Mt**2.)/2304.+

     &  (149*Mgl**2.*Mst1**4.*Mt**2.)/1152.-

     &  (31*Mst1**6.*Mt**2.)/192.+

     &  (13*Mst1**8.*Mt**2.)/(2304.*Mgl**2.)-

     &  (19*Mst1**10.*Mt**2.)/(2304.*Mgl**4.)+

     &  (9*Mgl**4.*Mt**4.)/256.+

     &  (Mgl**6.*Mt**4.)/(576.*Mst1**2.)+

     &  (49*Mgl**2.*Mst1**2.*Mt**4.)/1152.+

     &  (53*Mst1**4.*Mt**4.)/288.-

     &  (71*Mst1**6.*Mt**4.)/(1152.*Mgl**2.)+

     &  (71*Mst1**8.*Mt**4.)/(2304.*Mgl**4.)+

     &  (Mgl**2.*Mt**6.)/576.-

     &  (Mgl**4.*Mt**6.)/(288.*Mst1**2.)+

     &  (Mst1**2.*Mt**6.)/1152.+

     &  (29*Mst1**4.*Mt**6.)/(288.*Mgl**2.)-

     &  (67*Mst1**6.*Mt**6.)/(1152.*Mgl**4.)-

     &  (97*Mt**8.)/2304.-

     &  (145*Mst1**2.*Mt**8.)/(2304.*Mgl**2.)+

     &  (17*Mst1**4.*Mt**8.)/(288.*Mgl**4.)+

     &  (31*Mt**10.)/(2304.*Mgl**2.)+

     &  Mt**10./(1152.*Mst1**2.)-

     &  (71*Mst1**2.*Mt**10.)/(2304.*Mgl**4.)+

     &  (5*Mt**12.)/(768.*Mgl**4.))*d123(Mt,Mgl,Mst1)**2.*

     &  ln(mu,Mst1)**2.+

     &  (-Mgl**12./2304.+Mgl**14./(288.*Mst1**2.)+

     &  (227*Mgl**10.*Mst1**2.)/2304.-

     &  (817*Mgl**8.*Mst1**4.)/2304.+

     &  (881*Mgl**6.*Mst1**6.)/2304.-

     &  (109*Mgl**4.*Mst1**8.)/2304.-

     &  (403*Mgl**2.*Mst1**10.)/2304.+

     &  (281*Mst1**12.)/2304.-

     &  (73*Mst1**14.)/(2304.*Mgl**2.)+

     &  Mst1**16./(384.*Mgl**4.)-

     &  (31*Mgl**10.*Mt**2.)/1152.-

     &  (Mgl**12.*Mt**2.)/(72.*Mst1**2.)-

     &  (127*Mgl**8.*Mst1**2.*Mt**2.)/768.+

     &  (113*Mgl**6.*Mst1**4.*Mt**2.)/384.-

     &  (31*Mgl**4.*Mst1**6.*Mt**2.)/2304.-

     &  (Mgl**2.*Mst1**8.*Mt**2.)/1152.-

     &  (443*Mst1**10.*Mt**2.)/2304.+

     &  (157*Mst1**12.*Mt**2.)/(1152.*Mgl**2.)-

     &  (41*Mst1**14.*Mt**2.)/(2304.*Mgl**4.)+

     &  (7*Mgl**8.*Mt**4.)/144.+

     &  (Mgl**10.*Mt**4.)/(72.*Mst1**2.)+

     &  (103*Mgl**6.*Mst1**2.*Mt**4.)/2304.+

     &  (175*Mgl**4.*Mst1**4.*Mt**4.)/2304.+

     &  (7*Mgl**2.*Mst1**6.*Mt**4.)/1152.-

     &  (29*Mst1**8.*Mt**4.)/1152.-

     &  (151*Mst1**10.*Mt**4.)/(768.*Mgl**2.)+

     &  (107*Mst1**12.*Mt**4.)/(2304.*Mgl**4.)+

     &  (37*Mgl**6.*Mt**6.)/1152.+

     &  (Mgl**8.*Mt**6.)/(96.*Mst1**2.)-

     &  (Mgl**4.*Mst1**2.*Mt**6.)/256.+

     &  (Mgl**2.*Mst1**4.*Mt**6.)/576.+

     &  (11*Mst1**6.*Mt**6.)/1152.+

     &  (77*Mst1**8.*Mt**6.)/(1152.*Mgl**2.)-

     &  (13*Mst1**10.*Mt**6.)/(256.*Mgl**4.)-

     &  (113*Mgl**4.*Mt**8.)/1152.-

     &  (7*Mgl**6.*Mt**8.)/(288.*Mst1**2.)+

     &  (277*Mgl**2.*Mst1**2.*Mt**8.)/2304.+

     &  (481*Mst1**4.*Mt**8.)/2304.+

     &  (21*Mst1**6.*Mt**8.)/(256.*Mgl**2.)-

     &  (5*Mst1**8.*Mt**8.)/(2304.*Mgl**4.)+

     &  (47*Mgl**2.*Mt**10.)/1152.+

     &  (Mgl**4.*Mt**10.)/(144.*Mst1**2.)-

     &  (275*Mst1**2.*Mt**10.)/2304.-

     &  (23*Mst1**4.*Mt**10.)/(384.*Mgl**2.)+

     &  (149*Mst1**6.*Mt**10.)/(2304.*Mgl**4.)+

     &  (Mgl**2.*Mt**12.)/(144.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**12.)/(768.*Mgl**2.)-

     &  (53*Mst1**4.*Mt**12.)/(768.*Mgl**4.)+

     &  (11*Mt**14.)/(1152.*Mgl**2.)-

     &  Mt**14./(288.*Mst1**2.)+

     &  (73*Mst1**2.*Mt**14.)/(2304.*Mgl**4.)-

     &  (13*Mt**16.)/(2304.*Mgl**4.))*d123(Mt,Mgl,Mst1)**3.*

     &  ln(mu,Mst1)**2.+

     &  ((5*Mgl**16.)/1152.-Mgl**18./(576.*Mst1**2.)-

     &  (43*Mgl**14.*Mst1**2.)/576.+

     &  (221*Mgl**12.*Mst1**4.)/576.-

     &  (19*Mgl**10.*Mst1**6.)/24.+

     &  (415*Mgl**8.*Mst1**8.)/576.-

     &  (Mgl**6.*Mst1**10.)/9.-(Mgl**4.*Mst1**12.)/3.+

     &  (169*Mgl**2.*Mst1**14.)/576.-

     &  (41*Mst1**16.)/384.+

     &  (11*Mst1**18.)/(576.*Mgl**2.)-

     &  Mst1**20./(576.*Mgl**4.)-

     &  (11*Mgl**14.*Mt**2.)/2304.+

     &  (13*Mgl**16.*Mt**2.)/(1152.*Mst1**2.)+

     &  (191*Mgl**12.*Mst1**2.*Mt**2.)/1152.-

     &  (39*Mgl**10.*Mst1**4.*Mt**2.)/64.+

     &  (11*Mgl**8.*Mst1**6.*Mt**2.)/16.-

     &  (47*Mgl**6.*Mst1**8.*Mt**2.)/128.+

     &  (253*Mgl**4.*Mst1**10.*Mt**2.)/576.-

     &  (119*Mgl**2.*Mst1**12.*Mt**2.)/192.+

     &  (463*Mst1**14.*Mt**2.)/1152.-

     &  (31*Mst1**16.*Mt**2.)/(256.*Mgl**2.)+

     &  (19*Mst1**18.*Mt**2.)/(1152.*Mgl**4.)-

     &  (7*Mgl**12.*Mt**4.)/192.-

     &  (5*Mgl**14.*Mt**4.)/(192.*Mst1**2.)+

     &  (55*Mgl**10.*Mst1**2.*Mt**4.)/576.-

     &  (25*Mgl**8.*Mst1**4.*Mt**4.)/576.+

     &  (113*Mgl**6.*Mst1**6.*Mt**4.)/576.-

     &  (25*Mgl**4.*Mst1**8.*Mt**4.)/96.+

     &  (209*Mgl**2.*Mst1**10.*Mt**4.)/576.-

     &  (301*Mst1**12.*Mt**4.)/576.+

     &  (29*Mst1**14.*Mt**4.)/(96.*Mgl**2.)-

     &  (13*Mst1**16.*Mt**4.)/(192.*Mgl**4.)+

     &  (83*Mgl**10.*Mt**6.)/1152.+

     &  (11*Mgl**12.*Mt**6.)/(576.*Mst1**2.)-

     &  (109*Mgl**8.*Mst1**2.*Mt**6.)/192.+

     &  (289*Mgl**6.*Mst1**4.*Mt**6.)/1152.+

     &  (145*Mgl**4.*Mst1**6.*Mt**6.)/576.-

     &  (7*Mgl**2.*Mst1**8.*Mt**6.)/1152.+

     &  (193*Mst1**10.*Mt**6.)/576.-

     &  (397*Mst1**12.*Mt**6.)/(1152.*Mgl**2.)+

     &  (5*Mst1**14.*Mt**6.)/(32.*Mgl**4.)+

     &  (7*Mgl**8.*Mt**8.)/576.+

     &  (11*Mgl**10.*Mt**8.)/(576.*Mst1**2.)+

     &  (313*Mgl**6.*Mst1**2.*Mt**8.)/576.-

     &  (13*Mgl**4.*Mst1**4.*Mt**8.)/96.-

     &  (21*Mgl**2.*Mst1**6.*Mt**8.)/64.-

     &  (235*Mst1**8.*Mt**8.)/576.+

     &  (19*Mst1**10.*Mt**8.)/(192.*Mgl**2.)-

     &  (7*Mst1**12.*Mt**8.)/(32.*Mgl**4.)-

     &  (11*Mgl**6.*Mt**10.)/96.-

     &  (Mgl**8.*Mt**10.)/(24.*Mst1**2.)-

     &  (3*Mgl**4.*Mst1**2.*Mt**10.)/64.+

     &  (155*Mgl**2.*Mst1**4.*Mt**10.)/288.+

     &  (373*Mst1**6.*Mt**10.)/576.+

     &  (11*Mst1**8.*Mt**10.)/(64.*Mgl**2.)+

     &  (35*Mst1**10.*Mt**10.)/(192.*Mgl**4.)+

     &  (11*Mgl**4.*Mt**12.)/144.+

     &  (11*Mgl**6.*Mt**12.)/(576.*Mst1**2.)-

     &  (131*Mgl**2.*Mst1**2.*Mt**12.)/576.-

     &  (265*Mst1**4.*Mt**12.)/576.-

     &  (13*Mst1**6.*Mt**12.)/(72.*Mgl**2.)-

     &  (7*Mst1**8.*Mt**12.)/(96.*Mgl**4.)-

     &  (Mgl**2.*Mt**14.)/384.+

     &  (5*Mgl**4.*Mt**14.)/(576.*Mst1**2.)+

     &  (65*Mst1**2.*Mt**14.)/576.+

     &  (19*Mst1**4.*Mt**14.)/(384.*Mgl**2.)-

     &  (Mst1**6.*Mt**14.)/(96.*Mgl**4.)-Mt**16./384.-

     &  (Mgl**2.*Mt**16.)/(96.*Mst1**2.)+

     &  (Mst1**2.*Mt**16.)/(96.*Mgl**2.)+

     &  (5*Mst1**4.*Mt**16.)/(192.*Mgl**4.)-

     &  (13*Mt**18.)/(2304.*Mgl**2.)+

     &  Mt**18./(384.*Mst1**2.)-

     &  (13*Mst1**2.*Mt**18.)/(1152.*Mgl**4.)+

     &  Mt**20./(576.*Mgl**4.))*d123(Mt,Mgl,Mst1)**4.*

     &  ln(mu,Mst1)**2.+

     &  ((-11*Mt**2.)/(192.*Mgl**1.)+

     &  (Mst1**2.*Mt**2.)/(288.*Mgl**3.)-

     &  Mt**4./(576.*Mgl**3.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mst1)**2.+

     &  ((37*Mgl**3.*Mt**2.)/384.-

     &  (79*Mgl*Mst1**2.*Mt**2.)/192.+

     &  (7*Mst1**4.*Mt**2.)/(384.*Mgl**1.)-

     &  (Mst1**6.*Mt**2.)/(576.*Mgl**3.)-

     &  (29*Mgl*Mt**4.)/128.-

     &  (29*Mst1**2.*Mt**4.)/(192.*Mgl**1.)+

     &  (13*Mst1**4.*Mt**4.)/(1152.*Mgl**3.)+

     &  (149*Mt**6.)/(1152.*Mgl**1.)-

     &  (5*Mst1**2.*Mt**6.)/(288.*Mgl**3.)+

     &  Mt**8./(128.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)*ln(mu,Mst1)**2.+

     &  ((-11*Mgl**7.*Mt**2.)/576.+

     &  (Mgl**9.*Mt**2.)/(144.*Mst1**2.)+

     &  (221*Mgl**5.*Mst1**2.*Mt**2.)/576.-

     &  (85*Mgl**3.*Mst1**4.*Mt**2.)/192.-

     &  (5*Mgl*Mst1**6.*Mt**2.)/576.+

     &  (25*Mst1**8.*Mt**2.)/(288.*Mgl**1.)-

     &  (Mst1**10.*Mt**2.)/(144.*Mgl**3.)+

     &  (65*Mgl**5.*Mt**4.)/576.-

     &  (5*Mgl**7.*Mt**4.)/(288.*Mst1**2.)-

     &  (203*Mgl**3.*Mst1**2.*Mt**4.)/288.-

     &  (163*Mgl*Mst1**4.*Mt**4.)/192.-

     &  (23*Mst1**6.*Mt**4.)/(288.*Mgl**1.)+

     &  (5*Mst1**8.*Mt**4.)/(288.*Mgl**3.)-

     &  (161*Mgl**3.*Mt**6.)/576.+

     &  (Mgl**5.*Mt**6.)/(96.*Mst1**2.)+

     &  (41*Mgl*Mst1**2.*Mt**6.)/576.-

     &  (49*Mst1**4.*Mt**6.)/(288.*Mgl**1.)+

     &  (Mst1**6.*Mt**6.)/(96.*Mgl**3.)+

     &  (17*Mgl*Mt**8.)/64.+

     &  (Mgl**3.*Mt**8.)/(288.*Mst1**2.)+

     &  (2*Mst1**2.*Mt**8.)/(9.*Mgl**1.)-

     &  (19*Mst1**4.*Mt**8.)/(288.*Mgl**3.)-

     &  (17*Mt**10.)/(288.*Mgl**1.)-

     &  (Mgl*Mt**10.)/(288.*Mst1**2.)+

     &  (19*Mst1**2.*Mt**10.)/(288.*Mgl**3.)-

     &  Mt**12./(48.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst1)**2.*

     &  Den(Mst1,Mst2)*ln(mu,Mst1)**2.+

     &  ((-11*Mgl**11.*Mt**2.)/1152.-

     &  (Mgl**13.*Mt**2.)/(72.*Mst1**2.)-

     &  (77*Mgl**9.*Mst1**2.*Mt**2.)/288.+

     &  (911*Mgl**7.*Mst1**4.*Mt**2.)/1152.-

     &  (325*Mgl**5.*Mst1**6.*Mt**2.)/576.-

     &  (47*Mgl**3.*Mst1**8.*Mt**2.)/384.+

     &  (5*Mgl*Mst1**10.*Mt**2.)/18.-

     &  (119*Mst1**12.*Mt**2.)/(1152.*Mgl**1.)+

     &  (7*Mst1**14.*Mt**2.)/(576.*Mgl**3.)+

     &  (203*Mgl**9.*Mt**4.)/1152.+

     &  (5*Mgl**11.*Mt**4.)/(72.*Mst1**2.)+

     &  (127*Mgl**7.*Mst1**2.*Mt**4.)/288.-

     &  (793*Mgl**5.*Mst1**4.*Mt**4.)/1152.-

     &  (13*Mgl**3.*Mst1**6.*Mt**4.)/48.-

     &  (143*Mgl*Mst1**8.*Mt**4.)/1152.+

     &  (29*Mst1**10.*Mt**4.)/(96.*Mgl**1.)-

     &  (83*Mst1**12.*Mt**4.)/(1152.*Mgl**3.)-

     &  (563*Mgl**7.*Mt**6.)/1152.-

     &  (Mgl**9.*Mt**6.)/(8.*Mst1**2.)+

     &  (11*Mgl**5.*Mst1**2.*Mt**6.)/72.+

     &  (11*Mgl**3.*Mst1**4.*Mt**6.)/576.+

     &  (Mgl*Mst1**6.*Mt**6.)/288.-

     &  (19*Mst1**8.*Mt**6.)/(128.*Mgl**1.)+

     &  (5*Mst1**10.*Mt**6.)/(32.*Mgl**3.)+

     &  (547*Mgl**5.*Mt**8.)/1152.+

     &  (Mgl**7.*Mt**8.)/(12.*Mst1**2.)-

     &  (113*Mgl**3.*Mst1**2.*Mt**8.)/144.-

     &  (425*Mgl*Mst1**4.*Mt**8.)/576.-

     &  (41*Mst1**6.*Mt**8.)/(144.*Mgl**1.)-

     &  (145*Mst1**8.*Mt**8.)/(1152.*Mgl**3.)-

     &  (169*Mgl**3.*Mt**10.)/1152.+

     &  (Mgl**5.*Mt**10.)/(72.*Mst1**2.)+

     &  (157*Mgl*Mst1**2.*Mt**10.)/288.+

     &  (35*Mst1**4.*Mt**10.)/(128.*Mgl**1.)-

     &  (25*Mst1**6.*Mt**10.)/(576.*Mgl**3.)+

     &  (25*Mgl*Mt**12.)/1152.-

     &  (Mgl**3.*Mt**12.)/(24.*Mst1**2.)+

     &  (Mst1**2.*Mt**12.)/(96.*Mgl**1.)+

     &  (19*Mst1**4.*Mt**12.)/(128.*Mgl**3.)-

     &  (19*Mt**14.)/(384.*Mgl**1.)+

     &  (Mgl*Mt**14.)/(72.*Mst1**2.)-

     &  (7*Mst1**2.*Mt**14.)/(72.*Mgl**3.)+

     &  (25*Mt**16.)/(1152.*Mgl**3.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mst1)**2.

     &  +(-(Mgl**15.*Mt**2.)/96.+

     &  (Mgl**17.*Mt**2.)/(144.*Mst1**2.)+

     &  (83*Mgl**13.*Mst1**2.*Mt**2.)/288.-

     &  (359*Mgl**11.*Mst1**4.*Mt**2.)/288.+

     &  (553*Mgl**9.*Mst1**6.*Mt**2.)/288.-

     &  (277*Mgl**7.*Mst1**8.*Mt**2.)/288.-

     &  (149*Mgl**5.*Mst1**10.*Mt**2.)/288.+

     &  (235*Mgl**3.*Mst1**12.*Mt**2.)/288.-

     &  (103*Mgl*Mst1**14.*Mt**2.)/288.+

     &  (5*Mst1**16.*Mt**2.)/(72.*Mgl**1.)-

     &  (Mst1**18.*Mt**2.)/(144.*Mgl**3.)-

     &  (13*Mgl**13.*Mt**4.)/576.-

     &  (5*Mgl**15.*Mt**4.)/(96.*Mst1**2.)-

     &  (187*Mgl**11.*Mst1**2.*Mt**4.)/192.+

     &  (1561*Mgl**9.*Mst1**4.*Mt**4.)/576.-

     &  (1129*Mgl**7.*Mst1**6.*Mt**4.)/576.+

     &  (271*Mgl**5.*Mst1**8.*Mt**4.)/576.-

     &  (443*Mgl**3.*Mst1**10.*Mt**4.)/576.+

     &  (515*Mgl*Mst1**12.*Mt**4.)/576.-

     &  (205*Mst1**14.*Mt**4.)/(576.*Mgl**1.)+

     &  (17*Mst1**16.*Mt**4.)/(288.*Mgl**3.)+

     &  (187*Mgl**11.*Mt**6.)/576.+

     &  (5*Mgl**13.*Mt**6.)/(32.*Mst1**2.)+

     &  (11*Mgl**9.*Mst1**2.*Mt**6.)/12.-

     &  (311*Mgl**7.*Mst1**4.*Mt**6.)/192.-

     &  (4*Mgl**5.*Mst1**6.*Mt**6.)/9.+

     &  (73*Mgl**3.*Mst1**8.*Mt**6.)/576.-

     &  (5*Mgl*Mst1**10.*Mt**6.)/9.+

     &  (41*Mst1**12.*Mt**6.)/(64.*Mgl**1.)-

     &  (61*Mst1**14.*Mt**6.)/(288.*Mgl**3.)-

     &  (487*Mgl**9.*Mt**8.)/576.-

     &  (67*Mgl**11.*Mt**8.)/(288.*Mst1**2.)+

     &  (293*Mgl**7.*Mst1**2.*Mt**8.)/576.+

     &  (9*Mgl**5.*Mst1**4.*Mt**8.)/8.+

     &  (9*Mgl**3.*Mst1**6.*Mt**8.)/16.+

     &  (265*Mgl*Mst1**8.*Mt**8.)/576.-

     &  (187*Mst1**10.*Mt**8.)/(576.*Mgl**1.)+

     &  (119*Mst1**12.*Mt**8.)/(288.*Mgl**3.)+

     &  (61*Mgl**7.*Mt**10.)/64.+

     &  (5*Mgl**9.*Mt**10.)/(32.*Mst1**2.)-

     &  (83*Mgl**5.*Mst1**2.*Mt**10.)/48.-

     &  (37*Mgl**3.*Mst1**4.*Mt**10.)/16.-

     &  (25*Mgl*Mst1**6.*Mt**10.)/16.-

     &  (25*Mst1**8.*Mt**10.)/(64.*Mgl**1.)-

     &  (133*Mst1**10.*Mt**10.)/(288.*Mgl**3.)-

     &  (31*Mgl**5.*Mt**12.)/64.+

     &  (Mgl**7.*Mt**12.)/(96.*Mst1**2.)+

     &  (275*Mgl**3.*Mst1**2.*Mt**12.)/192.+

     &  (917*Mgl*Mst1**4.*Mt**12.)/576.+

     &  (325*Mst1**6.*Mt**12.)/(576.*Mgl**1.)+

     &  (77*Mst1**8.*Mt**12.)/(288.*Mgl**3.)+

     &  (53*Mgl**3.*Mt**14.)/576.-

     &  (25*Mgl**5.*Mt**14.)/(288.*Mst1**2.)-

     &  (31*Mgl*Mst1**2.*Mt**14.)/72.-

     &  (35*Mst1**4.*Mt**14.)/(192.*Mgl**1.)-

     &  (7*Mst1**6.*Mt**14.)/(288.*Mgl**3.)-

     &  (17*Mgl*Mt**16.)/576.+

     &  (5*Mgl**3.*Mt**16.)/(96.*Mst1**2.)-

     &  (29*Mst1**2.*Mt**16.)/(576.*Mgl**1.)-

     &  (19*Mst1**4.*Mt**16.)/(288.*Mgl**3.)+

     &  (17*Mt**18.)/(576.*Mgl**1.)-

     &  (Mgl*Mt**18.)/(96.*Mst1**2.)+

     &  (11*Mst1**2.*Mt**18.)/(288.*Mgl**3.)-

     &  Mt**20./(144.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst1)**4.*

     &  Den(Mst1,Mst2)*ln(mu,Mst1)**2.+

     &  (0.031684027777777776+Mgl**2./(384.*Mst2**2.)-

     &  (29*Mst2**2.)/(1152.*Mgl**2.)+

     &  (5*Mst2**4.)/(768.*Mgl**4.)-

     &  Mgl**2./(576.*Mt**2.)+Mst2**2./(144.*Mt**2.)-

     &  Mst2**4./(192.*Mgl**2.*Mt**2.)-

     &  (5*Mt**2.)/(288.*Mgl**2.)+

     &  Mt**2./(576.*Mst2**2.)-

     &  (17*Mst2**2.*Mt**2.)/(1152.*Mgl**4.)+

     &  (23*Mt**4.)/(2304.*Mgl**4.)-

     &  Mt**4./(384.*Mgl**2.*Mst2**2.)-

     &  Mt**6./(576.*Mgl**4.*Mst2**2.))*ln(mu,Mst2)+

     &  ((-83*Mgl**4.)/2304.-Mgl**6./(384.*Mst2**2.)+

     &  (197*Mgl**2.*Mst2**2.)/1728.-

     &  (245*Mst2**4.)/3456.-

     &  (41*Mst2**6.)/(3456.*Mgl**2.)-

     &  (5*Mst2**8.)/(768.*Mgl**4.)+

     &  (13*Mgl**6.)/(576.*Mt**2.)-

     &  Mgl**8./(192.*Mst2**2.*Mt**2.)-

     &  (Mgl**4.*Mst2**2.)/(32.*Mt**2.)+

     &  (Mgl**2.*Mst2**4.)/(96.*Mt**2.)+

     &  (5*Mst2**6.)/(576.*Mt**2.)-

     &  Mst2**8./(192.*Mgl**2.*Mt**2.)+

     &  (197*Mgl**2.*Mt**2.)/3456.+

     &  (Mgl**4.*Mt**2.)/(64.*Mst2**2.)+

     &  (155*Mst2**2.*Mt**2.)/3456.+

     &  (7*Mst2**6.*Mt**2.)/(192.*Mgl**4.)+

     &  (5*Mt**4.)/1152.+

     &  (Mgl**2.*Mt**4.)/(576.*Mst2**2.)+

     &  (67*Mst2**2.*Mt**4.)/(1152.*Mgl**2.)-

     &  (83*Mst2**4.*Mt**4.)/(1152.*Mgl**4.)-

     &  (145*Mt**6.)/(3456.*Mgl**2.)-

     &  (7*Mt**6.)/(576.*Mst2**2.)+

     &  (Mst2**2.*Mt**6.)/(16.*Mgl**4.)-

     &  (17*Mt**8.)/(768.*Mgl**4.)+

     &  Mt**8./(1152.*Mgl**2.*Mst2**2.)+

     &  Mt**10./(576.*Mgl**4.*Mst2**2.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mst2)+

     &  (Mgl**8./384.-(5*Mgl**10.)/(576.*Mst2**2.)-

     &  (1745*Mgl**6.*Mst2**2.)/6912.+

     &  (3169*Mgl**4.*Mst2**4.)/6912.-

     &  (115*Mgl**2.*Mst2**6.)/384.+

     &  (113*Mst2**8.)/1728.+

     &  (227*Mst2**10.)/(6912.*Mgl**2.)+

     &  Mst2**12./(768.*Mgl**4.)-

     &  (11*Mgl**10.)/(288.*Mt**2.)+

     &  Mgl**12./(192.*Mst2**2.*Mt**2.)+

     &  (55*Mgl**8.*Mst2**2.)/(576.*Mt**2.)-

     &  (25*Mgl**6.*Mst2**4.)/(288.*Mt**2.)-

     &  (5*Mgl**4.*Mst2**6.)/(192.*Mt**2.)+

     &  (31*Mgl**2.*Mst2**8.)/(288.*Mt**2.)-

     &  (43*Mst2**10.)/(576.*Mt**2.)+

     &  (5*Mst2**12.)/(288.*Mgl**2.*Mt**2.)+

     &  (611*Mgl**6.*Mt**2.)/6912.-

     &  (5*Mgl**8.*Mt**2.)/(576.*Mst2**2.)+

     &  (491*Mgl**4.*Mst2**2.*Mt**2.)/1152.+

     &  (553*Mgl**2.*Mst2**4.*Mt**2.)/3456.-

     &  (253*Mst2**6.*Mt**2.)/864.-

     &  (773*Mst2**8.*Mt**2.)/(6912.*Mgl**2.)+

     &  (Mst2**10.*Mt**2.)/(384.*Mgl**4.)+

     &  (17*Mgl**4.*Mt**4.)/768.+

     &  (7*Mgl**6.*Mt**4.)/(576.*Mst2**2.)-

     &  (1073*Mgl**2.*Mst2**2.*Mt**4.)/3456.+

     &  (Mst2**4.*Mt**4.)/432.-

     &  (613*Mst2**6.*Mt**4.)/(3456.*Mgl**2.)-

     &  (11*Mst2**8.*Mt**4.)/(2304.*Mgl**4.)+

     &  (19*Mgl**2.*Mt**6.)/3456.+

     &  (Mgl**4.*Mt**6.)/(64.*Mst2**2.)+

     &  (427*Mst2**2.*Mt**6.)/864.+

     &  (1979*Mst2**4.*Mt**6.)/(3456.*Mgl**2.)-

     &  (19*Mst2**6.*Mt**6.)/(576.*Mgl**4.)-

     &  (35*Mt**8.)/192.-

     &  (7*Mgl**2.*Mt**8.)/(576.*Mst2**2.)-

     &  (2941*Mst2**2.*Mt**8.)/(6912.*Mgl**2.)+

     &  (21*Mst2**4.*Mt**8.)/(256.*Mgl**4.)+

     &  (575*Mt**10.)/(6912.*Mgl**2.)-

     &  (7*Mt**10.)/(576.*Mst2**2.)-

     &  (77*Mst2**2.*Mt**10.)/(1152.*Mgl**4.)+

     &  (43*Mt**12.)/(2304.*Mgl**4.)+

     &  (5*Mt**12.)/(576.*Mgl**2.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mst2)+

     &  ((125*Mgl**12.)/2304.-Mgl**14./(576.*Mst2**2.)+

     &  (173*Mgl**10.*Mst2**2.)/432.-

     &  (5225*Mgl**8.*Mst2**4.)/3456.+

     &  (1483*Mgl**6.*Mst2**6.)/864.-

     &  (959*Mgl**4.*Mst2**8.)/1728.-

     &  (47*Mgl**2.*Mst2**10.)/108.+

     &  (1553*Mst2**12.)/3456.-

     &  (61*Mst2**14.)/(576.*Mgl**2.)-

     &  (25*Mst2**16.)/(2304.*Mgl**4.)+

     &  Mgl**14./(144.*Mt**2.)-

     &  (Mgl**12.*Mst2**2.)/(24.*Mt**2.)+

     &  (7*Mgl**10.*Mst2**4.)/(72.*Mt**2.)-

     &  (7*Mgl**8.*Mst2**6.)/(72.*Mt**2.)+

     &  (7*Mgl**4.*Mst2**10.)/(72.*Mt**2.)-

     &  (7*Mgl**2.*Mst2**12.)/(72.*Mt**2.)+

     &  Mst2**14./(24.*Mt**2.)-

     &  Mst2**16./(144.*Mgl**2.*Mt**2.)-

     &  (377*Mgl**10.*Mt**2.)/1152.+

     &  (Mgl**12.*Mt**2.)/(192.*Mst2**2.)-

     &  (1805*Mgl**8.*Mst2**2.*Mt**2.)/3456.+

     &  (2371*Mgl**6.*Mst2**4.*Mt**2.)/1728.-

     &  (439*Mgl**4.*Mst2**6.*Mt**2.)/1728.+

     &  (761*Mgl**2.*Mst2**8.*Mt**2.)/3456.-

     &  (3857*Mst2**10.*Mt**2.)/3456.+

     &  (515*Mst2**12.*Mt**2.)/(864.*Mgl**2.)+

     &  (5*Mst2**14.*Mt**2.)/(192.*Mgl**4.)+

     &  (1543*Mgl**8.*Mt**4.)/3456.+

     &  (5*Mgl**10.*Mt**4.)/(576.*Mst2**2.)+

     &  (53*Mgl**6.*Mst2**2.*Mt**4.)/3456.+

     &  (1507*Mgl**4.*Mst2**4.*Mt**4.)/1728.+

     &  (23*Mgl**2.*Mst2**6.*Mt**4.)/96.+

     &  (2575*Mst2**8.*Mt**4.)/3456.-

     &  (1093*Mst2**10.*Mt**4.)/(1152.*Mgl**2.)+

     &  (5*Mst2**12.*Mt**4.)/(96.*Mgl**4.)+

     &  (131*Mgl**6.*Mt**6.)/3456.-

     &  (29*Mgl**8.*Mt**6.)/(576.*Mst2**2.)+

     &  (61*Mgl**4.*Mst2**2.*Mt**6.)/864.-

     &  (205*Mgl**2.*Mst2**4.*Mt**6.)/288.-

     &  (43*Mst2**6.*Mt**6.)/48.+

     &  (625*Mst2**8.*Mt**6.)/(3456.*Mgl**2.)-

     &  (145*Mst2**10.*Mt**6.)/(576.*Mgl**4.)-

     &  (43*Mgl**4.*Mt**8.)/96.+

     &  (35*Mgl**6.*Mt**8.)/(576.*Mst2**2.)+

     &  (343*Mgl**2.*Mst2**2.*Mt**8.)/576.+

     &  (5483*Mst2**4.*Mt**8.)/3456.+

     &  (401*Mst2**6.*Mt**8.)/(432.*Mgl**2.)+

     &  (125*Mst2**8.*Mt**8.)/(384.*Mgl**4.)+

     &  (851*Mgl**2.*Mt**10.)/3456.+

     &  (Mgl**4.*Mt**10.)/(576.*Mst2**2.)-

     &  (2869*Mst2**2.*Mt**10.)/3456.-

     &  (515*Mst2**4.*Mt**10.)/(576.*Mgl**2.)-

     &  (25*Mst2**6.*Mt**10.)/(192.*Mgl**4.)-

     &  (83*Mt**12.)/3456.-

     &  (11*Mgl**2.*Mt**12.)/(192.*Mst2**2.)+

     &  (809*Mst2**2.*Mt**12.)/(3456.*Mgl**2.)-

     &  (5*Mst2**4.*Mt**12.)/(72.*Mgl**4.)+

     &  (31*Mt**14.)/(1152.*Mgl**2.)+

     &  (25*Mt**14.)/(576.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**14.)/(64.*Mgl**4.)-

     &  (5*Mt**16.)/(256.*Mgl**4.)-

     &  Mt**16./(96.*Mgl**2.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**3.*ln(mu,Mst2)+

     &  ((-7*Mgl**16.)/768.-(2315*Mgl**14.*Mst2**2.)/6912.+

     &  (2015*Mgl**12.*Mst2**4.)/1152.-

     &  (3011*Mgl**10.*Mst2**6.)/864.+

     &  (11357*Mgl**8.*Mst2**8.)/3456.-

     &  (1105*Mgl**6.*Mst2**10.)/1152.-

     &  (1753*Mgl**4.*Mst2**12.)/1728.+

     &  (127*Mgl**2.*Mst2**14.)/108.-

     &  (1073*Mst2**16.)/2304.+

     &  (329*Mst2**18.)/(6912.*Mgl**2.)+

     &  (11*Mst2**20.)/(1152.*Mgl**4.)+

     &  (73*Mgl**14.*Mt**2.)/768.+

     &  (25*Mgl**12.*Mst2**2.*Mt**2.)/27.-

     &  (637*Mgl**10.*Mst2**4.*Mt**2.)/192.+

     &  (2245*Mgl**8.*Mst2**6.*Mt**2.)/576.-

     &  (7849*Mgl**6.*Mst2**8.*Mt**2.)/3456.+

     &  (1103*Mgl**4.*Mst2**10.*Mt**2.)/576.-

     &  (521*Mgl**2.*Mst2**12.*Mt**2.)/192.+

     &  (3265*Mst2**14.*Mt**2.)/1728.-

     &  (845*Mst2**16.*Mt**2.)/(2304.*Mgl**2.)-

     &  (31*Mst2**18.*Mt**2.)/(576.*Mgl**4.)-

     &  (361*Mgl**12.*Mt**4.)/1152.-

     &  (181*Mgl**10.*Mst2**2.*Mt**4.)/864.+

     &  (575*Mgl**8.*Mst2**4.*Mt**4.)/576.+

     &  (1415*Mgl**6.*Mst2**6.*Mt**4.)/1728.-

     &  (781*Mgl**4.*Mst2**8.*Mt**4.)/576.+

     &  (83*Mgl**2.*Mst2**10.*Mt**4.)/48.-

     &  (4895*Mst2**12.*Mt**4.)/1728.+

     &  (1847*Mst2**14.*Mt**4.)/(1728.*Mgl**2.)+

     &  (37*Mst2**16.*Mt**4.)/(384.*Mgl**4.)+

     &  (121*Mgl**10.*Mt**6.)/288.-

     &  (1043*Mgl**8.*Mst2**2.*Mt**6.)/576.+

     &  (101*Mgl**6.*Mst2**4.*Mt**6.)/288.+

     &  (695*Mgl**4.*Mst2**6.*Mt**6.)/864.+

     &  (13*Mgl**2.*Mst2**8.*Mt**6.)/288.+

     &  (1261*Mst2**10.*Mt**6.)/576.-

     &  (1217*Mst2**12.*Mt**6.)/(864.*Mgl**2.)+

     &  (Mst2**14.*Mt**6.)/(48.*Mgl**4.)-

     &  (121*Mgl**8.*Mt**8.)/1152.+

     &  (2747*Mgl**6.*Mst2**2.*Mt**8.)/1152.+

     &  (15*Mgl**4.*Mst2**4.*Mt**8.)/64.-

     &  (41*Mgl**2.*Mst2**6.*Mt**8.)/48.-

     &  (2147*Mst2**8.*Mt**8.)/1152.+

     &  (629*Mst2**10.*Mt**8.)/(1152.*Mgl**2.)-

     &  (21*Mst2**12.*Mt**8.)/(64.*Mgl**4.)-

     &  (373*Mgl**6.*Mt**10.)/1152.-

     &  (545*Mgl**4.*Mst2**2.*Mt**10.)/576.+

     &  (581*Mgl**2.*Mst2**4.*Mt**10.)/576.+

     &  (3743*Mst2**6.*Mt**10.)/1728.+

     &  (2293*Mst2**8.*Mt**10.)/(3456.*Mgl**2.)+

     &  (49*Mst2**10.*Mt**10.)/(96.*Mgl**4.)+

     &  (209*Mgl**4.*Mt**12.)/576.-

     &  (25*Mgl**2.*Mst2**2.*Mt**12.)/108.-

     &  (781*Mst2**4.*Mt**12.)/576.-

     &  (1405*Mst2**6.*Mt**12.)/(1728.*Mgl**2.)-

     &  (21*Mst2**8.*Mt**12.)/(64.*Mgl**4.)-

     &  (23*Mgl**2.*Mt**14.)/144.+

     &  (377*Mst2**2.*Mt**14.)/1728.+

     &  (17*Mst2**4.*Mt**14.)/(72.*Mgl**2.)+

     &  (Mst2**6.*Mt**14.)/(48.*Mgl**4.)+

     &  (127*Mt**16.)/2304.+

     &  (401*Mst2**2.*Mt**16.)/(6912.*Mgl**2.)+

     &  (37*Mst2**4.*Mt**16.)/(384.*Mgl**4.)-

     &  (73*Mt**18.)/(2304.*Mgl**2.)-

     &  (31*Mst2**2.*Mt**18.)/(576.*Mgl**4.)+

     &  (11*Mt**20.)/(1152.*Mgl**4.))*d123(Mt,Mgl,Mst2)**4.*

     &  ln(mu,Mst2)+

     &  ((-5*Mgl)/288.+Mst2**2./(96.*Mgl**1.)+

     &  (Mgl*Mt**2.)/(96.*Mst2**2.)-

     &  (Mst2**2.*Mt**2.)/(48.*Mgl**3.)+

     &  Mt**4./(36.*Mgl**3.)-

     &  Mt**4./(288.*Mgl**1.*Mst2**2.)-

     &  Mt**6./(144.*Mgl**3.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mst2)+

     &  ((7*Mgl**5.)/144.-Mgl**7./(48.*Mst2**2.)-

     &  (5*Mgl**3.*Mst2**2.)/144.+(Mgl*Mst2**4.)/144.-

     &  (167*Mgl**3.*Mt**2.)/1152.+

     &  (Mgl**5.*Mt**2.)/(96.*Mst2**2.)+

     &  (1997*Mgl*Mst2**2.*Mt**2.)/3456.+

     &  (917*Mst2**4.*Mt**2.)/(3456.*Mgl**1.)+

     &  (23*Mst2**6.*Mt**2.)/(3456.*Mgl**3.)+

     &  (1187*Mgl*Mt**4.)/3456.+

     &  (5*Mgl**3.*Mt**4.)/(96.*Mst2**2.)-

     &  (59*Mst2**2.*Mt**4.)/(1728.*Mgl**1.)-

     &  (71*Mst2**4.*Mt**4.)/(1152.*Mgl**3.)-

     &  (751*Mt**6.)/(3456.*Mgl**1.)-

     &  (13*Mgl*Mt**6.)/(288.*Mst2**2.)+

     &  (127*Mst2**2.*Mt**6.)/(1152.*Mgl**3.)-

     &  (215*Mt**8.)/(3456.*Mgl**3.)-

     &  Mt**8./(288.*Mgl**1.*Mst2**2.)+

     &  Mt**10./(144.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mst2)+

     &  ((-29*Mgl**9.)/288.+Mgl**11./(48.*Mst2**2.)+

     &  (5*Mgl**7.*Mst2**2.)/32.-

     &  (5*Mgl**5.*Mst2**4.)/144.-

     &  (5*Mgl**3.*Mst2**6.)/36.+(13*Mgl*Mst2**8.)/96.-

     &  (11*Mst2**10.)/(288.*Mgl**1.)+

     &  (Mgl**7.*Mt**2.)/64.-

     &  (Mgl**9.*Mt**2.)/(18.*Mst2**2.)-

     &  (39*Mgl**5.*Mst2**2.*Mt**2.)/64.+

     &  (277*Mgl**3.*Mst2**4.*Mt**2.)/288.-

     &  (17*Mgl*Mst2**6.*Mt**2.)/288.-

     &  (155*Mst2**8.*Mt**2.)/(576.*Mgl**1.)+

     &  (Mst2**10.*Mt**2.)/(64.*Mgl**3.)+

     &  (269*Mgl**5.*Mt**4.)/1728.+

     &  (Mgl**7.*Mt**4.)/(48.*Mst2**2.)+

     &  (361*Mgl**3.*Mst2**2.*Mt**4.)/432.+

     &  (317*Mgl*Mst2**4.*Mt**4.)/288.+

     &  (49*Mst2**6.*Mt**4.)/(144.*Mgl**1.)-

     &  (23*Mst2**8.*Mt**4.)/(192.*Mgl**3.)+

     &  (455*Mgl**3.*Mt**6.)/864.+

     &  (Mgl**5.*Mt**6.)/(36.*Mst2**2.)+

     &  (751*Mgl*Mst2**2.*Mt**6.)/864.+

     &  (715*Mst2**4.*Mt**6.)/(864.*Mgl**1.)+

     &  (61*Mst2**6.*Mt**6.)/(288.*Mgl**3.)-

     &  (431*Mgl*Mt**8.)/432.+

     &  (5*Mgl**3.*Mt**8.)/(144.*Mst2**2.)-

     &  (1073*Mst2**2.*Mt**8.)/(864.*Mgl**1.)-

     &  (7*Mst2**4.*Mt**8.)/(96.*Mgl**3.)+

     &  (599*Mt**10.)/(1728.*Mgl**1.)-

     &  (Mgl*Mt**10.)/(12.*Mst2**2.)-

     &  (17*Mst2**2.*Mt**10.)/(192.*Mgl**3.)+

     &  (31*Mt**12.)/(576.*Mgl**3.)+

     &  (5*Mt**12.)/(144.*Mgl**1.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mst2)+

     &  (Mgl**13./36.-(5*Mgl**11.*Mst2**2.)/36.+

     &  (Mgl**9.*Mst2**4.)/4.-(5*Mgl**7.*Mst2**6.)/36.-

     &  (5*Mgl**5.*Mst2**8.)/36.+(Mgl**3.*Mst2**10.)/4.-

     &  (5*Mgl*Mst2**12.)/36.+Mst2**14./(36.*Mgl**1.)+

     &  (199*Mgl**11.*Mt**2.)/1152.-

     &  (Mgl**13.*Mt**2.)/(144.*Mst2**2.)+

     &  (4985*Mgl**9.*Mst2**2.*Mt**2.)/3456.-

     &  (4237*Mgl**7.*Mst2**4.*Mt**2.)/1152.+

     &  (9701*Mgl**5.*Mst2**6.*Mt**2.)/3456.-

     &  (43*Mgl**3.*Mst2**8.*Mt**2.)/1152.-

     &  (1303*Mgl*Mst2**10.*Mt**2.)/1152.+

     &  (1363*Mst2**12.*Mt**2.)/(3456.*Mgl**1.)+

     &  (127*Mst2**14.*Mt**2.)/(3456.*Mgl**3.)-

     &  (529*Mgl**9.*Mt**4.)/384.+

     &  (Mgl**11.*Mt**4.)/(36.*Mst2**2.)-

     &  (4315*Mgl**7.*Mst2**2.*Mt**4.)/1728.+

     &  (14857*Mgl**5.*Mst2**4.*Mt**4.)/3456.+

     &  (61*Mgl**3.*Mst2**6.*Mt**4.)/96.+

     &  (3937*Mgl*Mst2**8.*Mt**4.)/3456.-

     &  (2767*Mst2**10.*Mt**4.)/(1728.*Mgl**1.)-

     &  (49*Mst2**12.*Mt**4.)/(3456.*Mgl**3.)+

     &  (1121*Mgl**7.*Mt**6.)/384.+

     &  (Mgl**9.*Mt**6.)/(144.*Mst2**2.)+

     &  (421*Mgl**5.*Mst2**2.*Mt**6.)/1152.-

     &  (107*Mgl**3.*Mst2**4.*Mt**6.)/192.-

     &  (929*Mgl*Mst2**6.*Mt**6.)/1728.+

     &  (3997*Mst2**8.*Mt**6.)/(3456.*Mgl**1.)-

     &  (157*Mst2**10.*Mt**6.)/(384.*Mgl**3.)-

     &  (8773*Mgl**5.*Mt**8.)/3456.-

     &  (5*Mgl**7.*Mt**8.)/(24.*Mst2**2.)+

     &  (2657*Mgl**3.*Mst2**2.*Mt**8.)/864.+

     &  (6589*Mgl*Mst2**4.*Mt**8.)/1728.+

     &  (1543*Mst2**6.*Mt**8.)/(864.*Mgl**1.)+

     &  (3355*Mst2**8.*Mt**8.)/(3456.*Mgl**3.)+

     &  (2671*Mgl**3.*Mt**10.)/3456.+

     &  (65*Mgl**5.*Mt**10.)/(144.*Mst2**2.)-

     &  (11537*Mgl*Mst2**2.*Mt**10.)/3456.-

     &  (9475*Mst2**4.*Mt**10.)/(3456.*Mgl**1.)-

     &  (2755*Mst2**6.*Mt**10.)/(3456.*Mgl**3.)-

     &  (25*Mgl*Mt**12.)/1152.-

     &  (4*Mgl**3.*Mt**12.)/(9.*Mst2**2.)+

     &  (1561*Mst2**2.*Mt**12.)/(1728.*Mgl**1.)+

     &  (37*Mst2**4.*Mt**12.)/(384.*Mgl**3.)+

     &  (403*Mt**14.)/(3456.*Mgl**1.)+

     &  (31*Mgl*Mt**14.)/(144.*Mst2**2.)+

     &  (649*Mst2**2.*Mt**14.)/(3456.*Mgl**3.)-

     &  (247*Mt**16.)/(3456.*Mgl**3.)-

     &  Mt**16./(24.*Mgl**1.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mst2)+

     &  ((-7*Mgl**15.*Mt**2.)/192.-

     &  (1189*Mgl**13.*Mst2**2.*Mt**2.)/864.+

     &  (607*Mgl**11.*Mst2**4.*Mt**2.)/108.-

     &  (599*Mgl**9.*Mst2**6.*Mt**2.)/72.+

     &  (4169*Mgl**7.*Mst2**8.*Mt**2.)/864.+

     &  (427*Mgl**5.*Mst2**10.*Mt**2.)/432.-

     &  (221*Mgl**3.*Mst2**12.*Mt**2.)/72.+

     &  (353*Mgl*Mst2**14.*Mt**2.)/216.-

     &  (395*Mst2**16.*Mt**2.)/(1728.*Mgl**1.)-

     &  (11*Mst2**18.*Mt**2.)/(288.*Mgl**3.)+

     &  (5*Mgl**13.*Mt**4.)/12.+

     &  (1583*Mgl**11.*Mst2**2.*Mt**4.)/288.-

     &  (11573*Mgl**9.*Mst2**4.*Mt**4.)/864.+

     &  (9085*Mgl**7.*Mst2**6.*Mt**4.)/864.-

     &  (2933*Mgl**5.*Mst2**8.*Mt**4.)/864.+

     &  (2831*Mgl**3.*Mst2**10.*Mt**4.)/864.-

     &  (3895*Mgl*Mst2**12.*Mt**4.)/864.+

     &  (1223*Mst2**14.*Mt**4.)/(864.*Mgl**1.)+

     &  (17*Mst2**16.*Mt**4.)/(96.*Mgl**3.)-

     &  (481*Mgl**11.*Mt**6.)/288.-

     &  (1729*Mgl**9.*Mst2**2.*Mt**6.)/216.+

     &  (8107*Mgl**7.*Mst2**4.*Mt**6.)/864.+

     &  (463*Mgl**5.*Mst2**6.*Mt**6.)/216.+

     &  (11*Mgl**3.*Mst2**8.*Mt**6.)/96.+

     &  (811*Mgl*Mst2**10.*Mt**6.)/216.-

     &  (2651*Mst2**12.*Mt**6.)/(864.*Mgl**1.)-

     &  (5*Mst2**14.*Mt**6.)/(24.*Mgl**3.)+

     &  (965*Mgl**9.*Mt**8.)/288.+

     &  (3553*Mgl**7.*Mst2**2.*Mt**8.)/864.-

     &  (557*Mgl**5.*Mst2**4.*Mt**8.)/144.-

     &  (1207*Mgl**3.*Mst2**6.*Mt**8.)/432.-

     &  (2357*Mgl*Mst2**8.*Mt**8.)/864.+

     &  (655*Mst2**10.*Mt**8.)/(288.*Mgl**1.)-

     &  (7*Mst2**12.*Mt**8.)/(24.*Mgl**3.)-

     &  (181*Mgl**7.*Mt**10.)/48.+

     &  (715*Mgl**5.*Mst2**2.*Mt**10.)/432.+

     &  (2791*Mgl**3.*Mst2**4.*Mt**10.)/432.+

     &  (1261*Mgl*Mst2**6.*Mt**10.)/216.+

     &  (10*Mst2**8.*Mt**10.)/(9.*Mgl**1.)+

     &  (49*Mst2**10.*Mt**10.)/(48.*Mgl**3.)+

     &  (713*Mgl**5.*Mt**12.)/288.-

     &  (2561*Mgl**3.*Mst2**2.*Mt**12.)/864.-

     &  (4657*Mgl*Mst2**4.*Mt**12.)/864.-

     &  (2215*Mst2**6.*Mt**12.)/(864.*Mgl**1.)-

     &  (49*Mst2**8.*Mt**12.)/(48.*Mgl**3.)-

     &  (295*Mgl**3.*Mt**14.)/288.+

     &  (73*Mgl*Mst2**2.*Mt**14.)/72.+

     &  (847*Mst2**4.*Mt**14.)/(864.*Mgl**1.)+

     &  (7*Mst2**6.*Mt**14.)/(24.*Mgl**3.)+

     &  (37*Mgl*Mt**16.)/96.+

     &  (211*Mst2**2.*Mt**16.)/(864.*Mgl**1.)+

     &  (5*Mst2**4.*Mt**16.)/(24.*Mgl**3.)-

     &  (95*Mt**18.)/(576.*Mgl**1.)-

     &  (17*Mst2**2.*Mt**18.)/(96.*Mgl**3.)+

     &  (11*Mt**20.)/(288.*Mgl**3.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mst2)+

     &  (0.030381944444444444-Mst2**2./(1152.*Mgl**2.)+

     &  Mt**2./(1152.*Mgl**2.))*ln(mu,Mgl)*ln(mu,Mst2)+

     &  ((-17*Mgl**4.)/288.+(5*Mgl**6.)/(1152.*Mst2**2.)+

     &  (11*Mgl**2.*Mst2**2.)/96.-(65*Mst2**4.)/576.+

     &  (13*Mst2**6.)/(1152.*Mgl**2.)-

     &  (13*Mgl**2.*Mt**2.)/384.-

     &  (5*Mgl**4.*Mt**2.)/(1152.*Mst2**2.)+

     &  (79*Mst2**2.*Mt**2.)/1152.-

     &  (Mst2**4.*Mt**2.)/(128.*Mgl**2.)-Mt**4./576.-

     &  (5*Mgl**2.*Mt**4.)/(1152.*Mst2**2.)-

     &  (7*Mst2**2.*Mt**4.)/(384.*Mgl**2.)+

     &  (17*Mt**6.)/(1152.*Mgl**2.)+

     &  (5*Mt**6.)/(1152.*Mst2**2.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mgl)*ln(mu,Mst2)+

     &  ((29*Mgl**8.)/576.-(5*Mgl**10.)/(1152.*Mst2**2.)-

     &  (301*Mgl**6.*Mst2**2.)/1152.+

     &  (29*Mgl**4.*Mst2**4.)/72.-

     &  (343*Mgl**2.*Mst2**6.)/1152.+(71*Mst2**8.)/576.-

     &  (5*Mst2**10.)/(384.*Mgl**2.)-

     &  (53*Mgl**6.*Mt**2.)/1152.+

     &  (37*Mgl**8.*Mt**2.)/(1152.*Mst2**2.)-

     &  (Mgl**4.*Mst2**2.*Mt**2.)/36.+

     &  (115*Mgl**2.*Mst2**4.*Mt**2.)/576.-

     &  (221*Mst2**6.*Mt**2.)/1152.+

     &  (55*Mst2**8.*Mt**2.)/(1152.*Mgl**2.)-

     &  (19*Mgl**4.*Mt**4.)/576.-

     &  (5*Mgl**6.*Mt**4.)/(192.*Mst2**2.)-

     &  (13*Mgl**2.*Mst2**2.*Mt**4.)/288.+

     &  (19*Mst2**4.*Mt**4.)/576.-

     &  (23*Mst2**6.*Mt**4.)/(576.*Mgl**2.)-

     &  (19*Mgl**2.*Mt**6.)/576.-

     &  (17*Mgl**4.*Mt**6.)/(576.*Mst2**2.)-

     &  (Mst2**2.*Mt**6.)/144.-

     &  (7*Mst2**4.*Mt**6.)/(192.*Mgl**2.)+

     &  (13*Mt**8.)/288.+

     &  (35*Mgl**2.*Mt**8.)/(1152.*Mst2**2.)+

     &  (77*Mst2**2.*Mt**8.)/(1152.*Mgl**2.)-

     &  (29*Mt**10.)/(1152.*Mgl**2.)-

     &  Mt**10./(384.*Mst2**2.))*d123(Mt,Mgl,Mst2)**2.*

     &  ln(mu,Mgl)*ln(mu,Mst2)+

     &  (-Mgl**12./128.-Mgl**14./(144.*Mst2**2.)+

     &  (251*Mgl**10.*Mst2**2.)/1152.-

     &  (607*Mgl**8.*Mst2**4.)/1152.+

     &  (565*Mgl**6.*Mst2**6.)/1152.-

     &  (85*Mgl**4.*Mst2**8.)/384.+

     &  (31*Mgl**2.*Mst2**10.)/384.-

     &  (25*Mst2**12.)/1152.-

     &  (5*Mst2**14.)/(1152.*Mgl**2.)+

     &  (67*Mgl**10.*Mt**2.)/1152.-

     &  (71*Mgl**8.*Mst2**2.*Mt**2.)/192.+

     &  (379*Mgl**6.*Mst2**4.*Mt**2.)/1152.+

     &  (Mgl**4.*Mst2**6.*Mt**2.)/48.-

     &  (107*Mgl**2.*Mst2**8.*Mt**2.)/1152.+

     &  (11*Mst2**10.*Mt**2.)/192.-

     &  (Mst2**12.*Mt**2.)/(384.*Mgl**2.)+

     &  (5*Mgl**8.*Mt**4.)/1152.+

     &  (Mgl**10.*Mt**4.)/(18.*Mst2**2.)+

     &  (151*Mgl**6.*Mst2**2.*Mt**4.)/1152.+

     &  (259*Mgl**4.*Mst2**4.*Mt**4.)/576.+

     &  (3*Mgl**2.*Mst2**6.*Mt**4.)/64.+

     &  (61*Mst2**8.*Mt**4.)/1152.+

     &  (25*Mst2**10.*Mt**4.)/(384.*Mgl**2.)+

     &  (97*Mgl**6.*Mt**6.)/1152.-

     &  (7*Mgl**8.*Mt**6.)/(144.*Mst2**2.)+

     &  (25*Mgl**4.*Mst2**2.*Mt**6.)/144.+

     &  (13*Mgl**2.*Mst2**4.*Mt**6.)/192.-

     &  (7*Mst2**6.*Mt**6.)/32.-

     &  (155*Mst2**8.*Mt**6.)/(1152.*Mgl**2.)-

     &  (157*Mgl**4.*Mt**8.)/384.-

     &  (Mgl**6.*Mt**8.)/(16.*Mst2**2.)-

     &  (145*Mgl**2.*Mst2**2.*Mt**8.)/384.+

     &  (43*Mst2**4.*Mt**8.)/384.+

     &  (35*Mst2**6.*Mt**8.)/(384.*Mgl**2.)+

     &  (301*Mgl**2.*Mt**10.)/1152.+

     &  (5*Mgl**4.*Mt**10.)/(72.*Mst2**2.)+

     &  (25*Mst2**2.*Mt**10.)/576.+

     &  (5*Mst2**4.*Mt**10.)/(384.*Mgl**2.)-

     &  (5*Mt**12.)/1152.+

     &  (Mgl**2.*Mt**12.)/(72.*Mst2**2.)-

     &  (47*Mst2**2.*Mt**12.)/(1152.*Mgl**2.)+

     &  (5*Mt**14.)/(384.*Mgl**2.)-Mt**14./(48.*Mst2**2.))

     &  *d123(Mt,Mgl,Mst2)**3.*ln(mu,Mgl)*ln(mu,Mst2)+

     &  (-Mgl**16./192.+Mgl**18./(144.*Mst2**2.)-

     &  (5*Mgl**14.*Mst2**2.)/36.+

     &  (73*Mgl**12.*Mst2**4.)/144.-

     &  (113*Mgl**10.*Mst2**6.)/144.+

     &  (191*Mgl**8.*Mst2**8.)/288.-

     &  (53*Mgl**6.*Mst2**10.)/144.+

     &  (25*Mgl**4.*Mst2**12.)/144.-

     &  (Mgl**2.*Mst2**14.)/18.-Mst2**16./192.+

     &  Mst2**18./(144.*Mgl**2.)+

     &  (7*Mgl**14.*Mt**2.)/576.-

     &  (19*Mgl**16.*Mt**2.)/(576.*Mst2**2.)+

     &  (7*Mgl**12.*Mst2**2.*Mt**2.)/18.-

     &  (545*Mgl**10.*Mst2**4.*Mt**2.)/576.+

     &  (43*Mgl**8.*Mst2**6.*Mt**2.)/48.-

     &  (17*Mgl**6.*Mst2**8.*Mt**2.)/64.-

     &  (35*Mgl**4.*Mst2**10.*Mt**2.)/144.+

     &  (137*Mgl**2.*Mst2**12.*Mt**2.)/576.-

     &  (5*Mst2**14.*Mt**2.)/576.-

     &  (11*Mst2**16.*Mt**2.)/(288.*Mgl**2.)-

     &  (5*Mgl**12.*Mt**4.)/48.+

     &  (13*Mgl**14.*Mt**4.)/(288.*Mst2**2.)-

     &  (49*Mgl**10.*Mst2**2.*Mt**4.)/288.+

     &  (4*Mgl**8.*Mst2**4.*Mt**4.)/9.+

     &  (53*Mgl**6.*Mst2**6.*Mt**4.)/288.-

     &  (29*Mgl**4.*Mst2**8.*Mt**4.)/144.-

     &  (103*Mgl**2.*Mst2**10.*Mt**4.)/288.+

     &  (Mst2**12.*Mt**4.)/12.+

     &  (11*Mst2**14.*Mt**4.)/(144.*Mgl**2.)+

     &  (233*Mgl**10.*Mt**6.)/576.-

     &  (Mgl**12.*Mt**6.)/(288.*Mst2**2.)-

     &  (2*Mgl**8.*Mst2**2.*Mt**6.)/9.+

     &  (Mgl**6.*Mst2**4.*Mt**6.)/288.+

     &  (23*Mgl**4.*Mst2**6.*Mt**6.)/96.+

     &  (19*Mgl**2.*Mst2**8.*Mt**6.)/192.-

     &  (5*Mst2**10.*Mt**6.)/36.-

     &  (7*Mst2**12.*Mt**6.)/(144.*Mgl**2.)-

     &  (125*Mgl**8.*Mt**8.)/288.-

     &  (Mgl**10.*Mt**8.)/(96.*Mst2**2.)+

     &  (73*Mgl**6.*Mst2**2.*Mt**8.)/144.+

     &  (89*Mgl**4.*Mst2**4.*Mt**8.)/144.+

     &  (143*Mgl**2.*Mst2**6.*Mt**8.)/288.+

     &  (3*Mst2**8.*Mt**8.)/32.-

     &  (7*Mst2**10.*Mt**8.)/(144.*Mgl**2.)-

     &  (49*Mgl**6.*Mt**10.)/576.-

     &  (Mgl**8.*Mt**10.)/(24.*Mst2**2.)-

     &  (11*Mgl**4.*Mst2**2.*Mt**10.)/12.-

     &  (485*Mgl**2.*Mst2**4.*Mt**10.)/576.-

     &  (11*Mst2**6.*Mt**10.)/288.+

     &  (7*Mst2**8.*Mt**10.)/(72.*Mgl**2.)+

     &  (13*Mgl**4.*Mt**12.)/48.+

     &  (7*Mgl**6.*Mt**12.)/(288.*Mst2**2.)+

     &  (139*Mgl**2.*Mst2**2.*Mt**12.)/288.-

     &  (7*Mst2**6.*Mt**12.)/(144.*Mgl**2.)+

     &  (Mgl**2.*Mt**14.)/192.+

     &  (17*Mgl**4.*Mt**14.)/(288.*Mst2**2.)+

     &  (Mst2**2.*Mt**14.)/18.-

     &  (Mst2**4.*Mt**14.)/(144.*Mgl**2.)-

     &  (35*Mt**16.)/576.-

     &  (19*Mgl**2.*Mt**16.)/(288.*Mst2**2.)+

     &  (Mst2**2.*Mt**16.)/(72.*Mgl**2.)-

     &  Mt**18./(288.*Mgl**2.)+

     &  (11*Mt**18.)/(576.*Mst2**2.))*d123(Mt,Mgl,Mst2)**4.*

     &  ln(mu,Mgl)*ln(mu,Mst2)+

     &  (Mt**2.*Xt*Den(Mst1,Mst2)*ln(mu,Mgl)*ln(mu,Mst2))/

     &  (288.*Mgl**1.)+

     &  ((-43*Mgl**3.*Mt**2.)/192.+

     &  (5*Mgl**5.*Mt**2.)/(288.*Mst2**2.)+

     &  (91*Mgl*Mst2**2.*Mt**2.)/288.-

     &  (5*Mst2**4.*Mt**2.)/(192.*Mgl**1.)+

     &  (Mgl*Mt**4.)/36.-

     &  (5*Mgl**3.*Mt**4.)/(144.*Mst2**2.)-

     &  (Mst2**2.*Mt**4.)/(96.*Mgl**1.)+

     &  (7*Mt**6.)/(192.*Mgl**1.)+

     &  (5*Mgl*Mt**6.)/(288.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst2)+

     &  ((31*Mgl**7.*Mt**2.)/144.-

     &  (5*Mgl**9.*Mt**2.)/(288.*Mst2**2.)-

     &  (223*Mgl**5.*Mst2**2.*Mt**2.)/288.+

     &  (107*Mgl**3.*Mst2**4.*Mt**2.)/96.-

     &  (41*Mgl*Mst2**6.*Mt**2.)/72.+

     &  (Mst2**8.*Mt**2.)/(32.*Mgl**1.)-

     &  (47*Mgl**5.*Mt**4.)/144.+

     &  (7*Mgl**7.*Mt**4.)/(48.*Mst2**2.)+

     &  (11*Mgl**3.*Mst2**2.*Mt**4.)/288.+

     &  (23*Mgl*Mst2**4.*Mt**4.)/48.-

     &  (29*Mst2**6.*Mt**4.)/(288.*Mgl**1.)-

     &  (7*Mgl**3.*Mt**6.)/144.-

     &  (Mgl**5.*Mt**6.)/(4.*Mst2**2.)+

     &  (Mgl*Mst2**2.*Mt**6.)/32.+

     &  (Mst2**4.*Mt**6.)/(32.*Mgl**1.)+

     &  (11*Mgl*Mt**8.)/72.+

     &  (19*Mgl**3.*Mt**8.)/(144.*Mst2**2.)+

     &  (11*Mst2**2.*Mt**8.)/(96.*Mgl**1.)-

     &  (11*Mt**10.)/(144.*Mgl**1.)-

     &  (Mgl*Mt**10.)/(96.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst2)+

     &  ((-13*Mgl**11.*Mt**2.)/576.-

     &  (Mgl**13.*Mt**2.)/(36.*Mst2**2.)+

     &  (181*Mgl**9.*Mst2**2.*Mt**2.)/288.-

     &  (715*Mgl**7.*Mst2**4.*Mt**2.)/576.+

     &  (131*Mgl**5.*Mst2**6.*Mt**2.)/144.-

     &  (179*Mgl**3.*Mst2**8.*Mt**2.)/576.+

     &  (13*Mgl*Mst2**10.*Mt**2.)/288.+

     &  (11*Mst2**12.*Mt**2.)/(576.*Mgl**1.)+

     &  (7*Mgl**9.*Mt**4.)/144.+

     &  (Mgl**11.*Mt**4.)/(36.*Mst2**2.)-

     &  (161*Mgl**7.*Mst2**2.*Mt**4.)/144.+

     &  (49*Mgl**5.*Mst2**4.*Mt**4.)/36.+

     &  (Mgl**3.*Mst2**6.*Mt**4.)/8.-

     &  (19*Mgl*Mst2**8.*Mt**4.)/144.+

     &  (Mst2**10.*Mt**4.)/(48.*Mgl**1.)+

     &  (455*Mgl**7.*Mt**6.)/576.+

     &  (7*Mgl**9.*Mt**6.)/(36.*Mst2**2.)+

     &  (15*Mgl**5.*Mst2**2.*Mt**6.)/16.+

     &  (35*Mgl**3.*Mst2**4.*Mt**6.)/96.-

     &  (7*Mgl*Mst2**6.*Mt**6.)/48.-

     &  (43*Mst2**8.*Mt**6.)/(192.*Mgl**1.)-

     &  (125*Mgl**5.*Mt**8.)/72.-

     &  (7*Mgl**7.*Mt**8.)/(18.*Mst2**2.)-

     &  (17*Mgl**3.*Mst2**2.*Mt**8.)/18.+

     &  (Mgl*Mst2**4.*Mt**8.)/4.+

     &  (11*Mst2**6.*Mt**8.)/(36.*Mgl**1.)+

     &  (553*Mgl**3.*Mt**10.)/576.+

     &  (5*Mgl**5.*Mt**10.)/(36.*Mst2**2.)+

     &  (5*Mgl*Mst2**2.*Mt**10.)/32.-

     &  (13*Mst2**4.*Mt**10.)/(192.*Mgl**1.)-

     &  (13*Mgl*Mt**12.)/144.+

     &  (5*Mgl**3.*Mt**12.)/(36.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**12.)/(48.*Mgl**1.)+

     &  (29*Mt**14.)/(576.*Mgl**1.)-

     &  (Mgl*Mt**14.)/(12.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst2)+

     &  ((Mgl**15.*Mt**2.)/144.+

     &  (Mgl**17.*Mt**2.)/(36.*Mst2**2.)-

     &  (79*Mgl**13.*Mst2**2.*Mt**2.)/144.+

     &  (71*Mgl**11.*Mst2**4.*Mt**2.)/48.-

     &  (239*Mgl**9.*Mst2**6.*Mt**2.)/144.+

     &  (143*Mgl**7.*Mst2**8.*Mt**2.)/144.-

     &  (23*Mgl**5.*Mst2**10.*Mt**2.)/48.+

     &  (31*Mgl**3.*Mst2**12.*Mt**2.)/144.-

     &  (Mgl*Mst2**14.*Mt**2.)/144.-

     &  (Mst2**16.*Mt**2.)/(36.*Mgl**1.)-

     &  (17*Mgl**13.*Mt**4.)/144.-

     &  (23*Mgl**15.*Mt**4.)/(144.*Mst2**2.)+

     &  (143*Mgl**11.*Mst2**2.*Mt**4.)/72.-

     &  (59*Mgl**9.*Mst2**4.*Mt**4.)/18.+

     &  (283*Mgl**7.*Mst2**6.*Mt**4.)/144.-

     &  (13*Mgl**5.*Mst2**8.*Mt**4.)/144.-

     &  (7*Mgl**3.*Mst2**10.*Mt**4.)/12.+

     &  (11*Mgl*Mst2**12.*Mt**4.)/72.+

     &  (Mst2**14.*Mt**4.)/(8.*Mgl**1.)+

     &  (Mgl**11.*Mt**6.)/24.+

     &  (49*Mgl**13.*Mt**6.)/(144.*Mst2**2.)-

     &  (21*Mgl**9.*Mst2**2.*Mt**6.)/8.+

     &  (175*Mgl**7.*Mst2**4.*Mt**6.)/72.+

     &  (173*Mgl**5.*Mst2**6.*Mt**6.)/144.+

     &  (35*Mgl**3.*Mst2**8.*Mt**6.)/72.-

     &  (13*Mgl*Mst2**10.*Mt**6.)/36.-

     &  (13*Mst2**12.*Mt**6.)/(72.*Mgl**1.)+

     &  (11*Mgl**9.*Mt**8.)/9.-

     &  (17*Mgl**11.*Mt**8.)/(48.*Mst2**2.)+

     &  (71*Mgl**7.*Mst2**2.*Mt**8.)/24.+

     &  (13*Mgl**5.*Mst2**4.*Mt**8.)/24.+

     &  (43*Mgl**3.*Mst2**6.*Mt**8.)/144.+

     &  (5*Mgl*Mst2**8.*Mt**8.)/24.+

     &  (Mst2**10.*Mt**8.)/(72.*Mgl**1.)-

     &  (127*Mgl**7.*Mt**10.)/48.+

     &  (5*Mgl**9.*Mt**10.)/(16.*Mst2**2.)-

     &  (515*Mgl**5.*Mst2**2.*Mt**10.)/144.-

     &  (79*Mgl**3.*Mst2**4.*Mt**10.)/48.+

     &  (Mgl*Mst2**6.*Mt**10.)/24.+

     &  (5*Mst2**8.*Mt**10.)/(24.*Mgl**1.)+

     &  (263*Mgl**5.*Mt**12.)/144.-

     &  (23*Mgl**7.*Mt**12.)/(48.*Mst2**2.)+

     &  (125*Mgl**3.*Mst2**2.*Mt**12.)/72.+

     &  (Mgl*Mst2**4.*Mt**12.)/72.-

     &  (13*Mst2**6.*Mt**12.)/(72.*Mgl**1.)-

     &  (Mgl**3.*Mt**14.)/6.+

     &  (83*Mgl**5.*Mt**14.)/(144.*Mst2**2.)+

     &  (Mgl*Mst2**2.*Mt**14.)/36.+

     &  (Mst2**4.*Mt**14.)/(72.*Mgl**1.)-

     &  (11*Mgl*Mt**16.)/72.-

     &  (49*Mgl**3.*Mt**16.)/(144.*Mst2**2.)+

     &  (Mst2**2.*Mt**16.)/(24.*Mgl**1.)-

     &  Mt**18./(72.*Mgl**1.)+

     &  (11*Mgl*Mt**18.)/(144.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mst2)+

     &  (0.01171875-(11*Mst2**2.)/(2304.*Mgl**2.)+

     &  Mst2**4./(1152.*Mgl**4.)+

     &  (7*Mt**2.)/(576.*Mgl**2.)-

     &  (Mst2**2.*Mt**2.)/(768.*Mgl**4.)+

     &  Mt**4./(2304.*Mgl**4.))*ln(mu,Mst2)**2.+

     &  ((-5*Mgl**4.)/256.+(173*Mgl**2.*Mst2**2.)/2304.-

     &  (103*Mst2**4.)/2304.+

     &  (29*Mst2**6.)/(2304.*Mgl**2.)-

     &  Mst2**8./(384.*Mgl**4.)+(5*Mgl**2.*Mt**2.)/192.+

     &  (221*Mst2**2.*Mt**2.)/2304.-

     &  (23*Mst2**4.*Mt**2.)/(576.*Mgl**2.)+

     &  (25*Mst2**6.*Mt**2.)/(2304.*Mgl**4.)+

     &  (13*Mt**4.)/576.+

     &  (131*Mst2**2.*Mt**4.)/(2304.*Mgl**2.)-

     &  (13*Mst2**4.*Mt**4.)/(768.*Mgl**4.)-

     &  (17*Mt**6.)/(576.*Mgl**2.)+

     &  (3*Mst2**2.*Mt**6.)/(256.*Mgl**4.)-

     &  (7*Mt**8.)/(2304.*Mgl**4.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mst2)**2.+

     &  (Mgl**8./256.-Mgl**10./(576.*Mst2**2.)-

     &  (221*Mgl**6.*Mst2**2.)/2304.+

     &  (101*Mgl**4.*Mst2**4.)/576.-

     &  (121*Mgl**2.*Mst2**6.)/1152.+

     &  (41*Mst2**8.)/2304.+

     &  (11*Mst2**10.)/(2304.*Mgl**2.)+

     &  Mst2**12./(1152.*Mgl**4.)-

     &  (43*Mgl**6.*Mt**2.)/2304.+

     &  (Mgl**8.*Mt**2.)/(384.*Mst2**2.)+

     &  (293*Mgl**4.*Mst2**2.*Mt**2.)/2304.+

     &  (149*Mgl**2.*Mst2**4.*Mt**2.)/1152.-

     &  (31*Mst2**6.*Mt**2.)/192.+

     &  (13*Mst2**8.*Mt**2.)/(2304.*Mgl**2.)-

     &  (19*Mst2**10.*Mt**2.)/(2304.*Mgl**4.)+

     &  (9*Mgl**4.*Mt**4.)/256.+

     &  (Mgl**6.*Mt**4.)/(576.*Mst2**2.)+

     &  (49*Mgl**2.*Mst2**2.*Mt**4.)/1152.+

     &  (53*Mst2**4.*Mt**4.)/288.-

     &  (71*Mst2**6.*Mt**4.)/(1152.*Mgl**2.)+

     &  (71*Mst2**8.*Mt**4.)/(2304.*Mgl**4.)+

     &  (Mgl**2.*Mt**6.)/576.-

     &  (Mgl**4.*Mt**6.)/(288.*Mst2**2.)+

     &  (Mst2**2.*Mt**6.)/1152.+

     &  (29*Mst2**4.*Mt**6.)/(288.*Mgl**2.)-

     &  (67*Mst2**6.*Mt**6.)/(1152.*Mgl**4.)-

     &  (97*Mt**8.)/2304.-

     &  (145*Mst2**2.*Mt**8.)/(2304.*Mgl**2.)+

     &  (17*Mst2**4.*Mt**8.)/(288.*Mgl**4.)+

     &  (31*Mt**10.)/(2304.*Mgl**2.)+

     &  Mt**10./(1152.*Mst2**2.)-

     &  (71*Mst2**2.*Mt**10.)/(2304.*Mgl**4.)+

     &  (5*Mt**12.)/(768.*Mgl**4.))*d123(Mt,Mgl,Mst2)**2.*

     &  ln(mu,Mst2)**2.+

     &  (-Mgl**12./2304.+Mgl**14./(288.*Mst2**2.)+

     &  (227*Mgl**10.*Mst2**2.)/2304.-

     &  (817*Mgl**8.*Mst2**4.)/2304.+

     &  (881*Mgl**6.*Mst2**6.)/2304.-

     &  (109*Mgl**4.*Mst2**8.)/2304.-

     &  (403*Mgl**2.*Mst2**10.)/2304.+

     &  (281*Mst2**12.)/2304.-

     &  (73*Mst2**14.)/(2304.*Mgl**2.)+

     &  Mst2**16./(384.*Mgl**4.)-

     &  (31*Mgl**10.*Mt**2.)/1152.-

     &  (Mgl**12.*Mt**2.)/(72.*Mst2**2.)-

     &  (127*Mgl**8.*Mst2**2.*Mt**2.)/768.+

     &  (113*Mgl**6.*Mst2**4.*Mt**2.)/384.-

     &  (31*Mgl**4.*Mst2**6.*Mt**2.)/2304.-

     &  (Mgl**2.*Mst2**8.*Mt**2.)/1152.-

     &  (443*Mst2**10.*Mt**2.)/2304.+

     &  (157*Mst2**12.*Mt**2.)/(1152.*Mgl**2.)-

     &  (41*Mst2**14.*Mt**2.)/(2304.*Mgl**4.)+

     &  (7*Mgl**8.*Mt**4.)/144.+

     &  (Mgl**10.*Mt**4.)/(72.*Mst2**2.)+

     &  (103*Mgl**6.*Mst2**2.*Mt**4.)/2304.+

     &  (175*Mgl**4.*Mst2**4.*Mt**4.)/2304.+

     &  (7*Mgl**2.*Mst2**6.*Mt**4.)/1152.-

     &  (29*Mst2**8.*Mt**4.)/1152.-

     &  (151*Mst2**10.*Mt**4.)/(768.*Mgl**2.)+

     &  (107*Mst2**12.*Mt**4.)/(2304.*Mgl**4.)+

     &  (37*Mgl**6.*Mt**6.)/1152.+

     &  (Mgl**8.*Mt**6.)/(96.*Mst2**2.)-

     &  (Mgl**4.*Mst2**2.*Mt**6.)/256.+

     &  (Mgl**2.*Mst2**4.*Mt**6.)/576.+

     &  (11*Mst2**6.*Mt**6.)/1152.+

     &  (77*Mst2**8.*Mt**6.)/(1152.*Mgl**2.)-

     &  (13*Mst2**10.*Mt**6.)/(256.*Mgl**4.)-

     &  (113*Mgl**4.*Mt**8.)/1152.-

     &  (7*Mgl**6.*Mt**8.)/(288.*Mst2**2.)+

     &  (277*Mgl**2.*Mst2**2.*Mt**8.)/2304.+

     &  (481*Mst2**4.*Mt**8.)/2304.+

     &  (21*Mst2**6.*Mt**8.)/(256.*Mgl**2.)-

     &  (5*Mst2**8.*Mt**8.)/(2304.*Mgl**4.)+

     &  (47*Mgl**2.*Mt**10.)/1152.+

     &  (Mgl**4.*Mt**10.)/(144.*Mst2**2.)-

     &  (275*Mst2**2.*Mt**10.)/2304.-

     &  (23*Mst2**4.*Mt**10.)/(384.*Mgl**2.)+

     &  (149*Mst2**6.*Mt**10.)/(2304.*Mgl**4.)+

     &  (Mgl**2.*Mt**12.)/(144.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**12.)/(768.*Mgl**2.)-

     &  (53*Mst2**4.*Mt**12.)/(768.*Mgl**4.)+

     &  (11*Mt**14.)/(1152.*Mgl**2.)-

     &  Mt**14./(288.*Mst2**2.)+

     &  (73*Mst2**2.*Mt**14.)/(2304.*Mgl**4.)-

     &  (13*Mt**16.)/(2304.*Mgl**4.))*d123(Mt,Mgl,Mst2)**3.*

     &  ln(mu,Mst2)**2.+

     &  ((5*Mgl**16.)/1152.-Mgl**18./(576.*Mst2**2.)-

     &  (43*Mgl**14.*Mst2**2.)/576.+

     &  (221*Mgl**12.*Mst2**4.)/576.-

     &  (19*Mgl**10.*Mst2**6.)/24.+

     &  (415*Mgl**8.*Mst2**8.)/576.-

     &  (Mgl**6.*Mst2**10.)/9.-(Mgl**4.*Mst2**12.)/3.+

     &  (169*Mgl**2.*Mst2**14.)/576.-

     &  (41*Mst2**16.)/384.+

     &  (11*Mst2**18.)/(576.*Mgl**2.)-

     &  Mst2**20./(576.*Mgl**4.)-

     &  (11*Mgl**14.*Mt**2.)/2304.+

     &  (13*Mgl**16.*Mt**2.)/(1152.*Mst2**2.)+

     &  (191*Mgl**12.*Mst2**2.*Mt**2.)/1152.-

     &  (39*Mgl**10.*Mst2**4.*Mt**2.)/64.+

     &  (11*Mgl**8.*Mst2**6.*Mt**2.)/16.-

     &  (47*Mgl**6.*Mst2**8.*Mt**2.)/128.+

     &  (253*Mgl**4.*Mst2**10.*Mt**2.)/576.-

     &  (119*Mgl**2.*Mst2**12.*Mt**2.)/192.+

     &  (463*Mst2**14.*Mt**2.)/1152.-

     &  (31*Mst2**16.*Mt**2.)/(256.*Mgl**2.)+

     &  (19*Mst2**18.*Mt**2.)/(1152.*Mgl**4.)-

     &  (7*Mgl**12.*Mt**4.)/192.-

     &  (5*Mgl**14.*Mt**4.)/(192.*Mst2**2.)+

     &  (55*Mgl**10.*Mst2**2.*Mt**4.)/576.-

     &  (25*Mgl**8.*Mst2**4.*Mt**4.)/576.+

     &  (113*Mgl**6.*Mst2**6.*Mt**4.)/576.-

     &  (25*Mgl**4.*Mst2**8.*Mt**4.)/96.+

     &  (209*Mgl**2.*Mst2**10.*Mt**4.)/576.-

     &  (301*Mst2**12.*Mt**4.)/576.+

     &  (29*Mst2**14.*Mt**4.)/(96.*Mgl**2.)-

     &  (13*Mst2**16.*Mt**4.)/(192.*Mgl**4.)+

     &  (83*Mgl**10.*Mt**6.)/1152.+

     &  (11*Mgl**12.*Mt**6.)/(576.*Mst2**2.)-

     &  (109*Mgl**8.*Mst2**2.*Mt**6.)/192.+

     &  (289*Mgl**6.*Mst2**4.*Mt**6.)/1152.+

     &  (145*Mgl**4.*Mst2**6.*Mt**6.)/576.-

     &  (7*Mgl**2.*Mst2**8.*Mt**6.)/1152.+

     &  (193*Mst2**10.*Mt**6.)/576.-

     &  (397*Mst2**12.*Mt**6.)/(1152.*Mgl**2.)+

     &  (5*Mst2**14.*Mt**6.)/(32.*Mgl**4.)+

     &  (7*Mgl**8.*Mt**8.)/576.+

     &  (11*Mgl**10.*Mt**8.)/(576.*Mst2**2.)+

     &  (313*Mgl**6.*Mst2**2.*Mt**8.)/576.-

     &  (13*Mgl**4.*Mst2**4.*Mt**8.)/96.-

     &  (21*Mgl**2.*Mst2**6.*Mt**8.)/64.-

     &  (235*Mst2**8.*Mt**8.)/576.+

     &  (19*Mst2**10.*Mt**8.)/(192.*Mgl**2.)-

     &  (7*Mst2**12.*Mt**8.)/(32.*Mgl**4.)-

     &  (11*Mgl**6.*Mt**10.)/96.-

     &  (Mgl**8.*Mt**10.)/(24.*Mst2**2.)-

     &  (3*Mgl**4.*Mst2**2.*Mt**10.)/64.+

     &  (155*Mgl**2.*Mst2**4.*Mt**10.)/288.+

     &  (373*Mst2**6.*Mt**10.)/576.+

     &  (11*Mst2**8.*Mt**10.)/(64.*Mgl**2.)+

     &  (35*Mst2**10.*Mt**10.)/(192.*Mgl**4.)+

     &  (11*Mgl**4.*Mt**12.)/144.+

     &  (11*Mgl**6.*Mt**12.)/(576.*Mst2**2.)-

     &  (131*Mgl**2.*Mst2**2.*Mt**12.)/576.-

     &  (265*Mst2**4.*Mt**12.)/576.-

     &  (13*Mst2**6.*Mt**12.)/(72.*Mgl**2.)-

     &  (7*Mst2**8.*Mt**12.)/(96.*Mgl**4.)-

     &  (Mgl**2.*Mt**14.)/384.+

     &  (5*Mgl**4.*Mt**14.)/(576.*Mst2**2.)+

     &  (65*Mst2**2.*Mt**14.)/576.+

     &  (19*Mst2**4.*Mt**14.)/(384.*Mgl**2.)-

     &  (Mst2**6.*Mt**14.)/(96.*Mgl**4.)-Mt**16./384.-

     &  (Mgl**2.*Mt**16.)/(96.*Mst2**2.)+

     &  (Mst2**2.*Mt**16.)/(96.*Mgl**2.)+

     &  (5*Mst2**4.*Mt**16.)/(192.*Mgl**4.)-

     &  (13*Mt**18.)/(2304.*Mgl**2.)+

     &  Mt**18./(384.*Mst2**2.)-

     &  (13*Mst2**2.*Mt**18.)/(1152.*Mgl**4.)+

     &  Mt**20./(576.*Mgl**4.))*d123(Mt,Mgl,Mst2)**4.*

     &  ln(mu,Mst2)**2.+

     &  ((11*Mt**2.)/(192.*Mgl**1.)-

     &  (Mst2**2.*Mt**2.)/(288.*Mgl**3.)+

     &  Mt**4./(576.*Mgl**3.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mst2)**2.+

     &  ((-37*Mgl**3.*Mt**2.)/384.+

     &  (79*Mgl*Mst2**2.*Mt**2.)/192.-

     &  (7*Mst2**4.*Mt**2.)/(384.*Mgl**1.)+

     &  (Mst2**6.*Mt**2.)/(576.*Mgl**3.)+

     &  (29*Mgl*Mt**4.)/128.+

     &  (29*Mst2**2.*Mt**4.)/(192.*Mgl**1.)-

     &  (13*Mst2**4.*Mt**4.)/(1152.*Mgl**3.)-

     &  (149*Mt**6.)/(1152.*Mgl**1.)+

     &  (5*Mst2**2.*Mt**6.)/(288.*Mgl**3.)-

     &  Mt**8./(128.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)*ln(mu,Mst2)**2.+

     &  ((11*Mgl**7.*Mt**2.)/576.-

     &  (Mgl**9.*Mt**2.)/(144.*Mst2**2.)-

     &  (221*Mgl**5.*Mst2**2.*Mt**2.)/576.+

     &  (85*Mgl**3.*Mst2**4.*Mt**2.)/192.+

     &  (5*Mgl*Mst2**6.*Mt**2.)/576.-

     &  (25*Mst2**8.*Mt**2.)/(288.*Mgl**1.)+

     &  (Mst2**10.*Mt**2.)/(144.*Mgl**3.)-

     &  (65*Mgl**5.*Mt**4.)/576.+

     &  (5*Mgl**7.*Mt**4.)/(288.*Mst2**2.)+

     &  (203*Mgl**3.*Mst2**2.*Mt**4.)/288.+

     &  (163*Mgl*Mst2**4.*Mt**4.)/192.+

     &  (23*Mst2**6.*Mt**4.)/(288.*Mgl**1.)-

     &  (5*Mst2**8.*Mt**4.)/(288.*Mgl**3.)+

     &  (161*Mgl**3.*Mt**6.)/576.-

     &  (Mgl**5.*Mt**6.)/(96.*Mst2**2.)-

     &  (41*Mgl*Mst2**2.*Mt**6.)/576.+

     &  (49*Mst2**4.*Mt**6.)/(288.*Mgl**1.)-

     &  (Mst2**6.*Mt**6.)/(96.*Mgl**3.)-

     &  (17*Mgl*Mt**8.)/64.-

     &  (Mgl**3.*Mt**8.)/(288.*Mst2**2.)-

     &  (2*Mst2**2.*Mt**8.)/(9.*Mgl**1.)+

     &  (19*Mst2**4.*Mt**8.)/(288.*Mgl**3.)+

     &  (17*Mt**10.)/(288.*Mgl**1.)+

     &  (Mgl*Mt**10.)/(288.*Mst2**2.)-

     &  (19*Mst2**2.*Mt**10.)/(288.*Mgl**3.)+

     &  Mt**12./(48.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst2)**2.*

     &  Den(Mst1,Mst2)*ln(mu,Mst2)**2.+

     &  ((11*Mgl**11.*Mt**2.)/1152.+

     &  (Mgl**13.*Mt**2.)/(72.*Mst2**2.)+

     &  (77*Mgl**9.*Mst2**2.*Mt**2.)/288.-

     &  (911*Mgl**7.*Mst2**4.*Mt**2.)/1152.+

     &  (325*Mgl**5.*Mst2**6.*Mt**2.)/576.+

     &  (47*Mgl**3.*Mst2**8.*Mt**2.)/384.-

     &  (5*Mgl*Mst2**10.*Mt**2.)/18.+

     &  (119*Mst2**12.*Mt**2.)/(1152.*Mgl**1.)-

     &  (7*Mst2**14.*Mt**2.)/(576.*Mgl**3.)-

     &  (203*Mgl**9.*Mt**4.)/1152.-

     &  (5*Mgl**11.*Mt**4.)/(72.*Mst2**2.)-

     &  (127*Mgl**7.*Mst2**2.*Mt**4.)/288.+

     &  (793*Mgl**5.*Mst2**4.*Mt**4.)/1152.+

     &  (13*Mgl**3.*Mst2**6.*Mt**4.)/48.+

     &  (143*Mgl*Mst2**8.*Mt**4.)/1152.-

     &  (29*Mst2**10.*Mt**4.)/(96.*Mgl**1.)+

     &  (83*Mst2**12.*Mt**4.)/(1152.*Mgl**3.)+

     &  (563*Mgl**7.*Mt**6.)/1152.+

     &  (Mgl**9.*Mt**6.)/(8.*Mst2**2.)-

     &  (11*Mgl**5.*Mst2**2.*Mt**6.)/72.-

     &  (11*Mgl**3.*Mst2**4.*Mt**6.)/576.-

     &  (Mgl*Mst2**6.*Mt**6.)/288.+

     &  (19*Mst2**8.*Mt**6.)/(128.*Mgl**1.)-

     &  (5*Mst2**10.*Mt**6.)/(32.*Mgl**3.)-

     &  (547*Mgl**5.*Mt**8.)/1152.-

     &  (Mgl**7.*Mt**8.)/(12.*Mst2**2.)+

     &  (113*Mgl**3.*Mst2**2.*Mt**8.)/144.+

     &  (425*Mgl*Mst2**4.*Mt**8.)/576.+

     &  (41*Mst2**6.*Mt**8.)/(144.*Mgl**1.)+

     &  (145*Mst2**8.*Mt**8.)/(1152.*Mgl**3.)+

     &  (169*Mgl**3.*Mt**10.)/1152.-

     &  (Mgl**5.*Mt**10.)/(72.*Mst2**2.)-

     &  (157*Mgl*Mst2**2.*Mt**10.)/288.-

     &  (35*Mst2**4.*Mt**10.)/(128.*Mgl**1.)+

     &  (25*Mst2**6.*Mt**10.)/(576.*Mgl**3.)-

     &  (25*Mgl*Mt**12.)/1152.+

     &  (Mgl**3.*Mt**12.)/(24.*Mst2**2.)-

     &  (Mst2**2.*Mt**12.)/(96.*Mgl**1.)-

     &  (19*Mst2**4.*Mt**12.)/(128.*Mgl**3.)+

     &  (19*Mt**14.)/(384.*Mgl**1.)-

     &  (Mgl*Mt**14.)/(72.*Mst2**2.)+

     &  (7*Mst2**2.*Mt**14.)/(72.*Mgl**3.)-

     &  (25*Mt**16.)/(1152.*Mgl**3.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mst2)**2.

     &  +((Mgl**15.*Mt**2.)/96.-

     &  (Mgl**17.*Mt**2.)/(144.*Mst2**2.)-

     &  (83*Mgl**13.*Mst2**2.*Mt**2.)/288.+

     &  (359*Mgl**11.*Mst2**4.*Mt**2.)/288.-

     &  (553*Mgl**9.*Mst2**6.*Mt**2.)/288.+

     &  (277*Mgl**7.*Mst2**8.*Mt**2.)/288.+

     &  (149*Mgl**5.*Mst2**10.*Mt**2.)/288.-

     &  (235*Mgl**3.*Mst2**12.*Mt**2.)/288.+

     &  (103*Mgl*Mst2**14.*Mt**2.)/288.-

     &  (5*Mst2**16.*Mt**2.)/(72.*Mgl**1.)+

     &  (Mst2**18.*Mt**2.)/(144.*Mgl**3.)+

     &  (13*Mgl**13.*Mt**4.)/576.+

     &  (5*Mgl**15.*Mt**4.)/(96.*Mst2**2.)+

     &  (187*Mgl**11.*Mst2**2.*Mt**4.)/192.-

     &  (1561*Mgl**9.*Mst2**4.*Mt**4.)/576.+

     &  (1129*Mgl**7.*Mst2**6.*Mt**4.)/576.-

     &  (271*Mgl**5.*Mst2**8.*Mt**4.)/576.+

     &  (443*Mgl**3.*Mst2**10.*Mt**4.)/576.-

     &  (515*Mgl*Mst2**12.*Mt**4.)/576.+

     &  (205*Mst2**14.*Mt**4.)/(576.*Mgl**1.)-

     &  (17*Mst2**16.*Mt**4.)/(288.*Mgl**3.)-

     &  (187*Mgl**11.*Mt**6.)/576.-

     &  (5*Mgl**13.*Mt**6.)/(32.*Mst2**2.)-

     &  (11*Mgl**9.*Mst2**2.*Mt**6.)/12.+

     &  (311*Mgl**7.*Mst2**4.*Mt**6.)/192.+

     &  (4*Mgl**5.*Mst2**6.*Mt**6.)/9.-

     &  (73*Mgl**3.*Mst2**8.*Mt**6.)/576.+

     &  (5*Mgl*Mst2**10.*Mt**6.)/9.-

     &  (41*Mst2**12.*Mt**6.)/(64.*Mgl**1.)+

     &  (61*Mst2**14.*Mt**6.)/(288.*Mgl**3.)+

     &  (487*Mgl**9.*Mt**8.)/576.+

     &  (67*Mgl**11.*Mt**8.)/(288.*Mst2**2.)-

     &  (293*Mgl**7.*Mst2**2.*Mt**8.)/576.-

     &  (9*Mgl**5.*Mst2**4.*Mt**8.)/8.-

     &  (9*Mgl**3.*Mst2**6.*Mt**8.)/16.-

     &  (265*Mgl*Mst2**8.*Mt**8.)/576.+

     &  (187*Mst2**10.*Mt**8.)/(576.*Mgl**1.)-

     &  (119*Mst2**12.*Mt**8.)/(288.*Mgl**3.)-

     &  (61*Mgl**7.*Mt**10.)/64.-

     &  (5*Mgl**9.*Mt**10.)/(32.*Mst2**2.)+

     &  (83*Mgl**5.*Mst2**2.*Mt**10.)/48.+

     &  (37*Mgl**3.*Mst2**4.*Mt**10.)/16.+

     &  (25*Mgl*Mst2**6.*Mt**10.)/16.+

     &  (25*Mst2**8.*Mt**10.)/(64.*Mgl**1.)+

     &  (133*Mst2**10.*Mt**10.)/(288.*Mgl**3.)+

     &  (31*Mgl**5.*Mt**12.)/64.-

     &  (Mgl**7.*Mt**12.)/(96.*Mst2**2.)-

     &  (275*Mgl**3.*Mst2**2.*Mt**12.)/192.-

     &  (917*Mgl*Mst2**4.*Mt**12.)/576.-

     &  (325*Mst2**6.*Mt**12.)/(576.*Mgl**1.)-

     &  (77*Mst2**8.*Mt**12.)/(288.*Mgl**3.)-

     &  (53*Mgl**3.*Mt**14.)/576.+

     &  (25*Mgl**5.*Mt**14.)/(288.*Mst2**2.)+

     &  (31*Mgl*Mst2**2.*Mt**14.)/72.+

     &  (35*Mst2**4.*Mt**14.)/(192.*Mgl**1.)+

     &  (7*Mst2**6.*Mt**14.)/(288.*Mgl**3.)+

     &  (17*Mgl*Mt**16.)/576.-

     &  (5*Mgl**3.*Mt**16.)/(96.*Mst2**2.)+

     &  (29*Mst2**2.*Mt**16.)/(576.*Mgl**1.)+

     &  (19*Mst2**4.*Mt**16.)/(288.*Mgl**3.)-

     &  (17*Mt**18.)/(576.*Mgl**1.)+

     &  (Mgl*Mt**18.)/(96.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**18.)/(288.*Mgl**3.)+

     &  Mt**20./(144.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst2)**4.*

     &  Den(Mst1,Mst2)*ln(mu,Mst2)**2.+

     &  (0.17881944444444445-(5*Mgl**2.)/(1152.*Mst1**2.)+

     &  Mst1**2./(576.*Mgl**2.)-

     &  (5*Mgl**2.)/(1152.*Mst2**2.)+

     &  Mst2**2./(576.*Mgl**2.)+Mgl**2./(96.*Mt**2.)-

     &  Mgl**4./(192.*Mst1**2.*Mt**2.)+

     &  Mst1**2./(192.*Mt**2.)-

     &  Mst1**4./(192.*Mgl**2.*Mt**2.)-

     &  Mgl**4./(192.*Mst2**2.*Mt**2.)+

     &  Mst2**2./(192.*Mt**2.)-

     &  Mst2**4./(192.*Mgl**2.*Mt**2.)+

     &  Mt**2./(24.*Mgl**2.)-Mt**2./(384.*Mst1**2.)-

     &  (Mst1**2.*Mt**2.)/(288.*Mgl**4.)-

     &  Mt**2./(384.*Mst2**2.)-

     &  (Mst2**2.*Mt**2.)/(288.*Mgl**4.)+

     &  Mt**4./(72.*Mgl**4.)+

     &  Mt**4./(64.*Mgl**2.*Mst1**2.)+

     &  Mt**4./(64.*Mgl**2.*Mst2**2.)-

     &  Mt**6./(288.*Mgl**4.*Mst1**2.)-

     &  Mt**6./(288.*Mgl**4.*Mst2**2.))*ln(mu,Mt)+

     &  ((29*Mgl**4.)/1728.+(5*Mgl**8.)/(576.*Mst1**4.)-

     &  (13*Mgl**6.)/(864.*Mst1**2.)-

     &  (19*Mgl**2.*Mst1**2.)/192.+(299*Mst1**4.)/1728.-

     &  (161*Mst1**6.)/(1728.*Mgl**2.)+

     &  (5*Mst1**8.)/(576.*Mgl**4.)+

     &  Mgl**6./(32.*Mt**2.)-

     &  Mgl**8./(96.*Mst1**2.*Mt**2.)-

     &  (Mgl**4.*Mst1**2.)/(48.*Mt**2.)-

     &  (Mgl**2.*Mst1**4.)/(48.*Mt**2.)+

     &  Mst1**6./(32.*Mt**2.)-

     &  Mst1**8./(96.*Mgl**2.*Mt**2.)+

     &  (83*Mgl**2.*Mt**2.)/1728.-

     &  (5*Mgl**6.*Mt**2.)/(288.*Mst1**4.)-

     &  (115*Mgl**4.*Mt**2.)/(1728.*Mst1**2.)-

     &  (179*Mst1**2.*Mt**2.)/1152.+

     &  (211*Mst1**4.*Mt**2.)/(1152.*Mgl**2.)-

     &  (Mst1**6.*Mt**2.)/(48.*Mgl**4.)-(7*Mt**4.)/576.+

     &  (Mgl**4.*Mt**4.)/(192.*Mst1**4.)+

     &  (163*Mgl**2.*Mt**4.)/(3456.*Mst1**2.)-

     &  (31*Mst1**2.*Mt**4.)/(576.*Mgl**2.)+

     &  (Mst1**4.*Mt**4.)/(192.*Mgl**4.)-

     &  (19*Mt**6.)/(1728.*Mgl**2.)+

     &  (7*Mgl**2.*Mt**6.)/(576.*Mst1**4.)+

     &  (85*Mt**6.)/(1728.*Mst1**2.)+

     &  (13*Mst1**2.*Mt**6.)/(576.*Mgl**4.)-

     &  Mt**8./(48.*Mgl**4.)-Mt**8./(72.*Mst1**4.)-

     &  (23*Mt**8.)/(1152.*Mgl**2.*Mst1**2.)+

     &  Mt**10./(192.*Mgl**2.*Mst1**4.)+

     &  Mt**10./(192.*Mgl**4.*Mst1**2.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mt)+((-455*Mgl**8.)/1728.-

     &  Mgl**12./(576.*Mst1**4.)+

     &  (85*Mgl**10.)/(864.*Mst1**2.)+

     &  (467*Mgl**6.*Mst1**2.)/1728.-

     &  (77*Mgl**4.*Mst1**4.)/216.+

     &  (139*Mgl**2.*Mst1**6.)/216.-

     &  (971*Mst1**8.)/1728.+

     &  (299*Mst1**10.)/(1728.*Mgl**2.)-

     &  Mst1**12./(576.*Mgl**4.)-

     &  (65*Mgl**10.)/(576.*Mt**2.)+

     &  (13*Mgl**12.)/(576.*Mst1**2.*Mt**2.)+

     &  (13*Mgl**8.*Mst1**2.)/(64.*Mt**2.)-

     &  (65*Mgl**6.*Mst1**4.)/(576.*Mt**2.)-

     &  (65*Mgl**4.*Mst1**6.)/(576.*Mt**2.)+

     &  (13*Mgl**2.*Mst1**8.)/(64.*Mt**2.)-

     &  (65*Mst1**10.)/(576.*Mt**2.)+

     &  (13*Mst1**12.)/(576.*Mgl**2.*Mt**2.)+

     &  (223*Mgl**6.*Mt**2.)/864.+

     &  (Mgl**10.*Mt**2.)/(72.*Mst1**4.)-

     &  (61*Mgl**8.*Mt**2.)/(288.*Mst1**2.)+

     &  (439*Mgl**4.*Mst1**2.*Mt**2.)/3456.-

     &  (2609*Mgl**2.*Mst1**4.*Mt**2.)/3456.+

     &  (1513*Mst1**6.*Mt**2.)/1152.-

     &  (299*Mst1**8.*Mt**2.)/(384.*Mgl**2.)+

     &  (19*Mst1**10.*Mt**2.)/(576.*Mgl**4.)-

     &  (115*Mgl**4.*Mt**4.)/432.-

     &  (5*Mgl**8.*Mt**4.)/(576.*Mst1**4.)-

     &  (401*Mgl**6.*Mt**4.)/(3456.*Mst1**2.)+

     &  (211*Mgl**2.*Mst1**2.*Mt**4.)/1152.-

     &  (205*Mst1**4.*Mt**4.)/192.+

     &  (1409*Mst1**6.*Mt**4.)/(1728.*Mgl**2.)-

     &  (7*Mst1**8.*Mt**4.)/(64.*Mgl**4.)+

     &  (Mgl**2.*Mt**6.)/18.-

     &  (Mgl**6.*Mt**6.)/(72.*Mst1**4.)+

     &  (5*Mgl**4.*Mt**6.)/(36.*Mst1**2.)+

     &  (1753*Mst1**2.*Mt**6.)/3456.+

     &  (491*Mst1**4.*Mt**6.)/(3456.*Mgl**2.)+

     &  (9*Mst1**6.*Mt**6.)/(64.*Mgl**4.)+

     &  (13*Mt**8.)/144.-

     &  (Mgl**4.*Mt**8.)/(192.*Mst1**4.)+

     &  (199*Mgl**2.*Mt**8.)/(864.*Mst1**2.)-

     &  (715*Mst1**2.*Mt**8.)/(1152.*Mgl**2.)-

     &  (13*Mst1**4.*Mt**8.)/(192.*Mgl**4.)+

     &  (409*Mt**10.)/(1728.*Mgl**2.)+

     &  (Mgl**2.*Mt**10.)/(72.*Mst1**4.)-

     &  (53*Mt**10.)/(288.*Mst1**2.)-

     &  (Mst1**2.*Mt**10.)/(192.*Mgl**4.)+

     &  (7*Mt**12.)/(576.*Mgl**4.)+

     &  Mt**12./(64.*Mst1**4.)+

     &  (3*Mt**12.)/(128.*Mgl**2.*Mst1**2.)-

     &  Mt**14./(72.*Mgl**2.*Mst1**4.)-

     &  Mt**14./(576.*Mgl**4.*Mst1**2.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mt)+

     &  ((305*Mgl**12.)/384.-(17*Mgl**16.)/(576.*Mst1**4.)-

     &  (359*Mgl**14.)/(3456.*Mst1**2.)-

     &  (4199*Mgl**10.*Mst1**2.)/3456.+

     &  (403*Mgl**8.*Mst1**4.)/3456.+

     &  (331*Mgl**6.*Mst1**6.)/384.+

     &  (529*Mgl**4.*Mst1**8.)/3456.-

     &  (4325*Mgl**2.*Mst1**10.)/3456.+

     &  (311*Mst1**12.)/384.-

     &  (23*Mst1**14.)/(216.*Mgl**2.)-

     &  (17*Mst1**16.)/(576.*Mgl**4.)+

     &  (7*Mgl**14.)/(144.*Mt**2.)-

     &  Mgl**16./(144.*Mst1**2.*Mt**2.)-

     &  (5*Mgl**12.*Mst1**2.)/(36.*Mt**2.)+

     &  (7*Mgl**10.*Mst1**4.)/(36.*Mt**2.)-

     &  (7*Mgl**8.*Mst1**6.)/(72.*Mt**2.)-

     &  (7*Mgl**6.*Mst1**8.)/(72.*Mt**2.)+

     &  (7*Mgl**4.*Mst1**10.)/(36.*Mt**2.)-

     &  (5*Mgl**2.*Mst1**12.)/(36.*Mt**2.)+

     &  (7*Mst1**14.)/(144.*Mt**2.)-

     &  Mst1**16./(144.*Mgl**2.*Mt**2.)-

     &  (6167*Mgl**10.*Mt**2.)/3456.+

     &  (13*Mgl**14.*Mt**2.)/(96.*Mst1**4.)+

     &  (725*Mgl**12.*Mt**2.)/(1728.*Mst1**2.)+

     &  (1631*Mgl**8.*Mst1**2.*Mt**2.)/1152.-

     &  (23*Mgl**6.*Mst1**4.*Mt**2.)/288.-

     &  (1391*Mgl**4.*Mst1**6.*Mt**2.)/1728.+

     &  (3179*Mgl**2.*Mst1**8.*Mt**2.)/1152.-

     &  (10495*Mst1**10.*Mt**2.)/3456.+

     &  (481*Mst1**12.*Mt**2.)/(576.*Mgl**2.)+

     &  (9*Mst1**14.*Mt**2.)/(64.*Mgl**4.)+

     &  (3989*Mgl**8.*Mt**4.)/3456.-

     &  (157*Mgl**12.*Mt**4.)/(576.*Mst1**4.)-

     &  (1027*Mgl**10.*Mt**4.)/(3456.*Mst1**2.)-

     &  (919*Mgl**6.*Mst1**2.*Mt**4.)/3456.-

     &  (661*Mgl**4.*Mst1**4.*Mt**4.)/1728.-

     &  (701*Mgl**2.*Mst1**6.*Mt**4.)/384.+

     &  (4687*Mst1**8.*Mt**4.)/1152.-

     &  (6745*Mst1**10.*Mt**4.)/(3456.*Mgl**2.)-

     &  (131*Mst1**12.*Mt**4.)/(576.*Mgl**4.)-

     &  (3107*Mgl**6.*Mt**6.)/3456.+

     &  (21*Mgl**10.*Mt**6.)/(64.*Mst1**4.)-

     &  (73*Mgl**8.*Mt**6.)/(216.*Mst1**2.)-

     &  (565*Mgl**4.*Mst1**2.*Mt**6.)/864.-

     &  (629*Mgl**2.*Mst1**4.*Mt**6.)/1728.-

     &  (5165*Mst1**6.*Mt**6.)/1728.+

     &  (5551*Mst1**8.*Mt**6.)/(3456.*Mgl**2.)+

     &  (37*Mst1**10.*Mt**6.)/(576.*Mgl**4.)-

     &  (637*Mgl**4.*Mt**8.)/3456.-

     &  (103*Mgl**8.*Mt**8.)/(576.*Mst1**4.)+

     &  (23*Mgl**6.*Mt**8.)/(128.*Mst1**2.)-

     &  (203*Mgl**2.*Mst1**2.*Mt**8.)/1152.+

     &  (4601*Mst1**4.*Mt**8.)/3456.+

     &  (221*Mst1**6.*Mt**8.)/(432.*Mgl**2.)+

     &  (15*Mst1**8.*Mt**8.)/(64.*Mgl**4.)+

     &  (671*Mgl**2.*Mt**10.)/384.-

     &  (37*Mgl**6.*Mt**10.)/(192.*Mst1**4.)+

     &  (869*Mgl**4.*Mt**10.)/(1728.*Mst1**2.)+

     &  (295*Mst1**2.*Mt**10.)/1152.-

     &  (3019*Mst1**4.*Mt**10.)/(1728.*Mgl**2.)-

     &  (173*Mst1**6.*Mt**10.)/(576.*Mgl**4.)-

     &  (2357*Mt**12.)/3456.+

     &  (83*Mgl**4.*Mt**12.)/(192.*Mst1**4.)-

     &  (181*Mgl**2.*Mt**12.)/(384.*Mst1**2.)+

     &  (3703*Mst1**2.*Mt**12.)/(3456.*Mgl**2.)+

     &  (79*Mst1**4.*Mt**12.)/(576.*Mgl**4.)-

     &  (661*Mt**14.)/(3456.*Mgl**2.)-

     &  (161*Mgl**2.*Mt**14.)/(576.*Mst1**4.)+

     &  (125*Mt**14.)/(864.*Mst1**2.)-

     &  (Mst1**2.*Mt**14.)/(64.*Mgl**4.)-

     &  Mt**16./(288.*Mgl**4.)+

     &  (7*Mt**16.)/(144.*Mst1**4.)-

     &  (17*Mt**16.)/(576.*Mgl**2.*Mst1**2.)+

     &  (5*Mt**18.)/(576.*Mgl**2.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.*ln(mu,Mt)+

     &  ((-19*Mgl**16.)/48.+(13*Mgl**20.)/(576.*Mst1**4.)-

     &  (29*Mgl**18.)/(1728.*Mst1**2.)+

     &  (2119*Mgl**14.*Mst1**2.)/1728.-

     &  (1679*Mgl**12.*Mst1**4.)/1728.-

     &  (1045*Mgl**10.*Mst1**6.)/864.+

     &  (581*Mgl**8.*Mst1**8.)/216.-

     &  (1045*Mgl**6.*Mst1**10.)/864.-

     &  (1679*Mgl**4.*Mst1**12.)/1728.+

     &  (2119*Mgl**2.*Mst1**14.)/1728.-

     &  (19*Mst1**16.)/48.-

     &  (29*Mst1**18.)/(1728.*Mgl**2.)+

     &  (13*Mst1**20.)/(576.*Mgl**4.)+

     &  (3701*Mgl**14.*Mt**2.)/3456.-

     &  (7*Mgl**18.*Mt**2.)/(48.*Mst1**4.)+

     &  (379*Mgl**16.*Mt**2.)/(3456.*Mst1**2.)-

     &  (6881*Mgl**12.*Mst1**2.*Mt**2.)/3456.+

     &  (3361*Mgl**10.*Mst1**4.*Mt**2.)/3456.-

     &  (3127*Mgl**8.*Mst1**6.*Mt**2.)/3456.+

     &  (5635*Mgl**6.*Mst1**8.*Mt**2.)/3456.+

     &  (3169*Mgl**4.*Mst1**10.*Mt**2.)/3456.-

     &  (11989*Mgl**2.*Mst1**12.*Mt**2.)/3456.+

     &  (439*Mst1**14.*Mt**2.)/216.-

     &  (17*Mst1**16.*Mt**2.)/(288.*Mgl**2.)-

     &  (47*Mst1**18.*Mt**2.)/(288.*Mgl**4.)-

     &  (11*Mgl**12.*Mt**4.)/18.+

     &  (235*Mgl**16.*Mt**4.)/(576.*Mst1**4.)-

     &  (103*Mgl**14.*Mt**4.)/(192.*Mst1**2.)+

     &  (163*Mgl**10.*Mst1**2.*Mt**4.)/128.-

     &  (251*Mgl**8.*Mst1**4.*Mt**4.)/864.-

     &  (6089*Mgl**6.*Mst1**6.*Mt**4.)/3456.+

     &  (2039*Mgl**4.*Mst1**8.*Mt**4.)/1728.+

     &  (12119*Mgl**2.*Mst1**10.*Mt**4.)/3456.-

     &  (7433*Mst1**12.*Mt**4.)/1728.+

     &  (2207*Mst1**14.*Mt**4.)/(3456.*Mgl**2.)+

     &  (95*Mst1**16.*Mt**4.)/(192.*Mgl**4.)-

     &  (431*Mgl**10.*Mt**6.)/1728.-

     &  (2*Mgl**14.*Mt**6.)/(3.*Mst1**4.)+

     &  (181*Mgl**12.*Mt**6.)/(108.*Mst1**2.)-

     &  (6601*Mgl**8.*Mst1**2.*Mt**6.)/3456.+

     &  (1445*Mgl**6.*Mst1**4.*Mt**6.)/3456.-

     &  (817*Mgl**4.*Mst1**6.*Mt**6.)/1728.-

     &  (1103*Mgl**2.*Mst1**8.*Mt**6.)/864.+

     &  (16859*Mst1**10.*Mt**6.)/3456.-

     &  (1849*Mst1**12.*Mt**6.)/(1152.*Mgl**2.)-

     &  (19*Mst1**14.*Mt**6.)/(24.*Mgl**4.)-

     &  (9*Mgl**8.*Mt**8.)/64.+

     &  (67*Mgl**12.*Mt**8.)/(96.*Mst1**4.)-

     &  (4877*Mgl**10.*Mt**8.)/(1728.*Mst1**2.)+

     &  (2069*Mgl**6.*Mst1**2.*Mt**8.)/1152.-

     &  (13*Mgl**4.*Mst1**4.*Mt**8.)/54.+

     &  (5*Mgl**2.*Mst1**6.*Mt**8.)/36.-

     &  (5189*Mst1**8.*Mt**8.)/1728.+

     &  (1889*Mst1**10.*Mt**8.)/(1152.*Mgl**2.)+

     &  (21*Mst1**12.*Mt**8.)/(32.*Mgl**4.)-

     &  (13*Mgl**6.*Mt**10.)/24.-

     &  (25*Mgl**10.*Mt**10.)/(72.*Mst1**4.)+

     &  (4283*Mgl**8.*Mt**10.)/(1728.*Mst1**2.)-

     &  (8863*Mgl**4.*Mst1**2.*Mt**10.)/3456.-

     &  (7501*Mgl**2.*Mst1**4.*Mt**10.)/3456.+

     &  (625*Mst1**6.*Mt**10.)/3456.-

     &  (787*Mst1**8.*Mt**10.)/(3456.*Mgl**2.)-

     &  (7*Mst1**10.*Mt**10.)/(48.*Mgl**4.)+

     &  (1379*Mgl**4.*Mt**12.)/576.-

     &  (31*Mgl**8.*Mt**12.)/(96.*Mst1**4.)-

     &  (671*Mgl**6.*Mt**12.)/(576.*Mst1**2.)+

     &  (4645*Mgl**2.*Mst1**2.*Mt**12.)/1152.+

     &  (1445*Mst1**4.*Mt**12.)/864.-

     &  (1177*Mst1**6.*Mt**12.)/(1152.*Mgl**2.)-

     &  (7*Mst1**8.*Mt**12.)/(32.*Mgl**4.)-

     &  (3397*Mgl**2.*Mt**14.)/1728.+

     &  (5*Mgl**6.*Mt**14.)/(6.*Mst1**4.)+

     &  (73*Mgl**4.*Mt**14.)/(144.*Mst1**2.)-

     &  (1745*Mst1**2.*Mt**14.)/1152.+

     &  (367*Mst1**4.*Mt**14.)/(384.*Mgl**2.)+

     &  (5*Mst1**6.*Mt**14.)/(24.*Mgl**4.)+

     &  (25*Mt**16.)/64.-

     &  (431*Mgl**4.*Mt**16.)/(576.*Mst1**4.)-

     &  (301*Mgl**2.*Mt**16.)/(864.*Mst1**2.)-

     &  (1213*Mst1**2.*Mt**16.)/(3456.*Mgl**2.)-

     &  (13*Mst1**4.*Mt**16.)/(192.*Mgl**4.)+

     &  (163*Mt**18.)/(3456.*Mgl**2.)+

     &  (47*Mgl**2.*Mt**18.)/(144.*Mst1**4.)+

     &  (407*Mt**18.)/(3456.*Mst1**2.)+

     &  (Mst1**2.*Mt**18.)/(288.*Mgl**4.)+

     &  Mt**20./(576.*Mgl**4.)-

     &  (11*Mt**20.)/(192.*Mst1**4.))*d123(Mt,Mgl,Mst1)**4.*

     &  ln(mu,Mt)+((29*Mgl**4.)/1728.+

     &  (5*Mgl**8.)/(576.*Mst2**4.)-

     &  (13*Mgl**6.)/(864.*Mst2**2.)-

     &  (19*Mgl**2.*Mst2**2.)/192.+(299*Mst2**4.)/1728.-

     &  (161*Mst2**6.)/(1728.*Mgl**2.)+

     &  (5*Mst2**8.)/(576.*Mgl**4.)+

     &  Mgl**6./(32.*Mt**2.)-

     &  Mgl**8./(96.*Mst2**2.*Mt**2.)-

     &  (Mgl**4.*Mst2**2.)/(48.*Mt**2.)-

     &  (Mgl**2.*Mst2**4.)/(48.*Mt**2.)+

     &  Mst2**6./(32.*Mt**2.)-

     &  Mst2**8./(96.*Mgl**2.*Mt**2.)+

     &  (83*Mgl**2.*Mt**2.)/1728.-

     &  (5*Mgl**6.*Mt**2.)/(288.*Mst2**4.)-

     &  (115*Mgl**4.*Mt**2.)/(1728.*Mst2**2.)-

     &  (179*Mst2**2.*Mt**2.)/1152.+

     &  (211*Mst2**4.*Mt**2.)/(1152.*Mgl**2.)-

     &  (Mst2**6.*Mt**2.)/(48.*Mgl**4.)-(7*Mt**4.)/576.+

     &  (Mgl**4.*Mt**4.)/(192.*Mst2**4.)+

     &  (163*Mgl**2.*Mt**4.)/(3456.*Mst2**2.)-

     &  (31*Mst2**2.*Mt**4.)/(576.*Mgl**2.)+

     &  (Mst2**4.*Mt**4.)/(192.*Mgl**4.)-

     &  (19*Mt**6.)/(1728.*Mgl**2.)+

     &  (7*Mgl**2.*Mt**6.)/(576.*Mst2**4.)+

     &  (85*Mt**6.)/(1728.*Mst2**2.)+

     &  (13*Mst2**2.*Mt**6.)/(576.*Mgl**4.)-

     &  Mt**8./(48.*Mgl**4.)-Mt**8./(72.*Mst2**4.)-

     &  (23*Mt**8.)/(1152.*Mgl**2.*Mst2**2.)+

     &  Mt**10./(192.*Mgl**2.*Mst2**4.)+

     &  Mt**10./(192.*Mgl**4.*Mst2**2.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mt)+((-455*Mgl**8.)/1728.-

     &  Mgl**12./(576.*Mst2**4.)+

     &  (85*Mgl**10.)/(864.*Mst2**2.)+

     &  (467*Mgl**6.*Mst2**2.)/1728.-

     &  (77*Mgl**4.*Mst2**4.)/216.+

     &  (139*Mgl**2.*Mst2**6.)/216.-

     &  (971*Mst2**8.)/1728.+

     &  (299*Mst2**10.)/(1728.*Mgl**2.)-

     &  Mst2**12./(576.*Mgl**4.)-

     &  (65*Mgl**10.)/(576.*Mt**2.)+

     &  (13*Mgl**12.)/(576.*Mst2**2.*Mt**2.)+

     &  (13*Mgl**8.*Mst2**2.)/(64.*Mt**2.)-

     &  (65*Mgl**6.*Mst2**4.)/(576.*Mt**2.)-

     &  (65*Mgl**4.*Mst2**6.)/(576.*Mt**2.)+

     &  (13*Mgl**2.*Mst2**8.)/(64.*Mt**2.)-

     &  (65*Mst2**10.)/(576.*Mt**2.)+

     &  (13*Mst2**12.)/(576.*Mgl**2.*Mt**2.)+

     &  (223*Mgl**6.*Mt**2.)/864.+

     &  (Mgl**10.*Mt**2.)/(72.*Mst2**4.)-

     &  (61*Mgl**8.*Mt**2.)/(288.*Mst2**2.)+

     &  (439*Mgl**4.*Mst2**2.*Mt**2.)/3456.-

     &  (2609*Mgl**2.*Mst2**4.*Mt**2.)/3456.+

     &  (1513*Mst2**6.*Mt**2.)/1152.-

     &  (299*Mst2**8.*Mt**2.)/(384.*Mgl**2.)+

     &  (19*Mst2**10.*Mt**2.)/(576.*Mgl**4.)-

     &  (115*Mgl**4.*Mt**4.)/432.-

     &  (5*Mgl**8.*Mt**4.)/(576.*Mst2**4.)-

     &  (401*Mgl**6.*Mt**4.)/(3456.*Mst2**2.)+

     &  (211*Mgl**2.*Mst2**2.*Mt**4.)/1152.-

     &  (205*Mst2**4.*Mt**4.)/192.+

     &  (1409*Mst2**6.*Mt**4.)/(1728.*Mgl**2.)-

     &  (7*Mst2**8.*Mt**4.)/(64.*Mgl**4.)+

     &  (Mgl**2.*Mt**6.)/18.-

     &  (Mgl**6.*Mt**6.)/(72.*Mst2**4.)+

     &  (5*Mgl**4.*Mt**6.)/(36.*Mst2**2.)+

     &  (1753*Mst2**2.*Mt**6.)/3456.+

     &  (491*Mst2**4.*Mt**6.)/(3456.*Mgl**2.)+

     &  (9*Mst2**6.*Mt**6.)/(64.*Mgl**4.)+

     &  (13*Mt**8.)/144.-

     &  (Mgl**4.*Mt**8.)/(192.*Mst2**4.)+

     &  (199*Mgl**2.*Mt**8.)/(864.*Mst2**2.)-

     &  (715*Mst2**2.*Mt**8.)/(1152.*Mgl**2.)-

     &  (13*Mst2**4.*Mt**8.)/(192.*Mgl**4.)+

     &  (409*Mt**10.)/(1728.*Mgl**2.)+

     &  (Mgl**2.*Mt**10.)/(72.*Mst2**4.)-

     &  (53*Mt**10.)/(288.*Mst2**2.)-

     &  (Mst2**2.*Mt**10.)/(192.*Mgl**4.)+

     &  (7*Mt**12.)/(576.*Mgl**4.)+

     &  Mt**12./(64.*Mst2**4.)+

     &  (3*Mt**12.)/(128.*Mgl**2.*Mst2**2.)-

     &  Mt**14./(72.*Mgl**2.*Mst2**4.)-

     &  Mt**14./(576.*Mgl**4.*Mst2**2.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mt)+

     &  ((305*Mgl**12.)/384.-(17*Mgl**16.)/(576.*Mst2**4.)-

     &  (359*Mgl**14.)/(3456.*Mst2**2.)-

     &  (4199*Mgl**10.*Mst2**2.)/3456.+

     &  (403*Mgl**8.*Mst2**4.)/3456.+

     &  (331*Mgl**6.*Mst2**6.)/384.+

     &  (529*Mgl**4.*Mst2**8.)/3456.-

     &  (4325*Mgl**2.*Mst2**10.)/3456.+

     &  (311*Mst2**12.)/384.-

     &  (23*Mst2**14.)/(216.*Mgl**2.)-

     &  (17*Mst2**16.)/(576.*Mgl**4.)+

     &  (7*Mgl**14.)/(144.*Mt**2.)-

     &  Mgl**16./(144.*Mst2**2.*Mt**2.)-

     &  (5*Mgl**12.*Mst2**2.)/(36.*Mt**2.)+

     &  (7*Mgl**10.*Mst2**4.)/(36.*Mt**2.)-

     &  (7*Mgl**8.*Mst2**6.)/(72.*Mt**2.)-

     &  (7*Mgl**6.*Mst2**8.)/(72.*Mt**2.)+

     &  (7*Mgl**4.*Mst2**10.)/(36.*Mt**2.)-

     &  (5*Mgl**2.*Mst2**12.)/(36.*Mt**2.)+

     &  (7*Mst2**14.)/(144.*Mt**2.)-

     &  Mst2**16./(144.*Mgl**2.*Mt**2.)-

     &  (6167*Mgl**10.*Mt**2.)/3456.+

     &  (13*Mgl**14.*Mt**2.)/(96.*Mst2**4.)+

     &  (725*Mgl**12.*Mt**2.)/(1728.*Mst2**2.)+

     &  (1631*Mgl**8.*Mst2**2.*Mt**2.)/1152.-

     &  (23*Mgl**6.*Mst2**4.*Mt**2.)/288.-

     &  (1391*Mgl**4.*Mst2**6.*Mt**2.)/1728.+

     &  (3179*Mgl**2.*Mst2**8.*Mt**2.)/1152.-

     &  (10495*Mst2**10.*Mt**2.)/3456.+

     &  (481*Mst2**12.*Mt**2.)/(576.*Mgl**2.)+

     &  (9*Mst2**14.*Mt**2.)/(64.*Mgl**4.)+

     &  (3989*Mgl**8.*Mt**4.)/3456.-

     &  (157*Mgl**12.*Mt**4.)/(576.*Mst2**4.)-

     &  (1027*Mgl**10.*Mt**4.)/(3456.*Mst2**2.)-

     &  (919*Mgl**6.*Mst2**2.*Mt**4.)/3456.-

     &  (661*Mgl**4.*Mst2**4.*Mt**4.)/1728.-

     &  (701*Mgl**2.*Mst2**6.*Mt**4.)/384.+

     &  (4687*Mst2**8.*Mt**4.)/1152.-

     &  (6745*Mst2**10.*Mt**4.)/(3456.*Mgl**2.)-

     &  (131*Mst2**12.*Mt**4.)/(576.*Mgl**4.)-

     &  (3107*Mgl**6.*Mt**6.)/3456.+

     &  (21*Mgl**10.*Mt**6.)/(64.*Mst2**4.)-

     &  (73*Mgl**8.*Mt**6.)/(216.*Mst2**2.)-

     &  (565*Mgl**4.*Mst2**2.*Mt**6.)/864.-

     &  (629*Mgl**2.*Mst2**4.*Mt**6.)/1728.-

     &  (5165*Mst2**6.*Mt**6.)/1728.+

     &  (5551*Mst2**8.*Mt**6.)/(3456.*Mgl**2.)+

     &  (37*Mst2**10.*Mt**6.)/(576.*Mgl**4.)-

     &  (637*Mgl**4.*Mt**8.)/3456.-

     &  (103*Mgl**8.*Mt**8.)/(576.*Mst2**4.)+

     &  (23*Mgl**6.*Mt**8.)/(128.*Mst2**2.)-

     &  (203*Mgl**2.*Mst2**2.*Mt**8.)/1152.+

     &  (4601*Mst2**4.*Mt**8.)/3456.+

     &  (221*Mst2**6.*Mt**8.)/(432.*Mgl**2.)+

     &  (15*Mst2**8.*Mt**8.)/(64.*Mgl**4.)+

     &  (671*Mgl**2.*Mt**10.)/384.-

     &  (37*Mgl**6.*Mt**10.)/(192.*Mst2**4.)+

     &  (869*Mgl**4.*Mt**10.)/(1728.*Mst2**2.)+

     &  (295*Mst2**2.*Mt**10.)/1152.-

     &  (3019*Mst2**4.*Mt**10.)/(1728.*Mgl**2.)-

     &  (173*Mst2**6.*Mt**10.)/(576.*Mgl**4.)-

     &  (2357*Mt**12.)/3456.+

     &  (83*Mgl**4.*Mt**12.)/(192.*Mst2**4.)-

     &  (181*Mgl**2.*Mt**12.)/(384.*Mst2**2.)+

     &  (3703*Mst2**2.*Mt**12.)/(3456.*Mgl**2.)+

     &  (79*Mst2**4.*Mt**12.)/(576.*Mgl**4.)-

     &  (661*Mt**14.)/(3456.*Mgl**2.)-

     &  (161*Mgl**2.*Mt**14.)/(576.*Mst2**4.)+

     &  (125*Mt**14.)/(864.*Mst2**2.)-

     &  (Mst2**2.*Mt**14.)/(64.*Mgl**4.)-

     &  Mt**16./(288.*Mgl**4.)+

     &  (7*Mt**16.)/(144.*Mst2**4.)-

     &  (17*Mt**16.)/(576.*Mgl**2.*Mst2**2.)+

     &  (5*Mt**18.)/(576.*Mgl**2.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.*ln(mu,Mt)+

     &  ((-19*Mgl**16.)/48.+(13*Mgl**20.)/(576.*Mst2**4.)-

     &  (29*Mgl**18.)/(1728.*Mst2**2.)+

     &  (2119*Mgl**14.*Mst2**2.)/1728.-

     &  (1679*Mgl**12.*Mst2**4.)/1728.-

     &  (1045*Mgl**10.*Mst2**6.)/864.+

     &  (581*Mgl**8.*Mst2**8.)/216.-

     &  (1045*Mgl**6.*Mst2**10.)/864.-

     &  (1679*Mgl**4.*Mst2**12.)/1728.+

     &  (2119*Mgl**2.*Mst2**14.)/1728.-

     &  (19*Mst2**16.)/48.-

     &  (29*Mst2**18.)/(1728.*Mgl**2.)+

     &  (13*Mst2**20.)/(576.*Mgl**4.)+

     &  (3701*Mgl**14.*Mt**2.)/3456.-

     &  (7*Mgl**18.*Mt**2.)/(48.*Mst2**4.)+

     &  (379*Mgl**16.*Mt**2.)/(3456.*Mst2**2.)-

     &  (6881*Mgl**12.*Mst2**2.*Mt**2.)/3456.+

     &  (3361*Mgl**10.*Mst2**4.*Mt**2.)/3456.-

     &  (3127*Mgl**8.*Mst2**6.*Mt**2.)/3456.+

     &  (5635*Mgl**6.*Mst2**8.*Mt**2.)/3456.+

     &  (3169*Mgl**4.*Mst2**10.*Mt**2.)/3456.-

     &  (11989*Mgl**2.*Mst2**12.*Mt**2.)/3456.+

     &  (439*Mst2**14.*Mt**2.)/216.-

     &  (17*Mst2**16.*Mt**2.)/(288.*Mgl**2.)-

     &  (47*Mst2**18.*Mt**2.)/(288.*Mgl**4.)-

     &  (11*Mgl**12.*Mt**4.)/18.+

     &  (235*Mgl**16.*Mt**4.)/(576.*Mst2**4.)-

     &  (103*Mgl**14.*Mt**4.)/(192.*Mst2**2.)+

     &  (163*Mgl**10.*Mst2**2.*Mt**4.)/128.-

     &  (251*Mgl**8.*Mst2**4.*Mt**4.)/864.-

     &  (6089*Mgl**6.*Mst2**6.*Mt**4.)/3456.+

     &  (2039*Mgl**4.*Mst2**8.*Mt**4.)/1728.+

     &  (12119*Mgl**2.*Mst2**10.*Mt**4.)/3456.-

     &  (7433*Mst2**12.*Mt**4.)/1728.+

     &  (2207*Mst2**14.*Mt**4.)/(3456.*Mgl**2.)+

     &  (95*Mst2**16.*Mt**4.)/(192.*Mgl**4.)-

     &  (431*Mgl**10.*Mt**6.)/1728.-

     &  (2*Mgl**14.*Mt**6.)/(3.*Mst2**4.)+

     &  (181*Mgl**12.*Mt**6.)/(108.*Mst2**2.)-

     &  (6601*Mgl**8.*Mst2**2.*Mt**6.)/3456.+

     &  (1445*Mgl**6.*Mst2**4.*Mt**6.)/3456.-

     &  (817*Mgl**4.*Mst2**6.*Mt**6.)/1728.-

     &  (1103*Mgl**2.*Mst2**8.*Mt**6.)/864.+

     &  (16859*Mst2**10.*Mt**6.)/3456.-

     &  (1849*Mst2**12.*Mt**6.)/(1152.*Mgl**2.)-

     &  (19*Mst2**14.*Mt**6.)/(24.*Mgl**4.)-

     &  (9*Mgl**8.*Mt**8.)/64.+

     &  (67*Mgl**12.*Mt**8.)/(96.*Mst2**4.)-

     &  (4877*Mgl**10.*Mt**8.)/(1728.*Mst2**2.)+

     &  (2069*Mgl**6.*Mst2**2.*Mt**8.)/1152.-

     &  (13*Mgl**4.*Mst2**4.*Mt**8.)/54.+

     &  (5*Mgl**2.*Mst2**6.*Mt**8.)/36.-

     &  (5189*Mst2**8.*Mt**8.)/1728.+

     &  (1889*Mst2**10.*Mt**8.)/(1152.*Mgl**2.)+

     &  (21*Mst2**12.*Mt**8.)/(32.*Mgl**4.)-

     &  (13*Mgl**6.*Mt**10.)/24.-

     &  (25*Mgl**10.*Mt**10.)/(72.*Mst2**4.)+

     &  (4283*Mgl**8.*Mt**10.)/(1728.*Mst2**2.)-

     &  (8863*Mgl**4.*Mst2**2.*Mt**10.)/3456.-

     &  (7501*Mgl**2.*Mst2**4.*Mt**10.)/3456.+

     &  (625*Mst2**6.*Mt**10.)/3456.-

     &  (787*Mst2**8.*Mt**10.)/(3456.*Mgl**2.)-

     &  (7*Mst2**10.*Mt**10.)/(48.*Mgl**4.)+

     &  (1379*Mgl**4.*Mt**12.)/576.-

     &  (31*Mgl**8.*Mt**12.)/(96.*Mst2**4.)-

     &  (671*Mgl**6.*Mt**12.)/(576.*Mst2**2.)+

     &  (4645*Mgl**2.*Mst2**2.*Mt**12.)/1152.+

     &  (1445*Mst2**4.*Mt**12.)/864.-

     &  (1177*Mst2**6.*Mt**12.)/(1152.*Mgl**2.)-

     &  (7*Mst2**8.*Mt**12.)/(32.*Mgl**4.)-

     &  (3397*Mgl**2.*Mt**14.)/1728.+

     &  (5*Mgl**6.*Mt**14.)/(6.*Mst2**4.)+

     &  (73*Mgl**4.*Mt**14.)/(144.*Mst2**2.)-

     &  (1745*Mst2**2.*Mt**14.)/1152.+

     &  (367*Mst2**4.*Mt**14.)/(384.*Mgl**2.)+

     &  (5*Mst2**6.*Mt**14.)/(24.*Mgl**4.)+

     &  (25*Mt**16.)/64.-

     &  (431*Mgl**4.*Mt**16.)/(576.*Mst2**4.)-

     &  (301*Mgl**2.*Mt**16.)/(864.*Mst2**2.)-

     &  (1213*Mst2**2.*Mt**16.)/(3456.*Mgl**2.)-

     &  (13*Mst2**4.*Mt**16.)/(192.*Mgl**4.)+

     &  (163*Mt**18.)/(3456.*Mgl**2.)+

     &  (47*Mgl**2.*Mt**18.)/(144.*Mst2**4.)+

     &  (407*Mt**18.)/(3456.*Mst2**2.)+

     &  (Mst2**2.*Mt**18.)/(288.*Mgl**4.)+

     &  Mt**20./(576.*Mgl**4.)-

     &  (11*Mt**20.)/(192.*Mst2**4.))*d123(Mt,Mgl,Mst2)**4.*

     &  ln(mu,Mt)+(Mgl**3./(96.*Mst1**2.)-

     &  Mst1**2./(96.*Mgl**1.)-Mgl**3./(96.*Mst2**2.)+

     &  Mst2**2./(96.*Mgl**1.)+

     &  (Mgl*Mt**2.)/(96.*Mst1**2.)-

     &  (Mgl*Mt**2.)/(96.*Mst2**2.)-

     &  (7*Mt**4.)/(288.*Mgl**1.*Mst1**2.)+

     &  (7*Mt**4.)/(288.*Mgl**1.*Mst2**2.)+

     &  Mt**6./(288.*Mgl**3.*Mst1**2.)-

     &  Mt**6./(288.*Mgl**3.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mt)+(-Mgl**5./24.+Mgl**7./(48.*Mst1**2.)+

     &  (Mgl*Mst1**4.)/24.-Mst1**6./(48.*Mgl**1.)-

     &  (19*Mgl**3.*Mt**2.)/288.-

     &  (5*Mgl**7.*Mt**2.)/(144.*Mst1**4.)+

     &  (85*Mgl**5.*Mt**2.)/(864.*Mst1**2.)+

     &  (127*Mgl*Mst1**2.*Mt**2.)/288.-

     &  (409*Mst1**4.*Mt**2.)/(864.*Mgl**1.)+

     &  (5*Mst1**6.*Mt**2.)/(144.*Mgl**3.)+

     &  (67*Mgl*Mt**4.)/864.+

     &  (5*Mgl**5.*Mt**4.)/(48.*Mst1**4.)+

     &  (41*Mgl**3.*Mt**4.)/(432.*Mst1**2.)+

     &  (467*Mst1**2.*Mt**4.)/(864.*Mgl**1.)-

     &  (17*Mst1**4.*Mt**4.)/(288.*Mgl**3.)-

     &  (41*Mt**6.)/(432.*Mgl**1.)-

     &  (Mgl**3.*Mt**6.)/(8.*Mst1**4.)-

     &  (209*Mgl*Mt**6.)/(864.*Mst1**2.)+

     &  (Mst1**2.*Mt**6.)/(288.*Mgl**3.)+

     &  Mt**8./(32.*Mgl**3.)+

     &  (11*Mgl*Mt**8.)/(144.*Mst1**4.)+

     &  (17*Mt**8.)/(288.*Mgl**1.*Mst1**2.)-

     &  Mt**10./(48.*Mgl**1.*Mst1**4.)-

     &  Mt**10./(96.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((17*Mgl**9.)/72.-(17*Mgl**11.)/(288.*Mst1**2.)-

     &  (85*Mgl**7.*Mst1**2.)/288.+

     &  (85*Mgl**3.*Mst1**6.)/288.-

     &  (17*Mgl*Mst1**8.)/72.+

     &  (17*Mst1**10.)/(288.*Mgl**1.)+

     &  (149*Mgl**7.*Mt**2.)/288.+

     &  (Mgl**11.*Mt**2.)/(144.*Mst1**4.)-

     &  (271*Mgl**9.*Mt**2.)/(864.*Mst1**2.)-

     &  (11*Mgl**5.*Mst1**2.*Mt**2.)/27.+

     &  (125*Mgl**3.*Mst1**4.*Mt**2.)/108.-

     &  (473*Mgl*Mst1**6.*Mt**2.)/288.+

     &  (595*Mst1**8.*Mt**2.)/(864.*Mgl**1.)-

     &  (Mst1**10.*Mt**2.)/(144.*Mgl**3.)-

     &  (77*Mgl**5.*Mt**4.)/864.-

     &  (Mgl**9.*Mt**4.)/(16.*Mst1**4.)+

     &  (601*Mgl**7.*Mt**4.)/(864.*Mst1**2.)-

     &  (203*Mgl**3.*Mst1**2.*Mt**4.)/432.+

     &  (557*Mgl*Mst1**4.*Mt**4.)/288.-

     &  (1843*Mst1**6.*Mt**4.)/(864.*Mgl**1.)+

     &  (Mst1**8.*Mt**4.)/(8.*Mgl**3.)+

     &  (37*Mgl**3.*Mt**6.)/144.+

     &  (7*Mgl**7.*Mt**6.)/(72.*Mst1**4.)+

     &  (571*Mgl**5.*Mt**6.)/(864.*Mst1**2.)-

     &  (827*Mgl*Mst1**2.*Mt**6.)/864.+

     &  (523*Mst1**4.*Mt**6.)/(432.*Mgl**1.)-

     &  (5*Mst1**6.*Mt**6.)/(16.*Mgl**3.)-

     &  (265*Mgl*Mt**8.)/864.-

     &  (Mgl**5.*Mt**8.)/(24.*Mst1**4.)-

     &  (385*Mgl**3.*Mt**8.)/(216.*Mst1**2.)+

     &  (175*Mst1**2.*Mt**8.)/(216.*Mgl**1.)+

     &  (Mst1**4.*Mt**8.)/(4.*Mgl**3.)-

     &  (19*Mt**10.)/(32.*Mgl**1.)+

     &  (Mgl**3.*Mt**10.)/(16.*Mst1**4.)+

     &  (8*Mgl*Mt**10.)/(9.*Mst1**2.)-

     &  (Mst1**2.*Mt**10.)/(48.*Mgl**3.)-

     &  Mt**12./(24.*Mgl**3.)-

     &  (17*Mgl*Mt**12.)/(144.*Mst1**4.)-

     &  (7*Mt**12.)/(72.*Mgl**1.*Mst1**2.)+

     &  Mt**14./(18.*Mgl**1.*Mst1**4.)+

     &  Mt**14./(144.*Mgl**3.*Mst1**2.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  (-Mgl**13./6.+Mgl**15./(36.*Mst1**2.)+

     &  (7*Mgl**11.*Mst1**2.)/18.-

     &  (7*Mgl**9.*Mst1**4.)/18.+

     &  (7*Mgl**5.*Mst1**8.)/18.-

     &  (7*Mgl**3.*Mst1**10.)/18.+(Mgl*Mst1**12.)/6.-

     &  Mst1**14./(36.*Mgl**1.)-

     &  (1717*Mgl**11.*Mt**2.)/864.+

     &  (17*Mgl**15.*Mt**2.)/(144.*Mst1**4.)+

     &  (269*Mgl**13.*Mt**2.)/(864.*Mst1**2.)+

     &  (1759*Mgl**9.*Mst1**2.*Mt**2.)/864.+

     &  (169*Mgl**7.*Mst1**4.*Mt**2.)/288.-

     &  (169*Mgl**5.*Mst1**6.*Mt**2.)/288.-

     &  (1759*Mgl**3.*Mst1**8.*Mt**2.)/864.+

     &  (1717*Mgl*Mst1**10.*Mt**2.)/864.-

     &  (269*Mst1**12.*Mt**2.)/(864.*Mgl**1.)-

     &  (17*Mst1**14.*Mt**2.)/(144.*Mgl**3.)+

     &  (4141*Mgl**9.*Mt**4.)/864.-

     &  (95*Mgl**13.*Mt**4.)/(144.*Mst1**4.)-

     &  (395*Mgl**11.*Mt**4.)/(288.*Mst1**2.)-

     &  (2069*Mgl**7.*Mst1**2.*Mt**4.)/864.-

     &  (17*Mgl**5.*Mst1**4.*Mt**4.)/72.+

     &  (2081*Mgl**3.*Mst1**6.*Mt**4.)/864.-

     &  (4495*Mgl*Mst1**8.*Mt**4.)/864.+

     &  (71*Mst1**10.*Mt**4.)/(32.*Mgl**1.)+

     &  (4*Mst1**12.*Mt**4.)/(9.*Mgl**3.)-

     &  (3251*Mgl**7.*Mt**6.)/864.+

     &  (7*Mgl**11.*Mt**6.)/(4.*Mst1**4.)+

     &  (157*Mgl**9.*Mt**6.)/(216.*Mst1**2.)+

     &  (25*Mgl**5.*Mst1**2.*Mt**6.)/16.+

     &  (131*Mgl**3.*Mst1**4.*Mt**6.)/144.+

     &  (118*Mgl*Mst1**6.*Mt**6.)/27.-

     &  (3295*Mst1**8.*Mt**6.)/(864.*Mgl**1.)-

     &  (67*Mst1**10.*Mt**6.)/(144.*Mgl**3.)+

     &  (2609*Mgl**5.*Mt**8.)/432.-

     &  (49*Mgl**9.*Mt**8.)/(16.*Mst1**4.)+

     &  (449*Mgl**7.*Mt**8.)/(144.*Mst1**2.)+

     &  (191*Mgl**3.*Mst1**2.*Mt**8.)/216.-

     &  (503*Mgl*Mst1**4.*Mt**8.)/216.+

     &  (131*Mst1**6.*Mt**8.)/(144.*Mgl**1.)-

     &  (5*Mst1**8.*Mt**8.)/(24.*Mgl**3.)-

     &  (6611*Mgl**3.*Mt**10.)/864.+

     &  (34*Mgl**7.*Mt**10.)/(9.*Mst1**4.)-

     &  (499*Mgl**5.*Mt**10.)/(96.*Mst1**2.)-

     &  (119*Mgl*Mst1**2.*Mt**10.)/864.+

     &  (311*Mst1**4.*Mt**10.)/(96.*Mgl**1.)+

     &  (35*Mst1**6.*Mt**10.)/(48.*Mgl**3.)+

     &  (1741*Mgl*Mt**12.)/864.-

     &  (433*Mgl**5.*Mt**12.)/(144.*Mst1**4.)+

     &  (2603*Mgl**3.*Mt**12.)/(864.*Mst1**2.)-

     &  (2567*Mst1**2.*Mt**12.)/(864.*Mgl**1.)-

     &  (17*Mst1**4.*Mt**12.)/(36.*Mgl**3.)+

     &  (611*Mt**14.)/(864.*Mgl**1.)+

     &  (23*Mgl**3.*Mt**14.)/(18.*Mst1**4.)-

     &  (307*Mgl*Mt**14.)/(432.*Mst1**2.)+

     &  (11*Mst1**2.*Mt**14.)/(144.*Mgl**3.)+

     &  Mt**16./(72.*Mgl**3.)-

     &  (23*Mgl*Mt**16.)/(144.*Mst1**4.)+

     &  Mt**16./(12.*Mgl**1.*Mst1**2.)-

     &  (5*Mt**18.)/(144.*Mgl**1.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((337*Mgl**15.*Mt**2.)/216.-

     &  (13*Mgl**19.*Mt**2.)/(144.*Mst1**4.)-

     &  (5*Mgl**17.*Mt**2.)/(216.*Mst1**2.)-

     &  (1445*Mgl**13.*Mst1**2.*Mt**2.)/432.+

     &  (13*Mgl**11.*Mst1**4.*Mt**2.)/24.+

     &  (581*Mgl**9.*Mst1**6.*Mt**2.)/108.-

     &  (581*Mgl**7.*Mst1**8.*Mt**2.)/108.-

     &  (13*Mgl**5.*Mst1**10.*Mt**2.)/24.+

     &  (1445*Mgl**3.*Mst1**12.*Mt**2.)/432.-

     &  (337*Mgl*Mst1**14.*Mt**2.)/216.+

     &  (5*Mst1**16.*Mt**2.)/(216.*Mgl**1.)+

     &  (13*Mst1**18.*Mt**2.)/(144.*Mgl**3.)-

     &  (2413*Mgl**13.*Mt**4.)/432.+

     &  (97*Mgl**17.*Mt**4.)/(144.*Mst1**4.)+

     &  (223*Mgl**15.*Mt**4.)/(864.*Mst1**2.)+

     &  (4945*Mgl**11.*Mst1**2.*Mt**4.)/864.+

     &  (31*Mgl**9.*Mst1**4.*Mt**4.)/24.-

     &  (15*Mgl**7.*Mst1**6.*Mt**4.)/32.-

     &  (29*Mgl**5.*Mst1**8.*Mt**4.)/18.-

     &  (4093*Mgl**3.*Mst1**10.*Mt**4.)/864.+

     &  (2503*Mgl*Mst1**12.*Mt**4.)/432.-

     &  (335*Mst1**14.*Mt**4.)/(432.*Mgl**1.)-

     &  (9*Mst1**16.*Mt**4.)/(16.*Mgl**3.)+

     &  (6577*Mgl**11.*Mt**6.)/864.-

     &  (83*Mgl**15.*Mt**6.)/(36.*Mst1**4.)-

     &  (361*Mgl**13.*Mt**6.)/(864.*Mst1**2.)-

     &  (923*Mgl**9.*Mst1**2.*Mt**6.)/288.-

     &  (2881*Mgl**7.*Mst1**4.*Mt**6.)/864.+

     &  (3613*Mgl**5.*Mst1**6.*Mt**6.)/864.+

     &  (103*Mgl**3.*Mst1**8.*Mt**6.)/96.-

     &  (7099*Mgl*Mst1**10.*Mt**6.)/864.+

     &  (2761*Mst1**12.*Mt**6.)/(864.*Mgl**1.)+

     &  (17*Mst1**14.*Mt**6.)/(12.*Mgl**3.)-

     &  (3425*Mgl**9.*Mt**8.)/432.+

     &  (179*Mgl**13.*Mt**8.)/(36.*Mst1**4.)-

     &  (1135*Mgl**11.*Mt**8.)/(864.*Mst1**2.)+

     &  (35*Mgl**7.*Mst1**2.*Mt**8.)/12.+

     &  (989*Mgl**5.*Mst1**4.*Mt**8.)/216.+

     &  (659*Mgl**3.*Mst1**6.*Mt**8.)/288.+

     &  (2731*Mgl*Mst1**8.*Mt**8.)/432.-

     &  (2149*Mst1**10.*Mt**8.)/(432.*Mgl**1.)-

     &  (7*Mst1**12.*Mt**8.)/(4.*Mgl**3.)+

     &  (3839*Mgl**7.*Mt**10.)/288.-

     &  (559*Mgl**11.*Mt**10.)/(72.*Mst1**4.)+

     &  (4181*Mgl**9.*Mt**10.)/(864.*Mst1**2.)+

     &  (155*Mgl**5.*Mst1**2.*Mt**10.)/48.-

     &  (167*Mgl**3.*Mst1**4.*Mt**10.)/432.-

     &  (2791*Mgl*Mst1**6.*Mt**10.)/864.+

     &  (2125*Mst1**8.*Mt**10.)/(864.*Mgl**1.)+

     &  (7*Mst1**10.*Mt**10.)/(8.*Mgl**3.)-

     &  (1207*Mgl**5.*Mt**12.)/72.+

     &  (659*Mgl**9.*Mt**12.)/(72.*Mst1**4.)-

     &  (1613*Mgl**7.*Mt**12.)/(288.*Mst1**2.)-

     &  (8411*Mgl**3.*Mst1**2.*Mt**12.)/864.-

     &  (2*Mgl*Mst1**4.*Mt**12.)/3.+

     &  (265*Mst1**6.*Mt**12.)/(144.*Mgl**1.)+

     &  (7*Mst1**8.*Mt**12.)/(24.*Mgl**3.)+

     &  (2761*Mgl**3.*Mt**14.)/288.-

     &  (283*Mgl**7.*Mt**14.)/(36.*Mst1**4.)+

     &  (691*Mgl**5.*Mt**14.)/(288.*Mst1**2.)+

     &  (2759*Mgl*Mst1**2.*Mt**14.)/864.-

     &  (815*Mst1**4.*Mt**14.)/(288.*Mgl**1.)-

     &  (7*Mst1**6.*Mt**14.)/(12.*Mgl**3.)-

     &  (701*Mgl*Mt**16.)/432.+

     &  (163*Mgl**5.*Mt**16.)/(36.*Mst1**4.)+

     &  (29*Mgl**3.*Mt**16.)/(288.*Mst1**2.)+

     &  (179*Mst1**2.*Mt**16.)/(144.*Mgl**1.)+

     &  (Mst1**4.*Mt**16.)/(4.*Mgl**3.)-

     &  (157*Mt**18.)/(864.*Mgl**1.)-

     &  (221*Mgl**3.*Mt**18.)/(144.*Mst1**4.)-

     &  (209*Mgl*Mt**18.)/(864.*Mst1**2.)-

     &  (Mst1**2.*Mt**18.)/(48.*Mgl**3.)-

     &  Mt**20./(144.*Mgl**3.)+

     &  (11*Mgl*Mt**20.)/(48.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  (Mgl**5./24.-Mgl**7./(48.*Mst2**2.)-

     &  (Mgl*Mst2**4.)/24.+Mst2**6./(48.*Mgl**1.)+

     &  (19*Mgl**3.*Mt**2.)/288.+

     &  (5*Mgl**7.*Mt**2.)/(144.*Mst2**4.)-

     &  (85*Mgl**5.*Mt**2.)/(864.*Mst2**2.)-

     &  (127*Mgl*Mst2**2.*Mt**2.)/288.+

     &  (409*Mst2**4.*Mt**2.)/(864.*Mgl**1.)-

     &  (5*Mst2**6.*Mt**2.)/(144.*Mgl**3.)-

     &  (67*Mgl*Mt**4.)/864.-

     &  (5*Mgl**5.*Mt**4.)/(48.*Mst2**4.)-

     &  (41*Mgl**3.*Mt**4.)/(432.*Mst2**2.)-

     &  (467*Mst2**2.*Mt**4.)/(864.*Mgl**1.)+

     &  (17*Mst2**4.*Mt**4.)/(288.*Mgl**3.)+

     &  (41*Mt**6.)/(432.*Mgl**1.)+

     &  (Mgl**3.*Mt**6.)/(8.*Mst2**4.)+

     &  (209*Mgl*Mt**6.)/(864.*Mst2**2.)-

     &  (Mst2**2.*Mt**6.)/(288.*Mgl**3.)-

     &  Mt**8./(32.*Mgl**3.)-

     &  (11*Mgl*Mt**8.)/(144.*Mst2**4.)-

     &  (17*Mt**8.)/(288.*Mgl**1.*Mst2**2.)+

     &  Mt**10./(48.*Mgl**1.*Mst2**4.)+

     &  Mt**10./(96.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((-17*Mgl**9.)/72.+(17*Mgl**11.)/(288.*Mst2**2.)+

     &  (85*Mgl**7.*Mst2**2.)/288.-

     &  (85*Mgl**3.*Mst2**6.)/288.+

     &  (17*Mgl*Mst2**8.)/72.-

     &  (17*Mst2**10.)/(288.*Mgl**1.)-

     &  (149*Mgl**7.*Mt**2.)/288.-

     &  (Mgl**11.*Mt**2.)/(144.*Mst2**4.)+

     &  (271*Mgl**9.*Mt**2.)/(864.*Mst2**2.)+

     &  (11*Mgl**5.*Mst2**2.*Mt**2.)/27.-

     &  (125*Mgl**3.*Mst2**4.*Mt**2.)/108.+

     &  (473*Mgl*Mst2**6.*Mt**2.)/288.-

     &  (595*Mst2**8.*Mt**2.)/(864.*Mgl**1.)+

     &  (Mst2**10.*Mt**2.)/(144.*Mgl**3.)+

     &  (77*Mgl**5.*Mt**4.)/864.+

     &  (Mgl**9.*Mt**4.)/(16.*Mst2**4.)-

     &  (601*Mgl**7.*Mt**4.)/(864.*Mst2**2.)+

     &  (203*Mgl**3.*Mst2**2.*Mt**4.)/432.-

     &  (557*Mgl*Mst2**4.*Mt**4.)/288.+

     &  (1843*Mst2**6.*Mt**4.)/(864.*Mgl**1.)-

     &  (Mst2**8.*Mt**4.)/(8.*Mgl**3.)-

     &  (37*Mgl**3.*Mt**6.)/144.-

     &  (7*Mgl**7.*Mt**6.)/(72.*Mst2**4.)-

     &  (571*Mgl**5.*Mt**6.)/(864.*Mst2**2.)+

     &  (827*Mgl*Mst2**2.*Mt**6.)/864.-

     &  (523*Mst2**4.*Mt**6.)/(432.*Mgl**1.)+

     &  (5*Mst2**6.*Mt**6.)/(16.*Mgl**3.)+

     &  (265*Mgl*Mt**8.)/864.+

     &  (Mgl**5.*Mt**8.)/(24.*Mst2**4.)+

     &  (385*Mgl**3.*Mt**8.)/(216.*Mst2**2.)-

     &  (175*Mst2**2.*Mt**8.)/(216.*Mgl**1.)-

     &  (Mst2**4.*Mt**8.)/(4.*Mgl**3.)+

     &  (19*Mt**10.)/(32.*Mgl**1.)-

     &  (Mgl**3.*Mt**10.)/(16.*Mst2**4.)-

     &  (8*Mgl*Mt**10.)/(9.*Mst2**2.)+

     &  (Mst2**2.*Mt**10.)/(48.*Mgl**3.)+

     &  Mt**12./(24.*Mgl**3.)+

     &  (17*Mgl*Mt**12.)/(144.*Mst2**4.)+

     &  (7*Mt**12.)/(72.*Mgl**1.*Mst2**2.)-

     &  Mt**14./(18.*Mgl**1.*Mst2**4.)-

     &  Mt**14./(144.*Mgl**3.*Mst2**2.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  (Mgl**13./6.-Mgl**15./(36.*Mst2**2.)-

     &  (7*Mgl**11.*Mst2**2.)/18.+

     &  (7*Mgl**9.*Mst2**4.)/18.-

     &  (7*Mgl**5.*Mst2**8.)/18.+

     &  (7*Mgl**3.*Mst2**10.)/18.-(Mgl*Mst2**12.)/6.+

     &  Mst2**14./(36.*Mgl**1.)+

     &  (1717*Mgl**11.*Mt**2.)/864.-

     &  (17*Mgl**15.*Mt**2.)/(144.*Mst2**4.)-

     &  (269*Mgl**13.*Mt**2.)/(864.*Mst2**2.)-

     &  (1759*Mgl**9.*Mst2**2.*Mt**2.)/864.-

     &  (169*Mgl**7.*Mst2**4.*Mt**2.)/288.+

     &  (169*Mgl**5.*Mst2**6.*Mt**2.)/288.+

     &  (1759*Mgl**3.*Mst2**8.*Mt**2.)/864.-

     &  (1717*Mgl*Mst2**10.*Mt**2.)/864.+

     &  (269*Mst2**12.*Mt**2.)/(864.*Mgl**1.)+

     &  (17*Mst2**14.*Mt**2.)/(144.*Mgl**3.)-

     &  (4141*Mgl**9.*Mt**4.)/864.+

     &  (95*Mgl**13.*Mt**4.)/(144.*Mst2**4.)+

     &  (395*Mgl**11.*Mt**4.)/(288.*Mst2**2.)+

     &  (2069*Mgl**7.*Mst2**2.*Mt**4.)/864.+

     &  (17*Mgl**5.*Mst2**4.*Mt**4.)/72.-

     &  (2081*Mgl**3.*Mst2**6.*Mt**4.)/864.+

     &  (4495*Mgl*Mst2**8.*Mt**4.)/864.-

     &  (71*Mst2**10.*Mt**4.)/(32.*Mgl**1.)-

     &  (4*Mst2**12.*Mt**4.)/(9.*Mgl**3.)+

     &  (3251*Mgl**7.*Mt**6.)/864.-

     &  (7*Mgl**11.*Mt**6.)/(4.*Mst2**4.)-

     &  (157*Mgl**9.*Mt**6.)/(216.*Mst2**2.)-

     &  (25*Mgl**5.*Mst2**2.*Mt**6.)/16.-

     &  (131*Mgl**3.*Mst2**4.*Mt**6.)/144.-

     &  (118*Mgl*Mst2**6.*Mt**6.)/27.+

     &  (3295*Mst2**8.*Mt**6.)/(864.*Mgl**1.)+

     &  (67*Mst2**10.*Mt**6.)/(144.*Mgl**3.)-

     &  (2609*Mgl**5.*Mt**8.)/432.+

     &  (49*Mgl**9.*Mt**8.)/(16.*Mst2**4.)-

     &  (449*Mgl**7.*Mt**8.)/(144.*Mst2**2.)-

     &  (191*Mgl**3.*Mst2**2.*Mt**8.)/216.+

     &  (503*Mgl*Mst2**4.*Mt**8.)/216.-

     &  (131*Mst2**6.*Mt**8.)/(144.*Mgl**1.)+

     &  (5*Mst2**8.*Mt**8.)/(24.*Mgl**3.)+

     &  (6611*Mgl**3.*Mt**10.)/864.-

     &  (34*Mgl**7.*Mt**10.)/(9.*Mst2**4.)+

     &  (499*Mgl**5.*Mt**10.)/(96.*Mst2**2.)+

     &  (119*Mgl*Mst2**2.*Mt**10.)/864.-

     &  (311*Mst2**4.*Mt**10.)/(96.*Mgl**1.)-

     &  (35*Mst2**6.*Mt**10.)/(48.*Mgl**3.)-

     &  (1741*Mgl*Mt**12.)/864.+

     &  (433*Mgl**5.*Mt**12.)/(144.*Mst2**4.)-

     &  (2603*Mgl**3.*Mt**12.)/(864.*Mst2**2.)+

     &  (2567*Mst2**2.*Mt**12.)/(864.*Mgl**1.)+

     &  (17*Mst2**4.*Mt**12.)/(36.*Mgl**3.)-

     &  (611*Mt**14.)/(864.*Mgl**1.)-

     &  (23*Mgl**3.*Mt**14.)/(18.*Mst2**4.)+

     &  (307*Mgl*Mt**14.)/(432.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**14.)/(144.*Mgl**3.)-

     &  Mt**16./(72.*Mgl**3.)+

     &  (23*Mgl*Mt**16.)/(144.*Mst2**4.)-

     &  Mt**16./(12.*Mgl**1.*Mst2**2.)+

     &  (5*Mt**18.)/(144.*Mgl**1.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  ((-337*Mgl**15.*Mt**2.)/216.+

     &  (13*Mgl**19.*Mt**2.)/(144.*Mst2**4.)+

     &  (5*Mgl**17.*Mt**2.)/(216.*Mst2**2.)+

     &  (1445*Mgl**13.*Mst2**2.*Mt**2.)/432.-

     &  (13*Mgl**11.*Mst2**4.*Mt**2.)/24.-

     &  (581*Mgl**9.*Mst2**6.*Mt**2.)/108.+

     &  (581*Mgl**7.*Mst2**8.*Mt**2.)/108.+

     &  (13*Mgl**5.*Mst2**10.*Mt**2.)/24.-

     &  (1445*Mgl**3.*Mst2**12.*Mt**2.)/432.+

     &  (337*Mgl*Mst2**14.*Mt**2.)/216.-

     &  (5*Mst2**16.*Mt**2.)/(216.*Mgl**1.)-

     &  (13*Mst2**18.*Mt**2.)/(144.*Mgl**3.)+

     &  (2413*Mgl**13.*Mt**4.)/432.-

     &  (97*Mgl**17.*Mt**4.)/(144.*Mst2**4.)-

     &  (223*Mgl**15.*Mt**4.)/(864.*Mst2**2.)-

     &  (4945*Mgl**11.*Mst2**2.*Mt**4.)/864.-

     &  (31*Mgl**9.*Mst2**4.*Mt**4.)/24.+

     &  (15*Mgl**7.*Mst2**6.*Mt**4.)/32.+

     &  (29*Mgl**5.*Mst2**8.*Mt**4.)/18.+

     &  (4093*Mgl**3.*Mst2**10.*Mt**4.)/864.-

     &  (2503*Mgl*Mst2**12.*Mt**4.)/432.+

     &  (335*Mst2**14.*Mt**4.)/(432.*Mgl**1.)+

     &  (9*Mst2**16.*Mt**4.)/(16.*Mgl**3.)-

     &  (6577*Mgl**11.*Mt**6.)/864.+

     &  (83*Mgl**15.*Mt**6.)/(36.*Mst2**4.)+

     &  (361*Mgl**13.*Mt**6.)/(864.*Mst2**2.)+

     &  (923*Mgl**9.*Mst2**2.*Mt**6.)/288.+

     &  (2881*Mgl**7.*Mst2**4.*Mt**6.)/864.-

     &  (3613*Mgl**5.*Mst2**6.*Mt**6.)/864.-

     &  (103*Mgl**3.*Mst2**8.*Mt**6.)/96.+

     &  (7099*Mgl*Mst2**10.*Mt**6.)/864.-

     &  (2761*Mst2**12.*Mt**6.)/(864.*Mgl**1.)-

     &  (17*Mst2**14.*Mt**6.)/(12.*Mgl**3.)+

     &  (3425*Mgl**9.*Mt**8.)/432.-

     &  (179*Mgl**13.*Mt**8.)/(36.*Mst2**4.)+

     &  (1135*Mgl**11.*Mt**8.)/(864.*Mst2**2.)-

     &  (35*Mgl**7.*Mst2**2.*Mt**8.)/12.-

     &  (989*Mgl**5.*Mst2**4.*Mt**8.)/216.-

     &  (659*Mgl**3.*Mst2**6.*Mt**8.)/288.-

     &  (2731*Mgl*Mst2**8.*Mt**8.)/432.+

     &  (2149*Mst2**10.*Mt**8.)/(432.*Mgl**1.)+

     &  (7*Mst2**12.*Mt**8.)/(4.*Mgl**3.)-

     &  (3839*Mgl**7.*Mt**10.)/288.+

     &  (559*Mgl**11.*Mt**10.)/(72.*Mst2**4.)-

     &  (4181*Mgl**9.*Mt**10.)/(864.*Mst2**2.)-

     &  (155*Mgl**5.*Mst2**2.*Mt**10.)/48.+

     &  (167*Mgl**3.*Mst2**4.*Mt**10.)/432.+

     &  (2791*Mgl*Mst2**6.*Mt**10.)/864.-

     &  (2125*Mst2**8.*Mt**10.)/(864.*Mgl**1.)-

     &  (7*Mst2**10.*Mt**10.)/(8.*Mgl**3.)+

     &  (1207*Mgl**5.*Mt**12.)/72.-

     &  (659*Mgl**9.*Mt**12.)/(72.*Mst2**4.)+

     &  (1613*Mgl**7.*Mt**12.)/(288.*Mst2**2.)+

     &  (8411*Mgl**3.*Mst2**2.*Mt**12.)/864.+

     &  (2*Mgl*Mst2**4.*Mt**12.)/3.-

     &  (265*Mst2**6.*Mt**12.)/(144.*Mgl**1.)-

     &  (7*Mst2**8.*Mt**12.)/(24.*Mgl**3.)-

     &  (2761*Mgl**3.*Mt**14.)/288.+

     &  (283*Mgl**7.*Mt**14.)/(36.*Mst2**4.)-

     &  (691*Mgl**5.*Mt**14.)/(288.*Mst2**2.)-

     &  (2759*Mgl*Mst2**2.*Mt**14.)/864.+

     &  (815*Mst2**4.*Mt**14.)/(288.*Mgl**1.)+

     &  (7*Mst2**6.*Mt**14.)/(12.*Mgl**3.)+

     &  (701*Mgl*Mt**16.)/432.-

     &  (163*Mgl**5.*Mt**16.)/(36.*Mst2**4.)-

     &  (29*Mgl**3.*Mt**16.)/(288.*Mst2**2.)-

     &  (179*Mst2**2.*Mt**16.)/(144.*Mgl**1.)-

     &  (Mst2**4.*Mt**16.)/(4.*Mgl**3.)+

     &  (157*Mt**18.)/(864.*Mgl**1.)+

     &  (221*Mgl**3.*Mt**18.)/(144.*Mst2**4.)+

     &  (209*Mgl*Mt**18.)/(864.*Mst2**2.)+

     &  (Mst2**2.*Mt**18.)/(48.*Mgl**3.)+

     &  Mt**20./(144.*Mgl**3.)-

     &  (11*Mgl*Mt**20.)/(48.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mt)+

     &  (0.10069444444444445+(5*Mgl**2.)/(576.*Mst1**2.)+

     &  (5*Mgl**2.)/(576.*Mst2**2.)-

     &  Mt**2./(576.*Mst1**2.)-Mt**2./(576.*Mst2**2.))*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  (Mgl**4./1152.+Mgl**8./(288.*Mst1**4.)-

     &  (13*Mgl**6.)/(1152.*Mst1**2.)-

     &  (Mgl**2.*Mst1**2.)/384.+(19*Mst1**4.)/1152.-

     &  Mst1**6./(144.*Mgl**2.)+

     &  (23*Mgl**2.*Mt**2.)/576.-

     &  (Mgl**6.*Mt**2.)/(144.*Mst1**4.)-

     &  (17*Mgl**4.*Mt**2.)/(1152.*Mst1**2.)+

     &  (121*Mst1**2.*Mt**2.)/1152.-

     &  (Mst1**4.*Mt**2.)/(192.*Mgl**2.)-

     &  (121*Mt**4.)/1152.-

     &  (Mgl**2.*Mt**4.)/(384.*Mst1**2.)+

     &  (Mst1**2.*Mt**4.)/(32.*Mgl**2.)-

     &  (11*Mt**6.)/(576.*Mgl**2.)+

     &  (Mgl**2.*Mt**6.)/(144.*Mst1**4.)+

     &  (11*Mt**6.)/(384.*Mst1**2.)-Mt**8./(288.*Mst1**4.)

     &  )*d123(Mt,Mgl,Mst1)*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-31*Mgl**8.)/384.-Mgl**12./(288.*Mst1**4.)+

     &  (49*Mgl**10.)/(1152.*Mst1**2.)+

     &  (37*Mgl**6.*Mst1**2.)/576.-

     &  (53*Mgl**4.*Mst1**4.)/576.+

     &  (17*Mgl**2.*Mst1**6.)/128.-(85*Mst1**8.)/1152.+

     &  Mst1**10./(96.*Mgl**2.)-(Mgl**6.*Mt**2.)/12.+

     &  (7*Mgl**10.*Mt**2.)/(288.*Mst1**4.)-

     &  (Mgl**8.*Mt**2.)/(192.*Mst1**2.)-

     &  (11*Mgl**4.*Mst1**2.*Mt**2.)/144.+

     &  (65*Mgl**2.*Mst1**4.*Mt**2.)/576.+

     &  (11*Mst1**6.*Mt**2.)/192.-

     &  (17*Mst1**8.*Mt**2.)/(576.*Mgl**2.)+

     &  (Mgl**4.*Mt**4.)/96.-

     &  (19*Mgl**8.*Mt**4.)/(576.*Mst1**4.)-

     &  (11*Mgl**6.*Mt**4.)/(96.*Mst1**2.)-

     &  (55*Mgl**2.*Mst1**2.*Mt**4.)/288.+

     &  (101*Mst1**4.*Mt**4.)/576.-

     &  (Mst1**6.*Mt**4.)/(144.*Mgl**2.)-

     &  (73*Mgl**2.*Mt**6.)/576.-

     &  (Mgl**6.*Mt**6.)/(96.*Mst1**4.)-

     &  (Mgl**4.*Mt**6.)/(18.*Mst1**2.)-

     &  (89*Mst1**2.*Mt**6.)/288.+

     &  (3*Mst1**4.*Mt**6.)/(32.*Mgl**2.)+

     &  (289*Mt**8.)/1152.+

     &  (11*Mgl**4.*Mt**8.)/(288.*Mst1**4.)+

     &  (89*Mgl**2.*Mt**8.)/(384.*Mst1**2.)-

     &  (29*Mst1**2.*Mt**8.)/(288.*Mgl**2.)+

     &  (19*Mt**10.)/(576.*Mgl**2.)-

     &  (Mgl**2.*Mt**10.)/(72.*Mst1**4.)-

     &  (19*Mt**10.)/(192.*Mst1**2.)-

     &  Mt**12./(576.*Mst1**4.))*d123(Mt,Mgl,Mst1)**2.*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  ((13*Mgl**12.)/64.-Mgl**16./(288.*Mst1**4.)-

     &  (7*Mgl**14.)/(144.*Mst1**2.)-

     &  (5*Mgl**10.*Mst1**2.)/24.-

     &  (35*Mgl**8.*Mst1**4.)/576.+

     &  (23*Mgl**6.*Mst1**6.)/144.+

     &  (23*Mgl**4.*Mst1**8.)/576.-

     &  (Mgl**2.*Mst1**10.)/8.+(25*Mst1**12.)/576.-

     &  (127*Mgl**10.*Mt**2.)/576.+

     &  (41*Mgl**12.*Mt**2.)/(288.*Mst1**2.)+

     &  (17*Mgl**8.*Mst1**2.*Mt**2.)/144.-

     &  (179*Mgl**6.*Mst1**4.*Mt**2.)/576.+

     &  (13*Mgl**4.*Mst1**6.*Mt**2.)/48.+

     &  (109*Mgl**2.*Mst1**8.*Mt**2.)/576.-

     &  (61*Mst1**10.*Mt**2.)/288.+

     &  (13*Mst1**12.*Mt**2.)/(576.*Mgl**2.)-

     &  (5*Mgl**8.*Mt**4.)/64.+

     &  (5*Mgl**12.*Mt**4.)/(144.*Mst1**4.)+

     &  (5*Mgl**10.*Mt**4.)/(144.*Mst1**2.)+

     &  (Mgl**6.*Mst1**2.*Mt**4.)/96.-

     &  (49*Mgl**4.*Mst1**4.*Mt**4.)/144.+

     &  (Mgl**2.*Mst1**6.*Mt**4.)/8.+

     &  (59*Mst1**8.*Mt**4.)/192.-

     &  (3*Mst1**10.*Mt**4.)/(32.*Mgl**2.)+

     &  (5*Mgl**6.*Mt**6.)/64.-

     &  (5*Mgl**10.*Mt**6.)/(144.*Mst1**4.)-

     &  (23*Mgl**8.*Mt**6.)/(96.*Mst1**2.)-

     &  (17*Mgl**4.*Mst1**2.*Mt**6.)/96.-

     &  (7*Mgl**2.*Mst1**4.*Mt**6.)/32.-

     &  (Mst1**6.*Mt**6.)/96.+

     &  (25*Mst1**8.*Mt**6.)/(192.*Mgl**2.)-

     &  (109*Mgl**4.*Mt**8.)/192.-

     &  (Mgl**8.*Mt**8.)/(16.*Mst1**4.)-

     &  (Mgl**6.*Mt**8.)/(4.*Mst1**2.)-

     &  (11*Mgl**2.*Mst1**2.*Mt**8.)/24.-

     &  (85*Mst1**4.*Mt**8.)/192.-

     &  (5*Mst1**6.*Mt**8.)/(144.*Mgl**2.)+

     &  (517*Mgl**2.*Mt**10.)/576.+

     &  (7*Mgl**6.*Mt**10.)/(72.*Mst1**4.)+

     &  (197*Mgl**4.*Mt**10.)/(288.*Mst1**2.)+

     &  (161*Mst1**2.*Mt**10.)/288.-

     &  (5*Mst1**4.*Mt**10.)/(64.*Mgl**2.)-

     &  (169*Mt**12.)/576.+

     &  (Mgl**4.*Mt**12.)/(144.*Mst1**4.)-

     &  (25*Mgl**2.*Mt**12.)/(72.*Mst1**2.)+

     &  (7*Mst1**2.*Mt**12.)/(96.*Mgl**2.)-

     &  (11*Mt**14.)/(576.*Mgl**2.)-

     &  (Mgl**2.*Mt**14.)/(16.*Mst1**4.)+

     &  (7*Mt**14.)/(288.*Mst1**2.)+

     &  (7*Mt**16.)/(288.*Mst1**4.))*d123(Mt,Mgl,Mst1)**3.*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-19*Mgl**16.)/192.+Mgl**20./(288.*Mst1**4.)+

     &  (5*Mgl**18.)/(576.*Mst1**2.)+

     &  (55*Mgl**14.*Mst1**2.)/288.-

     &  (Mgl**12.*Mst1**4.)/48.-

     &  (91*Mgl**10.*Mst1**6.)/288.+

     &  (91*Mgl**8.*Mst1**8.)/288.+

     &  (Mgl**6.*Mst1**10.)/48.-

     &  (55*Mgl**4.*Mst1**12.)/288.+

     &  (19*Mgl**2.*Mst1**14.)/192.-(5*Mst1**16.)/576.-

     &  Mst1**18./(288.*Mgl**2.)+

     &  (19*Mgl**14.*Mt**2.)/64.-

     &  (5*Mgl**18.*Mt**2.)/(288.*Mst1**4.)-

     &  (53*Mgl**16.*Mt**2.)/(1152.*Mst1**2.)-

     &  (263*Mgl**12.*Mst1**2.*Mt**2.)/576.+

     &  (71*Mgl**10.*Mst1**4.*Mt**2.)/144.-

     &  (11*Mgl**8.*Mst1**6.*Mt**2.)/18.+

     &  (29*Mgl**6.*Mst1**8.*Mt**2.)/96.+

     &  (199*Mgl**4.*Mst1**10.*Mt**2.)/576.-

     &  (121*Mgl**2.*Mst1**12.*Mt**2.)/288.+

     &  (13*Mst1**14.*Mt**2.)/128.+

     &  (7*Mst1**16.*Mt**2.)/(576.*Mgl**2.)-

     &  (7*Mgl**12.*Mt**4.)/48.+

     &  (5*Mgl**16.*Mt**4.)/(192.*Mst1**4.)-

     &  (Mgl**14.*Mt**4.)/(64.*Mst1**2.)+

     &  (307*Mgl**10.*Mst1**2.*Mt**4.)/576.-

     &  (85*Mgl**8.*Mst1**4.*Mt**4.)/144.+

     &  (17*Mgl**6.*Mst1**6.*Mt**4.)/576.-

     &  (7*Mgl**4.*Mst1**8.*Mt**4.)/72.+

     &  (337*Mgl**2.*Mst1**10.*Mt**4.)/576.-

     &  (191*Mst1**12.*Mt**4.)/576.+

     &  (Mst1**14.*Mt**4.)/(144.*Mgl**2.)-

     &  (Mgl**10.*Mt**6.)/6.-

     &  (Mgl**14.*Mt**6.)/(96.*Mst1**4.)+

     &  (31*Mgl**12.*Mt**6.)/(72.*Mst1**2.)-

     &  (157*Mgl**8.*Mst1**2.*Mt**6.)/576.-

     &  (3*Mgl**6.*Mst1**4.*Mt**6.)/32.+

     &  (11*Mgl**4.*Mst1**6.*Mt**6.)/288.-

     &  (37*Mgl**2.*Mst1**8.*Mt**6.)/144.+

     &  (247*Mst1**10.*Mt**6.)/576.-

     &  (7*Mst1**12.*Mt**6.)/(72.*Mgl**2.)+

     &  (5*Mgl**8.*Mt**8.)/18.+

     &  (Mgl**12.*Mt**8.)/(32.*Mst1**4.)-

     &  (149*Mgl**10.*Mt**8.)/(192.*Mst1**2.)+

     &  (71*Mgl**6.*Mst1**2.*Mt**8.)/288.+

     &  (5*Mgl**4.*Mst1**4.*Mt**8.)/32.+

     &  (35*Mgl**2.*Mst1**6.*Mt**8.)/192.-

     &  (13*Mst1**8.*Mt**8.)/144.+

     &  (7*Mst1**10.*Mt**8.)/(36.*Mgl**2.)-

     &  (85*Mgl**6.*Mt**10.)/96.-

     &  (11*Mgl**10.*Mt**10.)/(96.*Mst1**4.)+

     &  (175*Mgl**8.*Mt**10.)/(576.*Mst1**2.)-

     &  (641*Mgl**4.*Mst1**2.*Mt**10.)/576.-

     &  (77*Mgl**2.*Mst1**4.*Mt**10.)/96.-

     &  (107*Mst1**6.*Mt**10.)/288.-

     &  (49*Mst1**8.*Mt**10.)/(288.*Mgl**2.)+

     &  (29*Mgl**4.*Mt**12.)/24.+

     &  (5*Mgl**8.*Mt**12.)/(48.*Mst1**4.)+

     &  (21*Mgl**6.*Mt**12.)/(64.*Mst1**2.)+

     &  (205*Mgl**2.*Mst1**2.*Mt**12.)/192.+

     &  (127*Mst1**4.*Mt**12.)/288.+

     &  (7*Mst1**6.*Mt**12.)/(144.*Mgl**2.)-

     &  (4*Mgl**2.*Mt**14.)/9.+

     &  (5*Mgl**6.*Mt**14.)/(96.*Mst1**4.)-

     &  (29*Mgl**4.*Mt**14.)/(144.*Mst1**2.)-

     &  (11*Mst1**2.*Mt**14.)/64.+

     &  (Mst1**4.*Mt**14.)/(36.*Mgl**2.)-

     &  (3*Mt**16.)/64.-

     &  (7*Mgl**4.*Mt**16.)/(48.*Mst1**4.)-

     &  (29*Mgl**2.*Mt**16.)/(288.*Mst1**2.)-

     &  (7*Mst1**2.*Mt**16.)/(288.*Mgl**2.)+

     &  Mt**18./(192.*Mgl**2.)+

     &  (13*Mgl**2.*Mt**18.)/(144.*Mst1**4.)+

     &  (79*Mt**18.)/(1152.*Mst1**2.)-

     &  (11*Mt**20.)/(576.*Mst1**4.))*d123(Mt,Mgl,Mst1)**4.*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  (Mgl**4./1152.+Mgl**8./(288.*Mst2**4.)-

     &  (13*Mgl**6.)/(1152.*Mst2**2.)-

     &  (Mgl**2.*Mst2**2.)/384.+(19*Mst2**4.)/1152.-

     &  Mst2**6./(144.*Mgl**2.)+

     &  (23*Mgl**2.*Mt**2.)/576.-

     &  (Mgl**6.*Mt**2.)/(144.*Mst2**4.)-

     &  (17*Mgl**4.*Mt**2.)/(1152.*Mst2**2.)+

     &  (121*Mst2**2.*Mt**2.)/1152.-

     &  (Mst2**4.*Mt**2.)/(192.*Mgl**2.)-

     &  (121*Mt**4.)/1152.-

     &  (Mgl**2.*Mt**4.)/(384.*Mst2**2.)+

     &  (Mst2**2.*Mt**4.)/(32.*Mgl**2.)-

     &  (11*Mt**6.)/(576.*Mgl**2.)+

     &  (Mgl**2.*Mt**6.)/(144.*Mst2**4.)+

     &  (11*Mt**6.)/(384.*Mst2**2.)-Mt**8./(288.*Mst2**4.)

     &  )*d123(Mt,Mgl,Mst2)*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-31*Mgl**8.)/384.-Mgl**12./(288.*Mst2**4.)+

     &  (49*Mgl**10.)/(1152.*Mst2**2.)+

     &  (37*Mgl**6.*Mst2**2.)/576.-

     &  (53*Mgl**4.*Mst2**4.)/576.+

     &  (17*Mgl**2.*Mst2**6.)/128.-(85*Mst2**8.)/1152.+

     &  Mst2**10./(96.*Mgl**2.)-(Mgl**6.*Mt**2.)/12.+

     &  (7*Mgl**10.*Mt**2.)/(288.*Mst2**4.)-

     &  (Mgl**8.*Mt**2.)/(192.*Mst2**2.)-

     &  (11*Mgl**4.*Mst2**2.*Mt**2.)/144.+

     &  (65*Mgl**2.*Mst2**4.*Mt**2.)/576.+

     &  (11*Mst2**6.*Mt**2.)/192.-

     &  (17*Mst2**8.*Mt**2.)/(576.*Mgl**2.)+

     &  (Mgl**4.*Mt**4.)/96.-

     &  (19*Mgl**8.*Mt**4.)/(576.*Mst2**4.)-

     &  (11*Mgl**6.*Mt**4.)/(96.*Mst2**2.)-

     &  (55*Mgl**2.*Mst2**2.*Mt**4.)/288.+

     &  (101*Mst2**4.*Mt**4.)/576.-

     &  (Mst2**6.*Mt**4.)/(144.*Mgl**2.)-

     &  (73*Mgl**2.*Mt**6.)/576.-

     &  (Mgl**6.*Mt**6.)/(96.*Mst2**4.)-

     &  (Mgl**4.*Mt**6.)/(18.*Mst2**2.)-

     &  (89*Mst2**2.*Mt**6.)/288.+

     &  (3*Mst2**4.*Mt**6.)/(32.*Mgl**2.)+

     &  (289*Mt**8.)/1152.+

     &  (11*Mgl**4.*Mt**8.)/(288.*Mst2**4.)+

     &  (89*Mgl**2.*Mt**8.)/(384.*Mst2**2.)-

     &  (29*Mst2**2.*Mt**8.)/(288.*Mgl**2.)+

     &  (19*Mt**10.)/(576.*Mgl**2.)-

     &  (Mgl**2.*Mt**10.)/(72.*Mst2**4.)-

     &  (19*Mt**10.)/(192.*Mst2**2.)-

     &  Mt**12./(576.*Mst2**4.))*d123(Mt,Mgl,Mst2)**2.*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  ((13*Mgl**12.)/64.-Mgl**16./(288.*Mst2**4.)-

     &  (7*Mgl**14.)/(144.*Mst2**2.)-

     &  (5*Mgl**10.*Mst2**2.)/24.-

     &  (35*Mgl**8.*Mst2**4.)/576.+

     &  (23*Mgl**6.*Mst2**6.)/144.+

     &  (23*Mgl**4.*Mst2**8.)/576.-

     &  (Mgl**2.*Mst2**10.)/8.+(25*Mst2**12.)/576.-

     &  (127*Mgl**10.*Mt**2.)/576.+

     &  (41*Mgl**12.*Mt**2.)/(288.*Mst2**2.)+

     &  (17*Mgl**8.*Mst2**2.*Mt**2.)/144.-

     &  (179*Mgl**6.*Mst2**4.*Mt**2.)/576.+

     &  (13*Mgl**4.*Mst2**6.*Mt**2.)/48.+

     &  (109*Mgl**2.*Mst2**8.*Mt**2.)/576.-

     &  (61*Mst2**10.*Mt**2.)/288.+

     &  (13*Mst2**12.*Mt**2.)/(576.*Mgl**2.)-

     &  (5*Mgl**8.*Mt**4.)/64.+

     &  (5*Mgl**12.*Mt**4.)/(144.*Mst2**4.)+

     &  (5*Mgl**10.*Mt**4.)/(144.*Mst2**2.)+

     &  (Mgl**6.*Mst2**2.*Mt**4.)/96.-

     &  (49*Mgl**4.*Mst2**4.*Mt**4.)/144.+

     &  (Mgl**2.*Mst2**6.*Mt**4.)/8.+

     &  (59*Mst2**8.*Mt**4.)/192.-

     &  (3*Mst2**10.*Mt**4.)/(32.*Mgl**2.)+

     &  (5*Mgl**6.*Mt**6.)/64.-

     &  (5*Mgl**10.*Mt**6.)/(144.*Mst2**4.)-

     &  (23*Mgl**8.*Mt**6.)/(96.*Mst2**2.)-

     &  (17*Mgl**4.*Mst2**2.*Mt**6.)/96.-

     &  (7*Mgl**2.*Mst2**4.*Mt**6.)/32.-

     &  (Mst2**6.*Mt**6.)/96.+

     &  (25*Mst2**8.*Mt**6.)/(192.*Mgl**2.)-

     &  (109*Mgl**4.*Mt**8.)/192.-

     &  (Mgl**8.*Mt**8.)/(16.*Mst2**4.)-

     &  (Mgl**6.*Mt**8.)/(4.*Mst2**2.)-

     &  (11*Mgl**2.*Mst2**2.*Mt**8.)/24.-

     &  (85*Mst2**4.*Mt**8.)/192.-

     &  (5*Mst2**6.*Mt**8.)/(144.*Mgl**2.)+

     &  (517*Mgl**2.*Mt**10.)/576.+

     &  (7*Mgl**6.*Mt**10.)/(72.*Mst2**4.)+

     &  (197*Mgl**4.*Mt**10.)/(288.*Mst2**2.)+

     &  (161*Mst2**2.*Mt**10.)/288.-

     &  (5*Mst2**4.*Mt**10.)/(64.*Mgl**2.)-

     &  (169*Mt**12.)/576.+

     &  (Mgl**4.*Mt**12.)/(144.*Mst2**4.)-

     &  (25*Mgl**2.*Mt**12.)/(72.*Mst2**2.)+

     &  (7*Mst2**2.*Mt**12.)/(96.*Mgl**2.)-

     &  (11*Mt**14.)/(576.*Mgl**2.)-

     &  (Mgl**2.*Mt**14.)/(16.*Mst2**4.)+

     &  (7*Mt**14.)/(288.*Mst2**2.)+

     &  (7*Mt**16.)/(288.*Mst2**4.))*d123(Mt,Mgl,Mst2)**3.*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-19*Mgl**16.)/192.+Mgl**20./(288.*Mst2**4.)+

     &  (5*Mgl**18.)/(576.*Mst2**2.)+

     &  (55*Mgl**14.*Mst2**2.)/288.-

     &  (Mgl**12.*Mst2**4.)/48.-

     &  (91*Mgl**10.*Mst2**6.)/288.+

     &  (91*Mgl**8.*Mst2**8.)/288.+

     &  (Mgl**6.*Mst2**10.)/48.-

     &  (55*Mgl**4.*Mst2**12.)/288.+

     &  (19*Mgl**2.*Mst2**14.)/192.-(5*Mst2**16.)/576.-

     &  Mst2**18./(288.*Mgl**2.)+

     &  (19*Mgl**14.*Mt**2.)/64.-

     &  (5*Mgl**18.*Mt**2.)/(288.*Mst2**4.)-

     &  (53*Mgl**16.*Mt**2.)/(1152.*Mst2**2.)-

     &  (263*Mgl**12.*Mst2**2.*Mt**2.)/576.+

     &  (71*Mgl**10.*Mst2**4.*Mt**2.)/144.-

     &  (11*Mgl**8.*Mst2**6.*Mt**2.)/18.+

     &  (29*Mgl**6.*Mst2**8.*Mt**2.)/96.+

     &  (199*Mgl**4.*Mst2**10.*Mt**2.)/576.-

     &  (121*Mgl**2.*Mst2**12.*Mt**2.)/288.+

     &  (13*Mst2**14.*Mt**2.)/128.+

     &  (7*Mst2**16.*Mt**2.)/(576.*Mgl**2.)-

     &  (7*Mgl**12.*Mt**4.)/48.+

     &  (5*Mgl**16.*Mt**4.)/(192.*Mst2**4.)-

     &  (Mgl**14.*Mt**4.)/(64.*Mst2**2.)+

     &  (307*Mgl**10.*Mst2**2.*Mt**4.)/576.-

     &  (85*Mgl**8.*Mst2**4.*Mt**4.)/144.+

     &  (17*Mgl**6.*Mst2**6.*Mt**4.)/576.-

     &  (7*Mgl**4.*Mst2**8.*Mt**4.)/72.+

     &  (337*Mgl**2.*Mst2**10.*Mt**4.)/576.-

     &  (191*Mst2**12.*Mt**4.)/576.+

     &  (Mst2**14.*Mt**4.)/(144.*Mgl**2.)-

     &  (Mgl**10.*Mt**6.)/6.-

     &  (Mgl**14.*Mt**6.)/(96.*Mst2**4.)+

     &  (31*Mgl**12.*Mt**6.)/(72.*Mst2**2.)-

     &  (157*Mgl**8.*Mst2**2.*Mt**6.)/576.-

     &  (3*Mgl**6.*Mst2**4.*Mt**6.)/32.+

     &  (11*Mgl**4.*Mst2**6.*Mt**6.)/288.-

     &  (37*Mgl**2.*Mst2**8.*Mt**6.)/144.+

     &  (247*Mst2**10.*Mt**6.)/576.-

     &  (7*Mst2**12.*Mt**6.)/(72.*Mgl**2.)+

     &  (5*Mgl**8.*Mt**8.)/18.+

     &  (Mgl**12.*Mt**8.)/(32.*Mst2**4.)-

     &  (149*Mgl**10.*Mt**8.)/(192.*Mst2**2.)+

     &  (71*Mgl**6.*Mst2**2.*Mt**8.)/288.+

     &  (5*Mgl**4.*Mst2**4.*Mt**8.)/32.+

     &  (35*Mgl**2.*Mst2**6.*Mt**8.)/192.-

     &  (13*Mst2**8.*Mt**8.)/144.+

     &  (7*Mst2**10.*Mt**8.)/(36.*Mgl**2.)-

     &  (85*Mgl**6.*Mt**10.)/96.-

     &  (11*Mgl**10.*Mt**10.)/(96.*Mst2**4.)+

     &  (175*Mgl**8.*Mt**10.)/(576.*Mst2**2.)-

     &  (641*Mgl**4.*Mst2**2.*Mt**10.)/576.-

     &  (77*Mgl**2.*Mst2**4.*Mt**10.)/96.-

     &  (107*Mst2**6.*Mt**10.)/288.-

     &  (49*Mst2**8.*Mt**10.)/(288.*Mgl**2.)+

     &  (29*Mgl**4.*Mt**12.)/24.+

     &  (5*Mgl**8.*Mt**12.)/(48.*Mst2**4.)+

     &  (21*Mgl**6.*Mt**12.)/(64.*Mst2**2.)+

     &  (205*Mgl**2.*Mst2**2.*Mt**12.)/192.+

     &  (127*Mst2**4.*Mt**12.)/288.+

     &  (7*Mst2**6.*Mt**12.)/(144.*Mgl**2.)-

     &  (4*Mgl**2.*Mt**14.)/9.+

     &  (5*Mgl**6.*Mt**14.)/(96.*Mst2**4.)-

     &  (29*Mgl**4.*Mt**14.)/(144.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**14.)/64.+

     &  (Mst2**4.*Mt**14.)/(36.*Mgl**2.)-

     &  (3*Mt**16.)/64.-

     &  (7*Mgl**4.*Mt**16.)/(48.*Mst2**4.)-

     &  (29*Mgl**2.*Mt**16.)/(288.*Mst2**2.)-

     &  (7*Mst2**2.*Mt**16.)/(288.*Mgl**2.)+

     &  Mt**18./(192.*Mgl**2.)+

     &  (13*Mgl**2.*Mt**18.)/(144.*Mst2**4.)+

     &  (79*Mt**18.)/(1152.*Mst2**2.)-

     &  (11*Mt**20.)/(576.*Mst2**4.))*d123(Mt,Mgl,Mst2)**4.*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  (-(Mgl*Mt**2.)/(72.*Mst1**2.)+

     &  (Mgl*Mt**2.)/(72.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mgl)*ln(mu,Mt)+

     &  ((11*Mgl**3.*Mt**2.)/288.-

     &  (Mgl**7.*Mt**2.)/(72.*Mst1**4.)+

     &  (Mgl**5.*Mt**2.)/(32.*Mst1**2.)-

     &  (7*Mgl*Mst1**2.*Mt**2.)/288.-

     &  (5*Mst1**4.*Mt**2.)/(288.*Mgl**1.)+

     &  (Mgl*Mt**4.)/8.+(Mgl**5.*Mt**4.)/(24.*Mst1**4.)+

     &  (5*Mgl**3.*Mt**4.)/(72.*Mst1**2.)-

     &  (Mst1**2.*Mt**4.)/(36.*Mgl**1.)+

     &  (13*Mt**6.)/(288.*Mgl**1.)-

     &  (Mgl**3.*Mt**6.)/(24.*Mst1**4.)-

     &  (29*Mgl*Mt**6.)/(288.*Mst1**2.)+

     &  (Mgl*Mt**8.)/(72.*Mst1**4.))*Xt*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((13*Mgl**7.*Mt**2.)/96.+

     &  (Mgl**11.*Mt**2.)/(72.*Mst1**4.)-

     &  (13*Mgl**9.*Mt**2.)/(96.*Mst1**2.)-

     &  (Mgl**5.*Mst1**2.*Mt**2.)/9.+

     &  (23*Mgl**3.*Mst1**4.*Mt**2.)/72.-

     &  (73*Mgl*Mst1**6.*Mt**2.)/288.+

     &  (Mst1**8.*Mt**2.)/(32.*Mgl**1.)+

     &  (43*Mgl**5.*Mt**4.)/144.-

     &  (Mgl**9.*Mt**4.)/(9.*Mst1**4.)-

     &  (17*Mgl**7.*Mt**4.)/(288.*Mst1**2.)+

     &  (65*Mgl**3.*Mst1**2.*Mt**4.)/144.-

     &  (2*Mgl*Mst1**4.*Mt**4.)/9.-

     &  (23*Mst1**6.*Mt**4.)/(288.*Mgl**1.)+

     &  (103*Mgl**3.*Mt**6.)/288.+

     &  (35*Mgl**7.*Mt**6.)/(144.*Mst1**4.)+

     &  (31*Mgl**5.*Mt**6.)/(32.*Mst1**2.)+

     &  (251*Mgl*Mst1**2.*Mt**6.)/288.-

     &  (Mst1**4.*Mt**6.)/(32.*Mgl**1.)-

     &  (101*Mgl*Mt**8.)/144.-

     &  (29*Mgl**5.*Mt**8.)/(144.*Mst1**4.)-

     &  (37*Mgl**3.*Mt**8.)/(32.*Mst1**2.)+

     &  (17*Mst1**2.*Mt**8.)/(96.*Mgl**1.)-

     &  (7*Mt**10.)/(72.*Mgl**1.)+

     &  (7*Mgl**3.*Mt**10.)/(144.*Mst1**4.)+

     &  (55*Mgl*Mt**10.)/(144.*Mst1**2.)+

     &  (Mgl*Mt**12.)/(144.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+((-13*Mgl**11.*Mt**2.)/24.+

     &  (Mgl**15.*Mt**2.)/(72.*Mst1**4.)+

     &  (Mgl**13.*Mt**2.)/(6.*Mst1**2.)+

     &  (Mgl**9.*Mst1**2.*Mt**2.)/3.+

     &  (19*Mgl**7.*Mst1**4.*Mt**2.)/72.-

     &  (Mgl**5.*Mst1**6.*Mt**2.)/6.-

     &  (13*Mgl**3.*Mst1**8.*Mt**2.)/72.+

     &  (Mgl*Mst1**10.*Mt**2.)/9.+

     &  (43*Mgl**9.*Mt**4.)/96.-

     &  (Mgl**13.*Mt**4.)/(72.*Mst1**4.)-

     &  (11*Mgl**11.*Mt**4.)/(24.*Mst1**2.)-

     &  (109*Mgl**7.*Mst1**2.*Mt**4.)/288.+

     &  (151*Mgl**5.*Mst1**4.*Mt**4.)/144.-

     &  (41*Mgl**3.*Mst1**6.*Mt**4.)/144.-

     &  (131*Mgl*Mst1**8.*Mt**4.)/288.+

     &  (3*Mst1**10.*Mt**4.)/(32.*Mgl**1.)+

     &  (19*Mgl**7.*Mt**6.)/96.-

     &  (Mgl**11.*Mt**6.)/(8.*Mst1**4.)-

     &  (49*Mgl**9.*Mt**6.)/(72.*Mst1**2.)+

     &  (25*Mgl**5.*Mst1**2.*Mt**6.)/36.+

     &  (101*Mgl**3.*Mst1**4.*Mt**6.)/144.+

     &  (13*Mgl*Mst1**6.*Mt**6.)/72.-

     &  (29*Mst1**8.*Mt**6.)/(96.*Mgl**1.)+

     &  (271*Mgl**5.*Mt**8.)/144.+

     &  (19*Mgl**9.*Mt**8.)/(72.*Mst1**4.)+

     &  (121*Mgl**7.*Mt**8.)/(36.*Mst1**2.)+

     &  (167*Mgl**3.*Mst1**2.*Mt**8.)/144.+

     &  (131*Mgl*Mst1**4.*Mt**8.)/144.+

     &  (13*Mst1**6.*Mt**8.)/(48.*Mgl**1.)-

     &  (433*Mgl**3.*Mt**10.)/144.-

     &  (Mgl**7.*Mt**10.)/(72.*Mst1**4.)-

     &  (23*Mgl**5.*Mt**10.)/(6.*Mst1**2.)-

     &  (13*Mgl*Mst1**2.*Mt**10.)/9.+

     &  (Mst1**4.*Mt**10.)/(16.*Mgl**1.)+

     &  (91*Mgl*Mt**12.)/96.-

     &  (3*Mgl**5.*Mt**12.)/(8.*Mst1**4.)+

     &  (115*Mgl**3.*Mt**12.)/(72.*Mst1**2.)-

     &  (19*Mst1**2.*Mt**12.)/(96.*Mgl**1.)+

     &  (7*Mt**14.)/(96.*Mgl**1.)+

     &  (25*Mgl**3.*Mt**14.)/(72.*Mst1**4.)-

     &  (11*Mgl*Mt**14.)/(72.*Mst1**2.)-

     &  (7*Mgl*Mt**16.)/(72.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+((25*Mgl**15.*Mt**2.)/72.-

     &  (Mgl**19.*Mt**2.)/(72.*Mst1**4.)-

     &  (7*Mgl**17.*Mt**2.)/(144.*Mst1**2.)-

     &  (5*Mgl**13.*Mst1**2.*Mt**2.)/12.-

     &  (Mgl**11.*Mst1**4.*Mt**2.)/3.+

     &  (67*Mgl**9.*Mst1**6.*Mt**2.)/72.-

     &  (Mgl**7.*Mst1**8.*Mt**2.)/3.-

     &  (5*Mgl**5.*Mst1**10.*Mt**2.)/12.+

     &  (25*Mgl**3.*Mst1**12.*Mt**2.)/72.-

     &  (7*Mgl*Mst1**14.*Mt**2.)/144.-

     &  (Mst1**16.*Mt**2.)/(72.*Mgl**1.)-

     &  (39*Mgl**13.*Mt**4.)/32.+

     &  (Mgl**17.*Mt**4.)/(12.*Mst1**4.)+

     &  (91*Mgl**15.*Mt**4.)/(288.*Mst1**2.)+

     &  (295*Mgl**11.*Mst1**2.*Mt**4.)/288.-

     &  (59*Mgl**9.*Mst1**4.*Mt**4.)/96.+

     &  (259*Mgl**7.*Mst1**6.*Mt**4.)/288.+

     &  (7*Mgl**5.*Mst1**8.*Mt**4.)/288.-

     &  (271*Mgl**3.*Mst1**10.*Mt**4.)/288.+

     &  (113*Mgl*Mst1**12.*Mt**4.)/288.+

     &  (5*Mst1**14.*Mt**4.)/(144.*Mgl**1.)+

     &  (49*Mgl**11.*Mt**6.)/36.-

     &  (3*Mgl**15.*Mt**6.)/(16.*Mst1**4.)-

     &  (127*Mgl**13.*Mt**6.)/(288.*Mst1**2.)-

     &  (517*Mgl**9.*Mst1**2.*Mt**6.)/288.+

     &  (85*Mgl**7.*Mst1**4.*Mt**6.)/72.+

     &  (47*Mgl**5.*Mst1**6.*Mt**6.)/288.+

     &  (19*Mgl**3.*Mst1**8.*Mt**6.)/36.-

     &  (251*Mgl*Mst1**10.*Mt**6.)/288.+

     &  (Mst1**12.*Mt**6.)/(16.*Mgl**1.)-

     &  (503*Mgl**9.*Mt**8.)/288.+

     &  (11*Mgl**13.*Mt**8.)/(48.*Mst1**4.)-

     &  (101*Mgl**11.*Mt**8.)/(96.*Mst1**2.)+

     &  (41*Mgl**7.*Mst1**2.*Mt**8.)/36.+

     &  (Mgl**5.*Mst1**4.*Mt**8.)/3.+

     &  (5*Mgl**3.*Mst1**6.*Mt**8.)/288.+

     &  (149*Mgl*Mst1**8.*Mt**8.)/288.-

     &  (47*Mst1**10.*Mt**8.)/(144.*Mgl**1.)+

     &  (71*Mgl**7.*Mt**10.)/16.-

     &  (17*Mgl**11.*Mt**10.)/(48.*Mst1**4.)+

     &  (365*Mgl**9.*Mt**10.)/(96.*Mst1**2.)+

     &  (37*Mgl**5.*Mst1**2.*Mt**10.)/16.+

     &  (65*Mgl**3.*Mst1**4.*Mt**10.)/48.+

     &  (175*Mgl*Mst1**6.*Mt**10.)/288.+

     &  (65*Mst1**8.*Mt**10.)/(144.*Mgl**1.)-

     &  (1469*Mgl**5.*Mt**12.)/288.+

     &  (13*Mgl**9.*Mt**12.)/(16.*Mst1**4.)-

     &  (1211*Mgl**7.*Mt**12.)/(288.*Mst1**2.)-

     &  (853*Mgl**3.*Mst1**2.*Mt**12.)/288.-

     &  (319*Mgl*Mst1**4.*Mt**12.)/288.-

     &  (11*Mst1**6.*Mt**12.)/(48.*Mgl**1.)+

     &  (139*Mgl**3.*Mt**14.)/72.-

     &  (59*Mgl**7.*Mt**14.)/(48.*Mst1**4.)+

     &  (479*Mgl**5.*Mt**14.)/(288.*Mst1**2.)+

     &  (179*Mgl*Mst1**2.*Mt**14.)/288.-

     &  (5*Mst1**4.*Mt**14.)/(144.*Mgl**1.)+

     &  (Mgl*Mt**16.)/96.+

     &  (49*Mgl**5.*Mt**16.)/(48.*Mst1**4.)+

     &  (47*Mgl**3.*Mt**16.)/(288.*Mst1**2.)+

     &  (11*Mst1**2.*Mt**16.)/(144.*Mgl**1.)-

     &  Mt**18./(48.*Mgl**1.)-

     &  (7*Mgl**3.*Mt**18.)/(16.*Mst1**4.)-

     &  (19*Mgl*Mt**18.)/(96.*Mst1**2.)+

     &  (11*Mgl*Mt**20.)/(144.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+((-11*Mgl**3.*Mt**2.)/288.+

     &  (Mgl**7.*Mt**2.)/(72.*Mst2**4.)-

     &  (Mgl**5.*Mt**2.)/(32.*Mst2**2.)+

     &  (7*Mgl*Mst2**2.*Mt**2.)/288.+

     &  (5*Mst2**4.*Mt**2.)/(288.*Mgl**1.)-

     &  (Mgl*Mt**4.)/8.-(Mgl**5.*Mt**4.)/(24.*Mst2**4.)-

     &  (5*Mgl**3.*Mt**4.)/(72.*Mst2**2.)+

     &  (Mst2**2.*Mt**4.)/(36.*Mgl**1.)-

     &  (13*Mt**6.)/(288.*Mgl**1.)+

     &  (Mgl**3.*Mt**6.)/(24.*Mst2**4.)+

     &  (29*Mgl*Mt**6.)/(288.*Mst2**2.)-

     &  (Mgl*Mt**8.)/(72.*Mst2**4.))*Xt*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)*ln(mu,Mgl)*ln(mu,Mt)+

     &  ((-13*Mgl**7.*Mt**2.)/96.-

     &  (Mgl**11.*Mt**2.)/(72.*Mst2**4.)+

     &  (13*Mgl**9.*Mt**2.)/(96.*Mst2**2.)+

     &  (Mgl**5.*Mst2**2.*Mt**2.)/9.-

     &  (23*Mgl**3.*Mst2**4.*Mt**2.)/72.+

     &  (73*Mgl*Mst2**6.*Mt**2.)/288.-

     &  (Mst2**8.*Mt**2.)/(32.*Mgl**1.)-

     &  (43*Mgl**5.*Mt**4.)/144.+

     &  (Mgl**9.*Mt**4.)/(9.*Mst2**4.)+

     &  (17*Mgl**7.*Mt**4.)/(288.*Mst2**2.)-

     &  (65*Mgl**3.*Mst2**2.*Mt**4.)/144.+

     &  (2*Mgl*Mst2**4.*Mt**4.)/9.+

     &  (23*Mst2**6.*Mt**4.)/(288.*Mgl**1.)-

     &  (103*Mgl**3.*Mt**6.)/288.-

     &  (35*Mgl**7.*Mt**6.)/(144.*Mst2**4.)-

     &  (31*Mgl**5.*Mt**6.)/(32.*Mst2**2.)-

     &  (251*Mgl*Mst2**2.*Mt**6.)/288.+

     &  (Mst2**4.*Mt**6.)/(32.*Mgl**1.)+

     &  (101*Mgl*Mt**8.)/144.+

     &  (29*Mgl**5.*Mt**8.)/(144.*Mst2**4.)+

     &  (37*Mgl**3.*Mt**8.)/(32.*Mst2**2.)-

     &  (17*Mst2**2.*Mt**8.)/(96.*Mgl**1.)+

     &  (7*Mt**10.)/(72.*Mgl**1.)-

     &  (7*Mgl**3.*Mt**10.)/(144.*Mst2**4.)-

     &  (55*Mgl*Mt**10.)/(144.*Mst2**2.)-

     &  (Mgl*Mt**12.)/(144.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+((13*Mgl**11.*Mt**2.)/24.-

     &  (Mgl**15.*Mt**2.)/(72.*Mst2**4.)-

     &  (Mgl**13.*Mt**2.)/(6.*Mst2**2.)-

     &  (Mgl**9.*Mst2**2.*Mt**2.)/3.-

     &  (19*Mgl**7.*Mst2**4.*Mt**2.)/72.+

     &  (Mgl**5.*Mst2**6.*Mt**2.)/6.+

     &  (13*Mgl**3.*Mst2**8.*Mt**2.)/72.-

     &  (Mgl*Mst2**10.*Mt**2.)/9.-

     &  (43*Mgl**9.*Mt**4.)/96.+

     &  (Mgl**13.*Mt**4.)/(72.*Mst2**4.)+

     &  (11*Mgl**11.*Mt**4.)/(24.*Mst2**2.)+

     &  (109*Mgl**7.*Mst2**2.*Mt**4.)/288.-

     &  (151*Mgl**5.*Mst2**4.*Mt**4.)/144.+

     &  (41*Mgl**3.*Mst2**6.*Mt**4.)/144.+

     &  (131*Mgl*Mst2**8.*Mt**4.)/288.-

     &  (3*Mst2**10.*Mt**4.)/(32.*Mgl**1.)-

     &  (19*Mgl**7.*Mt**6.)/96.+

     &  (Mgl**11.*Mt**6.)/(8.*Mst2**4.)+

     &  (49*Mgl**9.*Mt**6.)/(72.*Mst2**2.)-

     &  (25*Mgl**5.*Mst2**2.*Mt**6.)/36.-

     &  (101*Mgl**3.*Mst2**4.*Mt**6.)/144.-

     &  (13*Mgl*Mst2**6.*Mt**6.)/72.+

     &  (29*Mst2**8.*Mt**6.)/(96.*Mgl**1.)-

     &  (271*Mgl**5.*Mt**8.)/144.-

     &  (19*Mgl**9.*Mt**8.)/(72.*Mst2**4.)-

     &  (121*Mgl**7.*Mt**8.)/(36.*Mst2**2.)-

     &  (167*Mgl**3.*Mst2**2.*Mt**8.)/144.-

     &  (131*Mgl*Mst2**4.*Mt**8.)/144.-

     &  (13*Mst2**6.*Mt**8.)/(48.*Mgl**1.)+

     &  (433*Mgl**3.*Mt**10.)/144.+

     &  (Mgl**7.*Mt**10.)/(72.*Mst2**4.)+

     &  (23*Mgl**5.*Mt**10.)/(6.*Mst2**2.)+

     &  (13*Mgl*Mst2**2.*Mt**10.)/9.-

     &  (Mst2**4.*Mt**10.)/(16.*Mgl**1.)-

     &  (91*Mgl*Mt**12.)/96.+

     &  (3*Mgl**5.*Mt**12.)/(8.*Mst2**4.)-

     &  (115*Mgl**3.*Mt**12.)/(72.*Mst2**2.)+

     &  (19*Mst2**2.*Mt**12.)/(96.*Mgl**1.)-

     &  (7*Mt**14.)/(96.*Mgl**1.)-

     &  (25*Mgl**3.*Mt**14.)/(72.*Mst2**4.)+

     &  (11*Mgl*Mt**14.)/(72.*Mst2**2.)+

     &  (7*Mgl*Mt**16.)/(72.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+((-25*Mgl**15.*Mt**2.)/72.+

     &  (Mgl**19.*Mt**2.)/(72.*Mst2**4.)+

     &  (7*Mgl**17.*Mt**2.)/(144.*Mst2**2.)+

     &  (5*Mgl**13.*Mst2**2.*Mt**2.)/12.+

     &  (Mgl**11.*Mst2**4.*Mt**2.)/3.-

     &  (67*Mgl**9.*Mst2**6.*Mt**2.)/72.+

     &  (Mgl**7.*Mst2**8.*Mt**2.)/3.+

     &  (5*Mgl**5.*Mst2**10.*Mt**2.)/12.-

     &  (25*Mgl**3.*Mst2**12.*Mt**2.)/72.+

     &  (7*Mgl*Mst2**14.*Mt**2.)/144.+

     &  (Mst2**16.*Mt**2.)/(72.*Mgl**1.)+

     &  (39*Mgl**13.*Mt**4.)/32.-

     &  (Mgl**17.*Mt**4.)/(12.*Mst2**4.)-

     &  (91*Mgl**15.*Mt**4.)/(288.*Mst2**2.)-

     &  (295*Mgl**11.*Mst2**2.*Mt**4.)/288.+

     &  (59*Mgl**9.*Mst2**4.*Mt**4.)/96.-

     &  (259*Mgl**7.*Mst2**6.*Mt**4.)/288.-

     &  (7*Mgl**5.*Mst2**8.*Mt**4.)/288.+

     &  (271*Mgl**3.*Mst2**10.*Mt**4.)/288.-

     &  (113*Mgl*Mst2**12.*Mt**4.)/288.-

     &  (5*Mst2**14.*Mt**4.)/(144.*Mgl**1.)-

     &  (49*Mgl**11.*Mt**6.)/36.+

     &  (3*Mgl**15.*Mt**6.)/(16.*Mst2**4.)+

     &  (127*Mgl**13.*Mt**6.)/(288.*Mst2**2.)+

     &  (517*Mgl**9.*Mst2**2.*Mt**6.)/288.-

     &  (85*Mgl**7.*Mst2**4.*Mt**6.)/72.-

     &  (47*Mgl**5.*Mst2**6.*Mt**6.)/288.-

     &  (19*Mgl**3.*Mst2**8.*Mt**6.)/36.+

     &  (251*Mgl*Mst2**10.*Mt**6.)/288.-

     &  (Mst2**12.*Mt**6.)/(16.*Mgl**1.)+

     &  (503*Mgl**9.*Mt**8.)/288.-

     &  (11*Mgl**13.*Mt**8.)/(48.*Mst2**4.)+

     &  (101*Mgl**11.*Mt**8.)/(96.*Mst2**2.)-

     &  (41*Mgl**7.*Mst2**2.*Mt**8.)/36.-

     &  (Mgl**5.*Mst2**4.*Mt**8.)/3.-

     &  (5*Mgl**3.*Mst2**6.*Mt**8.)/288.-

     &  (149*Mgl*Mst2**8.*Mt**8.)/288.+

     &  (47*Mst2**10.*Mt**8.)/(144.*Mgl**1.)-

     &  (71*Mgl**7.*Mt**10.)/16.+

     &  (17*Mgl**11.*Mt**10.)/(48.*Mst2**4.)-

     &  (365*Mgl**9.*Mt**10.)/(96.*Mst2**2.)-

     &  (37*Mgl**5.*Mst2**2.*Mt**10.)/16.-

     &  (65*Mgl**3.*Mst2**4.*Mt**10.)/48.-

     &  (175*Mgl*Mst2**6.*Mt**10.)/288.-

     &  (65*Mst2**8.*Mt**10.)/(144.*Mgl**1.)+

     &  (1469*Mgl**5.*Mt**12.)/288.-

     &  (13*Mgl**9.*Mt**12.)/(16.*Mst2**4.)+

     &  (1211*Mgl**7.*Mt**12.)/(288.*Mst2**2.)+

     &  (853*Mgl**3.*Mst2**2.*Mt**12.)/288.+

     &  (319*Mgl*Mst2**4.*Mt**12.)/288.+

     &  (11*Mst2**6.*Mt**12.)/(48.*Mgl**1.)-

     &  (139*Mgl**3.*Mt**14.)/72.+

     &  (59*Mgl**7.*Mt**14.)/(48.*Mst2**4.)-

     &  (479*Mgl**5.*Mt**14.)/(288.*Mst2**2.)-

     &  (179*Mgl*Mst2**2.*Mt**14.)/288.+

     &  (5*Mst2**4.*Mt**14.)/(144.*Mgl**1.)-

     &  (Mgl*Mt**16.)/96.-

     &  (49*Mgl**5.*Mt**16.)/(48.*Mst2**4.)-

     &  (47*Mgl**3.*Mt**16.)/(288.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**16.)/(144.*Mgl**1.)+

     &  Mt**18./(48.*Mgl**1.)+

     &  (7*Mgl**3.*Mt**18.)/(16.*Mst2**4.)+

     &  (19*Mgl*Mt**18.)/(96.*Mst2**2.)-

     &  (11*Mgl*Mt**20.)/(144.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mgl)*

     &  ln(mu,Mt)+(0.006944444444444444-

     &  (5*Mst1**2.)/(288.*Mgl**2.)+

     &  (3*Mt**2.)/(128.*Mgl**2.)-

     &  (Mst1**2.*Mt**2.)/(1152.*Mgl**4.)+

     &  Mt**4./(1152.*Mgl**4.))*ln(mu,Mst1)*ln(mu,Mt)+

     &  ((7*Mgl**4.)/1152.-(5*Mgl**6.)/(1152.*Mst1**2.)+

     &  (5*Mgl**2.*Mst1**2.)/384.-(11*Mst1**4.)/1152.-

     &  (5*Mst1**6.)/(576.*Mgl**2.)+

     &  Mst1**8./(288.*Mgl**4.)+

     &  (11*Mgl**2.*Mt**2.)/128.+

     &  (5*Mgl**4.*Mt**2.)/(1152.*Mst1**2.)-

     &  (19*Mst1**2.*Mt**2.)/288.-

     &  (55*Mst1**4.*Mt**2.)/(1152.*Mgl**2.)-

     &  (5*Mst1**6.*Mt**2.)/(1152.*Mgl**4.)+

     &  (35*Mt**4.)/576.+

     &  (5*Mgl**2.*Mt**4.)/(1152.*Mst1**2.)+

     &  (25*Mst1**2.*Mt**4.)/(192.*Mgl**2.)-

     &  (Mst1**4.*Mt**4.)/(128.*Mgl**4.)-

     &  (85*Mt**6.)/(1152.*Mgl**2.)-

     &  (5*Mt**6.)/(1152.*Mst1**2.)+

     &  (17*Mst1**2.*Mt**6.)/(1152.*Mgl**4.)-

     &  (7*Mt**8.)/(1152.*Mgl**4.))*d123(Mt,Mgl,Mst1)*

     &  ln(mu,Mst1)*ln(mu,Mt)+

     &  ((-43*Mgl**8.)/1152.+Mgl**10./(128.*Mst1**2.)+

     &  (Mgl**6.*Mst1**2.)/24.-

     &  (23*Mgl**4.*Mst1**4.)/576.+

     &  (149*Mgl**2.*Mst1**6.)/1152.-(65*Mst1**8.)/384.+

     &  (41*Mst1**10.)/(576.*Mgl**2.)-

     &  Mst1**12./(288.*Mgl**4.)-

     &  (5*Mgl**6.*Mt**2.)/576.-

     &  (43*Mgl**8.*Mt**2.)/(1152.*Mst1**2.)+

     &  (335*Mgl**4.*Mst1**2.*Mt**2.)/1152.-

     &  (79*Mgl**2.*Mst1**4.*Mt**2.)/288.+

     &  (185*Mst1**6.*Mt**2.)/1152.-

     &  (29*Mst1**8.*Mt**2.)/(192.*Mgl**2.)+

     &  (23*Mst1**10.*Mt**2.)/(1152.*Mgl**4.)+

     &  (107*Mgl**4.*Mt**4.)/1152.+

     &  (13*Mgl**6.*Mt**4.)/(576.*Mst1**2.)+

     &  (5*Mgl**2.*Mst1**2.*Mt**4.)/192.-

     &  (35*Mst1**4.*Mt**4.)/576.-

     &  (Mst1**6.*Mt**4.)/(24.*Mgl**2.)-

     &  (37*Mst1**8.*Mt**4.)/(1152.*Mgl**4.)+

     &  (13*Mgl**2.*Mt**6.)/192.+

     &  (7*Mgl**4.*Mt**6.)/(192.*Mst1**2.)+

     &  (119*Mst1**2.*Mt**6.)/576.+

     &  (175*Mst1**4.*Mt**6.)/(576.*Mgl**2.)-

     &  (Mst1**6.*Mt**6.)/(576.*Mgl**4.)-

     &  (53*Mt**8.)/384.-

     &  (35*Mgl**2.*Mt**8.)/(1152.*Mst1**2.)-

     &  (15*Mst1**2.*Mt**8.)/(64.*Mgl**2.)+

     &  (29*Mst1**4.*Mt**8.)/(576.*Mgl**4.)+

     &  (5*Mt**10.)/(96.*Mgl**2.)+

     &  Mt**10./(1152.*Mst1**2.)-

     &  (53*Mst1**2.*Mt**10.)/(1152.*Mgl**4.)+

     &  (5*Mt**12.)/(384.*Mgl**4.))*d123(Mt,Mgl,Mst1)**2.*

     &  ln(mu,Mst1)*ln(mu,Mt)+

     &  ((11*Mgl**12.)/288.-(19*Mgl**10.*Mst1**2.)/192.-

     &  (Mgl**8.*Mst1**4.)/144.+

     &  (107*Mgl**6.*Mst1**6.)/576.-

     &  (5*Mgl**4.*Mst1**8.)/144.-

     &  (49*Mgl**2.*Mst1**10.)/192.+(11*Mst1**12.)/48.-

     &  (31*Mst1**14.)/(576.*Mgl**2.)-

     &  Mst1**16./(288.*Mgl**4.)-

     &  (59*Mgl**10.*Mt**2.)/384.+

     &  (Mgl**12.*Mt**2.)/(36.*Mst1**2.)-

     &  (41*Mgl**8.*Mst1**2.*Mt**2.)/1152.+

     &  (173*Mgl**6.*Mst1**4.*Mt**2.)/384.-

     &  (37*Mgl**4.*Mst1**6.*Mt**2.)/128.+

     &  (91*Mgl**2.*Mst1**8.*Mt**2.)/384.-

     &  (575*Mst1**10.*Mt**2.)/1152.+

     &  (33*Mst1**12.*Mt**2.)/(128.*Mgl**2.)+

     &  (5*Mst1**14.*Mt**2.)/(1152.*Mgl**4.)+

     &  (37*Mgl**8.*Mt**4.)/384.-

     &  (Mgl**10.*Mt**4.)/(12.*Mst1**2.)+

     &  (13*Mgl**6.*Mst1**2.*Mt**4.)/64.-

     &  (83*Mgl**4.*Mst1**4.*Mt**4.)/384.+

     &  (47*Mgl**2.*Mst1**6.*Mt**4.)/288.+

     &  (67*Mst1**8.*Mt**4.)/384.-

     &  (215*Mst1**10.*Mt**4.)/(576.*Mgl**2.)+

     &  (41*Mst1**12.*Mt**4.)/(1152.*Mgl**4.)-

     &  (103*Mgl**6.*Mt**6.)/1152.+

     &  (Mgl**8.*Mt**6.)/(36.*Mst1**2.)-

     &  (43*Mgl**4.*Mst1**2.*Mt**6.)/1152.-

     &  (35*Mgl**2.*Mst1**4.*Mt**6.)/192.+

     &  (35*Mst1**6.*Mt**6.)/576.-

     &  (Mst1**8.*Mt**6.)/(384.*Mgl**2.)-

     &  (127*Mst1**10.*Mt**6.)/(1152.*Mgl**4.)+

     &  (41*Mgl**4.*Mt**8.)/128.+

     &  (Mgl**6.*Mt**8.)/(9.*Mst1**2.)+

     &  (47*Mgl**2.*Mst1**2.*Mt**8.)/192.+

     &  (15*Mst1**4.*Mt**8.)/64.+

     &  (271*Mst1**6.*Mt**8.)/(576.*Mgl**2.)+

     &  (125*Mst1**8.*Mt**8.)/(1152.*Mgl**4.)-

     &  (23*Mgl**2.*Mt**10.)/128.-

     &  (Mgl**4.*Mt**10.)/(12.*Mst1**2.)-

     &  (77*Mst1**2.*Mt**10.)/384.-

     &  (461*Mst1**4.*Mt**10.)/(1152.*Mgl**2.)-

     &  (Mst1**6.*Mt**10.)/(1152.*Mgl**4.)-

     &  (31*Mt**12.)/1152.-

     &  (Mgl**2.*Mt**12.)/(36.*Mst1**2.)+

     &  (55*Mst1**2.*Mt**12.)/(576.*Mgl**2.)-

     &  (85*Mst1**4.*Mt**12.)/(1152.*Mgl**4.)+

     &  (7*Mt**14.)/(1152.*Mgl**2.)+

     &  Mt**14./(36.*Mst1**2.)+

     &  (59*Mst1**2.*Mt**14.)/(1152.*Mgl**4.)-

     &  (13*Mt**16.)/(1152.*Mgl**4.))*d123(Mt,Mgl,Mst1)**3.*

     &  ln(mu,Mst1)*ln(mu,Mt)+

     &  ((-5*Mgl**16.)/576.-Mgl**18./(288.*Mst1**2.)+

     &  (19*Mgl**14.*Mst1**2.)/192.-

     &  (55*Mgl**12.*Mst1**4.)/288.+

     &  (Mgl**10.*Mst1**6.)/48.+

     &  (91*Mgl**8.*Mst1**8.)/288.-

     &  (91*Mgl**6.*Mst1**10.)/288.-

     &  (Mgl**4.*Mst1**12.)/48.+

     &  (55*Mgl**2.*Mst1**14.)/288.-(19*Mst1**16.)/192.+

     &  (5*Mst1**18.)/(576.*Mgl**2.)+

     &  Mst1**20./(288.*Mgl**4.)+

     &  (59*Mgl**14.*Mt**2.)/1152.+

     &  (Mgl**16.*Mt**2.)/(96.*Mst1**2.)-

     &  (91*Mgl**12.*Mst1**2.*Mt**2.)/576.-

     &  (29*Mgl**10.*Mst1**4.*Mt**2.)/576.+

     &  (7*Mgl**8.*Mst1**6.*Mt**2.)/24.-

     &  (5*Mgl**6.*Mst1**8.*Mt**2.)/96.+

     &  (19*Mgl**4.*Mst1**10.*Mt**2.)/288.-

     &  (299*Mgl**2.*Mst1**12.*Mt**2.)/576.+

     &  (137*Mst1**14.*Mt**2.)/288.-

     &  (37*Mst1**16.*Mt**2.)/(384.*Mgl**2.)-

     &  (11*Mst1**18.*Mt**2.)/(576.*Mgl**4.)+

     &  (Mgl**12.*Mt**4.)/288.+

     &  (Mgl**14.*Mt**4.)/(144.*Mst1**2.)-

     &  (35*Mgl**10.*Mst1**2.*Mt**4.)/144.+

     &  (119*Mgl**8.*Mst1**4.*Mt**4.)/288.-

     &  (11*Mgl**6.*Mst1**6.*Mt**4.)/36.+

     &  (17*Mgl**4.*Mst1**8.*Mt**4.)/72.+

     &  (49*Mgl**2.*Mst1**10.*Mt**4.)/144.-

     &  (79*Mst1**12.*Mt**4.)/96.+

     &  (49*Mst1**14.*Mt**4.)/(144.*Mgl**2.)+

     &  (Mst1**16.*Mt**4.)/(32.*Mgl**4.)-

     &  (47*Mgl**10.*Mt**6.)/144.-

     &  (5*Mgl**12.*Mt**6.)/(144.*Mst1**2.)+

     &  (97*Mgl**8.*Mst1**2.*Mt**6.)/288.-

     &  (11*Mgl**6.*Mst1**4.*Mt**6.)/64.-

     &  (13*Mgl**4.*Mst1**6.*Mt**6.)/144.+

     &  (47*Mgl**2.*Mst1**8.*Mt**6.)/288.+

     &  (59*Mst1**10.*Mt**6.)/96.-

     &  (295*Mst1**12.*Mt**6.)/(576.*Mgl**2.)+

     &  (Mst1**14.*Mt**6.)/(48.*Mgl**4.)+

     &  (107*Mgl**8.*Mt**8.)/288.-

     &  (Mgl**10.*Mt**8.)/(36.*Mst1**2.)-

     &  (Mgl**6.*Mst1**2.*Mt**8.)/18.-

     &  (Mgl**4.*Mst1**4.*Mt**8.)/4.-

     &  (19*Mgl**2.*Mst1**6.*Mt**8.)/48.-

     &  (9*Mst1**8.*Mt**8.)/32.+

     &  (11*Mst1**10.*Mt**8.)/(48.*Mgl**2.)-

     &  (7*Mst1**12.*Mt**8.)/(48.*Mgl**4.)+

     &  (25*Mgl**6.*Mt**10.)/192.+

     &  (Mgl**8.*Mt**10.)/(8.*Mst1**2.)+

     &  (109*Mgl**4.*Mst1**2.*Mt**10.)/288.+

     &  (95*Mgl**2.*Mst1**4.*Mt**10.)/192.+

     &  (11*Mst1**6.*Mt**10.)/36.+

     &  (5*Mst1**8.*Mt**10.)/(18.*Mgl**2.)+

     &  (7*Mst1**10.*Mt**10.)/(32.*Mgl**4.)-

     &  (35*Mgl**4.*Mt**12.)/144.-

     &  (Mgl**6.*Mt**12.)/(16.*Mst1**2.)-

     &  (7*Mgl**2.*Mst1**2.*Mt**12.)/24.-

     &  (65*Mst1**4.*Mt**12.)/288.-

     &  (29*Mst1**6.*Mt**12.)/(72.*Mgl**2.)-

     &  (7*Mst1**8.*Mt**12.)/(48.*Mgl**4.)-

     &  (5*Mgl**2.*Mt**14.)/72.-

     &  (11*Mgl**4.*Mt**14.)/(144.*Mst1**2.)-

     &  (11*Mst1**2.*Mt**14.)/288.+

     &  (11*Mst1**4.*Mt**14.)/(64.*Mgl**2.)+

     &  (Mst1**6.*Mt**14.)/(48.*Mgl**4.)+

     &  (55*Mt**16.)/576.+

     &  (25*Mgl**2.*Mt**16.)/(288.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**16.)/(576.*Mgl**2.)+

     &  (Mst1**4.*Mt**16.)/(32.*Mgl**4.)-

     &  Mt**18./(128.*Mgl**2.)-

     &  (7*Mt**18.)/(288.*Mst1**2.)-

     &  (11*Mst1**2.*Mt**18.)/(576.*Mgl**4.)+

     &  Mt**20./(288.*Mgl**4.))*d123(Mt,Mgl,Mst1)**4.*

     &  ln(mu,Mst1)*ln(mu,Mt)+

     &  (-Mt**2./(9.*Mgl**1.)-Mt**4./(288.*Mgl**3.))*Xt*

     &  Den(Mst1,Mst2)*ln(mu,Mst1)*ln(mu,Mt)+

     &  ((7*Mgl**3.*Mt**2.)/288.+

     &  (5*Mgl**5.*Mt**2.)/(288.*Mst1**2.)-

     &  (11*Mgl*Mst1**2.*Mt**2.)/288.-

     &  (Mst1**4.*Mt**2.)/(32.*Mgl**1.)+

     &  (Mst1**6.*Mt**2.)/(72.*Mgl**3.)-

     &  (277*Mgl*Mt**4.)/576.-

     &  (5*Mgl**3.*Mt**4.)/(144.*Mst1**2.)-

     &  (13*Mst1**2.*Mt**4.)/(48.*Mgl**1.)-

     &  (7*Mst1**4.*Mt**4.)/(576.*Mgl**3.)+

     &  (85*Mt**6.)/(288.*Mgl**1.)+

     &  (5*Mgl*Mt**6.)/(288.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**6.)/(288.*Mgl**3.)+

     &  Mt**8./(64.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)*ln(mu,Mst1)*ln(mu,Mt)+

     &  ((37*Mgl**7.*Mt**2.)/288.-

     &  (Mgl**9.*Mt**2.)/(32.*Mst1**2.)-

     &  (5*Mgl**5.*Mst1**2.*Mt**2.)/72.+

     &  (Mgl**3.*Mst1**4.*Mt**2.)/9.-

     &  (37*Mgl*Mst1**6.*Mt**2.)/96.+

     &  (25*Mst1**8.*Mt**2.)/(96.*Mgl**1.)-

     &  (Mst1**10.*Mt**2.)/(72.*Mgl**3.)+

     &  (25*Mgl**5.*Mt**4.)/288.+

     &  (13*Mgl**7.*Mt**4.)/(72.*Mst1**2.)-

     &  (247*Mgl**3.*Mst1**2.*Mt**4.)/288.+

     &  (163*Mgl*Mst1**4.*Mt**4.)/288.-

     &  (95*Mst1**6.*Mt**4.)/(288.*Mgl**1.)+

     &  (11*Mst1**8.*Mt**4.)/(144.*Mgl**3.)-

     &  (229*Mgl**3.*Mt**6.)/288.-

     &  (13*Mgl**5.*Mt**6.)/(48.*Mst1**2.)-

     &  (5*Mgl*Mst1**2.*Mt**6.)/12.-

     &  (109*Mst1**4.*Mt**6.)/(288.*Mgl**1.)-

     &  (5*Mst1**6.*Mt**6.)/(48.*Mgl**3.)+

     &  (211*Mgl*Mt**8.)/288.+

     &  (Mgl**3.*Mt**8.)/(8.*Mst1**2.)+

     &  (185*Mst1**2.*Mt**8.)/(288.*Mgl**1.)-

     &  (Mst1**4.*Mt**8.)/(144.*Mgl**3.)-

     &  (7*Mt**10.)/(36.*Mgl**1.)-

     &  (Mgl*Mt**10.)/(288.*Mst1**2.)+

     &  (13*Mst1**2.*Mt**10.)/(144.*Mgl**3.)-

     &  Mt**12./(24.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst1)**2.*

     &  Den(Mst1,Mst2)*ln(mu,Mst1)*ln(mu,Mt)+

     &  (-(Mgl**11.*Mt**2.)/9.+

     &  (13*Mgl**9.*Mst1**2.*Mt**2.)/72.+

     &  (Mgl**7.*Mst1**4.*Mt**2.)/6.-

     &  (19*Mgl**5.*Mst1**6.*Mt**2.)/72.-

     &  (Mgl**3.*Mst1**8.*Mt**2.)/3.+

     &  (13*Mgl*Mst1**10.*Mt**2.)/24.-

     &  (Mst1**12.*Mt**2.)/(6.*Mgl**1.)-

     &  (Mst1**14.*Mt**2.)/(72.*Mgl**3.)+

     &  (23*Mgl**9.*Mt**4.)/64.-

     &  (Mgl**11.*Mt**4.)/(9.*Mst1**2.)+

     &  (89*Mgl**7.*Mst1**2.*Mt**4.)/144.-

     &  (629*Mgl**5.*Mst1**4.*Mt**4.)/576.+

     &  (5*Mgl**3.*Mst1**6.*Mt**4.)/72.-

     &  (89*Mgl*Mst1**8.*Mt**4.)/192.+

     &  (89*Mst1**10.*Mt**4.)/(144.*Mgl**1.)+

     &  (Mst1**12.*Mt**4.)/(576.*Mgl**3.)+

     &  (49*Mgl**7.*Mt**6.)/144.+

     &  (4*Mgl**9.*Mt**6.)/(9.*Mst1**2.)-

     &  (335*Mgl**5.*Mst1**2.*Mt**6.)/288.+

     &  (5*Mgl**3.*Mst1**4.*Mt**6.)/9.-

     &  (13*Mgl*Mst1**6.*Mt**6.)/48.-

     &  (19*Mst1**8.*Mt**6.)/(48.*Mgl**1.)+

     &  (5*Mst1**10.*Mt**6.)/(32.*Mgl**3.)-

     &  (263*Mgl**5.*Mt**8.)/192.-

     &  (5*Mgl**7.*Mt**8.)/(9.*Mst1**2.)-

     &  (7*Mgl**3.*Mst1**2.*Mt**8.)/12.-

     &  (197*Mgl*Mst1**4.*Mt**8.)/288.-

     &  (29*Mst1**6.*Mt**8.)/(36.*Mgl**1.)-

     &  (185*Mst1**8.*Mt**8.)/(576.*Mgl**3.)+

     &  (55*Mgl**3.*Mt**10.)/72.+

     &  (Mgl**5.*Mt**10.)/(9.*Mst1**2.)+

     &  (139*Mgl*Mst1**2.*Mt**10.)/144.+

     &  (10*Mst1**4.*Mt**10.)/(9.*Mgl**1.)+

     &  (25*Mst1**6.*Mt**10.)/(144.*Mgl**3.)+

     &  (13*Mgl*Mt**12.)/576.+

     &  (2*Mgl**3.*Mt**12.)/(9.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**12.)/(16.*Mgl**1.)+

     &  (7*Mst1**4.*Mt**12.)/(64.*Mgl**3.)-

     &  (7*Mt**14.)/(144.*Mgl**1.)-

     &  (Mgl*Mt**14.)/(9.*Mst1**2.)-

     &  (43*Mst1**2.*Mt**14.)/(288.*Mgl**3.)+

     &  (25*Mt**16.)/(576.*Mgl**3.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mst1)*

     &  ln(mu,Mt)+((7*Mgl**15.*Mt**2.)/144.+

     &  (Mgl**17.*Mt**2.)/(72.*Mst1**2.)-

     &  (25*Mgl**13.*Mst1**2.*Mt**2.)/72.+

     &  (5*Mgl**11.*Mst1**4.*Mt**2.)/12.+

     &  (Mgl**9.*Mst1**6.*Mt**2.)/3.-

     &  (67*Mgl**7.*Mst1**8.*Mt**2.)/72.+

     &  (Mgl**5.*Mst1**10.*Mt**2.)/3.+

     &  (5*Mgl**3.*Mst1**12.*Mt**2.)/12.-

     &  (25*Mgl*Mst1**14.*Mt**2.)/72.+

     &  (7*Mst1**16.*Mt**2.)/(144.*Mgl**1.)+

     &  (Mst1**18.*Mt**2.)/(72.*Mgl**3.)-

     &  (89*Mgl**13.*Mt**4.)/288.-

     &  (Mgl**15.*Mt**4.)/(18.*Mst1**2.)+

     &  (193*Mgl**11.*Mst1**2.*Mt**4.)/288.+

     &  (131*Mgl**9.*Mst1**4.*Mt**4.)/288.-

     &  (301*Mgl**7.*Mst1**6.*Mt**4.)/288.+

     &  (3*Mgl**5.*Mst1**8.*Mt**4.)/32.-

     &  (145*Mgl**3.*Mst1**10.*Mt**4.)/288.+

     &  (37*Mgl*Mst1**12.*Mt**4.)/32.-

     &  (115*Mst1**14.*Mt**4.)/(288.*Mgl**1.)-

     &  (Mst1**16.*Mt**4.)/(16.*Mgl**3.)+

     &  (31*Mgl**11.*Mt**6.)/96.+

     &  (Mgl**13.*Mt**6.)/(36.*Mst1**2.)+

     &  (5*Mgl**9.*Mst1**2.*Mt**6.)/8.-

     &  (427*Mgl**7.*Mst1**4.*Mt**6.)/288.+

     &  (113*Mgl**5.*Mst1**6.*Mt**6.)/144.-

     &  (73*Mgl**3.*Mst1**8.*Mt**6.)/288.-

     &  (10*Mgl*Mst1**10.*Mt**6.)/9.+

     &  (295*Mst1**12.*Mt**6.)/(288.*Mgl**1.)+

     &  (Mst1**14.*Mt**6.)/(16.*Mgl**3.)+

     &  (35*Mgl**9.*Mt**8.)/32.+

     &  (Mgl**11.*Mt**8.)/(9.*Mst1**2.)-

     &  (253*Mgl**7.*Mst1**2.*Mt**8.)/288.+

     &  (31*Mgl**5.*Mst1**4.*Mt**8.)/24.+

     &  (125*Mgl**3.*Mst1**6.*Mt**8.)/144.+

     &  (15*Mgl*Mst1**8.*Mt**8.)/32.-

     &  (253*Mst1**10.*Mt**8.)/(288.*Mgl**1.)+

     &  (7*Mst1**12.*Mt**8.)/(48.*Mgl**3.)-

     &  (743*Mgl**7.*Mt**10.)/288.-

     &  (71*Mgl**5.*Mst1**2.*Mt**10.)/48.-

     &  (85*Mgl**3.*Mst1**4.*Mt**10.)/48.-

     &  (19*Mgl*Mst1**6.*Mt**10.)/18.-

     &  (115*Mst1**8.*Mt**10.)/(288.*Mgl**1.)-

     &  (7*Mst1**10.*Mt**10.)/(16.*Mgl**3.)+

     &  (449*Mgl**5.*Mt**12.)/288.-

     &  (Mgl**7.*Mt**12.)/(2.*Mst1**2.)+

     &  (439*Mgl**3.*Mst1**2.*Mt**12.)/288.+

     &  (379*Mgl*Mst1**4.*Mt**12.)/288.+

     &  (331*Mst1**6.*Mt**12.)/(288.*Mgl**1.)+

     &  (7*Mst1**8.*Mt**12.)/(16.*Mgl**3.)+

     &  (47*Mgl**3.*Mt**14.)/288.+

     &  (3*Mgl**5.*Mt**14.)/(4.*Mst1**2.)-

     &  (7*Mgl*Mst1**2.*Mt**14.)/36.-

     &  (175*Mst1**4.*Mt**14.)/(288.*Mgl**1.)-

     &  (7*Mst1**6.*Mt**14.)/(48.*Mgl**3.)-

     &  (95*Mgl*Mt**16.)/288.-

     &  (4*Mgl**3.*Mt**16.)/(9.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**16.)/(288.*Mgl**1.)-

     &  (Mst1**4.*Mt**16.)/(16.*Mgl**3.)+

     &  (13*Mt**18.)/(288.*Mgl**1.)+

     &  (7*Mgl*Mt**18.)/(72.*Mst1**2.)+

     &  (Mst1**2.*Mt**18.)/(16.*Mgl**3.)-

     &  Mt**20./(72.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst1)**4.*

     &  Den(Mst1,Mst2)*ln(mu,Mst1)*ln(mu,Mt)+

     &  (0.006944444444444444-(5*Mst2**2.)/(288.*Mgl**2.)+

     &  (3*Mt**2.)/(128.*Mgl**2.)-

     &  (Mst2**2.*Mt**2.)/(1152.*Mgl**4.)+

     &  Mt**4./(1152.*Mgl**4.))*ln(mu,Mst2)*ln(mu,Mt)+

     &  ((7*Mgl**4.)/1152.-(5*Mgl**6.)/(1152.*Mst2**2.)+

     &  (5*Mgl**2.*Mst2**2.)/384.-(11*Mst2**4.)/1152.-

     &  (5*Mst2**6.)/(576.*Mgl**2.)+

     &  Mst2**8./(288.*Mgl**4.)+

     &  (11*Mgl**2.*Mt**2.)/128.+

     &  (5*Mgl**4.*Mt**2.)/(1152.*Mst2**2.)-

     &  (19*Mst2**2.*Mt**2.)/288.-

     &  (55*Mst2**4.*Mt**2.)/(1152.*Mgl**2.)-

     &  (5*Mst2**6.*Mt**2.)/(1152.*Mgl**4.)+

     &  (35*Mt**4.)/576.+

     &  (5*Mgl**2.*Mt**4.)/(1152.*Mst2**2.)+

     &  (25*Mst2**2.*Mt**4.)/(192.*Mgl**2.)-

     &  (Mst2**4.*Mt**4.)/(128.*Mgl**4.)-

     &  (85*Mt**6.)/(1152.*Mgl**2.)-

     &  (5*Mt**6.)/(1152.*Mst2**2.)+

     &  (17*Mst2**2.*Mt**6.)/(1152.*Mgl**4.)-

     &  (7*Mt**8.)/(1152.*Mgl**4.))*d123(Mt,Mgl,Mst2)*

     &  ln(mu,Mst2)*ln(mu,Mt)+

     &  ((-43*Mgl**8.)/1152.+Mgl**10./(128.*Mst2**2.)+

     &  (Mgl**6.*Mst2**2.)/24.-

     &  (23*Mgl**4.*Mst2**4.)/576.+

     &  (149*Mgl**2.*Mst2**6.)/1152.-(65*Mst2**8.)/384.+

     &  (41*Mst2**10.)/(576.*Mgl**2.)-

     &  Mst2**12./(288.*Mgl**4.)-

     &  (5*Mgl**6.*Mt**2.)/576.-

     &  (43*Mgl**8.*Mt**2.)/(1152.*Mst2**2.)+

     &  (335*Mgl**4.*Mst2**2.*Mt**2.)/1152.-

     &  (79*Mgl**2.*Mst2**4.*Mt**2.)/288.+

     &  (185*Mst2**6.*Mt**2.)/1152.-

     &  (29*Mst2**8.*Mt**2.)/(192.*Mgl**2.)+

     &  (23*Mst2**10.*Mt**2.)/(1152.*Mgl**4.)+

     &  (107*Mgl**4.*Mt**4.)/1152.+

     &  (13*Mgl**6.*Mt**4.)/(576.*Mst2**2.)+

     &  (5*Mgl**2.*Mst2**2.*Mt**4.)/192.-

     &  (35*Mst2**4.*Mt**4.)/576.-

     &  (Mst2**6.*Mt**4.)/(24.*Mgl**2.)-

     &  (37*Mst2**8.*Mt**4.)/(1152.*Mgl**4.)+

     &  (13*Mgl**2.*Mt**6.)/192.+

     &  (7*Mgl**4.*Mt**6.)/(192.*Mst2**2.)+

     &  (119*Mst2**2.*Mt**6.)/576.+

     &  (175*Mst2**4.*Mt**6.)/(576.*Mgl**2.)-

     &  (Mst2**6.*Mt**6.)/(576.*Mgl**4.)-

     &  (53*Mt**8.)/384.-

     &  (35*Mgl**2.*Mt**8.)/(1152.*Mst2**2.)-

     &  (15*Mst2**2.*Mt**8.)/(64.*Mgl**2.)+

     &  (29*Mst2**4.*Mt**8.)/(576.*Mgl**4.)+

     &  (5*Mt**10.)/(96.*Mgl**2.)+

     &  Mt**10./(1152.*Mst2**2.)-

     &  (53*Mst2**2.*Mt**10.)/(1152.*Mgl**4.)+

     &  (5*Mt**12.)/(384.*Mgl**4.))*d123(Mt,Mgl,Mst2)**2.*

     &  ln(mu,Mst2)*ln(mu,Mt)+

     &  ((11*Mgl**12.)/288.-(19*Mgl**10.*Mst2**2.)/192.-

     &  (Mgl**8.*Mst2**4.)/144.+

     &  (107*Mgl**6.*Mst2**6.)/576.-

     &  (5*Mgl**4.*Mst2**8.)/144.-

     &  (49*Mgl**2.*Mst2**10.)/192.+(11*Mst2**12.)/48.-

     &  (31*Mst2**14.)/(576.*Mgl**2.)-

     &  Mst2**16./(288.*Mgl**4.)-

     &  (59*Mgl**10.*Mt**2.)/384.+

     &  (Mgl**12.*Mt**2.)/(36.*Mst2**2.)-

     &  (41*Mgl**8.*Mst2**2.*Mt**2.)/1152.+

     &  (173*Mgl**6.*Mst2**4.*Mt**2.)/384.-

     &  (37*Mgl**4.*Mst2**6.*Mt**2.)/128.+

     &  (91*Mgl**2.*Mst2**8.*Mt**2.)/384.-

     &  (575*Mst2**10.*Mt**2.)/1152.+

     &  (33*Mst2**12.*Mt**2.)/(128.*Mgl**2.)+

     &  (5*Mst2**14.*Mt**2.)/(1152.*Mgl**4.)+

     &  (37*Mgl**8.*Mt**4.)/384.-

     &  (Mgl**10.*Mt**4.)/(12.*Mst2**2.)+

     &  (13*Mgl**6.*Mst2**2.*Mt**4.)/64.-

     &  (83*Mgl**4.*Mst2**4.*Mt**4.)/384.+

     &  (47*Mgl**2.*Mst2**6.*Mt**4.)/288.+

     &  (67*Mst2**8.*Mt**4.)/384.-

     &  (215*Mst2**10.*Mt**4.)/(576.*Mgl**2.)+

     &  (41*Mst2**12.*Mt**4.)/(1152.*Mgl**4.)-

     &  (103*Mgl**6.*Mt**6.)/1152.+

     &  (Mgl**8.*Mt**6.)/(36.*Mst2**2.)-

     &  (43*Mgl**4.*Mst2**2.*Mt**6.)/1152.-

     &  (35*Mgl**2.*Mst2**4.*Mt**6.)/192.+

     &  (35*Mst2**6.*Mt**6.)/576.-

     &  (Mst2**8.*Mt**6.)/(384.*Mgl**2.)-

     &  (127*Mst2**10.*Mt**6.)/(1152.*Mgl**4.)+

     &  (41*Mgl**4.*Mt**8.)/128.+

     &  (Mgl**6.*Mt**8.)/(9.*Mst2**2.)+

     &  (47*Mgl**2.*Mst2**2.*Mt**8.)/192.+

     &  (15*Mst2**4.*Mt**8.)/64.+

     &  (271*Mst2**6.*Mt**8.)/(576.*Mgl**2.)+

     &  (125*Mst2**8.*Mt**8.)/(1152.*Mgl**4.)-

     &  (23*Mgl**2.*Mt**10.)/128.-

     &  (Mgl**4.*Mt**10.)/(12.*Mst2**2.)-

     &  (77*Mst2**2.*Mt**10.)/384.-

     &  (461*Mst2**4.*Mt**10.)/(1152.*Mgl**2.)-

     &  (Mst2**6.*Mt**10.)/(1152.*Mgl**4.)-

     &  (31*Mt**12.)/1152.-

     &  (Mgl**2.*Mt**12.)/(36.*Mst2**2.)+

     &  (55*Mst2**2.*Mt**12.)/(576.*Mgl**2.)-

     &  (85*Mst2**4.*Mt**12.)/(1152.*Mgl**4.)+

     &  (7*Mt**14.)/(1152.*Mgl**2.)+

     &  Mt**14./(36.*Mst2**2.)+

     &  (59*Mst2**2.*Mt**14.)/(1152.*Mgl**4.)-

     &  (13*Mt**16.)/(1152.*Mgl**4.))*d123(Mt,Mgl,Mst2)**3.*

     &  ln(mu,Mst2)*ln(mu,Mt)+

     &  ((-5*Mgl**16.)/576.-Mgl**18./(288.*Mst2**2.)+

     &  (19*Mgl**14.*Mst2**2.)/192.-

     &  (55*Mgl**12.*Mst2**4.)/288.+

     &  (Mgl**10.*Mst2**6.)/48.+

     &  (91*Mgl**8.*Mst2**8.)/288.-

     &  (91*Mgl**6.*Mst2**10.)/288.-

     &  (Mgl**4.*Mst2**12.)/48.+

     &  (55*Mgl**2.*Mst2**14.)/288.-(19*Mst2**16.)/192.+

     &  (5*Mst2**18.)/(576.*Mgl**2.)+

     &  Mst2**20./(288.*Mgl**4.)+

     &  (59*Mgl**14.*Mt**2.)/1152.+

     &  (Mgl**16.*Mt**2.)/(96.*Mst2**2.)-

     &  (91*Mgl**12.*Mst2**2.*Mt**2.)/576.-

     &  (29*Mgl**10.*Mst2**4.*Mt**2.)/576.+

     &  (7*Mgl**8.*Mst2**6.*Mt**2.)/24.-

     &  (5*Mgl**6.*Mst2**8.*Mt**2.)/96.+

     &  (19*Mgl**4.*Mst2**10.*Mt**2.)/288.-

     &  (299*Mgl**2.*Mst2**12.*Mt**2.)/576.+

     &  (137*Mst2**14.*Mt**2.)/288.-

     &  (37*Mst2**16.*Mt**2.)/(384.*Mgl**2.)-

     &  (11*Mst2**18.*Mt**2.)/(576.*Mgl**4.)+

     &  (Mgl**12.*Mt**4.)/288.+

     &  (Mgl**14.*Mt**4.)/(144.*Mst2**2.)-

     &  (35*Mgl**10.*Mst2**2.*Mt**4.)/144.+

     &  (119*Mgl**8.*Mst2**4.*Mt**4.)/288.-

     &  (11*Mgl**6.*Mst2**6.*Mt**4.)/36.+

     &  (17*Mgl**4.*Mst2**8.*Mt**4.)/72.+

     &  (49*Mgl**2.*Mst2**10.*Mt**4.)/144.-

     &  (79*Mst2**12.*Mt**4.)/96.+

     &  (49*Mst2**14.*Mt**4.)/(144.*Mgl**2.)+

     &  (Mst2**16.*Mt**4.)/(32.*Mgl**4.)-

     &  (47*Mgl**10.*Mt**6.)/144.-

     &  (5*Mgl**12.*Mt**6.)/(144.*Mst2**2.)+

     &  (97*Mgl**8.*Mst2**2.*Mt**6.)/288.-

     &  (11*Mgl**6.*Mst2**4.*Mt**6.)/64.-

     &  (13*Mgl**4.*Mst2**6.*Mt**6.)/144.+

     &  (47*Mgl**2.*Mst2**8.*Mt**6.)/288.+

     &  (59*Mst2**10.*Mt**6.)/96.-

     &  (295*Mst2**12.*Mt**6.)/(576.*Mgl**2.)+

     &  (Mst2**14.*Mt**6.)/(48.*Mgl**4.)+

     &  (107*Mgl**8.*Mt**8.)/288.-

     &  (Mgl**10.*Mt**8.)/(36.*Mst2**2.)-

     &  (Mgl**6.*Mst2**2.*Mt**8.)/18.-

     &  (Mgl**4.*Mst2**4.*Mt**8.)/4.-

     &  (19*Mgl**2.*Mst2**6.*Mt**8.)/48.-

     &  (9*Mst2**8.*Mt**8.)/32.+

     &  (11*Mst2**10.*Mt**8.)/(48.*Mgl**2.)-

     &  (7*Mst2**12.*Mt**8.)/(48.*Mgl**4.)+

     &  (25*Mgl**6.*Mt**10.)/192.+

     &  (Mgl**8.*Mt**10.)/(8.*Mst2**2.)+

     &  (109*Mgl**4.*Mst2**2.*Mt**10.)/288.+

     &  (95*Mgl**2.*Mst2**4.*Mt**10.)/192.+

     &  (11*Mst2**6.*Mt**10.)/36.+

     &  (5*Mst2**8.*Mt**10.)/(18.*Mgl**2.)+

     &  (7*Mst2**10.*Mt**10.)/(32.*Mgl**4.)-

     &  (35*Mgl**4.*Mt**12.)/144.-

     &  (Mgl**6.*Mt**12.)/(16.*Mst2**2.)-

     &  (7*Mgl**2.*Mst2**2.*Mt**12.)/24.-

     &  (65*Mst2**4.*Mt**12.)/288.-

     &  (29*Mst2**6.*Mt**12.)/(72.*Mgl**2.)-

     &  (7*Mst2**8.*Mt**12.)/(48.*Mgl**4.)-

     &  (5*Mgl**2.*Mt**14.)/72.-

     &  (11*Mgl**4.*Mt**14.)/(144.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**14.)/288.+

     &  (11*Mst2**4.*Mt**14.)/(64.*Mgl**2.)+

     &  (Mst2**6.*Mt**14.)/(48.*Mgl**4.)+

     &  (55*Mt**16.)/576.+

     &  (25*Mgl**2.*Mt**16.)/(288.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**16.)/(576.*Mgl**2.)+

     &  (Mst2**4.*Mt**16.)/(32.*Mgl**4.)-

     &  Mt**18./(128.*Mgl**2.)-

     &  (7*Mt**18.)/(288.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**18.)/(576.*Mgl**4.)+

     &  Mt**20./(288.*Mgl**4.))*d123(Mt,Mgl,Mst2)**4.*

     &  ln(mu,Mst2)*ln(mu,Mt)+

     &  (Mt**2./(9.*Mgl**1.)+Mt**4./(288.*Mgl**3.))*Xt*

     &  Den(Mst1,Mst2)*ln(mu,Mst2)*ln(mu,Mt)+

     &  ((-7*Mgl**3.*Mt**2.)/288.-

     &  (5*Mgl**5.*Mt**2.)/(288.*Mst2**2.)+

     &  (11*Mgl*Mst2**2.*Mt**2.)/288.+

     &  (Mst2**4.*Mt**2.)/(32.*Mgl**1.)-

     &  (Mst2**6.*Mt**2.)/(72.*Mgl**3.)+

     &  (277*Mgl*Mt**4.)/576.+

     &  (5*Mgl**3.*Mt**4.)/(144.*Mst2**2.)+

     &  (13*Mst2**2.*Mt**4.)/(48.*Mgl**1.)+

     &  (7*Mst2**4.*Mt**4.)/(576.*Mgl**3.)-

     &  (85*Mt**6.)/(288.*Mgl**1.)-

     &  (5*Mgl*Mt**6.)/(288.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**6.)/(288.*Mgl**3.)-

     &  Mt**8./(64.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)*ln(mu,Mst2)*ln(mu,Mt)+

     &  ((-37*Mgl**7.*Mt**2.)/288.+

     &  (Mgl**9.*Mt**2.)/(32.*Mst2**2.)+

     &  (5*Mgl**5.*Mst2**2.*Mt**2.)/72.-

     &  (Mgl**3.*Mst2**4.*Mt**2.)/9.+

     &  (37*Mgl*Mst2**6.*Mt**2.)/96.-

     &  (25*Mst2**8.*Mt**2.)/(96.*Mgl**1.)+

     &  (Mst2**10.*Mt**2.)/(72.*Mgl**3.)-

     &  (25*Mgl**5.*Mt**4.)/288.-

     &  (13*Mgl**7.*Mt**4.)/(72.*Mst2**2.)+

     &  (247*Mgl**3.*Mst2**2.*Mt**4.)/288.-

     &  (163*Mgl*Mst2**4.*Mt**4.)/288.+

     &  (95*Mst2**6.*Mt**4.)/(288.*Mgl**1.)-

     &  (11*Mst2**8.*Mt**4.)/(144.*Mgl**3.)+

     &  (229*Mgl**3.*Mt**6.)/288.+

     &  (13*Mgl**5.*Mt**6.)/(48.*Mst2**2.)+

     &  (5*Mgl*Mst2**2.*Mt**6.)/12.+

     &  (109*Mst2**4.*Mt**6.)/(288.*Mgl**1.)+

     &  (5*Mst2**6.*Mt**6.)/(48.*Mgl**3.)-

     &  (211*Mgl*Mt**8.)/288.-

     &  (Mgl**3.*Mt**8.)/(8.*Mst2**2.)-

     &  (185*Mst2**2.*Mt**8.)/(288.*Mgl**1.)+

     &  (Mst2**4.*Mt**8.)/(144.*Mgl**3.)+

     &  (7*Mt**10.)/(36.*Mgl**1.)+

     &  (Mgl*Mt**10.)/(288.*Mst2**2.)-

     &  (13*Mst2**2.*Mt**10.)/(144.*Mgl**3.)+

     &  Mt**12./(24.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst2)**2.*

     &  Den(Mst1,Mst2)*ln(mu,Mst2)*ln(mu,Mt)+

     &  ((Mgl**11.*Mt**2.)/9.-

     &  (13*Mgl**9.*Mst2**2.*Mt**2.)/72.-

     &  (Mgl**7.*Mst2**4.*Mt**2.)/6.+

     &  (19*Mgl**5.*Mst2**6.*Mt**2.)/72.+

     &  (Mgl**3.*Mst2**8.*Mt**2.)/3.-

     &  (13*Mgl*Mst2**10.*Mt**2.)/24.+

     &  (Mst2**12.*Mt**2.)/(6.*Mgl**1.)+

     &  (Mst2**14.*Mt**2.)/(72.*Mgl**3.)-

     &  (23*Mgl**9.*Mt**4.)/64.+

     &  (Mgl**11.*Mt**4.)/(9.*Mst2**2.)-

     &  (89*Mgl**7.*Mst2**2.*Mt**4.)/144.+

     &  (629*Mgl**5.*Mst2**4.*Mt**4.)/576.-

     &  (5*Mgl**3.*Mst2**6.*Mt**4.)/72.+

     &  (89*Mgl*Mst2**8.*Mt**4.)/192.-

     &  (89*Mst2**10.*Mt**4.)/(144.*Mgl**1.)-

     &  (Mst2**12.*Mt**4.)/(576.*Mgl**3.)-

     &  (49*Mgl**7.*Mt**6.)/144.-

     &  (4*Mgl**9.*Mt**6.)/(9.*Mst2**2.)+

     &  (335*Mgl**5.*Mst2**2.*Mt**6.)/288.-

     &  (5*Mgl**3.*Mst2**4.*Mt**6.)/9.+

     &  (13*Mgl*Mst2**6.*Mt**6.)/48.+

     &  (19*Mst2**8.*Mt**6.)/(48.*Mgl**1.)-

     &  (5*Mst2**10.*Mt**6.)/(32.*Mgl**3.)+

     &  (263*Mgl**5.*Mt**8.)/192.+

     &  (5*Mgl**7.*Mt**8.)/(9.*Mst2**2.)+

     &  (7*Mgl**3.*Mst2**2.*Mt**8.)/12.+

     &  (197*Mgl*Mst2**4.*Mt**8.)/288.+

     &  (29*Mst2**6.*Mt**8.)/(36.*Mgl**1.)+

     &  (185*Mst2**8.*Mt**8.)/(576.*Mgl**3.)-

     &  (55*Mgl**3.*Mt**10.)/72.-

     &  (Mgl**5.*Mt**10.)/(9.*Mst2**2.)-

     &  (139*Mgl*Mst2**2.*Mt**10.)/144.-

     &  (10*Mst2**4.*Mt**10.)/(9.*Mgl**1.)-

     &  (25*Mst2**6.*Mt**10.)/(144.*Mgl**3.)-

     &  (13*Mgl*Mt**12.)/576.-

     &  (2*Mgl**3.*Mt**12.)/(9.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**12.)/(16.*Mgl**1.)-

     &  (7*Mst2**4.*Mt**12.)/(64.*Mgl**3.)+

     &  (7*Mt**14.)/(144.*Mgl**1.)+

     &  (Mgl*Mt**14.)/(9.*Mst2**2.)+

     &  (43*Mst2**2.*Mt**14.)/(288.*Mgl**3.)-

     &  (25*Mt**16.)/(576.*Mgl**3.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mst2)*

     &  ln(mu,Mt)+((-7*Mgl**15.*Mt**2.)/144.-

     &  (Mgl**17.*Mt**2.)/(72.*Mst2**2.)+

     &  (25*Mgl**13.*Mst2**2.*Mt**2.)/72.-

     &  (5*Mgl**11.*Mst2**4.*Mt**2.)/12.-

     &  (Mgl**9.*Mst2**6.*Mt**2.)/3.+

     &  (67*Mgl**7.*Mst2**8.*Mt**2.)/72.-

     &  (Mgl**5.*Mst2**10.*Mt**2.)/3.-

     &  (5*Mgl**3.*Mst2**12.*Mt**2.)/12.+

     &  (25*Mgl*Mst2**14.*Mt**2.)/72.-

     &  (7*Mst2**16.*Mt**2.)/(144.*Mgl**1.)-

     &  (Mst2**18.*Mt**2.)/(72.*Mgl**3.)+

     &  (89*Mgl**13.*Mt**4.)/288.+

     &  (Mgl**15.*Mt**4.)/(18.*Mst2**2.)-

     &  (193*Mgl**11.*Mst2**2.*Mt**4.)/288.-

     &  (131*Mgl**9.*Mst2**4.*Mt**4.)/288.+

     &  (301*Mgl**7.*Mst2**6.*Mt**4.)/288.-

     &  (3*Mgl**5.*Mst2**8.*Mt**4.)/32.+

     &  (145*Mgl**3.*Mst2**10.*Mt**4.)/288.-

     &  (37*Mgl*Mst2**12.*Mt**4.)/32.+

     &  (115*Mst2**14.*Mt**4.)/(288.*Mgl**1.)+

     &  (Mst2**16.*Mt**4.)/(16.*Mgl**3.)-

     &  (31*Mgl**11.*Mt**6.)/96.-

     &  (Mgl**13.*Mt**6.)/(36.*Mst2**2.)-

     &  (5*Mgl**9.*Mst2**2.*Mt**6.)/8.+

     &  (427*Mgl**7.*Mst2**4.*Mt**6.)/288.-

     &  (113*Mgl**5.*Mst2**6.*Mt**6.)/144.+

     &  (73*Mgl**3.*Mst2**8.*Mt**6.)/288.+

     &  (10*Mgl*Mst2**10.*Mt**6.)/9.-

     &  (295*Mst2**12.*Mt**6.)/(288.*Mgl**1.)-

     &  (Mst2**14.*Mt**6.)/(16.*Mgl**3.)-

     &  (35*Mgl**9.*Mt**8.)/32.-

     &  (Mgl**11.*Mt**8.)/(9.*Mst2**2.)+

     &  (253*Mgl**7.*Mst2**2.*Mt**8.)/288.-

     &  (31*Mgl**5.*Mst2**4.*Mt**8.)/24.-

     &  (125*Mgl**3.*Mst2**6.*Mt**8.)/144.-

     &  (15*Mgl*Mst2**8.*Mt**8.)/32.+

     &  (253*Mst2**10.*Mt**8.)/(288.*Mgl**1.)-

     &  (7*Mst2**12.*Mt**8.)/(48.*Mgl**3.)+

     &  (743*Mgl**7.*Mt**10.)/288.+

     &  (71*Mgl**5.*Mst2**2.*Mt**10.)/48.+

     &  (85*Mgl**3.*Mst2**4.*Mt**10.)/48.+

     &  (19*Mgl*Mst2**6.*Mt**10.)/18.+

     &  (115*Mst2**8.*Mt**10.)/(288.*Mgl**1.)+

     &  (7*Mst2**10.*Mt**10.)/(16.*Mgl**3.)-

     &  (449*Mgl**5.*Mt**12.)/288.+

     &  (Mgl**7.*Mt**12.)/(2.*Mst2**2.)-

     &  (439*Mgl**3.*Mst2**2.*Mt**12.)/288.-

     &  (379*Mgl*Mst2**4.*Mt**12.)/288.-

     &  (331*Mst2**6.*Mt**12.)/(288.*Mgl**1.)-

     &  (7*Mst2**8.*Mt**12.)/(16.*Mgl**3.)-

     &  (47*Mgl**3.*Mt**14.)/288.-

     &  (3*Mgl**5.*Mt**14.)/(4.*Mst2**2.)+

     &  (7*Mgl*Mst2**2.*Mt**14.)/36.+

     &  (175*Mst2**4.*Mt**14.)/(288.*Mgl**1.)+

     &  (7*Mst2**6.*Mt**14.)/(48.*Mgl**3.)+

     &  (95*Mgl*Mt**16.)/288.+

     &  (4*Mgl**3.*Mt**16.)/(9.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**16.)/(288.*Mgl**1.)+

     &  (Mst2**4.*Mt**16.)/(16.*Mgl**3.)-

     &  (13*Mt**18.)/(288.*Mgl**1.)-

     &  (7*Mgl*Mt**18.)/(72.*Mst2**2.)-

     &  (Mst2**2.*Mt**18.)/(16.*Mgl**3.)+

     &  Mt**20./(72.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst2)**4.*

     &  Den(Mst1,Mst2)*ln(mu,Mst2)*ln(mu,Mt)+

     &  (0.029513888888888888+(5*Mgl**2.)/(1152.*Mst1**2.)-

     &  (5*Mst1**2.)/(576.*Mgl**2.)+

     &  (5*Mgl**2.)/(1152.*Mst2**2.)-

     &  (5*Mst2**2.)/(576.*Mgl**2.)+

     &  (37*Mt**2.)/(1152.*Mgl**2.)-

     &  Mt**2./(1152.*Mst1**2.)+

     &  (Mst1**2.*Mt**2.)/(2304.*Mgl**4.)-

     &  Mt**2./(1152.*Mst2**2.)+

     &  (Mst2**2.*Mt**2.)/(2304.*Mgl**4.)-

     &  Mt**4./(1152.*Mgl**4.))*ln(mu,Mt)**2.+

     &  (Mgl**4./288.+Mgl**8./(576.*Mst1**4.)-

     &  Mgl**6./(128.*Mst1**2.)+(Mgl**2.*Mst1**2.)/192.+

     &  Mst1**4./288.-Mst1**6./(128.*Mgl**2.)+

     &  Mst1**8./(576.*Mgl**4.)+

     &  (19*Mgl**2.*Mt**2.)/256.-

     &  (Mgl**6.*Mt**2.)/(288.*Mst1**4.)+

     &  (Mgl**4.*Mt**2.)/(576.*Mst1**2.)+

     &  (83*Mst1**2.*Mt**2.)/2304.-

     &  (35*Mst1**4.*Mt**2.)/(2304.*Mgl**2.)-

     &  (5*Mst1**6.*Mt**2.)/(768.*Mgl**4.)+

     &  (167*Mt**4.)/2304.+

     &  (Mgl**2.*Mt**4.)/(1152.*Mst1**2.)+

     &  (79*Mst1**2.*Mt**4.)/(1152.*Mgl**2.)+

     &  (7*Mst1**4.*Mt**4.)/(768.*Mgl**4.)-

     &  (35*Mt**6.)/(768.*Mgl**2.)+

     &  (Mgl**2.*Mt**6.)/(288.*Mst1**4.)+

     &  Mt**6./(192.*Mst1**2.)-

     &  (13*Mst1**2.*Mt**6.)/(2304.*Mgl**4.)+

     &  Mt**8./(768.*Mgl**4.)-Mt**8./(576.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)*ln(mu,Mt)**2.+

     &  ((-17*Mgl**8.)/288.-Mgl**12./(576.*Mst1**4.)+

     &  (29*Mgl**10.)/(1152.*Mst1**2.)+

     &  (61*Mgl**6.*Mst1**2.)/1152.-

     &  (19*Mgl**4.*Mst1**4.)/288.+

     &  (151*Mgl**2.*Mst1**6.)/1152.-(35*Mst1**8.)/288.+

     &  (47*Mst1**10.)/(1152.*Mgl**2.)-

     &  Mst1**12./(576.*Mgl**4.)-

     &  (37*Mgl**6.*Mt**2.)/1152.+

     &  (5*Mgl**10.*Mt**2.)/(576.*Mst1**4.)-

     &  (55*Mgl**8.*Mt**2.)/(2304.*Mst1**2.)+

     &  (233*Mgl**4.*Mst1**2.*Mt**2.)/2304.-

     &  (13*Mgl**2.*Mst1**4.*Mt**2.)/128.+

     &  (115*Mst1**6.*Mt**2.)/768.-

     &  (11*Mst1**8.*Mt**2.)/(96.*Mgl**2.)+

     &  (29*Mst1**10.*Mt**2.)/(2304.*Mgl**4.)+

     &  (109*Mgl**4.*Mt**4.)/2304.-

     &  (13*Mgl**8.*Mt**4.)/(1152.*Mst1**4.)-

     &  (43*Mgl**6.*Mt**4.)/(1152.*Mst1**2.)+

     &  (97*Mgl**2.*Mst1**2.*Mt**4.)/1152.-

     &  (17*Mst1**4.*Mt**4.)/192.+

     &  (19*Mst1**6.*Mt**4.)/(576.*Mgl**2.)-

     &  (79*Mst1**8.*Mt**4.)/(2304.*Mgl**4.)+

     &  (13*Mgl**2.*Mt**6.)/576.-

     &  (Mgl**6.*Mt**6.)/(576.*Mst1**4.)-

     &  (5*Mgl**4.*Mt**6.)/(1152.*Mst1**2.)+

     &  (169*Mst1**2.*Mt**6.)/1152.+

     &  (205*Mst1**4.*Mt**6.)/(1152.*Mgl**2.)+

     &  (53*Mst1**6.*Mt**6.)/(1152.*Mgl**4.)-

     &  (49*Mt**8.)/1152.+

     &  (7*Mgl**4.*Mt**8.)/(576.*Mst1**4.)+

     &  (49*Mgl**2.*Mt**8.)/(576.*Mst1**2.)-

     &  (77*Mst1**2.*Mt**8.)/(384.*Mgl**2.)-

     &  (37*Mst1**4.*Mt**8.)/(1152.*Mgl**4.)+

     &  (73*Mt**10.)/(1152.*Mgl**2.)-

     &  (Mgl**2.*Mt**10.)/(144.*Mst1**4.)-

     &  (103*Mt**10.)/(2304.*Mst1**2.)+

     &  (25*Mst1**2.*Mt**10.)/(2304.*Mgl**4.)-

     &  Mt**12./(768.*Mgl**4.)+Mt**12./(1152.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**2.*ln(mu,Mt)**2.+

     &  ((139*Mgl**12.)/1152.-Mgl**16./(576.*Mst1**4.)-

     &  (7*Mgl**14.)/(288.*Mst1**2.)-

     &  (59*Mgl**10.*Mst1**2.)/384.-

     &  (13*Mgl**8.*Mst1**4.)/384.+

     &  (199*Mgl**6.*Mst1**6.)/1152.+

     &  (Mgl**4.*Mst1**8.)/384.-

     &  (73*Mgl**2.*Mst1**10.)/384.+

     &  (157*Mst1**12.)/1152.-

     &  (31*Mst1**14.)/(1152.*Mgl**2.)-

     &  Mst1**16./(576.*Mgl**4.)-

     &  (341*Mgl**10.*Mt**2.)/2304.+

     &  (Mgl**14.*Mt**2.)/(144.*Mst1**4.)+

     &  (5*Mgl**12.*Mt**2.)/(72.*Mst1**2.)-

     &  (107*Mgl**8.*Mst1**2.*Mt**2.)/2304.+

     &  (263*Mgl**6.*Mst1**4.*Mt**2.)/2304.+

     &  (55*Mgl**4.*Mst1**6.*Mt**2.)/768.+

     &  (289*Mgl**2.*Mst1**8.*Mt**2.)/2304.-

     &  (259*Mst1**10.*Mt**2.)/768.+

     &  (317*Mst1**12.*Mt**2.)/(2304.*Mgl**2.)+

     &  (5*Mst1**14.*Mt**2.)/(768.*Mgl**4.)+

     &  (107*Mgl**8.*Mt**4.)/2304.-

     &  (Mgl**12.*Mt**4.)/(96.*Mst1**4.)-

     &  (Mgl**10.*Mt**4.)/(288.*Mst1**2.)+

     &  (13*Mgl**6.*Mst1**2.*Mt**4.)/1152.-

     &  (121*Mgl**4.*Mst1**4.*Mt**4.)/768.+

     &  (41*Mgl**2.*Mst1**6.*Mt**4.)/576.+

     &  (69*Mst1**8.*Mt**4.)/256.-

     &  (259*Mst1**10.*Mt**4.)/(1152.*Mgl**2.)-

     &  (5*Mst1**12.*Mt**4.)/(2304.*Mgl**4.)-

     &  (295*Mgl**6.*Mt**6.)/2304.+

     &  (Mgl**10.*Mt**6.)/(96.*Mst1**4.)-

     &  (31*Mgl**8.*Mt**6.)/(288.*Mst1**2.)-

     &  (341*Mgl**4.*Mst1**2.*Mt**6.)/2304.-

     &  (115*Mgl**2.*Mst1**4.*Mt**6.)/384.-

     &  (131*Mst1**6.*Mt**6.)/1152.+

     &  (49*Mst1**8.*Mt**6.)/(2304.*Mgl**2.)-

     &  (61*Mst1**10.*Mt**6.)/(2304.*Mgl**4.)-

     &  (451*Mgl**4.*Mt**8.)/2304.-

     &  (Mgl**8.*Mt**8.)/(96.*Mst1**4.)-

     &  (5*Mgl**6.*Mt**8.)/(144.*Mst1**2.)-

     &  (55*Mgl**2.*Mst1**2.*Mt**8.)/1152.-

     &  (Mst1**4.*Mt**8.)/64.+

     &  (407*Mst1**6.*Mt**8.)/(1152.*Mgl**2.)+

     &  (15*Mst1**8.*Mt**8.)/(256.*Mgl**4.)+

     &  (419*Mgl**2.*Mt**10.)/768.+

     &  (71*Mgl**4.*Mt**10.)/(288.*Mst1**2.)+

     &  (55*Mst1**2.*Mt**10.)/256.-

     &  (1009*Mst1**4.*Mt**10.)/(2304.*Mgl**2.)-

     &  (131*Mst1**6.*Mt**10.)/(2304.*Mgl**4.)-

     &  (463*Mt**12.)/2304.+

     &  (5*Mgl**4.*Mt**12.)/(288.*Mst1**4.)-

     &  (3*Mgl**2.*Mt**12.)/(16.*Mst1**2.)+

     &  (251*Mst1**2.*Mt**12.)/(1152.*Mgl**2.)+

     &  (65*Mst1**4.*Mt**12.)/(2304.*Mgl**4.)-

     &  (31*Mt**14.)/(768.*Mgl**2.)-

     &  (5*Mgl**2.*Mt**14.)/(288.*Mst1**4.)+

     &  Mt**14./(24.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**14.)/(768.*Mgl**4.)+

     &  Mt**16./(2304.*Mgl**4.)+Mt**16./(192.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**3.*ln(mu,Mt)**2.+

     &  ((-31*Mgl**16.)/576.+Mgl**20./(576.*Mst1**4.)+

     &  Mgl**18./(384.*Mst1**2.)+

     &  (167*Mgl**14.*Mst1**2.)/1152.-

     &  (61*Mgl**12.*Mst1**4.)/576.-

     &  (85*Mgl**10.*Mst1**6.)/576.+

     &  (91*Mgl**8.*Mst1**8.)/288.-

     &  (85*Mgl**6.*Mst1**10.)/576.-

     &  (61*Mgl**4.*Mst1**12.)/576.+

     &  (167*Mgl**2.*Mst1**14.)/1152.-

     &  (31*Mst1**16.)/576.+Mst1**18./(384.*Mgl**2.)+

     &  Mst1**20./(576.*Mgl**4.)+

     &  (275*Mgl**14.*Mt**2.)/2304.-

     &  (7*Mgl**18.*Mt**2.)/(576.*Mst1**4.)-

     &  (5*Mgl**16.*Mt**2.)/(768.*Mst1**2.)-

     &  (47*Mgl**12.*Mst1**2.*Mt**2.)/576.-

     &  (217*Mgl**10.*Mst1**4.*Mt**2.)/1152.+

     &  (41*Mgl**8.*Mst1**6.*Mt**2.)/576.+

     &  (205*Mgl**6.*Mst1**8.*Mt**2.)/576.-

     &  (235*Mgl**4.*Mst1**10.*Mt**2.)/1152.-

     &  (281*Mgl**2.*Mst1**12.*Mt**2.)/1152.+

     &  (539*Mst1**14.*Mt**2.)/2304.-

     &  (71*Mst1**16.*Mt**2.)/(2304.*Mgl**2.)-

     &  (5*Mst1**18.*Mt**2.)/(384.*Mgl**4.)-

     &  (Mgl**12.*Mt**4.)/48.+

     &  (41*Mgl**16.*Mt**4.)/(1152.*Mst1**4.)-

     &  (47*Mgl**14.*Mt**4.)/(1152.*Mst1**2.)+

     &  (13*Mgl**10.*Mst1**2.*Mt**4.)/384.+

     &  (Mgl**8.*Mst1**4.*Mt**4.)/192.-

     &  (133*Mgl**6.*Mst1**6.*Mt**4.)/384.+

     &  (43*Mgl**4.*Mst1**8.*Mt**4.)/72.-

     &  (19*Mgl**2.*Mst1**10.*Mt**4.)/1152.-

     &  (157*Mst1**12.*Mt**4.)/384.+

     &  (23*Mst1**14.*Mt**4.)/(192.*Mgl**2.)+

     &  (Mst1**16.*Mt**4.)/(24.*Mgl**4.)+

     &  (Mgl**10.*Mt**6.)/18.-

     &  (11*Mgl**14.*Mt**6.)/(192.*Mst1**4.)+

     &  (61*Mgl**12.*Mt**6.)/(288.*Mst1**2.)-

     &  (169*Mgl**8.*Mst1**2.*Mt**6.)/384.+

     &  (143*Mgl**6.*Mst1**4.*Mt**6.)/1152.-

     &  (175*Mgl**4.*Mst1**6.*Mt**6.)/576.+

     &  (187*Mgl**2.*Mst1**8.*Mt**6.)/576.+

     &  (425*Mst1**10.*Mt**6.)/1152.-

     &  (27*Mst1**12.*Mt**6.)/(128.*Mgl**2.)-

     &  (7*Mst1**14.*Mt**6.)/(96.*Mgl**4.)-

     &  (173*Mgl**8.*Mt**8.)/576.+

     &  (31*Mgl**12.*Mt**8.)/(576.*Mst1**4.)-

     &  (425*Mgl**10.*Mt**8.)/(1152.*Mst1**2.)+

     &  (31*Mgl**6.*Mst1**2.*Mt**8.)/72.+

     &  (25*Mgl**4.*Mst1**4.*Mt**8.)/192.-

     &  (281*Mgl**2.*Mst1**6.*Mt**8.)/1152.-

     &  (17*Mst1**8.*Mt**8.)/192.+

     &  (85*Mst1**10.*Mt**8.)/(576.*Mgl**2.)+

     &  (7*Mst1**12.*Mt**8.)/(96.*Mgl**4.)-

     &  (23*Mgl**6.*Mt**10.)/384.-

     &  (11*Mgl**10.*Mt**10.)/(576.*Mst1**4.)+

     &  (33*Mgl**8.*Mt**10.)/(128.*Mst1**2.)-

     &  (791*Mgl**4.*Mst1**2.*Mt**10.)/1152.-

     &  (613*Mgl**2.*Mst1**4.*Mt**10.)/1152.-

     &  (25*Mst1**6.*Mt**10.)/72.+

     &  (Mst1**8.*Mt**10.)/(16.*Mgl**2.)-

     &  (7*Mst1**10.*Mt**10.)/(192.*Mgl**4.)+

     &  (203*Mgl**4.*Mt**12.)/288.-

     &  (Mgl**8.*Mt**12.)/(32.*Mst1**4.)-

     &  (5*Mgl**6.*Mt**12.)/(1152.*Mst1**2.)+

     &  (1267*Mgl**2.*Mst1**2.*Mt**12.)/1152.+

     &  (179*Mst1**4.*Mt**12.)/288.-

     &  (37*Mst1**6.*Mt**12.)/(192.*Mgl**2.)-

     &  (167*Mgl**2.*Mt**14.)/288.+

     &  (37*Mgl**6.*Mt**14.)/(576.*Mst1**4.)-

     &  (11*Mgl**4.*Mt**14.)/(144.*Mst1**2.)-

     &  (521*Mst1**2.*Mt**14.)/1152.+

     &  (167*Mst1**4.*Mt**14.)/(1152.*Mgl**2.)+

     &  (Mst1**6.*Mt**14.)/(96.*Mgl**4.)+

     &  (37*Mt**16.)/288.-

     &  (Mgl**4.*Mt**16.)/(18.*Mst1**4.)+

     &  (13*Mgl**2.*Mt**16.)/(576.*Mst1**2.)-

     &  (19*Mst1**2.*Mt**16.)/(384.*Mgl**2.)-

     &  (Mst1**4.*Mt**16.)/(192.*Mgl**4.)+

     &  (5*Mt**18.)/(768.*Mgl**2.)+

     &  (7*Mgl**2.*Mt**18.)/(288.*Mst1**4.)+

     &  (5*Mt**18.)/(2304.*Mst1**2.)+

     &  (Mst1**2.*Mt**18.)/(1152.*Mgl**4.)-

     &  (5*Mt**20.)/(1152.*Mst1**4.))*d123(Mt,Mgl,Mst1)**4.*

     &  ln(mu,Mt)**2.+

     &  (Mgl**4./288.+Mgl**8./(576.*Mst2**4.)-

     &  Mgl**6./(128.*Mst2**2.)+(Mgl**2.*Mst2**2.)/192.+

     &  Mst2**4./288.-Mst2**6./(128.*Mgl**2.)+

     &  Mst2**8./(576.*Mgl**4.)+

     &  (19*Mgl**2.*Mt**2.)/256.-

     &  (Mgl**6.*Mt**2.)/(288.*Mst2**4.)+

     &  (Mgl**4.*Mt**2.)/(576.*Mst2**2.)+

     &  (83*Mst2**2.*Mt**2.)/2304.-

     &  (35*Mst2**4.*Mt**2.)/(2304.*Mgl**2.)-

     &  (5*Mst2**6.*Mt**2.)/(768.*Mgl**4.)+

     &  (167*Mt**4.)/2304.+

     &  (Mgl**2.*Mt**4.)/(1152.*Mst2**2.)+

     &  (79*Mst2**2.*Mt**4.)/(1152.*Mgl**2.)+

     &  (7*Mst2**4.*Mt**4.)/(768.*Mgl**4.)-

     &  (35*Mt**6.)/(768.*Mgl**2.)+

     &  (Mgl**2.*Mt**6.)/(288.*Mst2**4.)+

     &  Mt**6./(192.*Mst2**2.)-

     &  (13*Mst2**2.*Mt**6.)/(2304.*Mgl**4.)+

     &  Mt**8./(768.*Mgl**4.)-Mt**8./(576.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)*ln(mu,Mt)**2.+

     &  ((-17*Mgl**8.)/288.-Mgl**12./(576.*Mst2**4.)+

     &  (29*Mgl**10.)/(1152.*Mst2**2.)+

     &  (61*Mgl**6.*Mst2**2.)/1152.-

     &  (19*Mgl**4.*Mst2**4.)/288.+

     &  (151*Mgl**2.*Mst2**6.)/1152.-(35*Mst2**8.)/288.+

     &  (47*Mst2**10.)/(1152.*Mgl**2.)-

     &  Mst2**12./(576.*Mgl**4.)-

     &  (37*Mgl**6.*Mt**2.)/1152.+

     &  (5*Mgl**10.*Mt**2.)/(576.*Mst2**4.)-

     &  (55*Mgl**8.*Mt**2.)/(2304.*Mst2**2.)+

     &  (233*Mgl**4.*Mst2**2.*Mt**2.)/2304.-

     &  (13*Mgl**2.*Mst2**4.*Mt**2.)/128.+

     &  (115*Mst2**6.*Mt**2.)/768.-

     &  (11*Mst2**8.*Mt**2.)/(96.*Mgl**2.)+

     &  (29*Mst2**10.*Mt**2.)/(2304.*Mgl**4.)+

     &  (109*Mgl**4.*Mt**4.)/2304.-

     &  (13*Mgl**8.*Mt**4.)/(1152.*Mst2**4.)-

     &  (43*Mgl**6.*Mt**4.)/(1152.*Mst2**2.)+

     &  (97*Mgl**2.*Mst2**2.*Mt**4.)/1152.-

     &  (17*Mst2**4.*Mt**4.)/192.+

     &  (19*Mst2**6.*Mt**4.)/(576.*Mgl**2.)-

     &  (79*Mst2**8.*Mt**4.)/(2304.*Mgl**4.)+

     &  (13*Mgl**2.*Mt**6.)/576.-

     &  (Mgl**6.*Mt**6.)/(576.*Mst2**4.)-

     &  (5*Mgl**4.*Mt**6.)/(1152.*Mst2**2.)+

     &  (169*Mst2**2.*Mt**6.)/1152.+

     &  (205*Mst2**4.*Mt**6.)/(1152.*Mgl**2.)+

     &  (53*Mst2**6.*Mt**6.)/(1152.*Mgl**4.)-

     &  (49*Mt**8.)/1152.+

     &  (7*Mgl**4.*Mt**8.)/(576.*Mst2**4.)+

     &  (49*Mgl**2.*Mt**8.)/(576.*Mst2**2.)-

     &  (77*Mst2**2.*Mt**8.)/(384.*Mgl**2.)-

     &  (37*Mst2**4.*Mt**8.)/(1152.*Mgl**4.)+

     &  (73*Mt**10.)/(1152.*Mgl**2.)-

     &  (Mgl**2.*Mt**10.)/(144.*Mst2**4.)-

     &  (103*Mt**10.)/(2304.*Mst2**2.)+

     &  (25*Mst2**2.*Mt**10.)/(2304.*Mgl**4.)-

     &  Mt**12./(768.*Mgl**4.)+Mt**12./(1152.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**2.*ln(mu,Mt)**2.+

     &  ((139*Mgl**12.)/1152.-Mgl**16./(576.*Mst2**4.)-

     &  (7*Mgl**14.)/(288.*Mst2**2.)-

     &  (59*Mgl**10.*Mst2**2.)/384.-

     &  (13*Mgl**8.*Mst2**4.)/384.+

     &  (199*Mgl**6.*Mst2**6.)/1152.+

     &  (Mgl**4.*Mst2**8.)/384.-

     &  (73*Mgl**2.*Mst2**10.)/384.+

     &  (157*Mst2**12.)/1152.-

     &  (31*Mst2**14.)/(1152.*Mgl**2.)-

     &  Mst2**16./(576.*Mgl**4.)-

     &  (341*Mgl**10.*Mt**2.)/2304.+

     &  (Mgl**14.*Mt**2.)/(144.*Mst2**4.)+

     &  (5*Mgl**12.*Mt**2.)/(72.*Mst2**2.)-

     &  (107*Mgl**8.*Mst2**2.*Mt**2.)/2304.+

     &  (263*Mgl**6.*Mst2**4.*Mt**2.)/2304.+

     &  (55*Mgl**4.*Mst2**6.*Mt**2.)/768.+

     &  (289*Mgl**2.*Mst2**8.*Mt**2.)/2304.-

     &  (259*Mst2**10.*Mt**2.)/768.+

     &  (317*Mst2**12.*Mt**2.)/(2304.*Mgl**2.)+

     &  (5*Mst2**14.*Mt**2.)/(768.*Mgl**4.)+

     &  (107*Mgl**8.*Mt**4.)/2304.-

     &  (Mgl**12.*Mt**4.)/(96.*Mst2**4.)-

     &  (Mgl**10.*Mt**4.)/(288.*Mst2**2.)+

     &  (13*Mgl**6.*Mst2**2.*Mt**4.)/1152.-

     &  (121*Mgl**4.*Mst2**4.*Mt**4.)/768.+

     &  (41*Mgl**2.*Mst2**6.*Mt**4.)/576.+

     &  (69*Mst2**8.*Mt**4.)/256.-

     &  (259*Mst2**10.*Mt**4.)/(1152.*Mgl**2.)-

     &  (5*Mst2**12.*Mt**4.)/(2304.*Mgl**4.)-

     &  (295*Mgl**6.*Mt**6.)/2304.+

     &  (Mgl**10.*Mt**6.)/(96.*Mst2**4.)-

     &  (31*Mgl**8.*Mt**6.)/(288.*Mst2**2.)-

     &  (341*Mgl**4.*Mst2**2.*Mt**6.)/2304.-

     &  (115*Mgl**2.*Mst2**4.*Mt**6.)/384.-

     &  (131*Mst2**6.*Mt**6.)/1152.+

     &  (49*Mst2**8.*Mt**6.)/(2304.*Mgl**2.)-

     &  (61*Mst2**10.*Mt**6.)/(2304.*Mgl**4.)-

     &  (451*Mgl**4.*Mt**8.)/2304.-

     &  (Mgl**8.*Mt**8.)/(96.*Mst2**4.)-

     &  (5*Mgl**6.*Mt**8.)/(144.*Mst2**2.)-

     &  (55*Mgl**2.*Mst2**2.*Mt**8.)/1152.-

     &  (Mst2**4.*Mt**8.)/64.+

     &  (407*Mst2**6.*Mt**8.)/(1152.*Mgl**2.)+

     &  (15*Mst2**8.*Mt**8.)/(256.*Mgl**4.)+

     &  (419*Mgl**2.*Mt**10.)/768.+

     &  (71*Mgl**4.*Mt**10.)/(288.*Mst2**2.)+

     &  (55*Mst2**2.*Mt**10.)/256.-

     &  (1009*Mst2**4.*Mt**10.)/(2304.*Mgl**2.)-

     &  (131*Mst2**6.*Mt**10.)/(2304.*Mgl**4.)-

     &  (463*Mt**12.)/2304.+

     &  (5*Mgl**4.*Mt**12.)/(288.*Mst2**4.)-

     &  (3*Mgl**2.*Mt**12.)/(16.*Mst2**2.)+

     &  (251*Mst2**2.*Mt**12.)/(1152.*Mgl**2.)+

     &  (65*Mst2**4.*Mt**12.)/(2304.*Mgl**4.)-

     &  (31*Mt**14.)/(768.*Mgl**2.)-

     &  (5*Mgl**2.*Mt**14.)/(288.*Mst2**4.)+

     &  Mt**14./(24.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**14.)/(768.*Mgl**4.)+

     &  Mt**16./(2304.*Mgl**4.)+Mt**16./(192.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**3.*ln(mu,Mt)**2.+

     &  ((-31*Mgl**16.)/576.+Mgl**20./(576.*Mst2**4.)+

     &  Mgl**18./(384.*Mst2**2.)+

     &  (167*Mgl**14.*Mst2**2.)/1152.-

     &  (61*Mgl**12.*Mst2**4.)/576.-

     &  (85*Mgl**10.*Mst2**6.)/576.+

     &  (91*Mgl**8.*Mst2**8.)/288.-

     &  (85*Mgl**6.*Mst2**10.)/576.-

     &  (61*Mgl**4.*Mst2**12.)/576.+

     &  (167*Mgl**2.*Mst2**14.)/1152.-

     &  (31*Mst2**16.)/576.+Mst2**18./(384.*Mgl**2.)+

     &  Mst2**20./(576.*Mgl**4.)+

     &  (275*Mgl**14.*Mt**2.)/2304.-

     &  (7*Mgl**18.*Mt**2.)/(576.*Mst2**4.)-

     &  (5*Mgl**16.*Mt**2.)/(768.*Mst2**2.)-

     &  (47*Mgl**12.*Mst2**2.*Mt**2.)/576.-

     &  (217*Mgl**10.*Mst2**4.*Mt**2.)/1152.+

     &  (41*Mgl**8.*Mst2**6.*Mt**2.)/576.+

     &  (205*Mgl**6.*Mst2**8.*Mt**2.)/576.-

     &  (235*Mgl**4.*Mst2**10.*Mt**2.)/1152.-

     &  (281*Mgl**2.*Mst2**12.*Mt**2.)/1152.+

     &  (539*Mst2**14.*Mt**2.)/2304.-

     &  (71*Mst2**16.*Mt**2.)/(2304.*Mgl**2.)-

     &  (5*Mst2**18.*Mt**2.)/(384.*Mgl**4.)-

     &  (Mgl**12.*Mt**4.)/48.+

     &  (41*Mgl**16.*Mt**4.)/(1152.*Mst2**4.)-

     &  (47*Mgl**14.*Mt**4.)/(1152.*Mst2**2.)+

     &  (13*Mgl**10.*Mst2**2.*Mt**4.)/384.+

     &  (Mgl**8.*Mst2**4.*Mt**4.)/192.-

     &  (133*Mgl**6.*Mst2**6.*Mt**4.)/384.+

     &  (43*Mgl**4.*Mst2**8.*Mt**4.)/72.-

     &  (19*Mgl**2.*Mst2**10.*Mt**4.)/1152.-

     &  (157*Mst2**12.*Mt**4.)/384.+

     &  (23*Mst2**14.*Mt**4.)/(192.*Mgl**2.)+

     &  (Mst2**16.*Mt**4.)/(24.*Mgl**4.)+

     &  (Mgl**10.*Mt**6.)/18.-

     &  (11*Mgl**14.*Mt**6.)/(192.*Mst2**4.)+

     &  (61*Mgl**12.*Mt**6.)/(288.*Mst2**2.)-

     &  (169*Mgl**8.*Mst2**2.*Mt**6.)/384.+

     &  (143*Mgl**6.*Mst2**4.*Mt**6.)/1152.-

     &  (175*Mgl**4.*Mst2**6.*Mt**6.)/576.+

     &  (187*Mgl**2.*Mst2**8.*Mt**6.)/576.+

     &  (425*Mst2**10.*Mt**6.)/1152.-

     &  (27*Mst2**12.*Mt**6.)/(128.*Mgl**2.)-

     &  (7*Mst2**14.*Mt**6.)/(96.*Mgl**4.)-

     &  (173*Mgl**8.*Mt**8.)/576.+

     &  (31*Mgl**12.*Mt**8.)/(576.*Mst2**4.)-

     &  (425*Mgl**10.*Mt**8.)/(1152.*Mst2**2.)+

     &  (31*Mgl**6.*Mst2**2.*Mt**8.)/72.+

     &  (25*Mgl**4.*Mst2**4.*Mt**8.)/192.-

     &  (281*Mgl**2.*Mst2**6.*Mt**8.)/1152.-

     &  (17*Mst2**8.*Mt**8.)/192.+

     &  (85*Mst2**10.*Mt**8.)/(576.*Mgl**2.)+

     &  (7*Mst2**12.*Mt**8.)/(96.*Mgl**4.)-

     &  (23*Mgl**6.*Mt**10.)/384.-

     &  (11*Mgl**10.*Mt**10.)/(576.*Mst2**4.)+

     &  (33*Mgl**8.*Mt**10.)/(128.*Mst2**2.)-

     &  (791*Mgl**4.*Mst2**2.*Mt**10.)/1152.-

     &  (613*Mgl**2.*Mst2**4.*Mt**10.)/1152.-

     &  (25*Mst2**6.*Mt**10.)/72.+

     &  (Mst2**8.*Mt**10.)/(16.*Mgl**2.)-

     &  (7*Mst2**10.*Mt**10.)/(192.*Mgl**4.)+

     &  (203*Mgl**4.*Mt**12.)/288.-

     &  (Mgl**8.*Mt**12.)/(32.*Mst2**4.)-

     &  (5*Mgl**6.*Mt**12.)/(1152.*Mst2**2.)+

     &  (1267*Mgl**2.*Mst2**2.*Mt**12.)/1152.+

     &  (179*Mst2**4.*Mt**12.)/288.-

     &  (37*Mst2**6.*Mt**12.)/(192.*Mgl**2.)-

     &  (167*Mgl**2.*Mt**14.)/288.+

     &  (37*Mgl**6.*Mt**14.)/(576.*Mst2**4.)-

     &  (11*Mgl**4.*Mt**14.)/(144.*Mst2**2.)-

     &  (521*Mst2**2.*Mt**14.)/1152.+

     &  (167*Mst2**4.*Mt**14.)/(1152.*Mgl**2.)+

     &  (Mst2**6.*Mt**14.)/(96.*Mgl**4.)+

     &  (37*Mt**16.)/288.-

     &  (Mgl**4.*Mt**16.)/(18.*Mst2**4.)+

     &  (13*Mgl**2.*Mt**16.)/(576.*Mst2**2.)-

     &  (19*Mst2**2.*Mt**16.)/(384.*Mgl**2.)-

     &  (Mst2**4.*Mt**16.)/(192.*Mgl**4.)+

     &  (5*Mt**18.)/(768.*Mgl**2.)+

     &  (7*Mgl**2.*Mt**18.)/(288.*Mst2**4.)+

     &  (5*Mt**18.)/(2304.*Mst2**2.)+

     &  (Mst2**2.*Mt**18.)/(1152.*Mgl**4.)-

     &  (5*Mt**20.)/(1152.*Mst2**4.))*d123(Mt,Mgl,Mst2)**4.*

     &  ln(mu,Mt)**2.+

     &  (-(Mgl*Mt**2.)/(144.*Mst1**2.)+

     &  (Mgl*Mt**2.)/(144.*Mst2**2.))*Xt*Den(Mst1,Mst2)*

     &  ln(mu,Mt)**2.+

     &  ((Mgl**3.*Mt**2.)/32.-

     &  (Mgl**7.*Mt**2.)/(144.*Mst1**4.)+

     &  (7*Mgl**5.*Mt**2.)/(288.*Mst1**2.)-

     &  (Mgl*Mst1**2.*Mt**2.)/32.-

     &  (7*Mst1**4.*Mt**2.)/(288.*Mgl**1.)+

     &  (Mst1**6.*Mt**2.)/(144.*Mgl**3.)-

     &  (475*Mgl*Mt**4.)/1152.+

     &  (Mgl**5.*Mt**4.)/(48.*Mst1**4.)-

     &  (Mgl**3.*Mt**4.)/(96.*Mst1**2.)-

     &  (37*Mst1**2.*Mt**4.)/(288.*Mgl**1.)-

     &  (17*Mst1**4.*Mt**4.)/(1152.*Mgl**3.)+

     &  (43*Mt**6.)/(288.*Mgl**1.)-

     &  (Mgl**3.*Mt**6.)/(48.*Mst1**4.)-

     &  (Mgl*Mt**6.)/(72.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**6.)/(576.*Mgl**3.)-

     &  Mt**8./(1152.*Mgl**3.)+

     &  (Mgl*Mt**8.)/(144.*Mst1**4.))*Xt*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((19*Mgl**7.*Mt**2.)/144.+

     &  (Mgl**11.*Mt**2.)/(144.*Mst1**4.)-

     &  (Mgl**9.*Mt**2.)/(12.*Mst1**2.)-

     &  (13*Mgl**5.*Mst1**2.*Mt**2.)/144.+

     &  (31*Mgl**3.*Mst1**4.*Mt**2.)/144.-

     &  (23*Mgl*Mst1**6.*Mt**2.)/72.+

     &  (7*Mst1**8.*Mt**2.)/(48.*Mgl**1.)-

     &  (Mst1**10.*Mt**2.)/(144.*Mgl**3.)+

     &  (43*Mgl**5.*Mt**4.)/192.-

     &  (Mgl**9.*Mt**4.)/(24.*Mst1**4.)+

     &  (49*Mgl**7.*Mt**4.)/(576.*Mst1**2.)-

     &  (83*Mgl**3.*Mst1**2.*Mt**4.)/576.+

     &  (41*Mgl*Mst1**4.*Mt**4.)/576.-

     &  (67*Mst1**6.*Mt**4.)/(288.*Mgl**1.)+

     &  (11*Mst1**8.*Mt**4.)/(288.*Mgl**3.)-

     &  (137*Mgl**3.*Mt**6.)/288.+

     &  (25*Mgl**7.*Mt**6.)/(288.*Mst1**4.)+

     &  (49*Mgl**5.*Mt**6.)/(192.*Mst1**2.)-

     &  (383*Mgl*Mst1**2.*Mt**6.)/576.-

     &  (49*Mst1**4.*Mt**6.)/(288.*Mgl**1.)-

     &  (7*Mst1**6.*Mt**6.)/(96.*Mgl**3.)+

     &  (179*Mgl*Mt**8.)/576.-

     &  (23*Mgl**5.*Mt**8.)/(288.*Mst1**4.)-

     &  (27*Mgl**3.*Mt**8.)/(64.*Mst1**2.)+

     &  (4*Mst1**2.*Mt**8.)/(9.*Mgl**1.)+

     &  (17*Mst1**4.*Mt**8.)/(288.*Mgl**3.)-

     &  (3*Mt**10.)/(16.*Mgl**1.)+

     &  (Mgl**3.*Mt**10.)/(32.*Mst1**4.)+

     &  (95*Mgl*Mt**10.)/(576.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**10.)/(288.*Mgl**3.)-

     &  (Mgl*Mt**12.)/(288.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((-47*Mgl**11.*Mt**2.)/144.+

     &  (Mgl**15.*Mt**2.)/(144.*Mst1**4.)+

     &  (Mgl**13.*Mt**2.)/(12.*Mst1**2.)+

     &  (37*Mgl**9.*Mst1**2.*Mt**2.)/144.+

     &  (31*Mgl**7.*Mst1**4.*Mt**2.)/144.-

     &  (31*Mgl**5.*Mst1**6.*Mt**2.)/144.-

     &  (37*Mgl**3.*Mst1**8.*Mt**2.)/144.+

     &  (47*Mgl*Mst1**10.*Mt**2.)/144.-

     &  (Mst1**12.*Mt**2.)/(12.*Mgl**1.)-

     &  (Mst1**14.*Mt**2.)/(144.*Mgl**3.)+

     &  (415*Mgl**9.*Mt**4.)/1152.-

     &  (5*Mgl**13.*Mt**4.)/(144.*Mst1**4.)-

     &  (Mgl**11.*Mt**4.)/(4.*Mst1**2.)+

     &  (119*Mgl**7.*Mst1**2.*Mt**4.)/576.+

     &  (Mgl**5.*Mst1**4.*Mt**4.)/1152.-

     &  (7*Mgl**3.*Mst1**6.*Mt**4.)/32.-

     &  (55*Mgl*Mst1**8.*Mt**4.)/128.+

     &  (199*Mst1**10.*Mt**4.)/(576.*Mgl**1.)+

     &  (23*Mst1**12.*Mt**4.)/(1152.*Mgl**3.)-

     &  (91*Mgl**7.*Mt**6.)/576.+

     &  (11*Mgl**11.*Mt**6.)/(144.*Mst1**4.)-

     &  (7*Mgl**9.*Mt**6.)/(72.*Mst1**2.)+

     &  (175*Mgl**5.*Mst1**2.*Mt**6.)/576.+

     &  (37*Mgl**3.*Mst1**4.*Mt**6.)/96.-

     &  (Mgl*Mst1**6.*Mt**6.)/288.-

     &  (199*Mst1**8.*Mt**6.)/(576.*Mgl**1.)+

     &  (Mst1**10.*Mt**6.)/(192.*Mgl**3.)+

     &  (1681*Mgl**5.*Mt**8.)/1152.-

     &  (17*Mgl**9.*Mt**8.)/(144.*Mst1**4.)+

     &  (41*Mgl**7.*Mt**8.)/(36.*Mst1**2.)+

     &  (61*Mgl**3.*Mst1**2.*Mt**8.)/288.+

     &  (103*Mgl*Mst1**4.*Mt**8.)/576.-

     &  (95*Mst1**6.*Mt**8.)/(288.*Mgl**1.)-

     &  (95*Mst1**8.*Mt**8.)/(1152.*Mgl**3.)-

     &  (601*Mgl**3.*Mt**10.)/288.+

     &  (23*Mgl**7.*Mt**10.)/(144.*Mst1**4.)-

     &  (113*Mgl**5.*Mt**10.)/(72.*Mst1**2.)-

     &  (49*Mgl*Mst1**2.*Mt**10.)/96.+

     &  (247*Mst1**4.*Mt**10.)/(288.*Mgl**1.)+

     &  (35*Mst1**6.*Mt**10.)/(288.*Mgl**3.)+

     &  (721*Mgl*Mt**12.)/1152.-

     &  (23*Mgl**5.*Mt**12.)/(144.*Mst1**4.)+

     &  (31*Mgl**3.*Mt**12.)/(36.*Mst1**2.)-

     &  (329*Mst1**2.*Mt**12.)/(576.*Mgl**1.)-

     &  (29*Mst1**4.*Mt**12.)/(384.*Mgl**3.)+

     &  (73*Mt**14.)/(576.*Mgl**1.)+

     &  (13*Mgl**3.*Mt**14.)/(144.*Mst1**4.)-

     &  (Mgl*Mt**14.)/(6.*Mst1**2.)+

     &  (11*Mst1**2.*Mt**14.)/(576.*Mgl**3.)-

     &  Mt**16./(1152.*Mgl**3.)-

     &  (Mgl*Mt**16.)/(48.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((19*Mgl**15.*Mt**2.)/96.-

     &  (Mgl**19.*Mt**2.)/(144.*Mst1**4.)-

     &  (5*Mgl**17.*Mt**2.)/(288.*Mst1**2.)-

     &  (55*Mgl**13.*Mst1**2.*Mt**2.)/144.+

     &  (Mgl**11.*Mst1**4.*Mt**2.)/24.+

     &  (91*Mgl**9.*Mst1**6.*Mt**2.)/144.-

     &  (91*Mgl**7.*Mst1**8.*Mt**2.)/144.-

     &  (Mgl**5.*Mst1**10.*Mt**2.)/24.+

     &  (55*Mgl**3.*Mst1**12.*Mt**2.)/144.-

     &  (19*Mgl*Mst1**14.*Mt**2.)/96.+

     &  (5*Mst1**16.*Mt**2.)/(288.*Mgl**1.)+

     &  (Mst1**18.*Mt**2.)/(144.*Mgl**3.)-

     &  (83*Mgl**13.*Mt**4.)/144.+

     &  (Mgl**17.*Mt**4.)/(18.*Mst1**4.)+

     &  (19*Mgl**15.*Mt**4.)/(192.*Mst1**2.)+

     &  (19*Mgl**11.*Mst1**2.*Mt**4.)/144.+

     &  (27*Mgl**9.*Mst1**4.*Mt**4.)/32.-

     &  (7*Mgl**7.*Mst1**6.*Mt**4.)/96.-

     &  (83*Mgl**5.*Mst1**8.*Mt**4.)/96.-

     &  (Mgl**3.*Mst1**10.*Mt**4.)/144.+

     &  (169*Mgl*Mst1**12.*Mt**4.)/288.-

     &  (29*Mst1**14.*Mt**4.)/(192.*Mgl**1.)-

     &  (13*Mst1**16.*Mt**4.)/(288.*Mgl**3.)+

     &  (101*Mgl**11.*Mt**6.)/192.-

     &  (19*Mgl**15.*Mt**6.)/(96.*Mst1**4.)-

     &  (77*Mgl**13.*Mt**6.)/(576.*Mst1**2.)+

     &  (149*Mgl**9.*Mst1**2.*Mt**6.)/576.-

     &  (349*Mgl**7.*Mst1**4.*Mt**6.)/576.+

     &  (491*Mgl**5.*Mst1**6.*Mt**6.)/576.-

     &  (43*Mgl**3.*Mst1**8.*Mt**6.)/64.-

     &  (115*Mgl*Mst1**10.*Mt**6.)/192.+

     &  (259*Mst1**12.*Mt**6.)/(576.*Mgl**1.)+

     &  (35*Mst1**14.*Mt**6.)/(288.*Mgl**3.)-

     &  (149*Mgl**9.*Mt**8.)/144.+

     &  (41*Mgl**13.*Mt**8.)/(96.*Mst1**4.)-

     &  (55*Mgl**11.*Mt**8.)/(192.*Mst1**2.)+

     &  (269*Mgl**7.*Mst1**2.*Mt**8.)/576.+

     &  (83*Mgl**5.*Mst1**4.*Mt**8.)/144.+

     &  (541*Mgl**3.*Mst1**6.*Mt**8.)/576.+

     &  (5*Mgl*Mst1**8.*Mt**8.)/16.-

     &  (325*Mst1**10.*Mt**8.)/(576.*Mgl**1.)-

     &  (49*Mst1**12.*Mt**8.)/(288.*Mgl**3.)+

     &  (1933*Mgl**7.*Mt**10.)/576.-

     &  (185*Mgl**11.*Mt**10.)/(288.*Mst1**4.)+

     &  (215*Mgl**9.*Mt**10.)/(192.*Mst1**2.)+

     &  (7*Mgl**5.*Mst1**2.*Mt**10.)/6.+

     &  (5*Mgl**3.*Mst1**4.*Mt**10.)/72.+

     &  (61*Mgl*Mst1**6.*Mt**10.)/576.+

     &  (85*Mst1**8.*Mt**10.)/(576.*Mgl**1.)+

     &  (35*Mst1**10.*Mt**10.)/(288.*Mgl**3.)-

     &  (655*Mgl**5.*Mt**12.)/144.+

     &  (23*Mgl**9.*Mt**12.)/(32.*Mst1**4.)-

     &  (275*Mgl**7.*Mt**12.)/(192.*Mst1**2.)-

     &  (95*Mgl**3.*Mst1**2.*Mt**12.)/32.-

     &  (131*Mgl*Mst1**4.*Mt**12.)/144.+

     &  (215*Mst1**6.*Mt**12.)/(576.*Mgl**1.)-

     &  (7*Mst1**8.*Mt**12.)/(288.*Mgl**3.)+

     &  (1489*Mgl**3.*Mt**14.)/576.-

     &  (19*Mgl**7.*Mt**14.)/(32.*Mst1**4.)+

     &  (493*Mgl**5.*Mt**14.)/(576.*Mst1**2.)+

     &  (665*Mgl*Mst1**2.*Mt**14.)/576.-

     &  (27*Mst1**4.*Mt**14.)/(64.*Mgl**1.)-

     &  (7*Mst1**6.*Mt**14.)/(288.*Mgl**3.)-

     &  (23*Mgl*Mt**16.)/48.+

     &  (97*Mgl**5.*Mt**16.)/(288.*Mst1**4.)-

     &  (41*Mgl**3.*Mt**16.)/(192.*Mst1**2.)+

     &  (101*Mst1**2.*Mt**16.)/(576.*Mgl**1.)+

     &  (5*Mst1**4.*Mt**16.)/(288.*Mgl**3.)-

     &  (5*Mt**18.)/(192.*Mgl**1.)-

     &  (11*Mgl**3.*Mt**18.)/(96.*Mst1**4.)+

     &  (5*Mgl*Mt**18.)/(576.*Mst1**2.)-

     &  (Mst1**2.*Mt**18.)/(288.*Mgl**3.)+

     &  (5*Mgl*Mt**20.)/(288.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  (-(Mgl**3.*Mt**2.)/32.+

     &  (Mgl**7.*Mt**2.)/(144.*Mst2**4.)-

     &  (7*Mgl**5.*Mt**2.)/(288.*Mst2**2.)+

     &  (Mgl*Mst2**2.*Mt**2.)/32.+

     &  (7*Mst2**4.*Mt**2.)/(288.*Mgl**1.)-

     &  (Mst2**6.*Mt**2.)/(144.*Mgl**3.)+

     &  (475*Mgl*Mt**4.)/1152.-

     &  (Mgl**5.*Mt**4.)/(48.*Mst2**4.)+

     &  (Mgl**3.*Mt**4.)/(96.*Mst2**2.)+

     &  (37*Mst2**2.*Mt**4.)/(288.*Mgl**1.)+

     &  (17*Mst2**4.*Mt**4.)/(1152.*Mgl**3.)-

     &  (43*Mt**6.)/(288.*Mgl**1.)+

     &  (Mgl**3.*Mt**6.)/(48.*Mst2**4.)+

     &  (Mgl*Mt**6.)/(72.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**6.)/(576.*Mgl**3.)+

     &  Mt**8./(1152.*Mgl**3.)-

     &  (Mgl*Mt**8.)/(144.*Mst2**4.))*Xt*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((-19*Mgl**7.*Mt**2.)/144.-

     &  (Mgl**11.*Mt**2.)/(144.*Mst2**4.)+

     &  (Mgl**9.*Mt**2.)/(12.*Mst2**2.)+

     &  (13*Mgl**5.*Mst2**2.*Mt**2.)/144.-

     &  (31*Mgl**3.*Mst2**4.*Mt**2.)/144.+

     &  (23*Mgl*Mst2**6.*Mt**2.)/72.-

     &  (7*Mst2**8.*Mt**2.)/(48.*Mgl**1.)+

     &  (Mst2**10.*Mt**2.)/(144.*Mgl**3.)-

     &  (43*Mgl**5.*Mt**4.)/192.+

     &  (Mgl**9.*Mt**4.)/(24.*Mst2**4.)-

     &  (49*Mgl**7.*Mt**4.)/(576.*Mst2**2.)+

     &  (83*Mgl**3.*Mst2**2.*Mt**4.)/576.-

     &  (41*Mgl*Mst2**4.*Mt**4.)/576.+

     &  (67*Mst2**6.*Mt**4.)/(288.*Mgl**1.)-

     &  (11*Mst2**8.*Mt**4.)/(288.*Mgl**3.)+

     &  (137*Mgl**3.*Mt**6.)/288.-

     &  (25*Mgl**7.*Mt**6.)/(288.*Mst2**4.)-

     &  (49*Mgl**5.*Mt**6.)/(192.*Mst2**2.)+

     &  (383*Mgl*Mst2**2.*Mt**6.)/576.+

     &  (49*Mst2**4.*Mt**6.)/(288.*Mgl**1.)+

     &  (7*Mst2**6.*Mt**6.)/(96.*Mgl**3.)-

     &  (179*Mgl*Mt**8.)/576.+

     &  (23*Mgl**5.*Mt**8.)/(288.*Mst2**4.)+

     &  (27*Mgl**3.*Mt**8.)/(64.*Mst2**2.)-

     &  (4*Mst2**2.*Mt**8.)/(9.*Mgl**1.)-

     &  (17*Mst2**4.*Mt**8.)/(288.*Mgl**3.)+

     &  (3*Mt**10.)/(16.*Mgl**1.)-

     &  (Mgl**3.*Mt**10.)/(32.*Mst2**4.)-

     &  (95*Mgl*Mt**10.)/(576.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**10.)/(288.*Mgl**3.)+

     &  (Mgl*Mt**12.)/(288.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((47*Mgl**11.*Mt**2.)/144.-

     &  (Mgl**15.*Mt**2.)/(144.*Mst2**4.)-

     &  (Mgl**13.*Mt**2.)/(12.*Mst2**2.)-

     &  (37*Mgl**9.*Mst2**2.*Mt**2.)/144.-

     &  (31*Mgl**7.*Mst2**4.*Mt**2.)/144.+

     &  (31*Mgl**5.*Mst2**6.*Mt**2.)/144.+

     &  (37*Mgl**3.*Mst2**8.*Mt**2.)/144.-

     &  (47*Mgl*Mst2**10.*Mt**2.)/144.+

     &  (Mst2**12.*Mt**2.)/(12.*Mgl**1.)+

     &  (Mst2**14.*Mt**2.)/(144.*Mgl**3.)-

     &  (415*Mgl**9.*Mt**4.)/1152.+

     &  (5*Mgl**13.*Mt**4.)/(144.*Mst2**4.)+

     &  (Mgl**11.*Mt**4.)/(4.*Mst2**2.)-

     &  (119*Mgl**7.*Mst2**2.*Mt**4.)/576.-

     &  (Mgl**5.*Mst2**4.*Mt**4.)/1152.+

     &  (7*Mgl**3.*Mst2**6.*Mt**4.)/32.+

     &  (55*Mgl*Mst2**8.*Mt**4.)/128.-

     &  (199*Mst2**10.*Mt**4.)/(576.*Mgl**1.)-

     &  (23*Mst2**12.*Mt**4.)/(1152.*Mgl**3.)+

     &  (91*Mgl**7.*Mt**6.)/576.-

     &  (11*Mgl**11.*Mt**6.)/(144.*Mst2**4.)+

     &  (7*Mgl**9.*Mt**6.)/(72.*Mst2**2.)-

     &  (175*Mgl**5.*Mst2**2.*Mt**6.)/576.-

     &  (37*Mgl**3.*Mst2**4.*Mt**6.)/96.+

     &  (Mgl*Mst2**6.*Mt**6.)/288.+

     &  (199*Mst2**8.*Mt**6.)/(576.*Mgl**1.)-

     &  (Mst2**10.*Mt**6.)/(192.*Mgl**3.)-

     &  (1681*Mgl**5.*Mt**8.)/1152.+

     &  (17*Mgl**9.*Mt**8.)/(144.*Mst2**4.)-

     &  (41*Mgl**7.*Mt**8.)/(36.*Mst2**2.)-

     &  (61*Mgl**3.*Mst2**2.*Mt**8.)/288.-

     &  (103*Mgl*Mst2**4.*Mt**8.)/576.+

     &  (95*Mst2**6.*Mt**8.)/(288.*Mgl**1.)+

     &  (95*Mst2**8.*Mt**8.)/(1152.*Mgl**3.)+

     &  (601*Mgl**3.*Mt**10.)/288.-

     &  (23*Mgl**7.*Mt**10.)/(144.*Mst2**4.)+

     &  (113*Mgl**5.*Mt**10.)/(72.*Mst2**2.)+

     &  (49*Mgl*Mst2**2.*Mt**10.)/96.-

     &  (247*Mst2**4.*Mt**10.)/(288.*Mgl**1.)-

     &  (35*Mst2**6.*Mt**10.)/(288.*Mgl**3.)-

     &  (721*Mgl*Mt**12.)/1152.+

     &  (23*Mgl**5.*Mt**12.)/(144.*Mst2**4.)-

     &  (31*Mgl**3.*Mt**12.)/(36.*Mst2**2.)+

     &  (329*Mst2**2.*Mt**12.)/(576.*Mgl**1.)+

     &  (29*Mst2**4.*Mt**12.)/(384.*Mgl**3.)-

     &  (73*Mt**14.)/(576.*Mgl**1.)-

     &  (13*Mgl**3.*Mt**14.)/(144.*Mst2**4.)+

     &  (Mgl*Mt**14.)/(6.*Mst2**2.)-

     &  (11*Mst2**2.*Mt**14.)/(576.*Mgl**3.)+

     &  Mt**16./(1152.*Mgl**3.)+

     &  (Mgl*Mt**16.)/(48.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  ((-19*Mgl**15.*Mt**2.)/96.+

     &  (Mgl**19.*Mt**2.)/(144.*Mst2**4.)+

     &  (5*Mgl**17.*Mt**2.)/(288.*Mst2**2.)+

     &  (55*Mgl**13.*Mst2**2.*Mt**2.)/144.-

     &  (Mgl**11.*Mst2**4.*Mt**2.)/24.-

     &  (91*Mgl**9.*Mst2**6.*Mt**2.)/144.+

     &  (91*Mgl**7.*Mst2**8.*Mt**2.)/144.+

     &  (Mgl**5.*Mst2**10.*Mt**2.)/24.-

     &  (55*Mgl**3.*Mst2**12.*Mt**2.)/144.+

     &  (19*Mgl*Mst2**14.*Mt**2.)/96.-

     &  (5*Mst2**16.*Mt**2.)/(288.*Mgl**1.)-

     &  (Mst2**18.*Mt**2.)/(144.*Mgl**3.)+

     &  (83*Mgl**13.*Mt**4.)/144.-

     &  (Mgl**17.*Mt**4.)/(18.*Mst2**4.)-

     &  (19*Mgl**15.*Mt**4.)/(192.*Mst2**2.)-

     &  (19*Mgl**11.*Mst2**2.*Mt**4.)/144.-

     &  (27*Mgl**9.*Mst2**4.*Mt**4.)/32.+

     &  (7*Mgl**7.*Mst2**6.*Mt**4.)/96.+

     &  (83*Mgl**5.*Mst2**8.*Mt**4.)/96.+

     &  (Mgl**3.*Mst2**10.*Mt**4.)/144.-

     &  (169*Mgl*Mst2**12.*Mt**4.)/288.+

     &  (29*Mst2**14.*Mt**4.)/(192.*Mgl**1.)+

     &  (13*Mst2**16.*Mt**4.)/(288.*Mgl**3.)-

     &  (101*Mgl**11.*Mt**6.)/192.+

     &  (19*Mgl**15.*Mt**6.)/(96.*Mst2**4.)+

     &  (77*Mgl**13.*Mt**6.)/(576.*Mst2**2.)-

     &  (149*Mgl**9.*Mst2**2.*Mt**6.)/576.+

     &  (349*Mgl**7.*Mst2**4.*Mt**6.)/576.-

     &  (491*Mgl**5.*Mst2**6.*Mt**6.)/576.+

     &  (43*Mgl**3.*Mst2**8.*Mt**6.)/64.+

     &  (115*Mgl*Mst2**10.*Mt**6.)/192.-

     &  (259*Mst2**12.*Mt**6.)/(576.*Mgl**1.)-

     &  (35*Mst2**14.*Mt**6.)/(288.*Mgl**3.)+

     &  (149*Mgl**9.*Mt**8.)/144.-

     &  (41*Mgl**13.*Mt**8.)/(96.*Mst2**4.)+

     &  (55*Mgl**11.*Mt**8.)/(192.*Mst2**2.)-

     &  (269*Mgl**7.*Mst2**2.*Mt**8.)/576.-

     &  (83*Mgl**5.*Mst2**4.*Mt**8.)/144.-

     &  (541*Mgl**3.*Mst2**6.*Mt**8.)/576.-

     &  (5*Mgl*Mst2**8.*Mt**8.)/16.+

     &  (325*Mst2**10.*Mt**8.)/(576.*Mgl**1.)+

     &  (49*Mst2**12.*Mt**8.)/(288.*Mgl**3.)-

     &  (1933*Mgl**7.*Mt**10.)/576.+

     &  (185*Mgl**11.*Mt**10.)/(288.*Mst2**4.)-

     &  (215*Mgl**9.*Mt**10.)/(192.*Mst2**2.)-

     &  (7*Mgl**5.*Mst2**2.*Mt**10.)/6.-

     &  (5*Mgl**3.*Mst2**4.*Mt**10.)/72.-

     &  (61*Mgl*Mst2**6.*Mt**10.)/576.-

     &  (85*Mst2**8.*Mt**10.)/(576.*Mgl**1.)-

     &  (35*Mst2**10.*Mt**10.)/(288.*Mgl**3.)+

     &  (655*Mgl**5.*Mt**12.)/144.-

     &  (23*Mgl**9.*Mt**12.)/(32.*Mst2**4.)+

     &  (275*Mgl**7.*Mt**12.)/(192.*Mst2**2.)+

     &  (95*Mgl**3.*Mst2**2.*Mt**12.)/32.+

     &  (131*Mgl*Mst2**4.*Mt**12.)/144.-

     &  (215*Mst2**6.*Mt**12.)/(576.*Mgl**1.)+

     &  (7*Mst2**8.*Mt**12.)/(288.*Mgl**3.)-

     &  (1489*Mgl**3.*Mt**14.)/576.+

     &  (19*Mgl**7.*Mt**14.)/(32.*Mst2**4.)-

     &  (493*Mgl**5.*Mt**14.)/(576.*Mst2**2.)-

     &  (665*Mgl*Mst2**2.*Mt**14.)/576.+

     &  (27*Mst2**4.*Mt**14.)/(64.*Mgl**1.)+

     &  (7*Mst2**6.*Mt**14.)/(288.*Mgl**3.)+

     &  (23*Mgl*Mt**16.)/48.-

     &  (97*Mgl**5.*Mt**16.)/(288.*Mst2**4.)+

     &  (41*Mgl**3.*Mt**16.)/(192.*Mst2**2.)-

     &  (101*Mst2**2.*Mt**16.)/(576.*Mgl**1.)-

     &  (5*Mst2**4.*Mt**16.)/(288.*Mgl**3.)+

     &  (5*Mt**18.)/(192.*Mgl**1.)+

     &  (11*Mgl**3.*Mt**18.)/(96.*Mst2**4.)-

     &  (5*Mgl*Mt**18.)/(576.*Mst2**2.)+

     &  (Mst2**2.*Mt**18.)/(288.*Mgl**3.)-

     &  (5*Mgl*Mt**20.)/(288.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*ln(mu,Mt)**2.+

     &  (-5/(1152.*Mgl**2.)-Mst1**2./(1152.*Mgl**4.)+

     &  Mt**2./(1152.*Mgl**4.))*Tfin(Mt,Mgl,Mst1)+

     &  ((-13*Mgl**2.)/1152.-Mgl**4./(144.*Mst1**2.)-

     &  (19*Mst1**2.)/1152.-

     &  (13*Mst1**4.)/(1152.*Mgl**2.)+

     &  (5*Mst1**6.)/(1152.*Mgl**4.)-(109*Mt**2.)/1152.+

     &  (7*Mst1**2.*Mt**2.)/(576.*Mgl**2.)-

     &  (5*Mst1**4.*Mt**2.)/(384.*Mgl**4.)-

     &  Mt**4./(1152.*Mgl**2.)+Mt**4./(144.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**4.)/(384.*Mgl**4.)-

     &  (5*Mt**6.)/(1152.*Mgl**4.))*d123(Mt,Mgl,Mst1)*

     &  Tfin(Mt,Mgl,Mst1)+

     &  (-Mgl**6./72.+Mgl**10./(288.*Mst1**4.)+

     &  Mgl**8./(384.*Mst1**2.)+

     &  (7*Mgl**4.*Mst1**2.)/1152.+

     &  (Mgl**2.*Mst1**4.)/48.-(47*Mst1**6.)/1152.+

     &  (7*Mst1**8.)/(288.*Mgl**2.)-

     &  Mst1**10./(384.*Mgl**4.)+

     &  (5*Mgl**4.*Mt**2.)/1152.-

     &  (Mgl**8.*Mt**2.)/(192.*Mst1**4.)-

     &  (5*Mgl**6.*Mt**2.)/(576.*Mst1**2.)-

     &  (Mgl**2.*Mst1**2.*Mt**2.)/6.+

     &  (7*Mst1**4.*Mt**2.)/48.-

     &  (11*Mst1**6.*Mt**2.)/(192.*Mgl**2.)+

     &  (7*Mst1**8.*Mt**2.)/(384.*Mgl**4.)-

     &  (5*Mgl**2.*Mt**4.)/96.-

     &  (Mgl**6.*Mt**4.)/(288.*Mst1**4.)-

     &  (Mgl**4.*Mt**4.)/(192.*Mst1**2.)-

     &  (19*Mst1**2.*Mt**4.)/96.+

     &  (Mst1**4.*Mt**4.)/(48.*Mgl**2.)-

     &  (3*Mst1**6.*Mt**4.)/(64.*Mgl**4.)+

     &  (19*Mt**6.)/192.+

     &  (Mgl**4.*Mt**6.)/(144.*Mst1**4.)+

     &  (Mgl**2.*Mt**6.)/(64.*Mst1**2.)+

     &  (19*Mst1**2.*Mt**6.)/(576.*Mgl**2.)+

     &  (11*Mst1**4.*Mt**6.)/(192.*Mgl**4.)-

     &  Mt**8./(48.*Mgl**2.)-

     &  (5*Mt**8.)/(1152.*Mst1**2.)-

     &  (13*Mst1**2.*Mt**8.)/(384.*Mgl**4.)+

     &  Mt**10./(128.*Mgl**4.)-Mt**10./(576.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**2.*Tfin(Mt,Mgl,Mst1)+

     &  ((-5*Mgl**10.)/128.-Mgl**14./(144.*Mst1**4.)+

     &  Mgl**12./(64.*Mst1**2.)+

     &  (101*Mgl**8.*Mst1**2.)/1152.-

     &  (17*Mgl**6.*Mst1**4.)/384.-

     &  (31*Mgl**4.*Mst1**6.)/384.+

     &  (101*Mgl**2.*Mst1**8.)/1152.-(7*Mst1**10.)/384.+

     &  Mst1**12./(384.*Mgl**2.)-

     &  (5*Mst1**14.)/(1152.*Mgl**4.)-

     &  (43*Mgl**8.*Mt**2.)/1152.+

     &  (Mgl**12.*Mt**2.)/(36.*Mst1**4.)-

     &  (Mgl**10.*Mt**2.)/(48.*Mst1**2.)+

     &  (55*Mgl**6.*Mst1**2.*Mt**2.)/576.-

     &  (139*Mgl**4.*Mst1**4.*Mt**2.)/1152.+

     &  (7*Mgl**2.*Mst1**6.*Mt**2.)/96.-

     &  (11*Mst1**8.*Mt**2.)/384.-

     &  (5*Mst1**10.*Mt**2.)/(576.*Mgl**2.)+

     &  (23*Mst1**12.*Mt**2.)/(1152.*Mgl**4.)+

     &  (47*Mgl**6.*Mt**4.)/384.-

     &  (Mgl**10.*Mt**4.)/(36.*Mst1**4.)+

     &  (Mgl**8.*Mt**4.)/(576.*Mst1**2.)+

     &  (47*Mgl**4.*Mst1**2.*Mt**4.)/1152.+

     &  (19*Mgl**2.*Mst1**4.*Mt**4.)/192.+

     &  (5*Mst1**6.*Mt**4.)/36.+

     &  (49*Mst1**8.*Mt**4.)/(1152.*Mgl**2.)-

     &  (11*Mst1**10.*Mt**4.)/(384.*Mgl**4.)+

     &  (83*Mgl**4.*Mt**6.)/1152.-

     &  (Mgl**8.*Mt**6.)/(48.*Mst1**4.)-

     &  (5*Mgl**6.*Mt**6.)/(144.*Mst1**2.)-

     &  (17*Mgl**2.*Mst1**2.*Mt**6.)/288.-

     &  (17*Mst1**4.*Mt**6.)/192.-

     &  (13*Mst1**6.*Mt**6.)/(96.*Mgl**2.)-

     &  (5*Mst1**8.*Mt**6.)/(1152.*Mgl**4.)-

     &  (215*Mgl**2.*Mt**8.)/1152.+

     &  (7*Mgl**6.*Mt**8.)/(144.*Mst1**4.)+

     &  (31*Mgl**4.*Mt**8.)/(576.*Mst1**2.)-

     &  (41*Mst1**2.*Mt**8.)/1152.+

     &  (229*Mst1**4.*Mt**8.)/(1152.*Mgl**2.)+

     &  (65*Mst1**6.*Mt**8.)/(1152.*Mgl**4.)+

     &  (47*Mt**10.)/1152.-

     &  (Mgl**4.*Mt**10.)/(72.*Mst1**4.)-

     &  (77*Mst1**2.*Mt**10.)/(576.*Mgl**2.)-

     &  (25*Mst1**4.*Mt**10.)/(384.*Mgl**4.)+

     &  (13*Mt**12.)/(384.*Mgl**2.)-

     &  (Mgl**2.*Mt**12.)/(72.*Mst1**4.)-

     &  Mt**12./(64.*Mst1**2.)+

     &  (37*Mst1**2.*Mt**12.)/(1152.*Mgl**4.)-

     &  (7*Mt**14.)/(1152.*Mgl**4.)+

     &  Mt**14./(144.*Mst1**4.))*d123(Mt,Mgl,Mst1)**3.*

     &  Tfin(Mt,Mgl,Mst1)+

     &  ((7*Mgl**14.)/128.+Mgl**18./(288.*Mst1**4.)-

     &  (13*Mgl**16.)/(1152.*Mst1**2.)-

     &  (65*Mgl**12.*Mst1**2.)/288.+

     &  (59*Mgl**10.*Mst1**4.)/144.-

     &  (133*Mgl**8.*Mst1**6.)/576.-

     &  (133*Mgl**6.*Mst1**8.)/576.+

     &  (59*Mgl**4.*Mst1**10.)/144.-

     &  (65*Mgl**2.*Mst1**12.)/288.+(7*Mst1**14.)/128.-

     &  (13*Mst1**16.)/(1152.*Mgl**2.)+

     &  Mst1**18./(288.*Mgl**4.)-

     &  (29*Mgl**12.*Mt**2.)/576.-

     &  (13*Mgl**16.*Mt**2.)/(576.*Mst1**4.)+

     &  (7*Mgl**14.*Mt**2.)/(192.*Mst1**2.)+

     &  (Mgl**10.*Mst1**2.*Mt**2.)/9.-

     &  (3*Mgl**8.*Mst1**4.*Mt**2.)/32.+

     &  (5*Mgl**6.*Mst1**6.*Mt**2.)/24.-

     &  (19*Mgl**4.*Mst1**8.*Mt**2.)/36.+

     &  (23*Mgl**2.*Mst1**10.*Mt**2.)/48.-

     &  (97*Mst1**12.*Mt**2.)/576.+

     &  (31*Mst1**14.*Mt**2.)/(576.*Mgl**2.)-

     &  (5*Mst1**16.*Mt**2.)/(192.*Mgl**4.)-

     &  (29*Mgl**10.*Mt**4.)/96.+

     &  (5*Mgl**14.*Mt**4.)/(96.*Mst1**4.)-

     &  (Mgl**12.*Mt**4.)/(72.*Mst1**2.)+

     &  (17*Mgl**8.*Mst1**2.*Mt**4.)/36.-

     &  (37*Mgl**6.*Mst1**4.*Mt**4.)/144.+

     &  (5*Mgl**4.*Mst1**6.*Mt**4.)/18.-

     &  (107*Mgl**2.*Mst1**8.*Mt**4.)/288.+

     &  (11*Mst1**10.*Mt**4.)/72.-

     &  (3*Mst1**12.*Mt**4.)/(32.*Mgl**2.)+

     &  (Mst1**14.*Mt**4.)/(12.*Mgl**4.)+

     &  (5*Mgl**8.*Mt**6.)/8.-

     &  (11*Mgl**12.*Mt**6.)/(288.*Mst1**4.)-

     &  (19*Mgl**10.*Mt**6.)/(576.*Mst1**2.)-

     &  (193*Mgl**6.*Mst1**2.*Mt**6.)/576.-

     &  (17*Mgl**4.*Mst1**4.*Mt**6.)/96.+

     &  (79*Mgl**2.*Mst1**6.*Mt**6.)/576.-

     &  (7*Mst1**8.*Mt**6.)/72.+

     &  (37*Mst1**10.*Mt**6.)/(576.*Mgl**2.)-

     &  (7*Mst1**12.*Mt**6.)/(48.*Mgl**4.)-

     &  (61*Mgl**6.*Mt**8.)/192.-

     &  (11*Mgl**10.*Mt**8.)/(288.*Mst1**4.)-

     &  (25*Mgl**8.*Mt**8.)/(576.*Mst1**2.)+

     &  (23*Mgl**4.*Mst1**2.*Mt**8.)/72.+

     &  (109*Mgl**2.*Mst1**4.*Mt**8.)/288.+

     &  (181*Mst1**6.*Mt**8.)/576.-

     &  (5*Mst1**8.*Mt**8.)/(576.*Mgl**2.)+

     &  (7*Mst1**10.*Mt**8.)/(48.*Mgl**4.)-

     &  (2*Mgl**4.*Mt**10.)/9.+

     &  (Mgl**8.*Mt**10.)/(12.*Mst1**4.)+

     &  (79*Mgl**6.*Mt**10.)/(576.*Mst1**2.)-

     &  (205*Mgl**2.*Mst1**2.*Mt**10.)/288.-

     &  (37*Mst1**4.*Mt**10.)/72.+

     &  (Mst1**6.*Mt**10.)/(64.*Mgl**2.)-

     &  (7*Mst1**8.*Mt**10.)/(96.*Mgl**4.)+

     &  (31*Mgl**2.*Mt**12.)/96.-

     &  (11*Mgl**6.*Mt**12.)/(288.*Mst1**4.)-

     &  (Mgl**4.*Mt**12.)/(16.*Mst1**2.)+

     &  (25*Mst1**2.*Mt**12.)/72.-

     &  (13*Mst1**4.*Mt**12.)/(288.*Mgl**2.)-

     &  (5*Mt**14.)/48.-

     &  (5*Mgl**4.*Mt**14.)/(288.*Mst1**4.)-

     &  (17*Mgl**2.*Mt**14.)/(576.*Mst1**2.)+

     &  (19*Mst1**2.*Mt**14.)/(576.*Mgl**2.)+

     &  (Mst1**4.*Mt**14.)/(48.*Mgl**4.)-

     &  Mt**16./(128.*Mgl**2.)+

     &  (Mgl**2.*Mt**16.)/(48.*Mst1**4.)+

     &  (23*Mt**16.)/(1152.*Mst1**2.)-

     &  (Mst1**2.*Mt**16.)/(96.*Mgl**4.)+

     &  Mt**18./(576.*Mgl**4.)-Mt**18./(192.*Mst1**4.))*

     &  d123(Mt,Mgl,Mst1)**4.*Tfin(Mt,Mgl,Mst1)-

     &  (Mt**2.*Xt*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1))/

     &  (288.*Mgl**3.)+

     &  ((15*Mgl*Mt**2.)/64.+

     &  (Mgl**3.*Mt**2.)/(36.*Mst1**2.)-

     &  (Mst1**2.*Mt**2.)/(48.*Mgl**1.)+

     &  (5*Mst1**4.*Mt**2.)/(576.*Mgl**3.)+

     &  Mt**4./(48.*Mgl**1.)-

     &  (Mgl*Mt**4.)/(36.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**4.)/(288.*Mgl**3.)+

     &  (5*Mt**6.)/(576.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst1)*

     &  Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1)+

     &  (-(Mgl**5.*Mt**2.)/32.-

     &  (Mgl**9.*Mt**2.)/(72.*Mst1**4.)-

     &  (7*Mgl**7.*Mt**2.)/(288.*Mst1**2.)-

     &  (17*Mgl**3.*Mst1**2.*Mt**2.)/288.+

     &  (29*Mgl*Mst1**4.*Mt**2.)/288.+

     &  (Mst1**6.*Mt**2.)/(36.*Mgl**1.)+

     &  (37*Mgl**3.*Mt**4.)/144.+

     &  (5*Mgl**7.*Mt**4.)/(144.*Mst1**4.)+

     &  (3*Mgl**5.*Mt**4.)/(32.*Mst1**2.)+

     &  (257*Mgl*Mst1**2.*Mt**4.)/288.-

     &  (5*Mst1**4.*Mt**4.)/(144.*Mgl**1.)+

     &  (Mst1**6.*Mt**4.)/(48.*Mgl**3.)-

     &  (85*Mgl*Mt**6.)/288.-

     &  (Mgl**5.*Mt**6.)/(48.*Mst1**4.)-

     &  (3*Mgl**3.*Mt**6.)/(32.*Mst1**2.)-

     &  (5*Mst1**2.*Mt**6.)/(144.*Mgl**1.)-

     &  (Mst1**4.*Mt**6.)/(16.*Mgl**3.)+

     &  Mt**8./(24.*Mgl**1.)-

     &  (Mgl**3.*Mt**8.)/(144.*Mst1**4.)+

     &  (7*Mgl*Mt**8.)/(288.*Mst1**2.)+

     &  (Mst1**2.*Mt**8.)/(16.*Mgl**3.)-

     &  Mt**10./(48.*Mgl**3.)+

     &  (Mgl*Mt**10.)/(144.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**2.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1)

     &  +((25*Mgl**9.*Mt**2.)/576.+

     &  (Mgl**13.*Mt**2.)/(36.*Mst1**4.)-

     &  (5*Mgl**11.*Mt**2.)/(144.*Mst1**2.)-

     &  (25*Mgl**7.*Mst1**2.*Mt**2.)/288.-

     &  (13*Mgl**5.*Mst1**4.*Mt**2.)/576.+

     &  (Mgl**3.*Mst1**6.*Mt**2.)/9.-

     &  (17*Mgl*Mst1**8.*Mt**2.)/576.+

     &  (Mst1**10.*Mt**2.)/(96.*Mgl**1.)-

     &  (11*Mst1**12.*Mt**2.)/(576.*Mgl**3.)+

     &  (41*Mgl**7.*Mt**4.)/96.-

     &  (5*Mgl**11.*Mt**4.)/(36.*Mst1**4.)-

     &  (Mgl**9.*Mt**4.)/(48.*Mst1**2.)-

     &  (155*Mgl**5.*Mst1**2.*Mt**4.)/288.+

     &  (35*Mgl**3.*Mst1**4.*Mt**4.)/144.-

     &  (Mgl*Mst1**6.*Mt**4.)/24.-

     &  (Mst1**8.*Mt**4.)/(288.*Mgl**1.)+

     &  (7*Mst1**10.*Mt**4.)/(96.*Mgl**3.)-

     &  (77*Mgl**5.*Mt**6.)/64.+

     &  (Mgl**9.*Mt**6.)/(4.*Mst1**4.)+

     &  (19*Mgl**7.*Mt**6.)/(72.*Mst1**2.)+

     &  (11*Mgl**3.*Mst1**2.*Mt**6.)/144.-

     &  (19*Mgl*Mst1**4.*Mt**6.)/288.+

     &  (Mst1**6.*Mt**6.)/(16.*Mgl**1.)-

     &  (5*Mst1**8.*Mt**6.)/(64.*Mgl**3.)+

     &  (139*Mgl**3.*Mt**8.)/144.-

     &  (Mgl**7.*Mt**8.)/(6.*Mst1**4.)-

     &  (7*Mgl**5.*Mt**8.)/(24.*Mst1**2.)+

     &  (13*Mgl*Mst1**2.*Mt**8.)/48.-

     &  (13*Mst1**4.*Mt**8.)/(48.*Mgl**1.)-

     &  (5*Mst1**6.*Mt**8.)/(144.*Mgl**3.)-

     &  (9*Mgl*Mt**10.)/64.-

     &  (Mgl**5.*Mt**10.)/(36.*Mst1**4.)+

     &  (7*Mgl**3.*Mt**10.)/(144.*Mst1**2.)+

     &  (91*Mst1**2.*Mt**10.)/(288.*Mgl**1.)+

     &  (25*Mst1**4.*Mt**10.)/(192.*Mgl**3.)-

     &  (11*Mt**12.)/(96.*Mgl**1.)+

     &  (Mgl**3.*Mt**12.)/(12.*Mst1**4.)+

     &  (5*Mgl*Mt**12.)/(144.*Mst1**2.)-

     &  (3*Mst1**2.*Mt**12.)/(32.*Mgl**3.)+

     &  (13*Mt**14.)/(576.*Mgl**3.)-

     &  (Mgl*Mt**14.)/(36.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**3.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1)

     &  +((-3*Mgl**13.*Mt**2.)/16.-

     &  (Mgl**17.*Mt**2.)/(72.*Mst1**4.)+

     &  (Mgl**15.*Mt**2.)/(32.*Mst1**2.)+

     &  (103*Mgl**11.*Mst1**2.*Mt**2.)/144.-

     &  (133*Mgl**9.*Mst1**4.*Mt**2.)/144.+

     &  (133*Mgl**5.*Mst1**8.*Mt**2.)/144.-

     &  (103*Mgl**3.*Mst1**10.*Mt**2.)/144.+

     &  (3*Mgl*Mst1**12.*Mt**2.)/16.-

     &  (Mst1**14.*Mt**2.)/(32.*Mgl**1.)+

     &  (Mst1**16.*Mt**2.)/(72.*Mgl**3.)+

     &  (91*Mgl**11.*Mt**4.)/288.+

     &  (5*Mgl**15.*Mt**4.)/(48.*Mst1**4.)-

     &  (7*Mgl**13.*Mt**4.)/(96.*Mst1**2.)-

     &  (27*Mgl**9.*Mst1**2.*Mt**4.)/32.+

     &  (131*Mgl**7.*Mst1**4.*Mt**4.)/288.-

     &  (109*Mgl**5.*Mst1**6.*Mt**4.)/288.+

     &  (233*Mgl**3.*Mst1**8.*Mt**4.)/288.-

     &  (113*Mgl*Mst1**10.*Mt**4.)/288.+

     &  (3*Mst1**12.*Mt**4.)/(32.*Mgl**1.)-

     &  (13*Mst1**14.*Mt**4.)/(144.*Mgl**3.)+

     &  (17*Mgl**9.*Mt**6.)/24.-

     &  (5*Mgl**13.*Mt**6.)/(16.*Mst1**4.)-

     &  (53*Mgl**11.*Mt**6.)/(288.*Mst1**2.)-

     &  (97*Mgl**7.*Mst1**2.*Mt**6.)/288.+

     &  (17*Mgl**5.*Mst1**4.*Mt**6.)/72.-

     &  (143*Mgl**3.*Mst1**6.*Mt**6.)/288.+

     &  (13*Mgl*Mst1**8.*Mt**6.)/72.-

     &  (11*Mst1**10.*Mt**6.)/(288.*Mgl**1.)+

     &  (35*Mst1**12.*Mt**6.)/(144.*Mgl**3.)-

     &  (233*Mgl**7.*Mt**8.)/96.+

     &  (67*Mgl**11.*Mt**8.)/(144.*Mst1**4.)+

     &  (25*Mgl**9.*Mt**8.)/(32.*Mst1**2.)-

     &  (3*Mgl**5.*Mst1**2.*Mt**8.)/4.-

     &  (5*Mgl**3.*Mst1**4.*Mt**8.)/18.-

     &  (95*Mgl*Mst1**6.*Mt**8.)/288.-

     &  (35*Mst1**8.*Mt**8.)/(288.*Mgl**1.)-

     &  (49*Mst1**10.*Mt**8.)/(144.*Mgl**3.)+

     &  (25*Mgl**5.*Mt**10.)/9.-

     &  (5*Mgl**9.*Mt**10.)/(16.*Mst1**4.)-

     &  (265*Mgl**7.*Mt**10.)/(288.*Mst1**2.)+

     &  (9*Mgl**3.*Mst1**2.*Mt**10.)/4.+

     &  (73*Mgl*Mst1**4.*Mt**10.)/72.+

     &  (25*Mst1**6.*Mt**10.)/(288.*Mgl**1.)+

     &  (35*Mst1**8.*Mt**10.)/(144.*Mgl**3.)-

     &  (443*Mgl**3.*Mt**12.)/288.-

     &  (Mgl**7.*Mt**12.)/(48.*Mst1**4.)+

     &  (101*Mgl**5.*Mt**12.)/(288.*Mst1**2.)-

     &  (271*Mgl*Mst1**2.*Mt**12.)/288.+

     &  (29*Mst1**4.*Mt**12.)/(288.*Mgl**1.)-

     &  (7*Mst1**6.*Mt**12.)/(144.*Mgl**3.)+

     &  (23*Mgl*Mt**14.)/72.+

     &  (25*Mgl**5.*Mt**14.)/(144.*Mst1**4.)+

     &  (7*Mgl**3.*Mt**14.)/(96.*Mst1**2.)-

     &  (37*Mst1**2.*Mt**14.)/(288.*Mgl**1.)-

     &  (7*Mst1**4.*Mt**14.)/(144.*Mgl**3.)+

     &  (11*Mt**16.)/(288.*Mgl**1.)-

     &  (5*Mgl**3.*Mt**16.)/(48.*Mst1**4.)-

     &  (17*Mgl*Mt**16.)/(288.*Mst1**2.)+

     &  (5*Mst1**2.*Mt**16.)/(144.*Mgl**3.)-

     &  Mt**18./(144.*Mgl**3.)+

     &  (Mgl*Mt**18.)/(48.*Mst1**4.))*Xt*

     &  d123(Mt,Mgl,Mst1)**4.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst1)

     &  +(-5/(1152.*Mgl**2.)-Mst2**2./(1152.*Mgl**4.)+

     &  Mt**2./(1152.*Mgl**4.))*Tfin(Mt,Mgl,Mst2)+

     &  ((-13*Mgl**2.)/1152.-Mgl**4./(144.*Mst2**2.)-

     &  (19*Mst2**2.)/1152.-

     &  (13*Mst2**4.)/(1152.*Mgl**2.)+

     &  (5*Mst2**6.)/(1152.*Mgl**4.)-(109*Mt**2.)/1152.+

     &  (7*Mst2**2.*Mt**2.)/(576.*Mgl**2.)-

     &  (5*Mst2**4.*Mt**2.)/(384.*Mgl**4.)-

     &  Mt**4./(1152.*Mgl**2.)+Mt**4./(144.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**4.)/(384.*Mgl**4.)-

     &  (5*Mt**6.)/(1152.*Mgl**4.))*d123(Mt,Mgl,Mst2)*

     &  Tfin(Mt,Mgl,Mst2)+

     &  (-Mgl**6./72.+Mgl**10./(288.*Mst2**4.)+

     &  Mgl**8./(384.*Mst2**2.)+

     &  (7*Mgl**4.*Mst2**2.)/1152.+

     &  (Mgl**2.*Mst2**4.)/48.-(47*Mst2**6.)/1152.+

     &  (7*Mst2**8.)/(288.*Mgl**2.)-

     &  Mst2**10./(384.*Mgl**4.)+

     &  (5*Mgl**4.*Mt**2.)/1152.-

     &  (Mgl**8.*Mt**2.)/(192.*Mst2**4.)-

     &  (5*Mgl**6.*Mt**2.)/(576.*Mst2**2.)-

     &  (Mgl**2.*Mst2**2.*Mt**2.)/6.+

     &  (7*Mst2**4.*Mt**2.)/48.-

     &  (11*Mst2**6.*Mt**2.)/(192.*Mgl**2.)+

     &  (7*Mst2**8.*Mt**2.)/(384.*Mgl**4.)-

     &  (5*Mgl**2.*Mt**4.)/96.-

     &  (Mgl**6.*Mt**4.)/(288.*Mst2**4.)-

     &  (Mgl**4.*Mt**4.)/(192.*Mst2**2.)-

     &  (19*Mst2**2.*Mt**4.)/96.+

     &  (Mst2**4.*Mt**4.)/(48.*Mgl**2.)-

     &  (3*Mst2**6.*Mt**4.)/(64.*Mgl**4.)+

     &  (19*Mt**6.)/192.+

     &  (Mgl**4.*Mt**6.)/(144.*Mst2**4.)+

     &  (Mgl**2.*Mt**6.)/(64.*Mst2**2.)+

     &  (19*Mst2**2.*Mt**6.)/(576.*Mgl**2.)+

     &  (11*Mst2**4.*Mt**6.)/(192.*Mgl**4.)-

     &  Mt**8./(48.*Mgl**2.)-

     &  (5*Mt**8.)/(1152.*Mst2**2.)-

     &  (13*Mst2**2.*Mt**8.)/(384.*Mgl**4.)+

     &  Mt**10./(128.*Mgl**4.)-Mt**10./(576.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**2.*Tfin(Mt,Mgl,Mst2)+

     &  ((-5*Mgl**10.)/128.-Mgl**14./(144.*Mst2**4.)+

     &  Mgl**12./(64.*Mst2**2.)+

     &  (101*Mgl**8.*Mst2**2.)/1152.-

     &  (17*Mgl**6.*Mst2**4.)/384.-

     &  (31*Mgl**4.*Mst2**6.)/384.+

     &  (101*Mgl**2.*Mst2**8.)/1152.-(7*Mst2**10.)/384.+

     &  Mst2**12./(384.*Mgl**2.)-

     &  (5*Mst2**14.)/(1152.*Mgl**4.)-

     &  (43*Mgl**8.*Mt**2.)/1152.+

     &  (Mgl**12.*Mt**2.)/(36.*Mst2**4.)-

     &  (Mgl**10.*Mt**2.)/(48.*Mst2**2.)+

     &  (55*Mgl**6.*Mst2**2.*Mt**2.)/576.-

     &  (139*Mgl**4.*Mst2**4.*Mt**2.)/1152.+

     &  (7*Mgl**2.*Mst2**6.*Mt**2.)/96.-

     &  (11*Mst2**8.*Mt**2.)/384.-

     &  (5*Mst2**10.*Mt**2.)/(576.*Mgl**2.)+

     &  (23*Mst2**12.*Mt**2.)/(1152.*Mgl**4.)+

     &  (47*Mgl**6.*Mt**4.)/384.-

     &  (Mgl**10.*Mt**4.)/(36.*Mst2**4.)+

     &  (Mgl**8.*Mt**4.)/(576.*Mst2**2.)+

     &  (47*Mgl**4.*Mst2**2.*Mt**4.)/1152.+

     &  (19*Mgl**2.*Mst2**4.*Mt**4.)/192.+

     &  (5*Mst2**6.*Mt**4.)/36.+

     &  (49*Mst2**8.*Mt**4.)/(1152.*Mgl**2.)-

     &  (11*Mst2**10.*Mt**4.)/(384.*Mgl**4.)+

     &  (83*Mgl**4.*Mt**6.)/1152.-

     &  (Mgl**8.*Mt**6.)/(48.*Mst2**4.)-

     &  (5*Mgl**6.*Mt**6.)/(144.*Mst2**2.)-

     &  (17*Mgl**2.*Mst2**2.*Mt**6.)/288.-

     &  (17*Mst2**4.*Mt**6.)/192.-

     &  (13*Mst2**6.*Mt**6.)/(96.*Mgl**2.)-

     &  (5*Mst2**8.*Mt**6.)/(1152.*Mgl**4.)-

     &  (215*Mgl**2.*Mt**8.)/1152.+

     &  (7*Mgl**6.*Mt**8.)/(144.*Mst2**4.)+

     &  (31*Mgl**4.*Mt**8.)/(576.*Mst2**2.)-

     &  (41*Mst2**2.*Mt**8.)/1152.+

     &  (229*Mst2**4.*Mt**8.)/(1152.*Mgl**2.)+

     &  (65*Mst2**6.*Mt**8.)/(1152.*Mgl**4.)+

     &  (47*Mt**10.)/1152.-

     &  (Mgl**4.*Mt**10.)/(72.*Mst2**4.)-

     &  (77*Mst2**2.*Mt**10.)/(576.*Mgl**2.)-

     &  (25*Mst2**4.*Mt**10.)/(384.*Mgl**4.)+

     &  (13*Mt**12.)/(384.*Mgl**2.)-

     &  (Mgl**2.*Mt**12.)/(72.*Mst2**4.)-

     &  Mt**12./(64.*Mst2**2.)+

     &  (37*Mst2**2.*Mt**12.)/(1152.*Mgl**4.)-

     &  (7*Mt**14.)/(1152.*Mgl**4.)+

     &  Mt**14./(144.*Mst2**4.))*d123(Mt,Mgl,Mst2)**3.*

     &  Tfin(Mt,Mgl,Mst2)+

     &  ((7*Mgl**14.)/128.+Mgl**18./(288.*Mst2**4.)-

     &  (13*Mgl**16.)/(1152.*Mst2**2.)-

     &  (65*Mgl**12.*Mst2**2.)/288.+

     &  (59*Mgl**10.*Mst2**4.)/144.-

     &  (133*Mgl**8.*Mst2**6.)/576.-

     &  (133*Mgl**6.*Mst2**8.)/576.+

     &  (59*Mgl**4.*Mst2**10.)/144.-

     &  (65*Mgl**2.*Mst2**12.)/288.+(7*Mst2**14.)/128.-

     &  (13*Mst2**16.)/(1152.*Mgl**2.)+

     &  Mst2**18./(288.*Mgl**4.)-

     &  (29*Mgl**12.*Mt**2.)/576.-

     &  (13*Mgl**16.*Mt**2.)/(576.*Mst2**4.)+

     &  (7*Mgl**14.*Mt**2.)/(192.*Mst2**2.)+

     &  (Mgl**10.*Mst2**2.*Mt**2.)/9.-

     &  (3*Mgl**8.*Mst2**4.*Mt**2.)/32.+

     &  (5*Mgl**6.*Mst2**6.*Mt**2.)/24.-

     &  (19*Mgl**4.*Mst2**8.*Mt**2.)/36.+

     &  (23*Mgl**2.*Mst2**10.*Mt**2.)/48.-

     &  (97*Mst2**12.*Mt**2.)/576.+

     &  (31*Mst2**14.*Mt**2.)/(576.*Mgl**2.)-

     &  (5*Mst2**16.*Mt**2.)/(192.*Mgl**4.)-

     &  (29*Mgl**10.*Mt**4.)/96.+

     &  (5*Mgl**14.*Mt**4.)/(96.*Mst2**4.)-

     &  (Mgl**12.*Mt**4.)/(72.*Mst2**2.)+

     &  (17*Mgl**8.*Mst2**2.*Mt**4.)/36.-

     &  (37*Mgl**6.*Mst2**4.*Mt**4.)/144.+

     &  (5*Mgl**4.*Mst2**6.*Mt**4.)/18.-

     &  (107*Mgl**2.*Mst2**8.*Mt**4.)/288.+

     &  (11*Mst2**10.*Mt**4.)/72.-

     &  (3*Mst2**12.*Mt**4.)/(32.*Mgl**2.)+

     &  (Mst2**14.*Mt**4.)/(12.*Mgl**4.)+

     &  (5*Mgl**8.*Mt**6.)/8.-

     &  (11*Mgl**12.*Mt**6.)/(288.*Mst2**4.)-

     &  (19*Mgl**10.*Mt**6.)/(576.*Mst2**2.)-

     &  (193*Mgl**6.*Mst2**2.*Mt**6.)/576.-

     &  (17*Mgl**4.*Mst2**4.*Mt**6.)/96.+

     &  (79*Mgl**2.*Mst2**6.*Mt**6.)/576.-

     &  (7*Mst2**8.*Mt**6.)/72.+

     &  (37*Mst2**10.*Mt**6.)/(576.*Mgl**2.)-

     &  (7*Mst2**12.*Mt**6.)/(48.*Mgl**4.)-

     &  (61*Mgl**6.*Mt**8.)/192.-

     &  (11*Mgl**10.*Mt**8.)/(288.*Mst2**4.)-

     &  (25*Mgl**8.*Mt**8.)/(576.*Mst2**2.)+

     &  (23*Mgl**4.*Mst2**2.*Mt**8.)/72.+

     &  (109*Mgl**2.*Mst2**4.*Mt**8.)/288.+

     &  (181*Mst2**6.*Mt**8.)/576.-

     &  (5*Mst2**8.*Mt**8.)/(576.*Mgl**2.)+

     &  (7*Mst2**10.*Mt**8.)/(48.*Mgl**4.)-

     &  (2*Mgl**4.*Mt**10.)/9.+

     &  (Mgl**8.*Mt**10.)/(12.*Mst2**4.)+

     &  (79*Mgl**6.*Mt**10.)/(576.*Mst2**2.)-

     &  (205*Mgl**2.*Mst2**2.*Mt**10.)/288.-

     &  (37*Mst2**4.*Mt**10.)/72.+

     &  (Mst2**6.*Mt**10.)/(64.*Mgl**2.)-

     &  (7*Mst2**8.*Mt**10.)/(96.*Mgl**4.)+

     &  (31*Mgl**2.*Mt**12.)/96.-

     &  (11*Mgl**6.*Mt**12.)/(288.*Mst2**4.)-

     &  (Mgl**4.*Mt**12.)/(16.*Mst2**2.)+

     &  (25*Mst2**2.*Mt**12.)/72.-

     &  (13*Mst2**4.*Mt**12.)/(288.*Mgl**2.)-

     &  (5*Mt**14.)/48.-

     &  (5*Mgl**4.*Mt**14.)/(288.*Mst2**4.)-

     &  (17*Mgl**2.*Mt**14.)/(576.*Mst2**2.)+

     &  (19*Mst2**2.*Mt**14.)/(576.*Mgl**2.)+

     &  (Mst2**4.*Mt**14.)/(48.*Mgl**4.)-

     &  Mt**16./(128.*Mgl**2.)+

     &  (Mgl**2.*Mt**16.)/(48.*Mst2**4.)+

     &  (23*Mt**16.)/(1152.*Mst2**2.)-

     &  (Mst2**2.*Mt**16.)/(96.*Mgl**4.)+

     &  Mt**18./(576.*Mgl**4.)-Mt**18./(192.*Mst2**4.))*

     &  d123(Mt,Mgl,Mst2)**4.*Tfin(Mt,Mgl,Mst2)+

     &  (Mt**2.*Xt*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst2))/

     &  (288.*Mgl**3.)+

     &  ((-15*Mgl*Mt**2.)/64.-

     &  (Mgl**3.*Mt**2.)/(36.*Mst2**2.)+

     &  (Mst2**2.*Mt**2.)/(48.*Mgl**1.)-

     &  (5*Mst2**4.*Mt**2.)/(576.*Mgl**3.)-

     &  Mt**4./(48.*Mgl**1.)+

     &  (Mgl*Mt**4.)/(36.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**4.)/(288.*Mgl**3.)-

     &  (5*Mt**6.)/(576.*Mgl**3.))*Xt*d123(Mt,Mgl,Mst2)*

     &  Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst2)+

     &  ((Mgl**5.*Mt**2.)/32.+

     &  (Mgl**9.*Mt**2.)/(72.*Mst2**4.)+

     &  (7*Mgl**7.*Mt**2.)/(288.*Mst2**2.)+

     &  (17*Mgl**3.*Mst2**2.*Mt**2.)/288.-

     &  (29*Mgl*Mst2**4.*Mt**2.)/288.-

     &  (Mst2**6.*Mt**2.)/(36.*Mgl**1.)-

     &  (37*Mgl**3.*Mt**4.)/144.-

     &  (5*Mgl**7.*Mt**4.)/(144.*Mst2**4.)-

     &  (3*Mgl**5.*Mt**4.)/(32.*Mst2**2.)-

     &  (257*Mgl*Mst2**2.*Mt**4.)/288.+

     &  (5*Mst2**4.*Mt**4.)/(144.*Mgl**1.)-

     &  (Mst2**6.*Mt**4.)/(48.*Mgl**3.)+

     &  (85*Mgl*Mt**6.)/288.+

     &  (Mgl**5.*Mt**6.)/(48.*Mst2**4.)+

     &  (3*Mgl**3.*Mt**6.)/(32.*Mst2**2.)+

     &  (5*Mst2**2.*Mt**6.)/(144.*Mgl**1.)+

     &  (Mst2**4.*Mt**6.)/(16.*Mgl**3.)-

     &  Mt**8./(24.*Mgl**1.)+

     &  (Mgl**3.*Mt**8.)/(144.*Mst2**4.)-

     &  (7*Mgl*Mt**8.)/(288.*Mst2**2.)-

     &  (Mst2**2.*Mt**8.)/(16.*Mgl**3.)+

     &  Mt**10./(48.*Mgl**3.)-

     &  (Mgl*Mt**10.)/(144.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**2.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst2)

     &  +((-25*Mgl**9.*Mt**2.)/576.-

     &  (Mgl**13.*Mt**2.)/(36.*Mst2**4.)+

     &  (5*Mgl**11.*Mt**2.)/(144.*Mst2**2.)+

     &  (25*Mgl**7.*Mst2**2.*Mt**2.)/288.+

     &  (13*Mgl**5.*Mst2**4.*Mt**2.)/576.-

     &  (Mgl**3.*Mst2**6.*Mt**2.)/9.+

     &  (17*Mgl*Mst2**8.*Mt**2.)/576.-

     &  (Mst2**10.*Mt**2.)/(96.*Mgl**1.)+

     &  (11*Mst2**12.*Mt**2.)/(576.*Mgl**3.)-

     &  (41*Mgl**7.*Mt**4.)/96.+

     &  (5*Mgl**11.*Mt**4.)/(36.*Mst2**4.)+

     &  (Mgl**9.*Mt**4.)/(48.*Mst2**2.)+

     &  (155*Mgl**5.*Mst2**2.*Mt**4.)/288.-

     &  (35*Mgl**3.*Mst2**4.*Mt**4.)/144.+

     &  (Mgl*Mst2**6.*Mt**4.)/24.+

     &  (Mst2**8.*Mt**4.)/(288.*Mgl**1.)-

     &  (7*Mst2**10.*Mt**4.)/(96.*Mgl**3.)+

     &  (77*Mgl**5.*Mt**6.)/64.-

     &  (Mgl**9.*Mt**6.)/(4.*Mst2**4.)-

     &  (19*Mgl**7.*Mt**6.)/(72.*Mst2**2.)-

     &  (11*Mgl**3.*Mst2**2.*Mt**6.)/144.+

     &  (19*Mgl*Mst2**4.*Mt**6.)/288.-

     &  (Mst2**6.*Mt**6.)/(16.*Mgl**1.)+

     &  (5*Mst2**8.*Mt**6.)/(64.*Mgl**3.)-

     &  (139*Mgl**3.*Mt**8.)/144.+

     &  (Mgl**7.*Mt**8.)/(6.*Mst2**4.)+

     &  (7*Mgl**5.*Mt**8.)/(24.*Mst2**2.)-

     &  (13*Mgl*Mst2**2.*Mt**8.)/48.+

     &  (13*Mst2**4.*Mt**8.)/(48.*Mgl**1.)+

     &  (5*Mst2**6.*Mt**8.)/(144.*Mgl**3.)+

     &  (9*Mgl*Mt**10.)/64.+

     &  (Mgl**5.*Mt**10.)/(36.*Mst2**4.)-

     &  (7*Mgl**3.*Mt**10.)/(144.*Mst2**2.)-

     &  (91*Mst2**2.*Mt**10.)/(288.*Mgl**1.)-

     &  (25*Mst2**4.*Mt**10.)/(192.*Mgl**3.)+

     &  (11*Mt**12.)/(96.*Mgl**1.)-

     &  (Mgl**3.*Mt**12.)/(12.*Mst2**4.)-

     &  (5*Mgl*Mt**12.)/(144.*Mst2**2.)+

     &  (3*Mst2**2.*Mt**12.)/(32.*Mgl**3.)-

     &  (13*Mt**14.)/(576.*Mgl**3.)+

     &  (Mgl*Mt**14.)/(36.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**3.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst2)

     &  +((3*Mgl**13.*Mt**2.)/16.+

     &  (Mgl**17.*Mt**2.)/(72.*Mst2**4.)-

     &  (Mgl**15.*Mt**2.)/(32.*Mst2**2.)-

     &  (103*Mgl**11.*Mst2**2.*Mt**2.)/144.+

     &  (133*Mgl**9.*Mst2**4.*Mt**2.)/144.-

     &  (133*Mgl**5.*Mst2**8.*Mt**2.)/144.+

     &  (103*Mgl**3.*Mst2**10.*Mt**2.)/144.-

     &  (3*Mgl*Mst2**12.*Mt**2.)/16.+

     &  (Mst2**14.*Mt**2.)/(32.*Mgl**1.)-

     &  (Mst2**16.*Mt**2.)/(72.*Mgl**3.)-

     &  (91*Mgl**11.*Mt**4.)/288.-

     &  (5*Mgl**15.*Mt**4.)/(48.*Mst2**4.)+

     &  (7*Mgl**13.*Mt**4.)/(96.*Mst2**2.)+

     &  (27*Mgl**9.*Mst2**2.*Mt**4.)/32.-

     &  (131*Mgl**7.*Mst2**4.*Mt**4.)/288.+

     &  (109*Mgl**5.*Mst2**6.*Mt**4.)/288.-

     &  (233*Mgl**3.*Mst2**8.*Mt**4.)/288.+

     &  (113*Mgl*Mst2**10.*Mt**4.)/288.-

     &  (3*Mst2**12.*Mt**4.)/(32.*Mgl**1.)+

     &  (13*Mst2**14.*Mt**4.)/(144.*Mgl**3.)-

     &  (17*Mgl**9.*Mt**6.)/24.+

     &  (5*Mgl**13.*Mt**6.)/(16.*Mst2**4.)+

     &  (53*Mgl**11.*Mt**6.)/(288.*Mst2**2.)+

     &  (97*Mgl**7.*Mst2**2.*Mt**6.)/288.-

     &  (17*Mgl**5.*Mst2**4.*Mt**6.)/72.+

     &  (143*Mgl**3.*Mst2**6.*Mt**6.)/288.-

     &  (13*Mgl*Mst2**8.*Mt**6.)/72.+

     &  (11*Mst2**10.*Mt**6.)/(288.*Mgl**1.)-

     &  (35*Mst2**12.*Mt**6.)/(144.*Mgl**3.)+

     &  (233*Mgl**7.*Mt**8.)/96.-

     &  (67*Mgl**11.*Mt**8.)/(144.*Mst2**4.)-

     &  (25*Mgl**9.*Mt**8.)/(32.*Mst2**2.)+

     &  (3*Mgl**5.*Mst2**2.*Mt**8.)/4.+

     &  (5*Mgl**3.*Mst2**4.*Mt**8.)/18.+

     &  (95*Mgl*Mst2**6.*Mt**8.)/288.+

     &  (35*Mst2**8.*Mt**8.)/(288.*Mgl**1.)+

     &  (49*Mst2**10.*Mt**8.)/(144.*Mgl**3.)-

     &  (25*Mgl**5.*Mt**10.)/9.+

     &  (5*Mgl**9.*Mt**10.)/(16.*Mst2**4.)+

     &  (265*Mgl**7.*Mt**10.)/(288.*Mst2**2.)-

     &  (9*Mgl**3.*Mst2**2.*Mt**10.)/4.-

     &  (73*Mgl*Mst2**4.*Mt**10.)/72.-

     &  (25*Mst2**6.*Mt**10.)/(288.*Mgl**1.)-

     &  (35*Mst2**8.*Mt**10.)/(144.*Mgl**3.)+

     &  (443*Mgl**3.*Mt**12.)/288.+

     &  (Mgl**7.*Mt**12.)/(48.*Mst2**4.)-

     &  (101*Mgl**5.*Mt**12.)/(288.*Mst2**2.)+

     &  (271*Mgl*Mst2**2.*Mt**12.)/288.-

     &  (29*Mst2**4.*Mt**12.)/(288.*Mgl**1.)+

     &  (7*Mst2**6.*Mt**12.)/(144.*Mgl**3.)-

     &  (23*Mgl*Mt**14.)/72.-

     &  (25*Mgl**5.*Mt**14.)/(144.*Mst2**4.)-

     &  (7*Mgl**3.*Mt**14.)/(96.*Mst2**2.)+

     &  (37*Mst2**2.*Mt**14.)/(288.*Mgl**1.)+

     &  (7*Mst2**4.*Mt**14.)/(144.*Mgl**3.)-

     &  (11*Mt**16.)/(288.*Mgl**1.)+

     &  (5*Mgl**3.*Mt**16.)/(48.*Mst2**4.)+

     &  (17*Mgl*Mt**16.)/(288.*Mst2**2.)-

     &  (5*Mst2**2.*Mt**16.)/(144.*Mgl**3.)+

     &  Mt**18./(144.*Mgl**3.)-

     &  (Mgl*Mt**18.)/(48.*Mst2**4.))*Xt*

     &  d123(Mt,Mgl,Mst2)**4.*Den(Mst1,Mst2)*Tfin(Mt,Mgl,Mst2)

     &  )+Nq*(0.056996286651234566+

     &  (7*Mgl**2.)/(3456.*Msq1**2.)+

     &  (91*Msq1**2.)/(2304.*Mgl**2.)+

     &  (3937*Msq1**4.)/(331776.*Mgl**4.)+

     &  (7*Mgl**2.)/(3456.*Msq2**2.)+

     &  (91*Msq2**2.)/(2304.*Mgl**2.)+

     &  (3937*Msq2**4.)/(331776.*Mgl**4.)+z2/24.+

     &  (-0.041666666666666664+Msq1**2./(24.*Mgl**2.))*

     &  B0fin(Mgl,Mq,Msq1,mu)+

     &  (-0.041666666666666664+Msq2**2./(24.*Mgl**2.))*

     &  B0fin(Mgl,Mq,Msq2,mu)+

     &  ((3151*Mgl**4.)/82944.-

     &  (43*Mgl**6.)/(6912.*Msq1**2.)+

     &  (2845*Mgl**2.*Msq1**2.)/9216.-

     &  (523*Msq1**4.)/2304.-

     &  (7493*Msq1**6.)/(82944.*Mgl**2.)+

     &  (3473*Msq1**8.)/(82944.*Mgl**4.)-

     &  (17*Mgl**4.*z2)/384.+

     &  (5*Mgl**6.*z2)/(1152.*Msq1**2.)+

     &  (407*Mgl**2.*Msq1**2.*z2)/2304.-

     &  (191*Msq1**4.*z2)/1152.+

     &  (11*Msq1**6.*z2)/(256.*Mgl**2.))*Den(Msq1,Mgl)**2.

     &  +((-4891*Mgl**8.)/165888.+

     &  Mgl**12./(5184.*Msq1**4.)+

     &  (733*Mgl**10.)/(27648.*Msq1**2.)-

     &  (259*Mgl**6.*Msq1**2.)/4608.+

     &  (37037*Mgl**4.*Msq1**4.)/55296.-

     &  (106435*Mgl**2.*Msq1**6.)/82944.+

     &  (105319*Msq1**8.)/165888.+

     &  (1363*Msq1**10.)/(13824.*Mgl**2.)-

     &  (3377*Msq1**12.)/(55296.*Mgl**4.)+

     &  (59*Mgl**8.*z2)/1152.-

     &  (Mgl**10.*z2)/(1152.*Msq1**2.)-

     &  (133*Mgl**6.*Msq1**2.*z2)/768.+

     &  (3*Mgl**4.*Msq1**4.*z2)/8.-

     &  (283*Mgl**2.*Msq1**6.*z2)/576.+

     &  (37*Msq1**8.*z2)/128.-

     &  (115*Msq1**10.*z2)/(2304.*Mgl**2.))*

     &  Den(Msq1,Mgl)**4.+

     &  ((551*Mgl**12.)/27648.-Mgl**16./(1296.*Msq1**4.)-

     &  (2657*Mgl**14.)/(20736.*Msq1**2.)+

     &  (13873*Mgl**10.*Msq1**2.)/82944.+

     &  (15515*Mgl**8.*Msq1**4.)/13824.-

     &  (159967*Mgl**6.*Msq1**6.)/82944.-

     &  (1073*Mgl**4.*Msq1**8.)/6912.+

     &  (123779*Mgl**2.*Msq1**10.)/82944.-

     &  (21445*Msq1**12.)/41472.-

     &  (2267*Msq1**14.)/(27648.*Mgl**2.)+

     &  (277*Msq1**16.)/(27648.*Mgl**4.)+

     &  (Mgl**12.*z2)/36.-(Mgl**14.*z2)/(36.*Msq1**2.)-

     &  (7*Mgl**10.*Msq1**2.*z2)/768.+

     &  (43*Mgl**8.*Msq1**4.*z2)/192.-

     &  (97*Mgl**6.*Msq1**6.*z2)/256.+

     &  (Mgl**4.*Msq1**8.*z2)/16.+

     &  (409*Mgl**2.*Msq1**10.*z2)/2304.-

     &  (37*Msq1**12.*z2)/576.-

     &  (3*Msq1**14.*z2)/(256.*Mgl**2.))*Den(Msq1,Mgl)**6.

     &  +((-81625*Mgl**16.)/331776.+

     &  Mgl**20./(1728.*Msq1**4.)+

     &  (8713*Mgl**18.)/(82944.*Msq1**2.)+

     &  (923*Mgl**14.*Msq1**2.)/41472.-

     &  (188399*Mgl**12.*Msq1**4.)/331776.+

     &  (11615*Mgl**10.*Msq1**6.)/3456.-

     &  (879553*Mgl**8.*Msq1**8.)/165888.+

     &  (131297*Mgl**6.*Msq1**10.)/41472.-

     &  (14849*Mgl**4.*Msq1**12.)/55296.-

     &  (14849*Mgl**2.*Msq1**14.)/82944.-

     &  (22439*Msq1**16.)/110592.+

     &  (1187*Msq1**18.)/(10368.*Mgl**2.)-

     &  (11*Msq1**20.)/(4096.*Mgl**4.)-

     &  (17*Mgl**16.*z2)/192.+

     &  (7*Mgl**18.*z2)/(288.*Msq1**2.)+

     &  (311*Mgl**14.*Msq1**2.*z2)/2304.-

     &  (49*Mgl**12.*Msq1**4.*z2)/192.+

     &  (173*Mgl**10.*Msq1**6.*z2)/288.-

     &  (451*Mgl**8.*Msq1**8.*z2)/576.+

     &  (169*Mgl**6.*Msq1**10.*z2)/384.-

     &  (29*Mgl**4.*Msq1**12.*z2)/576.+

     &  (Mgl**2.*Msq1**14.*z2)/288.-

     &  (13*Msq1**16.*z2)/288.+

     &  (43*Msq1**18.*z2)/(2304.*Mgl**2.))*Den(Msq1,Mgl)**8.

     &  +((3151*Mgl**4.)/82944.-

     &  (43*Mgl**6.)/(6912.*Msq2**2.)+

     &  (2845*Mgl**2.*Msq2**2.)/9216.-

     &  (523*Msq2**4.)/2304.-

     &  (7493*Msq2**6.)/(82944.*Mgl**2.)+

     &  (3473*Msq2**8.)/(82944.*Mgl**4.)-

     &  (17*Mgl**4.*z2)/384.+

     &  (5*Mgl**6.*z2)/(1152.*Msq2**2.)+

     &  (407*Mgl**2.*Msq2**2.*z2)/2304.-

     &  (191*Msq2**4.*z2)/1152.+

     &  (11*Msq2**6.*z2)/(256.*Mgl**2.))*Den(Msq2,Mgl)**2.

     &  +((-4891*Mgl**8.)/165888.+

     &  Mgl**12./(5184.*Msq2**4.)+

     &  (733*Mgl**10.)/(27648.*Msq2**2.)-

     &  (259*Mgl**6.*Msq2**2.)/4608.+

     &  (37037*Mgl**4.*Msq2**4.)/55296.-

     &  (106435*Mgl**2.*Msq2**6.)/82944.+

     &  (105319*Msq2**8.)/165888.+

     &  (1363*Msq2**10.)/(13824.*Mgl**2.)-

     &  (3377*Msq2**12.)/(55296.*Mgl**4.)+

     &  (59*Mgl**8.*z2)/1152.-

     &  (Mgl**10.*z2)/(1152.*Msq2**2.)-

     &  (133*Mgl**6.*Msq2**2.*z2)/768.+

     &  (3*Mgl**4.*Msq2**4.*z2)/8.-

     &  (283*Mgl**2.*Msq2**6.*z2)/576.+

     &  (37*Msq2**8.*z2)/128.-

     &  (115*Msq2**10.*z2)/(2304.*Mgl**2.))*

     &  Den(Msq2,Mgl)**4.+

     &  ((551*Mgl**12.)/27648.-Mgl**16./(1296.*Msq2**4.)-

     &  (2657*Mgl**14.)/(20736.*Msq2**2.)+

     &  (13873*Mgl**10.*Msq2**2.)/82944.+

     &  (15515*Mgl**8.*Msq2**4.)/13824.-

     &  (159967*Mgl**6.*Msq2**6.)/82944.-

     &  (1073*Mgl**4.*Msq2**8.)/6912.+

     &  (123779*Mgl**2.*Msq2**10.)/82944.-

     &  (21445*Msq2**12.)/41472.-

     &  (2267*Msq2**14.)/(27648.*Mgl**2.)+

     &  (277*Msq2**16.)/(27648.*Mgl**4.)+

     &  (Mgl**12.*z2)/36.-(Mgl**14.*z2)/(36.*Msq2**2.)-

     &  (7*Mgl**10.*Msq2**2.*z2)/768.+

     &  (43*Mgl**8.*Msq2**4.*z2)/192.-

     &  (97*Mgl**6.*Msq2**6.*z2)/256.+

     &  (Mgl**4.*Msq2**8.*z2)/16.+

     &  (409*Mgl**2.*Msq2**10.*z2)/2304.-

     &  (37*Msq2**12.*z2)/576.-

     &  (3*Msq2**14.*z2)/(256.*Mgl**2.))*Den(Msq2,Mgl)**6.

     &  +((-81625*Mgl**16.)/331776.+

     &  Mgl**20./(1728.*Msq2**4.)+

     &  (8713*Mgl**18.)/(82944.*Msq2**2.)+

     &  (923*Mgl**14.*Msq2**2.)/41472.-

     &  (188399*Mgl**12.*Msq2**4.)/331776.+

     &  (11615*Mgl**10.*Msq2**6.)/3456.-

     &  (879553*Mgl**8.*Msq2**8.)/165888.+

     &  (131297*Mgl**6.*Msq2**10.)/41472.-

     &  (14849*Mgl**4.*Msq2**12.)/55296.-

     &  (14849*Mgl**2.*Msq2**14.)/82944.-

     &  (22439*Msq2**16.)/110592.+

     &  (1187*Msq2**18.)/(10368.*Mgl**2.)-

     &  (11*Msq2**20.)/(4096.*Mgl**4.)-

     &  (17*Mgl**16.*z2)/192.+

     &  (7*Mgl**18.*z2)/(288.*Msq2**2.)+

     &  (311*Mgl**14.*Msq2**2.*z2)/2304.-

     &  (49*Mgl**12.*Msq2**4.*z2)/192.+

     &  (173*Mgl**10.*Msq2**6.*z2)/288.-

     &  (451*Mgl**8.*Msq2**8.*z2)/576.+

     &  (169*Mgl**6.*Msq2**10.*z2)/384.-

     &  (29*Mgl**4.*Msq2**12.*z2)/576.+

     &  (Mgl**2.*Msq2**14.*z2)/288.-

     &  (13*Msq2**16.*z2)/288.+

     &  (43*Msq2**18.*z2)/(2304.*Mgl**2.))*Den(Msq2,Mgl)**8.

     &  +(-0.05577256944444445+Mgl**2./(576.*Msq1**2.)+

     &  Msq1**2./(9216.*Mgl**2.)+

     &  Mgl**2./(576.*Msq2**2.)+Msq2**2./(9216.*Mgl**2.))*

     &  ln(mu,Mgl)+((-47*Mgl**4.)/432.+

     &  (25*Mgl**6.)/(6912.*Msq1**2.)+

     &  (2471*Mgl**2.*Msq1**2.)/13824.-

     &  (151*Msq1**4.)/1728.+

     &  (367*Msq1**6.)/(13824.*Mgl**2.))*Den(Msq1,Mgl)**2.*

     &  ln(mu,Mgl)+((91*Mgl**8.)/1536.-

     &  Mgl**12./(144.*Msq1**4.)+

     &  (7*Mgl**10.)/(864.*Msq1**2.)-

     &  (1507*Mgl**6.*Msq1**2.)/3456.+

     &  (367*Mgl**4.*Msq1**4.)/384.-

     &  (5881*Mgl**2.*Msq1**6.)/6912.+

     &  (3905*Msq1**8.)/13824.-

     &  (3*Msq1**10.)/(256.*Mgl**2.))*Den(Msq1,Mgl)**4.*

     &  ln(mu,Mgl)+((3559*Mgl**12.)/6912.+

     &  Mgl**16./(36.*Msq1**4.)-

     &  (211*Mgl**14.)/(1728.*Msq1**2.)-

     &  (5995*Mgl**10.*Msq1**2.)/4608.+

     &  (299*Mgl**8.*Msq1**4.)/256.+

     &  (345*Mgl**6.*Msq1**6.)/512.-

     &  (4313*Mgl**4.*Msq1**8.)/2304.+

     &  (14021*Mgl**2.*Msq1**10.)/13824.-

     &  (133*Msq1**12.)/6912.-

     &  (389*Msq1**14.)/(4608.*Mgl**2.))*Den(Msq1,Mgl)**6.*

     &  ln(mu,Mgl)+((-17159*Mgl**16.)/27648.-

     &  Mgl**20./(48.*Msq1**4.)+

     &  (943*Mgl**18.)/(6912.*Msq1**2.)+

     &  (56341*Mgl**14.*Msq1**2.)/27648.-

     &  (863*Mgl**12.*Msq1**4.)/216.+

     &  (14041*Mgl**10.*Msq1**6.)/3456.-

     &  (15859*Mgl**8.*Msq1**8.)/13824.-

     &  (21983*Mgl**6.*Msq1**10.)/13824.+

     &  (5173*Mgl**4.*Msq1**12.)/3456.-

     &  (1559*Mgl**2.*Msq1**14.)/6912.-

     &  (5627*Msq1**16.)/27648.+

     &  (1921*Msq1**18.)/(27648.*Mgl**2.))*

     &  Den(Msq1,Mgl)**8.*ln(mu,Mgl)+

     &  ((-47*Mgl**4.)/432.+(25*Mgl**6.)/(6912.*Msq2**2.)+

     &  (2471*Mgl**2.*Msq2**2.)/13824.-

     &  (151*Msq2**4.)/1728.+

     &  (367*Msq2**6.)/(13824.*Mgl**2.))*Den(Msq2,Mgl)**2.*

     &  ln(mu,Mgl)+((91*Mgl**8.)/1536.-

     &  Mgl**12./(144.*Msq2**4.)+

     &  (7*Mgl**10.)/(864.*Msq2**2.)-

     &  (1507*Mgl**6.*Msq2**2.)/3456.+

     &  (367*Mgl**4.*Msq2**4.)/384.-

     &  (5881*Mgl**2.*Msq2**6.)/6912.+

     &  (3905*Msq2**8.)/13824.-

     &  (3*Msq2**10.)/(256.*Mgl**2.))*Den(Msq2,Mgl)**4.*

     &  ln(mu,Mgl)+((3559*Mgl**12.)/6912.+

     &  Mgl**16./(36.*Msq2**4.)-

     &  (211*Mgl**14.)/(1728.*Msq2**2.)-

     &  (5995*Mgl**10.*Msq2**2.)/4608.+

     &  (299*Mgl**8.*Msq2**4.)/256.+

     &  (345*Mgl**6.*Msq2**6.)/512.-

     &  (4313*Mgl**4.*Msq2**8.)/2304.+

     &  (14021*Mgl**2.*Msq2**10.)/13824.-

     &  (133*Msq2**12.)/6912.-

     &  (389*Msq2**14.)/(4608.*Mgl**2.))*Den(Msq2,Mgl)**6.*

     &  ln(mu,Mgl)+((-17159*Mgl**16.)/27648.-

     &  Mgl**20./(48.*Msq2**4.)+

     &  (943*Mgl**18.)/(6912.*Msq2**2.)+

     &  (56341*Mgl**14.*Msq2**2.)/27648.-

     &  (863*Mgl**12.*Msq2**4.)/216.+

     &  (14041*Mgl**10.*Msq2**6.)/3456.-

     &  (15859*Mgl**8.*Msq2**8.)/13824.-

     &  (21983*Mgl**6.*Msq2**10.)/13824.+

     &  (5173*Mgl**4.*Msq2**12.)/3456.-

     &  (1559*Mgl**2.*Msq2**14.)/6912.-

     &  (5627*Msq2**16.)/27648.+

     &  (1921*Msq2**18.)/(27648.*Mgl**2.))*

     &  Den(Msq2,Mgl)**8.*ln(mu,Mgl)+

     &  (-0.005642361111111111-

     &  (35*Msq1**2.)/(4608.*Mgl**2.)-

     &  (35*Msq2**2.)/(4608.*Mgl**2.))*ln(mu,Mgl)**2.+

     &  ((-149*Mgl**4.)/2304.+(7*Mgl**6.)/(768.*Msq1**2.)+

     &  (379*Mgl**2.*Msq1**2.)/4608.-

     &  (97*Msq1**4.)/2304.+(71*Msq1**6.)/(4608.*Mgl**2.))

     &  *Den(Msq1,Mgl)**2.*ln(mu,Mgl)**2.+

     &  ((7*Mgl**8.)/128.-Mgl**12./(576.*Msq1**4.)-

     &  (11*Mgl**10.)/(2304.*Msq1**2.)-

     &  (929*Mgl**6.*Msq1**2.)/4608.+

     &  (23*Mgl**4.*Msq1**4.)/72.-

     &  (43*Mgl**2.*Msq1**6.)/192.+(79*Msq1**8.)/1152.-

     &  (49*Msq1**10.)/(4608.*Mgl**2.))*Den(Msq1,Mgl)**4.*

     &  ln(mu,Mgl)**2.+

     &  ((21*Mgl**12.)/128.+Mgl**16./(144.*Msq1**4.)-

     &  (17*Mgl**14.)/(576.*Msq1**2.)-

     &  (1993*Mgl**10.*Msq1**2.)/4608.+

     &  (227*Mgl**8.*Msq1**4.)/576.+

     &  (451*Mgl**6.*Msq1**6.)/4608.-

     &  (421*Mgl**4.*Msq1**8.)/1152.+

     &  (287*Mgl**2.*Msq1**10.)/1536.-

     &  (11*Msq1**12.)/576.-(5*Msq1**14.)/(1536.*Mgl**2.))

     &  *Den(Msq1,Mgl)**6.*ln(mu,Mgl)**2.+

     &  ((-263*Mgl**16.)/1536.-Mgl**20./(192.*Msq1**4.)+

     &  (37*Mgl**18.)/(1152.*Msq1**2.)+

     &  (703*Mgl**14.*Msq1**2.)/1152.-

     &  (1369*Mgl**12.*Msq1**4.)/1152.+

     &  (85*Mgl**10.*Msq1**6.)/72.-

     &  (943*Mgl**8.*Msq1**8.)/2304.-

     &  (137*Mgl**6.*Msq1**10.)/576.+

     &  (277*Mgl**4.*Msq1**12.)/1152.-

     &  (41*Mgl**2.*Msq1**14.)/1152.-

     &  (101*Msq1**16.)/4608.+

     &  (7*Msq1**18.)/(1152.*Mgl**2.))*Den(Msq1,Mgl)**8.*

     &  ln(mu,Mgl)**2.+

     &  ((-149*Mgl**4.)/2304.+(7*Mgl**6.)/(768.*Msq2**2.)+

     &  (379*Mgl**2.*Msq2**2.)/4608.-

     &  (97*Msq2**4.)/2304.+(71*Msq2**6.)/(4608.*Mgl**2.))

     &  *Den(Msq2,Mgl)**2.*ln(mu,Mgl)**2.+

     &  ((7*Mgl**8.)/128.-Mgl**12./(576.*Msq2**4.)-

     &  (11*Mgl**10.)/(2304.*Msq2**2.)-

     &  (929*Mgl**6.*Msq2**2.)/4608.+

     &  (23*Mgl**4.*Msq2**4.)/72.-

     &  (43*Mgl**2.*Msq2**6.)/192.+(79*Msq2**8.)/1152.-

     &  (49*Msq2**10.)/(4608.*Mgl**2.))*Den(Msq2,Mgl)**4.*

     &  ln(mu,Mgl)**2.+

     &  ((21*Mgl**12.)/128.+Mgl**16./(144.*Msq2**4.)-

     &  (17*Mgl**14.)/(576.*Msq2**2.)-

     &  (1993*Mgl**10.*Msq2**2.)/4608.+

     &  (227*Mgl**8.*Msq2**4.)/576.+

     &  (451*Mgl**6.*Msq2**6.)/4608.-

     &  (421*Mgl**4.*Msq2**8.)/1152.+

     &  (287*Mgl**2.*Msq2**10.)/1536.-

     &  (11*Msq2**12.)/576.-(5*Msq2**14.)/(1536.*Mgl**2.))

     &  *Den(Msq2,Mgl)**6.*ln(mu,Mgl)**2.+

     &  ((-263*Mgl**16.)/1536.-Mgl**20./(192.*Msq2**4.)+

     &  (37*Mgl**18.)/(1152.*Msq2**2.)+

     &  (703*Mgl**14.*Msq2**2.)/1152.-

     &  (1369*Mgl**12.*Msq2**4.)/1152.+

     &  (85*Mgl**10.*Msq2**6.)/72.-

     &  (943*Mgl**8.*Msq2**8.)/2304.-

     &  (137*Mgl**6.*Msq2**10.)/576.+

     &  (277*Mgl**4.*Msq2**12.)/1152.-

     &  (41*Mgl**2.*Msq2**14.)/1152.-

     &  (101*Msq2**16.)/4608.+

     &  (7*Msq2**18.)/(1152.*Mgl**2.))*Den(Msq2,Mgl)**8.*

     &  ln(mu,Mgl)**2.+

     &  (0.029513888888888888+Mgl**2./(576.*Msq1**2.)-

     &  (113*Msq1**2.)/(9216.*Mgl**2.)-

     &  (223*Msq1**4.)/(9216.*Mgl**4.))*ln(mu,Msq1)+

     &  ((-323*Mgl**4.)/6912.+

     &  (41*Mgl**6.)/(2304.*Msq1**2.)+

     &  (1727*Mgl**2.*Msq1**2.)/13824.-

     &  (11*Msq1**4.)/72.+

     &  (217*Msq1**6.)/(4608.*Mgl**2.)+

     &  (155*Msq1**8.)/(6912.*Mgl**4.))*Den(Msq1,Mgl)**2.*

     &  ln(mu,Msq1)+

     &  ((103*Mgl**8.)/1152.+

     &  (23*Mgl**10.)/(2304.*Msq1**2.)-

     &  (61*Mgl**6.*Msq1**2.)/216.+

     &  (1451*Mgl**4.*Msq1**4.)/4608.-

     &  (173*Mgl**2.*Msq1**6.)/432.+

     &  (1679*Msq1**8.)/3456.-

     &  (1549*Msq1**10.)/(6912.*Mgl**2.)+

     &  (95*Msq1**12.)/(13824.*Mgl**4.))*Den(Msq1,Mgl)**4.*

     &  ln(mu,Msq1)+

     &  ((4*Mgl**12.)/27.-(31*Mgl**14.)/(288.*Msq1**2.)+

     &  (6175*Mgl**10.*Msq1**2.)/13824.-

     &  (5131*Mgl**8.*Msq1**4.)/6912.-

     &  (2743*Mgl**6.*Msq1**6.)/4608.+

     &  (11903*Mgl**4.*Msq1**8.)/6912.-

     &  (4505*Mgl**2.*Msq1**10.)/4608.+

     &  (239*Msq1**12.)/6912.+

     &  (865*Msq1**14.)/(13824.*Mgl**2.)+

     &  (61*Msq1**16.)/(6912.*Mgl**4.))*Den(Msq1,Mgl)**6.*

     &  ln(mu,Msq1)+

     &  ((-1757*Mgl**16.)/6912.+

     &  (5*Mgl**18.)/(64.*Msq1**2.)-

     &  (3389*Mgl**14.*Msq1**2.)/27648.+

     &  (40739*Mgl**12.*Msq1**4.)/27648.-

     &  (725*Mgl**10.*Msq1**6.)/384.-

     &  (61*Mgl**8.*Msq1**8.)/144.+

     &  (42619*Mgl**6.*Msq1**10.)/13824.-

     &  (14191*Mgl**4.*Msq1**12.)/4608.+

     &  (827*Mgl**2.*Msq1**14.)/576.-

     &  (2485*Msq1**16.)/6912.+

     &  (1967*Msq1**18.)/(27648.*Mgl**2.)-

     &  (385*Msq1**20.)/(27648.*Mgl**4.))*Den(Msq1,Mgl)**8.*

     &  ln(mu,Msq1)+(5*ln(mu,Mgl)*ln(mu,Msq1))/144.+

     &  ((-17*Mgl**4.)/384.+(5*Mgl**6.)/(1152.*Msq1**2.)+

     &  (407*Mgl**2.*Msq1**2.)/2304.-

     &  (191*Msq1**4.)/1152.+(11*Msq1**6.)/(256.*Mgl**2.))

     &  *Den(Msq1,Mgl)**2.*ln(mu,Mgl)*ln(mu,Msq1)+

     &  ((59*Mgl**8.)/1152.-Mgl**10./(1152.*Msq1**2.)-

     &  (133*Mgl**6.*Msq1**2.)/768.+

     &  (3*Mgl**4.*Msq1**4.)/8.-

     &  (283*Mgl**2.*Msq1**6.)/576.+(37*Msq1**8.)/128.-

     &  (115*Msq1**10.)/(2304.*Mgl**2.))*Den(Msq1,Mgl)**4.*

     &  ln(mu,Mgl)*ln(mu,Msq1)+

     &  (Mgl**12./36.-Mgl**14./(36.*Msq1**2.)-

     &  (7*Mgl**10.*Msq1**2.)/768.+

     &  (43*Mgl**8.*Msq1**4.)/192.-

     &  (97*Mgl**6.*Msq1**6.)/256.+

     &  (Mgl**4.*Msq1**8.)/16.+

     &  (409*Mgl**2.*Msq1**10.)/2304.-

     &  (37*Msq1**12.)/576.-(3*Msq1**14.)/(256.*Mgl**2.))*

     &  Den(Msq1,Mgl)**6.*ln(mu,Mgl)*ln(mu,Msq1)+

     &  ((-17*Mgl**16.)/192.+(7*Mgl**18.)/(288.*Msq1**2.)+

     &  (311*Mgl**14.*Msq1**2.)/2304.-

     &  (49*Mgl**12.*Msq1**4.)/192.+

     &  (173*Mgl**10.*Msq1**6.)/288.-

     &  (451*Mgl**8.*Msq1**8.)/576.+

     &  (169*Mgl**6.*Msq1**10.)/384.-

     &  (29*Mgl**4.*Msq1**12.)/576.+

     &  (Mgl**2.*Msq1**14.)/288.-(13*Msq1**16.)/288.+

     &  (43*Msq1**18.)/(2304.*Mgl**2.))*Den(Msq1,Mgl)**8.*

     &  ln(mu,Mgl)*ln(mu,Msq1)+

     &  (0.010416666666666666-

     &  (61*Msq1**2.)/(4608.*Mgl**2.)-

     &  (35*Msq1**4.)/(4608.*Mgl**4.))*ln(mu,Msq1)**2.+

     &  ((-35*Mgl**4.)/2304.+(5*Mgl**6.)/(2304.*Msq1**2.)+

     &  (211*Mgl**2.*Msq1**2.)/4608.-

     &  (205*Msq1**4.)/2304.+

     &  (287*Msq1**6.)/(4608.*Mgl**2.)-

     &  (7*Msq1**8.)/(1152.*Mgl**4.))*Den(Msq1,Mgl)**2.*

     &  ln(mu,Msq1)**2.+

     &  ((49*Mgl**8.)/2304.-(5*Mgl**10.)/(2304.*Msq1**2.)-

     &  (265*Mgl**6.*Msq1**2.)/4608.+

     &  (167*Mgl**4.*Msq1**4.)/2304.-

     &  (131*Mgl**2.*Msq1**6.)/1152.+

     &  (383*Msq1**8.)/2304.-

     &  (155*Msq1**10.)/(1536.*Mgl**2.)+

     &  (11*Msq1**12.)/(768.*Mgl**4.))*Den(Msq1,Mgl)**4.*

     &  ln(mu,Msq1)**2.+

     &  (-Mgl**12./576.-Mgl**14./(144.*Msq1**2.)+

     &  (671*Mgl**10.*Msq1**2.)/4608.-

     &  (91*Mgl**8.*Msq1**4.)/288.+

     &  (427*Mgl**6.*Msq1**6.)/4608.+

     &  (367*Mgl**4.*Msq1**8.)/1152.-

     &  (473*Mgl**2.*Msq1**10.)/1536.+

     &  (19*Msq1**12.)/288.+

     &  (11*Msq1**14.)/(1536.*Mgl**2.)+

     &  Msq1**16./(384.*Mgl**4.))*Den(Msq1,Mgl)**6.*

     &  ln(mu,Msq1)**2.+

     &  ((-7*Mgl**16.)/288.+Mgl**18./(144.*Msq1**2.)-

     &  (137*Mgl**14.*Msq1**2.)/2304.+

     &  (1913*Mgl**12.*Msq1**4.)/4608.-

     &  (73*Mgl**10.*Msq1**6.)/96.+

     &  (563*Mgl**8.*Msq1**8.)/1152.+

     &  (233*Mgl**6.*Msq1**10.)/1152.-

     &  (371*Mgl**4.*Msq1**12.)/768.+

     &  (77*Mgl**2.*Msq1**14.)/288.-(23*Msq1**16.)/384.+

     &  (23*Msq1**18.)/(2304.*Mgl**2.)-

     &  (5*Msq1**20.)/(1536.*Mgl**4.))*Den(Msq1,Mgl)**8.*

     &  ln(mu,Msq1)**2.+

     &  (0.029513888888888888+Mgl**2./(576.*Msq2**2.)-

     &  (113*Msq2**2.)/(9216.*Mgl**2.)-

     &  (223*Msq2**4.)/(9216.*Mgl**4.))*ln(mu,Msq2)+

     &  ((-323*Mgl**4.)/6912.+

     &  (41*Mgl**6.)/(2304.*Msq2**2.)+

     &  (1727*Mgl**2.*Msq2**2.)/13824.-

     &  (11*Msq2**4.)/72.+

     &  (217*Msq2**6.)/(4608.*Mgl**2.)+

     &  (155*Msq2**8.)/(6912.*Mgl**4.))*Den(Msq2,Mgl)**2.*

     &  ln(mu,Msq2)+

     &  ((103*Mgl**8.)/1152.+

     &  (23*Mgl**10.)/(2304.*Msq2**2.)-

     &  (61*Mgl**6.*Msq2**2.)/216.+

     &  (1451*Mgl**4.*Msq2**4.)/4608.-

     &  (173*Mgl**2.*Msq2**6.)/432.+

     &  (1679*Msq2**8.)/3456.-

     &  (1549*Msq2**10.)/(6912.*Mgl**2.)+

     &  (95*Msq2**12.)/(13824.*Mgl**4.))*Den(Msq2,Mgl)**4.*

     &  ln(mu,Msq2)+

     &  ((4*Mgl**12.)/27.-(31*Mgl**14.)/(288.*Msq2**2.)+

     &  (6175*Mgl**10.*Msq2**2.)/13824.-

     &  (5131*Mgl**8.*Msq2**4.)/6912.-

     &  (2743*Mgl**6.*Msq2**6.)/4608.+

     &  (11903*Mgl**4.*Msq2**8.)/6912.-

     &  (4505*Mgl**2.*Msq2**10.)/4608.+

     &  (239*Msq2**12.)/6912.+

     &  (865*Msq2**14.)/(13824.*Mgl**2.)+

     &  (61*Msq2**16.)/(6912.*Mgl**4.))*Den(Msq2,Mgl)**6.*

     &  ln(mu,Msq2)+

     &  ((-1757*Mgl**16.)/6912.+

     &  (5*Mgl**18.)/(64.*Msq2**2.)-

     &  (3389*Mgl**14.*Msq2**2.)/27648.+

     &  (40739*Mgl**12.*Msq2**4.)/27648.-

     &  (725*Mgl**10.*Msq2**6.)/384.-

     &  (61*Mgl**8.*Msq2**8.)/144.+

     &  (42619*Mgl**6.*Msq2**10.)/13824.-

     &  (14191*Mgl**4.*Msq2**12.)/4608.+

     &  (827*Mgl**2.*Msq2**14.)/576.-

     &  (2485*Msq2**16.)/6912.+

     &  (1967*Msq2**18.)/(27648.*Mgl**2.)-

     &  (385*Msq2**20.)/(27648.*Mgl**4.))*Den(Msq2,Mgl)**8.*

     &  ln(mu,Msq2)+(5*ln(mu,Mgl)*ln(mu,Msq2))/144.+

     &  ((-17*Mgl**4.)/384.+(5*Mgl**6.)/(1152.*Msq2**2.)+

     &  (407*Mgl**2.*Msq2**2.)/2304.-

     &  (191*Msq2**4.)/1152.+(11*Msq2**6.)/(256.*Mgl**2.))

     &  *Den(Msq2,Mgl)**2.*ln(mu,Mgl)*ln(mu,Msq2)+

     &  ((59*Mgl**8.)/1152.-Mgl**10./(1152.*Msq2**2.)-

     &  (133*Mgl**6.*Msq2**2.)/768.+

     &  (3*Mgl**4.*Msq2**4.)/8.-

     &  (283*Mgl**2.*Msq2**6.)/576.+(37*Msq2**8.)/128.-

     &  (115*Msq2**10.)/(2304.*Mgl**2.))*Den(Msq2,Mgl)**4.*

     &  ln(mu,Mgl)*ln(mu,Msq2)+

     &  (Mgl**12./36.-Mgl**14./(36.*Msq2**2.)-

     &  (7*Mgl**10.*Msq2**2.)/768.+

     &  (43*Mgl**8.*Msq2**4.)/192.-

     &  (97*Mgl**6.*Msq2**6.)/256.+

     &  (Mgl**4.*Msq2**8.)/16.+

     &  (409*Mgl**2.*Msq2**10.)/2304.-

     &  (37*Msq2**12.)/576.-(3*Msq2**14.)/(256.*Mgl**2.))*

     &  Den(Msq2,Mgl)**6.*ln(mu,Mgl)*ln(mu,Msq2)+

     &  ((-17*Mgl**16.)/192.+(7*Mgl**18.)/(288.*Msq2**2.)+

     &  (311*Mgl**14.*Msq2**2.)/2304.-

     &  (49*Mgl**12.*Msq2**4.)/192.+

     &  (173*Mgl**10.*Msq2**6.)/288.-

     &  (451*Mgl**8.*Msq2**8.)/576.+

     &  (169*Mgl**6.*Msq2**10.)/384.-

     &  (29*Mgl**4.*Msq2**12.)/576.+

     &  (Mgl**2.*Msq2**14.)/288.-(13*Msq2**16.)/288.+

     &  (43*Msq2**18.)/(2304.*Mgl**2.))*Den(Msq2,Mgl)**8.*

     &  ln(mu,Mgl)*ln(mu,Msq2)+

     &  (0.010416666666666666-

     &  (61*Msq2**2.)/(4608.*Mgl**2.)-

     &  (35*Msq2**4.)/(4608.*Mgl**4.))*ln(mu,Msq2)**2.+

     &  ((-35*Mgl**4.)/2304.+(5*Mgl**6.)/(2304.*Msq2**2.)+

     &  (211*Mgl**2.*Msq2**2.)/4608.-

     &  (205*Msq2**4.)/2304.+

     &  (287*Msq2**6.)/(4608.*Mgl**2.)-

     &  (7*Msq2**8.)/(1152.*Mgl**4.))*Den(Msq2,Mgl)**2.*

     &  ln(mu,Msq2)**2.+

     &  ((49*Mgl**8.)/2304.-(5*Mgl**10.)/(2304.*Msq2**2.)-

     &  (265*Mgl**6.*Msq2**2.)/4608.+

     &  (167*Mgl**4.*Msq2**4.)/2304.-

     &  (131*Mgl**2.*Msq2**6.)/1152.+

     &  (383*Msq2**8.)/2304.-

     &  (155*Msq2**10.)/(1536.*Mgl**2.)+

     &  (11*Msq2**12.)/(768.*Mgl**4.))*Den(Msq2,Mgl)**4.*

     &  ln(mu,Msq2)**2.+

     &  (-Mgl**12./576.-Mgl**14./(144.*Msq2**2.)+

     &  (671*Mgl**10.*Msq2**2.)/4608.-

     &  (91*Mgl**8.*Msq2**4.)/288.+

     &  (427*Mgl**6.*Msq2**6.)/4608.+

     &  (367*Mgl**4.*Msq2**8.)/1152.-

     &  (473*Mgl**2.*Msq2**10.)/1536.+

     &  (19*Msq2**12.)/288.+

     &  (11*Msq2**14.)/(1536.*Mgl**2.)+

     &  Msq2**16./(384.*Mgl**4.))*Den(Msq2,Mgl)**6.*

     &  ln(mu,Msq2)**2.+

     &  ((-7*Mgl**16.)/288.+Mgl**18./(144.*Msq2**2.)-

     &  (137*Mgl**14.*Msq2**2.)/2304.+

     &  (1913*Mgl**12.*Msq2**4.)/4608.-

     &  (73*Mgl**10.*Msq2**6.)/96.+

     &  (563*Mgl**8.*Msq2**8.)/1152.+

     &  (233*Mgl**6.*Msq2**10.)/1152.-

     &  (371*Mgl**4.*Msq2**12.)/768.+

     &  (77*Mgl**2.*Msq2**14.)/288.-(23*Msq2**16.)/384.+

     &  (23*Msq2**18.)/(2304.*Mgl**2.)-

     &  (5*Msq2**20.)/(1536.*Mgl**4.))*Den(Msq2,Mgl)**8.*

     &  ln(mu,Msq2)**2.+

     &  (61/(4608.*Mgl**2.)+(35*Msq1**2.)/(4608.*Mgl**4.))*

     &  Tfin0(Msq1,Mgl)+

     &  ((49*Mgl**2.)/1152.-Mgl**4./(144.*Msq1**2.)+

     &  (7*Msq1**2.)/1152.-

     &  (47*Msq1**4.)/(1152.*Mgl**2.)+

     &  (7*Msq1**6.)/(1152.*Mgl**4.))*Den(Msq1,Mgl)**2.*

     &  Tfin0(Msq1,Mgl)+

     &  ((-67*Mgl**6.)/2304.+Mgl**10./(576.*Msq1**4.)+

     &  (5*Mgl**8.)/(1152.*Msq1**2.)+

     &  (265*Mgl**4.*Msq1**2.)/2304.-

     &  (19*Mgl**2.*Msq1**4.)/144.-(25*Msq1**6.)/1152.+

     &  (175*Msq1**8.)/(2304.*Mgl**2.)-

     &  (11*Msq1**10.)/(768.*Mgl**4.))*Den(Msq1,Mgl)**4.*

     &  Tfin0(Msq1,Mgl)+

     &  ((-173*Mgl**10.)/1152.-Mgl**14./(144.*Msq1**4.)+

     &  Mgl**12./(64.*Msq1**2.)+

     &  (493*Mgl**8.*Msq1**2.)/1152.-

     &  (325*Mgl**6.*Msq1**4.)/1152.-

     &  (331*Mgl**4.*Msq1**6.)/1152.+

     &  (457*Mgl**2.*Msq1**8.)/1152.-

     &  (113*Msq1**10.)/1152.-

     &  (5*Msq1**12.)/(384.*Mgl**2.)-

     &  Msq1**14./(384.*Mgl**4.))*Den(Msq1,Mgl)**6.*

     &  Tfin0(Msq1,Mgl)+

     &  ((65*Mgl**14.)/512.+Mgl**18./(192.*Msq1**4.)-

     &  (23*Mgl**16.)/(1152.*Msq1**2.)-

     &  (2501*Mgl**12.*Msq1**2.)/4608.+

     &  (611*Mgl**10.*Msq1**4.)/576.-

     &  (169*Mgl**8.*Msq1**6.)/192.+

     &  (41*Mgl**6.*Msq1**8.)/2304.+

     &  (1055*Mgl**4.*Msq1**10.)/2304.-

     &  (17*Mgl**2.*Msq1**12.)/64.+(43*Msq1**14.)/1152.-

     &  Msq1**16./(1536.*Mgl**2.)+

     &  (5*Msq1**18.)/(1536.*Mgl**4.))*Den(Msq1,Mgl)**8.*

     &  Tfin0(Msq1,Mgl)+

     &  (61/(4608.*Mgl**2.)+(35*Msq2**2.)/(4608.*Mgl**4.))*

     &  Tfin0(Msq2,Mgl)+

     &  ((49*Mgl**2.)/1152.-Mgl**4./(144.*Msq2**2.)+

     &  (7*Msq2**2.)/1152.-

     &  (47*Msq2**4.)/(1152.*Mgl**2.)+

     &  (7*Msq2**6.)/(1152.*Mgl**4.))*Den(Msq2,Mgl)**2.*

     &  Tfin0(Msq2,Mgl)+

     &  ((-67*Mgl**6.)/2304.+Mgl**10./(576.*Msq2**4.)+

     &  (5*Mgl**8.)/(1152.*Msq2**2.)+

     &  (265*Mgl**4.*Msq2**2.)/2304.-

     &  (19*Mgl**2.*Msq2**4.)/144.-(25*Msq2**6.)/1152.+

     &  (175*Msq2**8.)/(2304.*Mgl**2.)-

     &  (11*Msq2**10.)/(768.*Mgl**4.))*Den(Msq2,Mgl)**4.*

     &  Tfin0(Msq2,Mgl)+

     &  ((-173*Mgl**10.)/1152.-Mgl**14./(144.*Msq2**4.)+

     &  Mgl**12./(64.*Msq2**2.)+

     &  (493*Mgl**8.*Msq2**2.)/1152.-

     &  (325*Mgl**6.*Msq2**4.)/1152.-

     &  (331*Mgl**4.*Msq2**6.)/1152.+

     &  (457*Mgl**2.*Msq2**8.)/1152.-

     &  (113*Msq2**10.)/1152.-

     &  (5*Msq2**12.)/(384.*Mgl**2.)-

     &  Msq2**14./(384.*Mgl**4.))*Den(Msq2,Mgl)**6.*

     &  Tfin0(Msq2,Mgl)+

     &  ((65*Mgl**14.)/512.+Mgl**18./(192.*Msq2**4.)-

     &  (23*Mgl**16.)/(1152.*Msq2**2.)-

     &  (2501*Mgl**12.*Msq2**2.)/4608.+

     &  (611*Mgl**10.*Msq2**4.)/576.-

     &  (169*Mgl**8.*Msq2**6.)/192.+

     &  (41*Mgl**6.*Msq2**8.)/2304.+

     &  (1055*Mgl**4.*Msq2**10.)/2304.-

     &  (17*Mgl**2.*Msq2**12.)/64.+(43*Msq2**14.)/1152.-

     &  Msq2**16./(1536.*Mgl**2.)+

     &  (5*Msq2**18.)/(1536.*Mgl**4.))*Den(Msq2,Mgl)**8.*

     &  Tfin0(Msq2,Mgl)))))


       return
       end
